# deviceXlib

### deviceXlib, fortran library wrapping device-oriented routines and utilities

- deviceXlib is a Fortran library wrapping device-oriented routines and utilities;
- deviceXlib is Fortran 2008 standard compliant;

#### Table of Contents

+ [What is deviceXlib?](#what-is-deviceXlib?)
	+ [What are OpenMP Device Memory Routines?](#what-are-omp-routines?)
+ [Main features](#main-features)
+ [Status](#status)
+ [Copyrights](#copyrights)

## What is deviceXlib?

deviceXlib is a library that wraps device-oriented routines and utilities, such as device data allocation, host-device data transfers.
deviceXlib supports CUDA language, together with OpenACC and OpenMP programming paradigms.
deviceXlib wraps a subset of functions from Nvidia cuBLAS, Intel oneMKL BLAS and AMD rocBLAS libraries.

## Main features

deviceXlib is aimed to be a Fortran library providing basic and advanced functionalities needed for GPU offload in MaX CoE codes.

+ [x] KISS and user-friendly:
  + [x] simple API;
  + [x] easy building and porting on heterogeneous architectures;
+ [x] comprehensive:
  + [x] GPU programming models:
     + [x] CUDA support;
     + [x] OpenACC support;
     + [x] OpenMP Offload support;
  + [x] GPU BLAS support (via cuBLAS, Intel oneMKL BLAS and AMD rocBLAS):
     + [x] ?DOT;
     + [x] ?AXPY;
     + [x] ?GEMV;
     + [x] ?GEMM;
     + [ ] ?SCAL;
     + [ ] ?SWAP;
     + [ ] ?COPY;
     + [ ] ?DOTC;
     + [ ] ?GER;
     + [ ] ?TRSM;

Any feature request is welcome.

Go to [Top](#top)

## Status

deviceXlib provides the following Fortran routines:

+ [x] GPU buffer allocation via linked list --> device_fbuff
+ [x] data allocation on GPU --> device_malloc
+ [x] data mapping on GPU --> device_mapping
+ [x] data synchronization between CPU and GPU --> device_memcpy and device_memcpy_async
+ [x] auxiliary functions for GPU data manipulation --> device_auxfunc
+ [x] subset of linear algebra routines for GPU --> device_linalg

Go to [Top](#top)

## Copyrights

&copy; 2024, MaX - Materials at the eXascale - CoE

Anyone is interest to use, to develop or to contribute to deviceXlib is welcome!

Go to [Top](#top)

!
! Copyright (C) 2002-2018 Quantum ESPRESSO group
! This file is distributed under the terms of the
! GNU General Public License. See the file `License'
! in the root directory of the present distribution,
! or http://www.gnu.org/copyleft/gpl.txt .
!
! dev_util memcpy async test
!
#include<device_macros.h>
#if defined(__CUDA)
#  define __PINNED pinned,
#else
#  define __PINNED 
#endif
!
program test_memcpy_async
  !
  ! This program tests the routines and interfaces related to
  ! device_util.
  !
#ifdef __CUDA
  use cudafor
#endif
  use timer_m
  use iso_fortran_env
  implicit none

#include "device_memcpy_interf.f90"
#include "device_auxfunc_interf.f90"

  real(real64), parameter :: thr=1.0d-6
  integer,      parameter :: nranks=4
  integer :: ndim(nranks)
  integer :: vrange(2,nranks)
  integer :: vlbound(nranks)
  real(real64):: t0,t1
  integer :: npass,nfail
#if defined(__CUDA)
  integer(kind=cuda_Stream_Kind) :: stream
#else
  integer :: stream
#endif
  real(real32), __PINNED allocatable :: A_hst1__sp_r1d(:)
  real(real32), __PINNED allocatable :: A_hst2__sp_r1d(:)
  real(real32), allocatable :: A_dev1__sp_r1d(:)
  real(real32), allocatable :: A_dev2__sp_r1d(:)
#if defined(__CUDA)
  attributes(device) :: A_dev1__sp_r1d, A_dev2__sp_r1d
#endif
  

  real(real32), __PINNED allocatable :: A_hst1__sp_r2d(:,:)
  real(real32), __PINNED allocatable :: A_hst2__sp_r2d(:,:)
  real(real32), allocatable :: A_dev1__sp_r2d(:,:)
  real(real32), allocatable :: A_dev2__sp_r2d(:,:)
#if defined(__CUDA)
  attributes(device) :: A_dev1__sp_r2d, A_dev2__sp_r2d
#endif
  

  real(real32), __PINNED allocatable :: A_hst1__sp_r3d(:,:,:)
  real(real32), __PINNED allocatable :: A_hst2__sp_r3d(:,:,:)
  real(real32), allocatable :: A_dev1__sp_r3d(:,:,:)
  real(real32), allocatable :: A_dev2__sp_r3d(:,:,:)
#if defined(__CUDA)
  attributes(device) :: A_dev1__sp_r3d, A_dev2__sp_r3d
#endif
  

  real(real32), __PINNED allocatable :: A_hst1__sp_r4d(:,:,:,:)
  real(real32), __PINNED allocatable :: A_hst2__sp_r4d(:,:,:,:)
  real(real32), allocatable :: A_dev1__sp_r4d(:,:,:,:)
  real(real32), allocatable :: A_dev2__sp_r4d(:,:,:,:)
#if defined(__CUDA)
  attributes(device) :: A_dev1__sp_r4d, A_dev2__sp_r4d
#endif
  


  real(real64), __PINNED allocatable :: A_hst1__dp_r1d(:)
  real(real64), __PINNED allocatable :: A_hst2__dp_r1d(:)
  real(real64), allocatable :: A_dev1__dp_r1d(:)
  real(real64), allocatable :: A_dev2__dp_r1d(:)
#if defined(__CUDA)
  attributes(device) :: A_dev1__dp_r1d, A_dev2__dp_r1d
#endif
  

  real(real64), __PINNED allocatable :: A_hst1__dp_r2d(:,:)
  real(real64), __PINNED allocatable :: A_hst2__dp_r2d(:,:)
  real(real64), allocatable :: A_dev1__dp_r2d(:,:)
  real(real64), allocatable :: A_dev2__dp_r2d(:,:)
#if defined(__CUDA)
  attributes(device) :: A_dev1__dp_r2d, A_dev2__dp_r2d
#endif
  

  real(real64), __PINNED allocatable :: A_hst1__dp_r3d(:,:,:)
  real(real64), __PINNED allocatable :: A_hst2__dp_r3d(:,:,:)
  real(real64), allocatable :: A_dev1__dp_r3d(:,:,:)
  real(real64), allocatable :: A_dev2__dp_r3d(:,:,:)
#if defined(__CUDA)
  attributes(device) :: A_dev1__dp_r3d, A_dev2__dp_r3d
#endif
  

  real(real64), __PINNED allocatable :: A_hst1__dp_r4d(:,:,:,:)
  real(real64), __PINNED allocatable :: A_hst2__dp_r4d(:,:,:,:)
  real(real64), allocatable :: A_dev1__dp_r4d(:,:,:,:)
  real(real64), allocatable :: A_dev2__dp_r4d(:,:,:,:)
#if defined(__CUDA)
  attributes(device) :: A_dev1__dp_r4d, A_dev2__dp_r4d
#endif
  



  complex(real32), __PINNED allocatable :: A_hst1__sp_c1d(:)
  complex(real32), __PINNED allocatable :: A_hst2__sp_c1d(:)
  complex(real32), allocatable :: A_dev1__sp_c1d(:)
  complex(real32), allocatable :: A_dev2__sp_c1d(:)
#if defined(__CUDA)
  attributes(device) :: A_dev1__sp_c1d, A_dev2__sp_c1d
#endif
  
  real(real32), __PINNED allocatable :: A_rtmp__sp_1d(:)
  

  complex(real32), __PINNED allocatable :: A_hst1__sp_c2d(:,:)
  complex(real32), __PINNED allocatable :: A_hst2__sp_c2d(:,:)
  complex(real32), allocatable :: A_dev1__sp_c2d(:,:)
  complex(real32), allocatable :: A_dev2__sp_c2d(:,:)
#if defined(__CUDA)
  attributes(device) :: A_dev1__sp_c2d, A_dev2__sp_c2d
#endif
  
  real(real32), __PINNED allocatable :: A_rtmp__sp_2d(:,:)
  

  complex(real32), __PINNED allocatable :: A_hst1__sp_c3d(:,:,:)
  complex(real32), __PINNED allocatable :: A_hst2__sp_c3d(:,:,:)
  complex(real32), allocatable :: A_dev1__sp_c3d(:,:,:)
  complex(real32), allocatable :: A_dev2__sp_c3d(:,:,:)
#if defined(__CUDA)
  attributes(device) :: A_dev1__sp_c3d, A_dev2__sp_c3d
#endif
  
  real(real32), __PINNED allocatable :: A_rtmp__sp_3d(:,:,:)
  

  complex(real32), __PINNED allocatable :: A_hst1__sp_c4d(:,:,:,:)
  complex(real32), __PINNED allocatable :: A_hst2__sp_c4d(:,:,:,:)
  complex(real32), allocatable :: A_dev1__sp_c4d(:,:,:,:)
  complex(real32), allocatable :: A_dev2__sp_c4d(:,:,:,:)
#if defined(__CUDA)
  attributes(device) :: A_dev1__sp_c4d, A_dev2__sp_c4d
#endif
  
  real(real32), __PINNED allocatable :: A_rtmp__sp_4d(:,:,:,:)
  


  complex(real64), __PINNED allocatable :: A_hst1__dp_c1d(:)
  complex(real64), __PINNED allocatable :: A_hst2__dp_c1d(:)
  complex(real64), allocatable :: A_dev1__dp_c1d(:)
  complex(real64), allocatable :: A_dev2__dp_c1d(:)
#if defined(__CUDA)
  attributes(device) :: A_dev1__dp_c1d, A_dev2__dp_c1d
#endif
  
  real(real64), __PINNED allocatable :: A_rtmp__dp_1d(:)
  

  complex(real64), __PINNED allocatable :: A_hst1__dp_c2d(:,:)
  complex(real64), __PINNED allocatable :: A_hst2__dp_c2d(:,:)
  complex(real64), allocatable :: A_dev1__dp_c2d(:,:)
  complex(real64), allocatable :: A_dev2__dp_c2d(:,:)
#if defined(__CUDA)
  attributes(device) :: A_dev1__dp_c2d, A_dev2__dp_c2d
#endif
  
  real(real64), __PINNED allocatable :: A_rtmp__dp_2d(:,:)
  

  complex(real64), __PINNED allocatable :: A_hst1__dp_c3d(:,:,:)
  complex(real64), __PINNED allocatable :: A_hst2__dp_c3d(:,:,:)
  complex(real64), allocatable :: A_dev1__dp_c3d(:,:,:)
  complex(real64), allocatable :: A_dev2__dp_c3d(:,:,:)
#if defined(__CUDA)
  attributes(device) :: A_dev1__dp_c3d, A_dev2__dp_c3d
#endif
  
  real(real64), __PINNED allocatable :: A_rtmp__dp_3d(:,:,:)
  

  complex(real64), __PINNED allocatable :: A_hst1__dp_c4d(:,:,:,:)
  complex(real64), __PINNED allocatable :: A_hst2__dp_c4d(:,:,:,:)
  complex(real64), allocatable :: A_dev1__dp_c4d(:,:,:,:)
  complex(real64), allocatable :: A_dev2__dp_c4d(:,:,:,:)
#if defined(__CUDA)
  attributes(device) :: A_dev1__dp_c4d, A_dev2__dp_c4d
#endif
  
  real(real64), __PINNED allocatable :: A_rtmp__dp_4d(:,:,:,:)
  



  integer(int32), __PINNED allocatable :: A_hst1__i4_i1d(:)
  integer(int32), __PINNED allocatable :: A_hst2__i4_i1d(:)
  integer(int32), allocatable :: A_dev1__i4_i1d(:)
  integer(int32), allocatable :: A_dev2__i4_i1d(:)
#if defined(__CUDA)
  attributes(device) :: A_dev1__i4_i1d, A_dev2__i4_i1d
#endif
  
  real(int32), __PINNED allocatable :: A_rtmp__i4_1d(:)
  

  integer(int32), __PINNED allocatable :: A_hst1__i4_i2d(:,:)
  integer(int32), __PINNED allocatable :: A_hst2__i4_i2d(:,:)
  integer(int32), allocatable :: A_dev1__i4_i2d(:,:)
  integer(int32), allocatable :: A_dev2__i4_i2d(:,:)
#if defined(__CUDA)
  attributes(device) :: A_dev1__i4_i2d, A_dev2__i4_i2d
#endif
  
  real(int32), __PINNED allocatable :: A_rtmp__i4_2d(:,:)
  

  integer(int32), __PINNED allocatable :: A_hst1__i4_i3d(:,:,:)
  integer(int32), __PINNED allocatable :: A_hst2__i4_i3d(:,:,:)
  integer(int32), allocatable :: A_dev1__i4_i3d(:,:,:)
  integer(int32), allocatable :: A_dev2__i4_i3d(:,:,:)
#if defined(__CUDA)
  attributes(device) :: A_dev1__i4_i3d, A_dev2__i4_i3d
#endif
  
  real(int32), __PINNED allocatable :: A_rtmp__i4_3d(:,:,:)
  

  integer(int32), __PINNED allocatable :: A_hst1__i4_i4d(:,:,:,:)
  integer(int32), __PINNED allocatable :: A_hst2__i4_i4d(:,:,:,:)
  integer(int32), allocatable :: A_dev1__i4_i4d(:,:,:,:)
  integer(int32), allocatable :: A_dev2__i4_i4d(:,:,:,:)
#if defined(__CUDA)
  attributes(device) :: A_dev1__i4_i4d, A_dev2__i4_i4d
#endif
  
  real(int32), __PINNED allocatable :: A_rtmp__i4_4d(:,:,:,:)
  



  
  integer :: i,ierr
  !integer :: i1, i2, i3, i4 
  integer :: ndim1, ndim2, ndim3, ndim4 
  integer :: lbound1, lbound2, lbound3, lbound4 
  integer :: range1(2), range2(2), range3(2), range4(2) 
  integer :: bound1(2), bound2(2), bound3(2), bound4(2) 
  logical :: is_pinned(2)
  character(256) :: arg, str

!
!============================
! get dims
!============================
!
  ! defaults
  ndim(:)=100
  vrange(1,:)=1
  vrange(2,:)=ndim
  vlbound(:)=1

  i=0
  do
    call get_command_argument(i, arg)
    if (len_trim(arg) == 0) exit
    !
    select case (trim(arg))
    case("-h","--help")
      write(0,"(a)") "Usage: "
      write(0,"(a)") "   ./test_memcpy_async.x [--dims <vals>] [--range <vals>] [--lbound <vals>]"
      stop
    end select
    !
    i = i+1
    call get_command_argument(i, str)
    if (len_trim(str) == 0) exit
    !
    select case (trim(arg))
    case("-dims","--dims")
      read(str,*,iostat=ierr) ndim(:)
      if (ierr/=0) STOP "reading cmd-line args: dims"
    case("-range","--range")
      read(str,*,iostat=ierr) vrange(:,:)
      if (ierr/=0) STOP "reading cmd-line args: range"
    case("-lbound","--lbound")
      read(str,*,iostat=ierr) vlbound(:)
      if (ierr/=0) STOP "reading cmd-line args: lbound"
    end select
  enddo
  !
  write(0,"(/,a,/)") "Running test_memcpy_async.x with params: "
  write(0,"(3x,a,10i5)") "  ndim: ", ndim(:)
  write(0,"(3x,a,10i5)") "lbound: ", vlbound(:)
  do i = 1, nranks
     write(0,"(3x,a,i2,3x,10i5)") " range: ", i, vrange(:,i)
  enddo
  write(0,"()")
  !
  npass=0
  nfail=0

  stream=0
#ifdef __CUDA
  ierr = cudaStreamCreate(stream)
  !ierr = cudaStreamCreateWithFLags(stream,cudaStreamNonBlocking)
#endif



  ndim1=ndim(1)
  lbound1=vlbound(1)
  range1=vrange(:,1)
  bound1(1)=lbound1
  bound1(2)=lbound1+ndim1-1
  ndim2=ndim(2)
  lbound2=vlbound(2)
  range2=vrange(:,2)
  bound2(1)=lbound2
  bound2(2)=lbound2+ndim2-1
  ndim3=ndim(3)
  lbound3=vlbound(3)
  range3=vrange(:,3)
  bound3(1)=lbound3
  bound3(2)=lbound3+ndim3-1
  ndim4=ndim(4)
  lbound4=vlbound(4)
  range4=vrange(:,4)
  bound4(1)=lbound4
  bound4(2)=lbound4+ndim4-1

!
!============================
! check memcpy
!============================
!
  !
  !=====================
  write(0,"(/,3x,a)") "checking sp_r1d ..." 
  t0=wallclock()
  !
  ! allocations
#ifdef __CUDA
  allocate( A_hst1__sp_r1d(bound1(1):bound1(2)), PINNED=is_pinned(1) )
  allocate( A_hst2__sp_r1d(bound1(1):bound1(2)), PINNED=is_pinned(2) )
#else
  is_pinned=.false.
  allocate( A_hst1__sp_r1d(bound1(1):bound1(2)) )
  allocate( A_hst2__sp_r1d(bound1(1):bound1(2)) )
#endif
  allocate( A_dev1__sp_r1d(bound1(1):bound1(2)) )
  allocate( A_dev2__sp_r1d(bound1(1):bound1(2)) )
  write(0,"(3x,a,2l)") "host memory is pinned: ", is_pinned(1:2) 
  !
  ! init
  call random_number( A_hst1__sp_r1d )
  
  !
  ! mem copy h2d
  call dev_memcpy_async(A_dev1__sp_r1d, A_hst1__sp_r1d,stream)
  call dev_stream_sync( stream )
  !
  ! mem copy
  call dev_memcpy(A_dev2__sp_r1d, A_dev1__sp_r1d )
  !
  !
  ! mem copy d2h
  call dev_memcpy_async(A_hst2__sp_r1d, A_dev2__sp_r1d,stream)
  call dev_stream_sync( stream )
  !
  !
  ! check
  if ( any(abs(A_hst2__sp_r1d -A_hst1__sp_r1d )> thr) ) then
     write(0,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(0,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst1__sp_r1d)
  deallocate(A_hst2__sp_r1d)
  deallocate(A_dev1__sp_r1d)
  deallocate(A_dev2__sp_r1d)
  !
  t1=wallclock()
  write(0,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !

  !
  !=====================
  write(0,"(/,3x,a)") "checking sp_r2d ..." 
  t0=wallclock()
  !
  ! allocations
#ifdef __CUDA
  allocate( A_hst1__sp_r2d(bound1(1):bound1(2),bound2(1):bound2(2)), PINNED=is_pinned(1) )
  allocate( A_hst2__sp_r2d(bound1(1):bound1(2),bound2(1):bound2(2)), PINNED=is_pinned(2) )
#else
  is_pinned=.false.
  allocate( A_hst1__sp_r2d(bound1(1):bound1(2),bound2(1):bound2(2)) )
  allocate( A_hst2__sp_r2d(bound1(1):bound1(2),bound2(1):bound2(2)) )
#endif
  allocate( A_dev1__sp_r2d(bound1(1):bound1(2),bound2(1):bound2(2)) )
  allocate( A_dev2__sp_r2d(bound1(1):bound1(2),bound2(1):bound2(2)) )
  write(0,"(3x,a,2l)") "host memory is pinned: ", is_pinned(1:2) 
  !
  ! init
  call random_number( A_hst1__sp_r2d )
  
  !
  ! mem copy h2d
  call dev_memcpy_async(A_dev1__sp_r2d, A_hst1__sp_r2d,stream)
  call dev_stream_sync( stream )
  !
  ! mem copy
  call dev_memcpy(A_dev2__sp_r2d, A_dev1__sp_r2d )
  !
  !
  ! mem copy d2h
  call dev_memcpy_async(A_hst2__sp_r2d, A_dev2__sp_r2d,stream)
  call dev_stream_sync( stream )
  !
  !
  ! check
  if ( any(abs(A_hst2__sp_r2d -A_hst1__sp_r2d )> thr) ) then
     write(0,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(0,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst1__sp_r2d)
  deallocate(A_hst2__sp_r2d)
  deallocate(A_dev1__sp_r2d)
  deallocate(A_dev2__sp_r2d)
  !
  t1=wallclock()
  write(0,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !

  !
  !=====================
  write(0,"(/,3x,a)") "checking sp_r3d ..." 
  t0=wallclock()
  !
  ! allocations
#ifdef __CUDA
  allocate( A_hst1__sp_r3d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2)), PINNED=is_pinned(1) )
  allocate( A_hst2__sp_r3d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2)), PINNED=is_pinned(2) )
#else
  is_pinned=.false.
  allocate( A_hst1__sp_r3d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2)) )
  allocate( A_hst2__sp_r3d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2)) )
#endif
  allocate( A_dev1__sp_r3d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2)) )
  allocate( A_dev2__sp_r3d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2)) )
  write(0,"(3x,a,2l)") "host memory is pinned: ", is_pinned(1:2) 
  !
  ! init
  call random_number( A_hst1__sp_r3d )
  
  !
  ! mem copy h2d
  call dev_memcpy_async(A_dev1__sp_r3d, A_hst1__sp_r3d,stream)
  call dev_stream_sync( stream )
  !
  ! mem copy
  call dev_memcpy(A_dev2__sp_r3d, A_dev1__sp_r3d )
  !
  !
  ! mem copy d2h
  call dev_memcpy_async(A_hst2__sp_r3d, A_dev2__sp_r3d,stream)
  call dev_stream_sync( stream )
  !
  !
  ! check
  if ( any(abs(A_hst2__sp_r3d -A_hst1__sp_r3d )> thr) ) then
     write(0,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(0,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst1__sp_r3d)
  deallocate(A_hst2__sp_r3d)
  deallocate(A_dev1__sp_r3d)
  deallocate(A_dev2__sp_r3d)
  !
  t1=wallclock()
  write(0,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !

  !
  !=====================
  write(0,"(/,3x,a)") "checking sp_r4d ..." 
  t0=wallclock()
  !
  ! allocations
#ifdef __CUDA
  allocate( A_hst1__sp_r4d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2),bound4(1):bound4(2)), PINNED=is_pinned(1) )
  allocate( A_hst2__sp_r4d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2),bound4(1):bound4(2)), PINNED=is_pinned(2) )
#else
  is_pinned=.false.
  allocate( A_hst1__sp_r4d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2),bound4(1):bound4(2)) )
  allocate( A_hst2__sp_r4d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2),bound4(1):bound4(2)) )
#endif
  allocate( A_dev1__sp_r4d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2),bound4(1):bound4(2)) )
  allocate( A_dev2__sp_r4d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2),bound4(1):bound4(2)) )
  write(0,"(3x,a,2l)") "host memory is pinned: ", is_pinned(1:2) 
  !
  ! init
  call random_number( A_hst1__sp_r4d )
  
  !
  ! mem copy h2d
  call dev_memcpy_async(A_dev1__sp_r4d, A_hst1__sp_r4d,stream)
  call dev_stream_sync( stream )
  !
  ! mem copy
  call dev_memcpy(A_dev2__sp_r4d, A_dev1__sp_r4d )
  !
  !
  ! mem copy d2h
  call dev_memcpy_async(A_hst2__sp_r4d, A_dev2__sp_r4d,stream)
  call dev_stream_sync( stream )
  !
  !
  ! check
  if ( any(abs(A_hst2__sp_r4d -A_hst1__sp_r4d )> thr) ) then
     write(0,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(0,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst1__sp_r4d)
  deallocate(A_hst2__sp_r4d)
  deallocate(A_dev1__sp_r4d)
  deallocate(A_dev2__sp_r4d)
  !
  t1=wallclock()
  write(0,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !


  !
  !=====================
  write(0,"(/,3x,a)") "checking dp_r1d ..." 
  t0=wallclock()
  !
  ! allocations
#ifdef __CUDA
  allocate( A_hst1__dp_r1d(bound1(1):bound1(2)), PINNED=is_pinned(1) )
  allocate( A_hst2__dp_r1d(bound1(1):bound1(2)), PINNED=is_pinned(2) )
#else
  is_pinned=.false.
  allocate( A_hst1__dp_r1d(bound1(1):bound1(2)) )
  allocate( A_hst2__dp_r1d(bound1(1):bound1(2)) )
#endif
  allocate( A_dev1__dp_r1d(bound1(1):bound1(2)) )
  allocate( A_dev2__dp_r1d(bound1(1):bound1(2)) )
  write(0,"(3x,a,2l)") "host memory is pinned: ", is_pinned(1:2) 
  !
  ! init
  call random_number( A_hst1__dp_r1d )
  
  !
  ! mem copy h2d
  call dev_memcpy_async(A_dev1__dp_r1d, A_hst1__dp_r1d,stream)
  call dev_stream_sync( stream )
  !
  ! mem copy
  call dev_memcpy(A_dev2__dp_r1d, A_dev1__dp_r1d )
  !
  !
  ! mem copy d2h
  call dev_memcpy_async(A_hst2__dp_r1d, A_dev2__dp_r1d,stream)
  call dev_stream_sync( stream )
  !
  !
  ! check
  if ( any(abs(A_hst2__dp_r1d -A_hst1__dp_r1d )> thr) ) then
     write(0,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(0,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst1__dp_r1d)
  deallocate(A_hst2__dp_r1d)
  deallocate(A_dev1__dp_r1d)
  deallocate(A_dev2__dp_r1d)
  !
  t1=wallclock()
  write(0,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !

  !
  !=====================
  write(0,"(/,3x,a)") "checking dp_r2d ..." 
  t0=wallclock()
  !
  ! allocations
#ifdef __CUDA
  allocate( A_hst1__dp_r2d(bound1(1):bound1(2),bound2(1):bound2(2)), PINNED=is_pinned(1) )
  allocate( A_hst2__dp_r2d(bound1(1):bound1(2),bound2(1):bound2(2)), PINNED=is_pinned(2) )
#else
  is_pinned=.false.
  allocate( A_hst1__dp_r2d(bound1(1):bound1(2),bound2(1):bound2(2)) )
  allocate( A_hst2__dp_r2d(bound1(1):bound1(2),bound2(1):bound2(2)) )
#endif
  allocate( A_dev1__dp_r2d(bound1(1):bound1(2),bound2(1):bound2(2)) )
  allocate( A_dev2__dp_r2d(bound1(1):bound1(2),bound2(1):bound2(2)) )
  write(0,"(3x,a,2l)") "host memory is pinned: ", is_pinned(1:2) 
  !
  ! init
  call random_number( A_hst1__dp_r2d )
  
  !
  ! mem copy h2d
  call dev_memcpy_async(A_dev1__dp_r2d, A_hst1__dp_r2d,stream)
  call dev_stream_sync( stream )
  !
  ! mem copy
  call dev_memcpy(A_dev2__dp_r2d, A_dev1__dp_r2d )
  !
  !
  ! mem copy d2h
  call dev_memcpy_async(A_hst2__dp_r2d, A_dev2__dp_r2d,stream)
  call dev_stream_sync( stream )
  !
  !
  ! check
  if ( any(abs(A_hst2__dp_r2d -A_hst1__dp_r2d )> thr) ) then
     write(0,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(0,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst1__dp_r2d)
  deallocate(A_hst2__dp_r2d)
  deallocate(A_dev1__dp_r2d)
  deallocate(A_dev2__dp_r2d)
  !
  t1=wallclock()
  write(0,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !

  !
  !=====================
  write(0,"(/,3x,a)") "checking dp_r3d ..." 
  t0=wallclock()
  !
  ! allocations
#ifdef __CUDA
  allocate( A_hst1__dp_r3d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2)), PINNED=is_pinned(1) )
  allocate( A_hst2__dp_r3d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2)), PINNED=is_pinned(2) )
#else
  is_pinned=.false.
  allocate( A_hst1__dp_r3d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2)) )
  allocate( A_hst2__dp_r3d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2)) )
#endif
  allocate( A_dev1__dp_r3d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2)) )
  allocate( A_dev2__dp_r3d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2)) )
  write(0,"(3x,a,2l)") "host memory is pinned: ", is_pinned(1:2) 
  !
  ! init
  call random_number( A_hst1__dp_r3d )
  
  !
  ! mem copy h2d
  call dev_memcpy_async(A_dev1__dp_r3d, A_hst1__dp_r3d,stream)
  call dev_stream_sync( stream )
  !
  ! mem copy
  call dev_memcpy(A_dev2__dp_r3d, A_dev1__dp_r3d )
  !
  !
  ! mem copy d2h
  call dev_memcpy_async(A_hst2__dp_r3d, A_dev2__dp_r3d,stream)
  call dev_stream_sync( stream )
  !
  !
  ! check
  if ( any(abs(A_hst2__dp_r3d -A_hst1__dp_r3d )> thr) ) then
     write(0,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(0,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst1__dp_r3d)
  deallocate(A_hst2__dp_r3d)
  deallocate(A_dev1__dp_r3d)
  deallocate(A_dev2__dp_r3d)
  !
  t1=wallclock()
  write(0,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !

  !
  !=====================
  write(0,"(/,3x,a)") "checking dp_r4d ..." 
  t0=wallclock()
  !
  ! allocations
#ifdef __CUDA
  allocate( A_hst1__dp_r4d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2),bound4(1):bound4(2)), PINNED=is_pinned(1) )
  allocate( A_hst2__dp_r4d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2),bound4(1):bound4(2)), PINNED=is_pinned(2) )
#else
  is_pinned=.false.
  allocate( A_hst1__dp_r4d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2),bound4(1):bound4(2)) )
  allocate( A_hst2__dp_r4d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2),bound4(1):bound4(2)) )
#endif
  allocate( A_dev1__dp_r4d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2),bound4(1):bound4(2)) )
  allocate( A_dev2__dp_r4d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2),bound4(1):bound4(2)) )
  write(0,"(3x,a,2l)") "host memory is pinned: ", is_pinned(1:2) 
  !
  ! init
  call random_number( A_hst1__dp_r4d )
  
  !
  ! mem copy h2d
  call dev_memcpy_async(A_dev1__dp_r4d, A_hst1__dp_r4d,stream)
  call dev_stream_sync( stream )
  !
  ! mem copy
  call dev_memcpy(A_dev2__dp_r4d, A_dev1__dp_r4d )
  !
  !
  ! mem copy d2h
  call dev_memcpy_async(A_hst2__dp_r4d, A_dev2__dp_r4d,stream)
  call dev_stream_sync( stream )
  !
  !
  ! check
  if ( any(abs(A_hst2__dp_r4d -A_hst1__dp_r4d )> thr) ) then
     write(0,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(0,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst1__dp_r4d)
  deallocate(A_hst2__dp_r4d)
  deallocate(A_dev1__dp_r4d)
  deallocate(A_dev2__dp_r4d)
  !
  t1=wallclock()
  write(0,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !



  !
  !=====================
  write(0,"(/,3x,a)") "checking sp_c1d ..." 
  t0=wallclock()
  !
  ! allocations
#ifdef __CUDA
  allocate( A_hst1__sp_c1d(bound1(1):bound1(2)), PINNED=is_pinned(1) )
  allocate( A_hst2__sp_c1d(bound1(1):bound1(2)), PINNED=is_pinned(2) )
#else
  is_pinned=.false.
  allocate( A_hst1__sp_c1d(bound1(1):bound1(2)) )
  allocate( A_hst2__sp_c1d(bound1(1):bound1(2)) )
#endif
  allocate( A_dev1__sp_c1d(bound1(1):bound1(2)) )
  allocate( A_dev2__sp_c1d(bound1(1):bound1(2)) )
  allocate( A_rtmp__sp_1d(bound1(1):bound1(2)) )
  
  write(0,"(3x,a,2l)") "host memory is pinned: ", is_pinned(1:2) 
  !
  ! init
  call random_number( A_rtmp__sp_1d )
  A_hst1__sp_c1d=A_rtmp__sp_1d
  call random_number( A_rtmp__sp_1d )
  A_hst1__sp_c1d=A_hst1__sp_c1d+cmplx(0.0,1.0)*A_rtmp__sp_1d
  !
  ! mem copy h2d
  call dev_memcpy_async(A_dev1__sp_c1d, A_hst1__sp_c1d,stream)
  call dev_stream_sync( stream )
  !
  ! mem copy
  call dev_memcpy(A_dev2__sp_c1d, A_dev1__sp_c1d )
  !
  ! make cmplx conjg
  call dev_conjg( A_dev2__sp_c1d )
  
  !
  ! mem copy d2h
  call dev_memcpy_async(A_hst2__sp_c1d, A_dev2__sp_c1d,stream)
  call dev_stream_sync( stream )
  !
  ! retrieve conjg data
  A_hst2__sp_c1d = conjg( A_hst2__sp_c1d )
  
  !
  ! check
  if ( any(abs(A_hst2__sp_c1d -A_hst1__sp_c1d )> thr) ) then
     write(0,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(0,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst1__sp_c1d)
  deallocate(A_hst2__sp_c1d)
  deallocate(A_dev1__sp_c1d)
  deallocate(A_dev2__sp_c1d)
  !
  t1=wallclock()
  write(0,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !

  !
  !=====================
  write(0,"(/,3x,a)") "checking sp_c2d ..." 
  t0=wallclock()
  !
  ! allocations
#ifdef __CUDA
  allocate( A_hst1__sp_c2d(bound1(1):bound1(2),bound2(1):bound2(2)), PINNED=is_pinned(1) )
  allocate( A_hst2__sp_c2d(bound1(1):bound1(2),bound2(1):bound2(2)), PINNED=is_pinned(2) )
#else
  is_pinned=.false.
  allocate( A_hst1__sp_c2d(bound1(1):bound1(2),bound2(1):bound2(2)) )
  allocate( A_hst2__sp_c2d(bound1(1):bound1(2),bound2(1):bound2(2)) )
#endif
  allocate( A_dev1__sp_c2d(bound1(1):bound1(2),bound2(1):bound2(2)) )
  allocate( A_dev2__sp_c2d(bound1(1):bound1(2),bound2(1):bound2(2)) )
  allocate( A_rtmp__sp_2d(bound1(1):bound1(2),bound2(1):bound2(2)) )
  
  write(0,"(3x,a,2l)") "host memory is pinned: ", is_pinned(1:2) 
  !
  ! init
  call random_number( A_rtmp__sp_2d )
  A_hst1__sp_c2d=A_rtmp__sp_2d
  call random_number( A_rtmp__sp_2d )
  A_hst1__sp_c2d=A_hst1__sp_c2d+cmplx(0.0,1.0)*A_rtmp__sp_2d
  !
  ! mem copy h2d
  call dev_memcpy_async(A_dev1__sp_c2d, A_hst1__sp_c2d,stream)
  call dev_stream_sync( stream )
  !
  ! mem copy
  call dev_memcpy(A_dev2__sp_c2d, A_dev1__sp_c2d )
  !
  ! make cmplx conjg
  call dev_conjg( A_dev2__sp_c2d )
  
  !
  ! mem copy d2h
  call dev_memcpy_async(A_hst2__sp_c2d, A_dev2__sp_c2d,stream)
  call dev_stream_sync( stream )
  !
  ! retrieve conjg data
  A_hst2__sp_c2d = conjg( A_hst2__sp_c2d )
  
  !
  ! check
  if ( any(abs(A_hst2__sp_c2d -A_hst1__sp_c2d )> thr) ) then
     write(0,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(0,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst1__sp_c2d)
  deallocate(A_hst2__sp_c2d)
  deallocate(A_dev1__sp_c2d)
  deallocate(A_dev2__sp_c2d)
  !
  t1=wallclock()
  write(0,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !

  !
  !=====================
  write(0,"(/,3x,a)") "checking sp_c3d ..." 
  t0=wallclock()
  !
  ! allocations
#ifdef __CUDA
  allocate( A_hst1__sp_c3d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2)), PINNED=is_pinned(1) )
  allocate( A_hst2__sp_c3d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2)), PINNED=is_pinned(2) )
#else
  is_pinned=.false.
  allocate( A_hst1__sp_c3d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2)) )
  allocate( A_hst2__sp_c3d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2)) )
#endif
  allocate( A_dev1__sp_c3d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2)) )
  allocate( A_dev2__sp_c3d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2)) )
  allocate( A_rtmp__sp_3d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2)) )
  
  write(0,"(3x,a,2l)") "host memory is pinned: ", is_pinned(1:2) 
  !
  ! init
  call random_number( A_rtmp__sp_3d )
  A_hst1__sp_c3d=A_rtmp__sp_3d
  call random_number( A_rtmp__sp_3d )
  A_hst1__sp_c3d=A_hst1__sp_c3d+cmplx(0.0,1.0)*A_rtmp__sp_3d
  !
  ! mem copy h2d
  call dev_memcpy_async(A_dev1__sp_c3d, A_hst1__sp_c3d,stream)
  call dev_stream_sync( stream )
  !
  ! mem copy
  call dev_memcpy(A_dev2__sp_c3d, A_dev1__sp_c3d )
  !
  ! make cmplx conjg
  call dev_conjg( A_dev2__sp_c3d )
  
  !
  ! mem copy d2h
  call dev_memcpy_async(A_hst2__sp_c3d, A_dev2__sp_c3d,stream)
  call dev_stream_sync( stream )
  !
  ! retrieve conjg data
  A_hst2__sp_c3d = conjg( A_hst2__sp_c3d )
  
  !
  ! check
  if ( any(abs(A_hst2__sp_c3d -A_hst1__sp_c3d )> thr) ) then
     write(0,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(0,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst1__sp_c3d)
  deallocate(A_hst2__sp_c3d)
  deallocate(A_dev1__sp_c3d)
  deallocate(A_dev2__sp_c3d)
  !
  t1=wallclock()
  write(0,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !

  !
  !=====================
  write(0,"(/,3x,a)") "checking sp_c4d ..." 
  t0=wallclock()
  !
  ! allocations
#ifdef __CUDA
  allocate( A_hst1__sp_c4d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2),bound4(1):bound4(2)), PINNED=is_pinned(1) )
  allocate( A_hst2__sp_c4d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2),bound4(1):bound4(2)), PINNED=is_pinned(2) )
#else
  is_pinned=.false.
  allocate( A_hst1__sp_c4d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2),bound4(1):bound4(2)) )
  allocate( A_hst2__sp_c4d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2),bound4(1):bound4(2)) )
#endif
  allocate( A_dev1__sp_c4d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2),bound4(1):bound4(2)) )
  allocate( A_dev2__sp_c4d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2),bound4(1):bound4(2)) )
  allocate( A_rtmp__sp_4d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2),bound4(1):bound4(2)) )
  
  write(0,"(3x,a,2l)") "host memory is pinned: ", is_pinned(1:2) 
  !
  ! init
  call random_number( A_rtmp__sp_4d )
  A_hst1__sp_c4d=A_rtmp__sp_4d
  call random_number( A_rtmp__sp_4d )
  A_hst1__sp_c4d=A_hst1__sp_c4d+cmplx(0.0,1.0)*A_rtmp__sp_4d
  !
  ! mem copy h2d
  call dev_memcpy_async(A_dev1__sp_c4d, A_hst1__sp_c4d,stream)
  call dev_stream_sync( stream )
  !
  ! mem copy
  call dev_memcpy(A_dev2__sp_c4d, A_dev1__sp_c4d )
  !
  ! make cmplx conjg
  call dev_conjg( A_dev2__sp_c4d )
  
  !
  ! mem copy d2h
  call dev_memcpy_async(A_hst2__sp_c4d, A_dev2__sp_c4d,stream)
  call dev_stream_sync( stream )
  !
  ! retrieve conjg data
  A_hst2__sp_c4d = conjg( A_hst2__sp_c4d )
  
  !
  ! check
  if ( any(abs(A_hst2__sp_c4d -A_hst1__sp_c4d )> thr) ) then
     write(0,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(0,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst1__sp_c4d)
  deallocate(A_hst2__sp_c4d)
  deallocate(A_dev1__sp_c4d)
  deallocate(A_dev2__sp_c4d)
  !
  t1=wallclock()
  write(0,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !


  !
  !=====================
  write(0,"(/,3x,a)") "checking dp_c1d ..." 
  t0=wallclock()
  !
  ! allocations
#ifdef __CUDA
  allocate( A_hst1__dp_c1d(bound1(1):bound1(2)), PINNED=is_pinned(1) )
  allocate( A_hst2__dp_c1d(bound1(1):bound1(2)), PINNED=is_pinned(2) )
#else
  is_pinned=.false.
  allocate( A_hst1__dp_c1d(bound1(1):bound1(2)) )
  allocate( A_hst2__dp_c1d(bound1(1):bound1(2)) )
#endif
  allocate( A_dev1__dp_c1d(bound1(1):bound1(2)) )
  allocate( A_dev2__dp_c1d(bound1(1):bound1(2)) )
  allocate( A_rtmp__dp_1d(bound1(1):bound1(2)) )
  
  write(0,"(3x,a,2l)") "host memory is pinned: ", is_pinned(1:2) 
  !
  ! init
  call random_number( A_rtmp__dp_1d )
  A_hst1__dp_c1d=A_rtmp__dp_1d
  call random_number( A_rtmp__dp_1d )
  A_hst1__dp_c1d=A_hst1__dp_c1d+cmplx(0.0,1.0)*A_rtmp__dp_1d
  !
  ! mem copy h2d
  call dev_memcpy_async(A_dev1__dp_c1d, A_hst1__dp_c1d,stream)
  call dev_stream_sync( stream )
  !
  ! mem copy
  call dev_memcpy(A_dev2__dp_c1d, A_dev1__dp_c1d )
  !
  ! make cmplx conjg
  call dev_conjg( A_dev2__dp_c1d )
  
  !
  ! mem copy d2h
  call dev_memcpy_async(A_hst2__dp_c1d, A_dev2__dp_c1d,stream)
  call dev_stream_sync( stream )
  !
  ! retrieve conjg data
  A_hst2__dp_c1d = conjg( A_hst2__dp_c1d )
  
  !
  ! check
  if ( any(abs(A_hst2__dp_c1d -A_hst1__dp_c1d )> thr) ) then
     write(0,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(0,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst1__dp_c1d)
  deallocate(A_hst2__dp_c1d)
  deallocate(A_dev1__dp_c1d)
  deallocate(A_dev2__dp_c1d)
  !
  t1=wallclock()
  write(0,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !

  !
  !=====================
  write(0,"(/,3x,a)") "checking dp_c2d ..." 
  t0=wallclock()
  !
  ! allocations
#ifdef __CUDA
  allocate( A_hst1__dp_c2d(bound1(1):bound1(2),bound2(1):bound2(2)), PINNED=is_pinned(1) )
  allocate( A_hst2__dp_c2d(bound1(1):bound1(2),bound2(1):bound2(2)), PINNED=is_pinned(2) )
#else
  is_pinned=.false.
  allocate( A_hst1__dp_c2d(bound1(1):bound1(2),bound2(1):bound2(2)) )
  allocate( A_hst2__dp_c2d(bound1(1):bound1(2),bound2(1):bound2(2)) )
#endif
  allocate( A_dev1__dp_c2d(bound1(1):bound1(2),bound2(1):bound2(2)) )
  allocate( A_dev2__dp_c2d(bound1(1):bound1(2),bound2(1):bound2(2)) )
  allocate( A_rtmp__dp_2d(bound1(1):bound1(2),bound2(1):bound2(2)) )
  
  write(0,"(3x,a,2l)") "host memory is pinned: ", is_pinned(1:2) 
  !
  ! init
  call random_number( A_rtmp__dp_2d )
  A_hst1__dp_c2d=A_rtmp__dp_2d
  call random_number( A_rtmp__dp_2d )
  A_hst1__dp_c2d=A_hst1__dp_c2d+cmplx(0.0,1.0)*A_rtmp__dp_2d
  !
  ! mem copy h2d
  call dev_memcpy_async(A_dev1__dp_c2d, A_hst1__dp_c2d,stream)
  call dev_stream_sync( stream )
  !
  ! mem copy
  call dev_memcpy(A_dev2__dp_c2d, A_dev1__dp_c2d )
  !
  ! make cmplx conjg
  call dev_conjg( A_dev2__dp_c2d )
  
  !
  ! mem copy d2h
  call dev_memcpy_async(A_hst2__dp_c2d, A_dev2__dp_c2d,stream)
  call dev_stream_sync( stream )
  !
  ! retrieve conjg data
  A_hst2__dp_c2d = conjg( A_hst2__dp_c2d )
  
  !
  ! check
  if ( any(abs(A_hst2__dp_c2d -A_hst1__dp_c2d )> thr) ) then
     write(0,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(0,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst1__dp_c2d)
  deallocate(A_hst2__dp_c2d)
  deallocate(A_dev1__dp_c2d)
  deallocate(A_dev2__dp_c2d)
  !
  t1=wallclock()
  write(0,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !

  !
  !=====================
  write(0,"(/,3x,a)") "checking dp_c3d ..." 
  t0=wallclock()
  !
  ! allocations
#ifdef __CUDA
  allocate( A_hst1__dp_c3d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2)), PINNED=is_pinned(1) )
  allocate( A_hst2__dp_c3d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2)), PINNED=is_pinned(2) )
#else
  is_pinned=.false.
  allocate( A_hst1__dp_c3d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2)) )
  allocate( A_hst2__dp_c3d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2)) )
#endif
  allocate( A_dev1__dp_c3d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2)) )
  allocate( A_dev2__dp_c3d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2)) )
  allocate( A_rtmp__dp_3d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2)) )
  
  write(0,"(3x,a,2l)") "host memory is pinned: ", is_pinned(1:2) 
  !
  ! init
  call random_number( A_rtmp__dp_3d )
  A_hst1__dp_c3d=A_rtmp__dp_3d
  call random_number( A_rtmp__dp_3d )
  A_hst1__dp_c3d=A_hst1__dp_c3d+cmplx(0.0,1.0)*A_rtmp__dp_3d
  !
  ! mem copy h2d
  call dev_memcpy_async(A_dev1__dp_c3d, A_hst1__dp_c3d,stream)
  call dev_stream_sync( stream )
  !
  ! mem copy
  call dev_memcpy(A_dev2__dp_c3d, A_dev1__dp_c3d )
  !
  ! make cmplx conjg
  call dev_conjg( A_dev2__dp_c3d )
  
  !
  ! mem copy d2h
  call dev_memcpy_async(A_hst2__dp_c3d, A_dev2__dp_c3d,stream)
  call dev_stream_sync( stream )
  !
  ! retrieve conjg data
  A_hst2__dp_c3d = conjg( A_hst2__dp_c3d )
  
  !
  ! check
  if ( any(abs(A_hst2__dp_c3d -A_hst1__dp_c3d )> thr) ) then
     write(0,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(0,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst1__dp_c3d)
  deallocate(A_hst2__dp_c3d)
  deallocate(A_dev1__dp_c3d)
  deallocate(A_dev2__dp_c3d)
  !
  t1=wallclock()
  write(0,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !

  !
  !=====================
  write(0,"(/,3x,a)") "checking dp_c4d ..." 
  t0=wallclock()
  !
  ! allocations
#ifdef __CUDA
  allocate( A_hst1__dp_c4d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2),bound4(1):bound4(2)), PINNED=is_pinned(1) )
  allocate( A_hst2__dp_c4d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2),bound4(1):bound4(2)), PINNED=is_pinned(2) )
#else
  is_pinned=.false.
  allocate( A_hst1__dp_c4d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2),bound4(1):bound4(2)) )
  allocate( A_hst2__dp_c4d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2),bound4(1):bound4(2)) )
#endif
  allocate( A_dev1__dp_c4d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2),bound4(1):bound4(2)) )
  allocate( A_dev2__dp_c4d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2),bound4(1):bound4(2)) )
  allocate( A_rtmp__dp_4d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2),bound4(1):bound4(2)) )
  
  write(0,"(3x,a,2l)") "host memory is pinned: ", is_pinned(1:2) 
  !
  ! init
  call random_number( A_rtmp__dp_4d )
  A_hst1__dp_c4d=A_rtmp__dp_4d
  call random_number( A_rtmp__dp_4d )
  A_hst1__dp_c4d=A_hst1__dp_c4d+cmplx(0.0,1.0)*A_rtmp__dp_4d
  !
  ! mem copy h2d
  call dev_memcpy_async(A_dev1__dp_c4d, A_hst1__dp_c4d,stream)
  call dev_stream_sync( stream )
  !
  ! mem copy
  call dev_memcpy(A_dev2__dp_c4d, A_dev1__dp_c4d )
  !
  ! make cmplx conjg
  call dev_conjg( A_dev2__dp_c4d )
  
  !
  ! mem copy d2h
  call dev_memcpy_async(A_hst2__dp_c4d, A_dev2__dp_c4d,stream)
  call dev_stream_sync( stream )
  !
  ! retrieve conjg data
  A_hst2__dp_c4d = conjg( A_hst2__dp_c4d )
  
  !
  ! check
  if ( any(abs(A_hst2__dp_c4d -A_hst1__dp_c4d )> thr) ) then
     write(0,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(0,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst1__dp_c4d)
  deallocate(A_hst2__dp_c4d)
  deallocate(A_dev1__dp_c4d)
  deallocate(A_dev2__dp_c4d)
  !
  t1=wallclock()
  write(0,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !



  !
  !=====================
  write(0,"(/,3x,a)") "checking i4_i1d ..." 
  t0=wallclock()
  !
  ! allocations
#ifdef __CUDA
  allocate( A_hst1__i4_i1d(bound1(1):bound1(2)), PINNED=is_pinned(1) )
  allocate( A_hst2__i4_i1d(bound1(1):bound1(2)), PINNED=is_pinned(2) )
#else
  is_pinned=.false.
  allocate( A_hst1__i4_i1d(bound1(1):bound1(2)) )
  allocate( A_hst2__i4_i1d(bound1(1):bound1(2)) )
#endif
  allocate( A_dev1__i4_i1d(bound1(1):bound1(2)) )
  allocate( A_dev2__i4_i1d(bound1(1):bound1(2)) )
  allocate( A_rtmp__i4_1d(bound1(1):bound1(2)) )
  
  write(0,"(3x,a,2l)") "host memory is pinned: ", is_pinned(1:2) 
  !
  ! init
  call random_number( A_rtmp__i4_1d )
  A_hst1__i4_i1d=int( 1000* A_rtmp__i4_1d )
  
  !
  ! mem copy h2d
  call dev_memcpy_async(A_dev1__i4_i1d, A_hst1__i4_i1d,stream)
  call dev_stream_sync( stream )
  !
  ! mem copy
  call dev_memcpy(A_dev2__i4_i1d, A_dev1__i4_i1d )
  !
  !
  ! mem copy d2h
  call dev_memcpy_async(A_hst2__i4_i1d, A_dev2__i4_i1d,stream)
  call dev_stream_sync( stream )
  !
  !
  ! check
  if ( any(abs(A_hst2__i4_i1d -A_hst1__i4_i1d )> thr) ) then
     write(0,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(0,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst1__i4_i1d)
  deallocate(A_hst2__i4_i1d)
  deallocate(A_dev1__i4_i1d)
  deallocate(A_dev2__i4_i1d)
  !
  t1=wallclock()
  write(0,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !

  !
  !=====================
  write(0,"(/,3x,a)") "checking i4_i2d ..." 
  t0=wallclock()
  !
  ! allocations
#ifdef __CUDA
  allocate( A_hst1__i4_i2d(bound1(1):bound1(2),bound2(1):bound2(2)), PINNED=is_pinned(1) )
  allocate( A_hst2__i4_i2d(bound1(1):bound1(2),bound2(1):bound2(2)), PINNED=is_pinned(2) )
#else
  is_pinned=.false.
  allocate( A_hst1__i4_i2d(bound1(1):bound1(2),bound2(1):bound2(2)) )
  allocate( A_hst2__i4_i2d(bound1(1):bound1(2),bound2(1):bound2(2)) )
#endif
  allocate( A_dev1__i4_i2d(bound1(1):bound1(2),bound2(1):bound2(2)) )
  allocate( A_dev2__i4_i2d(bound1(1):bound1(2),bound2(1):bound2(2)) )
  allocate( A_rtmp__i4_2d(bound1(1):bound1(2),bound2(1):bound2(2)) )
  
  write(0,"(3x,a,2l)") "host memory is pinned: ", is_pinned(1:2) 
  !
  ! init
  call random_number( A_rtmp__i4_2d )
  A_hst1__i4_i2d=int( 1000* A_rtmp__i4_2d )
  
  !
  ! mem copy h2d
  call dev_memcpy_async(A_dev1__i4_i2d, A_hst1__i4_i2d,stream)
  call dev_stream_sync( stream )
  !
  ! mem copy
  call dev_memcpy(A_dev2__i4_i2d, A_dev1__i4_i2d )
  !
  !
  ! mem copy d2h
  call dev_memcpy_async(A_hst2__i4_i2d, A_dev2__i4_i2d,stream)
  call dev_stream_sync( stream )
  !
  !
  ! check
  if ( any(abs(A_hst2__i4_i2d -A_hst1__i4_i2d )> thr) ) then
     write(0,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(0,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst1__i4_i2d)
  deallocate(A_hst2__i4_i2d)
  deallocate(A_dev1__i4_i2d)
  deallocate(A_dev2__i4_i2d)
  !
  t1=wallclock()
  write(0,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !

  !
  !=====================
  write(0,"(/,3x,a)") "checking i4_i3d ..." 
  t0=wallclock()
  !
  ! allocations
#ifdef __CUDA
  allocate( A_hst1__i4_i3d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2)), PINNED=is_pinned(1) )
  allocate( A_hst2__i4_i3d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2)), PINNED=is_pinned(2) )
#else
  is_pinned=.false.
  allocate( A_hst1__i4_i3d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2)) )
  allocate( A_hst2__i4_i3d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2)) )
#endif
  allocate( A_dev1__i4_i3d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2)) )
  allocate( A_dev2__i4_i3d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2)) )
  allocate( A_rtmp__i4_3d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2)) )
  
  write(0,"(3x,a,2l)") "host memory is pinned: ", is_pinned(1:2) 
  !
  ! init
  call random_number( A_rtmp__i4_3d )
  A_hst1__i4_i3d=int( 1000* A_rtmp__i4_3d )
  
  !
  ! mem copy h2d
  call dev_memcpy_async(A_dev1__i4_i3d, A_hst1__i4_i3d,stream)
  call dev_stream_sync( stream )
  !
  ! mem copy
  call dev_memcpy(A_dev2__i4_i3d, A_dev1__i4_i3d )
  !
  !
  ! mem copy d2h
  call dev_memcpy_async(A_hst2__i4_i3d, A_dev2__i4_i3d,stream)
  call dev_stream_sync( stream )
  !
  !
  ! check
  if ( any(abs(A_hst2__i4_i3d -A_hst1__i4_i3d )> thr) ) then
     write(0,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(0,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst1__i4_i3d)
  deallocate(A_hst2__i4_i3d)
  deallocate(A_dev1__i4_i3d)
  deallocate(A_dev2__i4_i3d)
  !
  t1=wallclock()
  write(0,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !

  !
  !=====================
  write(0,"(/,3x,a)") "checking i4_i4d ..." 
  t0=wallclock()
  !
  ! allocations
#ifdef __CUDA
  allocate( A_hst1__i4_i4d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2),bound4(1):bound4(2)), PINNED=is_pinned(1) )
  allocate( A_hst2__i4_i4d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2),bound4(1):bound4(2)), PINNED=is_pinned(2) )
#else
  is_pinned=.false.
  allocate( A_hst1__i4_i4d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2),bound4(1):bound4(2)) )
  allocate( A_hst2__i4_i4d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2),bound4(1):bound4(2)) )
#endif
  allocate( A_dev1__i4_i4d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2),bound4(1):bound4(2)) )
  allocate( A_dev2__i4_i4d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2),bound4(1):bound4(2)) )
  allocate( A_rtmp__i4_4d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2),bound4(1):bound4(2)) )
  
  write(0,"(3x,a,2l)") "host memory is pinned: ", is_pinned(1:2) 
  !
  ! init
  call random_number( A_rtmp__i4_4d )
  A_hst1__i4_i4d=int( 1000* A_rtmp__i4_4d )
  
  !
  ! mem copy h2d
  call dev_memcpy_async(A_dev1__i4_i4d, A_hst1__i4_i4d,stream)
  call dev_stream_sync( stream )
  !
  ! mem copy
  call dev_memcpy(A_dev2__i4_i4d, A_dev1__i4_i4d )
  !
  !
  ! mem copy d2h
  call dev_memcpy_async(A_hst2__i4_i4d, A_dev2__i4_i4d,stream)
  call dev_stream_sync( stream )
  !
  !
  ! check
  if ( any(abs(A_hst2__i4_i4d -A_hst1__i4_i4d )> thr) ) then
     write(0,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(0,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst1__i4_i4d)
  deallocate(A_hst2__i4_i4d)
  deallocate(A_dev1__i4_i4d)
  deallocate(A_dev2__i4_i4d)
  !
  t1=wallclock()
  write(0,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !




  !
  ! summary
  !
  write(0,"(/,a)") "Test SUMMARY:"
  write(0,"(3x,a,i5)") "# passed: ", npass
  write(0,"(3x,a,i5)") "# failed: ", nfail
  write(0,"()")

end program test_memcpy_async

!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
  module cuda_runtime_h
!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
    use, intrinsic :: ISO_C_BINDING
    use cuda_unknowns

    implicit none

    enum, bind(C) !:: cudaRoundMode
      enumerator :: cudaRoundNearest
      enumerator :: cudaRoundZero
      enumerator :: cudaRoundPosInf
      enumerator :: cudaRoundMinInf
    end enum ! cudaRoundMode

    enum, bind(C) !:: cudaError
      enumerator :: cudaSuccess=0
      enumerator :: cudaErrorMissingConfiguration=1
      enumerator :: cudaErrorMemoryAllocation=2
      enumerator :: cudaErrorInitializationError=3
      enumerator :: cudaErrorLaunchFailure=4
      enumerator :: cudaErrorPriorLaunchFailure=5
      enumerator :: cudaErrorLaunchTimeout=6
      enumerator :: cudaErrorLaunchOutOfResources=7
      enumerator :: cudaErrorInvalidDeviceFunction=8
      enumerator :: cudaErrorInvalidConfiguration=9
      enumerator :: cudaErrorInvalidDevice=10
      enumerator :: cudaErrorInvalidValue=11
      enumerator :: cudaErrorInvalidPitchValue=12
      enumerator :: cudaErrorInvalidSymbol=13
      enumerator :: cudaErrorMapBufferObjectFailed=14
      enumerator :: cudaErrorUnmapBufferObjectFailed=15
      enumerator :: cudaErrorInvalidHostPointer=16
      enumerator :: cudaErrorInvalidDevicePointer=17
      enumerator :: cudaErrorInvalidTexture=18
      enumerator :: cudaErrorInvalidTextureBinding=19
      enumerator :: cudaErrorInvalidChannelDescriptor=20
      enumerator :: cudaErrorInvalidMemcpyDirection=21
      enumerator :: cudaErrorAddressOfConstant=22
      enumerator :: cudaErrorTextureFetchFailed=23
      enumerator :: cudaErrorTextureNotBound=24
      enumerator :: cudaErrorSynchronizationError=25
      enumerator :: cudaErrorInvalidFilterSetting=26
      enumerator :: cudaErrorInvalidNormSetting=27
      enumerator :: cudaErrorMixedDeviceExecution=28
      enumerator :: cudaErrorCudartUnloading=29
      enumerator :: cudaErrorUnknown=30
      enumerator :: cudaErrorNotYetImplemented=31
      enumerator :: cudaErrorMemoryValueTooLarge=32
      enumerator :: cudaErrorInvalidResourceHandle=33
      enumerator :: cudaErrorNotReady=34
      enumerator :: cudaErrorInsufficientDriver=35
      enumerator :: cudaErrorSetOnActiveProcess=36
      enumerator :: cudaErrorInvalidSurface=37
      enumerator :: cudaErrorNoDevice=38
      enumerator :: cudaErrorECCUncorrectable=39
      enumerator :: cudaErrorSharedObjectSymbolNotFound=40
      enumerator :: cudaErrorSharedObjectInitFailed=41
      enumerator :: cudaErrorUnsupportedLimit=42
      enumerator :: cudaErrorDuplicateVariableName=43
      enumerator :: cudaErrorDuplicateTextureName=44
      enumerator :: cudaErrorDuplicateSurfaceName=45
      enumerator :: cudaErrorDevicesUnavailable=46
      enumerator :: cudaErrorStartupFailure=127
      enumerator :: cudaErrorApiFailureBase=10000
    end enum ! cudaError

    enum, bind(C) !:: cudaChannelFormatKind
      enumerator :: cudaChannelFormatKindSigned=0
      enumerator :: cudaChannelFormatKindUnsigned=1
      enumerator :: cudaChannelFormatKindFloat=2
      enumerator :: cudaChannelFormatKindNone=3
    end enum ! cudaChannelFormatKind

    enum, bind(C) !:: cudaMemcpyKind
      enumerator :: cudaMemcpyHostToHost=0
      enumerator :: cudaMemcpyHostToDevice=1
      enumerator :: cudaMemcpyDeviceToHost=2
      enumerator :: cudaMemcpyDeviceToDevice=3
    end enum ! cudaMemcpyKind

    enum, bind(C) !:: cudaGraphicsRegisterFlags
      enumerator :: cudaGraphicsRegisterFlagsNone=0
    end enum ! cudaGraphicsRegisterFlags

    enum, bind(C) !:: cudaGraphicsMapFlags
      enumerator :: cudaGraphicsMapFlagsNone=0
      enumerator :: cudaGraphicsMapFlagsReadOnly=1
      enumerator :: cudaGraphicsMapFlagsWriteDiscard=2
    end enum ! cudaGraphicsMapFlags

    enum, bind(C) !:: cudaGraphicsCubeFace
      enumerator :: cudaGraphicsCubeFacePositiveX=0
      enumerator :: cudaGraphicsCubeFaceNegativeX=1
      enumerator :: cudaGraphicsCubeFacePositiveY=2
      enumerator :: cudaGraphicsCubeFaceNegativeY=3
      enumerator :: cudaGraphicsCubeFacePositiveZ=4
      enumerator :: cudaGraphicsCubeFaceNegativeZ=5
    end enum ! cudaGraphicsCubeFace

    enum, bind(C) !:: cudaFuncCache
      enumerator :: cudaFuncCachePreferNone=0
      enumerator :: cudaFuncCachePreferShared=1
      enumerator :: cudaFuncCachePreferL1=2
    end enum ! cudaFuncCache

    enum, bind(C) !:: cudaComputeMode
      enumerator :: cudaComputeModeDefault=0
      enumerator :: cudaComputeModeExclusive=1
      enumerator :: cudaComputeModeProhibited=2
    end enum ! cudaComputeMode

    enum, bind(C) !:: cudaLimit
      enumerator :: cudaLimitStackSize=0
      enumerator :: cudaLimitPrintfFifoSize=1
    end enum ! cudaLimit

    enum, bind(C) !:: cudaSurfaceBoundaryMode
      enumerator :: cudaBoundaryModeZero=0
      enumerator :: cudaBoundaryModeClamp=1
      enumerator :: cudaBoundaryModeTrap=2
    end enum ! cudaSurfaceBoundaryMode

    enum, bind(C) !:: cudaSurfaceFormatMode
      enumerator :: cudaFormatModeForced
      enumerator :: cudaFormatModeAuto
    end enum ! cudaSurfaceFormatMode

    enum, bind(C) !:: cudaTextureAddressMode
      enumerator :: cudaAddressModeWrap
      enumerator :: cudaAddressModeClamp
      enumerator :: cudaAddressModeMirror
    end enum ! cudaTextureAddressMode

    enum, bind(C) !:: cudaTextureFilterMode
      enumerator :: cudaFilterModePoint
      enumerator :: cudaFilterModeLinear
    end enum ! cudaTextureFilterMode

    enum, bind(C) !:: cudaTextureReadMode
      enumerator :: cudaReadModeElementType
      enumerator :: cudaReadModeNormalizedFloat
    end enum ! cudaTextureReadMode

    type, bind(C) :: cudaChannelFormatDesc
      integer(c_int) :: x
      integer(c_int) :: y
      integer(c_int) :: z
      integer(c_int) :: w
      integer (KIND(cudaChannelFormatKindSigned)) :: f
    end type cudaChannelFormatDesc

    type, bind(C) :: cudaPitchedPtr
      type(c_ptr) :: ptr
      integer(c_int) :: pitch
      integer(c_int) :: xsize
      integer(c_int) :: ysize
    end type cudaPitchedPtr

    type, bind(C) :: cudaExtent
      integer(c_int) :: width
      integer(c_int) :: height
      integer(c_int) :: depth
    end type cudaExtent

    type, bind(C) :: cudaPos
      integer(c_int) :: x
      integer(c_int) :: y
      integer(c_int) :: z
    end type cudaPos

    type, bind(C) :: cudaMemcpy3DParms
      type (c_ptr) :: srcArray
      type (cudaPos) :: srcPos
      type (cudaPitchedPtr) :: srcPtr
      type (c_ptr) :: dstArray
      type (cudaPos) :: dstPos
      type (cudaPitchedPtr) :: dstPtr
      type (cudaExtent) :: extent
      integer (KIND(cudaMemcpyHostToHost)) :: kind
    end type cudaMemcpy3DParms

    type, bind(C) :: cudaFuncAttributes
      integer(c_int) :: sharedSizeBytes
      integer(c_int) :: constSizeBytes
      integer(c_int) :: localSizeBytes
      integer(c_int) :: maxThreadsPerBlock
      integer(c_int) :: numRegs
      integer(c_int) :: ptxVersion
      integer(c_int) :: binaryVersion
      integer(c_int) :: cudaReserved__(6)
    end type cudaFuncAttributes

    type, bind(C) :: cudaDeviceProp
      character(c_char) :: name(256)
      integer(c_int) :: totalGlobalMem
      integer(c_int) :: sharedMemPerBlock
      integer(c_int) :: regsPerBlock
      integer(c_int) :: warpSize
      integer(c_int) :: memPitch
      integer(c_int) :: maxThreadsPerBlock
      integer(c_int) :: maxThreadsDim(3)
      integer(c_int) :: maxGridSize(3)
      integer(c_int) :: clockRate
      integer(c_int) :: totalConstMem
      integer(c_int) :: major
      integer(c_int) :: minor
      integer(c_int) :: textureAlignment
      integer(c_int) :: deviceOverlap
      integer(c_int) :: multiProcessorCount
      integer(c_int) :: kernelExecTimeoutEnabled
      integer(c_int) :: integrated
      integer(c_int) :: canMapHostMemory
      integer(c_int) :: computeMode
      integer(c_int) :: maxTexture1D
      integer(c_int) :: maxTexture2D(2)
      integer(c_int) :: maxTexture3D(3)
      integer(c_int) :: maxTexture2DArray(3)
      integer(c_int) :: surfaceAlignment
      integer(c_int) :: concurrentKernels
      integer(c_int) :: ECCEnabled
      integer(c_int) :: pciBusID
      integer(c_int) :: pciDeviceID
      integer(c_int) :: cudaReserved__(22)
    end type cudaDeviceProp

    type, bind(C) :: surfaceReference
      type (cudaChannelFormatDesc) :: channelDesc
    end type surfaceReference

    type, bind(C) :: textureReference
      integer(c_int) :: normalized
      integer (KIND(cudaFilterModePoint)) :: filterMode
      integer (KIND(cudaAddressModeWrap)) :: addressMode(3)
      type (cudaChannelFormatDesc) :: channelDesc
      integer(c_int) :: cudaReserved__(16)
    end type textureReference

    type, bind(C) :: uchar1
      integer(c_signed_char) :: x
    end type uchar1

    type, bind(C) :: uchar3
      integer(c_signed_char) :: x
      integer(c_signed_char) :: y
      integer(c_signed_char) :: z
    end type uchar3

    type, bind(C) :: short1
      integer(c_short) :: x
    end type short1

    type, bind(C) :: short3
      integer(c_short) :: x
      integer(c_short) :: y
      integer(c_short) :: z
    end type short3

    type, bind(C) :: int1
      integer(c_int) :: x
    end type int1

    type, bind(C) :: uint1
      integer(c_int) :: x
    end type uint1

    type, bind(C) :: int3
      integer(c_int) :: x
      integer(c_int) :: y
      integer(c_int) :: z
    end type int3

    type, bind(C) :: uint3
      integer(c_int) :: x
      integer(c_int) :: y
      integer(c_int) :: z
    end type uint3

    type, bind(C) :: long1
      integer(c_long) :: x
    end type long1

    type, bind(C) :: long3
      integer(c_long) :: x
      integer(c_long) :: y
      integer(c_long) :: z
    end type long3

    type, bind(C) :: ulong3
      integer(c_long) :: x
      integer(c_long) :: y
      integer(c_long) :: z
    end type ulong3

    type, bind(C) :: float1
      real(c_float) :: x
    end type float1

    type, bind(C) :: float3
      real(c_float) :: x
      real(c_float) :: y
      real(c_float) :: z
    end type float3

    type, bind(C) :: longlong1
      integer(c_long_long) :: x
    end type longlong1

    type, bind(C) :: ulonglong1
      integer(c_long_long) :: x
    end type ulonglong1

    type, bind(C) :: longlong3
      integer(c_long_long) :: x
      integer(c_long_long) :: y
      integer(c_long_long) :: z
    end type longlong3

    type, bind(C) :: ulonglong3
      integer(c_long_long) :: x
      integer(c_long_long) :: y
      integer(c_long_long) :: z
    end type ulonglong3

    type, bind(C) :: double1
      real(c_double) :: x
    end type double1

    type, bind(C) :: double3
      real(c_double) :: x
      real(c_double) :: y
      real(c_double) :: z
    end type double3

    type, bind(C) :: dim3
      integer(c_int) :: x
      integer(c_int) :: y
      integer(c_int) :: z
    end type dim3

    interface ! [['cudaError_t', None], 'cudaMalloc3D', [['struct', 'cudaPitchedPtr', '*', 'pitchedDevPtr'], ['struct', 'cudaExtent', None, 'extent']]]
      function cudaMalloc3D(pitchedDevPtr,extent) result( res ) bind(C, name="cudaMalloc3D")
        use, intrinsic :: ISO_C_BINDING
        import cudaSuccess
        import cudaPitchedPtr
        import cudaExtent
        implicit none
        type (cudaPitchedPtr) :: pitchedDevPtr
        type (cudaExtent), value :: extent
        integer (KIND(cudaSuccess)) :: res
      end function cudaMalloc3D
    end interface

    interface ! [['cudaError_t', None], 'cudaMemset3D', [['struct', 'cudaPitchedPtr', None, 'pitchedDevPtr'], ['int', None, 'value'], ['struct', 'cudaExtent', None, 'extent']]]
      function cudaMemset3D(pitchedDevPtr,value,extent) result( res ) bind(C, name="cudaMemset3D")
        use, intrinsic :: ISO_C_BINDING
        import cudaSuccess
        import cudaPitchedPtr
        import cudaExtent
        implicit none
        type (cudaPitchedPtr), value :: pitchedDevPtr
        integer(c_int), value :: value
        type (cudaExtent), value :: extent
        integer (KIND(cudaSuccess)) :: res
      end function cudaMemset3D
    end interface

    interface ! [['cudaError_t', None], 'cudaMalloc', [['void', '**', 'devPtr'], ['size_t', None, 'size']]]
      function cudaMalloc(devPtr,size) result( res ) bind(C, name="cudaMalloc")
        use, intrinsic :: ISO_C_BINDING
        import cudaSuccess
        implicit none
        type(c_ptr) :: devPtr
        integer(c_size_t), value :: size
        integer (KIND(cudaSuccess)) :: res
      end function cudaMalloc
    end interface

    interface ! [['cudaError_t', None], 'cudaMallocHost', [['void', '**', 'ptr'], ['size_t', None, 'size']]]
      function cudaMallocHost(ptr,size) result( res ) bind(C, name="cudaMallocHost")
        use, intrinsic :: ISO_C_BINDING
        import cudaSuccess
        implicit none
        type(c_ptr) :: ptr
        integer(c_size_t), value :: size
        integer (KIND(cudaSuccess)) :: res
      end function cudaMallocHost
    end interface

    interface ! [['cudaError_t', None], 'cudaMallocPitch', [['void', '**', 'devPtr'], ['size_t', '*', 'pitch'], ['size_t', None, 'width'], ['size_t', None, 'height']]]
      function cudaMallocPitch(devPtr,pitch,width,height) result( res ) bind(C, name="cudaMallocPitch")
        use, intrinsic :: ISO_C_BINDING
        import cudaSuccess
        implicit none
        type(c_ptr) :: devPtr
        integer(c_size_t) :: pitch
        integer(c_size_t), value :: width
        integer(c_size_t), value :: height
        integer (KIND(cudaSuccess)) :: res
      end function cudaMallocPitch
    end interface

    interface ! [['cudaError_t', None], 'cudaFree', [['void', '*', 'devPtr']]]
      function cudaFree(devPtr) result( res ) bind(C, name="cudaFree")
        use, intrinsic :: ISO_C_BINDING
        import cudaSuccess
        implicit none
        type(c_ptr), value :: devPtr
        integer (KIND(cudaSuccess)) :: res
      end function cudaFree
    end interface

    interface ! [['cudaError_t', None], 'cudaFreeHost', [['void', '*', 'ptr']]]
      function cudaFreeHost(ptr) result( res ) bind(C, name="cudaFreeHost")
        use, intrinsic :: ISO_C_BINDING
        import cudaSuccess
        implicit none
        type(c_ptr), value :: ptr
        integer (KIND(cudaSuccess)) :: res
      end function cudaFreeHost
    end interface

    interface ! [['cudaError_t', None], 'cudaFreeArray', [['struct', 'cudaArray', '*', 'array']]]
      function cudaFreeArray(array) result( res ) bind(C, name="cudaFreeArray")
        use, intrinsic :: ISO_C_BINDING
        import cudaSuccess
        implicit none
        type (c_ptr), value :: array
        integer (KIND(cudaSuccess)) :: res
      end function cudaFreeArray
    end interface

    interface ! [['cudaError_t', None], 'cudaHostAlloc', [['void', '**', 'pHost'], ['size_t', None, 'bytes'], ['unsigned', 'int', None, 'flags']]]
      function cudaHostAlloc(pHost,bytes,flags) result( res ) bind(C, name="cudaHostAlloc")
        use, intrinsic :: ISO_C_BINDING
        import cudaSuccess
        implicit none
        type(c_ptr) :: pHost
        integer(c_size_t), value :: bytes
        integer(c_int), value :: flags
        integer (KIND(cudaSuccess)) :: res
      end function cudaHostAlloc
    end interface

    interface ! [['cudaError_t', None], 'cudaHostGetDevicePointer', [['void', '**', 'pDevice'], ['void', '*', 'pHost'], ['unsigned', 'int', None, 'flags']]]
      function cudaHostGetDevicePointer(pDevice,pHost,flags) result( res ) bind(C, name="cudaHostGetDevicePointer")
        use, intrinsic :: ISO_C_BINDING
        import cudaSuccess
        implicit none
        type(c_ptr) :: pDevice
        type(c_ptr), value :: pHost
        integer(c_int), value :: flags
        integer (KIND(cudaSuccess)) :: res
      end function cudaHostGetDevicePointer
    end interface

    interface ! [['cudaError_t', None], 'cudaHostGetFlags', [['unsigned', 'int', '*', 'pFlags'], ['void', '*', 'pHost']]]
      function cudaHostGetFlags(pFlags,pHost) result( res ) bind(C, name="cudaHostGetFlags")
        use, intrinsic :: ISO_C_BINDING
        import cudaSuccess
        implicit none
        integer(c_int) :: pFlags
        type(c_ptr), value :: pHost
        integer (KIND(cudaSuccess)) :: res
      end function cudaHostGetFlags
    end interface

    interface ! [['cudaError_t', None], 'cudaMemGetInfo', [['size_t', '*', 'free'], ['size_t', '*', 'total']]]
      function cudaMemGetInfo(free,total) result( res ) bind(C, name="cudaMemGetInfo")
        use, intrinsic :: ISO_C_BINDING
        import cudaSuccess
        implicit none
        integer(c_int) :: free
        integer(c_int) :: total
        integer (KIND(cudaSuccess)) :: res
      end function cudaMemGetInfo
    end interface

    interface ! [['cudaError_t', None], 'cudaMemcpy', [['void', '*', 'dst'], ['const', 'void', '*', 'src'], ['size_t', None, 'count'], ['enum', 'cudaMemcpyKind', None, 'kind']]]
      function cudaMemcpy(dst,src,count,kind_arg) result( res ) bind(C, name="cudaMemcpy")
        use, intrinsic :: ISO_C_BINDING
        import cudaSuccess
        import cudaMemcpyHostToHost
        implicit none
        type(c_ptr), value :: dst
        type(c_ptr), value :: src
        integer(c_int), value :: count
        integer (KIND(cudaMemcpyHostToHost)), value :: kind_arg
        integer (KIND(cudaSuccess)) :: res
      end function cudaMemcpy
    end interface

    interface ! [['cudaError_t', None], 'cudaMemcpyToArray', [['struct', 'cudaArray', '*', 'dst'], ['size_t', None, 'wOffset'], ['size_t', None, 'hOffset'], ['const', 'void', '*', 'src'], ['size_t', None, 'count'], ['enum', 'cudaMemcpyKind', None, 'kind']]]
      function cudaMemcpyToArray(dst,wOffset,hOffset,src,count,kind_arg) result( res ) bind(C, name="cudaMemcpyToArray")
        use, intrinsic :: ISO_C_BINDING
        import cudaSuccess
        import cudaMemcpyHostToHost
        implicit none
        type (c_ptr), value :: dst
        integer(c_int), value :: wOffset
        integer(c_int), value :: hOffset
        type(c_ptr), value :: src
        integer(c_int), value :: count
        integer (KIND(cudaMemcpyHostToHost)), value :: kind_arg
        integer (KIND(cudaSuccess)) :: res
      end function cudaMemcpyToArray
    end interface

    interface ! [['cudaError_t', None], 'cudaMemcpy2D', [['void', '*', 'dst'], ['size_t', None, 'dpitch'], ['const', 'void', '*', 'src'], ['size_t', None, 'spitch'], ['size_t', None, 'width'], ['size_t', None, 'height'], ['enum', 'cudaMemcpyKind', None, 'kind']]]
      function cudaMemcpy2D(dst,dpitch,src,spitch,width,height,kind_arg) result( res ) bind(C, name="cudaMemcpy2D")
        use, intrinsic :: ISO_C_BINDING
        import cudaSuccess
        import cudaMemcpyHostToHost
        implicit none
        type(c_ptr), value :: dst
        integer(c_int), value :: dpitch
        type(c_ptr), value :: src
        integer(c_int), value :: spitch
        integer(c_int), value :: width
        integer(c_int), value :: height
        integer (KIND(cudaMemcpyHostToHost)), value :: kind_arg
        integer (KIND(cudaSuccess)) :: res
      end function cudaMemcpy2D
    end interface

    interface ! [['cudaError_t', None], 'cudaMemcpy2DToArray', [['struct', 'cudaArray', '*', 'dst'], ['size_t', None, 'wOffset'], ['size_t', None, 'hOffset'], ['const', 'void', '*', 'src'], ['size_t', None, 'spitch'], ['size_t', None, 'width'], ['size_t', None, 'height'], ['enum', 'cudaMemcpyKind', None, 'kind']]]
      function cudaMemcpy2DToArray(dst,wOffset,hOffset,src,spitch,width,height,kind_arg) result( res ) bind(C, name="cudaMemcpy2DToArray")
        use, intrinsic :: ISO_C_BINDING
        import cudaSuccess
        import cudaMemcpyHostToHost
        implicit none
        type (c_ptr), value :: dst
        integer(c_int), value :: wOffset
        integer(c_int), value :: hOffset
        type(c_ptr), value :: src
        integer(c_int), value :: spitch
        integer(c_int), value :: width
        integer(c_int), value :: height
        integer (KIND(cudaMemcpyHostToHost)), value :: kind_arg
        integer (KIND(cudaSuccess)) :: res
      end function cudaMemcpy2DToArray
    end interface

    interface ! [['cudaError_t', None], 'cudaMemcpyToSymbol', [['const', 'char', '*', 'symbol'], ['const', 'void', '*', 'src'], ['size_t', None, 'count'], ['size_t', None, 'offset'], ['enum', 'cudaMemcpyKind', None, 'kind']]]
      function cudaMemcpyToSymbol(symbol,src,count,offset,kind_arg) result( res ) bind(C, name="cudaMemcpyToSymbol")
        use, intrinsic :: ISO_C_BINDING
        import cudaSuccess
        import cudaMemcpyHostToHost
        implicit none
        character(c_char) :: symbol
        type(c_ptr), value :: src
        integer(c_int), value :: count
        integer(c_int), value :: offset
        integer (KIND(cudaMemcpyHostToHost)), value :: kind_arg
        integer (KIND(cudaSuccess)) :: res
      end function cudaMemcpyToSymbol
    end interface

    interface ! [['cudaError_t', None], 'cudaMemcpyFromSymbol', [['void', '*', 'dst'], ['const', 'char', '*', 'symbol'], ['size_t', None, 'count'], ['size_t', None, 'offset'], ['enum', 'cudaMemcpyKind', None, 'kind']]]
      function cudaMemcpyFromSymbol(dst,symbol,count,offset,kind_arg) result( res ) bind(C, name="cudaMemcpyFromSymbol")
        use, intrinsic :: ISO_C_BINDING
        import cudaSuccess
        import cudaMemcpyHostToHost
        implicit none
        type(c_ptr), value :: dst
        character(c_char) :: symbol
        integer(c_int), value :: count
        integer(c_int), value :: offset
        integer (KIND(cudaMemcpyHostToHost)), value :: kind_arg
        integer (KIND(cudaSuccess)) :: res
      end function cudaMemcpyFromSymbol
    end interface

    interface ! [['cudaError_t', None], 'cudaMemcpyAsync', [['void', '*', 'dst'], ['const', 'void', '*', 'src'], ['size_t', None, 'count'], ['enum', 'cudaMemcpyKind', None, 'kind'], ['cudaStream_t', None, 'stream']]]
      function cudaMemcpyAsync(dst,src,count,kind_arg,stream) result( res ) bind(C, name="cudaMemcpyAsync")
        use, intrinsic :: ISO_C_BINDING
        import cudaSuccess
        import cudaMemcpyHostToHost
        import cudaStream_t
        implicit none
        type(c_ptr), value :: dst
        type(c_ptr), value :: src
        integer(c_int), value :: count
        integer (KIND(cudaMemcpyHostToHost)), value :: kind_arg
        type (cudaStream_t), value :: stream
        integer (KIND(cudaSuccess)) :: res
      end function cudaMemcpyAsync
    end interface

    interface ! [['cudaError_t', None], 'cudaMemcpyToArrayAsync', [['struct', 'cudaArray', '*', 'dst'], ['size_t', None, 'wOffset'], ['size_t', None, 'hOffset'], ['const', 'void', '*', 'src'], ['size_t', None, 'count'], ['enum', 'cudaMemcpyKind', None, 'kind'], ['cudaStream_t', None, 'stream']]]
      function cudaMemcpyToArrayAsync(dst,wOffset,hOffset,src,count,kind_arg,stream) result( res ) bind(C, name="cudaMemcpyToArrayAsync")
        use, intrinsic :: ISO_C_BINDING
        import cudaSuccess
        import cudaMemcpyHostToHost
        import cudaStream_t
        implicit none
        type (c_ptr), value :: dst
        integer(c_int), value :: wOffset
        integer(c_int), value :: hOffset
        type(c_ptr), value :: src
        integer(c_int), value :: count
        integer (KIND(cudaMemcpyHostToHost)), value :: kind_arg
        type (cudaStream_t), value :: stream
        integer (KIND(cudaSuccess)) :: res
      end function cudaMemcpyToArrayAsync
    end interface

    interface ! [['cudaError_t', None], 'cudaMemcpy2DAsync', [['void', '*', 'dst'], ['size_t', None, 'dpitch'], ['const', 'void', '*', 'src'], ['size_t', None, 'spitch'], ['size_t', None, 'width'], ['size_t', None, 'height'], ['enum', 'cudaMemcpyKind', None, 'kind'], ['cudaStream_t', None, 'stream']]]
      function cudaMemcpy2DAsync(dst,dpitch,src,spitch,width,height,kind_arg,stream) result( res ) bind(C, name="cudaMemcpy2DAsync")
        use, intrinsic :: ISO_C_BINDING
        import cudaSuccess
        import cudaMemcpyHostToHost
        import cudaStream_t
        implicit none
        type(c_ptr), value :: dst
        integer(c_int), value :: dpitch
        type(c_ptr), value :: src
        integer(c_int), value :: spitch
        integer(c_int), value :: width
        integer(c_int), value :: height
        integer (KIND(cudaMemcpyHostToHost)), value :: kind_arg
        type (cudaStream_t), value :: stream
        integer (KIND(cudaSuccess)) :: res
      end function cudaMemcpy2DAsync
    end interface

    interface ! [['cudaError_t', None], 'cudaMemcpy2DToArrayAsync', [['struct', 'cudaArray', '*', 'dst'], ['size_t', None, 'wOffset'], ['size_t', None, 'hOffset'], ['const', 'void', '*', 'src'], ['size_t', None, 'spitch'], ['size_t', None, 'width'], ['size_t', None, 'height'], ['enum', 'cudaMemcpyKind', None, 'kind'], ['cudaStream_t', None, 'stream']]]
      function cudaMemcpy2DToArrayAsync(dst,wOffset,hOffset,src,spitch,width,height,kind_arg,stream) result( res ) bind(C, name="cudaMemcpy2DToArrayAsync")
        use, intrinsic :: ISO_C_BINDING
        import cudaSuccess
        import cudaMemcpyHostToHost
        import cudaStream_t
        implicit none
        type (c_ptr), value :: dst
        integer(c_int), value :: wOffset
        integer(c_int), value :: hOffset
        type(c_ptr), value :: src
        integer(c_int), value :: spitch
        integer(c_int), value :: width
        integer(c_int), value :: height
        integer (KIND(cudaMemcpyHostToHost)), value :: kind_arg
        type (cudaStream_t), value :: stream
        integer (KIND(cudaSuccess)) :: res
      end function cudaMemcpy2DToArrayAsync
    end interface

    interface ! [['cudaError_t', None], 'cudaMemcpyToSymbolAsync', [['const', 'char', '*', 'symbol'], ['const', 'void', '*', 'src'], ['size_t', None, 'count'], ['size_t', None, 'offset'], ['enum', 'cudaMemcpyKind', None, 'kind'], ['cudaStream_t', None, 'stream']]]
      function cudaMemcpyToSymbolAsync(symbol,src,count,offset,kind_arg,stream) result( res ) bind(C, name="cudaMemcpyToSymbolAsync")
        use, intrinsic :: ISO_C_BINDING
        import cudaSuccess
        import cudaMemcpyHostToHost
        import cudaStream_t
        implicit none
        character(c_char) :: symbol
        type(c_ptr), value :: src
        integer(c_int), value :: count
        integer(c_int), value :: offset
        integer (KIND(cudaMemcpyHostToHost)), value :: kind_arg
        type (cudaStream_t), value :: stream
        integer (KIND(cudaSuccess)) :: res
      end function cudaMemcpyToSymbolAsync
    end interface

    interface ! [['cudaError_t', None], 'cudaMemcpyFromSymbolAsync', [['void', '*', 'dst'], ['const', 'char', '*', 'symbol'], ['size_t', None, 'count'], ['size_t', None, 'offset'], ['enum', 'cudaMemcpyKind', None, 'kind'], ['cudaStream_t', None, 'stream']]]
      function cudaMemcpyFromSymbolAsync(dst,symbol,count,offset,kind_arg,stream) result( res ) bind(C, name="cudaMemcpyFromSymbolAsync")
        use, intrinsic :: ISO_C_BINDING
        import cudaSuccess
        import cudaMemcpyHostToHost
        import cudaStream_t
        implicit none
        type(c_ptr), value :: dst
        character(c_char) :: symbol
        integer(c_int), value :: count
        integer(c_int), value :: offset
        integer (KIND(cudaMemcpyHostToHost)), value :: kind_arg
        type (cudaStream_t), value :: stream
        integer (KIND(cudaSuccess)) :: res
      end function cudaMemcpyFromSymbolAsync
    end interface

    interface ! [['cudaError_t', None], 'cudaMemset', [['void', '*', 'devPtr'], ['int', None, 'value'], ['size_t', None, 'count']]]
      function cudaMemset(devPtr,value,count) result( res ) bind(C, name="cudaMemset")
        use, intrinsic :: ISO_C_BINDING
        import cudaSuccess
        implicit none
        type(c_ptr), value :: devPtr
        integer(c_int), value :: value
        integer(c_int), value :: count
        integer (KIND(cudaSuccess)) :: res
      end function cudaMemset
    end interface

    interface ! [['cudaError_t', None], 'cudaMemset2D', [['void', '*', 'devPtr'], ['size_t', None, 'pitch'], ['int', None, 'value'], ['size_t', None, 'width'], ['size_t', None, 'height']]]
      function cudaMemset2D(devPtr,pitch,value,width,height) result( res ) bind(C, name="cudaMemset2D")
        use, intrinsic :: ISO_C_BINDING
        import cudaSuccess
        implicit none
        type(c_ptr), value :: devPtr
        integer(c_int), value :: pitch
        integer(c_int), value :: value
        integer(c_int), value :: width
        integer(c_int), value :: height
        integer (KIND(cudaSuccess)) :: res
      end function cudaMemset2D
    end interface

    interface ! [['cudaError_t', None], 'cudaGetSymbolAddress', [['void', '**', 'devPtr'], ['const', 'char', '*', 'symbol']]]
      function cudaGetSymbolAddress(devPtr,symbol) result( res ) bind(C, name="cudaGetSymbolAddress")
        use, intrinsic :: ISO_C_BINDING
        import cudaSuccess
        implicit none
        type(c_ptr) :: devPtr
        character(c_char) :: symbol
        integer (KIND(cudaSuccess)) :: res
      end function cudaGetSymbolAddress
    end interface

    interface ! [['cudaError_t', None], 'cudaGetSymbolSize', [['size_t', '*', 'size'], ['const', 'char', '*', 'symbol']]]
      function cudaGetSymbolSize(size,symbol) result( res ) bind(C, name="cudaGetSymbolSize")
        use, intrinsic :: ISO_C_BINDING
        import cudaSuccess
        implicit none
        integer(c_int) :: size
        character(c_char) :: symbol
        integer (KIND(cudaSuccess)) :: res
      end function cudaGetSymbolSize
    end interface

    interface ! [['cudaError_t', None], 'cudaGetDeviceCount', [['int', '*', 'count']]]
      function cudaGetDeviceCount(count) result( res ) bind(C, name="cudaGetDeviceCount")
        use, intrinsic :: ISO_C_BINDING
        import cudaSuccess
        implicit none
        integer(c_int) :: count
        integer (KIND(cudaSuccess)) :: res
      end function cudaGetDeviceCount
    end interface

    interface ! [['cudaError_t', None], 'cudaGetDeviceProperties', [['struct', 'cudaDeviceProp', '*', 'prop'], ['int', None, 'device']]]
      function cudaGetDeviceProperties(prop,device) result( res ) bind(C, name="cudaGetDeviceProperties")
        use, intrinsic :: ISO_C_BINDING
        import cudaSuccess
        import cudaDeviceProp
        implicit none
        type (cudaDeviceProp) :: prop
        integer(c_int), value :: device
        integer (KIND(cudaSuccess)) :: res
      end function cudaGetDeviceProperties
    end interface

    interface ! [['cudaError_t', None], 'cudaSetDevice', [['int', None, 'device']]]
      function cudaSetDevice(device) result( res ) bind(C, name="cudaSetDevice")
        use, intrinsic :: ISO_C_BINDING
        import cudaSuccess
        implicit none
        integer(c_int), value :: device
        integer (KIND(cudaSuccess)) :: res
      end function cudaSetDevice
    end interface

    interface ! [['cudaError_t', None], 'cudaGetDevice', [['int', '*', 'device']]]
      function cudaGetDevice(device) result( res ) bind(C, name="cudaGetDevice")
        use, intrinsic :: ISO_C_BINDING
        import cudaSuccess
        implicit none
        integer(c_int) :: device
        integer (KIND(cudaSuccess)) :: res
      end function cudaGetDevice
    end interface

    interface ! [['cudaError_t', None], 'cudaSetValidDevices', [['int', '*', 'device_arr'], ['int', None, 'len']]]
      function cudaSetValidDevices(device_arr,len) result( res ) bind(C, name="cudaSetValidDevices")
        use, intrinsic :: ISO_C_BINDING
        import cudaSuccess
        implicit none
        integer(c_int) :: device_arr
        integer(c_int), value :: len
        integer (KIND(cudaSuccess)) :: res
      end function cudaSetValidDevices
    end interface

    interface ! [['cudaError_t', None], 'cudaSetDeviceFlags', [['int', None, 'flags']]]
      function cudaSetDeviceFlags(flags) result( res ) bind(C, name="cudaSetDeviceFlags")
        use, intrinsic :: ISO_C_BINDING
        import cudaSuccess
        implicit none
        integer(c_int), value :: flags
        integer (KIND(cudaSuccess)) :: res
      end function cudaSetDeviceFlags
    end interface

    interface ! [['struct', 'cudaChannelFormatDesc', None], 'cudaCreateChannelDesc', [['int', None, 'x'], ['int', None, 'y'], ['int', None, 'z'], ['int', None, 'w'], ['enum', 'cudaChannelFormatKind', None, 'f']]]
      function cudaCreateChannelDesc(x,y,z,w,f) result( res ) bind(C, name="cudaCreateChannelDesc")
        use, intrinsic :: ISO_C_BINDING
        import cudaChannelFormatDesc
        import cudaChannelFormatKindSigned
        implicit none
        integer(c_int), value :: x
        integer(c_int), value :: y
        integer(c_int), value :: z
        integer(c_int), value :: w
        integer (KIND(cudaChannelFormatKindSigned)), value :: f
        type (cudaChannelFormatDesc) :: res
      end function cudaCreateChannelDesc
    end interface

    interface ! [['cudaError_t', None], 'cudaGetLastError', ['void']]
      function cudaGetLastError() result( res ) bind(C, name="cudaGetLastError")
        use, intrinsic :: ISO_C_BINDING
        import cudaSuccess
        implicit none
        integer (KIND(cudaSuccess)) :: res
      end function cudaGetLastError
    end interface

    interface ! [['cudaError_t', None], 'cudaPeekAtLastError', ['void']]
      function cudaPeekAtLastError() result( res ) bind(C, name="cudaPeekAtLastError")
        use, intrinsic :: ISO_C_BINDING
        import cudaSuccess
        implicit none
        integer (KIND(cudaSuccess)) :: res
      end function cudaPeekAtLastError
    end interface

    interface ! [['const', 'char', '*'], 'cudaGetErrorString', [['cudaError_t', None, 'error']]]
      function cudaGetErrorString(error) result( res ) bind(C, name="cudaGetErrorString")
        use, intrinsic :: ISO_C_BINDING
        import cudaSuccess
        implicit none
        integer (KIND(cudaSuccess)), value :: error
        type(c_ptr) :: res
      end function cudaGetErrorString
    end interface

    interface ! [['cudaError_t', None], 'cudaConfigureCall', [['dim3', None, 'gridDim'], ['dim3', None, 'blockDim'], ['size_t', None, 'sharedMem'], ['cudaStream_t', None, 'stream']]]
      function cudaConfigureCall(gridDim,blockDim,sharedMem,stream) result( res ) bind(C, name="cudaConfigureCall")
        use, intrinsic :: ISO_C_BINDING
        import cudaSuccess
        import dim3
        import dim3
        import cudaStream_t
        implicit none
        type (dim3), value :: gridDim
        type (dim3), value :: blockDim
        integer(c_int), value :: sharedMem
        type (cudaStream_t), value :: stream
        integer (KIND(cudaSuccess)) :: res
      end function cudaConfigureCall
    end interface

    interface ! [['cudaError_t', None], 'cudaSetupArgument', [['const', 'void', '*', 'arg'], ['size_t', None, 'size'], ['size_t', None, 'offset']]]
      function cudaSetupArgument(arg,size,offset) result( res ) bind(C, name="cudaSetupArgument")
        use, intrinsic :: ISO_C_BINDING
        import cudaSuccess
        implicit none
        type(c_ptr), value :: arg
        integer(c_int), value :: size
        integer(c_int), value :: offset
        integer (KIND(cudaSuccess)) :: res
      end function cudaSetupArgument
    end interface

    interface ! [['cudaError_t', None], 'cudaFuncSetCacheConfig', [['const', 'char', '*', 'func'], ['enum', 'cudaFuncCache', None, 'cacheConfig']]]
      function cudaFuncSetCacheConfig(func,cacheConfig) result( res ) bind(C, name="cudaFuncSetCacheConfig")
        use, intrinsic :: ISO_C_BINDING
        import cudaSuccess
        import cudaFuncCachePreferNone
        implicit none
        character(c_char) :: func
        integer (KIND(cudaFuncCachePreferNone)), value :: cacheConfig
        integer (KIND(cudaSuccess)) :: res
      end function cudaFuncSetCacheConfig
    end interface

    interface ! [['cudaError_t', None], 'cudaLaunch', [['const', 'char', '*', 'entry']]]
      function cudaLaunch(entry) result( res ) bind(C, name="cudaLaunch")
        use, intrinsic :: ISO_C_BINDING
        import cudaSuccess
        implicit none
        character(c_char) :: entry
        integer (KIND(cudaSuccess)) :: res
      end function cudaLaunch
    end interface

    interface ! [['cudaError_t', None], 'cudaFuncGetAttributes', [['struct', 'cudaFuncAttributes', '*', 'attr'], ['const', 'char', '*', 'func']]]
      function cudaFuncGetAttributes(attr,func) result( res ) bind(C, name="cudaFuncGetAttributes")
        use, intrinsic :: ISO_C_BINDING
        import cudaSuccess
        import cudaFuncAttributes
        implicit none
        type (cudaFuncAttributes) :: attr
        character(c_char) :: func
        integer (KIND(cudaSuccess)) :: res
      end function cudaFuncGetAttributes
    end interface

    interface ! [['cudaError_t', None], 'cudaStreamCreate', [['cudaStream_t', '*', 'pStream']]]
      function cudaStreamCreate(pStream) result( res ) bind(C, name="cudaStreamCreate")
        use, intrinsic :: ISO_C_BINDING
        import cudaSuccess
        import cudaStream_t
        implicit none
        type (cudaStream_t) :: pStream
        integer (KIND(cudaSuccess)) :: res
      end function cudaStreamCreate
    end interface

    interface ! [['cudaError_t', None], 'cudaStreamDestroy', [['cudaStream_t', None, 'stream']]]
      function cudaStreamDestroy(stream) result( res ) bind(C, name="cudaStreamDestroy")
        use, intrinsic :: ISO_C_BINDING
        import cudaSuccess
        import cudaStream_t
        implicit none
        type (cudaStream_t), value :: stream
        integer (KIND(cudaSuccess)) :: res
      end function cudaStreamDestroy
    end interface

    interface ! [['cudaError_t', None], 'cudaStreamSynchronize', [['cudaStream_t', None, 'stream']]]
      function cudaStreamSynchronize(stream) result( res ) bind(C, name="cudaStreamSynchronize")
        use, intrinsic :: ISO_C_BINDING
        import cudaSuccess
        import cudaStream_t
        implicit none
        type (cudaStream_t), value :: stream
        integer (KIND(cudaSuccess)) :: res
      end function cudaStreamSynchronize
    end interface

    interface ! [['cudaError_t', None], 'cudaStreamQuery', [['cudaStream_t', None, 'stream']]]
      function cudaStreamQuery(stream) result( res ) bind(C, name="cudaStreamQuery")
        use, intrinsic :: ISO_C_BINDING
        import cudaSuccess
        import cudaStream_t
        implicit none
        type (cudaStream_t), value :: stream
        integer (KIND(cudaSuccess)) :: res
      end function cudaStreamQuery
    end interface

    interface ! [['cudaError_t', None], 'cudaEventCreate', [['cudaEvent_t', '*', 'event']]]
      function cudaEventCreate(event) result( res ) bind(C, name="cudaEventCreate")
        use, intrinsic :: ISO_C_BINDING
        import cudaSuccess
        import cudaEvent_t
        implicit none
        type (cudaEvent_t) :: event
        integer (KIND(cudaSuccess)) :: res
      end function cudaEventCreate
    end interface

    interface ! [['cudaError_t', None], 'cudaEventCreateWithFlags', [['cudaEvent_t', '*', 'event'], ['int', None, 'flags']]]
      function cudaEventCreateWithFlags(event,flags) result( res ) bind(C, name="cudaEventCreateWithFlags")
        use, intrinsic :: ISO_C_BINDING
        import cudaSuccess
        import cudaEvent_t
        implicit none
        type (cudaEvent_t) :: event
        integer(c_int), value :: flags
        integer (KIND(cudaSuccess)) :: res
      end function cudaEventCreateWithFlags
    end interface

    interface ! [['cudaError_t', None], 'cudaEventRecord', [['cudaEvent_t', None, 'event'], ['cudaStream_t', None, 'stream']]]
      function cudaEventRecord(event,stream) result( res ) bind(C, name="cudaEventRecord")
        use, intrinsic :: ISO_C_BINDING
        import cudaSuccess
        import cudaEvent_t
        import cudaStream_t
        implicit none
        type (cudaEvent_t), value :: event
        type (cudaStream_t), value :: stream
        integer (KIND(cudaSuccess)) :: res
      end function cudaEventRecord
    end interface

    interface ! [['cudaError_t', None], 'cudaEventQuery', [['cudaEvent_t', None, 'event']]]
      function cudaEventQuery(event) result( res ) bind(C, name="cudaEventQuery")
        use, intrinsic :: ISO_C_BINDING
        import cudaSuccess
        import cudaEvent_t
        implicit none
        type (cudaEvent_t), value :: event
        integer (KIND(cudaSuccess)) :: res
      end function cudaEventQuery
    end interface

    interface ! [['cudaError_t', None], 'cudaEventSynchronize', [['cudaEvent_t', None, 'event']]]
      function cudaEventSynchronize(event) result( res ) bind(C, name="cudaEventSynchronize")
        use, intrinsic :: ISO_C_BINDING
        import cudaSuccess
        import cudaEvent_t
        implicit none
        type (cudaEvent_t), value :: event
        integer (KIND(cudaSuccess)) :: res
      end function cudaEventSynchronize
    end interface

    interface ! [['cudaError_t', None], 'cudaEventDestroy', [['cudaEvent_t', None, 'event']]]
      function cudaEventDestroy(event) result( res ) bind(C, name="cudaEventDestroy")
        use, intrinsic :: ISO_C_BINDING
        import cudaSuccess
        import cudaEvent_t
        implicit none
        type (cudaEvent_t), value :: event
        integer (KIND(cudaSuccess)) :: res
      end function cudaEventDestroy
    end interface

    interface ! [['cudaError_t', None], 'cudaEventElapsedTime', [['float', '*', 'ms'], ['cudaEvent_t', None, 'start'], ['cudaEvent_t', None, 'end']]]
      function cudaEventElapsedTime(ms,start,end) result( res ) bind(C, name="cudaEventElapsedTime")
        use, intrinsic :: ISO_C_BINDING
        import cudaSuccess
        import cudaEvent_t
        import cudaEvent_t
        implicit none
        real(c_float) :: ms
        type (cudaEvent_t), value :: start
        type (cudaEvent_t), value :: end
        integer (KIND(cudaSuccess)) :: res
      end function cudaEventElapsedTime
    end interface

    interface ! [['cudaError_t', None], 'cudaSetDoubleForDevice', [['double', '*', 'd']]]
      function cudaSetDoubleForDevice(d) result( res ) bind(C, name="cudaSetDoubleForDevice")
        use, intrinsic :: ISO_C_BINDING
        import cudaSuccess
        implicit none
        real(c_double) :: d
        integer (KIND(cudaSuccess)) :: res
      end function cudaSetDoubleForDevice
    end interface

    interface ! [['cudaError_t', None], 'cudaSetDoubleForHost', [['double', '*', 'd']]]
      function cudaSetDoubleForHost(d) result( res ) bind(C, name="cudaSetDoubleForHost")
        use, intrinsic :: ISO_C_BINDING
        import cudaSuccess
        implicit none
        real(c_double) :: d
        integer (KIND(cudaSuccess)) :: res
      end function cudaSetDoubleForHost
    end interface

    interface ! [['cudaError_t', None], 'cudaThreadExit', ['void']]
      function cudaThreadExit() result( res ) bind(C, name="cudaThreadExit")
        use, intrinsic :: ISO_C_BINDING
        import cudaSuccess
        implicit none
        integer (KIND(cudaSuccess)) :: res
      end function cudaThreadExit
    end interface

    interface ! [['cudaError_t', None], 'cudaThreadSynchronize', ['void']]
      function cudaThreadSynchronize() result( res ) bind(C, name="cudaThreadSynchronize")
        use, intrinsic :: ISO_C_BINDING
        import cudaSuccess
        implicit none
        integer (KIND(cudaSuccess)) :: res
      end function cudaThreadSynchronize
    end interface

    interface ! [['cudaError_t', None], 'cudaThreadSetLimit', [['enum', 'cudaLimit', None, 'limit'], ['size_t', None, 'value']]]
      function cudaThreadSetLimit(limit,value) result( res ) bind(C, name="cudaThreadSetLimit")
        use, intrinsic :: ISO_C_BINDING
        import cudaSuccess
        import cudaLimitStackSize
        implicit none
        integer (KIND(cudaLimitStackSize)), value :: limit
        integer(c_int), value :: value
        integer (KIND(cudaSuccess)) :: res
      end function cudaThreadSetLimit
    end interface

    interface ! [['cudaError_t', None], 'cudaThreadGetLimit', [['size_t', '*', 'pValue'], ['enum', 'cudaLimit', None, 'limit']]]
      function cudaThreadGetLimit(pValue,limit) result( res ) bind(C, name="cudaThreadGetLimit")
        use, intrinsic :: ISO_C_BINDING
        import cudaSuccess
        import cudaLimitStackSize
        implicit none
        integer(c_int) :: pValue
        integer (KIND(cudaLimitStackSize)), value :: limit
        integer (KIND(cudaSuccess)) :: res
      end function cudaThreadGetLimit
    end interface

    interface ! [['cudaError_t', None], 'cudaDriverGetVersion', [['int', '*', 'driverVersion']]]
      function cudaDriverGetVersion(driverVersion) result( res ) bind(C, name="cudaDriverGetVersion")
        use, intrinsic :: ISO_C_BINDING
        import cudaSuccess
        implicit none
        integer(c_int) :: driverVersion
        integer (KIND(cudaSuccess)) :: res
      end function cudaDriverGetVersion
    end interface

    interface ! [['cudaError_t', None], 'cudaRuntimeGetVersion', [['int', '*', 'runtimeVersion']]]
      function cudaRuntimeGetVersion(runtimeVersion) result( res ) bind(C, name="cudaRuntimeGetVersion")
        use, intrinsic :: ISO_C_BINDING
        import cudaSuccess
        implicit none
        integer(c_int) :: runtimeVersion
        integer (KIND(cudaSuccess)) :: res
      end function cudaRuntimeGetVersion
    end interface

    interface ! [['cudaError_t', None], 'cudaGraphicsUnregisterResource', [['struct', 'cudaGraphicsResource', '*', 'resource']]]
      function cudaGraphicsUnregisterResource(resource) result( res ) bind(C, name="cudaGraphicsUnregisterResource")
        use, intrinsic :: ISO_C_BINDING
        import cudaSuccess
        implicit none
        type (c_ptr), value :: resource
        integer (KIND(cudaSuccess)) :: res
      end function cudaGraphicsUnregisterResource
    end interface

    interface ! [['cudaError_t', None], 'cudaGraphicsResourceSetMapFlags', [['struct', 'cudaGraphicsResource', '*', 'resource'], ['unsigned', 'int', None, 'flags']]]
      function cudaGraphicsResourceSetMapFlags(resource,flags) result( res ) bind(C, name="cudaGraphicsResourceSetMapFlags")
        use, intrinsic :: ISO_C_BINDING
        import cudaSuccess
        implicit none
        type (c_ptr), value :: resource
        integer(c_int), value :: flags
        integer (KIND(cudaSuccess)) :: res
      end function cudaGraphicsResourceSetMapFlags
    end interface

    interface ! [['cudaError_t', None], 'cudaGraphicsMapResources', [['int', None, 'count'], ['struct', 'cudaGraphicsResource', '**', 'resources'], ['cudaStream_t', None, 'stream']]]
      function cudaGraphicsMapResources(count,resources,stream) result( res ) bind(C, name="cudaGraphicsMapResources")
        use, intrinsic :: ISO_C_BINDING
        import cudaSuccess
        import cudaStream_t
        implicit none
        integer(c_int), value :: count
        type (c_ptr) :: resources
        type (cudaStream_t), value :: stream
        integer (KIND(cudaSuccess)) :: res
      end function cudaGraphicsMapResources
    end interface

    interface ! [['cudaError_t', None], 'cudaGraphicsUnmapResources', [['int', None, 'count'], ['struct', 'cudaGraphicsResource', '**', 'resources'], ['cudaStream_t', None, 'stream']]]
      function cudaGraphicsUnmapResources(count,resources,stream) result( res ) bind(C, name="cudaGraphicsUnmapResources")
        use, intrinsic :: ISO_C_BINDING
        import cudaSuccess
        import cudaStream_t
        implicit none
        integer(c_int), value :: count
        type (c_ptr) :: resources
        type (cudaStream_t), value :: stream
        integer (KIND(cudaSuccess)) :: res
      end function cudaGraphicsUnmapResources
    end interface

    interface ! [['cudaError_t', None], 'cudaGraphicsResourceGetMappedPointer', [['void', '**', 'devPtr'], ['size_t', '*', 'size'], ['struct', 'cudaGraphicsResource', '*', 'resource']]]
      function cudaGraphicsResourceGetMappedPointer(devPtr,size,resource) result( res ) bind(C, name="cudaGraphicsResourceGetMappedPointer")
        use, intrinsic :: ISO_C_BINDING
        import cudaSuccess
        implicit none
        type(c_ptr) :: devPtr
        integer(c_int) :: size
        type (c_ptr), value :: resource
        integer (KIND(cudaSuccess)) :: res
      end function cudaGraphicsResourceGetMappedPointer
    end interface

    interface ! [['cudaError_t', None], 'cudaGraphicsSubResourceGetMappedArray', [['struct', 'cudaArray', '**', 'arrayPtr'], ['struct', 'cudaGraphicsResource', '*', 'resource'], ['unsigned', 'int', None, 'arrayIndex'], ['unsigned', 'int', None, 'mipLevel']]]
      function cudaGraphicsSubResourceGetMappedArray(arrayPtr,resource,arrayIndex,mipLevel) result( res ) bind(C, name="cudaGraphicsSubResourceGetMappedArray")
        use, intrinsic :: ISO_C_BINDING
        import cudaSuccess
        implicit none
        type (c_ptr) :: arrayPtr
        type (c_ptr), value :: resource
        integer(c_int), value :: arrayIndex
        integer(c_int), value :: mipLevel
        integer (KIND(cudaSuccess)) :: res
      end function cudaGraphicsSubResourceGetMappedArray
    end interface

  end module cuda_runtime_h

!
!        Copyright (C) 2000-2019 the YAMBO team
!              http://www.yambo-code.org
!
! Authors (see AUTHORS file for details): CA, AF
!
! This file is distributed under the terms of the GNU 
! General Public License. You can redistribute it and/or 
! modify it under the terms of the GNU General Public 
! License as published by the Free Software Foundation; 
! either version 2, or (at your option) any later version.
!
! This program is distributed in the hope that it will 
! be useful, but WITHOUT ANY WARRANTY; without even the 
! implied warranty of MERCHANTABILITY or FITNESS FOR A 
! PARTICULAR PURPOSE.  See the GNU General Public License 
! for more details.
!
! You should have received a copy of the GNU General Public 
! License along with this program; if not, write to the Free 
! Software Foundation, Inc., 59 Temple Place - Suite 330,Boston, 
! MA 02111-1307, USA or visit http://www.gnu.org/copyleft/gpl.txt.
!
!
! Utility functions to perform memcpy and memset on the device with CUDA Fortran
! cuf_memXXX contains a CUF KERNEL to perform the selected operation
! cu_memsync are wrappers for cuda_memcpy functions
!
#if defined(_CUDA)
#  define __CUDA
#endif

module device_linalg_loc
#ifdef __CUDA
    use cublas
#endif
    implicit none
    integer, parameter :: DP = selected_real_kind(14,200)
    integer, parameter :: SP = selected_real_kind(6, 37)
end module
!
SUBROUTINE dp_dev_memcpy_r1d(array_out, array_in, &
                                            range1 )
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(14,200)
    REAL(PRCSN), INTENT(INOUT) :: array_out(:)
    REAL(PRCSN), INTENT(IN) :: array_in(:)
    INTEGER, OPTIONAL, INTENT(IN) ::  range1(2)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_out, array_in
#endif
    !
    INTEGER :: i1, d1s, d1e
    !
    IF (PRESENT(range1)) THEN
        d1s = 1
        d1e = range1(2) - range1(1) + 1
    ELSE
        d1s = 1
        d1e = SIZE(array_out, 1)
    END IF
    !
    !
    !$cuf kernel do(1)
    DO i1 = d1s, d1e
        array_out(i1 ) = array_in(i1 )
    ENDDO
    !
END SUBROUTINE dp_dev_memcpy_r1d
!
SUBROUTINE dp_dev_memcpy_r2d(array_out, array_in, &
                                            range1, &
                                            range2 )
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(14,200)
    REAL(PRCSN), INTENT(INOUT) :: array_out(:,:)
    REAL(PRCSN), INTENT(IN) :: array_in(:,:)
    INTEGER, OPTIONAL, INTENT(IN) ::  range1(2), range2(2)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_out, array_in
#endif
    !
    INTEGER :: i1, d1s, d1e
    INTEGER :: i2, d2s, d2e
    !
    IF (PRESENT(range1)) THEN
        d1s = 1
        d1e = range1(2) - range1(1) + 1
    ELSE
        d1s = 1
        d1e = SIZE(array_out, 1)
    END IF
    !
    IF (PRESENT(range2)) THEN
        d2s = 1
        d2e = range2(2) - range2(1) + 1
    ELSE
        d2s = 1
        d2e = SIZE(array_out, 2)
    END IF
    !
    !
    !$cuf kernel do(2)
    DO i2 = d2s, d2e
    DO i1 = d1s, d1e
        array_out(i1,i2 ) = array_in(i1,i2 )
    ENDDO
    ENDDO
    !
END SUBROUTINE dp_dev_memcpy_r2d
!
SUBROUTINE dp_dev_memcpy_r3d(array_out, array_in, &
                                            range1, &
                                            range2, &
                                            range3 )
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(14,200)
    REAL(PRCSN), INTENT(INOUT) :: array_out(:,:,:)
    REAL(PRCSN), INTENT(IN) :: array_in(:,:,:)
    INTEGER, OPTIONAL, INTENT(IN) ::  range1(2), range2(2), range3(2)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_out, array_in
#endif
    !
    INTEGER :: i1, d1s, d1e
    INTEGER :: i2, d2s, d2e
    INTEGER :: i3, d3s, d3e
    !
    IF (PRESENT(range1)) THEN
        d1s = 1
        d1e = range1(2) - range1(1) + 1
    ELSE
        d1s = 1
        d1e = SIZE(array_out, 1)
    END IF
    !
    IF (PRESENT(range2)) THEN
        d2s = 1
        d2e = range2(2) - range2(1) + 1
    ELSE
        d2s = 1
        d2e = SIZE(array_out, 2)
    END IF
    !
    IF (PRESENT(range3)) THEN
        d3s = 1
        d3e = range3(2) - range3(1) + 1
    ELSE
        d3s = 1
        d3e = SIZE(array_out, 3)
    END IF
    !
    !
    !$cuf kernel do(3)
    DO i3 = d3s, d3e
    DO i2 = d2s, d2e
    DO i1 = d1s, d1e
        array_out(i1,i2,i3 ) = array_in(i1,i2,i3 )
    ENDDO
    ENDDO
    ENDDO
    !
END SUBROUTINE dp_dev_memcpy_r3d
!
SUBROUTINE dp_dev_memcpy_r4d(array_out, array_in, &
                                            range1, &
                                            range2, &
                                            range3, &
                                            range4 )
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(14,200)
    REAL(PRCSN), INTENT(INOUT) :: array_out(:,:,:,:)
    REAL(PRCSN), INTENT(IN) :: array_in(:,:,:,:)
    INTEGER, OPTIONAL, INTENT(IN) ::  range1(2), range2(2), range3(2), range4(2)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_out, array_in
#endif
    !
    INTEGER :: i1, d1s, d1e
    INTEGER :: i2, d2s, d2e
    INTEGER :: i3, d3s, d3e
    INTEGER :: i4, d4s, d4e
    !
    IF (PRESENT(range1)) THEN
        d1s = 1
        d1e = range1(2) - range1(1) + 1
    ELSE
        d1s = 1
        d1e = SIZE(array_out, 1)
    END IF
    !
    IF (PRESENT(range2)) THEN
        d2s = 1
        d2e = range2(2) - range2(1) + 1
    ELSE
        d2s = 1
        d2e = SIZE(array_out, 2)
    END IF
    !
    IF (PRESENT(range3)) THEN
        d3s = 1
        d3e = range3(2) - range3(1) + 1
    ELSE
        d3s = 1
        d3e = SIZE(array_out, 3)
    END IF
    !
    IF (PRESENT(range4)) THEN
        d4s = 1
        d4e = range4(2) - range4(1) + 1
    ELSE
        d4s = 1
        d4e = SIZE(array_out, 4)
    END IF
    !
    !
    !$cuf kernel do(4)
    DO i4 = d4s, d4e
    DO i3 = d3s, d3e
    DO i2 = d2s, d2e
    DO i1 = d1s, d1e
        array_out(i1,i2,i3,i4 ) = array_in(i1,i2,i3,i4 )
    ENDDO
    ENDDO
    ENDDO
    ENDDO
    !
END SUBROUTINE dp_dev_memcpy_r4d
!
SUBROUTINE dp_dev_memcpy_c1d(array_out, array_in, &
                                            range1 )
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(14,200)
    COMPLEX(PRCSN), INTENT(INOUT) :: array_out(:)
    COMPLEX(PRCSN), INTENT(IN) :: array_in(:)
    INTEGER, OPTIONAL, INTENT(IN) ::  range1(2)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_out, array_in
#endif
    !
    INTEGER :: i1, d1s, d1e
    !
    IF (PRESENT(range1)) THEN
        d1s = 1
        d1e = range1(2) - range1(1) + 1
    ELSE
        d1s = 1
        d1e = SIZE(array_out, 1)
    END IF
    !
    !
    !$cuf kernel do(1)
    DO i1 = d1s, d1e
        array_out(i1 ) = array_in(i1 )
    ENDDO
    !
END SUBROUTINE dp_dev_memcpy_c1d
!
SUBROUTINE dp_dev_memcpy_c2d(array_out, array_in, &
                                            range1, &
                                            range2 )
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(14,200)
    COMPLEX(PRCSN), INTENT(INOUT) :: array_out(:,:)
    COMPLEX(PRCSN), INTENT(IN) :: array_in(:,:)
    INTEGER, OPTIONAL, INTENT(IN) ::  range1(2), range2(2)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_out, array_in
#endif
    !
    INTEGER :: i1, d1s, d1e
    INTEGER :: i2, d2s, d2e
    !
    IF (PRESENT(range1)) THEN
        d1s = 1
        d1e = range1(2) - range1(1) + 1
    ELSE
        d1s = 1
        d1e = SIZE(array_out, 1)
    END IF
    !
    IF (PRESENT(range2)) THEN
        d2s = 1
        d2e = range2(2) - range2(1) + 1
    ELSE
        d2s = 1
        d2e = SIZE(array_out, 2)
    END IF
    !
    !
    !$cuf kernel do(2)
    DO i2 = d2s, d2e
    DO i1 = d1s, d1e
        array_out(i1,i2 ) = array_in(i1,i2 )
    ENDDO
    ENDDO
    !
END SUBROUTINE dp_dev_memcpy_c2d
!
SUBROUTINE dp_dev_memcpy_c3d(array_out, array_in, &
                                            range1, &
                                            range2, &
                                            range3 )
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(14,200)
    COMPLEX(PRCSN), INTENT(INOUT) :: array_out(:,:,:)
    COMPLEX(PRCSN), INTENT(IN) :: array_in(:,:,:)
    INTEGER, OPTIONAL, INTENT(IN) ::  range1(2), range2(2), range3(2)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_out, array_in
#endif
    !
    INTEGER :: i1, d1s, d1e
    INTEGER :: i2, d2s, d2e
    INTEGER :: i3, d3s, d3e
    !
    IF (PRESENT(range1)) THEN
        d1s = 1
        d1e = range1(2) - range1(1) + 1
    ELSE
        d1s = 1
        d1e = SIZE(array_out, 1)
    END IF
    !
    IF (PRESENT(range2)) THEN
        d2s = 1
        d2e = range2(2) - range2(1) + 1
    ELSE
        d2s = 1
        d2e = SIZE(array_out, 2)
    END IF
    !
    IF (PRESENT(range3)) THEN
        d3s = 1
        d3e = range3(2) - range3(1) + 1
    ELSE
        d3s = 1
        d3e = SIZE(array_out, 3)
    END IF
    !
    !
    !$cuf kernel do(3)
    DO i3 = d3s, d3e
    DO i2 = d2s, d2e
    DO i1 = d1s, d1e
        array_out(i1,i2,i3 ) = array_in(i1,i2,i3 )
    ENDDO
    ENDDO
    ENDDO
    !
END SUBROUTINE dp_dev_memcpy_c3d
!
SUBROUTINE dp_dev_memcpy_c4d(array_out, array_in, &
                                            range1, &
                                            range2, &
                                            range3, &
                                            range4 )
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(14,200)
    COMPLEX(PRCSN), INTENT(INOUT) :: array_out(:,:,:,:)
    COMPLEX(PRCSN), INTENT(IN) :: array_in(:,:,:,:)
    INTEGER, OPTIONAL, INTENT(IN) ::  range1(2), range2(2), range3(2), range4(2)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_out, array_in
#endif
    !
    INTEGER :: i1, d1s, d1e
    INTEGER :: i2, d2s, d2e
    INTEGER :: i3, d3s, d3e
    INTEGER :: i4, d4s, d4e
    !
    IF (PRESENT(range1)) THEN
        d1s = 1
        d1e = range1(2) - range1(1) + 1
    ELSE
        d1s = 1
        d1e = SIZE(array_out, 1)
    END IF
    !
    IF (PRESENT(range2)) THEN
        d2s = 1
        d2e = range2(2) - range2(1) + 1
    ELSE
        d2s = 1
        d2e = SIZE(array_out, 2)
    END IF
    !
    IF (PRESENT(range3)) THEN
        d3s = 1
        d3e = range3(2) - range3(1) + 1
    ELSE
        d3s = 1
        d3e = SIZE(array_out, 3)
    END IF
    !
    IF (PRESENT(range4)) THEN
        d4s = 1
        d4e = range4(2) - range4(1) + 1
    ELSE
        d4s = 1
        d4e = SIZE(array_out, 4)
    END IF
    !
    !
    !$cuf kernel do(4)
    DO i4 = d4s, d4e
    DO i3 = d3s, d3e
    DO i2 = d2s, d2e
    DO i1 = d1s, d1e
        array_out(i1,i2,i3,i4 ) = array_in(i1,i2,i3,i4 )
    ENDDO
    ENDDO
    ENDDO
    ENDDO
    !
END SUBROUTINE dp_dev_memcpy_c4d
!
SUBROUTINE sp_dev_memcpy_r1d(array_out, array_in, &
                                            range1 )
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(6, 37)
    REAL(PRCSN), INTENT(INOUT) :: array_out(:)
    REAL(PRCSN), INTENT(IN) :: array_in(:)
    INTEGER, OPTIONAL, INTENT(IN) ::  range1(2)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_out, array_in
#endif
    !
    INTEGER :: i1, d1s, d1e
    !
    IF (PRESENT(range1)) THEN
        d1s = 1
        d1e = range1(2) - range1(1) + 1
    ELSE
        d1s = 1
        d1e = SIZE(array_out, 1)
    END IF
    !
    !
    !$cuf kernel do(1)
    DO i1 = d1s, d1e
        array_out(i1 ) = array_in(i1 )
    ENDDO
    !
END SUBROUTINE sp_dev_memcpy_r1d
!
SUBROUTINE sp_dev_memcpy_r2d(array_out, array_in, &
                                            range1, &
                                            range2 )
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(6, 37)
    REAL(PRCSN), INTENT(INOUT) :: array_out(:,:)
    REAL(PRCSN), INTENT(IN) :: array_in(:,:)
    INTEGER, OPTIONAL, INTENT(IN) ::  range1(2), range2(2)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_out, array_in
#endif
    !
    INTEGER :: i1, d1s, d1e
    INTEGER :: i2, d2s, d2e
    !
    IF (PRESENT(range1)) THEN
        d1s = 1
        d1e = range1(2) - range1(1) + 1
    ELSE
        d1s = 1
        d1e = SIZE(array_out, 1)
    END IF
    !
    IF (PRESENT(range2)) THEN
        d2s = 1
        d2e = range2(2) - range2(1) + 1
    ELSE
        d2s = 1
        d2e = SIZE(array_out, 2)
    END IF
    !
    !
    !$cuf kernel do(2)
    DO i2 = d2s, d2e
    DO i1 = d1s, d1e
        array_out(i1,i2 ) = array_in(i1,i2 )
    ENDDO
    ENDDO
    !
END SUBROUTINE sp_dev_memcpy_r2d
!
SUBROUTINE sp_dev_memcpy_r3d(array_out, array_in, &
                                            range1, &
                                            range2, &
                                            range3 )
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(6, 37)
    REAL(PRCSN), INTENT(INOUT) :: array_out(:,:,:)
    REAL(PRCSN), INTENT(IN) :: array_in(:,:,:)
    INTEGER, OPTIONAL, INTENT(IN) ::  range1(2), range2(2), range3(2)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_out, array_in
#endif
    !
    INTEGER :: i1, d1s, d1e
    INTEGER :: i2, d2s, d2e
    INTEGER :: i3, d3s, d3e
    !
    IF (PRESENT(range1)) THEN
        d1s = 1
        d1e = range1(2) - range1(1) + 1
    ELSE
        d1s = 1
        d1e = SIZE(array_out, 1)
    END IF
    !
    IF (PRESENT(range2)) THEN
        d2s = 1
        d2e = range2(2) - range2(1) + 1
    ELSE
        d2s = 1
        d2e = SIZE(array_out, 2)
    END IF
    !
    IF (PRESENT(range3)) THEN
        d3s = 1
        d3e = range3(2) - range3(1) + 1
    ELSE
        d3s = 1
        d3e = SIZE(array_out, 3)
    END IF
    !
    !
    !$cuf kernel do(3)
    DO i3 = d3s, d3e
    DO i2 = d2s, d2e
    DO i1 = d1s, d1e
        array_out(i1,i2,i3 ) = array_in(i1,i2,i3 )
    ENDDO
    ENDDO
    ENDDO
    !
END SUBROUTINE sp_dev_memcpy_r3d
!
SUBROUTINE sp_dev_memcpy_r4d(array_out, array_in, &
                                            range1, &
                                            range2, &
                                            range3, &
                                            range4 )
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(6, 37)
    REAL(PRCSN), INTENT(INOUT) :: array_out(:,:,:,:)
    REAL(PRCSN), INTENT(IN) :: array_in(:,:,:,:)
    INTEGER, OPTIONAL, INTENT(IN) ::  range1(2), range2(2), range3(2), range4(2)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_out, array_in
#endif
    !
    INTEGER :: i1, d1s, d1e
    INTEGER :: i2, d2s, d2e
    INTEGER :: i3, d3s, d3e
    INTEGER :: i4, d4s, d4e
    !
    IF (PRESENT(range1)) THEN
        d1s = 1
        d1e = range1(2) - range1(1) + 1
    ELSE
        d1s = 1
        d1e = SIZE(array_out, 1)
    END IF
    !
    IF (PRESENT(range2)) THEN
        d2s = 1
        d2e = range2(2) - range2(1) + 1
    ELSE
        d2s = 1
        d2e = SIZE(array_out, 2)
    END IF
    !
    IF (PRESENT(range3)) THEN
        d3s = 1
        d3e = range3(2) - range3(1) + 1
    ELSE
        d3s = 1
        d3e = SIZE(array_out, 3)
    END IF
    !
    IF (PRESENT(range4)) THEN
        d4s = 1
        d4e = range4(2) - range4(1) + 1
    ELSE
        d4s = 1
        d4e = SIZE(array_out, 4)
    END IF
    !
    !
    !$cuf kernel do(4)
    DO i4 = d4s, d4e
    DO i3 = d3s, d3e
    DO i2 = d2s, d2e
    DO i1 = d1s, d1e
        array_out(i1,i2,i3,i4 ) = array_in(i1,i2,i3,i4 )
    ENDDO
    ENDDO
    ENDDO
    ENDDO
    !
END SUBROUTINE sp_dev_memcpy_r4d
!
SUBROUTINE sp_dev_memcpy_c1d(array_out, array_in, &
                                            range1 )
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(6, 37)
    COMPLEX(PRCSN), INTENT(INOUT) :: array_out(:)
    COMPLEX(PRCSN), INTENT(IN) :: array_in(:)
    INTEGER, OPTIONAL, INTENT(IN) ::  range1(2)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_out, array_in
#endif
    !
    INTEGER :: i1, d1s, d1e
    !
    IF (PRESENT(range1)) THEN
        d1s = 1
        d1e = range1(2) - range1(1) + 1
    ELSE
        d1s = 1
        d1e = SIZE(array_out, 1)
    END IF
    !
    !
    !$cuf kernel do(1)
    DO i1 = d1s, d1e
        array_out(i1 ) = array_in(i1 )
    ENDDO
    !
END SUBROUTINE sp_dev_memcpy_c1d
!
SUBROUTINE sp_dev_memcpy_c2d(array_out, array_in, &
                                            range1, &
                                            range2 )
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(6, 37)
    COMPLEX(PRCSN), INTENT(INOUT) :: array_out(:,:)
    COMPLEX(PRCSN), INTENT(IN) :: array_in(:,:)
    INTEGER, OPTIONAL, INTENT(IN) ::  range1(2), range2(2)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_out, array_in
#endif
    !
    INTEGER :: i1, d1s, d1e
    INTEGER :: i2, d2s, d2e
    !
    IF (PRESENT(range1)) THEN
        d1s = 1
        d1e = range1(2) - range1(1) + 1
    ELSE
        d1s = 1
        d1e = SIZE(array_out, 1)
    END IF
    !
    IF (PRESENT(range2)) THEN
        d2s = 1
        d2e = range2(2) - range2(1) + 1
    ELSE
        d2s = 1
        d2e = SIZE(array_out, 2)
    END IF
    !
    !
    !$cuf kernel do(2)
    DO i2 = d2s, d2e
    DO i1 = d1s, d1e
        array_out(i1,i2 ) = array_in(i1,i2 )
    ENDDO
    ENDDO
    !
END SUBROUTINE sp_dev_memcpy_c2d
!
SUBROUTINE sp_dev_memcpy_c3d(array_out, array_in, &
                                            range1, &
                                            range2, &
                                            range3 )
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(6, 37)
    COMPLEX(PRCSN), INTENT(INOUT) :: array_out(:,:,:)
    COMPLEX(PRCSN), INTENT(IN) :: array_in(:,:,:)
    INTEGER, OPTIONAL, INTENT(IN) ::  range1(2), range2(2), range3(2)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_out, array_in
#endif
    !
    INTEGER :: i1, d1s, d1e
    INTEGER :: i2, d2s, d2e
    INTEGER :: i3, d3s, d3e
    !
    IF (PRESENT(range1)) THEN
        d1s = 1
        d1e = range1(2) - range1(1) + 1
    ELSE
        d1s = 1
        d1e = SIZE(array_out, 1)
    END IF
    !
    IF (PRESENT(range2)) THEN
        d2s = 1
        d2e = range2(2) - range2(1) + 1
    ELSE
        d2s = 1
        d2e = SIZE(array_out, 2)
    END IF
    !
    IF (PRESENT(range3)) THEN
        d3s = 1
        d3e = range3(2) - range3(1) + 1
    ELSE
        d3s = 1
        d3e = SIZE(array_out, 3)
    END IF
    !
    !
    !$cuf kernel do(3)
    DO i3 = d3s, d3e
    DO i2 = d2s, d2e
    DO i1 = d1s, d1e
        array_out(i1,i2,i3 ) = array_in(i1,i2,i3 )
    ENDDO
    ENDDO
    ENDDO
    !
END SUBROUTINE sp_dev_memcpy_c3d
!
SUBROUTINE sp_dev_memcpy_c4d(array_out, array_in, &
                                            range1, &
                                            range2, &
                                            range3, &
                                            range4 )
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(6, 37)
    COMPLEX(PRCSN), INTENT(INOUT) :: array_out(:,:,:,:)
    COMPLEX(PRCSN), INTENT(IN) :: array_in(:,:,:,:)
    INTEGER, OPTIONAL, INTENT(IN) ::  range1(2), range2(2), range3(2), range4(2)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_out, array_in
#endif
    !
    INTEGER :: i1, d1s, d1e
    INTEGER :: i2, d2s, d2e
    INTEGER :: i3, d3s, d3e
    INTEGER :: i4, d4s, d4e
    !
    IF (PRESENT(range1)) THEN
        d1s = 1
        d1e = range1(2) - range1(1) + 1
    ELSE
        d1s = 1
        d1e = SIZE(array_out, 1)
    END IF
    !
    IF (PRESENT(range2)) THEN
        d2s = 1
        d2e = range2(2) - range2(1) + 1
    ELSE
        d2s = 1
        d2e = SIZE(array_out, 2)
    END IF
    !
    IF (PRESENT(range3)) THEN
        d3s = 1
        d3e = range3(2) - range3(1) + 1
    ELSE
        d3s = 1
        d3e = SIZE(array_out, 3)
    END IF
    !
    IF (PRESENT(range4)) THEN
        d4s = 1
        d4e = range4(2) - range4(1) + 1
    ELSE
        d4s = 1
        d4e = SIZE(array_out, 4)
    END IF
    !
    !
    !$cuf kernel do(4)
    DO i4 = d4s, d4e
    DO i3 = d3s, d3e
    DO i2 = d2s, d2e
    DO i1 = d1s, d1e
        array_out(i1,i2,i3,i4 ) = array_in(i1,i2,i3,i4 )
    ENDDO
    ENDDO
    ENDDO
    ENDDO
    !
END SUBROUTINE sp_dev_memcpy_c4d
!
!
SUBROUTINE dp_dev_memset_r1d(array_out, val, range1 )
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(14,200)
    REAL(PRCSN), INTENT(INOUT) :: array_out(:)
    REAL(PRCSN), INTENT(IN) :: val
    INTEGER, OPTIONAL, INTENT(IN) ::  range1(2)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_out
#endif
    !
    INTEGER :: i1, d1s, d1e
    !
    IF (PRESENT(range1)) THEN
        d1s = 1
        d1e = range1(2) - range1(1) + 1
    ELSE
        d1s = 1
        d1e = SIZE(array_out, 1)
    END IF
    !
    !
    !$cuf kernel do(1)
    DO i1 = d1s, d1e
        array_out(i1 ) = val
    ENDDO
    !
END SUBROUTINE dp_dev_memset_r1d
!
SUBROUTINE dp_dev_memset_r2d(array_out, val, range1, range2 )
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(14,200)
    REAL(PRCSN), INTENT(INOUT) :: array_out(:,:)
    REAL(PRCSN), INTENT(IN) :: val
    INTEGER, OPTIONAL, INTENT(IN) ::  range1(2), range2(2)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_out
#endif
    !
    INTEGER :: i1, d1s, d1e
    INTEGER :: i2, d2s, d2e
    !
    IF (PRESENT(range1)) THEN
        d1s = 1
        d1e = range1(2) - range1(1) + 1
    ELSE
        d1s = 1
        d1e = SIZE(array_out, 1)
    END IF
    !
    IF (PRESENT(range2)) THEN
        d2s = 1
        d2e = range2(2) - range2(1) + 1
    ELSE
        d2s = 1
        d2e = SIZE(array_out, 2)
    END IF
    !
    !
    !$cuf kernel do(2)
    DO i2 = d2s, d2e
    DO i1 = d1s, d1e
        array_out(i1,i2 ) = val
    ENDDO
    ENDDO
    !
END SUBROUTINE dp_dev_memset_r2d
!
SUBROUTINE dp_dev_memset_r3d(array_out, val, range1, range2, range3 )
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(14,200)
    REAL(PRCSN), INTENT(INOUT) :: array_out(:,:,:)
    REAL(PRCSN), INTENT(IN) :: val
    INTEGER, OPTIONAL, INTENT(IN) ::  range1(2), range2(2), range3(2)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_out
#endif
    !
    INTEGER :: i1, d1s, d1e
    INTEGER :: i2, d2s, d2e
    INTEGER :: i3, d3s, d3e
    !
    IF (PRESENT(range1)) THEN
        d1s = 1
        d1e = range1(2) - range1(1) + 1
    ELSE
        d1s = 1
        d1e = SIZE(array_out, 1)
    END IF
    !
    IF (PRESENT(range2)) THEN
        d2s = 1
        d2e = range2(2) - range2(1) + 1
    ELSE
        d2s = 1
        d2e = SIZE(array_out, 2)
    END IF
    !
    IF (PRESENT(range3)) THEN
        d3s = 1
        d3e = range3(2) - range3(1) + 1
    ELSE
        d3s = 1
        d3e = SIZE(array_out, 3)
    END IF
    !
    !
    !$cuf kernel do(3)
    DO i3 = d3s, d3e
    DO i2 = d2s, d2e
    DO i1 = d1s, d1e
        array_out(i1,i2,i3 ) = val
    ENDDO
    ENDDO
    ENDDO
    !
END SUBROUTINE dp_dev_memset_r3d
!
SUBROUTINE dp_dev_memset_r4d(array_out, val, range1, range2, range3, range4 )
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(14,200)
    REAL(PRCSN), INTENT(INOUT) :: array_out(:,:,:,:)
    REAL(PRCSN), INTENT(IN) :: val
    INTEGER, OPTIONAL, INTENT(IN) ::  range1(2), range2(2), range3(2), range4(2)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_out
#endif
    !
    INTEGER :: i1, d1s, d1e
    INTEGER :: i2, d2s, d2e
    INTEGER :: i3, d3s, d3e
    INTEGER :: i4, d4s, d4e
    !
    IF (PRESENT(range1)) THEN
        d1s = 1
        d1e = range1(2) - range1(1) + 1
    ELSE
        d1s = 1
        d1e = SIZE(array_out, 1)
    END IF
    !
    IF (PRESENT(range2)) THEN
        d2s = 1
        d2e = range2(2) - range2(1) + 1
    ELSE
        d2s = 1
        d2e = SIZE(array_out, 2)
    END IF
    !
    IF (PRESENT(range3)) THEN
        d3s = 1
        d3e = range3(2) - range3(1) + 1
    ELSE
        d3s = 1
        d3e = SIZE(array_out, 3)
    END IF
    !
    IF (PRESENT(range4)) THEN
        d4s = 1
        d4e = range4(2) - range4(1) + 1
    ELSE
        d4s = 1
        d4e = SIZE(array_out, 4)
    END IF
    !
    !
    !$cuf kernel do(4)
    DO i4 = d4s, d4e
    DO i3 = d3s, d3e
    DO i2 = d2s, d2e
    DO i1 = d1s, d1e
        array_out(i1,i2,i3,i4 ) = val
    ENDDO
    ENDDO
    ENDDO
    ENDDO
    !
END SUBROUTINE dp_dev_memset_r4d
!
SUBROUTINE dp_dev_memset_c1d(array_out, val, range1 )
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(14,200)
    COMPLEX(PRCSN), INTENT(INOUT) :: array_out(:)
    COMPLEX(PRCSN), INTENT(IN) :: val
    INTEGER, OPTIONAL, INTENT(IN) ::  range1(2)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_out
#endif
    !
    INTEGER :: i1, d1s, d1e
    !
    IF (PRESENT(range1)) THEN
        d1s = 1
        d1e = range1(2) - range1(1) + 1
    ELSE
        d1s = 1
        d1e = SIZE(array_out, 1)
    END IF
    !
    !
    !$cuf kernel do(1)
    DO i1 = d1s, d1e
        array_out(i1 ) = val
    ENDDO
    !
END SUBROUTINE dp_dev_memset_c1d
!
SUBROUTINE dp_dev_memset_c2d(array_out, val, range1, range2 )
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(14,200)
    COMPLEX(PRCSN), INTENT(INOUT) :: array_out(:,:)
    COMPLEX(PRCSN), INTENT(IN) :: val
    INTEGER, OPTIONAL, INTENT(IN) ::  range1(2), range2(2)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_out
#endif
    !
    INTEGER :: i1, d1s, d1e
    INTEGER :: i2, d2s, d2e
    !
    IF (PRESENT(range1)) THEN
        d1s = 1
        d1e = range1(2) - range1(1) + 1
    ELSE
        d1s = 1
        d1e = SIZE(array_out, 1)
    END IF
    !
    IF (PRESENT(range2)) THEN
        d2s = 1
        d2e = range2(2) - range2(1) + 1
    ELSE
        d2s = 1
        d2e = SIZE(array_out, 2)
    END IF
    !
    !
    !$cuf kernel do(2)
    DO i2 = d2s, d2e
    DO i1 = d1s, d1e
        array_out(i1,i2 ) = val
    ENDDO
    ENDDO
    !
END SUBROUTINE dp_dev_memset_c2d
!
SUBROUTINE dp_dev_memset_c3d(array_out, val, range1, range2, range3 )
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(14,200)
    COMPLEX(PRCSN), INTENT(INOUT) :: array_out(:,:,:)
    COMPLEX(PRCSN), INTENT(IN) :: val
    INTEGER, OPTIONAL, INTENT(IN) ::  range1(2), range2(2), range3(2)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_out
#endif
    !
    INTEGER :: i1, d1s, d1e
    INTEGER :: i2, d2s, d2e
    INTEGER :: i3, d3s, d3e
    !
    IF (PRESENT(range1)) THEN
        d1s = 1
        d1e = range1(2) - range1(1) + 1
    ELSE
        d1s = 1
        d1e = SIZE(array_out, 1)
    END IF
    !
    IF (PRESENT(range2)) THEN
        d2s = 1
        d2e = range2(2) - range2(1) + 1
    ELSE
        d2s = 1
        d2e = SIZE(array_out, 2)
    END IF
    !
    IF (PRESENT(range3)) THEN
        d3s = 1
        d3e = range3(2) - range3(1) + 1
    ELSE
        d3s = 1
        d3e = SIZE(array_out, 3)
    END IF
    !
    !
    !$cuf kernel do(3)
    DO i3 = d3s, d3e
    DO i2 = d2s, d2e
    DO i1 = d1s, d1e
        array_out(i1,i2,i3 ) = val
    ENDDO
    ENDDO
    ENDDO
    !
END SUBROUTINE dp_dev_memset_c3d
!
SUBROUTINE dp_dev_memset_c4d(array_out, val, range1, range2, range3, range4 )
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(14,200)
    COMPLEX(PRCSN), INTENT(INOUT) :: array_out(:,:,:,:)
    COMPLEX(PRCSN), INTENT(IN) :: val
    INTEGER, OPTIONAL, INTENT(IN) ::  range1(2), range2(2), range3(2), range4(2)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_out
#endif
    !
    INTEGER :: i1, d1s, d1e
    INTEGER :: i2, d2s, d2e
    INTEGER :: i3, d3s, d3e
    INTEGER :: i4, d4s, d4e
    !
    IF (PRESENT(range1)) THEN
        d1s = 1
        d1e = range1(2) - range1(1) + 1
    ELSE
        d1s = 1
        d1e = SIZE(array_out, 1)
    END IF
    !
    IF (PRESENT(range2)) THEN
        d2s = 1
        d2e = range2(2) - range2(1) + 1
    ELSE
        d2s = 1
        d2e = SIZE(array_out, 2)
    END IF
    !
    IF (PRESENT(range3)) THEN
        d3s = 1
        d3e = range3(2) - range3(1) + 1
    ELSE
        d3s = 1
        d3e = SIZE(array_out, 3)
    END IF
    !
    IF (PRESENT(range4)) THEN
        d4s = 1
        d4e = range4(2) - range4(1) + 1
    ELSE
        d4s = 1
        d4e = SIZE(array_out, 4)
    END IF
    !
    !
    !$cuf kernel do(4)
    DO i4 = d4s, d4e
    DO i3 = d3s, d3e
    DO i2 = d2s, d2e
    DO i1 = d1s, d1e
        array_out(i1,i2,i3,i4 ) = val
    ENDDO
    ENDDO
    ENDDO
    ENDDO
    !
END SUBROUTINE dp_dev_memset_c4d
!
SUBROUTINE sp_dev_memset_r1d(array_out, val, range1 )
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(6, 37)
    REAL(PRCSN), INTENT(INOUT) :: array_out(:)
    REAL(PRCSN), INTENT(IN) :: val
    INTEGER, OPTIONAL, INTENT(IN) ::  range1(2)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_out
#endif
    !
    INTEGER :: i1, d1s, d1e
    !
    IF (PRESENT(range1)) THEN
        d1s = 1
        d1e = range1(2) - range1(1) + 1
    ELSE
        d1s = 1
        d1e = SIZE(array_out, 1)
    END IF
    !
    !
    !$cuf kernel do(1)
    DO i1 = d1s, d1e
        array_out(i1 ) = val
    ENDDO
    !
END SUBROUTINE sp_dev_memset_r1d
!
SUBROUTINE sp_dev_memset_r2d(array_out, val, range1, range2 )
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(6, 37)
    REAL(PRCSN), INTENT(INOUT) :: array_out(:,:)
    REAL(PRCSN), INTENT(IN) :: val
    INTEGER, OPTIONAL, INTENT(IN) ::  range1(2), range2(2)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_out
#endif
    !
    INTEGER :: i1, d1s, d1e
    INTEGER :: i2, d2s, d2e
    !
    IF (PRESENT(range1)) THEN
        d1s = 1
        d1e = range1(2) - range1(1) + 1
    ELSE
        d1s = 1
        d1e = SIZE(array_out, 1)
    END IF
    !
    IF (PRESENT(range2)) THEN
        d2s = 1
        d2e = range2(2) - range2(1) + 1
    ELSE
        d2s = 1
        d2e = SIZE(array_out, 2)
    END IF
    !
    !
    !$cuf kernel do(2)
    DO i2 = d2s, d2e
    DO i1 = d1s, d1e
        array_out(i1,i2 ) = val
    ENDDO
    ENDDO
    !
END SUBROUTINE sp_dev_memset_r2d
!
SUBROUTINE sp_dev_memset_r3d(array_out, val, range1, range2, range3 )
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(6, 37)
    REAL(PRCSN), INTENT(INOUT) :: array_out(:,:,:)
    REAL(PRCSN), INTENT(IN) :: val
    INTEGER, OPTIONAL, INTENT(IN) ::  range1(2), range2(2), range3(2)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_out
#endif
    !
    INTEGER :: i1, d1s, d1e
    INTEGER :: i2, d2s, d2e
    INTEGER :: i3, d3s, d3e
    !
    IF (PRESENT(range1)) THEN
        d1s = 1
        d1e = range1(2) - range1(1) + 1
    ELSE
        d1s = 1
        d1e = SIZE(array_out, 1)
    END IF
    !
    IF (PRESENT(range2)) THEN
        d2s = 1
        d2e = range2(2) - range2(1) + 1
    ELSE
        d2s = 1
        d2e = SIZE(array_out, 2)
    END IF
    !
    IF (PRESENT(range3)) THEN
        d3s = 1
        d3e = range3(2) - range3(1) + 1
    ELSE
        d3s = 1
        d3e = SIZE(array_out, 3)
    END IF
    !
    !
    !$cuf kernel do(3)
    DO i3 = d3s, d3e
    DO i2 = d2s, d2e
    DO i1 = d1s, d1e
        array_out(i1,i2,i3 ) = val
    ENDDO
    ENDDO
    ENDDO
    !
END SUBROUTINE sp_dev_memset_r3d
!
SUBROUTINE sp_dev_memset_r4d(array_out, val, range1, range2, range3, range4 )
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(6, 37)
    REAL(PRCSN), INTENT(INOUT) :: array_out(:,:,:,:)
    REAL(PRCSN), INTENT(IN) :: val
    INTEGER, OPTIONAL, INTENT(IN) ::  range1(2), range2(2), range3(2), range4(2)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_out
#endif
    !
    INTEGER :: i1, d1s, d1e
    INTEGER :: i2, d2s, d2e
    INTEGER :: i3, d3s, d3e
    INTEGER :: i4, d4s, d4e
    !
    IF (PRESENT(range1)) THEN
        d1s = 1
        d1e = range1(2) - range1(1) + 1
    ELSE
        d1s = 1
        d1e = SIZE(array_out, 1)
    END IF
    !
    IF (PRESENT(range2)) THEN
        d2s = 1
        d2e = range2(2) - range2(1) + 1
    ELSE
        d2s = 1
        d2e = SIZE(array_out, 2)
    END IF
    !
    IF (PRESENT(range3)) THEN
        d3s = 1
        d3e = range3(2) - range3(1) + 1
    ELSE
        d3s = 1
        d3e = SIZE(array_out, 3)
    END IF
    !
    IF (PRESENT(range4)) THEN
        d4s = 1
        d4e = range4(2) - range4(1) + 1
    ELSE
        d4s = 1
        d4e = SIZE(array_out, 4)
    END IF
    !
    !
    !$cuf kernel do(4)
    DO i4 = d4s, d4e
    DO i3 = d3s, d3e
    DO i2 = d2s, d2e
    DO i1 = d1s, d1e
        array_out(i1,i2,i3,i4 ) = val
    ENDDO
    ENDDO
    ENDDO
    ENDDO
    !
END SUBROUTINE sp_dev_memset_r4d
!
SUBROUTINE sp_dev_memset_c1d(array_out, val, range1 )
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(6, 37)
    COMPLEX(PRCSN), INTENT(INOUT) :: array_out(:)
    COMPLEX(PRCSN), INTENT(IN) :: val
    INTEGER, OPTIONAL, INTENT(IN) ::  range1(2)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_out
#endif
    !
    INTEGER :: i1, d1s, d1e
    !
    IF (PRESENT(range1)) THEN
        d1s = 1
        d1e = range1(2) - range1(1) + 1
    ELSE
        d1s = 1
        d1e = SIZE(array_out, 1)
    END IF
    !
    !
    !$cuf kernel do(1)
    DO i1 = d1s, d1e
        array_out(i1 ) = val
    ENDDO
    !
END SUBROUTINE sp_dev_memset_c1d
!
SUBROUTINE sp_dev_memset_c2d(array_out, val, range1, range2 )
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(6, 37)
    COMPLEX(PRCSN), INTENT(INOUT) :: array_out(:,:)
    COMPLEX(PRCSN), INTENT(IN) :: val
    INTEGER, OPTIONAL, INTENT(IN) ::  range1(2), range2(2)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_out
#endif
    !
    INTEGER :: i1, d1s, d1e
    INTEGER :: i2, d2s, d2e
    !
    IF (PRESENT(range1)) THEN
        d1s = 1
        d1e = range1(2) - range1(1) + 1
    ELSE
        d1s = 1
        d1e = SIZE(array_out, 1)
    END IF
    !
    IF (PRESENT(range2)) THEN
        d2s = 1
        d2e = range2(2) - range2(1) + 1
    ELSE
        d2s = 1
        d2e = SIZE(array_out, 2)
    END IF
    !
    !
    !$cuf kernel do(2)
    DO i2 = d2s, d2e
    DO i1 = d1s, d1e
        array_out(i1,i2 ) = val
    ENDDO
    ENDDO
    !
END SUBROUTINE sp_dev_memset_c2d
!
SUBROUTINE sp_dev_memset_c3d(array_out, val, range1, range2, range3 )
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(6, 37)
    COMPLEX(PRCSN), INTENT(INOUT) :: array_out(:,:,:)
    COMPLEX(PRCSN), INTENT(IN) :: val
    INTEGER, OPTIONAL, INTENT(IN) ::  range1(2), range2(2), range3(2)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_out
#endif
    !
    INTEGER :: i1, d1s, d1e
    INTEGER :: i2, d2s, d2e
    INTEGER :: i3, d3s, d3e
    !
    IF (PRESENT(range1)) THEN
        d1s = 1
        d1e = range1(2) - range1(1) + 1
    ELSE
        d1s = 1
        d1e = SIZE(array_out, 1)
    END IF
    !
    IF (PRESENT(range2)) THEN
        d2s = 1
        d2e = range2(2) - range2(1) + 1
    ELSE
        d2s = 1
        d2e = SIZE(array_out, 2)
    END IF
    !
    IF (PRESENT(range3)) THEN
        d3s = 1
        d3e = range3(2) - range3(1) + 1
    ELSE
        d3s = 1
        d3e = SIZE(array_out, 3)
    END IF
    !
    !
    !$cuf kernel do(3)
    DO i3 = d3s, d3e
    DO i2 = d2s, d2e
    DO i1 = d1s, d1e
        array_out(i1,i2,i3 ) = val
    ENDDO
    ENDDO
    ENDDO
    !
END SUBROUTINE sp_dev_memset_c3d
!
SUBROUTINE sp_dev_memset_c4d(array_out, val, range1, range2, range3, range4 )
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(6, 37)
    COMPLEX(PRCSN), INTENT(INOUT) :: array_out(:,:,:,:)
    COMPLEX(PRCSN), INTENT(IN) :: val
    INTEGER, OPTIONAL, INTENT(IN) ::  range1(2), range2(2), range3(2), range4(2)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_out
#endif
    !
    INTEGER :: i1, d1s, d1e
    INTEGER :: i2, d2s, d2e
    INTEGER :: i3, d3s, d3e
    INTEGER :: i4, d4s, d4e
    !
    IF (PRESENT(range1)) THEN
        d1s = 1
        d1e = range1(2) - range1(1) + 1
    ELSE
        d1s = 1
        d1e = SIZE(array_out, 1)
    END IF
    !
    IF (PRESENT(range2)) THEN
        d2s = 1
        d2e = range2(2) - range2(1) + 1
    ELSE
        d2s = 1
        d2e = SIZE(array_out, 2)
    END IF
    !
    IF (PRESENT(range3)) THEN
        d3s = 1
        d3e = range3(2) - range3(1) + 1
    ELSE
        d3s = 1
        d3e = SIZE(array_out, 3)
    END IF
    !
    IF (PRESENT(range4)) THEN
        d4s = 1
        d4e = range4(2) - range4(1) + 1
    ELSE
        d4s = 1
        d4e = SIZE(array_out, 4)
    END IF
    !
    !
    !$cuf kernel do(4)
    DO i4 = d4s, d4e
    DO i3 = d3s, d3e
    DO i2 = d2s, d2e
    DO i1 = d1s, d1e
        array_out(i1,i2,i3,i4 ) = val
    ENDDO
    ENDDO
    ENDDO
    ENDDO
    !
END SUBROUTINE sp_dev_memset_c4d
!
!
SUBROUTINE dp_h2d_memsync_r1d(array_out, array_in, range1 )
#if defined(__CUDA)
    USE cudafor
#endif
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(14,200)
    REAL(PRCSN), INTENT(INOUT) :: array_out(:)
    REAL(PRCSN), INTENT(IN)    :: array_in(:)
    INTEGER, INTENT(IN) ::  range1(3)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_out
#endif
    !
    INTEGER :: d1_start, d1_size, d1_ld
    INTEGER :: ierr
    !
    d1_start = 1
    d1_size = range1(2) - range1(1) + 1
    d1_ld = range1(3)
    !
#if defined(__CUDA)
    ierr = cudaMemcpy( array_out(d1_start), array_in(d1_start), d1_size, cudaMemcpyHostToDevice )
#else
    array_out(d1_start:d1_start+d1_size-1) = array_in(d1_start:d1_start+d1_size-1)
#endif
    !
END SUBROUTINE dp_h2d_memsync_r1d
!
SUBROUTINE dp_h2d_memsync_r2d(array_out, array_in, range1, range2 )
#if defined(__CUDA)
    USE cudafor
#endif
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(14,200)
    REAL(PRCSN), INTENT(INOUT) :: array_out(:,:)
    REAL(PRCSN), INTENT(IN)    :: array_in(:,:)
    INTEGER, INTENT(IN) ::  range1(3), range2(3)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_out
#endif
    !
    INTEGER :: d1_start, d1_size, d1_ld
    INTEGER :: d2_start, d2_size, d2_ld
    INTEGER :: ierr
    !
    d1_start = 1
    d1_size = range1(2) - range1(1) + 1
    d1_ld = range1(3)
    d2_start = 1
    d2_size = range2(2) - range2(1) + 1
    d2_ld = range2(3)
    !
#if defined(__CUDA)
    ierr = cudaMemcpy2D( array_out(d1_start, d2_start) , d1_ld, array_in(d1_start, d2_start), d2_ld, d1_size, d2_size )
#else

    !pinned_buffer(1:nbase, n_start:n_end) = sc_d( 1:nbase, n_start:n_end )
    !ierr = cudaMemcpy2D( pinned_buffer(1, n_start) , nvecx, sc_d( 1, n_start ), nvecx, nbase, n_end-n_start+1 )

    array_out(d1_start:d1_start+d1_size-1, d2_start:d2_start+d2_size-1) =  &
                array_in(d1_start:d1_start+d1_size-1, d2_start:d2_start+d2_size-1)
#endif
    !
END SUBROUTINE dp_h2d_memsync_r2d
!
SUBROUTINE dp_h2d_memsync_r3d(array_out, array_in, range1, range2, range3 )
#if defined(__CUDA)
    USE cudafor
#endif
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(14,200)
    REAL(PRCSN), INTENT(INOUT) :: array_out(:,:,:)
    REAL(PRCSN), INTENT(IN)    :: array_in(:,:,:)
    INTEGER, INTENT(IN) ::  range1(3), range2(3), range3(3)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_out
#endif
    !
    INTEGER :: d1_start, d1_size, d1_ld
    INTEGER :: d2_start, d2_size, d2_ld
    INTEGER :: d3_start, d3_size, d3_ld
    INTEGER :: ierr
    !
    d1_start = 1
    d1_size = range1(2) - range1(1) + 1
    d1_ld = range1(3)
    d2_start = 1
    d2_size = range2(2) - range2(1) + 1
    d2_ld = range2(3)
    d3_start = 1
    d3_size = range3(2) - range3(1) + 1
    d3_ld = range3(3)
    !
#if defined(__CUDA)
    CALL dxlib_errore('cu_memsync_','3D arrays not implemented yet',1)
#else
    CALL dxlib_errore('cu_memsync_','3D arrays not implemented yet',1)
#endif
    !
END SUBROUTINE dp_h2d_memsync_r3d
!
SUBROUTINE dp_h2d_memsync_r4d(array_out, array_in, range1, range2, range3, range4 )
#if defined(__CUDA)
    USE cudafor
#endif
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(14,200)
    REAL(PRCSN), INTENT(INOUT) :: array_out(:,:,:,:)
    REAL(PRCSN), INTENT(IN)    :: array_in(:,:,:,:)
    INTEGER, INTENT(IN) ::  range1(3), range2(3), range3(3), range4(3)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_out
#endif
    !
    INTEGER :: d1_start, d1_size, d1_ld
    INTEGER :: d2_start, d2_size, d2_ld
    INTEGER :: d3_start, d3_size, d3_ld
    INTEGER :: d4_start, d4_size, d4_ld
    INTEGER :: ierr
    !
    d1_start = 1
    d1_size = range1(2) - range1(1) + 1
    d1_ld = range1(3)
    d2_start = 1
    d2_size = range2(2) - range2(1) + 1
    d2_ld = range2(3)
    d3_start = 1
    d3_size = range3(2) - range3(1) + 1
    d3_ld = range3(3)
    d4_start = 1
    d4_size = range4(2) - range4(1) + 1
    d4_ld = range4(3)
    !
#if defined(__CUDA)
    CALL dxlib_errore('cu_memsync_','4D arrays not implemented yet',1)
#else
    CALL dxlib_errore('cu_memsync_','4D arrays not implemented yet',1)
#endif
    !
END SUBROUTINE dp_h2d_memsync_r4d
!
SUBROUTINE dp_h2d_memsync_c1d(array_out, array_in, range1 )
#if defined(__CUDA)
    USE cudafor
#endif
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(14,200)
    COMPLEX(PRCSN), INTENT(INOUT) :: array_out(:)
    COMPLEX(PRCSN), INTENT(IN)    :: array_in(:)
    INTEGER, INTENT(IN) ::  range1(3)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_out
#endif
    !
    INTEGER :: d1_start, d1_size, d1_ld
    INTEGER :: ierr
    !
    d1_start = 1
    d1_size = range1(2) - range1(1) + 1
    d1_ld = range1(3)
    !
#if defined(__CUDA)
    ierr = cudaMemcpy( array_out(d1_start), array_in(d1_start), d1_size, cudaMemcpyHostToDevice )
#else
    array_out(d1_start:d1_start+d1_size-1) = array_in(d1_start:d1_start+d1_size-1)
#endif
    !
END SUBROUTINE dp_h2d_memsync_c1d
!
SUBROUTINE dp_h2d_memsync_c2d(array_out, array_in, range1, range2 )
#if defined(__CUDA)
    USE cudafor
#endif
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(14,200)
    COMPLEX(PRCSN), INTENT(INOUT) :: array_out(:,:)
    COMPLEX(PRCSN), INTENT(IN)    :: array_in(:,:)
    INTEGER, INTENT(IN) ::  range1(3), range2(3)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_out
#endif
    !
    INTEGER :: d1_start, d1_size, d1_ld
    INTEGER :: d2_start, d2_size, d2_ld
    INTEGER :: ierr
    !
    d1_start = 1
    d1_size = range1(2) - range1(1) + 1
    d1_ld = range1(3)
    d2_start = 1
    d2_size = range2(2) - range2(1) + 1
    d2_ld = range2(3)
    !
#if defined(__CUDA)
    ierr = cudaMemcpy2D( array_out(d1_start, d2_start) , d1_ld, array_in(d1_start, d2_start), d2_ld, d1_size, d2_size )
#else

    !pinned_buffer(1:nbase, n_start:n_end) = sc_d( 1:nbase, n_start:n_end )
    !ierr = cudaMemcpy2D( pinned_buffer(1, n_start) , nvecx, sc_d( 1, n_start ), nvecx, nbase, n_end-n_start+1 )

    array_out(d1_start:d1_start+d1_size-1, d2_start:d2_start+d2_size-1) =  &
                array_in(d1_start:d1_start+d1_size-1, d2_start:d2_start+d2_size-1)
#endif
    !
END SUBROUTINE dp_h2d_memsync_c2d
!
SUBROUTINE dp_h2d_memsync_c3d(array_out, array_in, range1, range2, range3 )
#if defined(__CUDA)
    USE cudafor
#endif
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(14,200)
    COMPLEX(PRCSN), INTENT(INOUT) :: array_out(:,:,:)
    COMPLEX(PRCSN), INTENT(IN)    :: array_in(:,:,:)
    INTEGER, INTENT(IN) ::  range1(3), range2(3), range3(3)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_out
#endif
    !
    INTEGER :: d1_start, d1_size, d1_ld
    INTEGER :: d2_start, d2_size, d2_ld
    INTEGER :: d3_start, d3_size, d3_ld
    INTEGER :: ierr
    !
    d1_start = 1
    d1_size = range1(2) - range1(1) + 1
    d1_ld = range1(3)
    d2_start = 1
    d2_size = range2(2) - range2(1) + 1
    d2_ld = range2(3)
    d3_start = 1
    d3_size = range3(2) - range3(1) + 1
    d3_ld = range3(3)
    !
#if defined(__CUDA)
    CALL dxlib_errore('cu_memsync_','3D arrays not implemented yet',1)
#else
    CALL dxlib_errore('cu_memsync_','3D arrays not implemented yet',1)
#endif
    !
END SUBROUTINE dp_h2d_memsync_c3d
!
SUBROUTINE dp_h2d_memsync_c4d(array_out, array_in, range1, range2, range3, range4 )
#if defined(__CUDA)
    USE cudafor
#endif
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(14,200)
    COMPLEX(PRCSN), INTENT(INOUT) :: array_out(:,:,:,:)
    COMPLEX(PRCSN), INTENT(IN)    :: array_in(:,:,:,:)
    INTEGER, INTENT(IN) ::  range1(3), range2(3), range3(3), range4(3)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_out
#endif
    !
    INTEGER :: d1_start, d1_size, d1_ld
    INTEGER :: d2_start, d2_size, d2_ld
    INTEGER :: d3_start, d3_size, d3_ld
    INTEGER :: d4_start, d4_size, d4_ld
    INTEGER :: ierr
    !
    d1_start = 1
    d1_size = range1(2) - range1(1) + 1
    d1_ld = range1(3)
    d2_start = 1
    d2_size = range2(2) - range2(1) + 1
    d2_ld = range2(3)
    d3_start = 1
    d3_size = range3(2) - range3(1) + 1
    d3_ld = range3(3)
    d4_start = 1
    d4_size = range4(2) - range4(1) + 1
    d4_ld = range4(3)
    !
#if defined(__CUDA)
    CALL dxlib_errore('cu_memsync_','4D arrays not implemented yet',1)
#else
    CALL dxlib_errore('cu_memsync_','4D arrays not implemented yet',1)
#endif
    !
END SUBROUTINE dp_h2d_memsync_c4d
!
SUBROUTINE sp_h2d_memsync_r1d(array_out, array_in, range1 )
#if defined(__CUDA)
    USE cudafor
#endif
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(6, 37)
    REAL(PRCSN), INTENT(INOUT) :: array_out(:)
    REAL(PRCSN), INTENT(IN)    :: array_in(:)
    INTEGER, INTENT(IN) ::  range1(3)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_out
#endif
    !
    INTEGER :: d1_start, d1_size, d1_ld
    INTEGER :: ierr
    !
    d1_start = 1
    d1_size = range1(2) - range1(1) + 1
    d1_ld = range1(3)
    !
#if defined(__CUDA)
    ierr = cudaMemcpy( array_out(d1_start), array_in(d1_start), d1_size, cudaMemcpyHostToDevice )
#else
    array_out(d1_start:d1_start+d1_size-1) = array_in(d1_start:d1_start+d1_size-1)
#endif
    !
END SUBROUTINE sp_h2d_memsync_r1d
!
SUBROUTINE sp_h2d_memsync_r2d(array_out, array_in, range1, range2 )
#if defined(__CUDA)
    USE cudafor
#endif
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(6, 37)
    REAL(PRCSN), INTENT(INOUT) :: array_out(:,:)
    REAL(PRCSN), INTENT(IN)    :: array_in(:,:)
    INTEGER, INTENT(IN) ::  range1(3), range2(3)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_out
#endif
    !
    INTEGER :: d1_start, d1_size, d1_ld
    INTEGER :: d2_start, d2_size, d2_ld
    INTEGER :: ierr
    !
    d1_start = 1
    d1_size = range1(2) - range1(1) + 1
    d1_ld = range1(3)
    d2_start = 1
    d2_size = range2(2) - range2(1) + 1
    d2_ld = range2(3)
    !
#if defined(__CUDA)
    ierr = cudaMemcpy2D( array_out(d1_start, d2_start) , d1_ld, array_in(d1_start, d2_start), d2_ld, d1_size, d2_size )
#else

    !pinned_buffer(1:nbase, n_start:n_end) = sc_d( 1:nbase, n_start:n_end )
    !ierr = cudaMemcpy2D( pinned_buffer(1, n_start) , nvecx, sc_d( 1, n_start ), nvecx, nbase, n_end-n_start+1 )

    array_out(d1_start:d1_start+d1_size-1, d2_start:d2_start+d2_size-1) =  &
                array_in(d1_start:d1_start+d1_size-1, d2_start:d2_start+d2_size-1)
#endif
    !
END SUBROUTINE sp_h2d_memsync_r2d
!
SUBROUTINE sp_h2d_memsync_r3d(array_out, array_in, range1, range2, range3 )
#if defined(__CUDA)
    USE cudafor
#endif
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(6, 37)
    REAL(PRCSN), INTENT(INOUT) :: array_out(:,:,:)
    REAL(PRCSN), INTENT(IN)    :: array_in(:,:,:)
    INTEGER, INTENT(IN) ::  range1(3), range2(3), range3(3)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_out
#endif
    !
    INTEGER :: d1_start, d1_size, d1_ld
    INTEGER :: d2_start, d2_size, d2_ld
    INTEGER :: d3_start, d3_size, d3_ld
    INTEGER :: ierr
    !
    d1_start = 1
    d1_size = range1(2) - range1(1) + 1
    d1_ld = range1(3)
    d2_start = 1
    d2_size = range2(2) - range2(1) + 1
    d2_ld = range2(3)
    d3_start = 1
    d3_size = range3(2) - range3(1) + 1
    d3_ld = range3(3)
    !
#if defined(__CUDA)
    CALL dxlib_errore('cu_memsync_','3D arrays not implemented yet',1)
#else
    CALL dxlib_errore('cu_memsync_','3D arrays not implemented yet',1)
#endif
    !
END SUBROUTINE sp_h2d_memsync_r3d
!
SUBROUTINE sp_h2d_memsync_r4d(array_out, array_in, range1, range2, range3, range4 )
#if defined(__CUDA)
    USE cudafor
#endif
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(6, 37)
    REAL(PRCSN), INTENT(INOUT) :: array_out(:,:,:,:)
    REAL(PRCSN), INTENT(IN)    :: array_in(:,:,:,:)
    INTEGER, INTENT(IN) ::  range1(3), range2(3), range3(3), range4(3)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_out
#endif
    !
    INTEGER :: d1_start, d1_size, d1_ld
    INTEGER :: d2_start, d2_size, d2_ld
    INTEGER :: d3_start, d3_size, d3_ld
    INTEGER :: d4_start, d4_size, d4_ld
    INTEGER :: ierr
    !
    d1_start = 1
    d1_size = range1(2) - range1(1) + 1
    d1_ld = range1(3)
    d2_start = 1
    d2_size = range2(2) - range2(1) + 1
    d2_ld = range2(3)
    d3_start = 1
    d3_size = range3(2) - range3(1) + 1
    d3_ld = range3(3)
    d4_start = 1
    d4_size = range4(2) - range4(1) + 1
    d4_ld = range4(3)
    !
#if defined(__CUDA)
    CALL dxlib_errore('cu_memsync_','4D arrays not implemented yet',1)
#else
    CALL dxlib_errore('cu_memsync_','4D arrays not implemented yet',1)
#endif
    !
END SUBROUTINE sp_h2d_memsync_r4d
!
SUBROUTINE sp_h2d_memsync_c1d(array_out, array_in, range1 )
#if defined(__CUDA)
    USE cudafor
#endif
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(6, 37)
    COMPLEX(PRCSN), INTENT(INOUT) :: array_out(:)
    COMPLEX(PRCSN), INTENT(IN)    :: array_in(:)
    INTEGER, INTENT(IN) ::  range1(3)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_out
#endif
    !
    INTEGER :: d1_start, d1_size, d1_ld
    INTEGER :: ierr
    !
    d1_start = 1
    d1_size = range1(2) - range1(1) + 1
    d1_ld = range1(3)
    !
#if defined(__CUDA)
    ierr = cudaMemcpy( array_out(d1_start), array_in(d1_start), d1_size, cudaMemcpyHostToDevice )
#else
    array_out(d1_start:d1_start+d1_size-1) = array_in(d1_start:d1_start+d1_size-1)
#endif
    !
END SUBROUTINE sp_h2d_memsync_c1d
!
SUBROUTINE sp_h2d_memsync_c2d(array_out, array_in, range1, range2 )
#if defined(__CUDA)
    USE cudafor
#endif
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(6, 37)
    COMPLEX(PRCSN), INTENT(INOUT) :: array_out(:,:)
    COMPLEX(PRCSN), INTENT(IN)    :: array_in(:,:)
    INTEGER, INTENT(IN) ::  range1(3), range2(3)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_out
#endif
    !
    INTEGER :: d1_start, d1_size, d1_ld
    INTEGER :: d2_start, d2_size, d2_ld
    INTEGER :: ierr
    !
    d1_start = 1
    d1_size = range1(2) - range1(1) + 1
    d1_ld = range1(3)
    d2_start = 1
    d2_size = range2(2) - range2(1) + 1
    d2_ld = range2(3)
    !
#if defined(__CUDA)
    ierr = cudaMemcpy2D( array_out(d1_start, d2_start) , d1_ld, array_in(d1_start, d2_start), d2_ld, d1_size, d2_size )
#else

    !pinned_buffer(1:nbase, n_start:n_end) = sc_d( 1:nbase, n_start:n_end )
    !ierr = cudaMemcpy2D( pinned_buffer(1, n_start) , nvecx, sc_d( 1, n_start ), nvecx, nbase, n_end-n_start+1 )

    array_out(d1_start:d1_start+d1_size-1, d2_start:d2_start+d2_size-1) =  &
                array_in(d1_start:d1_start+d1_size-1, d2_start:d2_start+d2_size-1)
#endif
    !
END SUBROUTINE sp_h2d_memsync_c2d
!
SUBROUTINE sp_h2d_memsync_c3d(array_out, array_in, range1, range2, range3 )
#if defined(__CUDA)
    USE cudafor
#endif
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(6, 37)
    COMPLEX(PRCSN), INTENT(INOUT) :: array_out(:,:,:)
    COMPLEX(PRCSN), INTENT(IN)    :: array_in(:,:,:)
    INTEGER, INTENT(IN) ::  range1(3), range2(3), range3(3)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_out
#endif
    !
    INTEGER :: d1_start, d1_size, d1_ld
    INTEGER :: d2_start, d2_size, d2_ld
    INTEGER :: d3_start, d3_size, d3_ld
    INTEGER :: ierr
    !
    d1_start = 1
    d1_size = range1(2) - range1(1) + 1
    d1_ld = range1(3)
    d2_start = 1
    d2_size = range2(2) - range2(1) + 1
    d2_ld = range2(3)
    d3_start = 1
    d3_size = range3(2) - range3(1) + 1
    d3_ld = range3(3)
    !
#if defined(__CUDA)
    CALL dxlib_errore('cu_memsync_','3D arrays not implemented yet',1)
#else
    CALL dxlib_errore('cu_memsync_','3D arrays not implemented yet',1)
#endif
    !
END SUBROUTINE sp_h2d_memsync_c3d
!
SUBROUTINE sp_h2d_memsync_c4d(array_out, array_in, range1, range2, range3, range4 )
#if defined(__CUDA)
    USE cudafor
#endif
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(6, 37)
    COMPLEX(PRCSN), INTENT(INOUT) :: array_out(:,:,:,:)
    COMPLEX(PRCSN), INTENT(IN)    :: array_in(:,:,:,:)
    INTEGER, INTENT(IN) ::  range1(3), range2(3), range3(3), range4(3)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_out
#endif
    !
    INTEGER :: d1_start, d1_size, d1_ld
    INTEGER :: d2_start, d2_size, d2_ld
    INTEGER :: d3_start, d3_size, d3_ld
    INTEGER :: d4_start, d4_size, d4_ld
    INTEGER :: ierr
    !
    d1_start = 1
    d1_size = range1(2) - range1(1) + 1
    d1_ld = range1(3)
    d2_start = 1
    d2_size = range2(2) - range2(1) + 1
    d2_ld = range2(3)
    d3_start = 1
    d3_size = range3(2) - range3(1) + 1
    d3_ld = range3(3)
    d4_start = 1
    d4_size = range4(2) - range4(1) + 1
    d4_ld = range4(3)
    !
#if defined(__CUDA)
    CALL dxlib_errore('cu_memsync_','4D arrays not implemented yet',1)
#else
    CALL dxlib_errore('cu_memsync_','4D arrays not implemented yet',1)
#endif
    !
END SUBROUTINE sp_h2d_memsync_c4d
!
!
SUBROUTINE dp_d2h_memsync_r1d(array_out, array_in, range1 )
    !
#if defined(__CUDA)
    USE cudafor
#endif
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(14,200)
    REAL(PRCSN), INTENT(INOUT) :: array_out(:)
    REAL(PRCSN), INTENT(IN)    :: array_in(:)
    INTEGER, INTENT(IN) ::  range1(3)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_in
#endif
    !
    INTEGER :: d1_start, d1_size, d1_ld
    INTEGER :: ierr
    !
    d1_start = 1
    d1_size = range1(2) - range1(1) + 1
    d1_ld = range1(3)
    !
#if defined(__CUDA)
    ierr = cudaMemcpy( array_out(d1_start), array_in(d1_start), d1_size, cudaMemcpyDeviceToHost )
#else
    array_out(d1_start:d1_start+d1_size-1) = array_in(d1_start:d1_start+d1_size-1)
#endif
    !
END SUBROUTINE dp_d2h_memsync_r1d
!
SUBROUTINE dp_d2h_memsync_r2d(array_out, array_in, range1, range2 )
    !
#if defined(__CUDA)
    USE cudafor
#endif
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(14,200)
    REAL(PRCSN), INTENT(INOUT) :: array_out(:,:)
    REAL(PRCSN), INTENT(IN)    :: array_in(:,:)
    INTEGER, INTENT(IN) ::  range1(3), range2(3)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_in
#endif
    !
    INTEGER :: d1_start, d1_size, d1_ld
    INTEGER :: d2_start, d2_size, d2_ld
    INTEGER :: ierr
    !
    d1_start = 1
    d1_size = range1(2) - range1(1) + 1
    d1_ld = range1(3)
    d2_start = 1
    d2_size = range2(2) - range2(1) + 1
    d2_ld = range2(3)
    !
#if defined(__CUDA)
    ierr = cudaMemcpy2D( array_out(d1_start, d2_start) , d1_ld, array_in(d1_start, d2_start), d2_ld, d1_size, d2_size )
#else

    !pinned_buffer(1:nbase, n_start:n_end) = sc_d( 1:nbase, n_start:n_end )
    !ierr = cudaMemcpy2D( pinned_buffer(1, n_start) , nvecx, sc_d( 1, n_start ), nvecx, nbase, n_end-n_start+1 )

    array_out(d1_start:d1_start+d1_size-1, d2_start:d2_start+d2_size-1) =  &
                array_in(d1_start:d1_start+d1_size-1, d2_start:d2_start+d2_size-1)
#endif
    !
END SUBROUTINE dp_d2h_memsync_r2d
!
SUBROUTINE dp_d2h_memsync_r3d(array_out, array_in, range1, range2, range3 )
    !
#if defined(__CUDA)
    USE cudafor
#endif
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(14,200)
    REAL(PRCSN), INTENT(INOUT) :: array_out(:,:,:)
    REAL(PRCSN), INTENT(IN)    :: array_in(:,:,:)
    INTEGER, INTENT(IN) ::  range1(3), range2(3), range3(3)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_in
#endif
    !
    INTEGER :: d1_start, d1_size, d1_ld
    INTEGER :: d2_start, d2_size, d2_ld
    INTEGER :: d3_start, d3_size, d3_ld
    INTEGER :: ierr
    !
    d1_start = 1
    d1_size = range1(2) - range1(1) + 1
    d1_ld = range1(3)
    d2_start = 1
    d2_size = range2(2) - range2(1) + 1
    d2_ld = range2(3)
    d3_start = 1
    d3_size = range3(2) - range3(1) + 1
    d3_ld = range3(3)
    !
#if defined(__CUDA)
    CALL dxlib_errore('cu_memsync_','3D arrays not implemented yet',1)
#else
    CALL dxlib_errore('cu_memsync_','3D arrays not implemented yet',1)
#endif
    !
END SUBROUTINE dp_d2h_memsync_r3d
!
SUBROUTINE dp_d2h_memsync_r4d(array_out, array_in, range1, range2, range3, range4 )
    !
#if defined(__CUDA)
    USE cudafor
#endif
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(14,200)
    REAL(PRCSN), INTENT(INOUT) :: array_out(:,:,:,:)
    REAL(PRCSN), INTENT(IN)    :: array_in(:,:,:,:)
    INTEGER, INTENT(IN) ::  range1(3), range2(3), range3(3), range4(3)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_in
#endif
    !
    INTEGER :: d1_start, d1_size, d1_ld
    INTEGER :: d2_start, d2_size, d2_ld
    INTEGER :: d3_start, d3_size, d3_ld
    INTEGER :: d4_start, d4_size, d4_ld
    INTEGER :: ierr
    !
    d1_start = 1
    d1_size = range1(2) - range1(1) + 1
    d1_ld = range1(3)
    d2_start = 1
    d2_size = range2(2) - range2(1) + 1
    d2_ld = range2(3)
    d3_start = 1
    d3_size = range3(2) - range3(1) + 1
    d3_ld = range3(3)
    d4_start = 1
    d4_size = range4(2) - range4(1) + 1
    d4_ld = range4(3)
    !
#if defined(__CUDA)
    CALL dxlib_errore('cu_memsync_','4D arrays not implemented yet',1)
#else
    CALL dxlib_errore('cu_memsync_','4D arrays not implemented yet',1)
#endif
    !
END SUBROUTINE dp_d2h_memsync_r4d
!
SUBROUTINE dp_d2h_memsync_c1d(array_out, array_in, range1 )
    !
#if defined(__CUDA)
    USE cudafor
#endif
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(14,200)
    COMPLEX(PRCSN), INTENT(INOUT) :: array_out(:)
    COMPLEX(PRCSN), INTENT(IN)    :: array_in(:)
    INTEGER, INTENT(IN) ::  range1(3)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_in
#endif
    !
    INTEGER :: d1_start, d1_size, d1_ld
    INTEGER :: ierr
    !
    d1_start = 1
    d1_size = range1(2) - range1(1) + 1
    d1_ld = range1(3)
    !
#if defined(__CUDA)
    ierr = cudaMemcpy( array_out(d1_start), array_in(d1_start), d1_size, cudaMemcpyDeviceToHost )
#else
    array_out(d1_start:d1_start+d1_size-1) = array_in(d1_start:d1_start+d1_size-1)
#endif
    !
END SUBROUTINE dp_d2h_memsync_c1d
!
SUBROUTINE dp_d2h_memsync_c2d(array_out, array_in, range1, range2 )
    !
#if defined(__CUDA)
    USE cudafor
#endif
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(14,200)
    COMPLEX(PRCSN), INTENT(INOUT) :: array_out(:,:)
    COMPLEX(PRCSN), INTENT(IN)    :: array_in(:,:)
    INTEGER, INTENT(IN) ::  range1(3), range2(3)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_in
#endif
    !
    INTEGER :: d1_start, d1_size, d1_ld
    INTEGER :: d2_start, d2_size, d2_ld
    INTEGER :: ierr
    !
    d1_start = 1
    d1_size = range1(2) - range1(1) + 1
    d1_ld = range1(3)
    d2_start = 1
    d2_size = range2(2) - range2(1) + 1
    d2_ld = range2(3)
    !
#if defined(__CUDA)
    ierr = cudaMemcpy2D( array_out(d1_start, d2_start) , d1_ld, array_in(d1_start, d2_start), d2_ld, d1_size, d2_size )
#else

    !pinned_buffer(1:nbase, n_start:n_end) = sc_d( 1:nbase, n_start:n_end )
    !ierr = cudaMemcpy2D( pinned_buffer(1, n_start) , nvecx, sc_d( 1, n_start ), nvecx, nbase, n_end-n_start+1 )

    array_out(d1_start:d1_start+d1_size-1, d2_start:d2_start+d2_size-1) =  &
                array_in(d1_start:d1_start+d1_size-1, d2_start:d2_start+d2_size-1)
#endif
    !
END SUBROUTINE dp_d2h_memsync_c2d
!
SUBROUTINE dp_d2h_memsync_c3d(array_out, array_in, range1, range2, range3 )
    !
#if defined(__CUDA)
    USE cudafor
#endif
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(14,200)
    COMPLEX(PRCSN), INTENT(INOUT) :: array_out(:,:,:)
    COMPLEX(PRCSN), INTENT(IN)    :: array_in(:,:,:)
    INTEGER, INTENT(IN) ::  range1(3), range2(3), range3(3)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_in
#endif
    !
    INTEGER :: d1_start, d1_size, d1_ld
    INTEGER :: d2_start, d2_size, d2_ld
    INTEGER :: d3_start, d3_size, d3_ld
    INTEGER :: ierr
    !
    d1_start = 1
    d1_size = range1(2) - range1(1) + 1
    d1_ld = range1(3)
    d2_start = 1
    d2_size = range2(2) - range2(1) + 1
    d2_ld = range2(3)
    d3_start = 1
    d3_size = range3(2) - range3(1) + 1
    d3_ld = range3(3)
    !
#if defined(__CUDA)
    CALL dxlib_errore('cu_memsync_','3D arrays not implemented yet',1)
#else
    CALL dxlib_errore('cu_memsync_','3D arrays not implemented yet',1)
#endif
    !
END SUBROUTINE dp_d2h_memsync_c3d
!
SUBROUTINE dp_d2h_memsync_c4d(array_out, array_in, range1, range2, range3, range4 )
    !
#if defined(__CUDA)
    USE cudafor
#endif
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(14,200)
    COMPLEX(PRCSN), INTENT(INOUT) :: array_out(:,:,:,:)
    COMPLEX(PRCSN), INTENT(IN)    :: array_in(:,:,:,:)
    INTEGER, INTENT(IN) ::  range1(3), range2(3), range3(3), range4(3)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_in
#endif
    !
    INTEGER :: d1_start, d1_size, d1_ld
    INTEGER :: d2_start, d2_size, d2_ld
    INTEGER :: d3_start, d3_size, d3_ld
    INTEGER :: d4_start, d4_size, d4_ld
    INTEGER :: ierr
    !
    d1_start = 1
    d1_size = range1(2) - range1(1) + 1
    d1_ld = range1(3)
    d2_start = 1
    d2_size = range2(2) - range2(1) + 1
    d2_ld = range2(3)
    d3_start = 1
    d3_size = range3(2) - range3(1) + 1
    d3_ld = range3(3)
    d4_start = 1
    d4_size = range4(2) - range4(1) + 1
    d4_ld = range4(3)
    !
#if defined(__CUDA)
    CALL dxlib_errore('cu_memsync_','4D arrays not implemented yet',1)
#else
    CALL dxlib_errore('cu_memsync_','4D arrays not implemented yet',1)
#endif
    !
END SUBROUTINE dp_d2h_memsync_c4d
!
SUBROUTINE sp_d2h_memsync_r1d(array_out, array_in, range1 )
    !
#if defined(__CUDA)
    USE cudafor
#endif
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(6, 37)
    REAL(PRCSN), INTENT(INOUT) :: array_out(:)
    REAL(PRCSN), INTENT(IN)    :: array_in(:)
    INTEGER, INTENT(IN) ::  range1(3)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_in
#endif
    !
    INTEGER :: d1_start, d1_size, d1_ld
    INTEGER :: ierr
    !
    d1_start = 1
    d1_size = range1(2) - range1(1) + 1
    d1_ld = range1(3)
    !
#if defined(__CUDA)
    ierr = cudaMemcpy( array_out(d1_start), array_in(d1_start), d1_size, cudaMemcpyDeviceToHost )
#else
    array_out(d1_start:d1_start+d1_size-1) = array_in(d1_start:d1_start+d1_size-1)
#endif
    !
END SUBROUTINE sp_d2h_memsync_r1d
!
SUBROUTINE sp_d2h_memsync_r2d(array_out, array_in, range1, range2 )
    !
#if defined(__CUDA)
    USE cudafor
#endif
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(6, 37)
    REAL(PRCSN), INTENT(INOUT) :: array_out(:,:)
    REAL(PRCSN), INTENT(IN)    :: array_in(:,:)
    INTEGER, INTENT(IN) ::  range1(3), range2(3)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_in
#endif
    !
    INTEGER :: d1_start, d1_size, d1_ld
    INTEGER :: d2_start, d2_size, d2_ld
    INTEGER :: ierr
    !
    d1_start = 1
    d1_size = range1(2) - range1(1) + 1
    d1_ld = range1(3)
    d2_start = 1
    d2_size = range2(2) - range2(1) + 1
    d2_ld = range2(3)
    !
#if defined(__CUDA)
    ierr = cudaMemcpy2D( array_out(d1_start, d2_start) , d1_ld, array_in(d1_start, d2_start), d2_ld, d1_size, d2_size )
#else

    !pinned_buffer(1:nbase, n_start:n_end) = sc_d( 1:nbase, n_start:n_end )
    !ierr = cudaMemcpy2D( pinned_buffer(1, n_start) , nvecx, sc_d( 1, n_start ), nvecx, nbase, n_end-n_start+1 )

    array_out(d1_start:d1_start+d1_size-1, d2_start:d2_start+d2_size-1) =  &
                array_in(d1_start:d1_start+d1_size-1, d2_start:d2_start+d2_size-1)
#endif
    !
END SUBROUTINE sp_d2h_memsync_r2d
!
SUBROUTINE sp_d2h_memsync_r3d(array_out, array_in, range1, range2, range3 )
    !
#if defined(__CUDA)
    USE cudafor
#endif
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(6, 37)
    REAL(PRCSN), INTENT(INOUT) :: array_out(:,:,:)
    REAL(PRCSN), INTENT(IN)    :: array_in(:,:,:)
    INTEGER, INTENT(IN) ::  range1(3), range2(3), range3(3)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_in
#endif
    !
    INTEGER :: d1_start, d1_size, d1_ld
    INTEGER :: d2_start, d2_size, d2_ld
    INTEGER :: d3_start, d3_size, d3_ld
    INTEGER :: ierr
    !
    d1_start = 1
    d1_size = range1(2) - range1(1) + 1
    d1_ld = range1(3)
    d2_start = 1
    d2_size = range2(2) - range2(1) + 1
    d2_ld = range2(3)
    d3_start = 1
    d3_size = range3(2) - range3(1) + 1
    d3_ld = range3(3)
    !
#if defined(__CUDA)
    CALL dxlib_errore('cu_memsync_','3D arrays not implemented yet',1)
#else
    CALL dxlib_errore('cu_memsync_','3D arrays not implemented yet',1)
#endif
    !
END SUBROUTINE sp_d2h_memsync_r3d
!
SUBROUTINE sp_d2h_memsync_r4d(array_out, array_in, range1, range2, range3, range4 )
    !
#if defined(__CUDA)
    USE cudafor
#endif
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(6, 37)
    REAL(PRCSN), INTENT(INOUT) :: array_out(:,:,:,:)
    REAL(PRCSN), INTENT(IN)    :: array_in(:,:,:,:)
    INTEGER, INTENT(IN) ::  range1(3), range2(3), range3(3), range4(3)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_in
#endif
    !
    INTEGER :: d1_start, d1_size, d1_ld
    INTEGER :: d2_start, d2_size, d2_ld
    INTEGER :: d3_start, d3_size, d3_ld
    INTEGER :: d4_start, d4_size, d4_ld
    INTEGER :: ierr
    !
    d1_start = 1
    d1_size = range1(2) - range1(1) + 1
    d1_ld = range1(3)
    d2_start = 1
    d2_size = range2(2) - range2(1) + 1
    d2_ld = range2(3)
    d3_start = 1
    d3_size = range3(2) - range3(1) + 1
    d3_ld = range3(3)
    d4_start = 1
    d4_size = range4(2) - range4(1) + 1
    d4_ld = range4(3)
    !
#if defined(__CUDA)
    CALL dxlib_errore('cu_memsync_','4D arrays not implemented yet',1)
#else
    CALL dxlib_errore('cu_memsync_','4D arrays not implemented yet',1)
#endif
    !
END SUBROUTINE sp_d2h_memsync_r4d
!
SUBROUTINE sp_d2h_memsync_c1d(array_out, array_in, range1 )
    !
#if defined(__CUDA)
    USE cudafor
#endif
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(6, 37)
    COMPLEX(PRCSN), INTENT(INOUT) :: array_out(:)
    COMPLEX(PRCSN), INTENT(IN)    :: array_in(:)
    INTEGER, INTENT(IN) ::  range1(3)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_in
#endif
    !
    INTEGER :: d1_start, d1_size, d1_ld
    INTEGER :: ierr
    !
    d1_start = 1
    d1_size = range1(2) - range1(1) + 1
    d1_ld = range1(3)
    !
#if defined(__CUDA)
    ierr = cudaMemcpy( array_out(d1_start), array_in(d1_start), d1_size, cudaMemcpyDeviceToHost )
#else
    array_out(d1_start:d1_start+d1_size-1) = array_in(d1_start:d1_start+d1_size-1)
#endif
    !
END SUBROUTINE sp_d2h_memsync_c1d
!
SUBROUTINE sp_d2h_memsync_c2d(array_out, array_in, range1, range2 )
    !
#if defined(__CUDA)
    USE cudafor
#endif
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(6, 37)
    COMPLEX(PRCSN), INTENT(INOUT) :: array_out(:,:)
    COMPLEX(PRCSN), INTENT(IN)    :: array_in(:,:)
    INTEGER, INTENT(IN) ::  range1(3), range2(3)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_in
#endif
    !
    INTEGER :: d1_start, d1_size, d1_ld
    INTEGER :: d2_start, d2_size, d2_ld
    INTEGER :: ierr
    !
    d1_start = 1
    d1_size = range1(2) - range1(1) + 1
    d1_ld = range1(3)
    d2_start = 1
    d2_size = range2(2) - range2(1) + 1
    d2_ld = range2(3)
    !
#if defined(__CUDA)
    ierr = cudaMemcpy2D( array_out(d1_start, d2_start) , d1_ld, array_in(d1_start, d2_start), d2_ld, d1_size, d2_size )
#else

    !pinned_buffer(1:nbase, n_start:n_end) = sc_d( 1:nbase, n_start:n_end )
    !ierr = cudaMemcpy2D( pinned_buffer(1, n_start) , nvecx, sc_d( 1, n_start ), nvecx, nbase, n_end-n_start+1 )

    array_out(d1_start:d1_start+d1_size-1, d2_start:d2_start+d2_size-1) =  &
                array_in(d1_start:d1_start+d1_size-1, d2_start:d2_start+d2_size-1)
#endif
    !
END SUBROUTINE sp_d2h_memsync_c2d
!
SUBROUTINE sp_d2h_memsync_c3d(array_out, array_in, range1, range2, range3 )
    !
#if defined(__CUDA)
    USE cudafor
#endif
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(6, 37)
    COMPLEX(PRCSN), INTENT(INOUT) :: array_out(:,:,:)
    COMPLEX(PRCSN), INTENT(IN)    :: array_in(:,:,:)
    INTEGER, INTENT(IN) ::  range1(3), range2(3), range3(3)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_in
#endif
    !
    INTEGER :: d1_start, d1_size, d1_ld
    INTEGER :: d2_start, d2_size, d2_ld
    INTEGER :: d3_start, d3_size, d3_ld
    INTEGER :: ierr
    !
    d1_start = 1
    d1_size = range1(2) - range1(1) + 1
    d1_ld = range1(3)
    d2_start = 1
    d2_size = range2(2) - range2(1) + 1
    d2_ld = range2(3)
    d3_start = 1
    d3_size = range3(2) - range3(1) + 1
    d3_ld = range3(3)
    !
#if defined(__CUDA)
    CALL dxlib_errore('cu_memsync_','3D arrays not implemented yet',1)
#else
    CALL dxlib_errore('cu_memsync_','3D arrays not implemented yet',1)
#endif
    !
END SUBROUTINE sp_d2h_memsync_c3d
!
SUBROUTINE sp_d2h_memsync_c4d(array_out, array_in, range1, range2, range3, range4 )
    !
#if defined(__CUDA)
    USE cudafor
#endif
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(6, 37)
    COMPLEX(PRCSN), INTENT(INOUT) :: array_out(:,:,:,:)
    COMPLEX(PRCSN), INTENT(IN)    :: array_in(:,:,:,:)
    INTEGER, INTENT(IN) ::  range1(3), range2(3), range3(3), range4(3)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_in
#endif
    !
    INTEGER :: d1_start, d1_size, d1_ld
    INTEGER :: d2_start, d2_size, d2_ld
    INTEGER :: d3_start, d3_size, d3_ld
    INTEGER :: d4_start, d4_size, d4_ld
    INTEGER :: ierr
    !
    d1_start = 1
    d1_size = range1(2) - range1(1) + 1
    d1_ld = range1(3)
    d2_start = 1
    d2_size = range2(2) - range2(1) + 1
    d2_ld = range2(3)
    d3_start = 1
    d3_size = range3(2) - range3(1) + 1
    d3_ld = range3(3)
    d4_start = 1
    d4_size = range4(2) - range4(1) + 1
    d4_ld = range4(3)
    !
#if defined(__CUDA)
    CALL dxlib_errore('cu_memsync_','4D arrays not implemented yet',1)
#else
    CALL dxlib_errore('cu_memsync_','4D arrays not implemented yet',1)
#endif
    !
END SUBROUTINE sp_d2h_memsync_c4d
!


SUBROUTINE dp_dev_conjg_c1d(array_inout, range1 )
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(14,200)
    COMPLEX(PRCSN), INTENT(INOUT) :: array_inout(:)
    INTEGER, OPTIONAL, INTENT(IN) ::  range1(2)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_inout
#endif
    !
    INTEGER :: i1, d1s, d1e
    !
    IF (PRESENT(range1)) THEN
        d1s = 1
        d1e = range1(2) - range1(1) + 1
    ELSE
        d1s = 1
        d1e = SIZE(array_inout, 1)
    END IF
    !
    !
    !$cuf kernel do(1)
    DO i1 = d1s, d1e
        array_inout(i1 ) = &
            conjg (  array_inout (i1 ) )
    ENDDO
    !
END SUBROUTINE dp_dev_conjg_c1d
!
SUBROUTINE dp_dev_conjg_c2d(array_inout, range1, range2 )
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(14,200)
    COMPLEX(PRCSN), INTENT(INOUT) :: array_inout(:,:)
    INTEGER, OPTIONAL, INTENT(IN) ::  range1(2), range2(2)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_inout
#endif
    !
    INTEGER :: i1, d1s, d1e
    INTEGER :: i2, d2s, d2e
    !
    IF (PRESENT(range1)) THEN
        d1s = 1
        d1e = range1(2) - range1(1) + 1
    ELSE
        d1s = 1
        d1e = SIZE(array_inout, 1)
    END IF
    !
    IF (PRESENT(range2)) THEN
        d2s = 1
        d2e = range2(2) - range2(1) + 1
    ELSE
        d2s = 1
        d2e = SIZE(array_inout, 2)
    END IF
    !
    !
    !$cuf kernel do(2)
    DO i2 = d2s, d2e
    DO i1 = d1s, d1e
        array_inout(i1,i2 ) = &
            conjg (  array_inout (i1,i2 ) )
    ENDDO
    ENDDO
    !
END SUBROUTINE dp_dev_conjg_c2d
!
SUBROUTINE dp_dev_conjg_c3d(array_inout, range1, range2, range3 )
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(14,200)
    COMPLEX(PRCSN), INTENT(INOUT) :: array_inout(:,:,:)
    INTEGER, OPTIONAL, INTENT(IN) ::  range1(2), range2(2), range3(2)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_inout
#endif
    !
    INTEGER :: i1, d1s, d1e
    INTEGER :: i2, d2s, d2e
    INTEGER :: i3, d3s, d3e
    !
    IF (PRESENT(range1)) THEN
        d1s = 1
        d1e = range1(2) - range1(1) + 1
    ELSE
        d1s = 1
        d1e = SIZE(array_inout, 1)
    END IF
    !
    IF (PRESENT(range2)) THEN
        d2s = 1
        d2e = range2(2) - range2(1) + 1
    ELSE
        d2s = 1
        d2e = SIZE(array_inout, 2)
    END IF
    !
    IF (PRESENT(range3)) THEN
        d3s = 1
        d3e = range3(2) - range3(1) + 1
    ELSE
        d3s = 1
        d3e = SIZE(array_inout, 3)
    END IF
    !
    !
    !$cuf kernel do(3)
    DO i3 = d3s, d3e
    DO i2 = d2s, d2e
    DO i1 = d1s, d1e
        array_inout(i1,i2,i3 ) = &
            conjg (  array_inout (i1,i2,i3 ) )
    ENDDO
    ENDDO
    ENDDO
    !
END SUBROUTINE dp_dev_conjg_c3d
!
SUBROUTINE dp_dev_conjg_c4d(array_inout, range1, range2, range3, range4 )
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(14,200)
    COMPLEX(PRCSN), INTENT(INOUT) :: array_inout(:,:,:,:)
    INTEGER, OPTIONAL, INTENT(IN) ::  range1(2), range2(2), range3(2), range4(2)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_inout
#endif
    !
    INTEGER :: i1, d1s, d1e
    INTEGER :: i2, d2s, d2e
    INTEGER :: i3, d3s, d3e
    INTEGER :: i4, d4s, d4e
    !
    IF (PRESENT(range1)) THEN
        d1s = 1
        d1e = range1(2) - range1(1) + 1
    ELSE
        d1s = 1
        d1e = SIZE(array_inout, 1)
    END IF
    !
    IF (PRESENT(range2)) THEN
        d2s = 1
        d2e = range2(2) - range2(1) + 1
    ELSE
        d2s = 1
        d2e = SIZE(array_inout, 2)
    END IF
    !
    IF (PRESENT(range3)) THEN
        d3s = 1
        d3e = range3(2) - range3(1) + 1
    ELSE
        d3s = 1
        d3e = SIZE(array_inout, 3)
    END IF
    !
    IF (PRESENT(range4)) THEN
        d4s = 1
        d4e = range4(2) - range4(1) + 1
    ELSE
        d4s = 1
        d4e = SIZE(array_inout, 4)
    END IF
    !
    !
    !$cuf kernel do(4)
    DO i4 = d4s, d4e
    DO i3 = d3s, d3e
    DO i2 = d2s, d2e
    DO i1 = d1s, d1e
        array_inout(i1,i2,i3,i4 ) = &
            conjg (  array_inout (i1,i2,i3,i4 ) )
    ENDDO
    ENDDO
    ENDDO
    ENDDO
    !
END SUBROUTINE dp_dev_conjg_c4d
!
SUBROUTINE sp_dev_conjg_c1d(array_inout, range1 )
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(6, 37)
    COMPLEX(PRCSN), INTENT(INOUT) :: array_inout(:)
    INTEGER, OPTIONAL, INTENT(IN) ::  range1(2)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_inout
#endif
    !
    INTEGER :: i1, d1s, d1e
    !
    IF (PRESENT(range1)) THEN
        d1s = 1
        d1e = range1(2) - range1(1) + 1
    ELSE
        d1s = 1
        d1e = SIZE(array_inout, 1)
    END IF
    !
    !
    !$cuf kernel do(1)
    DO i1 = d1s, d1e
        array_inout(i1 ) = &
            conjg (  array_inout (i1 ) )
    ENDDO
    !
END SUBROUTINE sp_dev_conjg_c1d
!
SUBROUTINE sp_dev_conjg_c2d(array_inout, range1, range2 )
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(6, 37)
    COMPLEX(PRCSN), INTENT(INOUT) :: array_inout(:,:)
    INTEGER, OPTIONAL, INTENT(IN) ::  range1(2), range2(2)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_inout
#endif
    !
    INTEGER :: i1, d1s, d1e
    INTEGER :: i2, d2s, d2e
    !
    IF (PRESENT(range1)) THEN
        d1s = 1
        d1e = range1(2) - range1(1) + 1
    ELSE
        d1s = 1
        d1e = SIZE(array_inout, 1)
    END IF
    !
    IF (PRESENT(range2)) THEN
        d2s = 1
        d2e = range2(2) - range2(1) + 1
    ELSE
        d2s = 1
        d2e = SIZE(array_inout, 2)
    END IF
    !
    !
    !$cuf kernel do(2)
    DO i2 = d2s, d2e
    DO i1 = d1s, d1e
        array_inout(i1,i2 ) = &
            conjg (  array_inout (i1,i2 ) )
    ENDDO
    ENDDO
    !
END SUBROUTINE sp_dev_conjg_c2d
!
SUBROUTINE sp_dev_conjg_c3d(array_inout, range1, range2, range3 )
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(6, 37)
    COMPLEX(PRCSN), INTENT(INOUT) :: array_inout(:,:,:)
    INTEGER, OPTIONAL, INTENT(IN) ::  range1(2), range2(2), range3(2)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_inout
#endif
    !
    INTEGER :: i1, d1s, d1e
    INTEGER :: i2, d2s, d2e
    INTEGER :: i3, d3s, d3e
    !
    IF (PRESENT(range1)) THEN
        d1s = 1
        d1e = range1(2) - range1(1) + 1
    ELSE
        d1s = 1
        d1e = SIZE(array_inout, 1)
    END IF
    !
    IF (PRESENT(range2)) THEN
        d2s = 1
        d2e = range2(2) - range2(1) + 1
    ELSE
        d2s = 1
        d2e = SIZE(array_inout, 2)
    END IF
    !
    IF (PRESENT(range3)) THEN
        d3s = 1
        d3e = range3(2) - range3(1) + 1
    ELSE
        d3s = 1
        d3e = SIZE(array_inout, 3)
    END IF
    !
    !
    !$cuf kernel do(3)
    DO i3 = d3s, d3e
    DO i2 = d2s, d2e
    DO i1 = d1s, d1e
        array_inout(i1,i2,i3 ) = &
            conjg (  array_inout (i1,i2,i3 ) )
    ENDDO
    ENDDO
    ENDDO
    !
END SUBROUTINE sp_dev_conjg_c3d
!
SUBROUTINE sp_dev_conjg_c4d(array_inout, range1, range2, range3, range4 )
    !
    IMPLICIT NONE
    !
    INTEGER, PARAMETER :: PRCSN = selected_real_kind(6, 37)
    COMPLEX(PRCSN), INTENT(INOUT) :: array_inout(:,:,:,:)
    INTEGER, OPTIONAL, INTENT(IN) ::  range1(2), range2(2), range3(2), range4(2)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_inout
#endif
    !
    INTEGER :: i1, d1s, d1e
    INTEGER :: i2, d2s, d2e
    INTEGER :: i3, d3s, d3e
    INTEGER :: i4, d4s, d4e
    !
    IF (PRESENT(range1)) THEN
        d1s = 1
        d1e = range1(2) - range1(1) + 1
    ELSE
        d1s = 1
        d1e = SIZE(array_inout, 1)
    END IF
    !
    IF (PRESENT(range2)) THEN
        d2s = 1
        d2e = range2(2) - range2(1) + 1
    ELSE
        d2s = 1
        d2e = SIZE(array_inout, 2)
    END IF
    !
    IF (PRESENT(range3)) THEN
        d3s = 1
        d3e = range3(2) - range3(1) + 1
    ELSE
        d3s = 1
        d3e = SIZE(array_inout, 3)
    END IF
    !
    IF (PRESENT(range4)) THEN
        d4s = 1
        d4e = range4(2) - range4(1) + 1
    ELSE
        d4s = 1
        d4e = SIZE(array_inout, 4)
    END IF
    !
    !
    !$cuf kernel do(4)
    DO i4 = d4s, d4e
    DO i3 = d3s, d3e
    DO i2 = d2s, d2e
    DO i1 = d1s, d1e
        array_inout(i1,i2,i3,i4 ) = &
            conjg (  array_inout (i1,i2,i3,i4 ) )
    ENDDO
    ENDDO
    ENDDO
    ENDDO
    !
END SUBROUTINE sp_dev_conjg_c4d
!


SUBROUTINE dxlib_errore( calling_routine, message, ierr )
    IMPLICIT NONE
    CHARACTER(LEN=*), INTENT(IN) :: calling_routine, message
    ! the name of the calling calling_routine
    ! the output message
    INTEGER,          INTENT(IN) :: ierr
    !
    PRINT *, calling_routine, message
    !
END SUBROUTINE dxlib_errore

module cuda_unknowns
  use, intrinsic :: ISO_C_BINDING

  type, bind(C) :: cudaStream_t
     type (c_ptr) :: stream
   end type cudaStream_t

   type, bind(C) :: cudaEvent_t
      type (c_ptr) :: event
   end type cudaEvent_t

   type, bind(C) :: cudaArray_t
      type (c_ptr) :: array
   end type cudaArray_t

   type, bind(C) :: cudaContext_t
      type (c_ptr) :: context
   end type cudaContext_t

   type, bind(C) :: cudaModule_t
      type (c_ptr) :: mod
   end type cudaModule_t

   type, bind(C) :: cudaFunction_t
      type (c_ptr) :: func
   end type cudaFunction_t

   type, bind(C) :: cudaSurfRef_t
      type (c_ptr) :: surf_ref
   end type cudaSurfRef_t
   
   type, bind(C) :: cudaTexRef_t
      type (c_ptr) :: tex_ref
   end type cudaTexRef_t

   type, bind(C) :: cudaGraphicsResource_t
      type (c_ptr) :: graphics_resource
   end type cudaGraphicsResource_t

end module cuda_unknowns

!!  Fortran CUDA Library interface -- CUBLAS (Legacy) module
!!
!!  Copyright (C) 2017-2018 Mentor, A Siemens Business
!!
!!  This software is provided 'as-is', without any express or implied
!!  warranty.  In no event will the authors be held liable for any damages
!!  arising from the use of this software.
!!
!!  Permission is granted to anyone to use this software for any purpose,
!!  including commercial applications, and to alter it and redistribute it
!!  freely, subject to the following restrictions:
!!
!!  1. The origin of this software must not be misrepresented; you must not
!!     claim that you wrote the original software. If you use this software
!!     in a product, an acknowledgment in the product documentation would be
!!     appreciated but is not required.
!!  2. Altered source versions must be plainly marked as such, and must not be
!!     misrepresented as being the original software.
!!  3. This notice may not be removed or altered from any source distribution.

module cublas_m
  use iso_c_binding

#if defined __DXL_CUBLAS

  enum, bind(c)
     enumerator :: CUBLAS_STATUS_SUCCESS          = 0
     enumerator :: CUBLAS_STATUS_NOT_INITIALIZED  = 1
     enumerator :: CUBLAS_STATUS_ALLOC_FAILED     = 3
     enumerator :: CUBLAS_STATUS_INVALID_VALUE    = 7
     enumerator :: CUBLAS_STATUS_ARCH_MISMATCH    = 8
     enumerator :: CUBLAS_STATUS_MAPPING_ERROR    = 11
     enumerator :: CUBLAS_STATUS_EXECUTION_FAILED = 13
     enumerator :: CUBLAS_STATUS_INTERNAL_ERROR   = 14
     enumerator :: CUBLAS_STATUS_NOT_SUPPORTED    = 15
     enumerator :: CUBLAS_STATUS_LICENSE_ERROR    = 16
  end enum

  interface
    integer(c_int) function cublasInit () &
        bind (c, name="cublasInit")
      import
    end function cublasInit

    integer(c_int) function cublasShutdown () &
        bind (c, name="cublasShutdown")
      import
    end function cublasShutdown

    integer(c_int) function cublasGetError () &
        bind (c, name="cublasGetError")
      import
    end function cublasGetError

!    integer(c_int) function cublasGetVersion (version) &
!        bind (c, name="cublasGetVersion")
!      import
!      integer(c_int) :: version
!    end function cublasGetVersion

    integer(c_int) function cublasSetKernelStream (stream) &
        bind (c, name="cublasSetKernelStream")
      import
      integer(c_intptr_t), value :: stream
    end function cublasSetKernelStream

    real(c_float) function cublasSnrm2 (n, x, incx) &
        bind (c, name="cublasSnrm2")
      import
      integer(c_int), value :: n, incx
      real(c_float), dimension(*) :: x
    end function cublasSnrm2

    real(c_double) function cublasDnrm2 (n, x, incx) &
        bind (c, name="cublasDnrm2")
      import
      real(c_double), dimension(*) :: x
      integer(c_int), value :: n, incx
    end function cublasDnrm2

    real(c_float) function cublasScnrm2 (n, x, incx) &
        bind (c, name="cublasScnrm2")
      import
      complex(c_float), dimension(*) :: x
      integer(c_int), value :: n, incx
    end function cublasScnrm2

    real(c_double) function cublasDznrm2 (n, x, incx) &
        bind (c, name="cublasDznrm2")
      import
      integer(c_int), value :: n, incx
      complex(c_double), dimension(*) :: x
    end function cublasDznrm2

    real(c_float) function cublasSdot (n, x, incx, y, incy) &
        bind (c, name="cublasSdot")
      import
      integer(c_int), value :: n, incx, incy
      real(c_float), dimension(*) :: x, y
    end function cublasSdot

    real(c_double) function cublasDdot (n, x, incx, y, incy) &
        bind (c, name="cublasDdot")
      import
      real(c_double), dimension(*) :: x, y
      integer(c_int), value :: n, incx, incy
    end function cublasDdot

    complex(c_float) function cublasCdotu (n, x, incx, y, incy) &
        bind (c, name="cublasCdotu")
      import
      complex(c_float), dimension(*) :: x, y
      integer(c_int), value :: n, incx, incy
    end function cublasCdotu

    complex(c_double) function cublasZdotu (n, x, incx, y, incy) &
        bind (c, name="cublasZdotu")
      import
      integer(c_int), value :: n, incx, incy
      complex(c_double), dimension(*) :: x, y
    end function cublasZdotu

    complex(c_float) function cublasCdotc (n, x, incx, y, incy) &
        bind (c, name="cublasCdotc")
      import
      complex(c_float), dimension(*) :: x, y
      integer(c_int), value :: n, incx, incy
    end function cublasCdotc

    complex(c_double) function cublasZdotc (n, x, incx, y, incy) &
        bind (c, name="cublasZdotc")
      import
      integer(c_int), value :: n, incx, incy
      complex(c_double), dimension(*) :: x, y
    end function cublasZdotc

    subroutine cublasSscal (n, alpha, x, incx) &
        bind (c, name="cublasSscal")
      import
      integer(c_int), value :: n, incx
      real(c_float), value :: alpha
      real(c_float), dimension(*) :: x
    end subroutine cublasSscal

    subroutine cublasDscal (n, alpha, x, incx) &
        bind (c, name="cublasDscal")
      import
      real(c_double), dimension(*) :: x
      integer(c_int), value :: n, incx
      real(c_double), value :: alpha
    end subroutine cublasDscal

    subroutine cublasCscal (n, alpha, x, incx) &
        bind (c, name="cublasCscal")
      import
      complex(c_float), dimension(*) :: x
      integer(c_int), value :: n, incx
      complex(c_float), value :: alpha
    end subroutine cublasCscal

    subroutine cublasZscal (n, alpha, x, incx) &
        bind (c, name="cublasZscal")
      import
      complex(c_double), value :: alpha
      integer(c_int), value :: n, incx
      complex(c_double), dimension(*) :: x
    end subroutine cublasZscal

    subroutine cublasCsscal (n, alpha, x, incx) &
        bind (c, name="cublasCsscal")
      import
      complex(c_float), dimension(*) :: x
      integer(c_int), value :: n, incx
      real(c_float), value :: alpha
    end subroutine cublasCsscal

    subroutine cublasZdscal (n, alpha, x, incx) &
        bind (c, name="cublasZdscal")
      import
      integer(c_int), value :: n, incx
      real(c_double), value :: alpha
      complex(c_double), dimension(*) :: x
    end subroutine cublasZdscal

    subroutine cublasSaxpy (n, alpha, x, incx, y, incy) &
        bind (c, name="cublasSaxpy")
      import
      integer(c_int), value :: n, incx, incy
      real(c_float), value :: alpha
      real(c_float), dimension(*) :: x, y
    end subroutine cublasSaxpy

    subroutine cublasDaxpy (n, alpha, x, incx, y, incy) &
        bind (c, name="cublasDaxpy")
      import
      real(c_double), dimension(*) :: x, y
      integer(c_int), value :: n, incx, incy
      real(c_double), value :: alpha
    end subroutine cublasDaxpy

    subroutine cublasCaxpy (n, alpha, x, incx, y, incy) &
        bind (c, name="cublasCaxpy")
      import
      complex(c_float), dimension(*) :: x, y
      integer(c_int), value :: n, incx, incy
      complex(c_float), value :: alpha
    end subroutine cublasCaxpy

    subroutine cublasZaxpy (n, alpha, x, incx, y, incy) &
        bind (c, name="cublasZaxpy")
      import
      complex(c_double), value :: alpha
      integer(c_int), value :: n, incx, incy
      complex(c_double), dimension(*) :: x, y
    end subroutine cublasZaxpy

    subroutine cublasScopy (n, x, incx, y, incy) &
        bind (c, name="cublasScopy")
      import
      integer(c_int), value :: n, incx, incy
      real(c_float), dimension(*) :: x, y
    end subroutine cublasScopy

    subroutine cublasDcopy (n, x, incx, y, incy) &
        bind (c, name="cublasDcopy")
      import
      real(c_double), dimension(*) :: x, y
      integer(c_int), value :: n, incx, incy
    end subroutine cublasDcopy

    subroutine cublasCcopy (n, x, incx, y, incy) &
        bind (c, name="cublasCcopy")
      import
      complex(c_float), dimension(*) :: x, y
      integer(c_int), value :: n, incx, incy
    end subroutine cublasCcopy

    subroutine cublasZcopy (n, x, incx, y, incy) &
        bind (c, name="cublasZcopy")
      import
      integer(c_int), value :: n, incx, incy
      complex(c_double), dimension(*) :: x, y
    end subroutine cublasZcopy

    subroutine cublasSswap (n, x, incx, y, incy) &
        bind (c, name="cublasSswap")
      import
      integer(c_int), value :: n, incx, incy
      real(c_float), dimension(*) :: x, y
    end subroutine cublasSswap

    subroutine cublasDswap (n, x, incx, y, incy) &
        bind (c, name="cublasDswap")
      import
      real(c_double), dimension(*) :: x, y
      integer(c_int), value :: n, incx, incy
    end subroutine cublasDswap

    subroutine cublasCswap (n, x, incx, y, incy) &
        bind (c, name="cublasCswap")
      import
      complex(c_float), dimension(*) :: x, y
      integer(c_int), value :: n, incx, incy
    end subroutine cublasCswap

    subroutine cublasZswap (n, x, incx, y, incy) &
        bind (c, name="cublasZswap")
      import
      integer(c_int), value :: n, incx, incy
      complex(c_double), dimension(*) :: x, y
    end subroutine cublasZswap

    integer(c_int) function cublasIsamax (n, x, incx) &
        bind (c, name="cublasIsamax")
      import
      integer(c_int), value :: n, incx
      real(c_float), dimension(*) :: x
    end function cublasIsamax

    integer(c_int) function cublasIdamax (n, x, incx) &
        bind (c, name="cublasIdamax")
      import
      real(c_double), dimension(*) :: x
      integer(c_int), value :: n, incx
    end function cublasIdamax

    integer(c_int) function cublasIcamax (n, x, incx) &
        bind (c, name="cublasIcamax")
      import
      complex(c_float), dimension(*) :: x
      integer(c_int), value :: n, incx
    end function cublasIcamax

    integer(c_int) function cublasIzamax (n, x, incx) &
        bind (c, name="cublasIzamax")
      import
      integer(c_int), value :: n, incx
      complex(c_double), dimension(*) :: x
    end function cublasIzamax

    integer(c_int) function cublasIsamin (n, x, incx) &
        bind (c, name="cublasIsamin")
      import
      integer(c_int), value :: n, incx
      real(c_float), dimension(*) :: x
    end function cublasIsamin

    integer(c_int) function cublasIdamin (n, x, incx) &
        bind (c, name="cublasIdamin")
      import
      real(c_double), dimension(*) :: x
      integer(c_int), value :: n, incx
    end function cublasIdamin

    integer(c_int) function cublasIcamin (n, x, incx) &
        bind (c, name="cublasIcamin")
      import
      complex(c_float), dimension(*) :: x
      integer(c_int), value :: n, incx
    end function cublasIcamin

    integer(c_int) function cublasIzamin (n, x, incx) &
        bind (c, name="cublasIzamin")
      import
      integer(c_int), value :: n, incx
      complex(c_double), dimension(*) :: x
    end function cublasIzamin

    real(c_float) function cublasSasum (n, x, incx) &
        bind (c, name="cublasSasum")
      import
      integer(c_int), value :: n, incx
      real(c_float), dimension(*) :: x
    end function cublasSasum

    real(c_double) function cublasDasum (n, x, incx) &
        bind (c, name="cublasDasum")
      import
      real(c_double), dimension(*) :: x
      integer(c_int), value :: n, incx
    end function cublasDasum

    real(c_float) function cublasScasum (n, x, incx) &
        bind (c, name="cublasScasum")
      import
      complex(c_float), dimension(*) :: x
      integer(c_int), value :: n, incx
    end function cublasScasum

    real(c_double) function cublasDzasum (n, x, incx) &
        bind (c, name="cublasDzasum")
      import
      integer(c_int), value :: n, incx
      complex(c_double), dimension(*) :: x
    end function cublasDzasum

    subroutine cublasSrot (n, x, incx, y, incy, sc, ss) &
        bind (c, name="cublasSrot")
      import
      integer(c_int), value :: n, incx, incy
      real(c_float), value :: sc, ss
      real(c_float), dimension(*) :: x, y
    end subroutine cublasSrot

    subroutine cublasDrot (n, x, incx, y, incy, sc, ss) &
        bind (c, name="cublasDrot")
      import
      real(c_double), dimension(*) :: x, y
      integer(c_int), value :: n, incx, incy
      real(c_double), value :: sc, ss
    end subroutine cublasDrot

    subroutine cublasCrot (n, x, incx, y, incy, sc, ss) &
        bind (c, name="cublasCrot")
      import
      complex(c_float), dimension(*) :: x, y
      integer(c_int), value :: n, incx, incy
      complex(c_float), value :: sc, ss
    end subroutine cublasCrot

    subroutine cublasZrot (n, x, incx, y, incy, sc, ss) &
        bind (c, name="cublasZrot")
      import
      complex(c_double), value :: sc, ss
      integer(c_int), value :: n, incx, incy
      complex(c_double), dimension(*) :: x, y
    end subroutine cublasZrot

    subroutine cublasCsrot (n, x, incx, y, incy, c, s) &
        bind (c, name="cublasCsrot")
      import
      complex(c_float), dimension(*) :: x, y
      integer(c_int), value :: n, incx, incy
      real(c_float), value :: c, s
    end subroutine cublasCsrot

    subroutine cublasZdrot (n, x, incx, y, incy, c, s) &
        bind (c, name="cublasZdrot")
      import
      integer(c_int), value :: n, incx, incy
      real(c_double), value :: c, s
      complex(c_double), dimension(*) :: x, y
    end subroutine cublasZdrot

    subroutine cublasSrotg (sa, sb, sc, ss) &
        bind (c, name="cublasSrotg")
      import
      real(c_float) :: sa, sb, sc, ss
    end subroutine cublasSrotg

    subroutine cublasDrotg (sa, sb, sc, ss) &
        bind (c, name="cublasDrotg")
      import
      real(c_double) :: sa, sb, sc, ss
    end subroutine cublasDrotg

    subroutine cublasCrotg (sa, sb, sc, ss) &
        bind (c, name="cublasCrotg")
      import
      complex(c_float) :: sa, sb, sc, ss
    end subroutine cublasCrotg

    subroutine cublasZrotg (sa, sb, sc, ss) &
        bind (c, name="cublasZrotg")
      import
      complex(c_double) :: sa, sb, sc, ss
    end subroutine cublasZrotg

    subroutine cublasSrotm (n, x, incx, y, incy, param) &
        bind (c, name="cublasSrotm")
      import
      integer(c_int), value :: n, incx, incy
      real(c_float), dimension(*) :: x, y, param
    end subroutine cublasSrotm

    subroutine cublasDrotm (n, x, incx, y, incy, param) &
        bind (c, name="cublasDrotm")
      import
      real(c_double), dimension(*) :: x, y, param
      integer(c_int), value :: n, incx, incy
    end subroutine cublasDrotm

    subroutine cublasSrotmg (d1, d2, x1, y1, param) &
        bind (c, name="cublasSrotmg")
      import
      real(c_float) :: d1, d2, x1, y1
      real(c_float), dimension(*) :: param
    end subroutine cublasSrotmg

    subroutine cublasDrotmg (d1, d2, x1, y1, param) &
        bind (c, name="cublasDrotmg")
      import
      real(c_double), dimension(*) :: param
      real(c_double) :: d1, d2, x1, y1
    end subroutine cublasDrotmg

    subroutine cublasSgemv (trans, m, n, alpha, A, lda, x, incx, beta, y, incy) &
        bind (c, name="cublasSgemv")
      import
      integer(c_int), value :: m, n, lda, incx, incy
      real(c_float), dimension(*) :: x, y
      real(c_float), value :: alpha, beta
      character(c_char), value :: trans
      real(c_float), dimension(lda, *) :: A
    end subroutine cublasSgemv

    subroutine cublasDgemv (trans, m, n, alpha, A, lda, x, incx, beta, y, incy) &
        bind (c, name="cublasDgemv")
      import
      integer(c_int), value :: m, n, lda, incx, incy
      real(c_double), dimension(lda, *) :: A
      real(c_double), value :: alpha, beta
      character(c_char), value :: trans
      real(c_double), dimension(*) :: x, y
    end subroutine cublasDgemv

    subroutine cublasCgemv (trans, m, n, alpha, A, lda, x, incx, beta, y, incy) &
        bind (c, name="cublasCgemv")
      import
      integer(c_int), value :: m, n, lda, incx, incy
      complex(c_float), dimension(*) :: x, y
      character(c_char), value :: trans
      complex(c_float), dimension(lda, *) :: A
      complex(c_float), value :: alpha, beta
    end subroutine cublasCgemv

    subroutine cublasZgemv (trans, m, n, alpha, A, lda, x, incx, beta, y, incy) &
        bind (c, name="cublasZgemv")
      import
      integer(c_int), value :: m, n, lda, incx, incy
      complex(c_double), dimension(*) :: x, y
      complex(c_double), value :: alpha, beta
      complex(c_double), dimension(lda, *) :: A
      character(c_char), value :: trans
    end subroutine cublasZgemv

    subroutine cublasSgbmv &
        (trans, m, n, kl, ku, alpha, A, lda, x, incx, beta, y, incy) &
        bind (c, name="cublasSgbmv")
      import
      integer(c_int), value :: m, n, kl, ku, lda, incx, incy
      real(c_float), dimension(*) :: x, y
      real(c_float), value :: alpha, beta
      character(c_char), value :: trans
      real(c_float), dimension(lda, *) :: A
    end subroutine cublasSgbmv

    subroutine cublasDgbmv &
        (trans, m, n, kl, ku, alpha, A, lda, x, incx, beta, y, incy) &
        bind (c, name="cublasDgbmv")
      import
      integer(c_int), value :: m, n, kl, ku, lda, incx, incy
      real(c_double), dimension(lda, *) :: A
      real(c_double), value :: alpha, beta
      character(c_char), value :: trans
      real(c_double), dimension(*) :: x, y
    end subroutine cublasDgbmv

    subroutine cublasCgbmv &
        (trans, m, n, kl, ku, alpha, A, lda, x, incx, beta, y, incy) &
        bind (c, name="cublasCgbmv")
      import
      integer(c_int), value :: m, n, kl, ku, lda, incx, incy
      complex(c_float), dimension(*) :: x, y
      character(c_char), value :: trans
      complex(c_float), dimension(lda, *) :: A
      complex(c_float), value :: alpha, beta
    end subroutine cublasCgbmv

    subroutine cublasZgbmv &
        (trans, m, n, kl, ku, alpha, A, lda, x, incx, beta, y, incy) &
        bind (c, name="cublasZgbmv")
      import
      integer(c_int), value :: m, n, kl, ku, lda, incx, incy
      complex(c_double), dimension(*) :: x, y
      complex(c_double), value :: alpha, beta
      complex(c_double), dimension(lda, *) :: A
      character(c_char), value :: trans
    end subroutine cublasZgbmv

    subroutine cublasStrmv (uplo, trans, diag, n, A, lda, x, incx) &
        bind (c, name="cublasStrmv")
      import
      integer(c_int), value :: n, lda, incx
      real(c_float), dimension(*) :: x
      character(c_char), value :: uplo, trans, diag
      real(c_float), dimension(lda, *) :: A
    end subroutine cublasStrmv

    subroutine cublasDtrmv (uplo, trans, diag, n, A, lda, x, incx) &
        bind (c, name="cublasDtrmv")
      import
      integer(c_int), value :: n, lda, incx
      real(c_double), dimension(lda, *) :: A
      character(c_char), value :: uplo, trans, diag
      real(c_double), dimension(*) :: x
    end subroutine cublasDtrmv

    subroutine cublasCtrmv (uplo, trans, diag, n, A, lda, x, incx) &
        bind (c, name="cublasCtrmv")
      import
      integer(c_int), value :: n, lda, incx
      complex(c_float), dimension(*) :: x
      character(c_char), value :: uplo, trans, diag
      complex(c_float), dimension(lda, *) :: A
    end subroutine cublasCtrmv

    subroutine cublasZtrmv (uplo, trans, diag, n, A, lda, x, incx) &
        bind (c, name="cublasZtrmv")
      import
      integer(c_int), value :: n, lda, incx
      complex(c_double), dimension(*) :: x
      complex(c_double), dimension(lda, *) :: A
      character(c_char), value :: uplo, trans, diag
    end subroutine cublasZtrmv

    subroutine cublasStbmv (uplo, trans, diag, n, k, A, lda, x, incx) &
        bind (c, name="cublasStbmv")
      import
      integer(c_int), value :: n, k, lda, incx
      real(c_float), dimension(*) :: x
      character(c_char), value :: uplo, trans, diag
      real(c_float), dimension(lda, *) :: A
    end subroutine cublasStbmv

    subroutine cublasDtbmv (uplo, trans, diag, n, k, A, lda, x, incx) &
        bind (c, name="cublasDtbmv")
      import
      integer(c_int), value :: n, k, lda, incx
      real(c_double), dimension(lda, *) :: A
      character(c_char), value :: uplo, trans, diag
      real(c_double), dimension(*) :: x
    end subroutine cublasDtbmv

    subroutine cublasCtbmv (uplo, trans, diag, n, k, A, lda, x, incx) &
        bind (c, name="cublasCtbmv")
      import
      integer(c_int), value :: n, k, lda, incx
      complex(c_float), dimension(*) :: x
      character(c_char), value :: uplo, trans, diag
      complex(c_float), dimension(lda, *) :: A
    end subroutine cublasCtbmv

    subroutine cublasZtbmv (uplo, trans, diag, n, k, A, lda, x, incx) &
        bind (c, name="cublasZtbmv")
      import
      integer(c_int), value :: n, k, lda, incx
      complex(c_double), dimension(*) :: x
      complex(c_double), dimension(lda, *) :: A
      character(c_char), value :: uplo, trans, diag
    end subroutine cublasZtbmv

    subroutine cublasStpmv (uplo, trans, diag, n, AP, x, incx) &
        bind (c, name="cublasStpmv")
      import
      integer(c_int), value :: n, incx
      character(c_char), value :: uplo, trans, diag
      real(c_float), dimension(*) :: AP, x
    end subroutine cublasStpmv

    subroutine cublasDtpmv (uplo, trans, diag, n, AP, x, incx) &
        bind (c, name="cublasDtpmv")
      import
      real(c_double), dimension(*) :: AP, x
      integer(c_int), value :: n, incx
      character(c_char), value :: uplo, trans, diag
    end subroutine cublasDtpmv

    subroutine cublasCtpmv (uplo, trans, diag, n, AP, x, incx) &
        bind (c, name="cublasCtpmv")
      import
      complex(c_float), dimension(*) :: AP, x
      integer(c_int), value :: n, incx
      character(c_char), value :: uplo, trans, diag
    end subroutine cublasCtpmv

    subroutine cublasZtpmv (uplo, trans, diag, n, AP, x, incx) &
        bind (c, name="cublasZtpmv")
      import
      integer(c_int), value :: n, incx
      complex(c_double), dimension(*) :: AP, x
      character(c_char), value :: uplo, trans, diag
    end subroutine cublasZtpmv

    subroutine cublasStrsv (uplo, trans, diag, n, A, lda, x, incx) &
        bind (c, name="cublasStrsv")
      import
      integer(c_int), value :: n, lda, incx
      real(c_float), dimension(*) :: x
      character(c_char), value :: uplo, trans, diag
      real(c_float), dimension(lda, *) :: A
    end subroutine cublasStrsv

    subroutine cublasDtrsv (uplo, trans, diag, n, A, lda, x, incx) &
        bind (c, name="cublasDtrsv")
      import
      integer(c_int), value :: n, lda, incx
      real(c_double), dimension(lda, *) :: A
      character(c_char), value :: uplo, trans, diag
      real(c_double), dimension(*) :: x
    end subroutine cublasDtrsv

    subroutine cublasCtrsv (uplo, trans, diag, n, A, lda, x, incx) &
        bind (c, name="cublasCtrsv")
      import
      integer(c_int), value :: n, lda, incx
      complex(c_float), dimension(*) :: x
      character(c_char), value :: uplo, trans, diag
      complex(c_float), dimension(lda, *) :: A
    end subroutine cublasCtrsv

    subroutine cublasZtrsv (uplo, trans, diag, n, A, lda, x, incx) &
        bind (c, name="cublasZtrsv")
      import
      integer(c_int), value :: n, lda, incx
      complex(c_double), dimension(*) :: x
      complex(c_double), dimension(lda, *) :: A
      character(c_char), value :: uplo, trans, diag
    end subroutine cublasZtrsv

    subroutine cublasStpsv (uplo, trans, diag, n, AP, x, incx) &
        bind (c, name="cublasStpsv")
      import
      integer(c_int), value :: n, incx
      character(c_char), value :: uplo, trans, diag
      real(c_float), dimension(*) :: AP, x
    end subroutine cublasStpsv

    subroutine cublasDtpsv (uplo, trans, diag, n, AP, x, incx) &
        bind (c, name="cublasDtpsv")
      import
      real(c_double), dimension(*) :: AP, x
      integer(c_int), value :: n, incx
      character(c_char), value :: uplo, trans, diag
    end subroutine cublasDtpsv

    subroutine cublasCtpsv (uplo, trans, diag, n, AP, x, incx) &
        bind (c, name="cublasCtpsv")
      import
      complex(c_float), dimension(*) :: AP, x
      integer(c_int), value :: n, incx
      character(c_char), value :: uplo, trans, diag
    end subroutine cublasCtpsv

    subroutine cublasZtpsv (uplo, trans, diag, n, AP, x, incx) &
        bind (c, name="cublasZtpsv")
      import
      integer(c_int), value :: n, incx
      complex(c_double), dimension(*) :: AP, x
      character(c_char), value :: uplo, trans, diag
    end subroutine cublasZtpsv

    subroutine cublasStbsv (uplo, trans, diag, n, k, A, lda, x, incx) &
        bind (c, name="cublasStbsv")
      import
      integer(c_int), value :: n, k, lda, incx
      real(c_float), dimension(*) :: x
      character(c_char), value :: uplo, trans, diag
      real(c_float), dimension(lda, *) :: A
    end subroutine cublasStbsv

    subroutine cublasDtbsv (uplo, trans, diag, n, k, A, lda, x, incx) &
        bind (c, name="cublasDtbsv")
      import
      integer(c_int), value :: n, k, lda, incx
      real(c_double), dimension(lda, *) :: A
      character(c_char), value :: uplo, trans, diag
      real(c_double), dimension(*) :: x
    end subroutine cublasDtbsv

    subroutine cublasCtbsv (uplo, trans, diag, n, k, A, lda, x, incx) &
        bind (c, name="cublasCtbsv")
      import
      integer(c_int), value :: n, k, lda, incx
      complex(c_float), dimension(*) :: x
      character(c_char), value :: uplo, trans, diag
      complex(c_float), dimension(lda, *) :: A
    end subroutine cublasCtbsv

    subroutine cublasZtbsv (uplo, trans, diag, n, k, A, lda, x, incx) &
        bind (c, name="cublasZtbsv")
      import
      integer(c_int), value :: n, k, lda, incx
      complex(c_double), dimension(*) :: x
      complex(c_double), dimension(lda, *) :: A
      character(c_char), value :: uplo, trans, diag
    end subroutine cublasZtbsv

    subroutine cublasSsymv (uplo, n, alpha, A, lda, x, incx, beta, y, incy) &
        bind (c, name="cublasSsymv")
      import
      integer(c_int), value :: n, lda, incx, incy
      real(c_float), dimension(*) :: x, y
      real(c_float), value :: alpha, beta
      character(c_char), value :: uplo
      real(c_float), dimension(lda, *) :: A
    end subroutine cublasSsymv

    subroutine cublasDsymv (uplo, n, alpha, A, lda, x, incx, beta, y, incy) &
        bind (c, name="cublasDsymv")
      import
      integer(c_int), value :: n, lda, incx, incy
      real(c_double), dimension(lda, *) :: A
      real(c_double), value :: alpha, beta
      character(c_char), value :: uplo
      real(c_double), dimension(*) :: x, y
    end subroutine cublasDsymv

    subroutine cublasChemv (uplo, n, alpha, A, lda, x, incx, beta, y, incy) &
        bind (c, name="cublasChemv")
      import
      integer(c_int), value :: n, lda, incx, incy
      complex(c_float), dimension(*) :: x, y
      character(c_char), value :: uplo
      complex(c_float), dimension(lda, *) :: A
      complex(c_float), value :: alpha, beta
    end subroutine cublasChemv

    subroutine cublasZhemv (uplo, n, alpha, A, lda, x, incx, beta, y, incy) &
        bind (c, name="cublasZhemv")
      import
      integer(c_int), value :: n, lda, incx, incy
      complex(c_double), dimension(*) :: x, y
      complex(c_double), value :: alpha, beta
      complex(c_double), dimension(lda, *) :: A
      character(c_char), value :: uplo
    end subroutine cublasZhemv

    subroutine cublasSsbmv (uplo, n, k, alpha, A, lda, x, incx, beta, y, incy) &
        bind (c, name="cublasSsbmv")
      import
      integer(c_int), value :: n, k, lda, incx, incy
      real(c_float), dimension(*) :: x, y
      real(c_float), value :: alpha, beta
      character(c_char), value :: uplo
      real(c_float), dimension(lda, *) :: A
    end subroutine cublasSsbmv

    subroutine cublasDsbmv (uplo, n, k, alpha, A, lda, x, incx, beta, y, incy) &
        bind (c, name="cublasDsbmv")
      import
      integer(c_int), value :: n, k, lda, incx, incy
      real(c_double), dimension(lda, *) :: A
      real(c_double), value :: alpha, beta
      character(c_char), value :: uplo
      real(c_double), dimension(*) :: x, y
    end subroutine cublasDsbmv

    subroutine cublasChbmv (uplo, n, k, alpha, A, lda, x, incx, beta, y, incy) &
        bind (c, name="cublasChbmv")
      import
      integer(c_int), value :: n, k, lda, incx, incy
      complex(c_float), dimension(*) :: x, y
      character(c_char), value :: uplo
      complex(c_float), dimension(lda, *) :: A
      complex(c_float), value :: alpha, beta
    end subroutine cublasChbmv

    subroutine cublasZhbmv (uplo, n, k, alpha, A, lda, x, incx, beta, y, incy) &
        bind (c, name="cublasZhbmv")
      import
      integer(c_int), value :: n, k, lda, incx, incy
      complex(c_double), dimension(*) :: x, y
      complex(c_double), value :: alpha, beta
      complex(c_double), dimension(lda, *) :: A
      character(c_char), value :: uplo
    end subroutine cublasZhbmv

    subroutine cublasSspmv (uplo, n, alpha, AP, x, incx, beta, y, incy) &
        bind (c, name="cublasSspmv")
      import
      integer(c_int), value :: n, incx, incy
      real(c_float), value :: alpha, beta
      character(c_char), value :: uplo
      real(c_float), dimension(*) :: AP, x, y
    end subroutine cublasSspmv

    subroutine cublasDspmv (uplo, n, alpha, AP, x, incx, beta, y, incy) &
        bind (c, name="cublasDspmv")
      import
      real(c_double), dimension(*) :: AP, x, y
      integer(c_int), value :: n, incx, incy
      real(c_double), value :: alpha, beta
      character(c_char), value :: uplo
    end subroutine cublasDspmv

    subroutine cublasChpmv (uplo, n, alpha, AP, x, incx, beta, y, incy) &
        bind (c, name="cublasChpmv")
      import
      complex(c_float), dimension(*) :: AP, x, y
      integer(c_int), value :: n, incx, incy
      character(c_char), value :: uplo
      complex(c_float), value :: alpha, beta
    end subroutine cublasChpmv

    subroutine cublasZhpmv (uplo, n, alpha, AP, x, incx, beta, y, incy) &
        bind (c, name="cublasZhpmv")
      import
      complex(c_double), value :: alpha, beta
      integer(c_int), value :: n, incx, incy
      complex(c_double), dimension(*) :: AP, x, y
      character(c_char), value :: uplo
    end subroutine cublasZhpmv

    subroutine cublasSger (m, n, alpha, x, incx, y, incy, A, lda) &
        bind (c, name="cublasSger")
      import
      integer(c_int), value :: m, n, incx, incy, lda
      real(c_float), value :: alpha
      real(c_float), dimension(*) :: x, y
      real(c_float), dimension(lda, *) :: A
    end subroutine cublasSger

    subroutine cublasDger (m, n, alpha, x, incx, y, incy, A, lda) &
        bind (c, name="cublasDger")
      import
      integer(c_int), value :: m, n, incx, incy, lda
      real(c_double), dimension(*) :: x, y
      real(c_double), value :: alpha
      real(c_double), dimension(lda, *) :: A
    end subroutine cublasDger

    subroutine cublasCgeru (m, n, alpha, x, incx, y, incy, A, lda) &
        bind (c, name="cublasCgeru")
      import
      integer(c_int), value :: m, n, incx, incy, lda
      complex(c_float), dimension(*) :: x, y
      complex(c_float), dimension(lda, *) :: A
      complex(c_float), value :: alpha
    end subroutine cublasCgeru

    subroutine cublasZgeru (m, n, alpha, x, incx, y, incy, A, lda) &
        bind (c, name="cublasZgeru")
      import
      integer(c_int), value :: m, n, incx, incy, lda
      complex(c_double), value :: alpha
      complex(c_double), dimension(lda, *) :: A
      complex(c_double), dimension(*) :: x, y
    end subroutine cublasZgeru

    subroutine cublasCgerc (m, n, alpha, x, incx, y, incy, A, lda) &
        bind (c, name="cublasCgerc")
      import
      integer(c_int), value :: m, n, incx, incy, lda
      complex(c_float), dimension(*) :: x, y
      complex(c_float), dimension(lda, *) :: A
      complex(c_float), value :: alpha
    end subroutine cublasCgerc

    subroutine cublasZgerc (m, n, alpha, x, incx, y, incy, A, lda) &
        bind (c, name="cublasZgerc")
      import
      integer(c_int), value :: m, n, incx, incy, lda
      complex(c_double), value :: alpha
      complex(c_double), dimension(lda, *) :: A
      complex(c_double), dimension(*) :: x, y
    end subroutine cublasZgerc

    subroutine cublasSsyr (uplo, n, alpha, x, incx, A, lda) &
        bind (c, name="cublasSsyr")
      import
      integer(c_int), value :: n, incx, lda
      real(c_float), dimension(lda, *) :: A
      real(c_float), value :: alpha
      character(c_char), value :: uplo
      real(c_float), dimension(*) :: x
    end subroutine cublasSsyr

    subroutine cublasDsyr (uplo, n, alpha, x, incx, A, lda) &
        bind (c, name="cublasDsyr")
      import
      integer(c_int), value :: n, incx, lda
      real(c_double), dimension(*) :: x
      real(c_double), value :: alpha
      character(c_char), value :: uplo
      real(c_double), dimension(lda, *) :: A
    end subroutine cublasDsyr

    subroutine cublasCher (uplo, n, alpha, x, incx, A, lda) &
        bind (c, name="cublasCher")
      import
      integer(c_int), value :: n, incx, lda
      complex(c_float), dimension(*) :: x
      character(c_char), value :: uplo
      complex(c_float), dimension(lda, *) :: A
      complex(c_float), value :: alpha
    end subroutine cublasCher

    subroutine cublasZher (uplo, n, alpha, x, incx, A, lda) &
        bind (c, name="cublasZher")
      import
      integer(c_int), value :: n, incx, lda
      complex(c_double), value :: alpha
      complex(c_double), dimension(*) :: x
      character(c_char), value :: uplo
      complex(c_double), dimension(lda, *) :: A
    end subroutine cublasZher

    subroutine cublasSspr (uplo, n, alpha, x, incx, AP) &
        bind (c, name="cublasSspr")
      import
      integer(c_int), value :: n, incx
      real(c_float), value :: alpha
      character(c_char), value :: uplo
      real(c_float), dimension(*) :: x, AP
    end subroutine cublasSspr

    subroutine cublasDspr (uplo, n, alpha, x, incx, AP) &
        bind (c, name="cublasDspr")
      import
      real(c_double), dimension(*) :: x, AP
      integer(c_int), value :: n, incx
      real(c_double), value :: alpha
      character(c_char), value :: uplo
    end subroutine cublasDspr

    subroutine cublasChpr (uplo, n, alpha, x, incx, AP) &
        bind (c, name="cublasChpr")
      import
      complex(c_float), dimension(*) :: x, AP
      integer(c_int), value :: n, incx
      character(c_char), value :: uplo
      complex(c_float), value :: alpha
    end subroutine cublasChpr

    subroutine cublasZhpr (uplo, n, alpha, x, incx, AP) &
        bind (c, name="cublasZhpr")
      import
      complex(c_double), value :: alpha
      integer(c_int), value :: n, incx
      complex(c_double), dimension(*) :: x, AP
      character(c_char), value :: uplo
    end subroutine cublasZhpr

    subroutine cublasSsyr2 (uplo, n, alpha, x, incx, y, incy, A, lda) &
        bind (c, name="cublasSsyr2")
      import
      integer(c_int), value :: n, incx, incy, lda
      real(c_float), dimension(lda, *) :: A
      real(c_float), value :: alpha
      character(c_char), value :: uplo
      real(c_float), dimension(*) :: x, y
    end subroutine cublasSsyr2

    subroutine cublasDsyr2 (uplo, n, alpha, x, incx, y, incy, A, lda) &
        bind (c, name="cublasDsyr2")
      import
      integer(c_int), value :: n, incx, incy, lda
      real(c_double), dimension(*) :: x, y
      real(c_double), value :: alpha
      character(c_char), value :: uplo
      real(c_double), dimension(lda, *) :: A
    end subroutine cublasDsyr2

    subroutine cublasCher2 (uplo, n, alpha, x, incx, y, incy, A, lda) &
        bind (c, name="cublasCher2")
      import
      integer(c_int), value :: n, incx, incy, lda
      complex(c_float), dimension(*) :: x, y
      character(c_char), value :: uplo
      complex(c_float), dimension(lda, *) :: A
      complex(c_float), value :: alpha
    end subroutine cublasCher2

    subroutine cublasZher2 (uplo, n, alpha, x, incx, y, incy, A, lda) &
        bind (c, name="cublasZher2")
      import
      integer(c_int), value :: n, incx, incy, lda
      complex(c_double), value :: alpha
      complex(c_double), dimension(*) :: x, y
      character(c_char), value :: uplo
      complex(c_double), dimension(lda, *) :: A
    end subroutine cublasZher2

    subroutine cublasSspr2 (uplo, n, alpha, x, incx, y, incy, AP) &
        bind (c, name="cublasSspr2")
      import
      integer(c_int), value :: n, incx, incy
      real(c_float), value :: alpha
      character(c_char), value :: uplo
      real(c_float), dimension(*) :: x, y, AP
    end subroutine cublasSspr2

    subroutine cublasDspr2 (uplo, n, alpha, x, incx, y, incy, AP) &
        bind (c, name="cublasDspr2")
      import
      real(c_double), dimension(*) :: x, y, AP
      integer(c_int), value :: n, incx, incy
      real(c_double), value :: alpha
      character(c_char), value :: uplo
    end subroutine cublasDspr2

    subroutine cublasChpr2 (uplo, n, alpha, x, incx, y, incy, AP) &
        bind (c, name="cublasChpr2")
      import
      complex(c_float), dimension(*) :: x, y, AP
      integer(c_int), value :: n, incx, incy
      character(c_char), value :: uplo
      complex(c_float), value :: alpha
    end subroutine cublasChpr2

    subroutine cublasZhpr2 (uplo, n, alpha, x, incx, y, incy, AP) &
        bind (c, name="cublasZhpr2")
      import
      complex(c_double), value :: alpha
      integer(c_int), value :: n, incx, incy
      complex(c_double), dimension(*) :: x, y, AP
      character(c_char), value :: uplo
    end subroutine cublasZhpr2

    subroutine cublasSgemm &
        (transa, transb, m, n, k, alpha, A, lda, B, ldb, beta, C, ldc) &
        bind (c, name="cublasSgemm")
      import
      integer(c_int), value :: m, n, k, lda, ldb, ldc
      real(c_float), dimension(lda, *) :: A
      character(c_char), value :: transa, transb
      real(c_float), dimension(ldc, *) :: C
      real(c_float), dimension(ldb, *) :: B
      real(c_float), value :: alpha, beta
    end subroutine cublasSgemm

    subroutine cublasDgemm &
        (transa, transb, m, n, k, alpha, A, lda, B, ldb, beta, C, ldc) &
        bind (c, name="cublasDgemm")
      import
      integer(c_int), value :: m, n, k, lda, ldb, ldc
      real(c_double), dimension(ldb, *) :: B
      real(c_double), dimension(ldc, *) :: C
      character(c_char), value :: transa, transb
      real(c_double), value :: alpha, beta
      real(c_double), dimension(lda, *) :: A
    end subroutine cublasDgemm

    subroutine cublasCgemm &
        (transa, transb, m, n, k, alpha, A, lda, B, ldb, beta, C, ldc) &
        bind (c, name="cublasCgemm")
      import
      integer(c_int), value :: m, n, k, lda, ldb, ldc
      complex(c_float), dimension(ldc, *) :: C
      complex(c_float), dimension(ldb, *) :: B
      character(c_char), value :: transa, transb
      complex(c_float), value :: alpha, beta
      complex(c_float), dimension(lda, *) :: A
    end subroutine cublasCgemm

    subroutine cublasZgemm &
        (transa, transb, m, n, k, alpha, A, lda, B, ldb, beta, C, ldc) &
        bind (c, name="cublasZgemm")
      import
      integer(c_int), value :: m, n, k, lda, ldb, ldc
      complex(c_double), value :: alpha, beta
      complex(c_double), dimension(lda, *) :: A
      character(c_char), value :: transa, transb
      complex(c_double), dimension(ldb, *) :: B
      complex(c_double), dimension(ldc, *) :: C
    end subroutine cublasZgemm

    subroutine cublasSsyrk (uplo, trans, n, k, alpha, A, lda, beta, C, ldc) &
        bind (c, name="cublasSsyrk")
      import
      integer(c_int), value :: n, k, lda, ldc
      real(c_float), dimension(ldc, *) :: C
      real(c_float), value :: alpha, beta
      character(c_char), value :: uplo, trans
      real(c_float), dimension(lda, *) :: A
    end subroutine cublasSsyrk

    subroutine cublasDsyrk (uplo, trans, n, k, alpha, A, lda, beta, C, ldc) &
        bind (c, name="cublasDsyrk")
      import
      integer(c_int), value :: n, k, lda, ldc
      real(c_double), dimension(lda, *) :: A
      real(c_double), dimension(ldc, *) :: C
      real(c_double), value :: alpha, beta
      character(c_char), value :: uplo, trans
    end subroutine cublasDsyrk

    subroutine cublasCsyrk (uplo, trans, n, k, alpha, A, lda, beta, C, ldc) &
        bind (c, name="cublasCsyrk")
      import
      integer(c_int), value :: n, k, lda, ldc
      complex(c_float), dimension(ldc, *) :: C
      character(c_char), value :: uplo, trans
      complex(c_float), dimension(lda, *) :: A
      complex(c_float), value :: alpha, beta
    end subroutine cublasCsyrk

    subroutine cublasZsyrk (uplo, trans, n, k, alpha, A, lda, beta, C, ldc) &
        bind (c, name="cublasZsyrk")
      import
      integer(c_int), value :: n, k, lda, ldc
      complex(c_double), value :: alpha, beta
      complex(c_double), dimension(lda, *) :: A
      character(c_char), value :: uplo, trans
      complex(c_double), dimension(ldc, *) :: C
    end subroutine cublasZsyrk

    subroutine cublasCherk (uplo, trans, n, k, alpha, A, lda, beta, C, ldc) &
        bind (c, name="cublasCherk")
      import
      integer(c_int), value :: n, k, lda, ldc
      complex(c_float), dimension(ldc, *) :: C
      character(c_char), value :: uplo, trans
      complex(c_float), dimension(lda, *) :: A
      complex(c_float), value :: alpha, beta
    end subroutine cublasCherk

    subroutine cublasZherk (uplo, trans, n, k, alpha, A, lda, beta, C, ldc) &
        bind (c, name="cublasZherk")
      import
      integer(c_int), value :: n, k, lda, ldc
      complex(c_double), value :: alpha, beta
      complex(c_double), dimension(lda, *) :: A
      character(c_char), value :: uplo, trans
      complex(c_double), dimension(ldc, *) :: C
    end subroutine cublasZherk

    subroutine cublasSsyr2k (uplo, trans, n, k, alpha, A, lda, B, ldb, beta, C, ldc) &
        bind (c, name="cublasSsyr2k")
      import
      integer(c_int), value :: n, k, lda, ldb, ldc
      real(c_float), dimension(lda, *) :: A
      character(c_char), value :: uplo, trans
      real(c_float), dimension(ldc, *) :: C
      real(c_float), dimension(ldb, *) :: B
      real(c_float), value :: alpha, beta
    end subroutine cublasSsyr2k

    subroutine cublasDsyr2k (uplo, trans, n, k, alpha, A, lda, B, ldb, beta, C, ldc) &
        bind (c, name="cublasDsyr2k")
      import
      integer(c_int), value :: n, k, lda, ldb, ldc
      real(c_double), dimension(ldb, *) :: B
      real(c_double), dimension(ldc, *) :: C
      character(c_char), value :: uplo, trans
      real(c_double), value :: alpha, beta
      real(c_double), dimension(lda, *) :: A
    end subroutine cublasDsyr2k

    subroutine cublasCsyr2k (uplo, trans, n, k, alpha, A, lda, B, ldb, beta, C, ldc) &
        bind (c, name="cublasCsyr2k")
      import
      integer(c_int), value :: n, k, lda, ldb, ldc
      complex(c_float), dimension(ldc, *) :: C
      complex(c_float), dimension(ldb, *) :: B
      character(c_char), value :: uplo, trans
      complex(c_float), value :: alpha, beta
      complex(c_float), dimension(lda, *) :: A
    end subroutine cublasCsyr2k

    subroutine cublasZsyr2k (uplo, trans, n, k, alpha, A, lda, B, ldb, beta, C, ldc) &
        bind (c, name="cublasZsyr2k")
      import
      integer(c_int), value :: n, k, lda, ldb, ldc
      complex(c_double), value :: alpha, beta
      complex(c_double), dimension(lda, *) :: A
      character(c_char), value :: uplo, trans
      complex(c_double), dimension(ldb, *) :: B
      complex(c_double), dimension(ldc, *) :: C
    end subroutine cublasZsyr2k

    subroutine cublasCher2k (uplo, trans, n, k, alpha, A, lda, B, ldb, beta, C, ldc) &
        bind (c, name="cublasCher2k")
      import
      integer(c_int), value :: n, k, lda, ldb, ldc
      complex(c_float), dimension(ldc, *) :: C
      complex(c_float), dimension(ldb, *) :: B
      character(c_char), value :: uplo, trans
      complex(c_float), value :: alpha, beta
      complex(c_float), dimension(lda, *) :: A
    end subroutine cublasCher2k

    subroutine cublasZher2k (uplo, trans, n, k, alpha, A, lda, B, ldb, beta, C, ldc) &
        bind (c, name="cublasZher2k")
      import
      integer(c_int), value :: n, k, lda, ldb, ldc
      complex(c_double), value :: alpha, beta
      complex(c_double), dimension(lda, *) :: A
      character(c_char), value :: uplo, trans
      complex(c_double), dimension(ldb, *) :: B
      complex(c_double), dimension(ldc, *) :: C
    end subroutine cublasZher2k

    subroutine cublasSsymm (side, uplo, m, n, alpha, A, lda, B, ldb, beta, C, ldc) &
        bind (c, name="cublasSsymm")
      import
      integer(c_int), value :: m, n, lda, ldb, ldc
      real(c_float), dimension(lda, *) :: A
      character(c_char), value :: side, uplo
      real(c_float), dimension(ldc, *) :: C
      real(c_float), dimension(ldb, *) :: B
      real(c_float), value :: alpha, beta
    end subroutine cublasSsymm

    subroutine cublasDsymm (side, uplo, m, n, alpha, A, lda, B, ldb, beta, C, ldc) &
        bind (c, name="cublasDsymm")
      import
      integer(c_int), value :: m, n, lda, ldb, ldc
      real(c_double), dimension(ldb, *) :: B
      real(c_double), dimension(ldc, *) :: C
      character(c_char), value :: side, uplo
      real(c_double), value :: alpha, beta
      real(c_double), dimension(lda, *) :: A
    end subroutine cublasDsymm

    subroutine cublasCsymm (side, uplo, m, n, alpha, A, lda, B, ldb, beta, C, ldc) &
        bind (c, name="cublasCsymm")
      import
      integer(c_int), value :: m, n, lda, ldb, ldc
      complex(c_float), dimension(ldc, *) :: C
      complex(c_float), dimension(ldb, *) :: B
      character(c_char), value :: side, uplo
      complex(c_float), value :: alpha, beta
      complex(c_float), dimension(lda, *) :: A
    end subroutine cublasCsymm

    subroutine cublasZsymm (side, uplo, m, n, alpha, A, lda, B, ldb, beta, C, ldc) &
        bind (c, name="cublasZsymm")
      import
      integer(c_int), value :: m, n, lda, ldb, ldc
      complex(c_double), value :: alpha, beta
      complex(c_double), dimension(lda, *) :: A
      character(c_char), value :: side, uplo
      complex(c_double), dimension(ldb, *) :: B
      complex(c_double), dimension(ldc, *) :: C
    end subroutine cublasZsymm

    subroutine cublasChemm (side, uplo, m, n, alpha, A, lda, B, ldb, beta, C, ldc) &
        bind (c, name="cublasChemm")
      import
      integer(c_int), value :: m, n, lda, ldb, ldc
      complex(c_float), dimension(ldc, *) :: C
      complex(c_float), dimension(ldb, *) :: B
      character(c_char), value :: side, uplo
      complex(c_float), value :: alpha, beta
      complex(c_float), dimension(lda, *) :: A
    end subroutine cublasChemm

    subroutine cublasZhemm (side, uplo, m, n, alpha, A, lda, B, ldb, beta, C, ldc) &
        bind (c, name="cublasZhemm")
      import
      integer(c_int), value :: m, n, lda, ldb, ldc
      complex(c_double), value :: alpha, beta
      complex(c_double), dimension(lda, *) :: A
      character(c_char), value :: side, uplo
      complex(c_double), dimension(ldb, *) :: B
      complex(c_double), dimension(ldc, *) :: C
    end subroutine cublasZhemm

    subroutine cublasStrsm (side, uplo, transa, diag, m, n, alpha, A, lda, B, ldb) &
        bind (c, name="cublasStrsm")
      import
      integer(c_int), value :: m, n, lda, ldb
      real(c_float), dimension(ldb, *) :: B
      real(c_float), value :: alpha
      character(c_char), value :: side, uplo, transa, diag
      real(c_float), dimension(lda, *) :: A
    end subroutine cublasStrsm

    subroutine cublasDtrsm (side, uplo, transa, diag, m, n, alpha, A, lda, B, ldb) &
        bind (c, name="cublasDtrsm")
      import
      integer(c_int), value :: m, n, lda, ldb
      real(c_double), dimension(lda, *) :: A
      real(c_double), value :: alpha
      character(c_char), value :: side, uplo, transa, diag
      real(c_double), dimension(ldb, *) :: B
    end subroutine cublasDtrsm

    subroutine cublasCtrsm (side, uplo, transa, diag, m, n, alpha, A, lda, B, ldb) &
        bind (c, name="cublasCtrsm")
      import
      integer(c_int), value :: m, n, lda, ldb
      complex(c_float), dimension(ldb, *) :: B
      character(c_char), value :: side, uplo, transa, diag
      complex(c_float), dimension(lda, *) :: A
      complex(c_float), value :: alpha
    end subroutine cublasCtrsm

    subroutine cublasZtrsm (side, uplo, transa, diag, m, n, alpha, A, lda, B, ldb) &
        bind (c, name="cublasZtrsm")
      import
      integer(c_int), value :: m, n, lda, ldb
      complex(c_double), value :: alpha
      complex(c_double), dimension(ldb, *) :: B
      complex(c_double), dimension(lda, *) :: A
      character(c_char), value :: side, uplo, transa, diag
    end subroutine cublasZtrsm

    subroutine cublasStrmm (side, uplo, transa, diag, m, n, alpha, A, lda, B, ldb) &
        bind (c, name="cublasStrmm")
      import
      integer(c_int), value :: m, n, lda, ldb
      real(c_float), dimension(ldb, *) :: B
      real(c_float), value :: alpha
      character(c_char), value :: side, uplo, transa, diag
      real(c_float), dimension(lda, *) :: A
    end subroutine cublasStrmm

    subroutine cublasDtrmm (side, uplo, transa, diag, m, n, alpha, A, lda, B, ldb) &
        bind (c, name="cublasDtrmm")
      import
      integer(c_int), value :: m, n, lda, ldb
      real(c_double), dimension(lda, *) :: A
      real(c_double), value :: alpha
      character(c_char), value :: side, uplo, transa, diag
      real(c_double), dimension(ldb, *) :: B
    end subroutine cublasDtrmm

    subroutine cublasCtrmm (side, uplo, transa, diag, m, n, alpha, A, lda, B, ldb) &
        bind (c, name="cublasCtrmm")
      import
      integer(c_int), value :: m, n, lda, ldb
      complex(c_float), dimension(ldb, *) :: B
      character(c_char), value :: side, uplo, transa, diag
      complex(c_float), dimension(lda, *) :: A
      complex(c_float), value :: alpha
    end subroutine cublasCtrmm

    subroutine cublasZtrmm (side, uplo, transa, diag, m, n, alpha, A, lda, B, ldb) &
        bind (c, name="cublasZtrmm")
      import
      integer(c_int), value :: m, n, lda, ldb
      complex(c_double), value :: alpha
      complex(c_double), dimension(ldb, *) :: B
      complex(c_double), dimension(lda, *) :: A
      character(c_char), value :: side, uplo, transa, diag
    end subroutine cublasZtrmm

  end interface

#else
  integer :: cublas_dummy
#endif

end module

!
! Copyright (C) 2021, MaX CoE
! Distributed under the MIT License
! (license terms are at http://opensource.org/licenses/MIT).
!
!--
!
! Wrappers for selected Linear Algebra subroutines
!
#include<devxlib_defs.h>
#include<devxlib_macros.h>
!
#ifdef __DXL_HAVE_DEVICE
  !
  ! checks
  !
#if ! defined __DXL_CUBLAS && ! defined __DXL_ROCBLAS && ! defined __DXL_MKL_GPU
# error
#endif
#endif

submodule (devxlib_linalg) devxlib_linalg_gemv

   implicit none

   contains

   module subroutine dev_SGEMV_gpu(TRANS,M,N,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
      implicit none
      real(real32),  intent(in) TAR_ATTR :: ALPHA,BETA
      integer,   intent(in) :: M,N,LDA,INCX,INCY
      character, intent(in) :: TRANS
      real(real32),  intent(in) TAR_ATTR DEV_ATTR :: A(:,:),X(:)
      real(real32)              TAR_ATTR DEV_ATTR :: Y(:)
      !
#if defined __DXL_ROCBLAS
      integer(c_int) :: itrans
#else
      character(c_char) :: trans_
#endif
      integer :: ierr
      !
#if defined __DXL_ROCBLAS
      itrans = rocblas_get_operation(TRANS)
#else
      trans_=TRANS
#endif
      !
      call acc_loc_dev_sync()
      !
      !DEV_ACC data present(A,X,Y)
      !DEV_ACC host_data use_device(A,X,Y)
#if defined __DXL_CUBLAS
      call cublasSgemv(trans_,M,N,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
#elif defined __DXL_ROCBLAS
      !DEV_OMPGPU target data use_device_ptr(A,X,Y)
      ierr=rocblas_sgemv(handle,itrans,M,N,c_loc(ALPHA),c_loc(A),LDA,c_loc(X),INCX,c_loc(BETA),c_loc(Y),INCY)
      !DEV_OMPGPU end target data
#elif defined __DXL_MKL_GPU
      !DEV_OMPGPU target data use_device_addr(A,X,Y)
      !DEV_OMPGPU dispatch
      call SGEMV(TRANS,M,N,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
      !DEV_OMPGPU end dispatch
      !DEV_OMPGPU end target data
#else
      call SGEMV(TRANS,M,N,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
#endif
      !DEV_ACC end host_data
      !DEV_ACC end data
      !
      call acc_loc_dev_sync()
      !
   end subroutine dev_SGEMV_gpu
   !
   module subroutine dev_DGEMV_gpu(TRANS,M,N,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
      implicit none
      real(real64),  intent(in) TAR_ATTR :: ALPHA,BETA
      integer,   intent(in) :: M,N,LDA,INCX,INCY
      character, intent(in) :: TRANS
      real(real64),  intent(in) TAR_ATTR DEV_ATTR :: A(:,:),X(:)
      real(real64)              TAR_ATTR DEV_ATTR :: Y(:)
      !
#if defined __DXL_ROCBLAS
      integer(c_int) :: itrans
#else
      character(c_char) :: trans_
#endif
      integer :: ierr
      !
#if defined __DXL_ROCBLAS
      itrans = rocblas_get_operation(TRANS)
#else
      trans_=TRANS
#endif
      !
      call acc_loc_dev_sync()
      !
      !DEV_ACC data present(A,X,Y)
      !DEV_ACC host_data use_device(A,X,Y)
#if defined __DXL_CUBLAS
      call cublasDgemv(trans_,M,N,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
#elif defined __DXL_ROCBLAS
      !DEV_OMPGPU target data use_device_ptr(A,X,Y)
      ierr=rocblas_dgemv(handle,itrans,M,N,c_loc(ALPHA),c_loc(A),LDA,c_loc(X),INCX,c_loc(BETA),c_loc(Y),INCY)
      !DEV_OMPGPU end target data
#elif defined __DXL_MKL_GPU
      !DEV_OMPGPU target data use_device_addr(A,X,Y)
      !DEV_OMPGPU dispatch
      call DGEMV(TRANS,M,N,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
      !DEV_OMPGPU end dispatch
      !DEV_OMPGPU end target data
#else
      call DGEMV(TRANS,M,N,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
#endif
      !DEV_ACC end host_data
      !DEV_ACC end data
      !
      call acc_loc_dev_sync()
      !
   end subroutine dev_DGEMV_gpu
   !
   module subroutine dev_CGEMV_gpu(TRANS,M,N,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
      implicit none
      complex(real32), intent(in) TAR_ATTR :: ALPHA,BETA
      integer,     intent(in) :: M,N,LDA,INCX,INCY
      character,   intent(in) :: TRANS
      complex(real32), intent(in) TAR_ATTR DEV_ATTR :: A(:,:),X(:)
      complex(real32)             TAR_ATTR DEV_ATTR :: Y(:)
      !
#if defined __DXL_ROCBLAS
      integer(c_int) :: itrans
#else
      character(c_char) :: trans_
#endif
      integer :: ierr
      !
#if defined __DXL_ROCBLAS
      itrans = rocblas_get_operation(TRANS)
#else
      trans_=TRANS
#endif
      !
      call acc_loc_dev_sync()
      !
      !DEV_ACC data present(A,X,Y)
      !DEV_ACC host_data use_device(A,X,Y)
#if defined __DXL_CUBLAS
      call cublasCgemv(trans_,M,N,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
#elif defined __DXL_ROCBLAS
      !DEV_OMPGPU target data use_device_ptr(A,X,Y)
      ierr=rocblas_cgemv(handle,itrans,M,N,c_loc(ALPHA),c_loc(A),LDA,c_loc(X),INCX,c_loc(BETA),c_loc(Y),INCY)
      !DEV_OMPGPU end target data
#elif defined __DXL_MKL_GPU
      !DEV_OMPGPU target data use_device_addr(A,X,Y)
      !DEV_OMPGPU dispatch
      call CGEMV(TRANS,M,N,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
      !DEV_OMPGPU end dispatch
      !DEV_OMPGPU end target data
#else
      call CGEMV(TRANS,M,N,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
#endif
      !DEV_ACC end host_data
      !DEV_ACC end data
      !
      call acc_loc_dev_sync()
      !
   end subroutine dev_CGEMV_gpu
   !
   module subroutine dev_ZGEMV_gpu(TRANS,M,N,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
      implicit none
      complex(real64), intent(in) TAR_ATTR :: ALPHA,BETA
      integer,     intent(in) :: M,N,LDA,INCX,INCY
      character,   intent(in) :: TRANS
      complex(real64), intent(in) TAR_ATTR DEV_ATTR :: A(:,:),X(:)
      complex(real64)             TAR_ATTR DEV_ATTR :: Y(:)
      !
#if defined __DXL_ROCBLAS
      integer(c_int) :: itrans
#else
      character(c_char) :: trans_
#endif
      integer :: ierr
      !
#if defined __DXL_ROCBLAS
      itrans = rocblas_get_operation(TRANS)
#else
      trans_=TRANS
#endif
      !
      call acc_loc_dev_sync()
      !
      !DEV_ACC data present(A,X,Y)
      !DEV_ACC host_data use_device(A,X,Y)
#if defined __DXL_CUBLAS
      call cublasZgemv(trans_,M,N,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
#elif defined __DXL_ROCBLAS
      !DEV_OMPGPU target data use_device_ptr(A,X,Y)
      ierr=rocblas_zgemv(handle,itrans,M,N,c_loc(ALPHA),c_loc(A),LDA,c_loc(X),INCX,c_loc(BETA),c_loc(Y),INCY)
      !DEV_OMPGPU end target data
#elif defined __DXL_MKL_GPU
      !DEV_OMPGPU target data use_device_addr(A,X,Y)
      !DEV_OMPGPU dispatch
      call ZGEMV(TRANS,M,N,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
      !DEV_OMPGPU end dispatch
      !DEV_OMPGPU end target data
#else
      call ZGEMV(TRANS,M,N,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
#endif
      !DEV_ACC end host_data
      !DEV_ACC end data
      !
      call acc_loc_dev_sync()
      !
   end subroutine dev_ZGEMV_gpu
   !
end submodule devxlib_linalg_gemv

!
! Copyright (C) 2002-2018 Quantum ESPRESSO group
! This file is distributed under the terms of the
! GNU General Public License. See the file `License'
! in the root directory of the present distribution,
! or http://www.gnu.org/copyleft/gpl.txt .
!
! Utility functions to perform memcpy and memset on the device with CUDA Fortran
! cuf_memXXX contains a CUF KERNEL to perform the selected operation
! cu_memsync are wrappers for cuda_memcpy functions
!
#if defined(_CUDA)
#  define __CUDA
#endif
!
module device_fbuff_m
  use tb_dev, only : tb_dev_t
  use tb_pin, only : tb_pin_t

  implicit none

  TYPE(tb_dev_t) :: dev_buf ! A global variable hosting a global device buffer
  TYPE(tb_pin_t) :: pin_buf ! A global variable hosting a global pinned memory buffer

#include<device_fbuff_interf.f90>

end module device_fbuff_m

!................................................................................
! Copyright (C) 2010 david.car, david.car7@gmail.com
! Copyright (C) 2010 Michael List, listmg@users.sourceforge.net

! This program is free software; you can redistribute it and/or modify it under
! the terms of the GNU General Public License as published by the Free Software
! Foundation; either version 2 of the License, or (at your option) any later
! version.

! This program is distributed in the hope that it will be useful, but WITHOUT
! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
! FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

! You should have received a copy of the GNU General Public License along with
! this program; if not, write to the Free Software Foundation, Inc., 59 Temple
! Place, Suite 330, Boston, MA 02111-1307 USA
!................................................................................

module OpenCL
  
  use, intrinsic :: ISO_C_BINDING

  implicit none

end module OpenCL

!
! Copyright (C) 2022, MaX CoE
! Distributed under the MIT License 
! (license terms are at http://opensource.org/licenses/MIT).
!
!--
!
! Utility functions to perform device memory mapping from host memory
! using CUDA-Fortran, OpenACC or OpenMP Offload
!
!==================================================================
!==================================================================
! *DO NOT EDIT*: automatically generated from device_mapping.jf90
!==================================================================
!==================================================================
!
#include<devxlib_macros.h>
#include<devxlib_defs.h>
!
!=======================================
!
module devxlib_mapping

   use iso_fortran_env,     only : int32, int64, real32, real64
   use devxlib_environment, only : devxlib_error
#if defined __DXL_CUDAF
   use cudafor
#elif defined __DXL_OPENACC
   use openacc
#elif defined __DXL_OPENMP_GPU
   use iso_c_binding, only : c_loc
   use omp_lib,       only : omp_get_default_device, omp_target_is_present
#endif

   implicit none

   interface devxlib_map
      module procedure &
         sp_devxlib_mapping_map_r1d, sp_devxlib_mapping_map_r2d, sp_devxlib_mapping_map_r3d, &
         sp_devxlib_mapping_map_r4d, sp_devxlib_mapping_map_r5d, sp_devxlib_mapping_map_r6d, &
         dp_devxlib_mapping_map_r1d, dp_devxlib_mapping_map_r2d, dp_devxlib_mapping_map_r3d, &
         dp_devxlib_mapping_map_r4d, dp_devxlib_mapping_map_r5d, dp_devxlib_mapping_map_r6d, &
         sp_devxlib_mapping_map_c1d, sp_devxlib_mapping_map_c2d, sp_devxlib_mapping_map_c3d, &
         sp_devxlib_mapping_map_c4d, sp_devxlib_mapping_map_c5d, sp_devxlib_mapping_map_c6d, &
         dp_devxlib_mapping_map_c1d, dp_devxlib_mapping_map_c2d, dp_devxlib_mapping_map_c3d, &
         dp_devxlib_mapping_map_c4d, dp_devxlib_mapping_map_c5d, dp_devxlib_mapping_map_c6d, &
         i4_devxlib_mapping_map_i1d, i4_devxlib_mapping_map_i2d, i4_devxlib_mapping_map_i3d, &
         i4_devxlib_mapping_map_i4d, i4_devxlib_mapping_map_i5d, i4_devxlib_mapping_map_i6d, &
         i8_devxlib_mapping_map_i1d, i8_devxlib_mapping_map_i2d, i8_devxlib_mapping_map_i3d, &
         i8_devxlib_mapping_map_i4d, i8_devxlib_mapping_map_i5d, i8_devxlib_mapping_map_i6d, &
         l4_devxlib_mapping_map_l1d, l4_devxlib_mapping_map_l2d, l4_devxlib_mapping_map_l3d, &
         l4_devxlib_mapping_map_l4d, l4_devxlib_mapping_map_l5d, l4_devxlib_mapping_map_l6d
   endinterface devxlib_map

   interface devxlib_unmap
      module procedure &
         sp_devxlib_mapping_unmap_r1d, sp_devxlib_mapping_unmap_r2d, sp_devxlib_mapping_unmap_r3d, &
         sp_devxlib_mapping_unmap_r4d, sp_devxlib_mapping_unmap_r5d, sp_devxlib_mapping_unmap_r6d, &
         dp_devxlib_mapping_unmap_r1d, dp_devxlib_mapping_unmap_r2d, dp_devxlib_mapping_unmap_r3d, &
         dp_devxlib_mapping_unmap_r4d, dp_devxlib_mapping_unmap_r5d, dp_devxlib_mapping_unmap_r6d, &
         sp_devxlib_mapping_unmap_c1d, sp_devxlib_mapping_unmap_c2d, sp_devxlib_mapping_unmap_c3d, &
         sp_devxlib_mapping_unmap_c4d, sp_devxlib_mapping_unmap_c5d, sp_devxlib_mapping_unmap_c6d, &
         dp_devxlib_mapping_unmap_c1d, dp_devxlib_mapping_unmap_c2d, dp_devxlib_mapping_unmap_c3d, &
         dp_devxlib_mapping_unmap_c4d, dp_devxlib_mapping_unmap_c5d, dp_devxlib_mapping_unmap_c6d, &
         i4_devxlib_mapping_unmap_i1d, i4_devxlib_mapping_unmap_i2d, i4_devxlib_mapping_unmap_i3d, &
         i4_devxlib_mapping_unmap_i4d, i4_devxlib_mapping_unmap_i5d, i4_devxlib_mapping_unmap_i6d, &
         i8_devxlib_mapping_unmap_i1d, i8_devxlib_mapping_unmap_i2d, i8_devxlib_mapping_unmap_i3d, &
         i8_devxlib_mapping_unmap_i4d, i8_devxlib_mapping_unmap_i5d, i8_devxlib_mapping_unmap_i6d, &
         l4_devxlib_mapping_unmap_l1d, l4_devxlib_mapping_unmap_l2d, l4_devxlib_mapping_unmap_l3d, &
         l4_devxlib_mapping_unmap_l4d, l4_devxlib_mapping_unmap_l5d, l4_devxlib_mapping_unmap_l6d
   endinterface devxlib_unmap

   interface devxlib_mapped
      module procedure &
         sp_devxlib_mapping_mapped_r1d, sp_devxlib_mapping_mapped_r2d, sp_devxlib_mapping_mapped_r3d, &
         sp_devxlib_mapping_mapped_r4d, sp_devxlib_mapping_mapped_r5d, sp_devxlib_mapping_mapped_r6d, &
         dp_devxlib_mapping_mapped_r1d, dp_devxlib_mapping_mapped_r2d, dp_devxlib_mapping_mapped_r3d, &
         dp_devxlib_mapping_mapped_r4d, dp_devxlib_mapping_mapped_r5d, dp_devxlib_mapping_mapped_r6d, &
         sp_devxlib_mapping_mapped_c1d, sp_devxlib_mapping_mapped_c2d, sp_devxlib_mapping_mapped_c3d, &
         sp_devxlib_mapping_mapped_c4d, sp_devxlib_mapping_mapped_c5d, sp_devxlib_mapping_mapped_c6d, &
         dp_devxlib_mapping_mapped_c1d, dp_devxlib_mapping_mapped_c2d, dp_devxlib_mapping_mapped_c3d, &
         dp_devxlib_mapping_mapped_c4d, dp_devxlib_mapping_mapped_c5d, dp_devxlib_mapping_mapped_c6d, &
         i4_devxlib_mapping_mapped_i1d, i4_devxlib_mapping_mapped_i2d, i4_devxlib_mapping_mapped_i3d, &
         i4_devxlib_mapping_mapped_i4d, i4_devxlib_mapping_mapped_i5d, i4_devxlib_mapping_mapped_i6d, &
         i8_devxlib_mapping_mapped_i1d, i8_devxlib_mapping_mapped_i2d, i8_devxlib_mapping_mapped_i3d, &
         i8_devxlib_mapping_mapped_i4d, i8_devxlib_mapping_mapped_i5d, i8_devxlib_mapping_mapped_i6d, &
         l4_devxlib_mapping_mapped_l1d, l4_devxlib_mapping_mapped_l2d, l4_devxlib_mapping_mapped_l3d, &
         l4_devxlib_mapping_mapped_l4d, l4_devxlib_mapping_mapped_l5d, l4_devxlib_mapping_mapped_l6d
   endinterface devxlib_mapped



   interface
      module subroutine sp_devxlib_mapping_map_r1d(array, range1 )
         implicit none
         real(real32), allocatable DEV_ATTR, intent(inout) :: array(:)
         integer, optional, intent(in) ::  range1(2)
      end subroutine sp_devxlib_mapping_map_r1d
      module subroutine sp_devxlib_mapping_map_r2d(array, range1, &
                                            range2 )
         implicit none
         real(real32), allocatable DEV_ATTR, intent(inout) :: array(:,:)
         integer, optional, intent(in) ::  range1(2), range2(2)
      end subroutine sp_devxlib_mapping_map_r2d
      module subroutine sp_devxlib_mapping_map_r3d(array, range1, &
                                            range2, &
                                            range3 )
         implicit none
         real(real32), allocatable DEV_ATTR, intent(inout) :: array(:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
      end subroutine sp_devxlib_mapping_map_r3d
      module subroutine sp_devxlib_mapping_map_r4d(array, range1, &
                                            range2, &
                                            range3, &
                                            range4 )
         implicit none
         real(real32), allocatable DEV_ATTR, intent(inout) :: array(:,:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
      end subroutine sp_devxlib_mapping_map_r4d
      module subroutine sp_devxlib_mapping_map_r5d(array, range1, &
                                            range2, &
                                            range3, &
                                            range4, &
                                            range5 )
         implicit none
         real(real32), allocatable DEV_ATTR, intent(inout) :: array(:,:,:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2)
      end subroutine sp_devxlib_mapping_map_r5d
      module subroutine sp_devxlib_mapping_map_r6d(array, range1, &
                                            range2, &
                                            range3, &
                                            range4, &
                                            range5, &
                                            range6 )
         implicit none
         real(real32), allocatable DEV_ATTR, intent(inout) :: array(:,:,:,:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2), range6(2)
      end subroutine sp_devxlib_mapping_map_r6d
      module subroutine dp_devxlib_mapping_map_r1d(array, range1 )
         implicit none
         real(real64), allocatable DEV_ATTR, intent(inout) :: array(:)
         integer, optional, intent(in) ::  range1(2)
      end subroutine dp_devxlib_mapping_map_r1d
      module subroutine dp_devxlib_mapping_map_r2d(array, range1, &
                                            range2 )
         implicit none
         real(real64), allocatable DEV_ATTR, intent(inout) :: array(:,:)
         integer, optional, intent(in) ::  range1(2), range2(2)
      end subroutine dp_devxlib_mapping_map_r2d
      module subroutine dp_devxlib_mapping_map_r3d(array, range1, &
                                            range2, &
                                            range3 )
         implicit none
         real(real64), allocatable DEV_ATTR, intent(inout) :: array(:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
      end subroutine dp_devxlib_mapping_map_r3d
      module subroutine dp_devxlib_mapping_map_r4d(array, range1, &
                                            range2, &
                                            range3, &
                                            range4 )
         implicit none
         real(real64), allocatable DEV_ATTR, intent(inout) :: array(:,:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
      end subroutine dp_devxlib_mapping_map_r4d
      module subroutine dp_devxlib_mapping_map_r5d(array, range1, &
                                            range2, &
                                            range3, &
                                            range4, &
                                            range5 )
         implicit none
         real(real64), allocatable DEV_ATTR, intent(inout) :: array(:,:,:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2)
      end subroutine dp_devxlib_mapping_map_r5d
      module subroutine dp_devxlib_mapping_map_r6d(array, range1, &
                                            range2, &
                                            range3, &
                                            range4, &
                                            range5, &
                                            range6 )
         implicit none
         real(real64), allocatable DEV_ATTR, intent(inout) :: array(:,:,:,:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2), range6(2)
      end subroutine dp_devxlib_mapping_map_r6d
      module subroutine sp_devxlib_mapping_map_c1d(array, range1 )
         implicit none
         complex(real32), allocatable DEV_ATTR, intent(inout) :: array(:)
         integer, optional, intent(in) ::  range1(2)
      end subroutine sp_devxlib_mapping_map_c1d
      module subroutine sp_devxlib_mapping_map_c2d(array, range1, &
                                            range2 )
         implicit none
         complex(real32), allocatable DEV_ATTR, intent(inout) :: array(:,:)
         integer, optional, intent(in) ::  range1(2), range2(2)
      end subroutine sp_devxlib_mapping_map_c2d
      module subroutine sp_devxlib_mapping_map_c3d(array, range1, &
                                            range2, &
                                            range3 )
         implicit none
         complex(real32), allocatable DEV_ATTR, intent(inout) :: array(:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
      end subroutine sp_devxlib_mapping_map_c3d
      module subroutine sp_devxlib_mapping_map_c4d(array, range1, &
                                            range2, &
                                            range3, &
                                            range4 )
         implicit none
         complex(real32), allocatable DEV_ATTR, intent(inout) :: array(:,:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
      end subroutine sp_devxlib_mapping_map_c4d
      module subroutine sp_devxlib_mapping_map_c5d(array, range1, &
                                            range2, &
                                            range3, &
                                            range4, &
                                            range5 )
         implicit none
         complex(real32), allocatable DEV_ATTR, intent(inout) :: array(:,:,:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2)
      end subroutine sp_devxlib_mapping_map_c5d
      module subroutine sp_devxlib_mapping_map_c6d(array, range1, &
                                            range2, &
                                            range3, &
                                            range4, &
                                            range5, &
                                            range6 )
         implicit none
         complex(real32), allocatable DEV_ATTR, intent(inout) :: array(:,:,:,:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2), range6(2)
      end subroutine sp_devxlib_mapping_map_c6d
      module subroutine dp_devxlib_mapping_map_c1d(array, range1 )
         implicit none
         complex(real64), allocatable DEV_ATTR, intent(inout) :: array(:)
         integer, optional, intent(in) ::  range1(2)
      end subroutine dp_devxlib_mapping_map_c1d
      module subroutine dp_devxlib_mapping_map_c2d(array, range1, &
                                            range2 )
         implicit none
         complex(real64), allocatable DEV_ATTR, intent(inout) :: array(:,:)
         integer, optional, intent(in) ::  range1(2), range2(2)
      end subroutine dp_devxlib_mapping_map_c2d
      module subroutine dp_devxlib_mapping_map_c3d(array, range1, &
                                            range2, &
                                            range3 )
         implicit none
         complex(real64), allocatable DEV_ATTR, intent(inout) :: array(:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
      end subroutine dp_devxlib_mapping_map_c3d
      module subroutine dp_devxlib_mapping_map_c4d(array, range1, &
                                            range2, &
                                            range3, &
                                            range4 )
         implicit none
         complex(real64), allocatable DEV_ATTR, intent(inout) :: array(:,:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
      end subroutine dp_devxlib_mapping_map_c4d
      module subroutine dp_devxlib_mapping_map_c5d(array, range1, &
                                            range2, &
                                            range3, &
                                            range4, &
                                            range5 )
         implicit none
         complex(real64), allocatable DEV_ATTR, intent(inout) :: array(:,:,:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2)
      end subroutine dp_devxlib_mapping_map_c5d
      module subroutine dp_devxlib_mapping_map_c6d(array, range1, &
                                            range2, &
                                            range3, &
                                            range4, &
                                            range5, &
                                            range6 )
         implicit none
         complex(real64), allocatable DEV_ATTR, intent(inout) :: array(:,:,:,:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2), range6(2)
      end subroutine dp_devxlib_mapping_map_c6d
      module subroutine i4_devxlib_mapping_map_i1d(array, range1 )
         implicit none
         integer(int32), allocatable DEV_ATTR, intent(inout) :: array(:)
         integer, optional, intent(in) ::  range1(2)
      end subroutine i4_devxlib_mapping_map_i1d
      module subroutine i4_devxlib_mapping_map_i2d(array, range1, &
                                            range2 )
         implicit none
         integer(int32), allocatable DEV_ATTR, intent(inout) :: array(:,:)
         integer, optional, intent(in) ::  range1(2), range2(2)
      end subroutine i4_devxlib_mapping_map_i2d
      module subroutine i4_devxlib_mapping_map_i3d(array, range1, &
                                            range2, &
                                            range3 )
         implicit none
         integer(int32), allocatable DEV_ATTR, intent(inout) :: array(:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
      end subroutine i4_devxlib_mapping_map_i3d
      module subroutine i4_devxlib_mapping_map_i4d(array, range1, &
                                            range2, &
                                            range3, &
                                            range4 )
         implicit none
         integer(int32), allocatable DEV_ATTR, intent(inout) :: array(:,:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
      end subroutine i4_devxlib_mapping_map_i4d
      module subroutine i4_devxlib_mapping_map_i5d(array, range1, &
                                            range2, &
                                            range3, &
                                            range4, &
                                            range5 )
         implicit none
         integer(int32), allocatable DEV_ATTR, intent(inout) :: array(:,:,:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2)
      end subroutine i4_devxlib_mapping_map_i5d
      module subroutine i4_devxlib_mapping_map_i6d(array, range1, &
                                            range2, &
                                            range3, &
                                            range4, &
                                            range5, &
                                            range6 )
         implicit none
         integer(int32), allocatable DEV_ATTR, intent(inout) :: array(:,:,:,:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2), range6(2)
      end subroutine i4_devxlib_mapping_map_i6d
      module subroutine i8_devxlib_mapping_map_i1d(array, range1 )
         implicit none
         integer(int64), allocatable DEV_ATTR, intent(inout) :: array(:)
         integer, optional, intent(in) ::  range1(2)
      end subroutine i8_devxlib_mapping_map_i1d
      module subroutine i8_devxlib_mapping_map_i2d(array, range1, &
                                            range2 )
         implicit none
         integer(int64), allocatable DEV_ATTR, intent(inout) :: array(:,:)
         integer, optional, intent(in) ::  range1(2), range2(2)
      end subroutine i8_devxlib_mapping_map_i2d
      module subroutine i8_devxlib_mapping_map_i3d(array, range1, &
                                            range2, &
                                            range3 )
         implicit none
         integer(int64), allocatable DEV_ATTR, intent(inout) :: array(:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
      end subroutine i8_devxlib_mapping_map_i3d
      module subroutine i8_devxlib_mapping_map_i4d(array, range1, &
                                            range2, &
                                            range3, &
                                            range4 )
         implicit none
         integer(int64), allocatable DEV_ATTR, intent(inout) :: array(:,:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
      end subroutine i8_devxlib_mapping_map_i4d
      module subroutine i8_devxlib_mapping_map_i5d(array, range1, &
                                            range2, &
                                            range3, &
                                            range4, &
                                            range5 )
         implicit none
         integer(int64), allocatable DEV_ATTR, intent(inout) :: array(:,:,:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2)
      end subroutine i8_devxlib_mapping_map_i5d
      module subroutine i8_devxlib_mapping_map_i6d(array, range1, &
                                            range2, &
                                            range3, &
                                            range4, &
                                            range5, &
                                            range6 )
         implicit none
         integer(int64), allocatable DEV_ATTR, intent(inout) :: array(:,:,:,:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2), range6(2)
      end subroutine i8_devxlib_mapping_map_i6d
      module subroutine l4_devxlib_mapping_map_l1d(array, range1 )
         implicit none
         logical(int32), allocatable DEV_ATTR, intent(inout) :: array(:)
         integer, optional, intent(in) ::  range1(2)
      end subroutine l4_devxlib_mapping_map_l1d
      module subroutine l4_devxlib_mapping_map_l2d(array, range1, &
                                            range2 )
         implicit none
         logical(int32), allocatable DEV_ATTR, intent(inout) :: array(:,:)
         integer, optional, intent(in) ::  range1(2), range2(2)
      end subroutine l4_devxlib_mapping_map_l2d
      module subroutine l4_devxlib_mapping_map_l3d(array, range1, &
                                            range2, &
                                            range3 )
         implicit none
         logical(int32), allocatable DEV_ATTR, intent(inout) :: array(:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
      end subroutine l4_devxlib_mapping_map_l3d
      module subroutine l4_devxlib_mapping_map_l4d(array, range1, &
                                            range2, &
                                            range3, &
                                            range4 )
         implicit none
         logical(int32), allocatable DEV_ATTR, intent(inout) :: array(:,:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
      end subroutine l4_devxlib_mapping_map_l4d
      module subroutine l4_devxlib_mapping_map_l5d(array, range1, &
                                            range2, &
                                            range3, &
                                            range4, &
                                            range5 )
         implicit none
         logical(int32), allocatable DEV_ATTR, intent(inout) :: array(:,:,:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2)
      end subroutine l4_devxlib_mapping_map_l5d
      module subroutine l4_devxlib_mapping_map_l6d(array, range1, &
                                            range2, &
                                            range3, &
                                            range4, &
                                            range5, &
                                            range6 )
         implicit none
         logical(int32), allocatable DEV_ATTR, intent(inout) :: array(:,:,:,:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2), range6(2)
      end subroutine l4_devxlib_mapping_map_l6d
   endinterface

   interface
      module subroutine sp_devxlib_mapping_unmap_r1d(array, ierr)
         implicit none
         real(real32), allocatable DEV_ATTR :: array(:)
         integer, optional, intent(out) :: ierr
      end subroutine sp_devxlib_mapping_unmap_r1d
      module subroutine sp_devxlib_mapping_unmap_r2d(array, ierr)
         implicit none
         real(real32), allocatable DEV_ATTR :: array(:,:)
         integer, optional, intent(out) :: ierr
      end subroutine sp_devxlib_mapping_unmap_r2d
      module subroutine sp_devxlib_mapping_unmap_r3d(array, ierr)
         implicit none
         real(real32), allocatable DEV_ATTR :: array(:,:,:)
         integer, optional, intent(out) :: ierr
      end subroutine sp_devxlib_mapping_unmap_r3d
      module subroutine sp_devxlib_mapping_unmap_r4d(array, ierr)
         implicit none
         real(real32), allocatable DEV_ATTR :: array(:,:,:,:)
         integer, optional, intent(out) :: ierr
      end subroutine sp_devxlib_mapping_unmap_r4d
      module subroutine sp_devxlib_mapping_unmap_r5d(array, ierr)
         implicit none
         real(real32), allocatable DEV_ATTR :: array(:,:,:,:,:)
         integer, optional, intent(out) :: ierr
      end subroutine sp_devxlib_mapping_unmap_r5d
      module subroutine sp_devxlib_mapping_unmap_r6d(array, ierr)
         implicit none
         real(real32), allocatable DEV_ATTR :: array(:,:,:,:,:,:)
         integer, optional, intent(out) :: ierr
      end subroutine sp_devxlib_mapping_unmap_r6d
      module subroutine dp_devxlib_mapping_unmap_r1d(array, ierr)
         implicit none
         real(real64), allocatable DEV_ATTR :: array(:)
         integer, optional, intent(out) :: ierr
      end subroutine dp_devxlib_mapping_unmap_r1d
      module subroutine dp_devxlib_mapping_unmap_r2d(array, ierr)
         implicit none
         real(real64), allocatable DEV_ATTR :: array(:,:)
         integer, optional, intent(out) :: ierr
      end subroutine dp_devxlib_mapping_unmap_r2d
      module subroutine dp_devxlib_mapping_unmap_r3d(array, ierr)
         implicit none
         real(real64), allocatable DEV_ATTR :: array(:,:,:)
         integer, optional, intent(out) :: ierr
      end subroutine dp_devxlib_mapping_unmap_r3d
      module subroutine dp_devxlib_mapping_unmap_r4d(array, ierr)
         implicit none
         real(real64), allocatable DEV_ATTR :: array(:,:,:,:)
         integer, optional, intent(out) :: ierr
      end subroutine dp_devxlib_mapping_unmap_r4d
      module subroutine dp_devxlib_mapping_unmap_r5d(array, ierr)
         implicit none
         real(real64), allocatable DEV_ATTR :: array(:,:,:,:,:)
         integer, optional, intent(out) :: ierr
      end subroutine dp_devxlib_mapping_unmap_r5d
      module subroutine dp_devxlib_mapping_unmap_r6d(array, ierr)
         implicit none
         real(real64), allocatable DEV_ATTR :: array(:,:,:,:,:,:)
         integer, optional, intent(out) :: ierr
      end subroutine dp_devxlib_mapping_unmap_r6d
      module subroutine sp_devxlib_mapping_unmap_c1d(array, ierr)
         implicit none
         complex(real32), allocatable DEV_ATTR :: array(:)
         integer, optional, intent(out) :: ierr
      end subroutine sp_devxlib_mapping_unmap_c1d
      module subroutine sp_devxlib_mapping_unmap_c2d(array, ierr)
         implicit none
         complex(real32), allocatable DEV_ATTR :: array(:,:)
         integer, optional, intent(out) :: ierr
      end subroutine sp_devxlib_mapping_unmap_c2d
      module subroutine sp_devxlib_mapping_unmap_c3d(array, ierr)
         implicit none
         complex(real32), allocatable DEV_ATTR :: array(:,:,:)
         integer, optional, intent(out) :: ierr
      end subroutine sp_devxlib_mapping_unmap_c3d
      module subroutine sp_devxlib_mapping_unmap_c4d(array, ierr)
         implicit none
         complex(real32), allocatable DEV_ATTR :: array(:,:,:,:)
         integer, optional, intent(out) :: ierr
      end subroutine sp_devxlib_mapping_unmap_c4d
      module subroutine sp_devxlib_mapping_unmap_c5d(array, ierr)
         implicit none
         complex(real32), allocatable DEV_ATTR :: array(:,:,:,:,:)
         integer, optional, intent(out) :: ierr
      end subroutine sp_devxlib_mapping_unmap_c5d
      module subroutine sp_devxlib_mapping_unmap_c6d(array, ierr)
         implicit none
         complex(real32), allocatable DEV_ATTR :: array(:,:,:,:,:,:)
         integer, optional, intent(out) :: ierr
      end subroutine sp_devxlib_mapping_unmap_c6d
      module subroutine dp_devxlib_mapping_unmap_c1d(array, ierr)
         implicit none
         complex(real64), allocatable DEV_ATTR :: array(:)
         integer, optional, intent(out) :: ierr
      end subroutine dp_devxlib_mapping_unmap_c1d
      module subroutine dp_devxlib_mapping_unmap_c2d(array, ierr)
         implicit none
         complex(real64), allocatable DEV_ATTR :: array(:,:)
         integer, optional, intent(out) :: ierr
      end subroutine dp_devxlib_mapping_unmap_c2d
      module subroutine dp_devxlib_mapping_unmap_c3d(array, ierr)
         implicit none
         complex(real64), allocatable DEV_ATTR :: array(:,:,:)
         integer, optional, intent(out) :: ierr
      end subroutine dp_devxlib_mapping_unmap_c3d
      module subroutine dp_devxlib_mapping_unmap_c4d(array, ierr)
         implicit none
         complex(real64), allocatable DEV_ATTR :: array(:,:,:,:)
         integer, optional, intent(out) :: ierr
      end subroutine dp_devxlib_mapping_unmap_c4d
      module subroutine dp_devxlib_mapping_unmap_c5d(array, ierr)
         implicit none
         complex(real64), allocatable DEV_ATTR :: array(:,:,:,:,:)
         integer, optional, intent(out) :: ierr
      end subroutine dp_devxlib_mapping_unmap_c5d
      module subroutine dp_devxlib_mapping_unmap_c6d(array, ierr)
         implicit none
         complex(real64), allocatable DEV_ATTR :: array(:,:,:,:,:,:)
         integer, optional, intent(out) :: ierr
      end subroutine dp_devxlib_mapping_unmap_c6d
      module subroutine i4_devxlib_mapping_unmap_i1d(array, ierr)
         implicit none
         integer(int32), allocatable DEV_ATTR :: array(:)
         integer, optional, intent(out) :: ierr
      end subroutine i4_devxlib_mapping_unmap_i1d
      module subroutine i4_devxlib_mapping_unmap_i2d(array, ierr)
         implicit none
         integer(int32), allocatable DEV_ATTR :: array(:,:)
         integer, optional, intent(out) :: ierr
      end subroutine i4_devxlib_mapping_unmap_i2d
      module subroutine i4_devxlib_mapping_unmap_i3d(array, ierr)
         implicit none
         integer(int32), allocatable DEV_ATTR :: array(:,:,:)
         integer, optional, intent(out) :: ierr
      end subroutine i4_devxlib_mapping_unmap_i3d
      module subroutine i4_devxlib_mapping_unmap_i4d(array, ierr)
         implicit none
         integer(int32), allocatable DEV_ATTR :: array(:,:,:,:)
         integer, optional, intent(out) :: ierr
      end subroutine i4_devxlib_mapping_unmap_i4d
      module subroutine i4_devxlib_mapping_unmap_i5d(array, ierr)
         implicit none
         integer(int32), allocatable DEV_ATTR :: array(:,:,:,:,:)
         integer, optional, intent(out) :: ierr
      end subroutine i4_devxlib_mapping_unmap_i5d
      module subroutine i4_devxlib_mapping_unmap_i6d(array, ierr)
         implicit none
         integer(int32), allocatable DEV_ATTR :: array(:,:,:,:,:,:)
         integer, optional, intent(out) :: ierr
      end subroutine i4_devxlib_mapping_unmap_i6d
      module subroutine i8_devxlib_mapping_unmap_i1d(array, ierr)
         implicit none
         integer(int64), allocatable DEV_ATTR :: array(:)
         integer, optional, intent(out) :: ierr
      end subroutine i8_devxlib_mapping_unmap_i1d
      module subroutine i8_devxlib_mapping_unmap_i2d(array, ierr)
         implicit none
         integer(int64), allocatable DEV_ATTR :: array(:,:)
         integer, optional, intent(out) :: ierr
      end subroutine i8_devxlib_mapping_unmap_i2d
      module subroutine i8_devxlib_mapping_unmap_i3d(array, ierr)
         implicit none
         integer(int64), allocatable DEV_ATTR :: array(:,:,:)
         integer, optional, intent(out) :: ierr
      end subroutine i8_devxlib_mapping_unmap_i3d
      module subroutine i8_devxlib_mapping_unmap_i4d(array, ierr)
         implicit none
         integer(int64), allocatable DEV_ATTR :: array(:,:,:,:)
         integer, optional, intent(out) :: ierr
      end subroutine i8_devxlib_mapping_unmap_i4d
      module subroutine i8_devxlib_mapping_unmap_i5d(array, ierr)
         implicit none
         integer(int64), allocatable DEV_ATTR :: array(:,:,:,:,:)
         integer, optional, intent(out) :: ierr
      end subroutine i8_devxlib_mapping_unmap_i5d
      module subroutine i8_devxlib_mapping_unmap_i6d(array, ierr)
         implicit none
         integer(int64), allocatable DEV_ATTR :: array(:,:,:,:,:,:)
         integer, optional, intent(out) :: ierr
      end subroutine i8_devxlib_mapping_unmap_i6d
      module subroutine l4_devxlib_mapping_unmap_l1d(array, ierr)
         implicit none
         logical(int32), allocatable DEV_ATTR :: array(:)
         integer, optional, intent(out) :: ierr
      end subroutine l4_devxlib_mapping_unmap_l1d
      module subroutine l4_devxlib_mapping_unmap_l2d(array, ierr)
         implicit none
         logical(int32), allocatable DEV_ATTR :: array(:,:)
         integer, optional, intent(out) :: ierr
      end subroutine l4_devxlib_mapping_unmap_l2d
      module subroutine l4_devxlib_mapping_unmap_l3d(array, ierr)
         implicit none
         logical(int32), allocatable DEV_ATTR :: array(:,:,:)
         integer, optional, intent(out) :: ierr
      end subroutine l4_devxlib_mapping_unmap_l3d
      module subroutine l4_devxlib_mapping_unmap_l4d(array, ierr)
         implicit none
         logical(int32), allocatable DEV_ATTR :: array(:,:,:,:)
         integer, optional, intent(out) :: ierr
      end subroutine l4_devxlib_mapping_unmap_l4d
      module subroutine l4_devxlib_mapping_unmap_l5d(array, ierr)
         implicit none
         logical(int32), allocatable DEV_ATTR :: array(:,:,:,:,:)
         integer, optional, intent(out) :: ierr
      end subroutine l4_devxlib_mapping_unmap_l5d
      module subroutine l4_devxlib_mapping_unmap_l6d(array, ierr)
         implicit none
         logical(int32), allocatable DEV_ATTR :: array(:,:,:,:,:,:)
         integer, optional, intent(out) :: ierr
      end subroutine l4_devxlib_mapping_unmap_l6d
   endinterface

   interface
      module function sp_devxlib_mapping_mapped_r1d(array) result(res)
         implicit none
         logical :: res
#if defined __DXL_OPENMP_GPU
         real(real32), allocatable, target :: array(:)
#else
         real(real32), allocatable DEV_ATTR :: array(:)
#endif
      end function sp_devxlib_mapping_mapped_r1d
      module function sp_devxlib_mapping_mapped_r2d(array) result(res)
         implicit none
         logical :: res
#if defined __DXL_OPENMP_GPU
         real(real32), allocatable, target :: array(:,:)
#else
         real(real32), allocatable DEV_ATTR :: array(:,:)
#endif
      end function sp_devxlib_mapping_mapped_r2d
      module function sp_devxlib_mapping_mapped_r3d(array) result(res)
         implicit none
         logical :: res
#if defined __DXL_OPENMP_GPU
         real(real32), allocatable, target :: array(:,:,:)
#else
         real(real32), allocatable DEV_ATTR :: array(:,:,:)
#endif
      end function sp_devxlib_mapping_mapped_r3d
      module function sp_devxlib_mapping_mapped_r4d(array) result(res)
         implicit none
         logical :: res
#if defined __DXL_OPENMP_GPU
         real(real32), allocatable, target :: array(:,:,:,:)
#else
         real(real32), allocatable DEV_ATTR :: array(:,:,:,:)
#endif
      end function sp_devxlib_mapping_mapped_r4d
      module function sp_devxlib_mapping_mapped_r5d(array) result(res)
         implicit none
         logical :: res
#if defined __DXL_OPENMP_GPU
         real(real32), allocatable, target :: array(:,:,:,:,:)
#else
         real(real32), allocatable DEV_ATTR :: array(:,:,:,:,:)
#endif
      end function sp_devxlib_mapping_mapped_r5d
      module function sp_devxlib_mapping_mapped_r6d(array) result(res)
         implicit none
         logical :: res
#if defined __DXL_OPENMP_GPU
         real(real32), allocatable, target :: array(:,:,:,:,:,:)
#else
         real(real32), allocatable DEV_ATTR :: array(:,:,:,:,:,:)
#endif
      end function sp_devxlib_mapping_mapped_r6d
      module function dp_devxlib_mapping_mapped_r1d(array) result(res)
         implicit none
         logical :: res
#if defined __DXL_OPENMP_GPU
         real(real64), allocatable, target :: array(:)
#else
         real(real64), allocatable DEV_ATTR :: array(:)
#endif
      end function dp_devxlib_mapping_mapped_r1d
      module function dp_devxlib_mapping_mapped_r2d(array) result(res)
         implicit none
         logical :: res
#if defined __DXL_OPENMP_GPU
         real(real64), allocatable, target :: array(:,:)
#else
         real(real64), allocatable DEV_ATTR :: array(:,:)
#endif
      end function dp_devxlib_mapping_mapped_r2d
      module function dp_devxlib_mapping_mapped_r3d(array) result(res)
         implicit none
         logical :: res
#if defined __DXL_OPENMP_GPU
         real(real64), allocatable, target :: array(:,:,:)
#else
         real(real64), allocatable DEV_ATTR :: array(:,:,:)
#endif
      end function dp_devxlib_mapping_mapped_r3d
      module function dp_devxlib_mapping_mapped_r4d(array) result(res)
         implicit none
         logical :: res
#if defined __DXL_OPENMP_GPU
         real(real64), allocatable, target :: array(:,:,:,:)
#else
         real(real64), allocatable DEV_ATTR :: array(:,:,:,:)
#endif
      end function dp_devxlib_mapping_mapped_r4d
      module function dp_devxlib_mapping_mapped_r5d(array) result(res)
         implicit none
         logical :: res
#if defined __DXL_OPENMP_GPU
         real(real64), allocatable, target :: array(:,:,:,:,:)
#else
         real(real64), allocatable DEV_ATTR :: array(:,:,:,:,:)
#endif
      end function dp_devxlib_mapping_mapped_r5d
      module function dp_devxlib_mapping_mapped_r6d(array) result(res)
         implicit none
         logical :: res
#if defined __DXL_OPENMP_GPU
         real(real64), allocatable, target :: array(:,:,:,:,:,:)
#else
         real(real64), allocatable DEV_ATTR :: array(:,:,:,:,:,:)
#endif
      end function dp_devxlib_mapping_mapped_r6d
      module function sp_devxlib_mapping_mapped_c1d(array) result(res)
         implicit none
         logical :: res
#if defined __DXL_OPENMP_GPU
         complex(real32), allocatable, target :: array(:)
#else
         complex(real32), allocatable DEV_ATTR :: array(:)
#endif
      end function sp_devxlib_mapping_mapped_c1d
      module function sp_devxlib_mapping_mapped_c2d(array) result(res)
         implicit none
         logical :: res
#if defined __DXL_OPENMP_GPU
         complex(real32), allocatable, target :: array(:,:)
#else
         complex(real32), allocatable DEV_ATTR :: array(:,:)
#endif
      end function sp_devxlib_mapping_mapped_c2d
      module function sp_devxlib_mapping_mapped_c3d(array) result(res)
         implicit none
         logical :: res
#if defined __DXL_OPENMP_GPU
         complex(real32), allocatable, target :: array(:,:,:)
#else
         complex(real32), allocatable DEV_ATTR :: array(:,:,:)
#endif
      end function sp_devxlib_mapping_mapped_c3d
      module function sp_devxlib_mapping_mapped_c4d(array) result(res)
         implicit none
         logical :: res
#if defined __DXL_OPENMP_GPU
         complex(real32), allocatable, target :: array(:,:,:,:)
#else
         complex(real32), allocatable DEV_ATTR :: array(:,:,:,:)
#endif
      end function sp_devxlib_mapping_mapped_c4d
      module function sp_devxlib_mapping_mapped_c5d(array) result(res)
         implicit none
         logical :: res
#if defined __DXL_OPENMP_GPU
         complex(real32), allocatable, target :: array(:,:,:,:,:)
#else
         complex(real32), allocatable DEV_ATTR :: array(:,:,:,:,:)
#endif
      end function sp_devxlib_mapping_mapped_c5d
      module function sp_devxlib_mapping_mapped_c6d(array) result(res)
         implicit none
         logical :: res
#if defined __DXL_OPENMP_GPU
         complex(real32), allocatable, target :: array(:,:,:,:,:,:)
#else
         complex(real32), allocatable DEV_ATTR :: array(:,:,:,:,:,:)
#endif
      end function sp_devxlib_mapping_mapped_c6d
      module function dp_devxlib_mapping_mapped_c1d(array) result(res)
         implicit none
         logical :: res
#if defined __DXL_OPENMP_GPU
         complex(real64), allocatable, target :: array(:)
#else
         complex(real64), allocatable DEV_ATTR :: array(:)
#endif
      end function dp_devxlib_mapping_mapped_c1d
      module function dp_devxlib_mapping_mapped_c2d(array) result(res)
         implicit none
         logical :: res
#if defined __DXL_OPENMP_GPU
         complex(real64), allocatable, target :: array(:,:)
#else
         complex(real64), allocatable DEV_ATTR :: array(:,:)
#endif
      end function dp_devxlib_mapping_mapped_c2d
      module function dp_devxlib_mapping_mapped_c3d(array) result(res)
         implicit none
         logical :: res
#if defined __DXL_OPENMP_GPU
         complex(real64), allocatable, target :: array(:,:,:)
#else
         complex(real64), allocatable DEV_ATTR :: array(:,:,:)
#endif
      end function dp_devxlib_mapping_mapped_c3d
      module function dp_devxlib_mapping_mapped_c4d(array) result(res)
         implicit none
         logical :: res
#if defined __DXL_OPENMP_GPU
         complex(real64), allocatable, target :: array(:,:,:,:)
#else
         complex(real64), allocatable DEV_ATTR :: array(:,:,:,:)
#endif
      end function dp_devxlib_mapping_mapped_c4d
      module function dp_devxlib_mapping_mapped_c5d(array) result(res)
         implicit none
         logical :: res
#if defined __DXL_OPENMP_GPU
         complex(real64), allocatable, target :: array(:,:,:,:,:)
#else
         complex(real64), allocatable DEV_ATTR :: array(:,:,:,:,:)
#endif
      end function dp_devxlib_mapping_mapped_c5d
      module function dp_devxlib_mapping_mapped_c6d(array) result(res)
         implicit none
         logical :: res
#if defined __DXL_OPENMP_GPU
         complex(real64), allocatable, target :: array(:,:,:,:,:,:)
#else
         complex(real64), allocatable DEV_ATTR :: array(:,:,:,:,:,:)
#endif
      end function dp_devxlib_mapping_mapped_c6d
      module function i4_devxlib_mapping_mapped_i1d(array) result(res)
         implicit none
         logical :: res
#if defined __DXL_OPENMP_GPU
         integer(int32), allocatable, target :: array(:)
#else
         integer(int32), allocatable DEV_ATTR :: array(:)
#endif
      end function i4_devxlib_mapping_mapped_i1d
      module function i4_devxlib_mapping_mapped_i2d(array) result(res)
         implicit none
         logical :: res
#if defined __DXL_OPENMP_GPU
         integer(int32), allocatable, target :: array(:,:)
#else
         integer(int32), allocatable DEV_ATTR :: array(:,:)
#endif
      end function i4_devxlib_mapping_mapped_i2d
      module function i4_devxlib_mapping_mapped_i3d(array) result(res)
         implicit none
         logical :: res
#if defined __DXL_OPENMP_GPU
         integer(int32), allocatable, target :: array(:,:,:)
#else
         integer(int32), allocatable DEV_ATTR :: array(:,:,:)
#endif
      end function i4_devxlib_mapping_mapped_i3d
      module function i4_devxlib_mapping_mapped_i4d(array) result(res)
         implicit none
         logical :: res
#if defined __DXL_OPENMP_GPU
         integer(int32), allocatable, target :: array(:,:,:,:)
#else
         integer(int32), allocatable DEV_ATTR :: array(:,:,:,:)
#endif
      end function i4_devxlib_mapping_mapped_i4d
      module function i4_devxlib_mapping_mapped_i5d(array) result(res)
         implicit none
         logical :: res
#if defined __DXL_OPENMP_GPU
         integer(int32), allocatable, target :: array(:,:,:,:,:)
#else
         integer(int32), allocatable DEV_ATTR :: array(:,:,:,:,:)
#endif
      end function i4_devxlib_mapping_mapped_i5d
      module function i4_devxlib_mapping_mapped_i6d(array) result(res)
         implicit none
         logical :: res
#if defined __DXL_OPENMP_GPU
         integer(int32), allocatable, target :: array(:,:,:,:,:,:)
#else
         integer(int32), allocatable DEV_ATTR :: array(:,:,:,:,:,:)
#endif
      end function i4_devxlib_mapping_mapped_i6d
      module function i8_devxlib_mapping_mapped_i1d(array) result(res)
         implicit none
         logical :: res
#if defined __DXL_OPENMP_GPU
         integer(int64), allocatable, target :: array(:)
#else
         integer(int64), allocatable DEV_ATTR :: array(:)
#endif
      end function i8_devxlib_mapping_mapped_i1d
      module function i8_devxlib_mapping_mapped_i2d(array) result(res)
         implicit none
         logical :: res
#if defined __DXL_OPENMP_GPU
         integer(int64), allocatable, target :: array(:,:)
#else
         integer(int64), allocatable DEV_ATTR :: array(:,:)
#endif
      end function i8_devxlib_mapping_mapped_i2d
      module function i8_devxlib_mapping_mapped_i3d(array) result(res)
         implicit none
         logical :: res
#if defined __DXL_OPENMP_GPU
         integer(int64), allocatable, target :: array(:,:,:)
#else
         integer(int64), allocatable DEV_ATTR :: array(:,:,:)
#endif
      end function i8_devxlib_mapping_mapped_i3d
      module function i8_devxlib_mapping_mapped_i4d(array) result(res)
         implicit none
         logical :: res
#if defined __DXL_OPENMP_GPU
         integer(int64), allocatable, target :: array(:,:,:,:)
#else
         integer(int64), allocatable DEV_ATTR :: array(:,:,:,:)
#endif
      end function i8_devxlib_mapping_mapped_i4d
      module function i8_devxlib_mapping_mapped_i5d(array) result(res)
         implicit none
         logical :: res
#if defined __DXL_OPENMP_GPU
         integer(int64), allocatable, target :: array(:,:,:,:,:)
#else
         integer(int64), allocatable DEV_ATTR :: array(:,:,:,:,:)
#endif
      end function i8_devxlib_mapping_mapped_i5d
      module function i8_devxlib_mapping_mapped_i6d(array) result(res)
         implicit none
         logical :: res
#if defined __DXL_OPENMP_GPU
         integer(int64), allocatable, target :: array(:,:,:,:,:,:)
#else
         integer(int64), allocatable DEV_ATTR :: array(:,:,:,:,:,:)
#endif
      end function i8_devxlib_mapping_mapped_i6d
      module function l4_devxlib_mapping_mapped_l1d(array) result(res)
         implicit none
         logical :: res
#if defined __DXL_OPENMP_GPU
         logical(int32), allocatable, target :: array(:)
#else
         logical(int32), allocatable DEV_ATTR :: array(:)
#endif
      end function l4_devxlib_mapping_mapped_l1d
      module function l4_devxlib_mapping_mapped_l2d(array) result(res)
         implicit none
         logical :: res
#if defined __DXL_OPENMP_GPU
         logical(int32), allocatable, target :: array(:,:)
#else
         logical(int32), allocatable DEV_ATTR :: array(:,:)
#endif
      end function l4_devxlib_mapping_mapped_l2d
      module function l4_devxlib_mapping_mapped_l3d(array) result(res)
         implicit none
         logical :: res
#if defined __DXL_OPENMP_GPU
         logical(int32), allocatable, target :: array(:,:,:)
#else
         logical(int32), allocatable DEV_ATTR :: array(:,:,:)
#endif
      end function l4_devxlib_mapping_mapped_l3d
      module function l4_devxlib_mapping_mapped_l4d(array) result(res)
         implicit none
         logical :: res
#if defined __DXL_OPENMP_GPU
         logical(int32), allocatable, target :: array(:,:,:,:)
#else
         logical(int32), allocatable DEV_ATTR :: array(:,:,:,:)
#endif
      end function l4_devxlib_mapping_mapped_l4d
      module function l4_devxlib_mapping_mapped_l5d(array) result(res)
         implicit none
         logical :: res
#if defined __DXL_OPENMP_GPU
         logical(int32), allocatable, target :: array(:,:,:,:,:)
#else
         logical(int32), allocatable DEV_ATTR :: array(:,:,:,:,:)
#endif
      end function l4_devxlib_mapping_mapped_l5d
      module function l4_devxlib_mapping_mapped_l6d(array) result(res)
         implicit none
         logical :: res
#if defined __DXL_OPENMP_GPU
         logical(int32), allocatable, target :: array(:,:,:,:,:,:)
#else
         logical(int32), allocatable DEV_ATTR :: array(:,:,:,:,:,:)
#endif
      end function l4_devxlib_mapping_mapped_l6d
   endinterface
endmodule devxlib_mapping

!
! Copyright (C) 2021, MaX CoE
! Distributed under the MIT License
! (license terms are at http://opensource.org/licenses/MIT).
!
!--
!
! cublas defs and interfaces
!
#include<devxlib_defs.h>
#include<devxlib_macros.h>
!
module devxlib_cublas
  !
#if defined __DXL_CUDAF
  use cublas
#endif
#if defined __DXL_CUBLAS && !defined __DXL_CUDAF
  use cublas_core_m
  use cublas_m
#endif
  !
  use iso_c_binding
  implicit none
  !
#if defined __DXL_CUBLAS
  type(cublasHandle) :: cublas_handle
#else
  type(c_ptr)        :: cublas_handle    ! just to have the symbol defined
#endif
  !
end module devxlib_cublas

!
! Copyright (C) 2002-2018 Quantum ESPRESSO group
! This file is distributed under the terms of the
! GNU General Public License. See the file `License'
! in the root directory of the present distribution,
! or http://www.gnu.org/copyleft/gpl.txt .
!
! Auxiliary functions
!
#include<device_macros.h>
!
!=======================================
!

subroutine dp_dev_conjg_c1d(array_inout, &
                                    
                                   range1, lbound1 )
    implicit none
    !
    integer, parameter :: PRCSN = selected_real_kind(14,200)
    complex(PRCSN), intent(inout) :: array_inout(:)
    integer, optional, intent(in) ::  range1(2)
    integer, optional, intent(in) ::  lbound1
#if defined(__CUDA)
    attributes(device) :: array_inout
#endif
    !
    integer :: i1, d1s, d1e
    integer :: lbound1_, range1_(2)
    !
    lbound1_=1
    if (present(lbound1)) lbound1_=lbound1 
    range1_=(/1,size(array_inout, 1)/)
    if (present(range1)) range1_=range1 
    !
    d1s = range1_(1) -lbound1_ +1
    d1e = range1_(2) -lbound1_ +1
    !
    !
    !$cuf kernel do(1)
    do i1 = d1s, d1e
        array_inout(i1 ) = &
            conjg (  array_inout (i1 ) )
    enddo
    !
end subroutine dp_dev_conjg_c1d
!
subroutine dp_dev_conjg_c2d(array_inout, &
                                    
                                   range1, lbound1, & 
                                   range2, lbound2 )
    implicit none
    !
    integer, parameter :: PRCSN = selected_real_kind(14,200)
    complex(PRCSN), intent(inout) :: array_inout(:,:)
    integer, optional, intent(in) ::  range1(2), range2(2)
    integer, optional, intent(in) ::  lbound1, lbound2
#if defined(__CUDA)
    attributes(device) :: array_inout
#endif
    !
    integer :: i1, d1s, d1e
    integer :: lbound1_, range1_(2)
    integer :: i2, d2s, d2e
    integer :: lbound2_, range2_(2)
    !
    lbound1_=1
    if (present(lbound1)) lbound1_=lbound1 
    range1_=(/1,size(array_inout, 1)/)
    if (present(range1)) range1_=range1 
    !
    d1s = range1_(1) -lbound1_ +1
    d1e = range1_(2) -lbound1_ +1
    !
    lbound2_=1
    if (present(lbound2)) lbound2_=lbound2 
    range2_=(/1,size(array_inout, 2)/)
    if (present(range2)) range2_=range2 
    !
    d2s = range2_(1) -lbound2_ +1
    d2e = range2_(2) -lbound2_ +1
    !
    !
    !$cuf kernel do(2)
    do i2 = d2s, d2e
    do i1 = d1s, d1e
        array_inout(i1,i2 ) = &
            conjg (  array_inout (i1,i2 ) )
    enddo
    enddo
    !
end subroutine dp_dev_conjg_c2d
!
subroutine dp_dev_conjg_c3d(array_inout, &
                                    
                                   range1, lbound1, & 
                                   range2, lbound2, & 
                                   range3, lbound3 )
    implicit none
    !
    integer, parameter :: PRCSN = selected_real_kind(14,200)
    complex(PRCSN), intent(inout) :: array_inout(:,:,:)
    integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
    integer, optional, intent(in) ::  lbound1, lbound2, lbound3
#if defined(__CUDA)
    attributes(device) :: array_inout
#endif
    !
    integer :: i1, d1s, d1e
    integer :: lbound1_, range1_(2)
    integer :: i2, d2s, d2e
    integer :: lbound2_, range2_(2)
    integer :: i3, d3s, d3e
    integer :: lbound3_, range3_(2)
    !
    lbound1_=1
    if (present(lbound1)) lbound1_=lbound1 
    range1_=(/1,size(array_inout, 1)/)
    if (present(range1)) range1_=range1 
    !
    d1s = range1_(1) -lbound1_ +1
    d1e = range1_(2) -lbound1_ +1
    !
    lbound2_=1
    if (present(lbound2)) lbound2_=lbound2 
    range2_=(/1,size(array_inout, 2)/)
    if (present(range2)) range2_=range2 
    !
    d2s = range2_(1) -lbound2_ +1
    d2e = range2_(2) -lbound2_ +1
    !
    lbound3_=1
    if (present(lbound3)) lbound3_=lbound3 
    range3_=(/1,size(array_inout, 3)/)
    if (present(range3)) range3_=range3 
    !
    d3s = range3_(1) -lbound3_ +1
    d3e = range3_(2) -lbound3_ +1
    !
    !
    !$cuf kernel do(3)
    do i3 = d3s, d3e
    do i2 = d2s, d2e
    do i1 = d1s, d1e
        array_inout(i1,i2,i3 ) = &
            conjg (  array_inout (i1,i2,i3 ) )
    enddo
    enddo
    enddo
    !
end subroutine dp_dev_conjg_c3d
!
subroutine dp_dev_conjg_c4d(array_inout, &
                                    
                                   range1, lbound1, & 
                                   range2, lbound2, & 
                                   range3, lbound3, & 
                                   range4, lbound4 )
    implicit none
    !
    integer, parameter :: PRCSN = selected_real_kind(14,200)
    complex(PRCSN), intent(inout) :: array_inout(:,:,:,:)
    integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
    integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
#if defined(__CUDA)
    attributes(device) :: array_inout
#endif
    !
    integer :: i1, d1s, d1e
    integer :: lbound1_, range1_(2)
    integer :: i2, d2s, d2e
    integer :: lbound2_, range2_(2)
    integer :: i3, d3s, d3e
    integer :: lbound3_, range3_(2)
    integer :: i4, d4s, d4e
    integer :: lbound4_, range4_(2)
    !
    lbound1_=1
    if (present(lbound1)) lbound1_=lbound1 
    range1_=(/1,size(array_inout, 1)/)
    if (present(range1)) range1_=range1 
    !
    d1s = range1_(1) -lbound1_ +1
    d1e = range1_(2) -lbound1_ +1
    !
    lbound2_=1
    if (present(lbound2)) lbound2_=lbound2 
    range2_=(/1,size(array_inout, 2)/)
    if (present(range2)) range2_=range2 
    !
    d2s = range2_(1) -lbound2_ +1
    d2e = range2_(2) -lbound2_ +1
    !
    lbound3_=1
    if (present(lbound3)) lbound3_=lbound3 
    range3_=(/1,size(array_inout, 3)/)
    if (present(range3)) range3_=range3 
    !
    d3s = range3_(1) -lbound3_ +1
    d3e = range3_(2) -lbound3_ +1
    !
    lbound4_=1
    if (present(lbound4)) lbound4_=lbound4 
    range4_=(/1,size(array_inout, 4)/)
    if (present(range4)) range4_=range4 
    !
    d4s = range4_(1) -lbound4_ +1
    d4e = range4_(2) -lbound4_ +1
    !
    !
    !$cuf kernel do(4)
    do i4 = d4s, d4e
    do i3 = d3s, d3e
    do i2 = d2s, d2e
    do i1 = d1s, d1e
        array_inout(i1,i2,i3,i4 ) = &
            conjg (  array_inout (i1,i2,i3,i4 ) )
    enddo
    enddo
    enddo
    enddo
    !
end subroutine dp_dev_conjg_c4d
!
subroutine sp_dev_conjg_c1d(array_inout, &
                                    
                                   range1, lbound1 )
    implicit none
    !
    integer, parameter :: PRCSN = selected_real_kind(6, 37)
    complex(PRCSN), intent(inout) :: array_inout(:)
    integer, optional, intent(in) ::  range1(2)
    integer, optional, intent(in) ::  lbound1
#if defined(__CUDA)
    attributes(device) :: array_inout
#endif
    !
    integer :: i1, d1s, d1e
    integer :: lbound1_, range1_(2)
    !
    lbound1_=1
    if (present(lbound1)) lbound1_=lbound1 
    range1_=(/1,size(array_inout, 1)/)
    if (present(range1)) range1_=range1 
    !
    d1s = range1_(1) -lbound1_ +1
    d1e = range1_(2) -lbound1_ +1
    !
    !
    !$cuf kernel do(1)
    do i1 = d1s, d1e
        array_inout(i1 ) = &
            conjg (  array_inout (i1 ) )
    enddo
    !
end subroutine sp_dev_conjg_c1d
!
subroutine sp_dev_conjg_c2d(array_inout, &
                                    
                                   range1, lbound1, & 
                                   range2, lbound2 )
    implicit none
    !
    integer, parameter :: PRCSN = selected_real_kind(6, 37)
    complex(PRCSN), intent(inout) :: array_inout(:,:)
    integer, optional, intent(in) ::  range1(2), range2(2)
    integer, optional, intent(in) ::  lbound1, lbound2
#if defined(__CUDA)
    attributes(device) :: array_inout
#endif
    !
    integer :: i1, d1s, d1e
    integer :: lbound1_, range1_(2)
    integer :: i2, d2s, d2e
    integer :: lbound2_, range2_(2)
    !
    lbound1_=1
    if (present(lbound1)) lbound1_=lbound1 
    range1_=(/1,size(array_inout, 1)/)
    if (present(range1)) range1_=range1 
    !
    d1s = range1_(1) -lbound1_ +1
    d1e = range1_(2) -lbound1_ +1
    !
    lbound2_=1
    if (present(lbound2)) lbound2_=lbound2 
    range2_=(/1,size(array_inout, 2)/)
    if (present(range2)) range2_=range2 
    !
    d2s = range2_(1) -lbound2_ +1
    d2e = range2_(2) -lbound2_ +1
    !
    !
    !$cuf kernel do(2)
    do i2 = d2s, d2e
    do i1 = d1s, d1e
        array_inout(i1,i2 ) = &
            conjg (  array_inout (i1,i2 ) )
    enddo
    enddo
    !
end subroutine sp_dev_conjg_c2d
!
subroutine sp_dev_conjg_c3d(array_inout, &
                                    
                                   range1, lbound1, & 
                                   range2, lbound2, & 
                                   range3, lbound3 )
    implicit none
    !
    integer, parameter :: PRCSN = selected_real_kind(6, 37)
    complex(PRCSN), intent(inout) :: array_inout(:,:,:)
    integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
    integer, optional, intent(in) ::  lbound1, lbound2, lbound3
#if defined(__CUDA)
    attributes(device) :: array_inout
#endif
    !
    integer :: i1, d1s, d1e
    integer :: lbound1_, range1_(2)
    integer :: i2, d2s, d2e
    integer :: lbound2_, range2_(2)
    integer :: i3, d3s, d3e
    integer :: lbound3_, range3_(2)
    !
    lbound1_=1
    if (present(lbound1)) lbound1_=lbound1 
    range1_=(/1,size(array_inout, 1)/)
    if (present(range1)) range1_=range1 
    !
    d1s = range1_(1) -lbound1_ +1
    d1e = range1_(2) -lbound1_ +1
    !
    lbound2_=1
    if (present(lbound2)) lbound2_=lbound2 
    range2_=(/1,size(array_inout, 2)/)
    if (present(range2)) range2_=range2 
    !
    d2s = range2_(1) -lbound2_ +1
    d2e = range2_(2) -lbound2_ +1
    !
    lbound3_=1
    if (present(lbound3)) lbound3_=lbound3 
    range3_=(/1,size(array_inout, 3)/)
    if (present(range3)) range3_=range3 
    !
    d3s = range3_(1) -lbound3_ +1
    d3e = range3_(2) -lbound3_ +1
    !
    !
    !$cuf kernel do(3)
    do i3 = d3s, d3e
    do i2 = d2s, d2e
    do i1 = d1s, d1e
        array_inout(i1,i2,i3 ) = &
            conjg (  array_inout (i1,i2,i3 ) )
    enddo
    enddo
    enddo
    !
end subroutine sp_dev_conjg_c3d
!
subroutine sp_dev_conjg_c4d(array_inout, &
                                    
                                   range1, lbound1, & 
                                   range2, lbound2, & 
                                   range3, lbound3, & 
                                   range4, lbound4 )
    implicit none
    !
    integer, parameter :: PRCSN = selected_real_kind(6, 37)
    complex(PRCSN), intent(inout) :: array_inout(:,:,:,:)
    integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
    integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
#if defined(__CUDA)
    attributes(device) :: array_inout
#endif
    !
    integer :: i1, d1s, d1e
    integer :: lbound1_, range1_(2)
    integer :: i2, d2s, d2e
    integer :: lbound2_, range2_(2)
    integer :: i3, d3s, d3e
    integer :: lbound3_, range3_(2)
    integer :: i4, d4s, d4e
    integer :: lbound4_, range4_(2)
    !
    lbound1_=1
    if (present(lbound1)) lbound1_=lbound1 
    range1_=(/1,size(array_inout, 1)/)
    if (present(range1)) range1_=range1 
    !
    d1s = range1_(1) -lbound1_ +1
    d1e = range1_(2) -lbound1_ +1
    !
    lbound2_=1
    if (present(lbound2)) lbound2_=lbound2 
    range2_=(/1,size(array_inout, 2)/)
    if (present(range2)) range2_=range2 
    !
    d2s = range2_(1) -lbound2_ +1
    d2e = range2_(2) -lbound2_ +1
    !
    lbound3_=1
    if (present(lbound3)) lbound3_=lbound3 
    range3_=(/1,size(array_inout, 3)/)
    if (present(range3)) range3_=range3 
    !
    d3s = range3_(1) -lbound3_ +1
    d3e = range3_(2) -lbound3_ +1
    !
    lbound4_=1
    if (present(lbound4)) lbound4_=lbound4 
    range4_=(/1,size(array_inout, 4)/)
    if (present(range4)) range4_=range4 
    !
    d4s = range4_(1) -lbound4_ +1
    d4e = range4_(2) -lbound4_ +1
    !
    !
    !$cuf kernel do(4)
    do i4 = d4s, d4e
    do i3 = d3s, d3e
    do i2 = d2s, d2e
    do i1 = d1s, d1e
        array_inout(i1,i2,i3,i4 ) = &
            conjg (  array_inout (i1,i2,i3,i4 ) )
    enddo
    enddo
    enddo
    enddo
    !
end subroutine sp_dev_conjg_c4d
!
!
!=======================================
!
#if defined(__HAVE_DEVICE)
!

subroutine dp_dev_conjg_h_c1d(array_inout, &
                                    
                                   range1, lbound1 )
    implicit none
    !
    integer, parameter :: PRCSN = selected_real_kind(14,200)
    complex(PRCSN), intent(inout) :: array_inout(:)
    integer, optional, intent(in) ::  range1(2)
    integer, optional, intent(in) ::  lbound1
    !
    integer :: i1, d1s, d1e
    integer :: lbound1_, range1_(2)
    !
    lbound1_=1
    if (present(lbound1)) lbound1_=lbound1 
    range1_=(/1,size(array_inout, 1)/)
    if (present(range1)) range1_=range1 
    !
    d1s = range1_(1) -lbound1_ +1
    d1e = range1_(2) -lbound1_ +1
    !
    !
    do i1 = d1s, d1e
        array_inout(i1 ) = &
            conjg (  array_inout (i1 ) )
    enddo
    !
end subroutine dp_dev_conjg_h_c1d
!
subroutine dp_dev_conjg_h_c2d(array_inout, &
                                    
                                   range1, lbound1, & 
                                   range2, lbound2 )
    implicit none
    !
    integer, parameter :: PRCSN = selected_real_kind(14,200)
    complex(PRCSN), intent(inout) :: array_inout(:,:)
    integer, optional, intent(in) ::  range1(2), range2(2)
    integer, optional, intent(in) ::  lbound1, lbound2
    !
    integer :: i1, d1s, d1e
    integer :: lbound1_, range1_(2)
    integer :: i2, d2s, d2e
    integer :: lbound2_, range2_(2)
    !
    lbound1_=1
    if (present(lbound1)) lbound1_=lbound1 
    range1_=(/1,size(array_inout, 1)/)
    if (present(range1)) range1_=range1 
    !
    d1s = range1_(1) -lbound1_ +1
    d1e = range1_(2) -lbound1_ +1
    !
    lbound2_=1
    if (present(lbound2)) lbound2_=lbound2 
    range2_=(/1,size(array_inout, 2)/)
    if (present(range2)) range2_=range2 
    !
    d2s = range2_(1) -lbound2_ +1
    d2e = range2_(2) -lbound2_ +1
    !
    !
    do i2 = d2s, d2e
    do i1 = d1s, d1e
        array_inout(i1,i2 ) = &
            conjg (  array_inout (i1,i2 ) )
    enddo
    enddo
    !
end subroutine dp_dev_conjg_h_c2d
!
subroutine dp_dev_conjg_h_c3d(array_inout, &
                                    
                                   range1, lbound1, & 
                                   range2, lbound2, & 
                                   range3, lbound3 )
    implicit none
    !
    integer, parameter :: PRCSN = selected_real_kind(14,200)
    complex(PRCSN), intent(inout) :: array_inout(:,:,:)
    integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
    integer, optional, intent(in) ::  lbound1, lbound2, lbound3
    !
    integer :: i1, d1s, d1e
    integer :: lbound1_, range1_(2)
    integer :: i2, d2s, d2e
    integer :: lbound2_, range2_(2)
    integer :: i3, d3s, d3e
    integer :: lbound3_, range3_(2)
    !
    lbound1_=1
    if (present(lbound1)) lbound1_=lbound1 
    range1_=(/1,size(array_inout, 1)/)
    if (present(range1)) range1_=range1 
    !
    d1s = range1_(1) -lbound1_ +1
    d1e = range1_(2) -lbound1_ +1
    !
    lbound2_=1
    if (present(lbound2)) lbound2_=lbound2 
    range2_=(/1,size(array_inout, 2)/)
    if (present(range2)) range2_=range2 
    !
    d2s = range2_(1) -lbound2_ +1
    d2e = range2_(2) -lbound2_ +1
    !
    lbound3_=1
    if (present(lbound3)) lbound3_=lbound3 
    range3_=(/1,size(array_inout, 3)/)
    if (present(range3)) range3_=range3 
    !
    d3s = range3_(1) -lbound3_ +1
    d3e = range3_(2) -lbound3_ +1
    !
    !
    do i3 = d3s, d3e
    do i2 = d2s, d2e
    do i1 = d1s, d1e
        array_inout(i1,i2,i3 ) = &
            conjg (  array_inout (i1,i2,i3 ) )
    enddo
    enddo
    enddo
    !
end subroutine dp_dev_conjg_h_c3d
!
subroutine dp_dev_conjg_h_c4d(array_inout, &
                                    
                                   range1, lbound1, & 
                                   range2, lbound2, & 
                                   range3, lbound3, & 
                                   range4, lbound4 )
    implicit none
    !
    integer, parameter :: PRCSN = selected_real_kind(14,200)
    complex(PRCSN), intent(inout) :: array_inout(:,:,:,:)
    integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
    integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
    !
    integer :: i1, d1s, d1e
    integer :: lbound1_, range1_(2)
    integer :: i2, d2s, d2e
    integer :: lbound2_, range2_(2)
    integer :: i3, d3s, d3e
    integer :: lbound3_, range3_(2)
    integer :: i4, d4s, d4e
    integer :: lbound4_, range4_(2)
    !
    lbound1_=1
    if (present(lbound1)) lbound1_=lbound1 
    range1_=(/1,size(array_inout, 1)/)
    if (present(range1)) range1_=range1 
    !
    d1s = range1_(1) -lbound1_ +1
    d1e = range1_(2) -lbound1_ +1
    !
    lbound2_=1
    if (present(lbound2)) lbound2_=lbound2 
    range2_=(/1,size(array_inout, 2)/)
    if (present(range2)) range2_=range2 
    !
    d2s = range2_(1) -lbound2_ +1
    d2e = range2_(2) -lbound2_ +1
    !
    lbound3_=1
    if (present(lbound3)) lbound3_=lbound3 
    range3_=(/1,size(array_inout, 3)/)
    if (present(range3)) range3_=range3 
    !
    d3s = range3_(1) -lbound3_ +1
    d3e = range3_(2) -lbound3_ +1
    !
    lbound4_=1
    if (present(lbound4)) lbound4_=lbound4 
    range4_=(/1,size(array_inout, 4)/)
    if (present(range4)) range4_=range4 
    !
    d4s = range4_(1) -lbound4_ +1
    d4e = range4_(2) -lbound4_ +1
    !
    !
    do i4 = d4s, d4e
    do i3 = d3s, d3e
    do i2 = d2s, d2e
    do i1 = d1s, d1e
        array_inout(i1,i2,i3,i4 ) = &
            conjg (  array_inout (i1,i2,i3,i4 ) )
    enddo
    enddo
    enddo
    enddo
    !
end subroutine dp_dev_conjg_h_c4d
!
subroutine sp_dev_conjg_h_c1d(array_inout, &
                                    
                                   range1, lbound1 )
    implicit none
    !
    integer, parameter :: PRCSN = selected_real_kind(6, 37)
    complex(PRCSN), intent(inout) :: array_inout(:)
    integer, optional, intent(in) ::  range1(2)
    integer, optional, intent(in) ::  lbound1
    !
    integer :: i1, d1s, d1e
    integer :: lbound1_, range1_(2)
    !
    lbound1_=1
    if (present(lbound1)) lbound1_=lbound1 
    range1_=(/1,size(array_inout, 1)/)
    if (present(range1)) range1_=range1 
    !
    d1s = range1_(1) -lbound1_ +1
    d1e = range1_(2) -lbound1_ +1
    !
    !
    do i1 = d1s, d1e
        array_inout(i1 ) = &
            conjg (  array_inout (i1 ) )
    enddo
    !
end subroutine sp_dev_conjg_h_c1d
!
subroutine sp_dev_conjg_h_c2d(array_inout, &
                                    
                                   range1, lbound1, & 
                                   range2, lbound2 )
    implicit none
    !
    integer, parameter :: PRCSN = selected_real_kind(6, 37)
    complex(PRCSN), intent(inout) :: array_inout(:,:)
    integer, optional, intent(in) ::  range1(2), range2(2)
    integer, optional, intent(in) ::  lbound1, lbound2
    !
    integer :: i1, d1s, d1e
    integer :: lbound1_, range1_(2)
    integer :: i2, d2s, d2e
    integer :: lbound2_, range2_(2)
    !
    lbound1_=1
    if (present(lbound1)) lbound1_=lbound1 
    range1_=(/1,size(array_inout, 1)/)
    if (present(range1)) range1_=range1 
    !
    d1s = range1_(1) -lbound1_ +1
    d1e = range1_(2) -lbound1_ +1
    !
    lbound2_=1
    if (present(lbound2)) lbound2_=lbound2 
    range2_=(/1,size(array_inout, 2)/)
    if (present(range2)) range2_=range2 
    !
    d2s = range2_(1) -lbound2_ +1
    d2e = range2_(2) -lbound2_ +1
    !
    !
    do i2 = d2s, d2e
    do i1 = d1s, d1e
        array_inout(i1,i2 ) = &
            conjg (  array_inout (i1,i2 ) )
    enddo
    enddo
    !
end subroutine sp_dev_conjg_h_c2d
!
subroutine sp_dev_conjg_h_c3d(array_inout, &
                                    
                                   range1, lbound1, & 
                                   range2, lbound2, & 
                                   range3, lbound3 )
    implicit none
    !
    integer, parameter :: PRCSN = selected_real_kind(6, 37)
    complex(PRCSN), intent(inout) :: array_inout(:,:,:)
    integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
    integer, optional, intent(in) ::  lbound1, lbound2, lbound3
    !
    integer :: i1, d1s, d1e
    integer :: lbound1_, range1_(2)
    integer :: i2, d2s, d2e
    integer :: lbound2_, range2_(2)
    integer :: i3, d3s, d3e
    integer :: lbound3_, range3_(2)
    !
    lbound1_=1
    if (present(lbound1)) lbound1_=lbound1 
    range1_=(/1,size(array_inout, 1)/)
    if (present(range1)) range1_=range1 
    !
    d1s = range1_(1) -lbound1_ +1
    d1e = range1_(2) -lbound1_ +1
    !
    lbound2_=1
    if (present(lbound2)) lbound2_=lbound2 
    range2_=(/1,size(array_inout, 2)/)
    if (present(range2)) range2_=range2 
    !
    d2s = range2_(1) -lbound2_ +1
    d2e = range2_(2) -lbound2_ +1
    !
    lbound3_=1
    if (present(lbound3)) lbound3_=lbound3 
    range3_=(/1,size(array_inout, 3)/)
    if (present(range3)) range3_=range3 
    !
    d3s = range3_(1) -lbound3_ +1
    d3e = range3_(2) -lbound3_ +1
    !
    !
    do i3 = d3s, d3e
    do i2 = d2s, d2e
    do i1 = d1s, d1e
        array_inout(i1,i2,i3 ) = &
            conjg (  array_inout (i1,i2,i3 ) )
    enddo
    enddo
    enddo
    !
end subroutine sp_dev_conjg_h_c3d
!
subroutine sp_dev_conjg_h_c4d(array_inout, &
                                    
                                   range1, lbound1, & 
                                   range2, lbound2, & 
                                   range3, lbound3, & 
                                   range4, lbound4 )
    implicit none
    !
    integer, parameter :: PRCSN = selected_real_kind(6, 37)
    complex(PRCSN), intent(inout) :: array_inout(:,:,:,:)
    integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
    integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
    !
    integer :: i1, d1s, d1e
    integer :: lbound1_, range1_(2)
    integer :: i2, d2s, d2e
    integer :: lbound2_, range2_(2)
    integer :: i3, d3s, d3e
    integer :: lbound3_, range3_(2)
    integer :: i4, d4s, d4e
    integer :: lbound4_, range4_(2)
    !
    lbound1_=1
    if (present(lbound1)) lbound1_=lbound1 
    range1_=(/1,size(array_inout, 1)/)
    if (present(range1)) range1_=range1 
    !
    d1s = range1_(1) -lbound1_ +1
    d1e = range1_(2) -lbound1_ +1
    !
    lbound2_=1
    if (present(lbound2)) lbound2_=lbound2 
    range2_=(/1,size(array_inout, 2)/)
    if (present(range2)) range2_=range2 
    !
    d2s = range2_(1) -lbound2_ +1
    d2e = range2_(2) -lbound2_ +1
    !
    lbound3_=1
    if (present(lbound3)) lbound3_=lbound3 
    range3_=(/1,size(array_inout, 3)/)
    if (present(range3)) range3_=range3 
    !
    d3s = range3_(1) -lbound3_ +1
    d3e = range3_(2) -lbound3_ +1
    !
    lbound4_=1
    if (present(lbound4)) lbound4_=lbound4 
    range4_=(/1,size(array_inout, 4)/)
    if (present(range4)) range4_=range4 
    !
    d4s = range4_(1) -lbound4_ +1
    d4e = range4_(2) -lbound4_ +1
    !
    !
    do i4 = d4s, d4e
    do i3 = d3s, d3e
    do i2 = d2s, d2e
    do i1 = d1s, d1e
        array_inout(i1,i2,i3,i4 ) = &
            conjg (  array_inout (i1,i2,i3,i4 ) )
    enddo
    enddo
    enddo
    enddo
    !
end subroutine sp_dev_conjg_h_c4d
!
!
#endif

subroutine dxlib_errore( calling_routine, message, ierr )
    implicit none
    character(len=*), intent(in) :: calling_routine, message
    ! the name of the calling calling_routine
    ! the output message
    integer,          intent(in) :: ierr
    !
    print *, trim(calling_routine), trim(message), ierr
    !
end subroutine dxlib_errore
!
!======================
!

subroutine dp_dev_vec_upd_remap_r1d(ndim, vout, v1, map1, scal)
    implicit none
    !   
    integer, parameter :: PRCSN = selected_real_kind(14,200)
    integer,      intent(in)    :: ndim
    real(PRCSN), intent(inout) :: vout(:) 
    real(PRCSN), intent(in)    :: v1(:) 
    integer,      intent(in)    :: map1(:) 
    real(PRCSN), optional, intent(in)    :: scal
#if defined(__CUDA)
    attributes(device) :: vout, v1, map1
#endif
    integer :: i
    !   
    if (present(scal)) then
      !$cuf kernel do(1)
      do i = 1, ndim
          vout(i) = v1(map1(i))*scal
      enddo
    else
      !$cuf kernel do(1)
      do i = 1, ndim
          vout(i) = v1(map1(i))
      enddo
    endif
end subroutine dp_dev_vec_upd_remap_r1d
!
subroutine dp_dev_vec_upd_remap_c1d(ndim, vout, v1, map1, scal)
    implicit none
    !   
    integer, parameter :: PRCSN = selected_real_kind(14,200)
    integer,      intent(in)    :: ndim
    complex(PRCSN), intent(inout) :: vout(:) 
    complex(PRCSN), intent(in)    :: v1(:) 
    integer,      intent(in)    :: map1(:) 
    complex(PRCSN), optional, intent(in)    :: scal
#if defined(__CUDA)
    attributes(device) :: vout, v1, map1
#endif
    integer :: i
    !   
    if (present(scal)) then
      !$cuf kernel do(1)
      do i = 1, ndim
          vout(i) = v1(map1(i))*scal
      enddo
    else
      !$cuf kernel do(1)
      do i = 1, ndim
          vout(i) = v1(map1(i))
      enddo
    endif
end subroutine dp_dev_vec_upd_remap_c1d
!
subroutine sp_dev_vec_upd_remap_r1d(ndim, vout, v1, map1, scal)
    implicit none
    !   
    integer, parameter :: PRCSN = selected_real_kind(6, 37)
    integer,      intent(in)    :: ndim
    real(PRCSN), intent(inout) :: vout(:) 
    real(PRCSN), intent(in)    :: v1(:) 
    integer,      intent(in)    :: map1(:) 
    real(PRCSN), optional, intent(in)    :: scal
#if defined(__CUDA)
    attributes(device) :: vout, v1, map1
#endif
    integer :: i
    !   
    if (present(scal)) then
      !$cuf kernel do(1)
      do i = 1, ndim
          vout(i) = v1(map1(i))*scal
      enddo
    else
      !$cuf kernel do(1)
      do i = 1, ndim
          vout(i) = v1(map1(i))
      enddo
    endif
end subroutine sp_dev_vec_upd_remap_r1d
!
subroutine sp_dev_vec_upd_remap_c1d(ndim, vout, v1, map1, scal)
    implicit none
    !   
    integer, parameter :: PRCSN = selected_real_kind(6, 37)
    integer,      intent(in)    :: ndim
    complex(PRCSN), intent(inout) :: vout(:) 
    complex(PRCSN), intent(in)    :: v1(:) 
    integer,      intent(in)    :: map1(:) 
    complex(PRCSN), optional, intent(in)    :: scal
#if defined(__CUDA)
    attributes(device) :: vout, v1, map1
#endif
    integer :: i
    !   
    if (present(scal)) then
      !$cuf kernel do(1)
      do i = 1, ndim
          vout(i) = v1(map1(i))*scal
      enddo
    else
      !$cuf kernel do(1)
      do i = 1, ndim
          vout(i) = v1(map1(i))
      enddo
    endif
end subroutine sp_dev_vec_upd_remap_c1d
!
!
!======================
!

subroutine dp_dev_vec_upd_v_remap_v_r1d(ndim, vout, v1, map1, v2, scal)
    implicit none
    !   
    integer, parameter :: PRCSN = selected_real_kind(14,200)
    integer,      intent(in)    :: ndim
    real(PRCSN), intent(inout) :: vout(:) 
    real(PRCSN), intent(in)    :: v1(:) 
    integer,      intent(in)    :: map1(:) 
    real(PRCSN), intent(in)    :: v2(:) 
    real(PRCSN), optional, intent(in)    :: scal
#if defined(__CUDA)
    attributes(device) :: vout, v1, v2, map1
#endif
    integer :: i
    !   
    if (present(scal)) then
      !$cuf kernel do(1)
      do i = 1, ndim
          vout(i) = v1(map1(i))*v2(i)*scal
      enddo
    else
      !$cuf kernel do(1)
      do i = 1, ndim
          vout(i) = v1(map1(i))*v2(i)
      enddo
    endif
end subroutine dp_dev_vec_upd_v_remap_v_r1d
!
subroutine dp_dev_vec_upd_v_remap_v_c1d(ndim, vout, v1, map1, v2, scal)
    implicit none
    !   
    integer, parameter :: PRCSN = selected_real_kind(14,200)
    integer,      intent(in)    :: ndim
    complex(PRCSN), intent(inout) :: vout(:) 
    complex(PRCSN), intent(in)    :: v1(:) 
    integer,      intent(in)    :: map1(:) 
    complex(PRCSN), intent(in)    :: v2(:) 
    complex(PRCSN), optional, intent(in)    :: scal
#if defined(__CUDA)
    attributes(device) :: vout, v1, v2, map1
#endif
    integer :: i
    !   
    if (present(scal)) then
      !$cuf kernel do(1)
      do i = 1, ndim
          vout(i) = v1(map1(i))*v2(i)*scal
      enddo
    else
      !$cuf kernel do(1)
      do i = 1, ndim
          vout(i) = v1(map1(i))*v2(i)
      enddo
    endif
end subroutine dp_dev_vec_upd_v_remap_v_c1d
!
subroutine sp_dev_vec_upd_v_remap_v_r1d(ndim, vout, v1, map1, v2, scal)
    implicit none
    !   
    integer, parameter :: PRCSN = selected_real_kind(6, 37)
    integer,      intent(in)    :: ndim
    real(PRCSN), intent(inout) :: vout(:) 
    real(PRCSN), intent(in)    :: v1(:) 
    integer,      intent(in)    :: map1(:) 
    real(PRCSN), intent(in)    :: v2(:) 
    real(PRCSN), optional, intent(in)    :: scal
#if defined(__CUDA)
    attributes(device) :: vout, v1, v2, map1
#endif
    integer :: i
    !   
    if (present(scal)) then
      !$cuf kernel do(1)
      do i = 1, ndim
          vout(i) = v1(map1(i))*v2(i)*scal
      enddo
    else
      !$cuf kernel do(1)
      do i = 1, ndim
          vout(i) = v1(map1(i))*v2(i)
      enddo
    endif
end subroutine sp_dev_vec_upd_v_remap_v_r1d
!
subroutine sp_dev_vec_upd_v_remap_v_c1d(ndim, vout, v1, map1, v2, scal)
    implicit none
    !   
    integer, parameter :: PRCSN = selected_real_kind(6, 37)
    integer,      intent(in)    :: ndim
    complex(PRCSN), intent(inout) :: vout(:) 
    complex(PRCSN), intent(in)    :: v1(:) 
    integer,      intent(in)    :: map1(:) 
    complex(PRCSN), intent(in)    :: v2(:) 
    complex(PRCSN), optional, intent(in)    :: scal
#if defined(__CUDA)
    attributes(device) :: vout, v1, v2, map1
#endif
    integer :: i
    !   
    if (present(scal)) then
      !$cuf kernel do(1)
      do i = 1, ndim
          vout(i) = v1(map1(i))*v2(i)*scal
      enddo
    else
      !$cuf kernel do(1)
      do i = 1, ndim
          vout(i) = v1(map1(i))*v2(i)
      enddo
    endif
end subroutine sp_dev_vec_upd_v_remap_v_c1d
!
!
!======================
!


subroutine dp_dev_vec_upd_v_remap_v_x_c1d(ndim, vout, v1,op1, map1, v2,op2, scal)
    implicit none
    !   
    integer, parameter :: PRCSN = selected_real_kind(14,200)
    integer,      intent(in)    :: ndim
    complex(PRCSN), intent(inout) :: vout(:) 
    complex(PRCSN), intent(in)    :: v1(:) 
    integer,      intent(in)    :: map1(:) 
    complex(PRCSN), intent(in)    :: v2(:) 
    character(1), intent(in)    :: op1, op2
    complex(PRCSN), optional, intent(in)    :: scal
#if defined(__CUDA)
    attributes(device) :: vout, v1, v2, map1
#endif
    integer :: i
    !   
    if (op1=="N".and.op2=="N") then
       if (present(scal)) then
         !$cuf kernel do(1)
         do i = 1, ndim
             vout(i) = v1(map1(i))*v2(i)*scal
         enddo
       else
         !$cuf kernel do(1)
         do i = 1, ndim
             vout(i) = v1(map1(i))*v2(i)
         enddo
       endif
    elseif (op1=="C".and.op2=="N") then
       if (present(scal)) then
         !$cuf kernel do(1)
         do i = 1, ndim
             vout(i) = conjg(v1(map1(i)))*v2(i)*scal
         enddo
       else
         !$cuf kernel do(1)
         do i = 1, ndim
             vout(i) = conjg(v1(map1(i)))*v2(i)
         enddo
       endif
    elseif (op1=="N".and.op2=="C") then
       if (present(scal)) then
         !$cuf kernel do(1)
         do i = 1, ndim
             vout(i) = v1(map1(i))*conjg(v2(i))*scal
         enddo
       else
         !$cuf kernel do(1)
         do i = 1, ndim
             vout(i) = v1(map1(i))*conjg(v2(i))
         enddo
       endif
    elseif (op1=="N".and.op2=="C") then
       if (present(scal)) then
         !$cuf kernel do(1)
         do i = 1, ndim
             vout(i) = conjg(v1(map1(i)))*conjg(v2(i))*scal
         enddo
       else
         !$cuf kernel do(1)
         do i = 1, ndim
             vout(i) = conjg(v1(map1(i)))*conjg(v2(i))
         enddo
       endif
    else
      call dxlib_errore("dp_dev_vec_upd_v_remap_v_x_c1d","invalid op1/op2",10)
    endif
    !
end subroutine dp_dev_vec_upd_v_remap_v_x_c1d
!
subroutine sp_dev_vec_upd_v_remap_v_x_c1d(ndim, vout, v1,op1, map1, v2,op2, scal)
    implicit none
    !   
    integer, parameter :: PRCSN = selected_real_kind(6, 37)
    integer,      intent(in)    :: ndim
    complex(PRCSN), intent(inout) :: vout(:) 
    complex(PRCSN), intent(in)    :: v1(:) 
    integer,      intent(in)    :: map1(:) 
    complex(PRCSN), intent(in)    :: v2(:) 
    character(1), intent(in)    :: op1, op2
    complex(PRCSN), optional, intent(in)    :: scal
#if defined(__CUDA)
    attributes(device) :: vout, v1, v2, map1
#endif
    integer :: i
    !   
    if (op1=="N".and.op2=="N") then
       if (present(scal)) then
         !$cuf kernel do(1)
         do i = 1, ndim
             vout(i) = v1(map1(i))*v2(i)*scal
         enddo
       else
         !$cuf kernel do(1)
         do i = 1, ndim
             vout(i) = v1(map1(i))*v2(i)
         enddo
       endif
    elseif (op1=="C".and.op2=="N") then
       if (present(scal)) then
         !$cuf kernel do(1)
         do i = 1, ndim
             vout(i) = conjg(v1(map1(i)))*v2(i)*scal
         enddo
       else
         !$cuf kernel do(1)
         do i = 1, ndim
             vout(i) = conjg(v1(map1(i)))*v2(i)
         enddo
       endif
    elseif (op1=="N".and.op2=="C") then
       if (present(scal)) then
         !$cuf kernel do(1)
         do i = 1, ndim
             vout(i) = v1(map1(i))*conjg(v2(i))*scal
         enddo
       else
         !$cuf kernel do(1)
         do i = 1, ndim
             vout(i) = v1(map1(i))*conjg(v2(i))
         enddo
       endif
    elseif (op1=="N".and.op2=="C") then
       if (present(scal)) then
         !$cuf kernel do(1)
         do i = 1, ndim
             vout(i) = conjg(v1(map1(i)))*conjg(v2(i))*scal
         enddo
       else
         !$cuf kernel do(1)
         do i = 1, ndim
             vout(i) = conjg(v1(map1(i)))*conjg(v2(i))
         enddo
       endif
    else
      call dxlib_errore("sp_dev_vec_upd_v_remap_v_x_c1d","invalid op1/op2",10)
    endif
    !
end subroutine sp_dev_vec_upd_v_remap_v_x_c1d
!
!
!======================
!
subroutine dp_dev_mat_upd_dMd_r2d(ndim1, ndim2, mat, v1,op1, v2,op2, scal)
    !
    ! performs: mat(i,j) = scal * op1(v1(i)) * mat(i,j) * op2(v2(j))
    ! op = 'N', 'R', 'C',       'RC'
    !       x   1/x  conjg(x)   conjg(1/x)
    implicit none
    !   
    integer, parameter :: PRCSN = selected_real_kind(14,200)
    integer,      intent(in)    :: ndim1,ndim2
    real(PRCSN), intent(inout) :: mat(:,:)
    real(PRCSN), intent(in)    :: v1(:)
    real(PRCSN), intent(in)    :: v2(:)
    character(1), intent(in)    :: op1, op2
    real(PRCSN), optional, intent(in)  :: scal
#if defined(__CUDA)
    attributes(device) :: mat, v1, v2
#endif
    integer :: i,j
    !   
    if (op1=="N".and.op2=="N") then
       if (present(scal)) then
#ifndef __CUDA
         !$omp parallel do default(shared), private(i,j), collapse(2)
#else
         !$cuf kernel do(2)
#endif
         do j = 1, ndim2
         do i = 1, ndim1
             mat(i,j) = scal * v1(i) * mat(i,j) * v2(j)
         enddo
         enddo

       else
#ifndef __CUDA
         !$omp parallel do default(shared), private(i,j), collapse(2)
#else
         !$cuf kernel do(2)
#endif
         do j = 1, ndim2
         do i = 1, ndim1
             mat(i,j) = v1(i) * mat(i,j) * v2(j)
         enddo
         enddo

       endif
    elseif (op1=="R".and.op2=="R") then
       if (present(scal)) then
#ifndef __CUDA
         !$omp parallel do default(shared), private(i,j), collapse(2)
#else
         !$cuf kernel do(2)
#endif
         do j = 1, ndim2
         do i = 1, ndim1
             mat(i,j) = scal / v1(i) * mat(i,j) / v2(j)
         enddo
         enddo

       else
#ifndef __CUDA
         !$omp parallel do default(shared), private(i,j), collapse(2)
#else
         !$cuf kernel do(2)
#endif
         do j = 1, ndim2
         do i = 1, ndim1
             mat(i,j) = mat(i,j) /v1(i) / v2(j)
         enddo
         enddo

       endif
    else
      call dxlib_errore("dp_mat_upd_dMd_r2d","invalid op1/op2",10)
    endif
    !
end subroutine dp_dev_mat_upd_dMd_r2d
!
subroutine dp_dev_mat_upd_dMd_c2d(ndim1, ndim2, mat, v1,op1, v2,op2, scal)
    !
    ! performs: mat(i,j) = scal * op1(v1(i)) * mat(i,j) * op2(v2(j))
    ! op = 'N', 'R', 'C',       'RC'
    !       x   1/x  conjg(x)   conjg(1/x)
    implicit none
    !   
    integer, parameter :: PRCSN = selected_real_kind(14,200)
    integer,      intent(in)    :: ndim1,ndim2
    complex(PRCSN), intent(inout) :: mat(:,:)
    complex(PRCSN), intent(in)    :: v1(:)
    complex(PRCSN), intent(in)    :: v2(:)
    character(1), intent(in)    :: op1, op2
    complex(PRCSN), optional, intent(in)  :: scal
#if defined(__CUDA)
    attributes(device) :: mat, v1, v2
#endif
    integer :: i,j
    !   
    if (op1=="N".and.op2=="N") then
       if (present(scal)) then
#ifndef __CUDA
         !$omp parallel do default(shared), private(i,j), collapse(2)
#else
         !$cuf kernel do(2)
#endif
         do j = 1, ndim2
         do i = 1, ndim1
             mat(i,j) = scal * v1(i) * mat(i,j) * v2(j)
         enddo
         enddo

       else
#ifndef __CUDA
         !$omp parallel do default(shared), private(i,j), collapse(2)
#else
         !$cuf kernel do(2)
#endif
         do j = 1, ndim2
         do i = 1, ndim1
             mat(i,j) = v1(i) * mat(i,j) * v2(j)
         enddo
         enddo

       endif
    elseif (op1=="R".and.op2=="R") then
       if (present(scal)) then
#ifndef __CUDA
         !$omp parallel do default(shared), private(i,j), collapse(2)
#else
         !$cuf kernel do(2)
#endif
         do j = 1, ndim2
         do i = 1, ndim1
             mat(i,j) = scal / v1(i) * mat(i,j) / v2(j)
         enddo
         enddo

       else
#ifndef __CUDA
         !$omp parallel do default(shared), private(i,j), collapse(2)
#else
         !$cuf kernel do(2)
#endif
         do j = 1, ndim2
         do i = 1, ndim1
             mat(i,j) = mat(i,j) /v1(i) / v2(j)
         enddo
         enddo

       endif
    elseif (op1=="C".and.op2=="C") then
       if (present(scal)) then
#ifndef __CUDA
         !$omp parallel do default(shared), private(i,j), collapse(2)
#else
         !$cuf kernel do(2)
#endif
         do j = 1, ndim2
         do i = 1, ndim1
             mat(i,j) = scal * conjg(v1(i)) * mat(i,j) * conjg(v2(j))
         enddo
         enddo

       else
#ifndef __CUDA
         !$omp parallel do default(shared), private(i,j), collapse(2)
#else
         !$cuf kernel do(2)
#endif
         do j = 1, ndim2
         do i = 1, ndim1
             mat(i,j) = conjg(v1(i)) * mat(i,j) * conjg(v2(j))
         enddo
         enddo

       endif
    else
      call dxlib_errore("dp_mat_upd_dMd_c2d","invalid op1/op2",10)
    endif
    !
end subroutine dp_dev_mat_upd_dMd_c2d
!
subroutine sp_dev_mat_upd_dMd_r2d(ndim1, ndim2, mat, v1,op1, v2,op2, scal)
    !
    ! performs: mat(i,j) = scal * op1(v1(i)) * mat(i,j) * op2(v2(j))
    ! op = 'N', 'R', 'C',       'RC'
    !       x   1/x  conjg(x)   conjg(1/x)
    implicit none
    !   
    integer, parameter :: PRCSN = selected_real_kind(6, 37)
    integer,      intent(in)    :: ndim1,ndim2
    real(PRCSN), intent(inout) :: mat(:,:)
    real(PRCSN), intent(in)    :: v1(:)
    real(PRCSN), intent(in)    :: v2(:)
    character(1), intent(in)    :: op1, op2
    real(PRCSN), optional, intent(in)  :: scal
#if defined(__CUDA)
    attributes(device) :: mat, v1, v2
#endif
    integer :: i,j
    !   
    if (op1=="N".and.op2=="N") then
       if (present(scal)) then
#ifndef __CUDA
         !$omp parallel do default(shared), private(i,j), collapse(2)
#else
         !$cuf kernel do(2)
#endif
         do j = 1, ndim2
         do i = 1, ndim1
             mat(i,j) = scal * v1(i) * mat(i,j) * v2(j)
         enddo
         enddo

       else
#ifndef __CUDA
         !$omp parallel do default(shared), private(i,j), collapse(2)
#else
         !$cuf kernel do(2)
#endif
         do j = 1, ndim2
         do i = 1, ndim1
             mat(i,j) = v1(i) * mat(i,j) * v2(j)
         enddo
         enddo

       endif
    elseif (op1=="R".and.op2=="R") then
       if (present(scal)) then
#ifndef __CUDA
         !$omp parallel do default(shared), private(i,j), collapse(2)
#else
         !$cuf kernel do(2)
#endif
         do j = 1, ndim2
         do i = 1, ndim1
             mat(i,j) = scal / v1(i) * mat(i,j) / v2(j)
         enddo
         enddo

       else
#ifndef __CUDA
         !$omp parallel do default(shared), private(i,j), collapse(2)
#else
         !$cuf kernel do(2)
#endif
         do j = 1, ndim2
         do i = 1, ndim1
             mat(i,j) = mat(i,j) /v1(i) / v2(j)
         enddo
         enddo

       endif
    else
      call dxlib_errore("sp_mat_upd_dMd_r2d","invalid op1/op2",10)
    endif
    !
end subroutine sp_dev_mat_upd_dMd_r2d
!
subroutine sp_dev_mat_upd_dMd_c2d(ndim1, ndim2, mat, v1,op1, v2,op2, scal)
    !
    ! performs: mat(i,j) = scal * op1(v1(i)) * mat(i,j) * op2(v2(j))
    ! op = 'N', 'R', 'C',       'RC'
    !       x   1/x  conjg(x)   conjg(1/x)
    implicit none
    !   
    integer, parameter :: PRCSN = selected_real_kind(6, 37)
    integer,      intent(in)    :: ndim1,ndim2
    complex(PRCSN), intent(inout) :: mat(:,:)
    complex(PRCSN), intent(in)    :: v1(:)
    complex(PRCSN), intent(in)    :: v2(:)
    character(1), intent(in)    :: op1, op2
    complex(PRCSN), optional, intent(in)  :: scal
#if defined(__CUDA)
    attributes(device) :: mat, v1, v2
#endif
    integer :: i,j
    !   
    if (op1=="N".and.op2=="N") then
       if (present(scal)) then
#ifndef __CUDA
         !$omp parallel do default(shared), private(i,j), collapse(2)
#else
         !$cuf kernel do(2)
#endif
         do j = 1, ndim2
         do i = 1, ndim1
             mat(i,j) = scal * v1(i) * mat(i,j) * v2(j)
         enddo
         enddo

       else
#ifndef __CUDA
         !$omp parallel do default(shared), private(i,j), collapse(2)
#else
         !$cuf kernel do(2)
#endif
         do j = 1, ndim2
         do i = 1, ndim1
             mat(i,j) = v1(i) * mat(i,j) * v2(j)
         enddo
         enddo

       endif
    elseif (op1=="R".and.op2=="R") then
       if (present(scal)) then
#ifndef __CUDA
         !$omp parallel do default(shared), private(i,j), collapse(2)
#else
         !$cuf kernel do(2)
#endif
         do j = 1, ndim2
         do i = 1, ndim1
             mat(i,j) = scal / v1(i) * mat(i,j) / v2(j)
         enddo
         enddo

       else
#ifndef __CUDA
         !$omp parallel do default(shared), private(i,j), collapse(2)
#else
         !$cuf kernel do(2)
#endif
         do j = 1, ndim2
         do i = 1, ndim1
             mat(i,j) = mat(i,j) /v1(i) / v2(j)
         enddo
         enddo

       endif
    elseif (op1=="C".and.op2=="C") then
       if (present(scal)) then
#ifndef __CUDA
         !$omp parallel do default(shared), private(i,j), collapse(2)
#else
         !$cuf kernel do(2)
#endif
         do j = 1, ndim2
         do i = 1, ndim1
             mat(i,j) = scal * conjg(v1(i)) * mat(i,j) * conjg(v2(j))
         enddo
         enddo

       else
#ifndef __CUDA
         !$omp parallel do default(shared), private(i,j), collapse(2)
#else
         !$cuf kernel do(2)
#endif
         do j = 1, ndim2
         do i = 1, ndim1
             mat(i,j) = conjg(v1(i)) * mat(i,j) * conjg(v2(j))
         enddo
         enddo

       endif
    else
      call dxlib_errore("sp_mat_upd_dMd_c2d","invalid op1/op2",10)
    endif
    !
end subroutine sp_dev_mat_upd_dMd_c2d
!
!
!======================
!
subroutine dp_dev_mem_addscal_r1d(array_out, array_in, scal, &
                                            range1, lbound1 )
    use iso_fortran_env
    implicit none
    !
    real(selected_real_kind(14,200)), intent(inout) :: array_out(:)
    real(selected_real_kind(14,200)), intent(in)    :: array_in(:)
    real(selected_real_kind(14,200)), optional, intent(in) :: scal
    integer, optional, intent(in) ::  range1(2)
    integer, optional, intent(in) ::  lbound1
#if defined(__CUDA)
    attributes(device) :: array_out, array_in
#endif
    !
    real(selected_real_kind(14,200)) :: scal_ = 1.0
    integer :: i1, d1s, d1e
    integer :: lbound1_, range1_(2)
    !
    lbound1_=1
    if (present(lbound1)) lbound1_=lbound1 
    range1_=(/1,size(array_out, 1)/)
    if (present(range1)) range1_=range1 
    !
    ! the lower bound of the assumed shape array passed to the subroutine is 1
    ! lbound and range instead refer to the indexing in the parent caller.
    d1s = range1_(1) -lbound1_ +1
    d1e = range1_(2) -lbound1_ +1
    !
    !
    if (present(scal)) scal_=scal
    !
    !$cuf kernel do(1)
    do i1 = d1s, d1e
        array_out(i1 ) = &
            array_out(i1 ) + &
            scal_*array_in(i1 )
    enddo
    !
end subroutine dp_dev_mem_addscal_r1d
!
subroutine dp_dev_mem_addscal_r2d(array_out, array_in, scal, &
                                            range1, lbound1, &
                                            range2, lbound2 )
    use iso_fortran_env
    implicit none
    !
    real(selected_real_kind(14,200)), intent(inout) :: array_out(:,:)
    real(selected_real_kind(14,200)), intent(in)    :: array_in(:,:)
    real(selected_real_kind(14,200)), optional, intent(in) :: scal
    integer, optional, intent(in) ::  range1(2), range2(2)
    integer, optional, intent(in) ::  lbound1, lbound2
#if defined(__CUDA)
    attributes(device) :: array_out, array_in
#endif
    !
    real(selected_real_kind(14,200)) :: scal_ = 1.0
    integer :: i1, d1s, d1e
    integer :: lbound1_, range1_(2)
    integer :: i2, d2s, d2e
    integer :: lbound2_, range2_(2)
    !
    lbound1_=1
    if (present(lbound1)) lbound1_=lbound1 
    range1_=(/1,size(array_out, 1)/)
    if (present(range1)) range1_=range1 
    !
    ! the lower bound of the assumed shape array passed to the subroutine is 1
    ! lbound and range instead refer to the indexing in the parent caller.
    d1s = range1_(1) -lbound1_ +1
    d1e = range1_(2) -lbound1_ +1
    !
    lbound2_=1
    if (present(lbound2)) lbound2_=lbound2 
    range2_=(/1,size(array_out, 2)/)
    if (present(range2)) range2_=range2 
    !
    ! the lower bound of the assumed shape array passed to the subroutine is 1
    ! lbound and range instead refer to the indexing in the parent caller.
    d2s = range2_(1) -lbound2_ +1
    d2e = range2_(2) -lbound2_ +1
    !
    !
    if (present(scal)) scal_=scal
    !
    !$cuf kernel do(2)
    do i2 = d2s, d2e
    do i1 = d1s, d1e
        array_out(i1,i2 ) = &
            array_out(i1,i2 ) + &
            scal_*array_in(i1,i2 )
    enddo
    enddo
    !
end subroutine dp_dev_mem_addscal_r2d
!
subroutine dp_dev_mem_addscal_r3d(array_out, array_in, scal, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3 )
    use iso_fortran_env
    implicit none
    !
    real(selected_real_kind(14,200)), intent(inout) :: array_out(:,:,:)
    real(selected_real_kind(14,200)), intent(in)    :: array_in(:,:,:)
    real(selected_real_kind(14,200)), optional, intent(in) :: scal
    integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
    integer, optional, intent(in) ::  lbound1, lbound2, lbound3
#if defined(__CUDA)
    attributes(device) :: array_out, array_in
#endif
    !
    real(selected_real_kind(14,200)) :: scal_ = 1.0
    integer :: i1, d1s, d1e
    integer :: lbound1_, range1_(2)
    integer :: i2, d2s, d2e
    integer :: lbound2_, range2_(2)
    integer :: i3, d3s, d3e
    integer :: lbound3_, range3_(2)
    !
    lbound1_=1
    if (present(lbound1)) lbound1_=lbound1 
    range1_=(/1,size(array_out, 1)/)
    if (present(range1)) range1_=range1 
    !
    ! the lower bound of the assumed shape array passed to the subroutine is 1
    ! lbound and range instead refer to the indexing in the parent caller.
    d1s = range1_(1) -lbound1_ +1
    d1e = range1_(2) -lbound1_ +1
    !
    lbound2_=1
    if (present(lbound2)) lbound2_=lbound2 
    range2_=(/1,size(array_out, 2)/)
    if (present(range2)) range2_=range2 
    !
    ! the lower bound of the assumed shape array passed to the subroutine is 1
    ! lbound and range instead refer to the indexing in the parent caller.
    d2s = range2_(1) -lbound2_ +1
    d2e = range2_(2) -lbound2_ +1
    !
    lbound3_=1
    if (present(lbound3)) lbound3_=lbound3 
    range3_=(/1,size(array_out, 3)/)
    if (present(range3)) range3_=range3 
    !
    ! the lower bound of the assumed shape array passed to the subroutine is 1
    ! lbound and range instead refer to the indexing in the parent caller.
    d3s = range3_(1) -lbound3_ +1
    d3e = range3_(2) -lbound3_ +1
    !
    !
    if (present(scal)) scal_=scal
    !
    !$cuf kernel do(3)
    do i3 = d3s, d3e
    do i2 = d2s, d2e
    do i1 = d1s, d1e
        array_out(i1,i2,i3 ) = &
            array_out(i1,i2,i3 ) + &
            scal_*array_in(i1,i2,i3 )
    enddo
    enddo
    enddo
    !
end subroutine dp_dev_mem_addscal_r3d
!
subroutine dp_dev_mem_addscal_r4d(array_out, array_in, scal, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3, &
                                            range4, lbound4 )
    use iso_fortran_env
    implicit none
    !
    real(selected_real_kind(14,200)), intent(inout) :: array_out(:,:,:,:)
    real(selected_real_kind(14,200)), intent(in)    :: array_in(:,:,:,:)
    real(selected_real_kind(14,200)), optional, intent(in) :: scal
    integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
    integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
#if defined(__CUDA)
    attributes(device) :: array_out, array_in
#endif
    !
    real(selected_real_kind(14,200)) :: scal_ = 1.0
    integer :: i1, d1s, d1e
    integer :: lbound1_, range1_(2)
    integer :: i2, d2s, d2e
    integer :: lbound2_, range2_(2)
    integer :: i3, d3s, d3e
    integer :: lbound3_, range3_(2)
    integer :: i4, d4s, d4e
    integer :: lbound4_, range4_(2)
    !
    lbound1_=1
    if (present(lbound1)) lbound1_=lbound1 
    range1_=(/1,size(array_out, 1)/)
    if (present(range1)) range1_=range1 
    !
    ! the lower bound of the assumed shape array passed to the subroutine is 1
    ! lbound and range instead refer to the indexing in the parent caller.
    d1s = range1_(1) -lbound1_ +1
    d1e = range1_(2) -lbound1_ +1
    !
    lbound2_=1
    if (present(lbound2)) lbound2_=lbound2 
    range2_=(/1,size(array_out, 2)/)
    if (present(range2)) range2_=range2 
    !
    ! the lower bound of the assumed shape array passed to the subroutine is 1
    ! lbound and range instead refer to the indexing in the parent caller.
    d2s = range2_(1) -lbound2_ +1
    d2e = range2_(2) -lbound2_ +1
    !
    lbound3_=1
    if (present(lbound3)) lbound3_=lbound3 
    range3_=(/1,size(array_out, 3)/)
    if (present(range3)) range3_=range3 
    !
    ! the lower bound of the assumed shape array passed to the subroutine is 1
    ! lbound and range instead refer to the indexing in the parent caller.
    d3s = range3_(1) -lbound3_ +1
    d3e = range3_(2) -lbound3_ +1
    !
    lbound4_=1
    if (present(lbound4)) lbound4_=lbound4 
    range4_=(/1,size(array_out, 4)/)
    if (present(range4)) range4_=range4 
    !
    ! the lower bound of the assumed shape array passed to the subroutine is 1
    ! lbound and range instead refer to the indexing in the parent caller.
    d4s = range4_(1) -lbound4_ +1
    d4e = range4_(2) -lbound4_ +1
    !
    !
    if (present(scal)) scal_=scal
    !
    !$cuf kernel do(4)
    do i4 = d4s, d4e
    do i3 = d3s, d3e
    do i2 = d2s, d2e
    do i1 = d1s, d1e
        array_out(i1,i2,i3,i4 ) = &
            array_out(i1,i2,i3,i4 ) + &
            scal_*array_in(i1,i2,i3,i4 )
    enddo
    enddo
    enddo
    enddo
    !
end subroutine dp_dev_mem_addscal_r4d
!
subroutine sp_dev_mem_addscal_r1d(array_out, array_in, scal, &
                                            range1, lbound1 )
    use iso_fortran_env
    implicit none
    !
    real(selected_real_kind(6, 37)), intent(inout) :: array_out(:)
    real(selected_real_kind(6, 37)), intent(in)    :: array_in(:)
    real(selected_real_kind(6, 37)), optional, intent(in) :: scal
    integer, optional, intent(in) ::  range1(2)
    integer, optional, intent(in) ::  lbound1
#if defined(__CUDA)
    attributes(device) :: array_out, array_in
#endif
    !
    real(selected_real_kind(6, 37)) :: scal_ = 1.0
    integer :: i1, d1s, d1e
    integer :: lbound1_, range1_(2)
    !
    lbound1_=1
    if (present(lbound1)) lbound1_=lbound1 
    range1_=(/1,size(array_out, 1)/)
    if (present(range1)) range1_=range1 
    !
    ! the lower bound of the assumed shape array passed to the subroutine is 1
    ! lbound and range instead refer to the indexing in the parent caller.
    d1s = range1_(1) -lbound1_ +1
    d1e = range1_(2) -lbound1_ +1
    !
    !
    if (present(scal)) scal_=scal
    !
    !$cuf kernel do(1)
    do i1 = d1s, d1e
        array_out(i1 ) = &
            array_out(i1 ) + &
            scal_*array_in(i1 )
    enddo
    !
end subroutine sp_dev_mem_addscal_r1d
!
subroutine sp_dev_mem_addscal_r2d(array_out, array_in, scal, &
                                            range1, lbound1, &
                                            range2, lbound2 )
    use iso_fortran_env
    implicit none
    !
    real(selected_real_kind(6, 37)), intent(inout) :: array_out(:,:)
    real(selected_real_kind(6, 37)), intent(in)    :: array_in(:,:)
    real(selected_real_kind(6, 37)), optional, intent(in) :: scal
    integer, optional, intent(in) ::  range1(2), range2(2)
    integer, optional, intent(in) ::  lbound1, lbound2
#if defined(__CUDA)
    attributes(device) :: array_out, array_in
#endif
    !
    real(selected_real_kind(6, 37)) :: scal_ = 1.0
    integer :: i1, d1s, d1e
    integer :: lbound1_, range1_(2)
    integer :: i2, d2s, d2e
    integer :: lbound2_, range2_(2)
    !
    lbound1_=1
    if (present(lbound1)) lbound1_=lbound1 
    range1_=(/1,size(array_out, 1)/)
    if (present(range1)) range1_=range1 
    !
    ! the lower bound of the assumed shape array passed to the subroutine is 1
    ! lbound and range instead refer to the indexing in the parent caller.
    d1s = range1_(1) -lbound1_ +1
    d1e = range1_(2) -lbound1_ +1
    !
    lbound2_=1
    if (present(lbound2)) lbound2_=lbound2 
    range2_=(/1,size(array_out, 2)/)
    if (present(range2)) range2_=range2 
    !
    ! the lower bound of the assumed shape array passed to the subroutine is 1
    ! lbound and range instead refer to the indexing in the parent caller.
    d2s = range2_(1) -lbound2_ +1
    d2e = range2_(2) -lbound2_ +1
    !
    !
    if (present(scal)) scal_=scal
    !
    !$cuf kernel do(2)
    do i2 = d2s, d2e
    do i1 = d1s, d1e
        array_out(i1,i2 ) = &
            array_out(i1,i2 ) + &
            scal_*array_in(i1,i2 )
    enddo
    enddo
    !
end subroutine sp_dev_mem_addscal_r2d
!
subroutine sp_dev_mem_addscal_r3d(array_out, array_in, scal, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3 )
    use iso_fortran_env
    implicit none
    !
    real(selected_real_kind(6, 37)), intent(inout) :: array_out(:,:,:)
    real(selected_real_kind(6, 37)), intent(in)    :: array_in(:,:,:)
    real(selected_real_kind(6, 37)), optional, intent(in) :: scal
    integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
    integer, optional, intent(in) ::  lbound1, lbound2, lbound3
#if defined(__CUDA)
    attributes(device) :: array_out, array_in
#endif
    !
    real(selected_real_kind(6, 37)) :: scal_ = 1.0
    integer :: i1, d1s, d1e
    integer :: lbound1_, range1_(2)
    integer :: i2, d2s, d2e
    integer :: lbound2_, range2_(2)
    integer :: i3, d3s, d3e
    integer :: lbound3_, range3_(2)
    !
    lbound1_=1
    if (present(lbound1)) lbound1_=lbound1 
    range1_=(/1,size(array_out, 1)/)
    if (present(range1)) range1_=range1 
    !
    ! the lower bound of the assumed shape array passed to the subroutine is 1
    ! lbound and range instead refer to the indexing in the parent caller.
    d1s = range1_(1) -lbound1_ +1
    d1e = range1_(2) -lbound1_ +1
    !
    lbound2_=1
    if (present(lbound2)) lbound2_=lbound2 
    range2_=(/1,size(array_out, 2)/)
    if (present(range2)) range2_=range2 
    !
    ! the lower bound of the assumed shape array passed to the subroutine is 1
    ! lbound and range instead refer to the indexing in the parent caller.
    d2s = range2_(1) -lbound2_ +1
    d2e = range2_(2) -lbound2_ +1
    !
    lbound3_=1
    if (present(lbound3)) lbound3_=lbound3 
    range3_=(/1,size(array_out, 3)/)
    if (present(range3)) range3_=range3 
    !
    ! the lower bound of the assumed shape array passed to the subroutine is 1
    ! lbound and range instead refer to the indexing in the parent caller.
    d3s = range3_(1) -lbound3_ +1
    d3e = range3_(2) -lbound3_ +1
    !
    !
    if (present(scal)) scal_=scal
    !
    !$cuf kernel do(3)
    do i3 = d3s, d3e
    do i2 = d2s, d2e
    do i1 = d1s, d1e
        array_out(i1,i2,i3 ) = &
            array_out(i1,i2,i3 ) + &
            scal_*array_in(i1,i2,i3 )
    enddo
    enddo
    enddo
    !
end subroutine sp_dev_mem_addscal_r3d
!
subroutine sp_dev_mem_addscal_r4d(array_out, array_in, scal, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3, &
                                            range4, lbound4 )
    use iso_fortran_env
    implicit none
    !
    real(selected_real_kind(6, 37)), intent(inout) :: array_out(:,:,:,:)
    real(selected_real_kind(6, 37)), intent(in)    :: array_in(:,:,:,:)
    real(selected_real_kind(6, 37)), optional, intent(in) :: scal
    integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
    integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
#if defined(__CUDA)
    attributes(device) :: array_out, array_in
#endif
    !
    real(selected_real_kind(6, 37)) :: scal_ = 1.0
    integer :: i1, d1s, d1e
    integer :: lbound1_, range1_(2)
    integer :: i2, d2s, d2e
    integer :: lbound2_, range2_(2)
    integer :: i3, d3s, d3e
    integer :: lbound3_, range3_(2)
    integer :: i4, d4s, d4e
    integer :: lbound4_, range4_(2)
    !
    lbound1_=1
    if (present(lbound1)) lbound1_=lbound1 
    range1_=(/1,size(array_out, 1)/)
    if (present(range1)) range1_=range1 
    !
    ! the lower bound of the assumed shape array passed to the subroutine is 1
    ! lbound and range instead refer to the indexing in the parent caller.
    d1s = range1_(1) -lbound1_ +1
    d1e = range1_(2) -lbound1_ +1
    !
    lbound2_=1
    if (present(lbound2)) lbound2_=lbound2 
    range2_=(/1,size(array_out, 2)/)
    if (present(range2)) range2_=range2 
    !
    ! the lower bound of the assumed shape array passed to the subroutine is 1
    ! lbound and range instead refer to the indexing in the parent caller.
    d2s = range2_(1) -lbound2_ +1
    d2e = range2_(2) -lbound2_ +1
    !
    lbound3_=1
    if (present(lbound3)) lbound3_=lbound3 
    range3_=(/1,size(array_out, 3)/)
    if (present(range3)) range3_=range3 
    !
    ! the lower bound of the assumed shape array passed to the subroutine is 1
    ! lbound and range instead refer to the indexing in the parent caller.
    d3s = range3_(1) -lbound3_ +1
    d3e = range3_(2) -lbound3_ +1
    !
    lbound4_=1
    if (present(lbound4)) lbound4_=lbound4 
    range4_=(/1,size(array_out, 4)/)
    if (present(range4)) range4_=range4 
    !
    ! the lower bound of the assumed shape array passed to the subroutine is 1
    ! lbound and range instead refer to the indexing in the parent caller.
    d4s = range4_(1) -lbound4_ +1
    d4e = range4_(2) -lbound4_ +1
    !
    !
    if (present(scal)) scal_=scal
    !
    !$cuf kernel do(4)
    do i4 = d4s, d4e
    do i3 = d3s, d3e
    do i2 = d2s, d2e
    do i1 = d1s, d1e
        array_out(i1,i2,i3,i4 ) = &
            array_out(i1,i2,i3,i4 ) + &
            scal_*array_in(i1,i2,i3,i4 )
    enddo
    enddo
    enddo
    enddo
    !
end subroutine sp_dev_mem_addscal_r4d
!
subroutine dp_dev_mem_addscal_c1d(array_out, array_in, scal, &
                                            range1, lbound1 )
    use iso_fortran_env
    implicit none
    !
    complex(selected_real_kind(14,200)), intent(inout) :: array_out(:)
    complex(selected_real_kind(14,200)), intent(in)    :: array_in(:)
    complex(selected_real_kind(14,200)), optional, intent(in) :: scal
    integer, optional, intent(in) ::  range1(2)
    integer, optional, intent(in) ::  lbound1
#if defined(__CUDA)
    attributes(device) :: array_out, array_in
#endif
    !
    complex(selected_real_kind(14,200)) :: scal_ = (1.0, 0.0)
    integer :: i1, d1s, d1e
    integer :: lbound1_, range1_(2)
    !
    lbound1_=1
    if (present(lbound1)) lbound1_=lbound1 
    range1_=(/1,size(array_out, 1)/)
    if (present(range1)) range1_=range1 
    !
    ! the lower bound of the assumed shape array passed to the subroutine is 1
    ! lbound and range instead refer to the indexing in the parent caller.
    d1s = range1_(1) -lbound1_ +1
    d1e = range1_(2) -lbound1_ +1
    !
    !
    if (present(scal)) scal_=scal
    !
    !$cuf kernel do(1)
    do i1 = d1s, d1e
        array_out(i1 ) = &
            array_out(i1 ) + &
            scal_*array_in(i1 )
    enddo
    !
end subroutine dp_dev_mem_addscal_c1d
!
subroutine dp_dev_mem_addscal_c2d(array_out, array_in, scal, &
                                            range1, lbound1, &
                                            range2, lbound2 )
    use iso_fortran_env
    implicit none
    !
    complex(selected_real_kind(14,200)), intent(inout) :: array_out(:,:)
    complex(selected_real_kind(14,200)), intent(in)    :: array_in(:,:)
    complex(selected_real_kind(14,200)), optional, intent(in) :: scal
    integer, optional, intent(in) ::  range1(2), range2(2)
    integer, optional, intent(in) ::  lbound1, lbound2
#if defined(__CUDA)
    attributes(device) :: array_out, array_in
#endif
    !
    complex(selected_real_kind(14,200)) :: scal_ = (1.0, 0.0)
    integer :: i1, d1s, d1e
    integer :: lbound1_, range1_(2)
    integer :: i2, d2s, d2e
    integer :: lbound2_, range2_(2)
    !
    lbound1_=1
    if (present(lbound1)) lbound1_=lbound1 
    range1_=(/1,size(array_out, 1)/)
    if (present(range1)) range1_=range1 
    !
    ! the lower bound of the assumed shape array passed to the subroutine is 1
    ! lbound and range instead refer to the indexing in the parent caller.
    d1s = range1_(1) -lbound1_ +1
    d1e = range1_(2) -lbound1_ +1
    !
    lbound2_=1
    if (present(lbound2)) lbound2_=lbound2 
    range2_=(/1,size(array_out, 2)/)
    if (present(range2)) range2_=range2 
    !
    ! the lower bound of the assumed shape array passed to the subroutine is 1
    ! lbound and range instead refer to the indexing in the parent caller.
    d2s = range2_(1) -lbound2_ +1
    d2e = range2_(2) -lbound2_ +1
    !
    !
    if (present(scal)) scal_=scal
    !
    !$cuf kernel do(2)
    do i2 = d2s, d2e
    do i1 = d1s, d1e
        array_out(i1,i2 ) = &
            array_out(i1,i2 ) + &
            scal_*array_in(i1,i2 )
    enddo
    enddo
    !
end subroutine dp_dev_mem_addscal_c2d
!
subroutine dp_dev_mem_addscal_c3d(array_out, array_in, scal, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3 )
    use iso_fortran_env
    implicit none
    !
    complex(selected_real_kind(14,200)), intent(inout) :: array_out(:,:,:)
    complex(selected_real_kind(14,200)), intent(in)    :: array_in(:,:,:)
    complex(selected_real_kind(14,200)), optional, intent(in) :: scal
    integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
    integer, optional, intent(in) ::  lbound1, lbound2, lbound3
#if defined(__CUDA)
    attributes(device) :: array_out, array_in
#endif
    !
    complex(selected_real_kind(14,200)) :: scal_ = (1.0, 0.0)
    integer :: i1, d1s, d1e
    integer :: lbound1_, range1_(2)
    integer :: i2, d2s, d2e
    integer :: lbound2_, range2_(2)
    integer :: i3, d3s, d3e
    integer :: lbound3_, range3_(2)
    !
    lbound1_=1
    if (present(lbound1)) lbound1_=lbound1 
    range1_=(/1,size(array_out, 1)/)
    if (present(range1)) range1_=range1 
    !
    ! the lower bound of the assumed shape array passed to the subroutine is 1
    ! lbound and range instead refer to the indexing in the parent caller.
    d1s = range1_(1) -lbound1_ +1
    d1e = range1_(2) -lbound1_ +1
    !
    lbound2_=1
    if (present(lbound2)) lbound2_=lbound2 
    range2_=(/1,size(array_out, 2)/)
    if (present(range2)) range2_=range2 
    !
    ! the lower bound of the assumed shape array passed to the subroutine is 1
    ! lbound and range instead refer to the indexing in the parent caller.
    d2s = range2_(1) -lbound2_ +1
    d2e = range2_(2) -lbound2_ +1
    !
    lbound3_=1
    if (present(lbound3)) lbound3_=lbound3 
    range3_=(/1,size(array_out, 3)/)
    if (present(range3)) range3_=range3 
    !
    ! the lower bound of the assumed shape array passed to the subroutine is 1
    ! lbound and range instead refer to the indexing in the parent caller.
    d3s = range3_(1) -lbound3_ +1
    d3e = range3_(2) -lbound3_ +1
    !
    !
    if (present(scal)) scal_=scal
    !
    !$cuf kernel do(3)
    do i3 = d3s, d3e
    do i2 = d2s, d2e
    do i1 = d1s, d1e
        array_out(i1,i2,i3 ) = &
            array_out(i1,i2,i3 ) + &
            scal_*array_in(i1,i2,i3 )
    enddo
    enddo
    enddo
    !
end subroutine dp_dev_mem_addscal_c3d
!
subroutine dp_dev_mem_addscal_c4d(array_out, array_in, scal, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3, &
                                            range4, lbound4 )
    use iso_fortran_env
    implicit none
    !
    complex(selected_real_kind(14,200)), intent(inout) :: array_out(:,:,:,:)
    complex(selected_real_kind(14,200)), intent(in)    :: array_in(:,:,:,:)
    complex(selected_real_kind(14,200)), optional, intent(in) :: scal
    integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
    integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
#if defined(__CUDA)
    attributes(device) :: array_out, array_in
#endif
    !
    complex(selected_real_kind(14,200)) :: scal_ = (1.0, 0.0)
    integer :: i1, d1s, d1e
    integer :: lbound1_, range1_(2)
    integer :: i2, d2s, d2e
    integer :: lbound2_, range2_(2)
    integer :: i3, d3s, d3e
    integer :: lbound3_, range3_(2)
    integer :: i4, d4s, d4e
    integer :: lbound4_, range4_(2)
    !
    lbound1_=1
    if (present(lbound1)) lbound1_=lbound1 
    range1_=(/1,size(array_out, 1)/)
    if (present(range1)) range1_=range1 
    !
    ! the lower bound of the assumed shape array passed to the subroutine is 1
    ! lbound and range instead refer to the indexing in the parent caller.
    d1s = range1_(1) -lbound1_ +1
    d1e = range1_(2) -lbound1_ +1
    !
    lbound2_=1
    if (present(lbound2)) lbound2_=lbound2 
    range2_=(/1,size(array_out, 2)/)
    if (present(range2)) range2_=range2 
    !
    ! the lower bound of the assumed shape array passed to the subroutine is 1
    ! lbound and range instead refer to the indexing in the parent caller.
    d2s = range2_(1) -lbound2_ +1
    d2e = range2_(2) -lbound2_ +1
    !
    lbound3_=1
    if (present(lbound3)) lbound3_=lbound3 
    range3_=(/1,size(array_out, 3)/)
    if (present(range3)) range3_=range3 
    !
    ! the lower bound of the assumed shape array passed to the subroutine is 1
    ! lbound and range instead refer to the indexing in the parent caller.
    d3s = range3_(1) -lbound3_ +1
    d3e = range3_(2) -lbound3_ +1
    !
    lbound4_=1
    if (present(lbound4)) lbound4_=lbound4 
    range4_=(/1,size(array_out, 4)/)
    if (present(range4)) range4_=range4 
    !
    ! the lower bound of the assumed shape array passed to the subroutine is 1
    ! lbound and range instead refer to the indexing in the parent caller.
    d4s = range4_(1) -lbound4_ +1
    d4e = range4_(2) -lbound4_ +1
    !
    !
    if (present(scal)) scal_=scal
    !
    !$cuf kernel do(4)
    do i4 = d4s, d4e
    do i3 = d3s, d3e
    do i2 = d2s, d2e
    do i1 = d1s, d1e
        array_out(i1,i2,i3,i4 ) = &
            array_out(i1,i2,i3,i4 ) + &
            scal_*array_in(i1,i2,i3,i4 )
    enddo
    enddo
    enddo
    enddo
    !
end subroutine dp_dev_mem_addscal_c4d
!
subroutine sp_dev_mem_addscal_c1d(array_out, array_in, scal, &
                                            range1, lbound1 )
    use iso_fortran_env
    implicit none
    !
    complex(selected_real_kind(6, 37)), intent(inout) :: array_out(:)
    complex(selected_real_kind(6, 37)), intent(in)    :: array_in(:)
    complex(selected_real_kind(6, 37)), optional, intent(in) :: scal
    integer, optional, intent(in) ::  range1(2)
    integer, optional, intent(in) ::  lbound1
#if defined(__CUDA)
    attributes(device) :: array_out, array_in
#endif
    !
    complex(selected_real_kind(6, 37)) :: scal_ = (1.0, 0.0)
    integer :: i1, d1s, d1e
    integer :: lbound1_, range1_(2)
    !
    lbound1_=1
    if (present(lbound1)) lbound1_=lbound1 
    range1_=(/1,size(array_out, 1)/)
    if (present(range1)) range1_=range1 
    !
    ! the lower bound of the assumed shape array passed to the subroutine is 1
    ! lbound and range instead refer to the indexing in the parent caller.
    d1s = range1_(1) -lbound1_ +1
    d1e = range1_(2) -lbound1_ +1
    !
    !
    if (present(scal)) scal_=scal
    !
    !$cuf kernel do(1)
    do i1 = d1s, d1e
        array_out(i1 ) = &
            array_out(i1 ) + &
            scal_*array_in(i1 )
    enddo
    !
end subroutine sp_dev_mem_addscal_c1d
!
subroutine sp_dev_mem_addscal_c2d(array_out, array_in, scal, &
                                            range1, lbound1, &
                                            range2, lbound2 )
    use iso_fortran_env
    implicit none
    !
    complex(selected_real_kind(6, 37)), intent(inout) :: array_out(:,:)
    complex(selected_real_kind(6, 37)), intent(in)    :: array_in(:,:)
    complex(selected_real_kind(6, 37)), optional, intent(in) :: scal
    integer, optional, intent(in) ::  range1(2), range2(2)
    integer, optional, intent(in) ::  lbound1, lbound2
#if defined(__CUDA)
    attributes(device) :: array_out, array_in
#endif
    !
    complex(selected_real_kind(6, 37)) :: scal_ = (1.0, 0.0)
    integer :: i1, d1s, d1e
    integer :: lbound1_, range1_(2)
    integer :: i2, d2s, d2e
    integer :: lbound2_, range2_(2)
    !
    lbound1_=1
    if (present(lbound1)) lbound1_=lbound1 
    range1_=(/1,size(array_out, 1)/)
    if (present(range1)) range1_=range1 
    !
    ! the lower bound of the assumed shape array passed to the subroutine is 1
    ! lbound and range instead refer to the indexing in the parent caller.
    d1s = range1_(1) -lbound1_ +1
    d1e = range1_(2) -lbound1_ +1
    !
    lbound2_=1
    if (present(lbound2)) lbound2_=lbound2 
    range2_=(/1,size(array_out, 2)/)
    if (present(range2)) range2_=range2 
    !
    ! the lower bound of the assumed shape array passed to the subroutine is 1
    ! lbound and range instead refer to the indexing in the parent caller.
    d2s = range2_(1) -lbound2_ +1
    d2e = range2_(2) -lbound2_ +1
    !
    !
    if (present(scal)) scal_=scal
    !
    !$cuf kernel do(2)
    do i2 = d2s, d2e
    do i1 = d1s, d1e
        array_out(i1,i2 ) = &
            array_out(i1,i2 ) + &
            scal_*array_in(i1,i2 )
    enddo
    enddo
    !
end subroutine sp_dev_mem_addscal_c2d
!
subroutine sp_dev_mem_addscal_c3d(array_out, array_in, scal, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3 )
    use iso_fortran_env
    implicit none
    !
    complex(selected_real_kind(6, 37)), intent(inout) :: array_out(:,:,:)
    complex(selected_real_kind(6, 37)), intent(in)    :: array_in(:,:,:)
    complex(selected_real_kind(6, 37)), optional, intent(in) :: scal
    integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
    integer, optional, intent(in) ::  lbound1, lbound2, lbound3
#if defined(__CUDA)
    attributes(device) :: array_out, array_in
#endif
    !
    complex(selected_real_kind(6, 37)) :: scal_ = (1.0, 0.0)
    integer :: i1, d1s, d1e
    integer :: lbound1_, range1_(2)
    integer :: i2, d2s, d2e
    integer :: lbound2_, range2_(2)
    integer :: i3, d3s, d3e
    integer :: lbound3_, range3_(2)
    !
    lbound1_=1
    if (present(lbound1)) lbound1_=lbound1 
    range1_=(/1,size(array_out, 1)/)
    if (present(range1)) range1_=range1 
    !
    ! the lower bound of the assumed shape array passed to the subroutine is 1
    ! lbound and range instead refer to the indexing in the parent caller.
    d1s = range1_(1) -lbound1_ +1
    d1e = range1_(2) -lbound1_ +1
    !
    lbound2_=1
    if (present(lbound2)) lbound2_=lbound2 
    range2_=(/1,size(array_out, 2)/)
    if (present(range2)) range2_=range2 
    !
    ! the lower bound of the assumed shape array passed to the subroutine is 1
    ! lbound and range instead refer to the indexing in the parent caller.
    d2s = range2_(1) -lbound2_ +1
    d2e = range2_(2) -lbound2_ +1
    !
    lbound3_=1
    if (present(lbound3)) lbound3_=lbound3 
    range3_=(/1,size(array_out, 3)/)
    if (present(range3)) range3_=range3 
    !
    ! the lower bound of the assumed shape array passed to the subroutine is 1
    ! lbound and range instead refer to the indexing in the parent caller.
    d3s = range3_(1) -lbound3_ +1
    d3e = range3_(2) -lbound3_ +1
    !
    !
    if (present(scal)) scal_=scal
    !
    !$cuf kernel do(3)
    do i3 = d3s, d3e
    do i2 = d2s, d2e
    do i1 = d1s, d1e
        array_out(i1,i2,i3 ) = &
            array_out(i1,i2,i3 ) + &
            scal_*array_in(i1,i2,i3 )
    enddo
    enddo
    enddo
    !
end subroutine sp_dev_mem_addscal_c3d
!
subroutine sp_dev_mem_addscal_c4d(array_out, array_in, scal, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3, &
                                            range4, lbound4 )
    use iso_fortran_env
    implicit none
    !
    complex(selected_real_kind(6, 37)), intent(inout) :: array_out(:,:,:,:)
    complex(selected_real_kind(6, 37)), intent(in)    :: array_in(:,:,:,:)
    complex(selected_real_kind(6, 37)), optional, intent(in) :: scal
    integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
    integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
#if defined(__CUDA)
    attributes(device) :: array_out, array_in
#endif
    !
    complex(selected_real_kind(6, 37)) :: scal_ = (1.0, 0.0)
    integer :: i1, d1s, d1e
    integer :: lbound1_, range1_(2)
    integer :: i2, d2s, d2e
    integer :: lbound2_, range2_(2)
    integer :: i3, d3s, d3e
    integer :: lbound3_, range3_(2)
    integer :: i4, d4s, d4e
    integer :: lbound4_, range4_(2)
    !
    lbound1_=1
    if (present(lbound1)) lbound1_=lbound1 
    range1_=(/1,size(array_out, 1)/)
    if (present(range1)) range1_=range1 
    !
    ! the lower bound of the assumed shape array passed to the subroutine is 1
    ! lbound and range instead refer to the indexing in the parent caller.
    d1s = range1_(1) -lbound1_ +1
    d1e = range1_(2) -lbound1_ +1
    !
    lbound2_=1
    if (present(lbound2)) lbound2_=lbound2 
    range2_=(/1,size(array_out, 2)/)
    if (present(range2)) range2_=range2 
    !
    ! the lower bound of the assumed shape array passed to the subroutine is 1
    ! lbound and range instead refer to the indexing in the parent caller.
    d2s = range2_(1) -lbound2_ +1
    d2e = range2_(2) -lbound2_ +1
    !
    lbound3_=1
    if (present(lbound3)) lbound3_=lbound3 
    range3_=(/1,size(array_out, 3)/)
    if (present(range3)) range3_=range3 
    !
    ! the lower bound of the assumed shape array passed to the subroutine is 1
    ! lbound and range instead refer to the indexing in the parent caller.
    d3s = range3_(1) -lbound3_ +1
    d3e = range3_(2) -lbound3_ +1
    !
    lbound4_=1
    if (present(lbound4)) lbound4_=lbound4 
    range4_=(/1,size(array_out, 4)/)
    if (present(range4)) range4_=range4 
    !
    ! the lower bound of the assumed shape array passed to the subroutine is 1
    ! lbound and range instead refer to the indexing in the parent caller.
    d4s = range4_(1) -lbound4_ +1
    d4e = range4_(2) -lbound4_ +1
    !
    !
    if (present(scal)) scal_=scal
    !
    !$cuf kernel do(4)
    do i4 = d4s, d4e
    do i3 = d3s, d3e
    do i2 = d2s, d2e
    do i1 = d1s, d1e
        array_out(i1,i2,i3,i4 ) = &
            array_out(i1,i2,i3,i4 ) + &
            scal_*array_in(i1,i2,i3,i4 )
    enddo
    enddo
    enddo
    enddo
    !
end subroutine sp_dev_mem_addscal_c4d
!
!
!======================
!

!
! Copyright (C) 2022, MaX CoE
! Distributed under the MIT License 
! (license terms are at http://opensource.org/licenses/MIT).
!
!--
!
! Utility functions to check host memory mapping state
! using CUDA-Fortran, OpenACC or OpenMP Offload
!
!==================================================================
!==================================================================
! *DO NOT EDIT*: automatically generated from device_mapping_mapped.jf90
!==================================================================
!==================================================================
!
#include<devxlib_macros.h>
#include<devxlib_defs.h>
!
!=======================================
!
submodule (devxlib_mapping) devxlib_mapping_mapped

   implicit none
     !
     ! _devxlib_mapping_mapped_  functions will return allocated(array)
     !                           when no GPU support is present
     !
   contains
      module function sp_devxlib_mapping_mapped_r1d(array) result(res)
         implicit none
         !
         logical :: res
#if defined __DXL_OPENMP_GPU
         real(real32), allocatable, target :: array(:)
#else
         real(real32), allocatable DEV_ATTR :: array(:)
#endif
         !
         res = .false.
         !
#if defined __DXL_CUDAF
         res=allocated(array)
#elif defined __DXL_OPENACC
         res=allocated(array)
         if (res) res=acc_is_present(array)
#elif defined __DXL_OPENMP_GPU
         res=allocated(array)
         if (res) res=(omp_target_is_present(c_loc(array), omp_get_default_device())/=0)
#else
         res=allocated(array)
#endif
         return
      end function sp_devxlib_mapping_mapped_r1d
      !
      module function sp_devxlib_mapping_mapped_r2d(array) result(res)
         implicit none
         !
         logical :: res
#if defined __DXL_OPENMP_GPU
         real(real32), allocatable, target :: array(:,:)
#else
         real(real32), allocatable DEV_ATTR :: array(:,:)
#endif
         !
         res = .false.
         !
#if defined __DXL_CUDAF
         res=allocated(array)
#elif defined __DXL_OPENACC
         res=allocated(array)
         if (res) res=acc_is_present(array)
#elif defined __DXL_OPENMP_GPU
         res=allocated(array)
         if (res) res=(omp_target_is_present(c_loc(array), omp_get_default_device())/=0)
#else
         res=allocated(array)
#endif
         return
      end function sp_devxlib_mapping_mapped_r2d
      !
      module function sp_devxlib_mapping_mapped_r3d(array) result(res)
         implicit none
         !
         logical :: res
#if defined __DXL_OPENMP_GPU
         real(real32), allocatable, target :: array(:,:,:)
#else
         real(real32), allocatable DEV_ATTR :: array(:,:,:)
#endif
         !
         res = .false.
         !
#if defined __DXL_CUDAF
         res=allocated(array)
#elif defined __DXL_OPENACC
         res=allocated(array)
         if (res) res=acc_is_present(array)
#elif defined __DXL_OPENMP_GPU
         res=allocated(array)
         if (res) res=(omp_target_is_present(c_loc(array), omp_get_default_device())/=0)
#else
         res=allocated(array)
#endif
         return
      end function sp_devxlib_mapping_mapped_r3d
      !
      module function sp_devxlib_mapping_mapped_r4d(array) result(res)
         implicit none
         !
         logical :: res
#if defined __DXL_OPENMP_GPU
         real(real32), allocatable, target :: array(:,:,:,:)
#else
         real(real32), allocatable DEV_ATTR :: array(:,:,:,:)
#endif
         !
         res = .false.
         !
#if defined __DXL_CUDAF
         res=allocated(array)
#elif defined __DXL_OPENACC
         res=allocated(array)
         if (res) res=acc_is_present(array)
#elif defined __DXL_OPENMP_GPU
         res=allocated(array)
         if (res) res=(omp_target_is_present(c_loc(array), omp_get_default_device())/=0)
#else
         res=allocated(array)
#endif
         return
      end function sp_devxlib_mapping_mapped_r4d
      !
      module function sp_devxlib_mapping_mapped_r5d(array) result(res)
         implicit none
         !
         logical :: res
#if defined __DXL_OPENMP_GPU
         real(real32), allocatable, target :: array(:,:,:,:,:)
#else
         real(real32), allocatable DEV_ATTR :: array(:,:,:,:,:)
#endif
         !
         res = .false.
         !
#if defined __DXL_CUDAF
         res=allocated(array)
#elif defined __DXL_OPENACC
         res=allocated(array)
         if (res) res=acc_is_present(array)
#elif defined __DXL_OPENMP_GPU
         res=allocated(array)
         if (res) res=(omp_target_is_present(c_loc(array), omp_get_default_device())/=0)
#else
         res=allocated(array)
#endif
         return
      end function sp_devxlib_mapping_mapped_r5d
      !
      module function sp_devxlib_mapping_mapped_r6d(array) result(res)
         implicit none
         !
         logical :: res
#if defined __DXL_OPENMP_GPU
         real(real32), allocatable, target :: array(:,:,:,:,:,:)
#else
         real(real32), allocatable DEV_ATTR :: array(:,:,:,:,:,:)
#endif
         !
         res = .false.
         !
#if defined __DXL_CUDAF
         res=allocated(array)
#elif defined __DXL_OPENACC
         res=allocated(array)
         if (res) res=acc_is_present(array)
#elif defined __DXL_OPENMP_GPU
         res=allocated(array)
         if (res) res=(omp_target_is_present(c_loc(array), omp_get_default_device())/=0)
#else
         res=allocated(array)
#endif
         return
      end function sp_devxlib_mapping_mapped_r6d
      !
      module function dp_devxlib_mapping_mapped_r1d(array) result(res)
         implicit none
         !
         logical :: res
#if defined __DXL_OPENMP_GPU
         real(real64), allocatable, target :: array(:)
#else
         real(real64), allocatable DEV_ATTR :: array(:)
#endif
         !
         res = .false.
         !
#if defined __DXL_CUDAF
         res=allocated(array)
#elif defined __DXL_OPENACC
         res=allocated(array)
         if (res) res=acc_is_present(array)
#elif defined __DXL_OPENMP_GPU
         res=allocated(array)
         if (res) res=(omp_target_is_present(c_loc(array), omp_get_default_device())/=0)
#else
         res=allocated(array)
#endif
         return
      end function dp_devxlib_mapping_mapped_r1d
      !
      module function dp_devxlib_mapping_mapped_r2d(array) result(res)
         implicit none
         !
         logical :: res
#if defined __DXL_OPENMP_GPU
         real(real64), allocatable, target :: array(:,:)
#else
         real(real64), allocatable DEV_ATTR :: array(:,:)
#endif
         !
         res = .false.
         !
#if defined __DXL_CUDAF
         res=allocated(array)
#elif defined __DXL_OPENACC
         res=allocated(array)
         if (res) res=acc_is_present(array)
#elif defined __DXL_OPENMP_GPU
         res=allocated(array)
         if (res) res=(omp_target_is_present(c_loc(array), omp_get_default_device())/=0)
#else
         res=allocated(array)
#endif
         return
      end function dp_devxlib_mapping_mapped_r2d
      !
      module function dp_devxlib_mapping_mapped_r3d(array) result(res)
         implicit none
         !
         logical :: res
#if defined __DXL_OPENMP_GPU
         real(real64), allocatable, target :: array(:,:,:)
#else
         real(real64), allocatable DEV_ATTR :: array(:,:,:)
#endif
         !
         res = .false.
         !
#if defined __DXL_CUDAF
         res=allocated(array)
#elif defined __DXL_OPENACC
         res=allocated(array)
         if (res) res=acc_is_present(array)
#elif defined __DXL_OPENMP_GPU
         res=allocated(array)
         if (res) res=(omp_target_is_present(c_loc(array), omp_get_default_device())/=0)
#else
         res=allocated(array)
#endif
         return
      end function dp_devxlib_mapping_mapped_r3d
      !
      module function dp_devxlib_mapping_mapped_r4d(array) result(res)
         implicit none
         !
         logical :: res
#if defined __DXL_OPENMP_GPU
         real(real64), allocatable, target :: array(:,:,:,:)
#else
         real(real64), allocatable DEV_ATTR :: array(:,:,:,:)
#endif
         !
         res = .false.
         !
#if defined __DXL_CUDAF
         res=allocated(array)
#elif defined __DXL_OPENACC
         res=allocated(array)
         if (res) res=acc_is_present(array)
#elif defined __DXL_OPENMP_GPU
         res=allocated(array)
         if (res) res=(omp_target_is_present(c_loc(array), omp_get_default_device())/=0)
#else
         res=allocated(array)
#endif
         return
      end function dp_devxlib_mapping_mapped_r4d
      !
      module function dp_devxlib_mapping_mapped_r5d(array) result(res)
         implicit none
         !
         logical :: res
#if defined __DXL_OPENMP_GPU
         real(real64), allocatable, target :: array(:,:,:,:,:)
#else
         real(real64), allocatable DEV_ATTR :: array(:,:,:,:,:)
#endif
         !
         res = .false.
         !
#if defined __DXL_CUDAF
         res=allocated(array)
#elif defined __DXL_OPENACC
         res=allocated(array)
         if (res) res=acc_is_present(array)
#elif defined __DXL_OPENMP_GPU
         res=allocated(array)
         if (res) res=(omp_target_is_present(c_loc(array), omp_get_default_device())/=0)
#else
         res=allocated(array)
#endif
         return
      end function dp_devxlib_mapping_mapped_r5d
      !
      module function dp_devxlib_mapping_mapped_r6d(array) result(res)
         implicit none
         !
         logical :: res
#if defined __DXL_OPENMP_GPU
         real(real64), allocatable, target :: array(:,:,:,:,:,:)
#else
         real(real64), allocatable DEV_ATTR :: array(:,:,:,:,:,:)
#endif
         !
         res = .false.
         !
#if defined __DXL_CUDAF
         res=allocated(array)
#elif defined __DXL_OPENACC
         res=allocated(array)
         if (res) res=acc_is_present(array)
#elif defined __DXL_OPENMP_GPU
         res=allocated(array)
         if (res) res=(omp_target_is_present(c_loc(array), omp_get_default_device())/=0)
#else
         res=allocated(array)
#endif
         return
      end function dp_devxlib_mapping_mapped_r6d
      !
      module function sp_devxlib_mapping_mapped_c1d(array) result(res)
         implicit none
         !
         logical :: res
#if defined __DXL_OPENMP_GPU
         complex(real32), allocatable, target :: array(:)
#else
         complex(real32), allocatable DEV_ATTR :: array(:)
#endif
         !
         res = .false.
         !
#if defined __DXL_CUDAF
         res=allocated(array)
#elif defined __DXL_OPENACC
         res=allocated(array)
         if (res) res=acc_is_present(array)
#elif defined __DXL_OPENMP_GPU
         res=allocated(array)
         if (res) res=(omp_target_is_present(c_loc(array), omp_get_default_device())/=0)
#else
         res=allocated(array)
#endif
         return
      end function sp_devxlib_mapping_mapped_c1d
      !
      module function sp_devxlib_mapping_mapped_c2d(array) result(res)
         implicit none
         !
         logical :: res
#if defined __DXL_OPENMP_GPU
         complex(real32), allocatable, target :: array(:,:)
#else
         complex(real32), allocatable DEV_ATTR :: array(:,:)
#endif
         !
         res = .false.
         !
#if defined __DXL_CUDAF
         res=allocated(array)
#elif defined __DXL_OPENACC
         res=allocated(array)
         if (res) res=acc_is_present(array)
#elif defined __DXL_OPENMP_GPU
         res=allocated(array)
         if (res) res=(omp_target_is_present(c_loc(array), omp_get_default_device())/=0)
#else
         res=allocated(array)
#endif
         return
      end function sp_devxlib_mapping_mapped_c2d
      !
      module function sp_devxlib_mapping_mapped_c3d(array) result(res)
         implicit none
         !
         logical :: res
#if defined __DXL_OPENMP_GPU
         complex(real32), allocatable, target :: array(:,:,:)
#else
         complex(real32), allocatable DEV_ATTR :: array(:,:,:)
#endif
         !
         res = .false.
         !
#if defined __DXL_CUDAF
         res=allocated(array)
#elif defined __DXL_OPENACC
         res=allocated(array)
         if (res) res=acc_is_present(array)
#elif defined __DXL_OPENMP_GPU
         res=allocated(array)
         if (res) res=(omp_target_is_present(c_loc(array), omp_get_default_device())/=0)
#else
         res=allocated(array)
#endif
         return
      end function sp_devxlib_mapping_mapped_c3d
      !
      module function sp_devxlib_mapping_mapped_c4d(array) result(res)
         implicit none
         !
         logical :: res
#if defined __DXL_OPENMP_GPU
         complex(real32), allocatable, target :: array(:,:,:,:)
#else
         complex(real32), allocatable DEV_ATTR :: array(:,:,:,:)
#endif
         !
         res = .false.
         !
#if defined __DXL_CUDAF
         res=allocated(array)
#elif defined __DXL_OPENACC
         res=allocated(array)
         if (res) res=acc_is_present(array)
#elif defined __DXL_OPENMP_GPU
         res=allocated(array)
         if (res) res=(omp_target_is_present(c_loc(array), omp_get_default_device())/=0)
#else
         res=allocated(array)
#endif
         return
      end function sp_devxlib_mapping_mapped_c4d
      !
      module function sp_devxlib_mapping_mapped_c5d(array) result(res)
         implicit none
         !
         logical :: res
#if defined __DXL_OPENMP_GPU
         complex(real32), allocatable, target :: array(:,:,:,:,:)
#else
         complex(real32), allocatable DEV_ATTR :: array(:,:,:,:,:)
#endif
         !
         res = .false.
         !
#if defined __DXL_CUDAF
         res=allocated(array)
#elif defined __DXL_OPENACC
         res=allocated(array)
         if (res) res=acc_is_present(array)
#elif defined __DXL_OPENMP_GPU
         res=allocated(array)
         if (res) res=(omp_target_is_present(c_loc(array), omp_get_default_device())/=0)
#else
         res=allocated(array)
#endif
         return
      end function sp_devxlib_mapping_mapped_c5d
      !
      module function sp_devxlib_mapping_mapped_c6d(array) result(res)
         implicit none
         !
         logical :: res
#if defined __DXL_OPENMP_GPU
         complex(real32), allocatable, target :: array(:,:,:,:,:,:)
#else
         complex(real32), allocatable DEV_ATTR :: array(:,:,:,:,:,:)
#endif
         !
         res = .false.
         !
#if defined __DXL_CUDAF
         res=allocated(array)
#elif defined __DXL_OPENACC
         res=allocated(array)
         if (res) res=acc_is_present(array)
#elif defined __DXL_OPENMP_GPU
         res=allocated(array)
         if (res) res=(omp_target_is_present(c_loc(array), omp_get_default_device())/=0)
#else
         res=allocated(array)
#endif
         return
      end function sp_devxlib_mapping_mapped_c6d
      !
      module function dp_devxlib_mapping_mapped_c1d(array) result(res)
         implicit none
         !
         logical :: res
#if defined __DXL_OPENMP_GPU
         complex(real64), allocatable, target :: array(:)
#else
         complex(real64), allocatable DEV_ATTR :: array(:)
#endif
         !
         res = .false.
         !
#if defined __DXL_CUDAF
         res=allocated(array)
#elif defined __DXL_OPENACC
         res=allocated(array)
         if (res) res=acc_is_present(array)
#elif defined __DXL_OPENMP_GPU
         res=allocated(array)
         if (res) res=(omp_target_is_present(c_loc(array), omp_get_default_device())/=0)
#else
         res=allocated(array)
#endif
         return
      end function dp_devxlib_mapping_mapped_c1d
      !
      module function dp_devxlib_mapping_mapped_c2d(array) result(res)
         implicit none
         !
         logical :: res
#if defined __DXL_OPENMP_GPU
         complex(real64), allocatable, target :: array(:,:)
#else
         complex(real64), allocatable DEV_ATTR :: array(:,:)
#endif
         !
         res = .false.
         !
#if defined __DXL_CUDAF
         res=allocated(array)
#elif defined __DXL_OPENACC
         res=allocated(array)
         if (res) res=acc_is_present(array)
#elif defined __DXL_OPENMP_GPU
         res=allocated(array)
         if (res) res=(omp_target_is_present(c_loc(array), omp_get_default_device())/=0)
#else
         res=allocated(array)
#endif
         return
      end function dp_devxlib_mapping_mapped_c2d
      !
      module function dp_devxlib_mapping_mapped_c3d(array) result(res)
         implicit none
         !
         logical :: res
#if defined __DXL_OPENMP_GPU
         complex(real64), allocatable, target :: array(:,:,:)
#else
         complex(real64), allocatable DEV_ATTR :: array(:,:,:)
#endif
         !
         res = .false.
         !
#if defined __DXL_CUDAF
         res=allocated(array)
#elif defined __DXL_OPENACC
         res=allocated(array)
         if (res) res=acc_is_present(array)
#elif defined __DXL_OPENMP_GPU
         res=allocated(array)
         if (res) res=(omp_target_is_present(c_loc(array), omp_get_default_device())/=0)
#else
         res=allocated(array)
#endif
         return
      end function dp_devxlib_mapping_mapped_c3d
      !
      module function dp_devxlib_mapping_mapped_c4d(array) result(res)
         implicit none
         !
         logical :: res
#if defined __DXL_OPENMP_GPU
         complex(real64), allocatable, target :: array(:,:,:,:)
#else
         complex(real64), allocatable DEV_ATTR :: array(:,:,:,:)
#endif
         !
         res = .false.
         !
#if defined __DXL_CUDAF
         res=allocated(array)
#elif defined __DXL_OPENACC
         res=allocated(array)
         if (res) res=acc_is_present(array)
#elif defined __DXL_OPENMP_GPU
         res=allocated(array)
         if (res) res=(omp_target_is_present(c_loc(array), omp_get_default_device())/=0)
#else
         res=allocated(array)
#endif
         return
      end function dp_devxlib_mapping_mapped_c4d
      !
      module function dp_devxlib_mapping_mapped_c5d(array) result(res)
         implicit none
         !
         logical :: res
#if defined __DXL_OPENMP_GPU
         complex(real64), allocatable, target :: array(:,:,:,:,:)
#else
         complex(real64), allocatable DEV_ATTR :: array(:,:,:,:,:)
#endif
         !
         res = .false.
         !
#if defined __DXL_CUDAF
         res=allocated(array)
#elif defined __DXL_OPENACC
         res=allocated(array)
         if (res) res=acc_is_present(array)
#elif defined __DXL_OPENMP_GPU
         res=allocated(array)
         if (res) res=(omp_target_is_present(c_loc(array), omp_get_default_device())/=0)
#else
         res=allocated(array)
#endif
         return
      end function dp_devxlib_mapping_mapped_c5d
      !
      module function dp_devxlib_mapping_mapped_c6d(array) result(res)
         implicit none
         !
         logical :: res
#if defined __DXL_OPENMP_GPU
         complex(real64), allocatable, target :: array(:,:,:,:,:,:)
#else
         complex(real64), allocatable DEV_ATTR :: array(:,:,:,:,:,:)
#endif
         !
         res = .false.
         !
#if defined __DXL_CUDAF
         res=allocated(array)
#elif defined __DXL_OPENACC
         res=allocated(array)
         if (res) res=acc_is_present(array)
#elif defined __DXL_OPENMP_GPU
         res=allocated(array)
         if (res) res=(omp_target_is_present(c_loc(array), omp_get_default_device())/=0)
#else
         res=allocated(array)
#endif
         return
      end function dp_devxlib_mapping_mapped_c6d
      !
      module function i4_devxlib_mapping_mapped_i1d(array) result(res)
         implicit none
         !
         logical :: res
#if defined __DXL_OPENMP_GPU
         integer(int32), allocatable, target :: array(:)
#else
         integer(int32), allocatable DEV_ATTR :: array(:)
#endif
         !
         res = .false.
         !
#if defined __DXL_CUDAF
         res=allocated(array)
#elif defined __DXL_OPENACC
         res=allocated(array)
         if (res) res=acc_is_present(array)
#elif defined __DXL_OPENMP_GPU
         res=allocated(array)
         if (res) res=(omp_target_is_present(c_loc(array), omp_get_default_device())/=0)
#else
         res=allocated(array)
#endif
         return
      end function i4_devxlib_mapping_mapped_i1d
      !
      module function i4_devxlib_mapping_mapped_i2d(array) result(res)
         implicit none
         !
         logical :: res
#if defined __DXL_OPENMP_GPU
         integer(int32), allocatable, target :: array(:,:)
#else
         integer(int32), allocatable DEV_ATTR :: array(:,:)
#endif
         !
         res = .false.
         !
#if defined __DXL_CUDAF
         res=allocated(array)
#elif defined __DXL_OPENACC
         res=allocated(array)
         if (res) res=acc_is_present(array)
#elif defined __DXL_OPENMP_GPU
         res=allocated(array)
         if (res) res=(omp_target_is_present(c_loc(array), omp_get_default_device())/=0)
#else
         res=allocated(array)
#endif
         return
      end function i4_devxlib_mapping_mapped_i2d
      !
      module function i4_devxlib_mapping_mapped_i3d(array) result(res)
         implicit none
         !
         logical :: res
#if defined __DXL_OPENMP_GPU
         integer(int32), allocatable, target :: array(:,:,:)
#else
         integer(int32), allocatable DEV_ATTR :: array(:,:,:)
#endif
         !
         res = .false.
         !
#if defined __DXL_CUDAF
         res=allocated(array)
#elif defined __DXL_OPENACC
         res=allocated(array)
         if (res) res=acc_is_present(array)
#elif defined __DXL_OPENMP_GPU
         res=allocated(array)
         if (res) res=(omp_target_is_present(c_loc(array), omp_get_default_device())/=0)
#else
         res=allocated(array)
#endif
         return
      end function i4_devxlib_mapping_mapped_i3d
      !
      module function i4_devxlib_mapping_mapped_i4d(array) result(res)
         implicit none
         !
         logical :: res
#if defined __DXL_OPENMP_GPU
         integer(int32), allocatable, target :: array(:,:,:,:)
#else
         integer(int32), allocatable DEV_ATTR :: array(:,:,:,:)
#endif
         !
         res = .false.
         !
#if defined __DXL_CUDAF
         res=allocated(array)
#elif defined __DXL_OPENACC
         res=allocated(array)
         if (res) res=acc_is_present(array)
#elif defined __DXL_OPENMP_GPU
         res=allocated(array)
         if (res) res=(omp_target_is_present(c_loc(array), omp_get_default_device())/=0)
#else
         res=allocated(array)
#endif
         return
      end function i4_devxlib_mapping_mapped_i4d
      !
      module function i4_devxlib_mapping_mapped_i5d(array) result(res)
         implicit none
         !
         logical :: res
#if defined __DXL_OPENMP_GPU
         integer(int32), allocatable, target :: array(:,:,:,:,:)
#else
         integer(int32), allocatable DEV_ATTR :: array(:,:,:,:,:)
#endif
         !
         res = .false.
         !
#if defined __DXL_CUDAF
         res=allocated(array)
#elif defined __DXL_OPENACC
         res=allocated(array)
         if (res) res=acc_is_present(array)
#elif defined __DXL_OPENMP_GPU
         res=allocated(array)
         if (res) res=(omp_target_is_present(c_loc(array), omp_get_default_device())/=0)
#else
         res=allocated(array)
#endif
         return
      end function i4_devxlib_mapping_mapped_i5d
      !
      module function i4_devxlib_mapping_mapped_i6d(array) result(res)
         implicit none
         !
         logical :: res
#if defined __DXL_OPENMP_GPU
         integer(int32), allocatable, target :: array(:,:,:,:,:,:)
#else
         integer(int32), allocatable DEV_ATTR :: array(:,:,:,:,:,:)
#endif
         !
         res = .false.
         !
#if defined __DXL_CUDAF
         res=allocated(array)
#elif defined __DXL_OPENACC
         res=allocated(array)
         if (res) res=acc_is_present(array)
#elif defined __DXL_OPENMP_GPU
         res=allocated(array)
         if (res) res=(omp_target_is_present(c_loc(array), omp_get_default_device())/=0)
#else
         res=allocated(array)
#endif
         return
      end function i4_devxlib_mapping_mapped_i6d
      !
      module function i8_devxlib_mapping_mapped_i1d(array) result(res)
         implicit none
         !
         logical :: res
#if defined __DXL_OPENMP_GPU
         integer(int64), allocatable, target :: array(:)
#else
         integer(int64), allocatable DEV_ATTR :: array(:)
#endif
         !
         res = .false.
         !
#if defined __DXL_CUDAF
         res=allocated(array)
#elif defined __DXL_OPENACC
         res=allocated(array)
         if (res) res=acc_is_present(array)
#elif defined __DXL_OPENMP_GPU
         res=allocated(array)
         if (res) res=(omp_target_is_present(c_loc(array), omp_get_default_device())/=0)
#else
         res=allocated(array)
#endif
         return
      end function i8_devxlib_mapping_mapped_i1d
      !
      module function i8_devxlib_mapping_mapped_i2d(array) result(res)
         implicit none
         !
         logical :: res
#if defined __DXL_OPENMP_GPU
         integer(int64), allocatable, target :: array(:,:)
#else
         integer(int64), allocatable DEV_ATTR :: array(:,:)
#endif
         !
         res = .false.
         !
#if defined __DXL_CUDAF
         res=allocated(array)
#elif defined __DXL_OPENACC
         res=allocated(array)
         if (res) res=acc_is_present(array)
#elif defined __DXL_OPENMP_GPU
         res=allocated(array)
         if (res) res=(omp_target_is_present(c_loc(array), omp_get_default_device())/=0)
#else
         res=allocated(array)
#endif
         return
      end function i8_devxlib_mapping_mapped_i2d
      !
      module function i8_devxlib_mapping_mapped_i3d(array) result(res)
         implicit none
         !
         logical :: res
#if defined __DXL_OPENMP_GPU
         integer(int64), allocatable, target :: array(:,:,:)
#else
         integer(int64), allocatable DEV_ATTR :: array(:,:,:)
#endif
         !
         res = .false.
         !
#if defined __DXL_CUDAF
         res=allocated(array)
#elif defined __DXL_OPENACC
         res=allocated(array)
         if (res) res=acc_is_present(array)
#elif defined __DXL_OPENMP_GPU
         res=allocated(array)
         if (res) res=(omp_target_is_present(c_loc(array), omp_get_default_device())/=0)
#else
         res=allocated(array)
#endif
         return
      end function i8_devxlib_mapping_mapped_i3d
      !
      module function i8_devxlib_mapping_mapped_i4d(array) result(res)
         implicit none
         !
         logical :: res
#if defined __DXL_OPENMP_GPU
         integer(int64), allocatable, target :: array(:,:,:,:)
#else
         integer(int64), allocatable DEV_ATTR :: array(:,:,:,:)
#endif
         !
         res = .false.
         !
#if defined __DXL_CUDAF
         res=allocated(array)
#elif defined __DXL_OPENACC
         res=allocated(array)
         if (res) res=acc_is_present(array)
#elif defined __DXL_OPENMP_GPU
         res=allocated(array)
         if (res) res=(omp_target_is_present(c_loc(array), omp_get_default_device())/=0)
#else
         res=allocated(array)
#endif
         return
      end function i8_devxlib_mapping_mapped_i4d
      !
      module function i8_devxlib_mapping_mapped_i5d(array) result(res)
         implicit none
         !
         logical :: res
#if defined __DXL_OPENMP_GPU
         integer(int64), allocatable, target :: array(:,:,:,:,:)
#else
         integer(int64), allocatable DEV_ATTR :: array(:,:,:,:,:)
#endif
         !
         res = .false.
         !
#if defined __DXL_CUDAF
         res=allocated(array)
#elif defined __DXL_OPENACC
         res=allocated(array)
         if (res) res=acc_is_present(array)
#elif defined __DXL_OPENMP_GPU
         res=allocated(array)
         if (res) res=(omp_target_is_present(c_loc(array), omp_get_default_device())/=0)
#else
         res=allocated(array)
#endif
         return
      end function i8_devxlib_mapping_mapped_i5d
      !
      module function i8_devxlib_mapping_mapped_i6d(array) result(res)
         implicit none
         !
         logical :: res
#if defined __DXL_OPENMP_GPU
         integer(int64), allocatable, target :: array(:,:,:,:,:,:)
#else
         integer(int64), allocatable DEV_ATTR :: array(:,:,:,:,:,:)
#endif
         !
         res = .false.
         !
#if defined __DXL_CUDAF
         res=allocated(array)
#elif defined __DXL_OPENACC
         res=allocated(array)
         if (res) res=acc_is_present(array)
#elif defined __DXL_OPENMP_GPU
         res=allocated(array)
         if (res) res=(omp_target_is_present(c_loc(array), omp_get_default_device())/=0)
#else
         res=allocated(array)
#endif
         return
      end function i8_devxlib_mapping_mapped_i6d
      !
      module function l4_devxlib_mapping_mapped_l1d(array) result(res)
         implicit none
         !
         logical :: res
#if defined __DXL_OPENMP_GPU
         logical(int32), allocatable, target :: array(:)
#else
         logical(int32), allocatable DEV_ATTR :: array(:)
#endif
         !
         res = .false.
         !
#if defined __DXL_CUDAF
         res=allocated(array)
#elif defined __DXL_OPENACC
         res=allocated(array)
         if (res) res=acc_is_present(array)
#elif defined __DXL_OPENMP_GPU
         res=allocated(array)
         if (res) res=(omp_target_is_present(c_loc(array), omp_get_default_device())/=0)
#else
         res=allocated(array)
#endif
         return
      end function l4_devxlib_mapping_mapped_l1d
      !
      module function l4_devxlib_mapping_mapped_l2d(array) result(res)
         implicit none
         !
         logical :: res
#if defined __DXL_OPENMP_GPU
         logical(int32), allocatable, target :: array(:,:)
#else
         logical(int32), allocatable DEV_ATTR :: array(:,:)
#endif
         !
         res = .false.
         !
#if defined __DXL_CUDAF
         res=allocated(array)
#elif defined __DXL_OPENACC
         res=allocated(array)
         if (res) res=acc_is_present(array)
#elif defined __DXL_OPENMP_GPU
         res=allocated(array)
         if (res) res=(omp_target_is_present(c_loc(array), omp_get_default_device())/=0)
#else
         res=allocated(array)
#endif
         return
      end function l4_devxlib_mapping_mapped_l2d
      !
      module function l4_devxlib_mapping_mapped_l3d(array) result(res)
         implicit none
         !
         logical :: res
#if defined __DXL_OPENMP_GPU
         logical(int32), allocatable, target :: array(:,:,:)
#else
         logical(int32), allocatable DEV_ATTR :: array(:,:,:)
#endif
         !
         res = .false.
         !
#if defined __DXL_CUDAF
         res=allocated(array)
#elif defined __DXL_OPENACC
         res=allocated(array)
         if (res) res=acc_is_present(array)
#elif defined __DXL_OPENMP_GPU
         res=allocated(array)
         if (res) res=(omp_target_is_present(c_loc(array), omp_get_default_device())/=0)
#else
         res=allocated(array)
#endif
         return
      end function l4_devxlib_mapping_mapped_l3d
      !
      module function l4_devxlib_mapping_mapped_l4d(array) result(res)
         implicit none
         !
         logical :: res
#if defined __DXL_OPENMP_GPU
         logical(int32), allocatable, target :: array(:,:,:,:)
#else
         logical(int32), allocatable DEV_ATTR :: array(:,:,:,:)
#endif
         !
         res = .false.
         !
#if defined __DXL_CUDAF
         res=allocated(array)
#elif defined __DXL_OPENACC
         res=allocated(array)
         if (res) res=acc_is_present(array)
#elif defined __DXL_OPENMP_GPU
         res=allocated(array)
         if (res) res=(omp_target_is_present(c_loc(array), omp_get_default_device())/=0)
#else
         res=allocated(array)
#endif
         return
      end function l4_devxlib_mapping_mapped_l4d
      !
      module function l4_devxlib_mapping_mapped_l5d(array) result(res)
         implicit none
         !
         logical :: res
#if defined __DXL_OPENMP_GPU
         logical(int32), allocatable, target :: array(:,:,:,:,:)
#else
         logical(int32), allocatable DEV_ATTR :: array(:,:,:,:,:)
#endif
         !
         res = .false.
         !
#if defined __DXL_CUDAF
         res=allocated(array)
#elif defined __DXL_OPENACC
         res=allocated(array)
         if (res) res=acc_is_present(array)
#elif defined __DXL_OPENMP_GPU
         res=allocated(array)
         if (res) res=(omp_target_is_present(c_loc(array), omp_get_default_device())/=0)
#else
         res=allocated(array)
#endif
         return
      end function l4_devxlib_mapping_mapped_l5d
      !
      module function l4_devxlib_mapping_mapped_l6d(array) result(res)
         implicit none
         !
         logical :: res
#if defined __DXL_OPENMP_GPU
         logical(int32), allocatable, target :: array(:,:,:,:,:,:)
#else
         logical(int32), allocatable DEV_ATTR :: array(:,:,:,:,:,:)
#endif
         !
         res = .false.
         !
#if defined __DXL_CUDAF
         res=allocated(array)
#elif defined __DXL_OPENACC
         res=allocated(array)
         if (res) res=acc_is_present(array)
#elif defined __DXL_OPENMP_GPU
         res=allocated(array)
         if (res) res=(omp_target_is_present(c_loc(array), omp_get_default_device())/=0)
#else
         res=allocated(array)
#endif
         return
      end function l4_devxlib_mapping_mapped_l6d
      !

endsubmodule devxlib_mapping_mapped

!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
  module cuda_h
!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
    use, intrinsic :: ISO_C_BINDING
    use cuda_unknowns

    implicit none

    enum, bind(C) !:: CUctx_flags_enum
      enumerator :: CU_CTX_SCHED_AUTO=0
      enumerator :: CU_CTX_SCHED_SPIN=1
      enumerator :: CU_CTX_SCHED_YIELD=2
      enumerator :: CU_CTX_SCHED_MASK=3
      enumerator :: CU_CTX_BLOCKING_SYNC=4
      enumerator :: CU_CTX_MAP_HOST=8
      enumerator :: CU_CTX_LMEM_RESIZE_TO_MAX=16
      enumerator :: CU_CTX_FLAGS_MASK=31
    end enum ! CUctx_flags_enum

    enum, bind(C) !:: CUevent_flags_enum
      enumerator :: CU_EVENT_DEFAULT=0
      enumerator :: CU_EVENT_BLOCKING_SYNC=1
    end enum ! CUevent_flags_enum

    enum, bind(C) !:: CUarray_format_enum
      enumerator :: CU_AD_FORMAT_UNSIGNED_INT8=1
      enumerator :: CU_AD_FORMAT_UNSIGNED_INT16=2
      enumerator :: CU_AD_FORMAT_UNSIGNED_INT32=3
      enumerator :: CU_AD_FORMAT_SIGNED_INT8=8
      enumerator :: CU_AD_FORMAT_SIGNED_INT16=9
      enumerator :: CU_AD_FORMAT_SIGNED_INT32=10
      enumerator :: CU_AD_FORMAT_HALF=16
      enumerator :: CU_AD_FORMAT_FLOAT=32
    end enum ! CUarray_format_enum

    enum, bind(C) !:: CUaddress_mode_enum
      enumerator :: CU_TR_ADDRESS_MODE_WRAP=0
      enumerator :: CU_TR_ADDRESS_MODE_CLAMP=1
      enumerator :: CU_TR_ADDRESS_MODE_MIRROR=2
    end enum ! CUaddress_mode_enum

    enum, bind(C) !:: CUfilter_mode_enum
      enumerator :: CU_TR_FILTER_MODE_POINT=0
      enumerator :: CU_TR_FILTER_MODE_LINEAR=1
    end enum ! CUfilter_mode_enum

    enum, bind(C) !:: CUdevice_attribute_enum
      enumerator :: CU_DEVICE_ATTRIBUTE_MAX_THREADS_PER_BLOCK=1
      enumerator :: CU_DEVICE_ATTRIBUTE_MAX_BLOCK_DIM_X=2
      enumerator :: CU_DEVICE_ATTRIBUTE_MAX_BLOCK_DIM_Y=3
      enumerator :: CU_DEVICE_ATTRIBUTE_MAX_BLOCK_DIM_Z=4
      enumerator :: CU_DEVICE_ATTRIBUTE_MAX_GRID_DIM_X=5
      enumerator :: CU_DEVICE_ATTRIBUTE_MAX_GRID_DIM_Y=6
      enumerator :: CU_DEVICE_ATTRIBUTE_MAX_GRID_DIM_Z=7
      enumerator :: CU_DEVICE_ATTRIBUTE_MAX_SHARED_MEMORY_PER_BLOCK=8
      enumerator :: CU_DEVICE_ATTRIBUTE_SHARED_MEMORY_PER_BLOCK=8
      enumerator :: CU_DEVICE_ATTRIBUTE_TOTAL_CONSTANT_MEMORY=9
      enumerator :: CU_DEVICE_ATTRIBUTE_WARP_SIZE=10
      enumerator :: CU_DEVICE_ATTRIBUTE_MAX_PITCH=11
      enumerator :: CU_DEVICE_ATTRIBUTE_MAX_REGISTERS_PER_BLOCK=12
      enumerator :: CU_DEVICE_ATTRIBUTE_REGISTERS_PER_BLOCK=12
      enumerator :: CU_DEVICE_ATTRIBUTE_CLOCK_RATE=13
      enumerator :: CU_DEVICE_ATTRIBUTE_TEXTURE_ALIGNMENT=14
      enumerator :: CU_DEVICE_ATTRIBUTE_GPU_OVERLAP=15
      enumerator :: CU_DEVICE_ATTRIBUTE_MULTIPROCESSOR_COUNT=16
      enumerator :: CU_DEVICE_ATTRIBUTE_KERNEL_EXEC_TIMEOUT=17
      enumerator :: CU_DEVICE_ATTRIBUTE_INTEGRATED=18
      enumerator :: CU_DEVICE_ATTRIBUTE_CAN_MAP_HOST_MEMORY=19
      enumerator :: CU_DEVICE_ATTRIBUTE_COMPUTE_MODE=20
      enumerator :: CU_DEVICE_ATTRIBUTE_MAXIMUM_TEXTURE1D_WIDTH=21
      enumerator :: CU_DEVICE_ATTRIBUTE_MAXIMUM_TEXTURE2D_WIDTH=22
      enumerator :: CU_DEVICE_ATTRIBUTE_MAXIMUM_TEXTURE2D_HEIGHT=23
      enumerator :: CU_DEVICE_ATTRIBUTE_MAXIMUM_TEXTURE3D_WIDTH=24
      enumerator :: CU_DEVICE_ATTRIBUTE_MAXIMUM_TEXTURE3D_HEIGHT=25
      enumerator :: CU_DEVICE_ATTRIBUTE_MAXIMUM_TEXTURE3D_DEPTH=26
      enumerator :: CU_DEVICE_ATTRIBUTE_MAXIMUM_TEXTURE2D_ARRAY_WIDTH=27
      enumerator :: CU_DEVICE_ATTRIBUTE_MAXIMUM_TEXTURE2D_ARRAY_HEIGHT=28
      enumerator :: CU_DEVICE_ATTRIBUTE_MAXIMUM_TEXTURE2D_ARRAY_NUMSLICES=29
      enumerator :: CU_DEVICE_ATTRIBUTE_SURFACE_ALIGNMENT=30
      enumerator :: CU_DEVICE_ATTRIBUTE_CONCURRENT_KERNELS=31
      enumerator :: CU_DEVICE_ATTRIBUTE_ECC_ENABLED=32
      enumerator :: CU_DEVICE_ATTRIBUTE_PCI_BUS_ID=33
      enumerator :: CU_DEVICE_ATTRIBUTE_PCI_DEVICE_ID=34
    end enum ! CUdevice_attribute_enum

    enum, bind(C) !:: CUfunction_attribute_enum
      enumerator :: CU_FUNC_ATTRIBUTE_MAX_THREADS_PER_BLOCK=0
      enumerator :: CU_FUNC_ATTRIBUTE_SHARED_SIZE_BYTES=1
      enumerator :: CU_FUNC_ATTRIBUTE_CONST_SIZE_BYTES=2
      enumerator :: CU_FUNC_ATTRIBUTE_LOCAL_SIZE_BYTES=3
      enumerator :: CU_FUNC_ATTRIBUTE_NUM_REGS=4
      enumerator :: CU_FUNC_ATTRIBUTE_PTX_VERSION=5
      enumerator :: CU_FUNC_ATTRIBUTE_BINARY_VERSION=6
      enumerator :: CU_FUNC_ATTRIBUTE_MAX
    end enum ! CUfunction_attribute_enum

    enum, bind(C) !:: CUfunc_cache_enum
      enumerator :: CU_FUNC_CACHE_PREFER_NONE=0
      enumerator :: CU_FUNC_CACHE_PREFER_SHARED=1
      enumerator :: CU_FUNC_CACHE_PREFER_L1=2
    end enum ! CUfunc_cache_enum

    enum, bind(C) !:: CUmemorytype_enum
      enumerator :: CU_MEMORYTYPE_HOST=1
      enumerator :: CU_MEMORYTYPE_DEVICE=2
      enumerator :: CU_MEMORYTYPE_ARRAY=3
    end enum ! CUmemorytype_enum

    enum, bind(C) !:: CUcomputemode_enum
      enumerator :: CU_COMPUTEMODE_DEFAULT=0
      enumerator :: CU_COMPUTEMODE_EXCLUSIVE=1
      enumerator :: CU_COMPUTEMODE_PROHIBITED=2
    end enum ! CUcomputemode_enum

    enum, bind(C) !:: CUjit_option_enum
      enumerator :: CU_JIT_MAX_REGISTERS=0
      enumerator :: CU_JIT_THREADS_PER_BLOCK
      enumerator :: CU_JIT_WALL_TIME
      enumerator :: CU_JIT_INFO_LOG_BUFFER
      enumerator :: CU_JIT_INFO_LOG_BUFFER_SIZE_BYTES
      enumerator :: CU_JIT_ERROR_LOG_BUFFER
      enumerator :: CU_JIT_ERROR_LOG_BUFFER_SIZE_BYTES
      enumerator :: CU_JIT_OPTIMIZATION_LEVEL
      enumerator :: CU_JIT_TARGET_FROM_CUCONTEXT
      enumerator :: CU_JIT_TARGET
      enumerator :: CU_JIT_FALLBACK_STRATEGY
    end enum ! CUjit_option_enum

    enum, bind(C) !:: CUjit_target_enum
      enumerator :: CU_TARGET_COMPUTE_10=0
      enumerator :: CU_TARGET_COMPUTE_11
      enumerator :: CU_TARGET_COMPUTE_12
      enumerator :: CU_TARGET_COMPUTE_13
      enumerator :: CU_TARGET_COMPUTE_20
    end enum ! CUjit_target_enum

    enum, bind(C) !:: CUjit_fallback_enum
      enumerator :: CU_PREFER_PTX=0
      enumerator :: CU_PREFER_BINARY
    end enum ! CUjit_fallback_enum

    enum, bind(C) !:: CUgraphicsRegisterFlags_enum
      enumerator :: CU_GRAPHICS_REGISTER_FLAGS_NONE=0
    end enum ! CUgraphicsRegisterFlags_enum

    enum, bind(C) !:: CUgraphicsMapResourceFlags_enum
      enumerator :: CU_GRAPHICS_MAP_RESOURCE_FLAGS_NONE=0
      enumerator :: CU_GRAPHICS_MAP_RESOURCE_FLAGS_READ_ONLY=1
      enumerator :: CU_GRAPHICS_MAP_RESOURCE_FLAGS_WRITE_DISCARD=2
    end enum ! CUgraphicsMapResourceFlags_enum

    enum, bind(C) !:: CUarray_cubemap_face_enum
      enumerator :: CU_CUBEMAP_FACE_POSITIVE_X=0
      enumerator :: CU_CUBEMAP_FACE_NEGATIVE_X=1
      enumerator :: CU_CUBEMAP_FACE_POSITIVE_Y=2
      enumerator :: CU_CUBEMAP_FACE_NEGATIVE_Y=3
      enumerator :: CU_CUBEMAP_FACE_POSITIVE_Z=4
      enumerator :: CU_CUBEMAP_FACE_NEGATIVE_Z=5
    end enum ! CUarray_cubemap_face_enum

    enum, bind(C) !:: CUlimit_enum
      enumerator :: CU_LIMIT_STACK_SIZE=0
      enumerator :: CU_LIMIT_PRINTF_FIFO_SIZE=1
    end enum ! CUlimit_enum

    enum, bind(C) !:: cudaError_enum
      enumerator :: CUDA_SUCCESS=0
      enumerator :: CUDA_ERROR_INVALID_VALUE=1
      enumerator :: CUDA_ERROR_OUT_OF_MEMORY=2
      enumerator :: CUDA_ERROR_NOT_INITIALIZED=3
      enumerator :: CUDA_ERROR_DEINITIALIZED=4
      enumerator :: CUDA_ERROR_NO_DEVICE=100
      enumerator :: CUDA_ERROR_INVALID_DEVICE=101
      enumerator :: CUDA_ERROR_INVALID_IMAGE=200
      enumerator :: CUDA_ERROR_INVALID_CONTEXT=201
      enumerator :: CUDA_ERROR_CONTEXT_ALREADY_CURRENT=202
      enumerator :: CUDA_ERROR_MAP_FAILED=205
      enumerator :: CUDA_ERROR_UNMAP_FAILED=206
      enumerator :: CUDA_ERROR_ARRAY_IS_MAPPED=207
      enumerator :: CUDA_ERROR_ALREADY_MAPPED=208
      enumerator :: CUDA_ERROR_NO_BINARY_FOR_GPU=209
      enumerator :: CUDA_ERROR_ALREADY_ACQUIRED=210
      enumerator :: CUDA_ERROR_NOT_MAPPED=211
      enumerator :: CUDA_ERROR_NOT_MAPPED_AS_ARRAY=212
      enumerator :: CUDA_ERROR_NOT_MAPPED_AS_POINTER=213
      enumerator :: CUDA_ERROR_ECC_UNCORRECTABLE=214
      enumerator :: CUDA_ERROR_UNSUPPORTED_LIMIT=215
      enumerator :: CUDA_ERROR_INVALID_SOURCE=300
      enumerator :: CUDA_ERROR_FILE_NOT_FOUND=301
      enumerator :: CUDA_ERROR_SHARED_OBJECT_SYMBOL_NOT_FOUND=302
      enumerator :: CUDA_ERROR_SHARED_OBJECT_INIT_FAILED=303
      enumerator :: CUDA_ERROR_INVALID_HANDLE=400
      enumerator :: CUDA_ERROR_NOT_FOUND=500
      enumerator :: CUDA_ERROR_NOT_READY=600
      enumerator :: CUDA_ERROR_LAUNCH_FAILED=700
      enumerator :: CUDA_ERROR_LAUNCH_OUT_OF_RESOURCES=701
      enumerator :: CUDA_ERROR_LAUNCH_TIMEOUT=702
      enumerator :: CUDA_ERROR_LAUNCH_INCOMPATIBLE_TEXTURING=703
      enumerator :: CUDA_ERROR_POINTER_IS_64BIT=800
      enumerator :: CUDA_ERROR_SIZE_IS_64BIT=801
      enumerator :: CUDA_ERROR_UNKNOWN=999
    end enum ! cudaError_enum

    type, bind(C) :: timespec
      integer(c_long) :: tv_sec
      integer(c_long) :: tv_nsec
    end type timespec

    type, bind(C) :: timeval
      integer(c_long) :: tv_sec
      integer(c_long) :: tv_usec
    end type timeval

    type, bind(C) :: pthread_internal_slist__
      type (c_ptr) :: next__
    end type pthread_internal_slist__

    type, bind(C) :: drand48_data
      integer(c_short) :: x__(3)
      integer(c_short) :: old_x__(3)
      integer(c_short) :: c__
      integer(c_short) :: init__
      integer(c_long_long) :: a__
    end type drand48_data

    type, bind(C) :: CUuuid_st
      character(c_char) :: bytes(16)
    end type CUuuid_st

    type, bind(C) :: CUdevprop_st
      integer(c_int) :: maxThreadsPerBlock
      integer(c_int) :: maxThreadsDim(3)
      integer(c_int) :: maxGridSize(3)
      integer(c_int) :: sharedMemPerBlock
      integer(c_int) :: totalConstantMemory
      integer(c_int) :: SIMDWidth
      integer(c_int) :: memPitch
      integer(c_int) :: regsPerBlock
      integer(c_int) :: clockRate
      integer(c_int) :: textureAlign
    end type CUdevprop_st

    type, bind(C) :: CUDA_MEMCPY2D_st
      integer(c_int) :: srcXInBytes
      integer(c_int) :: srcY
      integer (KIND(CU_MEMORYTYPE_HOST)) :: srcMemoryType
      type(c_ptr) :: srcHost
      integer(c_int) :: srcDevice
      type (cudaArray_t) :: srcArray
      integer(c_int) :: srcPitch
      integer(c_int) :: dstXInBytes
      integer(c_int) :: dstY
      integer (KIND(CU_MEMORYTYPE_HOST)) :: dstMemoryType
      type(c_ptr) :: dstHost
      integer(c_int) :: dstDevice
      type (cudaArray_t) :: dstArray
      integer(c_int) :: dstPitch
      integer(c_int) :: WidthInBytes
      integer(c_int) :: Height
    end type CUDA_MEMCPY2D_st

    type, bind(C) :: CUDA_MEMCPY3D_st
      integer(c_int) :: srcXInBytes
      integer(c_int) :: srcY
      integer(c_int) :: srcZ
      integer(c_int) :: srcLOD
      integer (KIND(CU_MEMORYTYPE_HOST)) :: srcMemoryType
      type(c_ptr) :: srcHost
      integer(c_int) :: srcDevice
      type (cudaArray_t) :: srcArray
      type(c_ptr) :: reserved0
      integer(c_int) :: srcPitch
      integer(c_int) :: srcHeight
      integer(c_int) :: dstXInBytes
      integer(c_int) :: dstY
      integer(c_int) :: dstZ
      integer(c_int) :: dstLOD
      integer (KIND(CU_MEMORYTYPE_HOST)) :: dstMemoryType
      type(c_ptr) :: dstHost
      integer(c_int) :: dstDevice
      type (cudaArray_t) :: dstArray
      type(c_ptr) :: reserved1
      integer(c_int) :: dstPitch
      integer(c_int) :: dstHeight
      integer(c_int) :: WidthInBytes
      integer(c_int) :: Height
      integer(c_int) :: Depth
    end type CUDA_MEMCPY3D_st

    interface ! [['int', None], 'posix_openpt', [['int', None, '__oflag']]]
      function posix_openpt(oflag__) result( res ) bind(C, name="posix_openpt")
        use, intrinsic :: ISO_C_BINDING
        implicit none
        integer(c_int), value :: oflag__
        integer(c_int) :: res
      end function posix_openpt
    end interface

    interface ! [['CUresult', None], 'cuInit', [['unsigned', 'int', None, 'Flags']]]
      function cuInit(Flags) result( res ) bind(C, name="cuInit")
        use, intrinsic :: ISO_C_BINDING
        import CUDA_SUCCESS
        implicit none
        integer(c_int), value :: Flags
        integer (KIND(CUDA_SUCCESS)) :: res
      end function cuInit
    end interface

    interface ! [['CUresult', None], 'cuDriverGetVersion', [['int', '*', 'driverVersion']]]
      function cuDriverGetVersion(driverVersion) result( res ) bind(C, name="cuDriverGetVersion")
        use, intrinsic :: ISO_C_BINDING
        import CUDA_SUCCESS
        implicit none
        integer(c_int) :: driverVersion
        integer (KIND(CUDA_SUCCESS)) :: res
      end function cuDriverGetVersion
    end interface

    interface ! [['CUresult', None], 'cuDeviceGet', [['CUdevice', '*', 'device'], ['int', None, 'ordinal']]]
      function cuDeviceGet(device,ordinal) result( res ) bind(C, name="cuDeviceGet")
        use, intrinsic :: ISO_C_BINDING
        import CUDA_SUCCESS
        implicit none
        integer(c_int) :: device
        integer(c_int), value :: ordinal
        integer (KIND(CUDA_SUCCESS)) :: res
      end function cuDeviceGet
    end interface

    interface ! [['CUresult', None], 'cuCtxCreate', [['CUcontext', '*', 'pctx'], ['unsigned', 'int', None, 'flags'], ['CUdevice', None, 'dev']]]
      function cuCtxCreate(pctx,flags,dev) result( res ) bind(C, name="cuCtxCreate")
        use, intrinsic :: ISO_C_BINDING
        import CUDA_SUCCESS
        import cudaContext_t
        implicit none
        type (cudaContext_t) :: pctx
        integer(c_int), value :: flags
        integer(c_int), value :: dev
        integer (KIND(CUDA_SUCCESS)) :: res
      end function cuCtxCreate
    end interface

    interface ! [['CUresult', None], 'cuModuleLoad', [['CUmodule', '*', 'module'], ['const', 'char', '*', 'fname']]]
      function cuModuleLoad(module,fname) result( res ) bind(C, name="cuModuleLoad")
        use, intrinsic :: ISO_C_BINDING
        import CUDA_SUCCESS
        import cudaModule_t
        implicit none
        type (cudaModule_t) :: module
        character(c_char) :: fname
        integer (KIND(CUDA_SUCCESS)) :: res
      end function cuModuleLoad
    end interface

    interface ! [['CUresult', None], 'cuMemGetInfo', [['unsigned', 'int', '*', 'free'], ['unsigned', 'int', '*', 'total']]]
      function cuMemGetInfo(free,total) result( res ) bind(C, name="cuMemGetInfo")
        use, intrinsic :: ISO_C_BINDING
        import CUDA_SUCCESS
        implicit none
        integer(c_int) :: free
        integer(c_int) :: total
        integer (KIND(CUDA_SUCCESS)) :: res
      end function cuMemGetInfo
    end interface

    interface ! [['CUresult', None], 'cuMemAlloc', [['CUdeviceptr', '*', 'dptr'], ['unsigned', 'int', None, 'bytesize']]]
      function cuMemAlloc(dptr,bytesize) result( res ) bind(C, name="cuMemAlloc")
        use, intrinsic :: ISO_C_BINDING
        import CUDA_SUCCESS
        implicit none
        integer(c_int) :: dptr
        integer(c_int), value :: bytesize
        integer (KIND(CUDA_SUCCESS)) :: res
      end function cuMemAlloc
    end interface

    interface ! [['CUresult', None], 'cuMemAllocHost', [['void', '**', 'pp'], ['unsigned', 'int', None, 'bytesize']]]
      function cuMemAllocHost(pp,bytesize) result( res ) bind(C, name="cuMemAllocHost")
        use, intrinsic :: ISO_C_BINDING
        import CUDA_SUCCESS
        implicit none
        type(c_ptr) :: pp
        integer(c_int), value :: bytesize
        integer (KIND(CUDA_SUCCESS)) :: res
      end function cuMemAllocHost
    end interface

    interface ! [['CUresult', None], 'cuMemHostAlloc', [['void', '**', 'pp'], ['size_t', None, 'bytesize'], ['unsigned', 'int', None, 'Flags']]]
      function cuMemHostAlloc(pp,bytesize,Flags) result( res ) bind(C, name="cuMemHostAlloc")
        use, intrinsic :: ISO_C_BINDING
        import CUDA_SUCCESS
        implicit none
        type(c_ptr) :: pp
        integer(c_int), value :: bytesize
        integer(c_int), value :: Flags
        integer (KIND(CUDA_SUCCESS)) :: res
      end function cuMemHostAlloc
    end interface

    interface ! [['CUresult', None], 'cuMemHostGetDevicePointer', [['CUdeviceptr', '*', 'pdptr'], ['void', '*', 'p'], ['unsigned', 'int', None, 'Flags']]]
      function cuMemHostGetDevicePointer(pdptr,p,Flags) result( res ) bind(C, name="cuMemHostGetDevicePointer")
        use, intrinsic :: ISO_C_BINDING
        import CUDA_SUCCESS
        implicit none
        integer(c_int) :: pdptr
        type(c_ptr), value :: p
        integer(c_int), value :: Flags
        integer (KIND(CUDA_SUCCESS)) :: res
      end function cuMemHostGetDevicePointer
    end interface

    interface ! [['CUresult', None], 'cuMemcpyHtoD', [['CUdeviceptr', None, 'dstDevice'], ['const', 'void', '*', 'srcHost'], ['unsigned', 'int', None, 'ByteCount']]]
      function cuMemcpyHtoD(dstDevice,srcHost,ByteCount) result( res ) bind(C, name="cuMemcpyHtoD")
        use, intrinsic :: ISO_C_BINDING
        import CUDA_SUCCESS
        implicit none
        integer(c_int), value :: dstDevice
        type(c_ptr), value :: srcHost
        integer(c_int), value :: ByteCount
        integer (KIND(CUDA_SUCCESS)) :: res
      end function cuMemcpyHtoD
    end interface

    interface ! [['CUresult', None], 'cuMemcpyDtoD', [['CUdeviceptr', None, 'dstDevice'], ['CUdeviceptr', None, 'srcDevice'], ['unsigned', 'int', None, 'ByteCount']]]
      function cuMemcpyDtoD(dstDevice,srcDevice,ByteCount) result( res ) bind(C, name="cuMemcpyDtoD")
        use, intrinsic :: ISO_C_BINDING
        import CUDA_SUCCESS
        implicit none
        integer(c_int), value :: dstDevice
        integer(c_int), value :: srcDevice
        integer(c_int), value :: ByteCount
        integer (KIND(CUDA_SUCCESS)) :: res
      end function cuMemcpyDtoD
    end interface

    interface ! [['CUresult', None], 'cuMemcpyDtoA', [['CUarray', None, 'dstArray'], ['unsigned', 'int', None, 'dstOffset'], ['CUdeviceptr', None, 'srcDevice'], ['unsigned', 'int', None, 'ByteCount']]]
      function cuMemcpyDtoA(dstArray,dstOffset,srcDevice,ByteCount) result( res ) bind(C, name="cuMemcpyDtoA")
        use, intrinsic :: ISO_C_BINDING
        import CUDA_SUCCESS
        import cudaArray_t
        implicit none
        type (cudaArray_t), value :: dstArray
        integer(c_int), value :: dstOffset
        integer(c_int), value :: srcDevice
        integer(c_int), value :: ByteCount
        integer (KIND(CUDA_SUCCESS)) :: res
      end function cuMemcpyDtoA
    end interface

    interface ! [['CUresult', None], 'cuMemcpyHtoA', [['CUarray', None, 'dstArray'], ['unsigned', 'int', None, 'dstOffset'], ['const', 'void', '*', 'srcHost'], ['unsigned', 'int', None, 'ByteCount']]]
      function cuMemcpyHtoA(dstArray,dstOffset,srcHost,ByteCount) result( res ) bind(C, name="cuMemcpyHtoA")
        use, intrinsic :: ISO_C_BINDING
        import CUDA_SUCCESS
        import cudaArray_t
        implicit none
        type (cudaArray_t), value :: dstArray
        integer(c_int), value :: dstOffset
        type(c_ptr), value :: srcHost
        integer(c_int), value :: ByteCount
        integer (KIND(CUDA_SUCCESS)) :: res
      end function cuMemcpyHtoA
    end interface

    interface ! [['CUresult', None], 'cuMemcpyAtoA', [['CUarray', None, 'dstArray'], ['unsigned', 'int', None, 'dstOffset'], ['CUarray', None, 'srcArray'], ['unsigned', 'int', None, 'srcOffset'], ['unsigned', 'int', None, 'ByteCount']]]
      function cuMemcpyAtoA(dstArray,dstOffset,srcArray,srcOffset,ByteCount) result( res ) bind(C, name="cuMemcpyAtoA")
        use, intrinsic :: ISO_C_BINDING
        import CUDA_SUCCESS
        import cudaArray_t
        import cudaArray_t
        implicit none
        type (cudaArray_t), value :: dstArray
        integer(c_int), value :: dstOffset
        type (cudaArray_t), value :: srcArray
        integer(c_int), value :: srcOffset
        integer(c_int), value :: ByteCount
        integer (KIND(CUDA_SUCCESS)) :: res
      end function cuMemcpyAtoA
    end interface

    interface ! [['CUresult', None], 'cuMemcpyHtoDAsync', [['CUdeviceptr', None, 'dstDevice'], ['const', 'void', '*', 'srcHost'], ['unsigned', 'int', None, 'ByteCount'], ['CUstream', None, 'hStream']]]
      function cuMemcpyHtoDAsync(dstDevice,srcHost,ByteCount,hStream) result( res ) bind(C, name="cuMemcpyHtoDAsync")
        use, intrinsic :: ISO_C_BINDING
        import CUDA_SUCCESS
        import cudaStream_t
        implicit none
        integer(c_int), value :: dstDevice
        type(c_ptr), value :: srcHost
        integer(c_int), value :: ByteCount
        type (cudaStream_t), value :: hStream
        integer (KIND(CUDA_SUCCESS)) :: res
      end function cuMemcpyHtoDAsync
    end interface

    interface ! [['CUresult', None], 'cuMemcpyDtoDAsync', [['CUdeviceptr', None, 'dstDevice'], ['CUdeviceptr', None, 'srcDevice'], ['unsigned', 'int', None, 'ByteCount'], ['CUstream', None, 'hStream']]]
      function cuMemcpyDtoDAsync(dstDevice,srcDevice,ByteCount,hStream) result( res ) bind(C, name="cuMemcpyDtoDAsync")
        use, intrinsic :: ISO_C_BINDING
        import CUDA_SUCCESS
        import cudaStream_t
        implicit none
        integer(c_int), value :: dstDevice
        integer(c_int), value :: srcDevice
        integer(c_int), value :: ByteCount
        type (cudaStream_t), value :: hStream
        integer (KIND(CUDA_SUCCESS)) :: res
      end function cuMemcpyDtoDAsync
    end interface

    interface ! [['CUresult', None], 'cuMemcpyHtoAAsync', [['CUarray', None, 'dstArray'], ['unsigned', 'int', None, 'dstOffset'], ['const', 'void', '*', 'srcHost'], ['unsigned', 'int', None, 'ByteCount'], ['CUstream', None, 'hStream']]]
      function cuMemcpyHtoAAsync(dstArray,dstOffset,srcHost,ByteCount,hStream) result( res ) bind(C, name="cuMemcpyHtoAAsync")
        use, intrinsic :: ISO_C_BINDING
        import CUDA_SUCCESS
        import cudaArray_t
        import cudaStream_t
        implicit none
        type (cudaArray_t), value :: dstArray
        integer(c_int), value :: dstOffset
        type(c_ptr), value :: srcHost
        integer(c_int), value :: ByteCount
        type (cudaStream_t), value :: hStream
        integer (KIND(CUDA_SUCCESS)) :: res
      end function cuMemcpyHtoAAsync
    end interface

    interface ! [['CUresult', None], 'cuMemsetD8', [['CUdeviceptr', None, 'dstDevice'], ['unsigned', 'char', None, 'uc'], ['unsigned', 'int', None, 'N']]]
      function cuMemsetD8(dstDevice,uc,N) result( res ) bind(C, name="cuMemsetD8")
        use, intrinsic :: ISO_C_BINDING
        import CUDA_SUCCESS
        implicit none
        integer(c_int), value :: dstDevice
        integer(c_signed_char), value :: uc
        integer(c_int), value :: N
        integer (KIND(CUDA_SUCCESS)) :: res
      end function cuMemsetD8
    end interface

    interface ! [['CUresult', None], 'cuMemsetD2D8', [['CUdeviceptr', None, 'dstDevice'], ['unsigned', 'int', None, 'dstPitch'], ['unsigned', 'char', None, 'uc'], ['unsigned', 'int', None, 'Width'], ['unsigned', 'int', None, 'Height']]]
      function cuMemsetD2D8(dstDevice,dstPitch,uc,Width,Height) result( res ) bind(C, name="cuMemsetD2D8")
        use, intrinsic :: ISO_C_BINDING
        import CUDA_SUCCESS
        implicit none
        integer(c_int), value :: dstDevice
        integer(c_int), value :: dstPitch
        integer(c_signed_char), value :: uc
        integer(c_int), value :: Width
        integer(c_int), value :: Height
        integer (KIND(CUDA_SUCCESS)) :: res
      end function cuMemsetD2D8
    end interface

    interface ! [['CUresult', None], 'cuFuncSetBlockShape', [['CUfunction', None, 'hfunc'], ['int', None, 'x'], ['int', None, 'y'], ['int', None, 'z']]]
      function cuFuncSetBlockShape(hfunc,x,y,z) result( res ) bind(C, name="cuFuncSetBlockShape")
        use, intrinsic :: ISO_C_BINDING
        import CUDA_SUCCESS
        import cudaFunction_t
        implicit none
        type (cudaFunction_t), value :: hfunc
        integer(c_int), value :: x
        integer(c_int), value :: y
        integer(c_int), value :: z
        integer (KIND(CUDA_SUCCESS)) :: res
      end function cuFuncSetBlockShape
    end interface

    interface ! [['CUresult', None], 'cuTexRefCreate', [['CUtexref', '*', 'pTexRef']]]
      function cuTexRefCreate(pTexRef) result( res ) bind(C, name="cuTexRefCreate")
        use, intrinsic :: ISO_C_BINDING
        import CUDA_SUCCESS
        import cudaTexRef_t
        implicit none
        type (cudaTexRef_t) :: pTexRef
        integer (KIND(CUDA_SUCCESS)) :: res
      end function cuTexRefCreate
    end interface

    interface ! [['CUresult', None], 'cuTexRefSetArray', [['CUtexref', None, 'hTexRef'], ['CUarray', None, 'hArray'], ['unsigned', 'int', None, 'Flags']]]
      function cuTexRefSetArray(hTexRef,hArray,Flags) result( res ) bind(C, name="cuTexRefSetArray")
        use, intrinsic :: ISO_C_BINDING
        import CUDA_SUCCESS
        import cudaTexRef_t
        import cudaArray_t
        implicit none
        type (cudaTexRef_t), value :: hTexRef
        type (cudaArray_t), value :: hArray
        integer(c_int), value :: Flags
        integer (KIND(CUDA_SUCCESS)) :: res
      end function cuTexRefSetArray
    end interface

    interface ! [['CUresult', None], 'cuTexRefGetAddress', [['CUdeviceptr', '*', 'pdptr'], ['CUtexref', None, 'hTexRef']]]
      function cuTexRefGetAddress(pdptr,hTexRef) result( res ) bind(C, name="cuTexRefGetAddress")
        use, intrinsic :: ISO_C_BINDING
        import CUDA_SUCCESS
        import cudaTexRef_t
        implicit none
        integer(c_int) :: pdptr
        type (cudaTexRef_t), value :: hTexRef
        integer (KIND(CUDA_SUCCESS)) :: res
      end function cuTexRefGetAddress
    end interface

    interface ! [['CUresult', None], 'cuSurfRefSetArray', [['CUsurfref', None, 'hSurfRef'], ['CUarray', None, 'hArray'], ['unsigned', 'int', None, 'Flags']]]
      function cuSurfRefSetArray(hSurfRef,hArray,Flags) result( res ) bind(C, name="cuSurfRefSetArray")
        use, intrinsic :: ISO_C_BINDING
        import CUDA_SUCCESS
        import cudaSurfRef_t
        import cudaArray_t
        implicit none
        type (cudaSurfRef_t), value :: hSurfRef
        type (cudaArray_t), value :: hArray
        integer(c_int), value :: Flags
        integer (KIND(CUDA_SUCCESS)) :: res
      end function cuSurfRefSetArray
    end interface

    interface ! [['CUresult', None], 'cuParamSetSize', [['CUfunction', None, 'hfunc'], ['unsigned', 'int', None, 'numbytes']]]
      function cuParamSetSize(hfunc,numbytes) result( res ) bind(C, name="cuParamSetSize")
        use, intrinsic :: ISO_C_BINDING
        import CUDA_SUCCESS
        import cudaFunction_t
        implicit none
        type (cudaFunction_t), value :: hfunc
        integer(c_int), value :: numbytes
        integer (KIND(CUDA_SUCCESS)) :: res
      end function cuParamSetSize
    end interface

    interface ! [['CUresult', None], 'cuLaunch', [['CUfunction', None, 'f']]]
      function cuLaunch(f) result( res ) bind(C, name="cuLaunch")
        use, intrinsic :: ISO_C_BINDING
        import CUDA_SUCCESS
        import cudaFunction_t
        implicit none
        type (cudaFunction_t), value :: f
        integer (KIND(CUDA_SUCCESS)) :: res
      end function cuLaunch
    end interface

    interface ! [['CUresult', None], 'cuEventCreate', [['CUevent', '*', 'phEvent'], ['unsigned', 'int', None, 'Flags']]]
      function cuEventCreate(phEvent,Flags) result( res ) bind(C, name="cuEventCreate")
        use, intrinsic :: ISO_C_BINDING
        import CUDA_SUCCESS
        import cudaEvent_t
        implicit none
        type (cudaEvent_t) :: phEvent
        integer(c_int), value :: Flags
        integer (KIND(CUDA_SUCCESS)) :: res
      end function cuEventCreate
    end interface

    interface ! [['CUresult', None], 'cuStreamCreate', [['CUstream', '*', 'phStream'], ['unsigned', 'int', None, 'Flags']]]
      function cuStreamCreate(phStream,Flags) result( res ) bind(C, name="cuStreamCreate")
        use, intrinsic :: ISO_C_BINDING
        import CUDA_SUCCESS
        import cudaStream_t
        implicit none
        type (cudaStream_t) :: phStream
        integer(c_int), value :: Flags
        integer (KIND(CUDA_SUCCESS)) :: res
      end function cuStreamCreate
    end interface

    interface ! [['CUresult', None], 'cuGraphicsUnregisterResource', [['CUgraphicsResource', None, 'resource']]]
      function cuGraphicsUnregisterResource(resource) result( res ) bind(C, name="cuGraphicsUnregisterResource")
        use, intrinsic :: ISO_C_BINDING
        import CUDA_SUCCESS
        import cudaGraphicsResource_t
        implicit none
        type (cudaGraphicsResource_t), value :: resource
        integer (KIND(CUDA_SUCCESS)) :: res
      end function cuGraphicsUnregisterResource
    end interface

    interface ! [['CUresult', None], 'cuCtxSetLimit', [['CUlimit', None, 'limit'], ['size_t', None, 'value']]]
      function cuCtxSetLimit(limit,value) result( res ) bind(C, name="cuCtxSetLimit")
        use, intrinsic :: ISO_C_BINDING
        import CUDA_SUCCESS
        import CU_LIMIT_STACK_SIZE
        implicit none
        integer (KIND(CU_LIMIT_STACK_SIZE)), value :: limit
        integer(c_int), value :: value
        integer (KIND(CUDA_SUCCESS)) :: res
      end function cuCtxSetLimit
    end interface

  end module cuda_h

!MIT License

!Copyright (c) 2019 maxcuda

!This module has been downloaded and adapted from
!   https://github.com/maxcuda/NVTX_example     
! 
! Permission is hereby granted, free of charge, to any person obtaining a copy
! of this software and associated documentation files (the "Software"), to deal
! in the Software without restriction, including without limitation the rights
! to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
! copies of the Software, and to permit persons to whom the Software is
! furnished to do so, subject to the following conditions:

! The above copyright notice and this permission notice shall be included in all
! copies or substantial portions of the Software.

! THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
! IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
! FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
! AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
! LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
! OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
! SOFTWARE.


! ----
! nvtx
! ----

module nvtx
  use iso_c_binding
#ifdef __CUDA
  use cudafor
#endif
  implicit none
#ifdef __PROFILE_NVTX
  integer,private :: col(7) = [ Z'0000ff00', Z'000000ff', Z'00ffff00',Z'00ff00ff',Z'0000ffff', &
                                Z'00ff0000', Z'00ffffff']
  character(len=256),private :: tempName
!  logical, save :: __PROFILE_NVTX=.false.
  type, bind(C):: nvtxEventAttributes
     integer(C_INT16_T):: version=1
     integer(C_INT16_T):: size=48 !
     integer(C_INT):: category=0
     integer(C_INT):: colorType=1 ! NVTX_COLOR_ARGB = 1
     integer(C_INT):: color
     integer(C_INT):: payloadType=0 ! NVTX_PAYLOAD_UNKNOWN = 0
     integer(C_INT):: reserved0
     integer(C_INT64_T):: payload   ! union uint,int,double
     integer(C_INT):: messageType=1  ! NVTX_MESSAGE_TYPE_ASCII     = 1 
     type(C_PTR):: message  ! ascii char
  end type nvtxEventAttributes

  interface nvtxRangePush
     ! push range with custom label and standard color
     subroutine nvtxRangePushA(name) bind(C, name='nvtxRangePushA')
       use iso_c_binding
       character(kind=C_CHAR,len=*) :: name
     end subroutine nvtxRangePushA

     ! push range with custom label and custom color
     subroutine nvtxRangePushEx(event) bind(C, name='nvtxRangePushEx')
       use iso_c_binding
       import:: nvtxEventAttributes
       type(nvtxEventAttributes):: event
     end subroutine nvtxRangePushEx
  end interface nvtxRangePush

  interface nvtxRangePop
     subroutine nvtxRangePop() bind(C, name='nvtxRangePop')
     end subroutine nvtxRangePop
  end interface nvtxRangePop
#endif

contains

  subroutine nvtxStartRange(name,id)
    character(kind=c_char,len=*) :: name
    integer, optional:: id
#ifdef __PROFILE_NVTX
    type(nvtxEventAttributes):: event
#if defined(__CUDA) && defined(__SYNC_NVPROF)
    integer :: istat
    istat = cudaDeviceSynchronize()
#endif

    tempName=trim(name)//c_null_char

    if ( .not. present(id)) then
       call nvtxRangePush(tempName)
    else
       event%color=col(mod(id,7)+1)
       event%message=c_loc(tempName)
       call nvtxRangePushEx(event)
    end if
#endif
  end subroutine nvtxStartRange

  subroutine nvtxStartRangeAsync(name,id)
    character(kind=c_char,len=*) :: name
    integer, optional:: id
#ifdef __PROFILE_NVTX
    type(nvtxEventAttributes):: event

    tempName=trim(name)//c_null_char

    if ( .not. present(id)) then
       call nvtxRangePush(tempName)
    else
       event%color=col(mod(id,7)+1)
       event%message=c_loc(tempName)
       call nvtxRangePushEx(event)
    end if
#endif
  end subroutine nvtxStartRangeAsync


  subroutine nvtxEndRange
#ifdef __PROFILE_NVTX
#if defined(__CUDA) && defined(__SYNC_NVPROF)
    integer :: istat
    istat = cudaDeviceSynchronize()
#endif
    call nvtxRangePop
#endif
  end subroutine nvtxEndRange

  subroutine nvtxEndRangeAsync
#ifdef __PROFILE_NVTX
    call nvtxRangePop
#endif
  end subroutine nvtxEndRangeAsync

end module nvtx

!
! Copyright (C) 2002-2018 Quantum ESPRESSO group
! This file is distributed under the terms of the
! GNU General Public License. See the file `License'
! in the root directory of the present distribution,
! or http://www.gnu.org/copyleft/gpl.txt .
!
! Utility functions to perform memcpy and memset on the device with CUDA Fortran
! cuf_memXXX contains a CUF KERNEL to perform the selected operation
! cu_memsync are wrappers for cuda_memcpy functions
!
#if defined(_CUDA)
#  define __CUDA
#endif
!
module device_auxfunc_m
  implicit none

#include<device_auxfunc_interf.f90>

end module device_auxfunc_m

!!  Fortran CUDA Library interface -- Module for Core CUBLAS definitions
!!
!!  Copyright (C) 2017-2018 Mentor, A Siemens Business
!!
!!  This software is provided 'as-is', without any express or implied
!!  warranty.  In no event will the authors be held liable for any damages
!!  arising from the use of this software.
!!
!!  Permission is granted to anyone to use this software for any purpose,
!!  including commercial applications, and to alter it and redistribute it
!!  freely, subject to the following restrictions:
!!
!!  1. The origin of this software must not be misrepresented; you must not
!!     claim that you wrote the original software. If you use this software
!!     in a product, an acknowledgment in the product documentation would be
!!     appreciated but is not required.
!!  2. Altered source versions must be plainly marked as such, and must not be
!!     misrepresented as being the original software.
!!  3. This notice may not be removed or altered from any source distribution.

module cublas_core_m
  use iso_c_binding

  type, bind(c) :: cuBlasHandle
     type(c_ptr) :: handle
  end type cuBlasHandle

#if defined __DXL_CUBLAS

  enum, bind(c)
     enumerator :: CUBLAS_STATUS_SUCCESS          = 0
     enumerator :: CUBLAS_STATUS_NOT_INITIALIZED  = 1
     enumerator :: CUBLAS_STATUS_ALLOC_FAILED     = 3
     enumerator :: CUBLAS_STATUS_INVALID_VALUE    = 7
     enumerator :: CUBLAS_STATUS_ARCH_MISMATCH    = 8
     enumerator :: CUBLAS_STATUS_MAPPING_ERROR    = 11
     enumerator :: CUBLAS_STATUS_EXECUTION_FAILED = 13
     enumerator :: CUBLAS_STATUS_INTERNAL_ERROR   = 14
     enumerator :: CUBLAS_STATUS_NOT_SUPPORTED    = 15
     enumerator :: CUBLAS_STATUS_LICENSE_ERROR    = 16
  end enum

  enum, bind(c)
     enumerator :: CUBLAS_FILL_MODE_LOWER = 0
     enumerator :: CUBLAS_FILL_MODE_UPPER = 1
  end enum

  enum, bind(c)
     enumerator :: CUBLAS_DIAG_NON_UNIT = 0
     enumerator :: CUBLAS_DIAG_UNIT     = 1
  end enum

  enum, bind(c)
     enumerator :: CUBLAS_SIDE_LEFT  = 0
     enumerator :: CUBLAS_SIDE_RIGHT = 1
  end enum

  enum, bind(c)
     enumerator :: CUBLAS_OP_N = 0
     enumerator :: CUBLAS_OP_T = 1
     enumerator :: CUBLAS_OP_C = 2
  end enum

  enum, bind(c)
     enumerator :: CUBLAS_POINTER_MODE_HOST   = 0
     enumerator :: CUBLAS_POINTER_MODE_DEVICE = 1
  end enum

  interface
     integer(c_int) function cublasCreate (handle) &
         bind (c, name="cublasCreate_v2")
       import
       type(cublasHandle) :: handle
     end function cublasCreate

     integer(c_int) function cublasDestroy (handle) &
         bind (c, name="cublasDestroy_v2")
       import
       type(cublasHandle), value :: handle
     end function cublasDestroy

     integer(c_int) function cublasGetVersion (handle, version) &
         bind (c, name="cublasGetVersion_v2")
       import
       type(cublasHandle), value :: handle
       integer(c_int) :: version
     end function cublasGetVersion

     integer(c_int) function cublasSetStream (handle, streamId) &
         bind (c, name="cublasSetStream_v2")
       import
       integer(c_intptr_t), value :: streamId
       type(cublasHandle), value :: handle
     end function cublasSetStream

     integer(c_int) function cublasGetStream (handle, streamId) &
         bind (c, name="cublasGetStream_v2")
       import
       type(cublasHandle), value :: handle
       integer(c_intptr_t) :: streamId
     end function cublasGetStream

     integer(c_int) function cublasGetPointerMode (handle, mode) &
         bind (c, name="cublasGetPointerMode_v2")
       import
       type(cublasHandle), value :: handle
       integer(c_int) :: mode
     end function cublasGetPointerMode

     integer(c_int) function cublasSetPointerMode (handle, mode) &
         bind (c, name="cublasSetPointerMode_v2")
       import
       integer(c_int), value :: mode
       type(cublasHandle), value :: handle
     end function cublasSetPointerMode

     integer(c_int) function cublasGetAtomicsMode (handle, mode) &
         bind (c, name="cublasGetAtomicsMode_v2")
       import
       type(cublasHandle), value :: handle
       integer(c_int) :: mode
     end function cublasGetAtomicsMode

     integer(c_int) function cublasSetAtomicsMode (handle, mode) &
         bind (c, name="cublasSetAtomicsMode_v2")
       import
       integer(c_int), value :: mode
       type(cublasHandle), value :: handle
     end function cublasSetAtomicsMode

     integer(c_int) function cublasSetVector (n, elemSize, x, incx, y, incy) &
         bind (c, name="cublasSetVector_v2")
       import
       integer(c_int), value :: n, elemSize, incx, incy
       integer(c_signed_char), dimension(*) :: x, y
     end function cublasSetVector

     integer(c_int) function cublasGetVector (n, elemSize, x, incx, y, incy) &
         bind (c, name="cublasGetVector_v2")
       import
       integer(c_int), value :: n, elemSize, incx, incy
       integer(c_signed_char), dimension(*) :: x, y
     end function cublasGetVector

     integer(c_int) function cublasSetMatrix (rows, cols, elemSize, A, lda, B, ldb) &
         bind (c, name="cublasSetMatrix_v2")
       import
       integer(c_int), value :: rows, cols, elemSize, lda, ldb
       integer(c_signed_char), dimension(lda, *) :: A
       integer(c_signed_char), dimension(ldb, *) :: B
     end function cublasSetMatrix

     integer(c_int) function cublasGetMatrix (rows, cols, elemSize, A, lda, B, ldb) &
         bind (c, name="cublasGetMatrix_v2")
       import
       integer(c_int), value :: rows, cols, elemSize, lda, ldb
       integer(c_signed_char), dimension(lda, *) :: A
       integer(c_signed_char), dimension(ldb, *) :: B
     end function cublasGetMatrix

     integer(c_int) function cublasSetVectorAsync (n, elemSize, hostPtr, incx, devicePtr, incy, stream) &
         bind (c, name="cublasSetVectorAsync_v2")
       import
       integer(c_int), value :: n, elemSize, incx, incy
       integer(c_intptr_t), value :: stream
       integer(c_signed_char), dimension(*) :: hostPtr, devicePtr
     end function cublasSetVectorAsync

     integer(c_int) function cublasGetVectorAsync (n, elemSize, devicePtr, incx, hostPtr, incy, stream) &
         bind (c, name="cublasGetVectorAsync_v2")
       import
       integer(c_int), value :: n, elemSize, incx, incy
       integer(c_intptr_t), value :: stream
       integer(c_signed_char), dimension(*) :: devicePtr, hostPtr
     end function cublasGetVectorAsync

     integer(c_int) function cublasSetMatrixAsync (rows, cols, elemSize, A, lda, B, ldb, stream) &
         bind (c, name="cublasSetMatrixAsync_v2")
       import
       integer(c_int), value :: rows, cols, elemSize, lda, ldb
       integer(c_signed_char), dimension(lda, *) :: A
       integer(c_signed_char), dimension(ldb, *) :: B
       integer(c_intptr_t), value :: stream
     end function cublasSetMatrixAsync

     integer(c_int) function cublasGetMatrixAsync (rows, cols, elemSize, A, lda, B, ldb, stream) &
         bind (c, name="cublasGetMatrixAsync_v2")
       import
       integer(c_int), value :: rows, cols, elemSize, lda, ldb
       integer(c_signed_char), dimension(lda, *) :: A
       integer(c_signed_char), dimension(ldb, *) :: B
       integer(c_intptr_t), value :: stream
     end function cublasGetMatrixAsync

  end interface

#endif

end module

!
! Copyright (C) 2021, MaX CoE
! Distributed under the MIT License 
! (license terms are at http://opensource.org/licenses/MIT).
!
!--
!
! Auxiliary functions
!
! AF: OpenACC support is incomplete !!
!
!==================================================================
!==================================================================
! *DO NOT EDIT*: automatically generated from device_auxfunc_vec_upd.jf90
!==================================================================
!==================================================================
!
#include<devxlib_macros.h>
#include<devxlib_defs.h>
!
!=======================================
!
submodule (devxlib_auxfunc) devxlib_auxfunc_vec_upd

   implicit none

   contains

      module subroutine dp_devxlib_vec_upd_remap_r1d(ndim, vout, v1, map1, scal)
         implicit none
         !   
         integer,      intent(in)    :: ndim
         real(real64) DEV_ATTR, intent(inout) :: vout(:) 
         real(real64) DEV_ATTR, intent(in)    :: v1(:) 
         integer DEV_ATTR,      intent(in)    :: map1(:) 
         real(real64), optional, intent(in)   :: scal
         integer :: i
         !   
         if (present(scal)) then
            !DEV_CUF kernel do(1)
            !DEV_ACC data present(vout,v1,map1)
            !DEV_ACC parallel loop async
            !DEV_OMPGPU target map(present,alloc:vout,v1,map1) nowait
            !DEV_OMPGPU teams loop
            do i = 1, ndim
               vout(i) = v1(map1(i))*scal
            enddo
            !DEV_ACC end data
            !DEV_OMPGPU end target
         else
            !DEV_CUF kernel do(1)
            !DEV_ACC data present(vout,v1,map1)
            !DEV_ACC parallel loop async
            !DEV_OMPGPU target map(present,alloc:vout,v1,map1) nowait
            !DEV_OMPGPU teams loop
            do i = 1, ndim
               vout(i) = v1(map1(i))
            enddo
            !DEV_ACC end data
            !DEV_OMPGPU end target
         endif
      end subroutine dp_devxlib_vec_upd_remap_r1d
      !
      module subroutine dp_devxlib_vec_upd_remap_c1d(ndim, vout, v1, map1, scal)
         implicit none
         !   
         integer,      intent(in)    :: ndim
         complex(real64) DEV_ATTR, intent(inout) :: vout(:) 
         complex(real64) DEV_ATTR, intent(in)    :: v1(:) 
         integer DEV_ATTR,      intent(in)    :: map1(:) 
         complex(real64), optional, intent(in)   :: scal
         integer :: i
         !   
         if (present(scal)) then
            !DEV_CUF kernel do(1)
            !DEV_ACC data present(vout,v1,map1)
            !DEV_ACC parallel loop async
            !DEV_OMPGPU target map(present,alloc:vout,v1,map1) nowait
            !DEV_OMPGPU teams loop
            do i = 1, ndim
               vout(i) = v1(map1(i))*scal
            enddo
            !DEV_ACC end data
            !DEV_OMPGPU end target
         else
            !DEV_CUF kernel do(1)
            !DEV_ACC data present(vout,v1,map1)
            !DEV_ACC parallel loop async
            !DEV_OMPGPU target map(present,alloc:vout,v1,map1) nowait
            !DEV_OMPGPU teams loop
            do i = 1, ndim
               vout(i) = v1(map1(i))
            enddo
            !DEV_ACC end data
            !DEV_OMPGPU end target
         endif
      end subroutine dp_devxlib_vec_upd_remap_c1d
      !
      module subroutine sp_devxlib_vec_upd_remap_r1d(ndim, vout, v1, map1, scal)
         implicit none
         !   
         integer,      intent(in)    :: ndim
         real(real32) DEV_ATTR, intent(inout) :: vout(:) 
         real(real32) DEV_ATTR, intent(in)    :: v1(:) 
         integer DEV_ATTR,      intent(in)    :: map1(:) 
         real(real32), optional, intent(in)   :: scal
         integer :: i
         !   
         if (present(scal)) then
            !DEV_CUF kernel do(1)
            !DEV_ACC data present(vout,v1,map1)
            !DEV_ACC parallel loop async
            !DEV_OMPGPU target map(present,alloc:vout,v1,map1) nowait
            !DEV_OMPGPU teams loop
            do i = 1, ndim
               vout(i) = v1(map1(i))*scal
            enddo
            !DEV_ACC end data
            !DEV_OMPGPU end target
         else
            !DEV_CUF kernel do(1)
            !DEV_ACC data present(vout,v1,map1)
            !DEV_ACC parallel loop async
            !DEV_OMPGPU target map(present,alloc:vout,v1,map1) nowait
            !DEV_OMPGPU teams loop
            do i = 1, ndim
               vout(i) = v1(map1(i))
            enddo
            !DEV_ACC end data
            !DEV_OMPGPU end target
         endif
      end subroutine sp_devxlib_vec_upd_remap_r1d
      !
      module subroutine sp_devxlib_vec_upd_remap_c1d(ndim, vout, v1, map1, scal)
         implicit none
         !   
         integer,      intent(in)    :: ndim
         complex(real32) DEV_ATTR, intent(inout) :: vout(:) 
         complex(real32) DEV_ATTR, intent(in)    :: v1(:) 
         integer DEV_ATTR,      intent(in)    :: map1(:) 
         complex(real32), optional, intent(in)   :: scal
         integer :: i
         !   
         if (present(scal)) then
            !DEV_CUF kernel do(1)
            !DEV_ACC data present(vout,v1,map1)
            !DEV_ACC parallel loop async
            !DEV_OMPGPU target map(present,alloc:vout,v1,map1) nowait
            !DEV_OMPGPU teams loop
            do i = 1, ndim
               vout(i) = v1(map1(i))*scal
            enddo
            !DEV_ACC end data
            !DEV_OMPGPU end target
         else
            !DEV_CUF kernel do(1)
            !DEV_ACC data present(vout,v1,map1)
            !DEV_ACC parallel loop async
            !DEV_OMPGPU target map(present,alloc:vout,v1,map1) nowait
            !DEV_OMPGPU teams loop
            do i = 1, ndim
               vout(i) = v1(map1(i))
            enddo
            !DEV_ACC end data
            !DEV_OMPGPU end target
         endif
      end subroutine sp_devxlib_vec_upd_remap_c1d
      !


      module subroutine dp_devxlib_vec_upd_v_remap_v_r1d(ndim, vout, v1, map1, v2, scal)
         implicit none
         !   
         integer,      intent(in)    :: ndim
         real(real64), intent(inout) DEV_ATTR :: vout(:) 
         real(real64), intent(in)    DEV_ATTR :: v1(:) 
         integer,      intent(in)    DEV_ATTR :: map1(:) 
         real(real64), intent(in)    DEV_ATTR :: v2(:) 
         real(real64), optional, intent(in)   :: scal
         integer :: i
         !   
         if (present(scal)) then
            !DEV_CUF kernel do(1)
            do i = 1, ndim
               vout(i) = v1(map1(i))*v2(i)*scal
            enddo
         else
            !DEV_CUF kernel do(1)
            do i = 1, ndim
               vout(i) = v1(map1(i))*v2(i)
            enddo
         endif
      end subroutine dp_devxlib_vec_upd_v_remap_v_r1d
      !
      module subroutine dp_devxlib_vec_upd_v_remap_v_c1d(ndim, vout, v1, map1, v2, scal)
         implicit none
         !   
         integer,      intent(in)    :: ndim
         complex(real64), intent(inout) DEV_ATTR :: vout(:) 
         complex(real64), intent(in)    DEV_ATTR :: v1(:) 
         integer,      intent(in)    DEV_ATTR :: map1(:) 
         complex(real64), intent(in)    DEV_ATTR :: v2(:) 
         complex(real64), optional, intent(in)   :: scal
         integer :: i
         !   
         if (present(scal)) then
            !DEV_CUF kernel do(1)
            do i = 1, ndim
               vout(i) = v1(map1(i))*v2(i)*scal
            enddo
         else
            !DEV_CUF kernel do(1)
            do i = 1, ndim
               vout(i) = v1(map1(i))*v2(i)
            enddo
         endif
      end subroutine dp_devxlib_vec_upd_v_remap_v_c1d
      !
      module subroutine sp_devxlib_vec_upd_v_remap_v_r1d(ndim, vout, v1, map1, v2, scal)
         implicit none
         !   
         integer,      intent(in)    :: ndim
         real(real32), intent(inout) DEV_ATTR :: vout(:) 
         real(real32), intent(in)    DEV_ATTR :: v1(:) 
         integer,      intent(in)    DEV_ATTR :: map1(:) 
         real(real32), intent(in)    DEV_ATTR :: v2(:) 
         real(real32), optional, intent(in)   :: scal
         integer :: i
         !   
         if (present(scal)) then
            !DEV_CUF kernel do(1)
            do i = 1, ndim
               vout(i) = v1(map1(i))*v2(i)*scal
            enddo
         else
            !DEV_CUF kernel do(1)
            do i = 1, ndim
               vout(i) = v1(map1(i))*v2(i)
            enddo
         endif
      end subroutine sp_devxlib_vec_upd_v_remap_v_r1d
      !
      module subroutine sp_devxlib_vec_upd_v_remap_v_c1d(ndim, vout, v1, map1, v2, scal)
         implicit none
         !   
         integer,      intent(in)    :: ndim
         complex(real32), intent(inout) DEV_ATTR :: vout(:) 
         complex(real32), intent(in)    DEV_ATTR :: v1(:) 
         integer,      intent(in)    DEV_ATTR :: map1(:) 
         complex(real32), intent(in)    DEV_ATTR :: v2(:) 
         complex(real32), optional, intent(in)   :: scal
         integer :: i
         !   
         if (present(scal)) then
            !DEV_CUF kernel do(1)
            do i = 1, ndim
               vout(i) = v1(map1(i))*v2(i)*scal
            enddo
         else
            !DEV_CUF kernel do(1)
            do i = 1, ndim
               vout(i) = v1(map1(i))*v2(i)
            enddo
         endif
      end subroutine sp_devxlib_vec_upd_v_remap_v_c1d
      !
!
!======================
!


      module subroutine dp_devxlib_vec_upd_v_remap_v_x_c1d(ndim, vout, v1,op1, map1, v2,op2, scal)
         implicit none
         !   
         integer,      intent(in)    :: ndim
         complex(real64), intent(inout) DEV_ATTR :: vout(:) 
         complex(real64), intent(in)    DEV_ATTR :: v1(:) 
         integer,      intent(in)    DEV_ATTR :: map1(:) 
         complex(real64), intent(in)    DEV_ATTR :: v2(:) 
         character(1), intent(in)    :: op1, op2
         complex(real64), optional, intent(in)    :: scal
         integer :: i
         !
         if (op1=="N".and.op2=="N") then
            if (present(scal)) then
               !DEV_CUF kernel do(1)
               do i = 1, ndim
                  vout(i) = v1(map1(i))*v2(i)*scal
               enddo
            else
               !DEV_CUF kernel do(1)
               do i = 1, ndim
                  vout(i) = v1(map1(i))*v2(i)
               enddo
            endif
         elseif (op1=="C".and.op2=="N") then
            if (present(scal)) then
               !DEV_CUF kernel do(1)
               do i = 1, ndim
                  vout(i) = conjg(v1(map1(i)))*v2(i)*scal
               enddo
            else
               !DEV_CUF kernel do(1)
               do i = 1, ndim
                  vout(i) = conjg(v1(map1(i)))*v2(i)
               enddo
            endif
         elseif (op1=="N".and.op2=="C") then
            if (present(scal)) then
               !DEV_CUF kernel do(1)
               do i = 1, ndim
                  vout(i) = v1(map1(i))*conjg(v2(i))*scal
               enddo
            else
               !DEV_CUF kernel do(1)
               do i = 1, ndim
                  vout(i) = v1(map1(i))*conjg(v2(i))
               enddo
            endif
         elseif (op1=="N".and.op2=="C") then
            if (present(scal)) then
               !DEV_CUF kernel do(1)
               do i = 1, ndim
                  vout(i) = conjg(v1(map1(i)))*conjg(v2(i))*scal
               enddo
            else
               !DEV_CUF kernel do(1)
               do i = 1, ndim
                  vout(i) = conjg(v1(map1(i)))*conjg(v2(i))
               enddo
            endif
         else
            call devxlib_error("dp_devxlib_vec_upd_v_remap_v_x_c1d","invalid op1/op2",10)
         endif
         !
      end subroutine dp_devxlib_vec_upd_v_remap_v_x_c1d
      !
      module subroutine sp_devxlib_vec_upd_v_remap_v_x_c1d(ndim, vout, v1,op1, map1, v2,op2, scal)
         implicit none
         !   
         integer,      intent(in)    :: ndim
         complex(real32), intent(inout) DEV_ATTR :: vout(:) 
         complex(real32), intent(in)    DEV_ATTR :: v1(:) 
         integer,      intent(in)    DEV_ATTR :: map1(:) 
         complex(real32), intent(in)    DEV_ATTR :: v2(:) 
         character(1), intent(in)    :: op1, op2
         complex(real32), optional, intent(in)    :: scal
         integer :: i
         !
         if (op1=="N".and.op2=="N") then
            if (present(scal)) then
               !DEV_CUF kernel do(1)
               do i = 1, ndim
                  vout(i) = v1(map1(i))*v2(i)*scal
               enddo
            else
               !DEV_CUF kernel do(1)
               do i = 1, ndim
                  vout(i) = v1(map1(i))*v2(i)
               enddo
            endif
         elseif (op1=="C".and.op2=="N") then
            if (present(scal)) then
               !DEV_CUF kernel do(1)
               do i = 1, ndim
                  vout(i) = conjg(v1(map1(i)))*v2(i)*scal
               enddo
            else
               !DEV_CUF kernel do(1)
               do i = 1, ndim
                  vout(i) = conjg(v1(map1(i)))*v2(i)
               enddo
            endif
         elseif (op1=="N".and.op2=="C") then
            if (present(scal)) then
               !DEV_CUF kernel do(1)
               do i = 1, ndim
                  vout(i) = v1(map1(i))*conjg(v2(i))*scal
               enddo
            else
               !DEV_CUF kernel do(1)
               do i = 1, ndim
                  vout(i) = v1(map1(i))*conjg(v2(i))
               enddo
            endif
         elseif (op1=="N".and.op2=="C") then
            if (present(scal)) then
               !DEV_CUF kernel do(1)
               do i = 1, ndim
                  vout(i) = conjg(v1(map1(i)))*conjg(v2(i))*scal
               enddo
            else
               !DEV_CUF kernel do(1)
               do i = 1, ndim
                  vout(i) = conjg(v1(map1(i)))*conjg(v2(i))
               enddo
            endif
         else
            call devxlib_error("sp_devxlib_vec_upd_v_remap_v_x_c1d","invalid op1/op2",10)
         endif
         !
      end subroutine sp_devxlib_vec_upd_v_remap_v_x_c1d
      !

end submodule devxlib_auxfunc_vec_upd

!                                                                                                                                                         c
! Copyright (C) 2021, MaX CoE
! Distributed under the MIT License 
! (license terms are at http://opensource.org/licenses/MIT).
!
!--
!
! Auxiliary functions
!
! AF: OpenACC support is incomplete !!
!
!==================================================================
!==================================================================
! *DO NOT EDIT*: automatically generated from devxlib_auxfunc.jf90
!==================================================================
!==================================================================
!
#include<devxlib_macros.h>
#include<devxlib_defs.h>
!
!=======================================
!
module devxlib_auxfunc
   !
   use iso_fortran_env,     only : real32, real64
   use devxlib_async,       only : dxl_async_kind
   use devxlib_environment, only : devxlib_error
   !
#if defined __DXL_CUDAF
   use cudafor
#endif

   implicit none

   private :: dxl_async_kind

   interface devxlib_conjg_d
      module procedure &

         dp_devxlib_conjg_c1d, dp_devxlib_conjg_c2d, dp_devxlib_conjg_c3d, &
         dp_devxlib_conjg_c4d, dp_devxlib_conjg_c5d, dp_devxlib_conjg_c6d, &
         sp_devxlib_conjg_c1d, sp_devxlib_conjg_c2d, sp_devxlib_conjg_c3d, &
         sp_devxlib_conjg_c4d, sp_devxlib_conjg_c5d, sp_devxlib_conjg_c6d
   endinterface devxlib_conjg_d


   interface devxlib_conjg_h
      module procedure &

         dp_devxlib_conjg_h_c1d, dp_devxlib_conjg_h_c2d, dp_devxlib_conjg_h_c3d, &
         dp_devxlib_conjg_h_c4d, dp_devxlib_conjg_h_c5d, dp_devxlib_conjg_h_c6d, &
         sp_devxlib_conjg_h_c1d, sp_devxlib_conjg_h_c2d, sp_devxlib_conjg_h_c3d, &
         sp_devxlib_conjg_h_c4d, sp_devxlib_conjg_h_c5d, sp_devxlib_conjg_h_c6d
   endinterface devxlib_conjg_h


   interface devxlib_conjg_d_p
      module procedure &

         dp_devxlib_conjg_c1d_p, dp_devxlib_conjg_c2d_p, dp_devxlib_conjg_c3d_p, &
         dp_devxlib_conjg_c4d_p, dp_devxlib_conjg_c5d_p, dp_devxlib_conjg_c6d_p, &
         sp_devxlib_conjg_c1d_p, sp_devxlib_conjg_c2d_p, sp_devxlib_conjg_c3d_p, &
         sp_devxlib_conjg_c4d_p, sp_devxlib_conjg_c5d_p, sp_devxlib_conjg_c6d_p
   endinterface devxlib_conjg_d_p

   interface devxlib_vec_upd_remap
      module procedure &

         dp_devxlib_vec_upd_remap_r1d, &
         dp_devxlib_vec_upd_remap_c1d, &
         sp_devxlib_vec_upd_remap_r1d, &
         sp_devxlib_vec_upd_remap_c1d
   endinterface devxlib_vec_upd_remap

   interface devxlib_vec_upd_v_remap_v
      module procedure &

         dp_devxlib_vec_upd_v_remap_v_r1d, &
         dp_devxlib_vec_upd_v_remap_v_c1d, &
         sp_devxlib_vec_upd_v_remap_v_r1d, &
         sp_devxlib_vec_upd_v_remap_v_c1d, &


         dp_devxlib_vec_upd_v_remap_v_x_c1d, &
         sp_devxlib_vec_upd_v_remap_v_x_c1d
   endinterface devxlib_vec_upd_v_remap_v

   interface devxlib_mat_upd_dMd
      module procedure &

         dp_devxlib_mat_upd_dMd_r2d, &
         dp_devxlib_mat_upd_dMd_c2d, &
         sp_devxlib_mat_upd_dMd_r2d, &
         sp_devxlib_mat_upd_dMd_c2d
   endinterface devxlib_mat_upd_dMd

   interface devxlib_mem_addscal
      module procedure &
         dp_devxlib_mem_addscal_r1d, dp_devxlib_mem_addscal_r2d, dp_devxlib_mem_addscal_r3d, &
         dp_devxlib_mem_addscal_r4d, dp_devxlib_mem_addscal_r5d, dp_devxlib_mem_addscal_r6d, &
         sp_devxlib_mem_addscal_r1d, sp_devxlib_mem_addscal_r2d, sp_devxlib_mem_addscal_r3d, &
         sp_devxlib_mem_addscal_r4d, sp_devxlib_mem_addscal_r5d, sp_devxlib_mem_addscal_r6d, &
         dp_devxlib_mem_addscal_c1d, dp_devxlib_mem_addscal_c2d, dp_devxlib_mem_addscal_c3d, &
         dp_devxlib_mem_addscal_c4d, dp_devxlib_mem_addscal_c5d, dp_devxlib_mem_addscal_c6d, &
         sp_devxlib_mem_addscal_c1d, sp_devxlib_mem_addscal_c2d, sp_devxlib_mem_addscal_c3d, &
         sp_devxlib_mem_addscal_c4d, sp_devxlib_mem_addscal_c5d, sp_devxlib_mem_addscal_c6d
   endinterface devxlib_mem_addscal

   interface

      module subroutine dp_devxlib_conjg_c1d(array_inout, async_id, &
                                        
                                        range1, lbound1 )
         implicit none
         complex(real64) DEV_ATTR, intent(inout) :: array_inout(:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2)
         integer, optional, intent(in) ::  lbound1
      end subroutine dp_devxlib_conjg_c1d
      !
      module subroutine dp_devxlib_conjg_c2d(array_inout, async_id, &
                                        
                                        range1, lbound1, &
                                        range2, lbound2 )
         implicit none
         complex(real64) DEV_ATTR, intent(inout) :: array_inout(:,:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2)
         integer, optional, intent(in) ::  lbound1, lbound2
      end subroutine dp_devxlib_conjg_c2d
      !
      module subroutine dp_devxlib_conjg_c3d(array_inout, async_id, &
                                        
                                        range1, lbound1, &
                                        range2, lbound2, &
                                        range3, lbound3 )
         implicit none
         complex(real64) DEV_ATTR, intent(inout) :: array_inout(:,:,:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3
      end subroutine dp_devxlib_conjg_c3d
      !
      module subroutine dp_devxlib_conjg_c4d(array_inout, async_id, &
                                        
                                        range1, lbound1, &
                                        range2, lbound2, &
                                        range3, lbound3, &
                                        range4, lbound4 )
         implicit none
         complex(real64) DEV_ATTR, intent(inout) :: array_inout(:,:,:,:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
      end subroutine dp_devxlib_conjg_c4d
      !
      module subroutine dp_devxlib_conjg_c5d(array_inout, async_id, &
                                        
                                        range1, lbound1, &
                                        range2, lbound2, &
                                        range3, lbound3, &
                                        range4, lbound4, &
                                        range5, lbound5 )
         implicit none
         complex(real64) DEV_ATTR, intent(inout) :: array_inout(:,:,:,:,:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5
      end subroutine dp_devxlib_conjg_c5d
      !
      module subroutine dp_devxlib_conjg_c6d(array_inout, async_id, &
                                        
                                        range1, lbound1, &
                                        range2, lbound2, &
                                        range3, lbound3, &
                                        range4, lbound4, &
                                        range5, lbound5, &
                                        range6, lbound6 )
         implicit none
         complex(real64) DEV_ATTR, intent(inout) :: array_inout(:,:,:,:,:,:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2), range6(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5, lbound6
      end subroutine dp_devxlib_conjg_c6d
      !
      module subroutine sp_devxlib_conjg_c1d(array_inout, async_id, &
                                        
                                        range1, lbound1 )
         implicit none
         complex(real32) DEV_ATTR, intent(inout) :: array_inout(:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2)
         integer, optional, intent(in) ::  lbound1
      end subroutine sp_devxlib_conjg_c1d
      !
      module subroutine sp_devxlib_conjg_c2d(array_inout, async_id, &
                                        
                                        range1, lbound1, &
                                        range2, lbound2 )
         implicit none
         complex(real32) DEV_ATTR, intent(inout) :: array_inout(:,:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2)
         integer, optional, intent(in) ::  lbound1, lbound2
      end subroutine sp_devxlib_conjg_c2d
      !
      module subroutine sp_devxlib_conjg_c3d(array_inout, async_id, &
                                        
                                        range1, lbound1, &
                                        range2, lbound2, &
                                        range3, lbound3 )
         implicit none
         complex(real32) DEV_ATTR, intent(inout) :: array_inout(:,:,:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3
      end subroutine sp_devxlib_conjg_c3d
      !
      module subroutine sp_devxlib_conjg_c4d(array_inout, async_id, &
                                        
                                        range1, lbound1, &
                                        range2, lbound2, &
                                        range3, lbound3, &
                                        range4, lbound4 )
         implicit none
         complex(real32) DEV_ATTR, intent(inout) :: array_inout(:,:,:,:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
      end subroutine sp_devxlib_conjg_c4d
      !
      module subroutine sp_devxlib_conjg_c5d(array_inout, async_id, &
                                        
                                        range1, lbound1, &
                                        range2, lbound2, &
                                        range3, lbound3, &
                                        range4, lbound4, &
                                        range5, lbound5 )
         implicit none
         complex(real32) DEV_ATTR, intent(inout) :: array_inout(:,:,:,:,:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5
      end subroutine sp_devxlib_conjg_c5d
      !
      module subroutine sp_devxlib_conjg_c6d(array_inout, async_id, &
                                        
                                        range1, lbound1, &
                                        range2, lbound2, &
                                        range3, lbound3, &
                                        range4, lbound4, &
                                        range5, lbound5, &
                                        range6, lbound6 )
         implicit none
         complex(real32) DEV_ATTR, intent(inout) :: array_inout(:,:,:,:,:,:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2), range6(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5, lbound6
      end subroutine sp_devxlib_conjg_c6d
      !
   endinterface

   interface

      module subroutine dp_devxlib_conjg_h_c1d(array_inout, async_id, &
                                     
                                     range1, lbound1 )
         implicit none
         complex(real64), intent(inout) :: array_inout(:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2)
         integer, optional, intent(in) ::  lbound1
      end subroutine dp_devxlib_conjg_h_c1d
      !
      module subroutine dp_devxlib_conjg_h_c2d(array_inout, async_id, &
                                     
                                     range1, lbound1, &
                                     range2, lbound2 )
         implicit none
         complex(real64), intent(inout) :: array_inout(:,:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2)
         integer, optional, intent(in) ::  lbound1, lbound2
      end subroutine dp_devxlib_conjg_h_c2d
      !
      module subroutine dp_devxlib_conjg_h_c3d(array_inout, async_id, &
                                     
                                     range1, lbound1, &
                                     range2, lbound2, &
                                     range3, lbound3 )
         implicit none
         complex(real64), intent(inout) :: array_inout(:,:,:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3
      end subroutine dp_devxlib_conjg_h_c3d
      !
      module subroutine dp_devxlib_conjg_h_c4d(array_inout, async_id, &
                                     
                                     range1, lbound1, &
                                     range2, lbound2, &
                                     range3, lbound3, &
                                     range4, lbound4 )
         implicit none
         complex(real64), intent(inout) :: array_inout(:,:,:,:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
      end subroutine dp_devxlib_conjg_h_c4d
      !
      module subroutine dp_devxlib_conjg_h_c5d(array_inout, async_id, &
                                     
                                     range1, lbound1, &
                                     range2, lbound2, &
                                     range3, lbound3, &
                                     range4, lbound4, &
                                     range5, lbound5 )
         implicit none
         complex(real64), intent(inout) :: array_inout(:,:,:,:,:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5
      end subroutine dp_devxlib_conjg_h_c5d
      !
      module subroutine dp_devxlib_conjg_h_c6d(array_inout, async_id, &
                                     
                                     range1, lbound1, &
                                     range2, lbound2, &
                                     range3, lbound3, &
                                     range4, lbound4, &
                                     range5, lbound5, &
                                     range6, lbound6 )
         implicit none
         complex(real64), intent(inout) :: array_inout(:,:,:,:,:,:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2), range6(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5, lbound6
      end subroutine dp_devxlib_conjg_h_c6d
      !
      module subroutine sp_devxlib_conjg_h_c1d(array_inout, async_id, &
                                     
                                     range1, lbound1 )
         implicit none
         complex(real32), intent(inout) :: array_inout(:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2)
         integer, optional, intent(in) ::  lbound1
      end subroutine sp_devxlib_conjg_h_c1d
      !
      module subroutine sp_devxlib_conjg_h_c2d(array_inout, async_id, &
                                     
                                     range1, lbound1, &
                                     range2, lbound2 )
         implicit none
         complex(real32), intent(inout) :: array_inout(:,:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2)
         integer, optional, intent(in) ::  lbound1, lbound2
      end subroutine sp_devxlib_conjg_h_c2d
      !
      module subroutine sp_devxlib_conjg_h_c3d(array_inout, async_id, &
                                     
                                     range1, lbound1, &
                                     range2, lbound2, &
                                     range3, lbound3 )
         implicit none
         complex(real32), intent(inout) :: array_inout(:,:,:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3
      end subroutine sp_devxlib_conjg_h_c3d
      !
      module subroutine sp_devxlib_conjg_h_c4d(array_inout, async_id, &
                                     
                                     range1, lbound1, &
                                     range2, lbound2, &
                                     range3, lbound3, &
                                     range4, lbound4 )
         implicit none
         complex(real32), intent(inout) :: array_inout(:,:,:,:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
      end subroutine sp_devxlib_conjg_h_c4d
      !
      module subroutine sp_devxlib_conjg_h_c5d(array_inout, async_id, &
                                     
                                     range1, lbound1, &
                                     range2, lbound2, &
                                     range3, lbound3, &
                                     range4, lbound4, &
                                     range5, lbound5 )
         implicit none
         complex(real32), intent(inout) :: array_inout(:,:,:,:,:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5
      end subroutine sp_devxlib_conjg_h_c5d
      !
      module subroutine sp_devxlib_conjg_h_c6d(array_inout, async_id, &
                                     
                                     range1, lbound1, &
                                     range2, lbound2, &
                                     range3, lbound3, &
                                     range4, lbound4, &
                                     range5, lbound5, &
                                     range6, lbound6 )
         implicit none
         complex(real32), intent(inout) :: array_inout(:,:,:,:,:,:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2), range6(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5, lbound6
      end subroutine sp_devxlib_conjg_h_c6d
      !
   endinterface

   interface

      module subroutine dp_devxlib_conjg_c1d_p(ptr_inout, async_id, &
                                        
                                        range1, lbound1 )
         implicit none
         complex(real64), pointer, contiguous, intent(inout) DEV_ATTR :: ptr_inout(:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2)
         integer, optional, intent(in) ::  lbound1
      end subroutine dp_devxlib_conjg_c1d_p
      !
      module subroutine dp_devxlib_conjg_c2d_p(ptr_inout, async_id, &
                                        
                                        range1, lbound1, &
                                        range2, lbound2 )
         implicit none
         complex(real64), pointer, contiguous, intent(inout) DEV_ATTR :: ptr_inout(:,:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2)
         integer, optional, intent(in) ::  lbound1, lbound2
      end subroutine dp_devxlib_conjg_c2d_p
      !
      module subroutine dp_devxlib_conjg_c3d_p(ptr_inout, async_id, &
                                        
                                        range1, lbound1, &
                                        range2, lbound2, &
                                        range3, lbound3 )
         implicit none
         complex(real64), pointer, contiguous, intent(inout) DEV_ATTR :: ptr_inout(:,:,:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3
      end subroutine dp_devxlib_conjg_c3d_p
      !
      module subroutine dp_devxlib_conjg_c4d_p(ptr_inout, async_id, &
                                        
                                        range1, lbound1, &
                                        range2, lbound2, &
                                        range3, lbound3, &
                                        range4, lbound4 )
         implicit none
         complex(real64), pointer, contiguous, intent(inout) DEV_ATTR :: ptr_inout(:,:,:,:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
      end subroutine dp_devxlib_conjg_c4d_p
      !
      module subroutine dp_devxlib_conjg_c5d_p(ptr_inout, async_id, &
                                        
                                        range1, lbound1, &
                                        range2, lbound2, &
                                        range3, lbound3, &
                                        range4, lbound4, &
                                        range5, lbound5 )
         implicit none
         complex(real64), pointer, contiguous, intent(inout) DEV_ATTR :: ptr_inout(:,:,:,:,:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5
      end subroutine dp_devxlib_conjg_c5d_p
      !
      module subroutine dp_devxlib_conjg_c6d_p(ptr_inout, async_id, &
                                        
                                        range1, lbound1, &
                                        range2, lbound2, &
                                        range3, lbound3, &
                                        range4, lbound4, &
                                        range5, lbound5, &
                                        range6, lbound6 )
         implicit none
         complex(real64), pointer, contiguous, intent(inout) DEV_ATTR :: ptr_inout(:,:,:,:,:,:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2), range6(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5, lbound6
      end subroutine dp_devxlib_conjg_c6d_p
      !
      module subroutine sp_devxlib_conjg_c1d_p(ptr_inout, async_id, &
                                        
                                        range1, lbound1 )
         implicit none
         complex(real32), pointer, contiguous, intent(inout) DEV_ATTR :: ptr_inout(:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2)
         integer, optional, intent(in) ::  lbound1
      end subroutine sp_devxlib_conjg_c1d_p
      !
      module subroutine sp_devxlib_conjg_c2d_p(ptr_inout, async_id, &
                                        
                                        range1, lbound1, &
                                        range2, lbound2 )
         implicit none
         complex(real32), pointer, contiguous, intent(inout) DEV_ATTR :: ptr_inout(:,:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2)
         integer, optional, intent(in) ::  lbound1, lbound2
      end subroutine sp_devxlib_conjg_c2d_p
      !
      module subroutine sp_devxlib_conjg_c3d_p(ptr_inout, async_id, &
                                        
                                        range1, lbound1, &
                                        range2, lbound2, &
                                        range3, lbound3 )
         implicit none
         complex(real32), pointer, contiguous, intent(inout) DEV_ATTR :: ptr_inout(:,:,:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3
      end subroutine sp_devxlib_conjg_c3d_p
      !
      module subroutine sp_devxlib_conjg_c4d_p(ptr_inout, async_id, &
                                        
                                        range1, lbound1, &
                                        range2, lbound2, &
                                        range3, lbound3, &
                                        range4, lbound4 )
         implicit none
         complex(real32), pointer, contiguous, intent(inout) DEV_ATTR :: ptr_inout(:,:,:,:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
      end subroutine sp_devxlib_conjg_c4d_p
      !
      module subroutine sp_devxlib_conjg_c5d_p(ptr_inout, async_id, &
                                        
                                        range1, lbound1, &
                                        range2, lbound2, &
                                        range3, lbound3, &
                                        range4, lbound4, &
                                        range5, lbound5 )
         implicit none
         complex(real32), pointer, contiguous, intent(inout) DEV_ATTR :: ptr_inout(:,:,:,:,:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5
      end subroutine sp_devxlib_conjg_c5d_p
      !
      module subroutine sp_devxlib_conjg_c6d_p(ptr_inout, async_id, &
                                        
                                        range1, lbound1, &
                                        range2, lbound2, &
                                        range3, lbound3, &
                                        range4, lbound4, &
                                        range5, lbound5, &
                                        range6, lbound6 )
         implicit none
         complex(real32), pointer, contiguous, intent(inout) DEV_ATTR :: ptr_inout(:,:,:,:,:,:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2), range6(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5, lbound6
      end subroutine sp_devxlib_conjg_c6d_p
      !
   endinterface

   interface

       module subroutine dp_devxlib_vec_upd_remap_r1d(ndim, vout, v1, map1, scal)
          implicit none
          integer,      intent(in)    :: ndim
          real(real64) DEV_ATTR, intent(inout) :: vout(:) 
          real(real64) DEV_ATTR, intent(in)    :: v1(:) 
          integer DEV_ATTR,      intent(in)    :: map1(:) 
          real(real64), optional, intent(in)   :: scal
       end subroutine dp_devxlib_vec_upd_remap_r1d
       !
       module subroutine dp_devxlib_vec_upd_remap_c1d(ndim, vout, v1, map1, scal)
          implicit none
          integer,      intent(in)    :: ndim
          complex(real64) DEV_ATTR, intent(inout) :: vout(:) 
          complex(real64) DEV_ATTR, intent(in)    :: v1(:) 
          integer DEV_ATTR,      intent(in)    :: map1(:) 
          complex(real64), optional, intent(in)   :: scal
       end subroutine dp_devxlib_vec_upd_remap_c1d
       !
       module subroutine sp_devxlib_vec_upd_remap_r1d(ndim, vout, v1, map1, scal)
          implicit none
          integer,      intent(in)    :: ndim
          real(real32) DEV_ATTR, intent(inout) :: vout(:) 
          real(real32) DEV_ATTR, intent(in)    :: v1(:) 
          integer DEV_ATTR,      intent(in)    :: map1(:) 
          real(real32), optional, intent(in)   :: scal
       end subroutine sp_devxlib_vec_upd_remap_r1d
       !
       module subroutine sp_devxlib_vec_upd_remap_c1d(ndim, vout, v1, map1, scal)
          implicit none
          integer,      intent(in)    :: ndim
          complex(real32) DEV_ATTR, intent(inout) :: vout(:) 
          complex(real32) DEV_ATTR, intent(in)    :: v1(:) 
          integer DEV_ATTR,      intent(in)    :: map1(:) 
          complex(real32), optional, intent(in)   :: scal
       end subroutine sp_devxlib_vec_upd_remap_c1d
       !
   end interface

   interface

      module subroutine dp_devxlib_vec_upd_v_remap_v_r1d(ndim, vout, v1, map1, v2, scal)
         implicit none
         integer,      intent(in)    :: ndim
         real(real64) DEV_ATTR, intent(inout) :: vout(:)
         real(real64) DEV_ATTR, intent(in)    :: v1(:)
         integer DEV_ATTR,      intent(in)    :: map1(:)
         real(real64) DEV_ATTR, intent(in)    :: v2(:)
         real(real64), optional, intent(in)   :: scal
      end subroutine dp_devxlib_vec_upd_v_remap_v_r1d
      !
      module subroutine dp_devxlib_vec_upd_v_remap_v_c1d(ndim, vout, v1, map1, v2, scal)
         implicit none
         integer,      intent(in)    :: ndim
         complex(real64) DEV_ATTR, intent(inout) :: vout(:)
         complex(real64) DEV_ATTR, intent(in)    :: v1(:)
         integer DEV_ATTR,      intent(in)    :: map1(:)
         complex(real64) DEV_ATTR, intent(in)    :: v2(:)
         complex(real64), optional, intent(in)   :: scal
      end subroutine dp_devxlib_vec_upd_v_remap_v_c1d
      !
      module subroutine sp_devxlib_vec_upd_v_remap_v_r1d(ndim, vout, v1, map1, v2, scal)
         implicit none
         integer,      intent(in)    :: ndim
         real(real32) DEV_ATTR, intent(inout) :: vout(:)
         real(real32) DEV_ATTR, intent(in)    :: v1(:)
         integer DEV_ATTR,      intent(in)    :: map1(:)
         real(real32) DEV_ATTR, intent(in)    :: v2(:)
         real(real32), optional, intent(in)   :: scal
      end subroutine sp_devxlib_vec_upd_v_remap_v_r1d
      !
      module subroutine sp_devxlib_vec_upd_v_remap_v_c1d(ndim, vout, v1, map1, v2, scal)
         implicit none
         integer,      intent(in)    :: ndim
         complex(real32) DEV_ATTR, intent(inout) :: vout(:)
         complex(real32) DEV_ATTR, intent(in)    :: v1(:)
         integer DEV_ATTR,      intent(in)    :: map1(:)
         complex(real32) DEV_ATTR, intent(in)    :: v2(:)
         complex(real32), optional, intent(in)   :: scal
      end subroutine sp_devxlib_vec_upd_v_remap_v_c1d
      !



      module subroutine dp_devxlib_vec_upd_v_remap_v_x_c1d(ndim, vout, v1,op1, map1, v2,op2, scal)
         implicit none
         integer,      intent(in)    :: ndim
         complex(real64), intent(inout) :: vout(:)
         complex(real64), intent(in)    :: v1(:)
         integer,      intent(in)    :: map1(:)
         complex(real64), intent(in)    :: v2(:)
         character(1), intent(in)    :: op1, op2
         complex(real64), optional, intent(in)    :: scal
#if defined(__DXL_CUDAF)
         attributes(device) :: vout, v1, v2, map1
#endif
      end subroutine dp_devxlib_vec_upd_v_remap_v_x_c1d
      !
      module subroutine sp_devxlib_vec_upd_v_remap_v_x_c1d(ndim, vout, v1,op1, map1, v2,op2, scal)
         implicit none
         integer,      intent(in)    :: ndim
         complex(real32), intent(inout) :: vout(:)
         complex(real32), intent(in)    :: v1(:)
         integer,      intent(in)    :: map1(:)
         complex(real32), intent(in)    :: v2(:)
         character(1), intent(in)    :: op1, op2
         complex(real32), optional, intent(in)    :: scal
#if defined(__DXL_CUDAF)
         attributes(device) :: vout, v1, v2, map1
#endif
      end subroutine sp_devxlib_vec_upd_v_remap_v_x_c1d
      !
   end interface

   interface

      module subroutine dp_devxlib_mat_upd_dMd_r2d(ndim1, ndim2, mat, v1,op1, v2,op2, scal)
         !   
         ! performs: mat(i,j) = scal * op1(v1(i)) * mat(i,j) * op2(v2(j))
         ! op = 'N', 'R', 'C',       'RC'
         !       x   1/x  conjg(x)   conjg(1/x)
         implicit none
         integer,      intent(in)    :: ndim1,ndim2
         real(real64), intent(inout) DEV_ATTR :: mat(:,:)
         real(real64), intent(in)    DEV_ATTR :: v1(:)
         real(real64), intent(in)    DEV_ATTR :: v2(:)
         character(1), intent(in)    :: op1, op2 
         real(real64), optional, intent(in)  :: scal
      end subroutine dp_devxlib_mat_upd_dMd_r2d
      !
      module subroutine dp_devxlib_mat_upd_dMd_c2d(ndim1, ndim2, mat, v1,op1, v2,op2, scal)
         !   
         ! performs: mat(i,j) = scal * op1(v1(i)) * mat(i,j) * op2(v2(j))
         ! op = 'N', 'R', 'C',       'RC'
         !       x   1/x  conjg(x)   conjg(1/x)
         implicit none
         integer,      intent(in)    :: ndim1,ndim2
         complex(real64), intent(inout) DEV_ATTR :: mat(:,:)
         complex(real64), intent(in)    DEV_ATTR :: v1(:)
         complex(real64), intent(in)    DEV_ATTR :: v2(:)
         character(1), intent(in)    :: op1, op2 
         complex(real64), optional, intent(in)  :: scal
      end subroutine dp_devxlib_mat_upd_dMd_c2d
      !
      module subroutine sp_devxlib_mat_upd_dMd_r2d(ndim1, ndim2, mat, v1,op1, v2,op2, scal)
         !   
         ! performs: mat(i,j) = scal * op1(v1(i)) * mat(i,j) * op2(v2(j))
         ! op = 'N', 'R', 'C',       'RC'
         !       x   1/x  conjg(x)   conjg(1/x)
         implicit none
         integer,      intent(in)    :: ndim1,ndim2
         real(real32), intent(inout) DEV_ATTR :: mat(:,:)
         real(real32), intent(in)    DEV_ATTR :: v1(:)
         real(real32), intent(in)    DEV_ATTR :: v2(:)
         character(1), intent(in)    :: op1, op2 
         real(real32), optional, intent(in)  :: scal
      end subroutine sp_devxlib_mat_upd_dMd_r2d
      !
      module subroutine sp_devxlib_mat_upd_dMd_c2d(ndim1, ndim2, mat, v1,op1, v2,op2, scal)
         !   
         ! performs: mat(i,j) = scal * op1(v1(i)) * mat(i,j) * op2(v2(j))
         ! op = 'N', 'R', 'C',       'RC'
         !       x   1/x  conjg(x)   conjg(1/x)
         implicit none
         integer,      intent(in)    :: ndim1,ndim2
         complex(real32), intent(inout) DEV_ATTR :: mat(:,:)
         complex(real32), intent(in)    DEV_ATTR :: v1(:)
         complex(real32), intent(in)    DEV_ATTR :: v2(:)
         character(1), intent(in)    :: op1, op2 
         complex(real32), optional, intent(in)  :: scal
      end subroutine sp_devxlib_mat_upd_dMd_c2d
      !
   end interface

   interface
      module subroutine dp_devxlib_mem_addscal_r1d(array_out, array_in, scal, &
                                                  range1, lbound1 )
          implicit none
          real(real64), intent(inout) :: array_out(:)
          real(real64), intent(in)    :: array_in(:)
          real(real64), optional, intent(in) :: scal
          integer, optional, intent(in) ::  range1(2)
          integer, optional, intent(in) ::  lbound1
#if defined(__DXL_CUDAF)
          attributes(device) :: array_out, array_in
#endif
      end subroutine dp_devxlib_mem_addscal_r1d
      !
      module subroutine dp_devxlib_mem_addscal_r2d(array_out, array_in, scal, &
                                                  range1, lbound1, &
                                                  range2, lbound2 )
          implicit none
          real(real64), intent(inout) :: array_out(:,:)
          real(real64), intent(in)    :: array_in(:,:)
          real(real64), optional, intent(in) :: scal
          integer, optional, intent(in) ::  range1(2), range2(2)
          integer, optional, intent(in) ::  lbound1, lbound2
#if defined(__DXL_CUDAF)
          attributes(device) :: array_out, array_in
#endif
      end subroutine dp_devxlib_mem_addscal_r2d
      !
      module subroutine dp_devxlib_mem_addscal_r3d(array_out, array_in, scal, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3 )
          implicit none
          real(real64), intent(inout) :: array_out(:,:,:)
          real(real64), intent(in)    :: array_in(:,:,:)
          real(real64), optional, intent(in) :: scal
          integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
          integer, optional, intent(in) ::  lbound1, lbound2, lbound3
#if defined(__DXL_CUDAF)
          attributes(device) :: array_out, array_in
#endif
      end subroutine dp_devxlib_mem_addscal_r3d
      !
      module subroutine dp_devxlib_mem_addscal_r4d(array_out, array_in, scal, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3, &
                                                  range4, lbound4 )
          implicit none
          real(real64), intent(inout) :: array_out(:,:,:,:)
          real(real64), intent(in)    :: array_in(:,:,:,:)
          real(real64), optional, intent(in) :: scal
          integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
          integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
#if defined(__DXL_CUDAF)
          attributes(device) :: array_out, array_in
#endif
      end subroutine dp_devxlib_mem_addscal_r4d
      !
      module subroutine dp_devxlib_mem_addscal_r5d(array_out, array_in, scal, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3, &
                                                  range4, lbound4, &
                                                  range5, lbound5 )
          implicit none
          real(real64), intent(inout) :: array_out(:,:,:,:,:)
          real(real64), intent(in)    :: array_in(:,:,:,:,:)
          real(real64), optional, intent(in) :: scal
          integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2)
          integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5
#if defined(__DXL_CUDAF)
          attributes(device) :: array_out, array_in
#endif
      end subroutine dp_devxlib_mem_addscal_r5d
      !
      module subroutine dp_devxlib_mem_addscal_r6d(array_out, array_in, scal, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3, &
                                                  range4, lbound4, &
                                                  range5, lbound5, &
                                                  range6, lbound6 )
          implicit none
          real(real64), intent(inout) :: array_out(:,:,:,:,:,:)
          real(real64), intent(in)    :: array_in(:,:,:,:,:,:)
          real(real64), optional, intent(in) :: scal
          integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2), range6(2)
          integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5, lbound6
#if defined(__DXL_CUDAF)
          attributes(device) :: array_out, array_in
#endif
      end subroutine dp_devxlib_mem_addscal_r6d
      !
      module subroutine sp_devxlib_mem_addscal_r1d(array_out, array_in, scal, &
                                                  range1, lbound1 )
          implicit none
          real(real32), intent(inout) :: array_out(:)
          real(real32), intent(in)    :: array_in(:)
          real(real32), optional, intent(in) :: scal
          integer, optional, intent(in) ::  range1(2)
          integer, optional, intent(in) ::  lbound1
#if defined(__DXL_CUDAF)
          attributes(device) :: array_out, array_in
#endif
      end subroutine sp_devxlib_mem_addscal_r1d
      !
      module subroutine sp_devxlib_mem_addscal_r2d(array_out, array_in, scal, &
                                                  range1, lbound1, &
                                                  range2, lbound2 )
          implicit none
          real(real32), intent(inout) :: array_out(:,:)
          real(real32), intent(in)    :: array_in(:,:)
          real(real32), optional, intent(in) :: scal
          integer, optional, intent(in) ::  range1(2), range2(2)
          integer, optional, intent(in) ::  lbound1, lbound2
#if defined(__DXL_CUDAF)
          attributes(device) :: array_out, array_in
#endif
      end subroutine sp_devxlib_mem_addscal_r2d
      !
      module subroutine sp_devxlib_mem_addscal_r3d(array_out, array_in, scal, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3 )
          implicit none
          real(real32), intent(inout) :: array_out(:,:,:)
          real(real32), intent(in)    :: array_in(:,:,:)
          real(real32), optional, intent(in) :: scal
          integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
          integer, optional, intent(in) ::  lbound1, lbound2, lbound3
#if defined(__DXL_CUDAF)
          attributes(device) :: array_out, array_in
#endif
      end subroutine sp_devxlib_mem_addscal_r3d
      !
      module subroutine sp_devxlib_mem_addscal_r4d(array_out, array_in, scal, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3, &
                                                  range4, lbound4 )
          implicit none
          real(real32), intent(inout) :: array_out(:,:,:,:)
          real(real32), intent(in)    :: array_in(:,:,:,:)
          real(real32), optional, intent(in) :: scal
          integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
          integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
#if defined(__DXL_CUDAF)
          attributes(device) :: array_out, array_in
#endif
      end subroutine sp_devxlib_mem_addscal_r4d
      !
      module subroutine sp_devxlib_mem_addscal_r5d(array_out, array_in, scal, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3, &
                                                  range4, lbound4, &
                                                  range5, lbound5 )
          implicit none
          real(real32), intent(inout) :: array_out(:,:,:,:,:)
          real(real32), intent(in)    :: array_in(:,:,:,:,:)
          real(real32), optional, intent(in) :: scal
          integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2)
          integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5
#if defined(__DXL_CUDAF)
          attributes(device) :: array_out, array_in
#endif
      end subroutine sp_devxlib_mem_addscal_r5d
      !
      module subroutine sp_devxlib_mem_addscal_r6d(array_out, array_in, scal, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3, &
                                                  range4, lbound4, &
                                                  range5, lbound5, &
                                                  range6, lbound6 )
          implicit none
          real(real32), intent(inout) :: array_out(:,:,:,:,:,:)
          real(real32), intent(in)    :: array_in(:,:,:,:,:,:)
          real(real32), optional, intent(in) :: scal
          integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2), range6(2)
          integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5, lbound6
#if defined(__DXL_CUDAF)
          attributes(device) :: array_out, array_in
#endif
      end subroutine sp_devxlib_mem_addscal_r6d
      !
      module subroutine dp_devxlib_mem_addscal_c1d(array_out, array_in, scal, &
                                                  range1, lbound1 )
          implicit none
          complex(real64), intent(inout) :: array_out(:)
          complex(real64), intent(in)    :: array_in(:)
          complex(real64), optional, intent(in) :: scal
          integer, optional, intent(in) ::  range1(2)
          integer, optional, intent(in) ::  lbound1
#if defined(__DXL_CUDAF)
          attributes(device) :: array_out, array_in
#endif
      end subroutine dp_devxlib_mem_addscal_c1d
      !
      module subroutine dp_devxlib_mem_addscal_c2d(array_out, array_in, scal, &
                                                  range1, lbound1, &
                                                  range2, lbound2 )
          implicit none
          complex(real64), intent(inout) :: array_out(:,:)
          complex(real64), intent(in)    :: array_in(:,:)
          complex(real64), optional, intent(in) :: scal
          integer, optional, intent(in) ::  range1(2), range2(2)
          integer, optional, intent(in) ::  lbound1, lbound2
#if defined(__DXL_CUDAF)
          attributes(device) :: array_out, array_in
#endif
      end subroutine dp_devxlib_mem_addscal_c2d
      !
      module subroutine dp_devxlib_mem_addscal_c3d(array_out, array_in, scal, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3 )
          implicit none
          complex(real64), intent(inout) :: array_out(:,:,:)
          complex(real64), intent(in)    :: array_in(:,:,:)
          complex(real64), optional, intent(in) :: scal
          integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
          integer, optional, intent(in) ::  lbound1, lbound2, lbound3
#if defined(__DXL_CUDAF)
          attributes(device) :: array_out, array_in
#endif
      end subroutine dp_devxlib_mem_addscal_c3d
      !
      module subroutine dp_devxlib_mem_addscal_c4d(array_out, array_in, scal, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3, &
                                                  range4, lbound4 )
          implicit none
          complex(real64), intent(inout) :: array_out(:,:,:,:)
          complex(real64), intent(in)    :: array_in(:,:,:,:)
          complex(real64), optional, intent(in) :: scal
          integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
          integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
#if defined(__DXL_CUDAF)
          attributes(device) :: array_out, array_in
#endif
      end subroutine dp_devxlib_mem_addscal_c4d
      !
      module subroutine dp_devxlib_mem_addscal_c5d(array_out, array_in, scal, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3, &
                                                  range4, lbound4, &
                                                  range5, lbound5 )
          implicit none
          complex(real64), intent(inout) :: array_out(:,:,:,:,:)
          complex(real64), intent(in)    :: array_in(:,:,:,:,:)
          complex(real64), optional, intent(in) :: scal
          integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2)
          integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5
#if defined(__DXL_CUDAF)
          attributes(device) :: array_out, array_in
#endif
      end subroutine dp_devxlib_mem_addscal_c5d
      !
      module subroutine dp_devxlib_mem_addscal_c6d(array_out, array_in, scal, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3, &
                                                  range4, lbound4, &
                                                  range5, lbound5, &
                                                  range6, lbound6 )
          implicit none
          complex(real64), intent(inout) :: array_out(:,:,:,:,:,:)
          complex(real64), intent(in)    :: array_in(:,:,:,:,:,:)
          complex(real64), optional, intent(in) :: scal
          integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2), range6(2)
          integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5, lbound6
#if defined(__DXL_CUDAF)
          attributes(device) :: array_out, array_in
#endif
      end subroutine dp_devxlib_mem_addscal_c6d
      !
      module subroutine sp_devxlib_mem_addscal_c1d(array_out, array_in, scal, &
                                                  range1, lbound1 )
          implicit none
          complex(real32), intent(inout) :: array_out(:)
          complex(real32), intent(in)    :: array_in(:)
          complex(real32), optional, intent(in) :: scal
          integer, optional, intent(in) ::  range1(2)
          integer, optional, intent(in) ::  lbound1
#if defined(__DXL_CUDAF)
          attributes(device) :: array_out, array_in
#endif
      end subroutine sp_devxlib_mem_addscal_c1d
      !
      module subroutine sp_devxlib_mem_addscal_c2d(array_out, array_in, scal, &
                                                  range1, lbound1, &
                                                  range2, lbound2 )
          implicit none
          complex(real32), intent(inout) :: array_out(:,:)
          complex(real32), intent(in)    :: array_in(:,:)
          complex(real32), optional, intent(in) :: scal
          integer, optional, intent(in) ::  range1(2), range2(2)
          integer, optional, intent(in) ::  lbound1, lbound2
#if defined(__DXL_CUDAF)
          attributes(device) :: array_out, array_in
#endif
      end subroutine sp_devxlib_mem_addscal_c2d
      !
      module subroutine sp_devxlib_mem_addscal_c3d(array_out, array_in, scal, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3 )
          implicit none
          complex(real32), intent(inout) :: array_out(:,:,:)
          complex(real32), intent(in)    :: array_in(:,:,:)
          complex(real32), optional, intent(in) :: scal
          integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
          integer, optional, intent(in) ::  lbound1, lbound2, lbound3
#if defined(__DXL_CUDAF)
          attributes(device) :: array_out, array_in
#endif
      end subroutine sp_devxlib_mem_addscal_c3d
      !
      module subroutine sp_devxlib_mem_addscal_c4d(array_out, array_in, scal, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3, &
                                                  range4, lbound4 )
          implicit none
          complex(real32), intent(inout) :: array_out(:,:,:,:)
          complex(real32), intent(in)    :: array_in(:,:,:,:)
          complex(real32), optional, intent(in) :: scal
          integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
          integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
#if defined(__DXL_CUDAF)
          attributes(device) :: array_out, array_in
#endif
      end subroutine sp_devxlib_mem_addscal_c4d
      !
      module subroutine sp_devxlib_mem_addscal_c5d(array_out, array_in, scal, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3, &
                                                  range4, lbound4, &
                                                  range5, lbound5 )
          implicit none
          complex(real32), intent(inout) :: array_out(:,:,:,:,:)
          complex(real32), intent(in)    :: array_in(:,:,:,:,:)
          complex(real32), optional, intent(in) :: scal
          integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2)
          integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5
#if defined(__DXL_CUDAF)
          attributes(device) :: array_out, array_in
#endif
      end subroutine sp_devxlib_mem_addscal_c5d
      !
      module subroutine sp_devxlib_mem_addscal_c6d(array_out, array_in, scal, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3, &
                                                  range4, lbound4, &
                                                  range5, lbound5, &
                                                  range6, lbound6 )
          implicit none
          complex(real32), intent(inout) :: array_out(:,:,:,:,:,:)
          complex(real32), intent(in)    :: array_in(:,:,:,:,:,:)
          complex(real32), optional, intent(in) :: scal
          integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2), range6(2)
          integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5, lbound6
#if defined(__DXL_CUDAF)
          attributes(device) :: array_out, array_in
#endif
      end subroutine sp_devxlib_mem_addscal_c6d
      !
   end interface

endmodule devxlib_auxfunc

module offloadable
use iso_c_binding
use iso_fortran_env, only: DP=> REAL64 
implicit none 

type data_flags 
   logical  :: use_gpu 
end type data_flags

#if !defined(__CUDA) 
type c_devptr 
   type(c_ptr)  :: cptr 
end type c_devptr 

type cudaArrayPtr 
   type (c_ptr)  :: aptr 
end type cudaArrayPtr 
#endif 

type offloadable_base 
  type(c_ptr)          :: gpu_void =  c_null_ptr 
  type (c_ptr)         :: cpu_void =  c_null_ptr 
  integer                    ::  rank 
  integer,allocatable        :: shape(:)
  integer                    :: size 
  integer,allocatable        :: stride(:)  
  logical                    :: dev_tready = .false. 
  logical                    :: host_tready =.false. 
  logical                    :: owns_data   = .false. 
end type offloadable_base 

type offloadable_complex
  type(offloadable_base)     :: base 
  complex(dp), pointer           ::  gpu_pt(:) => NULL()
  complex(dp), pointer    ::  cpu_pt(:) => NULL() 
#if defined(__CUDA) 
  attributes, device    :: gpu_pt 
#endif
end type offloadable_complex

type offloadable_real
  type(offloadable_base)        ::  base 
  real(dp), pointer           ::  gpu_pt(:) =>NULL()
  real(dp), pointer           ::  cpu_pt(:) =>NULL()
#if defined(__CUDA)  
  attributes, device          :: gpu_pt 
#endif
end type offloadable_real

type offloadable_integer 
  type(offloadable_base)         :: base 
  integer(dp), pointer           ::  gpu_pt(:) =>NULL()
  integer(dp), pointer           ::  cpu_pt(:) =>NULL()
#if defined(__CUDA)  
  attributes,device              :: gpu_pt 
#endif 
end type offloadable_integer 

interface 
  function castpointers (c_pointer) bind(C, name="c_cast_ptr") result (t_ptr)
      import  c_size_t, c_ptr
      implicit none 
      type(c_ptr), value :: c_pointer
      integer(c_size_t)  :: t_ptr 
  end function castpointers  
end interface 


interface initdata 
   module procedure init_data_complex, init_data_real, init_data_integer
end interface initdata 

interface associate_read 
!   module procedure read_complex, read_real, read_integer 
end interface associate_read 

interface associate_write 
   module procedure write_complex, write_real, write_integer
   module procedure write_complex2d, write_real2d, write_integer2d
   module procedure write_complex3d, write_real3d, write_integer3d 
end   interface associate_write

interface free
!module procedure   free_complex, free_real, free_integer
end interface free 

contains 

function system_descriptor(use_gpu) result (descsys) 
   implicit none 
   type(data_flags) :: descsys 
   logical, optional, intent(in) :: use_gpu 
   descsys%use_gpu  = .false.
#if defined(__CUDA) 
   if (present(use_gpu)) descsys%use_gpu = use_gpu 
#endif 
end function system_descriptor

subroutine init_base(obj, rank, shape, cpu_ptr, gpu_ptr, descsys) 
   implicit none 
   type(offloadable_base) :: obj
   integer                :: rank 
   integer                :: shape(:) 
   type(c_ptr)      :: cpu_ptr, gpu_ptr 
   type(data_flags)       :: descsys 
   integer                :: i 
   obj%rank = rank 
   obj%size =1 
   do i =1, rank 
      obj%size = obj%size * shape(i) 
   end do 
   allocate(obj%shape, source = shape) 
   obj%cpu_void = cpu_ptr
   obj%gpu_void = gpu_ptr 
end subroutine init_base 

subroutine init_data_complex(a_manager, a, a_d, rank, shape, descsys) 
   implicit none 
   complex(dp),target :: a(:)
   complex(dp),target :: a_d(:) 
   type(offloadable_complex),intent(out) :: a_manager 
#if defined(__CUDA) 
   attributes, device :: a_d 
#endif 
   integer :: rank 
   integer :: shape(rank)
   type(data_flags) :: descsys 
   ! 
   type (c_ptr)       :: cpu_ptr, gpu_ptr
   type (c_devptr)    :: aux_ptr 

   cpu_ptr = c_loc(a) 
#if defined (__CUDA) 
   if (descsys%use_gpu) then 
      aux_ptr = c_devloc ( a_d)
      gpu_ptr = aux_ptr%cptr 
   else 
      gpu_ptr = c_loc(a_d) 
   end if 
#else 
   gpu_ptr= c_loc(a_d) 
#endif
   call init_base(a_manager%base, rank, shape, cpu_ptr, gpu_ptr, descsys ) 
end subroutine init_data_complex

subroutine init_data_real(a_manager, a, a_d, rank, shape, descsys) 
   implicit none 
   real(dp),target :: a(:)
   real(dp),target :: a_d(:) 
   type(offloadable_real),intent(out) :: a_manager 
#if defined(__CUDA) 
   attributes, device :: a_d 
#endif 
   integer :: rank 
   integer :: shape(rank)
   type(data_flags) :: descsys 
   ! 
   type (c_ptr)       :: cpu_ptr, gpu_ptr
   type (c_devptr)    :: aux_ptr 

   cpu_ptr = c_loc(a) 
#if defined (__CUDA) 
   if (descsys%use_gpu) then 
      aux_ptr = c_devloc ( a_d)
      gpu_ptr = aux_ptr%cptr 
   else 
      gpu_ptr = c_loc(a_d) 
   end if 
#else 
   gpu_ptr= c_loc(a_d) 
#endif
   call init_base(a_manager%base, rank, shape, cpu_ptr, gpu_ptr, descsys ) 
end subroutine init_data_real


subroutine init_data_integer(a_manager, a, a_d, rank, shape, descsys) 
   implicit none 
   integer,target :: a(:)
   integer,target :: a_d(:) 
   type(offloadable_integer),intent(out) :: a_manager 
#if defined(__CUDA) 
   attributes, device :: a_d 
#endif 
   integer :: rank 
   integer :: shape(rank)
   type(data_flags) :: descsys 
   ! 
   type (c_ptr)       :: cpu_ptr, gpu_ptr
   type (c_devptr)    :: aux_ptr 

   cpu_ptr = c_loc(a) 
#if defined (__CUDA) 
   if (descsys%use_gpu) then 
      aux_ptr = c_devloc ( a_d)
      gpu_ptr = aux_ptr%cptr 
   else 
      gpu_ptr = c_loc(a_d) 
   end if 
#else 
   gpu_ptr= c_loc(a_d) 
#endif
   call init_base(a_manager%base, rank, shape, cpu_ptr, gpu_ptr, descsys ) 
end subroutine init_data_integer

subroutine write_complex(a_manager, mode, ptr, descsys) 
   implicit none 
   type(offloadable_complex) :: a_manager 
   complex(dp),pointer       :: ptr(:)    
   character                 :: mode 
   type(data_flags)          :: descsys 
   ! 
   type(c_ptr)               :: aux_cptr 
#if defined(__CUDA)
   type(c_devptr)            :: aux_cdevptr
#endif 
   if ( mode == 'd' .or. mode == 'D') then 
      if (descsys%use_gpu) then 
         a_manager%base%dev_tready = .true. 
         a_manager%base%host_tready = .false. 
#if defined (__CUDA)
         aux_devcptr%cptr  = a_manager%base%gpu_void 
         call c_f_pointer(aux_devcptr, ptr(a_manager%size)) 
#else 
         aux_cptr = a_manager%base%gpu_void  
         call c_f_pointer(aux_cptr, ptr,shape=[a_manager%base%size])  
#endif 
      else
         a_manager%base%dev_tready =.false. 
         a_manager%base%host_tready =.true. 
         aux_cptr = a_manager%base%cpu_void 
         call c_f_pointer(aux_cptr, ptr,shape=[a_manager%base%size]) 
      end if 
   else if ( mode == 'h' .or. mode == 'H')  then 
      a_manager%base%dev_tready = .false. 
      a_manager%base%host_tready = .true. 
      aux_cptr = a_manager%base%cpu_void 
      call c_f_pointer (aux_cptr, ptr, shape=[a_manager%base%size]) 
   end if 
end subroutine write_complex 


subroutine write_complex2d(a_manager, mode, ptr, descsys) 
   implicit none 
   type(offloadable_complex) :: a_manager 
   complex(dp),pointer       :: ptr(:,:)   
   character                 :: mode 
   type(data_flags)          :: descsys 
   ! 
   complex(dp), pointer       :: auxpt(:) 
   type(c_ptr)               :: tempcptr 
   call write_complex(a_manager, mode, auxpt, descsys) 
   tempcptr = c_loc(auxpt) 
   call  c_f_pointer(tempcptr, ptr, a_manager%base%shape) 
end subroutine write_complex2d 
         

subroutine write_complex3d(a_manager, mode, ptr, descsys) 
   implicit none 
   type(offloadable_complex) :: a_manager 
   complex(dp),pointer       :: ptr(:,:,:)   
   character                 :: mode 
   type(data_flags)          :: descsys 
   ! 
   complex(dp), pointer       :: auxpt(:) 
   type(c_ptr)               :: tempcptr 
   call write_complex(a_manager, mode, auxpt, descsys) 
   tempcptr = c_loc(auxpt) 
   call  c_f_pointer(tempcptr, ptr, a_manager%base%shape) 
end subroutine write_complex3d 
 
subroutine write_real(a_manager, mode, ptr, descsys) 
   implicit none 
   type(offloadable_real) :: a_manager 
   real(dp),pointer       :: ptr(:)    
   character                 :: mode 
   type(data_flags)          :: descsys 
   ! 
   type(c_ptr)               :: aux_cptr 
#if defined(__CUDA)
   type(c_devptr)            :: aux_cdevptr
#endif 
   if ( mode == 'd' .or. mode == 'D') then 
      if (descsys%use_gpu) then 
         a_manager%base%dev_tready = .true. 
         a_manager%base%host_tready = .false. 
#if defined (__CUDA)
         aux_devcptr%cptr  = a_manager%base%gpu_void 
         call c_f_pointer(aux_devcptr, ptr(a_manager%size)) 
#else 
         aux_cptr = a_manager%base%gpu_void  
         call c_f_pointer(aux_cptr, ptr,shape=[a_manager%base%size])  
#endif 
      else
         a_manager%base%dev_tready =.false. 
         a_manager%base%host_tready =.true. 
         aux_cptr = a_manager%base%cpu_void 
         call c_f_pointer(aux_cptr, ptr,shape=[a_manager%base%size]) 
      end if 
   else if ( mode == 'h' .or. mode == 'H')  then 
      a_manager%base%dev_tready = .false. 
      a_manager%base%host_tready = .true. 
      aux_cptr = a_manager%base%cpu_void 
      call c_f_pointer (aux_cptr, ptr, shape=[a_manager%base%size]) 
   end if 
end subroutine write_real  

subroutine write_real2d(a_manager, mode, ptr, descsys) 
   implicit none 
   type(offloadable_real) :: a_manager 
   real(dp),pointer          :: ptr(:,:)   
   character                 :: mode 
   type(data_flags)          :: descsys 
   ! 
   real(dp), pointer       :: auxpt(:) 
   type(c_ptr)               :: tempcptr 
   call write_real(a_manager, mode, auxpt, descsys) 
   tempcptr = c_loc(auxpt) 
   call  c_f_pointer(tempcptr, ptr, a_manager%base%shape) 
end subroutine write_real2d 
         

subroutine write_real3d(a_manager, mode, ptr, descsys) 
   implicit none 
   type(offloadable_real) :: a_manager 
   real(dp),pointer       :: ptr(:,:,:)   
   character                 :: mode 
   type(data_flags)          :: descsys 
   ! 
   real(dp), pointer       :: auxpt(:) 
   type(c_ptr)               :: tempcptr 
   call write_real(a_manager, mode, auxpt, descsys) 
   tempcptr = c_loc(auxpt) 
   call  c_f_pointer(tempcptr, ptr, a_manager%base%shape) 
end subroutine write_real3d 
 
subroutine write_integer(a_manager, mode, ptr, descsys) 
   implicit none 
   type(offloadable_integer) :: a_manager 
   integer(dp),pointer       :: ptr(:)    
   character                 :: mode 
   type(data_flags)          :: descsys 
   ! 
   type(c_ptr)               :: aux_cptr 
#if defined(__CUDA)
   type(c_devptr)            :: aux_cdevptr
#endif 
   if ( mode == 'd' .or. mode == 'D') then 
      if (descsys%use_gpu) then 
         a_manager%base%dev_tready = .true. 
         a_manager%base%host_tready = .false. 
#if defined (__CUDA)
         aux_devcptr%cptr  = a_manager%base%gpu_void 
         call c_f_pointer(aux_devcptr, ptr(a_manager%size)) 
#else 
         aux_cptr = a_manager%base%gpu_void  
         call c_f_pointer(aux_cptr, ptr,shape=[a_manager%base%size])  
#endif 
      else
         a_manager%base%dev_tready =.false. 
         a_manager%base%host_tready =.true. 
         aux_cptr = a_manager%base%cpu_void 
         call c_f_pointer(aux_cptr, ptr,shape=[a_manager%base%size]) 
      end if 
   else if ( mode == 'h' .or. mode == 'H')  then 
      a_manager%base%dev_tready = .false. 
      a_manager%base%host_tready = .true. 
      aux_cptr = a_manager%base%cpu_void 
      call c_f_pointer (aux_cptr, ptr, shape=[a_manager%base%size]) 
   end if 
end subroutine write_integer  

subroutine write_integer2d(a_manager, mode, ptr, descsys) 
   implicit none 
   type(offloadable_integer) :: a_manager 
   integer(dp),pointer          :: ptr(:,:)   
   character                 :: mode 
   type(data_flags)          :: descsys 
   ! 
   integer(dp), pointer       :: auxpt(:) 
   type(c_ptr)               :: tempcptr 
   call write_integer(a_manager, mode, auxpt, descsys) 
   tempcptr = c_loc(auxpt) 
   call  c_f_pointer(tempcptr, ptr, a_manager%base%shape) 
end subroutine write_integer2d 
        ! 

subroutine write_integer3d(a_manager, mode, ptr, descsys) 
   implicit none 
   type(offloadable_integer) :: a_manager 
   integer(dp),pointer       :: ptr(:,:,:)   
   character                 :: mode 
   type(data_flags)          :: descsys 
   ! 
   integer(dp), pointer       :: auxpt(:) 
   type(c_ptr)               :: tempcptr 
   call write_integer(a_manager, mode, auxpt, descsys) 
   tempcptr = c_loc(auxpt) 
   call  c_f_pointer(tempcptr, ptr, a_manager%base%shape) 
end subroutine write_integer3d 
 
subroutine read_complex(a_manager, mode, ptr, descsys)  
   implicit none 
   type(offloadable_complex) :: a_manager 
   complex(dp),pointer       :: ptr(:)    
   character(3)              :: mode 
   type(data_flags)          :: descsys 
   ! 
   type(c_ptr)               :: aux_cptr 
   complex(dp),pointer       :: aux_d(:), aux(:)
#if defined(__CUDA)
   type(c_devptr)            :: aux_cdevptr
   attributes, device        :: aux(:) 
#endif 
   call c_f_pointer(a_manager%base%cpu_void, aux,   shape=[a_manager%base%size]) 
   if ( descsys%use_gpu) then 
      call c_f_pointer(a_manager%base%gpu_void, aux_d, shape=[a_manager%base%size])
   else 
      call c_f_pointer(a_manager%base%cpu_void, aux_d, shape=[a_manager%base%size]) 
   end if 
   select case (trim(mode))
      case ('rwd' , 'RWD', 'rwD', 'RWd', 'rod', 'ROD', 'ROd', 'roD') 
         if (.not. a_manager%base%dev_tready)  aux_d = aux 
         ptr => aux_d 
         !!  writeout some info msg about the copy really occurring ?  
         a_manager%base%dev_tready = .true. 
         if ( any(['rwd','RWD','RWd', 'rwD'] == trim(mode))) then 
            a_manager%base%host_tready=.false. 
         else 
            a_manager%base%host_tready = .true. 
         end if 
      case ('rwh', 'RWH', 'rwH', 'RWh', 'roh', 'ROH', 'ROh', 'roH') 
        if (.not. a_manager%base%host_tready) aux = aux_d 
        ptr => aux 
        a_manager%base%host_tready = .true. 
        if ( any(['rwh', 'RWH', 'rwH', 'RWH'] == trim(mode))) then 
           a_manager%base%dev_tready = .false. 
        else 
           a_manager%base%dev_tready = .true. 
        end if 
      case default 
         call dxlib_errore ('associate_read', 'unexpected error, wrong mode argument passed', 2)  
   end select  
end subroutine read_complex    

subroutine read_complex2d(a_manager, mode, ptr, descsys)
   implicit none 
   type(offloadable_complex) :: a_manager 
   complex(dp),pointer       :: ptr(:,:)    
   character(3)              :: mode 
   type(data_flags)          :: descsys 
   ! 
   complex(dp),pointer       :: aux(:) 
   type(c_ptr)               :: aux_cptr
   call read_complex(a_manager, mode, aux, descsys) 
   aux_cptr = c_loc(aux) 
   call c_f_pointer (aux_cptr, ptr, a_manager%base%shape) 
end subroutine read_complex2d 

subroutine read_complex3d(a_manager, mode, ptr, descsys)
   implicit none 
   type(offloadable_complex) :: a_manager 
   complex(dp),pointer       :: ptr(:,:,:)    
   character(3)              :: mode 
   type(data_flags)          :: descsys 
   ! 
   complex(dp),pointer       :: aux(:) 
   type(c_ptr)               :: aux_cptr
   call read_complex(a_manager, mode, aux, descsys) 
   aux_cptr = c_loc(aux) 
   call c_f_pointer (aux_cptr, ptr, a_manager%base%shape) 
end subroutine read_complex3d 

subroutine read_real(a_manager, mode, ptr, descsys)  
   implicit none 
   type(offloadable_real) :: a_manager 
   real(dp),pointer       :: ptr(:)    
   character(3)              :: mode 
   type(data_flags)          :: descsys 
   ! 
   type(c_ptr)               :: aux_cptr 
   real(dp),pointer       :: aux_d(:), aux(:)
#if defined(__CUDA)
   type(c_devptr)            :: aux_cdevptr
   attributes, device        :: aux(:) 
#endif 
   call c_f_pointer(a_manager%base%cpu_void, aux,   shape=[a_manager%base%size]) 
   if ( descsys%use_gpu) then 
      call c_f_pointer(a_manager%base%gpu_void, aux_d, shape=[a_manager%base%size])
   else 
      call c_f_pointer(a_manager%base%cpu_void, aux_d, shape=[a_manager%base%size]) 
   end if 
   select case (trim(mode))
      case ('rwd' , 'RWD', 'rwD', 'RWd', 'rod', 'ROD', 'ROd', 'roD') 
         if (.not. a_manager%base%dev_tready)  aux_d = aux 
         ptr => aux_d 
         !!  writeout some info msg about the copy really occurring ?  
         a_manager%base%dev_tready = .true. 
         if ( any(['rwd','RWD','RWd', 'rwD'] == trim(mode))) then 
            a_manager%base%host_tready=.false. 
         else 
            a_manager%base%host_tready = .true. 
         end if 
      case ('rwh', 'RWH', 'rwH', 'RWh', 'roh', 'ROH', 'ROh', 'roH') 
        if (.not. a_manager%base%host_tready) aux = aux_d 
        ptr => aux
        a_manager%base%host_tready = .true. 
        if ( any(['rwh', 'RWH', 'rwH', 'RWH'] == trim(mode))) then 
           a_manager%base%dev_tready = .false. 
        else 
           a_manager%base%dev_tready = .true. 
        end if 
      case default 
         call dxlib_errore ('associate_read', 'unexpected error, wrong mode argument passed', 2)  
   end select  
end subroutine read_real    

subroutine read_real2d(a_manager, mode, ptr, descsys)
   implicit none 
   type(offloadable_real) :: a_manager 
   real(dp),pointer       :: ptr(:,:)    
   character(3)              :: mode 
   type(data_flags)          :: descsys 
   ! 
   real(dp),pointer       :: aux(:) 
   type(c_ptr)            :: aux_cptr 
   call read_real(a_manager, mode, aux, descsys) 
   aux_cptr = c_loc(aux) 
   call c_f_pointer (aux_cptr, ptr, a_manager%base%shape) 
end subroutine read_real2d 

subroutine read_real3d(a_manager, mode, ptr, descsys)
   implicit none 
   type(offloadable_real) :: a_manager 
   real(dp),pointer       :: ptr(:,:,:)    
   character(3)              :: mode 
   type(data_flags)          :: descsys 
   ! 
   real(dp),pointer       :: aux(:) 
   type(c_ptr)            :: aux_cptr
   call read_real(a_manager, mode, aux, descsys) 
   aux_cptr = c_loc(aux) 
   call c_f_pointer (aux_cptr, ptr, a_manager%base%shape) 
end subroutine read_real3d 

subroutine read_integer(a_manager, mode, ptr, descsys)  
   implicit none 
   type(offloadable_integer) :: a_manager 
   integer, pointer       :: ptr(:)    
   character(3)              :: mode 
   type(data_flags)          :: descsys 
   ! 
   type(c_ptr)               :: aux_cptr 
   integer, pointer       :: aux_d(:), aux(:)
#if defined(__CUDA)
   type(c_devptr)            :: aux_cdevptr
   attributes, device        :: aux(:) 
#endif 
   call c_f_pointer(a_manager%base%cpu_void, aux,   shape=[a_manager%base%size]) 
   if ( descsys%use_gpu) then 
      call c_f_pointer(a_manager%base%gpu_void, aux_d, shape=[a_manager%base%size])
   else 
      call c_f_pointer(a_manager%base%cpu_void, aux_d, shape=[a_manager%base%size]) 
   end if 
   select case (trim(mode))
      case ('rwd' , 'RWD', 'rwD', 'RWd', 'rod', 'ROD', 'ROd', 'roD') 
         if (.not. a_manager%base%dev_tready)  aux_d = aux 
         ptr => aux_d 
         !!  writeout some info msg about the copy really occurring ?  
         a_manager%base%dev_tready = .true. 
         if ( any(['rwd','RWD','RWd', 'rwD'] == trim(mode))) then 
            a_manager%base%host_tready=.false. 
         else 
            a_manager%base%host_tready = .true. 
         end if 
      case ('rwh', 'RWH', 'rwH', 'RWh', 'roh', 'ROH', 'ROh', 'roH') 
        if (.not. a_manager%base%host_tready) aux = aux_d 
        ptr => aux 
        a_manager%base%host_tready = .true. 
        if ( any(['rwh', 'RWH', 'rwH', 'RWH'] == trim(mode))) then 
           a_manager%base%dev_tready = .false. 
        else 
           a_manager%base%dev_tready = .true. 
        end if 
      case default 
         call dxlib_errore ('associate_read', 'unexpected error, wrong mode argument passed', 2)  
   end select  
end subroutine read_integer    

subroutine read_integer2d(a_manager, mode, ptr, descsys)
   implicit none 
   type(offloadable_integer) :: a_manager 
   integer, pointer       :: ptr(:,:)    
   character(3)              :: mode 
   type(data_flags)          :: descsys 
   ! 
   integer, pointer       :: aux(:) 
   type(c_ptr)            :: aux_cptr
   call read_integer(a_manager, mode, aux, descsys) 
   aux_cptr = c_loc(aux) 
   call c_f_pointer (aux_cptr, ptr, a_manager%base%shape) 
end subroutine read_integer2d 

subroutine read_integer3d(a_manager, mode, ptr, descsys)
   implicit none 
   type(offloadable_integer) :: a_manager 
   integer, pointer       :: ptr(:,:,:)    
   character(3)              :: mode 
   type(data_flags)          :: descsys 
   ! 
   integer, pointer       :: aux(:) 
   type(c_ptr)            :: aux_cptr
   call read_integer(a_manager, mode, aux, descsys) 
   aux_cptr = c_loc(aux) 
   call c_f_pointer (aux_cptr, ptr, a_manager%base%shape) 
end subroutine read_integer3d 




end module offloadable 

MODULE roctx
  USE ISO_C_BINDING,   ONLY : c_char, c_null_char
  IMPLICIT NONE
  character(len=256),private :: tempName
  INTEGER :: ret

#if defined(__PROFILE_ROCTX)
 INTERFACE
     SUBROUTINE roctxMarkA(message) BIND(c, name="roctxMarkA")
       USE ISO_C_BINDING,   ONLY : C_CHAR
       IMPLICIT NONE
       CHARACTER(C_CHAR) :: message(*)
     END SUBROUTINE roctxMarkA

     FUNCTION roctxRangePushA(message) BIND(c, name="roctxRangePushA")
       USE ISO_C_BINDING,   ONLY: C_INT,C_CHAR
       IMPLICIT NONE
       INTEGER(C_INT) :: roctxRangePushA
       CHARACTER(C_CHAR) :: message(*)
     END FUNCTION roctxRangePushA

     SUBROUTINE roctxRangePop() BIND(c, name="roctxRangePop")
       IMPLICIT NONE
     END SUBROUTINE roctxRangePop
 END INTERFACE
#endif

 CONTAINS

      SUBROUTINE roctxStartRange(name)
         character(kind=c_char,len=*) :: name

#if defined(__PROFILE_ROCTX)
         tempName=trim(name)//c_null_char
         ret = roctxRangePushA(tempname)
#endif
      END SUBROUTINE

      SUBROUTINE roctxEndRange()
#if defined(__PROFILE_ROCTX)
         CALL roctxRangePop()
#endif
      END SUBROUTINE

END MODULE roctx

module CUDA
  use cuda_h
  use cuda_runtime_h

contains

  subroutine my_cudaErrorCheck( err, b )
    integer (KIND(cudaSuccess)), intent(in) :: err

    character, pointer :: string_err(:)
    integer :: i
    logical :: b

    print *, 'checking ...', err
    b = .false.
    if ( err /= cudaSuccess ) then
       print *, 'Error found'
       call C_F_POINTER( cudaGetErrorString( err ), string_err, [1] )
       i = 1
       do while ( string_err( i ) /= C_NULL_CHAR )
          i = i + 1
       enddo

       print *, 'CUDA Error Detected'
       print *, string_err( 1:i )
       b = .true.
    endif

  end subroutine my_cudaErrorCheck

end module

!
! Copyright (C) 2022, MaX CoE
! Distributed under the MIT License 
! (license terms are at http://opensource.org/licenses/MIT).
!
!--
!
!
! Utility functions to perform sync and async host-host memcpy
! using CUDA-Fortran, OpenACC or OpenMP Offload
!
!==================================================================
!==================================================================
! *DO NOT EDIT*: automatically generated from device_memcpy_h2h.jf90
!==================================================================
!==================================================================
!
#include<devxlib_macros.h>
#include<devxlib_defs.h>
!
!=======================================
!
! Note about dimensions:
! The lower bound of the assumed shape array passed to the subroutine is 1
! lbound and range instead refer to the indexing in the parent caller.
!
submodule (devxlib_memcpy) devxlib_memcpy_h2h

   implicit none

   contains
      module subroutine sp_devxlib_memcpy_h2h_r1d(array_out, array_in, &
                                                  range1, lbound1 )
         implicit none
         !
         real(real32), intent(inout) :: array_out(:)
         real(real32), intent(in)    :: array_in(:)
         integer, optional, intent(in) ::  range1(2)
         integer, optional, intent(in) ::  lbound1
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         do i1 = d1s, d1e
            array_out(i1 ) = array_in(i1 )
         enddo
         !
      end subroutine sp_devxlib_memcpy_h2h_r1d
!
      module subroutine sp_devxlib_memcpy_h2h_r2d(array_out, array_in, &
                                                  range1, lbound1, &
                                                  range2, lbound2 )
         implicit none
         !
         real(real32), intent(inout) :: array_out(:,:)
         real(real32), intent(in)    :: array_in(:,:)
         integer, optional, intent(in) ::  range1(2), range2(2)
         integer, optional, intent(in) ::  lbound1, lbound2
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2 ) = array_in(i1,i2 )
         enddo
         enddo
         !
      end subroutine sp_devxlib_memcpy_h2h_r2d
!
      module subroutine sp_devxlib_memcpy_h2h_r3d(array_out, array_in, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3 )
         implicit none
         !
         real(real32), intent(inout) :: array_out(:,:,:)
         real(real32), intent(in)    :: array_in(:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3 ) = array_in(i1,i2,i3 )
         enddo
         enddo
         enddo
         !
      end subroutine sp_devxlib_memcpy_h2h_r3d
!
      module subroutine sp_devxlib_memcpy_h2h_r4d(array_out, array_in, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3, &
                                                  range4, lbound4 )
         implicit none
         !
         real(real32), intent(inout) :: array_out(:,:,:,:)
         real(real32), intent(in)    :: array_in(:,:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(array_out, 4)/)
         if (present(range4)) range4_=range4 
         !
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         do i4 = d4s, d4e
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3,i4 ) = array_in(i1,i2,i3,i4 )
         enddo
         enddo
         enddo
         enddo
         !
      end subroutine sp_devxlib_memcpy_h2h_r4d
!
      module subroutine sp_devxlib_memcpy_h2h_r5d(array_out, array_in, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3, &
                                                  range4, lbound4, &
                                                  range5, lbound5 )
         implicit none
         !
         real(real32), intent(inout) :: array_out(:,:,:,:,:)
         real(real32), intent(in)    :: array_in(:,:,:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         integer :: i5, d5s, d5e
         integer :: lbound5_, range5_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(array_out, 4)/)
         if (present(range4)) range4_=range4 
         !
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         lbound5_=1
         if (present(lbound5)) lbound5_=lbound5 
         range5_=(/1,size(array_out, 5)/)
         if (present(range5)) range5_=range5 
         !
         d5s = range5_(1) -lbound5_ +1
         d5e = range5_(2) -lbound5_ +1
         !
         do i5 = d5s, d5e
         do i4 = d4s, d4e
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3,i4,i5 ) = array_in(i1,i2,i3,i4,i5 )
         enddo
         enddo
         enddo
         enddo
         enddo
         !
      end subroutine sp_devxlib_memcpy_h2h_r5d
!
      module subroutine sp_devxlib_memcpy_h2h_r6d(array_out, array_in, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3, &
                                                  range4, lbound4, &
                                                  range5, lbound5, &
                                                  range6, lbound6 )
         implicit none
         !
         real(real32), intent(inout) :: array_out(:,:,:,:,:,:)
         real(real32), intent(in)    :: array_in(:,:,:,:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2), range6(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5, lbound6
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         integer :: i5, d5s, d5e
         integer :: lbound5_, range5_(2)
         integer :: i6, d6s, d6e
         integer :: lbound6_, range6_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(array_out, 4)/)
         if (present(range4)) range4_=range4 
         !
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         lbound5_=1
         if (present(lbound5)) lbound5_=lbound5 
         range5_=(/1,size(array_out, 5)/)
         if (present(range5)) range5_=range5 
         !
         d5s = range5_(1) -lbound5_ +1
         d5e = range5_(2) -lbound5_ +1
         !
         lbound6_=1
         if (present(lbound6)) lbound6_=lbound6 
         range6_=(/1,size(array_out, 6)/)
         if (present(range6)) range6_=range6 
         !
         d6s = range6_(1) -lbound6_ +1
         d6e = range6_(2) -lbound6_ +1
         !
         do i6 = d6s, d6e
         do i5 = d5s, d5e
         do i4 = d4s, d4e
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3,i4,i5,i6 ) = array_in(i1,i2,i3,i4,i5,i6 )
         enddo
         enddo
         enddo
         enddo
         enddo
         enddo
         !
      end subroutine sp_devxlib_memcpy_h2h_r6d
!
      module subroutine dp_devxlib_memcpy_h2h_r1d(array_out, array_in, &
                                                  range1, lbound1 )
         implicit none
         !
         real(real64), intent(inout) :: array_out(:)
         real(real64), intent(in)    :: array_in(:)
         integer, optional, intent(in) ::  range1(2)
         integer, optional, intent(in) ::  lbound1
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         do i1 = d1s, d1e
            array_out(i1 ) = array_in(i1 )
         enddo
         !
      end subroutine dp_devxlib_memcpy_h2h_r1d
!
      module subroutine dp_devxlib_memcpy_h2h_r2d(array_out, array_in, &
                                                  range1, lbound1, &
                                                  range2, lbound2 )
         implicit none
         !
         real(real64), intent(inout) :: array_out(:,:)
         real(real64), intent(in)    :: array_in(:,:)
         integer, optional, intent(in) ::  range1(2), range2(2)
         integer, optional, intent(in) ::  lbound1, lbound2
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2 ) = array_in(i1,i2 )
         enddo
         enddo
         !
      end subroutine dp_devxlib_memcpy_h2h_r2d
!
      module subroutine dp_devxlib_memcpy_h2h_r3d(array_out, array_in, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3 )
         implicit none
         !
         real(real64), intent(inout) :: array_out(:,:,:)
         real(real64), intent(in)    :: array_in(:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3 ) = array_in(i1,i2,i3 )
         enddo
         enddo
         enddo
         !
      end subroutine dp_devxlib_memcpy_h2h_r3d
!
      module subroutine dp_devxlib_memcpy_h2h_r4d(array_out, array_in, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3, &
                                                  range4, lbound4 )
         implicit none
         !
         real(real64), intent(inout) :: array_out(:,:,:,:)
         real(real64), intent(in)    :: array_in(:,:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(array_out, 4)/)
         if (present(range4)) range4_=range4 
         !
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         do i4 = d4s, d4e
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3,i4 ) = array_in(i1,i2,i3,i4 )
         enddo
         enddo
         enddo
         enddo
         !
      end subroutine dp_devxlib_memcpy_h2h_r4d
!
      module subroutine dp_devxlib_memcpy_h2h_r5d(array_out, array_in, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3, &
                                                  range4, lbound4, &
                                                  range5, lbound5 )
         implicit none
         !
         real(real64), intent(inout) :: array_out(:,:,:,:,:)
         real(real64), intent(in)    :: array_in(:,:,:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         integer :: i5, d5s, d5e
         integer :: lbound5_, range5_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(array_out, 4)/)
         if (present(range4)) range4_=range4 
         !
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         lbound5_=1
         if (present(lbound5)) lbound5_=lbound5 
         range5_=(/1,size(array_out, 5)/)
         if (present(range5)) range5_=range5 
         !
         d5s = range5_(1) -lbound5_ +1
         d5e = range5_(2) -lbound5_ +1
         !
         do i5 = d5s, d5e
         do i4 = d4s, d4e
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3,i4,i5 ) = array_in(i1,i2,i3,i4,i5 )
         enddo
         enddo
         enddo
         enddo
         enddo
         !
      end subroutine dp_devxlib_memcpy_h2h_r5d
!
      module subroutine dp_devxlib_memcpy_h2h_r6d(array_out, array_in, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3, &
                                                  range4, lbound4, &
                                                  range5, lbound5, &
                                                  range6, lbound6 )
         implicit none
         !
         real(real64), intent(inout) :: array_out(:,:,:,:,:,:)
         real(real64), intent(in)    :: array_in(:,:,:,:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2), range6(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5, lbound6
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         integer :: i5, d5s, d5e
         integer :: lbound5_, range5_(2)
         integer :: i6, d6s, d6e
         integer :: lbound6_, range6_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(array_out, 4)/)
         if (present(range4)) range4_=range4 
         !
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         lbound5_=1
         if (present(lbound5)) lbound5_=lbound5 
         range5_=(/1,size(array_out, 5)/)
         if (present(range5)) range5_=range5 
         !
         d5s = range5_(1) -lbound5_ +1
         d5e = range5_(2) -lbound5_ +1
         !
         lbound6_=1
         if (present(lbound6)) lbound6_=lbound6 
         range6_=(/1,size(array_out, 6)/)
         if (present(range6)) range6_=range6 
         !
         d6s = range6_(1) -lbound6_ +1
         d6e = range6_(2) -lbound6_ +1
         !
         do i6 = d6s, d6e
         do i5 = d5s, d5e
         do i4 = d4s, d4e
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3,i4,i5,i6 ) = array_in(i1,i2,i3,i4,i5,i6 )
         enddo
         enddo
         enddo
         enddo
         enddo
         enddo
         !
      end subroutine dp_devxlib_memcpy_h2h_r6d
!
      module subroutine sp_devxlib_memcpy_h2h_c1d(array_out, array_in, &
                                                  range1, lbound1 )
         implicit none
         !
         complex(real32), intent(inout) :: array_out(:)
         complex(real32), intent(in)    :: array_in(:)
         integer, optional, intent(in) ::  range1(2)
         integer, optional, intent(in) ::  lbound1
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         do i1 = d1s, d1e
            array_out(i1 ) = array_in(i1 )
         enddo
         !
      end subroutine sp_devxlib_memcpy_h2h_c1d
!
      module subroutine sp_devxlib_memcpy_h2h_c2d(array_out, array_in, &
                                                  range1, lbound1, &
                                                  range2, lbound2 )
         implicit none
         !
         complex(real32), intent(inout) :: array_out(:,:)
         complex(real32), intent(in)    :: array_in(:,:)
         integer, optional, intent(in) ::  range1(2), range2(2)
         integer, optional, intent(in) ::  lbound1, lbound2
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2 ) = array_in(i1,i2 )
         enddo
         enddo
         !
      end subroutine sp_devxlib_memcpy_h2h_c2d
!
      module subroutine sp_devxlib_memcpy_h2h_c3d(array_out, array_in, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3 )
         implicit none
         !
         complex(real32), intent(inout) :: array_out(:,:,:)
         complex(real32), intent(in)    :: array_in(:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3 ) = array_in(i1,i2,i3 )
         enddo
         enddo
         enddo
         !
      end subroutine sp_devxlib_memcpy_h2h_c3d
!
      module subroutine sp_devxlib_memcpy_h2h_c4d(array_out, array_in, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3, &
                                                  range4, lbound4 )
         implicit none
         !
         complex(real32), intent(inout) :: array_out(:,:,:,:)
         complex(real32), intent(in)    :: array_in(:,:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(array_out, 4)/)
         if (present(range4)) range4_=range4 
         !
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         do i4 = d4s, d4e
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3,i4 ) = array_in(i1,i2,i3,i4 )
         enddo
         enddo
         enddo
         enddo
         !
      end subroutine sp_devxlib_memcpy_h2h_c4d
!
      module subroutine sp_devxlib_memcpy_h2h_c5d(array_out, array_in, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3, &
                                                  range4, lbound4, &
                                                  range5, lbound5 )
         implicit none
         !
         complex(real32), intent(inout) :: array_out(:,:,:,:,:)
         complex(real32), intent(in)    :: array_in(:,:,:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         integer :: i5, d5s, d5e
         integer :: lbound5_, range5_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(array_out, 4)/)
         if (present(range4)) range4_=range4 
         !
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         lbound5_=1
         if (present(lbound5)) lbound5_=lbound5 
         range5_=(/1,size(array_out, 5)/)
         if (present(range5)) range5_=range5 
         !
         d5s = range5_(1) -lbound5_ +1
         d5e = range5_(2) -lbound5_ +1
         !
         do i5 = d5s, d5e
         do i4 = d4s, d4e
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3,i4,i5 ) = array_in(i1,i2,i3,i4,i5 )
         enddo
         enddo
         enddo
         enddo
         enddo
         !
      end subroutine sp_devxlib_memcpy_h2h_c5d
!
      module subroutine sp_devxlib_memcpy_h2h_c6d(array_out, array_in, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3, &
                                                  range4, lbound4, &
                                                  range5, lbound5, &
                                                  range6, lbound6 )
         implicit none
         !
         complex(real32), intent(inout) :: array_out(:,:,:,:,:,:)
         complex(real32), intent(in)    :: array_in(:,:,:,:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2), range6(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5, lbound6
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         integer :: i5, d5s, d5e
         integer :: lbound5_, range5_(2)
         integer :: i6, d6s, d6e
         integer :: lbound6_, range6_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(array_out, 4)/)
         if (present(range4)) range4_=range4 
         !
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         lbound5_=1
         if (present(lbound5)) lbound5_=lbound5 
         range5_=(/1,size(array_out, 5)/)
         if (present(range5)) range5_=range5 
         !
         d5s = range5_(1) -lbound5_ +1
         d5e = range5_(2) -lbound5_ +1
         !
         lbound6_=1
         if (present(lbound6)) lbound6_=lbound6 
         range6_=(/1,size(array_out, 6)/)
         if (present(range6)) range6_=range6 
         !
         d6s = range6_(1) -lbound6_ +1
         d6e = range6_(2) -lbound6_ +1
         !
         do i6 = d6s, d6e
         do i5 = d5s, d5e
         do i4 = d4s, d4e
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3,i4,i5,i6 ) = array_in(i1,i2,i3,i4,i5,i6 )
         enddo
         enddo
         enddo
         enddo
         enddo
         enddo
         !
      end subroutine sp_devxlib_memcpy_h2h_c6d
!
      module subroutine dp_devxlib_memcpy_h2h_c1d(array_out, array_in, &
                                                  range1, lbound1 )
         implicit none
         !
         complex(real64), intent(inout) :: array_out(:)
         complex(real64), intent(in)    :: array_in(:)
         integer, optional, intent(in) ::  range1(2)
         integer, optional, intent(in) ::  lbound1
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         do i1 = d1s, d1e
            array_out(i1 ) = array_in(i1 )
         enddo
         !
      end subroutine dp_devxlib_memcpy_h2h_c1d
!
      module subroutine dp_devxlib_memcpy_h2h_c2d(array_out, array_in, &
                                                  range1, lbound1, &
                                                  range2, lbound2 )
         implicit none
         !
         complex(real64), intent(inout) :: array_out(:,:)
         complex(real64), intent(in)    :: array_in(:,:)
         integer, optional, intent(in) ::  range1(2), range2(2)
         integer, optional, intent(in) ::  lbound1, lbound2
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2 ) = array_in(i1,i2 )
         enddo
         enddo
         !
      end subroutine dp_devxlib_memcpy_h2h_c2d
!
      module subroutine dp_devxlib_memcpy_h2h_c3d(array_out, array_in, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3 )
         implicit none
         !
         complex(real64), intent(inout) :: array_out(:,:,:)
         complex(real64), intent(in)    :: array_in(:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3 ) = array_in(i1,i2,i3 )
         enddo
         enddo
         enddo
         !
      end subroutine dp_devxlib_memcpy_h2h_c3d
!
      module subroutine dp_devxlib_memcpy_h2h_c4d(array_out, array_in, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3, &
                                                  range4, lbound4 )
         implicit none
         !
         complex(real64), intent(inout) :: array_out(:,:,:,:)
         complex(real64), intent(in)    :: array_in(:,:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(array_out, 4)/)
         if (present(range4)) range4_=range4 
         !
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         do i4 = d4s, d4e
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3,i4 ) = array_in(i1,i2,i3,i4 )
         enddo
         enddo
         enddo
         enddo
         !
      end subroutine dp_devxlib_memcpy_h2h_c4d
!
      module subroutine dp_devxlib_memcpy_h2h_c5d(array_out, array_in, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3, &
                                                  range4, lbound4, &
                                                  range5, lbound5 )
         implicit none
         !
         complex(real64), intent(inout) :: array_out(:,:,:,:,:)
         complex(real64), intent(in)    :: array_in(:,:,:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         integer :: i5, d5s, d5e
         integer :: lbound5_, range5_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(array_out, 4)/)
         if (present(range4)) range4_=range4 
         !
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         lbound5_=1
         if (present(lbound5)) lbound5_=lbound5 
         range5_=(/1,size(array_out, 5)/)
         if (present(range5)) range5_=range5 
         !
         d5s = range5_(1) -lbound5_ +1
         d5e = range5_(2) -lbound5_ +1
         !
         do i5 = d5s, d5e
         do i4 = d4s, d4e
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3,i4,i5 ) = array_in(i1,i2,i3,i4,i5 )
         enddo
         enddo
         enddo
         enddo
         enddo
         !
      end subroutine dp_devxlib_memcpy_h2h_c5d
!
      module subroutine dp_devxlib_memcpy_h2h_c6d(array_out, array_in, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3, &
                                                  range4, lbound4, &
                                                  range5, lbound5, &
                                                  range6, lbound6 )
         implicit none
         !
         complex(real64), intent(inout) :: array_out(:,:,:,:,:,:)
         complex(real64), intent(in)    :: array_in(:,:,:,:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2), range6(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5, lbound6
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         integer :: i5, d5s, d5e
         integer :: lbound5_, range5_(2)
         integer :: i6, d6s, d6e
         integer :: lbound6_, range6_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(array_out, 4)/)
         if (present(range4)) range4_=range4 
         !
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         lbound5_=1
         if (present(lbound5)) lbound5_=lbound5 
         range5_=(/1,size(array_out, 5)/)
         if (present(range5)) range5_=range5 
         !
         d5s = range5_(1) -lbound5_ +1
         d5e = range5_(2) -lbound5_ +1
         !
         lbound6_=1
         if (present(lbound6)) lbound6_=lbound6 
         range6_=(/1,size(array_out, 6)/)
         if (present(range6)) range6_=range6 
         !
         d6s = range6_(1) -lbound6_ +1
         d6e = range6_(2) -lbound6_ +1
         !
         do i6 = d6s, d6e
         do i5 = d5s, d5e
         do i4 = d4s, d4e
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3,i4,i5,i6 ) = array_in(i1,i2,i3,i4,i5,i6 )
         enddo
         enddo
         enddo
         enddo
         enddo
         enddo
         !
      end subroutine dp_devxlib_memcpy_h2h_c6d
!
      module subroutine i4_devxlib_memcpy_h2h_i1d(array_out, array_in, &
                                                  range1, lbound1 )
         implicit none
         !
         integer(int32), intent(inout) :: array_out(:)
         integer(int32), intent(in)    :: array_in(:)
         integer, optional, intent(in) ::  range1(2)
         integer, optional, intent(in) ::  lbound1
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         do i1 = d1s, d1e
            array_out(i1 ) = array_in(i1 )
         enddo
         !
      end subroutine i4_devxlib_memcpy_h2h_i1d
!
      module subroutine i4_devxlib_memcpy_h2h_i2d(array_out, array_in, &
                                                  range1, lbound1, &
                                                  range2, lbound2 )
         implicit none
         !
         integer(int32), intent(inout) :: array_out(:,:)
         integer(int32), intent(in)    :: array_in(:,:)
         integer, optional, intent(in) ::  range1(2), range2(2)
         integer, optional, intent(in) ::  lbound1, lbound2
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2 ) = array_in(i1,i2 )
         enddo
         enddo
         !
      end subroutine i4_devxlib_memcpy_h2h_i2d
!
      module subroutine i4_devxlib_memcpy_h2h_i3d(array_out, array_in, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3 )
         implicit none
         !
         integer(int32), intent(inout) :: array_out(:,:,:)
         integer(int32), intent(in)    :: array_in(:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3 ) = array_in(i1,i2,i3 )
         enddo
         enddo
         enddo
         !
      end subroutine i4_devxlib_memcpy_h2h_i3d
!
      module subroutine i4_devxlib_memcpy_h2h_i4d(array_out, array_in, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3, &
                                                  range4, lbound4 )
         implicit none
         !
         integer(int32), intent(inout) :: array_out(:,:,:,:)
         integer(int32), intent(in)    :: array_in(:,:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(array_out, 4)/)
         if (present(range4)) range4_=range4 
         !
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         do i4 = d4s, d4e
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3,i4 ) = array_in(i1,i2,i3,i4 )
         enddo
         enddo
         enddo
         enddo
         !
      end subroutine i4_devxlib_memcpy_h2h_i4d
!
      module subroutine i4_devxlib_memcpy_h2h_i5d(array_out, array_in, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3, &
                                                  range4, lbound4, &
                                                  range5, lbound5 )
         implicit none
         !
         integer(int32), intent(inout) :: array_out(:,:,:,:,:)
         integer(int32), intent(in)    :: array_in(:,:,:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         integer :: i5, d5s, d5e
         integer :: lbound5_, range5_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(array_out, 4)/)
         if (present(range4)) range4_=range4 
         !
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         lbound5_=1
         if (present(lbound5)) lbound5_=lbound5 
         range5_=(/1,size(array_out, 5)/)
         if (present(range5)) range5_=range5 
         !
         d5s = range5_(1) -lbound5_ +1
         d5e = range5_(2) -lbound5_ +1
         !
         do i5 = d5s, d5e
         do i4 = d4s, d4e
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3,i4,i5 ) = array_in(i1,i2,i3,i4,i5 )
         enddo
         enddo
         enddo
         enddo
         enddo
         !
      end subroutine i4_devxlib_memcpy_h2h_i5d
!
      module subroutine i4_devxlib_memcpy_h2h_i6d(array_out, array_in, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3, &
                                                  range4, lbound4, &
                                                  range5, lbound5, &
                                                  range6, lbound6 )
         implicit none
         !
         integer(int32), intent(inout) :: array_out(:,:,:,:,:,:)
         integer(int32), intent(in)    :: array_in(:,:,:,:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2), range6(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5, lbound6
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         integer :: i5, d5s, d5e
         integer :: lbound5_, range5_(2)
         integer :: i6, d6s, d6e
         integer :: lbound6_, range6_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(array_out, 4)/)
         if (present(range4)) range4_=range4 
         !
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         lbound5_=1
         if (present(lbound5)) lbound5_=lbound5 
         range5_=(/1,size(array_out, 5)/)
         if (present(range5)) range5_=range5 
         !
         d5s = range5_(1) -lbound5_ +1
         d5e = range5_(2) -lbound5_ +1
         !
         lbound6_=1
         if (present(lbound6)) lbound6_=lbound6 
         range6_=(/1,size(array_out, 6)/)
         if (present(range6)) range6_=range6 
         !
         d6s = range6_(1) -lbound6_ +1
         d6e = range6_(2) -lbound6_ +1
         !
         do i6 = d6s, d6e
         do i5 = d5s, d5e
         do i4 = d4s, d4e
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3,i4,i5,i6 ) = array_in(i1,i2,i3,i4,i5,i6 )
         enddo
         enddo
         enddo
         enddo
         enddo
         enddo
         !
      end subroutine i4_devxlib_memcpy_h2h_i6d
!
      module subroutine i8_devxlib_memcpy_h2h_i1d(array_out, array_in, &
                                                  range1, lbound1 )
         implicit none
         !
         integer(int64), intent(inout) :: array_out(:)
         integer(int64), intent(in)    :: array_in(:)
         integer, optional, intent(in) ::  range1(2)
         integer, optional, intent(in) ::  lbound1
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         do i1 = d1s, d1e
            array_out(i1 ) = array_in(i1 )
         enddo
         !
      end subroutine i8_devxlib_memcpy_h2h_i1d
!
      module subroutine i8_devxlib_memcpy_h2h_i2d(array_out, array_in, &
                                                  range1, lbound1, &
                                                  range2, lbound2 )
         implicit none
         !
         integer(int64), intent(inout) :: array_out(:,:)
         integer(int64), intent(in)    :: array_in(:,:)
         integer, optional, intent(in) ::  range1(2), range2(2)
         integer, optional, intent(in) ::  lbound1, lbound2
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2 ) = array_in(i1,i2 )
         enddo
         enddo
         !
      end subroutine i8_devxlib_memcpy_h2h_i2d
!
      module subroutine i8_devxlib_memcpy_h2h_i3d(array_out, array_in, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3 )
         implicit none
         !
         integer(int64), intent(inout) :: array_out(:,:,:)
         integer(int64), intent(in)    :: array_in(:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3 ) = array_in(i1,i2,i3 )
         enddo
         enddo
         enddo
         !
      end subroutine i8_devxlib_memcpy_h2h_i3d
!
      module subroutine i8_devxlib_memcpy_h2h_i4d(array_out, array_in, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3, &
                                                  range4, lbound4 )
         implicit none
         !
         integer(int64), intent(inout) :: array_out(:,:,:,:)
         integer(int64), intent(in)    :: array_in(:,:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(array_out, 4)/)
         if (present(range4)) range4_=range4 
         !
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         do i4 = d4s, d4e
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3,i4 ) = array_in(i1,i2,i3,i4 )
         enddo
         enddo
         enddo
         enddo
         !
      end subroutine i8_devxlib_memcpy_h2h_i4d
!
      module subroutine i8_devxlib_memcpy_h2h_i5d(array_out, array_in, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3, &
                                                  range4, lbound4, &
                                                  range5, lbound5 )
         implicit none
         !
         integer(int64), intent(inout) :: array_out(:,:,:,:,:)
         integer(int64), intent(in)    :: array_in(:,:,:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         integer :: i5, d5s, d5e
         integer :: lbound5_, range5_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(array_out, 4)/)
         if (present(range4)) range4_=range4 
         !
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         lbound5_=1
         if (present(lbound5)) lbound5_=lbound5 
         range5_=(/1,size(array_out, 5)/)
         if (present(range5)) range5_=range5 
         !
         d5s = range5_(1) -lbound5_ +1
         d5e = range5_(2) -lbound5_ +1
         !
         do i5 = d5s, d5e
         do i4 = d4s, d4e
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3,i4,i5 ) = array_in(i1,i2,i3,i4,i5 )
         enddo
         enddo
         enddo
         enddo
         enddo
         !
      end subroutine i8_devxlib_memcpy_h2h_i5d
!
      module subroutine i8_devxlib_memcpy_h2h_i6d(array_out, array_in, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3, &
                                                  range4, lbound4, &
                                                  range5, lbound5, &
                                                  range6, lbound6 )
         implicit none
         !
         integer(int64), intent(inout) :: array_out(:,:,:,:,:,:)
         integer(int64), intent(in)    :: array_in(:,:,:,:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2), range6(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5, lbound6
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         integer :: i5, d5s, d5e
         integer :: lbound5_, range5_(2)
         integer :: i6, d6s, d6e
         integer :: lbound6_, range6_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(array_out, 4)/)
         if (present(range4)) range4_=range4 
         !
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         lbound5_=1
         if (present(lbound5)) lbound5_=lbound5 
         range5_=(/1,size(array_out, 5)/)
         if (present(range5)) range5_=range5 
         !
         d5s = range5_(1) -lbound5_ +1
         d5e = range5_(2) -lbound5_ +1
         !
         lbound6_=1
         if (present(lbound6)) lbound6_=lbound6 
         range6_=(/1,size(array_out, 6)/)
         if (present(range6)) range6_=range6 
         !
         d6s = range6_(1) -lbound6_ +1
         d6e = range6_(2) -lbound6_ +1
         !
         do i6 = d6s, d6e
         do i5 = d5s, d5e
         do i4 = d4s, d4e
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3,i4,i5,i6 ) = array_in(i1,i2,i3,i4,i5,i6 )
         enddo
         enddo
         enddo
         enddo
         enddo
         enddo
         !
      end subroutine i8_devxlib_memcpy_h2h_i6d
!
      module subroutine l4_devxlib_memcpy_h2h_l1d(array_out, array_in, &
                                                  range1, lbound1 )
         implicit none
         !
         logical(int32), intent(inout) :: array_out(:)
         logical(int32), intent(in)    :: array_in(:)
         integer, optional, intent(in) ::  range1(2)
         integer, optional, intent(in) ::  lbound1
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         do i1 = d1s, d1e
            array_out(i1 ) = array_in(i1 )
         enddo
         !
      end subroutine l4_devxlib_memcpy_h2h_l1d
!
      module subroutine l4_devxlib_memcpy_h2h_l2d(array_out, array_in, &
                                                  range1, lbound1, &
                                                  range2, lbound2 )
         implicit none
         !
         logical(int32), intent(inout) :: array_out(:,:)
         logical(int32), intent(in)    :: array_in(:,:)
         integer, optional, intent(in) ::  range1(2), range2(2)
         integer, optional, intent(in) ::  lbound1, lbound2
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2 ) = array_in(i1,i2 )
         enddo
         enddo
         !
      end subroutine l4_devxlib_memcpy_h2h_l2d
!
      module subroutine l4_devxlib_memcpy_h2h_l3d(array_out, array_in, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3 )
         implicit none
         !
         logical(int32), intent(inout) :: array_out(:,:,:)
         logical(int32), intent(in)    :: array_in(:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3 ) = array_in(i1,i2,i3 )
         enddo
         enddo
         enddo
         !
      end subroutine l4_devxlib_memcpy_h2h_l3d
!
      module subroutine l4_devxlib_memcpy_h2h_l4d(array_out, array_in, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3, &
                                                  range4, lbound4 )
         implicit none
         !
         logical(int32), intent(inout) :: array_out(:,:,:,:)
         logical(int32), intent(in)    :: array_in(:,:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(array_out, 4)/)
         if (present(range4)) range4_=range4 
         !
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         do i4 = d4s, d4e
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3,i4 ) = array_in(i1,i2,i3,i4 )
         enddo
         enddo
         enddo
         enddo
         !
      end subroutine l4_devxlib_memcpy_h2h_l4d
!
      module subroutine l4_devxlib_memcpy_h2h_l5d(array_out, array_in, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3, &
                                                  range4, lbound4, &
                                                  range5, lbound5 )
         implicit none
         !
         logical(int32), intent(inout) :: array_out(:,:,:,:,:)
         logical(int32), intent(in)    :: array_in(:,:,:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         integer :: i5, d5s, d5e
         integer :: lbound5_, range5_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(array_out, 4)/)
         if (present(range4)) range4_=range4 
         !
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         lbound5_=1
         if (present(lbound5)) lbound5_=lbound5 
         range5_=(/1,size(array_out, 5)/)
         if (present(range5)) range5_=range5 
         !
         d5s = range5_(1) -lbound5_ +1
         d5e = range5_(2) -lbound5_ +1
         !
         do i5 = d5s, d5e
         do i4 = d4s, d4e
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3,i4,i5 ) = array_in(i1,i2,i3,i4,i5 )
         enddo
         enddo
         enddo
         enddo
         enddo
         !
      end subroutine l4_devxlib_memcpy_h2h_l5d
!
      module subroutine l4_devxlib_memcpy_h2h_l6d(array_out, array_in, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3, &
                                                  range4, lbound4, &
                                                  range5, lbound5, &
                                                  range6, lbound6 )
         implicit none
         !
         logical(int32), intent(inout) :: array_out(:,:,:,:,:,:)
         logical(int32), intent(in)    :: array_in(:,:,:,:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2), range6(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5, lbound6
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         integer :: i5, d5s, d5e
         integer :: lbound5_, range5_(2)
         integer :: i6, d6s, d6e
         integer :: lbound6_, range6_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(array_out, 4)/)
         if (present(range4)) range4_=range4 
         !
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         lbound5_=1
         if (present(lbound5)) lbound5_=lbound5 
         range5_=(/1,size(array_out, 5)/)
         if (present(range5)) range5_=range5 
         !
         d5s = range5_(1) -lbound5_ +1
         d5e = range5_(2) -lbound5_ +1
         !
         lbound6_=1
         if (present(lbound6)) lbound6_=lbound6 
         range6_=(/1,size(array_out, 6)/)
         if (present(range6)) range6_=range6 
         !
         d6s = range6_(1) -lbound6_ +1
         d6e = range6_(2) -lbound6_ +1
         !
         do i6 = d6s, d6e
         do i5 = d5s, d5e
         do i4 = d4s, d4e
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3,i4,i5,i6 ) = array_in(i1,i2,i3,i4,i5,i6 )
         enddo
         enddo
         enddo
         enddo
         enddo
         enddo
         !
      end subroutine l4_devxlib_memcpy_h2h_l6d
!
      module subroutine sp_devxlib_memcpy_h2h_async_r1d(array_out, array_in, async_id, &
                                            range1, lbound1 )
         implicit none
         !
         real(real32), intent(inout) :: array_out(:)
         real(real32), intent(in)    :: array_in(:)
         integer(kind=dxl_async_kind), intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2)
         integer, optional, intent(in) ::  lbound1
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         !
         !DEV_OMP parallel do collapse(1)
         do i1 = d1s, d1e
            array_out(i1 ) = array_in(i1 )
         enddo
         !DEV_OMP end parallel do
         !
      end subroutine sp_devxlib_memcpy_h2h_async_r1d
!
      module subroutine sp_devxlib_memcpy_h2h_async_r2d(array_out, array_in, async_id, &
                                            range1, lbound1, &
                                            range2, lbound2 )
         implicit none
         !
         real(real32), intent(inout) :: array_out(:,:)
         real(real32), intent(in)    :: array_in(:,:)
         integer(kind=dxl_async_kind), intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2)
         integer, optional, intent(in) ::  lbound1, lbound2
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         !
         !DEV_OMP parallel do collapse(2)
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2 ) = array_in(i1,i2 )
         enddo
         enddo
         !DEV_OMP end parallel do
         !
      end subroutine sp_devxlib_memcpy_h2h_async_r2d
!
      module subroutine sp_devxlib_memcpy_h2h_async_r3d(array_out, array_in, async_id, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3 )
         implicit none
         !
         real(real32), intent(inout) :: array_out(:,:,:)
         real(real32), intent(in)    :: array_in(:,:,:)
         integer(kind=dxl_async_kind), intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         !
         !DEV_OMP parallel do collapse(3)
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3 ) = array_in(i1,i2,i3 )
         enddo
         enddo
         enddo
         !DEV_OMP end parallel do
         !
      end subroutine sp_devxlib_memcpy_h2h_async_r3d
!
      module subroutine sp_devxlib_memcpy_h2h_async_r4d(array_out, array_in, async_id, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3, &
                                            range4, lbound4 )
         implicit none
         !
         real(real32), intent(inout) :: array_out(:,:,:,:)
         real(real32), intent(in)    :: array_in(:,:,:,:)
         integer(kind=dxl_async_kind), intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(array_out, 4)/)
         if (present(range4)) range4_=range4 
         !
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         !
         !DEV_OMP parallel do collapse(4)
         do i4 = d4s, d4e
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3,i4 ) = array_in(i1,i2,i3,i4 )
         enddo
         enddo
         enddo
         enddo
         !DEV_OMP end parallel do
         !
      end subroutine sp_devxlib_memcpy_h2h_async_r4d
!
      module subroutine sp_devxlib_memcpy_h2h_async_r5d(array_out, array_in, async_id, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3, &
                                            range4, lbound4, &
                                            range5, lbound5 )
         implicit none
         !
         real(real32), intent(inout) :: array_out(:,:,:,:,:)
         real(real32), intent(in)    :: array_in(:,:,:,:,:)
         integer(kind=dxl_async_kind), intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         integer :: i5, d5s, d5e
         integer :: lbound5_, range5_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(array_out, 4)/)
         if (present(range4)) range4_=range4 
         !
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         lbound5_=1
         if (present(lbound5)) lbound5_=lbound5 
         range5_=(/1,size(array_out, 5)/)
         if (present(range5)) range5_=range5 
         !
         d5s = range5_(1) -lbound5_ +1
         d5e = range5_(2) -lbound5_ +1
         !
         !
         !DEV_OMP parallel do collapse(5)
         do i5 = d5s, d5e
         do i4 = d4s, d4e
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3,i4,i5 ) = array_in(i1,i2,i3,i4,i5 )
         enddo
         enddo
         enddo
         enddo
         enddo
         !DEV_OMP end parallel do
         !
      end subroutine sp_devxlib_memcpy_h2h_async_r5d
!
      module subroutine sp_devxlib_memcpy_h2h_async_r6d(array_out, array_in, async_id, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3, &
                                            range4, lbound4, &
                                            range5, lbound5, &
                                            range6, lbound6 )
         implicit none
         !
         real(real32), intent(inout) :: array_out(:,:,:,:,:,:)
         real(real32), intent(in)    :: array_in(:,:,:,:,:,:)
         integer(kind=dxl_async_kind), intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2), range6(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5, lbound6
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         integer :: i5, d5s, d5e
         integer :: lbound5_, range5_(2)
         integer :: i6, d6s, d6e
         integer :: lbound6_, range6_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(array_out, 4)/)
         if (present(range4)) range4_=range4 
         !
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         lbound5_=1
         if (present(lbound5)) lbound5_=lbound5 
         range5_=(/1,size(array_out, 5)/)
         if (present(range5)) range5_=range5 
         !
         d5s = range5_(1) -lbound5_ +1
         d5e = range5_(2) -lbound5_ +1
         !
         lbound6_=1
         if (present(lbound6)) lbound6_=lbound6 
         range6_=(/1,size(array_out, 6)/)
         if (present(range6)) range6_=range6 
         !
         d6s = range6_(1) -lbound6_ +1
         d6e = range6_(2) -lbound6_ +1
         !
         !
         !DEV_OMP parallel do collapse(6)
         do i6 = d6s, d6e
         do i5 = d5s, d5e
         do i4 = d4s, d4e
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3,i4,i5,i6 ) = array_in(i1,i2,i3,i4,i5,i6 )
         enddo
         enddo
         enddo
         enddo
         enddo
         enddo
         !DEV_OMP end parallel do
         !
      end subroutine sp_devxlib_memcpy_h2h_async_r6d
!
      module subroutine dp_devxlib_memcpy_h2h_async_r1d(array_out, array_in, async_id, &
                                            range1, lbound1 )
         implicit none
         !
         real(real64), intent(inout) :: array_out(:)
         real(real64), intent(in)    :: array_in(:)
         integer(kind=dxl_async_kind), intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2)
         integer, optional, intent(in) ::  lbound1
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         !
         !DEV_OMP parallel do collapse(1)
         do i1 = d1s, d1e
            array_out(i1 ) = array_in(i1 )
         enddo
         !DEV_OMP end parallel do
         !
      end subroutine dp_devxlib_memcpy_h2h_async_r1d
!
      module subroutine dp_devxlib_memcpy_h2h_async_r2d(array_out, array_in, async_id, &
                                            range1, lbound1, &
                                            range2, lbound2 )
         implicit none
         !
         real(real64), intent(inout) :: array_out(:,:)
         real(real64), intent(in)    :: array_in(:,:)
         integer(kind=dxl_async_kind), intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2)
         integer, optional, intent(in) ::  lbound1, lbound2
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         !
         !DEV_OMP parallel do collapse(2)
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2 ) = array_in(i1,i2 )
         enddo
         enddo
         !DEV_OMP end parallel do
         !
      end subroutine dp_devxlib_memcpy_h2h_async_r2d
!
      module subroutine dp_devxlib_memcpy_h2h_async_r3d(array_out, array_in, async_id, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3 )
         implicit none
         !
         real(real64), intent(inout) :: array_out(:,:,:)
         real(real64), intent(in)    :: array_in(:,:,:)
         integer(kind=dxl_async_kind), intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         !
         !DEV_OMP parallel do collapse(3)
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3 ) = array_in(i1,i2,i3 )
         enddo
         enddo
         enddo
         !DEV_OMP end parallel do
         !
      end subroutine dp_devxlib_memcpy_h2h_async_r3d
!
      module subroutine dp_devxlib_memcpy_h2h_async_r4d(array_out, array_in, async_id, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3, &
                                            range4, lbound4 )
         implicit none
         !
         real(real64), intent(inout) :: array_out(:,:,:,:)
         real(real64), intent(in)    :: array_in(:,:,:,:)
         integer(kind=dxl_async_kind), intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(array_out, 4)/)
         if (present(range4)) range4_=range4 
         !
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         !
         !DEV_OMP parallel do collapse(4)
         do i4 = d4s, d4e
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3,i4 ) = array_in(i1,i2,i3,i4 )
         enddo
         enddo
         enddo
         enddo
         !DEV_OMP end parallel do
         !
      end subroutine dp_devxlib_memcpy_h2h_async_r4d
!
      module subroutine dp_devxlib_memcpy_h2h_async_r5d(array_out, array_in, async_id, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3, &
                                            range4, lbound4, &
                                            range5, lbound5 )
         implicit none
         !
         real(real64), intent(inout) :: array_out(:,:,:,:,:)
         real(real64), intent(in)    :: array_in(:,:,:,:,:)
         integer(kind=dxl_async_kind), intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         integer :: i5, d5s, d5e
         integer :: lbound5_, range5_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(array_out, 4)/)
         if (present(range4)) range4_=range4 
         !
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         lbound5_=1
         if (present(lbound5)) lbound5_=lbound5 
         range5_=(/1,size(array_out, 5)/)
         if (present(range5)) range5_=range5 
         !
         d5s = range5_(1) -lbound5_ +1
         d5e = range5_(2) -lbound5_ +1
         !
         !
         !DEV_OMP parallel do collapse(5)
         do i5 = d5s, d5e
         do i4 = d4s, d4e
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3,i4,i5 ) = array_in(i1,i2,i3,i4,i5 )
         enddo
         enddo
         enddo
         enddo
         enddo
         !DEV_OMP end parallel do
         !
      end subroutine dp_devxlib_memcpy_h2h_async_r5d
!
      module subroutine dp_devxlib_memcpy_h2h_async_r6d(array_out, array_in, async_id, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3, &
                                            range4, lbound4, &
                                            range5, lbound5, &
                                            range6, lbound6 )
         implicit none
         !
         real(real64), intent(inout) :: array_out(:,:,:,:,:,:)
         real(real64), intent(in)    :: array_in(:,:,:,:,:,:)
         integer(kind=dxl_async_kind), intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2), range6(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5, lbound6
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         integer :: i5, d5s, d5e
         integer :: lbound5_, range5_(2)
         integer :: i6, d6s, d6e
         integer :: lbound6_, range6_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(array_out, 4)/)
         if (present(range4)) range4_=range4 
         !
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         lbound5_=1
         if (present(lbound5)) lbound5_=lbound5 
         range5_=(/1,size(array_out, 5)/)
         if (present(range5)) range5_=range5 
         !
         d5s = range5_(1) -lbound5_ +1
         d5e = range5_(2) -lbound5_ +1
         !
         lbound6_=1
         if (present(lbound6)) lbound6_=lbound6 
         range6_=(/1,size(array_out, 6)/)
         if (present(range6)) range6_=range6 
         !
         d6s = range6_(1) -lbound6_ +1
         d6e = range6_(2) -lbound6_ +1
         !
         !
         !DEV_OMP parallel do collapse(6)
         do i6 = d6s, d6e
         do i5 = d5s, d5e
         do i4 = d4s, d4e
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3,i4,i5,i6 ) = array_in(i1,i2,i3,i4,i5,i6 )
         enddo
         enddo
         enddo
         enddo
         enddo
         enddo
         !DEV_OMP end parallel do
         !
      end subroutine dp_devxlib_memcpy_h2h_async_r6d
!
      module subroutine sp_devxlib_memcpy_h2h_async_c1d(array_out, array_in, async_id, &
                                            range1, lbound1 )
         implicit none
         !
         complex(real32), intent(inout) :: array_out(:)
         complex(real32), intent(in)    :: array_in(:)
         integer(kind=dxl_async_kind), intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2)
         integer, optional, intent(in) ::  lbound1
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         !
         !DEV_OMP parallel do collapse(1)
         do i1 = d1s, d1e
            array_out(i1 ) = array_in(i1 )
         enddo
         !DEV_OMP end parallel do
         !
      end subroutine sp_devxlib_memcpy_h2h_async_c1d
!
      module subroutine sp_devxlib_memcpy_h2h_async_c2d(array_out, array_in, async_id, &
                                            range1, lbound1, &
                                            range2, lbound2 )
         implicit none
         !
         complex(real32), intent(inout) :: array_out(:,:)
         complex(real32), intent(in)    :: array_in(:,:)
         integer(kind=dxl_async_kind), intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2)
         integer, optional, intent(in) ::  lbound1, lbound2
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         !
         !DEV_OMP parallel do collapse(2)
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2 ) = array_in(i1,i2 )
         enddo
         enddo
         !DEV_OMP end parallel do
         !
      end subroutine sp_devxlib_memcpy_h2h_async_c2d
!
      module subroutine sp_devxlib_memcpy_h2h_async_c3d(array_out, array_in, async_id, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3 )
         implicit none
         !
         complex(real32), intent(inout) :: array_out(:,:,:)
         complex(real32), intent(in)    :: array_in(:,:,:)
         integer(kind=dxl_async_kind), intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         !
         !DEV_OMP parallel do collapse(3)
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3 ) = array_in(i1,i2,i3 )
         enddo
         enddo
         enddo
         !DEV_OMP end parallel do
         !
      end subroutine sp_devxlib_memcpy_h2h_async_c3d
!
      module subroutine sp_devxlib_memcpy_h2h_async_c4d(array_out, array_in, async_id, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3, &
                                            range4, lbound4 )
         implicit none
         !
         complex(real32), intent(inout) :: array_out(:,:,:,:)
         complex(real32), intent(in)    :: array_in(:,:,:,:)
         integer(kind=dxl_async_kind), intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(array_out, 4)/)
         if (present(range4)) range4_=range4 
         !
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         !
         !DEV_OMP parallel do collapse(4)
         do i4 = d4s, d4e
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3,i4 ) = array_in(i1,i2,i3,i4 )
         enddo
         enddo
         enddo
         enddo
         !DEV_OMP end parallel do
         !
      end subroutine sp_devxlib_memcpy_h2h_async_c4d
!
      module subroutine sp_devxlib_memcpy_h2h_async_c5d(array_out, array_in, async_id, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3, &
                                            range4, lbound4, &
                                            range5, lbound5 )
         implicit none
         !
         complex(real32), intent(inout) :: array_out(:,:,:,:,:)
         complex(real32), intent(in)    :: array_in(:,:,:,:,:)
         integer(kind=dxl_async_kind), intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         integer :: i5, d5s, d5e
         integer :: lbound5_, range5_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(array_out, 4)/)
         if (present(range4)) range4_=range4 
         !
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         lbound5_=1
         if (present(lbound5)) lbound5_=lbound5 
         range5_=(/1,size(array_out, 5)/)
         if (present(range5)) range5_=range5 
         !
         d5s = range5_(1) -lbound5_ +1
         d5e = range5_(2) -lbound5_ +1
         !
         !
         !DEV_OMP parallel do collapse(5)
         do i5 = d5s, d5e
         do i4 = d4s, d4e
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3,i4,i5 ) = array_in(i1,i2,i3,i4,i5 )
         enddo
         enddo
         enddo
         enddo
         enddo
         !DEV_OMP end parallel do
         !
      end subroutine sp_devxlib_memcpy_h2h_async_c5d
!
      module subroutine sp_devxlib_memcpy_h2h_async_c6d(array_out, array_in, async_id, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3, &
                                            range4, lbound4, &
                                            range5, lbound5, &
                                            range6, lbound6 )
         implicit none
         !
         complex(real32), intent(inout) :: array_out(:,:,:,:,:,:)
         complex(real32), intent(in)    :: array_in(:,:,:,:,:,:)
         integer(kind=dxl_async_kind), intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2), range6(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5, lbound6
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         integer :: i5, d5s, d5e
         integer :: lbound5_, range5_(2)
         integer :: i6, d6s, d6e
         integer :: lbound6_, range6_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(array_out, 4)/)
         if (present(range4)) range4_=range4 
         !
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         lbound5_=1
         if (present(lbound5)) lbound5_=lbound5 
         range5_=(/1,size(array_out, 5)/)
         if (present(range5)) range5_=range5 
         !
         d5s = range5_(1) -lbound5_ +1
         d5e = range5_(2) -lbound5_ +1
         !
         lbound6_=1
         if (present(lbound6)) lbound6_=lbound6 
         range6_=(/1,size(array_out, 6)/)
         if (present(range6)) range6_=range6 
         !
         d6s = range6_(1) -lbound6_ +1
         d6e = range6_(2) -lbound6_ +1
         !
         !
         !DEV_OMP parallel do collapse(6)
         do i6 = d6s, d6e
         do i5 = d5s, d5e
         do i4 = d4s, d4e
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3,i4,i5,i6 ) = array_in(i1,i2,i3,i4,i5,i6 )
         enddo
         enddo
         enddo
         enddo
         enddo
         enddo
         !DEV_OMP end parallel do
         !
      end subroutine sp_devxlib_memcpy_h2h_async_c6d
!
      module subroutine dp_devxlib_memcpy_h2h_async_c1d(array_out, array_in, async_id, &
                                            range1, lbound1 )
         implicit none
         !
         complex(real64), intent(inout) :: array_out(:)
         complex(real64), intent(in)    :: array_in(:)
         integer(kind=dxl_async_kind), intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2)
         integer, optional, intent(in) ::  lbound1
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         !
         !DEV_OMP parallel do collapse(1)
         do i1 = d1s, d1e
            array_out(i1 ) = array_in(i1 )
         enddo
         !DEV_OMP end parallel do
         !
      end subroutine dp_devxlib_memcpy_h2h_async_c1d
!
      module subroutine dp_devxlib_memcpy_h2h_async_c2d(array_out, array_in, async_id, &
                                            range1, lbound1, &
                                            range2, lbound2 )
         implicit none
         !
         complex(real64), intent(inout) :: array_out(:,:)
         complex(real64), intent(in)    :: array_in(:,:)
         integer(kind=dxl_async_kind), intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2)
         integer, optional, intent(in) ::  lbound1, lbound2
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         !
         !DEV_OMP parallel do collapse(2)
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2 ) = array_in(i1,i2 )
         enddo
         enddo
         !DEV_OMP end parallel do
         !
      end subroutine dp_devxlib_memcpy_h2h_async_c2d
!
      module subroutine dp_devxlib_memcpy_h2h_async_c3d(array_out, array_in, async_id, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3 )
         implicit none
         !
         complex(real64), intent(inout) :: array_out(:,:,:)
         complex(real64), intent(in)    :: array_in(:,:,:)
         integer(kind=dxl_async_kind), intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         !
         !DEV_OMP parallel do collapse(3)
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3 ) = array_in(i1,i2,i3 )
         enddo
         enddo
         enddo
         !DEV_OMP end parallel do
         !
      end subroutine dp_devxlib_memcpy_h2h_async_c3d
!
      module subroutine dp_devxlib_memcpy_h2h_async_c4d(array_out, array_in, async_id, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3, &
                                            range4, lbound4 )
         implicit none
         !
         complex(real64), intent(inout) :: array_out(:,:,:,:)
         complex(real64), intent(in)    :: array_in(:,:,:,:)
         integer(kind=dxl_async_kind), intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(array_out, 4)/)
         if (present(range4)) range4_=range4 
         !
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         !
         !DEV_OMP parallel do collapse(4)
         do i4 = d4s, d4e
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3,i4 ) = array_in(i1,i2,i3,i4 )
         enddo
         enddo
         enddo
         enddo
         !DEV_OMP end parallel do
         !
      end subroutine dp_devxlib_memcpy_h2h_async_c4d
!
      module subroutine dp_devxlib_memcpy_h2h_async_c5d(array_out, array_in, async_id, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3, &
                                            range4, lbound4, &
                                            range5, lbound5 )
         implicit none
         !
         complex(real64), intent(inout) :: array_out(:,:,:,:,:)
         complex(real64), intent(in)    :: array_in(:,:,:,:,:)
         integer(kind=dxl_async_kind), intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         integer :: i5, d5s, d5e
         integer :: lbound5_, range5_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(array_out, 4)/)
         if (present(range4)) range4_=range4 
         !
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         lbound5_=1
         if (present(lbound5)) lbound5_=lbound5 
         range5_=(/1,size(array_out, 5)/)
         if (present(range5)) range5_=range5 
         !
         d5s = range5_(1) -lbound5_ +1
         d5e = range5_(2) -lbound5_ +1
         !
         !
         !DEV_OMP parallel do collapse(5)
         do i5 = d5s, d5e
         do i4 = d4s, d4e
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3,i4,i5 ) = array_in(i1,i2,i3,i4,i5 )
         enddo
         enddo
         enddo
         enddo
         enddo
         !DEV_OMP end parallel do
         !
      end subroutine dp_devxlib_memcpy_h2h_async_c5d
!
      module subroutine dp_devxlib_memcpy_h2h_async_c6d(array_out, array_in, async_id, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3, &
                                            range4, lbound4, &
                                            range5, lbound5, &
                                            range6, lbound6 )
         implicit none
         !
         complex(real64), intent(inout) :: array_out(:,:,:,:,:,:)
         complex(real64), intent(in)    :: array_in(:,:,:,:,:,:)
         integer(kind=dxl_async_kind), intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2), range6(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5, lbound6
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         integer :: i5, d5s, d5e
         integer :: lbound5_, range5_(2)
         integer :: i6, d6s, d6e
         integer :: lbound6_, range6_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(array_out, 4)/)
         if (present(range4)) range4_=range4 
         !
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         lbound5_=1
         if (present(lbound5)) lbound5_=lbound5 
         range5_=(/1,size(array_out, 5)/)
         if (present(range5)) range5_=range5 
         !
         d5s = range5_(1) -lbound5_ +1
         d5e = range5_(2) -lbound5_ +1
         !
         lbound6_=1
         if (present(lbound6)) lbound6_=lbound6 
         range6_=(/1,size(array_out, 6)/)
         if (present(range6)) range6_=range6 
         !
         d6s = range6_(1) -lbound6_ +1
         d6e = range6_(2) -lbound6_ +1
         !
         !
         !DEV_OMP parallel do collapse(6)
         do i6 = d6s, d6e
         do i5 = d5s, d5e
         do i4 = d4s, d4e
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3,i4,i5,i6 ) = array_in(i1,i2,i3,i4,i5,i6 )
         enddo
         enddo
         enddo
         enddo
         enddo
         enddo
         !DEV_OMP end parallel do
         !
      end subroutine dp_devxlib_memcpy_h2h_async_c6d
!
      module subroutine i4_devxlib_memcpy_h2h_async_i1d(array_out, array_in, async_id, &
                                            range1, lbound1 )
         implicit none
         !
         integer(int32), intent(inout) :: array_out(:)
         integer(int32), intent(in)    :: array_in(:)
         integer(kind=dxl_async_kind), intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2)
         integer, optional, intent(in) ::  lbound1
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         !
         !DEV_OMP parallel do collapse(1)
         do i1 = d1s, d1e
            array_out(i1 ) = array_in(i1 )
         enddo
         !DEV_OMP end parallel do
         !
      end subroutine i4_devxlib_memcpy_h2h_async_i1d
!
      module subroutine i4_devxlib_memcpy_h2h_async_i2d(array_out, array_in, async_id, &
                                            range1, lbound1, &
                                            range2, lbound2 )
         implicit none
         !
         integer(int32), intent(inout) :: array_out(:,:)
         integer(int32), intent(in)    :: array_in(:,:)
         integer(kind=dxl_async_kind), intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2)
         integer, optional, intent(in) ::  lbound1, lbound2
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         !
         !DEV_OMP parallel do collapse(2)
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2 ) = array_in(i1,i2 )
         enddo
         enddo
         !DEV_OMP end parallel do
         !
      end subroutine i4_devxlib_memcpy_h2h_async_i2d
!
      module subroutine i4_devxlib_memcpy_h2h_async_i3d(array_out, array_in, async_id, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3 )
         implicit none
         !
         integer(int32), intent(inout) :: array_out(:,:,:)
         integer(int32), intent(in)    :: array_in(:,:,:)
         integer(kind=dxl_async_kind), intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         !
         !DEV_OMP parallel do collapse(3)
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3 ) = array_in(i1,i2,i3 )
         enddo
         enddo
         enddo
         !DEV_OMP end parallel do
         !
      end subroutine i4_devxlib_memcpy_h2h_async_i3d
!
      module subroutine i4_devxlib_memcpy_h2h_async_i4d(array_out, array_in, async_id, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3, &
                                            range4, lbound4 )
         implicit none
         !
         integer(int32), intent(inout) :: array_out(:,:,:,:)
         integer(int32), intent(in)    :: array_in(:,:,:,:)
         integer(kind=dxl_async_kind), intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(array_out, 4)/)
         if (present(range4)) range4_=range4 
         !
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         !
         !DEV_OMP parallel do collapse(4)
         do i4 = d4s, d4e
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3,i4 ) = array_in(i1,i2,i3,i4 )
         enddo
         enddo
         enddo
         enddo
         !DEV_OMP end parallel do
         !
      end subroutine i4_devxlib_memcpy_h2h_async_i4d
!
      module subroutine i4_devxlib_memcpy_h2h_async_i5d(array_out, array_in, async_id, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3, &
                                            range4, lbound4, &
                                            range5, lbound5 )
         implicit none
         !
         integer(int32), intent(inout) :: array_out(:,:,:,:,:)
         integer(int32), intent(in)    :: array_in(:,:,:,:,:)
         integer(kind=dxl_async_kind), intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         integer :: i5, d5s, d5e
         integer :: lbound5_, range5_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(array_out, 4)/)
         if (present(range4)) range4_=range4 
         !
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         lbound5_=1
         if (present(lbound5)) lbound5_=lbound5 
         range5_=(/1,size(array_out, 5)/)
         if (present(range5)) range5_=range5 
         !
         d5s = range5_(1) -lbound5_ +1
         d5e = range5_(2) -lbound5_ +1
         !
         !
         !DEV_OMP parallel do collapse(5)
         do i5 = d5s, d5e
         do i4 = d4s, d4e
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3,i4,i5 ) = array_in(i1,i2,i3,i4,i5 )
         enddo
         enddo
         enddo
         enddo
         enddo
         !DEV_OMP end parallel do
         !
      end subroutine i4_devxlib_memcpy_h2h_async_i5d
!
      module subroutine i4_devxlib_memcpy_h2h_async_i6d(array_out, array_in, async_id, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3, &
                                            range4, lbound4, &
                                            range5, lbound5, &
                                            range6, lbound6 )
         implicit none
         !
         integer(int32), intent(inout) :: array_out(:,:,:,:,:,:)
         integer(int32), intent(in)    :: array_in(:,:,:,:,:,:)
         integer(kind=dxl_async_kind), intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2), range6(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5, lbound6
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         integer :: i5, d5s, d5e
         integer :: lbound5_, range5_(2)
         integer :: i6, d6s, d6e
         integer :: lbound6_, range6_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(array_out, 4)/)
         if (present(range4)) range4_=range4 
         !
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         lbound5_=1
         if (present(lbound5)) lbound5_=lbound5 
         range5_=(/1,size(array_out, 5)/)
         if (present(range5)) range5_=range5 
         !
         d5s = range5_(1) -lbound5_ +1
         d5e = range5_(2) -lbound5_ +1
         !
         lbound6_=1
         if (present(lbound6)) lbound6_=lbound6 
         range6_=(/1,size(array_out, 6)/)
         if (present(range6)) range6_=range6 
         !
         d6s = range6_(1) -lbound6_ +1
         d6e = range6_(2) -lbound6_ +1
         !
         !
         !DEV_OMP parallel do collapse(6)
         do i6 = d6s, d6e
         do i5 = d5s, d5e
         do i4 = d4s, d4e
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3,i4,i5,i6 ) = array_in(i1,i2,i3,i4,i5,i6 )
         enddo
         enddo
         enddo
         enddo
         enddo
         enddo
         !DEV_OMP end parallel do
         !
      end subroutine i4_devxlib_memcpy_h2h_async_i6d
!
      module subroutine i8_devxlib_memcpy_h2h_async_i1d(array_out, array_in, async_id, &
                                            range1, lbound1 )
         implicit none
         !
         integer(int64), intent(inout) :: array_out(:)
         integer(int64), intent(in)    :: array_in(:)
         integer(kind=dxl_async_kind), intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2)
         integer, optional, intent(in) ::  lbound1
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         !
         !DEV_OMP parallel do collapse(1)
         do i1 = d1s, d1e
            array_out(i1 ) = array_in(i1 )
         enddo
         !DEV_OMP end parallel do
         !
      end subroutine i8_devxlib_memcpy_h2h_async_i1d
!
      module subroutine i8_devxlib_memcpy_h2h_async_i2d(array_out, array_in, async_id, &
                                            range1, lbound1, &
                                            range2, lbound2 )
         implicit none
         !
         integer(int64), intent(inout) :: array_out(:,:)
         integer(int64), intent(in)    :: array_in(:,:)
         integer(kind=dxl_async_kind), intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2)
         integer, optional, intent(in) ::  lbound1, lbound2
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         !
         !DEV_OMP parallel do collapse(2)
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2 ) = array_in(i1,i2 )
         enddo
         enddo
         !DEV_OMP end parallel do
         !
      end subroutine i8_devxlib_memcpy_h2h_async_i2d
!
      module subroutine i8_devxlib_memcpy_h2h_async_i3d(array_out, array_in, async_id, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3 )
         implicit none
         !
         integer(int64), intent(inout) :: array_out(:,:,:)
         integer(int64), intent(in)    :: array_in(:,:,:)
         integer(kind=dxl_async_kind), intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         !
         !DEV_OMP parallel do collapse(3)
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3 ) = array_in(i1,i2,i3 )
         enddo
         enddo
         enddo
         !DEV_OMP end parallel do
         !
      end subroutine i8_devxlib_memcpy_h2h_async_i3d
!
      module subroutine i8_devxlib_memcpy_h2h_async_i4d(array_out, array_in, async_id, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3, &
                                            range4, lbound4 )
         implicit none
         !
         integer(int64), intent(inout) :: array_out(:,:,:,:)
         integer(int64), intent(in)    :: array_in(:,:,:,:)
         integer(kind=dxl_async_kind), intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(array_out, 4)/)
         if (present(range4)) range4_=range4 
         !
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         !
         !DEV_OMP parallel do collapse(4)
         do i4 = d4s, d4e
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3,i4 ) = array_in(i1,i2,i3,i4 )
         enddo
         enddo
         enddo
         enddo
         !DEV_OMP end parallel do
         !
      end subroutine i8_devxlib_memcpy_h2h_async_i4d
!
      module subroutine i8_devxlib_memcpy_h2h_async_i5d(array_out, array_in, async_id, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3, &
                                            range4, lbound4, &
                                            range5, lbound5 )
         implicit none
         !
         integer(int64), intent(inout) :: array_out(:,:,:,:,:)
         integer(int64), intent(in)    :: array_in(:,:,:,:,:)
         integer(kind=dxl_async_kind), intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         integer :: i5, d5s, d5e
         integer :: lbound5_, range5_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(array_out, 4)/)
         if (present(range4)) range4_=range4 
         !
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         lbound5_=1
         if (present(lbound5)) lbound5_=lbound5 
         range5_=(/1,size(array_out, 5)/)
         if (present(range5)) range5_=range5 
         !
         d5s = range5_(1) -lbound5_ +1
         d5e = range5_(2) -lbound5_ +1
         !
         !
         !DEV_OMP parallel do collapse(5)
         do i5 = d5s, d5e
         do i4 = d4s, d4e
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3,i4,i5 ) = array_in(i1,i2,i3,i4,i5 )
         enddo
         enddo
         enddo
         enddo
         enddo
         !DEV_OMP end parallel do
         !
      end subroutine i8_devxlib_memcpy_h2h_async_i5d
!
      module subroutine i8_devxlib_memcpy_h2h_async_i6d(array_out, array_in, async_id, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3, &
                                            range4, lbound4, &
                                            range5, lbound5, &
                                            range6, lbound6 )
         implicit none
         !
         integer(int64), intent(inout) :: array_out(:,:,:,:,:,:)
         integer(int64), intent(in)    :: array_in(:,:,:,:,:,:)
         integer(kind=dxl_async_kind), intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2), range6(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5, lbound6
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         integer :: i5, d5s, d5e
         integer :: lbound5_, range5_(2)
         integer :: i6, d6s, d6e
         integer :: lbound6_, range6_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(array_out, 4)/)
         if (present(range4)) range4_=range4 
         !
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         lbound5_=1
         if (present(lbound5)) lbound5_=lbound5 
         range5_=(/1,size(array_out, 5)/)
         if (present(range5)) range5_=range5 
         !
         d5s = range5_(1) -lbound5_ +1
         d5e = range5_(2) -lbound5_ +1
         !
         lbound6_=1
         if (present(lbound6)) lbound6_=lbound6 
         range6_=(/1,size(array_out, 6)/)
         if (present(range6)) range6_=range6 
         !
         d6s = range6_(1) -lbound6_ +1
         d6e = range6_(2) -lbound6_ +1
         !
         !
         !DEV_OMP parallel do collapse(6)
         do i6 = d6s, d6e
         do i5 = d5s, d5e
         do i4 = d4s, d4e
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3,i4,i5,i6 ) = array_in(i1,i2,i3,i4,i5,i6 )
         enddo
         enddo
         enddo
         enddo
         enddo
         enddo
         !DEV_OMP end parallel do
         !
      end subroutine i8_devxlib_memcpy_h2h_async_i6d
!
      module subroutine l4_devxlib_memcpy_h2h_async_l1d(array_out, array_in, async_id, &
                                            range1, lbound1 )
         implicit none
         !
         logical(int32), intent(inout) :: array_out(:)
         logical(int32), intent(in)    :: array_in(:)
         integer(kind=dxl_async_kind), intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2)
         integer, optional, intent(in) ::  lbound1
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         !
         !DEV_OMP parallel do collapse(1)
         do i1 = d1s, d1e
            array_out(i1 ) = array_in(i1 )
         enddo
         !DEV_OMP end parallel do
         !
      end subroutine l4_devxlib_memcpy_h2h_async_l1d
!
      module subroutine l4_devxlib_memcpy_h2h_async_l2d(array_out, array_in, async_id, &
                                            range1, lbound1, &
                                            range2, lbound2 )
         implicit none
         !
         logical(int32), intent(inout) :: array_out(:,:)
         logical(int32), intent(in)    :: array_in(:,:)
         integer(kind=dxl_async_kind), intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2)
         integer, optional, intent(in) ::  lbound1, lbound2
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         !
         !DEV_OMP parallel do collapse(2)
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2 ) = array_in(i1,i2 )
         enddo
         enddo
         !DEV_OMP end parallel do
         !
      end subroutine l4_devxlib_memcpy_h2h_async_l2d
!
      module subroutine l4_devxlib_memcpy_h2h_async_l3d(array_out, array_in, async_id, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3 )
         implicit none
         !
         logical(int32), intent(inout) :: array_out(:,:,:)
         logical(int32), intent(in)    :: array_in(:,:,:)
         integer(kind=dxl_async_kind), intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         !
         !DEV_OMP parallel do collapse(3)
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3 ) = array_in(i1,i2,i3 )
         enddo
         enddo
         enddo
         !DEV_OMP end parallel do
         !
      end subroutine l4_devxlib_memcpy_h2h_async_l3d
!
      module subroutine l4_devxlib_memcpy_h2h_async_l4d(array_out, array_in, async_id, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3, &
                                            range4, lbound4 )
         implicit none
         !
         logical(int32), intent(inout) :: array_out(:,:,:,:)
         logical(int32), intent(in)    :: array_in(:,:,:,:)
         integer(kind=dxl_async_kind), intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(array_out, 4)/)
         if (present(range4)) range4_=range4 
         !
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         !
         !DEV_OMP parallel do collapse(4)
         do i4 = d4s, d4e
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3,i4 ) = array_in(i1,i2,i3,i4 )
         enddo
         enddo
         enddo
         enddo
         !DEV_OMP end parallel do
         !
      end subroutine l4_devxlib_memcpy_h2h_async_l4d
!
      module subroutine l4_devxlib_memcpy_h2h_async_l5d(array_out, array_in, async_id, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3, &
                                            range4, lbound4, &
                                            range5, lbound5 )
         implicit none
         !
         logical(int32), intent(inout) :: array_out(:,:,:,:,:)
         logical(int32), intent(in)    :: array_in(:,:,:,:,:)
         integer(kind=dxl_async_kind), intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         integer :: i5, d5s, d5e
         integer :: lbound5_, range5_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(array_out, 4)/)
         if (present(range4)) range4_=range4 
         !
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         lbound5_=1
         if (present(lbound5)) lbound5_=lbound5 
         range5_=(/1,size(array_out, 5)/)
         if (present(range5)) range5_=range5 
         !
         d5s = range5_(1) -lbound5_ +1
         d5e = range5_(2) -lbound5_ +1
         !
         !
         !DEV_OMP parallel do collapse(5)
         do i5 = d5s, d5e
         do i4 = d4s, d4e
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3,i4,i5 ) = array_in(i1,i2,i3,i4,i5 )
         enddo
         enddo
         enddo
         enddo
         enddo
         !DEV_OMP end parallel do
         !
      end subroutine l4_devxlib_memcpy_h2h_async_l5d
!
      module subroutine l4_devxlib_memcpy_h2h_async_l6d(array_out, array_in, async_id, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3, &
                                            range4, lbound4, &
                                            range5, lbound5, &
                                            range6, lbound6 )
         implicit none
         !
         logical(int32), intent(inout) :: array_out(:,:,:,:,:,:)
         logical(int32), intent(in)    :: array_in(:,:,:,:,:,:)
         integer(kind=dxl_async_kind), intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2), range6(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5, lbound6
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         integer :: i5, d5s, d5e
         integer :: lbound5_, range5_(2)
         integer :: i6, d6s, d6e
         integer :: lbound6_, range6_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(array_out, 4)/)
         if (present(range4)) range4_=range4 
         !
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         lbound5_=1
         if (present(lbound5)) lbound5_=lbound5 
         range5_=(/1,size(array_out, 5)/)
         if (present(range5)) range5_=range5 
         !
         d5s = range5_(1) -lbound5_ +1
         d5e = range5_(2) -lbound5_ +1
         !
         lbound6_=1
         if (present(lbound6)) lbound6_=lbound6 
         range6_=(/1,size(array_out, 6)/)
         if (present(range6)) range6_=range6 
         !
         d6s = range6_(1) -lbound6_ +1
         d6e = range6_(2) -lbound6_ +1
         !
         !
         !DEV_OMP parallel do collapse(6)
         do i6 = d6s, d6e
         do i5 = d5s, d5e
         do i4 = d4s, d4e
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3,i4,i5,i6 ) = array_in(i1,i2,i3,i4,i5,i6 )
         enddo
         enddo
         enddo
         enddo
         enddo
         enddo
         !DEV_OMP end parallel do
         !
      end subroutine l4_devxlib_memcpy_h2h_async_l6d
!

endsubmodule devxlib_memcpy_h2h

#define HANDLE_ERROR( return_err )  call cudaErrorCheck( return_err, errored )

subroutine cudaErrorCheck( err, b )
   use cuda_runtime_h
   implicit none
   
   integer (KIND(cudaSuccess)), intent(in) :: err
   
   character, pointer :: string_err(:)
   integer :: i
   logical :: b
   
   b = .false.
   if ( err /= cudaSuccess ) then
       
       call C_F_POINTER( cudaGetErrorString( err ), string_err, [1] )
       i = 1
       do while ( string_err( i ) /= C_NULL_CHAR )
           i = i + 1
       enddo
   
       !print *, 'CUDA Error Detected'
       call dxlib_errore("devxlib", "CUDA Error Detected " // string_err( 1:i ), i)
       b = .true.
   endif

end subroutine cudaErrorCheck

module c_allocation
   use ISO_C_BINDING
   implicit none
   private
   public c_malloc, c_free

   interface

      function c_malloc(size) bind(C,name='malloc')
         import
         implicit none
         type(C_PTR) c_malloc
         integer(C_SIZE_T), value :: size
      end function c_malloc

      subroutine c_free(ptr) bind(C,name='free')
         import
         implicit none
         type(C_PTR), value :: ptr
      end subroutine c_free
   end interface
   
end module c_allocation

module offloadable_allocation_cudac
  
  
  implicit none

contains

subroutine allocate_(n_bytes, cpu_ptr, gpu_ptr, pinned)
   use, intrinsic :: ISO_C_BINDING
   use c_allocation, only : c_malloc
   use cuda_runtime_h, only : cudaMalloc, cudaMallocHost

   implicit none
   integer(c_size_t),intent(in)  :: n_bytes
   type(c_ptr) :: cpu_ptr
   type(c_ptr) :: gpu_ptr
   logical, intent(in) :: pinned
   
   logical :: errored = .false.
   
   HANDLE_ERROR( cudaMalloc( gpu_ptr, n_bytes ) )
   if (pinned) then
      HANDLE_ERROR( cudaMallocHost( cpu_ptr, n_bytes ) )
   else
      cpu_ptr = c_malloc (n_bytes)
   endif
end subroutine allocate_

subroutine deallocate_(cpu_ptr, gpu_ptr, pinned)
   use, intrinsic :: ISO_C_BINDING
   use c_allocation, only : c_free
   use cuda_runtime_h, only : cudaFree, cudaFreeHost
   implicit none
   type(c_ptr) :: cpu_ptr
   type(c_ptr) :: gpu_ptr
   logical, intent(in) :: pinned
   
   logical :: errored = .false.
   
   HANDLE_ERROR( cudaFree( gpu_ptr ) )
   if (pinned) then
      HANDLE_ERROR( cudaFreeHost( cpu_ptr ) )
   else
      CALL c_free (cpu_ptr)
   endif
end subroutine deallocate_
end module offloadable_allocation_cudac

! This file is part of fortran_tester
! Copyright 2015 Pierre de Buyl and Peter Colberg
!           2016 Pierre de Buyl and Stefano Szaghi
!           2018 Pierre de Buyl and Pietro Bonfa
! License: BSD

!> Routines to test Fortran programs
!!
!! fortran_tester is a pure-Fortran module. It provides a datatype to hold test results and
!! routines to test for equality, closeness, and positivity of variables. The routines are
!! overloaded and the resulting interface consists of a small number of names.

module devxlib_tester_fbuff
  use, intrinsic :: iso_fortran_env, only : int8, int16, int32, int64, real32, real64

  implicit none
  private
  public :: tester_t

  !> The main **tester** class.
  type :: tester_t
     integer(int32) :: n_errors=0_int32                         !< Number of errors.
     integer(int32) :: n_tests=0_int32                          !< Number of tests.
     real(real32)   :: tolerance32=2._real32*epsilon(1._real32) !< Real tolerance, 32 bits.
     real(real64)   :: tolerance64=2._real64*epsilon(1._real64) !< Real tolerance, 64 bits.
   contains
     procedure :: init                           !< Initialize the tester.
     procedure :: print                          !< Print tests results.
     generic, public :: assert_equal =>     &
                        assert_equal_i8,    &
                        assert_equal_i16,   &
                        assert_equal_i32,   &
                        assert_equal_i64,   &
                        assert_equal_r32,   &
                        assert_equal_r64,   &
                        assert_equal_c32,   &
                        assert_equal_c64,   &
                        assert_equal_l,     &
                        assert_equal_i8_1,  &
                        assert_equal_i16_1, &
                        assert_equal_i32_1, &
                        assert_equal_i64_1, &
                        assert_equal_r32_1, &
                        assert_equal_r64_1, &
                        assert_equal_c32_1, &
                        assert_equal_c64_1, &
                        assert_equal_l_1         !< Check if two values (integer, real, complex or logical) are equal.
     procedure, private :: assert_equal_i8       !< Check if two integers (8  bits) are equal.
     procedure, private :: assert_equal_i16      !< Check if two integers (16 bits) are equal.
     procedure, private :: assert_equal_i32      !< Check if two integers (32 bits) are equal.
     procedure, private :: assert_equal_i64      !< Check if two integers (64 bits) are equal.
     procedure, private :: assert_equal_r32      !< Check if two reals (32 bits) are equal.
     procedure, private :: assert_equal_r64      !< Check if two reals (64 bits) are equal.
     procedure, private :: assert_equal_c32      !< Check if two complex numbers (32 bits) are equal.
     procedure, private :: assert_equal_c64      !< Check if two complex numbers (64 bits) are equal.
     procedure, private :: assert_equal_l        !< Check if two logicals are equal.
     procedure, private :: assert_equal_i8_1     !< Check if two integer (8  bits) arrays (rank 1) are equal.
     procedure, private :: assert_equal_i16_1    !< Check if two integer (16 bits) arrays (rank 1) are equal.
     procedure, private :: assert_equal_i32_1    !< Check if two integer (32 bits) arrays (rank 1) are equal.
     procedure, private :: assert_equal_i64_1    !< Check if two integer (64 bits) arrays (rank 1) are equal.
     procedure, private :: assert_equal_r32_1    !< Check if two real (32 bits) arrays (rank 1) are equal.
     procedure, private :: assert_equal_r64_1    !< Check if two real (64 bits) arrays (rank 1) are equal.
     procedure, private :: assert_equal_c32_1    !< Check if two complex (32 bits) arrays (rank 1) are equal.
     procedure, private :: assert_equal_c64_1    !< Check if two complex (64 bits) arrays (rank 1) are equal.
     procedure, private :: assert_equal_l_1      !< Check if two logical arrays (rank 1) are equal.
     generic, public :: assert_positive =>     &
                        assert_positive_i8,    &
                        assert_positive_i16,   &
                        assert_positive_i32,   &
                        assert_positive_i64,   &
                        assert_positive_r32,   &
                        assert_positive_r64,   &
                        assert_positive_i8_1,  &
                        assert_positive_i16_1, &
                        assert_positive_i32_1, &
                        assert_positive_i64_1, &
                        assert_positive_r32_1, &
                        assert_positive_r64_1    !< Check if a number (integer or real) is positive.
     procedure, private :: assert_positive_i8    !< Check if a integer (8  bits) is positive.
     procedure, private :: assert_positive_i16   !< Check if a integer (16 bits) is positive.
     procedure, private :: assert_positive_i32   !< Check if a integer (32 bits) is positive.
     procedure, private :: assert_positive_i64   !< Check if a integer (64 bits) is positive.
     procedure, private :: assert_positive_r32   !< Check if a real (32 bits) is positive.
     procedure, private :: assert_positive_r64   !< Check if a real (64 bits) is positive.
     procedure, private :: assert_positive_i8_1  !< Check if a integer (8  bits) array (rank 1) is positive.
     procedure, private :: assert_positive_i16_1 !< Check if a integer (16 bits) array (rank 1) is positive.
     procedure, private :: assert_positive_i32_1 !< Check if a integer (32 bits) array (rank 1) is positive.
     procedure, private :: assert_positive_i64_1 !< Check if a integer (64 bits) array (rank 1) is positive.
     procedure, private :: assert_positive_r32_1 !< Check if a real (32 bits) array (rank 1) is positive.
     procedure, private :: assert_positive_r64_1 !< Check if a real (64 bits) array (rank 1) is positive.
     generic, public :: assert_close =>     &
                        assert_close_r32,   &
                        assert_close_r64,   &
                        assert_close_c32,   &
                        assert_close_c64,   &
                        assert_close_r32_1, &
                        assert_close_r64_1, &
                        assert_close_c32_1, &
                        assert_close_c64_1       !< Check if two values (real or complex) are close with respect a tolerance.
     procedure, private :: assert_close_r32      !< Check if two reals (32 bits) are close with respect a tolerance.
     procedure, private :: assert_close_r64      !< Check if two reals (64 bits) are close with respect a tolerance.
     procedure, private :: assert_close_c32      !< Check if two complex numbers (32 bits) are close with respect a tolerance.
     procedure, private :: assert_close_c64      !< Check if two complex numbers (64 bits) are close with respect a tolerance.
     procedure, private :: assert_close_r32_1    !< Check if two real (32 bits) arrays (rank 1) are close with respect a tolerance.
     procedure, private :: assert_close_r64_1    !< Check if two real (64 bits) arrays (rank 1) are close with respect a tolerance.
     procedure, private :: assert_close_c32_1    !< Check if two complex (32 bits) arrays (rank 1) are close with respect a tolerance.
     procedure, private :: assert_close_c64_1    !< Check if two complex (64 bits) arrays (rank 1) are close with respect a tolerance.
  end type tester_t

contains

  !> Initialize the tester.
  subroutine init(this, tolerance32, tolerance64)
    class(tester_t), intent(out)          :: this        !< The tester.
    real(real32),    intent(in), optional :: tolerance32 !< Real tolerance, 32 bits.
    real(real64),    intent(in), optional :: tolerance64 !< Real tolerance, 64 bits.

    this% n_errors = 0
    this% n_tests = 0

    if (present(tolerance64)) then
       this% tolerance64 = tolerance64
    else
       this% tolerance64 = 2._real64*epsilon(1._real64)
    end if

    if (present(tolerance32)) then
       this% tolerance32 = tolerance32
    else
       this% tolerance32 = 2._real32*epsilon(1._real32)
    end if

  end subroutine init

  !> Print tests results.
  subroutine print(this, errorstop)
    class(tester_t), intent(in)           :: this      !< The tester.
    logical,         intent(in), optional :: errorstop !< Flag to activate error stop if one test fails.
    !
    logical :: do_errorstop
    if (present(errorstop)) then
       do_errorstop = errorstop
    else
       do_errorstop = .true.
    end if
    !
    !write(6,*) 'fortran_tester:', this% n_errors, ' error(s) for', this% n_tests, 'test(s)'
    !
    write(6,"(/,a)") "# Test SUMMARY:"
    write(6,"(3x,a,i5)") "# passed: ", this% n_tests -this% n_errors
    write(6,"(3x,a,i5)") "# failed: ", this% n_errors
    write(6,"()")
    !
    if (this% n_errors == 0) then
       !write(6,*) 'fortran_tester: all tests succeeded'
    else
       if (do_errorstop) then
          stop 1
       !else
       !   write(6,*) 'fortran_tester: tests failed'
       endif
    end if
    !
  end subroutine print

  !> Check if two integers (8 bits) are equal.
  subroutine assert_equal_i8(this, i1, i2, fail)
    class(tester_t), intent(inout)        :: this !< The tester.
    integer(int8),   intent(in)           :: i1   !< Value to compare.
    integer(int8),   intent(in)           :: i2   !< Value to compare.
    logical,         intent(in), optional :: fail !< Fail flag.

    this% n_tests = this% n_tests + 1
    if (i1 .ne. i2) then
       if (.not. present(fail) .or. (present(fail) .and. fail .eqv. .false.)) then
          this% n_errors = this% n_errors + 1
       end if
    end if

  end subroutine assert_equal_i8

  !> Check if two integers (16 bits) are equal.
  subroutine assert_equal_i16(this, i1, i2, fail)
    class(tester_t), intent(inout)        :: this   !< The tester.
    integer(int16),  intent(in)           :: i1     !< Value to compare.
    integer(int16),  intent(in)           :: i2     !< Value to compare.
    logical,         intent(in), optional :: fail   !< Fail flag.

    this% n_tests = this% n_tests + 1
    if (i1 .ne. i2) then
       if (.not. present(fail) .or. (present(fail) .and. fail .eqv. .false.)) then
          this% n_errors = this% n_errors + 1
       end if
    end if

  end subroutine assert_equal_i16

  !> Check if two integers (32 bits) are equal.
  subroutine assert_equal_i32(this, i1, i2, fail)
    class(tester_t), intent(inout)        :: this !< The tester.
    integer(int32),  intent(in)           :: i1   !< Value to compare.
    integer(int32),  intent(in)           :: i2   !< Value to compare.
    logical,         intent(in), optional :: fail !< Fail flag.

    this% n_tests = this% n_tests + 1
    if (i1 .ne. i2) then
       if (.not. present(fail) .or. (present(fail) .and. fail .eqv. .false.)) then
          this% n_errors = this% n_errors + 1
       end if
    end if

  end subroutine assert_equal_i32

  !> Check if two integers (64 bits) are equal.
  subroutine assert_equal_i64(this, i1, i2, fail)
    class(tester_t), intent(inout)        :: this !< The tester.
    integer(int64),  intent(in)           :: i1   !< Value to compare.
    integer(int64),  intent(in)           :: i2   !< Value to compare.
    logical,         intent(in), optional :: fail !< Fail flag.

    this% n_tests = this% n_tests + 1
    if (i1 .ne. i2) then
       if (.not. present(fail) .or. (present(fail) .and. fail .eqv. .false.)) then
          this% n_errors = this% n_errors + 1
       end if
    end if

  end subroutine assert_equal_i64

  !> Check if two reals (32 bits) are equal.
  subroutine assert_equal_r32(this, r1, r2, fail)
    class(tester_t), intent(inout)        :: this !< The tester.
    real(real32),    intent(in)           :: r1   !< Value to compare.
    real(real32),    intent(in)           :: r2   !< Value to compare.
    logical,         intent(in), optional :: fail !< Fail flag.

    this% n_tests = this% n_tests + 1
    if (r1 .ne. r2) then
       if (.not. present(fail) .or. (present(fail) .and. fail .eqv. .false.)) then
          this% n_errors = this% n_errors + 1
       end if
    end if

  end subroutine assert_equal_r32

  !> Check if two reals (64 bits) are equal.
  subroutine assert_equal_r64(this, r1, r2, fail)
    class(tester_t), intent(inout)        :: this !< The tester.
    real(real64),    intent(in)           :: r1   !< Value to compare.
    real(real64),    intent(in)           :: r2   !< Value to compare.
    logical,         intent(in), optional :: fail !< Fail flag.

    this% n_tests = this% n_tests + 1
    if (r1 .ne. r2) then
       if (.not. present(fail) .or. (present(fail) .and. fail .eqv. .false.)) then
          this% n_errors = this% n_errors + 1
       end if
    end if

  end subroutine assert_equal_r64

  !> Check if two complex numbers (32 bits) are equal.
  subroutine assert_equal_c32(this, c1, c2, fail)
    class(tester_t), intent(inout)           :: this !< The tester.
    complex(real32),    intent(in)           :: c1   !< Value to compare.
    complex(real32),    intent(in)           :: c2   !< Value to compare.
    logical,            intent(in), optional :: fail !< Fail flag.

    this% n_tests = this% n_tests + 1
    if (c1 .ne. c2) then
       if (.not. present(fail) .or. (present(fail) .and. fail .eqv. .false.)) then
          this% n_errors = this% n_errors + 1
       end if
    end if

  end subroutine assert_equal_c32

  !> Check if two complex numbers (64 bits) are equal.
  subroutine assert_equal_c64(this, c1, c2, fail)
    class(tester_t), intent(inout)           :: this !< The tester.
    complex(real64),    intent(in)           :: c1   !< Value to compare.
    complex(real64),    intent(in)           :: c2   !< Value to compare.
    logical,            intent(in), optional :: fail !< Fail flag.

    this% n_tests = this% n_tests + 1
    if (c1 .ne. c2) then
       if (.not. present(fail) .or. (present(fail) .and. fail .eqv. .false.)) then
          this% n_errors = this% n_errors + 1
       end if
    end if

  end subroutine assert_equal_c64

  !> Check if two logicals are equal.
 subroutine assert_equal_l(this, l1, l2, fail)
    class(tester_t), intent(inout)        :: this !< The tester.
    logical,         intent(in)           :: l1   !< Value to compare.
    logical,         intent(in)           :: l2   !< Value to compare.
    logical,         intent(in), optional :: fail !< Fail flag.

    this% n_tests = this% n_tests + 1
    if (l1 .neqv. l2) then
       if (.not. present(fail) .or. (present(fail) .and. fail .eqv. .false.)) then
          this% n_errors = this% n_errors + 1
       end if
    end if

  end subroutine assert_equal_l

  !> Check if two integer (8 bits) arrays (rank 1) are equal.
  subroutine assert_equal_i8_1(this, i1, i2, fail)
    class(tester_t),             intent(inout)        :: this !< The tester.
    integer(int8), dimension(:), intent(in)           :: i1   !< Value to compare.
    integer(int8), dimension(:), intent(in)           :: i2   !< Value to compare.
    logical,                     intent(in), optional :: fail !< Fail flag.

    this% n_tests = this% n_tests + 1

    if ( size(i1) .ne. size(i2) ) then
       if (.not. present(fail) .or. (present(fail) .and. fail .eqv. .false.)) then
          this% n_errors = this% n_errors + 1
       end if
    else
       if ( maxval(abs(i1-i2)) > 0 ) then
          if (.not. present(fail) .or. (present(fail) .and. fail .eqv. .false.)) then
             this% n_errors = this% n_errors + 1
          end if
       end if
    end if

  end subroutine assert_equal_i8_1

  !> Check if two integer (16 bits) arrays (rank 1) are equal.
  subroutine assert_equal_i16_1(this, i1, i2, fail)
    class(tester_t),              intent(inout)        :: this !< The tester.
    integer(int16), dimension(:), intent(in)           :: i1   !< Value to compare.
    integer(int16), dimension(:), intent(in)           :: i2   !< Value to compare.
    logical,                      intent(in), optional :: fail !< Fail flag.

    this% n_tests = this% n_tests + 1

    if ( size(i1) .ne. size(i2) ) then
       if (.not. present(fail) .or. (present(fail) .and. fail .eqv. .false.)) then
          this% n_errors = this% n_errors + 1
       end if
    else
       if ( maxval(abs(i1-i2)) > 0 ) then
          if (.not. present(fail) .or. (present(fail) .and. fail .eqv. .false.)) then
             this% n_errors = this% n_errors + 1
          end if
       end if
    end if

  end subroutine assert_equal_i16_1

  !> Check if two integer (32 bits) arrays (rank 1) are equal.
  subroutine assert_equal_i32_1(this, i1, i2, fail)
    class(tester_t),              intent(inout)        :: this !< The tester.
    integer(int32), dimension(:), intent(in)           :: i1   !< Value to compare.
    integer(int32), dimension(:), intent(in)           :: i2   !< Value to compare.
    logical,                      intent(in), optional :: fail !< Fail flag.

    this% n_tests = this% n_tests + 1

    if ( size(i1) .ne. size(i2) ) then
       if (.not. present(fail) .or. (present(fail) .and. fail .eqv. .false.)) then
          this% n_errors = this% n_errors + 1
       end if
    else
       if ( maxval(abs(i1-i2)) > 0 ) then
          if (.not. present(fail) .or. (present(fail) .and. fail .eqv. .false.)) then
             this% n_errors = this% n_errors + 1
          end if
       end if
    end if

  end subroutine assert_equal_i32_1

  !> Check if two integer (64 bits) arrays (rank 1) are equal.
  subroutine assert_equal_i64_1(this, i1, i2, fail)
    class(tester_t),              intent(inout)        :: this !< The tester.
    integer(int64), dimension(:), intent(in)           :: i1   !< Value to compare.
    integer(int64), dimension(:), intent(in)           :: i2   !< Value to compare.
    logical,                      intent(in), optional :: fail !< Fail flag.

    this% n_tests = this% n_tests + 1

    if ( size(i1) .ne. size(i2) ) then
       if (.not. present(fail) .or. (present(fail) .and. fail .eqv. .false.)) then
          this% n_errors = this% n_errors + 1
       end if
    else
       if ( maxval(abs(i1-i2)) > 0 ) then
          if (.not. present(fail) .or. (present(fail) .and. fail .eqv. .false.)) then
             this% n_errors = this% n_errors + 1
          end if
       end if
    end if

  end subroutine assert_equal_i64_1

  !> Check if two real (32 bits) arrays (rank 1) are equal.
  subroutine assert_equal_r32_1(this, r1, r2, fail)
    class(tester_t),            intent(inout)        :: this !< The tester.
    real(real32), dimension(:), intent(in)           :: r1   !< Value to compare.
    real(real32), dimension(:), intent(in)           :: r2   !< Value to compare.
    logical,                    intent(in), optional :: fail !< Fail flag.

    this% n_tests = this% n_tests + 1

    if ( size(r1) .ne. size(r2) ) then
       if (.not. present(fail) .or. (present(fail) .and. fail .eqv. .false.)) then
          this% n_errors = this% n_errors + 1
       end if
    else
       if ( maxval(abs(r1-r2)) > 0 ) then
          if (.not. present(fail) .or. (present(fail) .and. fail .eqv. .false.)) then
             this% n_errors = this% n_errors + 1
          end if
       end if
    end if

  end subroutine assert_equal_r32_1

  !> Check if two real (64 bits) arrays (rank 1) are equal.
  subroutine assert_equal_r64_1(this, r1, r2, fail)
    class(tester_t),            intent(inout)        :: this !< The tester.
    real(real64), dimension(:), intent(in)           :: r1   !< Value to compare.
    real(real64), dimension(:), intent(in)           :: r2   !< Value to compare.
    logical,                    intent(in), optional :: fail !< Fail flag.

    this% n_tests = this% n_tests + 1

    if ( size(r1) .ne. size(r2) ) then
       if (.not. present(fail) .or. (present(fail) .and. fail .eqv. .false.)) then
          this% n_errors = this% n_errors + 1
       end if
    else
       if ( maxval(abs(r1-r2)) > 0 ) then
          if (.not. present(fail) .or. (present(fail) .and. fail .eqv. .false.)) then
             this% n_errors = this% n_errors + 1
          end if
       end if
    end if

  end subroutine assert_equal_r64_1
  
  !> Check if two complex (32 bits) arrays (rank 1) are equal.
  subroutine assert_equal_c32_1(this, c1, c2, fail)
    class(tester_t),               intent(inout)        :: this !< The tester.
    complex(real32), dimension(:), intent(in)           :: c1   !< Value to compare.
    complex(real32), dimension(:), intent(in)           :: c2   !< Value to compare.
    logical,                       intent(in), optional :: fail !< Fail flag.

    this% n_tests = this% n_tests + 1

    if ( size(c1) .ne. size(c2) ) then
       if (.not. present(fail) .or. (present(fail) .and. fail .eqv. .false.)) then
          this% n_errors = this% n_errors + 1
       end if
    else
       if ( maxval(abs(c1-c2)) > 0 ) then
          if (.not. present(fail) .or. (present(fail) .and. fail .eqv. .false.)) then
             this% n_errors = this% n_errors + 1
          end if
       end if
    end if

  end subroutine assert_equal_c32_1

  !> Check if two complex (64 bits) arrays (rank 1) are equal.
  subroutine assert_equal_c64_1(this, c1, c2, fail)
    class(tester_t),               intent(inout)        :: this !< The tester.
    complex(real64), dimension(:), intent(in)           :: c1   !< Value to compare.
    complex(real64), dimension(:), intent(in)           :: c2   !< Value to compare.
    logical,                       intent(in), optional :: fail !< Fail flag.

    this% n_tests = this% n_tests + 1

    if ( size(c1) .ne. size(c2) ) then
       if (.not. present(fail) .or. (present(fail) .and. fail .eqv. .false.)) then
          this% n_errors = this% n_errors + 1
       end if
    else
       if ( maxval(abs(c1-c2)) > 0 ) then
          if (.not. present(fail) .or. (present(fail) .and. fail .eqv. .false.)) then
             this% n_errors = this% n_errors + 1
          end if
       end if
    end if

  end subroutine assert_equal_c64_1

  !> Check if two logical arrays (rank 1) are equal.
  subroutine assert_equal_l_1(this, l1, l2, fail)
    class(tester_t), intent(inout)            :: this !< The tester.
    logical,         intent(in), dimension(:) :: l1   !< Value to compare.
    logical,         intent(in), dimension(:) :: l2   !< Value to compare.
    logical,         intent(in), optional     :: fail !< Fail flag.

    integer :: k

    this% n_tests = this% n_tests + 1

    if ( size(l1) .ne. size(l2) ) then
       if (.not. present(fail) .or. (present(fail) .and. fail .eqv. .false.)) then
          this% n_errors = this% n_errors + 1
       end if
    else
       do k = 1, size(l1)
          if (l1(k) .neqv. l2(k)) then
             if (.not. present(fail) .or. (present(fail) .and. fail .eqv. .false.)) then
                this% n_errors = this% n_errors + 1
             end if
             exit
          end if
       end do
    end if

  end subroutine assert_equal_l_1

  !> Check if a integer (32 bits) is positive.
  subroutine assert_positive_i8(this, i, fail)
    class(tester_t), intent(inout)        :: this !< The tester.
    integer(int8),   intent(in)           :: i    !< Value to check.
    logical,         intent(in), optional :: fail !< Fail flag.

    this% n_tests = this% n_tests + 1
    if (i < 0) then
       if (.not. present(fail) .or. (present(fail) .and. fail .eqv. .false.)) then
          this% n_errors = this% n_errors + 1
       end if
    end if

  end subroutine assert_positive_i8

  !> Check if a integer (16 bits) is positive.
  subroutine assert_positive_i16(this, i, fail)
    class(tester_t), intent(inout)        :: this !< The tester.
    integer(int16),  intent(in)           :: i    !< Value to check.
    logical,         intent(in), optional :: fail !< Fail flag.

    this% n_tests = this% n_tests + 1
    if (i < 0) then
       if (.not. present(fail) .or. (present(fail) .and. fail .eqv. .false.)) then
          this% n_errors = this% n_errors + 1
       end if
    end if

  end subroutine assert_positive_i16

  !> Check if a integer (32 bits) is positive.
  subroutine assert_positive_i32(this, i, fail)
    class(tester_t), intent(inout)        :: this !< The tester.
    integer(int32),  intent(in)           :: i    !< Value to check.
    logical,         intent(in), optional :: fail !< Fail flag.

    this% n_tests = this% n_tests + 1
    if (i < 0) then
       if (.not. present(fail) .or. (present(fail) .and. fail .eqv. .false.)) then
          this% n_errors = this% n_errors + 1
       end if
    end if

  end subroutine assert_positive_i32

  !> Check if a integer (32 bits) is positive.
  subroutine assert_positive_i64(this, i, fail)
    class(tester_t), intent(inout)        :: this !< The tester.
    integer(int64),  intent(in)           :: i    !< Value to check.
    logical,         intent(in), optional :: fail !< Fail flag.

    this% n_tests = this% n_tests + 1
    if (i < 0) then
       if (.not. present(fail) .or. (present(fail) .and. fail .eqv. .false.)) then
          this% n_errors = this% n_errors + 1
       end if
    end if

  end subroutine assert_positive_i64

  !> Check if a real (32 bits) is positive.
  subroutine assert_positive_r32(this, r, fail)
    class(tester_t), intent(inout)        :: this !< The tester.
    real(real32),    intent(in)           :: r    !< Value to check.
    logical,         intent(in), optional :: fail !< Fail flag.

    this% n_tests = this% n_tests + 1
    if (r < 0) then
       if (.not. present(fail) .or. (present(fail) .and. fail .eqv. .false.)) then
          this% n_errors = this% n_errors + 1
       end if
    end if

  end subroutine assert_positive_r32

  !> Check if a real (64 bits) is positive.
  subroutine assert_positive_r64(this, r, fail)
    class(tester_t), intent(inout)        :: this !< The tester.
    real(real64),    intent(in)           :: r    !< Value to check.
    logical,         intent(in), optional :: fail !< Fail flag.

    this% n_tests = this% n_tests + 1
    if (r < 0) then
       if (.not. present(fail) .or. (present(fail) .and. fail .eqv. .false.)) then
          this% n_errors = this% n_errors + 1
       end if
    end if

  end subroutine assert_positive_r64

  !> Check if a integer (8 bits) array (rank 1) is positive.
  subroutine assert_positive_i8_1(this, i, fail)
    class(tester_t),             intent(inout)        :: this !< The tester.
    integer(int8), dimension(:), intent(in)           :: i    !< Value to check.
    logical,                     intent(in), optional :: fail !< Fail flag.

    this% n_tests = this% n_tests + 1

    if ( minval(i) < 0 ) then
       if (.not. present(fail) .or. (present(fail) .and. fail .eqv. .false.)) then
          this% n_errors = this% n_errors + 1
       end if
    end if

  end subroutine assert_positive_i8_1

  !> Check if a integer (16 bits) array (rank 1) is positive.
  subroutine assert_positive_i16_1(this, i, fail)
    class(tester_t),              intent(inout)        :: this !< The tester.
    integer(int16), dimension(:), intent(in)           :: i    !< Value to check.
    logical,                      intent(in), optional :: fail !< Fail flag.

    this% n_tests = this% n_tests + 1

    if ( minval(i) < 0 ) then
       if (.not. present(fail) .or. (present(fail) .and. fail .eqv. .false.)) then
          this% n_errors = this% n_errors + 1
       end if
    end if

  end subroutine assert_positive_i16_1

  !> Check if a integer (32 bits) array (rank 1) is positive.
  subroutine assert_positive_i32_1(this, i, fail)
    class(tester_t),              intent(inout)        :: this !< The tester.
    integer(int32), dimension(:), intent(in)           :: i    !< Value to check.
    logical,                      intent(in), optional :: fail !< Fail flag.

    this% n_tests = this% n_tests + 1

    if ( minval(i) < 0 ) then
       if (.not. present(fail) .or. (present(fail) .and. fail .eqv. .false.)) then
          this% n_errors = this% n_errors + 1
       end if
    end if

  end subroutine assert_positive_i32_1

  !> Check if a integer (64 bits) array (rank 1) is positive.
  subroutine assert_positive_i64_1(this, i, fail)
    class(tester_t),              intent(inout)        :: this !< The tester.
    integer(int64), dimension(:), intent(in)           :: i    !< Value to check.
    logical,                      intent(in), optional :: fail !< Fail flag.

    this% n_tests = this% n_tests + 1

    if ( minval(i) < 0 ) then
       if (.not. present(fail) .or. (present(fail) .and. fail .eqv. .false.)) then
          this% n_errors = this% n_errors + 1
       end if
    end if

  end subroutine assert_positive_i64_1

  !> Check if a real (32 bits) array (rank 1) is positive.
  subroutine assert_positive_r32_1(this, r, fail)
    class(tester_t),            intent(inout)        :: this !< The tester.
    real(real32), dimension(:), intent(in)           :: r    !< Value to check.
    logical,                    intent(in), optional :: fail !< Fail flag.

    this% n_tests = this% n_tests + 1

    if ( minval(r) < 0 ) then
       if (.not. present(fail) .or. (present(fail) .and. fail .eqv. .false.)) then
          this% n_errors = this% n_errors + 1
       end if
    end if

  end subroutine assert_positive_r32_1

  !> Check if a real (64 bits) array (rank 1) is positive.
  subroutine assert_positive_r64_1(this, r, fail)
    class(tester_t),            intent(inout)        :: this !< The tester.
    real(real64), dimension(:), intent(in)           :: r    !< Value to check.
    logical,                    intent(in), optional :: fail !< Fail flag.

    this% n_tests = this% n_tests + 1

    if ( minval(r) < 0 ) then
       if (.not. present(fail) .or. (present(fail) .and. fail .eqv. .false.)) then
          this% n_errors = this% n_errors + 1
       end if
    end if

  end subroutine assert_positive_r64_1

  !> Check if two reals (32 bits) are close with respect a tolerance.
  subroutine assert_close_r32(this, r1, r2, fail)
    class(tester_t), intent(inout)        :: this !< The tester.
    real(real32),    intent(in)           :: r1   !< Value to compare.
    real(real32),    intent(in)           :: r2   !< Value to compare.
    logical,         intent(in), optional :: fail !< Fail flag.

    this% n_tests = this% n_tests + 1

    if ( abs(r1-r2) > this% tolerance32 ) then
       if (.not. present(fail) .or. (present(fail) .and. fail .eqv. .false.)) then
          this% n_errors = this% n_errors + 1
       end if
    end if

  end subroutine assert_close_r32

  !> Check if two reals (64 bits) are close with respect a tolerance.
  subroutine assert_close_r64(this, r1, r2, fail)
    class(tester_t),  intent(inout)        :: this !< The tester.
    real(real64),     intent(in)           :: r1   !< Value to compare.
    real(real64),     intent(in)           :: r2   !< Value to compare.
    logical,          intent(in), optional :: fail !< Fail flag.

    this% n_tests = this% n_tests + 1

    if ( abs(r1-r2) > this% tolerance64 ) then
       if (.not. present(fail) .or. (present(fail) .and. fail .eqv. .false.)) then
          this% n_errors = this% n_errors + 1
       end if
    end if

  end subroutine assert_close_r64

  !> Check if two real (32 bits) arrays (rank 1) are close with respect a tolerance.
  subroutine assert_close_r32_1(this, r1, r2, fail)
    class(tester_t), intent(inout)            :: this !< The tester.
    real(real32),    intent(in), dimension(:) :: r1   !< Value to compare.
    real(real32),    intent(in), dimension(:) :: r2   !< Value to compare.
    logical,         intent(in), optional     :: fail !< Fail flag.

    this% n_tests = this% n_tests + 1

    if ( size(r1) .ne. size(r2) ) then
       if (.not. present(fail) .or. (present(fail) .and. fail .eqv. .false.)) then
          this% n_errors = this% n_errors + 1
       end if
    else
       if ( maxval(abs(r1-r2)) > this% tolerance64 ) then
          if (.not. present(fail) .or. (present(fail) .and. fail .eqv. .false.)) then
             this% n_errors = this% n_errors + 1
          end if
       end if
    end if

  end subroutine assert_close_r32_1

  !> Check if two real (64 bits) arrays (rank 1) are close with respect a tolerance.
  subroutine assert_close_r64_1(this, r1, r2, fail)
    class(tester_t), intent(inout)            :: this !< The tester.
    real(real64),    intent(in), dimension(:) :: r1   !< Value to compare.
    real(real64),    intent(in), dimension(:) :: r2   !< Value to compare.
    logical,         intent(in), optional     :: fail !< Fail flag.

    this% n_tests = this% n_tests + 1

    if ( size(r1) .ne. size(r2) ) then
       if (.not. present(fail) .or. (present(fail) .and. fail .eqv. .false.)) then
          this% n_errors = this% n_errors + 1
       end if
    else
       if ( maxval(abs(r1-r2)) > this% tolerance64 ) then
          if (.not. present(fail) .or. (present(fail) .and. fail .eqv. .false.)) then
             this% n_errors = this% n_errors + 1
          end if
       end if
    end if

  end subroutine assert_close_r64_1
  
  !> Check if two complex numbers (32 bits) are close with respect a tolerance.
  subroutine assert_close_c32(this, c1, c2, fail)
    class(tester_t), intent(inout)        :: this !< The tester.
    complex(real32), intent(in)           :: c1   !< Value to compare.
    complex(real32), intent(in)           :: c2   !< Value to compare.
    logical,         intent(in), optional :: fail !< Fail flag.

    this% n_tests = this% n_tests + 1

    if ( abs(c1-c2) > this% tolerance32 ) then
       if (.not. present(fail) .or. (present(fail) .and. fail .eqv. .false.)) then
          this% n_errors = this% n_errors + 1
       end if
    end if

  end subroutine assert_close_c32

  !> Check if two complex numbers (64 bits) are close with respect a tolerance.
  subroutine assert_close_c64(this, r1, c2, fail)
    class(tester_t),  intent(inout)        :: this !< The tester.
    complex(real64),  intent(in)           :: r1   !< Value to compare.
    complex(real64),  intent(in)           :: c2   !< Value to compare.
    logical,          intent(in), optional :: fail !< Fail flag.

    this% n_tests = this% n_tests + 1

    if ( abs(r1-c2) > this% tolerance64 ) then
       if (.not. present(fail) .or. (present(fail) .and. fail .eqv. .false.)) then
          this% n_errors = this% n_errors + 1
       end if
    end if

  end subroutine assert_close_c64

  !> Check if two complex (32 bits) arrays (rank 1) are close with respect a tolerance.
  subroutine assert_close_c32_1(this, c1, c2, fail)
    class(tester_t), intent(inout)            :: this !< The tester.
    complex(real32), intent(in), dimension(:) :: c1   !< Value to compare.
    complex(real32), intent(in), dimension(:) :: c2   !< Value to compare.
    logical,         intent(in), optional     :: fail !< Fail flag.

    this% n_tests = this% n_tests + 1

    if ( size(c1) .ne. size(c2) ) then
       if (.not. present(fail) .or. (present(fail) .and. fail .eqv. .false.)) then
          this% n_errors = this% n_errors + 1
       end if
    else
       if ( maxval(abs(c1-c2)) > this% tolerance32 ) then
          if (.not. present(fail) .or. (present(fail) .and. fail .eqv. .false.)) then
             this% n_errors = this% n_errors + 1
          end if
       end if
    end if

  end subroutine assert_close_c32_1

  !> Check if two real (64 bits) arrays (rank 1) are close with respect a tolerance.
  subroutine assert_close_c64_1(this, c1, c2, fail)
    class(tester_t), intent(inout)            :: this !< The tester.
    complex(real64), intent(in), dimension(:) :: c1   !< Value to compare.
    complex(real64), intent(in), dimension(:) :: c2   !< Value to compare.
    logical,         intent(in), optional     :: fail !< Fail flag.

    this% n_tests = this% n_tests + 1

    if ( size(c1) .ne. size(c2) ) then
       if (.not. present(fail) .or. (present(fail) .and. fail .eqv. .false.)) then
          this% n_errors = this% n_errors + 1
       end if
    else
       if ( maxval(abs(c1-c2)) > this% tolerance64 ) then
          if (.not. present(fail) .or. (present(fail) .and. fail .eqv. .false.)) then
             this% n_errors = this% n_errors + 1
          end if
       end if
    end if

  end subroutine assert_close_c64_1

end module devxlib_tester_fbuff

!
! Copyright (C) 2021, MaX CoE
! Distributed under the MIT License 
! (license terms are at http://opensource.org/licenses/MIT).
!
!--
!
! Auxiliary functions
!
! AF: OpenACC support is incomplete !!
!
!==================================================================
!==================================================================
! *DO NOT EDIT*: automatically generated from device_auxfunc.jf90
!==================================================================
!==================================================================
!
#include<devxlib_macros.h>
#include<devxlib_defs.h>
!
!=======================================
!
submodule (devxlib_auxfunc) devxlib_auxfunc_mat_upd

   implicit none

   contains
!
      module subroutine dp_devxlib_mat_upd_dMd_r2d(ndim1, ndim2, mat, v1,op1, v2,op2, scal)
         !
         ! performs: mat(i,j) = scal * op1(v1(i)) * mat(i,j) * op2(v2(j))
         ! op = 'N', 'R', 'C',       'RC'
         !       x   1/x  conjg(x)   conjg(1/x)
         implicit none
         !   
         integer,      intent(in)    :: ndim1,ndim2
         real(real64), intent(inout) DEV_ATTR :: mat(:,:)
         real(real64), intent(in)    DEV_ATTR :: v1(:)
         real(real64), intent(in)    DEV_ATTR :: v2(:)
         character(1), intent(in)    :: op1, op2
         real(real64), optional, intent(in)  :: scal
         integer :: i,j
         !   
         if (op1=="N".and.op2=="N") then
            if (present(scal)) then
!DEV_CUF kernel do(2)
       !DEV_OMP parallel do default(shared), private(i,j), collapse(2)
               do j = 1, ndim2
                  do i = 1, ndim1
                     mat(i,j) = scal * v1(i) * mat(i,j) * v2(j)
                  enddo
               enddo

            else
!DEV_CUF kernel do(2)
       !DEV_OMP parallel do default(shared), private(i,j), collapse(2)
               do j = 1, ndim2
                  do i = 1, ndim1
                     mat(i,j) = v1(i) * mat(i,j) * v2(j)
                  enddo
               enddo

            endif
         elseif (op1=="R".and.op2=="R") then
            if (present(scal)) then
!DEV_CUF kernel do(2)
       !DEV_OMP parallel do default(shared), private(i,j), collapse(2)
               do j = 1, ndim2
                  do i = 1, ndim1
                     mat(i,j) = scal / v1(i) * mat(i,j) / v2(j)
                  enddo
               enddo

            else
!DEV_CUF kernel do(2)
       !DEV_OMP parallel do default(shared), private(i,j), collapse(2)
               do j = 1, ndim2
                  do i = 1, ndim1
                     mat(i,j) = mat(i,j) /v1(i) / v2(j)
                  enddo
               enddo

            endif
         else
            call devxlib_error("dp_mat_upd_dMd_r2d","invalid op1/op2",10)
         endif
         !
      end subroutine dp_devxlib_mat_upd_dMd_r2d
      !
      module subroutine dp_devxlib_mat_upd_dMd_c2d(ndim1, ndim2, mat, v1,op1, v2,op2, scal)
         !
         ! performs: mat(i,j) = scal * op1(v1(i)) * mat(i,j) * op2(v2(j))
         ! op = 'N', 'R', 'C',       'RC'
         !       x   1/x  conjg(x)   conjg(1/x)
         implicit none
         !   
         integer,      intent(in)    :: ndim1,ndim2
         complex(real64), intent(inout) DEV_ATTR :: mat(:,:)
         complex(real64), intent(in)    DEV_ATTR :: v1(:)
         complex(real64), intent(in)    DEV_ATTR :: v2(:)
         character(1), intent(in)    :: op1, op2
         complex(real64), optional, intent(in)  :: scal
         integer :: i,j
         !   
         if (op1=="N".and.op2=="N") then
            if (present(scal)) then
!DEV_CUF kernel do(2)
       !DEV_OMP parallel do default(shared), private(i,j), collapse(2)
               do j = 1, ndim2
                  do i = 1, ndim1
                     mat(i,j) = scal * v1(i) * mat(i,j) * v2(j)
                  enddo
               enddo

            else
!DEV_CUF kernel do(2)
       !DEV_OMP parallel do default(shared), private(i,j), collapse(2)
               do j = 1, ndim2
                  do i = 1, ndim1
                     mat(i,j) = v1(i) * mat(i,j) * v2(j)
                  enddo
               enddo

            endif
         elseif (op1=="R".and.op2=="R") then
            if (present(scal)) then
!DEV_CUF kernel do(2)
       !DEV_OMP parallel do default(shared), private(i,j), collapse(2)
               do j = 1, ndim2
                  do i = 1, ndim1
                     mat(i,j) = scal / v1(i) * mat(i,j) / v2(j)
                  enddo
               enddo

            else
!DEV_CUF kernel do(2)
       !DEV_OMP parallel do default(shared), private(i,j), collapse(2)
               do j = 1, ndim2
                  do i = 1, ndim1
                     mat(i,j) = mat(i,j) /v1(i) / v2(j)
                  enddo
               enddo

            endif
         elseif (op1=="C".and.op2=="C") then
            if (present(scal)) then
!DEV_CUF kernel do(2)
       !DEV_OMP parallel do default(shared), private(i,j), collapse(2)
               do j = 1, ndim2
                  do i = 1, ndim1
                     mat(i,j) = scal * conjg(v1(i)) * mat(i,j) * conjg(v2(j))
                  enddo
               enddo

            else
!DEV_CUF kernel do(2)
       !DEV_OMP parallel do default(shared), private(i,j), collapse(2)
               do j = 1, ndim2
                  do i = 1, ndim1
                     mat(i,j) = conjg(v1(i)) * mat(i,j) * conjg(v2(j))
                  enddo
               enddo

            endif
         else
            call devxlib_error("dp_mat_upd_dMd_c2d","invalid op1/op2",10)
         endif
         !
      end subroutine dp_devxlib_mat_upd_dMd_c2d
      !
      module subroutine sp_devxlib_mat_upd_dMd_r2d(ndim1, ndim2, mat, v1,op1, v2,op2, scal)
         !
         ! performs: mat(i,j) = scal * op1(v1(i)) * mat(i,j) * op2(v2(j))
         ! op = 'N', 'R', 'C',       'RC'
         !       x   1/x  conjg(x)   conjg(1/x)
         implicit none
         !   
         integer,      intent(in)    :: ndim1,ndim2
         real(real32), intent(inout) DEV_ATTR :: mat(:,:)
         real(real32), intent(in)    DEV_ATTR :: v1(:)
         real(real32), intent(in)    DEV_ATTR :: v2(:)
         character(1), intent(in)    :: op1, op2
         real(real32), optional, intent(in)  :: scal
         integer :: i,j
         !   
         if (op1=="N".and.op2=="N") then
            if (present(scal)) then
!DEV_CUF kernel do(2)
       !DEV_OMP parallel do default(shared), private(i,j), collapse(2)
               do j = 1, ndim2
                  do i = 1, ndim1
                     mat(i,j) = scal * v1(i) * mat(i,j) * v2(j)
                  enddo
               enddo

            else
!DEV_CUF kernel do(2)
       !DEV_OMP parallel do default(shared), private(i,j), collapse(2)
               do j = 1, ndim2
                  do i = 1, ndim1
                     mat(i,j) = v1(i) * mat(i,j) * v2(j)
                  enddo
               enddo

            endif
         elseif (op1=="R".and.op2=="R") then
            if (present(scal)) then
!DEV_CUF kernel do(2)
       !DEV_OMP parallel do default(shared), private(i,j), collapse(2)
               do j = 1, ndim2
                  do i = 1, ndim1
                     mat(i,j) = scal / v1(i) * mat(i,j) / v2(j)
                  enddo
               enddo

            else
!DEV_CUF kernel do(2)
       !DEV_OMP parallel do default(shared), private(i,j), collapse(2)
               do j = 1, ndim2
                  do i = 1, ndim1
                     mat(i,j) = mat(i,j) /v1(i) / v2(j)
                  enddo
               enddo

            endif
         else
            call devxlib_error("sp_mat_upd_dMd_r2d","invalid op1/op2",10)
         endif
         !
      end subroutine sp_devxlib_mat_upd_dMd_r2d
      !
      module subroutine sp_devxlib_mat_upd_dMd_c2d(ndim1, ndim2, mat, v1,op1, v2,op2, scal)
         !
         ! performs: mat(i,j) = scal * op1(v1(i)) * mat(i,j) * op2(v2(j))
         ! op = 'N', 'R', 'C',       'RC'
         !       x   1/x  conjg(x)   conjg(1/x)
         implicit none
         !   
         integer,      intent(in)    :: ndim1,ndim2
         complex(real32), intent(inout) DEV_ATTR :: mat(:,:)
         complex(real32), intent(in)    DEV_ATTR :: v1(:)
         complex(real32), intent(in)    DEV_ATTR :: v2(:)
         character(1), intent(in)    :: op1, op2
         complex(real32), optional, intent(in)  :: scal
         integer :: i,j
         !   
         if (op1=="N".and.op2=="N") then
            if (present(scal)) then
!DEV_CUF kernel do(2)
       !DEV_OMP parallel do default(shared), private(i,j), collapse(2)
               do j = 1, ndim2
                  do i = 1, ndim1
                     mat(i,j) = scal * v1(i) * mat(i,j) * v2(j)
                  enddo
               enddo

            else
!DEV_CUF kernel do(2)
       !DEV_OMP parallel do default(shared), private(i,j), collapse(2)
               do j = 1, ndim2
                  do i = 1, ndim1
                     mat(i,j) = v1(i) * mat(i,j) * v2(j)
                  enddo
               enddo

            endif
         elseif (op1=="R".and.op2=="R") then
            if (present(scal)) then
!DEV_CUF kernel do(2)
       !DEV_OMP parallel do default(shared), private(i,j), collapse(2)
               do j = 1, ndim2
                  do i = 1, ndim1
                     mat(i,j) = scal / v1(i) * mat(i,j) / v2(j)
                  enddo
               enddo

            else
!DEV_CUF kernel do(2)
       !DEV_OMP parallel do default(shared), private(i,j), collapse(2)
               do j = 1, ndim2
                  do i = 1, ndim1
                     mat(i,j) = mat(i,j) /v1(i) / v2(j)
                  enddo
               enddo

            endif
         elseif (op1=="C".and.op2=="C") then
            if (present(scal)) then
!DEV_CUF kernel do(2)
       !DEV_OMP parallel do default(shared), private(i,j), collapse(2)
               do j = 1, ndim2
                  do i = 1, ndim1
                     mat(i,j) = scal * conjg(v1(i)) * mat(i,j) * conjg(v2(j))
                  enddo
               enddo

            else
!DEV_CUF kernel do(2)
       !DEV_OMP parallel do default(shared), private(i,j), collapse(2)
               do j = 1, ndim2
                  do i = 1, ndim1
                     mat(i,j) = conjg(v1(i)) * mat(i,j) * conjg(v2(j))
                  enddo
               enddo

            endif
         else
            call devxlib_error("sp_mat_upd_dMd_c2d","invalid op1/op2",10)
         endif
         !
      end subroutine sp_devxlib_mat_upd_dMd_c2d
      !

end submodule devxlib_auxfunc_mat_upd

#include<device_macros.h>
!
interface dev_conjg
    !

    subroutine dp_dev_conjg_c1d(array_inout, &
                                   
                                   range1, lbound1 )
       implicit none
       !
       integer, parameter :: PRCSN = selected_real_kind(14,200)
       COMPLEX(PRCSN), intent(inout) :: array_inout(:)
       integer, optional, intent(in) ::  range1(2)
       integer, optional, intent(in) ::  lbound1
#if defined(__CUDA)
       attributes(device) :: array_inout
#endif
       !
    end subroutine dp_dev_conjg_c1d
    !
    subroutine dp_dev_conjg_c2d(array_inout, &
                                   
                                   range1, lbound1, &
                                   range2, lbound2 )
       implicit none
       !
       integer, parameter :: PRCSN = selected_real_kind(14,200)
       COMPLEX(PRCSN), intent(inout) :: array_inout(:,:)
       integer, optional, intent(in) ::  range1(2), range2(2)
       integer, optional, intent(in) ::  lbound1, lbound2
#if defined(__CUDA)
       attributes(device) :: array_inout
#endif
       !
    end subroutine dp_dev_conjg_c2d
    !
    subroutine dp_dev_conjg_c3d(array_inout, &
                                   
                                   range1, lbound1, &
                                   range2, lbound2, &
                                   range3, lbound3 )
       implicit none
       !
       integer, parameter :: PRCSN = selected_real_kind(14,200)
       COMPLEX(PRCSN), intent(inout) :: array_inout(:,:,:)
       integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
       integer, optional, intent(in) ::  lbound1, lbound2, lbound3
#if defined(__CUDA)
       attributes(device) :: array_inout
#endif
       !
    end subroutine dp_dev_conjg_c3d
    !
    subroutine dp_dev_conjg_c4d(array_inout, &
                                   
                                   range1, lbound1, &
                                   range2, lbound2, &
                                   range3, lbound3, &
                                   range4, lbound4 )
       implicit none
       !
       integer, parameter :: PRCSN = selected_real_kind(14,200)
       COMPLEX(PRCSN), intent(inout) :: array_inout(:,:,:,:)
       integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
       integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
#if defined(__CUDA)
       attributes(device) :: array_inout
#endif
       !
    end subroutine dp_dev_conjg_c4d
    !
    subroutine sp_dev_conjg_c1d(array_inout, &
                                   
                                   range1, lbound1 )
       implicit none
       !
       integer, parameter :: PRCSN = selected_real_kind(6, 37)
       COMPLEX(PRCSN), intent(inout) :: array_inout(:)
       integer, optional, intent(in) ::  range1(2)
       integer, optional, intent(in) ::  lbound1
#if defined(__CUDA)
       attributes(device) :: array_inout
#endif
       !
    end subroutine sp_dev_conjg_c1d
    !
    subroutine sp_dev_conjg_c2d(array_inout, &
                                   
                                   range1, lbound1, &
                                   range2, lbound2 )
       implicit none
       !
       integer, parameter :: PRCSN = selected_real_kind(6, 37)
       COMPLEX(PRCSN), intent(inout) :: array_inout(:,:)
       integer, optional, intent(in) ::  range1(2), range2(2)
       integer, optional, intent(in) ::  lbound1, lbound2
#if defined(__CUDA)
       attributes(device) :: array_inout
#endif
       !
    end subroutine sp_dev_conjg_c2d
    !
    subroutine sp_dev_conjg_c3d(array_inout, &
                                   
                                   range1, lbound1, &
                                   range2, lbound2, &
                                   range3, lbound3 )
       implicit none
       !
       integer, parameter :: PRCSN = selected_real_kind(6, 37)
       COMPLEX(PRCSN), intent(inout) :: array_inout(:,:,:)
       integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
       integer, optional, intent(in) ::  lbound1, lbound2, lbound3
#if defined(__CUDA)
       attributes(device) :: array_inout
#endif
       !
    end subroutine sp_dev_conjg_c3d
    !
    subroutine sp_dev_conjg_c4d(array_inout, &
                                   
                                   range1, lbound1, &
                                   range2, lbound2, &
                                   range3, lbound3, &
                                   range4, lbound4 )
       implicit none
       !
       integer, parameter :: PRCSN = selected_real_kind(6, 37)
       COMPLEX(PRCSN), intent(inout) :: array_inout(:,:,:,:)
       integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
       integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
#if defined(__CUDA)
       attributes(device) :: array_inout
#endif
       !
    end subroutine sp_dev_conjg_c4d
    !
    !
#if defined(__HAVE_DEVICE)
    !
    subroutine dp_dev_conjg_h_c1d(array_inout, &
                                   
                                   range1, lbound1 )
       implicit none
       !
       integer, parameter :: PRCSN = selected_real_kind(14,200)
       COMPLEX(PRCSN), intent(inout) :: array_inout(:)
       integer, optional, intent(in) ::  range1(2)
       integer, optional, intent(in) ::  lbound1
       !
    end subroutine dp_dev_conjg_h_c1d
    !
    subroutine dp_dev_conjg_h_c2d(array_inout, &
                                   
                                   range1, lbound1, &
                                   range2, lbound2 )
       implicit none
       !
       integer, parameter :: PRCSN = selected_real_kind(14,200)
       COMPLEX(PRCSN), intent(inout) :: array_inout(:,:)
       integer, optional, intent(in) ::  range1(2), range2(2)
       integer, optional, intent(in) ::  lbound1, lbound2
       !
    end subroutine dp_dev_conjg_h_c2d
    !
    subroutine dp_dev_conjg_h_c3d(array_inout, &
                                   
                                   range1, lbound1, &
                                   range2, lbound2, &
                                   range3, lbound3 )
       implicit none
       !
       integer, parameter :: PRCSN = selected_real_kind(14,200)
       COMPLEX(PRCSN), intent(inout) :: array_inout(:,:,:)
       integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
       integer, optional, intent(in) ::  lbound1, lbound2, lbound3
       !
    end subroutine dp_dev_conjg_h_c3d
    !
    subroutine dp_dev_conjg_h_c4d(array_inout, &
                                   
                                   range1, lbound1, &
                                   range2, lbound2, &
                                   range3, lbound3, &
                                   range4, lbound4 )
       implicit none
       !
       integer, parameter :: PRCSN = selected_real_kind(14,200)
       COMPLEX(PRCSN), intent(inout) :: array_inout(:,:,:,:)
       integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
       integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
       !
    end subroutine dp_dev_conjg_h_c4d
    !
    subroutine sp_dev_conjg_h_c1d(array_inout, &
                                   
                                   range1, lbound1 )
       implicit none
       !
       integer, parameter :: PRCSN = selected_real_kind(6, 37)
       COMPLEX(PRCSN), intent(inout) :: array_inout(:)
       integer, optional, intent(in) ::  range1(2)
       integer, optional, intent(in) ::  lbound1
       !
    end subroutine sp_dev_conjg_h_c1d
    !
    subroutine sp_dev_conjg_h_c2d(array_inout, &
                                   
                                   range1, lbound1, &
                                   range2, lbound2 )
       implicit none
       !
       integer, parameter :: PRCSN = selected_real_kind(6, 37)
       COMPLEX(PRCSN), intent(inout) :: array_inout(:,:)
       integer, optional, intent(in) ::  range1(2), range2(2)
       integer, optional, intent(in) ::  lbound1, lbound2
       !
    end subroutine sp_dev_conjg_h_c2d
    !
    subroutine sp_dev_conjg_h_c3d(array_inout, &
                                   
                                   range1, lbound1, &
                                   range2, lbound2, &
                                   range3, lbound3 )
       implicit none
       !
       integer, parameter :: PRCSN = selected_real_kind(6, 37)
       COMPLEX(PRCSN), intent(inout) :: array_inout(:,:,:)
       integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
       integer, optional, intent(in) ::  lbound1, lbound2, lbound3
       !
    end subroutine sp_dev_conjg_h_c3d
    !
    subroutine sp_dev_conjg_h_c4d(array_inout, &
                                   
                                   range1, lbound1, &
                                   range2, lbound2, &
                                   range3, lbound3, &
                                   range4, lbound4 )
       implicit none
       !
       integer, parameter :: PRCSN = selected_real_kind(6, 37)
       COMPLEX(PRCSN), intent(inout) :: array_inout(:,:,:,:)
       integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
       integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
       !
    end subroutine sp_dev_conjg_h_c4d
    !
    !
#endif
    !
end interface dev_conjg

interface dev_vec_upd_remap
    !

    subroutine dp_dev_vec_upd_remap_v_r1d(ndim, vout, v1, map1, v2, scal)
       implicit none
       !   
       integer, parameter :: PRCSN = selected_real_kind(14,200)
       integer,      intent(in)    :: ndim
       real(PRCSN), intent(inout) :: vout(:) 
       real(PRCSN), intent(in)    :: v1(:) 
       integer,      intent(in)    :: map1(:) 
       real(PRCSN), intent(in)    :: v2(:) 
       real(PRCSN), optional, intent(in)    :: scal
#if defined(__CUDA)
       attributes(device) :: vout, v1, v2, map1
#endif
       !
    end subroutine dp_dev_vec_upd_remap_v_r1d
    !
    subroutine dp_dev_vec_upd_remap_v_c1d(ndim, vout, v1, map1, v2, scal)
       implicit none
       !   
       integer, parameter :: PRCSN = selected_real_kind(14,200)
       integer,      intent(in)    :: ndim
       complex(PRCSN), intent(inout) :: vout(:) 
       complex(PRCSN), intent(in)    :: v1(:) 
       integer,      intent(in)    :: map1(:) 
       complex(PRCSN), intent(in)    :: v2(:) 
       complex(PRCSN), optional, intent(in)    :: scal
#if defined(__CUDA)
       attributes(device) :: vout, v1, v2, map1
#endif
       !
    end subroutine dp_dev_vec_upd_remap_v_c1d
    !
    subroutine sp_dev_vec_upd_remap_v_r1d(ndim, vout, v1, map1, v2, scal)
       implicit none
       !   
       integer, parameter :: PRCSN = selected_real_kind(6, 37)
       integer,      intent(in)    :: ndim
       real(PRCSN), intent(inout) :: vout(:) 
       real(PRCSN), intent(in)    :: v1(:) 
       integer,      intent(in)    :: map1(:) 
       real(PRCSN), intent(in)    :: v2(:) 
       real(PRCSN), optional, intent(in)    :: scal
#if defined(__CUDA)
       attributes(device) :: vout, v1, v2, map1
#endif
       !
    end subroutine sp_dev_vec_upd_remap_v_r1d
    !
    subroutine sp_dev_vec_upd_remap_v_c1d(ndim, vout, v1, map1, v2, scal)
       implicit none
       !   
       integer, parameter :: PRCSN = selected_real_kind(6, 37)
       integer,      intent(in)    :: ndim
       complex(PRCSN), intent(inout) :: vout(:) 
       complex(PRCSN), intent(in)    :: v1(:) 
       integer,      intent(in)    :: map1(:) 
       complex(PRCSN), intent(in)    :: v2(:) 
       complex(PRCSN), optional, intent(in)    :: scal
#if defined(__CUDA)
       attributes(device) :: vout, v1, v2, map1
#endif
       !
    end subroutine sp_dev_vec_upd_remap_v_c1d
    !
    !
end interface dev_vec_upd_remap

interface dev_vec_upd_v_remap_v
    !

    subroutine dp_dev_vec_upd_v_remap_v_r1d(ndim, vout, v1, map1, v2, scal)
       implicit none
       !   
       integer, parameter :: PRCSN = selected_real_kind(14,200)
       integer,      intent(in)    :: ndim
       real(PRCSN), intent(inout) :: vout(:)
       real(PRCSN), intent(in)    :: v1(:)
       integer,      intent(in)    :: map1(:)
       real(PRCSN), intent(in)    :: v2(:)
       real(PRCSN), optional, intent(in)    :: scal
#if defined(__CUDA)
       attributes(device) :: vout, v1, v2, map1
#endif
    !
    end subroutine dp_dev_vec_upd_v_remap_v_r1d
    !
    subroutine dp_dev_vec_upd_v_remap_v_c1d(ndim, vout, v1, map1, v2, scal)
       implicit none
       !   
       integer, parameter :: PRCSN = selected_real_kind(14,200)
       integer,      intent(in)    :: ndim
       complex(PRCSN), intent(inout) :: vout(:)
       complex(PRCSN), intent(in)    :: v1(:)
       integer,      intent(in)    :: map1(:)
       complex(PRCSN), intent(in)    :: v2(:)
       complex(PRCSN), optional, intent(in)    :: scal
#if defined(__CUDA)
       attributes(device) :: vout, v1, v2, map1
#endif
    !
    end subroutine dp_dev_vec_upd_v_remap_v_c1d
    !
    subroutine sp_dev_vec_upd_v_remap_v_r1d(ndim, vout, v1, map1, v2, scal)
       implicit none
       !   
       integer, parameter :: PRCSN = selected_real_kind(6, 37)
       integer,      intent(in)    :: ndim
       real(PRCSN), intent(inout) :: vout(:)
       real(PRCSN), intent(in)    :: v1(:)
       integer,      intent(in)    :: map1(:)
       real(PRCSN), intent(in)    :: v2(:)
       real(PRCSN), optional, intent(in)    :: scal
#if defined(__CUDA)
       attributes(device) :: vout, v1, v2, map1
#endif
    !
    end subroutine sp_dev_vec_upd_v_remap_v_r1d
    !
    subroutine sp_dev_vec_upd_v_remap_v_c1d(ndim, vout, v1, map1, v2, scal)
       implicit none
       !   
       integer, parameter :: PRCSN = selected_real_kind(6, 37)
       integer,      intent(in)    :: ndim
       complex(PRCSN), intent(inout) :: vout(:)
       complex(PRCSN), intent(in)    :: v1(:)
       integer,      intent(in)    :: map1(:)
       complex(PRCSN), intent(in)    :: v2(:)
       complex(PRCSN), optional, intent(in)    :: scal
#if defined(__CUDA)
       attributes(device) :: vout, v1, v2, map1
#endif
    !
    end subroutine sp_dev_vec_upd_v_remap_v_c1d
    !
    !


    subroutine dp_dev_vec_upd_v_remap_v_x_c1d(ndim, vout, v1,op1, map1, v2,op2, scal)
       implicit none
       !   
       integer, parameter :: PRCSN = selected_real_kind(14,200)
       integer,      intent(in)    :: ndim
       complex(PRCSN), intent(inout) :: vout(:)
       complex(PRCSN), intent(in)    :: v1(:)
       integer,      intent(in)    :: map1(:)
       complex(PRCSN), intent(in)    :: v2(:)
       character(1), intent(in)    :: op1, op2
       complex(PRCSN), optional, intent(in)    :: scal
#if defined(__CUDA)
       attributes(device) :: vout, v1, v2, map1
#endif
       !
    end subroutine dp_dev_vec_upd_v_remap_v_x_c1d
    !
    subroutine sp_dev_vec_upd_v_remap_v_x_c1d(ndim, vout, v1,op1, map1, v2,op2, scal)
       implicit none
       !   
       integer, parameter :: PRCSN = selected_real_kind(6, 37)
       integer,      intent(in)    :: ndim
       complex(PRCSN), intent(inout) :: vout(:)
       complex(PRCSN), intent(in)    :: v1(:)
       integer,      intent(in)    :: map1(:)
       complex(PRCSN), intent(in)    :: v2(:)
       character(1), intent(in)    :: op1, op2
       complex(PRCSN), optional, intent(in)    :: scal
#if defined(__CUDA)
       attributes(device) :: vout, v1, v2, map1
#endif
       !
    end subroutine sp_dev_vec_upd_v_remap_v_x_c1d
    !
    !
end interface dev_vec_upd_v_remap_v

interface dev_mat_upd_dMd
    !

    subroutine dp_dev_mat_upd_dMd_r2d(ndim1, ndim2, mat, v1,op1, v2,op2, scal)
       !   
       ! performs: mat(i,j) = scal * op1(v1(i)) * mat(i,j) * op2(v2(j))
       ! op = 'N', 'R', 'C',       'RC'
       !       x   1/x  conjg(x)   conjg(1/x)
       implicit none
       !   
       integer, parameter :: PRCSN = selected_real_kind(14,200)
       integer,      intent(in)    :: ndim1,ndim2
       real(PRCSN), intent(inout) :: mat(:,:)
       real(PRCSN), intent(in)    :: v1(:)
       real(PRCSN), intent(in)    :: v2(:)
       character(1), intent(in)    :: op1, op2 
       real(PRCSN), optional, intent(in)  :: scal
#if defined(__CUDA)
       attributes(device) :: mat, v1, v2
#endif
       !
    end subroutine dp_dev_mat_upd_dMd_r2d
    !
    subroutine dp_dev_mat_upd_dMd_c2d(ndim1, ndim2, mat, v1,op1, v2,op2, scal)
       !   
       ! performs: mat(i,j) = scal * op1(v1(i)) * mat(i,j) * op2(v2(j))
       ! op = 'N', 'R', 'C',       'RC'
       !       x   1/x  conjg(x)   conjg(1/x)
       implicit none
       !   
       integer, parameter :: PRCSN = selected_real_kind(14,200)
       integer,      intent(in)    :: ndim1,ndim2
       complex(PRCSN), intent(inout) :: mat(:,:)
       complex(PRCSN), intent(in)    :: v1(:)
       complex(PRCSN), intent(in)    :: v2(:)
       character(1), intent(in)    :: op1, op2 
       complex(PRCSN), optional, intent(in)  :: scal
#if defined(__CUDA)
       attributes(device) :: mat, v1, v2
#endif
       !
    end subroutine dp_dev_mat_upd_dMd_c2d
    !
    subroutine sp_dev_mat_upd_dMd_r2d(ndim1, ndim2, mat, v1,op1, v2,op2, scal)
       !   
       ! performs: mat(i,j) = scal * op1(v1(i)) * mat(i,j) * op2(v2(j))
       ! op = 'N', 'R', 'C',       'RC'
       !       x   1/x  conjg(x)   conjg(1/x)
       implicit none
       !   
       integer, parameter :: PRCSN = selected_real_kind(6, 37)
       integer,      intent(in)    :: ndim1,ndim2
       real(PRCSN), intent(inout) :: mat(:,:)
       real(PRCSN), intent(in)    :: v1(:)
       real(PRCSN), intent(in)    :: v2(:)
       character(1), intent(in)    :: op1, op2 
       real(PRCSN), optional, intent(in)  :: scal
#if defined(__CUDA)
       attributes(device) :: mat, v1, v2
#endif
       !
    end subroutine sp_dev_mat_upd_dMd_r2d
    !
    subroutine sp_dev_mat_upd_dMd_c2d(ndim1, ndim2, mat, v1,op1, v2,op2, scal)
       !   
       ! performs: mat(i,j) = scal * op1(v1(i)) * mat(i,j) * op2(v2(j))
       ! op = 'N', 'R', 'C',       'RC'
       !       x   1/x  conjg(x)   conjg(1/x)
       implicit none
       !   
       integer, parameter :: PRCSN = selected_real_kind(6, 37)
       integer,      intent(in)    :: ndim1,ndim2
       complex(PRCSN), intent(inout) :: mat(:,:)
       complex(PRCSN), intent(in)    :: v1(:)
       complex(PRCSN), intent(in)    :: v2(:)
       character(1), intent(in)    :: op1, op2 
       complex(PRCSN), optional, intent(in)  :: scal
#if defined(__CUDA)
       attributes(device) :: mat, v1, v2
#endif
       !
    end subroutine sp_dev_mat_upd_dMd_c2d
    !
    !
end interface dev_mat_upd_dMd

interface dev_mem_addscal
    !
    subroutine dp_dev_mem_addscal_r1d(array_out, array_in, scal, &
                                                range1, lbound1 )
        use iso_fortran_env
        implicit none
        !
        real(selected_real_kind(14,200)), intent(inout) :: array_out(:)
        real(selected_real_kind(14,200)), intent(in)    :: array_in(:)
        real(selected_real_kind(14,200)), optional, intent(in) :: scal
        integer, optional, intent(in) ::  range1(2)
        integer, optional, intent(in) ::  lbound1
#if defined(__CUDA)
        attributes(device) :: array_out, array_in
#endif
    end subroutine dp_dev_mem_addscal_r1d
    !
    subroutine dp_dev_mem_addscal_r2d(array_out, array_in, scal, &
                                                range1, lbound1, &
                                                range2, lbound2 )
        use iso_fortran_env
        implicit none
        !
        real(selected_real_kind(14,200)), intent(inout) :: array_out(:,:)
        real(selected_real_kind(14,200)), intent(in)    :: array_in(:,:)
        real(selected_real_kind(14,200)), optional, intent(in) :: scal
        integer, optional, intent(in) ::  range1(2), range2(2)
        integer, optional, intent(in) ::  lbound1, lbound2
#if defined(__CUDA)
        attributes(device) :: array_out, array_in
#endif
    end subroutine dp_dev_mem_addscal_r2d
    !
    subroutine dp_dev_mem_addscal_r3d(array_out, array_in, scal, &
                                                range1, lbound1, &
                                                range2, lbound2, &
                                                range3, lbound3 )
        use iso_fortran_env
        implicit none
        !
        real(selected_real_kind(14,200)), intent(inout) :: array_out(:,:,:)
        real(selected_real_kind(14,200)), intent(in)    :: array_in(:,:,:)
        real(selected_real_kind(14,200)), optional, intent(in) :: scal
        integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
        integer, optional, intent(in) ::  lbound1, lbound2, lbound3
#if defined(__CUDA)
        attributes(device) :: array_out, array_in
#endif
    end subroutine dp_dev_mem_addscal_r3d
    !
    subroutine dp_dev_mem_addscal_r4d(array_out, array_in, scal, &
                                                range1, lbound1, &
                                                range2, lbound2, &
                                                range3, lbound3, &
                                                range4, lbound4 )
        use iso_fortran_env
        implicit none
        !
        real(selected_real_kind(14,200)), intent(inout) :: array_out(:,:,:,:)
        real(selected_real_kind(14,200)), intent(in)    :: array_in(:,:,:,:)
        real(selected_real_kind(14,200)), optional, intent(in) :: scal
        integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
        integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
#if defined(__CUDA)
        attributes(device) :: array_out, array_in
#endif
    end subroutine dp_dev_mem_addscal_r4d
    !
    subroutine sp_dev_mem_addscal_r1d(array_out, array_in, scal, &
                                                range1, lbound1 )
        use iso_fortran_env
        implicit none
        !
        real(selected_real_kind(6, 37)), intent(inout) :: array_out(:)
        real(selected_real_kind(6, 37)), intent(in)    :: array_in(:)
        real(selected_real_kind(6, 37)), optional, intent(in) :: scal
        integer, optional, intent(in) ::  range1(2)
        integer, optional, intent(in) ::  lbound1
#if defined(__CUDA)
        attributes(device) :: array_out, array_in
#endif
    end subroutine sp_dev_mem_addscal_r1d
    !
    subroutine sp_dev_mem_addscal_r2d(array_out, array_in, scal, &
                                                range1, lbound1, &
                                                range2, lbound2 )
        use iso_fortran_env
        implicit none
        !
        real(selected_real_kind(6, 37)), intent(inout) :: array_out(:,:)
        real(selected_real_kind(6, 37)), intent(in)    :: array_in(:,:)
        real(selected_real_kind(6, 37)), optional, intent(in) :: scal
        integer, optional, intent(in) ::  range1(2), range2(2)
        integer, optional, intent(in) ::  lbound1, lbound2
#if defined(__CUDA)
        attributes(device) :: array_out, array_in
#endif
    end subroutine sp_dev_mem_addscal_r2d
    !
    subroutine sp_dev_mem_addscal_r3d(array_out, array_in, scal, &
                                                range1, lbound1, &
                                                range2, lbound2, &
                                                range3, lbound3 )
        use iso_fortran_env
        implicit none
        !
        real(selected_real_kind(6, 37)), intent(inout) :: array_out(:,:,:)
        real(selected_real_kind(6, 37)), intent(in)    :: array_in(:,:,:)
        real(selected_real_kind(6, 37)), optional, intent(in) :: scal
        integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
        integer, optional, intent(in) ::  lbound1, lbound2, lbound3
#if defined(__CUDA)
        attributes(device) :: array_out, array_in
#endif
    end subroutine sp_dev_mem_addscal_r3d
    !
    subroutine sp_dev_mem_addscal_r4d(array_out, array_in, scal, &
                                                range1, lbound1, &
                                                range2, lbound2, &
                                                range3, lbound3, &
                                                range4, lbound4 )
        use iso_fortran_env
        implicit none
        !
        real(selected_real_kind(6, 37)), intent(inout) :: array_out(:,:,:,:)
        real(selected_real_kind(6, 37)), intent(in)    :: array_in(:,:,:,:)
        real(selected_real_kind(6, 37)), optional, intent(in) :: scal
        integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
        integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
#if defined(__CUDA)
        attributes(device) :: array_out, array_in
#endif
    end subroutine sp_dev_mem_addscal_r4d
    !
    subroutine dp_dev_mem_addscal_c1d(array_out, array_in, scal, &
                                                range1, lbound1 )
        use iso_fortran_env
        implicit none
        !
        complex(selected_real_kind(14,200)), intent(inout) :: array_out(:)
        complex(selected_real_kind(14,200)), intent(in)    :: array_in(:)
        complex(selected_real_kind(14,200)), optional, intent(in) :: scal
        integer, optional, intent(in) ::  range1(2)
        integer, optional, intent(in) ::  lbound1
#if defined(__CUDA)
        attributes(device) :: array_out, array_in
#endif
    end subroutine dp_dev_mem_addscal_c1d
    !
    subroutine dp_dev_mem_addscal_c2d(array_out, array_in, scal, &
                                                range1, lbound1, &
                                                range2, lbound2 )
        use iso_fortran_env
        implicit none
        !
        complex(selected_real_kind(14,200)), intent(inout) :: array_out(:,:)
        complex(selected_real_kind(14,200)), intent(in)    :: array_in(:,:)
        complex(selected_real_kind(14,200)), optional, intent(in) :: scal
        integer, optional, intent(in) ::  range1(2), range2(2)
        integer, optional, intent(in) ::  lbound1, lbound2
#if defined(__CUDA)
        attributes(device) :: array_out, array_in
#endif
    end subroutine dp_dev_mem_addscal_c2d
    !
    subroutine dp_dev_mem_addscal_c3d(array_out, array_in, scal, &
                                                range1, lbound1, &
                                                range2, lbound2, &
                                                range3, lbound3 )
        use iso_fortran_env
        implicit none
        !
        complex(selected_real_kind(14,200)), intent(inout) :: array_out(:,:,:)
        complex(selected_real_kind(14,200)), intent(in)    :: array_in(:,:,:)
        complex(selected_real_kind(14,200)), optional, intent(in) :: scal
        integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
        integer, optional, intent(in) ::  lbound1, lbound2, lbound3
#if defined(__CUDA)
        attributes(device) :: array_out, array_in
#endif
    end subroutine dp_dev_mem_addscal_c3d
    !
    subroutine dp_dev_mem_addscal_c4d(array_out, array_in, scal, &
                                                range1, lbound1, &
                                                range2, lbound2, &
                                                range3, lbound3, &
                                                range4, lbound4 )
        use iso_fortran_env
        implicit none
        !
        complex(selected_real_kind(14,200)), intent(inout) :: array_out(:,:,:,:)
        complex(selected_real_kind(14,200)), intent(in)    :: array_in(:,:,:,:)
        complex(selected_real_kind(14,200)), optional, intent(in) :: scal
        integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
        integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
#if defined(__CUDA)
        attributes(device) :: array_out, array_in
#endif
    end subroutine dp_dev_mem_addscal_c4d
    !
    subroutine sp_dev_mem_addscal_c1d(array_out, array_in, scal, &
                                                range1, lbound1 )
        use iso_fortran_env
        implicit none
        !
        complex(selected_real_kind(6, 37)), intent(inout) :: array_out(:)
        complex(selected_real_kind(6, 37)), intent(in)    :: array_in(:)
        complex(selected_real_kind(6, 37)), optional, intent(in) :: scal
        integer, optional, intent(in) ::  range1(2)
        integer, optional, intent(in) ::  lbound1
#if defined(__CUDA)
        attributes(device) :: array_out, array_in
#endif
    end subroutine sp_dev_mem_addscal_c1d
    !
    subroutine sp_dev_mem_addscal_c2d(array_out, array_in, scal, &
                                                range1, lbound1, &
                                                range2, lbound2 )
        use iso_fortran_env
        implicit none
        !
        complex(selected_real_kind(6, 37)), intent(inout) :: array_out(:,:)
        complex(selected_real_kind(6, 37)), intent(in)    :: array_in(:,:)
        complex(selected_real_kind(6, 37)), optional, intent(in) :: scal
        integer, optional, intent(in) ::  range1(2), range2(2)
        integer, optional, intent(in) ::  lbound1, lbound2
#if defined(__CUDA)
        attributes(device) :: array_out, array_in
#endif
    end subroutine sp_dev_mem_addscal_c2d
    !
    subroutine sp_dev_mem_addscal_c3d(array_out, array_in, scal, &
                                                range1, lbound1, &
                                                range2, lbound2, &
                                                range3, lbound3 )
        use iso_fortran_env
        implicit none
        !
        complex(selected_real_kind(6, 37)), intent(inout) :: array_out(:,:,:)
        complex(selected_real_kind(6, 37)), intent(in)    :: array_in(:,:,:)
        complex(selected_real_kind(6, 37)), optional, intent(in) :: scal
        integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
        integer, optional, intent(in) ::  lbound1, lbound2, lbound3
#if defined(__CUDA)
        attributes(device) :: array_out, array_in
#endif
    end subroutine sp_dev_mem_addscal_c3d
    !
    subroutine sp_dev_mem_addscal_c4d(array_out, array_in, scal, &
                                                range1, lbound1, &
                                                range2, lbound2, &
                                                range3, lbound3, &
                                                range4, lbound4 )
        use iso_fortran_env
        implicit none
        !
        complex(selected_real_kind(6, 37)), intent(inout) :: array_out(:,:,:,:)
        complex(selected_real_kind(6, 37)), intent(in)    :: array_in(:,:,:,:)
        complex(selected_real_kind(6, 37)), optional, intent(in) :: scal
        integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
        integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
#if defined(__CUDA)
        attributes(device) :: array_out, array_in
#endif
    end subroutine sp_dev_mem_addscal_c4d
    !
    !
end interface dev_mem_addscal

!
#include<device_macros.h>
!
interface dev_memcpy
    !
    subroutine sp_dev_memcpy_r1d(array_out, array_in, &
                                            range1, lbound1 )
      use iso_fortran_env
      implicit none
      !   
      real(real32), intent(inout) :: array_out(:)
      real(real32), intent(in)    :: array_in(:)
      integer, optional, intent(in) ::  range1(2)
      integer, optional, intent(in) ::  lbound1
#if defined(__CUDA)
      attributes(device) :: array_out, array_in
#endif
       !
    end subroutine sp_dev_memcpy_r1d
    !
    subroutine sp_dev_memcpy_r2d(array_out, array_in, &
                                            range1, lbound1, &
                                            range2, lbound2 )
      use iso_fortran_env
      implicit none
      !   
      real(real32), intent(inout) :: array_out(:,:)
      real(real32), intent(in)    :: array_in(:,:)
      integer, optional, intent(in) ::  range1(2), range2(2)
      integer, optional, intent(in) ::  lbound1, lbound2
#if defined(__CUDA)
      attributes(device) :: array_out, array_in
#endif
       !
    end subroutine sp_dev_memcpy_r2d
    !
    subroutine sp_dev_memcpy_r3d(array_out, array_in, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3 )
      use iso_fortran_env
      implicit none
      !   
      real(real32), intent(inout) :: array_out(:,:,:)
      real(real32), intent(in)    :: array_in(:,:,:)
      integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
      integer, optional, intent(in) ::  lbound1, lbound2, lbound3
#if defined(__CUDA)
      attributes(device) :: array_out, array_in
#endif
       !
    end subroutine sp_dev_memcpy_r3d
    !
    subroutine sp_dev_memcpy_r4d(array_out, array_in, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3, &
                                            range4, lbound4 )
      use iso_fortran_env
      implicit none
      !   
      real(real32), intent(inout) :: array_out(:,:,:,:)
      real(real32), intent(in)    :: array_in(:,:,:,:)
      integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
      integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
#if defined(__CUDA)
      attributes(device) :: array_out, array_in
#endif
       !
    end subroutine sp_dev_memcpy_r4d
    !
    subroutine dp_dev_memcpy_r1d(array_out, array_in, &
                                            range1, lbound1 )
      use iso_fortran_env
      implicit none
      !   
      real(real64), intent(inout) :: array_out(:)
      real(real64), intent(in)    :: array_in(:)
      integer, optional, intent(in) ::  range1(2)
      integer, optional, intent(in) ::  lbound1
#if defined(__CUDA)
      attributes(device) :: array_out, array_in
#endif
       !
    end subroutine dp_dev_memcpy_r1d
    !
    subroutine dp_dev_memcpy_r2d(array_out, array_in, &
                                            range1, lbound1, &
                                            range2, lbound2 )
      use iso_fortran_env
      implicit none
      !   
      real(real64), intent(inout) :: array_out(:,:)
      real(real64), intent(in)    :: array_in(:,:)
      integer, optional, intent(in) ::  range1(2), range2(2)
      integer, optional, intent(in) ::  lbound1, lbound2
#if defined(__CUDA)
      attributes(device) :: array_out, array_in
#endif
       !
    end subroutine dp_dev_memcpy_r2d
    !
    subroutine dp_dev_memcpy_r3d(array_out, array_in, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3 )
      use iso_fortran_env
      implicit none
      !   
      real(real64), intent(inout) :: array_out(:,:,:)
      real(real64), intent(in)    :: array_in(:,:,:)
      integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
      integer, optional, intent(in) ::  lbound1, lbound2, lbound3
#if defined(__CUDA)
      attributes(device) :: array_out, array_in
#endif
       !
    end subroutine dp_dev_memcpy_r3d
    !
    subroutine dp_dev_memcpy_r4d(array_out, array_in, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3, &
                                            range4, lbound4 )
      use iso_fortran_env
      implicit none
      !   
      real(real64), intent(inout) :: array_out(:,:,:,:)
      real(real64), intent(in)    :: array_in(:,:,:,:)
      integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
      integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
#if defined(__CUDA)
      attributes(device) :: array_out, array_in
#endif
       !
    end subroutine dp_dev_memcpy_r4d
    !
    subroutine sp_dev_memcpy_c1d(array_out, array_in, &
                                            range1, lbound1 )
      use iso_fortran_env
      implicit none
      !   
      complex(real32), intent(inout) :: array_out(:)
      complex(real32), intent(in)    :: array_in(:)
      integer, optional, intent(in) ::  range1(2)
      integer, optional, intent(in) ::  lbound1
#if defined(__CUDA)
      attributes(device) :: array_out, array_in
#endif
       !
    end subroutine sp_dev_memcpy_c1d
    !
    subroutine sp_dev_memcpy_c2d(array_out, array_in, &
                                            range1, lbound1, &
                                            range2, lbound2 )
      use iso_fortran_env
      implicit none
      !   
      complex(real32), intent(inout) :: array_out(:,:)
      complex(real32), intent(in)    :: array_in(:,:)
      integer, optional, intent(in) ::  range1(2), range2(2)
      integer, optional, intent(in) ::  lbound1, lbound2
#if defined(__CUDA)
      attributes(device) :: array_out, array_in
#endif
       !
    end subroutine sp_dev_memcpy_c2d
    !
    subroutine sp_dev_memcpy_c3d(array_out, array_in, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3 )
      use iso_fortran_env
      implicit none
      !   
      complex(real32), intent(inout) :: array_out(:,:,:)
      complex(real32), intent(in)    :: array_in(:,:,:)
      integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
      integer, optional, intent(in) ::  lbound1, lbound2, lbound3
#if defined(__CUDA)
      attributes(device) :: array_out, array_in
#endif
       !
    end subroutine sp_dev_memcpy_c3d
    !
    subroutine sp_dev_memcpy_c4d(array_out, array_in, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3, &
                                            range4, lbound4 )
      use iso_fortran_env
      implicit none
      !   
      complex(real32), intent(inout) :: array_out(:,:,:,:)
      complex(real32), intent(in)    :: array_in(:,:,:,:)
      integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
      integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
#if defined(__CUDA)
      attributes(device) :: array_out, array_in
#endif
       !
    end subroutine sp_dev_memcpy_c4d
    !
    subroutine dp_dev_memcpy_c1d(array_out, array_in, &
                                            range1, lbound1 )
      use iso_fortran_env
      implicit none
      !   
      complex(real64), intent(inout) :: array_out(:)
      complex(real64), intent(in)    :: array_in(:)
      integer, optional, intent(in) ::  range1(2)
      integer, optional, intent(in) ::  lbound1
#if defined(__CUDA)
      attributes(device) :: array_out, array_in
#endif
       !
    end subroutine dp_dev_memcpy_c1d
    !
    subroutine dp_dev_memcpy_c2d(array_out, array_in, &
                                            range1, lbound1, &
                                            range2, lbound2 )
      use iso_fortran_env
      implicit none
      !   
      complex(real64), intent(inout) :: array_out(:,:)
      complex(real64), intent(in)    :: array_in(:,:)
      integer, optional, intent(in) ::  range1(2), range2(2)
      integer, optional, intent(in) ::  lbound1, lbound2
#if defined(__CUDA)
      attributes(device) :: array_out, array_in
#endif
       !
    end subroutine dp_dev_memcpy_c2d
    !
    subroutine dp_dev_memcpy_c3d(array_out, array_in, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3 )
      use iso_fortran_env
      implicit none
      !   
      complex(real64), intent(inout) :: array_out(:,:,:)
      complex(real64), intent(in)    :: array_in(:,:,:)
      integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
      integer, optional, intent(in) ::  lbound1, lbound2, lbound3
#if defined(__CUDA)
      attributes(device) :: array_out, array_in
#endif
       !
    end subroutine dp_dev_memcpy_c3d
    !
    subroutine dp_dev_memcpy_c4d(array_out, array_in, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3, &
                                            range4, lbound4 )
      use iso_fortran_env
      implicit none
      !   
      complex(real64), intent(inout) :: array_out(:,:,:,:)
      complex(real64), intent(in)    :: array_in(:,:,:,:)
      integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
      integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
#if defined(__CUDA)
      attributes(device) :: array_out, array_in
#endif
       !
    end subroutine dp_dev_memcpy_c4d
    !
    subroutine i4_dev_memcpy_i1d(array_out, array_in, &
                                            range1, lbound1 )
      use iso_fortran_env
      implicit none
      !   
      integer(int32), intent(inout) :: array_out(:)
      integer(int32), intent(in)    :: array_in(:)
      integer, optional, intent(in) ::  range1(2)
      integer, optional, intent(in) ::  lbound1
#if defined(__CUDA)
      attributes(device) :: array_out, array_in
#endif
       !
    end subroutine i4_dev_memcpy_i1d
    !
    subroutine i4_dev_memcpy_i2d(array_out, array_in, &
                                            range1, lbound1, &
                                            range2, lbound2 )
      use iso_fortran_env
      implicit none
      !   
      integer(int32), intent(inout) :: array_out(:,:)
      integer(int32), intent(in)    :: array_in(:,:)
      integer, optional, intent(in) ::  range1(2), range2(2)
      integer, optional, intent(in) ::  lbound1, lbound2
#if defined(__CUDA)
      attributes(device) :: array_out, array_in
#endif
       !
    end subroutine i4_dev_memcpy_i2d
    !
    subroutine i4_dev_memcpy_i3d(array_out, array_in, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3 )
      use iso_fortran_env
      implicit none
      !   
      integer(int32), intent(inout) :: array_out(:,:,:)
      integer(int32), intent(in)    :: array_in(:,:,:)
      integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
      integer, optional, intent(in) ::  lbound1, lbound2, lbound3
#if defined(__CUDA)
      attributes(device) :: array_out, array_in
#endif
       !
    end subroutine i4_dev_memcpy_i3d
    !
    subroutine i4_dev_memcpy_i4d(array_out, array_in, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3, &
                                            range4, lbound4 )
      use iso_fortran_env
      implicit none
      !   
      integer(int32), intent(inout) :: array_out(:,:,:,:)
      integer(int32), intent(in)    :: array_in(:,:,:,:)
      integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
      integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
#if defined(__CUDA)
      attributes(device) :: array_out, array_in
#endif
       !
    end subroutine i4_dev_memcpy_i4d
    !
    !
#if defined(__HAVE_DEVICE)
    subroutine sp_dev_memcpy_h2h_r1d(array_out, array_in, &
                                            range1, lbound1 )
      use iso_fortran_env
      implicit none
      !   
      real(real32), intent(inout) :: array_out(:)
      real(real32), intent(in)    :: array_in(:)
      integer, optional, intent(in) ::  range1(2)
      integer, optional, intent(in) ::  lbound1
       !
    end subroutine sp_dev_memcpy_h2h_r1d
    !
    subroutine sp_dev_memcpy_h2h_r2d(array_out, array_in, &
                                            range1, lbound1, &
                                            range2, lbound2 )
      use iso_fortran_env
      implicit none
      !   
      real(real32), intent(inout) :: array_out(:,:)
      real(real32), intent(in)    :: array_in(:,:)
      integer, optional, intent(in) ::  range1(2), range2(2)
      integer, optional, intent(in) ::  lbound1, lbound2
       !
    end subroutine sp_dev_memcpy_h2h_r2d
    !
    subroutine sp_dev_memcpy_h2h_r3d(array_out, array_in, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3 )
      use iso_fortran_env
      implicit none
      !   
      real(real32), intent(inout) :: array_out(:,:,:)
      real(real32), intent(in)    :: array_in(:,:,:)
      integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
      integer, optional, intent(in) ::  lbound1, lbound2, lbound3
       !
    end subroutine sp_dev_memcpy_h2h_r3d
    !
    subroutine sp_dev_memcpy_h2h_r4d(array_out, array_in, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3, &
                                            range4, lbound4 )
      use iso_fortran_env
      implicit none
      !   
      real(real32), intent(inout) :: array_out(:,:,:,:)
      real(real32), intent(in)    :: array_in(:,:,:,:)
      integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
      integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
       !
    end subroutine sp_dev_memcpy_h2h_r4d
    !
    subroutine dp_dev_memcpy_h2h_r1d(array_out, array_in, &
                                            range1, lbound1 )
      use iso_fortran_env
      implicit none
      !   
      real(real64), intent(inout) :: array_out(:)
      real(real64), intent(in)    :: array_in(:)
      integer, optional, intent(in) ::  range1(2)
      integer, optional, intent(in) ::  lbound1
       !
    end subroutine dp_dev_memcpy_h2h_r1d
    !
    subroutine dp_dev_memcpy_h2h_r2d(array_out, array_in, &
                                            range1, lbound1, &
                                            range2, lbound2 )
      use iso_fortran_env
      implicit none
      !   
      real(real64), intent(inout) :: array_out(:,:)
      real(real64), intent(in)    :: array_in(:,:)
      integer, optional, intent(in) ::  range1(2), range2(2)
      integer, optional, intent(in) ::  lbound1, lbound2
       !
    end subroutine dp_dev_memcpy_h2h_r2d
    !
    subroutine dp_dev_memcpy_h2h_r3d(array_out, array_in, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3 )
      use iso_fortran_env
      implicit none
      !   
      real(real64), intent(inout) :: array_out(:,:,:)
      real(real64), intent(in)    :: array_in(:,:,:)
      integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
      integer, optional, intent(in) ::  lbound1, lbound2, lbound3
       !
    end subroutine dp_dev_memcpy_h2h_r3d
    !
    subroutine dp_dev_memcpy_h2h_r4d(array_out, array_in, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3, &
                                            range4, lbound4 )
      use iso_fortran_env
      implicit none
      !   
      real(real64), intent(inout) :: array_out(:,:,:,:)
      real(real64), intent(in)    :: array_in(:,:,:,:)
      integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
      integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
       !
    end subroutine dp_dev_memcpy_h2h_r4d
    !
    subroutine sp_dev_memcpy_h2h_c1d(array_out, array_in, &
                                            range1, lbound1 )
      use iso_fortran_env
      implicit none
      !   
      complex(real32), intent(inout) :: array_out(:)
      complex(real32), intent(in)    :: array_in(:)
      integer, optional, intent(in) ::  range1(2)
      integer, optional, intent(in) ::  lbound1
       !
    end subroutine sp_dev_memcpy_h2h_c1d
    !
    subroutine sp_dev_memcpy_h2h_c2d(array_out, array_in, &
                                            range1, lbound1, &
                                            range2, lbound2 )
      use iso_fortran_env
      implicit none
      !   
      complex(real32), intent(inout) :: array_out(:,:)
      complex(real32), intent(in)    :: array_in(:,:)
      integer, optional, intent(in) ::  range1(2), range2(2)
      integer, optional, intent(in) ::  lbound1, lbound2
       !
    end subroutine sp_dev_memcpy_h2h_c2d
    !
    subroutine sp_dev_memcpy_h2h_c3d(array_out, array_in, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3 )
      use iso_fortran_env
      implicit none
      !   
      complex(real32), intent(inout) :: array_out(:,:,:)
      complex(real32), intent(in)    :: array_in(:,:,:)
      integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
      integer, optional, intent(in) ::  lbound1, lbound2, lbound3
       !
    end subroutine sp_dev_memcpy_h2h_c3d
    !
    subroutine sp_dev_memcpy_h2h_c4d(array_out, array_in, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3, &
                                            range4, lbound4 )
      use iso_fortran_env
      implicit none
      !   
      complex(real32), intent(inout) :: array_out(:,:,:,:)
      complex(real32), intent(in)    :: array_in(:,:,:,:)
      integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
      integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
       !
    end subroutine sp_dev_memcpy_h2h_c4d
    !
    subroutine dp_dev_memcpy_h2h_c1d(array_out, array_in, &
                                            range1, lbound1 )
      use iso_fortran_env
      implicit none
      !   
      complex(real64), intent(inout) :: array_out(:)
      complex(real64), intent(in)    :: array_in(:)
      integer, optional, intent(in) ::  range1(2)
      integer, optional, intent(in) ::  lbound1
       !
    end subroutine dp_dev_memcpy_h2h_c1d
    !
    subroutine dp_dev_memcpy_h2h_c2d(array_out, array_in, &
                                            range1, lbound1, &
                                            range2, lbound2 )
      use iso_fortran_env
      implicit none
      !   
      complex(real64), intent(inout) :: array_out(:,:)
      complex(real64), intent(in)    :: array_in(:,:)
      integer, optional, intent(in) ::  range1(2), range2(2)
      integer, optional, intent(in) ::  lbound1, lbound2
       !
    end subroutine dp_dev_memcpy_h2h_c2d
    !
    subroutine dp_dev_memcpy_h2h_c3d(array_out, array_in, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3 )
      use iso_fortran_env
      implicit none
      !   
      complex(real64), intent(inout) :: array_out(:,:,:)
      complex(real64), intent(in)    :: array_in(:,:,:)
      integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
      integer, optional, intent(in) ::  lbound1, lbound2, lbound3
       !
    end subroutine dp_dev_memcpy_h2h_c3d
    !
    subroutine dp_dev_memcpy_h2h_c4d(array_out, array_in, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3, &
                                            range4, lbound4 )
      use iso_fortran_env
      implicit none
      !   
      complex(real64), intent(inout) :: array_out(:,:,:,:)
      complex(real64), intent(in)    :: array_in(:,:,:,:)
      integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
      integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
       !
    end subroutine dp_dev_memcpy_h2h_c4d
    !
    subroutine i4_dev_memcpy_h2h_i1d(array_out, array_in, &
                                            range1, lbound1 )
      use iso_fortran_env
      implicit none
      !   
      integer(int32), intent(inout) :: array_out(:)
      integer(int32), intent(in)    :: array_in(:)
      integer, optional, intent(in) ::  range1(2)
      integer, optional, intent(in) ::  lbound1
       !
    end subroutine i4_dev_memcpy_h2h_i1d
    !
    subroutine i4_dev_memcpy_h2h_i2d(array_out, array_in, &
                                            range1, lbound1, &
                                            range2, lbound2 )
      use iso_fortran_env
      implicit none
      !   
      integer(int32), intent(inout) :: array_out(:,:)
      integer(int32), intent(in)    :: array_in(:,:)
      integer, optional, intent(in) ::  range1(2), range2(2)
      integer, optional, intent(in) ::  lbound1, lbound2
       !
    end subroutine i4_dev_memcpy_h2h_i2d
    !
    subroutine i4_dev_memcpy_h2h_i3d(array_out, array_in, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3 )
      use iso_fortran_env
      implicit none
      !   
      integer(int32), intent(inout) :: array_out(:,:,:)
      integer(int32), intent(in)    :: array_in(:,:,:)
      integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
      integer, optional, intent(in) ::  lbound1, lbound2, lbound3
       !
    end subroutine i4_dev_memcpy_h2h_i3d
    !
    subroutine i4_dev_memcpy_h2h_i4d(array_out, array_in, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3, &
                                            range4, lbound4 )
      use iso_fortran_env
      implicit none
      !   
      integer(int32), intent(inout) :: array_out(:,:,:,:)
      integer(int32), intent(in)    :: array_in(:,:,:,:)
      integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
      integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
       !
    end subroutine i4_dev_memcpy_h2h_i4d
    !
#endif
    !
#if defined(__HAVE_DEVICE)
    subroutine sp_memcpy_h2d_r1d(array_out, array_in, &
                                             range1, lbound1  )
#if defined(__CUDA)
       use cudafor
#endif  
       use iso_fortran_env
       implicit none
       !   
       real(real32), intent(inout) :: array_out(:) 
       real(real32), intent(in)    :: array_in(:) 
       integer, optional, intent(in) ::  range1(2)
       integer, optional, intent(in) ::  lbound1
#if defined(__CUDA)
       attributes(device) :: array_out
#endif
       !
    end subroutine sp_memcpy_h2d_r1d
    !
    subroutine sp_memcpy_h2d_r2d(array_out, array_in, &
                                             range1, lbound1 , &
                                             range2, lbound2  )
#if defined(__CUDA)
       use cudafor
#endif  
       use iso_fortran_env
       implicit none
       !   
       real(real32), intent(inout) :: array_out(:,:) 
       real(real32), intent(in)    :: array_in(:,:) 
       integer, optional, intent(in) ::  range1(2), range2(2)
       integer, optional, intent(in) ::  lbound1, lbound2
#if defined(__CUDA)
       attributes(device) :: array_out
#endif
       !
    end subroutine sp_memcpy_h2d_r2d
    !
    subroutine sp_memcpy_h2d_r3d(array_out, array_in, &
                                             range1, lbound1 , &
                                             range2, lbound2 , &
                                             range3, lbound3  )
#if defined(__CUDA)
       use cudafor
#endif  
       use iso_fortran_env
       implicit none
       !   
       real(real32), intent(inout) :: array_out(:,:,:) 
       real(real32), intent(in)    :: array_in(:,:,:) 
       integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
       integer, optional, intent(in) ::  lbound1, lbound2, lbound3
#if defined(__CUDA)
       attributes(device) :: array_out
#endif
       !
    end subroutine sp_memcpy_h2d_r3d
    !
    subroutine sp_memcpy_h2d_r4d(array_out, array_in, &
                                             range1, lbound1 , &
                                             range2, lbound2 , &
                                             range3, lbound3 , &
                                             range4, lbound4  )
#if defined(__CUDA)
       use cudafor
#endif  
       use iso_fortran_env
       implicit none
       !   
       real(real32), intent(inout) :: array_out(:,:,:,:) 
       real(real32), intent(in)    :: array_in(:,:,:,:) 
       integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
       integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
#if defined(__CUDA)
       attributes(device) :: array_out
#endif
       !
    end subroutine sp_memcpy_h2d_r4d
    !
    subroutine dp_memcpy_h2d_r1d(array_out, array_in, &
                                             range1, lbound1  )
#if defined(__CUDA)
       use cudafor
#endif  
       use iso_fortran_env
       implicit none
       !   
       real(real64), intent(inout) :: array_out(:) 
       real(real64), intent(in)    :: array_in(:) 
       integer, optional, intent(in) ::  range1(2)
       integer, optional, intent(in) ::  lbound1
#if defined(__CUDA)
       attributes(device) :: array_out
#endif
       !
    end subroutine dp_memcpy_h2d_r1d
    !
    subroutine dp_memcpy_h2d_r2d(array_out, array_in, &
                                             range1, lbound1 , &
                                             range2, lbound2  )
#if defined(__CUDA)
       use cudafor
#endif  
       use iso_fortran_env
       implicit none
       !   
       real(real64), intent(inout) :: array_out(:,:) 
       real(real64), intent(in)    :: array_in(:,:) 
       integer, optional, intent(in) ::  range1(2), range2(2)
       integer, optional, intent(in) ::  lbound1, lbound2
#if defined(__CUDA)
       attributes(device) :: array_out
#endif
       !
    end subroutine dp_memcpy_h2d_r2d
    !
    subroutine dp_memcpy_h2d_r3d(array_out, array_in, &
                                             range1, lbound1 , &
                                             range2, lbound2 , &
                                             range3, lbound3  )
#if defined(__CUDA)
       use cudafor
#endif  
       use iso_fortran_env
       implicit none
       !   
       real(real64), intent(inout) :: array_out(:,:,:) 
       real(real64), intent(in)    :: array_in(:,:,:) 
       integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
       integer, optional, intent(in) ::  lbound1, lbound2, lbound3
#if defined(__CUDA)
       attributes(device) :: array_out
#endif
       !
    end subroutine dp_memcpy_h2d_r3d
    !
    subroutine dp_memcpy_h2d_r4d(array_out, array_in, &
                                             range1, lbound1 , &
                                             range2, lbound2 , &
                                             range3, lbound3 , &
                                             range4, lbound4  )
#if defined(__CUDA)
       use cudafor
#endif  
       use iso_fortran_env
       implicit none
       !   
       real(real64), intent(inout) :: array_out(:,:,:,:) 
       real(real64), intent(in)    :: array_in(:,:,:,:) 
       integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
       integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
#if defined(__CUDA)
       attributes(device) :: array_out
#endif
       !
    end subroutine dp_memcpy_h2d_r4d
    !
    subroutine sp_memcpy_h2d_c1d(array_out, array_in, &
                                             range1, lbound1  )
#if defined(__CUDA)
       use cudafor
#endif  
       use iso_fortran_env
       implicit none
       !   
       complex(real32), intent(inout) :: array_out(:) 
       complex(real32), intent(in)    :: array_in(:) 
       integer, optional, intent(in) ::  range1(2)
       integer, optional, intent(in) ::  lbound1
#if defined(__CUDA)
       attributes(device) :: array_out
#endif
       !
    end subroutine sp_memcpy_h2d_c1d
    !
    subroutine sp_memcpy_h2d_c2d(array_out, array_in, &
                                             range1, lbound1 , &
                                             range2, lbound2  )
#if defined(__CUDA)
       use cudafor
#endif  
       use iso_fortran_env
       implicit none
       !   
       complex(real32), intent(inout) :: array_out(:,:) 
       complex(real32), intent(in)    :: array_in(:,:) 
       integer, optional, intent(in) ::  range1(2), range2(2)
       integer, optional, intent(in) ::  lbound1, lbound2
#if defined(__CUDA)
       attributes(device) :: array_out
#endif
       !
    end subroutine sp_memcpy_h2d_c2d
    !
    subroutine sp_memcpy_h2d_c3d(array_out, array_in, &
                                             range1, lbound1 , &
                                             range2, lbound2 , &
                                             range3, lbound3  )
#if defined(__CUDA)
       use cudafor
#endif  
       use iso_fortran_env
       implicit none
       !   
       complex(real32), intent(inout) :: array_out(:,:,:) 
       complex(real32), intent(in)    :: array_in(:,:,:) 
       integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
       integer, optional, intent(in) ::  lbound1, lbound2, lbound3
#if defined(__CUDA)
       attributes(device) :: array_out
#endif
       !
    end subroutine sp_memcpy_h2d_c3d
    !
    subroutine sp_memcpy_h2d_c4d(array_out, array_in, &
                                             range1, lbound1 , &
                                             range2, lbound2 , &
                                             range3, lbound3 , &
                                             range4, lbound4  )
#if defined(__CUDA)
       use cudafor
#endif  
       use iso_fortran_env
       implicit none
       !   
       complex(real32), intent(inout) :: array_out(:,:,:,:) 
       complex(real32), intent(in)    :: array_in(:,:,:,:) 
       integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
       integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
#if defined(__CUDA)
       attributes(device) :: array_out
#endif
       !
    end subroutine sp_memcpy_h2d_c4d
    !
    subroutine dp_memcpy_h2d_c1d(array_out, array_in, &
                                             range1, lbound1  )
#if defined(__CUDA)
       use cudafor
#endif  
       use iso_fortran_env
       implicit none
       !   
       complex(real64), intent(inout) :: array_out(:) 
       complex(real64), intent(in)    :: array_in(:) 
       integer, optional, intent(in) ::  range1(2)
       integer, optional, intent(in) ::  lbound1
#if defined(__CUDA)
       attributes(device) :: array_out
#endif
       !
    end subroutine dp_memcpy_h2d_c1d
    !
    subroutine dp_memcpy_h2d_c2d(array_out, array_in, &
                                             range1, lbound1 , &
                                             range2, lbound2  )
#if defined(__CUDA)
       use cudafor
#endif  
       use iso_fortran_env
       implicit none
       !   
       complex(real64), intent(inout) :: array_out(:,:) 
       complex(real64), intent(in)    :: array_in(:,:) 
       integer, optional, intent(in) ::  range1(2), range2(2)
       integer, optional, intent(in) ::  lbound1, lbound2
#if defined(__CUDA)
       attributes(device) :: array_out
#endif
       !
    end subroutine dp_memcpy_h2d_c2d
    !
    subroutine dp_memcpy_h2d_c3d(array_out, array_in, &
                                             range1, lbound1 , &
                                             range2, lbound2 , &
                                             range3, lbound3  )
#if defined(__CUDA)
       use cudafor
#endif  
       use iso_fortran_env
       implicit none
       !   
       complex(real64), intent(inout) :: array_out(:,:,:) 
       complex(real64), intent(in)    :: array_in(:,:,:) 
       integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
       integer, optional, intent(in) ::  lbound1, lbound2, lbound3
#if defined(__CUDA)
       attributes(device) :: array_out
#endif
       !
    end subroutine dp_memcpy_h2d_c3d
    !
    subroutine dp_memcpy_h2d_c4d(array_out, array_in, &
                                             range1, lbound1 , &
                                             range2, lbound2 , &
                                             range3, lbound3 , &
                                             range4, lbound4  )
#if defined(__CUDA)
       use cudafor
#endif  
       use iso_fortran_env
       implicit none
       !   
       complex(real64), intent(inout) :: array_out(:,:,:,:) 
       complex(real64), intent(in)    :: array_in(:,:,:,:) 
       integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
       integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
#if defined(__CUDA)
       attributes(device) :: array_out
#endif
       !
    end subroutine dp_memcpy_h2d_c4d
    !
    subroutine i4_memcpy_h2d_i1d(array_out, array_in, &
                                             range1, lbound1  )
#if defined(__CUDA)
       use cudafor
#endif  
       use iso_fortran_env
       implicit none
       !   
       integer(int32), intent(inout) :: array_out(:) 
       integer(int32), intent(in)    :: array_in(:) 
       integer, optional, intent(in) ::  range1(2)
       integer, optional, intent(in) ::  lbound1
#if defined(__CUDA)
       attributes(device) :: array_out
#endif
       !
    end subroutine i4_memcpy_h2d_i1d
    !
    subroutine i4_memcpy_h2d_i2d(array_out, array_in, &
                                             range1, lbound1 , &
                                             range2, lbound2  )
#if defined(__CUDA)
       use cudafor
#endif  
       use iso_fortran_env
       implicit none
       !   
       integer(int32), intent(inout) :: array_out(:,:) 
       integer(int32), intent(in)    :: array_in(:,:) 
       integer, optional, intent(in) ::  range1(2), range2(2)
       integer, optional, intent(in) ::  lbound1, lbound2
#if defined(__CUDA)
       attributes(device) :: array_out
#endif
       !
    end subroutine i4_memcpy_h2d_i2d
    !
    subroutine i4_memcpy_h2d_i3d(array_out, array_in, &
                                             range1, lbound1 , &
                                             range2, lbound2 , &
                                             range3, lbound3  )
#if defined(__CUDA)
       use cudafor
#endif  
       use iso_fortran_env
       implicit none
       !   
       integer(int32), intent(inout) :: array_out(:,:,:) 
       integer(int32), intent(in)    :: array_in(:,:,:) 
       integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
       integer, optional, intent(in) ::  lbound1, lbound2, lbound3
#if defined(__CUDA)
       attributes(device) :: array_out
#endif
       !
    end subroutine i4_memcpy_h2d_i3d
    !
    subroutine i4_memcpy_h2d_i4d(array_out, array_in, &
                                             range1, lbound1 , &
                                             range2, lbound2 , &
                                             range3, lbound3 , &
                                             range4, lbound4  )
#if defined(__CUDA)
       use cudafor
#endif  
       use iso_fortran_env
       implicit none
       !   
       integer(int32), intent(inout) :: array_out(:,:,:,:) 
       integer(int32), intent(in)    :: array_in(:,:,:,:) 
       integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
       integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
#if defined(__CUDA)
       attributes(device) :: array_out
#endif
       !
    end subroutine i4_memcpy_h2d_i4d
    !
    !
    subroutine sp_memcpy_d2h_r1d(array_out, array_in, &
                                             range1, lbound1  )
#if defined(__CUDA)
       use cudafor
#endif 
       use iso_fortran_env
       implicit none
       !
       real(real32), intent(inout) :: array_out(:)
       real(real32), intent(in)    :: array_in(:)
       integer, optional, intent(in) ::  range1(2)
       integer, optional, intent(in) ::  lbound1
#if defined(__CUDA)
       attributes(device) :: array_in
#endif
       !
    end subroutine sp_memcpy_d2h_r1d
    !
    subroutine sp_memcpy_d2h_r2d(array_out, array_in, &
                                             range1, lbound1 , &
                                             range2, lbound2  )
#if defined(__CUDA)
       use cudafor
#endif 
       use iso_fortran_env
       implicit none
       !
       real(real32), intent(inout) :: array_out(:,:)
       real(real32), intent(in)    :: array_in(:,:)
       integer, optional, intent(in) ::  range1(2), range2(2)
       integer, optional, intent(in) ::  lbound1, lbound2
#if defined(__CUDA)
       attributes(device) :: array_in
#endif
       !
    end subroutine sp_memcpy_d2h_r2d
    !
    subroutine sp_memcpy_d2h_r3d(array_out, array_in, &
                                             range1, lbound1 , &
                                             range2, lbound2 , &
                                             range3, lbound3  )
#if defined(__CUDA)
       use cudafor
#endif 
       use iso_fortran_env
       implicit none
       !
       real(real32), intent(inout) :: array_out(:,:,:)
       real(real32), intent(in)    :: array_in(:,:,:)
       integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
       integer, optional, intent(in) ::  lbound1, lbound2, lbound3
#if defined(__CUDA)
       attributes(device) :: array_in
#endif
       !
    end subroutine sp_memcpy_d2h_r3d
    !
    subroutine sp_memcpy_d2h_r4d(array_out, array_in, &
                                             range1, lbound1 , &
                                             range2, lbound2 , &
                                             range3, lbound3 , &
                                             range4, lbound4  )
#if defined(__CUDA)
       use cudafor
#endif 
       use iso_fortran_env
       implicit none
       !
       real(real32), intent(inout) :: array_out(:,:,:,:)
       real(real32), intent(in)    :: array_in(:,:,:,:)
       integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
       integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
#if defined(__CUDA)
       attributes(device) :: array_in
#endif
       !
    end subroutine sp_memcpy_d2h_r4d
    !
    subroutine dp_memcpy_d2h_r1d(array_out, array_in, &
                                             range1, lbound1  )
#if defined(__CUDA)
       use cudafor
#endif 
       use iso_fortran_env
       implicit none
       !
       real(real64), intent(inout) :: array_out(:)
       real(real64), intent(in)    :: array_in(:)
       integer, optional, intent(in) ::  range1(2)
       integer, optional, intent(in) ::  lbound1
#if defined(__CUDA)
       attributes(device) :: array_in
#endif
       !
    end subroutine dp_memcpy_d2h_r1d
    !
    subroutine dp_memcpy_d2h_r2d(array_out, array_in, &
                                             range1, lbound1 , &
                                             range2, lbound2  )
#if defined(__CUDA)
       use cudafor
#endif 
       use iso_fortran_env
       implicit none
       !
       real(real64), intent(inout) :: array_out(:,:)
       real(real64), intent(in)    :: array_in(:,:)
       integer, optional, intent(in) ::  range1(2), range2(2)
       integer, optional, intent(in) ::  lbound1, lbound2
#if defined(__CUDA)
       attributes(device) :: array_in
#endif
       !
    end subroutine dp_memcpy_d2h_r2d
    !
    subroutine dp_memcpy_d2h_r3d(array_out, array_in, &
                                             range1, lbound1 , &
                                             range2, lbound2 , &
                                             range3, lbound3  )
#if defined(__CUDA)
       use cudafor
#endif 
       use iso_fortran_env
       implicit none
       !
       real(real64), intent(inout) :: array_out(:,:,:)
       real(real64), intent(in)    :: array_in(:,:,:)
       integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
       integer, optional, intent(in) ::  lbound1, lbound2, lbound3
#if defined(__CUDA)
       attributes(device) :: array_in
#endif
       !
    end subroutine dp_memcpy_d2h_r3d
    !
    subroutine dp_memcpy_d2h_r4d(array_out, array_in, &
                                             range1, lbound1 , &
                                             range2, lbound2 , &
                                             range3, lbound3 , &
                                             range4, lbound4  )
#if defined(__CUDA)
       use cudafor
#endif 
       use iso_fortran_env
       implicit none
       !
       real(real64), intent(inout) :: array_out(:,:,:,:)
       real(real64), intent(in)    :: array_in(:,:,:,:)
       integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
       integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
#if defined(__CUDA)
       attributes(device) :: array_in
#endif
       !
    end subroutine dp_memcpy_d2h_r4d
    !
    subroutine sp_memcpy_d2h_c1d(array_out, array_in, &
                                             range1, lbound1  )
#if defined(__CUDA)
       use cudafor
#endif 
       use iso_fortran_env
       implicit none
       !
       complex(real32), intent(inout) :: array_out(:)
       complex(real32), intent(in)    :: array_in(:)
       integer, optional, intent(in) ::  range1(2)
       integer, optional, intent(in) ::  lbound1
#if defined(__CUDA)
       attributes(device) :: array_in
#endif
       !
    end subroutine sp_memcpy_d2h_c1d
    !
    subroutine sp_memcpy_d2h_c2d(array_out, array_in, &
                                             range1, lbound1 , &
                                             range2, lbound2  )
#if defined(__CUDA)
       use cudafor
#endif 
       use iso_fortran_env
       implicit none
       !
       complex(real32), intent(inout) :: array_out(:,:)
       complex(real32), intent(in)    :: array_in(:,:)
       integer, optional, intent(in) ::  range1(2), range2(2)
       integer, optional, intent(in) ::  lbound1, lbound2
#if defined(__CUDA)
       attributes(device) :: array_in
#endif
       !
    end subroutine sp_memcpy_d2h_c2d
    !
    subroutine sp_memcpy_d2h_c3d(array_out, array_in, &
                                             range1, lbound1 , &
                                             range2, lbound2 , &
                                             range3, lbound3  )
#if defined(__CUDA)
       use cudafor
#endif 
       use iso_fortran_env
       implicit none
       !
       complex(real32), intent(inout) :: array_out(:,:,:)
       complex(real32), intent(in)    :: array_in(:,:,:)
       integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
       integer, optional, intent(in) ::  lbound1, lbound2, lbound3
#if defined(__CUDA)
       attributes(device) :: array_in
#endif
       !
    end subroutine sp_memcpy_d2h_c3d
    !
    subroutine sp_memcpy_d2h_c4d(array_out, array_in, &
                                             range1, lbound1 , &
                                             range2, lbound2 , &
                                             range3, lbound3 , &
                                             range4, lbound4  )
#if defined(__CUDA)
       use cudafor
#endif 
       use iso_fortran_env
       implicit none
       !
       complex(real32), intent(inout) :: array_out(:,:,:,:)
       complex(real32), intent(in)    :: array_in(:,:,:,:)
       integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
       integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
#if defined(__CUDA)
       attributes(device) :: array_in
#endif
       !
    end subroutine sp_memcpy_d2h_c4d
    !
    subroutine dp_memcpy_d2h_c1d(array_out, array_in, &
                                             range1, lbound1  )
#if defined(__CUDA)
       use cudafor
#endif 
       use iso_fortran_env
       implicit none
       !
       complex(real64), intent(inout) :: array_out(:)
       complex(real64), intent(in)    :: array_in(:)
       integer, optional, intent(in) ::  range1(2)
       integer, optional, intent(in) ::  lbound1
#if defined(__CUDA)
       attributes(device) :: array_in
#endif
       !
    end subroutine dp_memcpy_d2h_c1d
    !
    subroutine dp_memcpy_d2h_c2d(array_out, array_in, &
                                             range1, lbound1 , &
                                             range2, lbound2  )
#if defined(__CUDA)
       use cudafor
#endif 
       use iso_fortran_env
       implicit none
       !
       complex(real64), intent(inout) :: array_out(:,:)
       complex(real64), intent(in)    :: array_in(:,:)
       integer, optional, intent(in) ::  range1(2), range2(2)
       integer, optional, intent(in) ::  lbound1, lbound2
#if defined(__CUDA)
       attributes(device) :: array_in
#endif
       !
    end subroutine dp_memcpy_d2h_c2d
    !
    subroutine dp_memcpy_d2h_c3d(array_out, array_in, &
                                             range1, lbound1 , &
                                             range2, lbound2 , &
                                             range3, lbound3  )
#if defined(__CUDA)
       use cudafor
#endif 
       use iso_fortran_env
       implicit none
       !
       complex(real64), intent(inout) :: array_out(:,:,:)
       complex(real64), intent(in)    :: array_in(:,:,:)
       integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
       integer, optional, intent(in) ::  lbound1, lbound2, lbound3
#if defined(__CUDA)
       attributes(device) :: array_in
#endif
       !
    end subroutine dp_memcpy_d2h_c3d
    !
    subroutine dp_memcpy_d2h_c4d(array_out, array_in, &
                                             range1, lbound1 , &
                                             range2, lbound2 , &
                                             range3, lbound3 , &
                                             range4, lbound4  )
#if defined(__CUDA)
       use cudafor
#endif 
       use iso_fortran_env
       implicit none
       !
       complex(real64), intent(inout) :: array_out(:,:,:,:)
       complex(real64), intent(in)    :: array_in(:,:,:,:)
       integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
       integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
#if defined(__CUDA)
       attributes(device) :: array_in
#endif
       !
    end subroutine dp_memcpy_d2h_c4d
    !
    subroutine i4_memcpy_d2h_i1d(array_out, array_in, &
                                             range1, lbound1  )
#if defined(__CUDA)
       use cudafor
#endif 
       use iso_fortran_env
       implicit none
       !
       integer(int32), intent(inout) :: array_out(:)
       integer(int32), intent(in)    :: array_in(:)
       integer, optional, intent(in) ::  range1(2)
       integer, optional, intent(in) ::  lbound1
#if defined(__CUDA)
       attributes(device) :: array_in
#endif
       !
    end subroutine i4_memcpy_d2h_i1d
    !
    subroutine i4_memcpy_d2h_i2d(array_out, array_in, &
                                             range1, lbound1 , &
                                             range2, lbound2  )
#if defined(__CUDA)
       use cudafor
#endif 
       use iso_fortran_env
       implicit none
       !
       integer(int32), intent(inout) :: array_out(:,:)
       integer(int32), intent(in)    :: array_in(:,:)
       integer, optional, intent(in) ::  range1(2), range2(2)
       integer, optional, intent(in) ::  lbound1, lbound2
#if defined(__CUDA)
       attributes(device) :: array_in
#endif
       !
    end subroutine i4_memcpy_d2h_i2d
    !
    subroutine i4_memcpy_d2h_i3d(array_out, array_in, &
                                             range1, lbound1 , &
                                             range2, lbound2 , &
                                             range3, lbound3  )
#if defined(__CUDA)
       use cudafor
#endif 
       use iso_fortran_env
       implicit none
       !
       integer(int32), intent(inout) :: array_out(:,:,:)
       integer(int32), intent(in)    :: array_in(:,:,:)
       integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
       integer, optional, intent(in) ::  lbound1, lbound2, lbound3
#if defined(__CUDA)
       attributes(device) :: array_in
#endif
       !
    end subroutine i4_memcpy_d2h_i3d
    !
    subroutine i4_memcpy_d2h_i4d(array_out, array_in, &
                                             range1, lbound1 , &
                                             range2, lbound2 , &
                                             range3, lbound3 , &
                                             range4, lbound4  )
#if defined(__CUDA)
       use cudafor
#endif 
       use iso_fortran_env
       implicit none
       !
       integer(int32), intent(inout) :: array_out(:,:,:,:)
       integer(int32), intent(in)    :: array_in(:,:,:,:)
       integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
       integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
#if defined(__CUDA)
       attributes(device) :: array_in
#endif
       !
    end subroutine i4_memcpy_d2h_i4d
    !
#endif
    !
end interface dev_memcpy
!
interface dev_memcpy_async
    !
    subroutine sp_memcpy_d2h_async_r1d(array_out, array_in, stream, &
                                             range1, lbound1  )
#if defined(__CUDA)
       use cudafor
#endif 
       use iso_fortran_env
       implicit none
       !
       real(real32), intent(inout) :: array_out(:)
       real(real32), intent(in)    :: array_in(:)
#if defined(__CUDA)
       integer(kind=cuda_Stream_Kind), intent(in) :: stream
#else
       integer, intent(in) :: stream
#endif
       integer, optional, intent(in) :: range1(2)
       integer, optional, intent(in) :: lbound1
#if defined(__CUDA)
       attributes(device) :: array_in
#endif
       !
    end subroutine sp_memcpy_d2h_async_r1d
    !
    subroutine sp_memcpy_d2h_async_r2d(array_out, array_in, stream, &
                                             range1, lbound1 , &
                                             range2, lbound2  )
#if defined(__CUDA)
       use cudafor
#endif 
       use iso_fortran_env
       implicit none
       !
       real(real32), intent(inout) :: array_out(:,:)
       real(real32), intent(in)    :: array_in(:,:)
#if defined(__CUDA)
       integer(kind=cuda_Stream_Kind), intent(in) :: stream
#else
       integer, intent(in) :: stream
#endif
       integer, optional, intent(in) :: range1(2),range2(2)
       integer, optional, intent(in) :: lbound1,lbound2
#if defined(__CUDA)
       attributes(device) :: array_in
#endif
       !
    end subroutine sp_memcpy_d2h_async_r2d
    !
    subroutine sp_memcpy_d2h_async_r3d(array_out, array_in, stream, &
                                             range1, lbound1 , &
                                             range2, lbound2 , &
                                             range3, lbound3  )
#if defined(__CUDA)
       use cudafor
#endif 
       use iso_fortran_env
       implicit none
       !
       real(real32), intent(inout) :: array_out(:,:,:)
       real(real32), intent(in)    :: array_in(:,:,:)
#if defined(__CUDA)
       integer(kind=cuda_Stream_Kind), intent(in) :: stream
#else
       integer, intent(in) :: stream
#endif
       integer, optional, intent(in) :: range1(2),range2(2),range3(2)
       integer, optional, intent(in) :: lbound1,lbound2,lbound3
#if defined(__CUDA)
       attributes(device) :: array_in
#endif
       !
    end subroutine sp_memcpy_d2h_async_r3d
    !
    subroutine sp_memcpy_d2h_async_r4d(array_out, array_in, stream, &
                                             range1, lbound1 , &
                                             range2, lbound2 , &
                                             range3, lbound3 , &
                                             range4, lbound4  )
#if defined(__CUDA)
       use cudafor
#endif 
       use iso_fortran_env
       implicit none
       !
       real(real32), intent(inout) :: array_out(:,:,:,:)
       real(real32), intent(in)    :: array_in(:,:,:,:)
#if defined(__CUDA)
       integer(kind=cuda_Stream_Kind), intent(in) :: stream
#else
       integer, intent(in) :: stream
#endif
       integer, optional, intent(in) :: range1(2),range2(2),range3(2),range4(2)
       integer, optional, intent(in) :: lbound1,lbound2,lbound3,lbound4
#if defined(__CUDA)
       attributes(device) :: array_in
#endif
       !
    end subroutine sp_memcpy_d2h_async_r4d
    !
    subroutine dp_memcpy_d2h_async_r1d(array_out, array_in, stream, &
                                             range1, lbound1  )
#if defined(__CUDA)
       use cudafor
#endif 
       use iso_fortran_env
       implicit none
       !
       real(real64), intent(inout) :: array_out(:)
       real(real64), intent(in)    :: array_in(:)
#if defined(__CUDA)
       integer(kind=cuda_Stream_Kind), intent(in) :: stream
#else
       integer, intent(in) :: stream
#endif
       integer, optional, intent(in) :: range1(2)
       integer, optional, intent(in) :: lbound1
#if defined(__CUDA)
       attributes(device) :: array_in
#endif
       !
    end subroutine dp_memcpy_d2h_async_r1d
    !
    subroutine dp_memcpy_d2h_async_r2d(array_out, array_in, stream, &
                                             range1, lbound1 , &
                                             range2, lbound2  )
#if defined(__CUDA)
       use cudafor
#endif 
       use iso_fortran_env
       implicit none
       !
       real(real64), intent(inout) :: array_out(:,:)
       real(real64), intent(in)    :: array_in(:,:)
#if defined(__CUDA)
       integer(kind=cuda_Stream_Kind), intent(in) :: stream
#else
       integer, intent(in) :: stream
#endif
       integer, optional, intent(in) :: range1(2),range2(2)
       integer, optional, intent(in) :: lbound1,lbound2
#if defined(__CUDA)
       attributes(device) :: array_in
#endif
       !
    end subroutine dp_memcpy_d2h_async_r2d
    !
    subroutine dp_memcpy_d2h_async_r3d(array_out, array_in, stream, &
                                             range1, lbound1 , &
                                             range2, lbound2 , &
                                             range3, lbound3  )
#if defined(__CUDA)
       use cudafor
#endif 
       use iso_fortran_env
       implicit none
       !
       real(real64), intent(inout) :: array_out(:,:,:)
       real(real64), intent(in)    :: array_in(:,:,:)
#if defined(__CUDA)
       integer(kind=cuda_Stream_Kind), intent(in) :: stream
#else
       integer, intent(in) :: stream
#endif
       integer, optional, intent(in) :: range1(2),range2(2),range3(2)
       integer, optional, intent(in) :: lbound1,lbound2,lbound3
#if defined(__CUDA)
       attributes(device) :: array_in
#endif
       !
    end subroutine dp_memcpy_d2h_async_r3d
    !
    subroutine dp_memcpy_d2h_async_r4d(array_out, array_in, stream, &
                                             range1, lbound1 , &
                                             range2, lbound2 , &
                                             range3, lbound3 , &
                                             range4, lbound4  )
#if defined(__CUDA)
       use cudafor
#endif 
       use iso_fortran_env
       implicit none
       !
       real(real64), intent(inout) :: array_out(:,:,:,:)
       real(real64), intent(in)    :: array_in(:,:,:,:)
#if defined(__CUDA)
       integer(kind=cuda_Stream_Kind), intent(in) :: stream
#else
       integer, intent(in) :: stream
#endif
       integer, optional, intent(in) :: range1(2),range2(2),range3(2),range4(2)
       integer, optional, intent(in) :: lbound1,lbound2,lbound3,lbound4
#if defined(__CUDA)
       attributes(device) :: array_in
#endif
       !
    end subroutine dp_memcpy_d2h_async_r4d
    !
    subroutine sp_memcpy_d2h_async_c1d(array_out, array_in, stream, &
                                             range1, lbound1  )
#if defined(__CUDA)
       use cudafor
#endif 
       use iso_fortran_env
       implicit none
       !
       complex(real32), intent(inout) :: array_out(:)
       complex(real32), intent(in)    :: array_in(:)
#if defined(__CUDA)
       integer(kind=cuda_Stream_Kind), intent(in) :: stream
#else
       integer, intent(in) :: stream
#endif
       integer, optional, intent(in) :: range1(2)
       integer, optional, intent(in) :: lbound1
#if defined(__CUDA)
       attributes(device) :: array_in
#endif
       !
    end subroutine sp_memcpy_d2h_async_c1d
    !
    subroutine sp_memcpy_d2h_async_c2d(array_out, array_in, stream, &
                                             range1, lbound1 , &
                                             range2, lbound2  )
#if defined(__CUDA)
       use cudafor
#endif 
       use iso_fortran_env
       implicit none
       !
       complex(real32), intent(inout) :: array_out(:,:)
       complex(real32), intent(in)    :: array_in(:,:)
#if defined(__CUDA)
       integer(kind=cuda_Stream_Kind), intent(in) :: stream
#else
       integer, intent(in) :: stream
#endif
       integer, optional, intent(in) :: range1(2),range2(2)
       integer, optional, intent(in) :: lbound1,lbound2
#if defined(__CUDA)
       attributes(device) :: array_in
#endif
       !
    end subroutine sp_memcpy_d2h_async_c2d
    !
    subroutine sp_memcpy_d2h_async_c3d(array_out, array_in, stream, &
                                             range1, lbound1 , &
                                             range2, lbound2 , &
                                             range3, lbound3  )
#if defined(__CUDA)
       use cudafor
#endif 
       use iso_fortran_env
       implicit none
       !
       complex(real32), intent(inout) :: array_out(:,:,:)
       complex(real32), intent(in)    :: array_in(:,:,:)
#if defined(__CUDA)
       integer(kind=cuda_Stream_Kind), intent(in) :: stream
#else
       integer, intent(in) :: stream
#endif
       integer, optional, intent(in) :: range1(2),range2(2),range3(2)
       integer, optional, intent(in) :: lbound1,lbound2,lbound3
#if defined(__CUDA)
       attributes(device) :: array_in
#endif
       !
    end subroutine sp_memcpy_d2h_async_c3d
    !
    subroutine sp_memcpy_d2h_async_c4d(array_out, array_in, stream, &
                                             range1, lbound1 , &
                                             range2, lbound2 , &
                                             range3, lbound3 , &
                                             range4, lbound4  )
#if defined(__CUDA)
       use cudafor
#endif 
       use iso_fortran_env
       implicit none
       !
       complex(real32), intent(inout) :: array_out(:,:,:,:)
       complex(real32), intent(in)    :: array_in(:,:,:,:)
#if defined(__CUDA)
       integer(kind=cuda_Stream_Kind), intent(in) :: stream
#else
       integer, intent(in) :: stream
#endif
       integer, optional, intent(in) :: range1(2),range2(2),range3(2),range4(2)
       integer, optional, intent(in) :: lbound1,lbound2,lbound3,lbound4
#if defined(__CUDA)
       attributes(device) :: array_in
#endif
       !
    end subroutine sp_memcpy_d2h_async_c4d
    !
    subroutine dp_memcpy_d2h_async_c1d(array_out, array_in, stream, &
                                             range1, lbound1  )
#if defined(__CUDA)
       use cudafor
#endif 
       use iso_fortran_env
       implicit none
       !
       complex(real64), intent(inout) :: array_out(:)
       complex(real64), intent(in)    :: array_in(:)
#if defined(__CUDA)
       integer(kind=cuda_Stream_Kind), intent(in) :: stream
#else
       integer, intent(in) :: stream
#endif
       integer, optional, intent(in) :: range1(2)
       integer, optional, intent(in) :: lbound1
#if defined(__CUDA)
       attributes(device) :: array_in
#endif
       !
    end subroutine dp_memcpy_d2h_async_c1d
    !
    subroutine dp_memcpy_d2h_async_c2d(array_out, array_in, stream, &
                                             range1, lbound1 , &
                                             range2, lbound2  )
#if defined(__CUDA)
       use cudafor
#endif 
       use iso_fortran_env
       implicit none
       !
       complex(real64), intent(inout) :: array_out(:,:)
       complex(real64), intent(in)    :: array_in(:,:)
#if defined(__CUDA)
       integer(kind=cuda_Stream_Kind), intent(in) :: stream
#else
       integer, intent(in) :: stream
#endif
       integer, optional, intent(in) :: range1(2),range2(2)
       integer, optional, intent(in) :: lbound1,lbound2
#if defined(__CUDA)
       attributes(device) :: array_in
#endif
       !
    end subroutine dp_memcpy_d2h_async_c2d
    !
    subroutine dp_memcpy_d2h_async_c3d(array_out, array_in, stream, &
                                             range1, lbound1 , &
                                             range2, lbound2 , &
                                             range3, lbound3  )
#if defined(__CUDA)
       use cudafor
#endif 
       use iso_fortran_env
       implicit none
       !
       complex(real64), intent(inout) :: array_out(:,:,:)
       complex(real64), intent(in)    :: array_in(:,:,:)
#if defined(__CUDA)
       integer(kind=cuda_Stream_Kind), intent(in) :: stream
#else
       integer, intent(in) :: stream
#endif
       integer, optional, intent(in) :: range1(2),range2(2),range3(2)
       integer, optional, intent(in) :: lbound1,lbound2,lbound3
#if defined(__CUDA)
       attributes(device) :: array_in
#endif
       !
    end subroutine dp_memcpy_d2h_async_c3d
    !
    subroutine dp_memcpy_d2h_async_c4d(array_out, array_in, stream, &
                                             range1, lbound1 , &
                                             range2, lbound2 , &
                                             range3, lbound3 , &
                                             range4, lbound4  )
#if defined(__CUDA)
       use cudafor
#endif 
       use iso_fortran_env
       implicit none
       !
       complex(real64), intent(inout) :: array_out(:,:,:,:)
       complex(real64), intent(in)    :: array_in(:,:,:,:)
#if defined(__CUDA)
       integer(kind=cuda_Stream_Kind), intent(in) :: stream
#else
       integer, intent(in) :: stream
#endif
       integer, optional, intent(in) :: range1(2),range2(2),range3(2),range4(2)
       integer, optional, intent(in) :: lbound1,lbound2,lbound3,lbound4
#if defined(__CUDA)
       attributes(device) :: array_in
#endif
       !
    end subroutine dp_memcpy_d2h_async_c4d
    !
    subroutine i4_memcpy_d2h_async_i1d(array_out, array_in, stream, &
                                             range1, lbound1  )
#if defined(__CUDA)
       use cudafor
#endif 
       use iso_fortran_env
       implicit none
       !
       integer(int32), intent(inout) :: array_out(:)
       integer(int32), intent(in)    :: array_in(:)
#if defined(__CUDA)
       integer(kind=cuda_Stream_Kind), intent(in) :: stream
#else
       integer, intent(in) :: stream
#endif
       integer, optional, intent(in) :: range1(2)
       integer, optional, intent(in) :: lbound1
#if defined(__CUDA)
       attributes(device) :: array_in
#endif
       !
    end subroutine i4_memcpy_d2h_async_i1d
    !
    subroutine i4_memcpy_d2h_async_i2d(array_out, array_in, stream, &
                                             range1, lbound1 , &
                                             range2, lbound2  )
#if defined(__CUDA)
       use cudafor
#endif 
       use iso_fortran_env
       implicit none
       !
       integer(int32), intent(inout) :: array_out(:,:)
       integer(int32), intent(in)    :: array_in(:,:)
#if defined(__CUDA)
       integer(kind=cuda_Stream_Kind), intent(in) :: stream
#else
       integer, intent(in) :: stream
#endif
       integer, optional, intent(in) :: range1(2),range2(2)
       integer, optional, intent(in) :: lbound1,lbound2
#if defined(__CUDA)
       attributes(device) :: array_in
#endif
       !
    end subroutine i4_memcpy_d2h_async_i2d
    !
    subroutine i4_memcpy_d2h_async_i3d(array_out, array_in, stream, &
                                             range1, lbound1 , &
                                             range2, lbound2 , &
                                             range3, lbound3  )
#if defined(__CUDA)
       use cudafor
#endif 
       use iso_fortran_env
       implicit none
       !
       integer(int32), intent(inout) :: array_out(:,:,:)
       integer(int32), intent(in)    :: array_in(:,:,:)
#if defined(__CUDA)
       integer(kind=cuda_Stream_Kind), intent(in) :: stream
#else
       integer, intent(in) :: stream
#endif
       integer, optional, intent(in) :: range1(2),range2(2),range3(2)
       integer, optional, intent(in) :: lbound1,lbound2,lbound3
#if defined(__CUDA)
       attributes(device) :: array_in
#endif
       !
    end subroutine i4_memcpy_d2h_async_i3d
    !
    subroutine i4_memcpy_d2h_async_i4d(array_out, array_in, stream, &
                                             range1, lbound1 , &
                                             range2, lbound2 , &
                                             range3, lbound3 , &
                                             range4, lbound4  )
#if defined(__CUDA)
       use cudafor
#endif 
       use iso_fortran_env
       implicit none
       !
       integer(int32), intent(inout) :: array_out(:,:,:,:)
       integer(int32), intent(in)    :: array_in(:,:,:,:)
#if defined(__CUDA)
       integer(kind=cuda_Stream_Kind), intent(in) :: stream
#else
       integer, intent(in) :: stream
#endif
       integer, optional, intent(in) :: range1(2),range2(2),range3(2),range4(2)
       integer, optional, intent(in) :: lbound1,lbound2,lbound3,lbound4
#if defined(__CUDA)
       attributes(device) :: array_in
#endif
       !
    end subroutine i4_memcpy_d2h_async_i4d
    !
    !
#if defined(__HAVE_DEVICE)
    subroutine sp_memcpy_h2d_async_r1d(array_out, array_in, stream, &
                                             range1, lbound1  )
#if defined(__CUDA)
       use cudafor
#endif 
       use iso_fortran_env
       implicit none
       !
       real(real32), intent(inout) :: array_out(:)
       real(real32), intent(in)    :: array_in(:)
#if defined(__CUDA)
       integer(kind=cuda_Stream_Kind), intent(in) :: stream
#else
       integer, intent(in) :: stream
#endif
       integer, optional, intent(in) :: range1(2)
       integer, optional, intent(in) :: lbound1
#if defined(__CUDA)
       attributes(device) :: array_out
#endif
       !
    end subroutine sp_memcpy_h2d_async_r1d
    !
    subroutine sp_memcpy_h2d_async_r2d(array_out, array_in, stream, &
                                             range1, lbound1 , &
                                             range2, lbound2  )
#if defined(__CUDA)
       use cudafor
#endif 
       use iso_fortran_env
       implicit none
       !
       real(real32), intent(inout) :: array_out(:,:)
       real(real32), intent(in)    :: array_in(:,:)
#if defined(__CUDA)
       integer(kind=cuda_Stream_Kind), intent(in) :: stream
#else
       integer, intent(in) :: stream
#endif
       integer, optional, intent(in) :: range1(2),range2(2)
       integer, optional, intent(in) :: lbound1,lbound2
#if defined(__CUDA)
       attributes(device) :: array_out
#endif
       !
    end subroutine sp_memcpy_h2d_async_r2d
    !
    subroutine sp_memcpy_h2d_async_r3d(array_out, array_in, stream, &
                                             range1, lbound1 , &
                                             range2, lbound2 , &
                                             range3, lbound3  )
#if defined(__CUDA)
       use cudafor
#endif 
       use iso_fortran_env
       implicit none
       !
       real(real32), intent(inout) :: array_out(:,:,:)
       real(real32), intent(in)    :: array_in(:,:,:)
#if defined(__CUDA)
       integer(kind=cuda_Stream_Kind), intent(in) :: stream
#else
       integer, intent(in) :: stream
#endif
       integer, optional, intent(in) :: range1(2),range2(2),range3(2)
       integer, optional, intent(in) :: lbound1,lbound2,lbound3
#if defined(__CUDA)
       attributes(device) :: array_out
#endif
       !
    end subroutine sp_memcpy_h2d_async_r3d
    !
    subroutine sp_memcpy_h2d_async_r4d(array_out, array_in, stream, &
                                             range1, lbound1 , &
                                             range2, lbound2 , &
                                             range3, lbound3 , &
                                             range4, lbound4  )
#if defined(__CUDA)
       use cudafor
#endif 
       use iso_fortran_env
       implicit none
       !
       real(real32), intent(inout) :: array_out(:,:,:,:)
       real(real32), intent(in)    :: array_in(:,:,:,:)
#if defined(__CUDA)
       integer(kind=cuda_Stream_Kind), intent(in) :: stream
#else
       integer, intent(in) :: stream
#endif
       integer, optional, intent(in) :: range1(2),range2(2),range3(2),range4(2)
       integer, optional, intent(in) :: lbound1,lbound2,lbound3,lbound4
#if defined(__CUDA)
       attributes(device) :: array_out
#endif
       !
    end subroutine sp_memcpy_h2d_async_r4d
    !
    subroutine dp_memcpy_h2d_async_r1d(array_out, array_in, stream, &
                                             range1, lbound1  )
#if defined(__CUDA)
       use cudafor
#endif 
       use iso_fortran_env
       implicit none
       !
       real(real64), intent(inout) :: array_out(:)
       real(real64), intent(in)    :: array_in(:)
#if defined(__CUDA)
       integer(kind=cuda_Stream_Kind), intent(in) :: stream
#else
       integer, intent(in) :: stream
#endif
       integer, optional, intent(in) :: range1(2)
       integer, optional, intent(in) :: lbound1
#if defined(__CUDA)
       attributes(device) :: array_out
#endif
       !
    end subroutine dp_memcpy_h2d_async_r1d
    !
    subroutine dp_memcpy_h2d_async_r2d(array_out, array_in, stream, &
                                             range1, lbound1 , &
                                             range2, lbound2  )
#if defined(__CUDA)
       use cudafor
#endif 
       use iso_fortran_env
       implicit none
       !
       real(real64), intent(inout) :: array_out(:,:)
       real(real64), intent(in)    :: array_in(:,:)
#if defined(__CUDA)
       integer(kind=cuda_Stream_Kind), intent(in) :: stream
#else
       integer, intent(in) :: stream
#endif
       integer, optional, intent(in) :: range1(2),range2(2)
       integer, optional, intent(in) :: lbound1,lbound2
#if defined(__CUDA)
       attributes(device) :: array_out
#endif
       !
    end subroutine dp_memcpy_h2d_async_r2d
    !
    subroutine dp_memcpy_h2d_async_r3d(array_out, array_in, stream, &
                                             range1, lbound1 , &
                                             range2, lbound2 , &
                                             range3, lbound3  )
#if defined(__CUDA)
       use cudafor
#endif 
       use iso_fortran_env
       implicit none
       !
       real(real64), intent(inout) :: array_out(:,:,:)
       real(real64), intent(in)    :: array_in(:,:,:)
#if defined(__CUDA)
       integer(kind=cuda_Stream_Kind), intent(in) :: stream
#else
       integer, intent(in) :: stream
#endif
       integer, optional, intent(in) :: range1(2),range2(2),range3(2)
       integer, optional, intent(in) :: lbound1,lbound2,lbound3
#if defined(__CUDA)
       attributes(device) :: array_out
#endif
       !
    end subroutine dp_memcpy_h2d_async_r3d
    !
    subroutine dp_memcpy_h2d_async_r4d(array_out, array_in, stream, &
                                             range1, lbound1 , &
                                             range2, lbound2 , &
                                             range3, lbound3 , &
                                             range4, lbound4  )
#if defined(__CUDA)
       use cudafor
#endif 
       use iso_fortran_env
       implicit none
       !
       real(real64), intent(inout) :: array_out(:,:,:,:)
       real(real64), intent(in)    :: array_in(:,:,:,:)
#if defined(__CUDA)
       integer(kind=cuda_Stream_Kind), intent(in) :: stream
#else
       integer, intent(in) :: stream
#endif
       integer, optional, intent(in) :: range1(2),range2(2),range3(2),range4(2)
       integer, optional, intent(in) :: lbound1,lbound2,lbound3,lbound4
#if defined(__CUDA)
       attributes(device) :: array_out
#endif
       !
    end subroutine dp_memcpy_h2d_async_r4d
    !
    subroutine sp_memcpy_h2d_async_c1d(array_out, array_in, stream, &
                                             range1, lbound1  )
#if defined(__CUDA)
       use cudafor
#endif 
       use iso_fortran_env
       implicit none
       !
       complex(real32), intent(inout) :: array_out(:)
       complex(real32), intent(in)    :: array_in(:)
#if defined(__CUDA)
       integer(kind=cuda_Stream_Kind), intent(in) :: stream
#else
       integer, intent(in) :: stream
#endif
       integer, optional, intent(in) :: range1(2)
       integer, optional, intent(in) :: lbound1
#if defined(__CUDA)
       attributes(device) :: array_out
#endif
       !
    end subroutine sp_memcpy_h2d_async_c1d
    !
    subroutine sp_memcpy_h2d_async_c2d(array_out, array_in, stream, &
                                             range1, lbound1 , &
                                             range2, lbound2  )
#if defined(__CUDA)
       use cudafor
#endif 
       use iso_fortran_env
       implicit none
       !
       complex(real32), intent(inout) :: array_out(:,:)
       complex(real32), intent(in)    :: array_in(:,:)
#if defined(__CUDA)
       integer(kind=cuda_Stream_Kind), intent(in) :: stream
#else
       integer, intent(in) :: stream
#endif
       integer, optional, intent(in) :: range1(2),range2(2)
       integer, optional, intent(in) :: lbound1,lbound2
#if defined(__CUDA)
       attributes(device) :: array_out
#endif
       !
    end subroutine sp_memcpy_h2d_async_c2d
    !
    subroutine sp_memcpy_h2d_async_c3d(array_out, array_in, stream, &
                                             range1, lbound1 , &
                                             range2, lbound2 , &
                                             range3, lbound3  )
#if defined(__CUDA)
       use cudafor
#endif 
       use iso_fortran_env
       implicit none
       !
       complex(real32), intent(inout) :: array_out(:,:,:)
       complex(real32), intent(in)    :: array_in(:,:,:)
#if defined(__CUDA)
       integer(kind=cuda_Stream_Kind), intent(in) :: stream
#else
       integer, intent(in) :: stream
#endif
       integer, optional, intent(in) :: range1(2),range2(2),range3(2)
       integer, optional, intent(in) :: lbound1,lbound2,lbound3
#if defined(__CUDA)
       attributes(device) :: array_out
#endif
       !
    end subroutine sp_memcpy_h2d_async_c3d
    !
    subroutine sp_memcpy_h2d_async_c4d(array_out, array_in, stream, &
                                             range1, lbound1 , &
                                             range2, lbound2 , &
                                             range3, lbound3 , &
                                             range4, lbound4  )
#if defined(__CUDA)
       use cudafor
#endif 
       use iso_fortran_env
       implicit none
       !
       complex(real32), intent(inout) :: array_out(:,:,:,:)
       complex(real32), intent(in)    :: array_in(:,:,:,:)
#if defined(__CUDA)
       integer(kind=cuda_Stream_Kind), intent(in) :: stream
#else
       integer, intent(in) :: stream
#endif
       integer, optional, intent(in) :: range1(2),range2(2),range3(2),range4(2)
       integer, optional, intent(in) :: lbound1,lbound2,lbound3,lbound4
#if defined(__CUDA)
       attributes(device) :: array_out
#endif
       !
    end subroutine sp_memcpy_h2d_async_c4d
    !
    subroutine dp_memcpy_h2d_async_c1d(array_out, array_in, stream, &
                                             range1, lbound1  )
#if defined(__CUDA)
       use cudafor
#endif 
       use iso_fortran_env
       implicit none
       !
       complex(real64), intent(inout) :: array_out(:)
       complex(real64), intent(in)    :: array_in(:)
#if defined(__CUDA)
       integer(kind=cuda_Stream_Kind), intent(in) :: stream
#else
       integer, intent(in) :: stream
#endif
       integer, optional, intent(in) :: range1(2)
       integer, optional, intent(in) :: lbound1
#if defined(__CUDA)
       attributes(device) :: array_out
#endif
       !
    end subroutine dp_memcpy_h2d_async_c1d
    !
    subroutine dp_memcpy_h2d_async_c2d(array_out, array_in, stream, &
                                             range1, lbound1 , &
                                             range2, lbound2  )
#if defined(__CUDA)
       use cudafor
#endif 
       use iso_fortran_env
       implicit none
       !
       complex(real64), intent(inout) :: array_out(:,:)
       complex(real64), intent(in)    :: array_in(:,:)
#if defined(__CUDA)
       integer(kind=cuda_Stream_Kind), intent(in) :: stream
#else
       integer, intent(in) :: stream
#endif
       integer, optional, intent(in) :: range1(2),range2(2)
       integer, optional, intent(in) :: lbound1,lbound2
#if defined(__CUDA)
       attributes(device) :: array_out
#endif
       !
    end subroutine dp_memcpy_h2d_async_c2d
    !
    subroutine dp_memcpy_h2d_async_c3d(array_out, array_in, stream, &
                                             range1, lbound1 , &
                                             range2, lbound2 , &
                                             range3, lbound3  )
#if defined(__CUDA)
       use cudafor
#endif 
       use iso_fortran_env
       implicit none
       !
       complex(real64), intent(inout) :: array_out(:,:,:)
       complex(real64), intent(in)    :: array_in(:,:,:)
#if defined(__CUDA)
       integer(kind=cuda_Stream_Kind), intent(in) :: stream
#else
       integer, intent(in) :: stream
#endif
       integer, optional, intent(in) :: range1(2),range2(2),range3(2)
       integer, optional, intent(in) :: lbound1,lbound2,lbound3
#if defined(__CUDA)
       attributes(device) :: array_out
#endif
       !
    end subroutine dp_memcpy_h2d_async_c3d
    !
    subroutine dp_memcpy_h2d_async_c4d(array_out, array_in, stream, &
                                             range1, lbound1 , &
                                             range2, lbound2 , &
                                             range3, lbound3 , &
                                             range4, lbound4  )
#if defined(__CUDA)
       use cudafor
#endif 
       use iso_fortran_env
       implicit none
       !
       complex(real64), intent(inout) :: array_out(:,:,:,:)
       complex(real64), intent(in)    :: array_in(:,:,:,:)
#if defined(__CUDA)
       integer(kind=cuda_Stream_Kind), intent(in) :: stream
#else
       integer, intent(in) :: stream
#endif
       integer, optional, intent(in) :: range1(2),range2(2),range3(2),range4(2)
       integer, optional, intent(in) :: lbound1,lbound2,lbound3,lbound4
#if defined(__CUDA)
       attributes(device) :: array_out
#endif
       !
    end subroutine dp_memcpy_h2d_async_c4d
    !
    subroutine i4_memcpy_h2d_async_i1d(array_out, array_in, stream, &
                                             range1, lbound1  )
#if defined(__CUDA)
       use cudafor
#endif 
       use iso_fortran_env
       implicit none
       !
       integer(int32), intent(inout) :: array_out(:)
       integer(int32), intent(in)    :: array_in(:)
#if defined(__CUDA)
       integer(kind=cuda_Stream_Kind), intent(in) :: stream
#else
       integer, intent(in) :: stream
#endif
       integer, optional, intent(in) :: range1(2)
       integer, optional, intent(in) :: lbound1
#if defined(__CUDA)
       attributes(device) :: array_out
#endif
       !
    end subroutine i4_memcpy_h2d_async_i1d
    !
    subroutine i4_memcpy_h2d_async_i2d(array_out, array_in, stream, &
                                             range1, lbound1 , &
                                             range2, lbound2  )
#if defined(__CUDA)
       use cudafor
#endif 
       use iso_fortran_env
       implicit none
       !
       integer(int32), intent(inout) :: array_out(:,:)
       integer(int32), intent(in)    :: array_in(:,:)
#if defined(__CUDA)
       integer(kind=cuda_Stream_Kind), intent(in) :: stream
#else
       integer, intent(in) :: stream
#endif
       integer, optional, intent(in) :: range1(2),range2(2)
       integer, optional, intent(in) :: lbound1,lbound2
#if defined(__CUDA)
       attributes(device) :: array_out
#endif
       !
    end subroutine i4_memcpy_h2d_async_i2d
    !
    subroutine i4_memcpy_h2d_async_i3d(array_out, array_in, stream, &
                                             range1, lbound1 , &
                                             range2, lbound2 , &
                                             range3, lbound3  )
#if defined(__CUDA)
       use cudafor
#endif 
       use iso_fortran_env
       implicit none
       !
       integer(int32), intent(inout) :: array_out(:,:,:)
       integer(int32), intent(in)    :: array_in(:,:,:)
#if defined(__CUDA)
       integer(kind=cuda_Stream_Kind), intent(in) :: stream
#else
       integer, intent(in) :: stream
#endif
       integer, optional, intent(in) :: range1(2),range2(2),range3(2)
       integer, optional, intent(in) :: lbound1,lbound2,lbound3
#if defined(__CUDA)
       attributes(device) :: array_out
#endif
       !
    end subroutine i4_memcpy_h2d_async_i3d
    !
    subroutine i4_memcpy_h2d_async_i4d(array_out, array_in, stream, &
                                             range1, lbound1 , &
                                             range2, lbound2 , &
                                             range3, lbound3 , &
                                             range4, lbound4  )
#if defined(__CUDA)
       use cudafor
#endif 
       use iso_fortran_env
       implicit none
       !
       integer(int32), intent(inout) :: array_out(:,:,:,:)
       integer(int32), intent(in)    :: array_in(:,:,:,:)
#if defined(__CUDA)
       integer(kind=cuda_Stream_Kind), intent(in) :: stream
#else
       integer, intent(in) :: stream
#endif
       integer, optional, intent(in) :: range1(2),range2(2),range3(2),range4(2)
       integer, optional, intent(in) :: lbound1,lbound2,lbound3,lbound4
#if defined(__CUDA)
       attributes(device) :: array_out
#endif
       !
    end subroutine i4_memcpy_h2d_async_i4d
    !
    !
#endif
    !
end interface dev_memcpy_async
!
interface 
    !
    subroutine dev_stream_sync(stream)
#if defined(__CUDA)
       use cudafor
#endif
       implicit none
#if defined(__CUDA)
       integer(kind=cuda_Stream_Kind), intent(in) :: stream
#else
       integer, intent(in) :: stream
#endif
    !
    end subroutine dev_stream_sync
    !
end interface 
!
interface dev_memset
    !
    subroutine sp_dev_memset_r1d(array_out, val, &
                                            
                                            range1, lbound1 )
       use iso_fortran_env
       implicit none
       !
       real(real32), intent(inout) :: array_out(:)
       real(real32), intent(in)    :: val
       integer, optional, intent(in) ::  range1(2)
       integer, optional, intent(in) ::  lbound1
#if defined(__CUDA)
       attributes(device) :: array_out
#endif
       !
    end subroutine sp_dev_memset_r1d
    !
    subroutine sp_dev_memset_r2d(array_out, val, &
                                            
                                            range1, lbound1, &
                                            range2, lbound2 )
       use iso_fortran_env
       implicit none
       !
       real(real32), intent(inout) :: array_out(:,:)
       real(real32), intent(in)    :: val
       integer, optional, intent(in) ::  range1(2), range2(2)
       integer, optional, intent(in) ::  lbound1, lbound2
#if defined(__CUDA)
       attributes(device) :: array_out
#endif
       !
    end subroutine sp_dev_memset_r2d
    !
    subroutine sp_dev_memset_r3d(array_out, val, &
                                            
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3 )
       use iso_fortran_env
       implicit none
       !
       real(real32), intent(inout) :: array_out(:,:,:)
       real(real32), intent(in)    :: val
       integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
       integer, optional, intent(in) ::  lbound1, lbound2, lbound3
#if defined(__CUDA)
       attributes(device) :: array_out
#endif
       !
    end subroutine sp_dev_memset_r3d
    !
    subroutine sp_dev_memset_r4d(array_out, val, &
                                            
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3, &
                                            range4, lbound4 )
       use iso_fortran_env
       implicit none
       !
       real(real32), intent(inout) :: array_out(:,:,:,:)
       real(real32), intent(in)    :: val
       integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
       integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
#if defined(__CUDA)
       attributes(device) :: array_out
#endif
       !
    end subroutine sp_dev_memset_r4d
    !
    subroutine dp_dev_memset_r1d(array_out, val, &
                                            
                                            range1, lbound1 )
       use iso_fortran_env
       implicit none
       !
       real(real64), intent(inout) :: array_out(:)
       real(real64), intent(in)    :: val
       integer, optional, intent(in) ::  range1(2)
       integer, optional, intent(in) ::  lbound1
#if defined(__CUDA)
       attributes(device) :: array_out
#endif
       !
    end subroutine dp_dev_memset_r1d
    !
    subroutine dp_dev_memset_r2d(array_out, val, &
                                            
                                            range1, lbound1, &
                                            range2, lbound2 )
       use iso_fortran_env
       implicit none
       !
       real(real64), intent(inout) :: array_out(:,:)
       real(real64), intent(in)    :: val
       integer, optional, intent(in) ::  range1(2), range2(2)
       integer, optional, intent(in) ::  lbound1, lbound2
#if defined(__CUDA)
       attributes(device) :: array_out
#endif
       !
    end subroutine dp_dev_memset_r2d
    !
    subroutine dp_dev_memset_r3d(array_out, val, &
                                            
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3 )
       use iso_fortran_env
       implicit none
       !
       real(real64), intent(inout) :: array_out(:,:,:)
       real(real64), intent(in)    :: val
       integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
       integer, optional, intent(in) ::  lbound1, lbound2, lbound3
#if defined(__CUDA)
       attributes(device) :: array_out
#endif
       !
    end subroutine dp_dev_memset_r3d
    !
    subroutine dp_dev_memset_r4d(array_out, val, &
                                            
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3, &
                                            range4, lbound4 )
       use iso_fortran_env
       implicit none
       !
       real(real64), intent(inout) :: array_out(:,:,:,:)
       real(real64), intent(in)    :: val
       integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
       integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
#if defined(__CUDA)
       attributes(device) :: array_out
#endif
       !
    end subroutine dp_dev_memset_r4d
    !
    subroutine sp_dev_memset_c1d(array_out, val, &
                                            
                                            range1, lbound1 )
       use iso_fortran_env
       implicit none
       !
       complex(real32), intent(inout) :: array_out(:)
       complex(real32), intent(in)    :: val
       integer, optional, intent(in) ::  range1(2)
       integer, optional, intent(in) ::  lbound1
#if defined(__CUDA)
       attributes(device) :: array_out
#endif
       !
    end subroutine sp_dev_memset_c1d
    !
    subroutine sp_dev_memset_c2d(array_out, val, &
                                            
                                            range1, lbound1, &
                                            range2, lbound2 )
       use iso_fortran_env
       implicit none
       !
       complex(real32), intent(inout) :: array_out(:,:)
       complex(real32), intent(in)    :: val
       integer, optional, intent(in) ::  range1(2), range2(2)
       integer, optional, intent(in) ::  lbound1, lbound2
#if defined(__CUDA)
       attributes(device) :: array_out
#endif
       !
    end subroutine sp_dev_memset_c2d
    !
    subroutine sp_dev_memset_c3d(array_out, val, &
                                            
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3 )
       use iso_fortran_env
       implicit none
       !
       complex(real32), intent(inout) :: array_out(:,:,:)
       complex(real32), intent(in)    :: val
       integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
       integer, optional, intent(in) ::  lbound1, lbound2, lbound3
#if defined(__CUDA)
       attributes(device) :: array_out
#endif
       !
    end subroutine sp_dev_memset_c3d
    !
    subroutine sp_dev_memset_c4d(array_out, val, &
                                            
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3, &
                                            range4, lbound4 )
       use iso_fortran_env
       implicit none
       !
       complex(real32), intent(inout) :: array_out(:,:,:,:)
       complex(real32), intent(in)    :: val
       integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
       integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
#if defined(__CUDA)
       attributes(device) :: array_out
#endif
       !
    end subroutine sp_dev_memset_c4d
    !
    subroutine dp_dev_memset_c1d(array_out, val, &
                                            
                                            range1, lbound1 )
       use iso_fortran_env
       implicit none
       !
       complex(real64), intent(inout) :: array_out(:)
       complex(real64), intent(in)    :: val
       integer, optional, intent(in) ::  range1(2)
       integer, optional, intent(in) ::  lbound1
#if defined(__CUDA)
       attributes(device) :: array_out
#endif
       !
    end subroutine dp_dev_memset_c1d
    !
    subroutine dp_dev_memset_c2d(array_out, val, &
                                            
                                            range1, lbound1, &
                                            range2, lbound2 )
       use iso_fortran_env
       implicit none
       !
       complex(real64), intent(inout) :: array_out(:,:)
       complex(real64), intent(in)    :: val
       integer, optional, intent(in) ::  range1(2), range2(2)
       integer, optional, intent(in) ::  lbound1, lbound2
#if defined(__CUDA)
       attributes(device) :: array_out
#endif
       !
    end subroutine dp_dev_memset_c2d
    !
    subroutine dp_dev_memset_c3d(array_out, val, &
                                            
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3 )
       use iso_fortran_env
       implicit none
       !
       complex(real64), intent(inout) :: array_out(:,:,:)
       complex(real64), intent(in)    :: val
       integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
       integer, optional, intent(in) ::  lbound1, lbound2, lbound3
#if defined(__CUDA)
       attributes(device) :: array_out
#endif
       !
    end subroutine dp_dev_memset_c3d
    !
    subroutine dp_dev_memset_c4d(array_out, val, &
                                            
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3, &
                                            range4, lbound4 )
       use iso_fortran_env
       implicit none
       !
       complex(real64), intent(inout) :: array_out(:,:,:,:)
       complex(real64), intent(in)    :: val
       integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
       integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
#if defined(__CUDA)
       attributes(device) :: array_out
#endif
       !
    end subroutine dp_dev_memset_c4d
    !
    subroutine i4_dev_memset_i1d(array_out, val, &
                                            
                                            range1, lbound1 )
       use iso_fortran_env
       implicit none
       !
       integer(int32), intent(inout) :: array_out(:)
       integer(int32), intent(in)    :: val
       integer, optional, intent(in) ::  range1(2)
       integer, optional, intent(in) ::  lbound1
#if defined(__CUDA)
       attributes(device) :: array_out
#endif
       !
    end subroutine i4_dev_memset_i1d
    !
    subroutine i4_dev_memset_i2d(array_out, val, &
                                            
                                            range1, lbound1, &
                                            range2, lbound2 )
       use iso_fortran_env
       implicit none
       !
       integer(int32), intent(inout) :: array_out(:,:)
       integer(int32), intent(in)    :: val
       integer, optional, intent(in) ::  range1(2), range2(2)
       integer, optional, intent(in) ::  lbound1, lbound2
#if defined(__CUDA)
       attributes(device) :: array_out
#endif
       !
    end subroutine i4_dev_memset_i2d
    !
    subroutine i4_dev_memset_i3d(array_out, val, &
                                            
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3 )
       use iso_fortran_env
       implicit none
       !
       integer(int32), intent(inout) :: array_out(:,:,:)
       integer(int32), intent(in)    :: val
       integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
       integer, optional, intent(in) ::  lbound1, lbound2, lbound3
#if defined(__CUDA)
       attributes(device) :: array_out
#endif
       !
    end subroutine i4_dev_memset_i3d
    !
    subroutine i4_dev_memset_i4d(array_out, val, &
                                            
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3, &
                                            range4, lbound4 )
       use iso_fortran_env
       implicit none
       !
       integer(int32), intent(inout) :: array_out(:,:,:,:)
       integer(int32), intent(in)    :: val
       integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
       integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
#if defined(__CUDA)
       attributes(device) :: array_out
#endif
       !
    end subroutine i4_dev_memset_i4d
    !
    !
#if defined(__HAVE_DEVICE)
    !
    subroutine sp_dev_memset_h_r1d(array_out, val, &
                                            
                                            range1, lbound1 )
       use iso_fortran_env
       implicit none
       !
       real(real32), intent(inout) :: array_out(:)
       real(real32), intent(in)    :: val
       integer, optional, intent(in) ::  range1(2)
       integer, optional, intent(in) ::  lbound1
       !
    end subroutine sp_dev_memset_h_r1d
    !
    subroutine sp_dev_memset_h_r2d(array_out, val, &
                                            
                                            range1, lbound1, &
                                            range2, lbound2 )
       use iso_fortran_env
       implicit none
       !
       real(real32), intent(inout) :: array_out(:,:)
       real(real32), intent(in)    :: val
       integer, optional, intent(in) ::  range1(2), range2(2)
       integer, optional, intent(in) ::  lbound1, lbound2
       !
    end subroutine sp_dev_memset_h_r2d
    !
    subroutine sp_dev_memset_h_r3d(array_out, val, &
                                            
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3 )
       use iso_fortran_env
       implicit none
       !
       real(real32), intent(inout) :: array_out(:,:,:)
       real(real32), intent(in)    :: val
       integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
       integer, optional, intent(in) ::  lbound1, lbound2, lbound3
       !
    end subroutine sp_dev_memset_h_r3d
    !
    subroutine sp_dev_memset_h_r4d(array_out, val, &
                                            
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3, &
                                            range4, lbound4 )
       use iso_fortran_env
       implicit none
       !
       real(real32), intent(inout) :: array_out(:,:,:,:)
       real(real32), intent(in)    :: val
       integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
       integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
       !
    end subroutine sp_dev_memset_h_r4d
    !
    subroutine dp_dev_memset_h_r1d(array_out, val, &
                                            
                                            range1, lbound1 )
       use iso_fortran_env
       implicit none
       !
       real(real64), intent(inout) :: array_out(:)
       real(real64), intent(in)    :: val
       integer, optional, intent(in) ::  range1(2)
       integer, optional, intent(in) ::  lbound1
       !
    end subroutine dp_dev_memset_h_r1d
    !
    subroutine dp_dev_memset_h_r2d(array_out, val, &
                                            
                                            range1, lbound1, &
                                            range2, lbound2 )
       use iso_fortran_env
       implicit none
       !
       real(real64), intent(inout) :: array_out(:,:)
       real(real64), intent(in)    :: val
       integer, optional, intent(in) ::  range1(2), range2(2)
       integer, optional, intent(in) ::  lbound1, lbound2
       !
    end subroutine dp_dev_memset_h_r2d
    !
    subroutine dp_dev_memset_h_r3d(array_out, val, &
                                            
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3 )
       use iso_fortran_env
       implicit none
       !
       real(real64), intent(inout) :: array_out(:,:,:)
       real(real64), intent(in)    :: val
       integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
       integer, optional, intent(in) ::  lbound1, lbound2, lbound3
       !
    end subroutine dp_dev_memset_h_r3d
    !
    subroutine dp_dev_memset_h_r4d(array_out, val, &
                                            
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3, &
                                            range4, lbound4 )
       use iso_fortran_env
       implicit none
       !
       real(real64), intent(inout) :: array_out(:,:,:,:)
       real(real64), intent(in)    :: val
       integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
       integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
       !
    end subroutine dp_dev_memset_h_r4d
    !
    subroutine sp_dev_memset_h_c1d(array_out, val, &
                                            
                                            range1, lbound1 )
       use iso_fortran_env
       implicit none
       !
       complex(real32), intent(inout) :: array_out(:)
       complex(real32), intent(in)    :: val
       integer, optional, intent(in) ::  range1(2)
       integer, optional, intent(in) ::  lbound1
       !
    end subroutine sp_dev_memset_h_c1d
    !
    subroutine sp_dev_memset_h_c2d(array_out, val, &
                                            
                                            range1, lbound1, &
                                            range2, lbound2 )
       use iso_fortran_env
       implicit none
       !
       complex(real32), intent(inout) :: array_out(:,:)
       complex(real32), intent(in)    :: val
       integer, optional, intent(in) ::  range1(2), range2(2)
       integer, optional, intent(in) ::  lbound1, lbound2
       !
    end subroutine sp_dev_memset_h_c2d
    !
    subroutine sp_dev_memset_h_c3d(array_out, val, &
                                            
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3 )
       use iso_fortran_env
       implicit none
       !
       complex(real32), intent(inout) :: array_out(:,:,:)
       complex(real32), intent(in)    :: val
       integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
       integer, optional, intent(in) ::  lbound1, lbound2, lbound3
       !
    end subroutine sp_dev_memset_h_c3d
    !
    subroutine sp_dev_memset_h_c4d(array_out, val, &
                                            
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3, &
                                            range4, lbound4 )
       use iso_fortran_env
       implicit none
       !
       complex(real32), intent(inout) :: array_out(:,:,:,:)
       complex(real32), intent(in)    :: val
       integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
       integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
       !
    end subroutine sp_dev_memset_h_c4d
    !
    subroutine dp_dev_memset_h_c1d(array_out, val, &
                                            
                                            range1, lbound1 )
       use iso_fortran_env
       implicit none
       !
       complex(real64), intent(inout) :: array_out(:)
       complex(real64), intent(in)    :: val
       integer, optional, intent(in) ::  range1(2)
       integer, optional, intent(in) ::  lbound1
       !
    end subroutine dp_dev_memset_h_c1d
    !
    subroutine dp_dev_memset_h_c2d(array_out, val, &
                                            
                                            range1, lbound1, &
                                            range2, lbound2 )
       use iso_fortran_env
       implicit none
       !
       complex(real64), intent(inout) :: array_out(:,:)
       complex(real64), intent(in)    :: val
       integer, optional, intent(in) ::  range1(2), range2(2)
       integer, optional, intent(in) ::  lbound1, lbound2
       !
    end subroutine dp_dev_memset_h_c2d
    !
    subroutine dp_dev_memset_h_c3d(array_out, val, &
                                            
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3 )
       use iso_fortran_env
       implicit none
       !
       complex(real64), intent(inout) :: array_out(:,:,:)
       complex(real64), intent(in)    :: val
       integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
       integer, optional, intent(in) ::  lbound1, lbound2, lbound3
       !
    end subroutine dp_dev_memset_h_c3d
    !
    subroutine dp_dev_memset_h_c4d(array_out, val, &
                                            
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3, &
                                            range4, lbound4 )
       use iso_fortran_env
       implicit none
       !
       complex(real64), intent(inout) :: array_out(:,:,:,:)
       complex(real64), intent(in)    :: val
       integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
       integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
       !
    end subroutine dp_dev_memset_h_c4d
    !
    subroutine i4_dev_memset_h_i1d(array_out, val, &
                                            
                                            range1, lbound1 )
       use iso_fortran_env
       implicit none
       !
       integer(int32), intent(inout) :: array_out(:)
       integer(int32), intent(in)    :: val
       integer, optional, intent(in) ::  range1(2)
       integer, optional, intent(in) ::  lbound1
       !
    end subroutine i4_dev_memset_h_i1d
    !
    subroutine i4_dev_memset_h_i2d(array_out, val, &
                                            
                                            range1, lbound1, &
                                            range2, lbound2 )
       use iso_fortran_env
       implicit none
       !
       integer(int32), intent(inout) :: array_out(:,:)
       integer(int32), intent(in)    :: val
       integer, optional, intent(in) ::  range1(2), range2(2)
       integer, optional, intent(in) ::  lbound1, lbound2
       !
    end subroutine i4_dev_memset_h_i2d
    !
    subroutine i4_dev_memset_h_i3d(array_out, val, &
                                            
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3 )
       use iso_fortran_env
       implicit none
       !
       integer(int32), intent(inout) :: array_out(:,:,:)
       integer(int32), intent(in)    :: val
       integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
       integer, optional, intent(in) ::  lbound1, lbound2, lbound3
       !
    end subroutine i4_dev_memset_h_i3d
    !
    subroutine i4_dev_memset_h_i4d(array_out, val, &
                                            
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3, &
                                            range4, lbound4 )
       use iso_fortran_env
       implicit none
       !
       integer(int32), intent(inout) :: array_out(:,:,:,:)
       integer(int32), intent(in)    :: val
       integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
       integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
       !
    end subroutine i4_dev_memset_h_i4d
    !
    !
#endif
    !
end interface dev_memset
!

!     FORTRAN BLAS INTERFACE ..
!     COPYRIGHT 2013 HENRIK HOLST <HOLST@MATMECH.COM>
!
!     YOU ARE FREE TO USE THIS IN ANY FSF APPROVED FREE LICENCED PROJECT.
!
      MODULE BLAS95_m
      INTERFACE
      SUBROUTINE CAXPY(N,CA,CX,INCX,CY,INCY)
      IMPLICIT NONE
      INTEGER INCX,INCY,N
      COMPLEX CA,CX(*),CY(*)
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE CCOPY(N,CX,INCX,CY,INCY)
      IMPLICIT NONE
      INTEGER INCX,INCY,N
      COMPLEX CX(*),CY(*)
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      COMPLEX FUNCTION CDOTC(N,CX,INCX,CY,INCY)
      IMPLICIT NONE
      INTEGER INCX,INCY,N
      COMPLEX CX(*),CY(*)
      END FUNCTION
      END INTERFACE
      INTERFACE
      COMPLEX FUNCTION CDOTU(N,CX,INCX,CY,INCY)
      IMPLICIT NONE
      INTEGER INCX,INCY,N
      COMPLEX CX(*),CY(*)
      END FUNCTION
      END INTERFACE
      INTERFACE
      SUBROUTINE CGBMV(TRANS,M,N,KL,KU,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
      IMPLICIT NONE
      INTEGER INCX,INCY,KL,KU,LDA,M,N
      COMPLEX ALPHA,BETA,A(LDA,*),X(*),Y(*)
      CHARACTER TRANS
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE CGEMM(TRANSA,TRANSB,M,N,K,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
      IMPLICIT NONE
      INTEGER K,LDA,LDB,LDC,M,N
      COMPLEX ALPHA,BETA,A(LDA,*),B(LDB,*),C(LDC,*)
      CHARACTER TRANSA,TRANSB
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE CGEMV(TRANS,M,N,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
      IMPLICIT NONE
      INTEGER INCX,INCY,LDA,M,N
      COMPLEX ALPHA,BETA,A(LDA,*),X(*),Y(*)
      CHARACTER TRANS
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE CGERC(M,N,ALPHA,X,INCX,Y,INCY,A,LDA)
      IMPLICIT NONE
      INTEGER INCX,INCY,LDA,M,N
      COMPLEX ALPHA,A(LDA,*),X(*),Y(*)
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE CGERU(M,N,ALPHA,X,INCX,Y,INCY,A,LDA)
      IMPLICIT NONE
      INTEGER INCX,INCY,LDA,M,N
      COMPLEX ALPHA,A(LDA,*),X(*),Y(*)
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE CHBMV(UPLO,N,K,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
      IMPLICIT NONE
      INTEGER INCX,INCY,K,LDA,N
      COMPLEX ALPHA,BETA,A(LDA,*),X(*),Y(*)
      CHARACTER UPLO
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE CHEMM(SIDE,UPLO,M,N,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
      IMPLICIT NONE
      INTEGER LDA,LDB,LDC,M,N
      COMPLEX ALPHA,BETA,A(LDA,*),B(LDB,*),C(LDC,*)
      CHARACTER SIDE,UPLO
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE CHEMV(UPLO,N,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
      IMPLICIT NONE
      INTEGER INCX,INCY,LDA,N
      COMPLEX ALPHA,BETA,A(LDA,*),X(*),Y(*)
      CHARACTER UPLO
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE CHER(UPLO,N,ALPHA,X,INCX,A,LDA)
      IMPLICIT NONE
      REAL ALPHA
      INTEGER INCX,LDA,N
      COMPLEX A(LDA,*),X(*)
      CHARACTER UPLO
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE CHER2(UPLO,N,ALPHA,X,INCX,Y,INCY,A,LDA)
      IMPLICIT NONE
      INTEGER INCX,INCY,LDA,N
      COMPLEX ALPHA,A(LDA,*),X(*),Y(*)
      CHARACTER UPLO
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE CHER2K(UPLO,TRANS,N,K,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
      IMPLICIT NONE
      REAL BETA
      INTEGER K,LDA,LDB,LDC,N
      COMPLEX ALPHA,A(LDA,*),B(LDB,*),C(LDC,*)
      CHARACTER TRANS,UPLO
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE CHERK(UPLO,TRANS,N,K,ALPHA,A,LDA,BETA,C,LDC)
      IMPLICIT NONE
      REAL ALPHA,BETA
      INTEGER K,LDA,LDC,N
      COMPLEX A(LDA,*),C(LDC,*)
      CHARACTER TRANS,UPLO
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE CHPMV(UPLO,N,ALPHA,AP,X,INCX,BETA,Y,INCY)
      IMPLICIT NONE
      INTEGER INCX,INCY,N
      COMPLEX ALPHA,BETA,AP(*),X(*),Y(*)
      CHARACTER UPLO
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE CHPR(UPLO,N,ALPHA,X,INCX,AP)
      IMPLICIT NONE
      REAL ALPHA
      INTEGER INCX,N
      COMPLEX AP(*),X(*)
      CHARACTER UPLO
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE CHPR2(UPLO,N,ALPHA,X,INCX,Y,INCY,AP)
      IMPLICIT NONE
      INTEGER INCX,INCY,N
      COMPLEX ALPHA,AP(*),X(*),Y(*)
      CHARACTER UPLO
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE CROTG(CA,CB,C,S)
      IMPLICIT NONE
      REAL C
      COMPLEX CA,CB,S
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE CSCAL(N,CA,CX,INCX)
      IMPLICIT NONE
      INTEGER INCX,N
      COMPLEX CA,CX(*)
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE CSROT(N,CX,INCX,CY,INCY,C,S)
      IMPLICIT NONE
      REAL C,S
      INTEGER INCX,INCY,N
      COMPLEX CX(*),CY(*)
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE CSSCAL(N,SA,CX,INCX)
      IMPLICIT NONE
      REAL SA
      INTEGER INCX,N
      COMPLEX CX(*)
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE CSWAP(N,CX,INCX,CY,INCY)
      IMPLICIT NONE
      INTEGER INCX,INCY,N
      COMPLEX CX(*),CY(*)
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE CSYMM(SIDE,UPLO,M,N,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
      IMPLICIT NONE
      INTEGER LDA,LDB,LDC,M,N
      COMPLEX ALPHA,BETA,A(LDA,*),B(LDB,*),C(LDC,*)
      CHARACTER SIDE,UPLO
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE CSYR2K(UPLO,TRANS,N,K,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
      IMPLICIT NONE
      INTEGER K,LDA,LDB,LDC,N
      COMPLEX ALPHA,BETA,A(LDA,*),B(LDB,*),C(LDC,*)
      CHARACTER TRANS,UPLO
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE CSYRK(UPLO,TRANS,N,K,ALPHA,A,LDA,BETA,C,LDC)
      IMPLICIT NONE
      INTEGER K,LDA,LDC,N
      COMPLEX ALPHA,BETA,A(LDA,*),C(LDC,*)
      CHARACTER TRANS,UPLO
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE CTBMV(UPLO,TRANS,DIAG,N,K,A,LDA,X,INCX)
      IMPLICIT NONE
      INTEGER INCX,K,LDA,N
      COMPLEX A(LDA,*),X(*)
      CHARACTER DIAG,TRANS,UPLO
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE CTBSV(UPLO,TRANS,DIAG,N,K,A,LDA,X,INCX)
      IMPLICIT NONE
      INTEGER INCX,K,LDA,N
      COMPLEX A(LDA,*),X(*)
      CHARACTER DIAG,TRANS,UPLO
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE CTPMV(UPLO,TRANS,DIAG,N,AP,X,INCX)
      IMPLICIT NONE
      INTEGER INCX,N
      COMPLEX AP(*),X(*)
      CHARACTER DIAG,TRANS,UPLO
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE CTPSV(UPLO,TRANS,DIAG,N,AP,X,INCX)
      IMPLICIT NONE
      INTEGER INCX,N
      COMPLEX AP(*),X(*)
      CHARACTER DIAG,TRANS,UPLO
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE CTRMM(SIDE,UPLO,TRANSA,DIAG,M,N,ALPHA,A,LDA,B,LDB)
      IMPLICIT NONE
      INTEGER LDA,LDB,M,N
      COMPLEX ALPHA,A(LDA,*),B(LDB,*)
      CHARACTER DIAG,SIDE,TRANSA,UPLO
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE CTRMV(UPLO,TRANS,DIAG,N,A,LDA,X,INCX)
      IMPLICIT NONE
      INTEGER INCX,LDA,N
      COMPLEX A(LDA,*),X(*)
      CHARACTER DIAG,TRANS,UPLO
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE CTRSM(SIDE,UPLO,TRANSA,DIAG,M,N,ALPHA,A,LDA,B,LDB)
      IMPLICIT NONE
      INTEGER LDA,LDB,M,N
      COMPLEX ALPHA,A(LDA,*),B(LDB,*)
      CHARACTER DIAG,SIDE,TRANSA,UPLO
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE CTRSV(UPLO,TRANS,DIAG,N,A,LDA,X,INCX)
      IMPLICIT NONE
      INTEGER INCX,LDA,N
      COMPLEX A(LDA,*),X(*)
      CHARACTER DIAG,TRANS,UPLO
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      DOUBLE PRECISION FUNCTION DASUM(N,DX,INCX)
      IMPLICIT NONE
      INTEGER INCX,N
      DOUBLE PRECISION DX(*)
      END FUNCTION
      END INTERFACE
      INTERFACE
      SUBROUTINE DAXPY(N,DA,DX,INCX,DY,INCY)
      IMPLICIT NONE
      INTEGER INCX,INCY,N
      DOUBLE PRECISION DA,DX(*),DY(*)
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      DOUBLE PRECISION FUNCTION DCABS1(Z)
      IMPLICIT NONE
      DOUBLE COMPLEX Z
      END FUNCTION
      END INTERFACE
      INTERFACE
      SUBROUTINE DCOPY(N,DX,INCX,DY,INCY)
      IMPLICIT NONE
      INTEGER INCX,INCY,N
      DOUBLE PRECISION DX(*),DY(*)
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      DOUBLE PRECISION FUNCTION DDOT(N,DX,INCX,DY,INCY)
      IMPLICIT NONE
      INTEGER INCX,INCY,N
      DOUBLE PRECISION DX(*),DY(*)
      END FUNCTION
      END INTERFACE
      INTERFACE
      SUBROUTINE DGBMV(TRANS,M,N,KL,KU,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
      IMPLICIT NONE
      INTEGER INCX,INCY,KL,KU,LDA,M,N
      DOUBLE PRECISION ALPHA,BETA,A(LDA,*),X(*),Y(*)
      CHARACTER TRANS
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE DGEMM(TRANSA,TRANSB,M,N,K,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
      IMPLICIT NONE
      INTEGER K,LDA,LDB,LDC,M,N
      DOUBLE PRECISION ALPHA,BETA,A(LDA,*),B(LDB,*),C(LDC,*)
      CHARACTER TRANSA,TRANSB
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE DGEMV(TRANS,M,N,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
      IMPLICIT NONE
      INTEGER INCX,INCY,LDA,M,N
      DOUBLE PRECISION ALPHA,BETA,A(LDA,*),X(*),Y(*)
      CHARACTER TRANS
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE DGER(M,N,ALPHA,X,INCX,Y,INCY,A,LDA)
      IMPLICIT NONE
      INTEGER INCX,INCY,LDA,M,N
      DOUBLE PRECISION ALPHA,A(LDA,*),X(*),Y(*)
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      DOUBLE PRECISION FUNCTION DNRM2(N,X,INCX)
      IMPLICIT NONE
      INTEGER INCX,N
      DOUBLE PRECISION X(*)
      END FUNCTION
      END INTERFACE
      INTERFACE
      SUBROUTINE DROT(N,DX,INCX,DY,INCY,C,S)
      IMPLICIT NONE
      INTEGER INCX,INCY,N
      DOUBLE PRECISION C,S,DX(*),DY(*)
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE DROTG(DA,DB,C,S)
      IMPLICIT NONE
      DOUBLE PRECISION C,DA,DB,S
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE DROTM(N,DX,INCX,DY,INCY,DPARAM)
      IMPLICIT NONE
      INTEGER INCX,INCY,N
      DOUBLE PRECISION DPARAM(5),DX(*),DY(*)
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE DROTMG(DD1,DD2,DX1,DY1,DPARAM)
      IMPLICIT NONE
      DOUBLE PRECISION DD1,DD2,DX1,DY1,DPARAM(5)
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE DSBMV(UPLO,N,K,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
      IMPLICIT NONE
      INTEGER INCX,INCY,K,LDA,N
      DOUBLE PRECISION ALPHA,BETA,A(LDA,*),X(*),Y(*)
      CHARACTER UPLO
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE DSCAL(N,DA,DX,INCX)
      IMPLICIT NONE
      INTEGER INCX,N
      DOUBLE PRECISION DA,DX(*)
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      DOUBLE PRECISION FUNCTION DSDOT(N,SX,INCX,SY,INCY)
      IMPLICIT NONE
      REAL SX(*),SY(*)
      INTEGER INCX,INCY,N
      END FUNCTION
      END INTERFACE
      INTERFACE
      SUBROUTINE DSPMV(UPLO,N,ALPHA,AP,X,INCX,BETA,Y,INCY)
      IMPLICIT NONE
      INTEGER INCX,INCY,N
      DOUBLE PRECISION ALPHA,BETA,AP(*),X(*),Y(*)
      CHARACTER UPLO
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE DSPR(UPLO,N,ALPHA,X,INCX,AP)
      IMPLICIT NONE
      INTEGER INCX,N
      DOUBLE PRECISION ALPHA,AP(*),X(*)
      CHARACTER UPLO
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE DSPR2(UPLO,N,ALPHA,X,INCX,Y,INCY,AP)
      IMPLICIT NONE
      INTEGER INCX,INCY,N
      DOUBLE PRECISION ALPHA,AP(*),X(*),Y(*)
      CHARACTER UPLO
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE DSWAP(N,DX,INCX,DY,INCY)
      IMPLICIT NONE
      INTEGER INCX,INCY,N
      DOUBLE PRECISION DX(*),DY(*)
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE DSYMM(SIDE,UPLO,M,N,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
      IMPLICIT NONE
      INTEGER LDA,LDB,LDC,M,N
      DOUBLE PRECISION ALPHA,BETA,A(LDA,*),B(LDB,*),C(LDC,*)
      CHARACTER SIDE,UPLO
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE DSYMV(UPLO,N,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
      IMPLICIT NONE
      INTEGER INCX,INCY,LDA,N
      DOUBLE PRECISION ALPHA,BETA,A(LDA,*),X(*),Y(*)
      CHARACTER UPLO
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE DSYR(UPLO,N,ALPHA,X,INCX,A,LDA)
      IMPLICIT NONE
      INTEGER INCX,LDA,N
      DOUBLE PRECISION ALPHA,A(LDA,*),X(*)
      CHARACTER UPLO
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE DSYR2(UPLO,N,ALPHA,X,INCX,Y,INCY,A,LDA)
      IMPLICIT NONE
      INTEGER INCX,INCY,LDA,N
      DOUBLE PRECISION ALPHA,A(LDA,*),X(*),Y(*)
      CHARACTER UPLO
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE DSYR2K(UPLO,TRANS,N,K,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
      IMPLICIT NONE
      INTEGER K,LDA,LDB,LDC,N
      DOUBLE PRECISION ALPHA,BETA,A(LDA,*),B(LDB,*),C(LDC,*)
      CHARACTER TRANS,UPLO
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE DSYRK(UPLO,TRANS,N,K,ALPHA,A,LDA,BETA,C,LDC)
      IMPLICIT NONE
      INTEGER K,LDA,LDC,N
      DOUBLE PRECISION ALPHA,BETA,A(LDA,*),C(LDC,*)
      CHARACTER TRANS,UPLO
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE DTBMV(UPLO,TRANS,DIAG,N,K,A,LDA,X,INCX)
      IMPLICIT NONE
      INTEGER INCX,K,LDA,N
      DOUBLE PRECISION A(LDA,*),X(*)
      CHARACTER DIAG,TRANS,UPLO
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE DTBSV(UPLO,TRANS,DIAG,N,K,A,LDA,X,INCX)
      IMPLICIT NONE
      INTEGER INCX,K,LDA,N
      DOUBLE PRECISION A(LDA,*),X(*)
      CHARACTER DIAG,TRANS,UPLO
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE DTPMV(UPLO,TRANS,DIAG,N,AP,X,INCX)
      IMPLICIT NONE
      INTEGER INCX,N
      DOUBLE PRECISION AP(*),X(*)
      CHARACTER DIAG,TRANS,UPLO
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE DTPSV(UPLO,TRANS,DIAG,N,AP,X,INCX)
      IMPLICIT NONE
      INTEGER INCX,N
      DOUBLE PRECISION AP(*),X(*)
      CHARACTER DIAG,TRANS,UPLO
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE DTRMM(SIDE,UPLO,TRANSA,DIAG,M,N,ALPHA,A,LDA,B,LDB)
      IMPLICIT NONE
      INTEGER LDA,LDB,M,N
      DOUBLE PRECISION ALPHA,A(LDA,*),B(LDB,*)
      CHARACTER DIAG,SIDE,TRANSA,UPLO
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE DTRMV(UPLO,TRANS,DIAG,N,A,LDA,X,INCX)
      IMPLICIT NONE
      INTEGER INCX,LDA,N
      DOUBLE PRECISION A(LDA,*),X(*)
      CHARACTER DIAG,TRANS,UPLO
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE DTRSM(SIDE,UPLO,TRANSA,DIAG,M,N,ALPHA,A,LDA,B,LDB)
      IMPLICIT NONE
      INTEGER LDA,LDB,M,N
      DOUBLE PRECISION ALPHA,A(LDA,*),B(LDB,*)
      CHARACTER DIAG,SIDE,TRANSA,UPLO
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE DTRSV(UPLO,TRANS,DIAG,N,A,LDA,X,INCX)
      IMPLICIT NONE
      INTEGER INCX,LDA,N
      DOUBLE PRECISION A(LDA,*),X(*)
      CHARACTER DIAG,TRANS,UPLO
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      DOUBLE PRECISION FUNCTION DZASUM(N,ZX,INCX)
      IMPLICIT NONE
      INTEGER INCX,N
      DOUBLE COMPLEX ZX(*)
      END FUNCTION
      END INTERFACE
      INTERFACE
      DOUBLE PRECISION FUNCTION DZNRM2(N,X,INCX)
      IMPLICIT NONE
      INTEGER INCX,N
      DOUBLE COMPLEX X(*)
      END FUNCTION
      END INTERFACE
      INTERFACE
      INTEGER FUNCTION ICAMAX(N,CX,INCX)
      IMPLICIT NONE
      INTEGER INCX,N
      COMPLEX CX(*)
      END FUNCTION
      END INTERFACE
      INTERFACE
      INTEGER FUNCTION IDAMAX(N,DX,INCX)
      IMPLICIT NONE
      INTEGER INCX,N
      DOUBLE PRECISION DX(*)
      END FUNCTION
      END INTERFACE
      INTERFACE
      INTEGER FUNCTION ISAMAX(N,SX,INCX)
      IMPLICIT NONE
      REAL SX(*)
      INTEGER INCX,N
      END FUNCTION
      END INTERFACE
      INTERFACE
      INTEGER FUNCTION IZAMAX(N,ZX,INCX)
      IMPLICIT NONE
      INTEGER INCX,N
      DOUBLE COMPLEX ZX(*)
      END FUNCTION
      END INTERFACE
      INTERFACE
      LOGICAL FUNCTION LSAME(CA,CB)
      IMPLICIT NONE
      CHARACTER CA,CB
      END FUNCTION
      END INTERFACE
      INTERFACE
      REAL FUNCTION SASUM(N,SX,INCX)
      IMPLICIT NONE
      REAL SX(*)
      INTEGER INCX,N
      END FUNCTION
      END INTERFACE
      INTERFACE
      SUBROUTINE SAXPY(N,SA,SX,INCX,SY,INCY)
      IMPLICIT NONE
      REAL SA,SX(*),SY(*)
      INTEGER INCX,INCY,N
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      REAL FUNCTION SCABS1(Z)
      IMPLICIT NONE
      COMPLEX Z
      END FUNCTION
      END INTERFACE
      INTERFACE
      REAL FUNCTION SCASUM(N,CX,INCX)
      IMPLICIT NONE
      INTEGER INCX,N
      COMPLEX CX(*)
      END FUNCTION
      END INTERFACE
      INTERFACE
      REAL FUNCTION SCNRM2(N,X,INCX)
      IMPLICIT NONE
      INTEGER INCX,N
      COMPLEX X(*)
      END FUNCTION
      END INTERFACE
      INTERFACE
      SUBROUTINE SCOPY(N,SX,INCX,SY,INCY)
      IMPLICIT NONE
      REAL SX(*),SY(*)
      INTEGER INCX,INCY,N
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      REAL FUNCTION SDOT(N,SX,INCX,SY,INCY)
      IMPLICIT NONE
      REAL SX(*),SY(*)
      INTEGER INCX,INCY,N
      END FUNCTION
      END INTERFACE
      INTERFACE
      REAL FUNCTION SDSDOT(N,SB,SX,INCX,SY,INCY)
      IMPLICIT NONE
      REAL SB,SX(*),SY(*)
      INTEGER INCX,INCY,N
      END FUNCTION
      END INTERFACE
      INTERFACE
      SUBROUTINE SGBMV(TRANS,M,N,KL,KU,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
      IMPLICIT NONE
      REAL ALPHA,BETA,A(LDA,*),X(*),Y(*)
      INTEGER INCX,INCY,KL,KU,LDA,M,N
      CHARACTER TRANS
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE SGEMM(TRANSA,TRANSB,M,N,K,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
      IMPLICIT NONE
      REAL ALPHA,BETA,A(LDA,*),B(LDB,*),C(LDC,*)
      INTEGER K,LDA,LDB,LDC,M,N
      CHARACTER TRANSA,TRANSB
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE SGEMV(TRANS,M,N,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
      IMPLICIT NONE
      REAL ALPHA,BETA,A(LDA,*),X(*),Y(*)
      INTEGER INCX,INCY,LDA,M,N
      CHARACTER TRANS
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE SGER(M,N,ALPHA,X,INCX,Y,INCY,A,LDA)
      IMPLICIT NONE
      REAL ALPHA,A(LDA,*),X(*),Y(*)
      INTEGER INCX,INCY,LDA,M,N
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      REAL FUNCTION SNRM2(N,X,INCX)
      IMPLICIT NONE
      REAL X(*)
      INTEGER INCX,N
      END FUNCTION
      END INTERFACE
      INTERFACE
      SUBROUTINE SROT(N,SX,INCX,SY,INCY,C,S)
      IMPLICIT NONE
      REAL C,S,SX(*),SY(*)
      INTEGER INCX,INCY,N
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE SROTG(SA,SB,C,S)
      IMPLICIT NONE
      REAL C,S,SA,SB
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE SROTM(N,SX,INCX,SY,INCY,SPARAM)
      IMPLICIT NONE
      REAL SPARAM(5),SX(*),SY(*)
      INTEGER INCX,INCY,N
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE SROTMG(SD1,SD2,SX1,SY1,SPARAM)
      IMPLICIT NONE
      REAL SD1,SD2,SX1,SY1,SPARAM(5)
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE SSBMV(UPLO,N,K,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
      IMPLICIT NONE
      REAL ALPHA,BETA,A(LDA,*),X(*),Y(*)
      INTEGER INCX,INCY,K,LDA,N
      CHARACTER UPLO
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE SSCAL(N,SA,SX,INCX)
      IMPLICIT NONE
      REAL SA,SX(*)
      INTEGER INCX,N
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE SSPMV(UPLO,N,ALPHA,AP,X,INCX,BETA,Y,INCY)
      IMPLICIT NONE
      REAL ALPHA,BETA,AP(*),X(*),Y(*)
      INTEGER INCX,INCY,N
      CHARACTER UPLO
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE SSPR(UPLO,N,ALPHA,X,INCX,AP)
      IMPLICIT NONE
      REAL ALPHA,AP(*),X(*)
      INTEGER INCX,N
      CHARACTER UPLO
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE SSPR2(UPLO,N,ALPHA,X,INCX,Y,INCY,AP)
      IMPLICIT NONE
      REAL ALPHA,AP(*),X(*),Y(*)
      INTEGER INCX,INCY,N
      CHARACTER UPLO
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE SSWAP(N,SX,INCX,SY,INCY)
      IMPLICIT NONE
      REAL SX(*),SY(*)
      INTEGER INCX,INCY,N
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE SSYMM(SIDE,UPLO,M,N,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
      IMPLICIT NONE
      REAL ALPHA,BETA,A(LDA,*),B(LDB,*),C(LDC,*)
      INTEGER LDA,LDB,LDC,M,N
      CHARACTER SIDE,UPLO
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE SSYMV(UPLO,N,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
      IMPLICIT NONE
      REAL ALPHA,BETA,A(LDA,*),X(*),Y(*)
      INTEGER INCX,INCY,LDA,N
      CHARACTER UPLO
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE SSYR(UPLO,N,ALPHA,X,INCX,A,LDA)
      IMPLICIT NONE
      REAL ALPHA,A(LDA,*),X(*)
      INTEGER INCX,LDA,N
      CHARACTER UPLO
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE SSYR2(UPLO,N,ALPHA,X,INCX,Y,INCY,A,LDA)
      IMPLICIT NONE
      REAL ALPHA,A(LDA,*),X(*),Y(*)
      INTEGER INCX,INCY,LDA,N
      CHARACTER UPLO
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE SSYR2K(UPLO,TRANS,N,K,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
      IMPLICIT NONE
      REAL ALPHA,BETA,A(LDA,*),B(LDB,*),C(LDC,*)
      INTEGER K,LDA,LDB,LDC,N
      CHARACTER TRANS,UPLO
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE SSYRK(UPLO,TRANS,N,K,ALPHA,A,LDA,BETA,C,LDC)
      IMPLICIT NONE
      REAL ALPHA,BETA,A(LDA,*),C(LDC,*)
      INTEGER K,LDA,LDC,N
      CHARACTER TRANS,UPLO
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE STBMV(UPLO,TRANS,DIAG,N,K,A,LDA,X,INCX)
      IMPLICIT NONE
      REAL A(LDA,*),X(*)
      INTEGER INCX,K,LDA,N
      CHARACTER DIAG,TRANS,UPLO
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE STBSV(UPLO,TRANS,DIAG,N,K,A,LDA,X,INCX)
      IMPLICIT NONE
      REAL A(LDA,*),X(*)
      INTEGER INCX,K,LDA,N
      CHARACTER DIAG,TRANS,UPLO
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE STPMV(UPLO,TRANS,DIAG,N,AP,X,INCX)
      IMPLICIT NONE
      REAL AP(*),X(*)
      INTEGER INCX,N
      CHARACTER DIAG,TRANS,UPLO
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE STPSV(UPLO,TRANS,DIAG,N,AP,X,INCX)
      IMPLICIT NONE
      REAL AP(*),X(*)
      INTEGER INCX,N
      CHARACTER DIAG,TRANS,UPLO
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE STRMM(SIDE,UPLO,TRANSA,DIAG,M,N,ALPHA,A,LDA,B,LDB)
      IMPLICIT NONE
      REAL ALPHA,A(LDA,*),B(LDB,*)
      INTEGER LDA,LDB,M,N
      CHARACTER DIAG,SIDE,TRANSA,UPLO
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE STRMV(UPLO,TRANS,DIAG,N,A,LDA,X,INCX)
      IMPLICIT NONE
      REAL A(LDA,*),X(*)
      INTEGER INCX,LDA,N
      CHARACTER DIAG,TRANS,UPLO
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE STRSM(SIDE,UPLO,TRANSA,DIAG,M,N,ALPHA,A,LDA,B,LDB)
      IMPLICIT NONE
      REAL ALPHA,A(LDA,*),B(LDB,*)
      INTEGER LDA,LDB,M,N
      CHARACTER DIAG,SIDE,TRANSA,UPLO
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE STRSV(UPLO,TRANS,DIAG,N,A,LDA,X,INCX)
      IMPLICIT NONE
      REAL A(LDA,*),X(*)
      INTEGER INCX,LDA,N
      CHARACTER DIAG,TRANS,UPLO
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE XERBLA(SRNAME,INFO)
      IMPLICIT NONE
      CHARACTER*(*) SRNAME
      INTEGER INFO
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE ZAXPY(N,ZA,ZX,INCX,ZY,INCY)
      IMPLICIT NONE
      DOUBLE COMPLEX ZA,ZX(*),ZY(*)
      INTEGER INCX,INCY,N
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE ZCOPY(N,ZX,INCX,ZY,INCY)
      IMPLICIT NONE
      INTEGER INCX,INCY,N
      DOUBLE COMPLEX ZX(*),ZY(*)
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      DOUBLE COMPLEX FUNCTION ZDOTC(N,ZX,INCX,ZY,INCY)
      IMPLICIT NONE
      INTEGER INCX,INCY,N
      DOUBLE COMPLEX ZX(*),ZY(*)
      END FUNCTION
      END INTERFACE
      INTERFACE
      DOUBLE COMPLEX FUNCTION ZDOTU(N,ZX,INCX,ZY,INCY)
      IMPLICIT NONE
      INTEGER INCX,INCY,N
      DOUBLE COMPLEX ZX(*),ZY(*)
      END FUNCTION
      END INTERFACE
      INTERFACE
      SUBROUTINE ZDROT(N,CX,INCX,CY,INCY,C,S)
      IMPLICIT NONE
      INTEGER INCX,INCY,N
      DOUBLE PRECISION C,S
      COMPLEX*16 CX(*),CY(*)
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE ZDSCAL(N,DA,ZX,INCX)
      IMPLICIT NONE
      INTEGER INCX,N
      DOUBLE PRECISION DA
      DOUBLE COMPLEX ZX(*)
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE ZGBMV(TRANS,M,N,KL,KU,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
      IMPLICIT NONE
      DOUBLE COMPLEX ALPHA,BETA,A(LDA,*),X(*),Y(*)
      CHARACTER TRANS
      INTEGER INCX,INCY,KL,KU,LDA,M,N
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE ZGEMM(TRANSA,TRANSB,M,N,K,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
      IMPLICIT NONE
      DOUBLE COMPLEX ALPHA,BETA,A(LDA,*),B(LDB,*),C(LDC,*)
      CHARACTER TRANSA,TRANSB
      INTEGER K,LDA,LDB,LDC,M,N
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE ZGEMV(TRANS,M,N,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
      IMPLICIT NONE
      DOUBLE COMPLEX ALPHA,BETA,A(LDA,*),X(*),Y(*)
      CHARACTER TRANS
      INTEGER INCX,INCY,LDA,M,N
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE ZGERC(M,N,ALPHA,X,INCX,Y,INCY,A,LDA)
      IMPLICIT NONE
      DOUBLE COMPLEX ALPHA,A(LDA,*),X(*),Y(*)
      INTEGER INCX,INCY,LDA,M,N
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE ZGERU(M,N,ALPHA,X,INCX,Y,INCY,A,LDA)
      IMPLICIT NONE
      DOUBLE COMPLEX ALPHA,A(LDA,*),X(*),Y(*)
      INTEGER INCX,INCY,LDA,M,N
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE ZHBMV(UPLO,N,K,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
      IMPLICIT NONE
      DOUBLE COMPLEX ALPHA,BETA,A(LDA,*),X(*),Y(*)
      CHARACTER UPLO
      INTEGER INCX,INCY,K,LDA,N
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE ZHEMM(SIDE,UPLO,M,N,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
      IMPLICIT NONE
      DOUBLE COMPLEX ALPHA,BETA,A(LDA,*),B(LDB,*),C(LDC,*)
      CHARACTER SIDE,UPLO
      INTEGER LDA,LDB,LDC,M,N
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE ZHEMV(UPLO,N,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
      IMPLICIT NONE
      DOUBLE COMPLEX ALPHA,BETA,A(LDA,*),X(*),Y(*)
      CHARACTER UPLO
      INTEGER INCX,INCY,LDA,N
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE ZHER(UPLO,N,ALPHA,X,INCX,A,LDA)
      IMPLICIT NONE
      INTEGER INCX,LDA,N
      DOUBLE PRECISION ALPHA
      CHARACTER UPLO
      DOUBLE COMPLEX A(LDA,*),X(*)
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE ZHER2(UPLO,N,ALPHA,X,INCX,Y,INCY,A,LDA)
      IMPLICIT NONE
      DOUBLE COMPLEX ALPHA,A(LDA,*),X(*),Y(*)
      CHARACTER UPLO
      INTEGER INCX,INCY,LDA,N
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE ZHER2K(UPLO,TRANS,N,K,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
      IMPLICIT NONE
      DOUBLE COMPLEX ALPHA,A(LDA,*),B(LDB,*),C(LDC,*)
      DOUBLE PRECISION BETA
      CHARACTER TRANS,UPLO
      INTEGER K,LDA,LDB,LDC,N
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE ZHERK(UPLO,TRANS,N,K,ALPHA,A,LDA,BETA,C,LDC)
      IMPLICIT NONE
      INTEGER K,LDA,LDC,N
      DOUBLE PRECISION ALPHA,BETA
      CHARACTER TRANS,UPLO
      DOUBLE COMPLEX A(LDA,*),C(LDC,*)
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE ZHPMV(UPLO,N,ALPHA,AP,X,INCX,BETA,Y,INCY)
      IMPLICIT NONE
      DOUBLE COMPLEX ALPHA,BETA,AP(*),X(*),Y(*)
      CHARACTER UPLO
      INTEGER INCX,INCY,N
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE ZHPR(UPLO,N,ALPHA,X,INCX,AP)
      IMPLICIT NONE
      INTEGER INCX,N
      DOUBLE PRECISION ALPHA
      CHARACTER UPLO
      DOUBLE COMPLEX AP(*),X(*)
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE ZHPR2(UPLO,N,ALPHA,X,INCX,Y,INCY,AP)
      IMPLICIT NONE
      DOUBLE COMPLEX ALPHA,AP(*),X(*),Y(*)
      CHARACTER UPLO
      INTEGER INCX,INCY,N
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE ZROTG(CA,CB,C,S)
      IMPLICIT NONE
      DOUBLE COMPLEX CA,CB,S
      DOUBLE PRECISION C
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE ZSCAL(N,ZA,ZX,INCX)
      IMPLICIT NONE
      DOUBLE COMPLEX ZA,ZX(*)
      INTEGER INCX,N
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE ZSWAP(N,ZX,INCX,ZY,INCY)
      IMPLICIT NONE
      INTEGER INCX,INCY,N
      DOUBLE COMPLEX ZX(*),ZY(*)
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE ZSYMM(SIDE,UPLO,M,N,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
      IMPLICIT NONE
      DOUBLE COMPLEX ALPHA,BETA,A(LDA,*),B(LDB,*),C(LDC,*)
      CHARACTER SIDE,UPLO
      INTEGER LDA,LDB,LDC,M,N
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE ZSYR2K(UPLO,TRANS,N,K,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
      IMPLICIT NONE
      DOUBLE COMPLEX ALPHA,BETA,A(LDA,*),B(LDB,*),C(LDC,*)
      CHARACTER TRANS,UPLO
      INTEGER K,LDA,LDB,LDC,N
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE ZSYRK(UPLO,TRANS,N,K,ALPHA,A,LDA,BETA,C,LDC)
      IMPLICIT NONE
      DOUBLE COMPLEX ALPHA,BETA,A(LDA,*),C(LDC,*)
      CHARACTER TRANS,UPLO
      INTEGER K,LDA,LDC,N
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE ZTBMV(UPLO,TRANS,DIAG,N,K,A,LDA,X,INCX)
      IMPLICIT NONE
      INTEGER INCX,K,LDA,N
      CHARACTER DIAG,TRANS,UPLO
      DOUBLE COMPLEX A(LDA,*),X(*)
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE ZTBSV(UPLO,TRANS,DIAG,N,K,A,LDA,X,INCX)
      IMPLICIT NONE
      INTEGER INCX,K,LDA,N
      CHARACTER DIAG,TRANS,UPLO
      DOUBLE COMPLEX A(LDA,*),X(*)
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE ZTPMV(UPLO,TRANS,DIAG,N,AP,X,INCX)
      IMPLICIT NONE
      INTEGER INCX,N
      CHARACTER DIAG,TRANS,UPLO
      DOUBLE COMPLEX AP(*),X(*)
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE ZTPSV(UPLO,TRANS,DIAG,N,AP,X,INCX)
      IMPLICIT NONE
      INTEGER INCX,N
      CHARACTER DIAG,TRANS,UPLO
      DOUBLE COMPLEX AP(*),X(*)
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE ZTRMM(SIDE,UPLO,TRANSA,DIAG,M,N,ALPHA,A,LDA,B,LDB)
      IMPLICIT NONE
      DOUBLE COMPLEX ALPHA,A(LDA,*),B(LDB,*)
      CHARACTER DIAG,SIDE,TRANSA,UPLO
      INTEGER LDA,LDB,M,N
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE ZTRMV(UPLO,TRANS,DIAG,N,A,LDA,X,INCX)
      IMPLICIT NONE
      INTEGER INCX,LDA,N
      CHARACTER DIAG,TRANS,UPLO
      DOUBLE COMPLEX A(LDA,*),X(*)
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE ZTRSM(SIDE,UPLO,TRANSA,DIAG,M,N,ALPHA,A,LDA,B,LDB)
      IMPLICIT NONE
      DOUBLE COMPLEX ALPHA,A(LDA,*),B(LDB,*)
      CHARACTER DIAG,SIDE,TRANSA,UPLO
      INTEGER LDA,LDB,M,N
      END SUBROUTINE
      END INTERFACE
      INTERFACE
      SUBROUTINE ZTRSV(UPLO,TRANS,DIAG,N,A,LDA,X,INCX)
      IMPLICIT NONE
      INTEGER INCX,LDA,N
      CHARACTER DIAG,TRANS,UPLO
      DOUBLE COMPLEX A(LDA,*),X(*)
      END SUBROUTINE
      END INTERFACE
      END

!
! Copyright (C) 2021, MaX CoE
! Distributed under the MIT License
! (license terms are at http://opensource.org/licenses/MIT).
!
!--
!
! Utility functions to perform memcpy and memset on the device with CUDA Fortran
! cuf_memXXX contains a CUF KERNEL to perform the selected operation
! cu_memsync are wrappers for cuda_memcpy functions
!
module devXlib

  use devxlib_malloc
  use devxlib_mapping
  use devxlib_memcpy
  use devxlib_memset
  use devxlib_auxfunc
  use devxlib_buffers
  use devxlib_linalg
  use devxlib_async

  implicit none

end module devXlib

!
! Copyright (C) 2022, MaX CoE
! Distributed under the MIT License 
! (license terms are at http://opensource.org/licenses/MIT).
!
!--
!
! Utility functions to perform device memory mapping from host memory
! using CUDA-Fortran, OpenACC or OpenMP Offload
!
!==================================================================
!==================================================================
! *DO NOT EDIT*: automatically generated from device_mapping.jf90
!==================================================================
!==================================================================
!
#include<devxlib_macros.h>
#include<devxlib_defs.h>
!
!=======================================
!
submodule (devxlib_mapping) devxlib_mapping_map

   implicit none

   contains
      module subroutine sp_devxlib_mapping_map_r1d(array, range1 )
         implicit none
         !
         real(real32), allocatable DEV_ATTR, intent(inout) :: array(:)
         integer, optional, intent(in) ::  range1(2)
         !
         integer :: i1, d1s, d1e
         !
         if (present(range1)) then
            d1s = range1(1)
            d1e = range1(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("sp_dev_mapping_r1d","range not present",1)
!#endif
            d1s = lbound(array,1)
            d1e = ubound(array,1)
         endif
         !
         !
#if defined __DXL_CUDAF
         if (.not.allocated(array)) allocate( array(d1s:d1e) )
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC enter data create( array(d1s:d1e) ) wait
         !DEV_OMPGPU target enter data map(alloc: array )
#endif
      end subroutine sp_devxlib_mapping_map_r1d
      !
      module subroutine sp_devxlib_mapping_map_r2d(array, range1, &
                                            range2 )
         implicit none
         !
         real(real32), allocatable DEV_ATTR, intent(inout) :: array(:,:)
         integer, optional, intent(in) ::  range1(2), range2(2)
         !
         integer :: i1, d1s, d1e
         integer :: i2, d2s, d2e
         !
         if (present(range1)) then
            d1s = range1(1)
            d1e = range1(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("sp_dev_mapping_r2d","range not present",1)
!#endif
            d1s = lbound(array,1)
            d1e = ubound(array,1)
         endif
         !
         if (present(range2)) then
            d2s = range2(1)
            d2e = range2(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("sp_dev_mapping_r2d","range not present",2)
!#endif
            d2s = lbound(array,2)
            d2e = ubound(array,2)
         endif
         !
         !
#if defined __DXL_CUDAF
         if (.not.allocated(array)) allocate( array(d1s:d1e,d2s:d2e) )
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC enter data create( array(d1s:d1e,d2s:d2e) ) wait
         !DEV_OMPGPU target enter data map(alloc: array )
#endif
      end subroutine sp_devxlib_mapping_map_r2d
      !
      module subroutine sp_devxlib_mapping_map_r3d(array, range1, &
                                            range2, &
                                            range3 )
         implicit none
         !
         real(real32), allocatable DEV_ATTR, intent(inout) :: array(:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
         !
         integer :: i1, d1s, d1e
         integer :: i2, d2s, d2e
         integer :: i3, d3s, d3e
         !
         if (present(range1)) then
            d1s = range1(1)
            d1e = range1(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("sp_dev_mapping_r3d","range not present",1)
!#endif
            d1s = lbound(array,1)
            d1e = ubound(array,1)
         endif
         !
         if (present(range2)) then
            d2s = range2(1)
            d2e = range2(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("sp_dev_mapping_r3d","range not present",2)
!#endif
            d2s = lbound(array,2)
            d2e = ubound(array,2)
         endif
         !
         if (present(range3)) then
            d3s = range3(1)
            d3e = range3(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("sp_dev_mapping_r3d","range not present",3)
!#endif
            d3s = lbound(array,3)
            d3e = ubound(array,3)
         endif
         !
         !
#if defined __DXL_CUDAF
         if (.not.allocated(array)) allocate( array(d1s:d1e,d2s:d2e,d3s:d3e) )
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC enter data create( array(d1s:d1e,d2s:d2e,d3s:d3e) ) wait
         !DEV_OMPGPU target enter data map(alloc: array )
#endif
      end subroutine sp_devxlib_mapping_map_r3d
      !
      module subroutine sp_devxlib_mapping_map_r4d(array, range1, &
                                            range2, &
                                            range3, &
                                            range4 )
         implicit none
         !
         real(real32), allocatable DEV_ATTR, intent(inout) :: array(:,:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
         !
         integer :: i1, d1s, d1e
         integer :: i2, d2s, d2e
         integer :: i3, d3s, d3e
         integer :: i4, d4s, d4e
         !
         if (present(range1)) then
            d1s = range1(1)
            d1e = range1(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("sp_dev_mapping_r4d","range not present",1)
!#endif
            d1s = lbound(array,1)
            d1e = ubound(array,1)
         endif
         !
         if (present(range2)) then
            d2s = range2(1)
            d2e = range2(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("sp_dev_mapping_r4d","range not present",2)
!#endif
            d2s = lbound(array,2)
            d2e = ubound(array,2)
         endif
         !
         if (present(range3)) then
            d3s = range3(1)
            d3e = range3(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("sp_dev_mapping_r4d","range not present",3)
!#endif
            d3s = lbound(array,3)
            d3e = ubound(array,3)
         endif
         !
         if (present(range4)) then
            d4s = range4(1)
            d4e = range4(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("sp_dev_mapping_r4d","range not present",4)
!#endif
            d4s = lbound(array,4)
            d4e = ubound(array,4)
         endif
         !
         !
#if defined __DXL_CUDAF
         if (.not.allocated(array)) allocate( array(d1s:d1e,d2s:d2e,d3s:d3e,d4s:d4e) )
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC enter data create( array(d1s:d1e,d2s:d2e,d3s:d3e,d4s:d4e) ) wait
         !DEV_OMPGPU target enter data map(alloc: array )
#endif
      end subroutine sp_devxlib_mapping_map_r4d
      !
      module subroutine sp_devxlib_mapping_map_r5d(array, range1, &
                                            range2, &
                                            range3, &
                                            range4, &
                                            range5 )
         implicit none
         !
         real(real32), allocatable DEV_ATTR, intent(inout) :: array(:,:,:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2)
         !
         integer :: i1, d1s, d1e
         integer :: i2, d2s, d2e
         integer :: i3, d3s, d3e
         integer :: i4, d4s, d4e
         integer :: i5, d5s, d5e
         !
         if (present(range1)) then
            d1s = range1(1)
            d1e = range1(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("sp_dev_mapping_r5d","range not present",1)
!#endif
            d1s = lbound(array,1)
            d1e = ubound(array,1)
         endif
         !
         if (present(range2)) then
            d2s = range2(1)
            d2e = range2(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("sp_dev_mapping_r5d","range not present",2)
!#endif
            d2s = lbound(array,2)
            d2e = ubound(array,2)
         endif
         !
         if (present(range3)) then
            d3s = range3(1)
            d3e = range3(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("sp_dev_mapping_r5d","range not present",3)
!#endif
            d3s = lbound(array,3)
            d3e = ubound(array,3)
         endif
         !
         if (present(range4)) then
            d4s = range4(1)
            d4e = range4(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("sp_dev_mapping_r5d","range not present",4)
!#endif
            d4s = lbound(array,4)
            d4e = ubound(array,4)
         endif
         !
         if (present(range5)) then
            d5s = range5(1)
            d5e = range5(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("sp_dev_mapping_r5d","range not present",5)
!#endif
            d5s = lbound(array,5)
            d5e = ubound(array,5)
         endif
         !
         !
#if defined __DXL_CUDAF
         if (.not.allocated(array)) allocate( array(d1s:d1e,d2s:d2e,d3s:d3e,d4s:d4e,d5s:d5e) )
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC enter data create( array(d1s:d1e,d2s:d2e,d3s:d3e,d4s:d4e,d5s:d5e) ) wait
         !DEV_OMPGPU target enter data map(alloc: array )
#endif
      end subroutine sp_devxlib_mapping_map_r5d
      !
      module subroutine sp_devxlib_mapping_map_r6d(array, range1, &
                                            range2, &
                                            range3, &
                                            range4, &
                                            range5, &
                                            range6 )
         implicit none
         !
         real(real32), allocatable DEV_ATTR, intent(inout) :: array(:,:,:,:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2), range6(2)
         !
         integer :: i1, d1s, d1e
         integer :: i2, d2s, d2e
         integer :: i3, d3s, d3e
         integer :: i4, d4s, d4e
         integer :: i5, d5s, d5e
         integer :: i6, d6s, d6e
         !
         if (present(range1)) then
            d1s = range1(1)
            d1e = range1(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("sp_dev_mapping_r6d","range not present",1)
!#endif
            d1s = lbound(array,1)
            d1e = ubound(array,1)
         endif
         !
         if (present(range2)) then
            d2s = range2(1)
            d2e = range2(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("sp_dev_mapping_r6d","range not present",2)
!#endif
            d2s = lbound(array,2)
            d2e = ubound(array,2)
         endif
         !
         if (present(range3)) then
            d3s = range3(1)
            d3e = range3(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("sp_dev_mapping_r6d","range not present",3)
!#endif
            d3s = lbound(array,3)
            d3e = ubound(array,3)
         endif
         !
         if (present(range4)) then
            d4s = range4(1)
            d4e = range4(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("sp_dev_mapping_r6d","range not present",4)
!#endif
            d4s = lbound(array,4)
            d4e = ubound(array,4)
         endif
         !
         if (present(range5)) then
            d5s = range5(1)
            d5e = range5(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("sp_dev_mapping_r6d","range not present",5)
!#endif
            d5s = lbound(array,5)
            d5e = ubound(array,5)
         endif
         !
         if (present(range6)) then
            d6s = range6(1)
            d6e = range6(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("sp_dev_mapping_r6d","range not present",6)
!#endif
            d6s = lbound(array,6)
            d6e = ubound(array,6)
         endif
         !
         !
#if defined __DXL_CUDAF
         if (.not.allocated(array)) allocate( array(d1s:d1e,d2s:d2e,d3s:d3e,d4s:d4e,d5s:d5e,d6s:d6e) )
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC enter data create( array(d1s:d1e,d2s:d2e,d3s:d3e,d4s:d4e,d5s:d5e,d6s:d6e) ) wait
         !DEV_OMPGPU target enter data map(alloc: array )
#endif
      end subroutine sp_devxlib_mapping_map_r6d
      !
      module subroutine dp_devxlib_mapping_map_r1d(array, range1 )
         implicit none
         !
         real(real64), allocatable DEV_ATTR, intent(inout) :: array(:)
         integer, optional, intent(in) ::  range1(2)
         !
         integer :: i1, d1s, d1e
         !
         if (present(range1)) then
            d1s = range1(1)
            d1e = range1(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("dp_dev_mapping_r1d","range not present",1)
!#endif
            d1s = lbound(array,1)
            d1e = ubound(array,1)
         endif
         !
         !
#if defined __DXL_CUDAF
         if (.not.allocated(array)) allocate( array(d1s:d1e) )
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC enter data create( array(d1s:d1e) ) wait
         !DEV_OMPGPU target enter data map(alloc: array )
#endif
      end subroutine dp_devxlib_mapping_map_r1d
      !
      module subroutine dp_devxlib_mapping_map_r2d(array, range1, &
                                            range2 )
         implicit none
         !
         real(real64), allocatable DEV_ATTR, intent(inout) :: array(:,:)
         integer, optional, intent(in) ::  range1(2), range2(2)
         !
         integer :: i1, d1s, d1e
         integer :: i2, d2s, d2e
         !
         if (present(range1)) then
            d1s = range1(1)
            d1e = range1(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("dp_dev_mapping_r2d","range not present",1)
!#endif
            d1s = lbound(array,1)
            d1e = ubound(array,1)
         endif
         !
         if (present(range2)) then
            d2s = range2(1)
            d2e = range2(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("dp_dev_mapping_r2d","range not present",2)
!#endif
            d2s = lbound(array,2)
            d2e = ubound(array,2)
         endif
         !
         !
#if defined __DXL_CUDAF
         if (.not.allocated(array)) allocate( array(d1s:d1e,d2s:d2e) )
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC enter data create( array(d1s:d1e,d2s:d2e) ) wait
         !DEV_OMPGPU target enter data map(alloc: array )
#endif
      end subroutine dp_devxlib_mapping_map_r2d
      !
      module subroutine dp_devxlib_mapping_map_r3d(array, range1, &
                                            range2, &
                                            range3 )
         implicit none
         !
         real(real64), allocatable DEV_ATTR, intent(inout) :: array(:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
         !
         integer :: i1, d1s, d1e
         integer :: i2, d2s, d2e
         integer :: i3, d3s, d3e
         !
         if (present(range1)) then
            d1s = range1(1)
            d1e = range1(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("dp_dev_mapping_r3d","range not present",1)
!#endif
            d1s = lbound(array,1)
            d1e = ubound(array,1)
         endif
         !
         if (present(range2)) then
            d2s = range2(1)
            d2e = range2(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("dp_dev_mapping_r3d","range not present",2)
!#endif
            d2s = lbound(array,2)
            d2e = ubound(array,2)
         endif
         !
         if (present(range3)) then
            d3s = range3(1)
            d3e = range3(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("dp_dev_mapping_r3d","range not present",3)
!#endif
            d3s = lbound(array,3)
            d3e = ubound(array,3)
         endif
         !
         !
#if defined __DXL_CUDAF
         if (.not.allocated(array)) allocate( array(d1s:d1e,d2s:d2e,d3s:d3e) )
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC enter data create( array(d1s:d1e,d2s:d2e,d3s:d3e) ) wait
         !DEV_OMPGPU target enter data map(alloc: array )
#endif
      end subroutine dp_devxlib_mapping_map_r3d
      !
      module subroutine dp_devxlib_mapping_map_r4d(array, range1, &
                                            range2, &
                                            range3, &
                                            range4 )
         implicit none
         !
         real(real64), allocatable DEV_ATTR, intent(inout) :: array(:,:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
         !
         integer :: i1, d1s, d1e
         integer :: i2, d2s, d2e
         integer :: i3, d3s, d3e
         integer :: i4, d4s, d4e
         !
         if (present(range1)) then
            d1s = range1(1)
            d1e = range1(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("dp_dev_mapping_r4d","range not present",1)
!#endif
            d1s = lbound(array,1)
            d1e = ubound(array,1)
         endif
         !
         if (present(range2)) then
            d2s = range2(1)
            d2e = range2(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("dp_dev_mapping_r4d","range not present",2)
!#endif
            d2s = lbound(array,2)
            d2e = ubound(array,2)
         endif
         !
         if (present(range3)) then
            d3s = range3(1)
            d3e = range3(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("dp_dev_mapping_r4d","range not present",3)
!#endif
            d3s = lbound(array,3)
            d3e = ubound(array,3)
         endif
         !
         if (present(range4)) then
            d4s = range4(1)
            d4e = range4(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("dp_dev_mapping_r4d","range not present",4)
!#endif
            d4s = lbound(array,4)
            d4e = ubound(array,4)
         endif
         !
         !
#if defined __DXL_CUDAF
         if (.not.allocated(array)) allocate( array(d1s:d1e,d2s:d2e,d3s:d3e,d4s:d4e) )
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC enter data create( array(d1s:d1e,d2s:d2e,d3s:d3e,d4s:d4e) ) wait
         !DEV_OMPGPU target enter data map(alloc: array )
#endif
      end subroutine dp_devxlib_mapping_map_r4d
      !
      module subroutine dp_devxlib_mapping_map_r5d(array, range1, &
                                            range2, &
                                            range3, &
                                            range4, &
                                            range5 )
         implicit none
         !
         real(real64), allocatable DEV_ATTR, intent(inout) :: array(:,:,:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2)
         !
         integer :: i1, d1s, d1e
         integer :: i2, d2s, d2e
         integer :: i3, d3s, d3e
         integer :: i4, d4s, d4e
         integer :: i5, d5s, d5e
         !
         if (present(range1)) then
            d1s = range1(1)
            d1e = range1(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("dp_dev_mapping_r5d","range not present",1)
!#endif
            d1s = lbound(array,1)
            d1e = ubound(array,1)
         endif
         !
         if (present(range2)) then
            d2s = range2(1)
            d2e = range2(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("dp_dev_mapping_r5d","range not present",2)
!#endif
            d2s = lbound(array,2)
            d2e = ubound(array,2)
         endif
         !
         if (present(range3)) then
            d3s = range3(1)
            d3e = range3(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("dp_dev_mapping_r5d","range not present",3)
!#endif
            d3s = lbound(array,3)
            d3e = ubound(array,3)
         endif
         !
         if (present(range4)) then
            d4s = range4(1)
            d4e = range4(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("dp_dev_mapping_r5d","range not present",4)
!#endif
            d4s = lbound(array,4)
            d4e = ubound(array,4)
         endif
         !
         if (present(range5)) then
            d5s = range5(1)
            d5e = range5(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("dp_dev_mapping_r5d","range not present",5)
!#endif
            d5s = lbound(array,5)
            d5e = ubound(array,5)
         endif
         !
         !
#if defined __DXL_CUDAF
         if (.not.allocated(array)) allocate( array(d1s:d1e,d2s:d2e,d3s:d3e,d4s:d4e,d5s:d5e) )
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC enter data create( array(d1s:d1e,d2s:d2e,d3s:d3e,d4s:d4e,d5s:d5e) ) wait
         !DEV_OMPGPU target enter data map(alloc: array )
#endif
      end subroutine dp_devxlib_mapping_map_r5d
      !
      module subroutine dp_devxlib_mapping_map_r6d(array, range1, &
                                            range2, &
                                            range3, &
                                            range4, &
                                            range5, &
                                            range6 )
         implicit none
         !
         real(real64), allocatable DEV_ATTR, intent(inout) :: array(:,:,:,:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2), range6(2)
         !
         integer :: i1, d1s, d1e
         integer :: i2, d2s, d2e
         integer :: i3, d3s, d3e
         integer :: i4, d4s, d4e
         integer :: i5, d5s, d5e
         integer :: i6, d6s, d6e
         !
         if (present(range1)) then
            d1s = range1(1)
            d1e = range1(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("dp_dev_mapping_r6d","range not present",1)
!#endif
            d1s = lbound(array,1)
            d1e = ubound(array,1)
         endif
         !
         if (present(range2)) then
            d2s = range2(1)
            d2e = range2(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("dp_dev_mapping_r6d","range not present",2)
!#endif
            d2s = lbound(array,2)
            d2e = ubound(array,2)
         endif
         !
         if (present(range3)) then
            d3s = range3(1)
            d3e = range3(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("dp_dev_mapping_r6d","range not present",3)
!#endif
            d3s = lbound(array,3)
            d3e = ubound(array,3)
         endif
         !
         if (present(range4)) then
            d4s = range4(1)
            d4e = range4(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("dp_dev_mapping_r6d","range not present",4)
!#endif
            d4s = lbound(array,4)
            d4e = ubound(array,4)
         endif
         !
         if (present(range5)) then
            d5s = range5(1)
            d5e = range5(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("dp_dev_mapping_r6d","range not present",5)
!#endif
            d5s = lbound(array,5)
            d5e = ubound(array,5)
         endif
         !
         if (present(range6)) then
            d6s = range6(1)
            d6e = range6(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("dp_dev_mapping_r6d","range not present",6)
!#endif
            d6s = lbound(array,6)
            d6e = ubound(array,6)
         endif
         !
         !
#if defined __DXL_CUDAF
         if (.not.allocated(array)) allocate( array(d1s:d1e,d2s:d2e,d3s:d3e,d4s:d4e,d5s:d5e,d6s:d6e) )
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC enter data create( array(d1s:d1e,d2s:d2e,d3s:d3e,d4s:d4e,d5s:d5e,d6s:d6e) ) wait
         !DEV_OMPGPU target enter data map(alloc: array )
#endif
      end subroutine dp_devxlib_mapping_map_r6d
      !
      module subroutine sp_devxlib_mapping_map_c1d(array, range1 )
         implicit none
         !
         complex(real32), allocatable DEV_ATTR, intent(inout) :: array(:)
         integer, optional, intent(in) ::  range1(2)
         !
         integer :: i1, d1s, d1e
         !
         if (present(range1)) then
            d1s = range1(1)
            d1e = range1(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("sp_dev_mapping_c1d","range not present",1)
!#endif
            d1s = lbound(array,1)
            d1e = ubound(array,1)
         endif
         !
         !
#if defined __DXL_CUDAF
         if (.not.allocated(array)) allocate( array(d1s:d1e) )
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC enter data create( array(d1s:d1e) ) wait
         !DEV_OMPGPU target enter data map(alloc: array )
#endif
      end subroutine sp_devxlib_mapping_map_c1d
      !
      module subroutine sp_devxlib_mapping_map_c2d(array, range1, &
                                            range2 )
         implicit none
         !
         complex(real32), allocatable DEV_ATTR, intent(inout) :: array(:,:)
         integer, optional, intent(in) ::  range1(2), range2(2)
         !
         integer :: i1, d1s, d1e
         integer :: i2, d2s, d2e
         !
         if (present(range1)) then
            d1s = range1(1)
            d1e = range1(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("sp_dev_mapping_c2d","range not present",1)
!#endif
            d1s = lbound(array,1)
            d1e = ubound(array,1)
         endif
         !
         if (present(range2)) then
            d2s = range2(1)
            d2e = range2(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("sp_dev_mapping_c2d","range not present",2)
!#endif
            d2s = lbound(array,2)
            d2e = ubound(array,2)
         endif
         !
         !
#if defined __DXL_CUDAF
         if (.not.allocated(array)) allocate( array(d1s:d1e,d2s:d2e) )
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC enter data create( array(d1s:d1e,d2s:d2e) ) wait
         !DEV_OMPGPU target enter data map(alloc: array )
#endif
      end subroutine sp_devxlib_mapping_map_c2d
      !
      module subroutine sp_devxlib_mapping_map_c3d(array, range1, &
                                            range2, &
                                            range3 )
         implicit none
         !
         complex(real32), allocatable DEV_ATTR, intent(inout) :: array(:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
         !
         integer :: i1, d1s, d1e
         integer :: i2, d2s, d2e
         integer :: i3, d3s, d3e
         !
         if (present(range1)) then
            d1s = range1(1)
            d1e = range1(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("sp_dev_mapping_c3d","range not present",1)
!#endif
            d1s = lbound(array,1)
            d1e = ubound(array,1)
         endif
         !
         if (present(range2)) then
            d2s = range2(1)
            d2e = range2(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("sp_dev_mapping_c3d","range not present",2)
!#endif
            d2s = lbound(array,2)
            d2e = ubound(array,2)
         endif
         !
         if (present(range3)) then
            d3s = range3(1)
            d3e = range3(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("sp_dev_mapping_c3d","range not present",3)
!#endif
            d3s = lbound(array,3)
            d3e = ubound(array,3)
         endif
         !
         !
#if defined __DXL_CUDAF
         if (.not.allocated(array)) allocate( array(d1s:d1e,d2s:d2e,d3s:d3e) )
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC enter data create( array(d1s:d1e,d2s:d2e,d3s:d3e) ) wait
         !DEV_OMPGPU target enter data map(alloc: array )
#endif
      end subroutine sp_devxlib_mapping_map_c3d
      !
      module subroutine sp_devxlib_mapping_map_c4d(array, range1, &
                                            range2, &
                                            range3, &
                                            range4 )
         implicit none
         !
         complex(real32), allocatable DEV_ATTR, intent(inout) :: array(:,:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
         !
         integer :: i1, d1s, d1e
         integer :: i2, d2s, d2e
         integer :: i3, d3s, d3e
         integer :: i4, d4s, d4e
         !
         if (present(range1)) then
            d1s = range1(1)
            d1e = range1(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("sp_dev_mapping_c4d","range not present",1)
!#endif
            d1s = lbound(array,1)
            d1e = ubound(array,1)
         endif
         !
         if (present(range2)) then
            d2s = range2(1)
            d2e = range2(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("sp_dev_mapping_c4d","range not present",2)
!#endif
            d2s = lbound(array,2)
            d2e = ubound(array,2)
         endif
         !
         if (present(range3)) then
            d3s = range3(1)
            d3e = range3(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("sp_dev_mapping_c4d","range not present",3)
!#endif
            d3s = lbound(array,3)
            d3e = ubound(array,3)
         endif
         !
         if (present(range4)) then
            d4s = range4(1)
            d4e = range4(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("sp_dev_mapping_c4d","range not present",4)
!#endif
            d4s = lbound(array,4)
            d4e = ubound(array,4)
         endif
         !
         !
#if defined __DXL_CUDAF
         if (.not.allocated(array)) allocate( array(d1s:d1e,d2s:d2e,d3s:d3e,d4s:d4e) )
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC enter data create( array(d1s:d1e,d2s:d2e,d3s:d3e,d4s:d4e) ) wait
         !DEV_OMPGPU target enter data map(alloc: array )
#endif
      end subroutine sp_devxlib_mapping_map_c4d
      !
      module subroutine sp_devxlib_mapping_map_c5d(array, range1, &
                                            range2, &
                                            range3, &
                                            range4, &
                                            range5 )
         implicit none
         !
         complex(real32), allocatable DEV_ATTR, intent(inout) :: array(:,:,:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2)
         !
         integer :: i1, d1s, d1e
         integer :: i2, d2s, d2e
         integer :: i3, d3s, d3e
         integer :: i4, d4s, d4e
         integer :: i5, d5s, d5e
         !
         if (present(range1)) then
            d1s = range1(1)
            d1e = range1(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("sp_dev_mapping_c5d","range not present",1)
!#endif
            d1s = lbound(array,1)
            d1e = ubound(array,1)
         endif
         !
         if (present(range2)) then
            d2s = range2(1)
            d2e = range2(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("sp_dev_mapping_c5d","range not present",2)
!#endif
            d2s = lbound(array,2)
            d2e = ubound(array,2)
         endif
         !
         if (present(range3)) then
            d3s = range3(1)
            d3e = range3(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("sp_dev_mapping_c5d","range not present",3)
!#endif
            d3s = lbound(array,3)
            d3e = ubound(array,3)
         endif
         !
         if (present(range4)) then
            d4s = range4(1)
            d4e = range4(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("sp_dev_mapping_c5d","range not present",4)
!#endif
            d4s = lbound(array,4)
            d4e = ubound(array,4)
         endif
         !
         if (present(range5)) then
            d5s = range5(1)
            d5e = range5(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("sp_dev_mapping_c5d","range not present",5)
!#endif
            d5s = lbound(array,5)
            d5e = ubound(array,5)
         endif
         !
         !
#if defined __DXL_CUDAF
         if (.not.allocated(array)) allocate( array(d1s:d1e,d2s:d2e,d3s:d3e,d4s:d4e,d5s:d5e) )
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC enter data create( array(d1s:d1e,d2s:d2e,d3s:d3e,d4s:d4e,d5s:d5e) ) wait
         !DEV_OMPGPU target enter data map(alloc: array )
#endif
      end subroutine sp_devxlib_mapping_map_c5d
      !
      module subroutine sp_devxlib_mapping_map_c6d(array, range1, &
                                            range2, &
                                            range3, &
                                            range4, &
                                            range5, &
                                            range6 )
         implicit none
         !
         complex(real32), allocatable DEV_ATTR, intent(inout) :: array(:,:,:,:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2), range6(2)
         !
         integer :: i1, d1s, d1e
         integer :: i2, d2s, d2e
         integer :: i3, d3s, d3e
         integer :: i4, d4s, d4e
         integer :: i5, d5s, d5e
         integer :: i6, d6s, d6e
         !
         if (present(range1)) then
            d1s = range1(1)
            d1e = range1(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("sp_dev_mapping_c6d","range not present",1)
!#endif
            d1s = lbound(array,1)
            d1e = ubound(array,1)
         endif
         !
         if (present(range2)) then
            d2s = range2(1)
            d2e = range2(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("sp_dev_mapping_c6d","range not present",2)
!#endif
            d2s = lbound(array,2)
            d2e = ubound(array,2)
         endif
         !
         if (present(range3)) then
            d3s = range3(1)
            d3e = range3(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("sp_dev_mapping_c6d","range not present",3)
!#endif
            d3s = lbound(array,3)
            d3e = ubound(array,3)
         endif
         !
         if (present(range4)) then
            d4s = range4(1)
            d4e = range4(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("sp_dev_mapping_c6d","range not present",4)
!#endif
            d4s = lbound(array,4)
            d4e = ubound(array,4)
         endif
         !
         if (present(range5)) then
            d5s = range5(1)
            d5e = range5(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("sp_dev_mapping_c6d","range not present",5)
!#endif
            d5s = lbound(array,5)
            d5e = ubound(array,5)
         endif
         !
         if (present(range6)) then
            d6s = range6(1)
            d6e = range6(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("sp_dev_mapping_c6d","range not present",6)
!#endif
            d6s = lbound(array,6)
            d6e = ubound(array,6)
         endif
         !
         !
#if defined __DXL_CUDAF
         if (.not.allocated(array)) allocate( array(d1s:d1e,d2s:d2e,d3s:d3e,d4s:d4e,d5s:d5e,d6s:d6e) )
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC enter data create( array(d1s:d1e,d2s:d2e,d3s:d3e,d4s:d4e,d5s:d5e,d6s:d6e) ) wait
         !DEV_OMPGPU target enter data map(alloc: array )
#endif
      end subroutine sp_devxlib_mapping_map_c6d
      !
      module subroutine dp_devxlib_mapping_map_c1d(array, range1 )
         implicit none
         !
         complex(real64), allocatable DEV_ATTR, intent(inout) :: array(:)
         integer, optional, intent(in) ::  range1(2)
         !
         integer :: i1, d1s, d1e
         !
         if (present(range1)) then
            d1s = range1(1)
            d1e = range1(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("dp_dev_mapping_c1d","range not present",1)
!#endif
            d1s = lbound(array,1)
            d1e = ubound(array,1)
         endif
         !
         !
#if defined __DXL_CUDAF
         if (.not.allocated(array)) allocate( array(d1s:d1e) )
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC enter data create( array(d1s:d1e) ) wait
         !DEV_OMPGPU target enter data map(alloc: array )
#endif
      end subroutine dp_devxlib_mapping_map_c1d
      !
      module subroutine dp_devxlib_mapping_map_c2d(array, range1, &
                                            range2 )
         implicit none
         !
         complex(real64), allocatable DEV_ATTR, intent(inout) :: array(:,:)
         integer, optional, intent(in) ::  range1(2), range2(2)
         !
         integer :: i1, d1s, d1e
         integer :: i2, d2s, d2e
         !
         if (present(range1)) then
            d1s = range1(1)
            d1e = range1(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("dp_dev_mapping_c2d","range not present",1)
!#endif
            d1s = lbound(array,1)
            d1e = ubound(array,1)
         endif
         !
         if (present(range2)) then
            d2s = range2(1)
            d2e = range2(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("dp_dev_mapping_c2d","range not present",2)
!#endif
            d2s = lbound(array,2)
            d2e = ubound(array,2)
         endif
         !
         !
#if defined __DXL_CUDAF
         if (.not.allocated(array)) allocate( array(d1s:d1e,d2s:d2e) )
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC enter data create( array(d1s:d1e,d2s:d2e) ) wait
         !DEV_OMPGPU target enter data map(alloc: array )
#endif
      end subroutine dp_devxlib_mapping_map_c2d
      !
      module subroutine dp_devxlib_mapping_map_c3d(array, range1, &
                                            range2, &
                                            range3 )
         implicit none
         !
         complex(real64), allocatable DEV_ATTR, intent(inout) :: array(:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
         !
         integer :: i1, d1s, d1e
         integer :: i2, d2s, d2e
         integer :: i3, d3s, d3e
         !
         if (present(range1)) then
            d1s = range1(1)
            d1e = range1(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("dp_dev_mapping_c3d","range not present",1)
!#endif
            d1s = lbound(array,1)
            d1e = ubound(array,1)
         endif
         !
         if (present(range2)) then
            d2s = range2(1)
            d2e = range2(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("dp_dev_mapping_c3d","range not present",2)
!#endif
            d2s = lbound(array,2)
            d2e = ubound(array,2)
         endif
         !
         if (present(range3)) then
            d3s = range3(1)
            d3e = range3(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("dp_dev_mapping_c3d","range not present",3)
!#endif
            d3s = lbound(array,3)
            d3e = ubound(array,3)
         endif
         !
         !
#if defined __DXL_CUDAF
         if (.not.allocated(array)) allocate( array(d1s:d1e,d2s:d2e,d3s:d3e) )
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC enter data create( array(d1s:d1e,d2s:d2e,d3s:d3e) ) wait
         !DEV_OMPGPU target enter data map(alloc: array )
#endif
      end subroutine dp_devxlib_mapping_map_c3d
      !
      module subroutine dp_devxlib_mapping_map_c4d(array, range1, &
                                            range2, &
                                            range3, &
                                            range4 )
         implicit none
         !
         complex(real64), allocatable DEV_ATTR, intent(inout) :: array(:,:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
         !
         integer :: i1, d1s, d1e
         integer :: i2, d2s, d2e
         integer :: i3, d3s, d3e
         integer :: i4, d4s, d4e
         !
         if (present(range1)) then
            d1s = range1(1)
            d1e = range1(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("dp_dev_mapping_c4d","range not present",1)
!#endif
            d1s = lbound(array,1)
            d1e = ubound(array,1)
         endif
         !
         if (present(range2)) then
            d2s = range2(1)
            d2e = range2(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("dp_dev_mapping_c4d","range not present",2)
!#endif
            d2s = lbound(array,2)
            d2e = ubound(array,2)
         endif
         !
         if (present(range3)) then
            d3s = range3(1)
            d3e = range3(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("dp_dev_mapping_c4d","range not present",3)
!#endif
            d3s = lbound(array,3)
            d3e = ubound(array,3)
         endif
         !
         if (present(range4)) then
            d4s = range4(1)
            d4e = range4(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("dp_dev_mapping_c4d","range not present",4)
!#endif
            d4s = lbound(array,4)
            d4e = ubound(array,4)
         endif
         !
         !
#if defined __DXL_CUDAF
         if (.not.allocated(array)) allocate( array(d1s:d1e,d2s:d2e,d3s:d3e,d4s:d4e) )
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC enter data create( array(d1s:d1e,d2s:d2e,d3s:d3e,d4s:d4e) ) wait
         !DEV_OMPGPU target enter data map(alloc: array )
#endif
      end subroutine dp_devxlib_mapping_map_c4d
      !
      module subroutine dp_devxlib_mapping_map_c5d(array, range1, &
                                            range2, &
                                            range3, &
                                            range4, &
                                            range5 )
         implicit none
         !
         complex(real64), allocatable DEV_ATTR, intent(inout) :: array(:,:,:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2)
         !
         integer :: i1, d1s, d1e
         integer :: i2, d2s, d2e
         integer :: i3, d3s, d3e
         integer :: i4, d4s, d4e
         integer :: i5, d5s, d5e
         !
         if (present(range1)) then
            d1s = range1(1)
            d1e = range1(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("dp_dev_mapping_c5d","range not present",1)
!#endif
            d1s = lbound(array,1)
            d1e = ubound(array,1)
         endif
         !
         if (present(range2)) then
            d2s = range2(1)
            d2e = range2(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("dp_dev_mapping_c5d","range not present",2)
!#endif
            d2s = lbound(array,2)
            d2e = ubound(array,2)
         endif
         !
         if (present(range3)) then
            d3s = range3(1)
            d3e = range3(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("dp_dev_mapping_c5d","range not present",3)
!#endif
            d3s = lbound(array,3)
            d3e = ubound(array,3)
         endif
         !
         if (present(range4)) then
            d4s = range4(1)
            d4e = range4(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("dp_dev_mapping_c5d","range not present",4)
!#endif
            d4s = lbound(array,4)
            d4e = ubound(array,4)
         endif
         !
         if (present(range5)) then
            d5s = range5(1)
            d5e = range5(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("dp_dev_mapping_c5d","range not present",5)
!#endif
            d5s = lbound(array,5)
            d5e = ubound(array,5)
         endif
         !
         !
#if defined __DXL_CUDAF
         if (.not.allocated(array)) allocate( array(d1s:d1e,d2s:d2e,d3s:d3e,d4s:d4e,d5s:d5e) )
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC enter data create( array(d1s:d1e,d2s:d2e,d3s:d3e,d4s:d4e,d5s:d5e) ) wait
         !DEV_OMPGPU target enter data map(alloc: array )
#endif
      end subroutine dp_devxlib_mapping_map_c5d
      !
      module subroutine dp_devxlib_mapping_map_c6d(array, range1, &
                                            range2, &
                                            range3, &
                                            range4, &
                                            range5, &
                                            range6 )
         implicit none
         !
         complex(real64), allocatable DEV_ATTR, intent(inout) :: array(:,:,:,:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2), range6(2)
         !
         integer :: i1, d1s, d1e
         integer :: i2, d2s, d2e
         integer :: i3, d3s, d3e
         integer :: i4, d4s, d4e
         integer :: i5, d5s, d5e
         integer :: i6, d6s, d6e
         !
         if (present(range1)) then
            d1s = range1(1)
            d1e = range1(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("dp_dev_mapping_c6d","range not present",1)
!#endif
            d1s = lbound(array,1)
            d1e = ubound(array,1)
         endif
         !
         if (present(range2)) then
            d2s = range2(1)
            d2e = range2(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("dp_dev_mapping_c6d","range not present",2)
!#endif
            d2s = lbound(array,2)
            d2e = ubound(array,2)
         endif
         !
         if (present(range3)) then
            d3s = range3(1)
            d3e = range3(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("dp_dev_mapping_c6d","range not present",3)
!#endif
            d3s = lbound(array,3)
            d3e = ubound(array,3)
         endif
         !
         if (present(range4)) then
            d4s = range4(1)
            d4e = range4(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("dp_dev_mapping_c6d","range not present",4)
!#endif
            d4s = lbound(array,4)
            d4e = ubound(array,4)
         endif
         !
         if (present(range5)) then
            d5s = range5(1)
            d5e = range5(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("dp_dev_mapping_c6d","range not present",5)
!#endif
            d5s = lbound(array,5)
            d5e = ubound(array,5)
         endif
         !
         if (present(range6)) then
            d6s = range6(1)
            d6e = range6(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("dp_dev_mapping_c6d","range not present",6)
!#endif
            d6s = lbound(array,6)
            d6e = ubound(array,6)
         endif
         !
         !
#if defined __DXL_CUDAF
         if (.not.allocated(array)) allocate( array(d1s:d1e,d2s:d2e,d3s:d3e,d4s:d4e,d5s:d5e,d6s:d6e) )
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC enter data create( array(d1s:d1e,d2s:d2e,d3s:d3e,d4s:d4e,d5s:d5e,d6s:d6e) ) wait
         !DEV_OMPGPU target enter data map(alloc: array )
#endif
      end subroutine dp_devxlib_mapping_map_c6d
      !
      module subroutine i4_devxlib_mapping_map_i1d(array, range1 )
         implicit none
         !
         integer(int32), allocatable DEV_ATTR, intent(inout) :: array(:)
         integer, optional, intent(in) ::  range1(2)
         !
         integer :: i1, d1s, d1e
         !
         if (present(range1)) then
            d1s = range1(1)
            d1e = range1(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("i4_dev_mapping_i1d","range not present",1)
!#endif
            d1s = lbound(array,1)
            d1e = ubound(array,1)
         endif
         !
         !
#if defined __DXL_CUDAF
         if (.not.allocated(array)) allocate( array(d1s:d1e) )
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC enter data create( array(d1s:d1e) ) wait
         !DEV_OMPGPU target enter data map(alloc: array )
#endif
      end subroutine i4_devxlib_mapping_map_i1d
      !
      module subroutine i4_devxlib_mapping_map_i2d(array, range1, &
                                            range2 )
         implicit none
         !
         integer(int32), allocatable DEV_ATTR, intent(inout) :: array(:,:)
         integer, optional, intent(in) ::  range1(2), range2(2)
         !
         integer :: i1, d1s, d1e
         integer :: i2, d2s, d2e
         !
         if (present(range1)) then
            d1s = range1(1)
            d1e = range1(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("i4_dev_mapping_i2d","range not present",1)
!#endif
            d1s = lbound(array,1)
            d1e = ubound(array,1)
         endif
         !
         if (present(range2)) then
            d2s = range2(1)
            d2e = range2(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("i4_dev_mapping_i2d","range not present",2)
!#endif
            d2s = lbound(array,2)
            d2e = ubound(array,2)
         endif
         !
         !
#if defined __DXL_CUDAF
         if (.not.allocated(array)) allocate( array(d1s:d1e,d2s:d2e) )
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC enter data create( array(d1s:d1e,d2s:d2e) ) wait
         !DEV_OMPGPU target enter data map(alloc: array )
#endif
      end subroutine i4_devxlib_mapping_map_i2d
      !
      module subroutine i4_devxlib_mapping_map_i3d(array, range1, &
                                            range2, &
                                            range3 )
         implicit none
         !
         integer(int32), allocatable DEV_ATTR, intent(inout) :: array(:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
         !
         integer :: i1, d1s, d1e
         integer :: i2, d2s, d2e
         integer :: i3, d3s, d3e
         !
         if (present(range1)) then
            d1s = range1(1)
            d1e = range1(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("i4_dev_mapping_i3d","range not present",1)
!#endif
            d1s = lbound(array,1)
            d1e = ubound(array,1)
         endif
         !
         if (present(range2)) then
            d2s = range2(1)
            d2e = range2(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("i4_dev_mapping_i3d","range not present",2)
!#endif
            d2s = lbound(array,2)
            d2e = ubound(array,2)
         endif
         !
         if (present(range3)) then
            d3s = range3(1)
            d3e = range3(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("i4_dev_mapping_i3d","range not present",3)
!#endif
            d3s = lbound(array,3)
            d3e = ubound(array,3)
         endif
         !
         !
#if defined __DXL_CUDAF
         if (.not.allocated(array)) allocate( array(d1s:d1e,d2s:d2e,d3s:d3e) )
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC enter data create( array(d1s:d1e,d2s:d2e,d3s:d3e) ) wait
         !DEV_OMPGPU target enter data map(alloc: array )
#endif
      end subroutine i4_devxlib_mapping_map_i3d
      !
      module subroutine i4_devxlib_mapping_map_i4d(array, range1, &
                                            range2, &
                                            range3, &
                                            range4 )
         implicit none
         !
         integer(int32), allocatable DEV_ATTR, intent(inout) :: array(:,:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
         !
         integer :: i1, d1s, d1e
         integer :: i2, d2s, d2e
         integer :: i3, d3s, d3e
         integer :: i4, d4s, d4e
         !
         if (present(range1)) then
            d1s = range1(1)
            d1e = range1(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("i4_dev_mapping_i4d","range not present",1)
!#endif
            d1s = lbound(array,1)
            d1e = ubound(array,1)
         endif
         !
         if (present(range2)) then
            d2s = range2(1)
            d2e = range2(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("i4_dev_mapping_i4d","range not present",2)
!#endif
            d2s = lbound(array,2)
            d2e = ubound(array,2)
         endif
         !
         if (present(range3)) then
            d3s = range3(1)
            d3e = range3(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("i4_dev_mapping_i4d","range not present",3)
!#endif
            d3s = lbound(array,3)
            d3e = ubound(array,3)
         endif
         !
         if (present(range4)) then
            d4s = range4(1)
            d4e = range4(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("i4_dev_mapping_i4d","range not present",4)
!#endif
            d4s = lbound(array,4)
            d4e = ubound(array,4)
         endif
         !
         !
#if defined __DXL_CUDAF
         if (.not.allocated(array)) allocate( array(d1s:d1e,d2s:d2e,d3s:d3e,d4s:d4e) )
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC enter data create( array(d1s:d1e,d2s:d2e,d3s:d3e,d4s:d4e) ) wait
         !DEV_OMPGPU target enter data map(alloc: array )
#endif
      end subroutine i4_devxlib_mapping_map_i4d
      !
      module subroutine i4_devxlib_mapping_map_i5d(array, range1, &
                                            range2, &
                                            range3, &
                                            range4, &
                                            range5 )
         implicit none
         !
         integer(int32), allocatable DEV_ATTR, intent(inout) :: array(:,:,:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2)
         !
         integer :: i1, d1s, d1e
         integer :: i2, d2s, d2e
         integer :: i3, d3s, d3e
         integer :: i4, d4s, d4e
         integer :: i5, d5s, d5e
         !
         if (present(range1)) then
            d1s = range1(1)
            d1e = range1(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("i4_dev_mapping_i5d","range not present",1)
!#endif
            d1s = lbound(array,1)
            d1e = ubound(array,1)
         endif
         !
         if (present(range2)) then
            d2s = range2(1)
            d2e = range2(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("i4_dev_mapping_i5d","range not present",2)
!#endif
            d2s = lbound(array,2)
            d2e = ubound(array,2)
         endif
         !
         if (present(range3)) then
            d3s = range3(1)
            d3e = range3(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("i4_dev_mapping_i5d","range not present",3)
!#endif
            d3s = lbound(array,3)
            d3e = ubound(array,3)
         endif
         !
         if (present(range4)) then
            d4s = range4(1)
            d4e = range4(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("i4_dev_mapping_i5d","range not present",4)
!#endif
            d4s = lbound(array,4)
            d4e = ubound(array,4)
         endif
         !
         if (present(range5)) then
            d5s = range5(1)
            d5e = range5(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("i4_dev_mapping_i5d","range not present",5)
!#endif
            d5s = lbound(array,5)
            d5e = ubound(array,5)
         endif
         !
         !
#if defined __DXL_CUDAF
         if (.not.allocated(array)) allocate( array(d1s:d1e,d2s:d2e,d3s:d3e,d4s:d4e,d5s:d5e) )
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC enter data create( array(d1s:d1e,d2s:d2e,d3s:d3e,d4s:d4e,d5s:d5e) ) wait
         !DEV_OMPGPU target enter data map(alloc: array )
#endif
      end subroutine i4_devxlib_mapping_map_i5d
      !
      module subroutine i4_devxlib_mapping_map_i6d(array, range1, &
                                            range2, &
                                            range3, &
                                            range4, &
                                            range5, &
                                            range6 )
         implicit none
         !
         integer(int32), allocatable DEV_ATTR, intent(inout) :: array(:,:,:,:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2), range6(2)
         !
         integer :: i1, d1s, d1e
         integer :: i2, d2s, d2e
         integer :: i3, d3s, d3e
         integer :: i4, d4s, d4e
         integer :: i5, d5s, d5e
         integer :: i6, d6s, d6e
         !
         if (present(range1)) then
            d1s = range1(1)
            d1e = range1(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("i4_dev_mapping_i6d","range not present",1)
!#endif
            d1s = lbound(array,1)
            d1e = ubound(array,1)
         endif
         !
         if (present(range2)) then
            d2s = range2(1)
            d2e = range2(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("i4_dev_mapping_i6d","range not present",2)
!#endif
            d2s = lbound(array,2)
            d2e = ubound(array,2)
         endif
         !
         if (present(range3)) then
            d3s = range3(1)
            d3e = range3(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("i4_dev_mapping_i6d","range not present",3)
!#endif
            d3s = lbound(array,3)
            d3e = ubound(array,3)
         endif
         !
         if (present(range4)) then
            d4s = range4(1)
            d4e = range4(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("i4_dev_mapping_i6d","range not present",4)
!#endif
            d4s = lbound(array,4)
            d4e = ubound(array,4)
         endif
         !
         if (present(range5)) then
            d5s = range5(1)
            d5e = range5(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("i4_dev_mapping_i6d","range not present",5)
!#endif
            d5s = lbound(array,5)
            d5e = ubound(array,5)
         endif
         !
         if (present(range6)) then
            d6s = range6(1)
            d6e = range6(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("i4_dev_mapping_i6d","range not present",6)
!#endif
            d6s = lbound(array,6)
            d6e = ubound(array,6)
         endif
         !
         !
#if defined __DXL_CUDAF
         if (.not.allocated(array)) allocate( array(d1s:d1e,d2s:d2e,d3s:d3e,d4s:d4e,d5s:d5e,d6s:d6e) )
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC enter data create( array(d1s:d1e,d2s:d2e,d3s:d3e,d4s:d4e,d5s:d5e,d6s:d6e) ) wait
         !DEV_OMPGPU target enter data map(alloc: array )
#endif
      end subroutine i4_devxlib_mapping_map_i6d
      !
      module subroutine i8_devxlib_mapping_map_i1d(array, range1 )
         implicit none
         !
         integer(int64), allocatable DEV_ATTR, intent(inout) :: array(:)
         integer, optional, intent(in) ::  range1(2)
         !
         integer :: i1, d1s, d1e
         !
         if (present(range1)) then
            d1s = range1(1)
            d1e = range1(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("i8_dev_mapping_i1d","range not present",1)
!#endif
            d1s = lbound(array,1)
            d1e = ubound(array,1)
         endif
         !
         !
#if defined __DXL_CUDAF
         if (.not.allocated(array)) allocate( array(d1s:d1e) )
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC enter data create( array(d1s:d1e) ) wait
         !DEV_OMPGPU target enter data map(alloc: array )
#endif
      end subroutine i8_devxlib_mapping_map_i1d
      !
      module subroutine i8_devxlib_mapping_map_i2d(array, range1, &
                                            range2 )
         implicit none
         !
         integer(int64), allocatable DEV_ATTR, intent(inout) :: array(:,:)
         integer, optional, intent(in) ::  range1(2), range2(2)
         !
         integer :: i1, d1s, d1e
         integer :: i2, d2s, d2e
         !
         if (present(range1)) then
            d1s = range1(1)
            d1e = range1(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("i8_dev_mapping_i2d","range not present",1)
!#endif
            d1s = lbound(array,1)
            d1e = ubound(array,1)
         endif
         !
         if (present(range2)) then
            d2s = range2(1)
            d2e = range2(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("i8_dev_mapping_i2d","range not present",2)
!#endif
            d2s = lbound(array,2)
            d2e = ubound(array,2)
         endif
         !
         !
#if defined __DXL_CUDAF
         if (.not.allocated(array)) allocate( array(d1s:d1e,d2s:d2e) )
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC enter data create( array(d1s:d1e,d2s:d2e) ) wait
         !DEV_OMPGPU target enter data map(alloc: array )
#endif
      end subroutine i8_devxlib_mapping_map_i2d
      !
      module subroutine i8_devxlib_mapping_map_i3d(array, range1, &
                                            range2, &
                                            range3 )
         implicit none
         !
         integer(int64), allocatable DEV_ATTR, intent(inout) :: array(:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
         !
         integer :: i1, d1s, d1e
         integer :: i2, d2s, d2e
         integer :: i3, d3s, d3e
         !
         if (present(range1)) then
            d1s = range1(1)
            d1e = range1(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("i8_dev_mapping_i3d","range not present",1)
!#endif
            d1s = lbound(array,1)
            d1e = ubound(array,1)
         endif
         !
         if (present(range2)) then
            d2s = range2(1)
            d2e = range2(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("i8_dev_mapping_i3d","range not present",2)
!#endif
            d2s = lbound(array,2)
            d2e = ubound(array,2)
         endif
         !
         if (present(range3)) then
            d3s = range3(1)
            d3e = range3(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("i8_dev_mapping_i3d","range not present",3)
!#endif
            d3s = lbound(array,3)
            d3e = ubound(array,3)
         endif
         !
         !
#if defined __DXL_CUDAF
         if (.not.allocated(array)) allocate( array(d1s:d1e,d2s:d2e,d3s:d3e) )
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC enter data create( array(d1s:d1e,d2s:d2e,d3s:d3e) ) wait
         !DEV_OMPGPU target enter data map(alloc: array )
#endif
      end subroutine i8_devxlib_mapping_map_i3d
      !
      module subroutine i8_devxlib_mapping_map_i4d(array, range1, &
                                            range2, &
                                            range3, &
                                            range4 )
         implicit none
         !
         integer(int64), allocatable DEV_ATTR, intent(inout) :: array(:,:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
         !
         integer :: i1, d1s, d1e
         integer :: i2, d2s, d2e
         integer :: i3, d3s, d3e
         integer :: i4, d4s, d4e
         !
         if (present(range1)) then
            d1s = range1(1)
            d1e = range1(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("i8_dev_mapping_i4d","range not present",1)
!#endif
            d1s = lbound(array,1)
            d1e = ubound(array,1)
         endif
         !
         if (present(range2)) then
            d2s = range2(1)
            d2e = range2(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("i8_dev_mapping_i4d","range not present",2)
!#endif
            d2s = lbound(array,2)
            d2e = ubound(array,2)
         endif
         !
         if (present(range3)) then
            d3s = range3(1)
            d3e = range3(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("i8_dev_mapping_i4d","range not present",3)
!#endif
            d3s = lbound(array,3)
            d3e = ubound(array,3)
         endif
         !
         if (present(range4)) then
            d4s = range4(1)
            d4e = range4(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("i8_dev_mapping_i4d","range not present",4)
!#endif
            d4s = lbound(array,4)
            d4e = ubound(array,4)
         endif
         !
         !
#if defined __DXL_CUDAF
         if (.not.allocated(array)) allocate( array(d1s:d1e,d2s:d2e,d3s:d3e,d4s:d4e) )
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC enter data create( array(d1s:d1e,d2s:d2e,d3s:d3e,d4s:d4e) ) wait
         !DEV_OMPGPU target enter data map(alloc: array )
#endif
      end subroutine i8_devxlib_mapping_map_i4d
      !
      module subroutine i8_devxlib_mapping_map_i5d(array, range1, &
                                            range2, &
                                            range3, &
                                            range4, &
                                            range5 )
         implicit none
         !
         integer(int64), allocatable DEV_ATTR, intent(inout) :: array(:,:,:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2)
         !
         integer :: i1, d1s, d1e
         integer :: i2, d2s, d2e
         integer :: i3, d3s, d3e
         integer :: i4, d4s, d4e
         integer :: i5, d5s, d5e
         !
         if (present(range1)) then
            d1s = range1(1)
            d1e = range1(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("i8_dev_mapping_i5d","range not present",1)
!#endif
            d1s = lbound(array,1)
            d1e = ubound(array,1)
         endif
         !
         if (present(range2)) then
            d2s = range2(1)
            d2e = range2(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("i8_dev_mapping_i5d","range not present",2)
!#endif
            d2s = lbound(array,2)
            d2e = ubound(array,2)
         endif
         !
         if (present(range3)) then
            d3s = range3(1)
            d3e = range3(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("i8_dev_mapping_i5d","range not present",3)
!#endif
            d3s = lbound(array,3)
            d3e = ubound(array,3)
         endif
         !
         if (present(range4)) then
            d4s = range4(1)
            d4e = range4(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("i8_dev_mapping_i5d","range not present",4)
!#endif
            d4s = lbound(array,4)
            d4e = ubound(array,4)
         endif
         !
         if (present(range5)) then
            d5s = range5(1)
            d5e = range5(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("i8_dev_mapping_i5d","range not present",5)
!#endif
            d5s = lbound(array,5)
            d5e = ubound(array,5)
         endif
         !
         !
#if defined __DXL_CUDAF
         if (.not.allocated(array)) allocate( array(d1s:d1e,d2s:d2e,d3s:d3e,d4s:d4e,d5s:d5e) )
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC enter data create( array(d1s:d1e,d2s:d2e,d3s:d3e,d4s:d4e,d5s:d5e) ) wait
         !DEV_OMPGPU target enter data map(alloc: array )
#endif
      end subroutine i8_devxlib_mapping_map_i5d
      !
      module subroutine i8_devxlib_mapping_map_i6d(array, range1, &
                                            range2, &
                                            range3, &
                                            range4, &
                                            range5, &
                                            range6 )
         implicit none
         !
         integer(int64), allocatable DEV_ATTR, intent(inout) :: array(:,:,:,:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2), range6(2)
         !
         integer :: i1, d1s, d1e
         integer :: i2, d2s, d2e
         integer :: i3, d3s, d3e
         integer :: i4, d4s, d4e
         integer :: i5, d5s, d5e
         integer :: i6, d6s, d6e
         !
         if (present(range1)) then
            d1s = range1(1)
            d1e = range1(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("i8_dev_mapping_i6d","range not present",1)
!#endif
            d1s = lbound(array,1)
            d1e = ubound(array,1)
         endif
         !
         if (present(range2)) then
            d2s = range2(1)
            d2e = range2(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("i8_dev_mapping_i6d","range not present",2)
!#endif
            d2s = lbound(array,2)
            d2e = ubound(array,2)
         endif
         !
         if (present(range3)) then
            d3s = range3(1)
            d3e = range3(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("i8_dev_mapping_i6d","range not present",3)
!#endif
            d3s = lbound(array,3)
            d3e = ubound(array,3)
         endif
         !
         if (present(range4)) then
            d4s = range4(1)
            d4e = range4(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("i8_dev_mapping_i6d","range not present",4)
!#endif
            d4s = lbound(array,4)
            d4e = ubound(array,4)
         endif
         !
         if (present(range5)) then
            d5s = range5(1)
            d5e = range5(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("i8_dev_mapping_i6d","range not present",5)
!#endif
            d5s = lbound(array,5)
            d5e = ubound(array,5)
         endif
         !
         if (present(range6)) then
            d6s = range6(1)
            d6e = range6(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("i8_dev_mapping_i6d","range not present",6)
!#endif
            d6s = lbound(array,6)
            d6e = ubound(array,6)
         endif
         !
         !
#if defined __DXL_CUDAF
         if (.not.allocated(array)) allocate( array(d1s:d1e,d2s:d2e,d3s:d3e,d4s:d4e,d5s:d5e,d6s:d6e) )
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC enter data create( array(d1s:d1e,d2s:d2e,d3s:d3e,d4s:d4e,d5s:d5e,d6s:d6e) ) wait
         !DEV_OMPGPU target enter data map(alloc: array )
#endif
      end subroutine i8_devxlib_mapping_map_i6d
      !
      module subroutine l4_devxlib_mapping_map_l1d(array, range1 )
         implicit none
         !
         logical(int32), allocatable DEV_ATTR, intent(inout) :: array(:)
         integer, optional, intent(in) ::  range1(2)
         !
         integer :: i1, d1s, d1e
         !
         if (present(range1)) then
            d1s = range1(1)
            d1e = range1(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("l4_dev_mapping_l1d","range not present",1)
!#endif
            d1s = lbound(array,1)
            d1e = ubound(array,1)
         endif
         !
         !
#if defined __DXL_CUDAF
         if (.not.allocated(array)) allocate( array(d1s:d1e) )
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC enter data create( array(d1s:d1e) ) wait
         !DEV_OMPGPU target enter data map(alloc: array )
#endif
      end subroutine l4_devxlib_mapping_map_l1d
      !
      module subroutine l4_devxlib_mapping_map_l2d(array, range1, &
                                            range2 )
         implicit none
         !
         logical(int32), allocatable DEV_ATTR, intent(inout) :: array(:,:)
         integer, optional, intent(in) ::  range1(2), range2(2)
         !
         integer :: i1, d1s, d1e
         integer :: i2, d2s, d2e
         !
         if (present(range1)) then
            d1s = range1(1)
            d1e = range1(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("l4_dev_mapping_l2d","range not present",1)
!#endif
            d1s = lbound(array,1)
            d1e = ubound(array,1)
         endif
         !
         if (present(range2)) then
            d2s = range2(1)
            d2e = range2(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("l4_dev_mapping_l2d","range not present",2)
!#endif
            d2s = lbound(array,2)
            d2e = ubound(array,2)
         endif
         !
         !
#if defined __DXL_CUDAF
         if (.not.allocated(array)) allocate( array(d1s:d1e,d2s:d2e) )
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC enter data create( array(d1s:d1e,d2s:d2e) ) wait
         !DEV_OMPGPU target enter data map(alloc: array )
#endif
      end subroutine l4_devxlib_mapping_map_l2d
      !
      module subroutine l4_devxlib_mapping_map_l3d(array, range1, &
                                            range2, &
                                            range3 )
         implicit none
         !
         logical(int32), allocatable DEV_ATTR, intent(inout) :: array(:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
         !
         integer :: i1, d1s, d1e
         integer :: i2, d2s, d2e
         integer :: i3, d3s, d3e
         !
         if (present(range1)) then
            d1s = range1(1)
            d1e = range1(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("l4_dev_mapping_l3d","range not present",1)
!#endif
            d1s = lbound(array,1)
            d1e = ubound(array,1)
         endif
         !
         if (present(range2)) then
            d2s = range2(1)
            d2e = range2(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("l4_dev_mapping_l3d","range not present",2)
!#endif
            d2s = lbound(array,2)
            d2e = ubound(array,2)
         endif
         !
         if (present(range3)) then
            d3s = range3(1)
            d3e = range3(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("l4_dev_mapping_l3d","range not present",3)
!#endif
            d3s = lbound(array,3)
            d3e = ubound(array,3)
         endif
         !
         !
#if defined __DXL_CUDAF
         if (.not.allocated(array)) allocate( array(d1s:d1e,d2s:d2e,d3s:d3e) )
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC enter data create( array(d1s:d1e,d2s:d2e,d3s:d3e) ) wait
         !DEV_OMPGPU target enter data map(alloc: array )
#endif
      end subroutine l4_devxlib_mapping_map_l3d
      !
      module subroutine l4_devxlib_mapping_map_l4d(array, range1, &
                                            range2, &
                                            range3, &
                                            range4 )
         implicit none
         !
         logical(int32), allocatable DEV_ATTR, intent(inout) :: array(:,:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
         !
         integer :: i1, d1s, d1e
         integer :: i2, d2s, d2e
         integer :: i3, d3s, d3e
         integer :: i4, d4s, d4e
         !
         if (present(range1)) then
            d1s = range1(1)
            d1e = range1(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("l4_dev_mapping_l4d","range not present",1)
!#endif
            d1s = lbound(array,1)
            d1e = ubound(array,1)
         endif
         !
         if (present(range2)) then
            d2s = range2(1)
            d2e = range2(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("l4_dev_mapping_l4d","range not present",2)
!#endif
            d2s = lbound(array,2)
            d2e = ubound(array,2)
         endif
         !
         if (present(range3)) then
            d3s = range3(1)
            d3e = range3(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("l4_dev_mapping_l4d","range not present",3)
!#endif
            d3s = lbound(array,3)
            d3e = ubound(array,3)
         endif
         !
         if (present(range4)) then
            d4s = range4(1)
            d4e = range4(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("l4_dev_mapping_l4d","range not present",4)
!#endif
            d4s = lbound(array,4)
            d4e = ubound(array,4)
         endif
         !
         !
#if defined __DXL_CUDAF
         if (.not.allocated(array)) allocate( array(d1s:d1e,d2s:d2e,d3s:d3e,d4s:d4e) )
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC enter data create( array(d1s:d1e,d2s:d2e,d3s:d3e,d4s:d4e) ) wait
         !DEV_OMPGPU target enter data map(alloc: array )
#endif
      end subroutine l4_devxlib_mapping_map_l4d
      !
      module subroutine l4_devxlib_mapping_map_l5d(array, range1, &
                                            range2, &
                                            range3, &
                                            range4, &
                                            range5 )
         implicit none
         !
         logical(int32), allocatable DEV_ATTR, intent(inout) :: array(:,:,:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2)
         !
         integer :: i1, d1s, d1e
         integer :: i2, d2s, d2e
         integer :: i3, d3s, d3e
         integer :: i4, d4s, d4e
         integer :: i5, d5s, d5e
         !
         if (present(range1)) then
            d1s = range1(1)
            d1e = range1(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("l4_dev_mapping_l5d","range not present",1)
!#endif
            d1s = lbound(array,1)
            d1e = ubound(array,1)
         endif
         !
         if (present(range2)) then
            d2s = range2(1)
            d2e = range2(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("l4_dev_mapping_l5d","range not present",2)
!#endif
            d2s = lbound(array,2)
            d2e = ubound(array,2)
         endif
         !
         if (present(range3)) then
            d3s = range3(1)
            d3e = range3(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("l4_dev_mapping_l5d","range not present",3)
!#endif
            d3s = lbound(array,3)
            d3e = ubound(array,3)
         endif
         !
         if (present(range4)) then
            d4s = range4(1)
            d4e = range4(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("l4_dev_mapping_l5d","range not present",4)
!#endif
            d4s = lbound(array,4)
            d4e = ubound(array,4)
         endif
         !
         if (present(range5)) then
            d5s = range5(1)
            d5e = range5(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("l4_dev_mapping_l5d","range not present",5)
!#endif
            d5s = lbound(array,5)
            d5e = ubound(array,5)
         endif
         !
         !
#if defined __DXL_CUDAF
         if (.not.allocated(array)) allocate( array(d1s:d1e,d2s:d2e,d3s:d3e,d4s:d4e,d5s:d5e) )
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC enter data create( array(d1s:d1e,d2s:d2e,d3s:d3e,d4s:d4e,d5s:d5e) ) wait
         !DEV_OMPGPU target enter data map(alloc: array )
#endif
      end subroutine l4_devxlib_mapping_map_l5d
      !
      module subroutine l4_devxlib_mapping_map_l6d(array, range1, &
                                            range2, &
                                            range3, &
                                            range4, &
                                            range5, &
                                            range6 )
         implicit none
         !
         logical(int32), allocatable DEV_ATTR, intent(inout) :: array(:,:,:,:,:,:)
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2), range6(2)
         !
         integer :: i1, d1s, d1e
         integer :: i2, d2s, d2e
         integer :: i3, d3s, d3e
         integer :: i4, d4s, d4e
         integer :: i5, d5s, d5e
         integer :: i6, d6s, d6e
         !
         if (present(range1)) then
            d1s = range1(1)
            d1e = range1(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("l4_dev_mapping_l6d","range not present",1)
!#endif
            d1s = lbound(array,1)
            d1e = ubound(array,1)
         endif
         !
         if (present(range2)) then
            d2s = range2(1)
            d2e = range2(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("l4_dev_mapping_l6d","range not present",2)
!#endif
            d2s = lbound(array,2)
            d2e = ubound(array,2)
         endif
         !
         if (present(range3)) then
            d3s = range3(1)
            d3e = range3(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("l4_dev_mapping_l6d","range not present",3)
!#endif
            d3s = lbound(array,3)
            d3e = ubound(array,3)
         endif
         !
         if (present(range4)) then
            d4s = range4(1)
            d4e = range4(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("l4_dev_mapping_l6d","range not present",4)
!#endif
            d4s = lbound(array,4)
            d4e = ubound(array,4)
         endif
         !
         if (present(range5)) then
            d5s = range5(1)
            d5e = range5(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("l4_dev_mapping_l6d","range not present",5)
!#endif
            d5s = lbound(array,5)
            d5e = ubound(array,5)
         endif
         !
         if (present(range6)) then
            d6s = range6(1)
            d6e = range6(2)
         else
!#if defined __DXL_CUDAF
!            call devxlib_error("l4_dev_mapping_l6d","range not present",6)
!#endif
            d6s = lbound(array,6)
            d6e = ubound(array,6)
         endif
         !
         !
#if defined __DXL_CUDAF
         if (.not.allocated(array)) allocate( array(d1s:d1e,d2s:d2e,d3s:d3e,d4s:d4e,d5s:d5e,d6s:d6e) )
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC enter data create( array(d1s:d1e,d2s:d2e,d3s:d3e,d4s:d4e,d5s:d5e,d6s:d6e) ) wait
         !DEV_OMPGPU target enter data map(alloc: array )
#endif
      end subroutine l4_devxlib_mapping_map_l6d
      !

endsubmodule devxlib_mapping_map

!
! interface to timing routines
!
module timer_m
  use iso_c_binding
  implicit none
  private
 
  interface 
    function wallclock() bind(C,name="wallclock_c")
       use iso_c_binding, only: c_double
       real(c_double) :: wallclock
    end function
  end interface

  public :: wallclock

end module timer_m

!
! Copyright (C) 2022, MaX CoE
! Distributed under the MIT License 
! (license terms are at http://opensource.org/licenses/MIT).
!
!--
!
! F-wrappers for selected acc functions
!
module openacc_m
  use iso_c_binding

#if defined __DXL_OPENACC

  interface
    !
    function acc_get_cuda_stream(async) &
        result(stream) bind(c, name="acc_get_cuda_stream")
      import c_int, c_intptr_t
      integer(c_intptr_t) :: stream
      integer(c_int) :: async
    end function acc_get_cuda_stream
    !
  end interface

#else
  integer :: acc_dummy  
#endif

end module

!
! Copyright (C) 2021, MaX CoE
! Distributed under the MIT License
! (license terms are at http://opensource.org/licenses/MIT).
!
!--
!
! Wrappers for selected Linear Algebra subroutines
!
#include<devxlib_defs.h>
#include<devxlib_macros.h>
!
#ifdef __DXL_HAVE_DEVICE
  !
  ! checks
  !
#if ! defined __DXL_CUBLAS && ! defined __DXL_ROCBLAS && ! defined __DXL_MKL_GPU
# error
#endif
#endif

submodule (devxlib_linalg) devxlib_linalg_gemm

   implicit none

   contains

   module subroutine dev_SGEMM_gpu(TRANSA,TRANSB,M,N,K,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
      implicit none
      real(real32),  target, intent(in) :: ALPHA,BETA
      integer,           intent(in) :: K,LDA,LDB,LDC,M,N
      character,         intent(in) :: TRANSA,TRANSB
      real(real32),  target, intent(in) DEV_ATTR :: A(:,:),B(:,:)
      real(real32),  target             DEV_ATTR :: C(:,:)
      !
#if defined __DXL_ROCBLAS
      integer(c_int) :: itransa, itransb
#else
      character(c_char) :: transa_,transb_
#endif
      integer :: ierr
      !
#if defined __DXL_ROCBLAS
      itransa = rocblas_get_operation(TRANSA)
      itransb = rocblas_get_operation(TRANSB)
#else
      transa_=TRANSA
      transb_=TRANSB
#endif
      !
      call acc_loc_dev_sync()
      !
      !DEV_ACC_DEBUG data present(A,B,C)
      !DEV_ACC host_data use_device(A,B,C)
#if defined __DXL_CUBLAS
      call cublasSgemm(transa_,transb_,M,N,K,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
#elif defined __DXL_ROCBLAS
      !DEV_OMPGPU target data use_device_ptr(A,B,C)
      ierr=rocblas_sgemm(handle,itransa,itransb,M,N,K,c_loc(ALPHA),c_loc(A),LDA,c_loc(B),LDB,c_loc(BETA),c_loc(C),LDC)
      !DEV_OMPGPU end target data
#elif defined __DXL_MKL_GPU
      !DEV_OMPGPU target data use_device_addr(A,B,C)
      !DEV_OMPGPU dispatch
      call SGEMM(transa,transb,M,N,K,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
      !DEV_OMPGPU end dispatch
      !DEV_OMPGPU end target data
#else
      call SGEMM(transa,transb,M,N,K,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
#endif
      !DEV_ACC end host_data
      !DEV_ACC_DEBUG end data
      !
      call acc_loc_dev_sync()
      !
   end subroutine dev_SGEMM_gpu
   !
   module subroutine dev_DGEMM_gpu(TRANSA,TRANSB,M,N,K,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
      implicit none
      real(real64),  target, intent(in) :: ALPHA,BETA
      integer,           intent(in) :: K,LDA,LDB,LDC,M,N
      character,         intent(in) :: TRANSA,TRANSB
      real(real64),  target, intent(in) DEV_ATTR :: A(:,:),B(:,:)
      real(real64),  target             DEV_ATTR :: C(:,:)
      !
#if defined __DXL_ROCBLAS
      integer :: itransa, itransb
#else
      character(c_char) :: transa_,transb_
#endif
      integer :: ierr
      !
#if defined __DXL_ROCBLAS
      itransa = rocblas_get_operation(TRANSA)
      itransb = rocblas_get_operation(TRANSB)
#else
      transa_=TRANSA
      transb_=TRANSB
#endif
      !
      call acc_loc_dev_sync()
      !
      !DEV_ACC_DEBUG data present(A,B,C)
      !DEV_ACC host_data use_device(A,B,C)
#if defined __DXL_CUBLAS
      call cublasDgemm(transa_,transb_,M,N,K,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
#elif defined __DXL_ROCBLAS
      !DEV_OMPGPU target data use_device_ptr(A,B,C)
      ierr=rocblas_dgemm(handle,itransa,itransb,M,N,K,c_loc(ALPHA),c_loc(A),LDA,c_loc(B),LDB,c_loc(BETA),c_loc(C),LDC)
      !DEV_OMPGPU end target data
#elif defined __DXL_MKL_GPU
      !DEV_OMPGPU target data use_device_addr(A,B,C)
      !DEV_OMPGPU dispatch
      call DGEMM(transa,transb,M,N,K,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
      !DEV_OMPGPU end dispatch
      !DEV_OMPGPU end target data
#else
      call DGEMM(transa,transb,M,N,K,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
#endif
      !DEV_ACC end host_data
      !DEV_ACC_DEBUG end data
      !
      call acc_loc_dev_sync()
      !
   end subroutine dev_DGEMM_gpu
   !
   module subroutine dev_CGEMM_gpu(TRANSA,TRANSB,M,N,K,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
      implicit none
      complex(real32), target, intent(in) :: ALPHA,BETA
      integer,             intent(in) :: K,LDA,LDB,LDC,M,N
      character,           intent(in) :: TRANSA,TRANSB
      complex(real32), target, intent(in) DEV_ATTR :: A(:,:),B(:,:)
      complex(real32), target             DEV_ATTR :: C(:,:)
      !
#if defined __DXL_ROCBLAS
      integer :: itransa, itransb
#else
      character(c_char) :: transa_,transb_
#endif

      integer :: ierr
      !
#if defined __DXL_ROCBLAS
      itransa = rocblas_get_operation(TRANSA)
      itransb = rocblas_get_operation(TRANSB)
#else
      transa_=TRANSA
      transb_=TRANSB
#endif
      !
      call acc_loc_dev_sync()
      !
      !DEV_ACC_DEBUG data present(A,B,C)
      !DEV_ACC host_data use_device(A,B,C)
#if defined __DXL_CUBLAS
      call cublasCgemm(transa_,transb_,M,N,K,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
#elif defined __DXL_ROCBLAS
      !DEV_OMPGPU target data use_device_ptr(A,B,C)
      ierr=rocblas_cgemm(handle,itransa,itransb,M,N,K,c_loc(ALPHA),c_loc(A),LDA,c_loc(B),LDB,c_loc(BETA),c_loc(C),LDC)
      !DEV_OMPGPU end target data
#elif defined __DXL_MKL_GPU
      !DEV_OMPGPU target data use_device_addr(A,B,C)
      !DEV_OMPGPU dispatch
      call CGEMM(TRANSA,TRANSB,M,N,K,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
      !DEV_OMPGPU end dispatch
      !DEV_OMPGPU end target data
#else
      call CGEMM(TRANSA,TRANSB,M,N,K,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
#endif
      !DEV_ACC end host_data
      !DEV_ACC_DEBUG end data
      !
      call acc_loc_dev_sync()
      !
   end subroutine dev_CGEMM_gpu
   !
   module subroutine dev_ZGEMM_gpu(TRANSA,TRANSB,M,N,K,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
      implicit none
      complex(real64), target, intent(in) :: ALPHA,BETA
      integer,             intent(in) :: K,LDA,LDB,LDC,M,N
      character,           intent(in) :: TRANSA,TRANSB
      complex(real64), target, intent(in) DEV_ATTR :: A(:,:),B(:,:)
      complex(real64), target             DEV_ATTR :: C(:,:)
      !
#if defined __DXL_ROCBLAS
      integer :: itransa, itransb
#else
      character(c_char) :: transa_,transb_
#endif

      integer :: ierr
      !
#if defined __DXL_ROCBLAS
      itransa = rocblas_get_operation(TRANSA)
      itransb = rocblas_get_operation(TRANSB)
#else
      transa_=TRANSA
      transb_=TRANSB
#endif
      !
      call acc_loc_dev_sync()
      !
      !DEV_ACC_DEBUG data present(A,B,C)
      !DEV_ACC host_data use_device(A,B,C)
#if defined __DXL_CUBLAS
      call cublasZgemm(transa_,transb_,M,N,K,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
#elif defined __DXL_ROCBLAS
      !DEV_OMPGPU target data use_device_ptr(A,B,C)
      ierr=rocblas_zgemm(handle,itransa,itransb,M,N,K,c_loc(ALPHA),c_loc(A),LDA,c_loc(B),LDB,c_loc(BETA),c_loc(C),LDC)
      !DEV_OMPGPU end target data
#elif defined __DXL_MKL_GPU
      !DEV_OMPGPU target data use_device_addr(A,B,C)
      !DEV_OMPGPU dispatch
      call ZGEMM(TRANSA,TRANSB,M,N,K,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
      !DEV_OMPGPU end dispatch
      !DEV_OMPGPU end target data
#else
      call ZGEMM(TRANSA,TRANSB,M,N,K,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
#endif
      !DEV_ACC end host_data
      !DEV_ACC_DEBUG end data
      !
      call acc_loc_dev_sync()
      !
   end subroutine dev_ZGEMM_gpu
   !
end submodule devxlib_linalg_gemm

!
! This file is part of FBUF - Fortran BUFfers For Accelerators
! Copyright 2018 Pietro Bonfa'
! License: GPLv2
!
!--
!
!==================================================================
!==================================================================
! *DO NOT EDIT*: automatically generated from devxlib_buffers.jf90
!==================================================================
!==================================================================
!
#include<devxlib_macros.h>
#include<devxlib_defs.h>
!
!> The **Buffers** module.
!
module devxlib_buffer
  !
#if defined(__DXL_CUDAF)
  use cudafor
#elif defined(__DXL_OPENACC)
  use openacc
#elif defined(__DXL_OPENMP_GPU)
  use omp_lib
#endif
  use iso_fortran_env, only : real64

  implicit none
  !
  integer, parameter :: LLI = selected_int_kind(15)

  TYPE :: Node
#if defined(__DXL_CUDAF)
     BYTE, POINTER , device  :: space(:)
#else
     BYTE, POINTER                 :: space(:)
#endif
     LOGICAL             :: locked
     TYPE(Node), POINTER :: Next
  END TYPE Node
  !
  private
  !
  TYPE(Node), POINTER  :: Head => null()
  !
  public :: devxlib_buffer_t
  !

!> The main **fbuf** class.
  type :: devxlib_buffer_t
     logical :: verbose = .false.
     !
   contains
     procedure :: init                     !< Initialize the class selecting buffers dimension and number per type.\
     final :: clean

     procedure :: reinit
     procedure :: dealloc

     generic, public :: lock_buffer => &
                        lock_buffer_iv, &           !< Releases a integer vector buffer
                        lock_buffer_im, &           !< Releases a integer matrix buffer
                        lock_buffer_it, &           !< Releases a integer tensor buffer
                        lock_buffer_if, &           !< Releases a integer four_dimensional buffer
                        lock_buffer_rv, &           !< Releases a real(real64) vector buffer
                        lock_buffer_rm, &           !< Releases a real(real64) matrix buffer
                        lock_buffer_rt, &           !< Releases a real(real64) tensor buffer
                        lock_buffer_rf, &           !< Releases a real(real64) four_dimensional buffer
                        lock_buffer_cv, &           !< Releases a complex(real64) vector buffer
                        lock_buffer_cm, &           !< Releases a complex(real64) matrix buffer
                        lock_buffer_ct, &           !< Releases a complex(real64) tensor buffer
                        lock_buffer_cf           !< Releases a complex(real64) four_dimensional buffer
     !
     procedure, private :: lock_buffer_iv           !< Releases a integer vector buffer
     procedure, private :: lock_buffer_im           !< Releases a integer matrix buffer
     procedure, private :: lock_buffer_it           !< Releases a integer tensor buffer
     procedure, private :: lock_buffer_if           !< Releases a integer four_dimensional buffer
     procedure, private :: lock_buffer_rv           !< Releases a real(real64) vector buffer
     procedure, private :: lock_buffer_rm           !< Releases a real(real64) matrix buffer
     procedure, private :: lock_buffer_rt           !< Releases a real(real64) tensor buffer
     procedure, private :: lock_buffer_rf           !< Releases a real(real64) four_dimensional buffer
     procedure, private :: lock_buffer_cv           !< Releases a complex(real64) vector buffer
     procedure, private :: lock_buffer_cm           !< Releases a complex(real64) matrix buffer
     procedure, private :: lock_buffer_ct           !< Releases a complex(real64) tensor buffer
     procedure, private :: lock_buffer_cf           !< Releases a complex(real64) four_dimensional buffer
     !
     generic, public :: release_buffer => &
                        release_buffer_iv, &        !< Releases a integer vector buffer
                        release_buffer_im, &        !< Releases a integer matrix buffer
                        release_buffer_it, &        !< Releases a integer tensor buffer
                        release_buffer_if, &        !< Releases a integer four_dimensional buffer
                        release_buffer_rv, &        !< Releases a real(real64) vector buffer
                        release_buffer_rm, &        !< Releases a real(real64) matrix buffer
                        release_buffer_rt, &        !< Releases a real(real64) tensor buffer
                        release_buffer_rf, &        !< Releases a real(real64) four_dimensional buffer
                        release_buffer_cv, &        !< Releases a complex(real64) vector buffer
                        release_buffer_cm, &        !< Releases a complex(real64) matrix buffer
                        release_buffer_ct, &        !< Releases a complex(real64) tensor buffer
                        release_buffer_cf        !< Releases a complex(real64) four_dimensional buffer
     !
     procedure, private :: release_buffer_iv           !< Releases a integer vector buffer
     procedure, private :: release_buffer_im           !< Releases a integer matrix buffer
     procedure, private :: release_buffer_it           !< Releases a integer tensor buffer
     procedure, private :: release_buffer_if           !< Releases a integer four_dimensional buffer
     procedure, private :: release_buffer_rv           !< Releases a real(real64) vector buffer
     procedure, private :: release_buffer_rm           !< Releases a real(real64) matrix buffer
     procedure, private :: release_buffer_rt           !< Releases a real(real64) tensor buffer
     procedure, private :: release_buffer_rf           !< Releases a real(real64) four_dimensional buffer
     procedure, private :: release_buffer_cv           !< Releases a complex(real64) vector buffer
     procedure, private :: release_buffer_cm           !< Releases a complex(real64) matrix buffer
     procedure, private :: release_buffer_ct           !< Releases a complex(real64) tensor buffer
     procedure, private :: release_buffer_cf           !< Releases a complex(real64) four_dimensional buffer
     !
     generic, public :: prepare_buffer => &
                        prepare_buffer_iv, &        !< Releases a integer vector buffer
                        prepare_buffer_im, &        !< Releases a integer matrix buffer
                        prepare_buffer_it, &        !< Releases a integer tensor buffer
                        prepare_buffer_if, &        !< Releases a integer four_dimensional buffer
                        prepare_buffer_rv, &        !< Releases a real(real64) vector buffer
                        prepare_buffer_rm, &        !< Releases a real(real64) matrix buffer
                        prepare_buffer_rt, &        !< Releases a real(real64) tensor buffer
                        prepare_buffer_rf, &        !< Releases a real(real64) four_dimensional buffer
                        prepare_buffer_cv, &        !< Releases a complex(real64) vector buffer
                        prepare_buffer_cm, &        !< Releases a complex(real64) matrix buffer
                        prepare_buffer_ct, &        !< Releases a complex(real64) tensor buffer
                        prepare_buffer_cf        !< Releases a complex(real64) four_dimensional buffer
     !
     procedure, private :: prepare_buffer_iv           !< Releases a integer vector buffer
     procedure, private :: prepare_buffer_im           !< Releases a integer matrix buffer
     procedure, private :: prepare_buffer_it           !< Releases a integer tensor buffer
     procedure, private :: prepare_buffer_if           !< Releases a integer four_dimensional buffer
     procedure, private :: prepare_buffer_rv           !< Releases a real(real64) vector buffer
     procedure, private :: prepare_buffer_rm           !< Releases a real(real64) matrix buffer
     procedure, private :: prepare_buffer_rt           !< Releases a real(real64) tensor buffer
     procedure, private :: prepare_buffer_rf           !< Releases a real(real64) four_dimensional buffer
     procedure, private :: prepare_buffer_cv           !< Releases a complex(real64) vector buffer
     procedure, private :: prepare_buffer_cm           !< Releases a complex(real64) matrix buffer
     procedure, private :: prepare_buffer_ct           !< Releases a complex(real64) tensor buffer
     procedure, private :: prepare_buffer_cf           !< Releases a complex(real64) four_dimensional buffer
     !
     procedure, private :: lock_space
     procedure, private :: prepare_space
     procedure, private :: release_space
     procedure, public  :: dump_status
     procedure, public  :: print_report
  end type

  
  
contains
  !> Initialize the class selecting the device type.
  subroutine init(this, info, verbose)
    use iso_c_binding
    implicit none
    class(devxlib_buffer_t),  intent(inout) :: this     !< The class.
    integer,       intent(out) :: info    !< Error reporting.
                                          !<  0: ok
                                          !< -1: generic error
    logical, optional, intent(in) :: verbose
    !
    this%verbose = .false.
    if (present(verbose)) this%verbose = verbose

    if (this%verbose) write (*, *) "[devxlib_buffer] Initializing buffers"
    NULLIFY (Head)
    info = 0
    !
  end subroutine init
  !
  subroutine clean(this)
    implicit none
    type(devxlib_buffer_t) :: this     !< The class.
    call this%dealloc()
  end subroutine clean
  !
  subroutine dealloc(this)
    use iso_c_binding
    implicit none
    class(devxlib_buffer_t) :: this     !< The class.
    integer :: i, info
    TYPE(Node), POINTER  :: temp
#if defined(__DXL_OPENMP_GPU)
    integer(c_int) :: omp_device
    type(c_ptr)    :: cloc
#endif
    i = 0
    DO WHILE (ASSOCIATED(head))
#if defined (__DXL_CUDAF)

        IF ( ASSOCIATED(head%space) ) DEALLOCATE(head%space)

#elif defined(__DXL_OPENMP_GPU)

        omp_device = omp_get_default_device()
        IF ( ASSOCIATED(head%space) ) THEN
           cloc = c_loc(head%space(1))
           call omp_target_free(cloc, omp_device)
        ENDIF

#else
        IF ( ASSOCIATED(head%space) ) DEALLOCATE(head%space)
#endif
        temp => head
        head => head%next
        DEALLOCATE(temp)
        i = i + 1
    END DO
    NULLIFY (Head)
    if (this%verbose) write (*, '("[devxlib_buffer] Cleaned ", I2, " buffers")') i
  end subroutine dealloc
  !
  subroutine reinit(this, info)
    use iso_c_binding
    implicit none
    class(devxlib_buffer_t), intent(inout)  :: this     !< The class.
    integer, intent(out) :: info !< 0 -> ok ; -n -> failed, n buffers still allocated
    integer :: l
    TYPE(Node), POINTER  :: temp

    temp => Head
    l = 0
    DO WHILE (ASSOCIATED(temp))
        if (temp%locked) l = l + 1
        temp => temp%Next
    END DO
    IF ( l > 0 ) THEN
        info = -l
        return
    ELSE
        CALL this%dealloc()
        info = 0
    END IF
    !
  end subroutine reinit
  !
  subroutine dump_status(this)
    class(devxlib_buffer_t), intent(inout)     :: this     !< The class.
    TYPE(Node), POINTER  :: temp
    integer :: i
    i = 1
    temp => Head
    write (*, *) "Buffer status ================="
    write (*, *) "          n        size Locked"
    DO WHILE (ASSOCIATED(temp))
        write (*,'(I12, I12, L7)') i, SIZE(TemP%space, kind=LLI), TemP%locked
        TemP => TemP%Next
        i = i + 1
    END DO
    write (*, *) "-------------------------------"
  end subroutine dump_status
  !
  subroutine print_report(this, unit)
    class(devxlib_buffer_t), intent(inout)     :: this     !< The class.
    INTEGER, OPTIONAL, intent(in)          :: unit
    !
    TYPE(Node), POINTER  :: temp
    integer(kind=LLI) :: tsz
    integer :: i, l
    i = 0
    l = 0
    tsz = 0
    temp => Head
    DO WHILE (ASSOCIATED(temp))
        tsz = tsz + SIZE(temp%space, kind=LLI)
        if (temp%locked) l = l + 1
        temp => temp%Next
        i = i + 1
    END DO
    if ( present (unit) ) then
        write(unit,'("[devxlib_buffer] Currently allocated ",(es12.2)," Mbytes, locked: ",(I4)," /",(I4) )') &
              REAL(tsz)/1048576, l, i
    else
        write(*   ,'("[devxlib_buffer] Currently allocated ",(es12.2)," Mbytes, locked: ",(I4)," /",(I4) )') &
              REAL(tsz)/1048576, l, i
    end if
  end subroutine print_report
  !
  subroutine lock_space(this, d, cloc, info)
    use iso_c_binding
    implicit none
    class(devxlib_buffer_t), intent(inout)     :: this     !< The class.
    integer(kind=LLI), intent(in)          :: d
#if defined(__DXL_CUDAF)
    type(c_devptr), intent(inout)  :: cloc
#else
    type(c_ptr), intent(inout)             :: cloc
#endif
    integer, intent(out)                   :: info
#if defined(__DXL_OPENMP_GPU)
    integer(c_int)                         :: omp_device !< OpenMP default device
#endif
    !
    integer(kind=LLI) :: r, tsz, sz
    TYPE(Node), POINTER  :: temp, good
    INTEGER :: i, good_one_idx
    !
    r   = 0
    tsz = 0
    i   = 1
    !
    ! Find the smallest usable buffer
    good_one_idx = 0
    temp => Head
    NULLIFY(good)
    DO WHILE (ASSOCIATED(temp))
        sz = SIZE(TemP%space, kind=LLI)
        IF ( ( sz >= d ) .and. (TemP%locked .eqv. .false.) ) THEN
            IF ( good_one_idx >= 1 ) THEN
                IF ( sz - d < r) THEN
                    good => temp
                    r = SIZE(TemP%space, kind=LLI) - d
                    good_one_idx = i
                END IF
            ELSE
                good_one_idx = i
                good => temp
                r = sz - d
            END IF
            info = 0
        END IF
        !
        tsz = tsz + sz
        i = i + 1
        !
        TemP => TemP%Next
    END DO
    !
    ! Allocate a new buffer
    IF ( good_one_idx == 0 ) THEN
        ALLOCATE (good)
#if defined(__DXL_CUDAF)
        ALLOCATE (good%space(d), stat=info)
#elif defined(__DXL_OPENMP_GPU)
        omp_device = omp_get_default_device()
        cloc = omp_target_alloc(d, omp_device)
        IF (c_associated(cloc)) THEN
           CALL c_f_pointer( cloc, good%space, [ d ] )
           info = 0
        ELSE
           info = -10000
        ENDIF
#else
        ALLOCATE (good%space(d), stat=info)
#endif
        good%Next   => Head
        Head        => good
        tsz         = tsz + d
        if (this%verbose) write (*, '("[devxlib_buffer] Created new buffer")')
    ELSE
        if (this%verbose) write (*, '("[devxlib_buffer] Locked buffer", I4)') good_one_idx
    END IF
    !
    if (this%verbose) &
         write(*,'("[devxlib_buffer] Currently allocated ",(es12.2)," Mbytes")') &
             REAL(tsz)/1048576 ! 1024/1024
    !
    good%locked = .true.
#if defined(__DXL_CUDAF)
    cloc = c_devloc(good%space)
#elif defined(__DXL_OPENMP_GPU)
    cloc = c_loc(good%space(1))
#else
    cloc = c_loc(good%space(1))
#endif
    !
  end subroutine lock_space
  !
  subroutine prepare_space(this, d, info)
    use iso_c_binding
    implicit none
    class(devxlib_buffer_t), intent(inout)     :: this     !< The class.
    integer(kind=LLI), intent(in)          :: d
    integer, intent(out)                   :: info
    !
#if defined(__DXL_CUDAF)
    type(c_devptr) :: cloc
#elif defined(__DXL_OPENMP_GPU)
    type(c_ptr)    :: cloc
#endif
    integer(kind=LLI) :: r, tsz, sz
    TYPE(Node), POINTER  :: temp, good
    INTEGER :: i, good_one_idx
#if defined(__DXL_OPENMP_GPU)
    integer(c_int)                         :: omp_device !< OpenMP default device
#endif
    !
    r   = 0
    tsz = 0
    i   = 1
    !
    ! Find the smallest usable buffer
    good_one_idx = 0
    temp => Head
    NULLIFY(good)
    DO WHILE (ASSOCIATED(temp))
        sz = SIZE(TemP%space, kind=LLI)
        IF ( ( sz >= d ) .and. (TemP%locked .eqv. .false.) ) THEN
            good_one_idx = i
            info = 0
        END IF
        !
        tsz = tsz + sz
        i = i + 1
        !
        TemP => TemP%Next
    END DO
    !
    ! Allocate a new buffer if needed
    IF ( good_one_idx == 0 ) THEN
        ALLOCATE (good)
#if defined(__DXL_CUDAF)
        ALLOCATE (good%space(d), stat=info)
#elif defined(__DXL_OPENMP_GPU)
        omp_device = omp_get_default_device()
        cloc = omp_target_alloc(d, omp_device)
        CALL c_f_pointer( cloc, good%space, [ d ] )
#else
        ALLOCATE (good%space(d), stat=info)
#endif
        good%locked = .false.
        good%Next   => Head
        Head        => good
        tsz         = tsz + d
        if (this%verbose) write (*, '("[devxlib_buffer] Created new buffer")')
    ELSE
        if (this%verbose) write (*, '("[devxlib_buffer] Good buffer found: ", I4)') good_one_idx
    END IF
    !
    if (this%verbose) &
         write (*, '("[devxlib_buffer] Currently allocated ",(es12.2)," Mbytes")') &
              REAL(tsz)/1048576 ! 1024/1024
    !
  end subroutine prepare_space
  !
  subroutine release_space(this, cloc, info)
#if defined(__DXL_CUDAF)
    use cudafor
#endif
    use iso_c_binding
    implicit none
    class(devxlib_buffer_t), intent(inout)  :: this     !< The class.
#if defined(__DXL_CUDAF)
    type(c_devptr), intent(in) :: cloc
#else
    type(c_ptr), intent(in) :: cloc
#endif
    integer, intent(out)            :: info    
    !
    TYPE(Node), POINTER  :: temp
#if defined(__DXL_CUDAF)
    type(c_devptr) :: clocint
#else
    type(c_ptr)            :: clocint
#endif
    !
    integer :: i
    info = -1
    i = 1
    temp => head
    DO WHILE (ASSOCIATED(temp))
#if defined(__DXL_OPENMP_GPU)
        clocint = c_loc(TemP%space(1))
        IF ( C_ASSOCIATED(cloc, clocint) ) THEN
            TemP%locked=.false.
            info = 0
            EXIT
        END IF
#else
#if defined(__DXL_CUDAF)
        IF ( cloc == c_devloc(TemP%space) ) THEN
#else
        clocint = c_loc(TemP%space(1))
        IF ( C_ASSOCIATED(cloc, clocint) ) THEN
#endif
            TemP%locked=.false.
            info = 0
            EXIT
        END IF
#endif
        i = i + 1
        TemP => TemP%Next
    END DO
    if (this%verbose) write (*, '("[devxlib_buffer] Released buffer ", I4)') i
  end subroutine release_space
  !

  !> Get or allocate a buffer for an integer vector.
  subroutine lock_buffer_iv(this, p, vsize_, info)
#if defined(__DXL_CUDAF)
    use cudafor
#endif
    use iso_c_binding
    implicit none
    class(devxlib_buffer_t), intent(inout)  :: this     !< The class.
    integer, pointer, intent(out) :: p(:)   !< Pointer possibly set to access buffer
    integer,       intent(in) :: vsize_   !< vector dimension
    integer,       intent(out) :: info    !<  0: ok
                                          !< -1: no buffers left, allocating space
                                          !< -2: unexpected error, no memory left
                                          !< other values come form allocate stat
#if defined(__DXL_CUDAF)
    attributes(device) :: p
#endif
    integer(kind=LLI) :: d
#if defined(__DXL_CUDAF)
    type(c_devptr) :: cloc
#else
    type(c_ptr) :: cloc
#endif
    !
    integer :: dummy
    integer :: vsize(1)
    vsize(1) = vsize_
    !
    d = PRODUCT(vsize)
    d = d*SIZEOF(dummy)
    !
    ! Free and simple compatibility with zero dimension buffers.
    IF ( d == 0 ) d = 1
    !
    CALL this%lock_space(d, cloc, info)
    CALL c_f_pointer( cloc, p, vsize )

  end subroutine lock_buffer_iv

  !> Get or allocate a buffer for an integer matrix.
  subroutine lock_buffer_im(this, p, msize, info)
#if defined(__DXL_CUDAF)
    use cudafor
#endif
    use iso_c_binding
    implicit none
    class(devxlib_buffer_t), intent(inout)  :: this     !< The class.
    integer, pointer, intent(out) :: p(:,:)   !< Pointer possibly set to access buffer
    integer,       intent(in) :: msize(2)   !< matrix dimension
    integer,       intent(out) :: info    !<  0: ok
                                          !< -1: no buffers left, allocating space
                                          !< -2: unexpected error, no memory left
                                          !< other values come form allocate stat
#if defined(__DXL_CUDAF)
    attributes(device) :: p
#endif
    integer(kind=LLI) :: d
#if defined(__DXL_CUDAF)
    type(c_devptr) :: cloc
#else
    type(c_ptr) :: cloc
#endif
    !
    integer :: dummy
    !
    d = PRODUCT(msize)
    d = d*SIZEOF(dummy)
    !
    ! Free and simple compatibility with zero dimension buffers.
    IF ( d == 0 ) d = 1
    !
    CALL this%lock_space(d, cloc, info)
    CALL c_f_pointer( cloc, p, msize )

  end subroutine lock_buffer_im

  !> Get or allocate a buffer for an integer tensor.
  subroutine lock_buffer_it(this, p, tsize, info)
#if defined(__DXL_CUDAF)
    use cudafor
#endif
    use iso_c_binding
    implicit none
    class(devxlib_buffer_t), intent(inout)  :: this     !< The class.
    integer, pointer, intent(out) :: p(:,:,:)   !< Pointer possibly set to access buffer
    integer,       intent(in) :: tsize(3)   !< tensor dimension
    integer,       intent(out) :: info    !<  0: ok
                                          !< -1: no buffers left, allocating space
                                          !< -2: unexpected error, no memory left
                                          !< other values come form allocate stat
#if defined(__DXL_CUDAF)
    attributes(device) :: p
#endif
    integer(kind=LLI) :: d
#if defined(__DXL_CUDAF)
    type(c_devptr) :: cloc
#else
    type(c_ptr) :: cloc
#endif
    !
    integer :: dummy
    !
    d = PRODUCT(tsize)
    d = d*SIZEOF(dummy)
    !
    ! Free and simple compatibility with zero dimension buffers.
    IF ( d == 0 ) d = 1
    !
    CALL this%lock_space(d, cloc, info)
    CALL c_f_pointer( cloc, p, tsize )

  end subroutine lock_buffer_it

  !> Get or allocate a buffer for an integer four_dimensional.
  subroutine lock_buffer_if(this, p, fsize, info)
#if defined(__DXL_CUDAF)
    use cudafor
#endif
    use iso_c_binding
    implicit none
    class(devxlib_buffer_t), intent(inout)  :: this     !< The class.
    integer, pointer, intent(out) :: p(:,:,:,:)   !< Pointer possibly set to access buffer
    integer,       intent(in) :: fsize(4)   !< four_dimensional dimension
    integer,       intent(out) :: info    !<  0: ok
                                          !< -1: no buffers left, allocating space
                                          !< -2: unexpected error, no memory left
                                          !< other values come form allocate stat
#if defined(__DXL_CUDAF)
    attributes(device) :: p
#endif
    integer(kind=LLI) :: d
#if defined(__DXL_CUDAF)
    type(c_devptr) :: cloc
#else
    type(c_ptr) :: cloc
#endif
    !
    integer :: dummy
    !
    d = PRODUCT(fsize)
    d = d*SIZEOF(dummy)
    !
    ! Free and simple compatibility with zero dimension buffers.
    IF ( d == 0 ) d = 1
    !
    CALL this%lock_space(d, cloc, info)
    CALL c_f_pointer( cloc, p, fsize )

  end subroutine lock_buffer_if

  !> Get or allocate a buffer for an real(real64) vector.
  subroutine lock_buffer_rv(this, p, vsize_, info)
#if defined(__DXL_CUDAF)
    use cudafor
#endif
    use iso_c_binding
    implicit none
    class(devxlib_buffer_t), intent(inout)  :: this     !< The class.
    real(real64), pointer, intent(out) :: p(:)   !< Pointer possibly set to access buffer
    integer,       intent(in) :: vsize_   !< vector dimension
    integer,       intent(out) :: info    !<  0: ok
                                          !< -1: no buffers left, allocating space
                                          !< -2: unexpected error, no memory left
                                          !< other values come form allocate stat
#if defined(__DXL_CUDAF)
    attributes(device) :: p
#endif
    integer(kind=LLI) :: d
#if defined(__DXL_CUDAF)
    type(c_devptr) :: cloc
#else
    type(c_ptr) :: cloc
#endif
    !
    real(real64) :: dummy
    integer :: vsize(1)
    vsize(1) = vsize_
    !
    d = PRODUCT(vsize)
    d = d*SIZEOF(dummy)
    !
    ! Free and simple compatibility with zero dimension buffers.
    IF ( d == 0 ) d = 1
    !
    CALL this%lock_space(d, cloc, info)
    CALL c_f_pointer( cloc, p, vsize )

  end subroutine lock_buffer_rv

  !> Get or allocate a buffer for an real(real64) matrix.
  subroutine lock_buffer_rm(this, p, msize, info)
#if defined(__DXL_CUDAF)
    use cudafor
#endif
    use iso_c_binding
    implicit none
    class(devxlib_buffer_t), intent(inout)  :: this     !< The class.
    real(real64), pointer, intent(out) :: p(:,:)   !< Pointer possibly set to access buffer
    integer,       intent(in) :: msize(2)   !< matrix dimension
    integer,       intent(out) :: info    !<  0: ok
                                          !< -1: no buffers left, allocating space
                                          !< -2: unexpected error, no memory left
                                          !< other values come form allocate stat
#if defined(__DXL_CUDAF)
    attributes(device) :: p
#endif
    integer(kind=LLI) :: d
#if defined(__DXL_CUDAF)
    type(c_devptr) :: cloc
#else
    type(c_ptr) :: cloc
#endif
    !
    real(real64) :: dummy
    !
    d = PRODUCT(msize)
    d = d*SIZEOF(dummy)
    !
    ! Free and simple compatibility with zero dimension buffers.
    IF ( d == 0 ) d = 1
    !
    CALL this%lock_space(d, cloc, info)
    CALL c_f_pointer( cloc, p, msize )

  end subroutine lock_buffer_rm

  !> Get or allocate a buffer for an real(real64) tensor.
  subroutine lock_buffer_rt(this, p, tsize, info)
#if defined(__DXL_CUDAF)
    use cudafor
#endif
    use iso_c_binding
    implicit none
    class(devxlib_buffer_t), intent(inout)  :: this     !< The class.
    real(real64), pointer, intent(out) :: p(:,:,:)   !< Pointer possibly set to access buffer
    integer,       intent(in) :: tsize(3)   !< tensor dimension
    integer,       intent(out) :: info    !<  0: ok
                                          !< -1: no buffers left, allocating space
                                          !< -2: unexpected error, no memory left
                                          !< other values come form allocate stat
#if defined(__DXL_CUDAF)
    attributes(device) :: p
#endif
    integer(kind=LLI) :: d
#if defined(__DXL_CUDAF)
    type(c_devptr) :: cloc
#else
    type(c_ptr) :: cloc
#endif
    !
    real(real64) :: dummy
    !
    d = PRODUCT(tsize)
    d = d*SIZEOF(dummy)
    !
    ! Free and simple compatibility with zero dimension buffers.
    IF ( d == 0 ) d = 1
    !
    CALL this%lock_space(d, cloc, info)
    CALL c_f_pointer( cloc, p, tsize )

  end subroutine lock_buffer_rt

  !> Get or allocate a buffer for an real(real64) four_dimensional.
  subroutine lock_buffer_rf(this, p, fsize, info)
#if defined(__DXL_CUDAF)
    use cudafor
#endif
    use iso_c_binding
    implicit none
    class(devxlib_buffer_t), intent(inout)  :: this     !< The class.
    real(real64), pointer, intent(out) :: p(:,:,:,:)   !< Pointer possibly set to access buffer
    integer,       intent(in) :: fsize(4)   !< four_dimensional dimension
    integer,       intent(out) :: info    !<  0: ok
                                          !< -1: no buffers left, allocating space
                                          !< -2: unexpected error, no memory left
                                          !< other values come form allocate stat
#if defined(__DXL_CUDAF)
    attributes(device) :: p
#endif
    integer(kind=LLI) :: d
#if defined(__DXL_CUDAF)
    type(c_devptr) :: cloc
#else
    type(c_ptr) :: cloc
#endif
    !
    real(real64) :: dummy
    !
    d = PRODUCT(fsize)
    d = d*SIZEOF(dummy)
    !
    ! Free and simple compatibility with zero dimension buffers.
    IF ( d == 0 ) d = 1
    !
    CALL this%lock_space(d, cloc, info)
    CALL c_f_pointer( cloc, p, fsize )

  end subroutine lock_buffer_rf

  !> Get or allocate a buffer for an complex(real64) vector.
  subroutine lock_buffer_cv(this, p, vsize_, info)
#if defined(__DXL_CUDAF)
    use cudafor
#endif
    use iso_c_binding
    implicit none
    class(devxlib_buffer_t), intent(inout)  :: this     !< The class.
    complex(real64), pointer, intent(out) :: p(:)   !< Pointer possibly set to access buffer
    integer,       intent(in) :: vsize_   !< vector dimension
    integer,       intent(out) :: info    !<  0: ok
                                          !< -1: no buffers left, allocating space
                                          !< -2: unexpected error, no memory left
                                          !< other values come form allocate stat
#if defined(__DXL_CUDAF)
    attributes(device) :: p
#endif
    integer(kind=LLI) :: d
#if defined(__DXL_CUDAF)
    type(c_devptr) :: cloc
#else
    type(c_ptr) :: cloc
#endif
    !
    complex(real64) :: dummy
    integer :: vsize(1)
    vsize(1) = vsize_
    !
    d = PRODUCT(vsize)
    d = d*SIZEOF(dummy)
    !
    ! Free and simple compatibility with zero dimension buffers.
    IF ( d == 0 ) d = 1
    !
    CALL this%lock_space(d, cloc, info)
    CALL c_f_pointer( cloc, p, vsize )

  end subroutine lock_buffer_cv

  !> Get or allocate a buffer for an complex(real64) matrix.
  subroutine lock_buffer_cm(this, p, msize, info)
#if defined(__DXL_CUDAF)
    use cudafor
#endif
    use iso_c_binding
    implicit none
    class(devxlib_buffer_t), intent(inout)  :: this     !< The class.
    complex(real64), pointer, intent(out) :: p(:,:)   !< Pointer possibly set to access buffer
    integer,       intent(in) :: msize(2)   !< matrix dimension
    integer,       intent(out) :: info    !<  0: ok
                                          !< -1: no buffers left, allocating space
                                          !< -2: unexpected error, no memory left
                                          !< other values come form allocate stat
#if defined(__DXL_CUDAF)
    attributes(device) :: p
#endif
    integer(kind=LLI) :: d
#if defined(__DXL_CUDAF)
    type(c_devptr) :: cloc
#else
    type(c_ptr) :: cloc
#endif
    !
    complex(real64) :: dummy
    !
    d = PRODUCT(msize)
    d = d*SIZEOF(dummy)
    !
    ! Free and simple compatibility with zero dimension buffers.
    IF ( d == 0 ) d = 1
    !
    CALL this%lock_space(d, cloc, info)
    CALL c_f_pointer( cloc, p, msize )

  end subroutine lock_buffer_cm

  !> Get or allocate a buffer for an complex(real64) tensor.
  subroutine lock_buffer_ct(this, p, tsize, info)
#if defined(__DXL_CUDAF)
    use cudafor
#endif
    use iso_c_binding
    implicit none
    class(devxlib_buffer_t), intent(inout)  :: this     !< The class.
    complex(real64), pointer, intent(out) :: p(:,:,:)   !< Pointer possibly set to access buffer
    integer,       intent(in) :: tsize(3)   !< tensor dimension
    integer,       intent(out) :: info    !<  0: ok
                                          !< -1: no buffers left, allocating space
                                          !< -2: unexpected error, no memory left
                                          !< other values come form allocate stat
#if defined(__DXL_CUDAF)
    attributes(device) :: p
#endif
    integer(kind=LLI) :: d
#if defined(__DXL_CUDAF)
    type(c_devptr) :: cloc
#else
    type(c_ptr) :: cloc
#endif
    !
    complex(real64) :: dummy
    !
    d = PRODUCT(tsize)
    d = d*SIZEOF(dummy)
    !
    ! Free and simple compatibility with zero dimension buffers.
    IF ( d == 0 ) d = 1
    !
    CALL this%lock_space(d, cloc, info)
    CALL c_f_pointer( cloc, p, tsize )

  end subroutine lock_buffer_ct

  !> Get or allocate a buffer for an complex(real64) four_dimensional.
  subroutine lock_buffer_cf(this, p, fsize, info)
#if defined(__DXL_CUDAF)
    use cudafor
#endif
    use iso_c_binding
    implicit none
    class(devxlib_buffer_t), intent(inout)  :: this     !< The class.
    complex(real64), pointer, intent(out) :: p(:,:,:,:)   !< Pointer possibly set to access buffer
    integer,       intent(in) :: fsize(4)   !< four_dimensional dimension
    integer,       intent(out) :: info    !<  0: ok
                                          !< -1: no buffers left, allocating space
                                          !< -2: unexpected error, no memory left
                                          !< other values come form allocate stat
#if defined(__DXL_CUDAF)
    attributes(device) :: p
#endif
    integer(kind=LLI) :: d
#if defined(__DXL_CUDAF)
    type(c_devptr) :: cloc
#else
    type(c_ptr) :: cloc
#endif
    !
    complex(real64) :: dummy
    !
    d = PRODUCT(fsize)
    d = d*SIZEOF(dummy)
    !
    ! Free and simple compatibility with zero dimension buffers.
    IF ( d == 0 ) d = 1
    !
    CALL this%lock_space(d, cloc, info)
    CALL c_f_pointer( cloc, p, fsize )

  end subroutine lock_buffer_cf

  !

  !> Release the buffer corresponding to pointer p, if associated with a buffer. Otherwise just deallocates.
  subroutine release_buffer_iv(this, p, info)
#if defined(__DXL_CUDAF)
    use cudafor
#endif
    use iso_c_binding
    implicit none
    class(devxlib_buffer_t), intent(inout)  :: this     !< The class.
    integer, pointer, intent(inout) :: p(:)   !< Pointer possibly pointing to buffer space
    integer, intent(out)            :: info
#if defined(__DXL_CUDAF)
    attributes(device) :: p
#endif

#if defined(__DXL_CUDAF)

    CALL this%release_space(c_devloc(p), info)

#else
    CALL this%release_space(c_loc(p( lbound(p, 1))), info)
#endif
  end subroutine release_buffer_iv

  !> Release the buffer corresponding to pointer p, if associated with a buffer. Otherwise just deallocates.
  subroutine release_buffer_im(this, p, info)
#if defined(__DXL_CUDAF)
    use cudafor
#endif
    use iso_c_binding
    implicit none
    class(devxlib_buffer_t), intent(inout)  :: this     !< The class.
    integer, pointer, intent(inout) :: p(:,:)   !< Pointer possibly pointing to buffer space
    integer, intent(out)            :: info
#if defined(__DXL_CUDAF)
    attributes(device) :: p
#endif

#if defined(__DXL_CUDAF)

    CALL this%release_space(c_devloc(p), info)

#else
    CALL this%release_space(c_loc(p( lbound(p, 1),  lbound(p, 2))), info)
#endif
  end subroutine release_buffer_im

  !> Release the buffer corresponding to pointer p, if associated with a buffer. Otherwise just deallocates.
  subroutine release_buffer_it(this, p, info)
#if defined(__DXL_CUDAF)
    use cudafor
#endif
    use iso_c_binding
    implicit none
    class(devxlib_buffer_t), intent(inout)  :: this     !< The class.
    integer, pointer, intent(inout) :: p(:,:,:)   !< Pointer possibly pointing to buffer space
    integer, intent(out)            :: info
#if defined(__DXL_CUDAF)
    attributes(device) :: p
#endif

#if defined(__DXL_CUDAF)

    CALL this%release_space(c_devloc(p), info)

#else
    CALL this%release_space(c_loc(p( lbound(p, 1),  lbound(p, 2),  lbound(p, 3))), info)
#endif
  end subroutine release_buffer_it

  !> Release the buffer corresponding to pointer p, if associated with a buffer. Otherwise just deallocates.
  subroutine release_buffer_if(this, p, info)
#if defined(__DXL_CUDAF)
    use cudafor
#endif
    use iso_c_binding
    implicit none
    class(devxlib_buffer_t), intent(inout)  :: this     !< The class.
    integer, pointer, intent(inout) :: p(:,:,:,:)   !< Pointer possibly pointing to buffer space
    integer, intent(out)            :: info
#if defined(__DXL_CUDAF)
    attributes(device) :: p
#endif

#if defined(__DXL_CUDAF)

    CALL this%release_space(c_devloc(p), info)

#else
    CALL this%release_space(c_loc(p( lbound(p, 1),  lbound(p, 2),  lbound(p, 3),  lbound(p, 4))), info)
#endif
  end subroutine release_buffer_if

  !> Release the buffer corresponding to pointer p, if associated with a buffer. Otherwise just deallocates.
  subroutine release_buffer_rv(this, p, info)
#if defined(__DXL_CUDAF)
    use cudafor
#endif
    use iso_c_binding
    implicit none
    class(devxlib_buffer_t), intent(inout)  :: this     !< The class.
    real(real64), pointer, intent(inout) :: p(:)   !< Pointer possibly pointing to buffer space
    integer, intent(out)            :: info
#if defined(__DXL_CUDAF)
    attributes(device) :: p
#endif

#if defined(__DXL_CUDAF)

    CALL this%release_space(c_devloc(p), info)

#else
    CALL this%release_space(c_loc(p( lbound(p, 1))), info)
#endif
  end subroutine release_buffer_rv

  !> Release the buffer corresponding to pointer p, if associated with a buffer. Otherwise just deallocates.
  subroutine release_buffer_rm(this, p, info)
#if defined(__DXL_CUDAF)
    use cudafor
#endif
    use iso_c_binding
    implicit none
    class(devxlib_buffer_t), intent(inout)  :: this     !< The class.
    real(real64), pointer, intent(inout) :: p(:,:)   !< Pointer possibly pointing to buffer space
    integer, intent(out)            :: info
#if defined(__DXL_CUDAF)
    attributes(device) :: p
#endif

#if defined(__DXL_CUDAF)

    CALL this%release_space(c_devloc(p), info)

#else
    CALL this%release_space(c_loc(p( lbound(p, 1),  lbound(p, 2))), info)
#endif
  end subroutine release_buffer_rm

  !> Release the buffer corresponding to pointer p, if associated with a buffer. Otherwise just deallocates.
  subroutine release_buffer_rt(this, p, info)
#if defined(__DXL_CUDAF)
    use cudafor
#endif
    use iso_c_binding
    implicit none
    class(devxlib_buffer_t), intent(inout)  :: this     !< The class.
    real(real64), pointer, intent(inout) :: p(:,:,:)   !< Pointer possibly pointing to buffer space
    integer, intent(out)            :: info
#if defined(__DXL_CUDAF)
    attributes(device) :: p
#endif

#if defined(__DXL_CUDAF)

    CALL this%release_space(c_devloc(p), info)

#else
    CALL this%release_space(c_loc(p( lbound(p, 1),  lbound(p, 2),  lbound(p, 3))), info)
#endif
  end subroutine release_buffer_rt

  !> Release the buffer corresponding to pointer p, if associated with a buffer. Otherwise just deallocates.
  subroutine release_buffer_rf(this, p, info)
#if defined(__DXL_CUDAF)
    use cudafor
#endif
    use iso_c_binding
    implicit none
    class(devxlib_buffer_t), intent(inout)  :: this     !< The class.
    real(real64), pointer, intent(inout) :: p(:,:,:,:)   !< Pointer possibly pointing to buffer space
    integer, intent(out)            :: info
#if defined(__DXL_CUDAF)
    attributes(device) :: p
#endif

#if defined(__DXL_CUDAF)

    CALL this%release_space(c_devloc(p), info)

#else
    CALL this%release_space(c_loc(p( lbound(p, 1),  lbound(p, 2),  lbound(p, 3),  lbound(p, 4))), info)
#endif
  end subroutine release_buffer_rf

  !> Release the buffer corresponding to pointer p, if associated with a buffer. Otherwise just deallocates.
  subroutine release_buffer_cv(this, p, info)
#if defined(__DXL_CUDAF)
    use cudafor
#endif
    use iso_c_binding
    implicit none
    class(devxlib_buffer_t), intent(inout)  :: this     !< The class.
    complex(real64), pointer, intent(inout) :: p(:)   !< Pointer possibly pointing to buffer space
    integer, intent(out)            :: info
#if defined(__DXL_CUDAF)
    attributes(device) :: p
#endif

#if defined(__DXL_CUDAF)

    CALL this%release_space(c_devloc(p), info)

#else
    CALL this%release_space(c_loc(p( lbound(p, 1))), info)
#endif
  end subroutine release_buffer_cv

  !> Release the buffer corresponding to pointer p, if associated with a buffer. Otherwise just deallocates.
  subroutine release_buffer_cm(this, p, info)
#if defined(__DXL_CUDAF)
    use cudafor
#endif
    use iso_c_binding
    implicit none
    class(devxlib_buffer_t), intent(inout)  :: this     !< The class.
    complex(real64), pointer, intent(inout) :: p(:,:)   !< Pointer possibly pointing to buffer space
    integer, intent(out)            :: info
#if defined(__DXL_CUDAF)
    attributes(device) :: p
#endif

#if defined(__DXL_CUDAF)

    CALL this%release_space(c_devloc(p), info)

#else
    CALL this%release_space(c_loc(p( lbound(p, 1),  lbound(p, 2))), info)
#endif
  end subroutine release_buffer_cm

  !> Release the buffer corresponding to pointer p, if associated with a buffer. Otherwise just deallocates.
  subroutine release_buffer_ct(this, p, info)
#if defined(__DXL_CUDAF)
    use cudafor
#endif
    use iso_c_binding
    implicit none
    class(devxlib_buffer_t), intent(inout)  :: this     !< The class.
    complex(real64), pointer, intent(inout) :: p(:,:,:)   !< Pointer possibly pointing to buffer space
    integer, intent(out)            :: info
#if defined(__DXL_CUDAF)
    attributes(device) :: p
#endif

#if defined(__DXL_CUDAF)

    CALL this%release_space(c_devloc(p), info)

#else
    CALL this%release_space(c_loc(p( lbound(p, 1),  lbound(p, 2),  lbound(p, 3))), info)
#endif
  end subroutine release_buffer_ct

  !> Release the buffer corresponding to pointer p, if associated with a buffer. Otherwise just deallocates.
  subroutine release_buffer_cf(this, p, info)
#if defined(__DXL_CUDAF)
    use cudafor
#endif
    use iso_c_binding
    implicit none
    class(devxlib_buffer_t), intent(inout)  :: this     !< The class.
    complex(real64), pointer, intent(inout) :: p(:,:,:,:)   !< Pointer possibly pointing to buffer space
    integer, intent(out)            :: info
#if defined(__DXL_CUDAF)
    attributes(device) :: p
#endif

#if defined(__DXL_CUDAF)

    CALL this%release_space(c_devloc(p), info)

#else
    CALL this%release_space(c_loc(p( lbound(p, 1),  lbound(p, 2),  lbound(p, 3),  lbound(p, 4))), info)
#endif
  end subroutine release_buffer_cf

  !

  !> 
  subroutine prepare_buffer_iv(this, p, vsize_, info)
#if defined(__DXL_CUDAF)
    use cudafor
#endif
    use iso_c_binding
    implicit none
    class(devxlib_buffer_t), intent(inout)  :: this     !< The class.
    integer, pointer, intent(out) :: p(:)   !< Pointer (only used for assesing type)
    integer,       intent(in) :: vsize_   !< vector dimension
    integer,       intent(out) :: info    !<  0: ok
                                          !< -1: no buffers left, allocating space
                                          !< -2: unexpected error, no memory left
                                          !< other values come form allocate stat
#if defined(__DXL_CUDAF)
    attributes(device) :: p
#endif
    integer(kind=LLI) :: d
#if defined(__DXL_CUDAF)
    type(c_devptr) :: cloc
#else
    type(c_ptr) :: cloc
#endif
    !
    integer :: dummy
    integer :: vsize(1)
    vsize(1) = vsize_
    !
    d = PRODUCT(vsize)
    d = d*SIZEOF(dummy)
    !
    CALL this%prepare_space(d, info)
    !
  end subroutine prepare_buffer_iv

  !> 
  subroutine prepare_buffer_im(this, p, msize, info)
#if defined(__DXL_CUDAF)
    use cudafor
#endif
    use iso_c_binding
    implicit none
    class(devxlib_buffer_t), intent(inout)  :: this     !< The class.
    integer, pointer, intent(out) :: p(:,:)   !< Pointer (only used for assesing type)
    integer,       intent(in) :: msize(2)   !< matrix dimension
    integer,       intent(out) :: info    !<  0: ok
                                          !< -1: no buffers left, allocating space
                                          !< -2: unexpected error, no memory left
                                          !< other values come form allocate stat
#if defined(__DXL_CUDAF)
    attributes(device) :: p
#endif
    integer(kind=LLI) :: d
#if defined(__DXL_CUDAF)
    type(c_devptr) :: cloc
#else
    type(c_ptr) :: cloc
#endif
    !
    integer :: dummy
    !
    d = PRODUCT(msize)
    d = d*SIZEOF(dummy)
    !
    CALL this%prepare_space(d, info)
    !
  end subroutine prepare_buffer_im

  !> 
  subroutine prepare_buffer_it(this, p, tsize, info)
#if defined(__DXL_CUDAF)
    use cudafor
#endif
    use iso_c_binding
    implicit none
    class(devxlib_buffer_t), intent(inout)  :: this     !< The class.
    integer, pointer, intent(out) :: p(:,:,:)   !< Pointer (only used for assesing type)
    integer,       intent(in) :: tsize(3)   !< tensor dimension
    integer,       intent(out) :: info    !<  0: ok
                                          !< -1: no buffers left, allocating space
                                          !< -2: unexpected error, no memory left
                                          !< other values come form allocate stat
#if defined(__DXL_CUDAF)
    attributes(device) :: p
#endif
    integer(kind=LLI) :: d
#if defined(__DXL_CUDAF)
    type(c_devptr) :: cloc
#else
    type(c_ptr) :: cloc
#endif
    !
    integer :: dummy
    !
    d = PRODUCT(tsize)
    d = d*SIZEOF(dummy)
    !
    CALL this%prepare_space(d, info)
    !
  end subroutine prepare_buffer_it

  !> 
  subroutine prepare_buffer_if(this, p, fsize, info)
#if defined(__DXL_CUDAF)
    use cudafor
#endif
    use iso_c_binding
    implicit none
    class(devxlib_buffer_t), intent(inout)  :: this     !< The class.
    integer, pointer, intent(out) :: p(:,:,:,:)   !< Pointer (only used for assesing type)
    integer,       intent(in) :: fsize(4)   !< four_dimensional dimension
    integer,       intent(out) :: info    !<  0: ok
                                          !< -1: no buffers left, allocating space
                                          !< -2: unexpected error, no memory left
                                          !< other values come form allocate stat
#if defined(__DXL_CUDAF)
    attributes(device) :: p
#endif
    integer(kind=LLI) :: d
#if defined(__DXL_CUDAF)
    type(c_devptr) :: cloc
#else
    type(c_ptr) :: cloc
#endif
    !
    integer :: dummy
    !
    d = PRODUCT(fsize)
    d = d*SIZEOF(dummy)
    !
    CALL this%prepare_space(d, info)
    !
  end subroutine prepare_buffer_if

  !> 
  subroutine prepare_buffer_rv(this, p, vsize_, info)
#if defined(__DXL_CUDAF)
    use cudafor
#endif
    use iso_c_binding
    implicit none
    class(devxlib_buffer_t), intent(inout)  :: this     !< The class.
    real(real64), pointer, intent(out) :: p(:)   !< Pointer (only used for assesing type)
    integer,       intent(in) :: vsize_   !< vector dimension
    integer,       intent(out) :: info    !<  0: ok
                                          !< -1: no buffers left, allocating space
                                          !< -2: unexpected error, no memory left
                                          !< other values come form allocate stat
#if defined(__DXL_CUDAF)
    attributes(device) :: p
#endif
    integer(kind=LLI) :: d
#if defined(__DXL_CUDAF)
    type(c_devptr) :: cloc
#else
    type(c_ptr) :: cloc
#endif
    !
    real(real64) :: dummy
    integer :: vsize(1)
    vsize(1) = vsize_
    !
    d = PRODUCT(vsize)
    d = d*SIZEOF(dummy)
    !
    CALL this%prepare_space(d, info)
    !
  end subroutine prepare_buffer_rv

  !> 
  subroutine prepare_buffer_rm(this, p, msize, info)
#if defined(__DXL_CUDAF)
    use cudafor
#endif
    use iso_c_binding
    implicit none
    class(devxlib_buffer_t), intent(inout)  :: this     !< The class.
    real(real64), pointer, intent(out) :: p(:,:)   !< Pointer (only used for assesing type)
    integer,       intent(in) :: msize(2)   !< matrix dimension
    integer,       intent(out) :: info    !<  0: ok
                                          !< -1: no buffers left, allocating space
                                          !< -2: unexpected error, no memory left
                                          !< other values come form allocate stat
#if defined(__DXL_CUDAF)
    attributes(device) :: p
#endif
    integer(kind=LLI) :: d
#if defined(__DXL_CUDAF)
    type(c_devptr) :: cloc
#else
    type(c_ptr) :: cloc
#endif
    !
    real(real64) :: dummy
    !
    d = PRODUCT(msize)
    d = d*SIZEOF(dummy)
    !
    CALL this%prepare_space(d, info)
    !
  end subroutine prepare_buffer_rm

  !> 
  subroutine prepare_buffer_rt(this, p, tsize, info)
#if defined(__DXL_CUDAF)
    use cudafor
#endif
    use iso_c_binding
    implicit none
    class(devxlib_buffer_t), intent(inout)  :: this     !< The class.
    real(real64), pointer, intent(out) :: p(:,:,:)   !< Pointer (only used for assesing type)
    integer,       intent(in) :: tsize(3)   !< tensor dimension
    integer,       intent(out) :: info    !<  0: ok
                                          !< -1: no buffers left, allocating space
                                          !< -2: unexpected error, no memory left
                                          !< other values come form allocate stat
#if defined(__DXL_CUDAF)
    attributes(device) :: p
#endif
    integer(kind=LLI) :: d
#if defined(__DXL_CUDAF)
    type(c_devptr) :: cloc
#else
    type(c_ptr) :: cloc
#endif
    !
    real(real64) :: dummy
    !
    d = PRODUCT(tsize)
    d = d*SIZEOF(dummy)
    !
    CALL this%prepare_space(d, info)
    !
  end subroutine prepare_buffer_rt

  !> 
  subroutine prepare_buffer_rf(this, p, fsize, info)
#if defined(__DXL_CUDAF)
    use cudafor
#endif
    use iso_c_binding
    implicit none
    class(devxlib_buffer_t), intent(inout)  :: this     !< The class.
    real(real64), pointer, intent(out) :: p(:,:,:,:)   !< Pointer (only used for assesing type)
    integer,       intent(in) :: fsize(4)   !< four_dimensional dimension
    integer,       intent(out) :: info    !<  0: ok
                                          !< -1: no buffers left, allocating space
                                          !< -2: unexpected error, no memory left
                                          !< other values come form allocate stat
#if defined(__DXL_CUDAF)
    attributes(device) :: p
#endif
    integer(kind=LLI) :: d
#if defined(__DXL_CUDAF)
    type(c_devptr) :: cloc
#else
    type(c_ptr) :: cloc
#endif
    !
    real(real64) :: dummy
    !
    d = PRODUCT(fsize)
    d = d*SIZEOF(dummy)
    !
    CALL this%prepare_space(d, info)
    !
  end subroutine prepare_buffer_rf

  !> 
  subroutine prepare_buffer_cv(this, p, vsize_, info)
#if defined(__DXL_CUDAF)
    use cudafor
#endif
    use iso_c_binding
    implicit none
    class(devxlib_buffer_t), intent(inout)  :: this     !< The class.
    complex(real64), pointer, intent(out) :: p(:)   !< Pointer (only used for assesing type)
    integer,       intent(in) :: vsize_   !< vector dimension
    integer,       intent(out) :: info    !<  0: ok
                                          !< -1: no buffers left, allocating space
                                          !< -2: unexpected error, no memory left
                                          !< other values come form allocate stat
#if defined(__DXL_CUDAF)
    attributes(device) :: p
#endif
    integer(kind=LLI) :: d
#if defined(__DXL_CUDAF)
    type(c_devptr) :: cloc
#else
    type(c_ptr) :: cloc
#endif
    !
    complex(real64) :: dummy
    integer :: vsize(1)
    vsize(1) = vsize_
    !
    d = PRODUCT(vsize)
    d = d*SIZEOF(dummy)
    !
    CALL this%prepare_space(d, info)
    !
  end subroutine prepare_buffer_cv

  !> 
  subroutine prepare_buffer_cm(this, p, msize, info)
#if defined(__DXL_CUDAF)
    use cudafor
#endif
    use iso_c_binding
    implicit none
    class(devxlib_buffer_t), intent(inout)  :: this     !< The class.
    complex(real64), pointer, intent(out) :: p(:,:)   !< Pointer (only used for assesing type)
    integer,       intent(in) :: msize(2)   !< matrix dimension
    integer,       intent(out) :: info    !<  0: ok
                                          !< -1: no buffers left, allocating space
                                          !< -2: unexpected error, no memory left
                                          !< other values come form allocate stat
#if defined(__DXL_CUDAF)
    attributes(device) :: p
#endif
    integer(kind=LLI) :: d
#if defined(__DXL_CUDAF)
    type(c_devptr) :: cloc
#else
    type(c_ptr) :: cloc
#endif
    !
    complex(real64) :: dummy
    !
    d = PRODUCT(msize)
    d = d*SIZEOF(dummy)
    !
    CALL this%prepare_space(d, info)
    !
  end subroutine prepare_buffer_cm

  !> 
  subroutine prepare_buffer_ct(this, p, tsize, info)
#if defined(__DXL_CUDAF)
    use cudafor
#endif
    use iso_c_binding
    implicit none
    class(devxlib_buffer_t), intent(inout)  :: this     !< The class.
    complex(real64), pointer, intent(out) :: p(:,:,:)   !< Pointer (only used for assesing type)
    integer,       intent(in) :: tsize(3)   !< tensor dimension
    integer,       intent(out) :: info    !<  0: ok
                                          !< -1: no buffers left, allocating space
                                          !< -2: unexpected error, no memory left
                                          !< other values come form allocate stat
#if defined(__DXL_CUDAF)
    attributes(device) :: p
#endif
    integer(kind=LLI) :: d
#if defined(__DXL_CUDAF)
    type(c_devptr) :: cloc
#else
    type(c_ptr) :: cloc
#endif
    !
    complex(real64) :: dummy
    !
    d = PRODUCT(tsize)
    d = d*SIZEOF(dummy)
    !
    CALL this%prepare_space(d, info)
    !
  end subroutine prepare_buffer_ct

  !> 
  subroutine prepare_buffer_cf(this, p, fsize, info)
#if defined(__DXL_CUDAF)
    use cudafor
#endif
    use iso_c_binding
    implicit none
    class(devxlib_buffer_t), intent(inout)  :: this     !< The class.
    complex(real64), pointer, intent(out) :: p(:,:,:,:)   !< Pointer (only used for assesing type)
    integer,       intent(in) :: fsize(4)   !< four_dimensional dimension
    integer,       intent(out) :: info    !<  0: ok
                                          !< -1: no buffers left, allocating space
                                          !< -2: unexpected error, no memory left
                                          !< other values come form allocate stat
#if defined(__DXL_CUDAF)
    attributes(device) :: p
#endif
    integer(kind=LLI) :: d
#if defined(__DXL_CUDAF)
    type(c_devptr) :: cloc
#else
    type(c_ptr) :: cloc
#endif
    !
    complex(real64) :: dummy
    !
    d = PRODUCT(fsize)
    d = d*SIZEOF(dummy)
    !
    CALL this%prepare_space(d, info)
    !
  end subroutine prepare_buffer_cf


end module devxlib_buffer

!
! Copyright (C) 2021, MaX CoE
! Distributed under the MIT License 
! (license terms are at http://opensource.org/licenses/MIT).
!
!--
!
! Auxiliary functions with device support via CUDAF, OpenACC, OpenMP-GPU
!
module device_auxfunc_m
  implicit none

#include<device_auxfunc_interf.f90>

end module device_auxfunc_m

!
! Copyright (C) 2002-2018 Quantum ESPRESSO group
! This file is distributed under the terms of the
! GNU General Public License. See the file `License'
! in the root directory of the present distribution,
! or http://www.gnu.org/copyleft/gpl.txt .
!
! Utility functions to perform memcpy and memset on the device with CUDA Fortran
! dev_memXXX contains a CUF KERNEL to perform the selected operation
!
#ifdef _CUDA
#  define __CUDA
#endif

MODULE dev_util_m
  !
  USE com, only: SP
  !
  IMPLICIT NONE
  !
  PUBLIC :: dev_memcpy, dev_memset
  PUBLIC :: dev_conjg
  !
  INTERFACE dev_memcpy
    MODULE PROCEDURE &
      cuf_memcpy_r1d, &
      cuf_memcpy_r2d, &
      cuf_memcpy_r3d, &
      cuf_memcpy_c1d, &
      cuf_memcpy_c2d, &
      cuf_memcpy_c3d, &
      cuf_memcpy_c4d
  END INTERFACE
  !
  INTERFACE dev_memset
    MODULE PROCEDURE &
      cuf_memset_r1d, &
      cuf_memset_r2d, &
      cuf_memset_r3d, &
      cuf_memset_c1d, &
      cuf_memset_c2d, &
      cuf_memset_c3d
  END INTERFACE
  !
  INTERFACE dev_conjg
    MODULE PROCEDURE &
      cuf_conjg_c1d, &
      cuf_conjg_c2d, &
      cuf_conjg_c3d, &
      cuf_conjg_c4d
  END INTERFACE
  !
CONTAINS
  !
  SUBROUTINE cuf_memcpy_r1d(array_out, array_in, range1 )
    !
    IMPLICIT NONE
    !
    REAL(SP), INTENT(INOUT) :: array_out(:)
    REAL(SP), INTENT(IN) :: array_in(:)
    INTEGER, INTENT(IN) ::  range1(2)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_out, array_in
#endif
    !
    INTEGER :: i1, d1s, d1e
    !
    d1s = range1(1)
    d1e = range1(2)
    !
    !$cuf kernel do(1)
    DO i1 = d1s, d1e
       array_out(i1 ) = array_in(i1 )
    ENDDO
    !
  END SUBROUTINE cuf_memcpy_r1d
  !
  SUBROUTINE cuf_memcpy_r2d(array_out, array_in, range1, range2 )
    !
    IMPLICIT NONE
    !
    REAL(SP), INTENT(INOUT) :: array_out(:,:)
    REAL(SP), INTENT(IN) :: array_in(:,:)
    INTEGER, INTENT(IN) ::  range1(2), range2(2)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_out, array_in
#endif
    !
    INTEGER :: i1, d1s, d1e
    INTEGER :: i2, d2s, d2e
    !
    d1s = range1(1)
    d1e = range1(2)
    d2s = range2(1)
    d2e = range2(2)
    !
    !$cuf kernel do(2)
    DO i2 = d2s, d2e
    DO i1 = d1s, d1e
       array_out(i1,i2 ) = array_in(i1,i2 )
    ENDDO
    ENDDO
    !
  END SUBROUTINE cuf_memcpy_r2d
  !
  SUBROUTINE cuf_memcpy_r3d(array_out, array_in, range1, range2, range3 )
    !
    IMPLICIT NONE
    !
    REAL(SP), INTENT(INOUT) :: array_out(:,:,:)
    REAL(SP), INTENT(IN) :: array_in(:,:,:)
    INTEGER, INTENT(IN) ::  range1(2), range2(2), range3(2)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_out, array_in
#endif
    !
    INTEGER :: i1, d1s, d1e
    INTEGER :: i2, d2s, d2e
    INTEGER :: i3, d3s, d3e
    !
    d1s = range1(1)
    d1e = range1(2)
    d2s = range2(1)
    d2e = range2(2)
    d3s = range3(1)
    d3e = range3(2)
    !
    !$cuf kernel do(3)
    DO i3 = d3s, d3e
    DO i2 = d2s, d2e
    DO i1 = d1s, d1e
       array_out(i1,i2,i3 ) = array_in(i1,i2,i3 )
    ENDDO
    ENDDO
    ENDDO
    !
  END SUBROUTINE cuf_memcpy_r3d
  !
  SUBROUTINE cuf_memcpy_c1d(array_out, array_in, range1 )
    !
    IMPLICIT NONE
    !
    COMPLEX(SP), INTENT(INOUT) :: array_out(:)
    COMPLEX(SP), INTENT(IN) :: array_in(:)
    INTEGER, INTENT(IN) ::  range1(2)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_out, array_in
#endif
    !
    INTEGER :: i1, d1s, d1e
    !
    d1s = range1(1)
    d1e = range1(2)
    !
    !$cuf kernel do(1)
    DO i1 = d1s, d1e
       array_out(i1 ) = array_in(i1 )
    ENDDO
    !
  END SUBROUTINE cuf_memcpy_c1d
  !
  SUBROUTINE cuf_memcpy_c2d(array_out, array_in, range1, range2 )
    IMPLICIT NONE
    COMPLEX(SP), INTENT(INOUT) :: array_out(:,:)
    COMPLEX(SP), INTENT(IN) :: array_in(:,:)
    INTEGER, INTENT(IN) ::  range1(2), range2(2)
#if defined(__CUDA)
    attributes(DEVICE) :: array_out, array_in
#endif
    INTEGER :: i1, d1s, d1e
    INTEGER :: i2, d2s, d2e
    !
    d1s = range1(1)
    d1e = range1(2)
    d2s = range2(1)
    d2e = range2(2)
    !
    !$cuf kernel do(2)
    DO i2 = d2s, d2e
    DO i1 = d1s, d1e
       array_out(i1,i2 ) = array_in(i1,i2 )
    ENDDO
    ENDDO
    !
  END SUBROUTINE cuf_memcpy_c2d
  !
  SUBROUTINE cuf_memcpy_c3d(array_out, array_in, range1, range2, range3 )
    IMPLICIT NONE
    COMPLEX(SP), INTENT(INOUT) :: array_out(:,:,:)
    COMPLEX(SP), INTENT(IN) :: array_in(:,:,:)
    INTEGER, INTENT(IN) ::  range1(2), range2(2), range3(2)
#if defined(__CUDA)
    attributes(DEVICE) :: array_out, array_in
#endif
    INTEGER :: i1, d1s, d1e
    INTEGER :: i2, d2s, d2e
    INTEGER :: i3, d3s, d3e
    !
    d1s = range1(1)
    d1e = range1(2)
    d2s = range2(1)
    d2e = range2(2)
    d3s = range3(1)
    d3e = range3(2)
    !
    !$cuf kernel do(3)
    DO i3 = d3s, d3e
    DO i2 = d2s, d2e
    DO i1 = d1s, d1e
       array_out(i1,i2,i3 ) = array_in(i1,i2,i3 )
    ENDDO
    ENDDO
    ENDDO
    !
  END SUBROUTINE cuf_memcpy_c3d
  !
  SUBROUTINE cuf_memcpy_c4d(array_out, array_in, range1, range2, range3, range4 )
    IMPLICIT NONE
    COMPLEX(SP), INTENT(INOUT) :: array_out(:,:,:,:)
    COMPLEX(SP), INTENT(IN) :: array_in(:,:,:,:)
    INTEGER, INTENT(IN) ::  range1(2), range2(2), range3(2), range4(2)
#if defined(__CUDA)
    attributes(DEVICE) :: array_out, array_in
#endif
    INTEGER :: i1, d1s, d1e
    INTEGER :: i2, d2s, d2e
    INTEGER :: i3, d3s, d3e
    INTEGER :: i4, d4s, d4e
    !
    d1s = range1(1)
    d1e = range1(2)
    d2s = range2(1)
    d2e = range2(2)
    d3s = range3(1)
    d3e = range3(2)
    d4s = range4(1)
    d4e = range4(2)
    !
    !$cuf kernel do(4)
    DO i4 = d4s, d4e
    DO i3 = d3s, d3e
    DO i2 = d2s, d2e
    DO i1 = d1s, d1e
       array_out(i1,i2,i3,i4) = array_in(i1,i2,i3,i4)
    ENDDO
    ENDDO
    ENDDO
    ENDDO
    !
  END SUBROUTINE cuf_memcpy_c4d
  !
  !=====================
  ! cuf memset
  !=====================
  !
  SUBROUTINE cuf_memset_r1d(array_out, val, range1 )
    !
    IMPLICIT NONE
    !
    REAL(SP), INTENT(INOUT) :: array_out(:)
    REAL(SP), INTENT(IN) :: val
    INTEGER, INTENT(IN) ::  range1(2)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_out
#endif
    !
    INTEGER :: i1, d1s, d1e
    !
    d1s = range1(1)
    d1e = range1(2)
    !
    !$cuf kernel do(1)
    DO i1 = d1s, d1e
       array_out(i1 ) = val
    ENDDO
    !
  END SUBROUTINE cuf_memset_r1d
  !
  SUBROUTINE cuf_memset_r2d(array_out, val, range1, range2 )
    !
    IMPLICIT NONE
    !
    REAL(SP), INTENT(INOUT) :: array_out(:,:)
    REAL(SP), INTENT(IN) :: val
    INTEGER, INTENT(IN) ::  range1(2), range2(2)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_out
#endif
    !
    INTEGER :: i1, d1s, d1e
    INTEGER :: i2, d2s, d2e
    !
    d1s = range1(1)
    d1e = range1(2)
    d2s = range2(1)
    d2e = range2(2)
    !
    !$cuf kernel do(2)
    DO i2 = d2s, d2e
    DO i1 = d1s, d1e
       array_out(i1,i2 ) = val
    ENDDO
    ENDDO
    !
  END SUBROUTINE cuf_memset_r2d
  !
  SUBROUTINE cuf_memset_r3d(array_out, val, range1, range2, range3 )
    !
    IMPLICIT NONE
    !
    REAL(SP), INTENT(INOUT) :: array_out(:,:,:)
    REAL(SP), INTENT(IN) :: val
    INTEGER, INTENT(IN) ::  range1(2), range2(2), range3(2)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_out
#endif
    !
    INTEGER :: i1, d1s, d1e
    INTEGER :: i2, d2s, d2e
    INTEGER :: i3, d3s, d3e
    !
    d1s = range1(1)
    d1e = range1(2)
    d2s = range2(1)
    d2e = range2(2)
    d3s = range3(1)
    d3e = range3(2)
    !
    !$cuf kernel do(3)
    DO i3 = d3s, d3e
    DO i2 = d2s, d2e
    DO i1 = d1s, d1e
       array_out(i1,i2,i3 ) = val
    ENDDO
    ENDDO
    ENDDO
    !
  END SUBROUTINE cuf_memset_r3d
  !
  SUBROUTINE cuf_memset_c1d(array_out, val, range1 )
    !
    IMPLICIT NONE
    !
    COMPLEX(SP), INTENT(INOUT) :: array_out(:)
    COMPLEX(SP), INTENT(IN) :: val
    INTEGER, INTENT(IN) ::  range1(2)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_out
#endif
    !
    INTEGER :: i1, d1s, d1e
    !
    d1s = range1(1)
    d1e = range1(2)
    !
    !$cuf kernel do(1)
    DO i1 = d1s, d1e
       array_out(i1 ) = val
    ENDDO
    !
  END SUBROUTINE cuf_memset_c1d
  !
  SUBROUTINE cuf_memset_c2d(array_out, val, range1, range2 )
    !
    IMPLICIT NONE
    !
    COMPLEX(SP), INTENT(INOUT) :: array_out(:,:)
    COMPLEX(SP), INTENT(IN) :: val
    INTEGER, INTENT(IN) ::  range1(2), range2(2)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_out
#endif
    !
    INTEGER :: i1, d1s, d1e
    INTEGER :: i2, d2s, d2e
    !
    d1s = range1(1)
    d1e = range1(2)
    d2s = range2(1)
    d2e = range2(2)
    !
    !$cuf kernel do(2)
    DO i2 = d2s, d2e
    DO i1 = d1s, d1e
       array_out(i1,i2 ) = val
    ENDDO
    ENDDO
    !
  END SUBROUTINE cuf_memset_c2d
  !
  SUBROUTINE cuf_memset_c3d(array_out, val, range1, range2, range3 )
    !
    IMPLICIT NONE
    !
    COMPLEX(SP), INTENT(INOUT) :: array_out(:,:,:)
    COMPLEX(SP), INTENT(IN) :: val
    INTEGER, INTENT(IN) ::  range1(2), range2(2), range3(2)
    !
#if defined(__CUDA)
    attributes(DEVICE) :: array_out
#endif
    !
    INTEGER :: i1, d1s, d1e
    INTEGER :: i2, d2s, d2e
    INTEGER :: i3, d3s, d3e
    !
    d1s = range1(1)
    d1e = range1(2)
    d2s = range2(1)
    d2e = range2(2)
    d3s = range3(1)
    d3e = range3(2)
    !
    !$cuf kernel do(3)
    DO i3 = d3s, d3e
    DO i2 = d2s, d2e
    DO i1 = d1s, d1e
       array_out(i1,i2,i3 ) = val
    ENDDO
    ENDDO
    ENDDO
    !
  END SUBROUTINE cuf_memset_c3d
  !
  SUBROUTINE cuf_conjg_c1d(array, range1)
    IMPLICIT NONE
    COMPLEX(SP), INTENT(INOUT) :: array(:)
    INTEGER,     INTENT(IN) ::  range1(2)
#if defined(__CUDA)
    attributes(DEVICE) :: array
#endif
    INTEGER :: i1, d1s, d1e
    !
    d1s = range1(1)
    d1e = range1(2)
    !
    !$cuf kernel do(1)
    DO i1 = d1s, d1e
       array(i1) = conjg(array(i1))
    ENDDO
    !
  END SUBROUTINE cuf_conjg_c1d
  !
  SUBROUTINE cuf_conjg_c2d(array, range1, range2)
    IMPLICIT NONE
    COMPLEX(SP), INTENT(INOUT) :: array(:,:)
    INTEGER,     INTENT(IN) ::  range1(2)
    INTEGER,     INTENT(IN) ::  range2(2)
#if defined(__CUDA)
    attributes(DEVICE) :: array
#endif
    INTEGER :: i1, d1s, d1e
    INTEGER :: i2, d2s, d2e
    !
    d1s = range1(1)
    d1e = range1(2)
    d2s = range2(1)
    d2e = range2(2)
    !
    !$cuf kernel do(2)
    DO i2 = d2s, d2e
    DO i1 = d1s, d1e
       array(i1,i2) = conjg(array(i1,i2))
    ENDDO
    ENDDO
    !
  END SUBROUTINE cuf_conjg_c2d
  !
  SUBROUTINE cuf_conjg_c3d(array, range1, range2, range3)
    IMPLICIT NONE
    COMPLEX(SP), INTENT(INOUT) :: array(:,:,:)
    INTEGER,     INTENT(IN) ::  range1(2)
    INTEGER,     INTENT(IN) ::  range2(2)
    INTEGER,     INTENT(IN) ::  range3(2)
#if defined(__CUDA)
    attributes(DEVICE) :: array
#endif
    INTEGER :: i1, d1s, d1e
    INTEGER :: i2, d2s, d2e
    INTEGER :: i3, d3s, d3e
    !
    d1s = range1(1)
    d1e = range1(2)
    d2s = range2(1)
    d2e = range2(2)
    d3s = range3(1)
    d3e = range3(2)
    !
    !$cuf kernel do(3)
    DO i3 = d3s, d3e
    DO i2 = d2s, d2e
    DO i1 = d1s, d1e
       array(i1,i2,i3) = conjg(array(i1,i2,i3))
    ENDDO
    ENDDO
    ENDDO
    !
  END SUBROUTINE cuf_conjg_c3d
  !
  SUBROUTINE cuf_conjg_c4d(array, range1, range2, range3, range4)
    IMPLICIT NONE
    COMPLEX(SP), INTENT(INOUT) :: array(:,:,:,:)
    INTEGER,     INTENT(IN) ::  range1(2)
    INTEGER,     INTENT(IN) ::  range2(2)
    INTEGER,     INTENT(IN) ::  range3(2)
    INTEGER,     INTENT(IN) ::  range4(2)
#if defined(__CUDA)
    attributes(DEVICE) :: array
#endif
    INTEGER :: i1, d1s, d1e
    INTEGER :: i2, d2s, d2e
    INTEGER :: i3, d3s, d3e
    INTEGER :: i4, d4s, d4e
    !
    d1s = range1(1)
    d1e = range1(2)
    d2s = range2(1)
    d2e = range2(2)
    d3s = range3(1)
    d3e = range3(2)
    d4s = range4(1)
    d4e = range4(2)
    !
    !$cuf kernel do(4)
    DO i4 = d4s, d4e
    DO i3 = d3s, d3e
    DO i2 = d2s, d2e
    DO i1 = d1s, d1e
       array(i1,i2,i3,i4) = conjg(array(i1,i2,i3,i4))
    ENDDO
    ENDDO
    ENDDO
    ENDDO
    !
  END SUBROUTINE cuf_conjg_c4d
  !
END MODULE dev_util_m
!
!
! === TEMPLATE USED TO GENERATE THIS FILE ===
!
!    MODULE cuda_util
!      !
!      USE util_param,   ONLY : SP
!      !
!      IMPLICIT NONE
!      !
!      PUBLIC :: cuf_memcpy, cuf_memset
!      !
!      INTERFACE cuf_memcpy
!        MODULE PROCEDURE &
!          {%- for t in types %}
!          {%- for d in range(dimensions) %}
!          cuf_memcpy_{{t[0]|lower}}{{d+1}}d{% if not loop.last %}, &{%- endif %}
!          {%- endfor %}{% if not loop.last %}, &{%- endif %}
!          {%- endfor %}
!      END INTERFACE
!      !
!      INTERFACE cuf_memset
!        MODULE PROCEDURE &
!          {%- for t in types %}
!          {%- for d in range(dimensions) %}
!          cuf_memset_{{t[0]|lower}}{{d+1}}d{% if not loop.last %}, &{%- endif %}
!          {%- endfor %}{% if not loop.last %}, &{%- endif %}
!          {%- endfor %}
!      END INTERFACE
!      !
!      CONTAINS
!      !
!    {%- for t in types %}
!    {%- for d in range(1,dimensions+1) %}
!      SUBROUTINE cuf_memcpy_{{t[0]|lower}}{{d}}d(array_out, array_in,{% for dd in range(d) %} {{ "range%s"|format(dd+1) }}{% if not loop.last %}, {%- endif %}{% endfor %} )
!        !
!        IMPLICIT NONE
!        !
!        {{t}}(SP), INTENT(INOUT) :: array_out({% for dd in range(d) %}:{% if not loop.last %}, {%- endif %}{% endfor %})
!        {{t}}(SP), INTENT(IN) :: array_in({% for dd in range(d) %}:{% if not loop.last %}, {%- endif %}{% endfor %})
!        INTEGER, INTENT(IN) :: {% for dd in range(d) %} {{ "range%s(2)"|format(dd+1) }}{% if not loop.last %}, {%- endif %}{% endfor %}
!        !
!    #if defined(__CUDA)
!        attributes(DEVICE) :: array_out, array_in
!    #endif
!        !
!    {%- for dd in range(d) %}
!        INTEGER :: i{{dd+1}}, d{{dd+1}}s, d{{dd+1}}e
!    {%- endfor %}
!        !
!    {%- for dd in range(d) %}
!        d{{dd+1}}s = range{{dd+1}}(1)
!        d{{dd+1}}e = range{{dd+1}}(2)
!    {%- endfor %}
!        !
!        !$cuf kernel do({{d}})
!    {%- for dd in range(d,0,-1) %}
!        DO i{{dd}} = d{{dd}}s, d{{dd}}e
!    {%- endfor %}
!           array_out( {%- for dd in range(d) %}i{{dd+1}}{% if not loop.last %}, {%- endif %} {%- endfor %} ) = array_in( {%- for dd in range(d) %}i{{dd+1}}{% if not loop.last %}, {%- endif %} {%- endfor %} )
!    {%- for dd in range(d) %}
!        ENDDO
!    {%- endfor %}
!        !
!      END SUBROUTINE cuf_memcpy_{{t[0]|lower}}{{d}}d
!      !
!    {%- endfor %}
!    {%- endfor %}
!      !
!    {%- for t in types %}
!    {%- for d in range(1,dimensions+1) %}
!      SUBROUTINE cuf_memset_{{t[0]|lower}}{{d}}d(array_out, val,{% for dd in range(d) %} {{ "range%s"|format(dd+1) }}{% if not loop.last %}, {%- endif %}{% endfor %} )
!        !
!        IMPLICIT NONE
!        !
!        {{t}}(SP), INTENT(INOUT) :: array_out({% for dd in range(d) %}:{% if not loop.last %}, {%- endif %}{% endfor %})
!        {{t}}(SP), INTENT(IN) :: val
!        INTEGER, INTENT(IN) :: {% for dd in range(d) %} {{ "range%s(2)"|format(dd+1) }}{% if not loop.last %}, {%- endif %}{% endfor %}
!        !
!    #if defined(__CUDA)
!        attributes(DEVICE) :: array_out
!    #endif
!        !
!    {%- for dd in range(d) %}
!        INTEGER :: i{{dd+1}}, d{{dd+1}}s, d{{dd+1}}e
!    {%- endfor %}
!        !
!    {%- for dd in range(d) %}
!        d{{dd+1}}s = range{{dd+1}}(1)
!        d{{dd+1}}e = range{{dd+1}}(2)
!    {%- endfor %}
!        !
!        !$cuf kernel do({{d}})
!    {%- for dd in range(d,0,-1) %}
!        DO i{{dd}} = d{{dd}}s, d{{dd}}e
!    {%- endfor %}
!           array_out( {%- for dd in range(d) %}i{{dd+1}}{% if not loop.last %}, {%- endif %} {%- endfor %} ) = val
!    {%- for dd in range(d) %}
!        ENDDO
!    {%- endfor %}
!        !
!      END SUBROUTINE cuf_memset_{{t[0]|lower}}{{d}}d
!      !
!    {%- endfor %}
!    {%- endfor %}
!    END MODULE cuda_util
!
! === CODE TO GENERATE THE f90 FILE ===
!
!import sys, os, jinja2
!
!def render(tpl_path, context):
!    path, filename = os.path.split(tpl_path)
!    return jinja2.Environment(undefined=jinja2.StrictUndefined,
!        loader=jinja2.FileSystemLoader(path or './')
!    ).get_template(filename).render(context)
!with open('cuda_util.f90', 'w') as f: f.write(render('cuda_util.jf90', {'types': ['REAL', 'COMPLEX'], 'dimensions': 3}))
!

!
! Copyright (C) 2021, MaX CoE
! Distributed under the MIT License
! (license terms are at http://opensource.org/licenses/MIT).
!
!--
!
! Definitions and utilities to handle async_id, which maps
! to CUDA stream (when using DXL_CUF), or OpenACC queues
!
#include<devxlib_defs.h>

module devxlib_async

   use iso_c_binding,       only : c_int, c_intptr_t
   use devxlib_environment, only : devxlib_error
   !
#if defined __DXL_CUDAF
   use cudafor
#elif defined __DXL_OPENACC
   use openacc
   use devxlib_environment, only : cudaStreamSynchronize, cudaDeviceSynchronize,&
                                   acc_get_cuda_stream_f
#endif
   !
   implicit none
   private
   !
   ! In the following dxl_async_kind is meant to represent
   ! - CUDA Streams    if CUDAF is used
   ! - ApenACC Queues  id OPENACC is used
   !
#if defined __DXL_CUDAF
   integer, parameter :: dxl_async_kind  = cuda_Stream_Kind
   integer, parameter :: dxl_stream_kind = cuda_Stream_Kind
#elif defined __DXL_OPENACC
   integer, parameter :: dxl_async_kind  = kind(acc_async_noval)
   integer, parameter :: dxl_stream_kind = c_intptr_t
#else
   integer, parameter :: dxl_async_kind  = kind(0)
   integer, parameter :: dxl_stream_kind = c_intptr_t
#endif
   !
   public :: dxl_async_kind 
   public :: dxl_stream_kind 
   public :: devxlib_async_create
   public :: devxlib_async_synchronize
   public :: devxlib_async2stream
   public :: devxlib_device_sync

contains

      subroutine devxlib_async_create(async_id,val,default_async)
         implicit none
         integer(kind=dxl_async_kind),        intent(inout) :: async_id
         integer(kind=dxl_async_kind), optional, intent(in) :: val 
         logical,                      optional, intent(in) :: default_async
         !   
         integer :: ierr
         logical :: set_default_async
         !   
         ierr=0
         async_id=0
         set_default_async=.false.
         if (present(default_async)) set_default_async=default_async
         !   
#if defined __DXL_CUDAF
         if (set_default_async) then
            async_id=cudaforGetDefaultStream()
         else if (present(val)) then
            async_id=val
         else
            !ierr = CudaStreamCreate(async_id)
            ierr = CudaStreamCreateWithFlags(async_id,cudaStreamNonBlocking)
         endif
         !
#elif defined __DXL_OPENACC
         if (set_default_async) then
            async_id=acc_async_sync
         else if (present(val)) then
            async_id=val
         else
            call devxlib_error("devxlib_async_create","unable to create queue",1)
         endif
#endif
         return
      end subroutine devxlib_async_create
      !
      !
      subroutine devxlib_async_synchronize(async_id)
         implicit none
         integer(kind=dxl_async_kind), intent(in) :: async_id
         integer :: ierr
         !   
         ierr=0
#if defined __DXL_CUDAF
         ierr = CudaStreamSynchronize(async_id)
#elif defined __DXL_OPENACC
         !DEV_ACC wait(async_id)
         !!call acc_wait(async_id)
#endif
         return
      end subroutine devxlib_async_synchronize
      !
      !
      function devxlib_async2stream(async_id) result(stream)
         implicit none
         integer(kind=dxl_async_kind), intent(in) :: async_id
         integer(kind=dxl_stream_kind) :: stream
         !
         stream=0
#if defined __DXL_CUDAF
         stream=async_id
#elif defined __DXL_OPENACC
#  if defined __PGI
         ! acc_get_cuda_stream not defined eg by GNU compilers
         stream=acc_get_cuda_stream(async_id)
#  else
         ! replace with hand-made c-binding interface
         stream=int( acc_get_cuda_stream_f(async_id), kind=dxl_stream_kind )
         !
         ! incorrect place-holder
         !stream=int(async_id,kind=dxl_stream_kind)
#  endif
#endif
         return
      end function devxlib_async2stream
      !
      !
      function devxlib_device_sync() result(ierr)
         implicit none
         integer :: ierr 
         !   
         ierr=0
#if defined __DXL_CUDAF
         ierr = CudaDeviceSynchronize()
#elif defined __DXL_OPENACC
         ierr = CudaDeviceSynchronize()
#endif
      end function devxlib_device_sync

end module devxlib_async

!
! Copyright (C) 2021, MaX CoE
! Distributed under the MIT License 
! (license terms are at http://opensource.org/licenses/MIT).
!
!--
!
! Auxiliary functions
!
! AF: OpenACC support is incomplete !!
!
!==================================================================
!==================================================================
! *DO NOT EDIT*: automatically generated from devxlib_auxfunc_addscal.jf90
!==================================================================
!==================================================================
!
#include<devxlib_macros.h>
#include<devxlib_defs.h>
!
!=======================================
!
submodule (devxlib_auxfunc) devxlib_auxfunc_addscal

   implicit none

   contains
      module subroutine dp_devxlib_mem_addscal_r1d(array_out, array_in, scal, &
                                                  range1, lbound1 )
         use iso_fortran_env
         implicit none
         !
         real(real64), intent(inout) DEV_ATTR :: array_out(:)
         real(real64), intent(in)    DEV_ATTR :: array_in(:)
         real(real64), optional, intent(in) :: scal
         integer, optional, intent(in) ::  range1(2)
         integer, optional, intent(in) ::  lbound1
         !
         real(real64) :: scal_ = 1.0
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         if (present(scal)) scal_=scal
         !
         !DEV_CUF kernel do(1)
         do i1 = d1s, d1e
            array_out(i1 ) = &
                array_out(i1 ) + &
                scal_*array_in(i1 )
         enddo
         !
      end subroutine dp_devxlib_mem_addscal_r1d
      !
      module subroutine dp_devxlib_mem_addscal_r2d(array_out, array_in, scal, &
                                                  range1, lbound1, &
                                                  range2, lbound2 )
         use iso_fortran_env
         implicit none
         !
         real(real64), intent(inout) DEV_ATTR :: array_out(:,:)
         real(real64), intent(in)    DEV_ATTR :: array_in(:,:)
         real(real64), optional, intent(in) :: scal
         integer, optional, intent(in) ::  range1(2), range2(2)
         integer, optional, intent(in) ::  lbound1, lbound2
         !
         real(real64) :: scal_ = 1.0
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         if (present(scal)) scal_=scal
         !
         !DEV_CUF kernel do(2)
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2 ) = &
                array_out(i1,i2 ) + &
                scal_*array_in(i1,i2 )
         enddo
         enddo
         !
      end subroutine dp_devxlib_mem_addscal_r2d
      !
      module subroutine dp_devxlib_mem_addscal_r3d(array_out, array_in, scal, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3 )
         use iso_fortran_env
         implicit none
         !
         real(real64), intent(inout) DEV_ATTR :: array_out(:,:,:)
         real(real64), intent(in)    DEV_ATTR :: array_in(:,:,:)
         real(real64), optional, intent(in) :: scal
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3
         !
         real(real64) :: scal_ = 1.0
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         if (present(scal)) scal_=scal
         !
         !DEV_CUF kernel do(3)
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3 ) = &
                array_out(i1,i2,i3 ) + &
                scal_*array_in(i1,i2,i3 )
         enddo
         enddo
         enddo
         !
      end subroutine dp_devxlib_mem_addscal_r3d
      !
      module subroutine dp_devxlib_mem_addscal_r4d(array_out, array_in, scal, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3, &
                                                  range4, lbound4 )
         use iso_fortran_env
         implicit none
         !
         real(real64), intent(inout) DEV_ATTR :: array_out(:,:,:,:)
         real(real64), intent(in)    DEV_ATTR :: array_in(:,:,:,:)
         real(real64), optional, intent(in) :: scal
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
         !
         real(real64) :: scal_ = 1.0
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(array_out, 4)/)
         if (present(range4)) range4_=range4 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         if (present(scal)) scal_=scal
         !
         !DEV_CUF kernel do(4)
         do i4 = d4s, d4e
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3,i4 ) = &
                array_out(i1,i2,i3,i4 ) + &
                scal_*array_in(i1,i2,i3,i4 )
         enddo
         enddo
         enddo
         enddo
         !
      end subroutine dp_devxlib_mem_addscal_r4d
      !
      module subroutine dp_devxlib_mem_addscal_r5d(array_out, array_in, scal, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3, &
                                                  range4, lbound4, &
                                                  range5, lbound5 )
         use iso_fortran_env
         implicit none
         !
         real(real64), intent(inout) DEV_ATTR :: array_out(:,:,:,:,:)
         real(real64), intent(in)    DEV_ATTR :: array_in(:,:,:,:,:)
         real(real64), optional, intent(in) :: scal
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5
         !
         real(real64) :: scal_ = 1.0
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         integer :: i5, d5s, d5e
         integer :: lbound5_, range5_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(array_out, 4)/)
         if (present(range4)) range4_=range4 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         lbound5_=1
         if (present(lbound5)) lbound5_=lbound5 
         range5_=(/1,size(array_out, 5)/)
         if (present(range5)) range5_=range5 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d5s = range5_(1) -lbound5_ +1
         d5e = range5_(2) -lbound5_ +1
         !
         if (present(scal)) scal_=scal
         !
         !DEV_CUF kernel do(5)
         do i5 = d5s, d5e
         do i4 = d4s, d4e
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3,i4,i5 ) = &
                array_out(i1,i2,i3,i4,i5 ) + &
                scal_*array_in(i1,i2,i3,i4,i5 )
         enddo
         enddo
         enddo
         enddo
         enddo
         !
      end subroutine dp_devxlib_mem_addscal_r5d
      !
      module subroutine dp_devxlib_mem_addscal_r6d(array_out, array_in, scal, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3, &
                                                  range4, lbound4, &
                                                  range5, lbound5, &
                                                  range6, lbound6 )
         use iso_fortran_env
         implicit none
         !
         real(real64), intent(inout) DEV_ATTR :: array_out(:,:,:,:,:,:)
         real(real64), intent(in)    DEV_ATTR :: array_in(:,:,:,:,:,:)
         real(real64), optional, intent(in) :: scal
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2), range6(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5, lbound6
         !
         real(real64) :: scal_ = 1.0
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         integer :: i5, d5s, d5e
         integer :: lbound5_, range5_(2)
         integer :: i6, d6s, d6e
         integer :: lbound6_, range6_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(array_out, 4)/)
         if (present(range4)) range4_=range4 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         lbound5_=1
         if (present(lbound5)) lbound5_=lbound5 
         range5_=(/1,size(array_out, 5)/)
         if (present(range5)) range5_=range5 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d5s = range5_(1) -lbound5_ +1
         d5e = range5_(2) -lbound5_ +1
         !
         lbound6_=1
         if (present(lbound6)) lbound6_=lbound6 
         range6_=(/1,size(array_out, 6)/)
         if (present(range6)) range6_=range6 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d6s = range6_(1) -lbound6_ +1
         d6e = range6_(2) -lbound6_ +1
         !
         if (present(scal)) scal_=scal
         !
         !DEV_CUF kernel do(6)
         do i6 = d6s, d6e
         do i5 = d5s, d5e
         do i4 = d4s, d4e
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3,i4,i5,i6 ) = &
                array_out(i1,i2,i3,i4,i5,i6 ) + &
                scal_*array_in(i1,i2,i3,i4,i5,i6 )
         enddo
         enddo
         enddo
         enddo
         enddo
         enddo
         !
      end subroutine dp_devxlib_mem_addscal_r6d
      !
      module subroutine sp_devxlib_mem_addscal_r1d(array_out, array_in, scal, &
                                                  range1, lbound1 )
         use iso_fortran_env
         implicit none
         !
         real(real32), intent(inout) DEV_ATTR :: array_out(:)
         real(real32), intent(in)    DEV_ATTR :: array_in(:)
         real(real32), optional, intent(in) :: scal
         integer, optional, intent(in) ::  range1(2)
         integer, optional, intent(in) ::  lbound1
         !
         real(real32) :: scal_ = 1.0
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         if (present(scal)) scal_=scal
         !
         !DEV_CUF kernel do(1)
         do i1 = d1s, d1e
            array_out(i1 ) = &
                array_out(i1 ) + &
                scal_*array_in(i1 )
         enddo
         !
      end subroutine sp_devxlib_mem_addscal_r1d
      !
      module subroutine sp_devxlib_mem_addscal_r2d(array_out, array_in, scal, &
                                                  range1, lbound1, &
                                                  range2, lbound2 )
         use iso_fortran_env
         implicit none
         !
         real(real32), intent(inout) DEV_ATTR :: array_out(:,:)
         real(real32), intent(in)    DEV_ATTR :: array_in(:,:)
         real(real32), optional, intent(in) :: scal
         integer, optional, intent(in) ::  range1(2), range2(2)
         integer, optional, intent(in) ::  lbound1, lbound2
         !
         real(real32) :: scal_ = 1.0
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         if (present(scal)) scal_=scal
         !
         !DEV_CUF kernel do(2)
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2 ) = &
                array_out(i1,i2 ) + &
                scal_*array_in(i1,i2 )
         enddo
         enddo
         !
      end subroutine sp_devxlib_mem_addscal_r2d
      !
      module subroutine sp_devxlib_mem_addscal_r3d(array_out, array_in, scal, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3 )
         use iso_fortran_env
         implicit none
         !
         real(real32), intent(inout) DEV_ATTR :: array_out(:,:,:)
         real(real32), intent(in)    DEV_ATTR :: array_in(:,:,:)
         real(real32), optional, intent(in) :: scal
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3
         !
         real(real32) :: scal_ = 1.0
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         if (present(scal)) scal_=scal
         !
         !DEV_CUF kernel do(3)
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3 ) = &
                array_out(i1,i2,i3 ) + &
                scal_*array_in(i1,i2,i3 )
         enddo
         enddo
         enddo
         !
      end subroutine sp_devxlib_mem_addscal_r3d
      !
      module subroutine sp_devxlib_mem_addscal_r4d(array_out, array_in, scal, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3, &
                                                  range4, lbound4 )
         use iso_fortran_env
         implicit none
         !
         real(real32), intent(inout) DEV_ATTR :: array_out(:,:,:,:)
         real(real32), intent(in)    DEV_ATTR :: array_in(:,:,:,:)
         real(real32), optional, intent(in) :: scal
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
         !
         real(real32) :: scal_ = 1.0
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(array_out, 4)/)
         if (present(range4)) range4_=range4 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         if (present(scal)) scal_=scal
         !
         !DEV_CUF kernel do(4)
         do i4 = d4s, d4e
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3,i4 ) = &
                array_out(i1,i2,i3,i4 ) + &
                scal_*array_in(i1,i2,i3,i4 )
         enddo
         enddo
         enddo
         enddo
         !
      end subroutine sp_devxlib_mem_addscal_r4d
      !
      module subroutine sp_devxlib_mem_addscal_r5d(array_out, array_in, scal, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3, &
                                                  range4, lbound4, &
                                                  range5, lbound5 )
         use iso_fortran_env
         implicit none
         !
         real(real32), intent(inout) DEV_ATTR :: array_out(:,:,:,:,:)
         real(real32), intent(in)    DEV_ATTR :: array_in(:,:,:,:,:)
         real(real32), optional, intent(in) :: scal
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5
         !
         real(real32) :: scal_ = 1.0
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         integer :: i5, d5s, d5e
         integer :: lbound5_, range5_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(array_out, 4)/)
         if (present(range4)) range4_=range4 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         lbound5_=1
         if (present(lbound5)) lbound5_=lbound5 
         range5_=(/1,size(array_out, 5)/)
         if (present(range5)) range5_=range5 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d5s = range5_(1) -lbound5_ +1
         d5e = range5_(2) -lbound5_ +1
         !
         if (present(scal)) scal_=scal
         !
         !DEV_CUF kernel do(5)
         do i5 = d5s, d5e
         do i4 = d4s, d4e
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3,i4,i5 ) = &
                array_out(i1,i2,i3,i4,i5 ) + &
                scal_*array_in(i1,i2,i3,i4,i5 )
         enddo
         enddo
         enddo
         enddo
         enddo
         !
      end subroutine sp_devxlib_mem_addscal_r5d
      !
      module subroutine sp_devxlib_mem_addscal_r6d(array_out, array_in, scal, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3, &
                                                  range4, lbound4, &
                                                  range5, lbound5, &
                                                  range6, lbound6 )
         use iso_fortran_env
         implicit none
         !
         real(real32), intent(inout) DEV_ATTR :: array_out(:,:,:,:,:,:)
         real(real32), intent(in)    DEV_ATTR :: array_in(:,:,:,:,:,:)
         real(real32), optional, intent(in) :: scal
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2), range6(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5, lbound6
         !
         real(real32) :: scal_ = 1.0
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         integer :: i5, d5s, d5e
         integer :: lbound5_, range5_(2)
         integer :: i6, d6s, d6e
         integer :: lbound6_, range6_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(array_out, 4)/)
         if (present(range4)) range4_=range4 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         lbound5_=1
         if (present(lbound5)) lbound5_=lbound5 
         range5_=(/1,size(array_out, 5)/)
         if (present(range5)) range5_=range5 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d5s = range5_(1) -lbound5_ +1
         d5e = range5_(2) -lbound5_ +1
         !
         lbound6_=1
         if (present(lbound6)) lbound6_=lbound6 
         range6_=(/1,size(array_out, 6)/)
         if (present(range6)) range6_=range6 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d6s = range6_(1) -lbound6_ +1
         d6e = range6_(2) -lbound6_ +1
         !
         if (present(scal)) scal_=scal
         !
         !DEV_CUF kernel do(6)
         do i6 = d6s, d6e
         do i5 = d5s, d5e
         do i4 = d4s, d4e
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3,i4,i5,i6 ) = &
                array_out(i1,i2,i3,i4,i5,i6 ) + &
                scal_*array_in(i1,i2,i3,i4,i5,i6 )
         enddo
         enddo
         enddo
         enddo
         enddo
         enddo
         !
      end subroutine sp_devxlib_mem_addscal_r6d
      !
      module subroutine dp_devxlib_mem_addscal_c1d(array_out, array_in, scal, &
                                                  range1, lbound1 )
         use iso_fortran_env
         implicit none
         !
         complex(real64), intent(inout) DEV_ATTR :: array_out(:)
         complex(real64), intent(in)    DEV_ATTR :: array_in(:)
         complex(real64), optional, intent(in) :: scal
         integer, optional, intent(in) ::  range1(2)
         integer, optional, intent(in) ::  lbound1
         !
         complex(real64) :: scal_ = (1.0, 0.0)
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         if (present(scal)) scal_=scal
         !
         !DEV_CUF kernel do(1)
         do i1 = d1s, d1e
            array_out(i1 ) = &
                array_out(i1 ) + &
                scal_*array_in(i1 )
         enddo
         !
      end subroutine dp_devxlib_mem_addscal_c1d
      !
      module subroutine dp_devxlib_mem_addscal_c2d(array_out, array_in, scal, &
                                                  range1, lbound1, &
                                                  range2, lbound2 )
         use iso_fortran_env
         implicit none
         !
         complex(real64), intent(inout) DEV_ATTR :: array_out(:,:)
         complex(real64), intent(in)    DEV_ATTR :: array_in(:,:)
         complex(real64), optional, intent(in) :: scal
         integer, optional, intent(in) ::  range1(2), range2(2)
         integer, optional, intent(in) ::  lbound1, lbound2
         !
         complex(real64) :: scal_ = (1.0, 0.0)
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         if (present(scal)) scal_=scal
         !
         !DEV_CUF kernel do(2)
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2 ) = &
                array_out(i1,i2 ) + &
                scal_*array_in(i1,i2 )
         enddo
         enddo
         !
      end subroutine dp_devxlib_mem_addscal_c2d
      !
      module subroutine dp_devxlib_mem_addscal_c3d(array_out, array_in, scal, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3 )
         use iso_fortran_env
         implicit none
         !
         complex(real64), intent(inout) DEV_ATTR :: array_out(:,:,:)
         complex(real64), intent(in)    DEV_ATTR :: array_in(:,:,:)
         complex(real64), optional, intent(in) :: scal
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3
         !
         complex(real64) :: scal_ = (1.0, 0.0)
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         if (present(scal)) scal_=scal
         !
         !DEV_CUF kernel do(3)
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3 ) = &
                array_out(i1,i2,i3 ) + &
                scal_*array_in(i1,i2,i3 )
         enddo
         enddo
         enddo
         !
      end subroutine dp_devxlib_mem_addscal_c3d
      !
      module subroutine dp_devxlib_mem_addscal_c4d(array_out, array_in, scal, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3, &
                                                  range4, lbound4 )
         use iso_fortran_env
         implicit none
         !
         complex(real64), intent(inout) DEV_ATTR :: array_out(:,:,:,:)
         complex(real64), intent(in)    DEV_ATTR :: array_in(:,:,:,:)
         complex(real64), optional, intent(in) :: scal
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
         !
         complex(real64) :: scal_ = (1.0, 0.0)
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(array_out, 4)/)
         if (present(range4)) range4_=range4 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         if (present(scal)) scal_=scal
         !
         !DEV_CUF kernel do(4)
         do i4 = d4s, d4e
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3,i4 ) = &
                array_out(i1,i2,i3,i4 ) + &
                scal_*array_in(i1,i2,i3,i4 )
         enddo
         enddo
         enddo
         enddo
         !
      end subroutine dp_devxlib_mem_addscal_c4d
      !
      module subroutine dp_devxlib_mem_addscal_c5d(array_out, array_in, scal, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3, &
                                                  range4, lbound4, &
                                                  range5, lbound5 )
         use iso_fortran_env
         implicit none
         !
         complex(real64), intent(inout) DEV_ATTR :: array_out(:,:,:,:,:)
         complex(real64), intent(in)    DEV_ATTR :: array_in(:,:,:,:,:)
         complex(real64), optional, intent(in) :: scal
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5
         !
         complex(real64) :: scal_ = (1.0, 0.0)
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         integer :: i5, d5s, d5e
         integer :: lbound5_, range5_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(array_out, 4)/)
         if (present(range4)) range4_=range4 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         lbound5_=1
         if (present(lbound5)) lbound5_=lbound5 
         range5_=(/1,size(array_out, 5)/)
         if (present(range5)) range5_=range5 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d5s = range5_(1) -lbound5_ +1
         d5e = range5_(2) -lbound5_ +1
         !
         if (present(scal)) scal_=scal
         !
         !DEV_CUF kernel do(5)
         do i5 = d5s, d5e
         do i4 = d4s, d4e
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3,i4,i5 ) = &
                array_out(i1,i2,i3,i4,i5 ) + &
                scal_*array_in(i1,i2,i3,i4,i5 )
         enddo
         enddo
         enddo
         enddo
         enddo
         !
      end subroutine dp_devxlib_mem_addscal_c5d
      !
      module subroutine dp_devxlib_mem_addscal_c6d(array_out, array_in, scal, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3, &
                                                  range4, lbound4, &
                                                  range5, lbound5, &
                                                  range6, lbound6 )
         use iso_fortran_env
         implicit none
         !
         complex(real64), intent(inout) DEV_ATTR :: array_out(:,:,:,:,:,:)
         complex(real64), intent(in)    DEV_ATTR :: array_in(:,:,:,:,:,:)
         complex(real64), optional, intent(in) :: scal
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2), range6(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5, lbound6
         !
         complex(real64) :: scal_ = (1.0, 0.0)
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         integer :: i5, d5s, d5e
         integer :: lbound5_, range5_(2)
         integer :: i6, d6s, d6e
         integer :: lbound6_, range6_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(array_out, 4)/)
         if (present(range4)) range4_=range4 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         lbound5_=1
         if (present(lbound5)) lbound5_=lbound5 
         range5_=(/1,size(array_out, 5)/)
         if (present(range5)) range5_=range5 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d5s = range5_(1) -lbound5_ +1
         d5e = range5_(2) -lbound5_ +1
         !
         lbound6_=1
         if (present(lbound6)) lbound6_=lbound6 
         range6_=(/1,size(array_out, 6)/)
         if (present(range6)) range6_=range6 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d6s = range6_(1) -lbound6_ +1
         d6e = range6_(2) -lbound6_ +1
         !
         if (present(scal)) scal_=scal
         !
         !DEV_CUF kernel do(6)
         do i6 = d6s, d6e
         do i5 = d5s, d5e
         do i4 = d4s, d4e
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3,i4,i5,i6 ) = &
                array_out(i1,i2,i3,i4,i5,i6 ) + &
                scal_*array_in(i1,i2,i3,i4,i5,i6 )
         enddo
         enddo
         enddo
         enddo
         enddo
         enddo
         !
      end subroutine dp_devxlib_mem_addscal_c6d
      !
      module subroutine sp_devxlib_mem_addscal_c1d(array_out, array_in, scal, &
                                                  range1, lbound1 )
         use iso_fortran_env
         implicit none
         !
         complex(real32), intent(inout) DEV_ATTR :: array_out(:)
         complex(real32), intent(in)    DEV_ATTR :: array_in(:)
         complex(real32), optional, intent(in) :: scal
         integer, optional, intent(in) ::  range1(2)
         integer, optional, intent(in) ::  lbound1
         !
         complex(real32) :: scal_ = (1.0, 0.0)
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         if (present(scal)) scal_=scal
         !
         !DEV_CUF kernel do(1)
         do i1 = d1s, d1e
            array_out(i1 ) = &
                array_out(i1 ) + &
                scal_*array_in(i1 )
         enddo
         !
      end subroutine sp_devxlib_mem_addscal_c1d
      !
      module subroutine sp_devxlib_mem_addscal_c2d(array_out, array_in, scal, &
                                                  range1, lbound1, &
                                                  range2, lbound2 )
         use iso_fortran_env
         implicit none
         !
         complex(real32), intent(inout) DEV_ATTR :: array_out(:,:)
         complex(real32), intent(in)    DEV_ATTR :: array_in(:,:)
         complex(real32), optional, intent(in) :: scal
         integer, optional, intent(in) ::  range1(2), range2(2)
         integer, optional, intent(in) ::  lbound1, lbound2
         !
         complex(real32) :: scal_ = (1.0, 0.0)
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         if (present(scal)) scal_=scal
         !
         !DEV_CUF kernel do(2)
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2 ) = &
                array_out(i1,i2 ) + &
                scal_*array_in(i1,i2 )
         enddo
         enddo
         !
      end subroutine sp_devxlib_mem_addscal_c2d
      !
      module subroutine sp_devxlib_mem_addscal_c3d(array_out, array_in, scal, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3 )
         use iso_fortran_env
         implicit none
         !
         complex(real32), intent(inout) DEV_ATTR :: array_out(:,:,:)
         complex(real32), intent(in)    DEV_ATTR :: array_in(:,:,:)
         complex(real32), optional, intent(in) :: scal
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3
         !
         complex(real32) :: scal_ = (1.0, 0.0)
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         if (present(scal)) scal_=scal
         !
         !DEV_CUF kernel do(3)
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3 ) = &
                array_out(i1,i2,i3 ) + &
                scal_*array_in(i1,i2,i3 )
         enddo
         enddo
         enddo
         !
      end subroutine sp_devxlib_mem_addscal_c3d
      !
      module subroutine sp_devxlib_mem_addscal_c4d(array_out, array_in, scal, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3, &
                                                  range4, lbound4 )
         use iso_fortran_env
         implicit none
         !
         complex(real32), intent(inout) DEV_ATTR :: array_out(:,:,:,:)
         complex(real32), intent(in)    DEV_ATTR :: array_in(:,:,:,:)
         complex(real32), optional, intent(in) :: scal
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
         !
         complex(real32) :: scal_ = (1.0, 0.0)
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(array_out, 4)/)
         if (present(range4)) range4_=range4 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         if (present(scal)) scal_=scal
         !
         !DEV_CUF kernel do(4)
         do i4 = d4s, d4e
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3,i4 ) = &
                array_out(i1,i2,i3,i4 ) + &
                scal_*array_in(i1,i2,i3,i4 )
         enddo
         enddo
         enddo
         enddo
         !
      end subroutine sp_devxlib_mem_addscal_c4d
      !
      module subroutine sp_devxlib_mem_addscal_c5d(array_out, array_in, scal, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3, &
                                                  range4, lbound4, &
                                                  range5, lbound5 )
         use iso_fortran_env
         implicit none
         !
         complex(real32), intent(inout) DEV_ATTR :: array_out(:,:,:,:,:)
         complex(real32), intent(in)    DEV_ATTR :: array_in(:,:,:,:,:)
         complex(real32), optional, intent(in) :: scal
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5
         !
         complex(real32) :: scal_ = (1.0, 0.0)
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         integer :: i5, d5s, d5e
         integer :: lbound5_, range5_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(array_out, 4)/)
         if (present(range4)) range4_=range4 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         lbound5_=1
         if (present(lbound5)) lbound5_=lbound5 
         range5_=(/1,size(array_out, 5)/)
         if (present(range5)) range5_=range5 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d5s = range5_(1) -lbound5_ +1
         d5e = range5_(2) -lbound5_ +1
         !
         if (present(scal)) scal_=scal
         !
         !DEV_CUF kernel do(5)
         do i5 = d5s, d5e
         do i4 = d4s, d4e
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3,i4,i5 ) = &
                array_out(i1,i2,i3,i4,i5 ) + &
                scal_*array_in(i1,i2,i3,i4,i5 )
         enddo
         enddo
         enddo
         enddo
         enddo
         !
      end subroutine sp_devxlib_mem_addscal_c5d
      !
      module subroutine sp_devxlib_mem_addscal_c6d(array_out, array_in, scal, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3, &
                                                  range4, lbound4, &
                                                  range5, lbound5, &
                                                  range6, lbound6 )
         use iso_fortran_env
         implicit none
         !
         complex(real32), intent(inout) DEV_ATTR :: array_out(:,:,:,:,:,:)
         complex(real32), intent(in)    DEV_ATTR :: array_in(:,:,:,:,:,:)
         complex(real32), optional, intent(in) :: scal
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2), range6(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5, lbound6
         !
         complex(real32) :: scal_ = (1.0, 0.0)
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         integer :: i5, d5s, d5e
         integer :: lbound5_, range5_(2)
         integer :: i6, d6s, d6e
         integer :: lbound6_, range6_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_out, 1)/)
         if (present(range1)) range1_=range1 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_out, 2)/)
         if (present(range2)) range2_=range2 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_out, 3)/)
         if (present(range3)) range3_=range3 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(array_out, 4)/)
         if (present(range4)) range4_=range4 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         lbound5_=1
         if (present(lbound5)) lbound5_=lbound5 
         range5_=(/1,size(array_out, 5)/)
         if (present(range5)) range5_=range5 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d5s = range5_(1) -lbound5_ +1
         d5e = range5_(2) -lbound5_ +1
         !
         lbound6_=1
         if (present(lbound6)) lbound6_=lbound6 
         range6_=(/1,size(array_out, 6)/)
         if (present(range6)) range6_=range6 
         !
         ! the lower bound of the assumed shape array passed to the subroutine is 1
         ! lbound and range instead refer to the indexing in the parent caller.
         d6s = range6_(1) -lbound6_ +1
         d6e = range6_(2) -lbound6_ +1
         !
         if (present(scal)) scal_=scal
         !
         !DEV_CUF kernel do(6)
         do i6 = d6s, d6e
         do i5 = d5s, d5e
         do i4 = d4s, d4e
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_out(i1,i2,i3,i4,i5,i6 ) = &
                array_out(i1,i2,i3,i4,i5,i6 ) + &
                scal_*array_in(i1,i2,i3,i4,i5,i6 )
         enddo
         enddo
         enddo
         enddo
         enddo
         enddo
         !
      end subroutine sp_devxlib_mem_addscal_c6d
      !

end submodule devxlib_auxfunc_addscal

!
! Copyright (C) 2021, MaX CoE
! Distributed under the MIT License
! (license terms are at http://opensource.org/licenses/MIT).
!
!--
!
! Testing: Linear Algebra interfaces and wrappers
!
#include<devxlib_macros.h>
#include<devxlib_defs.h>
!
program test_linalg
  !
  use iso_fortran_env
  use iso_c_binding
  use devxlib_linalg
  use devxlib_memcpy
  use devxlib_mapping
  use devxlib_async
  use myprof
  !
#if defined __DXL_CUDAF
  use cudafor
#endif
  !
  implicit none

  interface random_number_cmplx
     procedure :: random_number_cmplx_c1, random_number_cmplx_c2, &
                  random_number_cmplx_z1, random_number_cmplx_z2
  end interface

  complex(real32), parameter :: ci_sp=cmplx(0.0,1.0,kind=real32)
  complex(real64), parameter :: ci_dp=cmplx(0.0,1.0,kind=real64)
  integer(int64) :: cnt, count_max
  real(real64), parameter :: thr_SP=1.0d-6
  real(real64), parameter :: thr_DP=1.0d-12
  !
  ! naming scheme: v  vector
  !                M  matrix
  !                s d c z   real/comple precision
  !                _h, _d    host/device
  !
  real(real32), allocatable :: s_vx_h1(:), s_vy_h1(:)
  real(real32), allocatable :: s_vx_h2(:), s_vy_h2(:)
  real(real32), allocatable DEV_ATTR :: s_vx_d1(:), s_vy_d1(:)
  real(real64), allocatable :: d_vx_h1(:), d_vy_h1(:)
  real(real64), allocatable :: d_vx_h2(:), d_vy_h2(:)
  real(real64), allocatable DEV_ATTR :: d_vx_d1(:), d_vy_d1(:)
  complex(real32), allocatable :: c_vx_h1(:), c_vy_h1(:)
  complex(real32), allocatable :: c_vx_h2(:), c_vy_h2(:)
  complex(real32), allocatable DEV_ATTR :: c_vx_d1(:), c_vy_d1(:)
  complex(real64), allocatable :: z_vx_h1(:), z_vy_h1(:)
  complex(real64), allocatable :: z_vx_h2(:), z_vy_h2(:)
  complex(real64), allocatable DEV_ATTR :: z_vx_d1(:), z_vy_d1(:)
  !
  real(real32), allocatable :: s_mA_h1(:,:)
  real(real32), allocatable :: s_mB_h1(:,:)
  real(real32), allocatable :: s_mC_h1(:,:)
  real(real32), allocatable :: s_mC_h2(:,:)
  real(real32), allocatable DEV_ATTR :: s_mA_d1(:,:)
  real(real32), allocatable DEV_ATTR :: s_mB_d1(:,:)
  real(real32), allocatable DEV_ATTR :: s_mC_d1(:,:)
  real(real64), allocatable :: d_mA_h1(:,:)
  real(real64), allocatable :: d_mB_h1(:,:)
  real(real64), allocatable :: d_mC_h1(:,:)
  real(real64), allocatable :: d_mC_h2(:,:)
  real(real64), allocatable DEV_ATTR :: d_mA_d1(:,:)
  real(real64), allocatable DEV_ATTR :: d_mB_d1(:,:)
  real(real64), allocatable DEV_ATTR :: d_mC_d1(:,:)
  complex(real32), allocatable :: c_mA_h1(:,:)
  complex(real32), allocatable :: c_mB_h1(:,:)
  complex(real32), allocatable :: c_mC_h1(:,:)
  complex(real32), allocatable :: c_mC_h2(:,:)
  complex(real32), allocatable DEV_ATTR :: c_mA_d1(:,:)
  complex(real32), allocatable DEV_ATTR :: c_mB_d1(:,:)
  complex(real32), allocatable DEV_ATTR :: c_mC_d1(:,:)
  complex(real64), allocatable :: z_mA_h1(:,:)
  complex(real64), allocatable :: z_mB_h1(:,:)
  complex(real64), allocatable :: z_mC_h1(:,:)
  complex(real64), allocatable :: z_mC_h2(:,:)
  complex(real64), allocatable DEV_ATTR :: z_mA_d1(:,:)
  complex(real64), allocatable DEV_ATTR :: z_mB_d1(:,:)
  complex(real64), allocatable DEV_ATTR :: z_mC_d1(:,:)
  !
  real(real32) :: s_alpha, s_beta
  real(real64) :: d_alpha, d_beta
  complex(real32) :: c_alpha, c_beta
  complex(real64) :: z_alpha, z_beta
  real(real32) :: s_scal_h1, s_scal_h2
  real(real64) :: d_scal_h1, d_scal_h2
  complex(real32) :: c_scal_h1, c_scal_h2, c_scal_h3, c_scal_h4
  complex(real64) :: z_scal_h1, z_scal_h2, z_scal_h3, z_scal_h4
  !
  real(real64) :: t0, t1, count_rate
  real(real64) :: norm
  integer :: i,j,k,ierr
  integer :: ndim(4)
  integer :: nfail, npass
  !
  integer(kind=dxl_async_kind) :: default_async_id
  character(256) :: arg, str

!
!============================
! get dims
!============================
!
  ! defaults
  ndim(1:4)=[100,200,300,400]
  !
  i=0
  do
    call get_command_argument(i, arg)
    if (len_trim(arg) == 0) exit
    !
    select case (trim(arg))
    case("-h","--help")
      write(output_unit,"(a)") "Usage: "
      write(output_unit,"(a)") "   ./test_linalg.x [--dims <vals>] "
      stop
    end select
    !
    i = i+1
    call get_command_argument(i, str)
    if (len_trim(str) == 0) exit
    !
    select case (trim(arg))
    case("-dims","--dims")
      read(str,*,iostat=ierr) ndim(:)
      if (ierr/=0) STOP "reading cmd-line args: dims"
    end select
  enddo
  !
  write(output_unit,"(/,a,/)") "Running test with params: "
  write(output_unit,"(3x,a,10i5)") "  ndim: ", ndim(:)
  write(output_unit,"()")
  !
  npass=0
  nfail=0

  !
  ! async_id (streams/queues)
  !
#if defined __DXL_CUDAF || defined __DXL_OPENACC
  call devxlib_async_create(default_async_id,default_async=.true.)
#endif
!
!============================
! check linalg
!============================
!
  write(output_unit,"(/,3x,a)") "Initialize LinAlg ..."
  call dev_linalg_setup()
  write(output_unit,"()")

  write(output_unit,"(/,3x,a)") "Initialize profiling ..."
  call init_prof()
  write(output_unit,"()")

  !
  !=====================
  write(output_unit,"(/,3x,a)") "checking xDOT (S) ..."
  !=====================
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  !
  ! allocations
  allocate( s_vx_h1(ndim(1)) )
  allocate( s_vy_h1(ndim(1)) )
  allocate( s_vx_d1(ndim(1)) )
  allocate( s_vy_d1(ndim(1)) )
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_map(s_vx_d1)
  call devxlib_map(s_vy_d1)
#endif
  !
  ! init
  call random_number( s_vx_h1 )
  call random_number( s_vy_h1 )
  !
  ! mem copy h2d
  call devxlib_memcpy_h2d(s_vx_d1, s_vx_h1)
  call devxlib_memcpy_h2d(s_vy_d1, s_vy_h1)
  !
  ! host LinAlg
  s_scal_h1 = devxlib_xDOT( ndim(1), s_vx_h1, 1, s_vy_h1, 1)
  !
  ! dev LinAlg
  s_scal_h2 = devxlib_xDOT_gpu( ndim(1), s_vx_d1, 1, s_vy_d1, 1)
  call devxlib_async_synchronize(default_async_id)
  !
  norm=10.0d0*abs(s_scal_h1)/sqrt(real(ndim(1)))
  !
  if ( abs(s_scal_h2-s_scal_h1)> thr_SP*norm ) then
     !
     write(output_unit,"(3x,a)") "FAILED"
     nfail=nfail+1
  else
     write(output_unit,"(3x,a)") "passed"
     npass=npass+1
  endif
  !
  deallocate( s_vx_h1 )
  deallocate( s_vy_h1 )
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_unmap(s_vx_d1)
  call devxlib_unmap(s_vy_d1)
#endif
  deallocate( s_vx_d1 )
  deallocate( s_vy_d1 )
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(output_unit,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0

  !
  !=====================
  write(output_unit,"(/,3x,a)") "checking xDOT (D) ..."
  !=====================
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  !
  ! allocations
  allocate( d_vx_h1(ndim(1)) )
  allocate( d_vy_h1(ndim(1)) )
  allocate( d_vx_d1(ndim(1)) )
  allocate( d_vy_d1(ndim(1)) )
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_map(d_vx_d1)
  call devxlib_map(d_vy_d1)
#endif
  !
  ! init
  call random_number( d_vx_h1 )
  call random_number( d_vy_h1 )
  !
  ! mem copy h2d
  call devxlib_memcpy_h2d(d_vx_d1, d_vx_h1)
  call devxlib_memcpy_h2d(d_vy_d1, d_vy_h1)
  !
  ! host LinAlg
  call start_prof("xDOT_cpu")
  d_scal_h1 = devxlib_xDOT( ndim(1), d_vx_h1, 1, d_vy_h1, 1)
  call stop_prof("xDOT_cpu")
  !
  ! dev LinAlg
  call start_prof("xDOT_gpu")
  d_scal_h2 = devxlib_xDOT_gpu( ndim(1), d_vx_d1, 1, d_vy_d1, 1)
  call devxlib_async_synchronize(default_async_id)
  call stop_prof("xDOT_gpu")
  !
  norm=10.0d0*abs(d_scal_h1)/sqrt(real(ndim(1)))
  !
  if ( abs(d_scal_h2-d_scal_h1)> thr_DP*norm ) then
     !
     write(output_unit,"(3x,a)") "FAILED"
     nfail=nfail+1
  else
     write(output_unit,"(3x,a)") "passed"
     npass=npass+1
  endif
  !
  deallocate( d_vx_h1 )
  deallocate( d_vy_h1 )
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_unmap(d_vx_d1)
  call devxlib_unmap(d_vy_d1)
#endif
  deallocate( d_vx_d1 )
  deallocate( d_vy_d1 )
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(output_unit,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0

  !
  !=====================
  write(output_unit,"(/,3x,a)") "checking xDOTU/C (C) ..."
  !=====================
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  !
  ! allocations
  allocate( c_vx_h1(ndim(1)) )
  allocate( c_vy_h1(ndim(1)) )
  allocate( c_vx_d1(ndim(1)) )
  allocate( c_vy_d1(ndim(1)) )
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_map(c_vx_d1)
  call devxlib_map(c_vy_d1)
#endif
  !
  ! init
  call random_number_cmplx( c_vx_h1 )
  call random_number_cmplx( c_vy_h1 )
  !
  ! mem copy h2d
  call devxlib_memcpy_h2d(c_vx_d1, c_vx_h1)
  call devxlib_memcpy_h2d(c_vy_d1, c_vy_h1)
  !
  ! host LinAlg
  c_scal_h1 = devxlib_xDOTU( ndim(1), c_vx_h1, 1, c_vy_h1, 1)
  c_scal_h3 = devxlib_xDOTC( ndim(1), c_vx_h1, 1, c_vy_h1, 1)
  !
  ! dev LinAlg
  c_scal_h2 = devxlib_xDOTU_gpu( ndim(1), c_vx_d1, 1, c_vy_d1, 1)
  c_scal_h4 = devxlib_xDOTC_gpu( ndim(1), c_vx_d1, 1, c_vy_d1, 1)
  call devxlib_async_synchronize(default_async_id)
  !
  norm=10.0d0*abs(c_scal_h1)/sqrt(real(ndim(1)))
  !
  if ( abs(c_scal_h2-c_scal_h1)> thr_SP*norm .and. &
       abs(c_scal_h4-c_scal_h3)> thr_SP*norm ) then
     !
     write(output_unit,"(3x,a)") "FAILED"
     nfail=nfail+1
  else
     write(output_unit,"(3x,a)") "passed"
     npass=npass+1
  endif
  !
  deallocate( c_vx_h1 )
  deallocate( c_vy_h1 )
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_unmap(c_vx_d1)
  call devxlib_unmap(c_vy_d1)
#endif
  deallocate( c_vx_d1 )
  deallocate( c_vy_d1 )
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(output_unit,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0

  !
  !=====================
  write(output_unit,"(/,3x,a)") "checking xDOTU/C (Z) ..."
  !=====================
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  !
  ! allocations
  allocate( z_vx_h1(ndim(1)) )
  allocate( z_vy_h1(ndim(1)) )
  allocate( z_vx_d1(ndim(1)) )
  allocate( z_vy_d1(ndim(1)) )
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_map(z_vx_d1)
  call devxlib_map(z_vy_d1)
#endif
  !
  ! init
  call random_number_cmplx( z_vx_h1 )
  call random_number_cmplx( z_vy_h1 )
  !
  ! mem copy h2d
  call devxlib_memcpy_h2d(z_vx_d1, z_vx_h1)
  call devxlib_memcpy_h2d(z_vy_d1, z_vy_h1)
  !
  ! host LinAlg
  z_scal_h1 = devxlib_xDOTU( ndim(1), z_vx_h1, 1, z_vy_h1, 1)
  z_scal_h3 = devxlib_xDOTC( ndim(1), z_vx_h1, 1, z_vy_h1, 1)
  !
  ! dev LinAlg
  z_scal_h2 = devxlib_xDOTU_gpu( ndim(1), z_vx_d1, 1, z_vy_d1, 1)
  z_scal_h4 = devxlib_xDOTC_gpu( ndim(1), z_vx_d1, 1, z_vy_d1, 1)
  call devxlib_async_synchronize(default_async_id)
  !
  norm=10.0d0*abs(z_scal_h1)/sqrt(real(ndim(1)))
  !
  if ( abs(z_scal_h2-z_scal_h1)> thr_DP*norm .and. &
       abs(z_scal_h4-z_scal_h3)> thr_DP*norm ) then
     !
     write(output_unit,"(3x,a)") "FAILED"
     nfail=nfail+1
  else
     write(output_unit,"(3x,a)") "passed"
     npass=npass+1
  endif
  !
  deallocate( z_vx_h1 )
  deallocate( z_vy_h1 )
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_unmap(z_vx_d1)
  call devxlib_unmap(z_vy_d1)
#endif
  deallocate( z_vx_d1 )
  deallocate( z_vy_d1 )
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(output_unit,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0

  write(output_unit,"()")

  !
  !=====================
  write(output_unit,"(/,3x,a)") "checking xAXPY (S) ..."
  !=====================
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  !
  ! allocations
  allocate( s_vx_h1(ndim(1)) )
  allocate( s_vy_h1(ndim(1)) )
  allocate( s_vy_h2(ndim(1)) )
  allocate( s_vx_d1(ndim(1)) )
  allocate( s_vy_d1(ndim(1)) )
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_map(s_vx_d1)
  call devxlib_map(s_vy_d1)
#endif
  !
  ! init
  s_alpha=1.0
  call random_number( s_vx_h1 )
  call random_number( s_vy_h1 )
  !
  ! mem copy h2d
  call devxlib_memcpy_h2d(s_vx_d1, s_vx_h1)
  call devxlib_memcpy_h2d(s_vy_d1, s_vy_h1)
  !
  ! host LinAlg
  call devxlib_xAXPY( ndim(1), s_alpha, s_vx_h1, 1, s_vy_h1, 1)
  !
  ! dev LinAlg
  call devxlib_xAXPY_gpu( ndim(1), s_alpha, s_vx_d1, 1, s_vy_d1, 1)
  call devxlib_async_synchronize(default_async_id)
  !
  ! mem copy d2h
  call devxlib_memcpy_d2h( s_vy_h2, s_vy_d1)
  !
  if ( any(abs(s_vy_h2-s_vy_h1)> thr_SP) ) then
     !
     write(output_unit,"(3x,a)") "FAILED"
     nfail=nfail+1
  else
     write(output_unit,"(3x,a)") "passed"
     npass=npass+1
  endif
  !
  deallocate( s_vx_h1 )
  deallocate( s_vy_h1 )
  deallocate( s_vy_h2 )
  !
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_unmap(s_vx_d1)
  call devxlib_unmap(s_vy_d1)
#endif
  deallocate( s_vx_d1 )
  deallocate( s_vy_d1 )
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(output_unit,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0

  !
  !=====================
  write(output_unit,"(/,3x,a)") "checking xAXPY (D) ..."
  !=====================
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  !
  ! allocations
  allocate( d_vx_h1(ndim(1)) )
  allocate( d_vy_h1(ndim(1)) )
  allocate( d_vy_h2(ndim(1)) )
  allocate( d_vx_d1(ndim(1)) )
  allocate( d_vy_d1(ndim(1)) )
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_map(d_vx_d1)
  call devxlib_map(d_vy_d1)
#endif
  !
  ! init
  d_alpha=1.0
  call random_number( d_vx_h1 )
  call random_number( d_vy_h1 )
  !
  ! mem copy h2d
  call devxlib_memcpy_h2d(d_vx_d1, d_vx_h1)
  call devxlib_memcpy_h2d(d_vy_d1, d_vy_h1)
  !
  ! host LinAlg
  call devxlib_xAXPY( ndim(1), d_alpha, d_vx_h1, 1, d_vy_h1, 1)
  !
  ! dev LinAlg
  call devxlib_xAXPY_gpu( ndim(1), d_alpha, d_vx_d1, 1, d_vy_d1, 1)
  call devxlib_async_synchronize(default_async_id)
  !
  ! mem copy d2h
  call devxlib_memcpy_d2h( d_vy_h2, d_vy_d1)
  !
  if ( any(abs(d_vy_h2-d_vy_h1)> thr_DP) ) then
     !
     write(output_unit,"(3x,a)") "FAILED"
     nfail=nfail+1
  else
     write(output_unit,"(3x,a)") "passed"
     npass=npass+1
  endif
  !
  deallocate( d_vx_h1 )
  deallocate( d_vy_h1 )
  deallocate( d_vy_h2 )
  !
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_unmap(d_vx_d1)
  call devxlib_unmap(d_vy_d1)
#endif
  deallocate( d_vx_d1 )
  deallocate( d_vy_d1 )
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(output_unit,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0

  !
  !=====================
  write(output_unit,"(/,3x,a)") "checking xAXPY (C) ..."
  !=====================
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  !
  ! allocations
  allocate( c_vx_h1(ndim(1)) )
  allocate( c_vy_h1(ndim(1)) )
  allocate( c_vy_h2(ndim(1)) )
  allocate( c_vx_d1(ndim(1)) )
  allocate( c_vy_d1(ndim(1)) )
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_map(c_vx_d1)
  call devxlib_map(c_vy_d1)
#endif
  !
  ! init
  c_alpha=1.0
  call random_number_cmplx( c_vx_h1 )
  call random_number_cmplx( c_vy_h1 )
  !
  ! mem copy h2d
  call devxlib_memcpy_h2d(c_vx_d1, c_vx_h1)
  call devxlib_memcpy_h2d(c_vy_d1, c_vy_h1)
  !
  ! host LinAlg
  call devxlib_xAXPY( ndim(1), c_alpha, c_vx_h1, 1, c_vy_h1, 1)
  !
  ! dev LinAlg
  call devxlib_xAXPY_gpu( ndim(1), c_alpha, c_vx_d1, 1, c_vy_d1, 1)
  call devxlib_async_synchronize(default_async_id)
  !
  ! mem copy d2h
  call devxlib_memcpy_d2h( c_vy_h2, c_vy_d1)
  !
  if ( any(abs(c_vy_h2-c_vy_h1)> thr_SP) ) then
     !
     write(output_unit,"(3x,a)") "FAILED"
     nfail=nfail+1
  else
     write(output_unit,"(3x,a)") "passed"
     npass=npass+1
  endif
  !
  deallocate( c_vx_h1 )
  deallocate( c_vy_h1 )
  deallocate( c_vy_h2 )
  !
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_unmap(c_vx_d1)
  call devxlib_unmap(c_vy_d1)
#endif
  deallocate( c_vx_d1 )
  deallocate( c_vy_d1 )
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(output_unit,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0

  !
  !=====================
  write(output_unit,"(/,3x,a)") "checking xAXPY (Z) ..."
  !=====================
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  !
  ! allocations
  allocate( z_vx_h1(ndim(1)) )
  allocate( z_vy_h1(ndim(1)) )
  allocate( z_vy_h2(ndim(1)) )
  allocate( z_vx_d1(ndim(1)) )
  allocate( z_vy_d1(ndim(1)) )
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_map(z_vx_d1)
  call devxlib_map(z_vy_d1)
#endif
  !
  ! init
  z_alpha=1.0
  call random_number_cmplx( z_vx_h1 )
  call random_number_cmplx( z_vy_h1 )
  !
  ! mem copy h2d
  call devxlib_memcpy_h2d(z_vx_d1, z_vx_h1)
  call devxlib_memcpy_h2d(z_vy_d1, z_vy_h1)
  !
  ! host LinAlg
  call devxlib_xAXPY( ndim(1), z_alpha, z_vx_h1, 1, z_vy_h1, 1)
  !
  ! dev LinAlg
  call devxlib_xAXPY_gpu( ndim(1), z_alpha, z_vx_d1, 1, z_vy_d1, 1)
  call devxlib_async_synchronize(default_async_id)
  !
  ! mem copy d2h
  call devxlib_memcpy_d2h( z_vy_h2, z_vy_d1)
  !
  if ( any(abs(z_vy_h2-z_vy_h1)> thr_DP) ) then
     !
     write(output_unit,"(3x,a)") "FAILED"
     nfail=nfail+1
  else
     write(output_unit,"(3x,a)") "passed"
     npass=npass+1
  endif
  !
  deallocate( z_vx_h1 )
  deallocate( z_vy_h1 )
  deallocate( z_vy_h2 )
  !
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_unmap(z_vx_d1)
  call devxlib_unmap(z_vy_d1)
#endif
  deallocate( z_vx_d1 )
  deallocate( z_vy_d1 )
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(output_unit,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  write(output_unit,"()")

  !
  !=====================
  write(output_unit,"(/,3x,a)") "checking xGEMV (S) ..."
  !=====================
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  !
  ! allocations
  allocate( s_vx_h1(ndim(2)) )
  allocate( s_vy_h1(ndim(1)) )
  allocate( s_mA_h1(ndim(1),ndim(2)) )
  allocate( s_vy_h2(ndim(1)) )
  allocate( s_vx_d1(ndim(2)) )
  allocate( s_vy_d1(ndim(1)) )
  allocate( s_mA_d1(ndim(1),ndim(2)) )
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_map(s_vx_d1)
  call devxlib_map(s_vy_d1)
  call devxlib_map(s_mA_d1)
#endif
  !
  ! init
  s_alpha=1.0
  s_beta=1.0
  call random_number( s_vx_h1 )
  call random_number( s_vy_h1 )
  call random_number( s_mA_h1 )
  !
  ! mem copy h2d
  call devxlib_memcpy_h2d(s_vx_d1, s_vx_h1)
  call devxlib_memcpy_h2d(s_vy_d1, s_vy_h1)
  call devxlib_memcpy_h2d(s_mA_d1, s_mA_h1)
  !
  ! host LinAlg
  call devxlib_xGEMV( 'N', ndim(1), ndim(2), s_alpha, s_mA_h1, ndim(1), s_vx_h1, 1, s_beta, s_vy_h1, 1)
  !
  ! dev LinAlg
  call start_prof("xGEMV_gpu")
  call devxlib_xGEMV_gpu( 'N', ndim(1), ndim(2), s_alpha, s_mA_d1, ndim(1), s_vx_d1, 1, s_beta, s_vy_d1, 1)
  call devxlib_async_synchronize(default_async_id)
  call stop_prof("xGEMV_gpu")
  !
  ! mem copy d2h
  call devxlib_memcpy_d2h( s_vy_h2, s_vy_d1)
  !
  call start_prof("check")
  norm=sqrt( sum(abs(s_vy_h1(:))**2)/real(size(s_vy_h1),kind=kind(s_vy_h1)) )
  if ( any(abs(s_vy_h2-s_vy_h1)> thr_SP*norm ) ) then
     !
     write(output_unit,"(3x,a)") "FAILED"
     nfail=nfail+1
  else
     write(output_unit,"(3x,a)") "passed"
     npass=npass+1
  endif
  call stop_prof("check")
  !
  deallocate( s_vx_h1 )
  deallocate( s_vy_h1 )
  deallocate( s_vy_h2 )
  deallocate( s_mA_h1 )
  !
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_unmap(s_vx_d1)
  call devxlib_unmap(s_vy_d1)
  call devxlib_unmap(s_mA_d1)
#endif
  deallocate( s_vx_d1 )
  deallocate( s_vy_d1 )
  deallocate( s_mA_d1 )
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(output_unit,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0

  !
  !=====================
  write(output_unit,"(/,3x,a)") "checking xGEMV (D) ..."
  !=====================
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  !
  ! allocations
  allocate( d_vx_h1(ndim(2)) )
  allocate( d_vy_h1(ndim(1)) )
  allocate( d_mA_h1(ndim(1),ndim(2)) )
  allocate( d_vy_h2(ndim(1)) )
  allocate( d_vx_d1(ndim(2)) )
  allocate( d_vy_d1(ndim(1)) )
  allocate( d_mA_d1(ndim(1),ndim(2)) )
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_map(d_vx_d1)
  call devxlib_map(d_vy_d1)
  call devxlib_map(d_mA_d1)
#endif
  !
  ! init
  d_alpha=1.0
  d_beta=1.0
  call random_number( d_vx_h1 )
  call random_number( d_vy_h1 )
  call random_number( d_mA_h1 )
  !
  ! mem copy h2d
  call devxlib_memcpy_h2d(d_vx_d1, d_vx_h1)
  call devxlib_memcpy_h2d(d_vy_d1, d_vy_h1)
  call devxlib_memcpy_h2d(d_mA_d1, d_mA_h1)
  !
  ! host LinAlg
  call devxlib_xGEMV( 'N', ndim(1), ndim(2), d_alpha, d_mA_h1, ndim(1), d_vx_h1, 1, d_beta, d_vy_h1, 1)
  !
  ! dev LinAlg
  call devxlib_xGEMV_gpu( 'N', ndim(1), ndim(2), d_alpha, d_mA_d1, ndim(1), d_vx_d1, 1, d_beta, d_vy_d1, 1)
  call devxlib_async_synchronize(default_async_id)
  !
  ! mem copy d2h
  call devxlib_memcpy_d2h( d_vy_h2, d_vy_d1)
  !
  norm=sqrt( sum(abs(d_vy_h1(:))**2)/real(size(d_vy_h1),kind=kind(d_vy_h1)) )
  if ( any(abs(d_vy_h2-d_vy_h1)> thr_DP*norm ) ) then
     !
     write(output_unit,"(3x,a)") "FAILED"
     nfail=nfail+1
  else
     write(output_unit,"(3x,a)") "passed"
     npass=npass+1
  endif
  !
  deallocate( d_vx_h1 )
  deallocate( d_vy_h1 )
  deallocate( d_vy_h2 )
  deallocate( d_mA_h1 )
  !
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_unmap(d_vx_d1)
  call devxlib_unmap(d_vy_d1)
  call devxlib_unmap(d_mA_d1)
#endif
  deallocate( d_vx_d1 )
  deallocate( d_vy_d1 )
  deallocate( d_mA_d1 )
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(output_unit,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0

  !
  !=====================
  write(output_unit,"(/,3x,a)") "checking xGEMV (C) ..."
  !=====================
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  !
  ! allocations
  allocate( c_vx_h1(ndim(2)) )
  allocate( c_vy_h1(ndim(1)) )
  allocate( c_mA_h1(ndim(1),ndim(2)) )
  allocate( c_vy_h2(ndim(1)) )
  allocate( c_vx_d1(ndim(2)) )
  allocate( c_vy_d1(ndim(1)) )
  allocate( c_mA_d1(ndim(1),ndim(2)) )
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_map(c_vx_d1)
  call devxlib_map(c_vy_d1)
  call devxlib_map(c_mA_d1)
#endif
  !
  ! init
  c_alpha=1.0
  c_beta=1.0
  call random_number_cmplx( c_vx_h1 )
  call random_number_cmplx( c_vy_h1 )
  call random_number_cmplx( c_mA_h1 )
  !
  ! mem copy h2d
  call devxlib_memcpy_h2d(c_vx_d1, c_vx_h1)
  call devxlib_memcpy_h2d(c_vy_d1, c_vy_h1)
  call devxlib_memcpy_h2d(c_mA_d1, c_mA_h1)
  !
  ! host LinAlg
  call devxlib_xGEMV( 'N', ndim(1), ndim(2), c_alpha, c_mA_h1, ndim(1), c_vx_h1, 1, c_beta, c_vy_h1, 1)
  !
  ! dev LinAlg
  call devxlib_xGEMV_gpu( 'N', ndim(1), ndim(2), c_alpha, c_mA_d1, ndim(1), c_vx_d1, 1, c_beta, c_vy_d1, 1)
  call devxlib_async_synchronize(default_async_id)
  !
  ! mem copy d2h
  call devxlib_memcpy_d2h( c_vy_h2, c_vy_d1)
  !
  norm=sqrt( sum(abs(c_vy_h1(:))**2)/real(size(c_vy_h1),kind=kind(c_vy_h1)) )
  if ( any(abs(c_vy_h2-c_vy_h1)> thr_SP*norm ) ) then
     !
     write(output_unit,"(3x,a)") "FAILED"
     nfail=nfail+1
  else
     write(output_unit,"(3x,a)") "passed"
     npass=npass+1
  endif
  !
  deallocate( c_vx_h1 )
  deallocate( c_vy_h1 )
  deallocate( c_vy_h2 )
  deallocate( c_mA_h1 )
  !
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_unmap(c_vx_d1)
  call devxlib_unmap(c_vy_d1)
  call devxlib_unmap(c_mA_d1)
#endif
  deallocate( c_vx_d1 )
  deallocate( c_vy_d1 )
  deallocate( c_mA_d1 )
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(output_unit,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0

  !
  !=====================
  write(output_unit,"(/,3x,a)") "checking xGEMV (Z) ..."
  !=====================
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  !
  ! allocations
  allocate( z_vx_h1(ndim(2)) )
  allocate( z_vy_h1(ndim(1)) )
  allocate( z_mA_h1(ndim(1),ndim(2)) )
  allocate( z_vy_h2(ndim(1)) )
  allocate( z_vx_d1(ndim(2)) )
  allocate( z_vy_d1(ndim(1)) )
  allocate( z_mA_d1(ndim(1),ndim(2)) )
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_map(z_vx_d1)
  call devxlib_map(z_vy_d1)
  call devxlib_map(z_mA_d1)
#endif
  !
  ! init
  z_alpha=1.0
  z_beta=1.0
  call random_number_cmplx( z_vx_h1 )
  call random_number_cmplx( z_vy_h1 )
  call random_number_cmplx( z_mA_h1 )
  !
  ! mem copy h2d
  call devxlib_memcpy_h2d(z_vx_d1, z_vx_h1)
  call devxlib_memcpy_h2d(z_vy_d1, z_vy_h1)
  call devxlib_memcpy_h2d(z_mA_d1, z_mA_h1)
  !
  ! host LinAlg
  call devxlib_xGEMV( 'N', ndim(1), ndim(2), z_alpha, z_mA_h1, ndim(1), z_vx_h1, 1, z_beta, z_vy_h1, 1)
  !
  ! dev LinAlg
  call devxlib_xGEMV_gpu( 'N', ndim(1), ndim(2), z_alpha, z_mA_d1, ndim(1), z_vx_d1, 1, z_beta, z_vy_d1, 1)
  call devxlib_async_synchronize(default_async_id)
  !
  ! mem copy d2h
  call devxlib_memcpy_d2h( z_vy_h2, z_vy_d1)
  !
  norm=sqrt( sum(abs(z_vy_h1(:))**2)/real(size(z_vy_h1),kind=kind(z_vy_h1)) )
  if ( any(abs(z_vy_h2-z_vy_h1)> thr_DP*norm ) ) then
     !
     write(output_unit,"(3x,a)") "FAILED"
     nfail=nfail+1
  else
     write(output_unit,"(3x,a)") "passed"
     npass=npass+1
  endif
  !
  deallocate( z_vx_h1 )
  deallocate( z_vy_h1 )
  deallocate( z_vy_h2 )
  deallocate( z_mA_h1 )
  !
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_unmap(z_vx_d1)
  call devxlib_unmap(z_vy_d1)
  call devxlib_unmap(z_mA_d1)
#endif
  deallocate( z_vx_d1 )
  deallocate( z_vy_d1 )
  deallocate( z_mA_d1 )
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(output_unit,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  write(output_unit,"()")

  !
  !=====================
  write(output_unit,"(/,3x,a)") "checking xGEMM (S) ..."
  !=====================
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  !
  ! allocations
  allocate( s_mC_h1(ndim(1),ndim(2)) )
  allocate( s_mA_h1(ndim(1),ndim(3)) )
  allocate( s_mB_h1(ndim(3),ndim(2)) )
  allocate( s_mC_h2(ndim(1),ndim(2)) )
  !
  allocate( s_mC_d1(ndim(1),ndim(2)) )
  allocate( s_mA_d1(ndim(1),ndim(3)) )
  allocate( s_mB_d1(ndim(3),ndim(2)) )
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_map(s_mC_d1)
  call devxlib_map(s_mA_d1)
  call devxlib_map(s_mB_d1)
#endif
  !
  ! init
  s_alpha=1.0
  s_beta=1.0
  call random_number( s_mA_h1 )
  call random_number( s_mB_h1 )
  call random_number( s_mC_h1 )
  !
  ! mem copy h2d
  call devxlib_memcpy_h2d(s_mA_d1, s_mA_h1)
  call devxlib_memcpy_h2d(s_mB_d1, s_mB_h1)
  call devxlib_memcpy_h2d(s_mC_d1, s_mC_h1)
  !
  ! host LinAlg
  call start_prof("xGEMM_cpu")
  call devxlib_xGEMM( 'N', 'N', ndim(1), ndim(2), ndim(3), s_alpha, s_mA_h1, ndim(1), &
                            s_mB_h1, ndim(3), s_beta, s_mC_h1, ndim(1))
  call stop_prof("xGEMM_cpu")
  !
  ! dev LinAlg
  call start_prof("xGEMM_gpu")
  call devxlib_xGEMM_gpu( 'N', 'N', ndim(1), ndim(2), ndim(3), s_alpha, s_mA_d1, ndim(1), &
                                s_mB_d1, ndim(3), s_beta, s_mC_d1, ndim(1))
  call devxlib_async_synchronize(default_async_id)
  call stop_prof("xGEMM_gpu")
  !
  ! mem copy d2h
  call devxlib_memcpy_d2h(s_mC_h2, s_mC_d1)
  !
  norm=sqrt( sum(abs(s_mC_h1(:,:))**2)/real(size(s_mC_h1),kind=kind(s_mC_h1)) )
  norm=norm*10.0
  !
  if ( any(abs(s_mC_h2-s_mC_h1)> thr_SP*norm ) ) then
     !
     write(output_unit,"(3x,a)") "FAILED"
     nfail=nfail+1
  else
     write(output_unit,"(3x,a)") "passed"
     npass=npass+1
  endif
  !
  deallocate( s_mA_h1 )
  deallocate( s_mB_h1 )
  deallocate( s_mC_h1 )
  deallocate( s_mC_h2 )
  !
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_unmap(s_mA_d1)
  call devxlib_unmap(s_mB_d1)
  call devxlib_unmap(s_mC_d1)
#endif
  !
  deallocate( s_mA_d1 )
  deallocate( s_mB_d1 )
  deallocate( s_mC_d1 )
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(output_unit,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0

  !
  !=====================
  write(output_unit,"(/,3x,a)") "checking xGEMM (D) ..."
  !=====================
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  !
  ! allocations
  allocate( d_mC_h1(ndim(1),ndim(2)) )
  allocate( d_mA_h1(ndim(1),ndim(3)) )
  allocate( d_mB_h1(ndim(3),ndim(2)) )
  allocate( d_mC_h2(ndim(1),ndim(2)) )
  !
  allocate( d_mC_d1(ndim(1),ndim(2)) )
  allocate( d_mA_d1(ndim(1),ndim(3)) )
  allocate( d_mB_d1(ndim(3),ndim(2)) )
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_map(d_mC_d1)
  call devxlib_map(d_mA_d1)
  call devxlib_map(d_mB_d1)
#endif
  !
  ! init
  d_alpha=1.0
  d_beta=1.0
  call random_number( d_mA_h1 )
  call random_number( d_mB_h1 )
  call random_number( d_mC_h1 )
  !
  ! mem copy h2d
  call devxlib_memcpy_h2d(d_mA_d1, d_mA_h1)
  call devxlib_memcpy_h2d(d_mB_d1, d_mB_h1)
  call devxlib_memcpy_h2d(d_mC_d1, d_mC_h1)
  !
  ! host LinAlg
  call devxlib_xGEMM( 'N', 'N', ndim(1), ndim(2), ndim(3), d_alpha, d_mA_h1, ndim(1), &
                            d_mB_h1, ndim(3), d_beta, d_mC_h1, ndim(1))
  !
  ! dev LinAlg
  call devxlib_xGEMM_gpu( 'N', 'N', ndim(1), ndim(2), ndim(3), d_alpha, d_mA_d1, ndim(1), &
                                d_mB_d1, ndim(3), d_beta, d_mC_d1, ndim(1))
  call devxlib_async_synchronize(default_async_id)
  !
  ! mem copy d2h
  call devxlib_memcpy_d2h(d_mC_h2, d_mC_d1)
  !
  norm=sqrt( sum(abs(d_mC_h1(:,:))**2)/real(size(d_mC_h1),kind=kind(d_mC_h1)) )
  norm=norm*10.0
  !
  if ( any(abs(d_mC_h2-d_mC_h1)> thr_DP*norm ) ) then
     !
     write(output_unit,"(3x,a)") "FAILED"
     nfail=nfail+1
  else
     write(output_unit,"(3x,a)") "passed"
     npass=npass+1
  endif
  !
  deallocate( d_mA_h1 )
  deallocate( d_mB_h1 )
  deallocate( d_mC_h1 )
  deallocate( d_mC_h2 )
  !
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_unmap(d_mA_d1)
  call devxlib_unmap(d_mB_d1)
  call devxlib_unmap(d_mC_d1)
#endif
  !
  deallocate( d_mA_d1 )
  deallocate( d_mB_d1 )
  deallocate( d_mC_d1 )
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(output_unit,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0

  !
  !=====================
  write(output_unit,"(/,3x,a)") "checking xGEMM (C) ..."
  !=====================
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  !
  ! allocations
  allocate( c_mC_h1(ndim(1),ndim(2)) )
  allocate( c_mA_h1(ndim(1),ndim(3)) )
  allocate( c_mB_h1(ndim(3),ndim(2)) )
  allocate( c_mC_h2(ndim(1),ndim(2)) )
  !
  allocate( c_mC_d1(ndim(1),ndim(2)) )
  allocate( c_mA_d1(ndim(1),ndim(3)) )
  allocate( c_mB_d1(ndim(3),ndim(2)) )
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_map(c_mC_d1)
  call devxlib_map(c_mA_d1)
  call devxlib_map(c_mB_d1)
#endif
  !
  ! init
  c_alpha=1.0
  c_beta=1.0
  call random_number_cmplx( c_mA_h1 )
  call random_number_cmplx( c_mB_h1 )
  call random_number_cmplx( c_mC_h1 )
  !
  ! mem copy h2d
  call devxlib_memcpy_h2d(c_mA_d1, c_mA_h1)
  call devxlib_memcpy_h2d(c_mB_d1, c_mB_h1)
  call devxlib_memcpy_h2d(c_mC_d1, c_mC_h1)
  !
  ! host LinAlg
  call devxlib_xGEMM( 'N', 'N', ndim(1), ndim(2), ndim(3), c_alpha, c_mA_h1, ndim(1), &
                            c_mB_h1, ndim(3), c_beta, c_mC_h1, ndim(1))
  !
  ! dev LinAlg
  call devxlib_xGEMM_gpu( 'N', 'N', ndim(1), ndim(2), ndim(3), c_alpha, c_mA_d1, ndim(1), &
                                c_mB_d1, ndim(3), c_beta, c_mC_d1, ndim(1))
  call devxlib_async_synchronize(default_async_id)
  !
  ! mem copy d2h
  call devxlib_memcpy_d2h(c_mC_h2, c_mC_d1)
  !
  norm=sqrt( sum(abs(c_mC_h1(:,:))**2)/real(size(c_mC_h1),kind=kind(c_mC_h1)) )
  norm=norm*10.0
  !
  if ( any(abs(c_mC_h2-c_mC_h1)> thr_SP*norm ) ) then
     !
     write(output_unit,"(3x,a)") "FAILED"
     nfail=nfail+1
  else
     write(output_unit,"(3x,a)") "passed"
     npass=npass+1
  endif
  !
  deallocate( c_mA_h1 )
  deallocate( c_mB_h1 )
  deallocate( c_mC_h1 )
  deallocate( c_mC_h2 )
  !
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_unmap(c_mA_d1)
  call devxlib_unmap(c_mB_d1)
  call devxlib_unmap(c_mC_d1)
#endif
  !
  deallocate( c_mA_d1 )
  deallocate( c_mB_d1 )
  deallocate( c_mC_d1 )
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(output_unit,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0

  !
  !=====================
  write(output_unit,"(/,3x,a)") "checking xGEMM (Z) ..."
  !=====================
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  !
  ! allocations
  allocate( z_mC_h1(ndim(1),ndim(2)) )
  allocate( z_mA_h1(ndim(1),ndim(3)) )
  allocate( z_mB_h1(ndim(3),ndim(2)) )
  allocate( z_mC_h2(ndim(1),ndim(2)) )
  !
  allocate( z_mC_d1(ndim(1),ndim(2)) )
  allocate( z_mA_d1(ndim(1),ndim(3)) )
  allocate( z_mB_d1(ndim(3),ndim(2)) )
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_map(z_mC_d1)
  call devxlib_map(z_mA_d1)
  call devxlib_map(z_mB_d1)
#endif
  !
  ! init
  z_alpha=1.0
  z_beta=1.0
  call random_number_cmplx( z_mA_h1 )
  call random_number_cmplx( z_mB_h1 )
  call random_number_cmplx( z_mC_h1 )
  !
  ! mem copy h2d
  call devxlib_memcpy_h2d(z_mA_d1, z_mA_h1)
  call devxlib_memcpy_h2d(z_mB_d1, z_mB_h1)
  call devxlib_memcpy_h2d(z_mC_d1, z_mC_h1)
  !
  ! host LinAlg
  call devxlib_xGEMM( 'N', 'N', ndim(1), ndim(2), ndim(3), z_alpha, z_mA_h1, ndim(1), &
                            z_mB_h1, ndim(3), z_beta, z_mC_h1, ndim(1))
  !
  ! dev LinAlg
  call devxlib_xGEMM_gpu( 'N', 'N', ndim(1), ndim(2), ndim(3), z_alpha, z_mA_d1, ndim(1), &
                                z_mB_d1, ndim(3), z_beta, z_mC_d1, ndim(1))
  call devxlib_async_synchronize(default_async_id)
  !
  ! mem copy d2h
  call devxlib_memcpy_d2h(z_mC_h2, z_mC_d1)
  !
  norm=sqrt( sum(abs(z_mC_h1(:,:))**2)/real(size(z_mC_h1),kind=kind(z_mC_h1)) )
  norm=norm*10.0
  !
  if ( any(abs(z_mC_h2-z_mC_h1)> thr_DP*norm ) ) then
     !
     write(output_unit,"(3x,a)") "FAILED"
     nfail=nfail+1
  else
     write(output_unit,"(3x,a)") "passed"
     npass=npass+1
  endif
  !
  deallocate( z_mA_h1 )
  deallocate( z_mB_h1 )
  deallocate( z_mC_h1 )
  deallocate( z_mC_h2 )
  !
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_unmap(z_mA_d1)
  call devxlib_unmap(z_mB_d1)
  call devxlib_unmap(z_mC_d1)
#endif
  !
  deallocate( z_mA_d1 )
  deallocate( z_mB_d1 )
  deallocate( z_mC_d1 )
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(output_unit,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  write(output_unit,"()")

  !
  ! summary
  !
  write(output_unit,"(/,a)") "# Test SUMMARY:"
  write(output_unit,"(3x,a,i5)") "# passed: ", npass
  write(output_unit,"(3x,a,i5)") "# failed: ", nfail
  write(output_unit,"()")

  write(output_unit,"(/,3x,a)") "Shutdown LinAlg ..."
  call dev_linalg_shutdown()
  write(output_unit,"()")

  contains

     subroutine random_number_cmplx_c1(array)
        implicit none
        complex(real32) :: array(:)
        real(real32), allocatable :: rtmp(:)
        !
        allocate(rtmp,mold=real(array))
        call random_number(rtmp)
        array=rtmp
        call random_number(rtmp)
        array=array+ci_sp*rtmp
        deallocate(rtmp)
     end subroutine

     subroutine random_number_cmplx_c2(array)
        implicit none
        complex(real32) :: array(:,:)
        real(real32), allocatable :: rtmp(:,:)
        !
        allocate(rtmp,mold=real(array))
        call random_number(rtmp)
        array=rtmp
        call random_number(rtmp)
        array=array+ci_sp*rtmp
        deallocate(rtmp)
     end subroutine

     subroutine random_number_cmplx_z1(array)
        implicit none
        complex(real64) :: array(:)
        real(real64), allocatable :: rtmp(:)
        !
        allocate(rtmp,mold=real(array))
        call random_number(rtmp)
        array=rtmp
        call random_number(rtmp)
        array=array+ci_sp*rtmp
        deallocate(rtmp)
     end subroutine

     subroutine random_number_cmplx_z2(array)
        implicit none
        complex(real64) :: array(:,:)
        real(real64), allocatable :: rtmp(:,:)
        !
        allocate(rtmp,mold=real(array))
        call random_number(rtmp)
        array=rtmp
        call random_number(rtmp)
        array=array+ci_sp*rtmp
        deallocate(rtmp)
     end subroutine
end program test_linalg

!
! F-wrappers for selected cuda functions
! freely copied and modified from:
!
! FCUDA (C18096) is open source software; it is distributed under the terms of
! the 3-clause BSD license.
!
! Copyright (c) 2019-2020. Triad National Security, LLC. All rights reserved.
!
! This program was produced under U.S. Government contract 89233218CNA000001 for
! Los Alamos National Laboratory (LANL), which is operated by Triad National
! Security, LLC for the U.S. Department of Energy/National Nuclear Security
! Administration. All rights in the program are reserved by Triad National
! Security, LLC, and the U.S. Department of Energy/National Nuclear Security
! Administration. The Government is granted for itself and others acting on its
! behalf a nonexclusive, paid-up, irrevocable worldwide license in this material
! to reproduce, prepare derivative works, distribute copies to the public, perform
! publicly and display publicly, and to permit others to do so.
!
! https://github.com/zjibben/fcuda
!
module cudafor_m
  use iso_c_binding

! XXX to be fixed
!#define __DXL_CUDA 
#if defined __DXL_CUDA

  interface
    function cudaDeviceSynchronize() &
        result(ierr) bind(c, name="cudaDeviceSynchronize")
      import c_int
      integer(c_int) :: ierr
    end function cudaDeviceSynchronize
    function cudaStreamCreate(pstream) &
        result(ierr) bind(c, name="cudaStreamCreate")
      import c_ptr, c_int
      type(c_ptr) :: pstream
      integer(c_int) :: ierr
    end function cudaStreamCreate
    function cudaStreamDestroy(pstream) &
        result(ierr) bind(c, name="cudaStreamDestroy")
      import c_ptr, c_int
      type(c_ptr), value :: pstream
      integer(c_int) :: ierr
    end function cudaStreamDestroy
    function cudaStreamSynchronize(pstream) &
        result(ierr) bind(c, name="cudaStreamSynchronize")
      import c_ptr, c_int
      type(c_ptr), value :: pstream
      integer(c_int) :: ierr
    end function cudaStreamSynchronize
  end interface

#else
  integer :: cudafor_dummy
#endif

end module

!
! Copyright (C) 2022, MaX CoE
! Distributed under the MIT License 
! (license terms are at http://opensource.org/licenses/MIT).
!
!--
!
! Utility functions to perform device memory unmapping of host memory
! using CUDA-Fortran, OpenACC or OpenMP Offload
!
!==================================================================
!==================================================================
! *DO NOT EDIT*: automatically generated from device_mapping_unmap.jf90
!==================================================================
!==================================================================
!
#include<devxlib_macros.h>
#include<devxlib_defs.h>
!
!=======================================
!
submodule (devxlib_mapping) devxlib_mapping_unmap

   implicit none

   contains
!
      module subroutine sp_devxlib_mapping_unmap_r1d(array, ierr)
         implicit none
         !
         real(real32), allocatable DEV_ATTR :: array(:)
         integer, optional, intent(out) :: ierr
         integer :: ierr_
         !
         ierr_=0
         !
#if defined __DXL_CUDAF
         if (allocated(array)) deallocate( array, stat=ierr_)
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC exit data delete(array) wait
         !DEV_OMPGPU target exit data map(delete:array)
#endif
         if (present(ierr)) ierr=ierr_
         !
      end subroutine sp_devxlib_mapping_unmap_r1d
!
!
      module subroutine sp_devxlib_mapping_unmap_r2d(array, ierr)
         implicit none
         !
         real(real32), allocatable DEV_ATTR :: array(:,:)
         integer, optional, intent(out) :: ierr
         integer :: ierr_
         !
         ierr_=0
         !
#if defined __DXL_CUDAF
         if (allocated(array)) deallocate( array, stat=ierr_)
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC exit data delete(array) wait
         !DEV_OMPGPU target exit data map(delete:array)
#endif
         if (present(ierr)) ierr=ierr_
         !
      end subroutine sp_devxlib_mapping_unmap_r2d
!
!
      module subroutine sp_devxlib_mapping_unmap_r3d(array, ierr)
         implicit none
         !
         real(real32), allocatable DEV_ATTR :: array(:,:,:)
         integer, optional, intent(out) :: ierr
         integer :: ierr_
         !
         ierr_=0
         !
#if defined __DXL_CUDAF
         if (allocated(array)) deallocate( array, stat=ierr_)
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC exit data delete(array) wait
         !DEV_OMPGPU target exit data map(delete:array)
#endif
         if (present(ierr)) ierr=ierr_
         !
      end subroutine sp_devxlib_mapping_unmap_r3d
!
!
      module subroutine sp_devxlib_mapping_unmap_r4d(array, ierr)
         implicit none
         !
         real(real32), allocatable DEV_ATTR :: array(:,:,:,:)
         integer, optional, intent(out) :: ierr
         integer :: ierr_
         !
         ierr_=0
         !
#if defined __DXL_CUDAF
         if (allocated(array)) deallocate( array, stat=ierr_)
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC exit data delete(array) wait
         !DEV_OMPGPU target exit data map(delete:array)
#endif
         if (present(ierr)) ierr=ierr_
         !
      end subroutine sp_devxlib_mapping_unmap_r4d
!
!
      module subroutine sp_devxlib_mapping_unmap_r5d(array, ierr)
         implicit none
         !
         real(real32), allocatable DEV_ATTR :: array(:,:,:,:,:)
         integer, optional, intent(out) :: ierr
         integer :: ierr_
         !
         ierr_=0
         !
#if defined __DXL_CUDAF
         if (allocated(array)) deallocate( array, stat=ierr_)
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC exit data delete(array) wait
         !DEV_OMPGPU target exit data map(delete:array)
#endif
         if (present(ierr)) ierr=ierr_
         !
      end subroutine sp_devxlib_mapping_unmap_r5d
!
!
      module subroutine sp_devxlib_mapping_unmap_r6d(array, ierr)
         implicit none
         !
         real(real32), allocatable DEV_ATTR :: array(:,:,:,:,:,:)
         integer, optional, intent(out) :: ierr
         integer :: ierr_
         !
         ierr_=0
         !
#if defined __DXL_CUDAF
         if (allocated(array)) deallocate( array, stat=ierr_)
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC exit data delete(array) wait
         !DEV_OMPGPU target exit data map(delete:array)
#endif
         if (present(ierr)) ierr=ierr_
         !
      end subroutine sp_devxlib_mapping_unmap_r6d
!
!
      module subroutine dp_devxlib_mapping_unmap_r1d(array, ierr)
         implicit none
         !
         real(real64), allocatable DEV_ATTR :: array(:)
         integer, optional, intent(out) :: ierr
         integer :: ierr_
         !
         ierr_=0
         !
#if defined __DXL_CUDAF
         if (allocated(array)) deallocate( array, stat=ierr_)
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC exit data delete(array) wait
         !DEV_OMPGPU target exit data map(delete:array)
#endif
         if (present(ierr)) ierr=ierr_
         !
      end subroutine dp_devxlib_mapping_unmap_r1d
!
!
      module subroutine dp_devxlib_mapping_unmap_r2d(array, ierr)
         implicit none
         !
         real(real64), allocatable DEV_ATTR :: array(:,:)
         integer, optional, intent(out) :: ierr
         integer :: ierr_
         !
         ierr_=0
         !
#if defined __DXL_CUDAF
         if (allocated(array)) deallocate( array, stat=ierr_)
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC exit data delete(array) wait
         !DEV_OMPGPU target exit data map(delete:array)
#endif
         if (present(ierr)) ierr=ierr_
         !
      end subroutine dp_devxlib_mapping_unmap_r2d
!
!
      module subroutine dp_devxlib_mapping_unmap_r3d(array, ierr)
         implicit none
         !
         real(real64), allocatable DEV_ATTR :: array(:,:,:)
         integer, optional, intent(out) :: ierr
         integer :: ierr_
         !
         ierr_=0
         !
#if defined __DXL_CUDAF
         if (allocated(array)) deallocate( array, stat=ierr_)
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC exit data delete(array) wait
         !DEV_OMPGPU target exit data map(delete:array)
#endif
         if (present(ierr)) ierr=ierr_
         !
      end subroutine dp_devxlib_mapping_unmap_r3d
!
!
      module subroutine dp_devxlib_mapping_unmap_r4d(array, ierr)
         implicit none
         !
         real(real64), allocatable DEV_ATTR :: array(:,:,:,:)
         integer, optional, intent(out) :: ierr
         integer :: ierr_
         !
         ierr_=0
         !
#if defined __DXL_CUDAF
         if (allocated(array)) deallocate( array, stat=ierr_)
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC exit data delete(array) wait
         !DEV_OMPGPU target exit data map(delete:array)
#endif
         if (present(ierr)) ierr=ierr_
         !
      end subroutine dp_devxlib_mapping_unmap_r4d
!
!
      module subroutine dp_devxlib_mapping_unmap_r5d(array, ierr)
         implicit none
         !
         real(real64), allocatable DEV_ATTR :: array(:,:,:,:,:)
         integer, optional, intent(out) :: ierr
         integer :: ierr_
         !
         ierr_=0
         !
#if defined __DXL_CUDAF
         if (allocated(array)) deallocate( array, stat=ierr_)
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC exit data delete(array) wait
         !DEV_OMPGPU target exit data map(delete:array)
#endif
         if (present(ierr)) ierr=ierr_
         !
      end subroutine dp_devxlib_mapping_unmap_r5d
!
!
      module subroutine dp_devxlib_mapping_unmap_r6d(array, ierr)
         implicit none
         !
         real(real64), allocatable DEV_ATTR :: array(:,:,:,:,:,:)
         integer, optional, intent(out) :: ierr
         integer :: ierr_
         !
         ierr_=0
         !
#if defined __DXL_CUDAF
         if (allocated(array)) deallocate( array, stat=ierr_)
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC exit data delete(array) wait
         !DEV_OMPGPU target exit data map(delete:array)
#endif
         if (present(ierr)) ierr=ierr_
         !
      end subroutine dp_devxlib_mapping_unmap_r6d
!
!
      module subroutine sp_devxlib_mapping_unmap_c1d(array, ierr)
         implicit none
         !
         complex(real32), allocatable DEV_ATTR :: array(:)
         integer, optional, intent(out) :: ierr
         integer :: ierr_
         !
         ierr_=0
         !
#if defined __DXL_CUDAF
         if (allocated(array)) deallocate( array, stat=ierr_)
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC exit data delete(array) wait
         !DEV_OMPGPU target exit data map(delete:array)
#endif
         if (present(ierr)) ierr=ierr_
         !
      end subroutine sp_devxlib_mapping_unmap_c1d
!
!
      module subroutine sp_devxlib_mapping_unmap_c2d(array, ierr)
         implicit none
         !
         complex(real32), allocatable DEV_ATTR :: array(:,:)
         integer, optional, intent(out) :: ierr
         integer :: ierr_
         !
         ierr_=0
         !
#if defined __DXL_CUDAF
         if (allocated(array)) deallocate( array, stat=ierr_)
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC exit data delete(array) wait
         !DEV_OMPGPU target exit data map(delete:array)
#endif
         if (present(ierr)) ierr=ierr_
         !
      end subroutine sp_devxlib_mapping_unmap_c2d
!
!
      module subroutine sp_devxlib_mapping_unmap_c3d(array, ierr)
         implicit none
         !
         complex(real32), allocatable DEV_ATTR :: array(:,:,:)
         integer, optional, intent(out) :: ierr
         integer :: ierr_
         !
         ierr_=0
         !
#if defined __DXL_CUDAF
         if (allocated(array)) deallocate( array, stat=ierr_)
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC exit data delete(array) wait
         !DEV_OMPGPU target exit data map(delete:array)
#endif
         if (present(ierr)) ierr=ierr_
         !
      end subroutine sp_devxlib_mapping_unmap_c3d
!
!
      module subroutine sp_devxlib_mapping_unmap_c4d(array, ierr)
         implicit none
         !
         complex(real32), allocatable DEV_ATTR :: array(:,:,:,:)
         integer, optional, intent(out) :: ierr
         integer :: ierr_
         !
         ierr_=0
         !
#if defined __DXL_CUDAF
         if (allocated(array)) deallocate( array, stat=ierr_)
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC exit data delete(array) wait
         !DEV_OMPGPU target exit data map(delete:array)
#endif
         if (present(ierr)) ierr=ierr_
         !
      end subroutine sp_devxlib_mapping_unmap_c4d
!
!
      module subroutine sp_devxlib_mapping_unmap_c5d(array, ierr)
         implicit none
         !
         complex(real32), allocatable DEV_ATTR :: array(:,:,:,:,:)
         integer, optional, intent(out) :: ierr
         integer :: ierr_
         !
         ierr_=0
         !
#if defined __DXL_CUDAF
         if (allocated(array)) deallocate( array, stat=ierr_)
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC exit data delete(array) wait
         !DEV_OMPGPU target exit data map(delete:array)
#endif
         if (present(ierr)) ierr=ierr_
         !
      end subroutine sp_devxlib_mapping_unmap_c5d
!
!
      module subroutine sp_devxlib_mapping_unmap_c6d(array, ierr)
         implicit none
         !
         complex(real32), allocatable DEV_ATTR :: array(:,:,:,:,:,:)
         integer, optional, intent(out) :: ierr
         integer :: ierr_
         !
         ierr_=0
         !
#if defined __DXL_CUDAF
         if (allocated(array)) deallocate( array, stat=ierr_)
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC exit data delete(array) wait
         !DEV_OMPGPU target exit data map(delete:array)
#endif
         if (present(ierr)) ierr=ierr_
         !
      end subroutine sp_devxlib_mapping_unmap_c6d
!
!
      module subroutine dp_devxlib_mapping_unmap_c1d(array, ierr)
         implicit none
         !
         complex(real64), allocatable DEV_ATTR :: array(:)
         integer, optional, intent(out) :: ierr
         integer :: ierr_
         !
         ierr_=0
         !
#if defined __DXL_CUDAF
         if (allocated(array)) deallocate( array, stat=ierr_)
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC exit data delete(array) wait
         !DEV_OMPGPU target exit data map(delete:array)
#endif
         if (present(ierr)) ierr=ierr_
         !
      end subroutine dp_devxlib_mapping_unmap_c1d
!
!
      module subroutine dp_devxlib_mapping_unmap_c2d(array, ierr)
         implicit none
         !
         complex(real64), allocatable DEV_ATTR :: array(:,:)
         integer, optional, intent(out) :: ierr
         integer :: ierr_
         !
         ierr_=0
         !
#if defined __DXL_CUDAF
         if (allocated(array)) deallocate( array, stat=ierr_)
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC exit data delete(array) wait
         !DEV_OMPGPU target exit data map(delete:array)
#endif
         if (present(ierr)) ierr=ierr_
         !
      end subroutine dp_devxlib_mapping_unmap_c2d
!
!
      module subroutine dp_devxlib_mapping_unmap_c3d(array, ierr)
         implicit none
         !
         complex(real64), allocatable DEV_ATTR :: array(:,:,:)
         integer, optional, intent(out) :: ierr
         integer :: ierr_
         !
         ierr_=0
         !
#if defined __DXL_CUDAF
         if (allocated(array)) deallocate( array, stat=ierr_)
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC exit data delete(array) wait
         !DEV_OMPGPU target exit data map(delete:array)
#endif
         if (present(ierr)) ierr=ierr_
         !
      end subroutine dp_devxlib_mapping_unmap_c3d
!
!
      module subroutine dp_devxlib_mapping_unmap_c4d(array, ierr)
         implicit none
         !
         complex(real64), allocatable DEV_ATTR :: array(:,:,:,:)
         integer, optional, intent(out) :: ierr
         integer :: ierr_
         !
         ierr_=0
         !
#if defined __DXL_CUDAF
         if (allocated(array)) deallocate( array, stat=ierr_)
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC exit data delete(array) wait
         !DEV_OMPGPU target exit data map(delete:array)
#endif
         if (present(ierr)) ierr=ierr_
         !
      end subroutine dp_devxlib_mapping_unmap_c4d
!
!
      module subroutine dp_devxlib_mapping_unmap_c5d(array, ierr)
         implicit none
         !
         complex(real64), allocatable DEV_ATTR :: array(:,:,:,:,:)
         integer, optional, intent(out) :: ierr
         integer :: ierr_
         !
         ierr_=0
         !
#if defined __DXL_CUDAF
         if (allocated(array)) deallocate( array, stat=ierr_)
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC exit data delete(array) wait
         !DEV_OMPGPU target exit data map(delete:array)
#endif
         if (present(ierr)) ierr=ierr_
         !
      end subroutine dp_devxlib_mapping_unmap_c5d
!
!
      module subroutine dp_devxlib_mapping_unmap_c6d(array, ierr)
         implicit none
         !
         complex(real64), allocatable DEV_ATTR :: array(:,:,:,:,:,:)
         integer, optional, intent(out) :: ierr
         integer :: ierr_
         !
         ierr_=0
         !
#if defined __DXL_CUDAF
         if (allocated(array)) deallocate( array, stat=ierr_)
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC exit data delete(array) wait
         !DEV_OMPGPU target exit data map(delete:array)
#endif
         if (present(ierr)) ierr=ierr_
         !
      end subroutine dp_devxlib_mapping_unmap_c6d
!
!
      module subroutine i4_devxlib_mapping_unmap_i1d(array, ierr)
         implicit none
         !
         integer(int32), allocatable DEV_ATTR :: array(:)
         integer, optional, intent(out) :: ierr
         integer :: ierr_
         !
         ierr_=0
         !
#if defined __DXL_CUDAF
         if (allocated(array)) deallocate( array, stat=ierr_)
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC exit data delete(array) wait
         !DEV_OMPGPU target exit data map(delete:array)
#endif
         if (present(ierr)) ierr=ierr_
         !
      end subroutine i4_devxlib_mapping_unmap_i1d
!
!
      module subroutine i4_devxlib_mapping_unmap_i2d(array, ierr)
         implicit none
         !
         integer(int32), allocatable DEV_ATTR :: array(:,:)
         integer, optional, intent(out) :: ierr
         integer :: ierr_
         !
         ierr_=0
         !
#if defined __DXL_CUDAF
         if (allocated(array)) deallocate( array, stat=ierr_)
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC exit data delete(array) wait
         !DEV_OMPGPU target exit data map(delete:array)
#endif
         if (present(ierr)) ierr=ierr_
         !
      end subroutine i4_devxlib_mapping_unmap_i2d
!
!
      module subroutine i4_devxlib_mapping_unmap_i3d(array, ierr)
         implicit none
         !
         integer(int32), allocatable DEV_ATTR :: array(:,:,:)
         integer, optional, intent(out) :: ierr
         integer :: ierr_
         !
         ierr_=0
         !
#if defined __DXL_CUDAF
         if (allocated(array)) deallocate( array, stat=ierr_)
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC exit data delete(array) wait
         !DEV_OMPGPU target exit data map(delete:array)
#endif
         if (present(ierr)) ierr=ierr_
         !
      end subroutine i4_devxlib_mapping_unmap_i3d
!
!
      module subroutine i4_devxlib_mapping_unmap_i4d(array, ierr)
         implicit none
         !
         integer(int32), allocatable DEV_ATTR :: array(:,:,:,:)
         integer, optional, intent(out) :: ierr
         integer :: ierr_
         !
         ierr_=0
         !
#if defined __DXL_CUDAF
         if (allocated(array)) deallocate( array, stat=ierr_)
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC exit data delete(array) wait
         !DEV_OMPGPU target exit data map(delete:array)
#endif
         if (present(ierr)) ierr=ierr_
         !
      end subroutine i4_devxlib_mapping_unmap_i4d
!
!
      module subroutine i4_devxlib_mapping_unmap_i5d(array, ierr)
         implicit none
         !
         integer(int32), allocatable DEV_ATTR :: array(:,:,:,:,:)
         integer, optional, intent(out) :: ierr
         integer :: ierr_
         !
         ierr_=0
         !
#if defined __DXL_CUDAF
         if (allocated(array)) deallocate( array, stat=ierr_)
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC exit data delete(array) wait
         !DEV_OMPGPU target exit data map(delete:array)
#endif
         if (present(ierr)) ierr=ierr_
         !
      end subroutine i4_devxlib_mapping_unmap_i5d
!
!
      module subroutine i4_devxlib_mapping_unmap_i6d(array, ierr)
         implicit none
         !
         integer(int32), allocatable DEV_ATTR :: array(:,:,:,:,:,:)
         integer, optional, intent(out) :: ierr
         integer :: ierr_
         !
         ierr_=0
         !
#if defined __DXL_CUDAF
         if (allocated(array)) deallocate( array, stat=ierr_)
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC exit data delete(array) wait
         !DEV_OMPGPU target exit data map(delete:array)
#endif
         if (present(ierr)) ierr=ierr_
         !
      end subroutine i4_devxlib_mapping_unmap_i6d
!
!
      module subroutine i8_devxlib_mapping_unmap_i1d(array, ierr)
         implicit none
         !
         integer(int64), allocatable DEV_ATTR :: array(:)
         integer, optional, intent(out) :: ierr
         integer :: ierr_
         !
         ierr_=0
         !
#if defined __DXL_CUDAF
         if (allocated(array)) deallocate( array, stat=ierr_)
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC exit data delete(array) wait
         !DEV_OMPGPU target exit data map(delete:array)
#endif
         if (present(ierr)) ierr=ierr_
         !
      end subroutine i8_devxlib_mapping_unmap_i1d
!
!
      module subroutine i8_devxlib_mapping_unmap_i2d(array, ierr)
         implicit none
         !
         integer(int64), allocatable DEV_ATTR :: array(:,:)
         integer, optional, intent(out) :: ierr
         integer :: ierr_
         !
         ierr_=0
         !
#if defined __DXL_CUDAF
         if (allocated(array)) deallocate( array, stat=ierr_)
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC exit data delete(array) wait
         !DEV_OMPGPU target exit data map(delete:array)
#endif
         if (present(ierr)) ierr=ierr_
         !
      end subroutine i8_devxlib_mapping_unmap_i2d
!
!
      module subroutine i8_devxlib_mapping_unmap_i3d(array, ierr)
         implicit none
         !
         integer(int64), allocatable DEV_ATTR :: array(:,:,:)
         integer, optional, intent(out) :: ierr
         integer :: ierr_
         !
         ierr_=0
         !
#if defined __DXL_CUDAF
         if (allocated(array)) deallocate( array, stat=ierr_)
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC exit data delete(array) wait
         !DEV_OMPGPU target exit data map(delete:array)
#endif
         if (present(ierr)) ierr=ierr_
         !
      end subroutine i8_devxlib_mapping_unmap_i3d
!
!
      module subroutine i8_devxlib_mapping_unmap_i4d(array, ierr)
         implicit none
         !
         integer(int64), allocatable DEV_ATTR :: array(:,:,:,:)
         integer, optional, intent(out) :: ierr
         integer :: ierr_
         !
         ierr_=0
         !
#if defined __DXL_CUDAF
         if (allocated(array)) deallocate( array, stat=ierr_)
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC exit data delete(array) wait
         !DEV_OMPGPU target exit data map(delete:array)
#endif
         if (present(ierr)) ierr=ierr_
         !
      end subroutine i8_devxlib_mapping_unmap_i4d
!
!
      module subroutine i8_devxlib_mapping_unmap_i5d(array, ierr)
         implicit none
         !
         integer(int64), allocatable DEV_ATTR :: array(:,:,:,:,:)
         integer, optional, intent(out) :: ierr
         integer :: ierr_
         !
         ierr_=0
         !
#if defined __DXL_CUDAF
         if (allocated(array)) deallocate( array, stat=ierr_)
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC exit data delete(array) wait
         !DEV_OMPGPU target exit data map(delete:array)
#endif
         if (present(ierr)) ierr=ierr_
         !
      end subroutine i8_devxlib_mapping_unmap_i5d
!
!
      module subroutine i8_devxlib_mapping_unmap_i6d(array, ierr)
         implicit none
         !
         integer(int64), allocatable DEV_ATTR :: array(:,:,:,:,:,:)
         integer, optional, intent(out) :: ierr
         integer :: ierr_
         !
         ierr_=0
         !
#if defined __DXL_CUDAF
         if (allocated(array)) deallocate( array, stat=ierr_)
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC exit data delete(array) wait
         !DEV_OMPGPU target exit data map(delete:array)
#endif
         if (present(ierr)) ierr=ierr_
         !
      end subroutine i8_devxlib_mapping_unmap_i6d
!
!
      module subroutine l4_devxlib_mapping_unmap_l1d(array, ierr)
         implicit none
         !
         logical(int32), allocatable DEV_ATTR :: array(:)
         integer, optional, intent(out) :: ierr
         integer :: ierr_
         !
         ierr_=0
         !
#if defined __DXL_CUDAF
         if (allocated(array)) deallocate( array, stat=ierr_)
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC exit data delete(array) wait
         !DEV_OMPGPU target exit data map(delete:array)
#endif
         if (present(ierr)) ierr=ierr_
         !
      end subroutine l4_devxlib_mapping_unmap_l1d
!
!
      module subroutine l4_devxlib_mapping_unmap_l2d(array, ierr)
         implicit none
         !
         logical(int32), allocatable DEV_ATTR :: array(:,:)
         integer, optional, intent(out) :: ierr
         integer :: ierr_
         !
         ierr_=0
         !
#if defined __DXL_CUDAF
         if (allocated(array)) deallocate( array, stat=ierr_)
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC exit data delete(array) wait
         !DEV_OMPGPU target exit data map(delete:array)
#endif
         if (present(ierr)) ierr=ierr_
         !
      end subroutine l4_devxlib_mapping_unmap_l2d
!
!
      module subroutine l4_devxlib_mapping_unmap_l3d(array, ierr)
         implicit none
         !
         logical(int32), allocatable DEV_ATTR :: array(:,:,:)
         integer, optional, intent(out) :: ierr
         integer :: ierr_
         !
         ierr_=0
         !
#if defined __DXL_CUDAF
         if (allocated(array)) deallocate( array, stat=ierr_)
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC exit data delete(array) wait
         !DEV_OMPGPU target exit data map(delete:array)
#endif
         if (present(ierr)) ierr=ierr_
         !
      end subroutine l4_devxlib_mapping_unmap_l3d
!
!
      module subroutine l4_devxlib_mapping_unmap_l4d(array, ierr)
         implicit none
         !
         logical(int32), allocatable DEV_ATTR :: array(:,:,:,:)
         integer, optional, intent(out) :: ierr
         integer :: ierr_
         !
         ierr_=0
         !
#if defined __DXL_CUDAF
         if (allocated(array)) deallocate( array, stat=ierr_)
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC exit data delete(array) wait
         !DEV_OMPGPU target exit data map(delete:array)
#endif
         if (present(ierr)) ierr=ierr_
         !
      end subroutine l4_devxlib_mapping_unmap_l4d
!
!
      module subroutine l4_devxlib_mapping_unmap_l5d(array, ierr)
         implicit none
         !
         logical(int32), allocatable DEV_ATTR :: array(:,:,:,:,:)
         integer, optional, intent(out) :: ierr
         integer :: ierr_
         !
         ierr_=0
         !
#if defined __DXL_CUDAF
         if (allocated(array)) deallocate( array, stat=ierr_)
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC exit data delete(array) wait
         !DEV_OMPGPU target exit data map(delete:array)
#endif
         if (present(ierr)) ierr=ierr_
         !
      end subroutine l4_devxlib_mapping_unmap_l5d
!
!
      module subroutine l4_devxlib_mapping_unmap_l6d(array, ierr)
         implicit none
         !
         logical(int32), allocatable DEV_ATTR :: array(:,:,:,:,:,:)
         integer, optional, intent(out) :: ierr
         integer :: ierr_
         !
         ierr_=0
         !
#if defined __DXL_CUDAF
         if (allocated(array)) deallocate( array, stat=ierr_)
#elif defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
         !DEV_ACC exit data delete(array) wait
         !DEV_OMPGPU target exit data map(delete:array)
#endif
         if (present(ierr)) ierr=ierr_
         !
      end subroutine l4_devxlib_mapping_unmap_l6d
!

endsubmodule devxlib_mapping_unmap

!
! Copyright (C) 2021, MaX CoE
! Distributed under the MIT License 
! (license terms are at http://opensource.org/licenses/MIT).
!
!--
!
! interface to timing routines and other utilities, 
! mostly used in tests
!
module dev_utils_m
  !
  use iso_c_binding
  use iso_fortran_env
  implicit none
  private
 
  complex(real32), parameter :: ci_sp=cmplx(0.0,1.0,kind=real32)
  complex(real64), parameter :: ci_dp=cmplx(0.0,1.0,kind=real64)

  interface 
    function wallclock() bind(C,name="wallclock_c")
       use iso_c_binding, only: c_double
       real(c_double) :: wallclock
    end function
  end interface

  interface random_number_cmplx
    module procedure :: random_number_cmplx_c1
    module procedure :: random_number_cmplx_c2
    module procedure :: random_number_cmplx_z1
    module procedure :: random_number_cmplx_z2
  end interface

  public :: wallclock
  public :: random_number_cmplx

contains

  subroutine random_number_cmplx_c1(array)
    implicit none
    complex(real32) :: array(:)
    real(real32), allocatable :: rtmp(:)
    !
    allocate(rtmp,mold=real(array))
    call random_number(rtmp)
    array=rtmp
    call random_number(rtmp)
    array=array+ci_sp*rtmp
    deallocate(rtmp)
  end subroutine

  subroutine random_number_cmplx_c2(array)
    implicit none
    complex(real32) :: array(:,:)
    real(real32), allocatable :: rtmp(:,:)
    !
    allocate(rtmp,mold=real(array))
    call random_number(rtmp)
    array=rtmp
    call random_number(rtmp)
    array=array+ci_sp*rtmp
    deallocate(rtmp)
  end subroutine

  subroutine random_number_cmplx_z1(array)
    implicit none
    complex(real64) :: array(:)
    real(real64), allocatable :: rtmp(:)
    !
    allocate(rtmp,mold=real(array))
    call random_number(rtmp)
    array=rtmp
    call random_number(rtmp)
    array=array+ci_sp*rtmp
    deallocate(rtmp)
  end subroutine

  subroutine random_number_cmplx_z2(array)
    implicit none
    complex(real64) :: array(:,:)
    real(real64), allocatable :: rtmp(:,:)
    !
    allocate(rtmp,mold=real(array))
    call random_number(rtmp)
    array=rtmp
    call random_number(rtmp)
    array=array+ci_sp*rtmp
    deallocate(rtmp)
  end subroutine

end module dev_utils_m

!
! Copyright (C) 2021, MaX CoE
! Distributed under the MIT License
! (license terms are at http://opensource.org/licenses/MIT).
!
!--
!
! Wrappers for selected Linear Algebra subroutines
!
#include<devxlib_defs.h>
#include<devxlib_macros.h>
!
#ifdef __DXL_HAVE_DEVICE
  !
  ! checks
  !
#if ! defined __DXL_CUBLAS && ! defined __DXL_ROCBLAS && ! defined __DXL_MKL_GPU
# error
#endif
#endif

submodule (devxlib_linalg) devxlib_linalg_axpy

   implicit none

   contains

   module subroutine dev_SAXPY_gpu(N,SA,SX,INCX,SY,INCY)
      implicit none
      integer,  intent(in) :: N
      integer,  intent(in) :: INCX,INCY
      real(real32), intent(in) TAR_ATTR :: SA
      real(real32), intent(in) TAR_ATTR DEV_ATTR :: SX(:)
      real(real32)             TAR_ATTR DEV_ATTR :: SY(:)
      !
      integer :: ierr
      !
      call acc_loc_dev_sync()
      !
      !DEV_ACC data present(SX,SY)
      !DEV_ACC host_data use_device(SX,SY)
#if defined __DXL_CUBLAS
      call cublasSaxpy(N,SA,SX,INCX,SY,INCY)
#elif defined __DXL_ROCBLAS
      !DEV_OMPGPU target data use_device_ptr(SX,SY)
      ierr=rocblas_saxpy(handle,N,c_loc(SA),c_loc(SX),INCX,c_loc(SY),INCY)
      !DEV_OMPGPU end target data
#elif defined __DXL_MKL_GPU
      !DEV_OMPGPU target data use_device_addr(SX,SY)
      !DEV_OMPGPU dispatch
      call Saxpy(N,SA,SX,INCX,SY,INCY)
      !DEV_OMPGPU end dispatch
      !DEV_OMPGPU end target data
#else
      call SAXPY(N,SA,SX,INCX,SY,INCY)
#endif
      !DEV_ACC end host_data
      !DEV_ACC end data
      !
      call acc_loc_dev_sync()
      !
   end subroutine dev_SAXPY_gpu
   !
   module subroutine dev_DAXPY_gpu(N,DA,DX,INCX,DY,INCY)
      implicit none
      integer,  intent(in) :: N
      integer,  intent(in) :: INCX,INCY
      real(real64), intent(in) TAR_ATTR :: DA
      real(real64), intent(in) TAR_ATTR DEV_ATTR :: DX(:)
      real(real64)             TAR_ATTR DEV_ATTR :: DY(:)
      !
      integer :: ierr
      !
      call acc_loc_dev_sync()
      !
      !DEV_ACC data present(DX,DY)
      !DEV_ACC host_data use_device(DX,DY)
#if defined __DXL_CUBLAS
      call cublasDaxpy(N,DA,DX,INCX,DY,INCY)
#elif defined __DXL_ROCBLAS
      !DEV_OMPGPU target data use_device_ptr(DX,DY)
      ierr=rocblas_daxpy(handle,N,c_loc(DA),c_loc(DX),INCX,c_loc(DY),INCY)
      !DEV_OMPGPU end target data
#elif defined __DXL_MKL_GPU
      !DEV_OMPGPU target data use_device_addr(DX,DY)
      !DEV_OMPGPU dispatch
      call Daxpy(N,DA,DX,INCX,DY,INCY)
      !DEV_OMPGPU end dispatch
      !DEV_OMPGPU end target data
#else
      call DAXPY(N,DA,DX,INCX,DY,INCY)
#endif
      !DEV_ACC end host_data
      !DEV_ACC end data
      !
      call acc_loc_dev_sync()
      !
   end subroutine dev_DAXPY_gpu
   !
   module subroutine dev_CAXPY_gpu(N,CA,CX,INCX,CY,INCY)
      implicit none
      integer,     intent(in) :: N
      integer,     intent(in) :: INCX,INCY
      complex(real32), intent(in) TAR_ATTR :: CA
      complex(real32), intent(in) TAR_ATTR DEV_ATTR :: CX(:)
      complex(real32)             TAR_ATTR DEV_ATTR :: CY(:)
      !
      integer :: ierr
      !
      call acc_loc_dev_sync()
      !
      !DEV_ACC data present(CX,CY)
      !DEV_ACC host_data use_device(CX,CY)
#if defined __DXL_CUBLAS
      call cublasCaxpy(N,CA,CX,INCX,CY,INCY)
#elif defined __DXL_ROCBLAS
      !DEV_OMPGPU target data use_device_ptr(CX,CY)
      ierr=rocblas_caxpy(handle,N,c_loc(CA),c_loc(CX),INCX,c_loc(CY),INCY)
      !DEV_OMPGPU end target data
#elif defined __DXL_MKL_GPU
      !DEV_OMPGPU target data use_device_addr(CX,CY)
      !DEV_OMPGPU dispatch
      call Caxpy(N,CA,CX,INCX,CY,INCY)
      !DEV_OMPGPU end dispatch
      !DEV_OMPGPU end target data
#else
      call CAXPY(N,CA,CX,INCX,CY,INCY)
#endif
      !DEV_ACC end host_data
      !DEV_ACC end data
      !
      call acc_loc_dev_sync()
      !
   end subroutine dev_CAXPY_gpu
   !
   module subroutine dev_ZAXPY_gpu(N,CA,CX,INCX,CY,INCY)
      implicit none
      integer,     intent(in) :: N
      integer,     intent(in) :: INCX,INCY
      complex(real64), intent(in) TAR_ATTR :: CA
      complex(real64), intent(in) TAR_ATTR DEV_ATTR :: CX(:)
      complex(real64)             TAR_ATTR DEV_ATTR :: CY(:)
      !
      integer :: ierr
      !
      call acc_loc_dev_sync()
      !
      !DEV_ACC data present(CX,CY)
      !DEV_ACC host_data use_device(CX,CY)
#if defined __DXL_CUBLAS
      call cublasZaxpy(N,CA,CX,INCX,CY,INCY)
#elif defined __DXL_ROCBLAS
      !DEV_OMPGPU target data use_device_ptr(CX,CY)
      ierr=rocblas_zaxpy(handle,N,c_loc(CA),c_loc(CX),INCX,c_loc(CY),INCY)
      !DEV_OMPGPU end target data
#elif defined __DXL_MKL_GPU
      !DEV_OMPGPU target data use_device_addr(CX,CY)
      !DEV_OMPGPU dispatch
      call Zaxpy(N,CA,CX,INCX,CY,INCY)
      !DEV_OMPGPU end dispatch
      !DEV_OMPGPU end target data
#else
      call ZAXPY(N,CA,CX,INCX,CY,INCY)
#endif
      !DEV_ACC end host_data
      !DEV_ACC end data
      !
      call acc_loc_dev_sync()
      !
   end subroutine dev_ZAXPY_gpu
   !
end submodule devxlib_linalg_axpy

!
! Copyright (C) 2021, MaX CoE
! Distributed under the MIT License 
! (license terms are at http://opensource.org/licenses/MIT).
!
!--
!
! Auxiliary functions
!
! AF: OpenACC support is incomplete !!
!
!==================================================================
!==================================================================
! *DO NOT EDIT*: automatically generated from devxlib_auxfunc_conj.jf90
!==================================================================
!==================================================================
!
#include<devxlib_macros.h>
#include<devxlib_defs.h>
!
!=======================================
!
submodule (devxlib_auxfunc) devxlib_auxfunc_conjg

   implicit none

   contains

      module subroutine dp_devxlib_conjg_c1d(array_inout, async_id, &
                                         
                                        range1, lbound1 )
         implicit none
         !
         complex(real64) DEV_ATTR, intent(inout) :: array_inout(:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2)
         integer, optional, intent(in) ::  lbound1
         !
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_inout, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         !
         if (present(async_id)) then
            !
            !DEV_CUF kernel do(1) <<<*,*,0,stream=async_id>>>
            !DEV_ACC_DEBUG data present(array_inout)
            !DEV_ACC parallel loop collapse(1) async(async_id)
            !DEV_OMPGPU target map(present,alloc:array_inout)
            !DEV_OMPGPU teams loop collapse(1)
            !DEV_OMP  parallel do
            do i1 = d1s, d1e
               array_inout(i1 ) = &
                   conjg (  array_inout (i1 ) )
            enddo
            !DEV_ACC_DEBUG end data
            !DEV_OMPGPU end target
            !
         else
            !
            !DEV_CUF kernel do(1)
            !DEV_ACC_DEBUG data present(array_inout)
            !DEV_ACC parallel loop collapse(1) async
            !DEV_OMPGPU target map(present,alloc:array_inout)
            !DEV_OMPGPU teams loop collapse(1)
            !DEV_OMP  parallel do
            do i1 = d1s, d1e
               array_inout(i1 ) = &
                   conjg (  array_inout (i1 ) )
            enddo
            !DEV_ACC_DEBUG end data
            !DEV_OMPGPU end target
            !
         endif
          !
      end subroutine dp_devxlib_conjg_c1d
      !
      module subroutine dp_devxlib_conjg_c2d(array_inout, async_id, &
                                         
                                        range1, lbound1, & 
                                        range2, lbound2 )
         implicit none
         !
         complex(real64) DEV_ATTR, intent(inout) :: array_inout(:,:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2)
         integer, optional, intent(in) ::  lbound1, lbound2
         !
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_inout, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_inout, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         !
         if (present(async_id)) then
            !
            !DEV_CUF kernel do(2) <<<*,*,0,stream=async_id>>>
            !DEV_ACC_DEBUG data present(array_inout)
            !DEV_ACC parallel loop collapse(2) async(async_id)
            !DEV_OMPGPU target map(present,alloc:array_inout)
            !DEV_OMPGPU teams loop collapse(2)
            !DEV_OMP  parallel do
            do i2 = d2s, d2e
            do i1 = d1s, d1e
               array_inout(i1,i2 ) = &
                   conjg (  array_inout (i1,i2 ) )
            enddo
            enddo
            !DEV_ACC_DEBUG end data
            !DEV_OMPGPU end target
            !
         else
            !
            !DEV_CUF kernel do(2)
            !DEV_ACC_DEBUG data present(array_inout)
            !DEV_ACC parallel loop collapse(2) async
            !DEV_OMPGPU target map(present,alloc:array_inout)
            !DEV_OMPGPU teams loop collapse(2)
            !DEV_OMP  parallel do
            do i2 = d2s, d2e
            do i1 = d1s, d1e
               array_inout(i1,i2 ) = &
                   conjg (  array_inout (i1,i2 ) )
            enddo
            enddo
            !DEV_ACC_DEBUG end data
            !DEV_OMPGPU end target
            !
         endif
          !
      end subroutine dp_devxlib_conjg_c2d
      !
      module subroutine dp_devxlib_conjg_c3d(array_inout, async_id, &
                                         
                                        range1, lbound1, & 
                                        range2, lbound2, & 
                                        range3, lbound3 )
         implicit none
         !
         complex(real64) DEV_ATTR, intent(inout) :: array_inout(:,:,:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3
         !
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_inout, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_inout, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_inout, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         !
         if (present(async_id)) then
            !
            !DEV_CUF kernel do(3) <<<*,*,0,stream=async_id>>>
            !DEV_ACC_DEBUG data present(array_inout)
            !DEV_ACC parallel loop collapse(3) async(async_id)
            !DEV_OMPGPU target map(present,alloc:array_inout)
            !DEV_OMPGPU teams loop collapse(3)
            !DEV_OMP  parallel do
            do i3 = d3s, d3e
            do i2 = d2s, d2e
            do i1 = d1s, d1e
               array_inout(i1,i2,i3 ) = &
                   conjg (  array_inout (i1,i2,i3 ) )
            enddo
            enddo
            enddo
            !DEV_ACC_DEBUG end data
            !DEV_OMPGPU end target
            !
         else
            !
            !DEV_CUF kernel do(3)
            !DEV_ACC_DEBUG data present(array_inout)
            !DEV_ACC parallel loop collapse(3) async
            !DEV_OMPGPU target map(present,alloc:array_inout)
            !DEV_OMPGPU teams loop collapse(3)
            !DEV_OMP  parallel do
            do i3 = d3s, d3e
            do i2 = d2s, d2e
            do i1 = d1s, d1e
               array_inout(i1,i2,i3 ) = &
                   conjg (  array_inout (i1,i2,i3 ) )
            enddo
            enddo
            enddo
            !DEV_ACC_DEBUG end data
            !DEV_OMPGPU end target
            !
         endif
          !
      end subroutine dp_devxlib_conjg_c3d
      !
      module subroutine dp_devxlib_conjg_c4d(array_inout, async_id, &
                                         
                                        range1, lbound1, & 
                                        range2, lbound2, & 
                                        range3, lbound3, & 
                                        range4, lbound4 )
         implicit none
         !
         complex(real64) DEV_ATTR, intent(inout) :: array_inout(:,:,:,:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
         !
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_inout, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_inout, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_inout, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(array_inout, 4)/)
         if (present(range4)) range4_=range4 
         !
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         !
         if (present(async_id)) then
            !
            !DEV_CUF kernel do(4) <<<*,*,0,stream=async_id>>>
            !DEV_ACC_DEBUG data present(array_inout)
            !DEV_ACC parallel loop collapse(4) async(async_id)
            !DEV_OMPGPU target map(present,alloc:array_inout)
            !DEV_OMPGPU teams loop collapse(4)
            !DEV_OMP  parallel do
            do i4 = d4s, d4e
            do i3 = d3s, d3e
            do i2 = d2s, d2e
            do i1 = d1s, d1e
               array_inout(i1,i2,i3,i4 ) = &
                   conjg (  array_inout (i1,i2,i3,i4 ) )
            enddo
            enddo
            enddo
            enddo
            !DEV_ACC_DEBUG end data
            !DEV_OMPGPU end target
            !
         else
            !
            !DEV_CUF kernel do(4)
            !DEV_ACC_DEBUG data present(array_inout)
            !DEV_ACC parallel loop collapse(4) async
            !DEV_OMPGPU target map(present,alloc:array_inout)
            !DEV_OMPGPU teams loop collapse(4)
            !DEV_OMP  parallel do
            do i4 = d4s, d4e
            do i3 = d3s, d3e
            do i2 = d2s, d2e
            do i1 = d1s, d1e
               array_inout(i1,i2,i3,i4 ) = &
                   conjg (  array_inout (i1,i2,i3,i4 ) )
            enddo
            enddo
            enddo
            enddo
            !DEV_ACC_DEBUG end data
            !DEV_OMPGPU end target
            !
         endif
          !
      end subroutine dp_devxlib_conjg_c4d
      !
      module subroutine dp_devxlib_conjg_c5d(array_inout, async_id, &
                                         
                                        range1, lbound1, & 
                                        range2, lbound2, & 
                                        range3, lbound3, & 
                                        range4, lbound4, & 
                                        range5, lbound5 )
         implicit none
         !
         complex(real64) DEV_ATTR, intent(inout) :: array_inout(:,:,:,:,:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5
         !
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         integer :: i5, d5s, d5e
         integer :: lbound5_, range5_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_inout, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_inout, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_inout, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(array_inout, 4)/)
         if (present(range4)) range4_=range4 
         !
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         lbound5_=1
         if (present(lbound5)) lbound5_=lbound5 
         range5_=(/1,size(array_inout, 5)/)
         if (present(range5)) range5_=range5 
         !
         d5s = range5_(1) -lbound5_ +1
         d5e = range5_(2) -lbound5_ +1
         !
         !
         if (present(async_id)) then
            !
            !DEV_CUF kernel do(5) <<<*,*,0,stream=async_id>>>
            !DEV_ACC_DEBUG data present(array_inout)
            !DEV_ACC parallel loop collapse(5) async(async_id)
            !DEV_OMPGPU target map(present,alloc:array_inout)
            !DEV_OMPGPU teams loop collapse(5)
            !DEV_OMP  parallel do
            do i5 = d5s, d5e
            do i4 = d4s, d4e
            do i3 = d3s, d3e
            do i2 = d2s, d2e
            do i1 = d1s, d1e
               array_inout(i1,i2,i3,i4,i5 ) = &
                   conjg (  array_inout (i1,i2,i3,i4,i5 ) )
            enddo
            enddo
            enddo
            enddo
            enddo
            !DEV_ACC_DEBUG end data
            !DEV_OMPGPU end target
            !
         else
            !
            !DEV_CUF kernel do(5)
            !DEV_ACC_DEBUG data present(array_inout)
            !DEV_ACC parallel loop collapse(5) async
            !DEV_OMPGPU target map(present,alloc:array_inout)
            !DEV_OMPGPU teams loop collapse(5)
            !DEV_OMP  parallel do
            do i5 = d5s, d5e
            do i4 = d4s, d4e
            do i3 = d3s, d3e
            do i2 = d2s, d2e
            do i1 = d1s, d1e
               array_inout(i1,i2,i3,i4,i5 ) = &
                   conjg (  array_inout (i1,i2,i3,i4,i5 ) )
            enddo
            enddo
            enddo
            enddo
            enddo
            !DEV_ACC_DEBUG end data
            !DEV_OMPGPU end target
            !
         endif
          !
      end subroutine dp_devxlib_conjg_c5d
      !
      module subroutine dp_devxlib_conjg_c6d(array_inout, async_id, &
                                         
                                        range1, lbound1, & 
                                        range2, lbound2, & 
                                        range3, lbound3, & 
                                        range4, lbound4, & 
                                        range5, lbound5, & 
                                        range6, lbound6 )
         implicit none
         !
         complex(real64) DEV_ATTR, intent(inout) :: array_inout(:,:,:,:,:,:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2), range6(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5, lbound6
         !
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         integer :: i5, d5s, d5e
         integer :: lbound5_, range5_(2)
         integer :: i6, d6s, d6e
         integer :: lbound6_, range6_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_inout, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_inout, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_inout, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(array_inout, 4)/)
         if (present(range4)) range4_=range4 
         !
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         lbound5_=1
         if (present(lbound5)) lbound5_=lbound5 
         range5_=(/1,size(array_inout, 5)/)
         if (present(range5)) range5_=range5 
         !
         d5s = range5_(1) -lbound5_ +1
         d5e = range5_(2) -lbound5_ +1
         !
         lbound6_=1
         if (present(lbound6)) lbound6_=lbound6 
         range6_=(/1,size(array_inout, 6)/)
         if (present(range6)) range6_=range6 
         !
         d6s = range6_(1) -lbound6_ +1
         d6e = range6_(2) -lbound6_ +1
         !
         !
         if (present(async_id)) then
            !
            !DEV_CUF kernel do(6) <<<*,*,0,stream=async_id>>>
            !DEV_ACC_DEBUG data present(array_inout)
            !DEV_ACC parallel loop collapse(6) async(async_id)
            !DEV_OMPGPU target map(present,alloc:array_inout)
            !DEV_OMPGPU teams loop collapse(6)
            !DEV_OMP  parallel do
            do i6 = d6s, d6e
            do i5 = d5s, d5e
            do i4 = d4s, d4e
            do i3 = d3s, d3e
            do i2 = d2s, d2e
            do i1 = d1s, d1e
               array_inout(i1,i2,i3,i4,i5,i6 ) = &
                   conjg (  array_inout (i1,i2,i3,i4,i5,i6 ) )
            enddo
            enddo
            enddo
            enddo
            enddo
            enddo
            !DEV_ACC_DEBUG end data
            !DEV_OMPGPU end target
            !
         else
            !
            !DEV_CUF kernel do(6)
            !DEV_ACC_DEBUG data present(array_inout)
            !DEV_ACC parallel loop collapse(6) async
            !DEV_OMPGPU target map(present,alloc:array_inout)
            !DEV_OMPGPU teams loop collapse(6)
            !DEV_OMP  parallel do
            do i6 = d6s, d6e
            do i5 = d5s, d5e
            do i4 = d4s, d4e
            do i3 = d3s, d3e
            do i2 = d2s, d2e
            do i1 = d1s, d1e
               array_inout(i1,i2,i3,i4,i5,i6 ) = &
                   conjg (  array_inout (i1,i2,i3,i4,i5,i6 ) )
            enddo
            enddo
            enddo
            enddo
            enddo
            enddo
            !DEV_ACC_DEBUG end data
            !DEV_OMPGPU end target
            !
         endif
          !
      end subroutine dp_devxlib_conjg_c6d
      !
      module subroutine sp_devxlib_conjg_c1d(array_inout, async_id, &
                                         
                                        range1, lbound1 )
         implicit none
         !
         complex(real32) DEV_ATTR, intent(inout) :: array_inout(:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2)
         integer, optional, intent(in) ::  lbound1
         !
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_inout, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         !
         if (present(async_id)) then
            !
            !DEV_CUF kernel do(1) <<<*,*,0,stream=async_id>>>
            !DEV_ACC_DEBUG data present(array_inout)
            !DEV_ACC parallel loop collapse(1) async(async_id)
            !DEV_OMPGPU target map(present,alloc:array_inout)
            !DEV_OMPGPU teams loop collapse(1)
            !DEV_OMP  parallel do
            do i1 = d1s, d1e
               array_inout(i1 ) = &
                   conjg (  array_inout (i1 ) )
            enddo
            !DEV_ACC_DEBUG end data
            !DEV_OMPGPU end target
            !
         else
            !
            !DEV_CUF kernel do(1)
            !DEV_ACC_DEBUG data present(array_inout)
            !DEV_ACC parallel loop collapse(1) async
            !DEV_OMPGPU target map(present,alloc:array_inout)
            !DEV_OMPGPU teams loop collapse(1)
            !DEV_OMP  parallel do
            do i1 = d1s, d1e
               array_inout(i1 ) = &
                   conjg (  array_inout (i1 ) )
            enddo
            !DEV_ACC_DEBUG end data
            !DEV_OMPGPU end target
            !
         endif
          !
      end subroutine sp_devxlib_conjg_c1d
      !
      module subroutine sp_devxlib_conjg_c2d(array_inout, async_id, &
                                         
                                        range1, lbound1, & 
                                        range2, lbound2 )
         implicit none
         !
         complex(real32) DEV_ATTR, intent(inout) :: array_inout(:,:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2)
         integer, optional, intent(in) ::  lbound1, lbound2
         !
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_inout, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_inout, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         !
         if (present(async_id)) then
            !
            !DEV_CUF kernel do(2) <<<*,*,0,stream=async_id>>>
            !DEV_ACC_DEBUG data present(array_inout)
            !DEV_ACC parallel loop collapse(2) async(async_id)
            !DEV_OMPGPU target map(present,alloc:array_inout)
            !DEV_OMPGPU teams loop collapse(2)
            !DEV_OMP  parallel do
            do i2 = d2s, d2e
            do i1 = d1s, d1e
               array_inout(i1,i2 ) = &
                   conjg (  array_inout (i1,i2 ) )
            enddo
            enddo
            !DEV_ACC_DEBUG end data
            !DEV_OMPGPU end target
            !
         else
            !
            !DEV_CUF kernel do(2)
            !DEV_ACC_DEBUG data present(array_inout)
            !DEV_ACC parallel loop collapse(2) async
            !DEV_OMPGPU target map(present,alloc:array_inout)
            !DEV_OMPGPU teams loop collapse(2)
            !DEV_OMP  parallel do
            do i2 = d2s, d2e
            do i1 = d1s, d1e
               array_inout(i1,i2 ) = &
                   conjg (  array_inout (i1,i2 ) )
            enddo
            enddo
            !DEV_ACC_DEBUG end data
            !DEV_OMPGPU end target
            !
         endif
          !
      end subroutine sp_devxlib_conjg_c2d
      !
      module subroutine sp_devxlib_conjg_c3d(array_inout, async_id, &
                                         
                                        range1, lbound1, & 
                                        range2, lbound2, & 
                                        range3, lbound3 )
         implicit none
         !
         complex(real32) DEV_ATTR, intent(inout) :: array_inout(:,:,:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3
         !
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_inout, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_inout, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_inout, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         !
         if (present(async_id)) then
            !
            !DEV_CUF kernel do(3) <<<*,*,0,stream=async_id>>>
            !DEV_ACC_DEBUG data present(array_inout)
            !DEV_ACC parallel loop collapse(3) async(async_id)
            !DEV_OMPGPU target map(present,alloc:array_inout)
            !DEV_OMPGPU teams loop collapse(3)
            !DEV_OMP  parallel do
            do i3 = d3s, d3e
            do i2 = d2s, d2e
            do i1 = d1s, d1e
               array_inout(i1,i2,i3 ) = &
                   conjg (  array_inout (i1,i2,i3 ) )
            enddo
            enddo
            enddo
            !DEV_ACC_DEBUG end data
            !DEV_OMPGPU end target
            !
         else
            !
            !DEV_CUF kernel do(3)
            !DEV_ACC_DEBUG data present(array_inout)
            !DEV_ACC parallel loop collapse(3) async
            !DEV_OMPGPU target map(present,alloc:array_inout)
            !DEV_OMPGPU teams loop collapse(3)
            !DEV_OMP  parallel do
            do i3 = d3s, d3e
            do i2 = d2s, d2e
            do i1 = d1s, d1e
               array_inout(i1,i2,i3 ) = &
                   conjg (  array_inout (i1,i2,i3 ) )
            enddo
            enddo
            enddo
            !DEV_ACC_DEBUG end data
            !DEV_OMPGPU end target
            !
         endif
          !
      end subroutine sp_devxlib_conjg_c3d
      !
      module subroutine sp_devxlib_conjg_c4d(array_inout, async_id, &
                                         
                                        range1, lbound1, & 
                                        range2, lbound2, & 
                                        range3, lbound3, & 
                                        range4, lbound4 )
         implicit none
         !
         complex(real32) DEV_ATTR, intent(inout) :: array_inout(:,:,:,:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
         !
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_inout, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_inout, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_inout, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(array_inout, 4)/)
         if (present(range4)) range4_=range4 
         !
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         !
         if (present(async_id)) then
            !
            !DEV_CUF kernel do(4) <<<*,*,0,stream=async_id>>>
            !DEV_ACC_DEBUG data present(array_inout)
            !DEV_ACC parallel loop collapse(4) async(async_id)
            !DEV_OMPGPU target map(present,alloc:array_inout)
            !DEV_OMPGPU teams loop collapse(4)
            !DEV_OMP  parallel do
            do i4 = d4s, d4e
            do i3 = d3s, d3e
            do i2 = d2s, d2e
            do i1 = d1s, d1e
               array_inout(i1,i2,i3,i4 ) = &
                   conjg (  array_inout (i1,i2,i3,i4 ) )
            enddo
            enddo
            enddo
            enddo
            !DEV_ACC_DEBUG end data
            !DEV_OMPGPU end target
            !
         else
            !
            !DEV_CUF kernel do(4)
            !DEV_ACC_DEBUG data present(array_inout)
            !DEV_ACC parallel loop collapse(4) async
            !DEV_OMPGPU target map(present,alloc:array_inout)
            !DEV_OMPGPU teams loop collapse(4)
            !DEV_OMP  parallel do
            do i4 = d4s, d4e
            do i3 = d3s, d3e
            do i2 = d2s, d2e
            do i1 = d1s, d1e
               array_inout(i1,i2,i3,i4 ) = &
                   conjg (  array_inout (i1,i2,i3,i4 ) )
            enddo
            enddo
            enddo
            enddo
            !DEV_ACC_DEBUG end data
            !DEV_OMPGPU end target
            !
         endif
          !
      end subroutine sp_devxlib_conjg_c4d
      !
      module subroutine sp_devxlib_conjg_c5d(array_inout, async_id, &
                                         
                                        range1, lbound1, & 
                                        range2, lbound2, & 
                                        range3, lbound3, & 
                                        range4, lbound4, & 
                                        range5, lbound5 )
         implicit none
         !
         complex(real32) DEV_ATTR, intent(inout) :: array_inout(:,:,:,:,:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5
         !
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         integer :: i5, d5s, d5e
         integer :: lbound5_, range5_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_inout, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_inout, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_inout, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(array_inout, 4)/)
         if (present(range4)) range4_=range4 
         !
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         lbound5_=1
         if (present(lbound5)) lbound5_=lbound5 
         range5_=(/1,size(array_inout, 5)/)
         if (present(range5)) range5_=range5 
         !
         d5s = range5_(1) -lbound5_ +1
         d5e = range5_(2) -lbound5_ +1
         !
         !
         if (present(async_id)) then
            !
            !DEV_CUF kernel do(5) <<<*,*,0,stream=async_id>>>
            !DEV_ACC_DEBUG data present(array_inout)
            !DEV_ACC parallel loop collapse(5) async(async_id)
            !DEV_OMPGPU target map(present,alloc:array_inout)
            !DEV_OMPGPU teams loop collapse(5)
            !DEV_OMP  parallel do
            do i5 = d5s, d5e
            do i4 = d4s, d4e
            do i3 = d3s, d3e
            do i2 = d2s, d2e
            do i1 = d1s, d1e
               array_inout(i1,i2,i3,i4,i5 ) = &
                   conjg (  array_inout (i1,i2,i3,i4,i5 ) )
            enddo
            enddo
            enddo
            enddo
            enddo
            !DEV_ACC_DEBUG end data
            !DEV_OMPGPU end target
            !
         else
            !
            !DEV_CUF kernel do(5)
            !DEV_ACC_DEBUG data present(array_inout)
            !DEV_ACC parallel loop collapse(5) async
            !DEV_OMPGPU target map(present,alloc:array_inout)
            !DEV_OMPGPU teams loop collapse(5)
            !DEV_OMP  parallel do
            do i5 = d5s, d5e
            do i4 = d4s, d4e
            do i3 = d3s, d3e
            do i2 = d2s, d2e
            do i1 = d1s, d1e
               array_inout(i1,i2,i3,i4,i5 ) = &
                   conjg (  array_inout (i1,i2,i3,i4,i5 ) )
            enddo
            enddo
            enddo
            enddo
            enddo
            !DEV_ACC_DEBUG end data
            !DEV_OMPGPU end target
            !
         endif
          !
      end subroutine sp_devxlib_conjg_c5d
      !
      module subroutine sp_devxlib_conjg_c6d(array_inout, async_id, &
                                         
                                        range1, lbound1, & 
                                        range2, lbound2, & 
                                        range3, lbound3, & 
                                        range4, lbound4, & 
                                        range5, lbound5, & 
                                        range6, lbound6 )
         implicit none
         !
         complex(real32) DEV_ATTR, intent(inout) :: array_inout(:,:,:,:,:,:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2), range6(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5, lbound6
         !
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         integer :: i5, d5s, d5e
         integer :: lbound5_, range5_(2)
         integer :: i6, d6s, d6e
         integer :: lbound6_, range6_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_inout, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_inout, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_inout, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(array_inout, 4)/)
         if (present(range4)) range4_=range4 
         !
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         lbound5_=1
         if (present(lbound5)) lbound5_=lbound5 
         range5_=(/1,size(array_inout, 5)/)
         if (present(range5)) range5_=range5 
         !
         d5s = range5_(1) -lbound5_ +1
         d5e = range5_(2) -lbound5_ +1
         !
         lbound6_=1
         if (present(lbound6)) lbound6_=lbound6 
         range6_=(/1,size(array_inout, 6)/)
         if (present(range6)) range6_=range6 
         !
         d6s = range6_(1) -lbound6_ +1
         d6e = range6_(2) -lbound6_ +1
         !
         !
         if (present(async_id)) then
            !
            !DEV_CUF kernel do(6) <<<*,*,0,stream=async_id>>>
            !DEV_ACC_DEBUG data present(array_inout)
            !DEV_ACC parallel loop collapse(6) async(async_id)
            !DEV_OMPGPU target map(present,alloc:array_inout)
            !DEV_OMPGPU teams loop collapse(6)
            !DEV_OMP  parallel do
            do i6 = d6s, d6e
            do i5 = d5s, d5e
            do i4 = d4s, d4e
            do i3 = d3s, d3e
            do i2 = d2s, d2e
            do i1 = d1s, d1e
               array_inout(i1,i2,i3,i4,i5,i6 ) = &
                   conjg (  array_inout (i1,i2,i3,i4,i5,i6 ) )
            enddo
            enddo
            enddo
            enddo
            enddo
            enddo
            !DEV_ACC_DEBUG end data
            !DEV_OMPGPU end target
            !
         else
            !
            !DEV_CUF kernel do(6)
            !DEV_ACC_DEBUG data present(array_inout)
            !DEV_ACC parallel loop collapse(6) async
            !DEV_OMPGPU target map(present,alloc:array_inout)
            !DEV_OMPGPU teams loop collapse(6)
            !DEV_OMP  parallel do
            do i6 = d6s, d6e
            do i5 = d5s, d5e
            do i4 = d4s, d4e
            do i3 = d3s, d3e
            do i2 = d2s, d2e
            do i1 = d1s, d1e
               array_inout(i1,i2,i3,i4,i5,i6 ) = &
                   conjg (  array_inout (i1,i2,i3,i4,i5,i6 ) )
            enddo
            enddo
            enddo
            enddo
            enddo
            enddo
            !DEV_ACC_DEBUG end data
            !DEV_OMPGPU end target
            !
         endif
          !
      end subroutine sp_devxlib_conjg_c6d
      !


      module subroutine dp_devxlib_conjg_c1d_p(ptr_inout, async_id, &
                                         
                                        range1, lbound1 )
         implicit none
         !
         complex(real64), pointer, contiguous, intent(inout) DEV_ATTR :: ptr_inout(:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2)
         integer, optional, intent(in) ::  lbound1
         !
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(ptr_inout, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         !
         if (present(async_id)) then
            !
            !DEV_CUF kernel do(1) <<<*,*,0,stream=async_id>>>
#if defined __GFORTRAN__
            !DEV_ACC_DEBUG data present(ptr_inout)
#else
            !DEV_ACC_DEBUG data deviceptr(ptr_inout)
#endif
            !DEV_ACC parallel loop collapse(1) async(async_id)
            !DEV_OMPGPU target 
            !DEV_OMPGPU teams loop collapse(1)
            !DEV_OMP  parallel do
            do i1 = d1s, d1e
               ptr_inout(i1 ) = &
                   conjg (  ptr_inout (i1 ) )
            enddo
            !DEV_ACC_DEBUG end data
            !DEV_OMPGPU end target
            !
         else
            !
            !DEV_CUF kernel do(1)
#if defined __GFORTRAN__
            !DEV_ACC_DEBUG data present(ptr_inout)
#else
            !DEV_ACC_DEBUG data deviceptr(ptr_inout)
#endif
            !DEV_ACC parallel loop collapse(1) async
            !DEV_OMPGPU target 
            !DEV_OMPGPU teams loop collapse(1)
            !DEV_OMP  parallel do
            do i1 = d1s, d1e
               ptr_inout(i1 ) = &
                   conjg (  ptr_inout (i1 ) )
            enddo
            !DEV_ACC_DEBUG end data
            !DEV_OMPGPU end target
            !
         endif
          !
      end subroutine dp_devxlib_conjg_c1d_p
      !
      module subroutine dp_devxlib_conjg_c2d_p(ptr_inout, async_id, &
                                         
                                        range1, lbound1, & 
                                        range2, lbound2 )
         implicit none
         !
         complex(real64), pointer, contiguous, intent(inout) DEV_ATTR :: ptr_inout(:,:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2)
         integer, optional, intent(in) ::  lbound1, lbound2
         !
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(ptr_inout, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(ptr_inout, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         !
         if (present(async_id)) then
            !
            !DEV_CUF kernel do(2) <<<*,*,0,stream=async_id>>>
#if defined __GFORTRAN__
            !DEV_ACC_DEBUG data present(ptr_inout)
#else
            !DEV_ACC_DEBUG data deviceptr(ptr_inout)
#endif
            !DEV_ACC parallel loop collapse(2) async(async_id)
            !DEV_OMPGPU target 
            !DEV_OMPGPU teams loop collapse(2)
            !DEV_OMP  parallel do
            do i2 = d2s, d2e
            do i1 = d1s, d1e
               ptr_inout(i1,i2 ) = &
                   conjg (  ptr_inout (i1,i2 ) )
            enddo
            enddo
            !DEV_ACC_DEBUG end data
            !DEV_OMPGPU end target
            !
         else
            !
            !DEV_CUF kernel do(2)
#if defined __GFORTRAN__
            !DEV_ACC_DEBUG data present(ptr_inout)
#else
            !DEV_ACC_DEBUG data deviceptr(ptr_inout)
#endif
            !DEV_ACC parallel loop collapse(2) async
            !DEV_OMPGPU target 
            !DEV_OMPGPU teams loop collapse(2)
            !DEV_OMP  parallel do
            do i2 = d2s, d2e
            do i1 = d1s, d1e
               ptr_inout(i1,i2 ) = &
                   conjg (  ptr_inout (i1,i2 ) )
            enddo
            enddo
            !DEV_ACC_DEBUG end data
            !DEV_OMPGPU end target
            !
         endif
          !
      end subroutine dp_devxlib_conjg_c2d_p
      !
      module subroutine dp_devxlib_conjg_c3d_p(ptr_inout, async_id, &
                                         
                                        range1, lbound1, & 
                                        range2, lbound2, & 
                                        range3, lbound3 )
         implicit none
         !
         complex(real64), pointer, contiguous, intent(inout) DEV_ATTR :: ptr_inout(:,:,:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3
         !
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(ptr_inout, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(ptr_inout, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(ptr_inout, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         !
         if (present(async_id)) then
            !
            !DEV_CUF kernel do(3) <<<*,*,0,stream=async_id>>>
#if defined __GFORTRAN__
            !DEV_ACC_DEBUG data present(ptr_inout)
#else
            !DEV_ACC_DEBUG data deviceptr(ptr_inout)
#endif
            !DEV_ACC parallel loop collapse(3) async(async_id)
            !DEV_OMPGPU target 
            !DEV_OMPGPU teams loop collapse(3)
            !DEV_OMP  parallel do
            do i3 = d3s, d3e
            do i2 = d2s, d2e
            do i1 = d1s, d1e
               ptr_inout(i1,i2,i3 ) = &
                   conjg (  ptr_inout (i1,i2,i3 ) )
            enddo
            enddo
            enddo
            !DEV_ACC_DEBUG end data
            !DEV_OMPGPU end target
            !
         else
            !
            !DEV_CUF kernel do(3)
#if defined __GFORTRAN__
            !DEV_ACC_DEBUG data present(ptr_inout)
#else
            !DEV_ACC_DEBUG data deviceptr(ptr_inout)
#endif
            !DEV_ACC parallel loop collapse(3) async
            !DEV_OMPGPU target 
            !DEV_OMPGPU teams loop collapse(3)
            !DEV_OMP  parallel do
            do i3 = d3s, d3e
            do i2 = d2s, d2e
            do i1 = d1s, d1e
               ptr_inout(i1,i2,i3 ) = &
                   conjg (  ptr_inout (i1,i2,i3 ) )
            enddo
            enddo
            enddo
            !DEV_ACC_DEBUG end data
            !DEV_OMPGPU end target
            !
         endif
          !
      end subroutine dp_devxlib_conjg_c3d_p
      !
      module subroutine dp_devxlib_conjg_c4d_p(ptr_inout, async_id, &
                                         
                                        range1, lbound1, & 
                                        range2, lbound2, & 
                                        range3, lbound3, & 
                                        range4, lbound4 )
         implicit none
         !
         complex(real64), pointer, contiguous, intent(inout) DEV_ATTR :: ptr_inout(:,:,:,:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
         !
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(ptr_inout, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(ptr_inout, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(ptr_inout, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(ptr_inout, 4)/)
         if (present(range4)) range4_=range4 
         !
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         !
         if (present(async_id)) then
            !
            !DEV_CUF kernel do(4) <<<*,*,0,stream=async_id>>>
#if defined __GFORTRAN__
            !DEV_ACC_DEBUG data present(ptr_inout)
#else
            !DEV_ACC_DEBUG data deviceptr(ptr_inout)
#endif
            !DEV_ACC parallel loop collapse(4) async(async_id)
            !DEV_OMPGPU target 
            !DEV_OMPGPU teams loop collapse(4)
            !DEV_OMP  parallel do
            do i4 = d4s, d4e
            do i3 = d3s, d3e
            do i2 = d2s, d2e
            do i1 = d1s, d1e
               ptr_inout(i1,i2,i3,i4 ) = &
                   conjg (  ptr_inout (i1,i2,i3,i4 ) )
            enddo
            enddo
            enddo
            enddo
            !DEV_ACC_DEBUG end data
            !DEV_OMPGPU end target
            !
         else
            !
            !DEV_CUF kernel do(4)
#if defined __GFORTRAN__
            !DEV_ACC_DEBUG data present(ptr_inout)
#else
            !DEV_ACC_DEBUG data deviceptr(ptr_inout)
#endif
            !DEV_ACC parallel loop collapse(4) async
            !DEV_OMPGPU target 
            !DEV_OMPGPU teams loop collapse(4)
            !DEV_OMP  parallel do
            do i4 = d4s, d4e
            do i3 = d3s, d3e
            do i2 = d2s, d2e
            do i1 = d1s, d1e
               ptr_inout(i1,i2,i3,i4 ) = &
                   conjg (  ptr_inout (i1,i2,i3,i4 ) )
            enddo
            enddo
            enddo
            enddo
            !DEV_ACC_DEBUG end data
            !DEV_OMPGPU end target
            !
         endif
          !
      end subroutine dp_devxlib_conjg_c4d_p
      !
      module subroutine dp_devxlib_conjg_c5d_p(ptr_inout, async_id, &
                                         
                                        range1, lbound1, & 
                                        range2, lbound2, & 
                                        range3, lbound3, & 
                                        range4, lbound4, & 
                                        range5, lbound5 )
         implicit none
         !
         complex(real64), pointer, contiguous, intent(inout) DEV_ATTR :: ptr_inout(:,:,:,:,:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5
         !
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         integer :: i5, d5s, d5e
         integer :: lbound5_, range5_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(ptr_inout, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(ptr_inout, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(ptr_inout, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(ptr_inout, 4)/)
         if (present(range4)) range4_=range4 
         !
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         lbound5_=1
         if (present(lbound5)) lbound5_=lbound5 
         range5_=(/1,size(ptr_inout, 5)/)
         if (present(range5)) range5_=range5 
         !
         d5s = range5_(1) -lbound5_ +1
         d5e = range5_(2) -lbound5_ +1
         !
         !
         if (present(async_id)) then
            !
            !DEV_CUF kernel do(5) <<<*,*,0,stream=async_id>>>
#if defined __GFORTRAN__
            !DEV_ACC_DEBUG data present(ptr_inout)
#else
            !DEV_ACC_DEBUG data deviceptr(ptr_inout)
#endif
            !DEV_ACC parallel loop collapse(5) async(async_id)
            !DEV_OMPGPU target 
            !DEV_OMPGPU teams loop collapse(5)
            !DEV_OMP  parallel do
            do i5 = d5s, d5e
            do i4 = d4s, d4e
            do i3 = d3s, d3e
            do i2 = d2s, d2e
            do i1 = d1s, d1e
               ptr_inout(i1,i2,i3,i4,i5 ) = &
                   conjg (  ptr_inout (i1,i2,i3,i4,i5 ) )
            enddo
            enddo
            enddo
            enddo
            enddo
            !DEV_ACC_DEBUG end data
            !DEV_OMPGPU end target
            !
         else
            !
            !DEV_CUF kernel do(5)
#if defined __GFORTRAN__
            !DEV_ACC_DEBUG data present(ptr_inout)
#else
            !DEV_ACC_DEBUG data deviceptr(ptr_inout)
#endif
            !DEV_ACC parallel loop collapse(5) async
            !DEV_OMPGPU target 
            !DEV_OMPGPU teams loop collapse(5)
            !DEV_OMP  parallel do
            do i5 = d5s, d5e
            do i4 = d4s, d4e
            do i3 = d3s, d3e
            do i2 = d2s, d2e
            do i1 = d1s, d1e
               ptr_inout(i1,i2,i3,i4,i5 ) = &
                   conjg (  ptr_inout (i1,i2,i3,i4,i5 ) )
            enddo
            enddo
            enddo
            enddo
            enddo
            !DEV_ACC_DEBUG end data
            !DEV_OMPGPU end target
            !
         endif
          !
      end subroutine dp_devxlib_conjg_c5d_p
      !
      module subroutine dp_devxlib_conjg_c6d_p(ptr_inout, async_id, &
                                         
                                        range1, lbound1, & 
                                        range2, lbound2, & 
                                        range3, lbound3, & 
                                        range4, lbound4, & 
                                        range5, lbound5, & 
                                        range6, lbound6 )
         implicit none
         !
         complex(real64), pointer, contiguous, intent(inout) DEV_ATTR :: ptr_inout(:,:,:,:,:,:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2), range6(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5, lbound6
         !
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         integer :: i5, d5s, d5e
         integer :: lbound5_, range5_(2)
         integer :: i6, d6s, d6e
         integer :: lbound6_, range6_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(ptr_inout, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(ptr_inout, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(ptr_inout, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(ptr_inout, 4)/)
         if (present(range4)) range4_=range4 
         !
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         lbound5_=1
         if (present(lbound5)) lbound5_=lbound5 
         range5_=(/1,size(ptr_inout, 5)/)
         if (present(range5)) range5_=range5 
         !
         d5s = range5_(1) -lbound5_ +1
         d5e = range5_(2) -lbound5_ +1
         !
         lbound6_=1
         if (present(lbound6)) lbound6_=lbound6 
         range6_=(/1,size(ptr_inout, 6)/)
         if (present(range6)) range6_=range6 
         !
         d6s = range6_(1) -lbound6_ +1
         d6e = range6_(2) -lbound6_ +1
         !
         !
         if (present(async_id)) then
            !
            !DEV_CUF kernel do(6) <<<*,*,0,stream=async_id>>>
#if defined __GFORTRAN__
            !DEV_ACC_DEBUG data present(ptr_inout)
#else
            !DEV_ACC_DEBUG data deviceptr(ptr_inout)
#endif
            !DEV_ACC parallel loop collapse(6) async(async_id)
            !DEV_OMPGPU target 
            !DEV_OMPGPU teams loop collapse(6)
            !DEV_OMP  parallel do
            do i6 = d6s, d6e
            do i5 = d5s, d5e
            do i4 = d4s, d4e
            do i3 = d3s, d3e
            do i2 = d2s, d2e
            do i1 = d1s, d1e
               ptr_inout(i1,i2,i3,i4,i5,i6 ) = &
                   conjg (  ptr_inout (i1,i2,i3,i4,i5,i6 ) )
            enddo
            enddo
            enddo
            enddo
            enddo
            enddo
            !DEV_ACC_DEBUG end data
            !DEV_OMPGPU end target
            !
         else
            !
            !DEV_CUF kernel do(6)
#if defined __GFORTRAN__
            !DEV_ACC_DEBUG data present(ptr_inout)
#else
            !DEV_ACC_DEBUG data deviceptr(ptr_inout)
#endif
            !DEV_ACC parallel loop collapse(6) async
            !DEV_OMPGPU target 
            !DEV_OMPGPU teams loop collapse(6)
            !DEV_OMP  parallel do
            do i6 = d6s, d6e
            do i5 = d5s, d5e
            do i4 = d4s, d4e
            do i3 = d3s, d3e
            do i2 = d2s, d2e
            do i1 = d1s, d1e
               ptr_inout(i1,i2,i3,i4,i5,i6 ) = &
                   conjg (  ptr_inout (i1,i2,i3,i4,i5,i6 ) )
            enddo
            enddo
            enddo
            enddo
            enddo
            enddo
            !DEV_ACC_DEBUG end data
            !DEV_OMPGPU end target
            !
         endif
          !
      end subroutine dp_devxlib_conjg_c6d_p
      !
      module subroutine sp_devxlib_conjg_c1d_p(ptr_inout, async_id, &
                                         
                                        range1, lbound1 )
         implicit none
         !
         complex(real32), pointer, contiguous, intent(inout) DEV_ATTR :: ptr_inout(:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2)
         integer, optional, intent(in) ::  lbound1
         !
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(ptr_inout, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         !
         if (present(async_id)) then
            !
            !DEV_CUF kernel do(1) <<<*,*,0,stream=async_id>>>
#if defined __GFORTRAN__
            !DEV_ACC_DEBUG data present(ptr_inout)
#else
            !DEV_ACC_DEBUG data deviceptr(ptr_inout)
#endif
            !DEV_ACC parallel loop collapse(1) async(async_id)
            !DEV_OMPGPU target 
            !DEV_OMPGPU teams loop collapse(1)
            !DEV_OMP  parallel do
            do i1 = d1s, d1e
               ptr_inout(i1 ) = &
                   conjg (  ptr_inout (i1 ) )
            enddo
            !DEV_ACC_DEBUG end data
            !DEV_OMPGPU end target
            !
         else
            !
            !DEV_CUF kernel do(1)
#if defined __GFORTRAN__
            !DEV_ACC_DEBUG data present(ptr_inout)
#else
            !DEV_ACC_DEBUG data deviceptr(ptr_inout)
#endif
            !DEV_ACC parallel loop collapse(1) async
            !DEV_OMPGPU target 
            !DEV_OMPGPU teams loop collapse(1)
            !DEV_OMP  parallel do
            do i1 = d1s, d1e
               ptr_inout(i1 ) = &
                   conjg (  ptr_inout (i1 ) )
            enddo
            !DEV_ACC_DEBUG end data
            !DEV_OMPGPU end target
            !
         endif
          !
      end subroutine sp_devxlib_conjg_c1d_p
      !
      module subroutine sp_devxlib_conjg_c2d_p(ptr_inout, async_id, &
                                         
                                        range1, lbound1, & 
                                        range2, lbound2 )
         implicit none
         !
         complex(real32), pointer, contiguous, intent(inout) DEV_ATTR :: ptr_inout(:,:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2)
         integer, optional, intent(in) ::  lbound1, lbound2
         !
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(ptr_inout, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(ptr_inout, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         !
         if (present(async_id)) then
            !
            !DEV_CUF kernel do(2) <<<*,*,0,stream=async_id>>>
#if defined __GFORTRAN__
            !DEV_ACC_DEBUG data present(ptr_inout)
#else
            !DEV_ACC_DEBUG data deviceptr(ptr_inout)
#endif
            !DEV_ACC parallel loop collapse(2) async(async_id)
            !DEV_OMPGPU target 
            !DEV_OMPGPU teams loop collapse(2)
            !DEV_OMP  parallel do
            do i2 = d2s, d2e
            do i1 = d1s, d1e
               ptr_inout(i1,i2 ) = &
                   conjg (  ptr_inout (i1,i2 ) )
            enddo
            enddo
            !DEV_ACC_DEBUG end data
            !DEV_OMPGPU end target
            !
         else
            !
            !DEV_CUF kernel do(2)
#if defined __GFORTRAN__
            !DEV_ACC_DEBUG data present(ptr_inout)
#else
            !DEV_ACC_DEBUG data deviceptr(ptr_inout)
#endif
            !DEV_ACC parallel loop collapse(2) async
            !DEV_OMPGPU target 
            !DEV_OMPGPU teams loop collapse(2)
            !DEV_OMP  parallel do
            do i2 = d2s, d2e
            do i1 = d1s, d1e
               ptr_inout(i1,i2 ) = &
                   conjg (  ptr_inout (i1,i2 ) )
            enddo
            enddo
            !DEV_ACC_DEBUG end data
            !DEV_OMPGPU end target
            !
         endif
          !
      end subroutine sp_devxlib_conjg_c2d_p
      !
      module subroutine sp_devxlib_conjg_c3d_p(ptr_inout, async_id, &
                                         
                                        range1, lbound1, & 
                                        range2, lbound2, & 
                                        range3, lbound3 )
         implicit none
         !
         complex(real32), pointer, contiguous, intent(inout) DEV_ATTR :: ptr_inout(:,:,:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3
         !
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(ptr_inout, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(ptr_inout, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(ptr_inout, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         !
         if (present(async_id)) then
            !
            !DEV_CUF kernel do(3) <<<*,*,0,stream=async_id>>>
#if defined __GFORTRAN__
            !DEV_ACC_DEBUG data present(ptr_inout)
#else
            !DEV_ACC_DEBUG data deviceptr(ptr_inout)
#endif
            !DEV_ACC parallel loop collapse(3) async(async_id)
            !DEV_OMPGPU target 
            !DEV_OMPGPU teams loop collapse(3)
            !DEV_OMP  parallel do
            do i3 = d3s, d3e
            do i2 = d2s, d2e
            do i1 = d1s, d1e
               ptr_inout(i1,i2,i3 ) = &
                   conjg (  ptr_inout (i1,i2,i3 ) )
            enddo
            enddo
            enddo
            !DEV_ACC_DEBUG end data
            !DEV_OMPGPU end target
            !
         else
            !
            !DEV_CUF kernel do(3)
#if defined __GFORTRAN__
            !DEV_ACC_DEBUG data present(ptr_inout)
#else
            !DEV_ACC_DEBUG data deviceptr(ptr_inout)
#endif
            !DEV_ACC parallel loop collapse(3) async
            !DEV_OMPGPU target 
            !DEV_OMPGPU teams loop collapse(3)
            !DEV_OMP  parallel do
            do i3 = d3s, d3e
            do i2 = d2s, d2e
            do i1 = d1s, d1e
               ptr_inout(i1,i2,i3 ) = &
                   conjg (  ptr_inout (i1,i2,i3 ) )
            enddo
            enddo
            enddo
            !DEV_ACC_DEBUG end data
            !DEV_OMPGPU end target
            !
         endif
          !
      end subroutine sp_devxlib_conjg_c3d_p
      !
      module subroutine sp_devxlib_conjg_c4d_p(ptr_inout, async_id, &
                                         
                                        range1, lbound1, & 
                                        range2, lbound2, & 
                                        range3, lbound3, & 
                                        range4, lbound4 )
         implicit none
         !
         complex(real32), pointer, contiguous, intent(inout) DEV_ATTR :: ptr_inout(:,:,:,:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
         !
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(ptr_inout, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(ptr_inout, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(ptr_inout, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(ptr_inout, 4)/)
         if (present(range4)) range4_=range4 
         !
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         !
         if (present(async_id)) then
            !
            !DEV_CUF kernel do(4) <<<*,*,0,stream=async_id>>>
#if defined __GFORTRAN__
            !DEV_ACC_DEBUG data present(ptr_inout)
#else
            !DEV_ACC_DEBUG data deviceptr(ptr_inout)
#endif
            !DEV_ACC parallel loop collapse(4) async(async_id)
            !DEV_OMPGPU target 
            !DEV_OMPGPU teams loop collapse(4)
            !DEV_OMP  parallel do
            do i4 = d4s, d4e
            do i3 = d3s, d3e
            do i2 = d2s, d2e
            do i1 = d1s, d1e
               ptr_inout(i1,i2,i3,i4 ) = &
                   conjg (  ptr_inout (i1,i2,i3,i4 ) )
            enddo
            enddo
            enddo
            enddo
            !DEV_ACC_DEBUG end data
            !DEV_OMPGPU end target
            !
         else
            !
            !DEV_CUF kernel do(4)
#if defined __GFORTRAN__
            !DEV_ACC_DEBUG data present(ptr_inout)
#else
            !DEV_ACC_DEBUG data deviceptr(ptr_inout)
#endif
            !DEV_ACC parallel loop collapse(4) async
            !DEV_OMPGPU target 
            !DEV_OMPGPU teams loop collapse(4)
            !DEV_OMP  parallel do
            do i4 = d4s, d4e
            do i3 = d3s, d3e
            do i2 = d2s, d2e
            do i1 = d1s, d1e
               ptr_inout(i1,i2,i3,i4 ) = &
                   conjg (  ptr_inout (i1,i2,i3,i4 ) )
            enddo
            enddo
            enddo
            enddo
            !DEV_ACC_DEBUG end data
            !DEV_OMPGPU end target
            !
         endif
          !
      end subroutine sp_devxlib_conjg_c4d_p
      !
      module subroutine sp_devxlib_conjg_c5d_p(ptr_inout, async_id, &
                                         
                                        range1, lbound1, & 
                                        range2, lbound2, & 
                                        range3, lbound3, & 
                                        range4, lbound4, & 
                                        range5, lbound5 )
         implicit none
         !
         complex(real32), pointer, contiguous, intent(inout) DEV_ATTR :: ptr_inout(:,:,:,:,:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5
         !
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         integer :: i5, d5s, d5e
         integer :: lbound5_, range5_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(ptr_inout, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(ptr_inout, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(ptr_inout, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(ptr_inout, 4)/)
         if (present(range4)) range4_=range4 
         !
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         lbound5_=1
         if (present(lbound5)) lbound5_=lbound5 
         range5_=(/1,size(ptr_inout, 5)/)
         if (present(range5)) range5_=range5 
         !
         d5s = range5_(1) -lbound5_ +1
         d5e = range5_(2) -lbound5_ +1
         !
         !
         if (present(async_id)) then
            !
            !DEV_CUF kernel do(5) <<<*,*,0,stream=async_id>>>
#if defined __GFORTRAN__
            !DEV_ACC_DEBUG data present(ptr_inout)
#else
            !DEV_ACC_DEBUG data deviceptr(ptr_inout)
#endif
            !DEV_ACC parallel loop collapse(5) async(async_id)
            !DEV_OMPGPU target 
            !DEV_OMPGPU teams loop collapse(5)
            !DEV_OMP  parallel do
            do i5 = d5s, d5e
            do i4 = d4s, d4e
            do i3 = d3s, d3e
            do i2 = d2s, d2e
            do i1 = d1s, d1e
               ptr_inout(i1,i2,i3,i4,i5 ) = &
                   conjg (  ptr_inout (i1,i2,i3,i4,i5 ) )
            enddo
            enddo
            enddo
            enddo
            enddo
            !DEV_ACC_DEBUG end data
            !DEV_OMPGPU end target
            !
         else
            !
            !DEV_CUF kernel do(5)
#if defined __GFORTRAN__
            !DEV_ACC_DEBUG data present(ptr_inout)
#else
            !DEV_ACC_DEBUG data deviceptr(ptr_inout)
#endif
            !DEV_ACC parallel loop collapse(5) async
            !DEV_OMPGPU target 
            !DEV_OMPGPU teams loop collapse(5)
            !DEV_OMP  parallel do
            do i5 = d5s, d5e
            do i4 = d4s, d4e
            do i3 = d3s, d3e
            do i2 = d2s, d2e
            do i1 = d1s, d1e
               ptr_inout(i1,i2,i3,i4,i5 ) = &
                   conjg (  ptr_inout (i1,i2,i3,i4,i5 ) )
            enddo
            enddo
            enddo
            enddo
            enddo
            !DEV_ACC_DEBUG end data
            !DEV_OMPGPU end target
            !
         endif
          !
      end subroutine sp_devxlib_conjg_c5d_p
      !
      module subroutine sp_devxlib_conjg_c6d_p(ptr_inout, async_id, &
                                         
                                        range1, lbound1, & 
                                        range2, lbound2, & 
                                        range3, lbound3, & 
                                        range4, lbound4, & 
                                        range5, lbound5, & 
                                        range6, lbound6 )
         implicit none
         !
         complex(real32), pointer, contiguous, intent(inout) DEV_ATTR :: ptr_inout(:,:,:,:,:,:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2), range6(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5, lbound6
         !
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         integer :: i5, d5s, d5e
         integer :: lbound5_, range5_(2)
         integer :: i6, d6s, d6e
         integer :: lbound6_, range6_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(ptr_inout, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(ptr_inout, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(ptr_inout, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(ptr_inout, 4)/)
         if (present(range4)) range4_=range4 
         !
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         lbound5_=1
         if (present(lbound5)) lbound5_=lbound5 
         range5_=(/1,size(ptr_inout, 5)/)
         if (present(range5)) range5_=range5 
         !
         d5s = range5_(1) -lbound5_ +1
         d5e = range5_(2) -lbound5_ +1
         !
         lbound6_=1
         if (present(lbound6)) lbound6_=lbound6 
         range6_=(/1,size(ptr_inout, 6)/)
         if (present(range6)) range6_=range6 
         !
         d6s = range6_(1) -lbound6_ +1
         d6e = range6_(2) -lbound6_ +1
         !
         !
         if (present(async_id)) then
            !
            !DEV_CUF kernel do(6) <<<*,*,0,stream=async_id>>>
#if defined __GFORTRAN__
            !DEV_ACC_DEBUG data present(ptr_inout)
#else
            !DEV_ACC_DEBUG data deviceptr(ptr_inout)
#endif
            !DEV_ACC parallel loop collapse(6) async(async_id)
            !DEV_OMPGPU target 
            !DEV_OMPGPU teams loop collapse(6)
            !DEV_OMP  parallel do
            do i6 = d6s, d6e
            do i5 = d5s, d5e
            do i4 = d4s, d4e
            do i3 = d3s, d3e
            do i2 = d2s, d2e
            do i1 = d1s, d1e
               ptr_inout(i1,i2,i3,i4,i5,i6 ) = &
                   conjg (  ptr_inout (i1,i2,i3,i4,i5,i6 ) )
            enddo
            enddo
            enddo
            enddo
            enddo
            enddo
            !DEV_ACC_DEBUG end data
            !DEV_OMPGPU end target
            !
         else
            !
            !DEV_CUF kernel do(6)
#if defined __GFORTRAN__
            !DEV_ACC_DEBUG data present(ptr_inout)
#else
            !DEV_ACC_DEBUG data deviceptr(ptr_inout)
#endif
            !DEV_ACC parallel loop collapse(6) async
            !DEV_OMPGPU target 
            !DEV_OMPGPU teams loop collapse(6)
            !DEV_OMP  parallel do
            do i6 = d6s, d6e
            do i5 = d5s, d5e
            do i4 = d4s, d4e
            do i3 = d3s, d3e
            do i2 = d2s, d2e
            do i1 = d1s, d1e
               ptr_inout(i1,i2,i3,i4,i5,i6 ) = &
                   conjg (  ptr_inout (i1,i2,i3,i4,i5,i6 ) )
            enddo
            enddo
            enddo
            enddo
            enddo
            enddo
            !DEV_ACC_DEBUG end data
            !DEV_OMPGPU end target
            !
         endif
          !
      end subroutine sp_devxlib_conjg_c6d_p
      !


      module subroutine dp_devxlib_conjg_h_c1d(array_inout, async_id, &
                                         
                                        range1, lbound1 )
         implicit none
         !
         complex(real64), intent(inout) :: array_inout(:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2)
         integer, optional, intent(in) ::  lbound1
         !
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_inout, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         !
         do i1 = d1s, d1e
            array_inout(i1 ) = &
                conjg (  array_inout (i1 ) )
         enddo
         !
      end subroutine dp_devxlib_conjg_h_c1d
      !
      module subroutine dp_devxlib_conjg_h_c2d(array_inout, async_id, &
                                         
                                        range1, lbound1, & 
                                        range2, lbound2 )
         implicit none
         !
         complex(real64), intent(inout) :: array_inout(:,:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2)
         integer, optional, intent(in) ::  lbound1, lbound2
         !
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_inout, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_inout, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         !
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_inout(i1,i2 ) = &
                conjg (  array_inout (i1,i2 ) )
         enddo
         enddo
         !
      end subroutine dp_devxlib_conjg_h_c2d
      !
      module subroutine dp_devxlib_conjg_h_c3d(array_inout, async_id, &
                                         
                                        range1, lbound1, & 
                                        range2, lbound2, & 
                                        range3, lbound3 )
         implicit none
         !
         complex(real64), intent(inout) :: array_inout(:,:,:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3
         !
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_inout, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_inout, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_inout, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         !
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_inout(i1,i2,i3 ) = &
                conjg (  array_inout (i1,i2,i3 ) )
         enddo
         enddo
         enddo
         !
      end subroutine dp_devxlib_conjg_h_c3d
      !
      module subroutine dp_devxlib_conjg_h_c4d(array_inout, async_id, &
                                         
                                        range1, lbound1, & 
                                        range2, lbound2, & 
                                        range3, lbound3, & 
                                        range4, lbound4 )
         implicit none
         !
         complex(real64), intent(inout) :: array_inout(:,:,:,:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
         !
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_inout, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_inout, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_inout, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(array_inout, 4)/)
         if (present(range4)) range4_=range4 
         !
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         !
         do i4 = d4s, d4e
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_inout(i1,i2,i3,i4 ) = &
                conjg (  array_inout (i1,i2,i3,i4 ) )
         enddo
         enddo
         enddo
         enddo
         !
      end subroutine dp_devxlib_conjg_h_c4d
      !
      module subroutine dp_devxlib_conjg_h_c5d(array_inout, async_id, &
                                         
                                        range1, lbound1, & 
                                        range2, lbound2, & 
                                        range3, lbound3, & 
                                        range4, lbound4, & 
                                        range5, lbound5 )
         implicit none
         !
         complex(real64), intent(inout) :: array_inout(:,:,:,:,:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5
         !
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         integer :: i5, d5s, d5e
         integer :: lbound5_, range5_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_inout, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_inout, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_inout, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(array_inout, 4)/)
         if (present(range4)) range4_=range4 
         !
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         lbound5_=1
         if (present(lbound5)) lbound5_=lbound5 
         range5_=(/1,size(array_inout, 5)/)
         if (present(range5)) range5_=range5 
         !
         d5s = range5_(1) -lbound5_ +1
         d5e = range5_(2) -lbound5_ +1
         !
         !
         do i5 = d5s, d5e
         do i4 = d4s, d4e
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_inout(i1,i2,i3,i4,i5 ) = &
                conjg (  array_inout (i1,i2,i3,i4,i5 ) )
         enddo
         enddo
         enddo
         enddo
         enddo
         !
      end subroutine dp_devxlib_conjg_h_c5d
      !
      module subroutine dp_devxlib_conjg_h_c6d(array_inout, async_id, &
                                         
                                        range1, lbound1, & 
                                        range2, lbound2, & 
                                        range3, lbound3, & 
                                        range4, lbound4, & 
                                        range5, lbound5, & 
                                        range6, lbound6 )
         implicit none
         !
         complex(real64), intent(inout) :: array_inout(:,:,:,:,:,:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2), range6(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5, lbound6
         !
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         integer :: i5, d5s, d5e
         integer :: lbound5_, range5_(2)
         integer :: i6, d6s, d6e
         integer :: lbound6_, range6_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_inout, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_inout, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_inout, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(array_inout, 4)/)
         if (present(range4)) range4_=range4 
         !
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         lbound5_=1
         if (present(lbound5)) lbound5_=lbound5 
         range5_=(/1,size(array_inout, 5)/)
         if (present(range5)) range5_=range5 
         !
         d5s = range5_(1) -lbound5_ +1
         d5e = range5_(2) -lbound5_ +1
         !
         lbound6_=1
         if (present(lbound6)) lbound6_=lbound6 
         range6_=(/1,size(array_inout, 6)/)
         if (present(range6)) range6_=range6 
         !
         d6s = range6_(1) -lbound6_ +1
         d6e = range6_(2) -lbound6_ +1
         !
         !
         do i6 = d6s, d6e
         do i5 = d5s, d5e
         do i4 = d4s, d4e
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_inout(i1,i2,i3,i4,i5,i6 ) = &
                conjg (  array_inout (i1,i2,i3,i4,i5,i6 ) )
         enddo
         enddo
         enddo
         enddo
         enddo
         enddo
         !
      end subroutine dp_devxlib_conjg_h_c6d
      !
      module subroutine sp_devxlib_conjg_h_c1d(array_inout, async_id, &
                                         
                                        range1, lbound1 )
         implicit none
         !
         complex(real32), intent(inout) :: array_inout(:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2)
         integer, optional, intent(in) ::  lbound1
         !
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_inout, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         !
         do i1 = d1s, d1e
            array_inout(i1 ) = &
                conjg (  array_inout (i1 ) )
         enddo
         !
      end subroutine sp_devxlib_conjg_h_c1d
      !
      module subroutine sp_devxlib_conjg_h_c2d(array_inout, async_id, &
                                         
                                        range1, lbound1, & 
                                        range2, lbound2 )
         implicit none
         !
         complex(real32), intent(inout) :: array_inout(:,:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2)
         integer, optional, intent(in) ::  lbound1, lbound2
         !
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_inout, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_inout, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         !
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_inout(i1,i2 ) = &
                conjg (  array_inout (i1,i2 ) )
         enddo
         enddo
         !
      end subroutine sp_devxlib_conjg_h_c2d
      !
      module subroutine sp_devxlib_conjg_h_c3d(array_inout, async_id, &
                                         
                                        range1, lbound1, & 
                                        range2, lbound2, & 
                                        range3, lbound3 )
         implicit none
         !
         complex(real32), intent(inout) :: array_inout(:,:,:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3
         !
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_inout, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_inout, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_inout, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         !
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_inout(i1,i2,i3 ) = &
                conjg (  array_inout (i1,i2,i3 ) )
         enddo
         enddo
         enddo
         !
      end subroutine sp_devxlib_conjg_h_c3d
      !
      module subroutine sp_devxlib_conjg_h_c4d(array_inout, async_id, &
                                         
                                        range1, lbound1, & 
                                        range2, lbound2, & 
                                        range3, lbound3, & 
                                        range4, lbound4 )
         implicit none
         !
         complex(real32), intent(inout) :: array_inout(:,:,:,:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
         !
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_inout, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_inout, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_inout, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(array_inout, 4)/)
         if (present(range4)) range4_=range4 
         !
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         !
         do i4 = d4s, d4e
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_inout(i1,i2,i3,i4 ) = &
                conjg (  array_inout (i1,i2,i3,i4 ) )
         enddo
         enddo
         enddo
         enddo
         !
      end subroutine sp_devxlib_conjg_h_c4d
      !
      module subroutine sp_devxlib_conjg_h_c5d(array_inout, async_id, &
                                         
                                        range1, lbound1, & 
                                        range2, lbound2, & 
                                        range3, lbound3, & 
                                        range4, lbound4, & 
                                        range5, lbound5 )
         implicit none
         !
         complex(real32), intent(inout) :: array_inout(:,:,:,:,:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5
         !
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         integer :: i5, d5s, d5e
         integer :: lbound5_, range5_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_inout, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_inout, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_inout, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(array_inout, 4)/)
         if (present(range4)) range4_=range4 
         !
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         lbound5_=1
         if (present(lbound5)) lbound5_=lbound5 
         range5_=(/1,size(array_inout, 5)/)
         if (present(range5)) range5_=range5 
         !
         d5s = range5_(1) -lbound5_ +1
         d5e = range5_(2) -lbound5_ +1
         !
         !
         do i5 = d5s, d5e
         do i4 = d4s, d4e
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_inout(i1,i2,i3,i4,i5 ) = &
                conjg (  array_inout (i1,i2,i3,i4,i5 ) )
         enddo
         enddo
         enddo
         enddo
         enddo
         !
      end subroutine sp_devxlib_conjg_h_c5d
      !
      module subroutine sp_devxlib_conjg_h_c6d(array_inout, async_id, &
                                         
                                        range1, lbound1, & 
                                        range2, lbound2, & 
                                        range3, lbound3, & 
                                        range4, lbound4, & 
                                        range5, lbound5, & 
                                        range6, lbound6 )
         implicit none
         !
         complex(real32), intent(inout) :: array_inout(:,:,:,:,:,:)
         integer(kind=dxl_async_kind), optional, intent(in) :: async_id
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2), range6(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5, lbound6
         !
         integer :: i1, d1s, d1e
         integer :: lbound1_, range1_(2)
         integer :: i2, d2s, d2e
         integer :: lbound2_, range2_(2)
         integer :: i3, d3s, d3e
         integer :: lbound3_, range3_(2)
         integer :: i4, d4s, d4e
         integer :: lbound4_, range4_(2)
         integer :: i5, d5s, d5e
         integer :: lbound5_, range5_(2)
         integer :: i6, d6s, d6e
         integer :: lbound6_, range6_(2)
         !
         lbound1_=1
         if (present(lbound1)) lbound1_=lbound1 
         range1_=(/1,size(array_inout, 1)/)
         if (present(range1)) range1_=range1 
         !
         d1s = range1_(1) -lbound1_ +1
         d1e = range1_(2) -lbound1_ +1
         !
         lbound2_=1
         if (present(lbound2)) lbound2_=lbound2 
         range2_=(/1,size(array_inout, 2)/)
         if (present(range2)) range2_=range2 
         !
         d2s = range2_(1) -lbound2_ +1
         d2e = range2_(2) -lbound2_ +1
         !
         lbound3_=1
         if (present(lbound3)) lbound3_=lbound3 
         range3_=(/1,size(array_inout, 3)/)
         if (present(range3)) range3_=range3 
         !
         d3s = range3_(1) -lbound3_ +1
         d3e = range3_(2) -lbound3_ +1
         !
         lbound4_=1
         if (present(lbound4)) lbound4_=lbound4 
         range4_=(/1,size(array_inout, 4)/)
         if (present(range4)) range4_=range4 
         !
         d4s = range4_(1) -lbound4_ +1
         d4e = range4_(2) -lbound4_ +1
         !
         lbound5_=1
         if (present(lbound5)) lbound5_=lbound5 
         range5_=(/1,size(array_inout, 5)/)
         if (present(range5)) range5_=range5 
         !
         d5s = range5_(1) -lbound5_ +1
         d5e = range5_(2) -lbound5_ +1
         !
         lbound6_=1
         if (present(lbound6)) lbound6_=lbound6 
         range6_=(/1,size(array_inout, 6)/)
         if (present(range6)) range6_=range6 
         !
         d6s = range6_(1) -lbound6_ +1
         d6e = range6_(2) -lbound6_ +1
         !
         !
         do i6 = d6s, d6e
         do i5 = d5s, d5e
         do i4 = d4s, d4e
         do i3 = d3s, d3e
         do i2 = d2s, d2e
         do i1 = d1s, d1e
            array_inout(i1,i2,i3,i4,i5,i6 ) = &
                conjg (  array_inout (i1,i2,i3,i4,i5,i6 ) )
         enddo
         enddo
         enddo
         enddo
         enddo
         enddo
         !
      end subroutine sp_devxlib_conjg_h_c6d
      !

end submodule devxlib_auxfunc_conjg

!
! Copyright (C) 2021, MaX CoE
! Distributed under the MIT License 
! (license terms are at http://opensource.org/licenses/MIT).
!
!--
!
! Testing: devxlib_memcpy, devxlib_mapping, dev_auxfunc
!
!==================================================================
!==================================================================
! *DO NOT EDIT*: automatically generated from test_mapping.jf90
!==================================================================
!==================================================================
!
#include<devxlib_macros.h>
#include<devxlib_defs.h>
!
program test_mapping
  !
  ! This program tests the routines and interfaces related to
  ! device_memcpy and some device_auxfunc.
  !
  use iso_fortran_env, only : int32, int64, real32, real64
  use devxlib_memcpy
  use devxlib_mapping
  use devxlib_auxfunc

  implicit none

  integer(int64) :: cnt, count_max
  real(real64), parameter :: thr=1.0d-6
  integer,      parameter :: nranks=4
  integer(int64) :: ndim(nranks)
  integer(int64) :: bounds(2*nranks)
  real(real64):: t0, t1, count_rate
  logical :: is_mapped, lfail_mapping
  integer :: npass, nfail
  integer(int32) :: ierr
  integer :: nfail_mapping
  real(real32), allocatable :: A_hst1__sp_r1d(:)
  real(real32), allocatable :: A_hst2__sp_r1d(:)
  real(real32), allocatable :: A_hst3__sp_r1d(:)
  real(real32), allocatable DEV_ATTR :: A_dev1__sp_r1d(:)
  real(real32), allocatable DEV_ATTR :: A_dev2__sp_r1d(:)
  

  real(real32), allocatable :: A_hst1__sp_r2d(:,:)
  real(real32), allocatable :: A_hst2__sp_r2d(:,:)
  real(real32), allocatable :: A_hst3__sp_r2d(:,:)
  real(real32), allocatable DEV_ATTR :: A_dev1__sp_r2d(:,:)
  real(real32), allocatable DEV_ATTR :: A_dev2__sp_r2d(:,:)
  

  real(real32), allocatable :: A_hst1__sp_r3d(:,:,:)
  real(real32), allocatable :: A_hst2__sp_r3d(:,:,:)
  real(real32), allocatable :: A_hst3__sp_r3d(:,:,:)
  real(real32), allocatable DEV_ATTR :: A_dev1__sp_r3d(:,:,:)
  real(real32), allocatable DEV_ATTR :: A_dev2__sp_r3d(:,:,:)
  

  real(real32), allocatable :: A_hst1__sp_r4d(:,:,:,:)
  real(real32), allocatable :: A_hst2__sp_r4d(:,:,:,:)
  real(real32), allocatable :: A_hst3__sp_r4d(:,:,:,:)
  real(real32), allocatable DEV_ATTR :: A_dev1__sp_r4d(:,:,:,:)
  real(real32), allocatable DEV_ATTR :: A_dev2__sp_r4d(:,:,:,:)
  


  real(real64), allocatable :: A_hst1__dp_r1d(:)
  real(real64), allocatable :: A_hst2__dp_r1d(:)
  real(real64), allocatable :: A_hst3__dp_r1d(:)
  real(real64), allocatable DEV_ATTR :: A_dev1__dp_r1d(:)
  real(real64), allocatable DEV_ATTR :: A_dev2__dp_r1d(:)
  

  real(real64), allocatable :: A_hst1__dp_r2d(:,:)
  real(real64), allocatable :: A_hst2__dp_r2d(:,:)
  real(real64), allocatable :: A_hst3__dp_r2d(:,:)
  real(real64), allocatable DEV_ATTR :: A_dev1__dp_r2d(:,:)
  real(real64), allocatable DEV_ATTR :: A_dev2__dp_r2d(:,:)
  

  real(real64), allocatable :: A_hst1__dp_r3d(:,:,:)
  real(real64), allocatable :: A_hst2__dp_r3d(:,:,:)
  real(real64), allocatable :: A_hst3__dp_r3d(:,:,:)
  real(real64), allocatable DEV_ATTR :: A_dev1__dp_r3d(:,:,:)
  real(real64), allocatable DEV_ATTR :: A_dev2__dp_r3d(:,:,:)
  

  real(real64), allocatable :: A_hst1__dp_r4d(:,:,:,:)
  real(real64), allocatable :: A_hst2__dp_r4d(:,:,:,:)
  real(real64), allocatable :: A_hst3__dp_r4d(:,:,:,:)
  real(real64), allocatable DEV_ATTR :: A_dev1__dp_r4d(:,:,:,:)
  real(real64), allocatable DEV_ATTR :: A_dev2__dp_r4d(:,:,:,:)
  



  complex(real32), allocatable :: A_hst1__sp_c1d(:)
  complex(real32), allocatable :: A_hst2__sp_c1d(:)
  complex(real32), allocatable :: A_hst3__sp_c1d(:)
  complex(real32), allocatable DEV_ATTR :: A_dev1__sp_c1d(:)
  complex(real32), allocatable DEV_ATTR :: A_dev2__sp_c1d(:)
  
  real(real32), allocatable :: A_rtmp__sp_1d(:)
  

  complex(real32), allocatable :: A_hst1__sp_c2d(:,:)
  complex(real32), allocatable :: A_hst2__sp_c2d(:,:)
  complex(real32), allocatable :: A_hst3__sp_c2d(:,:)
  complex(real32), allocatable DEV_ATTR :: A_dev1__sp_c2d(:,:)
  complex(real32), allocatable DEV_ATTR :: A_dev2__sp_c2d(:,:)
  
  real(real32), allocatable :: A_rtmp__sp_2d(:,:)
  

  complex(real32), allocatable :: A_hst1__sp_c3d(:,:,:)
  complex(real32), allocatable :: A_hst2__sp_c3d(:,:,:)
  complex(real32), allocatable :: A_hst3__sp_c3d(:,:,:)
  complex(real32), allocatable DEV_ATTR :: A_dev1__sp_c3d(:,:,:)
  complex(real32), allocatable DEV_ATTR :: A_dev2__sp_c3d(:,:,:)
  
  real(real32), allocatable :: A_rtmp__sp_3d(:,:,:)
  

  complex(real32), allocatable :: A_hst1__sp_c4d(:,:,:,:)
  complex(real32), allocatable :: A_hst2__sp_c4d(:,:,:,:)
  complex(real32), allocatable :: A_hst3__sp_c4d(:,:,:,:)
  complex(real32), allocatable DEV_ATTR :: A_dev1__sp_c4d(:,:,:,:)
  complex(real32), allocatable DEV_ATTR :: A_dev2__sp_c4d(:,:,:,:)
  
  real(real32), allocatable :: A_rtmp__sp_4d(:,:,:,:)
  


  complex(real64), allocatable :: A_hst1__dp_c1d(:)
  complex(real64), allocatable :: A_hst2__dp_c1d(:)
  complex(real64), allocatable :: A_hst3__dp_c1d(:)
  complex(real64), allocatable DEV_ATTR :: A_dev1__dp_c1d(:)
  complex(real64), allocatable DEV_ATTR :: A_dev2__dp_c1d(:)
  
  real(real64), allocatable :: A_rtmp__dp_1d(:)
  

  complex(real64), allocatable :: A_hst1__dp_c2d(:,:)
  complex(real64), allocatable :: A_hst2__dp_c2d(:,:)
  complex(real64), allocatable :: A_hst3__dp_c2d(:,:)
  complex(real64), allocatable DEV_ATTR :: A_dev1__dp_c2d(:,:)
  complex(real64), allocatable DEV_ATTR :: A_dev2__dp_c2d(:,:)
  
  real(real64), allocatable :: A_rtmp__dp_2d(:,:)
  

  complex(real64), allocatable :: A_hst1__dp_c3d(:,:,:)
  complex(real64), allocatable :: A_hst2__dp_c3d(:,:,:)
  complex(real64), allocatable :: A_hst3__dp_c3d(:,:,:)
  complex(real64), allocatable DEV_ATTR :: A_dev1__dp_c3d(:,:,:)
  complex(real64), allocatable DEV_ATTR :: A_dev2__dp_c3d(:,:,:)
  
  real(real64), allocatable :: A_rtmp__dp_3d(:,:,:)
  

  complex(real64), allocatable :: A_hst1__dp_c4d(:,:,:,:)
  complex(real64), allocatable :: A_hst2__dp_c4d(:,:,:,:)
  complex(real64), allocatable :: A_hst3__dp_c4d(:,:,:,:)
  complex(real64), allocatable DEV_ATTR :: A_dev1__dp_c4d(:,:,:,:)
  complex(real64), allocatable DEV_ATTR :: A_dev2__dp_c4d(:,:,:,:)
  
  real(real64), allocatable :: A_rtmp__dp_4d(:,:,:,:)
  



  integer(int32), allocatable :: A_hst1__i4_i1d(:)
  integer(int32), allocatable :: A_hst2__i4_i1d(:)
  integer(int32), allocatable :: A_hst3__i4_i1d(:)
  integer(int32), allocatable DEV_ATTR :: A_dev1__i4_i1d(:)
  integer(int32), allocatable DEV_ATTR :: A_dev2__i4_i1d(:)
  
  real(int32), allocatable :: A_rtmp__i4_1d(:)
  

  integer(int32), allocatable :: A_hst1__i4_i2d(:,:)
  integer(int32), allocatable :: A_hst2__i4_i2d(:,:)
  integer(int32), allocatable :: A_hst3__i4_i2d(:,:)
  integer(int32), allocatable DEV_ATTR :: A_dev1__i4_i2d(:,:)
  integer(int32), allocatable DEV_ATTR :: A_dev2__i4_i2d(:,:)
  
  real(int32), allocatable :: A_rtmp__i4_2d(:,:)
  

  integer(int32), allocatable :: A_hst1__i4_i3d(:,:,:)
  integer(int32), allocatable :: A_hst2__i4_i3d(:,:,:)
  integer(int32), allocatable :: A_hst3__i4_i3d(:,:,:)
  integer(int32), allocatable DEV_ATTR :: A_dev1__i4_i3d(:,:,:)
  integer(int32), allocatable DEV_ATTR :: A_dev2__i4_i3d(:,:,:)
  
  real(int32), allocatable :: A_rtmp__i4_3d(:,:,:)
  

  integer(int32), allocatable :: A_hst1__i4_i4d(:,:,:,:)
  integer(int32), allocatable :: A_hst2__i4_i4d(:,:,:,:)
  integer(int32), allocatable :: A_hst3__i4_i4d(:,:,:,:)
  integer(int32), allocatable DEV_ATTR :: A_dev1__i4_i4d(:,:,:,:)
  integer(int32), allocatable DEV_ATTR :: A_dev2__i4_i4d(:,:,:,:)
  
  real(int32), allocatable :: A_rtmp__i4_4d(:,:,:,:)
  


  integer(int64), allocatable :: A_hst1__i8_i1d(:)
  integer(int64), allocatable :: A_hst2__i8_i1d(:)
  integer(int64), allocatable :: A_hst3__i8_i1d(:)
  integer(int64), allocatable DEV_ATTR :: A_dev1__i8_i1d(:)
  integer(int64), allocatable DEV_ATTR :: A_dev2__i8_i1d(:)
  
  real(int64), allocatable :: A_rtmp__i8_1d(:)
  

  integer(int64), allocatable :: A_hst1__i8_i2d(:,:)
  integer(int64), allocatable :: A_hst2__i8_i2d(:,:)
  integer(int64), allocatable :: A_hst3__i8_i2d(:,:)
  integer(int64), allocatable DEV_ATTR :: A_dev1__i8_i2d(:,:)
  integer(int64), allocatable DEV_ATTR :: A_dev2__i8_i2d(:,:)
  
  real(int64), allocatable :: A_rtmp__i8_2d(:,:)
  

  integer(int64), allocatable :: A_hst1__i8_i3d(:,:,:)
  integer(int64), allocatable :: A_hst2__i8_i3d(:,:,:)
  integer(int64), allocatable :: A_hst3__i8_i3d(:,:,:)
  integer(int64), allocatable DEV_ATTR :: A_dev1__i8_i3d(:,:,:)
  integer(int64), allocatable DEV_ATTR :: A_dev2__i8_i3d(:,:,:)
  
  real(int64), allocatable :: A_rtmp__i8_3d(:,:,:)
  

  integer(int64), allocatable :: A_hst1__i8_i4d(:,:,:,:)
  integer(int64), allocatable :: A_hst2__i8_i4d(:,:,:,:)
  integer(int64), allocatable :: A_hst3__i8_i4d(:,:,:,:)
  integer(int64), allocatable DEV_ATTR :: A_dev1__i8_i4d(:,:,:,:)
  integer(int64), allocatable DEV_ATTR :: A_dev2__i8_i4d(:,:,:,:)
  
  real(int64), allocatable :: A_rtmp__i8_4d(:,:,:,:)
  



  logical(int32), allocatable :: A_hst1__l4_l1d(:)
  logical(int32), allocatable :: A_hst2__l4_l1d(:)
  logical(int32), allocatable :: A_hst3__l4_l1d(:)
  logical(int32), allocatable DEV_ATTR :: A_dev1__l4_l1d(:)
  logical(int32), allocatable DEV_ATTR :: A_dev2__l4_l1d(:)
  
  real(int32), allocatable :: A_rtmp__l4_1d(:)
  

  logical(int32), allocatable :: A_hst1__l4_l2d(:,:)
  logical(int32), allocatable :: A_hst2__l4_l2d(:,:)
  logical(int32), allocatable :: A_hst3__l4_l2d(:,:)
  logical(int32), allocatable DEV_ATTR :: A_dev1__l4_l2d(:,:)
  logical(int32), allocatable DEV_ATTR :: A_dev2__l4_l2d(:,:)
  
  real(int32), allocatable :: A_rtmp__l4_2d(:,:)
  

  logical(int32), allocatable :: A_hst1__l4_l3d(:,:,:)
  logical(int32), allocatable :: A_hst2__l4_l3d(:,:,:)
  logical(int32), allocatable :: A_hst3__l4_l3d(:,:,:)
  logical(int32), allocatable DEV_ATTR :: A_dev1__l4_l3d(:,:,:)
  logical(int32), allocatable DEV_ATTR :: A_dev2__l4_l3d(:,:,:)
  
  real(int32), allocatable :: A_rtmp__l4_3d(:,:,:)
  

  logical(int32), allocatable :: A_hst1__l4_l4d(:,:,:,:)
  logical(int32), allocatable :: A_hst2__l4_l4d(:,:,:,:)
  logical(int32), allocatable :: A_hst3__l4_l4d(:,:,:,:)
  logical(int32), allocatable DEV_ATTR :: A_dev1__l4_l4d(:,:,:,:)
  logical(int32), allocatable DEV_ATTR :: A_dev2__l4_l4d(:,:,:,:)
  
  real(int32), allocatable :: A_rtmp__l4_4d(:,:,:,:)
  



  
  integer :: i
  character(256) :: arg, str

!
!============================
! get dims
!============================
!
  ! defaults
  ndim(:)=100
  do i=1,2*nranks,2
     bounds(i)   = 1
     bounds(i+1) = ndim((i+1)/2)
  enddo

  i=0
  do
    call get_command_argument(i, arg)
    if (len_trim(arg) == 0) exit
    !
    select case (trim(arg))
    case("-h","--help")
      write(6,"(a)") "Usage: "
      write(6,"(a)") "   ./test_mapping.x [--dims <vals>] [--bounds <vals>]"
      stop
    end select
    !
    i = i+1
    call get_command_argument(i, str)
    if (len_trim(str) == 0) exit
    !
    select case (trim(arg))
    case("-dims","--dims")
      read(str,*,iostat=ierr) ndim(:)
      if (ierr/=0) STOP "reading cmd-line args: dims"
    case("-bounds","--bounds")
      read(str,*,iostat=ierr) bounds(:)
      if (ierr/=0) STOP "reading cmd-line args: bounds"
    end select
  enddo
  !
  write(6,"(/,a,/)") "Running test with params: "
  write(6,"(3x,a,10i5)") "  ndim: ", ndim(:)
  write(6,"(3x,a,10i5)") "bounds: ", bounds(:)
  write(6,"()")
  !
  npass=0
  nfail=0
  nfail_mapping=0

!
!============================
! check memcpy
!============================
!
  !
  !=====================
  write(6,"(/,3x,a)") "checking sp_r1d ..." 
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  lfail_mapping=.false.
  !
  is_mapped = devxlib_mapped( A_dev1__sp_r1d ) .or. &
              devxlib_mapped( A_dev2__sp_r1d )
  if (is_mapped) then
     nfail_mapping=nfail_mapping+1
     lfail_mapping=.true.
     write(6,"(3x,a)") "mem mapping check-pre FAILED" 
  endif
  !
  ! allocations
  allocate( A_hst1__sp_r1d(bounds(1):bounds(2)) )
  allocate( A_hst2__sp_r1d(bounds(1):bounds(2)) )
  allocate( A_hst3__sp_r1d(bounds(1):bounds(2)) )
  allocate( A_dev1__sp_r1d(bounds(1):bounds(2)) )
  allocate( A_dev2__sp_r1d(bounds(1):bounds(2)) )
  call devxlib_map(A_dev1__sp_r1d)
  call devxlib_map(A_dev2__sp_r1d)
  !
  is_mapped = devxlib_mapped( A_dev1__sp_r1d )
  if (.not.is_mapped) then
    nfail_mapping=nfail_mapping+1
    lfail_mapping=.true.
    write(6,"(3x,a)") "mem mapping check-post FAILED" 
  endif
  !
  ! init
  call random_number( A_hst1__sp_r1d )
  
  !
  ! mem copy h2d
  call devxlib_memcpy_h2d(A_dev1__sp_r1d, A_hst1__sp_r1d)
  !
  ! mem copy
  call devxlib_memcpy_d2d(A_dev2__sp_r1d, A_dev1__sp_r1d )
  !
  !
  ! mem copy d2h
  call devxlib_memcpy_d2h(A_hst2__sp_r1d, A_dev2__sp_r1d)
  !
  !
  ! mem copy h2h
  call devxlib_memcpy_h2h(A_hst3__sp_r1d, A_hst2__sp_r1d)
  !
  ! check
  if (lfail_mapping) write(6,"(3x,a)") "Mapping FAILED" 
  !
  if ( any(abs(A_hst3__sp_r1d -A_hst1__sp_r1d )> thr) ) then
     !
     write(6,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(6,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst1__sp_r1d)
  deallocate(A_hst2__sp_r1d)
  deallocate(A_hst3__sp_r1d)
  !
  call devxlib_unmap(A_dev1__sp_r1d, ierr)
  call devxlib_unmap(A_dev2__sp_r1d, ierr)
  deallocate(A_dev1__sp_r1d)
  deallocate(A_dev2__sp_r1d)
  !
  is_mapped = devxlib_mapped( A_dev1__sp_r1d ) .or. &
              devxlib_mapped( A_dev2__sp_r1d )
  if (is_mapped) then
    nfail_mapping=nfail_mapping+1
    lfail_mapping=.true.
    write(6,"(3x,a)") "mem mapping check-post2 FAILED" 
  endif
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(6,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !

  !
  !=====================
  write(6,"(/,3x,a)") "checking sp_r2d ..." 
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  lfail_mapping=.false.
  !
  is_mapped = devxlib_mapped( A_dev1__sp_r2d ) .or. &
              devxlib_mapped( A_dev2__sp_r2d )
  if (is_mapped) then
     nfail_mapping=nfail_mapping+1
     lfail_mapping=.true.
     write(6,"(3x,a)") "mem mapping check-pre FAILED" 
  endif
  !
  ! allocations
  allocate( A_hst1__sp_r2d(bounds(1):bounds(2),bounds(3):bounds(4)) )
  allocate( A_hst2__sp_r2d(bounds(1):bounds(2),bounds(3):bounds(4)) )
  allocate( A_hst3__sp_r2d(bounds(1):bounds(2),bounds(3):bounds(4)) )
  allocate( A_dev1__sp_r2d(bounds(1):bounds(2),bounds(3):bounds(4)) )
  allocate( A_dev2__sp_r2d(bounds(1):bounds(2),bounds(3):bounds(4)) )
  call devxlib_map(A_dev1__sp_r2d)
  call devxlib_map(A_dev2__sp_r2d)
  !
  is_mapped = devxlib_mapped( A_dev1__sp_r2d )
  if (.not.is_mapped) then
    nfail_mapping=nfail_mapping+1
    lfail_mapping=.true.
    write(6,"(3x,a)") "mem mapping check-post FAILED" 
  endif
  !
  ! init
  call random_number( A_hst1__sp_r2d )
  
  !
  ! mem copy h2d
  call devxlib_memcpy_h2d(A_dev1__sp_r2d, A_hst1__sp_r2d)
  !
  ! mem copy
  call devxlib_memcpy_d2d(A_dev2__sp_r2d, A_dev1__sp_r2d )
  !
  !
  ! mem copy d2h
  call devxlib_memcpy_d2h(A_hst2__sp_r2d, A_dev2__sp_r2d)
  !
  !
  ! mem copy h2h
  call devxlib_memcpy_h2h(A_hst3__sp_r2d, A_hst2__sp_r2d)
  !
  ! check
  if (lfail_mapping) write(6,"(3x,a)") "Mapping FAILED" 
  !
  if ( any(abs(A_hst3__sp_r2d -A_hst1__sp_r2d )> thr) ) then
     !
     write(6,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(6,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst1__sp_r2d)
  deallocate(A_hst2__sp_r2d)
  deallocate(A_hst3__sp_r2d)
  !
  call devxlib_unmap(A_dev1__sp_r2d, ierr)
  call devxlib_unmap(A_dev2__sp_r2d, ierr)
  deallocate(A_dev1__sp_r2d)
  deallocate(A_dev2__sp_r2d)
  !
  is_mapped = devxlib_mapped( A_dev1__sp_r2d ) .or. &
              devxlib_mapped( A_dev2__sp_r2d )
  if (is_mapped) then
    nfail_mapping=nfail_mapping+1
    lfail_mapping=.true.
    write(6,"(3x,a)") "mem mapping check-post2 FAILED" 
  endif
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(6,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !

  !
  !=====================
  write(6,"(/,3x,a)") "checking sp_r3d ..." 
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  lfail_mapping=.false.
  !
  is_mapped = devxlib_mapped( A_dev1__sp_r3d ) .or. &
              devxlib_mapped( A_dev2__sp_r3d )
  if (is_mapped) then
     nfail_mapping=nfail_mapping+1
     lfail_mapping=.true.
     write(6,"(3x,a)") "mem mapping check-pre FAILED" 
  endif
  !
  ! allocations
  allocate( A_hst1__sp_r3d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6)) )
  allocate( A_hst2__sp_r3d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6)) )
  allocate( A_hst3__sp_r3d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6)) )
  allocate( A_dev1__sp_r3d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6)) )
  allocate( A_dev2__sp_r3d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6)) )
  call devxlib_map(A_dev1__sp_r3d)
  call devxlib_map(A_dev2__sp_r3d)
  !
  is_mapped = devxlib_mapped( A_dev1__sp_r3d )
  if (.not.is_mapped) then
    nfail_mapping=nfail_mapping+1
    lfail_mapping=.true.
    write(6,"(3x,a)") "mem mapping check-post FAILED" 
  endif
  !
  ! init
  call random_number( A_hst1__sp_r3d )
  
  !
  ! mem copy h2d
  call devxlib_memcpy_h2d(A_dev1__sp_r3d, A_hst1__sp_r3d)
  !
  ! mem copy
  call devxlib_memcpy_d2d(A_dev2__sp_r3d, A_dev1__sp_r3d )
  !
  !
  ! mem copy d2h
  call devxlib_memcpy_d2h(A_hst2__sp_r3d, A_dev2__sp_r3d)
  !
  !
  ! mem copy h2h
  call devxlib_memcpy_h2h(A_hst3__sp_r3d, A_hst2__sp_r3d)
  !
  ! check
  if (lfail_mapping) write(6,"(3x,a)") "Mapping FAILED" 
  !
  if ( any(abs(A_hst3__sp_r3d -A_hst1__sp_r3d )> thr) ) then
     !
     write(6,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(6,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst1__sp_r3d)
  deallocate(A_hst2__sp_r3d)
  deallocate(A_hst3__sp_r3d)
  !
  call devxlib_unmap(A_dev1__sp_r3d, ierr)
  call devxlib_unmap(A_dev2__sp_r3d, ierr)
  deallocate(A_dev1__sp_r3d)
  deallocate(A_dev2__sp_r3d)
  !
  is_mapped = devxlib_mapped( A_dev1__sp_r3d ) .or. &
              devxlib_mapped( A_dev2__sp_r3d )
  if (is_mapped) then
    nfail_mapping=nfail_mapping+1
    lfail_mapping=.true.
    write(6,"(3x,a)") "mem mapping check-post2 FAILED" 
  endif
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(6,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !

  !
  !=====================
  write(6,"(/,3x,a)") "checking sp_r4d ..." 
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  lfail_mapping=.false.
  !
  is_mapped = devxlib_mapped( A_dev1__sp_r4d ) .or. &
              devxlib_mapped( A_dev2__sp_r4d )
  if (is_mapped) then
     nfail_mapping=nfail_mapping+1
     lfail_mapping=.true.
     write(6,"(3x,a)") "mem mapping check-pre FAILED" 
  endif
  !
  ! allocations
  allocate( A_hst1__sp_r4d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6),bounds(7):bounds(8)) )
  allocate( A_hst2__sp_r4d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6),bounds(7):bounds(8)) )
  allocate( A_hst3__sp_r4d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6),bounds(7):bounds(8)) )
  allocate( A_dev1__sp_r4d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6),bounds(7):bounds(8)) )
  allocate( A_dev2__sp_r4d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6),bounds(7):bounds(8)) )
  call devxlib_map(A_dev1__sp_r4d)
  call devxlib_map(A_dev2__sp_r4d)
  !
  is_mapped = devxlib_mapped( A_dev1__sp_r4d )
  if (.not.is_mapped) then
    nfail_mapping=nfail_mapping+1
    lfail_mapping=.true.
    write(6,"(3x,a)") "mem mapping check-post FAILED" 
  endif
  !
  ! init
  call random_number( A_hst1__sp_r4d )
  
  !
  ! mem copy h2d
  call devxlib_memcpy_h2d(A_dev1__sp_r4d, A_hst1__sp_r4d)
  !
  ! mem copy
  call devxlib_memcpy_d2d(A_dev2__sp_r4d, A_dev1__sp_r4d )
  !
  !
  ! mem copy d2h
  call devxlib_memcpy_d2h(A_hst2__sp_r4d, A_dev2__sp_r4d)
  !
  !
  ! mem copy h2h
  call devxlib_memcpy_h2h(A_hst3__sp_r4d, A_hst2__sp_r4d)
  !
  ! check
  if (lfail_mapping) write(6,"(3x,a)") "Mapping FAILED" 
  !
  if ( any(abs(A_hst3__sp_r4d -A_hst1__sp_r4d )> thr) ) then
     !
     write(6,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(6,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst1__sp_r4d)
  deallocate(A_hst2__sp_r4d)
  deallocate(A_hst3__sp_r4d)
  !
  call devxlib_unmap(A_dev1__sp_r4d, ierr)
  call devxlib_unmap(A_dev2__sp_r4d, ierr)
  deallocate(A_dev1__sp_r4d)
  deallocate(A_dev2__sp_r4d)
  !
  is_mapped = devxlib_mapped( A_dev1__sp_r4d ) .or. &
              devxlib_mapped( A_dev2__sp_r4d )
  if (is_mapped) then
    nfail_mapping=nfail_mapping+1
    lfail_mapping=.true.
    write(6,"(3x,a)") "mem mapping check-post2 FAILED" 
  endif
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(6,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !


  !
  !=====================
  write(6,"(/,3x,a)") "checking dp_r1d ..." 
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  lfail_mapping=.false.
  !
  is_mapped = devxlib_mapped( A_dev1__dp_r1d ) .or. &
              devxlib_mapped( A_dev2__dp_r1d )
  if (is_mapped) then
     nfail_mapping=nfail_mapping+1
     lfail_mapping=.true.
     write(6,"(3x,a)") "mem mapping check-pre FAILED" 
  endif
  !
  ! allocations
  allocate( A_hst1__dp_r1d(bounds(1):bounds(2)) )
  allocate( A_hst2__dp_r1d(bounds(1):bounds(2)) )
  allocate( A_hst3__dp_r1d(bounds(1):bounds(2)) )
  allocate( A_dev1__dp_r1d(bounds(1):bounds(2)) )
  allocate( A_dev2__dp_r1d(bounds(1):bounds(2)) )
  call devxlib_map(A_dev1__dp_r1d)
  call devxlib_map(A_dev2__dp_r1d)
  !
  is_mapped = devxlib_mapped( A_dev1__dp_r1d )
  if (.not.is_mapped) then
    nfail_mapping=nfail_mapping+1
    lfail_mapping=.true.
    write(6,"(3x,a)") "mem mapping check-post FAILED" 
  endif
  !
  ! init
  call random_number( A_hst1__dp_r1d )
  
  !
  ! mem copy h2d
  call devxlib_memcpy_h2d(A_dev1__dp_r1d, A_hst1__dp_r1d)
  !
  ! mem copy
  call devxlib_memcpy_d2d(A_dev2__dp_r1d, A_dev1__dp_r1d )
  !
  !
  ! mem copy d2h
  call devxlib_memcpy_d2h(A_hst2__dp_r1d, A_dev2__dp_r1d)
  !
  !
  ! mem copy h2h
  call devxlib_memcpy_h2h(A_hst3__dp_r1d, A_hst2__dp_r1d)
  !
  ! check
  if (lfail_mapping) write(6,"(3x,a)") "Mapping FAILED" 
  !
  if ( any(abs(A_hst3__dp_r1d -A_hst1__dp_r1d )> thr) ) then
     !
     write(6,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(6,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst1__dp_r1d)
  deallocate(A_hst2__dp_r1d)
  deallocate(A_hst3__dp_r1d)
  !
  call devxlib_unmap(A_dev1__dp_r1d, ierr)
  call devxlib_unmap(A_dev2__dp_r1d, ierr)
  deallocate(A_dev1__dp_r1d)
  deallocate(A_dev2__dp_r1d)
  !
  is_mapped = devxlib_mapped( A_dev1__dp_r1d ) .or. &
              devxlib_mapped( A_dev2__dp_r1d )
  if (is_mapped) then
    nfail_mapping=nfail_mapping+1
    lfail_mapping=.true.
    write(6,"(3x,a)") "mem mapping check-post2 FAILED" 
  endif
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(6,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !

  !
  !=====================
  write(6,"(/,3x,a)") "checking dp_r2d ..." 
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  lfail_mapping=.false.
  !
  is_mapped = devxlib_mapped( A_dev1__dp_r2d ) .or. &
              devxlib_mapped( A_dev2__dp_r2d )
  if (is_mapped) then
     nfail_mapping=nfail_mapping+1
     lfail_mapping=.true.
     write(6,"(3x,a)") "mem mapping check-pre FAILED" 
  endif
  !
  ! allocations
  allocate( A_hst1__dp_r2d(bounds(1):bounds(2),bounds(3):bounds(4)) )
  allocate( A_hst2__dp_r2d(bounds(1):bounds(2),bounds(3):bounds(4)) )
  allocate( A_hst3__dp_r2d(bounds(1):bounds(2),bounds(3):bounds(4)) )
  allocate( A_dev1__dp_r2d(bounds(1):bounds(2),bounds(3):bounds(4)) )
  allocate( A_dev2__dp_r2d(bounds(1):bounds(2),bounds(3):bounds(4)) )
  call devxlib_map(A_dev1__dp_r2d)
  call devxlib_map(A_dev2__dp_r2d)
  !
  is_mapped = devxlib_mapped( A_dev1__dp_r2d )
  if (.not.is_mapped) then
    nfail_mapping=nfail_mapping+1
    lfail_mapping=.true.
    write(6,"(3x,a)") "mem mapping check-post FAILED" 
  endif
  !
  ! init
  call random_number( A_hst1__dp_r2d )
  
  !
  ! mem copy h2d
  call devxlib_memcpy_h2d(A_dev1__dp_r2d, A_hst1__dp_r2d)
  !
  ! mem copy
  call devxlib_memcpy_d2d(A_dev2__dp_r2d, A_dev1__dp_r2d )
  !
  !
  ! mem copy d2h
  call devxlib_memcpy_d2h(A_hst2__dp_r2d, A_dev2__dp_r2d)
  !
  !
  ! mem copy h2h
  call devxlib_memcpy_h2h(A_hst3__dp_r2d, A_hst2__dp_r2d)
  !
  ! check
  if (lfail_mapping) write(6,"(3x,a)") "Mapping FAILED" 
  !
  if ( any(abs(A_hst3__dp_r2d -A_hst1__dp_r2d )> thr) ) then
     !
     write(6,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(6,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst1__dp_r2d)
  deallocate(A_hst2__dp_r2d)
  deallocate(A_hst3__dp_r2d)
  !
  call devxlib_unmap(A_dev1__dp_r2d, ierr)
  call devxlib_unmap(A_dev2__dp_r2d, ierr)
  deallocate(A_dev1__dp_r2d)
  deallocate(A_dev2__dp_r2d)
  !
  is_mapped = devxlib_mapped( A_dev1__dp_r2d ) .or. &
              devxlib_mapped( A_dev2__dp_r2d )
  if (is_mapped) then
    nfail_mapping=nfail_mapping+1
    lfail_mapping=.true.
    write(6,"(3x,a)") "mem mapping check-post2 FAILED" 
  endif
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(6,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !

  !
  !=====================
  write(6,"(/,3x,a)") "checking dp_r3d ..." 
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  lfail_mapping=.false.
  !
  is_mapped = devxlib_mapped( A_dev1__dp_r3d ) .or. &
              devxlib_mapped( A_dev2__dp_r3d )
  if (is_mapped) then
     nfail_mapping=nfail_mapping+1
     lfail_mapping=.true.
     write(6,"(3x,a)") "mem mapping check-pre FAILED" 
  endif
  !
  ! allocations
  allocate( A_hst1__dp_r3d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6)) )
  allocate( A_hst2__dp_r3d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6)) )
  allocate( A_hst3__dp_r3d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6)) )
  allocate( A_dev1__dp_r3d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6)) )
  allocate( A_dev2__dp_r3d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6)) )
  call devxlib_map(A_dev1__dp_r3d)
  call devxlib_map(A_dev2__dp_r3d)
  !
  is_mapped = devxlib_mapped( A_dev1__dp_r3d )
  if (.not.is_mapped) then
    nfail_mapping=nfail_mapping+1
    lfail_mapping=.true.
    write(6,"(3x,a)") "mem mapping check-post FAILED" 
  endif
  !
  ! init
  call random_number( A_hst1__dp_r3d )
  
  !
  ! mem copy h2d
  call devxlib_memcpy_h2d(A_dev1__dp_r3d, A_hst1__dp_r3d)
  !
  ! mem copy
  call devxlib_memcpy_d2d(A_dev2__dp_r3d, A_dev1__dp_r3d )
  !
  !
  ! mem copy d2h
  call devxlib_memcpy_d2h(A_hst2__dp_r3d, A_dev2__dp_r3d)
  !
  !
  ! mem copy h2h
  call devxlib_memcpy_h2h(A_hst3__dp_r3d, A_hst2__dp_r3d)
  !
  ! check
  if (lfail_mapping) write(6,"(3x,a)") "Mapping FAILED" 
  !
  if ( any(abs(A_hst3__dp_r3d -A_hst1__dp_r3d )> thr) ) then
     !
     write(6,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(6,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst1__dp_r3d)
  deallocate(A_hst2__dp_r3d)
  deallocate(A_hst3__dp_r3d)
  !
  call devxlib_unmap(A_dev1__dp_r3d, ierr)
  call devxlib_unmap(A_dev2__dp_r3d, ierr)
  deallocate(A_dev1__dp_r3d)
  deallocate(A_dev2__dp_r3d)
  !
  is_mapped = devxlib_mapped( A_dev1__dp_r3d ) .or. &
              devxlib_mapped( A_dev2__dp_r3d )
  if (is_mapped) then
    nfail_mapping=nfail_mapping+1
    lfail_mapping=.true.
    write(6,"(3x,a)") "mem mapping check-post2 FAILED" 
  endif
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(6,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !

  !
  !=====================
  write(6,"(/,3x,a)") "checking dp_r4d ..." 
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  lfail_mapping=.false.
  !
  is_mapped = devxlib_mapped( A_dev1__dp_r4d ) .or. &
              devxlib_mapped( A_dev2__dp_r4d )
  if (is_mapped) then
     nfail_mapping=nfail_mapping+1
     lfail_mapping=.true.
     write(6,"(3x,a)") "mem mapping check-pre FAILED" 
  endif
  !
  ! allocations
  allocate( A_hst1__dp_r4d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6),bounds(7):bounds(8)) )
  allocate( A_hst2__dp_r4d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6),bounds(7):bounds(8)) )
  allocate( A_hst3__dp_r4d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6),bounds(7):bounds(8)) )
  allocate( A_dev1__dp_r4d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6),bounds(7):bounds(8)) )
  allocate( A_dev2__dp_r4d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6),bounds(7):bounds(8)) )
  call devxlib_map(A_dev1__dp_r4d)
  call devxlib_map(A_dev2__dp_r4d)
  !
  is_mapped = devxlib_mapped( A_dev1__dp_r4d )
  if (.not.is_mapped) then
    nfail_mapping=nfail_mapping+1
    lfail_mapping=.true.
    write(6,"(3x,a)") "mem mapping check-post FAILED" 
  endif
  !
  ! init
  call random_number( A_hst1__dp_r4d )
  
  !
  ! mem copy h2d
  call devxlib_memcpy_h2d(A_dev1__dp_r4d, A_hst1__dp_r4d)
  !
  ! mem copy
  call devxlib_memcpy_d2d(A_dev2__dp_r4d, A_dev1__dp_r4d )
  !
  !
  ! mem copy d2h
  call devxlib_memcpy_d2h(A_hst2__dp_r4d, A_dev2__dp_r4d)
  !
  !
  ! mem copy h2h
  call devxlib_memcpy_h2h(A_hst3__dp_r4d, A_hst2__dp_r4d)
  !
  ! check
  if (lfail_mapping) write(6,"(3x,a)") "Mapping FAILED" 
  !
  if ( any(abs(A_hst3__dp_r4d -A_hst1__dp_r4d )> thr) ) then
     !
     write(6,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(6,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst1__dp_r4d)
  deallocate(A_hst2__dp_r4d)
  deallocate(A_hst3__dp_r4d)
  !
  call devxlib_unmap(A_dev1__dp_r4d, ierr)
  call devxlib_unmap(A_dev2__dp_r4d, ierr)
  deallocate(A_dev1__dp_r4d)
  deallocate(A_dev2__dp_r4d)
  !
  is_mapped = devxlib_mapped( A_dev1__dp_r4d ) .or. &
              devxlib_mapped( A_dev2__dp_r4d )
  if (is_mapped) then
    nfail_mapping=nfail_mapping+1
    lfail_mapping=.true.
    write(6,"(3x,a)") "mem mapping check-post2 FAILED" 
  endif
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(6,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !



  !
  !=====================
  write(6,"(/,3x,a)") "checking sp_c1d ..." 
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  lfail_mapping=.false.
  !
  is_mapped = devxlib_mapped( A_dev1__sp_c1d ) .or. &
              devxlib_mapped( A_dev2__sp_c1d )
  if (is_mapped) then
     nfail_mapping=nfail_mapping+1
     lfail_mapping=.true.
     write(6,"(3x,a)") "mem mapping check-pre FAILED" 
  endif
  !
  ! allocations
  allocate( A_hst1__sp_c1d(bounds(1):bounds(2)) )
  allocate( A_hst2__sp_c1d(bounds(1):bounds(2)) )
  allocate( A_hst3__sp_c1d(bounds(1):bounds(2)) )
  allocate( A_dev1__sp_c1d(bounds(1):bounds(2)) )
  allocate( A_dev2__sp_c1d(bounds(1):bounds(2)) )
  call devxlib_map(A_dev1__sp_c1d)
  call devxlib_map(A_dev2__sp_c1d)
  allocate( A_rtmp__sp_1d(bounds(1):bounds(2)) )
  
  !
  is_mapped = devxlib_mapped( A_dev1__sp_c1d )
  if (.not.is_mapped) then
    nfail_mapping=nfail_mapping+1
    lfail_mapping=.true.
    write(6,"(3x,a)") "mem mapping check-post FAILED" 
  endif
  !
  ! init
  call random_number( A_rtmp__sp_1d )
  A_hst1__sp_c1d=A_rtmp__sp_1d
  call random_number( A_rtmp__sp_1d )
  A_hst1__sp_c1d=A_hst1__sp_c1d+cmplx(0.0,1.0)*A_rtmp__sp_1d
  
  !
  ! mem copy h2d
  call devxlib_memcpy_h2d(A_dev1__sp_c1d, A_hst1__sp_c1d)
  !
  ! mem copy
  call devxlib_memcpy_d2d(A_dev2__sp_c1d, A_dev1__sp_c1d )
  !
  ! make cmplx conjg
  call devxlib_conjg_d( A_dev2__sp_c1d )
  
  !
  ! mem copy d2h
  call devxlib_memcpy_d2h(A_hst2__sp_c1d, A_dev2__sp_c1d)
  !
  ! retrieve conjg data
  call devxlib_conjg_h( A_hst2__sp_c1d )
  
  !
  ! mem copy h2h
  call devxlib_memcpy_h2h(A_hst3__sp_c1d, A_hst2__sp_c1d)
  !
  ! check
  if (lfail_mapping) write(6,"(3x,a)") "Mapping FAILED" 
  !
  if ( any(abs(A_hst3__sp_c1d -A_hst1__sp_c1d )> thr) ) then
     !
     write(6,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(6,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst1__sp_c1d)
  deallocate(A_hst2__sp_c1d)
  deallocate(A_hst3__sp_c1d)
  !
  call devxlib_unmap(A_dev1__sp_c1d, ierr)
  call devxlib_unmap(A_dev2__sp_c1d, ierr)
  deallocate(A_dev1__sp_c1d)
  deallocate(A_dev2__sp_c1d)
  !
  is_mapped = devxlib_mapped( A_dev1__sp_c1d ) .or. &
              devxlib_mapped( A_dev2__sp_c1d )
  if (is_mapped) then
    nfail_mapping=nfail_mapping+1
    lfail_mapping=.true.
    write(6,"(3x,a)") "mem mapping check-post2 FAILED" 
  endif
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(6,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !

  !
  !=====================
  write(6,"(/,3x,a)") "checking sp_c2d ..." 
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  lfail_mapping=.false.
  !
  is_mapped = devxlib_mapped( A_dev1__sp_c2d ) .or. &
              devxlib_mapped( A_dev2__sp_c2d )
  if (is_mapped) then
     nfail_mapping=nfail_mapping+1
     lfail_mapping=.true.
     write(6,"(3x,a)") "mem mapping check-pre FAILED" 
  endif
  !
  ! allocations
  allocate( A_hst1__sp_c2d(bounds(1):bounds(2),bounds(3):bounds(4)) )
  allocate( A_hst2__sp_c2d(bounds(1):bounds(2),bounds(3):bounds(4)) )
  allocate( A_hst3__sp_c2d(bounds(1):bounds(2),bounds(3):bounds(4)) )
  allocate( A_dev1__sp_c2d(bounds(1):bounds(2),bounds(3):bounds(4)) )
  allocate( A_dev2__sp_c2d(bounds(1):bounds(2),bounds(3):bounds(4)) )
  call devxlib_map(A_dev1__sp_c2d)
  call devxlib_map(A_dev2__sp_c2d)
  allocate( A_rtmp__sp_2d(bounds(1):bounds(2),bounds(3):bounds(4)) )
  
  !
  is_mapped = devxlib_mapped( A_dev1__sp_c2d )
  if (.not.is_mapped) then
    nfail_mapping=nfail_mapping+1
    lfail_mapping=.true.
    write(6,"(3x,a)") "mem mapping check-post FAILED" 
  endif
  !
  ! init
  call random_number( A_rtmp__sp_2d )
  A_hst1__sp_c2d=A_rtmp__sp_2d
  call random_number( A_rtmp__sp_2d )
  A_hst1__sp_c2d=A_hst1__sp_c2d+cmplx(0.0,1.0)*A_rtmp__sp_2d
  
  !
  ! mem copy h2d
  call devxlib_memcpy_h2d(A_dev1__sp_c2d, A_hst1__sp_c2d)
  !
  ! mem copy
  call devxlib_memcpy_d2d(A_dev2__sp_c2d, A_dev1__sp_c2d )
  !
  ! make cmplx conjg
  call devxlib_conjg_d( A_dev2__sp_c2d )
  
  !
  ! mem copy d2h
  call devxlib_memcpy_d2h(A_hst2__sp_c2d, A_dev2__sp_c2d)
  !
  ! retrieve conjg data
  call devxlib_conjg_h( A_hst2__sp_c2d )
  
  !
  ! mem copy h2h
  call devxlib_memcpy_h2h(A_hst3__sp_c2d, A_hst2__sp_c2d)
  !
  ! check
  if (lfail_mapping) write(6,"(3x,a)") "Mapping FAILED" 
  !
  if ( any(abs(A_hst3__sp_c2d -A_hst1__sp_c2d )> thr) ) then
     !
     write(6,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(6,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst1__sp_c2d)
  deallocate(A_hst2__sp_c2d)
  deallocate(A_hst3__sp_c2d)
  !
  call devxlib_unmap(A_dev1__sp_c2d, ierr)
  call devxlib_unmap(A_dev2__sp_c2d, ierr)
  deallocate(A_dev1__sp_c2d)
  deallocate(A_dev2__sp_c2d)
  !
  is_mapped = devxlib_mapped( A_dev1__sp_c2d ) .or. &
              devxlib_mapped( A_dev2__sp_c2d )
  if (is_mapped) then
    nfail_mapping=nfail_mapping+1
    lfail_mapping=.true.
    write(6,"(3x,a)") "mem mapping check-post2 FAILED" 
  endif
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(6,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !

  !
  !=====================
  write(6,"(/,3x,a)") "checking sp_c3d ..." 
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  lfail_mapping=.false.
  !
  is_mapped = devxlib_mapped( A_dev1__sp_c3d ) .or. &
              devxlib_mapped( A_dev2__sp_c3d )
  if (is_mapped) then
     nfail_mapping=nfail_mapping+1
     lfail_mapping=.true.
     write(6,"(3x,a)") "mem mapping check-pre FAILED" 
  endif
  !
  ! allocations
  allocate( A_hst1__sp_c3d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6)) )
  allocate( A_hst2__sp_c3d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6)) )
  allocate( A_hst3__sp_c3d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6)) )
  allocate( A_dev1__sp_c3d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6)) )
  allocate( A_dev2__sp_c3d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6)) )
  call devxlib_map(A_dev1__sp_c3d)
  call devxlib_map(A_dev2__sp_c3d)
  allocate( A_rtmp__sp_3d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6)) )
  
  !
  is_mapped = devxlib_mapped( A_dev1__sp_c3d )
  if (.not.is_mapped) then
    nfail_mapping=nfail_mapping+1
    lfail_mapping=.true.
    write(6,"(3x,a)") "mem mapping check-post FAILED" 
  endif
  !
  ! init
  call random_number( A_rtmp__sp_3d )
  A_hst1__sp_c3d=A_rtmp__sp_3d
  call random_number( A_rtmp__sp_3d )
  A_hst1__sp_c3d=A_hst1__sp_c3d+cmplx(0.0,1.0)*A_rtmp__sp_3d
  
  !
  ! mem copy h2d
  call devxlib_memcpy_h2d(A_dev1__sp_c3d, A_hst1__sp_c3d)
  !
  ! mem copy
  call devxlib_memcpy_d2d(A_dev2__sp_c3d, A_dev1__sp_c3d )
  !
  ! make cmplx conjg
  call devxlib_conjg_d( A_dev2__sp_c3d )
  
  !
  ! mem copy d2h
  call devxlib_memcpy_d2h(A_hst2__sp_c3d, A_dev2__sp_c3d)
  !
  ! retrieve conjg data
  call devxlib_conjg_h( A_hst2__sp_c3d )
  
  !
  ! mem copy h2h
  call devxlib_memcpy_h2h(A_hst3__sp_c3d, A_hst2__sp_c3d)
  !
  ! check
  if (lfail_mapping) write(6,"(3x,a)") "Mapping FAILED" 
  !
  if ( any(abs(A_hst3__sp_c3d -A_hst1__sp_c3d )> thr) ) then
     !
     write(6,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(6,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst1__sp_c3d)
  deallocate(A_hst2__sp_c3d)
  deallocate(A_hst3__sp_c3d)
  !
  call devxlib_unmap(A_dev1__sp_c3d, ierr)
  call devxlib_unmap(A_dev2__sp_c3d, ierr)
  deallocate(A_dev1__sp_c3d)
  deallocate(A_dev2__sp_c3d)
  !
  is_mapped = devxlib_mapped( A_dev1__sp_c3d ) .or. &
              devxlib_mapped( A_dev2__sp_c3d )
  if (is_mapped) then
    nfail_mapping=nfail_mapping+1
    lfail_mapping=.true.
    write(6,"(3x,a)") "mem mapping check-post2 FAILED" 
  endif
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(6,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !

  !
  !=====================
  write(6,"(/,3x,a)") "checking sp_c4d ..." 
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  lfail_mapping=.false.
  !
  is_mapped = devxlib_mapped( A_dev1__sp_c4d ) .or. &
              devxlib_mapped( A_dev2__sp_c4d )
  if (is_mapped) then
     nfail_mapping=nfail_mapping+1
     lfail_mapping=.true.
     write(6,"(3x,a)") "mem mapping check-pre FAILED" 
  endif
  !
  ! allocations
  allocate( A_hst1__sp_c4d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6),bounds(7):bounds(8)) )
  allocate( A_hst2__sp_c4d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6),bounds(7):bounds(8)) )
  allocate( A_hst3__sp_c4d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6),bounds(7):bounds(8)) )
  allocate( A_dev1__sp_c4d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6),bounds(7):bounds(8)) )
  allocate( A_dev2__sp_c4d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6),bounds(7):bounds(8)) )
  call devxlib_map(A_dev1__sp_c4d)
  call devxlib_map(A_dev2__sp_c4d)
  allocate( A_rtmp__sp_4d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6),bounds(7):bounds(8)) )
  
  !
  is_mapped = devxlib_mapped( A_dev1__sp_c4d )
  if (.not.is_mapped) then
    nfail_mapping=nfail_mapping+1
    lfail_mapping=.true.
    write(6,"(3x,a)") "mem mapping check-post FAILED" 
  endif
  !
  ! init
  call random_number( A_rtmp__sp_4d )
  A_hst1__sp_c4d=A_rtmp__sp_4d
  call random_number( A_rtmp__sp_4d )
  A_hst1__sp_c4d=A_hst1__sp_c4d+cmplx(0.0,1.0)*A_rtmp__sp_4d
  
  !
  ! mem copy h2d
  call devxlib_memcpy_h2d(A_dev1__sp_c4d, A_hst1__sp_c4d)
  !
  ! mem copy
  call devxlib_memcpy_d2d(A_dev2__sp_c4d, A_dev1__sp_c4d )
  !
  ! make cmplx conjg
  call devxlib_conjg_d( A_dev2__sp_c4d )
  
  !
  ! mem copy d2h
  call devxlib_memcpy_d2h(A_hst2__sp_c4d, A_dev2__sp_c4d)
  !
  ! retrieve conjg data
  call devxlib_conjg_h( A_hst2__sp_c4d )
  
  !
  ! mem copy h2h
  call devxlib_memcpy_h2h(A_hst3__sp_c4d, A_hst2__sp_c4d)
  !
  ! check
  if (lfail_mapping) write(6,"(3x,a)") "Mapping FAILED" 
  !
  if ( any(abs(A_hst3__sp_c4d -A_hst1__sp_c4d )> thr) ) then
     !
     write(6,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(6,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst1__sp_c4d)
  deallocate(A_hst2__sp_c4d)
  deallocate(A_hst3__sp_c4d)
  !
  call devxlib_unmap(A_dev1__sp_c4d, ierr)
  call devxlib_unmap(A_dev2__sp_c4d, ierr)
  deallocate(A_dev1__sp_c4d)
  deallocate(A_dev2__sp_c4d)
  !
  is_mapped = devxlib_mapped( A_dev1__sp_c4d ) .or. &
              devxlib_mapped( A_dev2__sp_c4d )
  if (is_mapped) then
    nfail_mapping=nfail_mapping+1
    lfail_mapping=.true.
    write(6,"(3x,a)") "mem mapping check-post2 FAILED" 
  endif
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(6,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !


  !
  !=====================
  write(6,"(/,3x,a)") "checking dp_c1d ..." 
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  lfail_mapping=.false.
  !
  is_mapped = devxlib_mapped( A_dev1__dp_c1d ) .or. &
              devxlib_mapped( A_dev2__dp_c1d )
  if (is_mapped) then
     nfail_mapping=nfail_mapping+1
     lfail_mapping=.true.
     write(6,"(3x,a)") "mem mapping check-pre FAILED" 
  endif
  !
  ! allocations
  allocate( A_hst1__dp_c1d(bounds(1):bounds(2)) )
  allocate( A_hst2__dp_c1d(bounds(1):bounds(2)) )
  allocate( A_hst3__dp_c1d(bounds(1):bounds(2)) )
  allocate( A_dev1__dp_c1d(bounds(1):bounds(2)) )
  allocate( A_dev2__dp_c1d(bounds(1):bounds(2)) )
  call devxlib_map(A_dev1__dp_c1d)
  call devxlib_map(A_dev2__dp_c1d)
  allocate( A_rtmp__dp_1d(bounds(1):bounds(2)) )
  
  !
  is_mapped = devxlib_mapped( A_dev1__dp_c1d )
  if (.not.is_mapped) then
    nfail_mapping=nfail_mapping+1
    lfail_mapping=.true.
    write(6,"(3x,a)") "mem mapping check-post FAILED" 
  endif
  !
  ! init
  call random_number( A_rtmp__dp_1d )
  A_hst1__dp_c1d=A_rtmp__dp_1d
  call random_number( A_rtmp__dp_1d )
  A_hst1__dp_c1d=A_hst1__dp_c1d+cmplx(0.0,1.0)*A_rtmp__dp_1d
  
  !
  ! mem copy h2d
  call devxlib_memcpy_h2d(A_dev1__dp_c1d, A_hst1__dp_c1d)
  !
  ! mem copy
  call devxlib_memcpy_d2d(A_dev2__dp_c1d, A_dev1__dp_c1d )
  !
  ! make cmplx conjg
  call devxlib_conjg_d( A_dev2__dp_c1d )
  
  !
  ! mem copy d2h
  call devxlib_memcpy_d2h(A_hst2__dp_c1d, A_dev2__dp_c1d)
  !
  ! retrieve conjg data
  call devxlib_conjg_h( A_hst2__dp_c1d )
  
  !
  ! mem copy h2h
  call devxlib_memcpy_h2h(A_hst3__dp_c1d, A_hst2__dp_c1d)
  !
  ! check
  if (lfail_mapping) write(6,"(3x,a)") "Mapping FAILED" 
  !
  if ( any(abs(A_hst3__dp_c1d -A_hst1__dp_c1d )> thr) ) then
     !
     write(6,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(6,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst1__dp_c1d)
  deallocate(A_hst2__dp_c1d)
  deallocate(A_hst3__dp_c1d)
  !
  call devxlib_unmap(A_dev1__dp_c1d, ierr)
  call devxlib_unmap(A_dev2__dp_c1d, ierr)
  deallocate(A_dev1__dp_c1d)
  deallocate(A_dev2__dp_c1d)
  !
  is_mapped = devxlib_mapped( A_dev1__dp_c1d ) .or. &
              devxlib_mapped( A_dev2__dp_c1d )
  if (is_mapped) then
    nfail_mapping=nfail_mapping+1
    lfail_mapping=.true.
    write(6,"(3x,a)") "mem mapping check-post2 FAILED" 
  endif
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(6,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !

  !
  !=====================
  write(6,"(/,3x,a)") "checking dp_c2d ..." 
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  lfail_mapping=.false.
  !
  is_mapped = devxlib_mapped( A_dev1__dp_c2d ) .or. &
              devxlib_mapped( A_dev2__dp_c2d )
  if (is_mapped) then
     nfail_mapping=nfail_mapping+1
     lfail_mapping=.true.
     write(6,"(3x,a)") "mem mapping check-pre FAILED" 
  endif
  !
  ! allocations
  allocate( A_hst1__dp_c2d(bounds(1):bounds(2),bounds(3):bounds(4)) )
  allocate( A_hst2__dp_c2d(bounds(1):bounds(2),bounds(3):bounds(4)) )
  allocate( A_hst3__dp_c2d(bounds(1):bounds(2),bounds(3):bounds(4)) )
  allocate( A_dev1__dp_c2d(bounds(1):bounds(2),bounds(3):bounds(4)) )
  allocate( A_dev2__dp_c2d(bounds(1):bounds(2),bounds(3):bounds(4)) )
  call devxlib_map(A_dev1__dp_c2d)
  call devxlib_map(A_dev2__dp_c2d)
  allocate( A_rtmp__dp_2d(bounds(1):bounds(2),bounds(3):bounds(4)) )
  
  !
  is_mapped = devxlib_mapped( A_dev1__dp_c2d )
  if (.not.is_mapped) then
    nfail_mapping=nfail_mapping+1
    lfail_mapping=.true.
    write(6,"(3x,a)") "mem mapping check-post FAILED" 
  endif
  !
  ! init
  call random_number( A_rtmp__dp_2d )
  A_hst1__dp_c2d=A_rtmp__dp_2d
  call random_number( A_rtmp__dp_2d )
  A_hst1__dp_c2d=A_hst1__dp_c2d+cmplx(0.0,1.0)*A_rtmp__dp_2d
  
  !
  ! mem copy h2d
  call devxlib_memcpy_h2d(A_dev1__dp_c2d, A_hst1__dp_c2d)
  !
  ! mem copy
  call devxlib_memcpy_d2d(A_dev2__dp_c2d, A_dev1__dp_c2d )
  !
  ! make cmplx conjg
  call devxlib_conjg_d( A_dev2__dp_c2d )
  
  !
  ! mem copy d2h
  call devxlib_memcpy_d2h(A_hst2__dp_c2d, A_dev2__dp_c2d)
  !
  ! retrieve conjg data
  call devxlib_conjg_h( A_hst2__dp_c2d )
  
  !
  ! mem copy h2h
  call devxlib_memcpy_h2h(A_hst3__dp_c2d, A_hst2__dp_c2d)
  !
  ! check
  if (lfail_mapping) write(6,"(3x,a)") "Mapping FAILED" 
  !
  if ( any(abs(A_hst3__dp_c2d -A_hst1__dp_c2d )> thr) ) then
     !
     write(6,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(6,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst1__dp_c2d)
  deallocate(A_hst2__dp_c2d)
  deallocate(A_hst3__dp_c2d)
  !
  call devxlib_unmap(A_dev1__dp_c2d, ierr)
  call devxlib_unmap(A_dev2__dp_c2d, ierr)
  deallocate(A_dev1__dp_c2d)
  deallocate(A_dev2__dp_c2d)
  !
  is_mapped = devxlib_mapped( A_dev1__dp_c2d ) .or. &
              devxlib_mapped( A_dev2__dp_c2d )
  if (is_mapped) then
    nfail_mapping=nfail_mapping+1
    lfail_mapping=.true.
    write(6,"(3x,a)") "mem mapping check-post2 FAILED" 
  endif
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(6,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !

  !
  !=====================
  write(6,"(/,3x,a)") "checking dp_c3d ..." 
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  lfail_mapping=.false.
  !
  is_mapped = devxlib_mapped( A_dev1__dp_c3d ) .or. &
              devxlib_mapped( A_dev2__dp_c3d )
  if (is_mapped) then
     nfail_mapping=nfail_mapping+1
     lfail_mapping=.true.
     write(6,"(3x,a)") "mem mapping check-pre FAILED" 
  endif
  !
  ! allocations
  allocate( A_hst1__dp_c3d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6)) )
  allocate( A_hst2__dp_c3d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6)) )
  allocate( A_hst3__dp_c3d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6)) )
  allocate( A_dev1__dp_c3d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6)) )
  allocate( A_dev2__dp_c3d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6)) )
  call devxlib_map(A_dev1__dp_c3d)
  call devxlib_map(A_dev2__dp_c3d)
  allocate( A_rtmp__dp_3d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6)) )
  
  !
  is_mapped = devxlib_mapped( A_dev1__dp_c3d )
  if (.not.is_mapped) then
    nfail_mapping=nfail_mapping+1
    lfail_mapping=.true.
    write(6,"(3x,a)") "mem mapping check-post FAILED" 
  endif
  !
  ! init
  call random_number( A_rtmp__dp_3d )
  A_hst1__dp_c3d=A_rtmp__dp_3d
  call random_number( A_rtmp__dp_3d )
  A_hst1__dp_c3d=A_hst1__dp_c3d+cmplx(0.0,1.0)*A_rtmp__dp_3d
  
  !
  ! mem copy h2d
  call devxlib_memcpy_h2d(A_dev1__dp_c3d, A_hst1__dp_c3d)
  !
  ! mem copy
  call devxlib_memcpy_d2d(A_dev2__dp_c3d, A_dev1__dp_c3d )
  !
  ! make cmplx conjg
  call devxlib_conjg_d( A_dev2__dp_c3d )
  
  !
  ! mem copy d2h
  call devxlib_memcpy_d2h(A_hst2__dp_c3d, A_dev2__dp_c3d)
  !
  ! retrieve conjg data
  call devxlib_conjg_h( A_hst2__dp_c3d )
  
  !
  ! mem copy h2h
  call devxlib_memcpy_h2h(A_hst3__dp_c3d, A_hst2__dp_c3d)
  !
  ! check
  if (lfail_mapping) write(6,"(3x,a)") "Mapping FAILED" 
  !
  if ( any(abs(A_hst3__dp_c3d -A_hst1__dp_c3d )> thr) ) then
     !
     write(6,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(6,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst1__dp_c3d)
  deallocate(A_hst2__dp_c3d)
  deallocate(A_hst3__dp_c3d)
  !
  call devxlib_unmap(A_dev1__dp_c3d, ierr)
  call devxlib_unmap(A_dev2__dp_c3d, ierr)
  deallocate(A_dev1__dp_c3d)
  deallocate(A_dev2__dp_c3d)
  !
  is_mapped = devxlib_mapped( A_dev1__dp_c3d ) .or. &
              devxlib_mapped( A_dev2__dp_c3d )
  if (is_mapped) then
    nfail_mapping=nfail_mapping+1
    lfail_mapping=.true.
    write(6,"(3x,a)") "mem mapping check-post2 FAILED" 
  endif
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(6,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !

  !
  !=====================
  write(6,"(/,3x,a)") "checking dp_c4d ..." 
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  lfail_mapping=.false.
  !
  is_mapped = devxlib_mapped( A_dev1__dp_c4d ) .or. &
              devxlib_mapped( A_dev2__dp_c4d )
  if (is_mapped) then
     nfail_mapping=nfail_mapping+1
     lfail_mapping=.true.
     write(6,"(3x,a)") "mem mapping check-pre FAILED" 
  endif
  !
  ! allocations
  allocate( A_hst1__dp_c4d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6),bounds(7):bounds(8)) )
  allocate( A_hst2__dp_c4d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6),bounds(7):bounds(8)) )
  allocate( A_hst3__dp_c4d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6),bounds(7):bounds(8)) )
  allocate( A_dev1__dp_c4d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6),bounds(7):bounds(8)) )
  allocate( A_dev2__dp_c4d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6),bounds(7):bounds(8)) )
  call devxlib_map(A_dev1__dp_c4d)
  call devxlib_map(A_dev2__dp_c4d)
  allocate( A_rtmp__dp_4d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6),bounds(7):bounds(8)) )
  
  !
  is_mapped = devxlib_mapped( A_dev1__dp_c4d )
  if (.not.is_mapped) then
    nfail_mapping=nfail_mapping+1
    lfail_mapping=.true.
    write(6,"(3x,a)") "mem mapping check-post FAILED" 
  endif
  !
  ! init
  call random_number( A_rtmp__dp_4d )
  A_hst1__dp_c4d=A_rtmp__dp_4d
  call random_number( A_rtmp__dp_4d )
  A_hst1__dp_c4d=A_hst1__dp_c4d+cmplx(0.0,1.0)*A_rtmp__dp_4d
  
  !
  ! mem copy h2d
  call devxlib_memcpy_h2d(A_dev1__dp_c4d, A_hst1__dp_c4d)
  !
  ! mem copy
  call devxlib_memcpy_d2d(A_dev2__dp_c4d, A_dev1__dp_c4d )
  !
  ! make cmplx conjg
  call devxlib_conjg_d( A_dev2__dp_c4d )
  
  !
  ! mem copy d2h
  call devxlib_memcpy_d2h(A_hst2__dp_c4d, A_dev2__dp_c4d)
  !
  ! retrieve conjg data
  call devxlib_conjg_h( A_hst2__dp_c4d )
  
  !
  ! mem copy h2h
  call devxlib_memcpy_h2h(A_hst3__dp_c4d, A_hst2__dp_c4d)
  !
  ! check
  if (lfail_mapping) write(6,"(3x,a)") "Mapping FAILED" 
  !
  if ( any(abs(A_hst3__dp_c4d -A_hst1__dp_c4d )> thr) ) then
     !
     write(6,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(6,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst1__dp_c4d)
  deallocate(A_hst2__dp_c4d)
  deallocate(A_hst3__dp_c4d)
  !
  call devxlib_unmap(A_dev1__dp_c4d, ierr)
  call devxlib_unmap(A_dev2__dp_c4d, ierr)
  deallocate(A_dev1__dp_c4d)
  deallocate(A_dev2__dp_c4d)
  !
  is_mapped = devxlib_mapped( A_dev1__dp_c4d ) .or. &
              devxlib_mapped( A_dev2__dp_c4d )
  if (is_mapped) then
    nfail_mapping=nfail_mapping+1
    lfail_mapping=.true.
    write(6,"(3x,a)") "mem mapping check-post2 FAILED" 
  endif
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(6,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !



  !
  !=====================
  write(6,"(/,3x,a)") "checking i4_i1d ..." 
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  lfail_mapping=.false.
  !
  is_mapped = devxlib_mapped( A_dev1__i4_i1d ) .or. &
              devxlib_mapped( A_dev2__i4_i1d )
  if (is_mapped) then
     nfail_mapping=nfail_mapping+1
     lfail_mapping=.true.
     write(6,"(3x,a)") "mem mapping check-pre FAILED" 
  endif
  !
  ! allocations
  allocate( A_hst1__i4_i1d(bounds(1):bounds(2)) )
  allocate( A_hst2__i4_i1d(bounds(1):bounds(2)) )
  allocate( A_hst3__i4_i1d(bounds(1):bounds(2)) )
  allocate( A_dev1__i4_i1d(bounds(1):bounds(2)) )
  allocate( A_dev2__i4_i1d(bounds(1):bounds(2)) )
  call devxlib_map(A_dev1__i4_i1d)
  call devxlib_map(A_dev2__i4_i1d)
  allocate( A_rtmp__i4_1d(bounds(1):bounds(2)) )
  
  !
  is_mapped = devxlib_mapped( A_dev1__i4_i1d )
  if (.not.is_mapped) then
    nfail_mapping=nfail_mapping+1
    lfail_mapping=.true.
    write(6,"(3x,a)") "mem mapping check-post FAILED" 
  endif
  !
  ! init
  call random_number( A_rtmp__i4_1d )
  A_hst1__i4_i1d=int( 1000*A_rtmp__i4_1d )
  
  !
  ! mem copy h2d
  call devxlib_memcpy_h2d(A_dev1__i4_i1d, A_hst1__i4_i1d)
  !
  ! mem copy
  call devxlib_memcpy_d2d(A_dev2__i4_i1d, A_dev1__i4_i1d )
  !
  !
  ! mem copy d2h
  call devxlib_memcpy_d2h(A_hst2__i4_i1d, A_dev2__i4_i1d)
  !
  !
  ! mem copy h2h
  call devxlib_memcpy_h2h(A_hst3__i4_i1d, A_hst2__i4_i1d)
  !
  ! check
  if (lfail_mapping) write(6,"(3x,a)") "Mapping FAILED" 
  !
  if ( any(abs(A_hst3__i4_i1d -A_hst1__i4_i1d )> thr) ) then
     !
     write(6,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(6,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst1__i4_i1d)
  deallocate(A_hst2__i4_i1d)
  deallocate(A_hst3__i4_i1d)
  !
  call devxlib_unmap(A_dev1__i4_i1d, ierr)
  call devxlib_unmap(A_dev2__i4_i1d, ierr)
  deallocate(A_dev1__i4_i1d)
  deallocate(A_dev2__i4_i1d)
  !
  is_mapped = devxlib_mapped( A_dev1__i4_i1d ) .or. &
              devxlib_mapped( A_dev2__i4_i1d )
  if (is_mapped) then
    nfail_mapping=nfail_mapping+1
    lfail_mapping=.true.
    write(6,"(3x,a)") "mem mapping check-post2 FAILED" 
  endif
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(6,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !

  !
  !=====================
  write(6,"(/,3x,a)") "checking i4_i2d ..." 
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  lfail_mapping=.false.
  !
  is_mapped = devxlib_mapped( A_dev1__i4_i2d ) .or. &
              devxlib_mapped( A_dev2__i4_i2d )
  if (is_mapped) then
     nfail_mapping=nfail_mapping+1
     lfail_mapping=.true.
     write(6,"(3x,a)") "mem mapping check-pre FAILED" 
  endif
  !
  ! allocations
  allocate( A_hst1__i4_i2d(bounds(1):bounds(2),bounds(3):bounds(4)) )
  allocate( A_hst2__i4_i2d(bounds(1):bounds(2),bounds(3):bounds(4)) )
  allocate( A_hst3__i4_i2d(bounds(1):bounds(2),bounds(3):bounds(4)) )
  allocate( A_dev1__i4_i2d(bounds(1):bounds(2),bounds(3):bounds(4)) )
  allocate( A_dev2__i4_i2d(bounds(1):bounds(2),bounds(3):bounds(4)) )
  call devxlib_map(A_dev1__i4_i2d)
  call devxlib_map(A_dev2__i4_i2d)
  allocate( A_rtmp__i4_2d(bounds(1):bounds(2),bounds(3):bounds(4)) )
  
  !
  is_mapped = devxlib_mapped( A_dev1__i4_i2d )
  if (.not.is_mapped) then
    nfail_mapping=nfail_mapping+1
    lfail_mapping=.true.
    write(6,"(3x,a)") "mem mapping check-post FAILED" 
  endif
  !
  ! init
  call random_number( A_rtmp__i4_2d )
  A_hst1__i4_i2d=int( 1000*A_rtmp__i4_2d )
  
  !
  ! mem copy h2d
  call devxlib_memcpy_h2d(A_dev1__i4_i2d, A_hst1__i4_i2d)
  !
  ! mem copy
  call devxlib_memcpy_d2d(A_dev2__i4_i2d, A_dev1__i4_i2d )
  !
  !
  ! mem copy d2h
  call devxlib_memcpy_d2h(A_hst2__i4_i2d, A_dev2__i4_i2d)
  !
  !
  ! mem copy h2h
  call devxlib_memcpy_h2h(A_hst3__i4_i2d, A_hst2__i4_i2d)
  !
  ! check
  if (lfail_mapping) write(6,"(3x,a)") "Mapping FAILED" 
  !
  if ( any(abs(A_hst3__i4_i2d -A_hst1__i4_i2d )> thr) ) then
     !
     write(6,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(6,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst1__i4_i2d)
  deallocate(A_hst2__i4_i2d)
  deallocate(A_hst3__i4_i2d)
  !
  call devxlib_unmap(A_dev1__i4_i2d, ierr)
  call devxlib_unmap(A_dev2__i4_i2d, ierr)
  deallocate(A_dev1__i4_i2d)
  deallocate(A_dev2__i4_i2d)
  !
  is_mapped = devxlib_mapped( A_dev1__i4_i2d ) .or. &
              devxlib_mapped( A_dev2__i4_i2d )
  if (is_mapped) then
    nfail_mapping=nfail_mapping+1
    lfail_mapping=.true.
    write(6,"(3x,a)") "mem mapping check-post2 FAILED" 
  endif
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(6,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !

  !
  !=====================
  write(6,"(/,3x,a)") "checking i4_i3d ..." 
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  lfail_mapping=.false.
  !
  is_mapped = devxlib_mapped( A_dev1__i4_i3d ) .or. &
              devxlib_mapped( A_dev2__i4_i3d )
  if (is_mapped) then
     nfail_mapping=nfail_mapping+1
     lfail_mapping=.true.
     write(6,"(3x,a)") "mem mapping check-pre FAILED" 
  endif
  !
  ! allocations
  allocate( A_hst1__i4_i3d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6)) )
  allocate( A_hst2__i4_i3d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6)) )
  allocate( A_hst3__i4_i3d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6)) )
  allocate( A_dev1__i4_i3d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6)) )
  allocate( A_dev2__i4_i3d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6)) )
  call devxlib_map(A_dev1__i4_i3d)
  call devxlib_map(A_dev2__i4_i3d)
  allocate( A_rtmp__i4_3d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6)) )
  
  !
  is_mapped = devxlib_mapped( A_dev1__i4_i3d )
  if (.not.is_mapped) then
    nfail_mapping=nfail_mapping+1
    lfail_mapping=.true.
    write(6,"(3x,a)") "mem mapping check-post FAILED" 
  endif
  !
  ! init
  call random_number( A_rtmp__i4_3d )
  A_hst1__i4_i3d=int( 1000*A_rtmp__i4_3d )
  
  !
  ! mem copy h2d
  call devxlib_memcpy_h2d(A_dev1__i4_i3d, A_hst1__i4_i3d)
  !
  ! mem copy
  call devxlib_memcpy_d2d(A_dev2__i4_i3d, A_dev1__i4_i3d )
  !
  !
  ! mem copy d2h
  call devxlib_memcpy_d2h(A_hst2__i4_i3d, A_dev2__i4_i3d)
  !
  !
  ! mem copy h2h
  call devxlib_memcpy_h2h(A_hst3__i4_i3d, A_hst2__i4_i3d)
  !
  ! check
  if (lfail_mapping) write(6,"(3x,a)") "Mapping FAILED" 
  !
  if ( any(abs(A_hst3__i4_i3d -A_hst1__i4_i3d )> thr) ) then
     !
     write(6,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(6,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst1__i4_i3d)
  deallocate(A_hst2__i4_i3d)
  deallocate(A_hst3__i4_i3d)
  !
  call devxlib_unmap(A_dev1__i4_i3d, ierr)
  call devxlib_unmap(A_dev2__i4_i3d, ierr)
  deallocate(A_dev1__i4_i3d)
  deallocate(A_dev2__i4_i3d)
  !
  is_mapped = devxlib_mapped( A_dev1__i4_i3d ) .or. &
              devxlib_mapped( A_dev2__i4_i3d )
  if (is_mapped) then
    nfail_mapping=nfail_mapping+1
    lfail_mapping=.true.
    write(6,"(3x,a)") "mem mapping check-post2 FAILED" 
  endif
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(6,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !

  !
  !=====================
  write(6,"(/,3x,a)") "checking i4_i4d ..." 
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  lfail_mapping=.false.
  !
  is_mapped = devxlib_mapped( A_dev1__i4_i4d ) .or. &
              devxlib_mapped( A_dev2__i4_i4d )
  if (is_mapped) then
     nfail_mapping=nfail_mapping+1
     lfail_mapping=.true.
     write(6,"(3x,a)") "mem mapping check-pre FAILED" 
  endif
  !
  ! allocations
  allocate( A_hst1__i4_i4d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6),bounds(7):bounds(8)) )
  allocate( A_hst2__i4_i4d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6),bounds(7):bounds(8)) )
  allocate( A_hst3__i4_i4d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6),bounds(7):bounds(8)) )
  allocate( A_dev1__i4_i4d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6),bounds(7):bounds(8)) )
  allocate( A_dev2__i4_i4d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6),bounds(7):bounds(8)) )
  call devxlib_map(A_dev1__i4_i4d)
  call devxlib_map(A_dev2__i4_i4d)
  allocate( A_rtmp__i4_4d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6),bounds(7):bounds(8)) )
  
  !
  is_mapped = devxlib_mapped( A_dev1__i4_i4d )
  if (.not.is_mapped) then
    nfail_mapping=nfail_mapping+1
    lfail_mapping=.true.
    write(6,"(3x,a)") "mem mapping check-post FAILED" 
  endif
  !
  ! init
  call random_number( A_rtmp__i4_4d )
  A_hst1__i4_i4d=int( 1000*A_rtmp__i4_4d )
  
  !
  ! mem copy h2d
  call devxlib_memcpy_h2d(A_dev1__i4_i4d, A_hst1__i4_i4d)
  !
  ! mem copy
  call devxlib_memcpy_d2d(A_dev2__i4_i4d, A_dev1__i4_i4d )
  !
  !
  ! mem copy d2h
  call devxlib_memcpy_d2h(A_hst2__i4_i4d, A_dev2__i4_i4d)
  !
  !
  ! mem copy h2h
  call devxlib_memcpy_h2h(A_hst3__i4_i4d, A_hst2__i4_i4d)
  !
  ! check
  if (lfail_mapping) write(6,"(3x,a)") "Mapping FAILED" 
  !
  if ( any(abs(A_hst3__i4_i4d -A_hst1__i4_i4d )> thr) ) then
     !
     write(6,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(6,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst1__i4_i4d)
  deallocate(A_hst2__i4_i4d)
  deallocate(A_hst3__i4_i4d)
  !
  call devxlib_unmap(A_dev1__i4_i4d, ierr)
  call devxlib_unmap(A_dev2__i4_i4d, ierr)
  deallocate(A_dev1__i4_i4d)
  deallocate(A_dev2__i4_i4d)
  !
  is_mapped = devxlib_mapped( A_dev1__i4_i4d ) .or. &
              devxlib_mapped( A_dev2__i4_i4d )
  if (is_mapped) then
    nfail_mapping=nfail_mapping+1
    lfail_mapping=.true.
    write(6,"(3x,a)") "mem mapping check-post2 FAILED" 
  endif
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(6,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !


  !
  !=====================
  write(6,"(/,3x,a)") "checking i8_i1d ..." 
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  lfail_mapping=.false.
  !
  is_mapped = devxlib_mapped( A_dev1__i8_i1d ) .or. &
              devxlib_mapped( A_dev2__i8_i1d )
  if (is_mapped) then
     nfail_mapping=nfail_mapping+1
     lfail_mapping=.true.
     write(6,"(3x,a)") "mem mapping check-pre FAILED" 
  endif
  !
  ! allocations
  allocate( A_hst1__i8_i1d(bounds(1):bounds(2)) )
  allocate( A_hst2__i8_i1d(bounds(1):bounds(2)) )
  allocate( A_hst3__i8_i1d(bounds(1):bounds(2)) )
  allocate( A_dev1__i8_i1d(bounds(1):bounds(2)) )
  allocate( A_dev2__i8_i1d(bounds(1):bounds(2)) )
  call devxlib_map(A_dev1__i8_i1d)
  call devxlib_map(A_dev2__i8_i1d)
  allocate( A_rtmp__i8_1d(bounds(1):bounds(2)) )
  
  !
  is_mapped = devxlib_mapped( A_dev1__i8_i1d )
  if (.not.is_mapped) then
    nfail_mapping=nfail_mapping+1
    lfail_mapping=.true.
    write(6,"(3x,a)") "mem mapping check-post FAILED" 
  endif
  !
  ! init
  call random_number( A_rtmp__i8_1d )
  A_hst1__i8_i1d=int( 1000*A_rtmp__i8_1d )
  
  !
  ! mem copy h2d
  call devxlib_memcpy_h2d(A_dev1__i8_i1d, A_hst1__i8_i1d)
  !
  ! mem copy
  call devxlib_memcpy_d2d(A_dev2__i8_i1d, A_dev1__i8_i1d )
  !
  !
  ! mem copy d2h
  call devxlib_memcpy_d2h(A_hst2__i8_i1d, A_dev2__i8_i1d)
  !
  !
  ! mem copy h2h
  call devxlib_memcpy_h2h(A_hst3__i8_i1d, A_hst2__i8_i1d)
  !
  ! check
  if (lfail_mapping) write(6,"(3x,a)") "Mapping FAILED" 
  !
  if ( any(abs(A_hst3__i8_i1d -A_hst1__i8_i1d )> thr) ) then
     !
     write(6,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(6,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst1__i8_i1d)
  deallocate(A_hst2__i8_i1d)
  deallocate(A_hst3__i8_i1d)
  !
  call devxlib_unmap(A_dev1__i8_i1d, ierr)
  call devxlib_unmap(A_dev2__i8_i1d, ierr)
  deallocate(A_dev1__i8_i1d)
  deallocate(A_dev2__i8_i1d)
  !
  is_mapped = devxlib_mapped( A_dev1__i8_i1d ) .or. &
              devxlib_mapped( A_dev2__i8_i1d )
  if (is_mapped) then
    nfail_mapping=nfail_mapping+1
    lfail_mapping=.true.
    write(6,"(3x,a)") "mem mapping check-post2 FAILED" 
  endif
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(6,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !

  !
  !=====================
  write(6,"(/,3x,a)") "checking i8_i2d ..." 
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  lfail_mapping=.false.
  !
  is_mapped = devxlib_mapped( A_dev1__i8_i2d ) .or. &
              devxlib_mapped( A_dev2__i8_i2d )
  if (is_mapped) then
     nfail_mapping=nfail_mapping+1
     lfail_mapping=.true.
     write(6,"(3x,a)") "mem mapping check-pre FAILED" 
  endif
  !
  ! allocations
  allocate( A_hst1__i8_i2d(bounds(1):bounds(2),bounds(3):bounds(4)) )
  allocate( A_hst2__i8_i2d(bounds(1):bounds(2),bounds(3):bounds(4)) )
  allocate( A_hst3__i8_i2d(bounds(1):bounds(2),bounds(3):bounds(4)) )
  allocate( A_dev1__i8_i2d(bounds(1):bounds(2),bounds(3):bounds(4)) )
  allocate( A_dev2__i8_i2d(bounds(1):bounds(2),bounds(3):bounds(4)) )
  call devxlib_map(A_dev1__i8_i2d)
  call devxlib_map(A_dev2__i8_i2d)
  allocate( A_rtmp__i8_2d(bounds(1):bounds(2),bounds(3):bounds(4)) )
  
  !
  is_mapped = devxlib_mapped( A_dev1__i8_i2d )
  if (.not.is_mapped) then
    nfail_mapping=nfail_mapping+1
    lfail_mapping=.true.
    write(6,"(3x,a)") "mem mapping check-post FAILED" 
  endif
  !
  ! init
  call random_number( A_rtmp__i8_2d )
  A_hst1__i8_i2d=int( 1000*A_rtmp__i8_2d )
  
  !
  ! mem copy h2d
  call devxlib_memcpy_h2d(A_dev1__i8_i2d, A_hst1__i8_i2d)
  !
  ! mem copy
  call devxlib_memcpy_d2d(A_dev2__i8_i2d, A_dev1__i8_i2d )
  !
  !
  ! mem copy d2h
  call devxlib_memcpy_d2h(A_hst2__i8_i2d, A_dev2__i8_i2d)
  !
  !
  ! mem copy h2h
  call devxlib_memcpy_h2h(A_hst3__i8_i2d, A_hst2__i8_i2d)
  !
  ! check
  if (lfail_mapping) write(6,"(3x,a)") "Mapping FAILED" 
  !
  if ( any(abs(A_hst3__i8_i2d -A_hst1__i8_i2d )> thr) ) then
     !
     write(6,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(6,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst1__i8_i2d)
  deallocate(A_hst2__i8_i2d)
  deallocate(A_hst3__i8_i2d)
  !
  call devxlib_unmap(A_dev1__i8_i2d, ierr)
  call devxlib_unmap(A_dev2__i8_i2d, ierr)
  deallocate(A_dev1__i8_i2d)
  deallocate(A_dev2__i8_i2d)
  !
  is_mapped = devxlib_mapped( A_dev1__i8_i2d ) .or. &
              devxlib_mapped( A_dev2__i8_i2d )
  if (is_mapped) then
    nfail_mapping=nfail_mapping+1
    lfail_mapping=.true.
    write(6,"(3x,a)") "mem mapping check-post2 FAILED" 
  endif
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(6,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !

  !
  !=====================
  write(6,"(/,3x,a)") "checking i8_i3d ..." 
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  lfail_mapping=.false.
  !
  is_mapped = devxlib_mapped( A_dev1__i8_i3d ) .or. &
              devxlib_mapped( A_dev2__i8_i3d )
  if (is_mapped) then
     nfail_mapping=nfail_mapping+1
     lfail_mapping=.true.
     write(6,"(3x,a)") "mem mapping check-pre FAILED" 
  endif
  !
  ! allocations
  allocate( A_hst1__i8_i3d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6)) )
  allocate( A_hst2__i8_i3d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6)) )
  allocate( A_hst3__i8_i3d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6)) )
  allocate( A_dev1__i8_i3d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6)) )
  allocate( A_dev2__i8_i3d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6)) )
  call devxlib_map(A_dev1__i8_i3d)
  call devxlib_map(A_dev2__i8_i3d)
  allocate( A_rtmp__i8_3d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6)) )
  
  !
  is_mapped = devxlib_mapped( A_dev1__i8_i3d )
  if (.not.is_mapped) then
    nfail_mapping=nfail_mapping+1
    lfail_mapping=.true.
    write(6,"(3x,a)") "mem mapping check-post FAILED" 
  endif
  !
  ! init
  call random_number( A_rtmp__i8_3d )
  A_hst1__i8_i3d=int( 1000*A_rtmp__i8_3d )
  
  !
  ! mem copy h2d
  call devxlib_memcpy_h2d(A_dev1__i8_i3d, A_hst1__i8_i3d)
  !
  ! mem copy
  call devxlib_memcpy_d2d(A_dev2__i8_i3d, A_dev1__i8_i3d )
  !
  !
  ! mem copy d2h
  call devxlib_memcpy_d2h(A_hst2__i8_i3d, A_dev2__i8_i3d)
  !
  !
  ! mem copy h2h
  call devxlib_memcpy_h2h(A_hst3__i8_i3d, A_hst2__i8_i3d)
  !
  ! check
  if (lfail_mapping) write(6,"(3x,a)") "Mapping FAILED" 
  !
  if ( any(abs(A_hst3__i8_i3d -A_hst1__i8_i3d )> thr) ) then
     !
     write(6,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(6,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst1__i8_i3d)
  deallocate(A_hst2__i8_i3d)
  deallocate(A_hst3__i8_i3d)
  !
  call devxlib_unmap(A_dev1__i8_i3d, ierr)
  call devxlib_unmap(A_dev2__i8_i3d, ierr)
  deallocate(A_dev1__i8_i3d)
  deallocate(A_dev2__i8_i3d)
  !
  is_mapped = devxlib_mapped( A_dev1__i8_i3d ) .or. &
              devxlib_mapped( A_dev2__i8_i3d )
  if (is_mapped) then
    nfail_mapping=nfail_mapping+1
    lfail_mapping=.true.
    write(6,"(3x,a)") "mem mapping check-post2 FAILED" 
  endif
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(6,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !

  !
  !=====================
  write(6,"(/,3x,a)") "checking i8_i4d ..." 
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  lfail_mapping=.false.
  !
  is_mapped = devxlib_mapped( A_dev1__i8_i4d ) .or. &
              devxlib_mapped( A_dev2__i8_i4d )
  if (is_mapped) then
     nfail_mapping=nfail_mapping+1
     lfail_mapping=.true.
     write(6,"(3x,a)") "mem mapping check-pre FAILED" 
  endif
  !
  ! allocations
  allocate( A_hst1__i8_i4d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6),bounds(7):bounds(8)) )
  allocate( A_hst2__i8_i4d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6),bounds(7):bounds(8)) )
  allocate( A_hst3__i8_i4d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6),bounds(7):bounds(8)) )
  allocate( A_dev1__i8_i4d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6),bounds(7):bounds(8)) )
  allocate( A_dev2__i8_i4d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6),bounds(7):bounds(8)) )
  call devxlib_map(A_dev1__i8_i4d)
  call devxlib_map(A_dev2__i8_i4d)
  allocate( A_rtmp__i8_4d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6),bounds(7):bounds(8)) )
  
  !
  is_mapped = devxlib_mapped( A_dev1__i8_i4d )
  if (.not.is_mapped) then
    nfail_mapping=nfail_mapping+1
    lfail_mapping=.true.
    write(6,"(3x,a)") "mem mapping check-post FAILED" 
  endif
  !
  ! init
  call random_number( A_rtmp__i8_4d )
  A_hst1__i8_i4d=int( 1000*A_rtmp__i8_4d )
  
  !
  ! mem copy h2d
  call devxlib_memcpy_h2d(A_dev1__i8_i4d, A_hst1__i8_i4d)
  !
  ! mem copy
  call devxlib_memcpy_d2d(A_dev2__i8_i4d, A_dev1__i8_i4d )
  !
  !
  ! mem copy d2h
  call devxlib_memcpy_d2h(A_hst2__i8_i4d, A_dev2__i8_i4d)
  !
  !
  ! mem copy h2h
  call devxlib_memcpy_h2h(A_hst3__i8_i4d, A_hst2__i8_i4d)
  !
  ! check
  if (lfail_mapping) write(6,"(3x,a)") "Mapping FAILED" 
  !
  if ( any(abs(A_hst3__i8_i4d -A_hst1__i8_i4d )> thr) ) then
     !
     write(6,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(6,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst1__i8_i4d)
  deallocate(A_hst2__i8_i4d)
  deallocate(A_hst3__i8_i4d)
  !
  call devxlib_unmap(A_dev1__i8_i4d, ierr)
  call devxlib_unmap(A_dev2__i8_i4d, ierr)
  deallocate(A_dev1__i8_i4d)
  deallocate(A_dev2__i8_i4d)
  !
  is_mapped = devxlib_mapped( A_dev1__i8_i4d ) .or. &
              devxlib_mapped( A_dev2__i8_i4d )
  if (is_mapped) then
    nfail_mapping=nfail_mapping+1
    lfail_mapping=.true.
    write(6,"(3x,a)") "mem mapping check-post2 FAILED" 
  endif
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(6,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !



  !
  !=====================
  write(6,"(/,3x,a)") "checking l4_l1d ..." 
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  lfail_mapping=.false.
  !
  is_mapped = devxlib_mapped( A_dev1__l4_l1d ) .or. &
              devxlib_mapped( A_dev2__l4_l1d )
  if (is_mapped) then
     nfail_mapping=nfail_mapping+1
     lfail_mapping=.true.
     write(6,"(3x,a)") "mem mapping check-pre FAILED" 
  endif
  !
  ! allocations
  allocate( A_hst1__l4_l1d(bounds(1):bounds(2)) )
  allocate( A_hst2__l4_l1d(bounds(1):bounds(2)) )
  allocate( A_hst3__l4_l1d(bounds(1):bounds(2)) )
  allocate( A_dev1__l4_l1d(bounds(1):bounds(2)) )
  allocate( A_dev2__l4_l1d(bounds(1):bounds(2)) )
  call devxlib_map(A_dev1__l4_l1d)
  call devxlib_map(A_dev2__l4_l1d)
  allocate( A_rtmp__l4_1d(bounds(1):bounds(2)) )
  
  !
  is_mapped = devxlib_mapped( A_dev1__l4_l1d )
  if (.not.is_mapped) then
    nfail_mapping=nfail_mapping+1
    lfail_mapping=.true.
    write(6,"(3x,a)") "mem mapping check-post FAILED" 
  endif
  !
  ! init
  call random_number( A_rtmp__l4_1d )
  A_hst1__l4_l1d=( nint( A_rtmp__l4_1d ) == 1 )
  
  !
  ! mem copy h2d
  call devxlib_memcpy_h2d(A_dev1__l4_l1d, A_hst1__l4_l1d)
  !
  ! mem copy
  call devxlib_memcpy_d2d(A_dev2__l4_l1d, A_dev1__l4_l1d )
  !
  !
  ! mem copy d2h
  call devxlib_memcpy_d2h(A_hst2__l4_l1d, A_dev2__l4_l1d)
  !
  !
  ! mem copy h2h
  call devxlib_memcpy_h2h(A_hst3__l4_l1d, A_hst2__l4_l1d)
  !
  ! check
  if (lfail_mapping) write(6,"(3x,a)") "Mapping FAILED" 
  !
  if ( any( A_hst3__l4_l1d .neqv. A_hst1__l4_l1d ) ) then
     !
     write(6,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(6,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst1__l4_l1d)
  deallocate(A_hst2__l4_l1d)
  deallocate(A_hst3__l4_l1d)
  !
  call devxlib_unmap(A_dev1__l4_l1d, ierr)
  call devxlib_unmap(A_dev2__l4_l1d, ierr)
  deallocate(A_dev1__l4_l1d)
  deallocate(A_dev2__l4_l1d)
  !
  is_mapped = devxlib_mapped( A_dev1__l4_l1d ) .or. &
              devxlib_mapped( A_dev2__l4_l1d )
  if (is_mapped) then
    nfail_mapping=nfail_mapping+1
    lfail_mapping=.true.
    write(6,"(3x,a)") "mem mapping check-post2 FAILED" 
  endif
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(6,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !

  !
  !=====================
  write(6,"(/,3x,a)") "checking l4_l2d ..." 
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  lfail_mapping=.false.
  !
  is_mapped = devxlib_mapped( A_dev1__l4_l2d ) .or. &
              devxlib_mapped( A_dev2__l4_l2d )
  if (is_mapped) then
     nfail_mapping=nfail_mapping+1
     lfail_mapping=.true.
     write(6,"(3x,a)") "mem mapping check-pre FAILED" 
  endif
  !
  ! allocations
  allocate( A_hst1__l4_l2d(bounds(1):bounds(2),bounds(3):bounds(4)) )
  allocate( A_hst2__l4_l2d(bounds(1):bounds(2),bounds(3):bounds(4)) )
  allocate( A_hst3__l4_l2d(bounds(1):bounds(2),bounds(3):bounds(4)) )
  allocate( A_dev1__l4_l2d(bounds(1):bounds(2),bounds(3):bounds(4)) )
  allocate( A_dev2__l4_l2d(bounds(1):bounds(2),bounds(3):bounds(4)) )
  call devxlib_map(A_dev1__l4_l2d)
  call devxlib_map(A_dev2__l4_l2d)
  allocate( A_rtmp__l4_2d(bounds(1):bounds(2),bounds(3):bounds(4)) )
  
  !
  is_mapped = devxlib_mapped( A_dev1__l4_l2d )
  if (.not.is_mapped) then
    nfail_mapping=nfail_mapping+1
    lfail_mapping=.true.
    write(6,"(3x,a)") "mem mapping check-post FAILED" 
  endif
  !
  ! init
  call random_number( A_rtmp__l4_2d )
  A_hst1__l4_l2d=( nint( A_rtmp__l4_2d ) == 1 )
  
  !
  ! mem copy h2d
  call devxlib_memcpy_h2d(A_dev1__l4_l2d, A_hst1__l4_l2d)
  !
  ! mem copy
  call devxlib_memcpy_d2d(A_dev2__l4_l2d, A_dev1__l4_l2d )
  !
  !
  ! mem copy d2h
  call devxlib_memcpy_d2h(A_hst2__l4_l2d, A_dev2__l4_l2d)
  !
  !
  ! mem copy h2h
  call devxlib_memcpy_h2h(A_hst3__l4_l2d, A_hst2__l4_l2d)
  !
  ! check
  if (lfail_mapping) write(6,"(3x,a)") "Mapping FAILED" 
  !
  if ( any( A_hst3__l4_l2d .neqv. A_hst1__l4_l2d ) ) then
     !
     write(6,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(6,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst1__l4_l2d)
  deallocate(A_hst2__l4_l2d)
  deallocate(A_hst3__l4_l2d)
  !
  call devxlib_unmap(A_dev1__l4_l2d, ierr)
  call devxlib_unmap(A_dev2__l4_l2d, ierr)
  deallocate(A_dev1__l4_l2d)
  deallocate(A_dev2__l4_l2d)
  !
  is_mapped = devxlib_mapped( A_dev1__l4_l2d ) .or. &
              devxlib_mapped( A_dev2__l4_l2d )
  if (is_mapped) then
    nfail_mapping=nfail_mapping+1
    lfail_mapping=.true.
    write(6,"(3x,a)") "mem mapping check-post2 FAILED" 
  endif
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(6,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !

  !
  !=====================
  write(6,"(/,3x,a)") "checking l4_l3d ..." 
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  lfail_mapping=.false.
  !
  is_mapped = devxlib_mapped( A_dev1__l4_l3d ) .or. &
              devxlib_mapped( A_dev2__l4_l3d )
  if (is_mapped) then
     nfail_mapping=nfail_mapping+1
     lfail_mapping=.true.
     write(6,"(3x,a)") "mem mapping check-pre FAILED" 
  endif
  !
  ! allocations
  allocate( A_hst1__l4_l3d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6)) )
  allocate( A_hst2__l4_l3d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6)) )
  allocate( A_hst3__l4_l3d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6)) )
  allocate( A_dev1__l4_l3d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6)) )
  allocate( A_dev2__l4_l3d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6)) )
  call devxlib_map(A_dev1__l4_l3d)
  call devxlib_map(A_dev2__l4_l3d)
  allocate( A_rtmp__l4_3d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6)) )
  
  !
  is_mapped = devxlib_mapped( A_dev1__l4_l3d )
  if (.not.is_mapped) then
    nfail_mapping=nfail_mapping+1
    lfail_mapping=.true.
    write(6,"(3x,a)") "mem mapping check-post FAILED" 
  endif
  !
  ! init
  call random_number( A_rtmp__l4_3d )
  A_hst1__l4_l3d=( nint( A_rtmp__l4_3d ) == 1 )
  
  !
  ! mem copy h2d
  call devxlib_memcpy_h2d(A_dev1__l4_l3d, A_hst1__l4_l3d)
  !
  ! mem copy
  call devxlib_memcpy_d2d(A_dev2__l4_l3d, A_dev1__l4_l3d )
  !
  !
  ! mem copy d2h
  call devxlib_memcpy_d2h(A_hst2__l4_l3d, A_dev2__l4_l3d)
  !
  !
  ! mem copy h2h
  call devxlib_memcpy_h2h(A_hst3__l4_l3d, A_hst2__l4_l3d)
  !
  ! check
  if (lfail_mapping) write(6,"(3x,a)") "Mapping FAILED" 
  !
  if ( any( A_hst3__l4_l3d .neqv. A_hst1__l4_l3d ) ) then
     !
     write(6,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(6,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst1__l4_l3d)
  deallocate(A_hst2__l4_l3d)
  deallocate(A_hst3__l4_l3d)
  !
  call devxlib_unmap(A_dev1__l4_l3d, ierr)
  call devxlib_unmap(A_dev2__l4_l3d, ierr)
  deallocate(A_dev1__l4_l3d)
  deallocate(A_dev2__l4_l3d)
  !
  is_mapped = devxlib_mapped( A_dev1__l4_l3d ) .or. &
              devxlib_mapped( A_dev2__l4_l3d )
  if (is_mapped) then
    nfail_mapping=nfail_mapping+1
    lfail_mapping=.true.
    write(6,"(3x,a)") "mem mapping check-post2 FAILED" 
  endif
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(6,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !

  !
  !=====================
  write(6,"(/,3x,a)") "checking l4_l4d ..." 
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  lfail_mapping=.false.
  !
  is_mapped = devxlib_mapped( A_dev1__l4_l4d ) .or. &
              devxlib_mapped( A_dev2__l4_l4d )
  if (is_mapped) then
     nfail_mapping=nfail_mapping+1
     lfail_mapping=.true.
     write(6,"(3x,a)") "mem mapping check-pre FAILED" 
  endif
  !
  ! allocations
  allocate( A_hst1__l4_l4d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6),bounds(7):bounds(8)) )
  allocate( A_hst2__l4_l4d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6),bounds(7):bounds(8)) )
  allocate( A_hst3__l4_l4d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6),bounds(7):bounds(8)) )
  allocate( A_dev1__l4_l4d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6),bounds(7):bounds(8)) )
  allocate( A_dev2__l4_l4d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6),bounds(7):bounds(8)) )
  call devxlib_map(A_dev1__l4_l4d)
  call devxlib_map(A_dev2__l4_l4d)
  allocate( A_rtmp__l4_4d(bounds(1):bounds(2),bounds(3):bounds(4),bounds(5):bounds(6),bounds(7):bounds(8)) )
  
  !
  is_mapped = devxlib_mapped( A_dev1__l4_l4d )
  if (.not.is_mapped) then
    nfail_mapping=nfail_mapping+1
    lfail_mapping=.true.
    write(6,"(3x,a)") "mem mapping check-post FAILED" 
  endif
  !
  ! init
  call random_number( A_rtmp__l4_4d )
  A_hst1__l4_l4d=( nint( A_rtmp__l4_4d ) == 1 )
  
  !
  ! mem copy h2d
  call devxlib_memcpy_h2d(A_dev1__l4_l4d, A_hst1__l4_l4d)
  !
  ! mem copy
  call devxlib_memcpy_d2d(A_dev2__l4_l4d, A_dev1__l4_l4d )
  !
  !
  ! mem copy d2h
  call devxlib_memcpy_d2h(A_hst2__l4_l4d, A_dev2__l4_l4d)
  !
  !
  ! mem copy h2h
  call devxlib_memcpy_h2h(A_hst3__l4_l4d, A_hst2__l4_l4d)
  !
  ! check
  if (lfail_mapping) write(6,"(3x,a)") "Mapping FAILED" 
  !
  if ( any( A_hst3__l4_l4d .neqv. A_hst1__l4_l4d ) ) then
     !
     write(6,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(6,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst1__l4_l4d)
  deallocate(A_hst2__l4_l4d)
  deallocate(A_hst3__l4_l4d)
  !
  call devxlib_unmap(A_dev1__l4_l4d, ierr)
  call devxlib_unmap(A_dev2__l4_l4d, ierr)
  deallocate(A_dev1__l4_l4d)
  deallocate(A_dev2__l4_l4d)
  !
  is_mapped = devxlib_mapped( A_dev1__l4_l4d ) .or. &
              devxlib_mapped( A_dev2__l4_l4d )
  if (is_mapped) then
    nfail_mapping=nfail_mapping+1
    lfail_mapping=.true.
    write(6,"(3x,a)") "mem mapping check-post2 FAILED" 
  endif
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(6,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !




  !
  ! summary
  !
  write(6,"(/,a)") "# Test SUMMARY:"
  write(6,"(3x,a,i5)") "# passed: ", npass
  write(6,"(3x,a,i5)") "# failed: ", nfail
  write(6,"(3x,a,i5)") "# failed mapping ", nfail_mapping
  write(6,"()")

end program test_mapping

!
! Copyright (C) 2021, MaX CoE
! Distributed under the MIT License
! (license terms are at http://opensource.org/licenses/MIT).
!
!--
!
! Wrappers for selected Linear Algebra subroutines
!
#include<devxlib_defs.h>
#include<devxlib_macros.h>
!
#ifdef __DXL_HAVE_DEVICE
  !
  ! checks
  !
#if ! defined __DXL_CUBLAS && ! defined __DXL_ROCBLAS && ! defined __DXL_MKL_GPU
# error
#endif
#endif

module devxlib_linalg

   use iso_c_binding,       only : c_loc, c_char
   use iso_fortran_env,     only : real32, real64
   use devxlib_environment, only : devxlib_error
   !
#if !defined __DXL_MKL_GPU
   use blas95_m
#endif
#if defined __DXL_OPENACC
   use devxlib_environment, only : cudaStreamSynchronize
   use openacc
#endif
#if !defined __DXL_MKL_GPU && !defined __DXL_ROCBLAS
   use devxlib_cublas
#elif defined __DXL_MKL_GPU
   use devxlib_mklgpu
#elif defined __DXL_ROCBLAS
   use devxlib_rocblas
#endif

   implicit none

   logical :: dev_linalg_init=.false.
   logical :: dev_linalg_close=.false.

   !
   ! HOST interfaces
   !
   interface devxlib_xDOT
     procedure :: SDOT, DDOT
   end interface devxlib_xDOT

   interface devxlib_xDOTU
     procedure :: SDOT, DDOT, CDOTU, ZDOTU
   end interface devxlib_xDOTU

   interface devxlib_xDOTC
     procedure :: SDOT, DDOT, CDOTC, ZDOTC
   end interface devxlib_xDOTC

   interface devxlib_xAXPY
     procedure :: SAXPY, DAXPY, CAXPY, ZAXPY
   end interface devxlib_xAXPY

   interface devxlib_xGEMV
     procedure :: SGEMV, DGEMV, CGEMV, ZGEMV
   end interface devxlib_xGEMV

   interface devxlib_xGEMM
     procedure :: SGEMM, DGEMM, CGEMM, ZGEMM
   end interface devxlib_xGEMM
   !
   interface devxlib_xAXPY_gpu
      module procedure &
         dev_SAXPY_gpu, dev_DAXPY_gpu, dev_CAXPY_gpu, dev_ZAXPY_gpu
   endinterface devxlib_xAXPY_gpu

   interface devxlib_xDOT_gpu
      module procedure &
         dev_SDOT_gpu, dev_DDOT_gpu
   endinterface devxlib_xDOT_gpu

   interface devxlib_xDOTU_gpu
      module procedure &
         dev_SDOT_gpu, dev_DDOT_gpu, dev_CDOTU_gpu, dev_ZDOTU_gpu
   endinterface devxlib_xDOTU_gpu

   interface devxlib_xDOTC_gpu
      module procedure &
         dev_SDOT_gpu, dev_DDOT_gpu, dev_CDOTC_gpu, dev_ZDOTC_gpu
   endinterface devxlib_xDOTC_gpu

   interface devxlib_xGEMV_gpu
      module procedure &
         dev_SGEMV_gpu, dev_DGEMV_gpu, dev_CGEMV_gpu, dev_ZGEMV_gpu
   endinterface devxlib_xGEMV_gpu

   interface devxlib_xGEMM_gpu
      module procedure &
         dev_SGEMM_gpu, dev_DGEMM_gpu, dev_CGEMM_gpu, dev_ZGEMM_gpu
   endinterface devxlib_xGEMM_gpu

   interface
      module subroutine dev_SAXPY_gpu(N,SA,SX,INCX,SY,INCY)
         implicit none
         integer,      intent(in) :: N
         integer,      intent(in) :: INCX,INCY
         real(real32), intent(in) TAR_ATTR  :: SA
         real(real32), intent(in) TAR_ATTR  DEV_ATTR :: SX(:)
         real(real32)             TAR_ATTR  DEV_ATTR :: SY(:)
      end subroutine dev_SAXPY_gpu
      !
      module subroutine dev_DAXPY_gpu(N,DA,DX,INCX,DY,INCY)
         implicit none
         integer,      intent(in) :: N
         integer,      intent(in) :: INCX,INCY
         real(real64), intent(in) TAR_ATTR :: DA
         real(real64), intent(in) TAR_ATTR DEV_ATTR :: DX(:)
         real(real64)             TAR_ATTR DEV_ATTR :: DY(:)
      end subroutine dev_DAXPY_gpu
      !
      module subroutine dev_CAXPY_gpu(N,CA,CX,INCX,CY,INCY)
         implicit none
         integer,         intent(in) :: N
         integer,         intent(in) :: INCX,INCY
         complex(real32), intent(in) TAR_ATTR :: CA
         complex(real32), intent(in) TAR_ATTR DEV_ATTR :: CX(:)
         complex(real32)             TAR_ATTR DEV_ATTR :: CY(:)
      end subroutine dev_CAXPY_gpu
      !
      module subroutine dev_ZAXPY_gpu(N,CA,CX,INCX,CY,INCY)
         implicit none
         integer,         intent(in) :: N
         integer,         intent(in) :: INCX,INCY
         complex(real64), intent(in) TAR_ATTR :: CA
         complex(real64), intent(in) TAR_ATTR DEV_ATTR :: CX(:)
         complex(real64)             TAR_ATTR DEV_ATTR :: CY(:)
      end subroutine dev_ZAXPY_gpu
   endinterface

   interface
      module function dev_SDOT_gpu(N,X,INCX,Y,INCY) result(res)
         implicit none
         real(real32) TAR_ATTR :: res
         integer,      intent(in) :: N
         integer,      intent(in) :: INCX,INCY
         real(real32), intent(in) TAR_ATTR DEV_ATTR :: X(:)
         real(real32)             TAR_ATTR DEV_ATTR :: Y(:)
      end function dev_SDOT_gpu
      !
      module function dev_DDOT_gpu(N,X,INCX,Y,INCY) result(res)
         implicit none
         real(real64) TAR_ATTR :: res
         integer,      intent(in) :: N
         integer,      intent(in) :: INCX,INCY
         real(real64), intent(in) TAR_ATTR DEV_ATTR :: X(:)
         real(real64)             TAR_ATTR DEV_ATTR :: Y(:)
      end function dev_DDOT_gpu
      !
      module function dev_CDOTU_gpu(N,X,INCX,Y,INCY) result(res)
         implicit none
         complex(real32) TAR_ATTR :: res
         integer,         intent(in) :: N
         integer,         intent(in) :: INCX,INCY
         complex(real32), intent(in) TAR_ATTR DEV_ATTR :: X(:)
         complex(real32)             TAR_ATTR DEV_ATTR :: Y(:)
      end function dev_CDOTU_gpu
      !
      module function dev_ZDOTU_gpu(N,X,INCX,Y,INCY) result(res)
         implicit none
         complex(real64) TAR_ATTR :: res
         integer,         intent(in) :: N
         integer,         intent(in) :: INCX,INCY
         complex(real64), intent(in) TAR_ATTR DEV_ATTR :: X(:)
         complex(real64)             TAR_ATTR DEV_ATTR :: Y(:)
      end function dev_ZDOTU_gpu
      !
      module function dev_CDOTC_gpu(N,X,INCX,Y,INCY) result(res)
         implicit none
         complex(real32) TAR_ATTR :: res
         integer,         intent(in) :: N
         integer,         intent(in) :: INCX,INCY
         complex(real32), intent(in) TAR_ATTR DEV_ATTR :: X(:)
         complex(real32)             TAR_ATTR DEV_ATTR :: Y(:)
      end function dev_CDOTC_gpu
      !
      module function dev_ZDOTC_gpu(N,X,INCX,Y,INCY) result(res)
         implicit none
         complex(real64) TAR_ATTR :: res
         integer,         intent(in) :: N
         integer,         intent(in) :: INCX,INCY
         complex(real64), intent(in) TAR_ATTR DEV_ATTR :: X(:)
         complex(real64)             TAR_ATTR DEV_ATTR :: Y(:)
      end function dev_ZDOTC_gpu
   endinterface

   interface
      module subroutine dev_SGEMV_gpu(TRANS,M,N,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
         implicit none
         real(real32),  intent(in) TAR_ATTR :: ALPHA,BETA
         integer,       intent(in) :: M,N,LDA,INCX,INCY
         character,     intent(in) :: TRANS
         real(real32),  intent(in) TAR_ATTR DEV_ATTR :: A(:,:),X(:)
         real(real32)              TAR_ATTR DEV_ATTR :: Y(:)
      end subroutine dev_SGEMV_gpu
      !
      module subroutine dev_DGEMV_gpu(TRANS,M,N,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
         implicit none
         real(real64),  intent(in) TAR_ATTR :: ALPHA,BETA
         integer,       intent(in) :: M,N,LDA,INCX,INCY
         character,     intent(in) :: TRANS
         real(real64),  intent(in) TAR_ATTR DEV_ATTR :: A(:,:),X(:)
         real(real64)              TAR_ATTR DEV_ATTR :: Y(:)
      end subroutine dev_DGEMV_gpu
      !
      module subroutine dev_CGEMV_gpu(TRANS,M,N,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
         implicit none
         complex(real32), intent(in) TAR_ATTR :: ALPHA,BETA
         integer,         intent(in) :: M,N,LDA,INCX,INCY
         character,       intent(in) :: TRANS
         complex(real32), intent(in) TAR_ATTR DEV_ATTR :: A(:,:),X(:)
         complex(real32)             TAR_ATTR DEV_ATTR :: Y(:)
      end subroutine dev_CGEMV_gpu
      !
      module subroutine dev_ZGEMV_gpu(TRANS,M,N,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
         implicit none
         complex(real64), intent(in) TAR_ATTR :: ALPHA,BETA
         integer,         intent(in) :: M,N,LDA,INCX,INCY
         character,       intent(in) :: TRANS
         complex(real64), intent(in) TAR_ATTR DEV_ATTR :: A(:,:),X(:)
         complex(real64)             TAR_ATTR DEV_ATTR :: Y(:)
      end subroutine dev_ZGEMV_gpu
   endinterface

   interface
      module subroutine dev_SGEMM_gpu(TRANSA,TRANSB,M,N,K,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
         implicit none
         real(real32), target, intent(in) :: ALPHA,BETA
         integer,              intent(in) :: K,LDA,LDB,LDC,M,N
         character,            intent(in) :: TRANSA,TRANSB
         real(real32), target, intent(in) DEV_ATTR :: A(:,:),B(:,:)
         real(real32), target             DEV_ATTR :: C(:,:)
      end subroutine dev_SGEMM_gpu
      !
      module subroutine dev_DGEMM_gpu(TRANSA,TRANSB,M,N,K,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
         implicit none
         real(real64), target, intent(in) :: ALPHA,BETA
         integer,              intent(in) :: K,LDA,LDB,LDC,M,N
         character,            intent(in) :: TRANSA,TRANSB
         real(real64), target, intent(in) DEV_ATTR :: A(:,:),B(:,:)
         real(real64), target             DEV_ATTR :: C(:,:)
      end subroutine dev_DGEMM_gpu
      !
      module subroutine dev_CGEMM_gpu(TRANSA,TRANSB,M,N,K,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
         implicit none
         complex(real32), target, intent(in) :: ALPHA,BETA
         integer,                 intent(in) :: K,LDA,LDB,LDC,M,N
         character,               intent(in) :: TRANSA,TRANSB
         complex(real32), target, intent(in) DEV_ATTR :: A(:,:),B(:,:)
         complex(real32), target             DEV_ATTR :: C(:,:)
      end subroutine dev_CGEMM_gpu
      !
      module subroutine dev_ZGEMM_gpu(TRANSA,TRANSB,M,N,K,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
         implicit none
         complex(real64), target, intent(in) :: ALPHA,BETA
         integer,                 intent(in) :: K,LDA,LDB,LDC,M,N
         character,               intent(in) :: TRANSA,TRANSB
         complex(real64), target, intent(in) DEV_ATTR :: A(:,:),B(:,:)
         complex(real64), target             DEV_ATTR :: C(:,:)
      end subroutine dev_ZGEMM_gpu
   endinterface

   contains
      !
      ! aux funcs
      !
      subroutine dev_linalg_setup()
         implicit none
         integer :: istat
         !
#ifdef __DXL_CUBLAS
         ! Is cublasInit needed?
         istat = cublasInit()
         if(istat/=0) call devxlib_error('dev_linalg_setup','cublasInit failed',10)
         !
         istat = cublasCreate(cublas_handle)
         if(istat/=0) call devxlib_error('dev_linalg_setup','cublasCreate failed',10)
         !
#if defined __DXL_OPENACC
         !istat = cublasSetStream(cublas_handle, acc_get_cuda_stream(acc_async_noval))
         !if(istat/=0) call devxlib_error('dev_linalg_setup','cublasSetStream failed',10)
         istat = cublasSetKernelStream(acc_get_cuda_stream(acc_async_noval))
         if(istat/=0) call devxlib_error('dev_linalg_setup','cublasSetKernelStream failed',10)
#endif
         !
         !istat = cusolverDnCreate(cusolv_h)
         !if(istat/=CUSOLVER_STATUS_SUCCESS) call error('cusolverDnCreate failed')
#endif
#ifdef __DXL_ROCBLAS
         !
         istat = rocblas_create_handle(handle)
         if(istat/=0) call devxlib_error('dev_linalg_setup','rocblas_create_handle failed',10)
         !
#endif
         !
         dev_linalg_init=.true.
         !
      end subroutine dev_linalg_setup

      subroutine dev_linalg_shutdown()
         implicit none
         integer :: istat
         !
#ifdef __DXL_CUBLAS
         !
         istat = cublasDestroy(cublas_handle)
         if(istat/=0) call devxlib_error('dev_linalg_shutdown','cublasDestroy failed',10)
#endif
#ifdef __DXL_ROCBLAS
         !
         istat = rocblas_destroy_handle(handle)
         if(istat/=0) call devxlib_error('dev_linalg_shutdown','rocblas_destroy_handle failed',10)
         !
#endif
         !
         dev_linalg_close=.true.
         !
      end subroutine dev_linalg_shutdown


      subroutine acc_loc_dev_sync()
         !
         ! AF: in ths subroutine we may want to make use of
         !     cublasSetStream when using OpenACC
         !
         implicit none
         integer :: ierr
         !
#if defined __DXL_OPENACC
         !ierr=cudaDeviceSynchronize()
         ierr=cudaStreamSynchronize(c_null_ptr)
#endif
         return
      end subroutine acc_loc_dev_sync
      !
endmodule devxlib_linalg

!
! Copyright (C) 2021, MaX CoE
! Distributed under the MIT License 
! (license terms are at http://opensource.org/licenses/MIT).
!
!--
!
!
! Utility functions to perform data initializations (on host and
! on device), using CUDA-Fortran, OpenACC and OpenMP Offload
!
!==================================================================
!==================================================================
! *DO NOT EDIT*: automatically generated from devxlib_memset.jf90
!==================================================================
!==================================================================
!
#include<devxlib_macros.h>
#include<devxlib_defs.h>
!
!=======================================
!
! Note about dimensions:
! The lower bound of the assumed shape array passed to the subroutine is 1
! lbound and range instead refer to the indexing in the parent caller.
!
module devxlib_memset

   use iso_fortran_env,     only : int32, int64, real32, real64
#if defined __DXL_CUDAF
   use cudafor
#elif defined __DXL_OPENACC
   use openacc
   use devxlib_environment, only : cudaStreamSynchronize, cudaDeviceSynchronize, &
                                   acc_memcpy_device_f, acc_memcpy_from_device_f, acc_memcpy_to_device_f
#endif

   implicit none

   interface devxlib_memset_d
      module procedure &
         sp_devxlib_memset_d_r1d, sp_devxlib_memset_d_r2d, sp_devxlib_memset_d_r3d, &
         sp_devxlib_memset_d_r4d, sp_devxlib_memset_d_r5d, sp_devxlib_memset_d_r6d, &
         dp_devxlib_memset_d_r1d, dp_devxlib_memset_d_r2d, dp_devxlib_memset_d_r3d, &
         dp_devxlib_memset_d_r4d, dp_devxlib_memset_d_r5d, dp_devxlib_memset_d_r6d, &
         sp_devxlib_memset_d_c1d, sp_devxlib_memset_d_c2d, sp_devxlib_memset_d_c3d, &
         sp_devxlib_memset_d_c4d, sp_devxlib_memset_d_c5d, sp_devxlib_memset_d_c6d, &
         dp_devxlib_memset_d_c1d, dp_devxlib_memset_d_c2d, dp_devxlib_memset_d_c3d, &
         dp_devxlib_memset_d_c4d, dp_devxlib_memset_d_c5d, dp_devxlib_memset_d_c6d, &
         i4_devxlib_memset_d_i1d, i4_devxlib_memset_d_i2d, i4_devxlib_memset_d_i3d, &
         i4_devxlib_memset_d_i4d, i4_devxlib_memset_d_i5d, i4_devxlib_memset_d_i6d, &
         i8_devxlib_memset_d_i1d, i8_devxlib_memset_d_i2d, i8_devxlib_memset_d_i3d, &
         i8_devxlib_memset_d_i4d, i8_devxlib_memset_d_i5d, i8_devxlib_memset_d_i6d, &
         l4_devxlib_memset_d_l1d, l4_devxlib_memset_d_l2d, l4_devxlib_memset_d_l3d, &
         l4_devxlib_memset_d_l4d, l4_devxlib_memset_d_l5d, l4_devxlib_memset_d_l6d
   end interface devxlib_memset_d

   interface devxlib_memset_h
      module procedure &
         sp_devxlib_memset_h_r1d, sp_devxlib_memset_h_r2d, sp_devxlib_memset_h_r3d, &
         sp_devxlib_memset_h_r4d, sp_devxlib_memset_h_r5d, sp_devxlib_memset_h_r6d, &
         dp_devxlib_memset_h_r1d, dp_devxlib_memset_h_r2d, dp_devxlib_memset_h_r3d, &
         dp_devxlib_memset_h_r4d, dp_devxlib_memset_h_r5d, dp_devxlib_memset_h_r6d, &
         sp_devxlib_memset_h_c1d, sp_devxlib_memset_h_c2d, sp_devxlib_memset_h_c3d, &
         sp_devxlib_memset_h_c4d, sp_devxlib_memset_h_c5d, sp_devxlib_memset_h_c6d, &
         dp_devxlib_memset_h_c1d, dp_devxlib_memset_h_c2d, dp_devxlib_memset_h_c3d, &
         dp_devxlib_memset_h_c4d, dp_devxlib_memset_h_c5d, dp_devxlib_memset_h_c6d, &
         i4_devxlib_memset_h_i1d, i4_devxlib_memset_h_i2d, i4_devxlib_memset_h_i3d, &
         i4_devxlib_memset_h_i4d, i4_devxlib_memset_h_i5d, i4_devxlib_memset_h_i6d, &
         i8_devxlib_memset_h_i1d, i8_devxlib_memset_h_i2d, i8_devxlib_memset_h_i3d, &
         i8_devxlib_memset_h_i4d, i8_devxlib_memset_h_i5d, i8_devxlib_memset_h_i6d, &
         l4_devxlib_memset_h_l1d, l4_devxlib_memset_h_l2d, l4_devxlib_memset_h_l3d, &
         l4_devxlib_memset_h_l4d, l4_devxlib_memset_h_l5d, l4_devxlib_memset_h_l6d
   end interface devxlib_memset_h

   interface
      module subroutine sp_devxlib_memset_h_r1d(array_out, val, &
                                                  range1, lbound1 )
          implicit none
          !
          real(real32), intent(inout) :: array_out(:)
          real(real32), intent(in)    :: val
          integer, optional, intent(in) ::  range1(2)
          integer, optional, intent(in) ::  lbound1
      end subroutine sp_devxlib_memset_h_r1d
      !
      module subroutine sp_devxlib_memset_h_r2d(array_out, val, &
                                                  range1, lbound1, &
                                                  range2, lbound2 )
          implicit none
          !
          real(real32), intent(inout) :: array_out(:,:)
          real(real32), intent(in)    :: val
          integer, optional, intent(in) ::  range1(2), range2(2)
          integer, optional, intent(in) ::  lbound1, lbound2
      end subroutine sp_devxlib_memset_h_r2d
      !
      module subroutine sp_devxlib_memset_h_r3d(array_out, val, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3 )
          implicit none
          !
          real(real32), intent(inout) :: array_out(:,:,:)
          real(real32), intent(in)    :: val
          integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
          integer, optional, intent(in) ::  lbound1, lbound2, lbound3
      end subroutine sp_devxlib_memset_h_r3d
      !
      module subroutine sp_devxlib_memset_h_r4d(array_out, val, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3, &
                                                  range4, lbound4 )
          implicit none
          !
          real(real32), intent(inout) :: array_out(:,:,:,:)
          real(real32), intent(in)    :: val
          integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
          integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
      end subroutine sp_devxlib_memset_h_r4d
      !
      module subroutine sp_devxlib_memset_h_r5d(array_out, val, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3, &
                                                  range4, lbound4, &
                                                  range5, lbound5 )
          implicit none
          !
          real(real32), intent(inout) :: array_out(:,:,:,:,:)
          real(real32), intent(in)    :: val
          integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2)
          integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5
      end subroutine sp_devxlib_memset_h_r5d
      !
      module subroutine sp_devxlib_memset_h_r6d(array_out, val, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3, &
                                                  range4, lbound4, &
                                                  range5, lbound5, &
                                                  range6, lbound6 )
          implicit none
          !
          real(real32), intent(inout) :: array_out(:,:,:,:,:,:)
          real(real32), intent(in)    :: val
          integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2), range6(2)
          integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5, lbound6
      end subroutine sp_devxlib_memset_h_r6d
      !
      module subroutine dp_devxlib_memset_h_r1d(array_out, val, &
                                                  range1, lbound1 )
          implicit none
          !
          real(real64), intent(inout) :: array_out(:)
          real(real64), intent(in)    :: val
          integer, optional, intent(in) ::  range1(2)
          integer, optional, intent(in) ::  lbound1
      end subroutine dp_devxlib_memset_h_r1d
      !
      module subroutine dp_devxlib_memset_h_r2d(array_out, val, &
                                                  range1, lbound1, &
                                                  range2, lbound2 )
          implicit none
          !
          real(real64), intent(inout) :: array_out(:,:)
          real(real64), intent(in)    :: val
          integer, optional, intent(in) ::  range1(2), range2(2)
          integer, optional, intent(in) ::  lbound1, lbound2
      end subroutine dp_devxlib_memset_h_r2d
      !
      module subroutine dp_devxlib_memset_h_r3d(array_out, val, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3 )
          implicit none
          !
          real(real64), intent(inout) :: array_out(:,:,:)
          real(real64), intent(in)    :: val
          integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
          integer, optional, intent(in) ::  lbound1, lbound2, lbound3
      end subroutine dp_devxlib_memset_h_r3d
      !
      module subroutine dp_devxlib_memset_h_r4d(array_out, val, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3, &
                                                  range4, lbound4 )
          implicit none
          !
          real(real64), intent(inout) :: array_out(:,:,:,:)
          real(real64), intent(in)    :: val
          integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
          integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
      end subroutine dp_devxlib_memset_h_r4d
      !
      module subroutine dp_devxlib_memset_h_r5d(array_out, val, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3, &
                                                  range4, lbound4, &
                                                  range5, lbound5 )
          implicit none
          !
          real(real64), intent(inout) :: array_out(:,:,:,:,:)
          real(real64), intent(in)    :: val
          integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2)
          integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5
      end subroutine dp_devxlib_memset_h_r5d
      !
      module subroutine dp_devxlib_memset_h_r6d(array_out, val, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3, &
                                                  range4, lbound4, &
                                                  range5, lbound5, &
                                                  range6, lbound6 )
          implicit none
          !
          real(real64), intent(inout) :: array_out(:,:,:,:,:,:)
          real(real64), intent(in)    :: val
          integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2), range6(2)
          integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5, lbound6
      end subroutine dp_devxlib_memset_h_r6d
      !
      module subroutine sp_devxlib_memset_h_c1d(array_out, val, &
                                                  range1, lbound1 )
          implicit none
          !
          complex(real32), intent(inout) :: array_out(:)
          complex(real32), intent(in)    :: val
          integer, optional, intent(in) ::  range1(2)
          integer, optional, intent(in) ::  lbound1
      end subroutine sp_devxlib_memset_h_c1d
      !
      module subroutine sp_devxlib_memset_h_c2d(array_out, val, &
                                                  range1, lbound1, &
                                                  range2, lbound2 )
          implicit none
          !
          complex(real32), intent(inout) :: array_out(:,:)
          complex(real32), intent(in)    :: val
          integer, optional, intent(in) ::  range1(2), range2(2)
          integer, optional, intent(in) ::  lbound1, lbound2
      end subroutine sp_devxlib_memset_h_c2d
      !
      module subroutine sp_devxlib_memset_h_c3d(array_out, val, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3 )
          implicit none
          !
          complex(real32), intent(inout) :: array_out(:,:,:)
          complex(real32), intent(in)    :: val
          integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
          integer, optional, intent(in) ::  lbound1, lbound2, lbound3
      end subroutine sp_devxlib_memset_h_c3d
      !
      module subroutine sp_devxlib_memset_h_c4d(array_out, val, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3, &
                                                  range4, lbound4 )
          implicit none
          !
          complex(real32), intent(inout) :: array_out(:,:,:,:)
          complex(real32), intent(in)    :: val
          integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
          integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
      end subroutine sp_devxlib_memset_h_c4d
      !
      module subroutine sp_devxlib_memset_h_c5d(array_out, val, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3, &
                                                  range4, lbound4, &
                                                  range5, lbound5 )
          implicit none
          !
          complex(real32), intent(inout) :: array_out(:,:,:,:,:)
          complex(real32), intent(in)    :: val
          integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2)
          integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5
      end subroutine sp_devxlib_memset_h_c5d
      !
      module subroutine sp_devxlib_memset_h_c6d(array_out, val, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3, &
                                                  range4, lbound4, &
                                                  range5, lbound5, &
                                                  range6, lbound6 )
          implicit none
          !
          complex(real32), intent(inout) :: array_out(:,:,:,:,:,:)
          complex(real32), intent(in)    :: val
          integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2), range6(2)
          integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5, lbound6
      end subroutine sp_devxlib_memset_h_c6d
      !
      module subroutine dp_devxlib_memset_h_c1d(array_out, val, &
                                                  range1, lbound1 )
          implicit none
          !
          complex(real64), intent(inout) :: array_out(:)
          complex(real64), intent(in)    :: val
          integer, optional, intent(in) ::  range1(2)
          integer, optional, intent(in) ::  lbound1
      end subroutine dp_devxlib_memset_h_c1d
      !
      module subroutine dp_devxlib_memset_h_c2d(array_out, val, &
                                                  range1, lbound1, &
                                                  range2, lbound2 )
          implicit none
          !
          complex(real64), intent(inout) :: array_out(:,:)
          complex(real64), intent(in)    :: val
          integer, optional, intent(in) ::  range1(2), range2(2)
          integer, optional, intent(in) ::  lbound1, lbound2
      end subroutine dp_devxlib_memset_h_c2d
      !
      module subroutine dp_devxlib_memset_h_c3d(array_out, val, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3 )
          implicit none
          !
          complex(real64), intent(inout) :: array_out(:,:,:)
          complex(real64), intent(in)    :: val
          integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
          integer, optional, intent(in) ::  lbound1, lbound2, lbound3
      end subroutine dp_devxlib_memset_h_c3d
      !
      module subroutine dp_devxlib_memset_h_c4d(array_out, val, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3, &
                                                  range4, lbound4 )
          implicit none
          !
          complex(real64), intent(inout) :: array_out(:,:,:,:)
          complex(real64), intent(in)    :: val
          integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
          integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
      end subroutine dp_devxlib_memset_h_c4d
      !
      module subroutine dp_devxlib_memset_h_c5d(array_out, val, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3, &
                                                  range4, lbound4, &
                                                  range5, lbound5 )
          implicit none
          !
          complex(real64), intent(inout) :: array_out(:,:,:,:,:)
          complex(real64), intent(in)    :: val
          integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2)
          integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5
      end subroutine dp_devxlib_memset_h_c5d
      !
      module subroutine dp_devxlib_memset_h_c6d(array_out, val, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3, &
                                                  range4, lbound4, &
                                                  range5, lbound5, &
                                                  range6, lbound6 )
          implicit none
          !
          complex(real64), intent(inout) :: array_out(:,:,:,:,:,:)
          complex(real64), intent(in)    :: val
          integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2), range6(2)
          integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5, lbound6
      end subroutine dp_devxlib_memset_h_c6d
      !
      module subroutine i4_devxlib_memset_h_i1d(array_out, val, &
                                                  range1, lbound1 )
          implicit none
          !
          integer(int32), intent(inout) :: array_out(:)
          integer(int32), intent(in)    :: val
          integer, optional, intent(in) ::  range1(2)
          integer, optional, intent(in) ::  lbound1
      end subroutine i4_devxlib_memset_h_i1d
      !
      module subroutine i4_devxlib_memset_h_i2d(array_out, val, &
                                                  range1, lbound1, &
                                                  range2, lbound2 )
          implicit none
          !
          integer(int32), intent(inout) :: array_out(:,:)
          integer(int32), intent(in)    :: val
          integer, optional, intent(in) ::  range1(2), range2(2)
          integer, optional, intent(in) ::  lbound1, lbound2
      end subroutine i4_devxlib_memset_h_i2d
      !
      module subroutine i4_devxlib_memset_h_i3d(array_out, val, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3 )
          implicit none
          !
          integer(int32), intent(inout) :: array_out(:,:,:)
          integer(int32), intent(in)    :: val
          integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
          integer, optional, intent(in) ::  lbound1, lbound2, lbound3
      end subroutine i4_devxlib_memset_h_i3d
      !
      module subroutine i4_devxlib_memset_h_i4d(array_out, val, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3, &
                                                  range4, lbound4 )
          implicit none
          !
          integer(int32), intent(inout) :: array_out(:,:,:,:)
          integer(int32), intent(in)    :: val
          integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
          integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
      end subroutine i4_devxlib_memset_h_i4d
      !
      module subroutine i4_devxlib_memset_h_i5d(array_out, val, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3, &
                                                  range4, lbound4, &
                                                  range5, lbound5 )
          implicit none
          !
          integer(int32), intent(inout) :: array_out(:,:,:,:,:)
          integer(int32), intent(in)    :: val
          integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2)
          integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5
      end subroutine i4_devxlib_memset_h_i5d
      !
      module subroutine i4_devxlib_memset_h_i6d(array_out, val, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3, &
                                                  range4, lbound4, &
                                                  range5, lbound5, &
                                                  range6, lbound6 )
          implicit none
          !
          integer(int32), intent(inout) :: array_out(:,:,:,:,:,:)
          integer(int32), intent(in)    :: val
          integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2), range6(2)
          integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5, lbound6
      end subroutine i4_devxlib_memset_h_i6d
      !
      module subroutine i8_devxlib_memset_h_i1d(array_out, val, &
                                                  range1, lbound1 )
          implicit none
          !
          integer(int64), intent(inout) :: array_out(:)
          integer(int64), intent(in)    :: val
          integer, optional, intent(in) ::  range1(2)
          integer, optional, intent(in) ::  lbound1
      end subroutine i8_devxlib_memset_h_i1d
      !
      module subroutine i8_devxlib_memset_h_i2d(array_out, val, &
                                                  range1, lbound1, &
                                                  range2, lbound2 )
          implicit none
          !
          integer(int64), intent(inout) :: array_out(:,:)
          integer(int64), intent(in)    :: val
          integer, optional, intent(in) ::  range1(2), range2(2)
          integer, optional, intent(in) ::  lbound1, lbound2
      end subroutine i8_devxlib_memset_h_i2d
      !
      module subroutine i8_devxlib_memset_h_i3d(array_out, val, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3 )
          implicit none
          !
          integer(int64), intent(inout) :: array_out(:,:,:)
          integer(int64), intent(in)    :: val
          integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
          integer, optional, intent(in) ::  lbound1, lbound2, lbound3
      end subroutine i8_devxlib_memset_h_i3d
      !
      module subroutine i8_devxlib_memset_h_i4d(array_out, val, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3, &
                                                  range4, lbound4 )
          implicit none
          !
          integer(int64), intent(inout) :: array_out(:,:,:,:)
          integer(int64), intent(in)    :: val
          integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
          integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
      end subroutine i8_devxlib_memset_h_i4d
      !
      module subroutine i8_devxlib_memset_h_i5d(array_out, val, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3, &
                                                  range4, lbound4, &
                                                  range5, lbound5 )
          implicit none
          !
          integer(int64), intent(inout) :: array_out(:,:,:,:,:)
          integer(int64), intent(in)    :: val
          integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2)
          integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5
      end subroutine i8_devxlib_memset_h_i5d
      !
      module subroutine i8_devxlib_memset_h_i6d(array_out, val, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3, &
                                                  range4, lbound4, &
                                                  range5, lbound5, &
                                                  range6, lbound6 )
          implicit none
          !
          integer(int64), intent(inout) :: array_out(:,:,:,:,:,:)
          integer(int64), intent(in)    :: val
          integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2), range6(2)
          integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5, lbound6
      end subroutine i8_devxlib_memset_h_i6d
      !
      module subroutine l4_devxlib_memset_h_l1d(array_out, val, &
                                                  range1, lbound1 )
          implicit none
          !
          logical(int32), intent(inout) :: array_out(:)
          logical(int32), intent(in)    :: val
          integer, optional, intent(in) ::  range1(2)
          integer, optional, intent(in) ::  lbound1
      end subroutine l4_devxlib_memset_h_l1d
      !
      module subroutine l4_devxlib_memset_h_l2d(array_out, val, &
                                                  range1, lbound1, &
                                                  range2, lbound2 )
          implicit none
          !
          logical(int32), intent(inout) :: array_out(:,:)
          logical(int32), intent(in)    :: val
          integer, optional, intent(in) ::  range1(2), range2(2)
          integer, optional, intent(in) ::  lbound1, lbound2
      end subroutine l4_devxlib_memset_h_l2d
      !
      module subroutine l4_devxlib_memset_h_l3d(array_out, val, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3 )
          implicit none
          !
          logical(int32), intent(inout) :: array_out(:,:,:)
          logical(int32), intent(in)    :: val
          integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
          integer, optional, intent(in) ::  lbound1, lbound2, lbound3
      end subroutine l4_devxlib_memset_h_l3d
      !
      module subroutine l4_devxlib_memset_h_l4d(array_out, val, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3, &
                                                  range4, lbound4 )
          implicit none
          !
          logical(int32), intent(inout) :: array_out(:,:,:,:)
          logical(int32), intent(in)    :: val
          integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
          integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
      end subroutine l4_devxlib_memset_h_l4d
      !
      module subroutine l4_devxlib_memset_h_l5d(array_out, val, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3, &
                                                  range4, lbound4, &
                                                  range5, lbound5 )
          implicit none
          !
          logical(int32), intent(inout) :: array_out(:,:,:,:,:)
          logical(int32), intent(in)    :: val
          integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2)
          integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5
      end subroutine l4_devxlib_memset_h_l5d
      !
      module subroutine l4_devxlib_memset_h_l6d(array_out, val, &
                                                  range1, lbound1, &
                                                  range2, lbound2, &
                                                  range3, lbound3, &
                                                  range4, lbound4, &
                                                  range5, lbound5, &
                                                  range6, lbound6 )
          implicit none
          !
          logical(int32), intent(inout) :: array_out(:,:,:,:,:,:)
          logical(int32), intent(in)    :: val
          integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2), range6(2)
          integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5, lbound6
      end subroutine l4_devxlib_memset_h_l6d
      !
      module subroutine sp_devxlib_memset_d_r1d(array_out, val, &
                                            range1, lbound1 )
         implicit none
         !
         real(real32) DEV_ATTR, intent(inout) :: array_out(:)
         real(real32), intent(in)    :: val
         integer, optional, intent(in) ::  range1(2)
         integer, optional, intent(in) ::  lbound1
      end subroutine sp_devxlib_memset_d_r1d
      !
      module subroutine sp_devxlib_memset_d_r2d(array_out, val, &
                                            range1, lbound1, &
                                            range2, lbound2 )
         implicit none
         !
         real(real32) DEV_ATTR, intent(inout) :: array_out(:,:)
         real(real32), intent(in)    :: val
         integer, optional, intent(in) ::  range1(2), range2(2)
         integer, optional, intent(in) ::  lbound1, lbound2
      end subroutine sp_devxlib_memset_d_r2d
      !
      module subroutine sp_devxlib_memset_d_r3d(array_out, val, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3 )
         implicit none
         !
         real(real32) DEV_ATTR, intent(inout) :: array_out(:,:,:)
         real(real32), intent(in)    :: val
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3
      end subroutine sp_devxlib_memset_d_r3d
      !
      module subroutine sp_devxlib_memset_d_r4d(array_out, val, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3, &
                                            range4, lbound4 )
         implicit none
         !
         real(real32) DEV_ATTR, intent(inout) :: array_out(:,:,:,:)
         real(real32), intent(in)    :: val
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
      end subroutine sp_devxlib_memset_d_r4d
      !
      module subroutine sp_devxlib_memset_d_r5d(array_out, val, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3, &
                                            range4, lbound4, &
                                            range5, lbound5 )
         implicit none
         !
         real(real32) DEV_ATTR, intent(inout) :: array_out(:,:,:,:,:)
         real(real32), intent(in)    :: val
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5
      end subroutine sp_devxlib_memset_d_r5d
      !
      module subroutine sp_devxlib_memset_d_r6d(array_out, val, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3, &
                                            range4, lbound4, &
                                            range5, lbound5, &
                                            range6, lbound6 )
         implicit none
         !
         real(real32) DEV_ATTR, intent(inout) :: array_out(:,:,:,:,:,:)
         real(real32), intent(in)    :: val
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2), range6(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5, lbound6
      end subroutine sp_devxlib_memset_d_r6d
      !
      module subroutine dp_devxlib_memset_d_r1d(array_out, val, &
                                            range1, lbound1 )
         implicit none
         !
         real(real64) DEV_ATTR, intent(inout) :: array_out(:)
         real(real64), intent(in)    :: val
         integer, optional, intent(in) ::  range1(2)
         integer, optional, intent(in) ::  lbound1
      end subroutine dp_devxlib_memset_d_r1d
      !
      module subroutine dp_devxlib_memset_d_r2d(array_out, val, &
                                            range1, lbound1, &
                                            range2, lbound2 )
         implicit none
         !
         real(real64) DEV_ATTR, intent(inout) :: array_out(:,:)
         real(real64), intent(in)    :: val
         integer, optional, intent(in) ::  range1(2), range2(2)
         integer, optional, intent(in) ::  lbound1, lbound2
      end subroutine dp_devxlib_memset_d_r2d
      !
      module subroutine dp_devxlib_memset_d_r3d(array_out, val, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3 )
         implicit none
         !
         real(real64) DEV_ATTR, intent(inout) :: array_out(:,:,:)
         real(real64), intent(in)    :: val
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3
      end subroutine dp_devxlib_memset_d_r3d
      !
      module subroutine dp_devxlib_memset_d_r4d(array_out, val, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3, &
                                            range4, lbound4 )
         implicit none
         !
         real(real64) DEV_ATTR, intent(inout) :: array_out(:,:,:,:)
         real(real64), intent(in)    :: val
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
      end subroutine dp_devxlib_memset_d_r4d
      !
      module subroutine dp_devxlib_memset_d_r5d(array_out, val, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3, &
                                            range4, lbound4, &
                                            range5, lbound5 )
         implicit none
         !
         real(real64) DEV_ATTR, intent(inout) :: array_out(:,:,:,:,:)
         real(real64), intent(in)    :: val
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5
      end subroutine dp_devxlib_memset_d_r5d
      !
      module subroutine dp_devxlib_memset_d_r6d(array_out, val, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3, &
                                            range4, lbound4, &
                                            range5, lbound5, &
                                            range6, lbound6 )
         implicit none
         !
         real(real64) DEV_ATTR, intent(inout) :: array_out(:,:,:,:,:,:)
         real(real64), intent(in)    :: val
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2), range6(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5, lbound6
      end subroutine dp_devxlib_memset_d_r6d
      !
      module subroutine sp_devxlib_memset_d_c1d(array_out, val, &
                                            range1, lbound1 )
         implicit none
         !
         complex(real32) DEV_ATTR, intent(inout) :: array_out(:)
         complex(real32), intent(in)    :: val
         integer, optional, intent(in) ::  range1(2)
         integer, optional, intent(in) ::  lbound1
      end subroutine sp_devxlib_memset_d_c1d
      !
      module subroutine sp_devxlib_memset_d_c2d(array_out, val, &
                                            range1, lbound1, &
                                            range2, lbound2 )
         implicit none
         !
         complex(real32) DEV_ATTR, intent(inout) :: array_out(:,:)
         complex(real32), intent(in)    :: val
         integer, optional, intent(in) ::  range1(2), range2(2)
         integer, optional, intent(in) ::  lbound1, lbound2
      end subroutine sp_devxlib_memset_d_c2d
      !
      module subroutine sp_devxlib_memset_d_c3d(array_out, val, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3 )
         implicit none
         !
         complex(real32) DEV_ATTR, intent(inout) :: array_out(:,:,:)
         complex(real32), intent(in)    :: val
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3
      end subroutine sp_devxlib_memset_d_c3d
      !
      module subroutine sp_devxlib_memset_d_c4d(array_out, val, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3, &
                                            range4, lbound4 )
         implicit none
         !
         complex(real32) DEV_ATTR, intent(inout) :: array_out(:,:,:,:)
         complex(real32), intent(in)    :: val
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
      end subroutine sp_devxlib_memset_d_c4d
      !
      module subroutine sp_devxlib_memset_d_c5d(array_out, val, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3, &
                                            range4, lbound4, &
                                            range5, lbound5 )
         implicit none
         !
         complex(real32) DEV_ATTR, intent(inout) :: array_out(:,:,:,:,:)
         complex(real32), intent(in)    :: val
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5
      end subroutine sp_devxlib_memset_d_c5d
      !
      module subroutine sp_devxlib_memset_d_c6d(array_out, val, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3, &
                                            range4, lbound4, &
                                            range5, lbound5, &
                                            range6, lbound6 )
         implicit none
         !
         complex(real32) DEV_ATTR, intent(inout) :: array_out(:,:,:,:,:,:)
         complex(real32), intent(in)    :: val
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2), range6(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5, lbound6
      end subroutine sp_devxlib_memset_d_c6d
      !
      module subroutine dp_devxlib_memset_d_c1d(array_out, val, &
                                            range1, lbound1 )
         implicit none
         !
         complex(real64) DEV_ATTR, intent(inout) :: array_out(:)
         complex(real64), intent(in)    :: val
         integer, optional, intent(in) ::  range1(2)
         integer, optional, intent(in) ::  lbound1
      end subroutine dp_devxlib_memset_d_c1d
      !
      module subroutine dp_devxlib_memset_d_c2d(array_out, val, &
                                            range1, lbound1, &
                                            range2, lbound2 )
         implicit none
         !
         complex(real64) DEV_ATTR, intent(inout) :: array_out(:,:)
         complex(real64), intent(in)    :: val
         integer, optional, intent(in) ::  range1(2), range2(2)
         integer, optional, intent(in) ::  lbound1, lbound2
      end subroutine dp_devxlib_memset_d_c2d
      !
      module subroutine dp_devxlib_memset_d_c3d(array_out, val, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3 )
         implicit none
         !
         complex(real64) DEV_ATTR, intent(inout) :: array_out(:,:,:)
         complex(real64), intent(in)    :: val
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3
      end subroutine dp_devxlib_memset_d_c3d
      !
      module subroutine dp_devxlib_memset_d_c4d(array_out, val, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3, &
                                            range4, lbound4 )
         implicit none
         !
         complex(real64) DEV_ATTR, intent(inout) :: array_out(:,:,:,:)
         complex(real64), intent(in)    :: val
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
      end subroutine dp_devxlib_memset_d_c4d
      !
      module subroutine dp_devxlib_memset_d_c5d(array_out, val, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3, &
                                            range4, lbound4, &
                                            range5, lbound5 )
         implicit none
         !
         complex(real64) DEV_ATTR, intent(inout) :: array_out(:,:,:,:,:)
         complex(real64), intent(in)    :: val
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5
      end subroutine dp_devxlib_memset_d_c5d
      !
      module subroutine dp_devxlib_memset_d_c6d(array_out, val, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3, &
                                            range4, lbound4, &
                                            range5, lbound5, &
                                            range6, lbound6 )
         implicit none
         !
         complex(real64) DEV_ATTR, intent(inout) :: array_out(:,:,:,:,:,:)
         complex(real64), intent(in)    :: val
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2), range6(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5, lbound6
      end subroutine dp_devxlib_memset_d_c6d
      !
      module subroutine i4_devxlib_memset_d_i1d(array_out, val, &
                                            range1, lbound1 )
         implicit none
         !
         integer(int32) DEV_ATTR, intent(inout) :: array_out(:)
         integer(int32), intent(in)    :: val
         integer, optional, intent(in) ::  range1(2)
         integer, optional, intent(in) ::  lbound1
      end subroutine i4_devxlib_memset_d_i1d
      !
      module subroutine i4_devxlib_memset_d_i2d(array_out, val, &
                                            range1, lbound1, &
                                            range2, lbound2 )
         implicit none
         !
         integer(int32) DEV_ATTR, intent(inout) :: array_out(:,:)
         integer(int32), intent(in)    :: val
         integer, optional, intent(in) ::  range1(2), range2(2)
         integer, optional, intent(in) ::  lbound1, lbound2
      end subroutine i4_devxlib_memset_d_i2d
      !
      module subroutine i4_devxlib_memset_d_i3d(array_out, val, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3 )
         implicit none
         !
         integer(int32) DEV_ATTR, intent(inout) :: array_out(:,:,:)
         integer(int32), intent(in)    :: val
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3
      end subroutine i4_devxlib_memset_d_i3d
      !
      module subroutine i4_devxlib_memset_d_i4d(array_out, val, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3, &
                                            range4, lbound4 )
         implicit none
         !
         integer(int32) DEV_ATTR, intent(inout) :: array_out(:,:,:,:)
         integer(int32), intent(in)    :: val
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
      end subroutine i4_devxlib_memset_d_i4d
      !
      module subroutine i4_devxlib_memset_d_i5d(array_out, val, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3, &
                                            range4, lbound4, &
                                            range5, lbound5 )
         implicit none
         !
         integer(int32) DEV_ATTR, intent(inout) :: array_out(:,:,:,:,:)
         integer(int32), intent(in)    :: val
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5
      end subroutine i4_devxlib_memset_d_i5d
      !
      module subroutine i4_devxlib_memset_d_i6d(array_out, val, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3, &
                                            range4, lbound4, &
                                            range5, lbound5, &
                                            range6, lbound6 )
         implicit none
         !
         integer(int32) DEV_ATTR, intent(inout) :: array_out(:,:,:,:,:,:)
         integer(int32), intent(in)    :: val
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2), range6(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5, lbound6
      end subroutine i4_devxlib_memset_d_i6d
      !
      module subroutine i8_devxlib_memset_d_i1d(array_out, val, &
                                            range1, lbound1 )
         implicit none
         !
         integer(int64) DEV_ATTR, intent(inout) :: array_out(:)
         integer(int64), intent(in)    :: val
         integer, optional, intent(in) ::  range1(2)
         integer, optional, intent(in) ::  lbound1
      end subroutine i8_devxlib_memset_d_i1d
      !
      module subroutine i8_devxlib_memset_d_i2d(array_out, val, &
                                            range1, lbound1, &
                                            range2, lbound2 )
         implicit none
         !
         integer(int64) DEV_ATTR, intent(inout) :: array_out(:,:)
         integer(int64), intent(in)    :: val
         integer, optional, intent(in) ::  range1(2), range2(2)
         integer, optional, intent(in) ::  lbound1, lbound2
      end subroutine i8_devxlib_memset_d_i2d
      !
      module subroutine i8_devxlib_memset_d_i3d(array_out, val, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3 )
         implicit none
         !
         integer(int64) DEV_ATTR, intent(inout) :: array_out(:,:,:)
         integer(int64), intent(in)    :: val
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3
      end subroutine i8_devxlib_memset_d_i3d
      !
      module subroutine i8_devxlib_memset_d_i4d(array_out, val, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3, &
                                            range4, lbound4 )
         implicit none
         !
         integer(int64) DEV_ATTR, intent(inout) :: array_out(:,:,:,:)
         integer(int64), intent(in)    :: val
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
      end subroutine i8_devxlib_memset_d_i4d
      !
      module subroutine i8_devxlib_memset_d_i5d(array_out, val, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3, &
                                            range4, lbound4, &
                                            range5, lbound5 )
         implicit none
         !
         integer(int64) DEV_ATTR, intent(inout) :: array_out(:,:,:,:,:)
         integer(int64), intent(in)    :: val
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5
      end subroutine i8_devxlib_memset_d_i5d
      !
      module subroutine i8_devxlib_memset_d_i6d(array_out, val, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3, &
                                            range4, lbound4, &
                                            range5, lbound5, &
                                            range6, lbound6 )
         implicit none
         !
         integer(int64) DEV_ATTR, intent(inout) :: array_out(:,:,:,:,:,:)
         integer(int64), intent(in)    :: val
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2), range6(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5, lbound6
      end subroutine i8_devxlib_memset_d_i6d
      !
      module subroutine l4_devxlib_memset_d_l1d(array_out, val, &
                                            range1, lbound1 )
         implicit none
         !
         logical(int32) DEV_ATTR, intent(inout) :: array_out(:)
         logical(int32), intent(in)    :: val
         integer, optional, intent(in) ::  range1(2)
         integer, optional, intent(in) ::  lbound1
      end subroutine l4_devxlib_memset_d_l1d
      !
      module subroutine l4_devxlib_memset_d_l2d(array_out, val, &
                                            range1, lbound1, &
                                            range2, lbound2 )
         implicit none
         !
         logical(int32) DEV_ATTR, intent(inout) :: array_out(:,:)
         logical(int32), intent(in)    :: val
         integer, optional, intent(in) ::  range1(2), range2(2)
         integer, optional, intent(in) ::  lbound1, lbound2
      end subroutine l4_devxlib_memset_d_l2d
      !
      module subroutine l4_devxlib_memset_d_l3d(array_out, val, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3 )
         implicit none
         !
         logical(int32) DEV_ATTR, intent(inout) :: array_out(:,:,:)
         logical(int32), intent(in)    :: val
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3
      end subroutine l4_devxlib_memset_d_l3d
      !
      module subroutine l4_devxlib_memset_d_l4d(array_out, val, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3, &
                                            range4, lbound4 )
         implicit none
         !
         logical(int32) DEV_ATTR, intent(inout) :: array_out(:,:,:,:)
         logical(int32), intent(in)    :: val
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4
      end subroutine l4_devxlib_memset_d_l4d
      !
      module subroutine l4_devxlib_memset_d_l5d(array_out, val, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3, &
                                            range4, lbound4, &
                                            range5, lbound5 )
         implicit none
         !
         logical(int32) DEV_ATTR, intent(inout) :: array_out(:,:,:,:,:)
         logical(int32), intent(in)    :: val
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5
      end subroutine l4_devxlib_memset_d_l5d
      !
      module subroutine l4_devxlib_memset_d_l6d(array_out, val, &
                                            range1, lbound1, &
                                            range2, lbound2, &
                                            range3, lbound3, &
                                            range4, lbound4, &
                                            range5, lbound5, &
                                            range6, lbound6 )
         implicit none
         !
         logical(int32) DEV_ATTR, intent(inout) :: array_out(:,:,:,:,:,:)
         logical(int32), intent(in)    :: val
         integer, optional, intent(in) ::  range1(2), range2(2), range3(2), range4(2), range5(2), range6(2)
         integer, optional, intent(in) ::  lbound1, lbound2, lbound3, lbound4, lbound5, lbound6
      end subroutine l4_devxlib_memset_d_l6d
      !
   endinterface

endmodule devxlib_memset

#if defined __DXL_MKL_GPU
#  include "mkl_omp_offload.f90"
#endif

module devxlib_mklgpu
 !
#if defined __DXL_MKL_GPU
 use onemkl_blas_omp_offload_lp64
#endif
 !
 implicit none

end module devxlib_mklgpu

!
! Copyright (C) 2021, MaX CoE
! Distributed under the MIT License
! (license terms are at http://opensource.org/licenses/MIT).
!
!--
!
! Utility functions to perform memcpy, memset, malloc, free on accelerator
! devices using CUDAF, OpenACC, OpenMP-GPU
!
module device_memcpy_m
  implicit none

#include<device_memcpy_interf.f90>
#include<device_malloc_interf.f90>
#include<device_mapping_interf.f90>

end module device_memcpy_m

!
! Copyright (C) 2021, MaX CoE
! Distributed under the MIT License
! (license terms are at http://opensource.org/licenses/MIT).
!
!--
!
! Utility functions to perform memcpy and memset on the device with CUDA Fortran
! cuf_memXXX contains a CUF KERNEL to perform the selected operation
! cu_memsync are wrappers for cuda_memcpy functions
!
module devxlib_environment
   !
   use iso_c_binding, only : c_int, c_intptr_t, c_ptr
#if defined __DXL_OPENACC
   use openacc
#elif defined __DXL_CUDAF
   use cudafor
#endif

   implicit none

#if defined __DXL_OPENACC

   interface
      !
      function cudaDeviceSynchronize() &
         result(ierr) bind(c, name="cudaDeviceSynchronize")
         import c_int
         integer(c_int) :: ierr
      end function cudaDeviceSynchronize
      !
      function cudaStreamCreate(pstream) &
         result(ierr) bind(c, name="cudaStreamCreate")
         import c_ptr, c_int
         type(c_ptr) :: pstream
         integer(c_int) :: ierr
      end function cudaStreamCreate
      !
      function cudaStreamDestroy(pstream) &
         result(ierr) bind(c, name="cudaStreamDestroy")
         import c_ptr, c_int
         type(c_ptr), value :: pstream
         integer(c_int) :: ierr
      end function cudaStreamDestroy
      !
      function cudaStreamSynchronize(pstream) &
         result(ierr) bind(c, name="cudaStreamSynchronize")
         import c_ptr, c_int
         type(c_ptr), value :: pstream
         integer(c_int) :: ierr
      end function cudaStreamSynchronize
      !
      function cudaGetDeviceCount(count) &
         result(ierr) bind(c, name="cudaGetDeviceCount")
         import :: c_int
         implicit none
         integer(c_int) :: count
         integer(c_int) :: ierr
      end function cudaGetDeviceCount
      !
      function cudaSetDevice(device) &
         result(ierr) bind(c, name = "cudaSetDevice")
         import :: c_int
         implicit none
         integer(c_int), value :: device
         integer(c_int) :: ierr
      end function cudaSetDevice

      function cudaGetLastError() &
         result(ierr) bind(c, name = "cudaGetLastError")
         import :: c_int
         implicit none
         integer(c_int) :: ierr
      end function cudaGetLastError
      !
      function cudaGetDevice(device) &
         result(ierr) bind(c, name = "cudaGetDevice")
         import :: c_int
         implicit none
         integer(c_int) :: device
         integer(c_int) :: ierr
      end function cudaGetDevice
      !
   end interface

   interface
      function acc_malloc_f(total_byte_dim) bind(c, name="acc_malloc")
         use iso_c_binding, only : c_ptr, c_size_t
         implicit none
         type(c_ptr)                          :: acc_malloc_f
         integer(c_size_t), value, intent(in) :: total_byte_dim
      endfunction acc_malloc_f

      subroutine acc_free_f(dev_ptr) bind(c, name="acc_free")
         use iso_c_binding, only : c_ptr
         implicit none
         type(c_ptr), value :: dev_ptr
      endsubroutine acc_free_f

      function acc_get_cuda_stream_f(async) result(pstream) bind(c,name="acc_get_cuda_stream")
         import c_int, c_intptr_t
         integer(c_int), value :: async
         integer(c_intptr_t)   :: pstream
         !type(c_ptr)          :: pstream
      end function acc_get_cuda_stream_f

      subroutine acc_memcpy_to_device_f(dev_ptr, host_ptr, total_byte_dim) bind(c, name="acc_memcpy_to_device")
         use iso_c_binding, only : c_ptr, c_size_t
         implicit none
         type(c_ptr),       value :: dev_ptr
         type(c_ptr),       value :: host_ptr
         integer(c_size_t), value :: total_byte_dim
      endsubroutine acc_memcpy_to_device_f

      subroutine acc_memcpy_from_device_f(host_ptr, dev_ptr, total_byte_dim) bind(c, name="acc_memcpy_from_device")
         use iso_c_binding, only : c_ptr, c_size_t
         implicit none
         type(c_ptr),       value :: host_ptr
         type(c_ptr),       value :: dev_ptr
         integer(c_size_t), value :: total_byte_dim
      endsubroutine acc_memcpy_from_device_f

      subroutine acc_memcpy_device_f(dev_ptr_dst, dev_ptr_src, total_byte_dim) bind(c, name="acc_memcpy_device")
         use iso_c_binding, only : c_ptr, c_size_t
         implicit none
         type(c_ptr),       value :: dev_ptr_dst
         type(c_ptr),       value :: dev_ptr_src
         integer(c_size_t), value :: total_byte_dim
      endsubroutine acc_memcpy_device_f

   endinterface
#endif

#if defined __DXL_CUDAF
   interface
      integer (c_int) function cudaMalloc_f(buffer, size)  bind(C,name="cudaMalloc")
         use iso_c_binding
         implicit none
         type (c_ptr)              :: buffer
         integer (c_size_t), value :: size
      end function cudaMalloc_f

      integer (c_int) function cudaFree_f(buffer)  bind(C,name="cudaFree")
         use iso_c_binding
         implicit none
         type (c_ptr), value :: buffer
      end function cudaFree_f

      integer(c_int) function cudaMemcpy_f(dst, src, count, kind) bind(C, name='cudaMemcpy')
         use iso_c_binding
         type(c_ptr), value :: dst
         type(c_ptr), value :: src
         integer(c_size_t), value :: count
         integer(c_int), value :: kind
      end function cudaMemcpy_f
   endinterface
#endif

   contains

      subroutine devxlib_error( calling_routine, message, ierr )
         implicit none
         character(len=*), intent(in) :: calling_routine, message
         ! the name of the calling calling_routine
         ! the output message
         integer,          intent(in) :: ierr
         !
         write(0,*) trim(calling_routine), trim(message), ierr
         !
      end subroutine devxlib_error

endmodule devxlib_environment

!
! Copyright (C) 2022, MaX CoE
! Distributed under the MIT License 
! (license terms are at http://opensource.org/licenses/MIT).
!
!--
!
! Utility functions to perform memory allocation on the device
! using CUDA-Fortran, OpenACC or OpenMP Offload
!
!==================================================================
!==================================================================
! *DO NOT EDIT*: automatically generated from devxlib_malloc_alloc.jf90
!==================================================================
!==================================================================
!
#include<devxlib_macros.h>
#include<devxlib_defs.h>
!
!=======================================
!
submodule (devxlib_malloc) devxlib_malloc_alloc

   implicit none

   contains
      module subroutine sp_devxlib_malloc_alloc_r1d(dev_ptr, dimensions, ierr, device_id, lbounds)
          implicit none
          !
          real(real32), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:)
          integer(int64), intent(in)           :: dimensions
          integer(int32), intent(out)          :: ierr
          integer(int32), intent(in), optional :: device_id
          integer(int64), intent(in), optional :: lbounds
#if defined __DXL_CUDAF
          integer(kind=c_int) :: info
#endif
          real(real32) :: dummy
          type(c_ptr) :: c_dev_ptr
          real(real32), pointer, contiguous :: fptr(:)
#if defined __DXL_OPENMP_GPU
          integer(int32) :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) ierr = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local = device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
          if (present(lbounds)) then
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * dimensions / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * dimensions / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * dimensions / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, fptr, [dimensions])
                   dev_ptr(lbounds:lbounds+dimensions-1_int64) => fptr
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(lbounds:lbounds+dimensions-1_int64), stat = ierr )
#endif
          else
             !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * dimensions / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * dimensions / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * dimensions / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, dev_ptr, [dimensions])
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(dimensions), stat = ierr )
#endif
          endif
          !
      end subroutine sp_devxlib_malloc_alloc_r1d
      !
      module subroutine sp_devxlib_malloc_alloc_r2d(dev_ptr, dimensions, ierr, device_id, lbounds)
          implicit none
          !
          real(real32), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:)
          integer(int64), intent(in)           :: dimensions(2)
          integer(int32), intent(out)          :: ierr
          integer(int32), intent(in), optional :: device_id
          integer(int64), intent(in), optional :: lbounds(2)
#if defined __DXL_CUDAF
          integer(kind=c_int) :: info
#endif
          real(real32) :: dummy
          type(c_ptr) :: c_dev_ptr
          real(real32), pointer, contiguous :: fptr(:,:)
#if defined __DXL_OPENMP_GPU
          integer(int32) :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) ierr = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local = device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
          if (present(lbounds)) then
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, fptr, [dimensions(1), dimensions(2)])
                   dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                           lbounds(2):lbounds(2)+dimensions(2)-1_int64) => fptr
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                                                             lbounds(2):lbounds(2)+dimensions(2)-1_int64), stat = ierr )
#endif
          else
             !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, dev_ptr, [dimensions(1), dimensions(2)])
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(dimensions(1),&
                                                     dimensions(2)), stat = ierr )
#endif
          endif
          !
      end subroutine sp_devxlib_malloc_alloc_r2d
      !
      module subroutine sp_devxlib_malloc_alloc_r3d(dev_ptr, dimensions, ierr, device_id, lbounds)
          implicit none
          !
          real(real32), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:,:)
          integer(int64), intent(in)           :: dimensions(3)
          integer(int32), intent(out)          :: ierr
          integer(int32), intent(in), optional :: device_id
          integer(int64), intent(in), optional :: lbounds(3)
#if defined __DXL_CUDAF
          integer(kind=c_int) :: info
#endif
          real(real32) :: dummy
          type(c_ptr) :: c_dev_ptr
          real(real32), pointer, contiguous :: fptr(:,:,:)
#if defined __DXL_OPENMP_GPU
          integer(int32) :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) ierr = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local = device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
          if (present(lbounds)) then
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, fptr, [dimensions(1), dimensions(2), dimensions(3)])
                   dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                           lbounds(2):lbounds(2)+dimensions(2)-1_int64,&
                           lbounds(3):lbounds(3)+dimensions(3)-1_int64) => fptr
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                                                             lbounds(2):lbounds(2)+dimensions(2)-1_int64,&
                                                             lbounds(3):lbounds(3)+dimensions(3)-1_int64), stat = ierr )
#endif
          else
             !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, dev_ptr, [dimensions(1), dimensions(2), dimensions(3)])
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(dimensions(1),&
                                                     dimensions(2),&
                                                     dimensions(3)), stat = ierr )
#endif
          endif
          !
      end subroutine sp_devxlib_malloc_alloc_r3d
      !
      module subroutine sp_devxlib_malloc_alloc_r4d(dev_ptr, dimensions, ierr, device_id, lbounds)
          implicit none
          !
          real(real32), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:,:,:)
          integer(int64), intent(in)           :: dimensions(4)
          integer(int32), intent(out)          :: ierr
          integer(int32), intent(in), optional :: device_id
          integer(int64), intent(in), optional :: lbounds(4)
#if defined __DXL_CUDAF
          integer(kind=c_int) :: info
#endif
          real(real32) :: dummy
          type(c_ptr) :: c_dev_ptr
          real(real32), pointer, contiguous :: fptr(:,:,:,:)
#if defined __DXL_OPENMP_GPU
          integer(int32) :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) ierr = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local = device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
          if (present(lbounds)) then
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, fptr, [dimensions(1), dimensions(2), dimensions(3), dimensions(4)])
                   dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                           lbounds(2):lbounds(2)+dimensions(2)-1_int64,&
                           lbounds(3):lbounds(3)+dimensions(3)-1_int64,&
                           lbounds(4):lbounds(4)+dimensions(4)-1_int64) => fptr
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                                                             lbounds(2):lbounds(2)+dimensions(2)-1_int64,&
                                                             lbounds(3):lbounds(3)+dimensions(3)-1_int64,&
                                                             lbounds(4):lbounds(4)+dimensions(4)-1_int64), stat = ierr )
#endif
          else
             !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, dev_ptr, [dimensions(1), dimensions(2), dimensions(3), dimensions(4)])
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(dimensions(1),&
                                                     dimensions(2),&
                                                     dimensions(3),&
                                                     dimensions(4)), stat = ierr )
#endif
          endif
          !
      end subroutine sp_devxlib_malloc_alloc_r4d
      !
      module subroutine sp_devxlib_malloc_alloc_r5d(dev_ptr, dimensions, ierr, device_id, lbounds)
          implicit none
          !
          real(real32), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:,:,:,:)
          integer(int64), intent(in)           :: dimensions(5)
          integer(int32), intent(out)          :: ierr
          integer(int32), intent(in), optional :: device_id
          integer(int64), intent(in), optional :: lbounds(5)
#if defined __DXL_CUDAF
          integer(kind=c_int) :: info
#endif
          real(real32) :: dummy
          type(c_ptr) :: c_dev_ptr
          real(real32), pointer, contiguous :: fptr(:,:,:,:,:)
#if defined __DXL_OPENMP_GPU
          integer(int32) :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) ierr = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local = device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
          if (present(lbounds)) then
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, fptr, [dimensions(1), dimensions(2), dimensions(3), dimensions(4), &
                                                     dimensions(5)])
                   dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                           lbounds(2):lbounds(2)+dimensions(2)-1_int64,&
                           lbounds(3):lbounds(3)+dimensions(3)-1_int64,&
                           lbounds(4):lbounds(4)+dimensions(4)-1_int64,&
                           lbounds(5):lbounds(5)+dimensions(5)-1_int64) => fptr
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                                                             lbounds(2):lbounds(2)+dimensions(2)-1_int64,&
                                                             lbounds(3):lbounds(3)+dimensions(3)-1_int64,&
                                                             lbounds(4):lbounds(4)+dimensions(4)-1_int64,&
                                                             lbounds(5):lbounds(5)+dimensions(5)-1_int64), stat = ierr )
#endif
          else
             !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, dev_ptr, [dimensions(1), dimensions(2), dimensions(3), dimensions(4), &
                                                         dimensions(5)])
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(dimensions(1),&
                                                     dimensions(2),&
                                                     dimensions(3),&
                                                     dimensions(4),&
                                                     dimensions(5)), stat = ierr )
#endif
          endif
          !
      end subroutine sp_devxlib_malloc_alloc_r5d
      !
      module subroutine sp_devxlib_malloc_alloc_r6d(dev_ptr, dimensions, ierr, device_id, lbounds)
          implicit none
          !
          real(real32), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:,:,:,:,:)
          integer(int64), intent(in)           :: dimensions(6)
          integer(int32), intent(out)          :: ierr
          integer(int32), intent(in), optional :: device_id
          integer(int64), intent(in), optional :: lbounds(6)
#if defined __DXL_CUDAF
          integer(kind=c_int) :: info
#endif
          real(real32) :: dummy
          type(c_ptr) :: c_dev_ptr
          real(real32), pointer, contiguous :: fptr(:,:,:,:,:,:)
#if defined __DXL_OPENMP_GPU
          integer(int32) :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) ierr = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local = device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
          if (present(lbounds)) then
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, fptr, [dimensions(1), dimensions(2), dimensions(3), dimensions(4), &
                                                     dimensions(5), dimensions(6)])
                   dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                           lbounds(2):lbounds(2)+dimensions(2)-1_int64,&
                           lbounds(3):lbounds(3)+dimensions(3)-1_int64,&
                           lbounds(4):lbounds(4)+dimensions(4)-1_int64,&
                           lbounds(5):lbounds(5)+dimensions(5)-1_int64,&
                           lbounds(6):lbounds(6)+dimensions(6)-1_int64) => fptr
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                                                             lbounds(2):lbounds(2)+dimensions(2)-1_int64,&
                                                             lbounds(3):lbounds(3)+dimensions(3)-1_int64,&
                                                             lbounds(4):lbounds(4)+dimensions(4)-1_int64,&
                                                             lbounds(5):lbounds(5)+dimensions(5)-1_int64,&
                                                             lbounds(6):lbounds(6)+dimensions(6)-1_int64), stat = ierr )
#endif
          else
             !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, dev_ptr, [dimensions(1), dimensions(2), dimensions(3), dimensions(4), &
                                                         dimensions(5), dimensions(6)])
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(dimensions(1),&
                                                     dimensions(2),&
                                                     dimensions(3),&
                                                     dimensions(4),&
                                                     dimensions(5),&
                                                     dimensions(6)), stat = ierr )
#endif
          endif
          !
      end subroutine sp_devxlib_malloc_alloc_r6d
      !
      module subroutine dp_devxlib_malloc_alloc_r1d(dev_ptr, dimensions, ierr, device_id, lbounds)
          implicit none
          !
          real(real64), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:)
          integer(int64), intent(in)           :: dimensions
          integer(int32), intent(out)          :: ierr
          integer(int32), intent(in), optional :: device_id
          integer(int64), intent(in), optional :: lbounds
#if defined __DXL_CUDAF
          integer(kind=c_int) :: info
#endif
          real(real64) :: dummy
          type(c_ptr) :: c_dev_ptr
          real(real64), pointer, contiguous :: fptr(:)
#if defined __DXL_OPENMP_GPU
          integer(int32) :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) ierr = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local = device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
          if (present(lbounds)) then
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * dimensions / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * dimensions / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * dimensions / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, fptr, [dimensions])
                   dev_ptr(lbounds:lbounds+dimensions-1_int64) => fptr
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(lbounds:lbounds+dimensions-1_int64), stat = ierr )
#endif
          else
             !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * dimensions / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * dimensions / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * dimensions / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, dev_ptr, [dimensions])
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(dimensions), stat = ierr )
#endif
          endif
          !
      end subroutine dp_devxlib_malloc_alloc_r1d
      !
      module subroutine dp_devxlib_malloc_alloc_r2d(dev_ptr, dimensions, ierr, device_id, lbounds)
          implicit none
          !
          real(real64), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:)
          integer(int64), intent(in)           :: dimensions(2)
          integer(int32), intent(out)          :: ierr
          integer(int32), intent(in), optional :: device_id
          integer(int64), intent(in), optional :: lbounds(2)
#if defined __DXL_CUDAF
          integer(kind=c_int) :: info
#endif
          real(real64) :: dummy
          type(c_ptr) :: c_dev_ptr
          real(real64), pointer, contiguous :: fptr(:,:)
#if defined __DXL_OPENMP_GPU
          integer(int32) :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) ierr = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local = device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
          if (present(lbounds)) then
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, fptr, [dimensions(1), dimensions(2)])
                   dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                           lbounds(2):lbounds(2)+dimensions(2)-1_int64) => fptr
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                                                             lbounds(2):lbounds(2)+dimensions(2)-1_int64), stat = ierr )
#endif
          else
             !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, dev_ptr, [dimensions(1), dimensions(2)])
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(dimensions(1),&
                                                     dimensions(2)), stat = ierr )
#endif
          endif
          !
      end subroutine dp_devxlib_malloc_alloc_r2d
      !
      module subroutine dp_devxlib_malloc_alloc_r3d(dev_ptr, dimensions, ierr, device_id, lbounds)
          implicit none
          !
          real(real64), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:,:)
          integer(int64), intent(in)           :: dimensions(3)
          integer(int32), intent(out)          :: ierr
          integer(int32), intent(in), optional :: device_id
          integer(int64), intent(in), optional :: lbounds(3)
#if defined __DXL_CUDAF
          integer(kind=c_int) :: info
#endif
          real(real64) :: dummy
          type(c_ptr) :: c_dev_ptr
          real(real64), pointer, contiguous :: fptr(:,:,:)
#if defined __DXL_OPENMP_GPU
          integer(int32) :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) ierr = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local = device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
          if (present(lbounds)) then
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, fptr, [dimensions(1), dimensions(2), dimensions(3)])
                   dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                           lbounds(2):lbounds(2)+dimensions(2)-1_int64,&
                           lbounds(3):lbounds(3)+dimensions(3)-1_int64) => fptr
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                                                             lbounds(2):lbounds(2)+dimensions(2)-1_int64,&
                                                             lbounds(3):lbounds(3)+dimensions(3)-1_int64), stat = ierr )
#endif
          else
             !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, dev_ptr, [dimensions(1), dimensions(2), dimensions(3)])
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(dimensions(1),&
                                                     dimensions(2),&
                                                     dimensions(3)), stat = ierr )
#endif
          endif
          !
      end subroutine dp_devxlib_malloc_alloc_r3d
      !
      module subroutine dp_devxlib_malloc_alloc_r4d(dev_ptr, dimensions, ierr, device_id, lbounds)
          implicit none
          !
          real(real64), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:,:,:)
          integer(int64), intent(in)           :: dimensions(4)
          integer(int32), intent(out)          :: ierr
          integer(int32), intent(in), optional :: device_id
          integer(int64), intent(in), optional :: lbounds(4)
#if defined __DXL_CUDAF
          integer(kind=c_int) :: info
#endif
          real(real64) :: dummy
          type(c_ptr) :: c_dev_ptr
          real(real64), pointer, contiguous :: fptr(:,:,:,:)
#if defined __DXL_OPENMP_GPU
          integer(int32) :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) ierr = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local = device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
          if (present(lbounds)) then
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, fptr, [dimensions(1), dimensions(2), dimensions(3), dimensions(4)])
                   dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                           lbounds(2):lbounds(2)+dimensions(2)-1_int64,&
                           lbounds(3):lbounds(3)+dimensions(3)-1_int64,&
                           lbounds(4):lbounds(4)+dimensions(4)-1_int64) => fptr
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                                                             lbounds(2):lbounds(2)+dimensions(2)-1_int64,&
                                                             lbounds(3):lbounds(3)+dimensions(3)-1_int64,&
                                                             lbounds(4):lbounds(4)+dimensions(4)-1_int64), stat = ierr )
#endif
          else
             !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, dev_ptr, [dimensions(1), dimensions(2), dimensions(3), dimensions(4)])
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(dimensions(1),&
                                                     dimensions(2),&
                                                     dimensions(3),&
                                                     dimensions(4)), stat = ierr )
#endif
          endif
          !
      end subroutine dp_devxlib_malloc_alloc_r4d
      !
      module subroutine dp_devxlib_malloc_alloc_r5d(dev_ptr, dimensions, ierr, device_id, lbounds)
          implicit none
          !
          real(real64), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:,:,:,:)
          integer(int64), intent(in)           :: dimensions(5)
          integer(int32), intent(out)          :: ierr
          integer(int32), intent(in), optional :: device_id
          integer(int64), intent(in), optional :: lbounds(5)
#if defined __DXL_CUDAF
          integer(kind=c_int) :: info
#endif
          real(real64) :: dummy
          type(c_ptr) :: c_dev_ptr
          real(real64), pointer, contiguous :: fptr(:,:,:,:,:)
#if defined __DXL_OPENMP_GPU
          integer(int32) :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) ierr = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local = device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
          if (present(lbounds)) then
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, fptr, [dimensions(1), dimensions(2), dimensions(3), dimensions(4), &
                                                     dimensions(5)])
                   dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                           lbounds(2):lbounds(2)+dimensions(2)-1_int64,&
                           lbounds(3):lbounds(3)+dimensions(3)-1_int64,&
                           lbounds(4):lbounds(4)+dimensions(4)-1_int64,&
                           lbounds(5):lbounds(5)+dimensions(5)-1_int64) => fptr
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                                                             lbounds(2):lbounds(2)+dimensions(2)-1_int64,&
                                                             lbounds(3):lbounds(3)+dimensions(3)-1_int64,&
                                                             lbounds(4):lbounds(4)+dimensions(4)-1_int64,&
                                                             lbounds(5):lbounds(5)+dimensions(5)-1_int64), stat = ierr )
#endif
          else
             !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, dev_ptr, [dimensions(1), dimensions(2), dimensions(3), dimensions(4), &
                                                         dimensions(5)])
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(dimensions(1),&
                                                     dimensions(2),&
                                                     dimensions(3),&
                                                     dimensions(4),&
                                                     dimensions(5)), stat = ierr )
#endif
          endif
          !
      end subroutine dp_devxlib_malloc_alloc_r5d
      !
      module subroutine dp_devxlib_malloc_alloc_r6d(dev_ptr, dimensions, ierr, device_id, lbounds)
          implicit none
          !
          real(real64), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:,:,:,:,:)
          integer(int64), intent(in)           :: dimensions(6)
          integer(int32), intent(out)          :: ierr
          integer(int32), intent(in), optional :: device_id
          integer(int64), intent(in), optional :: lbounds(6)
#if defined __DXL_CUDAF
          integer(kind=c_int) :: info
#endif
          real(real64) :: dummy
          type(c_ptr) :: c_dev_ptr
          real(real64), pointer, contiguous :: fptr(:,:,:,:,:,:)
#if defined __DXL_OPENMP_GPU
          integer(int32) :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) ierr = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local = device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
          if (present(lbounds)) then
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, fptr, [dimensions(1), dimensions(2), dimensions(3), dimensions(4), &
                                                     dimensions(5), dimensions(6)])
                   dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                           lbounds(2):lbounds(2)+dimensions(2)-1_int64,&
                           lbounds(3):lbounds(3)+dimensions(3)-1_int64,&
                           lbounds(4):lbounds(4)+dimensions(4)-1_int64,&
                           lbounds(5):lbounds(5)+dimensions(5)-1_int64,&
                           lbounds(6):lbounds(6)+dimensions(6)-1_int64) => fptr
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                                                             lbounds(2):lbounds(2)+dimensions(2)-1_int64,&
                                                             lbounds(3):lbounds(3)+dimensions(3)-1_int64,&
                                                             lbounds(4):lbounds(4)+dimensions(4)-1_int64,&
                                                             lbounds(5):lbounds(5)+dimensions(5)-1_int64,&
                                                             lbounds(6):lbounds(6)+dimensions(6)-1_int64), stat = ierr )
#endif
          else
             !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, dev_ptr, [dimensions(1), dimensions(2), dimensions(3), dimensions(4), &
                                                         dimensions(5), dimensions(6)])
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(dimensions(1),&
                                                     dimensions(2),&
                                                     dimensions(3),&
                                                     dimensions(4),&
                                                     dimensions(5),&
                                                     dimensions(6)), stat = ierr )
#endif
          endif
          !
      end subroutine dp_devxlib_malloc_alloc_r6d
      !
      module subroutine sp_devxlib_malloc_alloc_c1d(dev_ptr, dimensions, ierr, device_id, lbounds)
          implicit none
          !
          complex(real32), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:)
          integer(int64), intent(in)           :: dimensions
          integer(int32), intent(out)          :: ierr
          integer(int32), intent(in), optional :: device_id
          integer(int64), intent(in), optional :: lbounds
#if defined __DXL_CUDAF
          integer(kind=c_int) :: info
#endif
          complex(real32) :: dummy
          type(c_ptr) :: c_dev_ptr
          complex(real32), pointer, contiguous :: fptr(:)
#if defined __DXL_OPENMP_GPU
          integer(int32) :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) ierr = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local = device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
          if (present(lbounds)) then
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * dimensions / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * dimensions / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * dimensions / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, fptr, [dimensions])
                   dev_ptr(lbounds:lbounds+dimensions-1_int64) => fptr
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(lbounds:lbounds+dimensions-1_int64), stat = ierr )
#endif
          else
             !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * dimensions / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * dimensions / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * dimensions / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, dev_ptr, [dimensions])
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(dimensions), stat = ierr )
#endif
          endif
          !
      end subroutine sp_devxlib_malloc_alloc_c1d
      !
      module subroutine sp_devxlib_malloc_alloc_c2d(dev_ptr, dimensions, ierr, device_id, lbounds)
          implicit none
          !
          complex(real32), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:)
          integer(int64), intent(in)           :: dimensions(2)
          integer(int32), intent(out)          :: ierr
          integer(int32), intent(in), optional :: device_id
          integer(int64), intent(in), optional :: lbounds(2)
#if defined __DXL_CUDAF
          integer(kind=c_int) :: info
#endif
          complex(real32) :: dummy
          type(c_ptr) :: c_dev_ptr
          complex(real32), pointer, contiguous :: fptr(:,:)
#if defined __DXL_OPENMP_GPU
          integer(int32) :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) ierr = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local = device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
          if (present(lbounds)) then
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, fptr, [dimensions(1), dimensions(2)])
                   dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                           lbounds(2):lbounds(2)+dimensions(2)-1_int64) => fptr
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                                                             lbounds(2):lbounds(2)+dimensions(2)-1_int64), stat = ierr )
#endif
          else
             !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, dev_ptr, [dimensions(1), dimensions(2)])
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(dimensions(1),&
                                                     dimensions(2)), stat = ierr )
#endif
          endif
          !
      end subroutine sp_devxlib_malloc_alloc_c2d
      !
      module subroutine sp_devxlib_malloc_alloc_c3d(dev_ptr, dimensions, ierr, device_id, lbounds)
          implicit none
          !
          complex(real32), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:,:)
          integer(int64), intent(in)           :: dimensions(3)
          integer(int32), intent(out)          :: ierr
          integer(int32), intent(in), optional :: device_id
          integer(int64), intent(in), optional :: lbounds(3)
#if defined __DXL_CUDAF
          integer(kind=c_int) :: info
#endif
          complex(real32) :: dummy
          type(c_ptr) :: c_dev_ptr
          complex(real32), pointer, contiguous :: fptr(:,:,:)
#if defined __DXL_OPENMP_GPU
          integer(int32) :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) ierr = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local = device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
          if (present(lbounds)) then
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, fptr, [dimensions(1), dimensions(2), dimensions(3)])
                   dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                           lbounds(2):lbounds(2)+dimensions(2)-1_int64,&
                           lbounds(3):lbounds(3)+dimensions(3)-1_int64) => fptr
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                                                             lbounds(2):lbounds(2)+dimensions(2)-1_int64,&
                                                             lbounds(3):lbounds(3)+dimensions(3)-1_int64), stat = ierr )
#endif
          else
             !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, dev_ptr, [dimensions(1), dimensions(2), dimensions(3)])
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(dimensions(1),&
                                                     dimensions(2),&
                                                     dimensions(3)), stat = ierr )
#endif
          endif
          !
      end subroutine sp_devxlib_malloc_alloc_c3d
      !
      module subroutine sp_devxlib_malloc_alloc_c4d(dev_ptr, dimensions, ierr, device_id, lbounds)
          implicit none
          !
          complex(real32), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:,:,:)
          integer(int64), intent(in)           :: dimensions(4)
          integer(int32), intent(out)          :: ierr
          integer(int32), intent(in), optional :: device_id
          integer(int64), intent(in), optional :: lbounds(4)
#if defined __DXL_CUDAF
          integer(kind=c_int) :: info
#endif
          complex(real32) :: dummy
          type(c_ptr) :: c_dev_ptr
          complex(real32), pointer, contiguous :: fptr(:,:,:,:)
#if defined __DXL_OPENMP_GPU
          integer(int32) :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) ierr = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local = device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
          if (present(lbounds)) then
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, fptr, [dimensions(1), dimensions(2), dimensions(3), dimensions(4)])
                   dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                           lbounds(2):lbounds(2)+dimensions(2)-1_int64,&
                           lbounds(3):lbounds(3)+dimensions(3)-1_int64,&
                           lbounds(4):lbounds(4)+dimensions(4)-1_int64) => fptr
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                                                             lbounds(2):lbounds(2)+dimensions(2)-1_int64,&
                                                             lbounds(3):lbounds(3)+dimensions(3)-1_int64,&
                                                             lbounds(4):lbounds(4)+dimensions(4)-1_int64), stat = ierr )
#endif
          else
             !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, dev_ptr, [dimensions(1), dimensions(2), dimensions(3), dimensions(4)])
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(dimensions(1),&
                                                     dimensions(2),&
                                                     dimensions(3),&
                                                     dimensions(4)), stat = ierr )
#endif
          endif
          !
      end subroutine sp_devxlib_malloc_alloc_c4d
      !
      module subroutine sp_devxlib_malloc_alloc_c5d(dev_ptr, dimensions, ierr, device_id, lbounds)
          implicit none
          !
          complex(real32), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:,:,:,:)
          integer(int64), intent(in)           :: dimensions(5)
          integer(int32), intent(out)          :: ierr
          integer(int32), intent(in), optional :: device_id
          integer(int64), intent(in), optional :: lbounds(5)
#if defined __DXL_CUDAF
          integer(kind=c_int) :: info
#endif
          complex(real32) :: dummy
          type(c_ptr) :: c_dev_ptr
          complex(real32), pointer, contiguous :: fptr(:,:,:,:,:)
#if defined __DXL_OPENMP_GPU
          integer(int32) :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) ierr = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local = device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
          if (present(lbounds)) then
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, fptr, [dimensions(1), dimensions(2), dimensions(3), dimensions(4), &
                                                     dimensions(5)])
                   dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                           lbounds(2):lbounds(2)+dimensions(2)-1_int64,&
                           lbounds(3):lbounds(3)+dimensions(3)-1_int64,&
                           lbounds(4):lbounds(4)+dimensions(4)-1_int64,&
                           lbounds(5):lbounds(5)+dimensions(5)-1_int64) => fptr
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                                                             lbounds(2):lbounds(2)+dimensions(2)-1_int64,&
                                                             lbounds(3):lbounds(3)+dimensions(3)-1_int64,&
                                                             lbounds(4):lbounds(4)+dimensions(4)-1_int64,&
                                                             lbounds(5):lbounds(5)+dimensions(5)-1_int64), stat = ierr )
#endif
          else
             !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, dev_ptr, [dimensions(1), dimensions(2), dimensions(3), dimensions(4), &
                                                         dimensions(5)])
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(dimensions(1),&
                                                     dimensions(2),&
                                                     dimensions(3),&
                                                     dimensions(4),&
                                                     dimensions(5)), stat = ierr )
#endif
          endif
          !
      end subroutine sp_devxlib_malloc_alloc_c5d
      !
      module subroutine sp_devxlib_malloc_alloc_c6d(dev_ptr, dimensions, ierr, device_id, lbounds)
          implicit none
          !
          complex(real32), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:,:,:,:,:)
          integer(int64), intent(in)           :: dimensions(6)
          integer(int32), intent(out)          :: ierr
          integer(int32), intent(in), optional :: device_id
          integer(int64), intent(in), optional :: lbounds(6)
#if defined __DXL_CUDAF
          integer(kind=c_int) :: info
#endif
          complex(real32) :: dummy
          type(c_ptr) :: c_dev_ptr
          complex(real32), pointer, contiguous :: fptr(:,:,:,:,:,:)
#if defined __DXL_OPENMP_GPU
          integer(int32) :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) ierr = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local = device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
          if (present(lbounds)) then
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, fptr, [dimensions(1), dimensions(2), dimensions(3), dimensions(4), &
                                                     dimensions(5), dimensions(6)])
                   dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                           lbounds(2):lbounds(2)+dimensions(2)-1_int64,&
                           lbounds(3):lbounds(3)+dimensions(3)-1_int64,&
                           lbounds(4):lbounds(4)+dimensions(4)-1_int64,&
                           lbounds(5):lbounds(5)+dimensions(5)-1_int64,&
                           lbounds(6):lbounds(6)+dimensions(6)-1_int64) => fptr
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                                                             lbounds(2):lbounds(2)+dimensions(2)-1_int64,&
                                                             lbounds(3):lbounds(3)+dimensions(3)-1_int64,&
                                                             lbounds(4):lbounds(4)+dimensions(4)-1_int64,&
                                                             lbounds(5):lbounds(5)+dimensions(5)-1_int64,&
                                                             lbounds(6):lbounds(6)+dimensions(6)-1_int64), stat = ierr )
#endif
          else
             !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, dev_ptr, [dimensions(1), dimensions(2), dimensions(3), dimensions(4), &
                                                         dimensions(5), dimensions(6)])
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(dimensions(1),&
                                                     dimensions(2),&
                                                     dimensions(3),&
                                                     dimensions(4),&
                                                     dimensions(5),&
                                                     dimensions(6)), stat = ierr )
#endif
          endif
          !
      end subroutine sp_devxlib_malloc_alloc_c6d
      !
      module subroutine dp_devxlib_malloc_alloc_c1d(dev_ptr, dimensions, ierr, device_id, lbounds)
          implicit none
          !
          complex(real64), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:)
          integer(int64), intent(in)           :: dimensions
          integer(int32), intent(out)          :: ierr
          integer(int32), intent(in), optional :: device_id
          integer(int64), intent(in), optional :: lbounds
#if defined __DXL_CUDAF
          integer(kind=c_int) :: info
#endif
          complex(real64) :: dummy
          type(c_ptr) :: c_dev_ptr
          complex(real64), pointer, contiguous :: fptr(:)
#if defined __DXL_OPENMP_GPU
          integer(int32) :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) ierr = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local = device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
          if (present(lbounds)) then
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * dimensions / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * dimensions / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * dimensions / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, fptr, [dimensions])
                   dev_ptr(lbounds:lbounds+dimensions-1_int64) => fptr
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(lbounds:lbounds+dimensions-1_int64), stat = ierr )
#endif
          else
             !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * dimensions / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * dimensions / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * dimensions / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, dev_ptr, [dimensions])
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(dimensions), stat = ierr )
#endif
          endif
          !
      end subroutine dp_devxlib_malloc_alloc_c1d
      !
      module subroutine dp_devxlib_malloc_alloc_c2d(dev_ptr, dimensions, ierr, device_id, lbounds)
          implicit none
          !
          complex(real64), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:)
          integer(int64), intent(in)           :: dimensions(2)
          integer(int32), intent(out)          :: ierr
          integer(int32), intent(in), optional :: device_id
          integer(int64), intent(in), optional :: lbounds(2)
#if defined __DXL_CUDAF
          integer(kind=c_int) :: info
#endif
          complex(real64) :: dummy
          type(c_ptr) :: c_dev_ptr
          complex(real64), pointer, contiguous :: fptr(:,:)
#if defined __DXL_OPENMP_GPU
          integer(int32) :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) ierr = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local = device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
          if (present(lbounds)) then
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, fptr, [dimensions(1), dimensions(2)])
                   dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                           lbounds(2):lbounds(2)+dimensions(2)-1_int64) => fptr
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                                                             lbounds(2):lbounds(2)+dimensions(2)-1_int64), stat = ierr )
#endif
          else
             !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, dev_ptr, [dimensions(1), dimensions(2)])
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(dimensions(1),&
                                                     dimensions(2)), stat = ierr )
#endif
          endif
          !
      end subroutine dp_devxlib_malloc_alloc_c2d
      !
      module subroutine dp_devxlib_malloc_alloc_c3d(dev_ptr, dimensions, ierr, device_id, lbounds)
          implicit none
          !
          complex(real64), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:,:)
          integer(int64), intent(in)           :: dimensions(3)
          integer(int32), intent(out)          :: ierr
          integer(int32), intent(in), optional :: device_id
          integer(int64), intent(in), optional :: lbounds(3)
#if defined __DXL_CUDAF
          integer(kind=c_int) :: info
#endif
          complex(real64) :: dummy
          type(c_ptr) :: c_dev_ptr
          complex(real64), pointer, contiguous :: fptr(:,:,:)
#if defined __DXL_OPENMP_GPU
          integer(int32) :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) ierr = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local = device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
          if (present(lbounds)) then
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, fptr, [dimensions(1), dimensions(2), dimensions(3)])
                   dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                           lbounds(2):lbounds(2)+dimensions(2)-1_int64,&
                           lbounds(3):lbounds(3)+dimensions(3)-1_int64) => fptr
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                                                             lbounds(2):lbounds(2)+dimensions(2)-1_int64,&
                                                             lbounds(3):lbounds(3)+dimensions(3)-1_int64), stat = ierr )
#endif
          else
             !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, dev_ptr, [dimensions(1), dimensions(2), dimensions(3)])
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(dimensions(1),&
                                                     dimensions(2),&
                                                     dimensions(3)), stat = ierr )
#endif
          endif
          !
      end subroutine dp_devxlib_malloc_alloc_c3d
      !
      module subroutine dp_devxlib_malloc_alloc_c4d(dev_ptr, dimensions, ierr, device_id, lbounds)
          implicit none
          !
          complex(real64), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:,:,:)
          integer(int64), intent(in)           :: dimensions(4)
          integer(int32), intent(out)          :: ierr
          integer(int32), intent(in), optional :: device_id
          integer(int64), intent(in), optional :: lbounds(4)
#if defined __DXL_CUDAF
          integer(kind=c_int) :: info
#endif
          complex(real64) :: dummy
          type(c_ptr) :: c_dev_ptr
          complex(real64), pointer, contiguous :: fptr(:,:,:,:)
#if defined __DXL_OPENMP_GPU
          integer(int32) :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) ierr = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local = device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
          if (present(lbounds)) then
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, fptr, [dimensions(1), dimensions(2), dimensions(3), dimensions(4)])
                   dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                           lbounds(2):lbounds(2)+dimensions(2)-1_int64,&
                           lbounds(3):lbounds(3)+dimensions(3)-1_int64,&
                           lbounds(4):lbounds(4)+dimensions(4)-1_int64) => fptr
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                                                             lbounds(2):lbounds(2)+dimensions(2)-1_int64,&
                                                             lbounds(3):lbounds(3)+dimensions(3)-1_int64,&
                                                             lbounds(4):lbounds(4)+dimensions(4)-1_int64), stat = ierr )
#endif
          else
             !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, dev_ptr, [dimensions(1), dimensions(2), dimensions(3), dimensions(4)])
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(dimensions(1),&
                                                     dimensions(2),&
                                                     dimensions(3),&
                                                     dimensions(4)), stat = ierr )
#endif
          endif
          !
      end subroutine dp_devxlib_malloc_alloc_c4d
      !
      module subroutine dp_devxlib_malloc_alloc_c5d(dev_ptr, dimensions, ierr, device_id, lbounds)
          implicit none
          !
          complex(real64), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:,:,:,:)
          integer(int64), intent(in)           :: dimensions(5)
          integer(int32), intent(out)          :: ierr
          integer(int32), intent(in), optional :: device_id
          integer(int64), intent(in), optional :: lbounds(5)
#if defined __DXL_CUDAF
          integer(kind=c_int) :: info
#endif
          complex(real64) :: dummy
          type(c_ptr) :: c_dev_ptr
          complex(real64), pointer, contiguous :: fptr(:,:,:,:,:)
#if defined __DXL_OPENMP_GPU
          integer(int32) :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) ierr = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local = device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
          if (present(lbounds)) then
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, fptr, [dimensions(1), dimensions(2), dimensions(3), dimensions(4), &
                                                     dimensions(5)])
                   dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                           lbounds(2):lbounds(2)+dimensions(2)-1_int64,&
                           lbounds(3):lbounds(3)+dimensions(3)-1_int64,&
                           lbounds(4):lbounds(4)+dimensions(4)-1_int64,&
                           lbounds(5):lbounds(5)+dimensions(5)-1_int64) => fptr
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                                                             lbounds(2):lbounds(2)+dimensions(2)-1_int64,&
                                                             lbounds(3):lbounds(3)+dimensions(3)-1_int64,&
                                                             lbounds(4):lbounds(4)+dimensions(4)-1_int64,&
                                                             lbounds(5):lbounds(5)+dimensions(5)-1_int64), stat = ierr )
#endif
          else
             !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, dev_ptr, [dimensions(1), dimensions(2), dimensions(3), dimensions(4), &
                                                         dimensions(5)])
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(dimensions(1),&
                                                     dimensions(2),&
                                                     dimensions(3),&
                                                     dimensions(4),&
                                                     dimensions(5)), stat = ierr )
#endif
          endif
          !
      end subroutine dp_devxlib_malloc_alloc_c5d
      !
      module subroutine dp_devxlib_malloc_alloc_c6d(dev_ptr, dimensions, ierr, device_id, lbounds)
          implicit none
          !
          complex(real64), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:,:,:,:,:)
          integer(int64), intent(in)           :: dimensions(6)
          integer(int32), intent(out)          :: ierr
          integer(int32), intent(in), optional :: device_id
          integer(int64), intent(in), optional :: lbounds(6)
#if defined __DXL_CUDAF
          integer(kind=c_int) :: info
#endif
          complex(real64) :: dummy
          type(c_ptr) :: c_dev_ptr
          complex(real64), pointer, contiguous :: fptr(:,:,:,:,:,:)
#if defined __DXL_OPENMP_GPU
          integer(int32) :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) ierr = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local = device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
          if (present(lbounds)) then
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, fptr, [dimensions(1), dimensions(2), dimensions(3), dimensions(4), &
                                                     dimensions(5), dimensions(6)])
                   dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                           lbounds(2):lbounds(2)+dimensions(2)-1_int64,&
                           lbounds(3):lbounds(3)+dimensions(3)-1_int64,&
                           lbounds(4):lbounds(4)+dimensions(4)-1_int64,&
                           lbounds(5):lbounds(5)+dimensions(5)-1_int64,&
                           lbounds(6):lbounds(6)+dimensions(6)-1_int64) => fptr
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                                                             lbounds(2):lbounds(2)+dimensions(2)-1_int64,&
                                                             lbounds(3):lbounds(3)+dimensions(3)-1_int64,&
                                                             lbounds(4):lbounds(4)+dimensions(4)-1_int64,&
                                                             lbounds(5):lbounds(5)+dimensions(5)-1_int64,&
                                                             lbounds(6):lbounds(6)+dimensions(6)-1_int64), stat = ierr )
#endif
          else
             !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, dev_ptr, [dimensions(1), dimensions(2), dimensions(3), dimensions(4), &
                                                         dimensions(5), dimensions(6)])
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(dimensions(1),&
                                                     dimensions(2),&
                                                     dimensions(3),&
                                                     dimensions(4),&
                                                     dimensions(5),&
                                                     dimensions(6)), stat = ierr )
#endif
          endif
          !
      end subroutine dp_devxlib_malloc_alloc_c6d
      !
      module subroutine i4_devxlib_malloc_alloc_i1d(dev_ptr, dimensions, ierr, device_id, lbounds)
          implicit none
          !
          integer(int32), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:)
          integer(int64), intent(in)           :: dimensions
          integer(int32), intent(out)          :: ierr
          integer(int32), intent(in), optional :: device_id
          integer(int64), intent(in), optional :: lbounds
#if defined __DXL_CUDAF
          integer(kind=c_int) :: info
#endif
          integer(int32) :: dummy
          type(c_ptr) :: c_dev_ptr
          integer(int32), pointer, contiguous :: fptr(:)
#if defined __DXL_OPENMP_GPU
          integer(int32) :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) ierr = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local = device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
          if (present(lbounds)) then
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * dimensions / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * dimensions / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * dimensions / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, fptr, [dimensions])
                   dev_ptr(lbounds:lbounds+dimensions-1_int64) => fptr
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(lbounds:lbounds+dimensions-1_int64), stat = ierr )
#endif
          else
             !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * dimensions / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * dimensions / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * dimensions / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, dev_ptr, [dimensions])
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(dimensions), stat = ierr )
#endif
          endif
          !
      end subroutine i4_devxlib_malloc_alloc_i1d
      !
      module subroutine i4_devxlib_malloc_alloc_i2d(dev_ptr, dimensions, ierr, device_id, lbounds)
          implicit none
          !
          integer(int32), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:)
          integer(int64), intent(in)           :: dimensions(2)
          integer(int32), intent(out)          :: ierr
          integer(int32), intent(in), optional :: device_id
          integer(int64), intent(in), optional :: lbounds(2)
#if defined __DXL_CUDAF
          integer(kind=c_int) :: info
#endif
          integer(int32) :: dummy
          type(c_ptr) :: c_dev_ptr
          integer(int32), pointer, contiguous :: fptr(:,:)
#if defined __DXL_OPENMP_GPU
          integer(int32) :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) ierr = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local = device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
          if (present(lbounds)) then
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, fptr, [dimensions(1), dimensions(2)])
                   dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                           lbounds(2):lbounds(2)+dimensions(2)-1_int64) => fptr
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                                                             lbounds(2):lbounds(2)+dimensions(2)-1_int64), stat = ierr )
#endif
          else
             !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, dev_ptr, [dimensions(1), dimensions(2)])
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(dimensions(1),&
                                                     dimensions(2)), stat = ierr )
#endif
          endif
          !
      end subroutine i4_devxlib_malloc_alloc_i2d
      !
      module subroutine i4_devxlib_malloc_alloc_i3d(dev_ptr, dimensions, ierr, device_id, lbounds)
          implicit none
          !
          integer(int32), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:,:)
          integer(int64), intent(in)           :: dimensions(3)
          integer(int32), intent(out)          :: ierr
          integer(int32), intent(in), optional :: device_id
          integer(int64), intent(in), optional :: lbounds(3)
#if defined __DXL_CUDAF
          integer(kind=c_int) :: info
#endif
          integer(int32) :: dummy
          type(c_ptr) :: c_dev_ptr
          integer(int32), pointer, contiguous :: fptr(:,:,:)
#if defined __DXL_OPENMP_GPU
          integer(int32) :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) ierr = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local = device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
          if (present(lbounds)) then
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, fptr, [dimensions(1), dimensions(2), dimensions(3)])
                   dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                           lbounds(2):lbounds(2)+dimensions(2)-1_int64,&
                           lbounds(3):lbounds(3)+dimensions(3)-1_int64) => fptr
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                                                             lbounds(2):lbounds(2)+dimensions(2)-1_int64,&
                                                             lbounds(3):lbounds(3)+dimensions(3)-1_int64), stat = ierr )
#endif
          else
             !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, dev_ptr, [dimensions(1), dimensions(2), dimensions(3)])
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(dimensions(1),&
                                                     dimensions(2),&
                                                     dimensions(3)), stat = ierr )
#endif
          endif
          !
      end subroutine i4_devxlib_malloc_alloc_i3d
      !
      module subroutine i4_devxlib_malloc_alloc_i4d(dev_ptr, dimensions, ierr, device_id, lbounds)
          implicit none
          !
          integer(int32), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:,:,:)
          integer(int64), intent(in)           :: dimensions(4)
          integer(int32), intent(out)          :: ierr
          integer(int32), intent(in), optional :: device_id
          integer(int64), intent(in), optional :: lbounds(4)
#if defined __DXL_CUDAF
          integer(kind=c_int) :: info
#endif
          integer(int32) :: dummy
          type(c_ptr) :: c_dev_ptr
          integer(int32), pointer, contiguous :: fptr(:,:,:,:)
#if defined __DXL_OPENMP_GPU
          integer(int32) :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) ierr = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local = device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
          if (present(lbounds)) then
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, fptr, [dimensions(1), dimensions(2), dimensions(3), dimensions(4)])
                   dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                           lbounds(2):lbounds(2)+dimensions(2)-1_int64,&
                           lbounds(3):lbounds(3)+dimensions(3)-1_int64,&
                           lbounds(4):lbounds(4)+dimensions(4)-1_int64) => fptr
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                                                             lbounds(2):lbounds(2)+dimensions(2)-1_int64,&
                                                             lbounds(3):lbounds(3)+dimensions(3)-1_int64,&
                                                             lbounds(4):lbounds(4)+dimensions(4)-1_int64), stat = ierr )
#endif
          else
             !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, dev_ptr, [dimensions(1), dimensions(2), dimensions(3), dimensions(4)])
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(dimensions(1),&
                                                     dimensions(2),&
                                                     dimensions(3),&
                                                     dimensions(4)), stat = ierr )
#endif
          endif
          !
      end subroutine i4_devxlib_malloc_alloc_i4d
      !
      module subroutine i4_devxlib_malloc_alloc_i5d(dev_ptr, dimensions, ierr, device_id, lbounds)
          implicit none
          !
          integer(int32), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:,:,:,:)
          integer(int64), intent(in)           :: dimensions(5)
          integer(int32), intent(out)          :: ierr
          integer(int32), intent(in), optional :: device_id
          integer(int64), intent(in), optional :: lbounds(5)
#if defined __DXL_CUDAF
          integer(kind=c_int) :: info
#endif
          integer(int32) :: dummy
          type(c_ptr) :: c_dev_ptr
          integer(int32), pointer, contiguous :: fptr(:,:,:,:,:)
#if defined __DXL_OPENMP_GPU
          integer(int32) :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) ierr = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local = device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
          if (present(lbounds)) then
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, fptr, [dimensions(1), dimensions(2), dimensions(3), dimensions(4), &
                                                     dimensions(5)])
                   dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                           lbounds(2):lbounds(2)+dimensions(2)-1_int64,&
                           lbounds(3):lbounds(3)+dimensions(3)-1_int64,&
                           lbounds(4):lbounds(4)+dimensions(4)-1_int64,&
                           lbounds(5):lbounds(5)+dimensions(5)-1_int64) => fptr
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                                                             lbounds(2):lbounds(2)+dimensions(2)-1_int64,&
                                                             lbounds(3):lbounds(3)+dimensions(3)-1_int64,&
                                                             lbounds(4):lbounds(4)+dimensions(4)-1_int64,&
                                                             lbounds(5):lbounds(5)+dimensions(5)-1_int64), stat = ierr )
#endif
          else
             !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, dev_ptr, [dimensions(1), dimensions(2), dimensions(3), dimensions(4), &
                                                         dimensions(5)])
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(dimensions(1),&
                                                     dimensions(2),&
                                                     dimensions(3),&
                                                     dimensions(4),&
                                                     dimensions(5)), stat = ierr )
#endif
          endif
          !
      end subroutine i4_devxlib_malloc_alloc_i5d
      !
      module subroutine i4_devxlib_malloc_alloc_i6d(dev_ptr, dimensions, ierr, device_id, lbounds)
          implicit none
          !
          integer(int32), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:,:,:,:,:)
          integer(int64), intent(in)           :: dimensions(6)
          integer(int32), intent(out)          :: ierr
          integer(int32), intent(in), optional :: device_id
          integer(int64), intent(in), optional :: lbounds(6)
#if defined __DXL_CUDAF
          integer(kind=c_int) :: info
#endif
          integer(int32) :: dummy
          type(c_ptr) :: c_dev_ptr
          integer(int32), pointer, contiguous :: fptr(:,:,:,:,:,:)
#if defined __DXL_OPENMP_GPU
          integer(int32) :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) ierr = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local = device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
          if (present(lbounds)) then
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, fptr, [dimensions(1), dimensions(2), dimensions(3), dimensions(4), &
                                                     dimensions(5), dimensions(6)])
                   dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                           lbounds(2):lbounds(2)+dimensions(2)-1_int64,&
                           lbounds(3):lbounds(3)+dimensions(3)-1_int64,&
                           lbounds(4):lbounds(4)+dimensions(4)-1_int64,&
                           lbounds(5):lbounds(5)+dimensions(5)-1_int64,&
                           lbounds(6):lbounds(6)+dimensions(6)-1_int64) => fptr
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                                                             lbounds(2):lbounds(2)+dimensions(2)-1_int64,&
                                                             lbounds(3):lbounds(3)+dimensions(3)-1_int64,&
                                                             lbounds(4):lbounds(4)+dimensions(4)-1_int64,&
                                                             lbounds(5):lbounds(5)+dimensions(5)-1_int64,&
                                                             lbounds(6):lbounds(6)+dimensions(6)-1_int64), stat = ierr )
#endif
          else
             !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, dev_ptr, [dimensions(1), dimensions(2), dimensions(3), dimensions(4), &
                                                         dimensions(5), dimensions(6)])
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(dimensions(1),&
                                                     dimensions(2),&
                                                     dimensions(3),&
                                                     dimensions(4),&
                                                     dimensions(5),&
                                                     dimensions(6)), stat = ierr )
#endif
          endif
          !
      end subroutine i4_devxlib_malloc_alloc_i6d
      !
      module subroutine i8_devxlib_malloc_alloc_i1d(dev_ptr, dimensions, ierr, device_id, lbounds)
          implicit none
          !
          integer(int64), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:)
          integer(int64), intent(in)           :: dimensions
          integer(int32), intent(out)          :: ierr
          integer(int32), intent(in), optional :: device_id
          integer(int64), intent(in), optional :: lbounds
#if defined __DXL_CUDAF
          integer(kind=c_int) :: info
#endif
          integer(int64) :: dummy
          type(c_ptr) :: c_dev_ptr
          integer(int64), pointer, contiguous :: fptr(:)
#if defined __DXL_OPENMP_GPU
          integer(int32) :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) ierr = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local = device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
          if (present(lbounds)) then
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * dimensions / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * dimensions / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * dimensions / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, fptr, [dimensions])
                   dev_ptr(lbounds:lbounds+dimensions-1_int64) => fptr
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(lbounds:lbounds+dimensions-1_int64), stat = ierr )
#endif
          else
             !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * dimensions / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * dimensions / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * dimensions / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, dev_ptr, [dimensions])
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(dimensions), stat = ierr )
#endif
          endif
          !
      end subroutine i8_devxlib_malloc_alloc_i1d
      !
      module subroutine i8_devxlib_malloc_alloc_i2d(dev_ptr, dimensions, ierr, device_id, lbounds)
          implicit none
          !
          integer(int64), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:)
          integer(int64), intent(in)           :: dimensions(2)
          integer(int32), intent(out)          :: ierr
          integer(int32), intent(in), optional :: device_id
          integer(int64), intent(in), optional :: lbounds(2)
#if defined __DXL_CUDAF
          integer(kind=c_int) :: info
#endif
          integer(int64) :: dummy
          type(c_ptr) :: c_dev_ptr
          integer(int64), pointer, contiguous :: fptr(:,:)
#if defined __DXL_OPENMP_GPU
          integer(int32) :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) ierr = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local = device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
          if (present(lbounds)) then
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, fptr, [dimensions(1), dimensions(2)])
                   dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                           lbounds(2):lbounds(2)+dimensions(2)-1_int64) => fptr
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                                                             lbounds(2):lbounds(2)+dimensions(2)-1_int64), stat = ierr )
#endif
          else
             !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, dev_ptr, [dimensions(1), dimensions(2)])
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(dimensions(1),&
                                                     dimensions(2)), stat = ierr )
#endif
          endif
          !
      end subroutine i8_devxlib_malloc_alloc_i2d
      !
      module subroutine i8_devxlib_malloc_alloc_i3d(dev_ptr, dimensions, ierr, device_id, lbounds)
          implicit none
          !
          integer(int64), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:,:)
          integer(int64), intent(in)           :: dimensions(3)
          integer(int32), intent(out)          :: ierr
          integer(int32), intent(in), optional :: device_id
          integer(int64), intent(in), optional :: lbounds(3)
#if defined __DXL_CUDAF
          integer(kind=c_int) :: info
#endif
          integer(int64) :: dummy
          type(c_ptr) :: c_dev_ptr
          integer(int64), pointer, contiguous :: fptr(:,:,:)
#if defined __DXL_OPENMP_GPU
          integer(int32) :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) ierr = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local = device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
          if (present(lbounds)) then
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, fptr, [dimensions(1), dimensions(2), dimensions(3)])
                   dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                           lbounds(2):lbounds(2)+dimensions(2)-1_int64,&
                           lbounds(3):lbounds(3)+dimensions(3)-1_int64) => fptr
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                                                             lbounds(2):lbounds(2)+dimensions(2)-1_int64,&
                                                             lbounds(3):lbounds(3)+dimensions(3)-1_int64), stat = ierr )
#endif
          else
             !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, dev_ptr, [dimensions(1), dimensions(2), dimensions(3)])
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(dimensions(1),&
                                                     dimensions(2),&
                                                     dimensions(3)), stat = ierr )
#endif
          endif
          !
      end subroutine i8_devxlib_malloc_alloc_i3d
      !
      module subroutine i8_devxlib_malloc_alloc_i4d(dev_ptr, dimensions, ierr, device_id, lbounds)
          implicit none
          !
          integer(int64), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:,:,:)
          integer(int64), intent(in)           :: dimensions(4)
          integer(int32), intent(out)          :: ierr
          integer(int32), intent(in), optional :: device_id
          integer(int64), intent(in), optional :: lbounds(4)
#if defined __DXL_CUDAF
          integer(kind=c_int) :: info
#endif
          integer(int64) :: dummy
          type(c_ptr) :: c_dev_ptr
          integer(int64), pointer, contiguous :: fptr(:,:,:,:)
#if defined __DXL_OPENMP_GPU
          integer(int32) :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) ierr = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local = device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
          if (present(lbounds)) then
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, fptr, [dimensions(1), dimensions(2), dimensions(3), dimensions(4)])
                   dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                           lbounds(2):lbounds(2)+dimensions(2)-1_int64,&
                           lbounds(3):lbounds(3)+dimensions(3)-1_int64,&
                           lbounds(4):lbounds(4)+dimensions(4)-1_int64) => fptr
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                                                             lbounds(2):lbounds(2)+dimensions(2)-1_int64,&
                                                             lbounds(3):lbounds(3)+dimensions(3)-1_int64,&
                                                             lbounds(4):lbounds(4)+dimensions(4)-1_int64), stat = ierr )
#endif
          else
             !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, dev_ptr, [dimensions(1), dimensions(2), dimensions(3), dimensions(4)])
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(dimensions(1),&
                                                     dimensions(2),&
                                                     dimensions(3),&
                                                     dimensions(4)), stat = ierr )
#endif
          endif
          !
      end subroutine i8_devxlib_malloc_alloc_i4d
      !
      module subroutine i8_devxlib_malloc_alloc_i5d(dev_ptr, dimensions, ierr, device_id, lbounds)
          implicit none
          !
          integer(int64), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:,:,:,:)
          integer(int64), intent(in)           :: dimensions(5)
          integer(int32), intent(out)          :: ierr
          integer(int32), intent(in), optional :: device_id
          integer(int64), intent(in), optional :: lbounds(5)
#if defined __DXL_CUDAF
          integer(kind=c_int) :: info
#endif
          integer(int64) :: dummy
          type(c_ptr) :: c_dev_ptr
          integer(int64), pointer, contiguous :: fptr(:,:,:,:,:)
#if defined __DXL_OPENMP_GPU
          integer(int32) :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) ierr = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local = device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
          if (present(lbounds)) then
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, fptr, [dimensions(1), dimensions(2), dimensions(3), dimensions(4), &
                                                     dimensions(5)])
                   dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                           lbounds(2):lbounds(2)+dimensions(2)-1_int64,&
                           lbounds(3):lbounds(3)+dimensions(3)-1_int64,&
                           lbounds(4):lbounds(4)+dimensions(4)-1_int64,&
                           lbounds(5):lbounds(5)+dimensions(5)-1_int64) => fptr
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                                                             lbounds(2):lbounds(2)+dimensions(2)-1_int64,&
                                                             lbounds(3):lbounds(3)+dimensions(3)-1_int64,&
                                                             lbounds(4):lbounds(4)+dimensions(4)-1_int64,&
                                                             lbounds(5):lbounds(5)+dimensions(5)-1_int64), stat = ierr )
#endif
          else
             !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, dev_ptr, [dimensions(1), dimensions(2), dimensions(3), dimensions(4), &
                                                         dimensions(5)])
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(dimensions(1),&
                                                     dimensions(2),&
                                                     dimensions(3),&
                                                     dimensions(4),&
                                                     dimensions(5)), stat = ierr )
#endif
          endif
          !
      end subroutine i8_devxlib_malloc_alloc_i5d
      !
      module subroutine i8_devxlib_malloc_alloc_i6d(dev_ptr, dimensions, ierr, device_id, lbounds)
          implicit none
          !
          integer(int64), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:,:,:,:,:)
          integer(int64), intent(in)           :: dimensions(6)
          integer(int32), intent(out)          :: ierr
          integer(int32), intent(in), optional :: device_id
          integer(int64), intent(in), optional :: lbounds(6)
#if defined __DXL_CUDAF
          integer(kind=c_int) :: info
#endif
          integer(int64) :: dummy
          type(c_ptr) :: c_dev_ptr
          integer(int64), pointer, contiguous :: fptr(:,:,:,:,:,:)
#if defined __DXL_OPENMP_GPU
          integer(int32) :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) ierr = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local = device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
          if (present(lbounds)) then
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, fptr, [dimensions(1), dimensions(2), dimensions(3), dimensions(4), &
                                                     dimensions(5), dimensions(6)])
                   dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                           lbounds(2):lbounds(2)+dimensions(2)-1_int64,&
                           lbounds(3):lbounds(3)+dimensions(3)-1_int64,&
                           lbounds(4):lbounds(4)+dimensions(4)-1_int64,&
                           lbounds(5):lbounds(5)+dimensions(5)-1_int64,&
                           lbounds(6):lbounds(6)+dimensions(6)-1_int64) => fptr
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                                                             lbounds(2):lbounds(2)+dimensions(2)-1_int64,&
                                                             lbounds(3):lbounds(3)+dimensions(3)-1_int64,&
                                                             lbounds(4):lbounds(4)+dimensions(4)-1_int64,&
                                                             lbounds(5):lbounds(5)+dimensions(5)-1_int64,&
                                                             lbounds(6):lbounds(6)+dimensions(6)-1_int64), stat = ierr )
#endif
          else
             !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, dev_ptr, [dimensions(1), dimensions(2), dimensions(3), dimensions(4), &
                                                         dimensions(5), dimensions(6)])
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(dimensions(1),&
                                                     dimensions(2),&
                                                     dimensions(3),&
                                                     dimensions(4),&
                                                     dimensions(5),&
                                                     dimensions(6)), stat = ierr )
#endif
          endif
          !
      end subroutine i8_devxlib_malloc_alloc_i6d
      !
      module subroutine l4_devxlib_malloc_alloc_l1d(dev_ptr, dimensions, ierr, device_id, lbounds)
          implicit none
          !
          logical(int32), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:)
          integer(int64), intent(in)           :: dimensions
          integer(int32), intent(out)          :: ierr
          integer(int32), intent(in), optional :: device_id
          integer(int64), intent(in), optional :: lbounds
#if defined __DXL_CUDAF
          integer(kind=c_int) :: info
#endif
          logical(int32) :: dummy
          type(c_ptr) :: c_dev_ptr
          logical(int32), pointer, contiguous :: fptr(:)
#if defined __DXL_OPENMP_GPU
          integer(int32) :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) ierr = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local = device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
          if (present(lbounds)) then
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * dimensions / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * dimensions / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * dimensions / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, fptr, [dimensions])
                   dev_ptr(lbounds:lbounds+dimensions-1_int64) => fptr
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(lbounds:lbounds+dimensions-1_int64), stat = ierr )
#endif
          else
             !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * dimensions / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * dimensions / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * dimensions / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, dev_ptr, [dimensions])
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(dimensions), stat = ierr )
#endif
          endif
          !
      end subroutine l4_devxlib_malloc_alloc_l1d
      !
      module subroutine l4_devxlib_malloc_alloc_l2d(dev_ptr, dimensions, ierr, device_id, lbounds)
          implicit none
          !
          logical(int32), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:)
          integer(int64), intent(in)           :: dimensions(2)
          integer(int32), intent(out)          :: ierr
          integer(int32), intent(in), optional :: device_id
          integer(int64), intent(in), optional :: lbounds(2)
#if defined __DXL_CUDAF
          integer(kind=c_int) :: info
#endif
          logical(int32) :: dummy
          type(c_ptr) :: c_dev_ptr
          logical(int32), pointer, contiguous :: fptr(:,:)
#if defined __DXL_OPENMP_GPU
          integer(int32) :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) ierr = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local = device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
          if (present(lbounds)) then
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, fptr, [dimensions(1), dimensions(2)])
                   dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                           lbounds(2):lbounds(2)+dimensions(2)-1_int64) => fptr
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                                                             lbounds(2):lbounds(2)+dimensions(2)-1_int64), stat = ierr )
#endif
          else
             !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, dev_ptr, [dimensions(1), dimensions(2)])
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(dimensions(1),&
                                                     dimensions(2)), stat = ierr )
#endif
          endif
          !
      end subroutine l4_devxlib_malloc_alloc_l2d
      !
      module subroutine l4_devxlib_malloc_alloc_l3d(dev_ptr, dimensions, ierr, device_id, lbounds)
          implicit none
          !
          logical(int32), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:,:)
          integer(int64), intent(in)           :: dimensions(3)
          integer(int32), intent(out)          :: ierr
          integer(int32), intent(in), optional :: device_id
          integer(int64), intent(in), optional :: lbounds(3)
#if defined __DXL_CUDAF
          integer(kind=c_int) :: info
#endif
          logical(int32) :: dummy
          type(c_ptr) :: c_dev_ptr
          logical(int32), pointer, contiguous :: fptr(:,:,:)
#if defined __DXL_OPENMP_GPU
          integer(int32) :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) ierr = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local = device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
          if (present(lbounds)) then
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, fptr, [dimensions(1), dimensions(2), dimensions(3)])
                   dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                           lbounds(2):lbounds(2)+dimensions(2)-1_int64,&
                           lbounds(3):lbounds(3)+dimensions(3)-1_int64) => fptr
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                                                             lbounds(2):lbounds(2)+dimensions(2)-1_int64,&
                                                             lbounds(3):lbounds(3)+dimensions(3)-1_int64), stat = ierr )
#endif
          else
             !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, dev_ptr, [dimensions(1), dimensions(2), dimensions(3)])
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(dimensions(1),&
                                                     dimensions(2),&
                                                     dimensions(3)), stat = ierr )
#endif
          endif
          !
      end subroutine l4_devxlib_malloc_alloc_l3d
      !
      module subroutine l4_devxlib_malloc_alloc_l4d(dev_ptr, dimensions, ierr, device_id, lbounds)
          implicit none
          !
          logical(int32), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:,:,:)
          integer(int64), intent(in)           :: dimensions(4)
          integer(int32), intent(out)          :: ierr
          integer(int32), intent(in), optional :: device_id
          integer(int64), intent(in), optional :: lbounds(4)
#if defined __DXL_CUDAF
          integer(kind=c_int) :: info
#endif
          logical(int32) :: dummy
          type(c_ptr) :: c_dev_ptr
          logical(int32), pointer, contiguous :: fptr(:,:,:,:)
#if defined __DXL_OPENMP_GPU
          integer(int32) :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) ierr = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local = device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
          if (present(lbounds)) then
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, fptr, [dimensions(1), dimensions(2), dimensions(3), dimensions(4)])
                   dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                           lbounds(2):lbounds(2)+dimensions(2)-1_int64,&
                           lbounds(3):lbounds(3)+dimensions(3)-1_int64,&
                           lbounds(4):lbounds(4)+dimensions(4)-1_int64) => fptr
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                                                             lbounds(2):lbounds(2)+dimensions(2)-1_int64,&
                                                             lbounds(3):lbounds(3)+dimensions(3)-1_int64,&
                                                             lbounds(4):lbounds(4)+dimensions(4)-1_int64), stat = ierr )
#endif
          else
             !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, dev_ptr, [dimensions(1), dimensions(2), dimensions(3), dimensions(4)])
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(dimensions(1),&
                                                     dimensions(2),&
                                                     dimensions(3),&
                                                     dimensions(4)), stat = ierr )
#endif
          endif
          !
      end subroutine l4_devxlib_malloc_alloc_l4d
      !
      module subroutine l4_devxlib_malloc_alloc_l5d(dev_ptr, dimensions, ierr, device_id, lbounds)
          implicit none
          !
          logical(int32), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:,:,:,:)
          integer(int64), intent(in)           :: dimensions(5)
          integer(int32), intent(out)          :: ierr
          integer(int32), intent(in), optional :: device_id
          integer(int64), intent(in), optional :: lbounds(5)
#if defined __DXL_CUDAF
          integer(kind=c_int) :: info
#endif
          logical(int32) :: dummy
          type(c_ptr) :: c_dev_ptr
          logical(int32), pointer, contiguous :: fptr(:,:,:,:,:)
#if defined __DXL_OPENMP_GPU
          integer(int32) :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) ierr = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local = device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
          if (present(lbounds)) then
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, fptr, [dimensions(1), dimensions(2), dimensions(3), dimensions(4), &
                                                     dimensions(5)])
                   dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                           lbounds(2):lbounds(2)+dimensions(2)-1_int64,&
                           lbounds(3):lbounds(3)+dimensions(3)-1_int64,&
                           lbounds(4):lbounds(4)+dimensions(4)-1_int64,&
                           lbounds(5):lbounds(5)+dimensions(5)-1_int64) => fptr
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                                                             lbounds(2):lbounds(2)+dimensions(2)-1_int64,&
                                                             lbounds(3):lbounds(3)+dimensions(3)-1_int64,&
                                                             lbounds(4):lbounds(4)+dimensions(4)-1_int64,&
                                                             lbounds(5):lbounds(5)+dimensions(5)-1_int64), stat = ierr )
#endif
          else
             !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, dev_ptr, [dimensions(1), dimensions(2), dimensions(3), dimensions(4), &
                                                         dimensions(5)])
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(dimensions(1),&
                                                     dimensions(2),&
                                                     dimensions(3),&
                                                     dimensions(4),&
                                                     dimensions(5)), stat = ierr )
#endif
          endif
          !
      end subroutine l4_devxlib_malloc_alloc_l5d
      !
      module subroutine l4_devxlib_malloc_alloc_l6d(dev_ptr, dimensions, ierr, device_id, lbounds)
          implicit none
          !
          logical(int32), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:,:,:,:,:)
          integer(int64), intent(in)           :: dimensions(6)
          integer(int32), intent(out)          :: ierr
          integer(int32), intent(in), optional :: device_id
          integer(int64), intent(in), optional :: lbounds(6)
#if defined __DXL_CUDAF
          integer(kind=c_int) :: info
#endif
          logical(int32) :: dummy
          type(c_ptr) :: c_dev_ptr
          logical(int32), pointer, contiguous :: fptr(:,:,:,:,:,:)
#if defined __DXL_OPENMP_GPU
          integer(int32) :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) ierr = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local = device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
          if (present(lbounds)) then
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, fptr, [dimensions(1), dimensions(2), dimensions(3), dimensions(4), &
                                                     dimensions(5), dimensions(6)])
                   dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                           lbounds(2):lbounds(2)+dimensions(2)-1_int64,&
                           lbounds(3):lbounds(3)+dimensions(3)-1_int64,&
                           lbounds(4):lbounds(4)+dimensions(4)-1_int64,&
                           lbounds(5):lbounds(5)+dimensions(5)-1_int64,&
                           lbounds(6):lbounds(6)+dimensions(6)-1_int64) => fptr
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(lbounds(1):lbounds(1)+dimensions(1)-1_int64,&
                                                             lbounds(2):lbounds(2)+dimensions(2)-1_int64,&
                                                             lbounds(3):lbounds(3)+dimensions(3)-1_int64,&
                                                             lbounds(4):lbounds(4)+dimensions(4)-1_int64,&
                                                             lbounds(5):lbounds(5)+dimensions(5)-1_int64,&
                                                             lbounds(6):lbounds(6)+dimensions(6)-1_int64), stat = ierr )
#endif
          else
             !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
             if (.not. associated(dev_ptr)) then
#  if defined __DXL_CUDAF
                info = cudaMalloc_f(c_dev_ptr,int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENACC
                c_dev_ptr = acc_malloc_f(int(storage_size(dummy) * product(dimensions) / 8, c_size_t))
#  elif defined __DXL_OPENMP_GPU
                c_dev_ptr = omp_target_alloc(int(storage_size(dummy) * product(dimensions) / 8, c_size_t), device_id_local)
#  endif
                if (c_associated(c_dev_ptr)) then
                   call c_f_pointer(c_dev_ptr, dev_ptr, [dimensions(1), dimensions(2), dimensions(3), dimensions(4), &
                                                         dimensions(5), dimensions(6)])
                   ierr = 0
                else
                   ierr = 1000
                endif
             endif
#else
             if (.not.associated(dev_ptr)) allocate( dev_ptr(dimensions(1),&
                                                     dimensions(2),&
                                                     dimensions(3),&
                                                     dimensions(4),&
                                                     dimensions(5),&
                                                     dimensions(6)), stat = ierr )
#endif
          endif
          !
      end subroutine l4_devxlib_malloc_alloc_l6d
      !

endsubmodule devxlib_malloc_alloc

!
! Copyright (C) 2022, MaX CoE
! Distributed under the MIT License 
! (license terms are at http://opensource.org/licenses/MIT).
!
!--
!
! Utility functions to perform memory deallocation on the device
! using CUDA-Fortran, OpenACC or OpenMP Offload
!
!==================================================================
!==================================================================
! *DO NOT EDIT*: automatically generated from devxlib_malloc_free.jf90
!==================================================================
!==================================================================
!
#include<devxlib_macros.h>
#include<devxlib_defs.h>
!
!=======================================
!
submodule (devxlib_malloc) devxlib_malloc_free

   implicit none

   contains
!
      module subroutine sp_devxlib_malloc_free_r1d(dev_ptr, device_id)
          implicit none
          !
          real(real32), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:)
          integer, optional, intent(in)  :: device_id
#if defined __DXL_CUDAF
          integer :: istat
          integer(kind=c_int) :: info
#endif
#if defined __DXL_OPENMP_GPU
          integer :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) istat = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local= device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
          if (associated(dev_ptr)) then
#if defined __DXL_CUDAF
             info = cudaFree_f(c_loc(dev_ptr))
#elif defined __DXL_OPENACC
             call acc_free_f(c_loc(dev_ptr))
#elif defined __DXL_OPENMP_GPU
             call omp_target_free(c_loc(dev_ptr), device_id_local)
#endif
             nullify(dev_ptr)
          endif
#else
          if (associated(dev_ptr)) deallocate( dev_ptr)
#endif
          !
      end subroutine sp_devxlib_malloc_free_r1d
      !
!
      module subroutine sp_devxlib_malloc_free_r2d(dev_ptr, device_id)
          implicit none
          !
          real(real32), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:)
          integer, optional, intent(in)  :: device_id
#if defined __DXL_CUDAF
          integer :: istat
          integer(kind=c_int) :: info
#endif
#if defined __DXL_OPENMP_GPU
          integer :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) istat = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local= device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
          if (associated(dev_ptr)) then
#if defined __DXL_CUDAF
             info = cudaFree_f(c_loc(dev_ptr))
#elif defined __DXL_OPENACC
             call acc_free_f(c_loc(dev_ptr))
#elif defined __DXL_OPENMP_GPU
             call omp_target_free(c_loc(dev_ptr), device_id_local)
#endif
             nullify(dev_ptr)
          endif
#else
          if (associated(dev_ptr)) deallocate( dev_ptr)
#endif
          !
      end subroutine sp_devxlib_malloc_free_r2d
      !
!
      module subroutine sp_devxlib_malloc_free_r3d(dev_ptr, device_id)
          implicit none
          !
          real(real32), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:,:)
          integer, optional, intent(in)  :: device_id
#if defined __DXL_CUDAF
          integer :: istat
          integer(kind=c_int) :: info
#endif
#if defined __DXL_OPENMP_GPU
          integer :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) istat = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local= device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
          if (associated(dev_ptr)) then
#if defined __DXL_CUDAF
             info = cudaFree_f(c_loc(dev_ptr))
#elif defined __DXL_OPENACC
             call acc_free_f(c_loc(dev_ptr))
#elif defined __DXL_OPENMP_GPU
             call omp_target_free(c_loc(dev_ptr), device_id_local)
#endif
             nullify(dev_ptr)
          endif
#else
          if (associated(dev_ptr)) deallocate( dev_ptr)
#endif
          !
      end subroutine sp_devxlib_malloc_free_r3d
      !
!
      module subroutine sp_devxlib_malloc_free_r4d(dev_ptr, device_id)
          implicit none
          !
          real(real32), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:,:,:)
          integer, optional, intent(in)  :: device_id
#if defined __DXL_CUDAF
          integer :: istat
          integer(kind=c_int) :: info
#endif
#if defined __DXL_OPENMP_GPU
          integer :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) istat = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local= device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
          if (associated(dev_ptr)) then
#if defined __DXL_CUDAF
             info = cudaFree_f(c_loc(dev_ptr))
#elif defined __DXL_OPENACC
             call acc_free_f(c_loc(dev_ptr))
#elif defined __DXL_OPENMP_GPU
             call omp_target_free(c_loc(dev_ptr), device_id_local)
#endif
             nullify(dev_ptr)
          endif
#else
          if (associated(dev_ptr)) deallocate( dev_ptr)
#endif
          !
      end subroutine sp_devxlib_malloc_free_r4d
      !
!
      module subroutine sp_devxlib_malloc_free_r5d(dev_ptr, device_id)
          implicit none
          !
          real(real32), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:,:,:,:)
          integer, optional, intent(in)  :: device_id
#if defined __DXL_CUDAF
          integer :: istat
          integer(kind=c_int) :: info
#endif
#if defined __DXL_OPENMP_GPU
          integer :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) istat = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local= device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
          if (associated(dev_ptr)) then
#if defined __DXL_CUDAF
             info = cudaFree_f(c_loc(dev_ptr))
#elif defined __DXL_OPENACC
             call acc_free_f(c_loc(dev_ptr))
#elif defined __DXL_OPENMP_GPU
             call omp_target_free(c_loc(dev_ptr), device_id_local)
#endif
             nullify(dev_ptr)
          endif
#else
          if (associated(dev_ptr)) deallocate( dev_ptr)
#endif
          !
      end subroutine sp_devxlib_malloc_free_r5d
      !
!
      module subroutine sp_devxlib_malloc_free_r6d(dev_ptr, device_id)
          implicit none
          !
          real(real32), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:,:,:,:,:)
          integer, optional, intent(in)  :: device_id
#if defined __DXL_CUDAF
          integer :: istat
          integer(kind=c_int) :: info
#endif
#if defined __DXL_OPENMP_GPU
          integer :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) istat = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local= device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
          if (associated(dev_ptr)) then
#if defined __DXL_CUDAF
             info = cudaFree_f(c_loc(dev_ptr))
#elif defined __DXL_OPENACC
             call acc_free_f(c_loc(dev_ptr))
#elif defined __DXL_OPENMP_GPU
             call omp_target_free(c_loc(dev_ptr), device_id_local)
#endif
             nullify(dev_ptr)
          endif
#else
          if (associated(dev_ptr)) deallocate( dev_ptr)
#endif
          !
      end subroutine sp_devxlib_malloc_free_r6d
      !
!
      module subroutine dp_devxlib_malloc_free_r1d(dev_ptr, device_id)
          implicit none
          !
          real(real64), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:)
          integer, optional, intent(in)  :: device_id
#if defined __DXL_CUDAF
          integer :: istat
          integer(kind=c_int) :: info
#endif
#if defined __DXL_OPENMP_GPU
          integer :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) istat = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local= device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
          if (associated(dev_ptr)) then
#if defined __DXL_CUDAF
             info = cudaFree_f(c_loc(dev_ptr))
#elif defined __DXL_OPENACC
             call acc_free_f(c_loc(dev_ptr))
#elif defined __DXL_OPENMP_GPU
             call omp_target_free(c_loc(dev_ptr), device_id_local)
#endif
             nullify(dev_ptr)
          endif
#else
          if (associated(dev_ptr)) deallocate( dev_ptr)
#endif
          !
      end subroutine dp_devxlib_malloc_free_r1d
      !
!
      module subroutine dp_devxlib_malloc_free_r2d(dev_ptr, device_id)
          implicit none
          !
          real(real64), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:)
          integer, optional, intent(in)  :: device_id
#if defined __DXL_CUDAF
          integer :: istat
          integer(kind=c_int) :: info
#endif
#if defined __DXL_OPENMP_GPU
          integer :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) istat = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local= device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
          if (associated(dev_ptr)) then
#if defined __DXL_CUDAF
             info = cudaFree_f(c_loc(dev_ptr))
#elif defined __DXL_OPENACC
             call acc_free_f(c_loc(dev_ptr))
#elif defined __DXL_OPENMP_GPU
             call omp_target_free(c_loc(dev_ptr), device_id_local)
#endif
             nullify(dev_ptr)
          endif
#else
          if (associated(dev_ptr)) deallocate( dev_ptr)
#endif
          !
      end subroutine dp_devxlib_malloc_free_r2d
      !
!
      module subroutine dp_devxlib_malloc_free_r3d(dev_ptr, device_id)
          implicit none
          !
          real(real64), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:,:)
          integer, optional, intent(in)  :: device_id
#if defined __DXL_CUDAF
          integer :: istat
          integer(kind=c_int) :: info
#endif
#if defined __DXL_OPENMP_GPU
          integer :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) istat = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local= device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
          if (associated(dev_ptr)) then
#if defined __DXL_CUDAF
             info = cudaFree_f(c_loc(dev_ptr))
#elif defined __DXL_OPENACC
             call acc_free_f(c_loc(dev_ptr))
#elif defined __DXL_OPENMP_GPU
             call omp_target_free(c_loc(dev_ptr), device_id_local)
#endif
             nullify(dev_ptr)
          endif
#else
          if (associated(dev_ptr)) deallocate( dev_ptr)
#endif
          !
      end subroutine dp_devxlib_malloc_free_r3d
      !
!
      module subroutine dp_devxlib_malloc_free_r4d(dev_ptr, device_id)
          implicit none
          !
          real(real64), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:,:,:)
          integer, optional, intent(in)  :: device_id
#if defined __DXL_CUDAF
          integer :: istat
          integer(kind=c_int) :: info
#endif
#if defined __DXL_OPENMP_GPU
          integer :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) istat = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local= device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
          if (associated(dev_ptr)) then
#if defined __DXL_CUDAF
             info = cudaFree_f(c_loc(dev_ptr))
#elif defined __DXL_OPENACC
             call acc_free_f(c_loc(dev_ptr))
#elif defined __DXL_OPENMP_GPU
             call omp_target_free(c_loc(dev_ptr), device_id_local)
#endif
             nullify(dev_ptr)
          endif
#else
          if (associated(dev_ptr)) deallocate( dev_ptr)
#endif
          !
      end subroutine dp_devxlib_malloc_free_r4d
      !
!
      module subroutine dp_devxlib_malloc_free_r5d(dev_ptr, device_id)
          implicit none
          !
          real(real64), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:,:,:,:)
          integer, optional, intent(in)  :: device_id
#if defined __DXL_CUDAF
          integer :: istat
          integer(kind=c_int) :: info
#endif
#if defined __DXL_OPENMP_GPU
          integer :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) istat = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local= device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
          if (associated(dev_ptr)) then
#if defined __DXL_CUDAF
             info = cudaFree_f(c_loc(dev_ptr))
#elif defined __DXL_OPENACC
             call acc_free_f(c_loc(dev_ptr))
#elif defined __DXL_OPENMP_GPU
             call omp_target_free(c_loc(dev_ptr), device_id_local)
#endif
             nullify(dev_ptr)
          endif
#else
          if (associated(dev_ptr)) deallocate( dev_ptr)
#endif
          !
      end subroutine dp_devxlib_malloc_free_r5d
      !
!
      module subroutine dp_devxlib_malloc_free_r6d(dev_ptr, device_id)
          implicit none
          !
          real(real64), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:,:,:,:,:)
          integer, optional, intent(in)  :: device_id
#if defined __DXL_CUDAF
          integer :: istat
          integer(kind=c_int) :: info
#endif
#if defined __DXL_OPENMP_GPU
          integer :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) istat = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local= device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
          if (associated(dev_ptr)) then
#if defined __DXL_CUDAF
             info = cudaFree_f(c_loc(dev_ptr))
#elif defined __DXL_OPENACC
             call acc_free_f(c_loc(dev_ptr))
#elif defined __DXL_OPENMP_GPU
             call omp_target_free(c_loc(dev_ptr), device_id_local)
#endif
             nullify(dev_ptr)
          endif
#else
          if (associated(dev_ptr)) deallocate( dev_ptr)
#endif
          !
      end subroutine dp_devxlib_malloc_free_r6d
      !
!
      module subroutine sp_devxlib_malloc_free_c1d(dev_ptr, device_id)
          implicit none
          !
          complex(real32), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:)
          integer, optional, intent(in)  :: device_id
#if defined __DXL_CUDAF
          integer :: istat
          integer(kind=c_int) :: info
#endif
#if defined __DXL_OPENMP_GPU
          integer :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) istat = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local= device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
          if (associated(dev_ptr)) then
#if defined __DXL_CUDAF
             info = cudaFree_f(c_loc(dev_ptr))
#elif defined __DXL_OPENACC
             call acc_free_f(c_loc(dev_ptr))
#elif defined __DXL_OPENMP_GPU
             call omp_target_free(c_loc(dev_ptr), device_id_local)
#endif
             nullify(dev_ptr)
          endif
#else
          if (associated(dev_ptr)) deallocate( dev_ptr)
#endif
          !
      end subroutine sp_devxlib_malloc_free_c1d
      !
!
      module subroutine sp_devxlib_malloc_free_c2d(dev_ptr, device_id)
          implicit none
          !
          complex(real32), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:)
          integer, optional, intent(in)  :: device_id
#if defined __DXL_CUDAF
          integer :: istat
          integer(kind=c_int) :: info
#endif
#if defined __DXL_OPENMP_GPU
          integer :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) istat = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local= device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
          if (associated(dev_ptr)) then
#if defined __DXL_CUDAF
             info = cudaFree_f(c_loc(dev_ptr))
#elif defined __DXL_OPENACC
             call acc_free_f(c_loc(dev_ptr))
#elif defined __DXL_OPENMP_GPU
             call omp_target_free(c_loc(dev_ptr), device_id_local)
#endif
             nullify(dev_ptr)
          endif
#else
          if (associated(dev_ptr)) deallocate( dev_ptr)
#endif
          !
      end subroutine sp_devxlib_malloc_free_c2d
      !
!
      module subroutine sp_devxlib_malloc_free_c3d(dev_ptr, device_id)
          implicit none
          !
          complex(real32), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:,:)
          integer, optional, intent(in)  :: device_id
#if defined __DXL_CUDAF
          integer :: istat
          integer(kind=c_int) :: info
#endif
#if defined __DXL_OPENMP_GPU
          integer :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) istat = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local= device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
          if (associated(dev_ptr)) then
#if defined __DXL_CUDAF
             info = cudaFree_f(c_loc(dev_ptr))
#elif defined __DXL_OPENACC
             call acc_free_f(c_loc(dev_ptr))
#elif defined __DXL_OPENMP_GPU
             call omp_target_free(c_loc(dev_ptr), device_id_local)
#endif
             nullify(dev_ptr)
          endif
#else
          if (associated(dev_ptr)) deallocate( dev_ptr)
#endif
          !
      end subroutine sp_devxlib_malloc_free_c3d
      !
!
      module subroutine sp_devxlib_malloc_free_c4d(dev_ptr, device_id)
          implicit none
          !
          complex(real32), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:,:,:)
          integer, optional, intent(in)  :: device_id
#if defined __DXL_CUDAF
          integer :: istat
          integer(kind=c_int) :: info
#endif
#if defined __DXL_OPENMP_GPU
          integer :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) istat = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local= device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
          if (associated(dev_ptr)) then
#if defined __DXL_CUDAF
             info = cudaFree_f(c_loc(dev_ptr))
#elif defined __DXL_OPENACC
             call acc_free_f(c_loc(dev_ptr))
#elif defined __DXL_OPENMP_GPU
             call omp_target_free(c_loc(dev_ptr), device_id_local)
#endif
             nullify(dev_ptr)
          endif
#else
          if (associated(dev_ptr)) deallocate( dev_ptr)
#endif
          !
      end subroutine sp_devxlib_malloc_free_c4d
      !
!
      module subroutine sp_devxlib_malloc_free_c5d(dev_ptr, device_id)
          implicit none
          !
          complex(real32), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:,:,:,:)
          integer, optional, intent(in)  :: device_id
#if defined __DXL_CUDAF
          integer :: istat
          integer(kind=c_int) :: info
#endif
#if defined __DXL_OPENMP_GPU
          integer :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) istat = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local= device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
          if (associated(dev_ptr)) then
#if defined __DXL_CUDAF
             info = cudaFree_f(c_loc(dev_ptr))
#elif defined __DXL_OPENACC
             call acc_free_f(c_loc(dev_ptr))
#elif defined __DXL_OPENMP_GPU
             call omp_target_free(c_loc(dev_ptr), device_id_local)
#endif
             nullify(dev_ptr)
          endif
#else
          if (associated(dev_ptr)) deallocate( dev_ptr)
#endif
          !
      end subroutine sp_devxlib_malloc_free_c5d
      !
!
      module subroutine sp_devxlib_malloc_free_c6d(dev_ptr, device_id)
          implicit none
          !
          complex(real32), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:,:,:,:,:)
          integer, optional, intent(in)  :: device_id
#if defined __DXL_CUDAF
          integer :: istat
          integer(kind=c_int) :: info
#endif
#if defined __DXL_OPENMP_GPU
          integer :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) istat = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local= device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
          if (associated(dev_ptr)) then
#if defined __DXL_CUDAF
             info = cudaFree_f(c_loc(dev_ptr))
#elif defined __DXL_OPENACC
             call acc_free_f(c_loc(dev_ptr))
#elif defined __DXL_OPENMP_GPU
             call omp_target_free(c_loc(dev_ptr), device_id_local)
#endif
             nullify(dev_ptr)
          endif
#else
          if (associated(dev_ptr)) deallocate( dev_ptr)
#endif
          !
      end subroutine sp_devxlib_malloc_free_c6d
      !
!
      module subroutine dp_devxlib_malloc_free_c1d(dev_ptr, device_id)
          implicit none
          !
          complex(real64), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:)
          integer, optional, intent(in)  :: device_id
#if defined __DXL_CUDAF
          integer :: istat
          integer(kind=c_int) :: info
#endif
#if defined __DXL_OPENMP_GPU
          integer :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) istat = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local= device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
          if (associated(dev_ptr)) then
#if defined __DXL_CUDAF
             info = cudaFree_f(c_loc(dev_ptr))
#elif defined __DXL_OPENACC
             call acc_free_f(c_loc(dev_ptr))
#elif defined __DXL_OPENMP_GPU
             call omp_target_free(c_loc(dev_ptr), device_id_local)
#endif
             nullify(dev_ptr)
          endif
#else
          if (associated(dev_ptr)) deallocate( dev_ptr)
#endif
          !
      end subroutine dp_devxlib_malloc_free_c1d
      !
!
      module subroutine dp_devxlib_malloc_free_c2d(dev_ptr, device_id)
          implicit none
          !
          complex(real64), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:)
          integer, optional, intent(in)  :: device_id
#if defined __DXL_CUDAF
          integer :: istat
          integer(kind=c_int) :: info
#endif
#if defined __DXL_OPENMP_GPU
          integer :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) istat = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local= device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
          if (associated(dev_ptr)) then
#if defined __DXL_CUDAF
             info = cudaFree_f(c_loc(dev_ptr))
#elif defined __DXL_OPENACC
             call acc_free_f(c_loc(dev_ptr))
#elif defined __DXL_OPENMP_GPU
             call omp_target_free(c_loc(dev_ptr), device_id_local)
#endif
             nullify(dev_ptr)
          endif
#else
          if (associated(dev_ptr)) deallocate( dev_ptr)
#endif
          !
      end subroutine dp_devxlib_malloc_free_c2d
      !
!
      module subroutine dp_devxlib_malloc_free_c3d(dev_ptr, device_id)
          implicit none
          !
          complex(real64), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:,:)
          integer, optional, intent(in)  :: device_id
#if defined __DXL_CUDAF
          integer :: istat
          integer(kind=c_int) :: info
#endif
#if defined __DXL_OPENMP_GPU
          integer :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) istat = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local= device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
          if (associated(dev_ptr)) then
#if defined __DXL_CUDAF
             info = cudaFree_f(c_loc(dev_ptr))
#elif defined __DXL_OPENACC
             call acc_free_f(c_loc(dev_ptr))
#elif defined __DXL_OPENMP_GPU
             call omp_target_free(c_loc(dev_ptr), device_id_local)
#endif
             nullify(dev_ptr)
          endif
#else
          if (associated(dev_ptr)) deallocate( dev_ptr)
#endif
          !
      end subroutine dp_devxlib_malloc_free_c3d
      !
!
      module subroutine dp_devxlib_malloc_free_c4d(dev_ptr, device_id)
          implicit none
          !
          complex(real64), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:,:,:)
          integer, optional, intent(in)  :: device_id
#if defined __DXL_CUDAF
          integer :: istat
          integer(kind=c_int) :: info
#endif
#if defined __DXL_OPENMP_GPU
          integer :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) istat = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local= device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
          if (associated(dev_ptr)) then
#if defined __DXL_CUDAF
             info = cudaFree_f(c_loc(dev_ptr))
#elif defined __DXL_OPENACC
             call acc_free_f(c_loc(dev_ptr))
#elif defined __DXL_OPENMP_GPU
             call omp_target_free(c_loc(dev_ptr), device_id_local)
#endif
             nullify(dev_ptr)
          endif
#else
          if (associated(dev_ptr)) deallocate( dev_ptr)
#endif
          !
      end subroutine dp_devxlib_malloc_free_c4d
      !
!
      module subroutine dp_devxlib_malloc_free_c5d(dev_ptr, device_id)
          implicit none
          !
          complex(real64), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:,:,:,:)
          integer, optional, intent(in)  :: device_id
#if defined __DXL_CUDAF
          integer :: istat
          integer(kind=c_int) :: info
#endif
#if defined __DXL_OPENMP_GPU
          integer :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) istat = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local= device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
          if (associated(dev_ptr)) then
#if defined __DXL_CUDAF
             info = cudaFree_f(c_loc(dev_ptr))
#elif defined __DXL_OPENACC
             call acc_free_f(c_loc(dev_ptr))
#elif defined __DXL_OPENMP_GPU
             call omp_target_free(c_loc(dev_ptr), device_id_local)
#endif
             nullify(dev_ptr)
          endif
#else
          if (associated(dev_ptr)) deallocate( dev_ptr)
#endif
          !
      end subroutine dp_devxlib_malloc_free_c5d
      !
!
      module subroutine dp_devxlib_malloc_free_c6d(dev_ptr, device_id)
          implicit none
          !
          complex(real64), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:,:,:,:,:)
          integer, optional, intent(in)  :: device_id
#if defined __DXL_CUDAF
          integer :: istat
          integer(kind=c_int) :: info
#endif
#if defined __DXL_OPENMP_GPU
          integer :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) istat = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local= device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
          if (associated(dev_ptr)) then
#if defined __DXL_CUDAF
             info = cudaFree_f(c_loc(dev_ptr))
#elif defined __DXL_OPENACC
             call acc_free_f(c_loc(dev_ptr))
#elif defined __DXL_OPENMP_GPU
             call omp_target_free(c_loc(dev_ptr), device_id_local)
#endif
             nullify(dev_ptr)
          endif
#else
          if (associated(dev_ptr)) deallocate( dev_ptr)
#endif
          !
      end subroutine dp_devxlib_malloc_free_c6d
      !
!
      module subroutine i4_devxlib_malloc_free_i1d(dev_ptr, device_id)
          implicit none
          !
          integer(int32), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:)
          integer, optional, intent(in)  :: device_id
#if defined __DXL_CUDAF
          integer :: istat
          integer(kind=c_int) :: info
#endif
#if defined __DXL_OPENMP_GPU
          integer :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) istat = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local= device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
          if (associated(dev_ptr)) then
#if defined __DXL_CUDAF
             info = cudaFree_f(c_loc(dev_ptr))
#elif defined __DXL_OPENACC
             call acc_free_f(c_loc(dev_ptr))
#elif defined __DXL_OPENMP_GPU
             call omp_target_free(c_loc(dev_ptr), device_id_local)
#endif
             nullify(dev_ptr)
          endif
#else
          if (associated(dev_ptr)) deallocate( dev_ptr)
#endif
          !
      end subroutine i4_devxlib_malloc_free_i1d
      !
!
      module subroutine i4_devxlib_malloc_free_i2d(dev_ptr, device_id)
          implicit none
          !
          integer(int32), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:)
          integer, optional, intent(in)  :: device_id
#if defined __DXL_CUDAF
          integer :: istat
          integer(kind=c_int) :: info
#endif
#if defined __DXL_OPENMP_GPU
          integer :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) istat = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local= device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
          if (associated(dev_ptr)) then
#if defined __DXL_CUDAF
             info = cudaFree_f(c_loc(dev_ptr))
#elif defined __DXL_OPENACC
             call acc_free_f(c_loc(dev_ptr))
#elif defined __DXL_OPENMP_GPU
             call omp_target_free(c_loc(dev_ptr), device_id_local)
#endif
             nullify(dev_ptr)
          endif
#else
          if (associated(dev_ptr)) deallocate( dev_ptr)
#endif
          !
      end subroutine i4_devxlib_malloc_free_i2d
      !
!
      module subroutine i4_devxlib_malloc_free_i3d(dev_ptr, device_id)
          implicit none
          !
          integer(int32), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:,:)
          integer, optional, intent(in)  :: device_id
#if defined __DXL_CUDAF
          integer :: istat
          integer(kind=c_int) :: info
#endif
#if defined __DXL_OPENMP_GPU
          integer :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) istat = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local= device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
          if (associated(dev_ptr)) then
#if defined __DXL_CUDAF
             info = cudaFree_f(c_loc(dev_ptr))
#elif defined __DXL_OPENACC
             call acc_free_f(c_loc(dev_ptr))
#elif defined __DXL_OPENMP_GPU
             call omp_target_free(c_loc(dev_ptr), device_id_local)
#endif
             nullify(dev_ptr)
          endif
#else
          if (associated(dev_ptr)) deallocate( dev_ptr)
#endif
          !
      end subroutine i4_devxlib_malloc_free_i3d
      !
!
      module subroutine i4_devxlib_malloc_free_i4d(dev_ptr, device_id)
          implicit none
          !
          integer(int32), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:,:,:)
          integer, optional, intent(in)  :: device_id
#if defined __DXL_CUDAF
          integer :: istat
          integer(kind=c_int) :: info
#endif
#if defined __DXL_OPENMP_GPU
          integer :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) istat = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local= device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
          if (associated(dev_ptr)) then
#if defined __DXL_CUDAF
             info = cudaFree_f(c_loc(dev_ptr))
#elif defined __DXL_OPENACC
             call acc_free_f(c_loc(dev_ptr))
#elif defined __DXL_OPENMP_GPU
             call omp_target_free(c_loc(dev_ptr), device_id_local)
#endif
             nullify(dev_ptr)
          endif
#else
          if (associated(dev_ptr)) deallocate( dev_ptr)
#endif
          !
      end subroutine i4_devxlib_malloc_free_i4d
      !
!
      module subroutine i4_devxlib_malloc_free_i5d(dev_ptr, device_id)
          implicit none
          !
          integer(int32), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:,:,:,:)
          integer, optional, intent(in)  :: device_id
#if defined __DXL_CUDAF
          integer :: istat
          integer(kind=c_int) :: info
#endif
#if defined __DXL_OPENMP_GPU
          integer :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) istat = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local= device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
          if (associated(dev_ptr)) then
#if defined __DXL_CUDAF
             info = cudaFree_f(c_loc(dev_ptr))
#elif defined __DXL_OPENACC
             call acc_free_f(c_loc(dev_ptr))
#elif defined __DXL_OPENMP_GPU
             call omp_target_free(c_loc(dev_ptr), device_id_local)
#endif
             nullify(dev_ptr)
          endif
#else
          if (associated(dev_ptr)) deallocate( dev_ptr)
#endif
          !
      end subroutine i4_devxlib_malloc_free_i5d
      !
!
      module subroutine i4_devxlib_malloc_free_i6d(dev_ptr, device_id)
          implicit none
          !
          integer(int32), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:,:,:,:,:)
          integer, optional, intent(in)  :: device_id
#if defined __DXL_CUDAF
          integer :: istat
          integer(kind=c_int) :: info
#endif
#if defined __DXL_OPENMP_GPU
          integer :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) istat = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local= device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
          if (associated(dev_ptr)) then
#if defined __DXL_CUDAF
             info = cudaFree_f(c_loc(dev_ptr))
#elif defined __DXL_OPENACC
             call acc_free_f(c_loc(dev_ptr))
#elif defined __DXL_OPENMP_GPU
             call omp_target_free(c_loc(dev_ptr), device_id_local)
#endif
             nullify(dev_ptr)
          endif
#else
          if (associated(dev_ptr)) deallocate( dev_ptr)
#endif
          !
      end subroutine i4_devxlib_malloc_free_i6d
      !
!
      module subroutine i8_devxlib_malloc_free_i1d(dev_ptr, device_id)
          implicit none
          !
          integer(int64), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:)
          integer, optional, intent(in)  :: device_id
#if defined __DXL_CUDAF
          integer :: istat
          integer(kind=c_int) :: info
#endif
#if defined __DXL_OPENMP_GPU
          integer :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) istat = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local= device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
          if (associated(dev_ptr)) then
#if defined __DXL_CUDAF
             info = cudaFree_f(c_loc(dev_ptr))
#elif defined __DXL_OPENACC
             call acc_free_f(c_loc(dev_ptr))
#elif defined __DXL_OPENMP_GPU
             call omp_target_free(c_loc(dev_ptr), device_id_local)
#endif
             nullify(dev_ptr)
          endif
#else
          if (associated(dev_ptr)) deallocate( dev_ptr)
#endif
          !
      end subroutine i8_devxlib_malloc_free_i1d
      !
!
      module subroutine i8_devxlib_malloc_free_i2d(dev_ptr, device_id)
          implicit none
          !
          integer(int64), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:)
          integer, optional, intent(in)  :: device_id
#if defined __DXL_CUDAF
          integer :: istat
          integer(kind=c_int) :: info
#endif
#if defined __DXL_OPENMP_GPU
          integer :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) istat = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local= device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
          if (associated(dev_ptr)) then
#if defined __DXL_CUDAF
             info = cudaFree_f(c_loc(dev_ptr))
#elif defined __DXL_OPENACC
             call acc_free_f(c_loc(dev_ptr))
#elif defined __DXL_OPENMP_GPU
             call omp_target_free(c_loc(dev_ptr), device_id_local)
#endif
             nullify(dev_ptr)
          endif
#else
          if (associated(dev_ptr)) deallocate( dev_ptr)
#endif
          !
      end subroutine i8_devxlib_malloc_free_i2d
      !
!
      module subroutine i8_devxlib_malloc_free_i3d(dev_ptr, device_id)
          implicit none
          !
          integer(int64), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:,:)
          integer, optional, intent(in)  :: device_id
#if defined __DXL_CUDAF
          integer :: istat
          integer(kind=c_int) :: info
#endif
#if defined __DXL_OPENMP_GPU
          integer :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) istat = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local= device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
          if (associated(dev_ptr)) then
#if defined __DXL_CUDAF
             info = cudaFree_f(c_loc(dev_ptr))
#elif defined __DXL_OPENACC
             call acc_free_f(c_loc(dev_ptr))
#elif defined __DXL_OPENMP_GPU
             call omp_target_free(c_loc(dev_ptr), device_id_local)
#endif
             nullify(dev_ptr)
          endif
#else
          if (associated(dev_ptr)) deallocate( dev_ptr)
#endif
          !
      end subroutine i8_devxlib_malloc_free_i3d
      !
!
      module subroutine i8_devxlib_malloc_free_i4d(dev_ptr, device_id)
          implicit none
          !
          integer(int64), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:,:,:)
          integer, optional, intent(in)  :: device_id
#if defined __DXL_CUDAF
          integer :: istat
          integer(kind=c_int) :: info
#endif
#if defined __DXL_OPENMP_GPU
          integer :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) istat = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local= device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
          if (associated(dev_ptr)) then
#if defined __DXL_CUDAF
             info = cudaFree_f(c_loc(dev_ptr))
#elif defined __DXL_OPENACC
             call acc_free_f(c_loc(dev_ptr))
#elif defined __DXL_OPENMP_GPU
             call omp_target_free(c_loc(dev_ptr), device_id_local)
#endif
             nullify(dev_ptr)
          endif
#else
          if (associated(dev_ptr)) deallocate( dev_ptr)
#endif
          !
      end subroutine i8_devxlib_malloc_free_i4d
      !
!
      module subroutine i8_devxlib_malloc_free_i5d(dev_ptr, device_id)
          implicit none
          !
          integer(int64), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:,:,:,:)
          integer, optional, intent(in)  :: device_id
#if defined __DXL_CUDAF
          integer :: istat
          integer(kind=c_int) :: info
#endif
#if defined __DXL_OPENMP_GPU
          integer :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) istat = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local= device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
          if (associated(dev_ptr)) then
#if defined __DXL_CUDAF
             info = cudaFree_f(c_loc(dev_ptr))
#elif defined __DXL_OPENACC
             call acc_free_f(c_loc(dev_ptr))
#elif defined __DXL_OPENMP_GPU
             call omp_target_free(c_loc(dev_ptr), device_id_local)
#endif
             nullify(dev_ptr)
          endif
#else
          if (associated(dev_ptr)) deallocate( dev_ptr)
#endif
          !
      end subroutine i8_devxlib_malloc_free_i5d
      !
!
      module subroutine i8_devxlib_malloc_free_i6d(dev_ptr, device_id)
          implicit none
          !
          integer(int64), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:,:,:,:,:)
          integer, optional, intent(in)  :: device_id
#if defined __DXL_CUDAF
          integer :: istat
          integer(kind=c_int) :: info
#endif
#if defined __DXL_OPENMP_GPU
          integer :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) istat = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local= device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
          if (associated(dev_ptr)) then
#if defined __DXL_CUDAF
             info = cudaFree_f(c_loc(dev_ptr))
#elif defined __DXL_OPENACC
             call acc_free_f(c_loc(dev_ptr))
#elif defined __DXL_OPENMP_GPU
             call omp_target_free(c_loc(dev_ptr), device_id_local)
#endif
             nullify(dev_ptr)
          endif
#else
          if (associated(dev_ptr)) deallocate( dev_ptr)
#endif
          !
      end subroutine i8_devxlib_malloc_free_i6d
      !
!
      module subroutine l4_devxlib_malloc_free_l1d(dev_ptr, device_id)
          implicit none
          !
          logical(int32), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:)
          integer, optional, intent(in)  :: device_id
#if defined __DXL_CUDAF
          integer :: istat
          integer(kind=c_int) :: info
#endif
#if defined __DXL_OPENMP_GPU
          integer :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) istat = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local= device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
          if (associated(dev_ptr)) then
#if defined __DXL_CUDAF
             info = cudaFree_f(c_loc(dev_ptr))
#elif defined __DXL_OPENACC
             call acc_free_f(c_loc(dev_ptr))
#elif defined __DXL_OPENMP_GPU
             call omp_target_free(c_loc(dev_ptr), device_id_local)
#endif
             nullify(dev_ptr)
          endif
#else
          if (associated(dev_ptr)) deallocate( dev_ptr)
#endif
          !
      end subroutine l4_devxlib_malloc_free_l1d
      !
!
      module subroutine l4_devxlib_malloc_free_l2d(dev_ptr, device_id)
          implicit none
          !
          logical(int32), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:)
          integer, optional, intent(in)  :: device_id
#if defined __DXL_CUDAF
          integer :: istat
          integer(kind=c_int) :: info
#endif
#if defined __DXL_OPENMP_GPU
          integer :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) istat = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local= device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
          if (associated(dev_ptr)) then
#if defined __DXL_CUDAF
             info = cudaFree_f(c_loc(dev_ptr))
#elif defined __DXL_OPENACC
             call acc_free_f(c_loc(dev_ptr))
#elif defined __DXL_OPENMP_GPU
             call omp_target_free(c_loc(dev_ptr), device_id_local)
#endif
             nullify(dev_ptr)
          endif
#else
          if (associated(dev_ptr)) deallocate( dev_ptr)
#endif
          !
      end subroutine l4_devxlib_malloc_free_l2d
      !
!
      module subroutine l4_devxlib_malloc_free_l3d(dev_ptr, device_id)
          implicit none
          !
          logical(int32), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:,:)
          integer, optional, intent(in)  :: device_id
#if defined __DXL_CUDAF
          integer :: istat
          integer(kind=c_int) :: info
#endif
#if defined __DXL_OPENMP_GPU
          integer :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) istat = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local= device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
          if (associated(dev_ptr)) then
#if defined __DXL_CUDAF
             info = cudaFree_f(c_loc(dev_ptr))
#elif defined __DXL_OPENACC
             call acc_free_f(c_loc(dev_ptr))
#elif defined __DXL_OPENMP_GPU
             call omp_target_free(c_loc(dev_ptr), device_id_local)
#endif
             nullify(dev_ptr)
          endif
#else
          if (associated(dev_ptr)) deallocate( dev_ptr)
#endif
          !
      end subroutine l4_devxlib_malloc_free_l3d
      !
!
      module subroutine l4_devxlib_malloc_free_l4d(dev_ptr, device_id)
          implicit none
          !
          logical(int32), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:,:,:)
          integer, optional, intent(in)  :: device_id
#if defined __DXL_CUDAF
          integer :: istat
          integer(kind=c_int) :: info
#endif
#if defined __DXL_OPENMP_GPU
          integer :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) istat = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local= device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
          if (associated(dev_ptr)) then
#if defined __DXL_CUDAF
             info = cudaFree_f(c_loc(dev_ptr))
#elif defined __DXL_OPENACC
             call acc_free_f(c_loc(dev_ptr))
#elif defined __DXL_OPENMP_GPU
             call omp_target_free(c_loc(dev_ptr), device_id_local)
#endif
             nullify(dev_ptr)
          endif
#else
          if (associated(dev_ptr)) deallocate( dev_ptr)
#endif
          !
      end subroutine l4_devxlib_malloc_free_l4d
      !
!
      module subroutine l4_devxlib_malloc_free_l5d(dev_ptr, device_id)
          implicit none
          !
          logical(int32), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:,:,:,:)
          integer, optional, intent(in)  :: device_id
#if defined __DXL_CUDAF
          integer :: istat
          integer(kind=c_int) :: info
#endif
#if defined __DXL_OPENMP_GPU
          integer :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) istat = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local= device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
          if (associated(dev_ptr)) then
#if defined __DXL_CUDAF
             info = cudaFree_f(c_loc(dev_ptr))
#elif defined __DXL_OPENACC
             call acc_free_f(c_loc(dev_ptr))
#elif defined __DXL_OPENMP_GPU
             call omp_target_free(c_loc(dev_ptr), device_id_local)
#endif
             nullify(dev_ptr)
          endif
#else
          if (associated(dev_ptr)) deallocate( dev_ptr)
#endif
          !
      end subroutine l4_devxlib_malloc_free_l5d
      !
!
      module subroutine l4_devxlib_malloc_free_l6d(dev_ptr, device_id)
          implicit none
          !
          logical(int32), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:,:,:,:,:)
          integer, optional, intent(in)  :: device_id
#if defined __DXL_CUDAF
          integer :: istat
          integer(kind=c_int) :: info
#endif
#if defined __DXL_OPENMP_GPU
          integer :: device_id_local
#endif
          !
#if defined __DXL_CUDAF
          if (present(device_id)) istat = cudaSetDevice(device_id)
#elif defined __DXL_OPENMP_GPU
          if (present(device_id)) then
             device_id_local= device_id
          else
             device_id_local = omp_get_default_device()
          endif
#endif
          !
#if defined __DXL_CUDAF || defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
          if (associated(dev_ptr)) then
#if defined __DXL_CUDAF
             info = cudaFree_f(c_loc(dev_ptr))
#elif defined __DXL_OPENACC
             call acc_free_f(c_loc(dev_ptr))
#elif defined __DXL_OPENMP_GPU
             call omp_target_free(c_loc(dev_ptr), device_id_local)
#endif
             nullify(dev_ptr)
          endif
#else
          if (associated(dev_ptr)) deallocate( dev_ptr)
#endif
          !
      end subroutine l4_devxlib_malloc_free_l6d
      !

endsubmodule devxlib_malloc_free

!
! Copyright (C) 2021, MaX CoE
! Distributed under the MIT License
! (license terms are at http://opensource.org/licenses/MIT).
!
!--
!
! cublas defs and interfaces
!
#include<devxlib_defs.h>
#include<devxlib_macros.h>
!
module devxlib_rocblas
  !
#if defined __DXL_ROCBLAS
  use rocblas_m
#endif
  !
  use iso_c_binding
  implicit none
  !
  type(c_ptr) :: handle
  !
end module devxlib_rocblas

!
! ===============================================================================
! PROFILING MODULE FOR RANGES
! =================================================================================
! From UtilXlib/clocks_handler.f90 of QuantumESPRESSO (v7.2)
! 14 Sep 2023 - bellenlau@cineca  
! 
!
! This module takes origin from QuantumESPRESSO inner clocks.
! It can be used to wrap routines and invoke ranges from different libraries
! By now, we support nvtx and roctx ranges for NVIDIA and AMD architectures
!
! There are three routines:
! - init_prof() to initialize the arrays checking if the range with a given name is already defined
! - start_prof() to start the range
! - stop_prof() to stop the range
!
! start and stop take two arguments. 
!       - If only the label is used, than a range with same name is looked for. 
!                - If it is found, the same colour is used. 
!                - If it is not found, a new color for the range is defined
!       - If also a number is used, than the number directly defines the color. No checks
!
! If a range with a given name is found, the color attribute of the range is the same
! These routines can be inserted into timers to start/stop library-agnostic ranges
!
!----------------------------------------------------------------------------
MODULE myprof
  !----------------------------------------------------------------------------
  !
#if defined(__PROFILE_NVTX)
  USE nvtx
#elif defined(__PROFILE_ROCTX)
  USE roctx
#endif
  !
  IMPLICIT NONE
  !
  SAVE
  !
  INTEGER, PARAMETER :: stdout = 6    ! unit connected to standard output
  INTEGER, PARAMETER :: maxevent = 64
  REAL*8, PARAMETER :: notrunning = -1.d0
  REAL*8, PARAMETER :: running = -2.d0
  !
  REAL*8 :: prof(maxevent)
  CHARACTER(len=12) :: prof_label(maxevent)
  !
  INTEGER :: nprof = 0
  LOGICAL :: no
  !
  CONTAINS
    !
    SUBROUTINE init_prof()
      IMPLICIT NONE
      !
      INTEGER :: n, ierr
      !
      !
      DO n = 1, maxevent
        !
        prof(n) = notrunning 
        prof_label(n) = ' '
        !
      END DO
      !
      RETURN

    END SUBROUTINE
    !
    SUBROUTINE start_prof(label,ncl)
      IMPLICIT NONE
      !
      CHARACTER(len=*), INTENT(IN) :: label
      INTEGER, INTENT(IN), OPTIONAL :: ncl
      !
      CHARACTER(len=12) :: label_
      INTEGER :: n

      label_ = TRIM(label)
      !  
      IF ( PRESENT(ncl) ) THEN
         !
         ! If ncl is present, does not look for a range with the same label
         !
#if defined(__PROFILE_NVTX)
         CALL nvtxStartRange(label_, ncl)
#elif defined(__PROFILE_ROCTX)
         CALL roctxStartRange(label_)
#endif
         !
         RETURN
         !
      ENDIF
      !
      ! If ncl is not present, looks for a range with same label
      !
      DO n = 1, nprof
        !
        IF (prof_label(n) == label_) THEN
          !
          ! ... found previously defined range: use the same index (color)
          !
          IF (prof(n) /= notrunning) THEN
          !            WRITE( stdout, '("start_clock: clock # ",I2," for ",A12, &
          !                           & " already started")' ) n, label_
          ELSE
            !
            prof(n) = running
            !
#if defined(__PROFILE_NVTX)
            CALL nvtxStartRange(label_, n)
#elif defined(__PROFILE_ROCTX)
            CALL roctxStartRange(label_)
#endif
            !
          END IF
          !
          RETURN
          !
        END IF
        !
      END DO
      ! 
      ! ... found a previously defined range: add a new one
      !
      IF (nprof == maxevent) THEN
        !
        WRITE (stdout, '("start_prof(",A,"): Too many events! call ignored")') label
        !
      ELSE
        !
        nprof = nprof + 1
        prof_label(nprof) = label_
        prof(nprof) = running
        !
#if defined(__PROFILE_NVTX)
        CALL nvtxStartRange(label_, nprof)
#elif defined(__PROFILE_ROCTX)
        CALL roctxStartRange(label_)
#endif
        !
      END IF
      !
      RETURN


    END SUBROUTINE
    !
    SUBROUTINE stop_prof(label,ncl)
      IMPLICIT NONE
      !
      CHARACTER(len=*), INTENT(IN) :: label
      INTEGER, INTENT(IN), OPTIONAL :: ncl
      !
      CHARACTER(len=12) :: label_
      INTEGER :: n

      label_ = trim(label)
      !
      IF ( PRESENT(ncl) ) THEN
         !
         ! If ncl is present, closes the any open range
         !
#if defined(__PROFILE_NVTX)
         CALL nvtxEndRange
#elif defined(__PROFILE_ROCTX)
         CALL roctxEndRange
#endif
         !
         RETURN
         !
      ENDIF
      !
      ! If ncl is not present, checks for an open range with same label
      !
      DO n = 1, nprof
        !
        IF (prof_label(n) == label_) THEN
          !
          ! ... found previously defined clock : check if properly initialised,
          ! ... close the nvtx range
          !
          IF (prof(n) == notrunning) THEN
            !WRITE (stdout, '("stop_prof: range # ",I2," for ",A12, " not running")') n, label
            !
          ELSE
            !
            prof(n) = notrunning
            !
#if defined(__PROFILE_NVTX)
            CALL nvtxEndRange
#elif defined(__PROFILE_ROCTX)
         CALL roctxEndRange
#endif
            !
          END IF
          !
          RETURN
          !
        END IF
        !
      END DO
      !
      ! ... clock not found
      !
      WRITE (stdout, '("stop_prof: no range starter for ",A12," found !")') label
      !
      RETURN

    END SUBROUTINE

END MODULE myprof
!

!
! Copyright (C) 2022, MaX CoE
! Distributed under the MIT License 
! (license terms are at http://opensource.org/licenses/MIT).
!
!--
!
! Utility functions to check allocation status on the device
! using CUDA-Fortran, OpenACC or OpenMP Offload
!
!==================================================================
!==================================================================
! *DO NOT EDIT*: automatically generated from devxlib_malloc_allocated.jf90
!==================================================================
!==================================================================
!
#include<devxlib_macros.h>
#include<devxlib_defs.h>
!
!=======================================
!
submodule (devxlib_malloc) devxlib_malloc_allocated

   implicit none

   contains
      module function sp_devxlib_malloc_allocated_r1d(array) result(res)
          implicit none
          !
          logical :: res
          real(real32), allocatable, intent(in) DEV_ATTR :: array(:)
          res=allocated(array)
          return
      end function sp_devxlib_malloc_allocated_r1d
      !
      module function sp_devxlib_malloc_allocated_r2d(array) result(res)
          implicit none
          !
          logical :: res
          real(real32), allocatable, intent(in) DEV_ATTR :: array(:,:)
          res=allocated(array)
          return
      end function sp_devxlib_malloc_allocated_r2d
      !
      module function sp_devxlib_malloc_allocated_r3d(array) result(res)
          implicit none
          !
          logical :: res
          real(real32), allocatable, intent(in) DEV_ATTR :: array(:,:,:)
          res=allocated(array)
          return
      end function sp_devxlib_malloc_allocated_r3d
      !
      module function sp_devxlib_malloc_allocated_r4d(array) result(res)
          implicit none
          !
          logical :: res
          real(real32), allocatable, intent(in) DEV_ATTR :: array(:,:,:,:)
          res=allocated(array)
          return
      end function sp_devxlib_malloc_allocated_r4d
      !
      module function sp_devxlib_malloc_allocated_r5d(array) result(res)
          implicit none
          !
          logical :: res
          real(real32), allocatable, intent(in) DEV_ATTR :: array(:,:,:,:,:)
          res=allocated(array)
          return
      end function sp_devxlib_malloc_allocated_r5d
      !
      module function sp_devxlib_malloc_allocated_r6d(array) result(res)
          implicit none
          !
          logical :: res
          real(real32), allocatable, intent(in) DEV_ATTR :: array(:,:,:,:,:,:)
          res=allocated(array)
          return
      end function sp_devxlib_malloc_allocated_r6d
      !
      module function dp_devxlib_malloc_allocated_r1d(array) result(res)
          implicit none
          !
          logical :: res
          real(real64), allocatable, intent(in) DEV_ATTR :: array(:)
          res=allocated(array)
          return
      end function dp_devxlib_malloc_allocated_r1d
      !
      module function dp_devxlib_malloc_allocated_r2d(array) result(res)
          implicit none
          !
          logical :: res
          real(real64), allocatable, intent(in) DEV_ATTR :: array(:,:)
          res=allocated(array)
          return
      end function dp_devxlib_malloc_allocated_r2d
      !
      module function dp_devxlib_malloc_allocated_r3d(array) result(res)
          implicit none
          !
          logical :: res
          real(real64), allocatable, intent(in) DEV_ATTR :: array(:,:,:)
          res=allocated(array)
          return
      end function dp_devxlib_malloc_allocated_r3d
      !
      module function dp_devxlib_malloc_allocated_r4d(array) result(res)
          implicit none
          !
          logical :: res
          real(real64), allocatable, intent(in) DEV_ATTR :: array(:,:,:,:)
          res=allocated(array)
          return
      end function dp_devxlib_malloc_allocated_r4d
      !
      module function dp_devxlib_malloc_allocated_r5d(array) result(res)
          implicit none
          !
          logical :: res
          real(real64), allocatable, intent(in) DEV_ATTR :: array(:,:,:,:,:)
          res=allocated(array)
          return
      end function dp_devxlib_malloc_allocated_r5d
      !
      module function dp_devxlib_malloc_allocated_r6d(array) result(res)
          implicit none
          !
          logical :: res
          real(real64), allocatable, intent(in) DEV_ATTR :: array(:,:,:,:,:,:)
          res=allocated(array)
          return
      end function dp_devxlib_malloc_allocated_r6d
      !
      module function sp_devxlib_malloc_allocated_c1d(array) result(res)
          implicit none
          !
          logical :: res
          complex(real32), allocatable, intent(in) DEV_ATTR :: array(:)
          res=allocated(array)
          return
      end function sp_devxlib_malloc_allocated_c1d
      !
      module function sp_devxlib_malloc_allocated_c2d(array) result(res)
          implicit none
          !
          logical :: res
          complex(real32), allocatable, intent(in) DEV_ATTR :: array(:,:)
          res=allocated(array)
          return
      end function sp_devxlib_malloc_allocated_c2d
      !
      module function sp_devxlib_malloc_allocated_c3d(array) result(res)
          implicit none
          !
          logical :: res
          complex(real32), allocatable, intent(in) DEV_ATTR :: array(:,:,:)
          res=allocated(array)
          return
      end function sp_devxlib_malloc_allocated_c3d
      !
      module function sp_devxlib_malloc_allocated_c4d(array) result(res)
          implicit none
          !
          logical :: res
          complex(real32), allocatable, intent(in) DEV_ATTR :: array(:,:,:,:)
          res=allocated(array)
          return
      end function sp_devxlib_malloc_allocated_c4d
      !
      module function sp_devxlib_malloc_allocated_c5d(array) result(res)
          implicit none
          !
          logical :: res
          complex(real32), allocatable, intent(in) DEV_ATTR :: array(:,:,:,:,:)
          res=allocated(array)
          return
      end function sp_devxlib_malloc_allocated_c5d
      !
      module function sp_devxlib_malloc_allocated_c6d(array) result(res)
          implicit none
          !
          logical :: res
          complex(real32), allocatable, intent(in) DEV_ATTR :: array(:,:,:,:,:,:)
          res=allocated(array)
          return
      end function sp_devxlib_malloc_allocated_c6d
      !
      module function dp_devxlib_malloc_allocated_c1d(array) result(res)
          implicit none
          !
          logical :: res
          complex(real64), allocatable, intent(in) DEV_ATTR :: array(:)
          res=allocated(array)
          return
      end function dp_devxlib_malloc_allocated_c1d
      !
      module function dp_devxlib_malloc_allocated_c2d(array) result(res)
          implicit none
          !
          logical :: res
          complex(real64), allocatable, intent(in) DEV_ATTR :: array(:,:)
          res=allocated(array)
          return
      end function dp_devxlib_malloc_allocated_c2d
      !
      module function dp_devxlib_malloc_allocated_c3d(array) result(res)
          implicit none
          !
          logical :: res
          complex(real64), allocatable, intent(in) DEV_ATTR :: array(:,:,:)
          res=allocated(array)
          return
      end function dp_devxlib_malloc_allocated_c3d
      !
      module function dp_devxlib_malloc_allocated_c4d(array) result(res)
          implicit none
          !
          logical :: res
          complex(real64), allocatable, intent(in) DEV_ATTR :: array(:,:,:,:)
          res=allocated(array)
          return
      end function dp_devxlib_malloc_allocated_c4d
      !
      module function dp_devxlib_malloc_allocated_c5d(array) result(res)
          implicit none
          !
          logical :: res
          complex(real64), allocatable, intent(in) DEV_ATTR :: array(:,:,:,:,:)
          res=allocated(array)
          return
      end function dp_devxlib_malloc_allocated_c5d
      !
      module function dp_devxlib_malloc_allocated_c6d(array) result(res)
          implicit none
          !
          logical :: res
          complex(real64), allocatable, intent(in) DEV_ATTR :: array(:,:,:,:,:,:)
          res=allocated(array)
          return
      end function dp_devxlib_malloc_allocated_c6d
      !
      module function i4_devxlib_malloc_allocated_i1d(array) result(res)
          implicit none
          !
          logical :: res
          integer(int32), allocatable, intent(in) DEV_ATTR :: array(:)
          res=allocated(array)
          return
      end function i4_devxlib_malloc_allocated_i1d
      !
      module function i4_devxlib_malloc_allocated_i2d(array) result(res)
          implicit none
          !
          logical :: res
          integer(int32), allocatable, intent(in) DEV_ATTR :: array(:,:)
          res=allocated(array)
          return
      end function i4_devxlib_malloc_allocated_i2d
      !
      module function i4_devxlib_malloc_allocated_i3d(array) result(res)
          implicit none
          !
          logical :: res
          integer(int32), allocatable, intent(in) DEV_ATTR :: array(:,:,:)
          res=allocated(array)
          return
      end function i4_devxlib_malloc_allocated_i3d
      !
      module function i4_devxlib_malloc_allocated_i4d(array) result(res)
          implicit none
          !
          logical :: res
          integer(int32), allocatable, intent(in) DEV_ATTR :: array(:,:,:,:)
          res=allocated(array)
          return
      end function i4_devxlib_malloc_allocated_i4d
      !
      module function i4_devxlib_malloc_allocated_i5d(array) result(res)
          implicit none
          !
          logical :: res
          integer(int32), allocatable, intent(in) DEV_ATTR :: array(:,:,:,:,:)
          res=allocated(array)
          return
      end function i4_devxlib_malloc_allocated_i5d
      !
      module function i4_devxlib_malloc_allocated_i6d(array) result(res)
          implicit none
          !
          logical :: res
          integer(int32), allocatable, intent(in) DEV_ATTR :: array(:,:,:,:,:,:)
          res=allocated(array)
          return
      end function i4_devxlib_malloc_allocated_i6d
      !
      module function i8_devxlib_malloc_allocated_i1d(array) result(res)
          implicit none
          !
          logical :: res
          integer(int64), allocatable, intent(in) DEV_ATTR :: array(:)
          res=allocated(array)
          return
      end function i8_devxlib_malloc_allocated_i1d
      !
      module function i8_devxlib_malloc_allocated_i2d(array) result(res)
          implicit none
          !
          logical :: res
          integer(int64), allocatable, intent(in) DEV_ATTR :: array(:,:)
          res=allocated(array)
          return
      end function i8_devxlib_malloc_allocated_i2d
      !
      module function i8_devxlib_malloc_allocated_i3d(array) result(res)
          implicit none
          !
          logical :: res
          integer(int64), allocatable, intent(in) DEV_ATTR :: array(:,:,:)
          res=allocated(array)
          return
      end function i8_devxlib_malloc_allocated_i3d
      !
      module function i8_devxlib_malloc_allocated_i4d(array) result(res)
          implicit none
          !
          logical :: res
          integer(int64), allocatable, intent(in) DEV_ATTR :: array(:,:,:,:)
          res=allocated(array)
          return
      end function i8_devxlib_malloc_allocated_i4d
      !
      module function i8_devxlib_malloc_allocated_i5d(array) result(res)
          implicit none
          !
          logical :: res
          integer(int64), allocatable, intent(in) DEV_ATTR :: array(:,:,:,:,:)
          res=allocated(array)
          return
      end function i8_devxlib_malloc_allocated_i5d
      !
      module function i8_devxlib_malloc_allocated_i6d(array) result(res)
          implicit none
          !
          logical :: res
          integer(int64), allocatable, intent(in) DEV_ATTR :: array(:,:,:,:,:,:)
          res=allocated(array)
          return
      end function i8_devxlib_malloc_allocated_i6d
      !
      module function l4_devxlib_malloc_allocated_l1d(array) result(res)
          implicit none
          !
          logical :: res
          logical(int32), allocatable, intent(in) DEV_ATTR :: array(:)
          res=allocated(array)
          return
      end function l4_devxlib_malloc_allocated_l1d
      !
      module function l4_devxlib_malloc_allocated_l2d(array) result(res)
          implicit none
          !
          logical :: res
          logical(int32), allocatable, intent(in) DEV_ATTR :: array(:,:)
          res=allocated(array)
          return
      end function l4_devxlib_malloc_allocated_l2d
      !
      module function l4_devxlib_malloc_allocated_l3d(array) result(res)
          implicit none
          !
          logical :: res
          logical(int32), allocatable, intent(in) DEV_ATTR :: array(:,:,:)
          res=allocated(array)
          return
      end function l4_devxlib_malloc_allocated_l3d
      !
      module function l4_devxlib_malloc_allocated_l4d(array) result(res)
          implicit none
          !
          logical :: res
          logical(int32), allocatable, intent(in) DEV_ATTR :: array(:,:,:,:)
          res=allocated(array)
          return
      end function l4_devxlib_malloc_allocated_l4d
      !
      module function l4_devxlib_malloc_allocated_l5d(array) result(res)
          implicit none
          !
          logical :: res
          logical(int32), allocatable, intent(in) DEV_ATTR :: array(:,:,:,:,:)
          res=allocated(array)
          return
      end function l4_devxlib_malloc_allocated_l5d
      !
      module function l4_devxlib_malloc_allocated_l6d(array) result(res)
          implicit none
          !
          logical :: res
          logical(int32), allocatable, intent(in) DEV_ATTR :: array(:,:,:,:,:,:)
          res=allocated(array)
          return
      end function l4_devxlib_malloc_allocated_l6d
      !
      module function sp_devxlib_malloc_allocated_r1d_p(dev_ptr) result(res)
          implicit none
          !
          logical :: res
          real(real32), pointer, intent(in) DEV_ATTR :: dev_ptr(:)
          res=associated(dev_ptr)
          return
      end function sp_devxlib_malloc_allocated_r1d_p
      !
      module function sp_devxlib_malloc_allocated_r2d_p(dev_ptr) result(res)
          implicit none
          !
          logical :: res
          real(real32), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:)
          res=associated(dev_ptr)
          return
      end function sp_devxlib_malloc_allocated_r2d_p
      !
      module function sp_devxlib_malloc_allocated_r3d_p(dev_ptr) result(res)
          implicit none
          !
          logical :: res
          real(real32), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:,:)
          res=associated(dev_ptr)
          return
      end function sp_devxlib_malloc_allocated_r3d_p
      !
      module function sp_devxlib_malloc_allocated_r4d_p(dev_ptr) result(res)
          implicit none
          !
          logical :: res
          real(real32), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:,:,:)
          res=associated(dev_ptr)
          return
      end function sp_devxlib_malloc_allocated_r4d_p
      !
      module function sp_devxlib_malloc_allocated_r5d_p(dev_ptr) result(res)
          implicit none
          !
          logical :: res
          real(real32), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:,:,:,:)
          res=associated(dev_ptr)
          return
      end function sp_devxlib_malloc_allocated_r5d_p
      !
      module function sp_devxlib_malloc_allocated_r6d_p(dev_ptr) result(res)
          implicit none
          !
          logical :: res
          real(real32), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:,:,:,:,:)
          res=associated(dev_ptr)
          return
      end function sp_devxlib_malloc_allocated_r6d_p
      !
      module function dp_devxlib_malloc_allocated_r1d_p(dev_ptr) result(res)
          implicit none
          !
          logical :: res
          real(real64), pointer, intent(in) DEV_ATTR :: dev_ptr(:)
          res=associated(dev_ptr)
          return
      end function dp_devxlib_malloc_allocated_r1d_p
      !
      module function dp_devxlib_malloc_allocated_r2d_p(dev_ptr) result(res)
          implicit none
          !
          logical :: res
          real(real64), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:)
          res=associated(dev_ptr)
          return
      end function dp_devxlib_malloc_allocated_r2d_p
      !
      module function dp_devxlib_malloc_allocated_r3d_p(dev_ptr) result(res)
          implicit none
          !
          logical :: res
          real(real64), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:,:)
          res=associated(dev_ptr)
          return
      end function dp_devxlib_malloc_allocated_r3d_p
      !
      module function dp_devxlib_malloc_allocated_r4d_p(dev_ptr) result(res)
          implicit none
          !
          logical :: res
          real(real64), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:,:,:)
          res=associated(dev_ptr)
          return
      end function dp_devxlib_malloc_allocated_r4d_p
      !
      module function dp_devxlib_malloc_allocated_r5d_p(dev_ptr) result(res)
          implicit none
          !
          logical :: res
          real(real64), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:,:,:,:)
          res=associated(dev_ptr)
          return
      end function dp_devxlib_malloc_allocated_r5d_p
      !
      module function dp_devxlib_malloc_allocated_r6d_p(dev_ptr) result(res)
          implicit none
          !
          logical :: res
          real(real64), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:,:,:,:,:)
          res=associated(dev_ptr)
          return
      end function dp_devxlib_malloc_allocated_r6d_p
      !
      module function sp_devxlib_malloc_allocated_c1d_p(dev_ptr) result(res)
          implicit none
          !
          logical :: res
          complex(real32), pointer, intent(in) DEV_ATTR :: dev_ptr(:)
          res=associated(dev_ptr)
          return
      end function sp_devxlib_malloc_allocated_c1d_p
      !
      module function sp_devxlib_malloc_allocated_c2d_p(dev_ptr) result(res)
          implicit none
          !
          logical :: res
          complex(real32), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:)
          res=associated(dev_ptr)
          return
      end function sp_devxlib_malloc_allocated_c2d_p
      !
      module function sp_devxlib_malloc_allocated_c3d_p(dev_ptr) result(res)
          implicit none
          !
          logical :: res
          complex(real32), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:,:)
          res=associated(dev_ptr)
          return
      end function sp_devxlib_malloc_allocated_c3d_p
      !
      module function sp_devxlib_malloc_allocated_c4d_p(dev_ptr) result(res)
          implicit none
          !
          logical :: res
          complex(real32), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:,:,:)
          res=associated(dev_ptr)
          return
      end function sp_devxlib_malloc_allocated_c4d_p
      !
      module function sp_devxlib_malloc_allocated_c5d_p(dev_ptr) result(res)
          implicit none
          !
          logical :: res
          complex(real32), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:,:,:,:)
          res=associated(dev_ptr)
          return
      end function sp_devxlib_malloc_allocated_c5d_p
      !
      module function sp_devxlib_malloc_allocated_c6d_p(dev_ptr) result(res)
          implicit none
          !
          logical :: res
          complex(real32), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:,:,:,:,:)
          res=associated(dev_ptr)
          return
      end function sp_devxlib_malloc_allocated_c6d_p
      !
      module function dp_devxlib_malloc_allocated_c1d_p(dev_ptr) result(res)
          implicit none
          !
          logical :: res
          complex(real64), pointer, intent(in) DEV_ATTR :: dev_ptr(:)
          res=associated(dev_ptr)
          return
      end function dp_devxlib_malloc_allocated_c1d_p
      !
      module function dp_devxlib_malloc_allocated_c2d_p(dev_ptr) result(res)
          implicit none
          !
          logical :: res
          complex(real64), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:)
          res=associated(dev_ptr)
          return
      end function dp_devxlib_malloc_allocated_c2d_p
      !
      module function dp_devxlib_malloc_allocated_c3d_p(dev_ptr) result(res)
          implicit none
          !
          logical :: res
          complex(real64), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:,:)
          res=associated(dev_ptr)
          return
      end function dp_devxlib_malloc_allocated_c3d_p
      !
      module function dp_devxlib_malloc_allocated_c4d_p(dev_ptr) result(res)
          implicit none
          !
          logical :: res
          complex(real64), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:,:,:)
          res=associated(dev_ptr)
          return
      end function dp_devxlib_malloc_allocated_c4d_p
      !
      module function dp_devxlib_malloc_allocated_c5d_p(dev_ptr) result(res)
          implicit none
          !
          logical :: res
          complex(real64), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:,:,:,:)
          res=associated(dev_ptr)
          return
      end function dp_devxlib_malloc_allocated_c5d_p
      !
      module function dp_devxlib_malloc_allocated_c6d_p(dev_ptr) result(res)
          implicit none
          !
          logical :: res
          complex(real64), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:,:,:,:,:)
          res=associated(dev_ptr)
          return
      end function dp_devxlib_malloc_allocated_c6d_p
      !
      module function i4_devxlib_malloc_allocated_i1d_p(dev_ptr) result(res)
          implicit none
          !
          logical :: res
          integer(int32), pointer, intent(in) DEV_ATTR :: dev_ptr(:)
          res=associated(dev_ptr)
          return
      end function i4_devxlib_malloc_allocated_i1d_p
      !
      module function i4_devxlib_malloc_allocated_i2d_p(dev_ptr) result(res)
          implicit none
          !
          logical :: res
          integer(int32), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:)
          res=associated(dev_ptr)
          return
      end function i4_devxlib_malloc_allocated_i2d_p
      !
      module function i4_devxlib_malloc_allocated_i3d_p(dev_ptr) result(res)
          implicit none
          !
          logical :: res
          integer(int32), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:,:)
          res=associated(dev_ptr)
          return
      end function i4_devxlib_malloc_allocated_i3d_p
      !
      module function i4_devxlib_malloc_allocated_i4d_p(dev_ptr) result(res)
          implicit none
          !
          logical :: res
          integer(int32), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:,:,:)
          res=associated(dev_ptr)
          return
      end function i4_devxlib_malloc_allocated_i4d_p
      !
      module function i4_devxlib_malloc_allocated_i5d_p(dev_ptr) result(res)
          implicit none
          !
          logical :: res
          integer(int32), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:,:,:,:)
          res=associated(dev_ptr)
          return
      end function i4_devxlib_malloc_allocated_i5d_p
      !
      module function i4_devxlib_malloc_allocated_i6d_p(dev_ptr) result(res)
          implicit none
          !
          logical :: res
          integer(int32), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:,:,:,:,:)
          res=associated(dev_ptr)
          return
      end function i4_devxlib_malloc_allocated_i6d_p
      !
      module function i8_devxlib_malloc_allocated_i1d_p(dev_ptr) result(res)
          implicit none
          !
          logical :: res
          integer(int64), pointer, intent(in) DEV_ATTR :: dev_ptr(:)
          res=associated(dev_ptr)
          return
      end function i8_devxlib_malloc_allocated_i1d_p
      !
      module function i8_devxlib_malloc_allocated_i2d_p(dev_ptr) result(res)
          implicit none
          !
          logical :: res
          integer(int64), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:)
          res=associated(dev_ptr)
          return
      end function i8_devxlib_malloc_allocated_i2d_p
      !
      module function i8_devxlib_malloc_allocated_i3d_p(dev_ptr) result(res)
          implicit none
          !
          logical :: res
          integer(int64), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:,:)
          res=associated(dev_ptr)
          return
      end function i8_devxlib_malloc_allocated_i3d_p
      !
      module function i8_devxlib_malloc_allocated_i4d_p(dev_ptr) result(res)
          implicit none
          !
          logical :: res
          integer(int64), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:,:,:)
          res=associated(dev_ptr)
          return
      end function i8_devxlib_malloc_allocated_i4d_p
      !
      module function i8_devxlib_malloc_allocated_i5d_p(dev_ptr) result(res)
          implicit none
          !
          logical :: res
          integer(int64), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:,:,:,:)
          res=associated(dev_ptr)
          return
      end function i8_devxlib_malloc_allocated_i5d_p
      !
      module function i8_devxlib_malloc_allocated_i6d_p(dev_ptr) result(res)
          implicit none
          !
          logical :: res
          integer(int64), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:,:,:,:,:)
          res=associated(dev_ptr)
          return
      end function i8_devxlib_malloc_allocated_i6d_p
      !
      module function l4_devxlib_malloc_allocated_l1d_p(dev_ptr) result(res)
          implicit none
          !
          logical :: res
          logical(int32), pointer, intent(in) DEV_ATTR :: dev_ptr(:)
          res=associated(dev_ptr)
          return
      end function l4_devxlib_malloc_allocated_l1d_p
      !
      module function l4_devxlib_malloc_allocated_l2d_p(dev_ptr) result(res)
          implicit none
          !
          logical :: res
          logical(int32), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:)
          res=associated(dev_ptr)
          return
      end function l4_devxlib_malloc_allocated_l2d_p
      !
      module function l4_devxlib_malloc_allocated_l3d_p(dev_ptr) result(res)
          implicit none
          !
          logical :: res
          logical(int32), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:,:)
          res=associated(dev_ptr)
          return
      end function l4_devxlib_malloc_allocated_l3d_p
      !
      module function l4_devxlib_malloc_allocated_l4d_p(dev_ptr) result(res)
          implicit none
          !
          logical :: res
          logical(int32), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:,:,:)
          res=associated(dev_ptr)
          return
      end function l4_devxlib_malloc_allocated_l4d_p
      !
      module function l4_devxlib_malloc_allocated_l5d_p(dev_ptr) result(res)
          implicit none
          !
          logical :: res
          logical(int32), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:,:,:,:)
          res=associated(dev_ptr)
          return
      end function l4_devxlib_malloc_allocated_l5d_p
      !
      module function l4_devxlib_malloc_allocated_l6d_p(dev_ptr) result(res)
          implicit none
          !
          logical :: res
          logical(int32), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:,:,:,:,:)
          res=associated(dev_ptr)
          return
      end function l4_devxlib_malloc_allocated_l6d_p
      !

endsubmodule devxlib_malloc_allocated

!
! Copyright (C) 2021, MaX CoE
! Distributed under the MIT License 
! (license terms are at http://opensource.org/licenses/MIT).
!
!--
!
! general definitions
!
module device_defs_m
  !
  use dev_cudafor_m
  use dev_openacc_m
!  use dev_openmpgpu_m
  use iso_fortran_env
  implicit none
  !
  !integer, parameter :: DP = selected_real_kind(14,200)
  !integer, parameter :: SP = selected_real_kind(6, 37) 
  integer, parameter :: DP = real64
  integer, parameter :: SP = real32
  !
end module

!
! Copyright (C) 2023, MaX CoE
! Distributed under the MIT License 
! (license terms are at http://opensource.org/licenses/MIT).
!
!--
!
! Testing: devxlib_memset, devxlib_memcpy
!
!==================================================================
!==================================================================
! *DO NOT EDIT*: automatically generated from test_memcpy.jf90
!==================================================================
!==================================================================
!
#include<devxlib_macros.h>
#include<devxlib_defs.h>
!
program test_memset
  !
  ! This program tests the routines and interfaces related to
  ! devxlib_memset and devxlib_memcpy
  !
  use iso_fortran_env, only : int32, int64, real32, real64
  use devxlib_memset
  use devxlib_memcpy
  use devxlib_mapping

  implicit none

  integer(int64) :: cnt, count_max
  real(real64), parameter :: thr=1.0d-6
  integer,      parameter :: nranks=4
  integer :: ndim(nranks)
  integer :: vrange(2,nranks)
  integer :: vlbound(nranks)
  real(real64):: t0, t1, count_rate
  logical :: is_alloc, lfail_malloc
  integer :: npass,nfail
  integer :: nfail_malloc
  !
  integer(int32)  :: i_const_int32
  integer(int64)  :: i_const_int64
  real(real32)    :: r_const_real32
  real(real64)    :: r_const_real64
  complex(real32) :: c_const_real32
  complex(real64) :: c_const_real64
  logical         :: l_const
  real(real32), allocatable :: A_hst0__sp_r1d(:)
  real(real32), allocatable :: A_hst1__sp_r1d(:)
  real(real32), allocatable :: A_hst2__sp_r1d(:)
  real(real32), allocatable DEV_ATTR :: A_dev__sp_r1d(:)

  real(real32), allocatable :: A_hst0__sp_r2d(:,:)
  real(real32), allocatable :: A_hst1__sp_r2d(:,:)
  real(real32), allocatable :: A_hst2__sp_r2d(:,:)
  real(real32), allocatable DEV_ATTR :: A_dev__sp_r2d(:,:)

  real(real32), allocatable :: A_hst0__sp_r3d(:,:,:)
  real(real32), allocatable :: A_hst1__sp_r3d(:,:,:)
  real(real32), allocatable :: A_hst2__sp_r3d(:,:,:)
  real(real32), allocatable DEV_ATTR :: A_dev__sp_r3d(:,:,:)

  real(real32), allocatable :: A_hst0__sp_r4d(:,:,:,:)
  real(real32), allocatable :: A_hst1__sp_r4d(:,:,:,:)
  real(real32), allocatable :: A_hst2__sp_r4d(:,:,:,:)
  real(real32), allocatable DEV_ATTR :: A_dev__sp_r4d(:,:,:,:)


  real(real64), allocatable :: A_hst0__dp_r1d(:)
  real(real64), allocatable :: A_hst1__dp_r1d(:)
  real(real64), allocatable :: A_hst2__dp_r1d(:)
  real(real64), allocatable DEV_ATTR :: A_dev__dp_r1d(:)

  real(real64), allocatable :: A_hst0__dp_r2d(:,:)
  real(real64), allocatable :: A_hst1__dp_r2d(:,:)
  real(real64), allocatable :: A_hst2__dp_r2d(:,:)
  real(real64), allocatable DEV_ATTR :: A_dev__dp_r2d(:,:)

  real(real64), allocatable :: A_hst0__dp_r3d(:,:,:)
  real(real64), allocatable :: A_hst1__dp_r3d(:,:,:)
  real(real64), allocatable :: A_hst2__dp_r3d(:,:,:)
  real(real64), allocatable DEV_ATTR :: A_dev__dp_r3d(:,:,:)

  real(real64), allocatable :: A_hst0__dp_r4d(:,:,:,:)
  real(real64), allocatable :: A_hst1__dp_r4d(:,:,:,:)
  real(real64), allocatable :: A_hst2__dp_r4d(:,:,:,:)
  real(real64), allocatable DEV_ATTR :: A_dev__dp_r4d(:,:,:,:)



  complex(real32), allocatable :: A_hst0__sp_c1d(:)
  complex(real32), allocatable :: A_hst1__sp_c1d(:)
  complex(real32), allocatable :: A_hst2__sp_c1d(:)
  complex(real32), allocatable DEV_ATTR :: A_dev__sp_c1d(:)

  complex(real32), allocatable :: A_hst0__sp_c2d(:,:)
  complex(real32), allocatable :: A_hst1__sp_c2d(:,:)
  complex(real32), allocatable :: A_hst2__sp_c2d(:,:)
  complex(real32), allocatable DEV_ATTR :: A_dev__sp_c2d(:,:)

  complex(real32), allocatable :: A_hst0__sp_c3d(:,:,:)
  complex(real32), allocatable :: A_hst1__sp_c3d(:,:,:)
  complex(real32), allocatable :: A_hst2__sp_c3d(:,:,:)
  complex(real32), allocatable DEV_ATTR :: A_dev__sp_c3d(:,:,:)

  complex(real32), allocatable :: A_hst0__sp_c4d(:,:,:,:)
  complex(real32), allocatable :: A_hst1__sp_c4d(:,:,:,:)
  complex(real32), allocatable :: A_hst2__sp_c4d(:,:,:,:)
  complex(real32), allocatable DEV_ATTR :: A_dev__sp_c4d(:,:,:,:)


  complex(real64), allocatable :: A_hst0__dp_c1d(:)
  complex(real64), allocatable :: A_hst1__dp_c1d(:)
  complex(real64), allocatable :: A_hst2__dp_c1d(:)
  complex(real64), allocatable DEV_ATTR :: A_dev__dp_c1d(:)

  complex(real64), allocatable :: A_hst0__dp_c2d(:,:)
  complex(real64), allocatable :: A_hst1__dp_c2d(:,:)
  complex(real64), allocatable :: A_hst2__dp_c2d(:,:)
  complex(real64), allocatable DEV_ATTR :: A_dev__dp_c2d(:,:)

  complex(real64), allocatable :: A_hst0__dp_c3d(:,:,:)
  complex(real64), allocatable :: A_hst1__dp_c3d(:,:,:)
  complex(real64), allocatable :: A_hst2__dp_c3d(:,:,:)
  complex(real64), allocatable DEV_ATTR :: A_dev__dp_c3d(:,:,:)

  complex(real64), allocatable :: A_hst0__dp_c4d(:,:,:,:)
  complex(real64), allocatable :: A_hst1__dp_c4d(:,:,:,:)
  complex(real64), allocatable :: A_hst2__dp_c4d(:,:,:,:)
  complex(real64), allocatable DEV_ATTR :: A_dev__dp_c4d(:,:,:,:)



  integer(int32), allocatable :: A_hst0__i4_i1d(:)
  integer(int32), allocatable :: A_hst1__i4_i1d(:)
  integer(int32), allocatable :: A_hst2__i4_i1d(:)
  integer(int32), allocatable DEV_ATTR :: A_dev__i4_i1d(:)

  integer(int32), allocatable :: A_hst0__i4_i2d(:,:)
  integer(int32), allocatable :: A_hst1__i4_i2d(:,:)
  integer(int32), allocatable :: A_hst2__i4_i2d(:,:)
  integer(int32), allocatable DEV_ATTR :: A_dev__i4_i2d(:,:)

  integer(int32), allocatable :: A_hst0__i4_i3d(:,:,:)
  integer(int32), allocatable :: A_hst1__i4_i3d(:,:,:)
  integer(int32), allocatable :: A_hst2__i4_i3d(:,:,:)
  integer(int32), allocatable DEV_ATTR :: A_dev__i4_i3d(:,:,:)

  integer(int32), allocatable :: A_hst0__i4_i4d(:,:,:,:)
  integer(int32), allocatable :: A_hst1__i4_i4d(:,:,:,:)
  integer(int32), allocatable :: A_hst2__i4_i4d(:,:,:,:)
  integer(int32), allocatable DEV_ATTR :: A_dev__i4_i4d(:,:,:,:)


  integer(int64), allocatable :: A_hst0__i8_i1d(:)
  integer(int64), allocatable :: A_hst1__i8_i1d(:)
  integer(int64), allocatable :: A_hst2__i8_i1d(:)
  integer(int64), allocatable DEV_ATTR :: A_dev__i8_i1d(:)

  integer(int64), allocatable :: A_hst0__i8_i2d(:,:)
  integer(int64), allocatable :: A_hst1__i8_i2d(:,:)
  integer(int64), allocatable :: A_hst2__i8_i2d(:,:)
  integer(int64), allocatable DEV_ATTR :: A_dev__i8_i2d(:,:)

  integer(int64), allocatable :: A_hst0__i8_i3d(:,:,:)
  integer(int64), allocatable :: A_hst1__i8_i3d(:,:,:)
  integer(int64), allocatable :: A_hst2__i8_i3d(:,:,:)
  integer(int64), allocatable DEV_ATTR :: A_dev__i8_i3d(:,:,:)

  integer(int64), allocatable :: A_hst0__i8_i4d(:,:,:,:)
  integer(int64), allocatable :: A_hst1__i8_i4d(:,:,:,:)
  integer(int64), allocatable :: A_hst2__i8_i4d(:,:,:,:)
  integer(int64), allocatable DEV_ATTR :: A_dev__i8_i4d(:,:,:,:)



  logical(int32), allocatable :: A_hst0__l4_l1d(:)
  logical(int32), allocatable :: A_hst1__l4_l1d(:)
  logical(int32), allocatable :: A_hst2__l4_l1d(:)
  logical(int32), allocatable DEV_ATTR :: A_dev__l4_l1d(:)

  logical(int32), allocatable :: A_hst0__l4_l2d(:,:)
  logical(int32), allocatable :: A_hst1__l4_l2d(:,:)
  logical(int32), allocatable :: A_hst2__l4_l2d(:,:)
  logical(int32), allocatable DEV_ATTR :: A_dev__l4_l2d(:,:)

  logical(int32), allocatable :: A_hst0__l4_l3d(:,:,:)
  logical(int32), allocatable :: A_hst1__l4_l3d(:,:,:)
  logical(int32), allocatable :: A_hst2__l4_l3d(:,:,:)
  logical(int32), allocatable DEV_ATTR :: A_dev__l4_l3d(:,:,:)

  logical(int32), allocatable :: A_hst0__l4_l4d(:,:,:,:)
  logical(int32), allocatable :: A_hst1__l4_l4d(:,:,:,:)
  logical(int32), allocatable :: A_hst2__l4_l4d(:,:,:,:)
  logical(int32), allocatable DEV_ATTR :: A_dev__l4_l4d(:,:,:,:)



  
  integer :: i,ierr
  integer :: ndim1, ndim2, ndim3, ndim4 
  integer :: lbound1, lbound2, lbound3, lbound4 
  integer :: range1(2), range2(2), range3(2), range4(2) 
  integer :: bound1(2), bound2(2), bound3(2), bound4(2) 
  character(256) :: arg, str

!
!============================
! get dims
!============================
!
  ! defaults
  ndim(:)=100
  vrange(1,:)=1
  vrange(2,:)=ndim
  vlbound(:)=1

  i=0
  do
    call get_command_argument(i, arg)
    if (len_trim(arg) == 0) exit
    !
    select case (trim(arg))
    case("-h","--help")
      write(6,"(a)") "Usage: "
      write(6,"(a)") "   ./test_memset.x [--dims <vals>] [--range <vals>] [--lbound <vals>]"
      stop
    end select
    !
    i = i+1
    call get_command_argument(i, str)
    if (len_trim(str) == 0) exit
    !
    select case (trim(arg))
    case("-dims","--dims")
      read(str,*,iostat=ierr) ndim(:)
      if (ierr/=0) STOP "reading cmd-line args: dims"
    case("-range","--range")
      read(str,*,iostat=ierr) vrange(:,:)
      if (ierr/=0) STOP "reading cmd-line args: range"
    case("-lbound","--lbound")
      read(str,*,iostat=ierr) vlbound(:)
      if (ierr/=0) STOP "reading cmd-line args: lbound"
    end select
  enddo
  !
  write(6,"(/,a,/)") "Running test with params: "
  write(6,"(3x,a,10i5)") "  ndim: ", ndim(:)
  write(6,"(3x,a,10i5)") "lbound: ", vlbound(:)
  do i = 1, nranks
     write(6,"(3x,a,i2,3x,10i5)") " range: ", i, vrange(:,i)
  enddo
  write(6,"()")
  !
  npass=0
  nfail=0
  nfail_malloc=0


  ndim1=ndim(1)
  lbound1=vlbound(1)
  range1=vrange(:,1)
  bound1(1)=lbound1
  bound1(2)=lbound1+ndim1-1
  ndim2=ndim(2)
  lbound2=vlbound(2)
  range2=vrange(:,2)
  bound2(1)=lbound2
  bound2(2)=lbound2+ndim2-1
  ndim3=ndim(3)
  lbound3=vlbound(3)
  range3=vrange(:,3)
  bound3(1)=lbound3
  bound3(2)=lbound3+ndim3-1
  ndim4=ndim(4)
  lbound4=vlbound(4)
  range4=vrange(:,4)
  bound4(1)=lbound4
  bound4(2)=lbound4+ndim4-1

!
!============================
! check memcpy
!============================
!
  !
  !=====================
  write(6,"(/,3x,a)") "checking sp_r1d ..." 
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  lfail_malloc=.false.
  !
  is_alloc = devxlib_mapped( A_dev__sp_r1d )
  !
  if (is_alloc) then
     nfail_malloc=nfail_malloc+1
     lfail_malloc=.true.
     write(6,"(3x,a)") "mem allocation check-pre FAILED" 
  endif
  !
  ! allocations
  allocate( A_hst0__sp_r1d(bound1(1):bound1(2)) )
  allocate( A_hst1__sp_r1d(bound1(1):bound1(2)) )
  allocate( A_hst2__sp_r1d(bound1(1):bound1(2)) )
  allocate( A_dev__sp_r1d(bound1(1):bound1(2)) )
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_map(A_dev__sp_r1d)
#endif
  !
  is_alloc = devxlib_mapped( A_dev__sp_r1d )
  !
  if (.not.is_alloc) then
    nfail_malloc=nfail_malloc+1
    lfail_malloc=.true.
    write(6,"(3x,a)") "mem allocation check-post FAILED" 
  endif
  !
  ! init
    r_const_real32 = 4.0
  
  !
  ! memset
  !
    A_hst0__sp_r1d=r_const_real32
    call devxlib_memset_h(A_hst1__sp_r1d,r_const_real32)
    call devxlib_memset_d(A_dev__sp_r1d,r_const_real32)
  
  ! 
  ! mem copy d2h
  call devxlib_memcpy_d2h(A_hst2__sp_r1d, A_dev__sp_r1d)
  !
  ! check
  if (lfail_malloc) write(6,"(3x,a)") "Malloc FAILED" 
  !
  if ( any(abs(A_hst1__sp_r1d -A_hst0__sp_r1d )> thr) .or. &
       any(abs(A_hst2__sp_r1d -A_hst0__sp_r1d )> thr) ) then
     !
     write(6,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(6,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst0__sp_r1d)
  deallocate(A_hst1__sp_r1d)
  deallocate(A_hst2__sp_r1d)
  !
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_unmap(A_dev__sp_r1d)
  is_alloc = devxlib_mapped( A_dev__sp_r1d )
  !
  if (is_alloc) then
    nfail_malloc=nfail_malloc+1
    lfail_malloc=.true.
    write(6,"(3x,a)") "mem allocation check-post2 FAILED" 
  endif
  !
#endif
  !
  deallocate(A_dev__sp_r1d)
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(6,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !

  !
  !=====================
  write(6,"(/,3x,a)") "checking sp_r2d ..." 
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  lfail_malloc=.false.
  !
  is_alloc = devxlib_mapped( A_dev__sp_r2d )
  !
  if (is_alloc) then
     nfail_malloc=nfail_malloc+1
     lfail_malloc=.true.
     write(6,"(3x,a)") "mem allocation check-pre FAILED" 
  endif
  !
  ! allocations
  allocate( A_hst0__sp_r2d(bound1(1):bound1(2),bound2(1):bound2(2)) )
  allocate( A_hst1__sp_r2d(bound1(1):bound1(2),bound2(1):bound2(2)) )
  allocate( A_hst2__sp_r2d(bound1(1):bound1(2),bound2(1):bound2(2)) )
  allocate( A_dev__sp_r2d(bound1(1):bound1(2),bound2(1):bound2(2)) )
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_map(A_dev__sp_r2d)
#endif
  !
  is_alloc = devxlib_mapped( A_dev__sp_r2d )
  !
  if (.not.is_alloc) then
    nfail_malloc=nfail_malloc+1
    lfail_malloc=.true.
    write(6,"(3x,a)") "mem allocation check-post FAILED" 
  endif
  !
  ! init
    r_const_real32 = 4.0
  
  !
  ! memset
  !
    A_hst0__sp_r2d=r_const_real32
    call devxlib_memset_h(A_hst1__sp_r2d,r_const_real32)
    call devxlib_memset_d(A_dev__sp_r2d,r_const_real32)
  
  ! 
  ! mem copy d2h
  call devxlib_memcpy_d2h(A_hst2__sp_r2d, A_dev__sp_r2d)
  !
  ! check
  if (lfail_malloc) write(6,"(3x,a)") "Malloc FAILED" 
  !
  if ( any(abs(A_hst1__sp_r2d -A_hst0__sp_r2d )> thr) .or. &
       any(abs(A_hst2__sp_r2d -A_hst0__sp_r2d )> thr) ) then
     !
     write(6,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(6,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst0__sp_r2d)
  deallocate(A_hst1__sp_r2d)
  deallocate(A_hst2__sp_r2d)
  !
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_unmap(A_dev__sp_r2d)
  is_alloc = devxlib_mapped( A_dev__sp_r2d )
  !
  if (is_alloc) then
    nfail_malloc=nfail_malloc+1
    lfail_malloc=.true.
    write(6,"(3x,a)") "mem allocation check-post2 FAILED" 
  endif
  !
#endif
  !
  deallocate(A_dev__sp_r2d)
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(6,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !

  !
  !=====================
  write(6,"(/,3x,a)") "checking sp_r3d ..." 
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  lfail_malloc=.false.
  !
  is_alloc = devxlib_mapped( A_dev__sp_r3d )
  !
  if (is_alloc) then
     nfail_malloc=nfail_malloc+1
     lfail_malloc=.true.
     write(6,"(3x,a)") "mem allocation check-pre FAILED" 
  endif
  !
  ! allocations
  allocate( A_hst0__sp_r3d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2)) )
  allocate( A_hst1__sp_r3d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2)) )
  allocate( A_hst2__sp_r3d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2)) )
  allocate( A_dev__sp_r3d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2)) )
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_map(A_dev__sp_r3d)
#endif
  !
  is_alloc = devxlib_mapped( A_dev__sp_r3d )
  !
  if (.not.is_alloc) then
    nfail_malloc=nfail_malloc+1
    lfail_malloc=.true.
    write(6,"(3x,a)") "mem allocation check-post FAILED" 
  endif
  !
  ! init
    r_const_real32 = 4.0
  
  !
  ! memset
  !
    A_hst0__sp_r3d=r_const_real32
    call devxlib_memset_h(A_hst1__sp_r3d,r_const_real32)
    call devxlib_memset_d(A_dev__sp_r3d,r_const_real32)
  
  ! 
  ! mem copy d2h
  call devxlib_memcpy_d2h(A_hst2__sp_r3d, A_dev__sp_r3d)
  !
  ! check
  if (lfail_malloc) write(6,"(3x,a)") "Malloc FAILED" 
  !
  if ( any(abs(A_hst1__sp_r3d -A_hst0__sp_r3d )> thr) .or. &
       any(abs(A_hst2__sp_r3d -A_hst0__sp_r3d )> thr) ) then
     !
     write(6,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(6,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst0__sp_r3d)
  deallocate(A_hst1__sp_r3d)
  deallocate(A_hst2__sp_r3d)
  !
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_unmap(A_dev__sp_r3d)
  is_alloc = devxlib_mapped( A_dev__sp_r3d )
  !
  if (is_alloc) then
    nfail_malloc=nfail_malloc+1
    lfail_malloc=.true.
    write(6,"(3x,a)") "mem allocation check-post2 FAILED" 
  endif
  !
#endif
  !
  deallocate(A_dev__sp_r3d)
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(6,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !

  !
  !=====================
  write(6,"(/,3x,a)") "checking sp_r4d ..." 
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  lfail_malloc=.false.
  !
  is_alloc = devxlib_mapped( A_dev__sp_r4d )
  !
  if (is_alloc) then
     nfail_malloc=nfail_malloc+1
     lfail_malloc=.true.
     write(6,"(3x,a)") "mem allocation check-pre FAILED" 
  endif
  !
  ! allocations
  allocate( A_hst0__sp_r4d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2),bound4(1):bound4(2)) )
  allocate( A_hst1__sp_r4d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2),bound4(1):bound4(2)) )
  allocate( A_hst2__sp_r4d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2),bound4(1):bound4(2)) )
  allocate( A_dev__sp_r4d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2),bound4(1):bound4(2)) )
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_map(A_dev__sp_r4d)
#endif
  !
  is_alloc = devxlib_mapped( A_dev__sp_r4d )
  !
  if (.not.is_alloc) then
    nfail_malloc=nfail_malloc+1
    lfail_malloc=.true.
    write(6,"(3x,a)") "mem allocation check-post FAILED" 
  endif
  !
  ! init
    r_const_real32 = 4.0
  
  !
  ! memset
  !
    A_hst0__sp_r4d=r_const_real32
    call devxlib_memset_h(A_hst1__sp_r4d,r_const_real32)
    call devxlib_memset_d(A_dev__sp_r4d,r_const_real32)
  
  ! 
  ! mem copy d2h
  call devxlib_memcpy_d2h(A_hst2__sp_r4d, A_dev__sp_r4d)
  !
  ! check
  if (lfail_malloc) write(6,"(3x,a)") "Malloc FAILED" 
  !
  if ( any(abs(A_hst1__sp_r4d -A_hst0__sp_r4d )> thr) .or. &
       any(abs(A_hst2__sp_r4d -A_hst0__sp_r4d )> thr) ) then
     !
     write(6,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(6,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst0__sp_r4d)
  deallocate(A_hst1__sp_r4d)
  deallocate(A_hst2__sp_r4d)
  !
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_unmap(A_dev__sp_r4d)
  is_alloc = devxlib_mapped( A_dev__sp_r4d )
  !
  if (is_alloc) then
    nfail_malloc=nfail_malloc+1
    lfail_malloc=.true.
    write(6,"(3x,a)") "mem allocation check-post2 FAILED" 
  endif
  !
#endif
  !
  deallocate(A_dev__sp_r4d)
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(6,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !


  !
  !=====================
  write(6,"(/,3x,a)") "checking dp_r1d ..." 
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  lfail_malloc=.false.
  !
  is_alloc = devxlib_mapped( A_dev__dp_r1d )
  !
  if (is_alloc) then
     nfail_malloc=nfail_malloc+1
     lfail_malloc=.true.
     write(6,"(3x,a)") "mem allocation check-pre FAILED" 
  endif
  !
  ! allocations
  allocate( A_hst0__dp_r1d(bound1(1):bound1(2)) )
  allocate( A_hst1__dp_r1d(bound1(1):bound1(2)) )
  allocate( A_hst2__dp_r1d(bound1(1):bound1(2)) )
  allocate( A_dev__dp_r1d(bound1(1):bound1(2)) )
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_map(A_dev__dp_r1d)
#endif
  !
  is_alloc = devxlib_mapped( A_dev__dp_r1d )
  !
  if (.not.is_alloc) then
    nfail_malloc=nfail_malloc+1
    lfail_malloc=.true.
    write(6,"(3x,a)") "mem allocation check-post FAILED" 
  endif
  !
  ! init
    r_const_real64 = 4.0
  
  !
  ! memset
  !
    A_hst0__dp_r1d=r_const_real64
    call devxlib_memset_h(A_hst1__dp_r1d,r_const_real64)
    call devxlib_memset_d(A_dev__dp_r1d,r_const_real64)
  
  ! 
  ! mem copy d2h
  call devxlib_memcpy_d2h(A_hst2__dp_r1d, A_dev__dp_r1d)
  !
  ! check
  if (lfail_malloc) write(6,"(3x,a)") "Malloc FAILED" 
  !
  if ( any(abs(A_hst1__dp_r1d -A_hst0__dp_r1d )> thr) .or. &
       any(abs(A_hst2__dp_r1d -A_hst0__dp_r1d )> thr) ) then
     !
     write(6,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(6,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst0__dp_r1d)
  deallocate(A_hst1__dp_r1d)
  deallocate(A_hst2__dp_r1d)
  !
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_unmap(A_dev__dp_r1d)
  is_alloc = devxlib_mapped( A_dev__dp_r1d )
  !
  if (is_alloc) then
    nfail_malloc=nfail_malloc+1
    lfail_malloc=.true.
    write(6,"(3x,a)") "mem allocation check-post2 FAILED" 
  endif
  !
#endif
  !
  deallocate(A_dev__dp_r1d)
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(6,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !

  !
  !=====================
  write(6,"(/,3x,a)") "checking dp_r2d ..." 
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  lfail_malloc=.false.
  !
  is_alloc = devxlib_mapped( A_dev__dp_r2d )
  !
  if (is_alloc) then
     nfail_malloc=nfail_malloc+1
     lfail_malloc=.true.
     write(6,"(3x,a)") "mem allocation check-pre FAILED" 
  endif
  !
  ! allocations
  allocate( A_hst0__dp_r2d(bound1(1):bound1(2),bound2(1):bound2(2)) )
  allocate( A_hst1__dp_r2d(bound1(1):bound1(2),bound2(1):bound2(2)) )
  allocate( A_hst2__dp_r2d(bound1(1):bound1(2),bound2(1):bound2(2)) )
  allocate( A_dev__dp_r2d(bound1(1):bound1(2),bound2(1):bound2(2)) )
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_map(A_dev__dp_r2d)
#endif
  !
  is_alloc = devxlib_mapped( A_dev__dp_r2d )
  !
  if (.not.is_alloc) then
    nfail_malloc=nfail_malloc+1
    lfail_malloc=.true.
    write(6,"(3x,a)") "mem allocation check-post FAILED" 
  endif
  !
  ! init
    r_const_real64 = 4.0
  
  !
  ! memset
  !
    A_hst0__dp_r2d=r_const_real64
    call devxlib_memset_h(A_hst1__dp_r2d,r_const_real64)
    call devxlib_memset_d(A_dev__dp_r2d,r_const_real64)
  
  ! 
  ! mem copy d2h
  call devxlib_memcpy_d2h(A_hst2__dp_r2d, A_dev__dp_r2d)
  !
  ! check
  if (lfail_malloc) write(6,"(3x,a)") "Malloc FAILED" 
  !
  if ( any(abs(A_hst1__dp_r2d -A_hst0__dp_r2d )> thr) .or. &
       any(abs(A_hst2__dp_r2d -A_hst0__dp_r2d )> thr) ) then
     !
     write(6,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(6,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst0__dp_r2d)
  deallocate(A_hst1__dp_r2d)
  deallocate(A_hst2__dp_r2d)
  !
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_unmap(A_dev__dp_r2d)
  is_alloc = devxlib_mapped( A_dev__dp_r2d )
  !
  if (is_alloc) then
    nfail_malloc=nfail_malloc+1
    lfail_malloc=.true.
    write(6,"(3x,a)") "mem allocation check-post2 FAILED" 
  endif
  !
#endif
  !
  deallocate(A_dev__dp_r2d)
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(6,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !

  !
  !=====================
  write(6,"(/,3x,a)") "checking dp_r3d ..." 
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  lfail_malloc=.false.
  !
  is_alloc = devxlib_mapped( A_dev__dp_r3d )
  !
  if (is_alloc) then
     nfail_malloc=nfail_malloc+1
     lfail_malloc=.true.
     write(6,"(3x,a)") "mem allocation check-pre FAILED" 
  endif
  !
  ! allocations
  allocate( A_hst0__dp_r3d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2)) )
  allocate( A_hst1__dp_r3d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2)) )
  allocate( A_hst2__dp_r3d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2)) )
  allocate( A_dev__dp_r3d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2)) )
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_map(A_dev__dp_r3d)
#endif
  !
  is_alloc = devxlib_mapped( A_dev__dp_r3d )
  !
  if (.not.is_alloc) then
    nfail_malloc=nfail_malloc+1
    lfail_malloc=.true.
    write(6,"(3x,a)") "mem allocation check-post FAILED" 
  endif
  !
  ! init
    r_const_real64 = 4.0
  
  !
  ! memset
  !
    A_hst0__dp_r3d=r_const_real64
    call devxlib_memset_h(A_hst1__dp_r3d,r_const_real64)
    call devxlib_memset_d(A_dev__dp_r3d,r_const_real64)
  
  ! 
  ! mem copy d2h
  call devxlib_memcpy_d2h(A_hst2__dp_r3d, A_dev__dp_r3d)
  !
  ! check
  if (lfail_malloc) write(6,"(3x,a)") "Malloc FAILED" 
  !
  if ( any(abs(A_hst1__dp_r3d -A_hst0__dp_r3d )> thr) .or. &
       any(abs(A_hst2__dp_r3d -A_hst0__dp_r3d )> thr) ) then
     !
     write(6,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(6,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst0__dp_r3d)
  deallocate(A_hst1__dp_r3d)
  deallocate(A_hst2__dp_r3d)
  !
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_unmap(A_dev__dp_r3d)
  is_alloc = devxlib_mapped( A_dev__dp_r3d )
  !
  if (is_alloc) then
    nfail_malloc=nfail_malloc+1
    lfail_malloc=.true.
    write(6,"(3x,a)") "mem allocation check-post2 FAILED" 
  endif
  !
#endif
  !
  deallocate(A_dev__dp_r3d)
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(6,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !

  !
  !=====================
  write(6,"(/,3x,a)") "checking dp_r4d ..." 
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  lfail_malloc=.false.
  !
  is_alloc = devxlib_mapped( A_dev__dp_r4d )
  !
  if (is_alloc) then
     nfail_malloc=nfail_malloc+1
     lfail_malloc=.true.
     write(6,"(3x,a)") "mem allocation check-pre FAILED" 
  endif
  !
  ! allocations
  allocate( A_hst0__dp_r4d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2),bound4(1):bound4(2)) )
  allocate( A_hst1__dp_r4d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2),bound4(1):bound4(2)) )
  allocate( A_hst2__dp_r4d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2),bound4(1):bound4(2)) )
  allocate( A_dev__dp_r4d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2),bound4(1):bound4(2)) )
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_map(A_dev__dp_r4d)
#endif
  !
  is_alloc = devxlib_mapped( A_dev__dp_r4d )
  !
  if (.not.is_alloc) then
    nfail_malloc=nfail_malloc+1
    lfail_malloc=.true.
    write(6,"(3x,a)") "mem allocation check-post FAILED" 
  endif
  !
  ! init
    r_const_real64 = 4.0
  
  !
  ! memset
  !
    A_hst0__dp_r4d=r_const_real64
    call devxlib_memset_h(A_hst1__dp_r4d,r_const_real64)
    call devxlib_memset_d(A_dev__dp_r4d,r_const_real64)
  
  ! 
  ! mem copy d2h
  call devxlib_memcpy_d2h(A_hst2__dp_r4d, A_dev__dp_r4d)
  !
  ! check
  if (lfail_malloc) write(6,"(3x,a)") "Malloc FAILED" 
  !
  if ( any(abs(A_hst1__dp_r4d -A_hst0__dp_r4d )> thr) .or. &
       any(abs(A_hst2__dp_r4d -A_hst0__dp_r4d )> thr) ) then
     !
     write(6,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(6,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst0__dp_r4d)
  deallocate(A_hst1__dp_r4d)
  deallocate(A_hst2__dp_r4d)
  !
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_unmap(A_dev__dp_r4d)
  is_alloc = devxlib_mapped( A_dev__dp_r4d )
  !
  if (is_alloc) then
    nfail_malloc=nfail_malloc+1
    lfail_malloc=.true.
    write(6,"(3x,a)") "mem allocation check-post2 FAILED" 
  endif
  !
#endif
  !
  deallocate(A_dev__dp_r4d)
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(6,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !



  !
  !=====================
  write(6,"(/,3x,a)") "checking sp_c1d ..." 
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  lfail_malloc=.false.
  !
  is_alloc = devxlib_mapped( A_dev__sp_c1d )
  !
  if (is_alloc) then
     nfail_malloc=nfail_malloc+1
     lfail_malloc=.true.
     write(6,"(3x,a)") "mem allocation check-pre FAILED" 
  endif
  !
  ! allocations
  allocate( A_hst0__sp_c1d(bound1(1):bound1(2)) )
  allocate( A_hst1__sp_c1d(bound1(1):bound1(2)) )
  allocate( A_hst2__sp_c1d(bound1(1):bound1(2)) )
  allocate( A_dev__sp_c1d(bound1(1):bound1(2)) )
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_map(A_dev__sp_c1d)
#endif
  !
  is_alloc = devxlib_mapped( A_dev__sp_c1d )
  !
  if (.not.is_alloc) then
    nfail_malloc=nfail_malloc+1
    lfail_malloc=.true.
    write(6,"(3x,a)") "mem allocation check-post FAILED" 
  endif
  !
  ! init
    c_const_real32 = (1.0,2.0)
  
  !
  ! memset
  !
    A_hst0__sp_c1d=c_const_real32
    call devxlib_memset_h(A_hst1__sp_c1d,c_const_real32)
    call devxlib_memset_d(A_dev__sp_c1d,c_const_real32)
  
  ! 
  ! mem copy d2h
  call devxlib_memcpy_d2h(A_hst2__sp_c1d, A_dev__sp_c1d)
  !
  ! check
  if (lfail_malloc) write(6,"(3x,a)") "Malloc FAILED" 
  !
  if ( any(abs(A_hst1__sp_c1d -A_hst0__sp_c1d )> thr) .or. &
       any(abs(A_hst2__sp_c1d -A_hst0__sp_c1d )> thr) ) then
     !
     write(6,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(6,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst0__sp_c1d)
  deallocate(A_hst1__sp_c1d)
  deallocate(A_hst2__sp_c1d)
  !
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_unmap(A_dev__sp_c1d)
  is_alloc = devxlib_mapped( A_dev__sp_c1d )
  !
  if (is_alloc) then
    nfail_malloc=nfail_malloc+1
    lfail_malloc=.true.
    write(6,"(3x,a)") "mem allocation check-post2 FAILED" 
  endif
  !
#endif
  !
  deallocate(A_dev__sp_c1d)
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(6,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !

  !
  !=====================
  write(6,"(/,3x,a)") "checking sp_c2d ..." 
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  lfail_malloc=.false.
  !
  is_alloc = devxlib_mapped( A_dev__sp_c2d )
  !
  if (is_alloc) then
     nfail_malloc=nfail_malloc+1
     lfail_malloc=.true.
     write(6,"(3x,a)") "mem allocation check-pre FAILED" 
  endif
  !
  ! allocations
  allocate( A_hst0__sp_c2d(bound1(1):bound1(2),bound2(1):bound2(2)) )
  allocate( A_hst1__sp_c2d(bound1(1):bound1(2),bound2(1):bound2(2)) )
  allocate( A_hst2__sp_c2d(bound1(1):bound1(2),bound2(1):bound2(2)) )
  allocate( A_dev__sp_c2d(bound1(1):bound1(2),bound2(1):bound2(2)) )
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_map(A_dev__sp_c2d)
#endif
  !
  is_alloc = devxlib_mapped( A_dev__sp_c2d )
  !
  if (.not.is_alloc) then
    nfail_malloc=nfail_malloc+1
    lfail_malloc=.true.
    write(6,"(3x,a)") "mem allocation check-post FAILED" 
  endif
  !
  ! init
    c_const_real32 = (1.0,2.0)
  
  !
  ! memset
  !
    A_hst0__sp_c2d=c_const_real32
    call devxlib_memset_h(A_hst1__sp_c2d,c_const_real32)
    call devxlib_memset_d(A_dev__sp_c2d,c_const_real32)
  
  ! 
  ! mem copy d2h
  call devxlib_memcpy_d2h(A_hst2__sp_c2d, A_dev__sp_c2d)
  !
  ! check
  if (lfail_malloc) write(6,"(3x,a)") "Malloc FAILED" 
  !
  if ( any(abs(A_hst1__sp_c2d -A_hst0__sp_c2d )> thr) .or. &
       any(abs(A_hst2__sp_c2d -A_hst0__sp_c2d )> thr) ) then
     !
     write(6,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(6,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst0__sp_c2d)
  deallocate(A_hst1__sp_c2d)
  deallocate(A_hst2__sp_c2d)
  !
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_unmap(A_dev__sp_c2d)
  is_alloc = devxlib_mapped( A_dev__sp_c2d )
  !
  if (is_alloc) then
    nfail_malloc=nfail_malloc+1
    lfail_malloc=.true.
    write(6,"(3x,a)") "mem allocation check-post2 FAILED" 
  endif
  !
#endif
  !
  deallocate(A_dev__sp_c2d)
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(6,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !

  !
  !=====================
  write(6,"(/,3x,a)") "checking sp_c3d ..." 
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  lfail_malloc=.false.
  !
  is_alloc = devxlib_mapped( A_dev__sp_c3d )
  !
  if (is_alloc) then
     nfail_malloc=nfail_malloc+1
     lfail_malloc=.true.
     write(6,"(3x,a)") "mem allocation check-pre FAILED" 
  endif
  !
  ! allocations
  allocate( A_hst0__sp_c3d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2)) )
  allocate( A_hst1__sp_c3d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2)) )
  allocate( A_hst2__sp_c3d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2)) )
  allocate( A_dev__sp_c3d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2)) )
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_map(A_dev__sp_c3d)
#endif
  !
  is_alloc = devxlib_mapped( A_dev__sp_c3d )
  !
  if (.not.is_alloc) then
    nfail_malloc=nfail_malloc+1
    lfail_malloc=.true.
    write(6,"(3x,a)") "mem allocation check-post FAILED" 
  endif
  !
  ! init
    c_const_real32 = (1.0,2.0)
  
  !
  ! memset
  !
    A_hst0__sp_c3d=c_const_real32
    call devxlib_memset_h(A_hst1__sp_c3d,c_const_real32)
    call devxlib_memset_d(A_dev__sp_c3d,c_const_real32)
  
  ! 
  ! mem copy d2h
  call devxlib_memcpy_d2h(A_hst2__sp_c3d, A_dev__sp_c3d)
  !
  ! check
  if (lfail_malloc) write(6,"(3x,a)") "Malloc FAILED" 
  !
  if ( any(abs(A_hst1__sp_c3d -A_hst0__sp_c3d )> thr) .or. &
       any(abs(A_hst2__sp_c3d -A_hst0__sp_c3d )> thr) ) then
     !
     write(6,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(6,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst0__sp_c3d)
  deallocate(A_hst1__sp_c3d)
  deallocate(A_hst2__sp_c3d)
  !
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_unmap(A_dev__sp_c3d)
  is_alloc = devxlib_mapped( A_dev__sp_c3d )
  !
  if (is_alloc) then
    nfail_malloc=nfail_malloc+1
    lfail_malloc=.true.
    write(6,"(3x,a)") "mem allocation check-post2 FAILED" 
  endif
  !
#endif
  !
  deallocate(A_dev__sp_c3d)
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(6,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !

  !
  !=====================
  write(6,"(/,3x,a)") "checking sp_c4d ..." 
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  lfail_malloc=.false.
  !
  is_alloc = devxlib_mapped( A_dev__sp_c4d )
  !
  if (is_alloc) then
     nfail_malloc=nfail_malloc+1
     lfail_malloc=.true.
     write(6,"(3x,a)") "mem allocation check-pre FAILED" 
  endif
  !
  ! allocations
  allocate( A_hst0__sp_c4d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2),bound4(1):bound4(2)) )
  allocate( A_hst1__sp_c4d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2),bound4(1):bound4(2)) )
  allocate( A_hst2__sp_c4d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2),bound4(1):bound4(2)) )
  allocate( A_dev__sp_c4d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2),bound4(1):bound4(2)) )
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_map(A_dev__sp_c4d)
#endif
  !
  is_alloc = devxlib_mapped( A_dev__sp_c4d )
  !
  if (.not.is_alloc) then
    nfail_malloc=nfail_malloc+1
    lfail_malloc=.true.
    write(6,"(3x,a)") "mem allocation check-post FAILED" 
  endif
  !
  ! init
    c_const_real32 = (1.0,2.0)
  
  !
  ! memset
  !
    A_hst0__sp_c4d=c_const_real32
    call devxlib_memset_h(A_hst1__sp_c4d,c_const_real32)
    call devxlib_memset_d(A_dev__sp_c4d,c_const_real32)
  
  ! 
  ! mem copy d2h
  call devxlib_memcpy_d2h(A_hst2__sp_c4d, A_dev__sp_c4d)
  !
  ! check
  if (lfail_malloc) write(6,"(3x,a)") "Malloc FAILED" 
  !
  if ( any(abs(A_hst1__sp_c4d -A_hst0__sp_c4d )> thr) .or. &
       any(abs(A_hst2__sp_c4d -A_hst0__sp_c4d )> thr) ) then
     !
     write(6,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(6,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst0__sp_c4d)
  deallocate(A_hst1__sp_c4d)
  deallocate(A_hst2__sp_c4d)
  !
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_unmap(A_dev__sp_c4d)
  is_alloc = devxlib_mapped( A_dev__sp_c4d )
  !
  if (is_alloc) then
    nfail_malloc=nfail_malloc+1
    lfail_malloc=.true.
    write(6,"(3x,a)") "mem allocation check-post2 FAILED" 
  endif
  !
#endif
  !
  deallocate(A_dev__sp_c4d)
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(6,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !


  !
  !=====================
  write(6,"(/,3x,a)") "checking dp_c1d ..." 
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  lfail_malloc=.false.
  !
  is_alloc = devxlib_mapped( A_dev__dp_c1d )
  !
  if (is_alloc) then
     nfail_malloc=nfail_malloc+1
     lfail_malloc=.true.
     write(6,"(3x,a)") "mem allocation check-pre FAILED" 
  endif
  !
  ! allocations
  allocate( A_hst0__dp_c1d(bound1(1):bound1(2)) )
  allocate( A_hst1__dp_c1d(bound1(1):bound1(2)) )
  allocate( A_hst2__dp_c1d(bound1(1):bound1(2)) )
  allocate( A_dev__dp_c1d(bound1(1):bound1(2)) )
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_map(A_dev__dp_c1d)
#endif
  !
  is_alloc = devxlib_mapped( A_dev__dp_c1d )
  !
  if (.not.is_alloc) then
    nfail_malloc=nfail_malloc+1
    lfail_malloc=.true.
    write(6,"(3x,a)") "mem allocation check-post FAILED" 
  endif
  !
  ! init
    c_const_real64 = (1.0,2.0)
  
  !
  ! memset
  !
    A_hst0__dp_c1d=c_const_real64
    call devxlib_memset_h(A_hst1__dp_c1d,c_const_real64)
    call devxlib_memset_d(A_dev__dp_c1d,c_const_real64)
  
  ! 
  ! mem copy d2h
  call devxlib_memcpy_d2h(A_hst2__dp_c1d, A_dev__dp_c1d)
  !
  ! check
  if (lfail_malloc) write(6,"(3x,a)") "Malloc FAILED" 
  !
  if ( any(abs(A_hst1__dp_c1d -A_hst0__dp_c1d )> thr) .or. &
       any(abs(A_hst2__dp_c1d -A_hst0__dp_c1d )> thr) ) then
     !
     write(6,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(6,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst0__dp_c1d)
  deallocate(A_hst1__dp_c1d)
  deallocate(A_hst2__dp_c1d)
  !
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_unmap(A_dev__dp_c1d)
  is_alloc = devxlib_mapped( A_dev__dp_c1d )
  !
  if (is_alloc) then
    nfail_malloc=nfail_malloc+1
    lfail_malloc=.true.
    write(6,"(3x,a)") "mem allocation check-post2 FAILED" 
  endif
  !
#endif
  !
  deallocate(A_dev__dp_c1d)
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(6,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !

  !
  !=====================
  write(6,"(/,3x,a)") "checking dp_c2d ..." 
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  lfail_malloc=.false.
  !
  is_alloc = devxlib_mapped( A_dev__dp_c2d )
  !
  if (is_alloc) then
     nfail_malloc=nfail_malloc+1
     lfail_malloc=.true.
     write(6,"(3x,a)") "mem allocation check-pre FAILED" 
  endif
  !
  ! allocations
  allocate( A_hst0__dp_c2d(bound1(1):bound1(2),bound2(1):bound2(2)) )
  allocate( A_hst1__dp_c2d(bound1(1):bound1(2),bound2(1):bound2(2)) )
  allocate( A_hst2__dp_c2d(bound1(1):bound1(2),bound2(1):bound2(2)) )
  allocate( A_dev__dp_c2d(bound1(1):bound1(2),bound2(1):bound2(2)) )
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_map(A_dev__dp_c2d)
#endif
  !
  is_alloc = devxlib_mapped( A_dev__dp_c2d )
  !
  if (.not.is_alloc) then
    nfail_malloc=nfail_malloc+1
    lfail_malloc=.true.
    write(6,"(3x,a)") "mem allocation check-post FAILED" 
  endif
  !
  ! init
    c_const_real64 = (1.0,2.0)
  
  !
  ! memset
  !
    A_hst0__dp_c2d=c_const_real64
    call devxlib_memset_h(A_hst1__dp_c2d,c_const_real64)
    call devxlib_memset_d(A_dev__dp_c2d,c_const_real64)
  
  ! 
  ! mem copy d2h
  call devxlib_memcpy_d2h(A_hst2__dp_c2d, A_dev__dp_c2d)
  !
  ! check
  if (lfail_malloc) write(6,"(3x,a)") "Malloc FAILED" 
  !
  if ( any(abs(A_hst1__dp_c2d -A_hst0__dp_c2d )> thr) .or. &
       any(abs(A_hst2__dp_c2d -A_hst0__dp_c2d )> thr) ) then
     !
     write(6,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(6,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst0__dp_c2d)
  deallocate(A_hst1__dp_c2d)
  deallocate(A_hst2__dp_c2d)
  !
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_unmap(A_dev__dp_c2d)
  is_alloc = devxlib_mapped( A_dev__dp_c2d )
  !
  if (is_alloc) then
    nfail_malloc=nfail_malloc+1
    lfail_malloc=.true.
    write(6,"(3x,a)") "mem allocation check-post2 FAILED" 
  endif
  !
#endif
  !
  deallocate(A_dev__dp_c2d)
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(6,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !

  !
  !=====================
  write(6,"(/,3x,a)") "checking dp_c3d ..." 
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  lfail_malloc=.false.
  !
  is_alloc = devxlib_mapped( A_dev__dp_c3d )
  !
  if (is_alloc) then
     nfail_malloc=nfail_malloc+1
     lfail_malloc=.true.
     write(6,"(3x,a)") "mem allocation check-pre FAILED" 
  endif
  !
  ! allocations
  allocate( A_hst0__dp_c3d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2)) )
  allocate( A_hst1__dp_c3d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2)) )
  allocate( A_hst2__dp_c3d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2)) )
  allocate( A_dev__dp_c3d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2)) )
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_map(A_dev__dp_c3d)
#endif
  !
  is_alloc = devxlib_mapped( A_dev__dp_c3d )
  !
  if (.not.is_alloc) then
    nfail_malloc=nfail_malloc+1
    lfail_malloc=.true.
    write(6,"(3x,a)") "mem allocation check-post FAILED" 
  endif
  !
  ! init
    c_const_real64 = (1.0,2.0)
  
  !
  ! memset
  !
    A_hst0__dp_c3d=c_const_real64
    call devxlib_memset_h(A_hst1__dp_c3d,c_const_real64)
    call devxlib_memset_d(A_dev__dp_c3d,c_const_real64)
  
  ! 
  ! mem copy d2h
  call devxlib_memcpy_d2h(A_hst2__dp_c3d, A_dev__dp_c3d)
  !
  ! check
  if (lfail_malloc) write(6,"(3x,a)") "Malloc FAILED" 
  !
  if ( any(abs(A_hst1__dp_c3d -A_hst0__dp_c3d )> thr) .or. &
       any(abs(A_hst2__dp_c3d -A_hst0__dp_c3d )> thr) ) then
     !
     write(6,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(6,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst0__dp_c3d)
  deallocate(A_hst1__dp_c3d)
  deallocate(A_hst2__dp_c3d)
  !
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_unmap(A_dev__dp_c3d)
  is_alloc = devxlib_mapped( A_dev__dp_c3d )
  !
  if (is_alloc) then
    nfail_malloc=nfail_malloc+1
    lfail_malloc=.true.
    write(6,"(3x,a)") "mem allocation check-post2 FAILED" 
  endif
  !
#endif
  !
  deallocate(A_dev__dp_c3d)
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(6,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !

  !
  !=====================
  write(6,"(/,3x,a)") "checking dp_c4d ..." 
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  lfail_malloc=.false.
  !
  is_alloc = devxlib_mapped( A_dev__dp_c4d )
  !
  if (is_alloc) then
     nfail_malloc=nfail_malloc+1
     lfail_malloc=.true.
     write(6,"(3x,a)") "mem allocation check-pre FAILED" 
  endif
  !
  ! allocations
  allocate( A_hst0__dp_c4d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2),bound4(1):bound4(2)) )
  allocate( A_hst1__dp_c4d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2),bound4(1):bound4(2)) )
  allocate( A_hst2__dp_c4d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2),bound4(1):bound4(2)) )
  allocate( A_dev__dp_c4d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2),bound4(1):bound4(2)) )
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_map(A_dev__dp_c4d)
#endif
  !
  is_alloc = devxlib_mapped( A_dev__dp_c4d )
  !
  if (.not.is_alloc) then
    nfail_malloc=nfail_malloc+1
    lfail_malloc=.true.
    write(6,"(3x,a)") "mem allocation check-post FAILED" 
  endif
  !
  ! init
    c_const_real64 = (1.0,2.0)
  
  !
  ! memset
  !
    A_hst0__dp_c4d=c_const_real64
    call devxlib_memset_h(A_hst1__dp_c4d,c_const_real64)
    call devxlib_memset_d(A_dev__dp_c4d,c_const_real64)
  
  ! 
  ! mem copy d2h
  call devxlib_memcpy_d2h(A_hst2__dp_c4d, A_dev__dp_c4d)
  !
  ! check
  if (lfail_malloc) write(6,"(3x,a)") "Malloc FAILED" 
  !
  if ( any(abs(A_hst1__dp_c4d -A_hst0__dp_c4d )> thr) .or. &
       any(abs(A_hst2__dp_c4d -A_hst0__dp_c4d )> thr) ) then
     !
     write(6,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(6,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst0__dp_c4d)
  deallocate(A_hst1__dp_c4d)
  deallocate(A_hst2__dp_c4d)
  !
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_unmap(A_dev__dp_c4d)
  is_alloc = devxlib_mapped( A_dev__dp_c4d )
  !
  if (is_alloc) then
    nfail_malloc=nfail_malloc+1
    lfail_malloc=.true.
    write(6,"(3x,a)") "mem allocation check-post2 FAILED" 
  endif
  !
#endif
  !
  deallocate(A_dev__dp_c4d)
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(6,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !



  !
  !=====================
  write(6,"(/,3x,a)") "checking i4_i1d ..." 
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  lfail_malloc=.false.
  !
  is_alloc = devxlib_mapped( A_dev__i4_i1d )
  !
  if (is_alloc) then
     nfail_malloc=nfail_malloc+1
     lfail_malloc=.true.
     write(6,"(3x,a)") "mem allocation check-pre FAILED" 
  endif
  !
  ! allocations
  allocate( A_hst0__i4_i1d(bound1(1):bound1(2)) )
  allocate( A_hst1__i4_i1d(bound1(1):bound1(2)) )
  allocate( A_hst2__i4_i1d(bound1(1):bound1(2)) )
  allocate( A_dev__i4_i1d(bound1(1):bound1(2)) )
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_map(A_dev__i4_i1d)
#endif
  !
  is_alloc = devxlib_mapped( A_dev__i4_i1d )
  !
  if (.not.is_alloc) then
    nfail_malloc=nfail_malloc+1
    lfail_malloc=.true.
    write(6,"(3x,a)") "mem allocation check-post FAILED" 
  endif
  !
  ! init
    i_const_int32 = 3
  
  !
  ! memset
  !
    A_hst0__i4_i1d=i_const_int32
    call devxlib_memset_h(A_hst1__i4_i1d,i_const_int32)
    call devxlib_memset_d(A_dev__i4_i1d,i_const_int32)
  
  ! 
  ! mem copy d2h
  call devxlib_memcpy_d2h(A_hst2__i4_i1d, A_dev__i4_i1d)
  !
  ! check
  if (lfail_malloc) write(6,"(3x,a)") "Malloc FAILED" 
  !
  if ( any(abs(A_hst1__i4_i1d -A_hst0__i4_i1d )> thr) .or. &
       any(abs(A_hst2__i4_i1d -A_hst0__i4_i1d )> thr) ) then
     !
     write(6,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(6,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst0__i4_i1d)
  deallocate(A_hst1__i4_i1d)
  deallocate(A_hst2__i4_i1d)
  !
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_unmap(A_dev__i4_i1d)
  is_alloc = devxlib_mapped( A_dev__i4_i1d )
  !
  if (is_alloc) then
    nfail_malloc=nfail_malloc+1
    lfail_malloc=.true.
    write(6,"(3x,a)") "mem allocation check-post2 FAILED" 
  endif
  !
#endif
  !
  deallocate(A_dev__i4_i1d)
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(6,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !

  !
  !=====================
  write(6,"(/,3x,a)") "checking i4_i2d ..." 
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  lfail_malloc=.false.
  !
  is_alloc = devxlib_mapped( A_dev__i4_i2d )
  !
  if (is_alloc) then
     nfail_malloc=nfail_malloc+1
     lfail_malloc=.true.
     write(6,"(3x,a)") "mem allocation check-pre FAILED" 
  endif
  !
  ! allocations
  allocate( A_hst0__i4_i2d(bound1(1):bound1(2),bound2(1):bound2(2)) )
  allocate( A_hst1__i4_i2d(bound1(1):bound1(2),bound2(1):bound2(2)) )
  allocate( A_hst2__i4_i2d(bound1(1):bound1(2),bound2(1):bound2(2)) )
  allocate( A_dev__i4_i2d(bound1(1):bound1(2),bound2(1):bound2(2)) )
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_map(A_dev__i4_i2d)
#endif
  !
  is_alloc = devxlib_mapped( A_dev__i4_i2d )
  !
  if (.not.is_alloc) then
    nfail_malloc=nfail_malloc+1
    lfail_malloc=.true.
    write(6,"(3x,a)") "mem allocation check-post FAILED" 
  endif
  !
  ! init
    i_const_int32 = 3
  
  !
  ! memset
  !
    A_hst0__i4_i2d=i_const_int32
    call devxlib_memset_h(A_hst1__i4_i2d,i_const_int32)
    call devxlib_memset_d(A_dev__i4_i2d,i_const_int32)
  
  ! 
  ! mem copy d2h
  call devxlib_memcpy_d2h(A_hst2__i4_i2d, A_dev__i4_i2d)
  !
  ! check
  if (lfail_malloc) write(6,"(3x,a)") "Malloc FAILED" 
  !
  if ( any(abs(A_hst1__i4_i2d -A_hst0__i4_i2d )> thr) .or. &
       any(abs(A_hst2__i4_i2d -A_hst0__i4_i2d )> thr) ) then
     !
     write(6,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(6,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst0__i4_i2d)
  deallocate(A_hst1__i4_i2d)
  deallocate(A_hst2__i4_i2d)
  !
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_unmap(A_dev__i4_i2d)
  is_alloc = devxlib_mapped( A_dev__i4_i2d )
  !
  if (is_alloc) then
    nfail_malloc=nfail_malloc+1
    lfail_malloc=.true.
    write(6,"(3x,a)") "mem allocation check-post2 FAILED" 
  endif
  !
#endif
  !
  deallocate(A_dev__i4_i2d)
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(6,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !

  !
  !=====================
  write(6,"(/,3x,a)") "checking i4_i3d ..." 
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  lfail_malloc=.false.
  !
  is_alloc = devxlib_mapped( A_dev__i4_i3d )
  !
  if (is_alloc) then
     nfail_malloc=nfail_malloc+1
     lfail_malloc=.true.
     write(6,"(3x,a)") "mem allocation check-pre FAILED" 
  endif
  !
  ! allocations
  allocate( A_hst0__i4_i3d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2)) )
  allocate( A_hst1__i4_i3d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2)) )
  allocate( A_hst2__i4_i3d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2)) )
  allocate( A_dev__i4_i3d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2)) )
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_map(A_dev__i4_i3d)
#endif
  !
  is_alloc = devxlib_mapped( A_dev__i4_i3d )
  !
  if (.not.is_alloc) then
    nfail_malloc=nfail_malloc+1
    lfail_malloc=.true.
    write(6,"(3x,a)") "mem allocation check-post FAILED" 
  endif
  !
  ! init
    i_const_int32 = 3
  
  !
  ! memset
  !
    A_hst0__i4_i3d=i_const_int32
    call devxlib_memset_h(A_hst1__i4_i3d,i_const_int32)
    call devxlib_memset_d(A_dev__i4_i3d,i_const_int32)
  
  ! 
  ! mem copy d2h
  call devxlib_memcpy_d2h(A_hst2__i4_i3d, A_dev__i4_i3d)
  !
  ! check
  if (lfail_malloc) write(6,"(3x,a)") "Malloc FAILED" 
  !
  if ( any(abs(A_hst1__i4_i3d -A_hst0__i4_i3d )> thr) .or. &
       any(abs(A_hst2__i4_i3d -A_hst0__i4_i3d )> thr) ) then
     !
     write(6,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(6,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst0__i4_i3d)
  deallocate(A_hst1__i4_i3d)
  deallocate(A_hst2__i4_i3d)
  !
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_unmap(A_dev__i4_i3d)
  is_alloc = devxlib_mapped( A_dev__i4_i3d )
  !
  if (is_alloc) then
    nfail_malloc=nfail_malloc+1
    lfail_malloc=.true.
    write(6,"(3x,a)") "mem allocation check-post2 FAILED" 
  endif
  !
#endif
  !
  deallocate(A_dev__i4_i3d)
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(6,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !

  !
  !=====================
  write(6,"(/,3x,a)") "checking i4_i4d ..." 
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  lfail_malloc=.false.
  !
  is_alloc = devxlib_mapped( A_dev__i4_i4d )
  !
  if (is_alloc) then
     nfail_malloc=nfail_malloc+1
     lfail_malloc=.true.
     write(6,"(3x,a)") "mem allocation check-pre FAILED" 
  endif
  !
  ! allocations
  allocate( A_hst0__i4_i4d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2),bound4(1):bound4(2)) )
  allocate( A_hst1__i4_i4d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2),bound4(1):bound4(2)) )
  allocate( A_hst2__i4_i4d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2),bound4(1):bound4(2)) )
  allocate( A_dev__i4_i4d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2),bound4(1):bound4(2)) )
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_map(A_dev__i4_i4d)
#endif
  !
  is_alloc = devxlib_mapped( A_dev__i4_i4d )
  !
  if (.not.is_alloc) then
    nfail_malloc=nfail_malloc+1
    lfail_malloc=.true.
    write(6,"(3x,a)") "mem allocation check-post FAILED" 
  endif
  !
  ! init
    i_const_int32 = 3
  
  !
  ! memset
  !
    A_hst0__i4_i4d=i_const_int32
    call devxlib_memset_h(A_hst1__i4_i4d,i_const_int32)
    call devxlib_memset_d(A_dev__i4_i4d,i_const_int32)
  
  ! 
  ! mem copy d2h
  call devxlib_memcpy_d2h(A_hst2__i4_i4d, A_dev__i4_i4d)
  !
  ! check
  if (lfail_malloc) write(6,"(3x,a)") "Malloc FAILED" 
  !
  if ( any(abs(A_hst1__i4_i4d -A_hst0__i4_i4d )> thr) .or. &
       any(abs(A_hst2__i4_i4d -A_hst0__i4_i4d )> thr) ) then
     !
     write(6,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(6,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst0__i4_i4d)
  deallocate(A_hst1__i4_i4d)
  deallocate(A_hst2__i4_i4d)
  !
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_unmap(A_dev__i4_i4d)
  is_alloc = devxlib_mapped( A_dev__i4_i4d )
  !
  if (is_alloc) then
    nfail_malloc=nfail_malloc+1
    lfail_malloc=.true.
    write(6,"(3x,a)") "mem allocation check-post2 FAILED" 
  endif
  !
#endif
  !
  deallocate(A_dev__i4_i4d)
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(6,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !


  !
  !=====================
  write(6,"(/,3x,a)") "checking i8_i1d ..." 
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  lfail_malloc=.false.
  !
  is_alloc = devxlib_mapped( A_dev__i8_i1d )
  !
  if (is_alloc) then
     nfail_malloc=nfail_malloc+1
     lfail_malloc=.true.
     write(6,"(3x,a)") "mem allocation check-pre FAILED" 
  endif
  !
  ! allocations
  allocate( A_hst0__i8_i1d(bound1(1):bound1(2)) )
  allocate( A_hst1__i8_i1d(bound1(1):bound1(2)) )
  allocate( A_hst2__i8_i1d(bound1(1):bound1(2)) )
  allocate( A_dev__i8_i1d(bound1(1):bound1(2)) )
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_map(A_dev__i8_i1d)
#endif
  !
  is_alloc = devxlib_mapped( A_dev__i8_i1d )
  !
  if (.not.is_alloc) then
    nfail_malloc=nfail_malloc+1
    lfail_malloc=.true.
    write(6,"(3x,a)") "mem allocation check-post FAILED" 
  endif
  !
  ! init
    i_const_int64 = 3
  
  !
  ! memset
  !
    A_hst0__i8_i1d=i_const_int64
    call devxlib_memset_h(A_hst1__i8_i1d,i_const_int64)
    call devxlib_memset_d(A_dev__i8_i1d,i_const_int64)
  
  ! 
  ! mem copy d2h
  call devxlib_memcpy_d2h(A_hst2__i8_i1d, A_dev__i8_i1d)
  !
  ! check
  if (lfail_malloc) write(6,"(3x,a)") "Malloc FAILED" 
  !
  if ( any(abs(A_hst1__i8_i1d -A_hst0__i8_i1d )> thr) .or. &
       any(abs(A_hst2__i8_i1d -A_hst0__i8_i1d )> thr) ) then
     !
     write(6,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(6,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst0__i8_i1d)
  deallocate(A_hst1__i8_i1d)
  deallocate(A_hst2__i8_i1d)
  !
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_unmap(A_dev__i8_i1d)
  is_alloc = devxlib_mapped( A_dev__i8_i1d )
  !
  if (is_alloc) then
    nfail_malloc=nfail_malloc+1
    lfail_malloc=.true.
    write(6,"(3x,a)") "mem allocation check-post2 FAILED" 
  endif
  !
#endif
  !
  deallocate(A_dev__i8_i1d)
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(6,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !

  !
  !=====================
  write(6,"(/,3x,a)") "checking i8_i2d ..." 
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  lfail_malloc=.false.
  !
  is_alloc = devxlib_mapped( A_dev__i8_i2d )
  !
  if (is_alloc) then
     nfail_malloc=nfail_malloc+1
     lfail_malloc=.true.
     write(6,"(3x,a)") "mem allocation check-pre FAILED" 
  endif
  !
  ! allocations
  allocate( A_hst0__i8_i2d(bound1(1):bound1(2),bound2(1):bound2(2)) )
  allocate( A_hst1__i8_i2d(bound1(1):bound1(2),bound2(1):bound2(2)) )
  allocate( A_hst2__i8_i2d(bound1(1):bound1(2),bound2(1):bound2(2)) )
  allocate( A_dev__i8_i2d(bound1(1):bound1(2),bound2(1):bound2(2)) )
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_map(A_dev__i8_i2d)
#endif
  !
  is_alloc = devxlib_mapped( A_dev__i8_i2d )
  !
  if (.not.is_alloc) then
    nfail_malloc=nfail_malloc+1
    lfail_malloc=.true.
    write(6,"(3x,a)") "mem allocation check-post FAILED" 
  endif
  !
  ! init
    i_const_int64 = 3
  
  !
  ! memset
  !
    A_hst0__i8_i2d=i_const_int64
    call devxlib_memset_h(A_hst1__i8_i2d,i_const_int64)
    call devxlib_memset_d(A_dev__i8_i2d,i_const_int64)
  
  ! 
  ! mem copy d2h
  call devxlib_memcpy_d2h(A_hst2__i8_i2d, A_dev__i8_i2d)
  !
  ! check
  if (lfail_malloc) write(6,"(3x,a)") "Malloc FAILED" 
  !
  if ( any(abs(A_hst1__i8_i2d -A_hst0__i8_i2d )> thr) .or. &
       any(abs(A_hst2__i8_i2d -A_hst0__i8_i2d )> thr) ) then
     !
     write(6,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(6,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst0__i8_i2d)
  deallocate(A_hst1__i8_i2d)
  deallocate(A_hst2__i8_i2d)
  !
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_unmap(A_dev__i8_i2d)
  is_alloc = devxlib_mapped( A_dev__i8_i2d )
  !
  if (is_alloc) then
    nfail_malloc=nfail_malloc+1
    lfail_malloc=.true.
    write(6,"(3x,a)") "mem allocation check-post2 FAILED" 
  endif
  !
#endif
  !
  deallocate(A_dev__i8_i2d)
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(6,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !

  !
  !=====================
  write(6,"(/,3x,a)") "checking i8_i3d ..." 
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  lfail_malloc=.false.
  !
  is_alloc = devxlib_mapped( A_dev__i8_i3d )
  !
  if (is_alloc) then
     nfail_malloc=nfail_malloc+1
     lfail_malloc=.true.
     write(6,"(3x,a)") "mem allocation check-pre FAILED" 
  endif
  !
  ! allocations
  allocate( A_hst0__i8_i3d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2)) )
  allocate( A_hst1__i8_i3d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2)) )
  allocate( A_hst2__i8_i3d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2)) )
  allocate( A_dev__i8_i3d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2)) )
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_map(A_dev__i8_i3d)
#endif
  !
  is_alloc = devxlib_mapped( A_dev__i8_i3d )
  !
  if (.not.is_alloc) then
    nfail_malloc=nfail_malloc+1
    lfail_malloc=.true.
    write(6,"(3x,a)") "mem allocation check-post FAILED" 
  endif
  !
  ! init
    i_const_int64 = 3
  
  !
  ! memset
  !
    A_hst0__i8_i3d=i_const_int64
    call devxlib_memset_h(A_hst1__i8_i3d,i_const_int64)
    call devxlib_memset_d(A_dev__i8_i3d,i_const_int64)
  
  ! 
  ! mem copy d2h
  call devxlib_memcpy_d2h(A_hst2__i8_i3d, A_dev__i8_i3d)
  !
  ! check
  if (lfail_malloc) write(6,"(3x,a)") "Malloc FAILED" 
  !
  if ( any(abs(A_hst1__i8_i3d -A_hst0__i8_i3d )> thr) .or. &
       any(abs(A_hst2__i8_i3d -A_hst0__i8_i3d )> thr) ) then
     !
     write(6,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(6,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst0__i8_i3d)
  deallocate(A_hst1__i8_i3d)
  deallocate(A_hst2__i8_i3d)
  !
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_unmap(A_dev__i8_i3d)
  is_alloc = devxlib_mapped( A_dev__i8_i3d )
  !
  if (is_alloc) then
    nfail_malloc=nfail_malloc+1
    lfail_malloc=.true.
    write(6,"(3x,a)") "mem allocation check-post2 FAILED" 
  endif
  !
#endif
  !
  deallocate(A_dev__i8_i3d)
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(6,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !

  !
  !=====================
  write(6,"(/,3x,a)") "checking i8_i4d ..." 
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  lfail_malloc=.false.
  !
  is_alloc = devxlib_mapped( A_dev__i8_i4d )
  !
  if (is_alloc) then
     nfail_malloc=nfail_malloc+1
     lfail_malloc=.true.
     write(6,"(3x,a)") "mem allocation check-pre FAILED" 
  endif
  !
  ! allocations
  allocate( A_hst0__i8_i4d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2),bound4(1):bound4(2)) )
  allocate( A_hst1__i8_i4d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2),bound4(1):bound4(2)) )
  allocate( A_hst2__i8_i4d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2),bound4(1):bound4(2)) )
  allocate( A_dev__i8_i4d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2),bound4(1):bound4(2)) )
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_map(A_dev__i8_i4d)
#endif
  !
  is_alloc = devxlib_mapped( A_dev__i8_i4d )
  !
  if (.not.is_alloc) then
    nfail_malloc=nfail_malloc+1
    lfail_malloc=.true.
    write(6,"(3x,a)") "mem allocation check-post FAILED" 
  endif
  !
  ! init
    i_const_int64 = 3
  
  !
  ! memset
  !
    A_hst0__i8_i4d=i_const_int64
    call devxlib_memset_h(A_hst1__i8_i4d,i_const_int64)
    call devxlib_memset_d(A_dev__i8_i4d,i_const_int64)
  
  ! 
  ! mem copy d2h
  call devxlib_memcpy_d2h(A_hst2__i8_i4d, A_dev__i8_i4d)
  !
  ! check
  if (lfail_malloc) write(6,"(3x,a)") "Malloc FAILED" 
  !
  if ( any(abs(A_hst1__i8_i4d -A_hst0__i8_i4d )> thr) .or. &
       any(abs(A_hst2__i8_i4d -A_hst0__i8_i4d )> thr) ) then
     !
     write(6,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(6,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst0__i8_i4d)
  deallocate(A_hst1__i8_i4d)
  deallocate(A_hst2__i8_i4d)
  !
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_unmap(A_dev__i8_i4d)
  is_alloc = devxlib_mapped( A_dev__i8_i4d )
  !
  if (is_alloc) then
    nfail_malloc=nfail_malloc+1
    lfail_malloc=.true.
    write(6,"(3x,a)") "mem allocation check-post2 FAILED" 
  endif
  !
#endif
  !
  deallocate(A_dev__i8_i4d)
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(6,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !



  !
  !=====================
  write(6,"(/,3x,a)") "checking l4_l1d ..." 
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  lfail_malloc=.false.
  !
  is_alloc = devxlib_mapped( A_dev__l4_l1d )
  !
  if (is_alloc) then
     nfail_malloc=nfail_malloc+1
     lfail_malloc=.true.
     write(6,"(3x,a)") "mem allocation check-pre FAILED" 
  endif
  !
  ! allocations
  allocate( A_hst0__l4_l1d(bound1(1):bound1(2)) )
  allocate( A_hst1__l4_l1d(bound1(1):bound1(2)) )
  allocate( A_hst2__l4_l1d(bound1(1):bound1(2)) )
  allocate( A_dev__l4_l1d(bound1(1):bound1(2)) )
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_map(A_dev__l4_l1d)
#endif
  !
  is_alloc = devxlib_mapped( A_dev__l4_l1d )
  !
  if (.not.is_alloc) then
    nfail_malloc=nfail_malloc+1
    lfail_malloc=.true.
    write(6,"(3x,a)") "mem allocation check-post FAILED" 
  endif
  !
  ! init
    l_const = .true.
  
  !
  ! memset
  !
    A_hst0__l4_l1d=l_const
    call devxlib_memset_h(A_hst1__l4_l1d,l_const)
    call devxlib_memset_d(A_dev__l4_l1d,l_const)
  
  ! 
  ! mem copy d2h
  call devxlib_memcpy_d2h(A_hst2__l4_l1d, A_dev__l4_l1d)
  !
  ! check
  if (lfail_malloc) write(6,"(3x,a)") "Malloc FAILED" 
  !
  if ( any( A_hst1__l4_l1d .neqv. A_hst0__l4_l1d ) .or. &
       any( A_hst2__l4_l1d .neqv. A_hst0__l4_l1d )    ) then
     !
     write(6,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(6,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst0__l4_l1d)
  deallocate(A_hst1__l4_l1d)
  deallocate(A_hst2__l4_l1d)
  !
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_unmap(A_dev__l4_l1d)
  is_alloc = devxlib_mapped( A_dev__l4_l1d )
  !
  if (is_alloc) then
    nfail_malloc=nfail_malloc+1
    lfail_malloc=.true.
    write(6,"(3x,a)") "mem allocation check-post2 FAILED" 
  endif
  !
#endif
  !
  deallocate(A_dev__l4_l1d)
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(6,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !

  !
  !=====================
  write(6,"(/,3x,a)") "checking l4_l2d ..." 
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  lfail_malloc=.false.
  !
  is_alloc = devxlib_mapped( A_dev__l4_l2d )
  !
  if (is_alloc) then
     nfail_malloc=nfail_malloc+1
     lfail_malloc=.true.
     write(6,"(3x,a)") "mem allocation check-pre FAILED" 
  endif
  !
  ! allocations
  allocate( A_hst0__l4_l2d(bound1(1):bound1(2),bound2(1):bound2(2)) )
  allocate( A_hst1__l4_l2d(bound1(1):bound1(2),bound2(1):bound2(2)) )
  allocate( A_hst2__l4_l2d(bound1(1):bound1(2),bound2(1):bound2(2)) )
  allocate( A_dev__l4_l2d(bound1(1):bound1(2),bound2(1):bound2(2)) )
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_map(A_dev__l4_l2d)
#endif
  !
  is_alloc = devxlib_mapped( A_dev__l4_l2d )
  !
  if (.not.is_alloc) then
    nfail_malloc=nfail_malloc+1
    lfail_malloc=.true.
    write(6,"(3x,a)") "mem allocation check-post FAILED" 
  endif
  !
  ! init
    l_const = .true.
  
  !
  ! memset
  !
    A_hst0__l4_l2d=l_const
    call devxlib_memset_h(A_hst1__l4_l2d,l_const)
    call devxlib_memset_d(A_dev__l4_l2d,l_const)
  
  ! 
  ! mem copy d2h
  call devxlib_memcpy_d2h(A_hst2__l4_l2d, A_dev__l4_l2d)
  !
  ! check
  if (lfail_malloc) write(6,"(3x,a)") "Malloc FAILED" 
  !
  if ( any( A_hst1__l4_l2d .neqv. A_hst0__l4_l2d ) .or. &
       any( A_hst2__l4_l2d .neqv. A_hst0__l4_l2d )    ) then
     !
     write(6,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(6,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst0__l4_l2d)
  deallocate(A_hst1__l4_l2d)
  deallocate(A_hst2__l4_l2d)
  !
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_unmap(A_dev__l4_l2d)
  is_alloc = devxlib_mapped( A_dev__l4_l2d )
  !
  if (is_alloc) then
    nfail_malloc=nfail_malloc+1
    lfail_malloc=.true.
    write(6,"(3x,a)") "mem allocation check-post2 FAILED" 
  endif
  !
#endif
  !
  deallocate(A_dev__l4_l2d)
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(6,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !

  !
  !=====================
  write(6,"(/,3x,a)") "checking l4_l3d ..." 
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  lfail_malloc=.false.
  !
  is_alloc = devxlib_mapped( A_dev__l4_l3d )
  !
  if (is_alloc) then
     nfail_malloc=nfail_malloc+1
     lfail_malloc=.true.
     write(6,"(3x,a)") "mem allocation check-pre FAILED" 
  endif
  !
  ! allocations
  allocate( A_hst0__l4_l3d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2)) )
  allocate( A_hst1__l4_l3d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2)) )
  allocate( A_hst2__l4_l3d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2)) )
  allocate( A_dev__l4_l3d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2)) )
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_map(A_dev__l4_l3d)
#endif
  !
  is_alloc = devxlib_mapped( A_dev__l4_l3d )
  !
  if (.not.is_alloc) then
    nfail_malloc=nfail_malloc+1
    lfail_malloc=.true.
    write(6,"(3x,a)") "mem allocation check-post FAILED" 
  endif
  !
  ! init
    l_const = .true.
  
  !
  ! memset
  !
    A_hst0__l4_l3d=l_const
    call devxlib_memset_h(A_hst1__l4_l3d,l_const)
    call devxlib_memset_d(A_dev__l4_l3d,l_const)
  
  ! 
  ! mem copy d2h
  call devxlib_memcpy_d2h(A_hst2__l4_l3d, A_dev__l4_l3d)
  !
  ! check
  if (lfail_malloc) write(6,"(3x,a)") "Malloc FAILED" 
  !
  if ( any( A_hst1__l4_l3d .neqv. A_hst0__l4_l3d ) .or. &
       any( A_hst2__l4_l3d .neqv. A_hst0__l4_l3d )    ) then
     !
     write(6,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(6,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst0__l4_l3d)
  deallocate(A_hst1__l4_l3d)
  deallocate(A_hst2__l4_l3d)
  !
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_unmap(A_dev__l4_l3d)
  is_alloc = devxlib_mapped( A_dev__l4_l3d )
  !
  if (is_alloc) then
    nfail_malloc=nfail_malloc+1
    lfail_malloc=.true.
    write(6,"(3x,a)") "mem allocation check-post2 FAILED" 
  endif
  !
#endif
  !
  deallocate(A_dev__l4_l3d)
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(6,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !

  !
  !=====================
  write(6,"(/,3x,a)") "checking l4_l4d ..." 
  call system_clock(cnt, count_rate, count_max)
  t0=cnt/count_rate
  lfail_malloc=.false.
  !
  is_alloc = devxlib_mapped( A_dev__l4_l4d )
  !
  if (is_alloc) then
     nfail_malloc=nfail_malloc+1
     lfail_malloc=.true.
     write(6,"(3x,a)") "mem allocation check-pre FAILED" 
  endif
  !
  ! allocations
  allocate( A_hst0__l4_l4d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2),bound4(1):bound4(2)) )
  allocate( A_hst1__l4_l4d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2),bound4(1):bound4(2)) )
  allocate( A_hst2__l4_l4d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2),bound4(1):bound4(2)) )
  allocate( A_dev__l4_l4d(bound1(1):bound1(2),bound2(1):bound2(2),bound3(1):bound3(2),bound4(1):bound4(2)) )
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_map(A_dev__l4_l4d)
#endif
  !
  is_alloc = devxlib_mapped( A_dev__l4_l4d )
  !
  if (.not.is_alloc) then
    nfail_malloc=nfail_malloc+1
    lfail_malloc=.true.
    write(6,"(3x,a)") "mem allocation check-post FAILED" 
  endif
  !
  ! init
    l_const = .true.
  
  !
  ! memset
  !
    A_hst0__l4_l4d=l_const
    call devxlib_memset_h(A_hst1__l4_l4d,l_const)
    call devxlib_memset_d(A_dev__l4_l4d,l_const)
  
  ! 
  ! mem copy d2h
  call devxlib_memcpy_d2h(A_hst2__l4_l4d, A_dev__l4_l4d)
  !
  ! check
  if (lfail_malloc) write(6,"(3x,a)") "Malloc FAILED" 
  !
  if ( any( A_hst1__l4_l4d .neqv. A_hst0__l4_l4d ) .or. &
       any( A_hst2__l4_l4d .neqv. A_hst0__l4_l4d )    ) then
     !
     write(6,"(3x,a)") "FAILED" 
     nfail=nfail+1
  else
     write(6,"(3x,a)") "passed" 
     npass=npass+1
  endif
  !
  deallocate(A_hst0__l4_l4d)
  deallocate(A_hst1__l4_l4d)
  deallocate(A_hst2__l4_l4d)
  !
#if defined __DXL_OPENACC || defined __DXL_OPENMP_GPU
  call devxlib_unmap(A_dev__l4_l4d)
  is_alloc = devxlib_mapped( A_dev__l4_l4d )
  !
  if (is_alloc) then
    nfail_malloc=nfail_malloc+1
    lfail_malloc=.true.
    write(6,"(3x,a)") "mem allocation check-post2 FAILED" 
  endif
  !
#endif
  !
  deallocate(A_dev__l4_l4d)
  !
  call system_clock(cnt, count_rate, count_max)
  t1=cnt/count_rate
  write(6,"(3x,a,f12.6,' sec')") "Timing: ", t1-t0
  !




  !
  ! summary
  !
  write(6,"(/,a)") "# Test SUMMARY:"
  write(6,"(3x,a,i5)") "# passed: ", npass
  write(6,"(3x,a,i5)") "# failed: ", nfail
  write(6,"(3x,a,i5)") "# failed malloc: ", nfail_malloc
  write(6,"()")

end program test_memset

!
! Copyright (C) 2021, MaX CoE
! Distributed under the MIT License 
! (license terms are at http://opensource.org/licenses/MIT).
!
!--
!
! Module for direct memory access on the device (allocation, deallocation
! and allocation check) using CUDA-Fortran, OpenACC or OpenMP Offload
!
!==================================================================
!==================================================================
! *DO NOT EDIT*: automatically generated from device_malloc.jf90
!==================================================================
!==================================================================
!
#include<devxlib_macros.h>
#include<devxlib_defs.h>
!
!=======================================
!
module devxlib_malloc

   use iso_fortran_env,             only : int32, int64, real32, real64
   use, intrinsic :: iso_c_binding, only : c_loc, c_ptr, c_size_t, c_f_pointer, c_associated
#if defined __DXL_CUDAF || defined __DXL_OPENACC
   use devxlib_environment
#elif defined __DXL_OPENMP_GPU
   use omp_lib, only : omp_get_default_device, omp_target_is_present, omp_target_alloc, omp_target_free
#endif

   implicit none

   interface devxlib_alloc
      module procedure &
         sp_devxlib_malloc_alloc_r1d, sp_devxlib_malloc_alloc_r2d, sp_devxlib_malloc_alloc_r3d, &
         sp_devxlib_malloc_alloc_r4d, sp_devxlib_malloc_alloc_r5d, sp_devxlib_malloc_alloc_r6d, &
         dp_devxlib_malloc_alloc_r1d, dp_devxlib_malloc_alloc_r2d, dp_devxlib_malloc_alloc_r3d, &
         dp_devxlib_malloc_alloc_r4d, dp_devxlib_malloc_alloc_r5d, dp_devxlib_malloc_alloc_r6d, &
         sp_devxlib_malloc_alloc_c1d, sp_devxlib_malloc_alloc_c2d, sp_devxlib_malloc_alloc_c3d, &
         sp_devxlib_malloc_alloc_c4d, sp_devxlib_malloc_alloc_c5d, sp_devxlib_malloc_alloc_c6d, &
         dp_devxlib_malloc_alloc_c1d, dp_devxlib_malloc_alloc_c2d, dp_devxlib_malloc_alloc_c3d, &
         dp_devxlib_malloc_alloc_c4d, dp_devxlib_malloc_alloc_c5d, dp_devxlib_malloc_alloc_c6d, &
         i4_devxlib_malloc_alloc_i1d, i4_devxlib_malloc_alloc_i2d, i4_devxlib_malloc_alloc_i3d, &
         i4_devxlib_malloc_alloc_i4d, i4_devxlib_malloc_alloc_i5d, i4_devxlib_malloc_alloc_i6d, &
         i8_devxlib_malloc_alloc_i1d, i8_devxlib_malloc_alloc_i2d, i8_devxlib_malloc_alloc_i3d, &
         i8_devxlib_malloc_alloc_i4d, i8_devxlib_malloc_alloc_i5d, i8_devxlib_malloc_alloc_i6d, &
         l4_devxlib_malloc_alloc_l1d, l4_devxlib_malloc_alloc_l2d, l4_devxlib_malloc_alloc_l3d, &
         l4_devxlib_malloc_alloc_l4d, l4_devxlib_malloc_alloc_l5d, l4_devxlib_malloc_alloc_l6d
   endinterface devxlib_alloc

   interface devxlib_free
      module procedure &
         sp_devxlib_malloc_free_r1d, sp_devxlib_malloc_free_r2d, sp_devxlib_malloc_free_r3d, &
         sp_devxlib_malloc_free_r4d, sp_devxlib_malloc_free_r5d, sp_devxlib_malloc_free_r6d, &
         dp_devxlib_malloc_free_r1d, dp_devxlib_malloc_free_r2d, dp_devxlib_malloc_free_r3d, &
         dp_devxlib_malloc_free_r4d, dp_devxlib_malloc_free_r5d, dp_devxlib_malloc_free_r6d, &
         sp_devxlib_malloc_free_c1d, sp_devxlib_malloc_free_c2d, sp_devxlib_malloc_free_c3d, &
         sp_devxlib_malloc_free_c4d, sp_devxlib_malloc_free_c5d, sp_devxlib_malloc_free_c6d, &
         dp_devxlib_malloc_free_c1d, dp_devxlib_malloc_free_c2d, dp_devxlib_malloc_free_c3d, &
         dp_devxlib_malloc_free_c4d, dp_devxlib_malloc_free_c5d, dp_devxlib_malloc_free_c6d, &
         i4_devxlib_malloc_free_i1d, i4_devxlib_malloc_free_i2d, i4_devxlib_malloc_free_i3d, &
         i4_devxlib_malloc_free_i4d, i4_devxlib_malloc_free_i5d, i4_devxlib_malloc_free_i6d, &
         i8_devxlib_malloc_free_i1d, i8_devxlib_malloc_free_i2d, i8_devxlib_malloc_free_i3d, &
         i8_devxlib_malloc_free_i4d, i8_devxlib_malloc_free_i5d, i8_devxlib_malloc_free_i6d, &
         l4_devxlib_malloc_free_l1d, l4_devxlib_malloc_free_l2d, l4_devxlib_malloc_free_l3d, &
         l4_devxlib_malloc_free_l4d, l4_devxlib_malloc_free_l5d, l4_devxlib_malloc_free_l6d
   endinterface devxlib_free

   interface devxlib_allocated
      module procedure &
         sp_devxlib_malloc_allocated_r1d, sp_devxlib_malloc_allocated_r2d, sp_devxlib_malloc_allocated_r3d, &
         sp_devxlib_malloc_allocated_r4d, sp_devxlib_malloc_allocated_r5d, sp_devxlib_malloc_allocated_r6d, &
         dp_devxlib_malloc_allocated_r1d, dp_devxlib_malloc_allocated_r2d, dp_devxlib_malloc_allocated_r3d, &
         dp_devxlib_malloc_allocated_r4d, dp_devxlib_malloc_allocated_r5d, dp_devxlib_malloc_allocated_r6d, &
         sp_devxlib_malloc_allocated_c1d, sp_devxlib_malloc_allocated_c2d, sp_devxlib_malloc_allocated_c3d, &
         sp_devxlib_malloc_allocated_c4d, sp_devxlib_malloc_allocated_c5d, sp_devxlib_malloc_allocated_c6d, &
         dp_devxlib_malloc_allocated_c1d, dp_devxlib_malloc_allocated_c2d, dp_devxlib_malloc_allocated_c3d, &
         dp_devxlib_malloc_allocated_c4d, dp_devxlib_malloc_allocated_c5d, dp_devxlib_malloc_allocated_c6d, &
         i4_devxlib_malloc_allocated_i1d, i4_devxlib_malloc_allocated_i2d, i4_devxlib_malloc_allocated_i3d, &
         i4_devxlib_malloc_allocated_i4d, i4_devxlib_malloc_allocated_i5d, i4_devxlib_malloc_allocated_i6d, &
         i8_devxlib_malloc_allocated_i1d, i8_devxlib_malloc_allocated_i2d, i8_devxlib_malloc_allocated_i3d, &
         i8_devxlib_malloc_allocated_i4d, i8_devxlib_malloc_allocated_i5d, i8_devxlib_malloc_allocated_i6d, &
         l4_devxlib_malloc_allocated_l1d, l4_devxlib_malloc_allocated_l2d, l4_devxlib_malloc_allocated_l3d, &
         l4_devxlib_malloc_allocated_l4d, l4_devxlib_malloc_allocated_l5d, l4_devxlib_malloc_allocated_l6d
   endinterface devxlib_allocated

   interface devxlib_allocated_p
      module procedure &
         sp_devxlib_malloc_allocated_r1d_p, sp_devxlib_malloc_allocated_r2d_p, sp_devxlib_malloc_allocated_r3d_p, &
         sp_devxlib_malloc_allocated_r4d_p, sp_devxlib_malloc_allocated_r5d_p, sp_devxlib_malloc_allocated_r6d_p, &
         dp_devxlib_malloc_allocated_r1d_p, dp_devxlib_malloc_allocated_r2d_p, dp_devxlib_malloc_allocated_r3d_p, &
         dp_devxlib_malloc_allocated_r4d_p, dp_devxlib_malloc_allocated_r5d_p, dp_devxlib_malloc_allocated_r6d_p, &
         sp_devxlib_malloc_allocated_c1d_p, sp_devxlib_malloc_allocated_c2d_p, sp_devxlib_malloc_allocated_c3d_p, &
         sp_devxlib_malloc_allocated_c4d_p, sp_devxlib_malloc_allocated_c5d_p, sp_devxlib_malloc_allocated_c6d_p, &
         dp_devxlib_malloc_allocated_c1d_p, dp_devxlib_malloc_allocated_c2d_p, dp_devxlib_malloc_allocated_c3d_p, &
         dp_devxlib_malloc_allocated_c4d_p, dp_devxlib_malloc_allocated_c5d_p, dp_devxlib_malloc_allocated_c6d_p, &
         i4_devxlib_malloc_allocated_i1d_p, i4_devxlib_malloc_allocated_i2d_p, i4_devxlib_malloc_allocated_i3d_p, &
         i4_devxlib_malloc_allocated_i4d_p, i4_devxlib_malloc_allocated_i5d_p, i4_devxlib_malloc_allocated_i6d_p, &
         i8_devxlib_malloc_allocated_i1d_p, i8_devxlib_malloc_allocated_i2d_p, i8_devxlib_malloc_allocated_i3d_p, &
         i8_devxlib_malloc_allocated_i4d_p, i8_devxlib_malloc_allocated_i5d_p, i8_devxlib_malloc_allocated_i6d_p, &
         l4_devxlib_malloc_allocated_l1d_p, l4_devxlib_malloc_allocated_l2d_p, l4_devxlib_malloc_allocated_l3d_p, &
         l4_devxlib_malloc_allocated_l4d_p, l4_devxlib_malloc_allocated_l5d_p, l4_devxlib_malloc_allocated_l6d_p
   endinterface devxlib_allocated_p


   interface
      module subroutine sp_devxlib_malloc_alloc_r1d(dev_ptr, dimensions, ierr, device_id, lbounds)
         implicit none
         real(real32), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:)
         integer(int64), intent(in)           :: dimensions
         integer(int32), intent(out)          :: ierr
         integer(int32), intent(in), optional :: device_id
         integer(int64), intent(in), optional :: lbounds
      end subroutine sp_devxlib_malloc_alloc_r1d
      module subroutine sp_devxlib_malloc_alloc_r2d(dev_ptr, dimensions, ierr, device_id, lbounds)
         implicit none
         real(real32), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:)
         integer(int64), intent(in)           :: dimensions(2)
         integer(int32), intent(out)          :: ierr
         integer(int32), intent(in), optional :: device_id
         integer(int64), intent(in), optional :: lbounds(2)
      end subroutine sp_devxlib_malloc_alloc_r2d
      module subroutine sp_devxlib_malloc_alloc_r3d(dev_ptr, dimensions, ierr, device_id, lbounds)
         implicit none
         real(real32), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:,:)
         integer(int64), intent(in)           :: dimensions(3)
         integer(int32), intent(out)          :: ierr
         integer(int32), intent(in), optional :: device_id
         integer(int64), intent(in), optional :: lbounds(3)
      end subroutine sp_devxlib_malloc_alloc_r3d
      module subroutine sp_devxlib_malloc_alloc_r4d(dev_ptr, dimensions, ierr, device_id, lbounds)
         implicit none
         real(real32), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:,:,:)
         integer(int64), intent(in)           :: dimensions(4)
         integer(int32), intent(out)          :: ierr
         integer(int32), intent(in), optional :: device_id
         integer(int64), intent(in), optional :: lbounds(4)
      end subroutine sp_devxlib_malloc_alloc_r4d
      module subroutine sp_devxlib_malloc_alloc_r5d(dev_ptr, dimensions, ierr, device_id, lbounds)
         implicit none
         real(real32), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:,:,:,:)
         integer(int64), intent(in)           :: dimensions(5)
         integer(int32), intent(out)          :: ierr
         integer(int32), intent(in), optional :: device_id
         integer(int64), intent(in), optional :: lbounds(5)
      end subroutine sp_devxlib_malloc_alloc_r5d
      module subroutine sp_devxlib_malloc_alloc_r6d(dev_ptr, dimensions, ierr, device_id, lbounds)
         implicit none
         real(real32), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:,:,:,:,:)
         integer(int64), intent(in)           :: dimensions(6)
         integer(int32), intent(out)          :: ierr
         integer(int32), intent(in), optional :: device_id
         integer(int64), intent(in), optional :: lbounds(6)
      end subroutine sp_devxlib_malloc_alloc_r6d
      module subroutine dp_devxlib_malloc_alloc_r1d(dev_ptr, dimensions, ierr, device_id, lbounds)
         implicit none
         real(real64), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:)
         integer(int64), intent(in)           :: dimensions
         integer(int32), intent(out)          :: ierr
         integer(int32), intent(in), optional :: device_id
         integer(int64), intent(in), optional :: lbounds
      end subroutine dp_devxlib_malloc_alloc_r1d
      module subroutine dp_devxlib_malloc_alloc_r2d(dev_ptr, dimensions, ierr, device_id, lbounds)
         implicit none
         real(real64), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:)
         integer(int64), intent(in)           :: dimensions(2)
         integer(int32), intent(out)          :: ierr
         integer(int32), intent(in), optional :: device_id
         integer(int64), intent(in), optional :: lbounds(2)
      end subroutine dp_devxlib_malloc_alloc_r2d
      module subroutine dp_devxlib_malloc_alloc_r3d(dev_ptr, dimensions, ierr, device_id, lbounds)
         implicit none
         real(real64), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:,:)
         integer(int64), intent(in)           :: dimensions(3)
         integer(int32), intent(out)          :: ierr
         integer(int32), intent(in), optional :: device_id
         integer(int64), intent(in), optional :: lbounds(3)
      end subroutine dp_devxlib_malloc_alloc_r3d
      module subroutine dp_devxlib_malloc_alloc_r4d(dev_ptr, dimensions, ierr, device_id, lbounds)
         implicit none
         real(real64), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:,:,:)
         integer(int64), intent(in)           :: dimensions(4)
         integer(int32), intent(out)          :: ierr
         integer(int32), intent(in), optional :: device_id
         integer(int64), intent(in), optional :: lbounds(4)
      end subroutine dp_devxlib_malloc_alloc_r4d
      module subroutine dp_devxlib_malloc_alloc_r5d(dev_ptr, dimensions, ierr, device_id, lbounds)
         implicit none
         real(real64), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:,:,:,:)
         integer(int64), intent(in)           :: dimensions(5)
         integer(int32), intent(out)          :: ierr
         integer(int32), intent(in), optional :: device_id
         integer(int64), intent(in), optional :: lbounds(5)
      end subroutine dp_devxlib_malloc_alloc_r5d
      module subroutine dp_devxlib_malloc_alloc_r6d(dev_ptr, dimensions, ierr, device_id, lbounds)
         implicit none
         real(real64), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:,:,:,:,:)
         integer(int64), intent(in)           :: dimensions(6)
         integer(int32), intent(out)          :: ierr
         integer(int32), intent(in), optional :: device_id
         integer(int64), intent(in), optional :: lbounds(6)
      end subroutine dp_devxlib_malloc_alloc_r6d
      module subroutine sp_devxlib_malloc_alloc_c1d(dev_ptr, dimensions, ierr, device_id, lbounds)
         implicit none
         complex(real32), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:)
         integer(int64), intent(in)           :: dimensions
         integer(int32), intent(out)          :: ierr
         integer(int32), intent(in), optional :: device_id
         integer(int64), intent(in), optional :: lbounds
      end subroutine sp_devxlib_malloc_alloc_c1d
      module subroutine sp_devxlib_malloc_alloc_c2d(dev_ptr, dimensions, ierr, device_id, lbounds)
         implicit none
         complex(real32), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:)
         integer(int64), intent(in)           :: dimensions(2)
         integer(int32), intent(out)          :: ierr
         integer(int32), intent(in), optional :: device_id
         integer(int64), intent(in), optional :: lbounds(2)
      end subroutine sp_devxlib_malloc_alloc_c2d
      module subroutine sp_devxlib_malloc_alloc_c3d(dev_ptr, dimensions, ierr, device_id, lbounds)
         implicit none
         complex(real32), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:,:)
         integer(int64), intent(in)           :: dimensions(3)
         integer(int32), intent(out)          :: ierr
         integer(int32), intent(in), optional :: device_id
         integer(int64), intent(in), optional :: lbounds(3)
      end subroutine sp_devxlib_malloc_alloc_c3d
      module subroutine sp_devxlib_malloc_alloc_c4d(dev_ptr, dimensions, ierr, device_id, lbounds)
         implicit none
         complex(real32), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:,:,:)
         integer(int64), intent(in)           :: dimensions(4)
         integer(int32), intent(out)          :: ierr
         integer(int32), intent(in), optional :: device_id
         integer(int64), intent(in), optional :: lbounds(4)
      end subroutine sp_devxlib_malloc_alloc_c4d
      module subroutine sp_devxlib_malloc_alloc_c5d(dev_ptr, dimensions, ierr, device_id, lbounds)
         implicit none
         complex(real32), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:,:,:,:)
         integer(int64), intent(in)           :: dimensions(5)
         integer(int32), intent(out)          :: ierr
         integer(int32), intent(in), optional :: device_id
         integer(int64), intent(in), optional :: lbounds(5)
      end subroutine sp_devxlib_malloc_alloc_c5d
      module subroutine sp_devxlib_malloc_alloc_c6d(dev_ptr, dimensions, ierr, device_id, lbounds)
         implicit none
         complex(real32), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:,:,:,:,:)
         integer(int64), intent(in)           :: dimensions(6)
         integer(int32), intent(out)          :: ierr
         integer(int32), intent(in), optional :: device_id
         integer(int64), intent(in), optional :: lbounds(6)
      end subroutine sp_devxlib_malloc_alloc_c6d
      module subroutine dp_devxlib_malloc_alloc_c1d(dev_ptr, dimensions, ierr, device_id, lbounds)
         implicit none
         complex(real64), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:)
         integer(int64), intent(in)           :: dimensions
         integer(int32), intent(out)          :: ierr
         integer(int32), intent(in), optional :: device_id
         integer(int64), intent(in), optional :: lbounds
      end subroutine dp_devxlib_malloc_alloc_c1d
      module subroutine dp_devxlib_malloc_alloc_c2d(dev_ptr, dimensions, ierr, device_id, lbounds)
         implicit none
         complex(real64), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:)
         integer(int64), intent(in)           :: dimensions(2)
         integer(int32), intent(out)          :: ierr
         integer(int32), intent(in), optional :: device_id
         integer(int64), intent(in), optional :: lbounds(2)
      end subroutine dp_devxlib_malloc_alloc_c2d
      module subroutine dp_devxlib_malloc_alloc_c3d(dev_ptr, dimensions, ierr, device_id, lbounds)
         implicit none
         complex(real64), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:,:)
         integer(int64), intent(in)           :: dimensions(3)
         integer(int32), intent(out)          :: ierr
         integer(int32), intent(in), optional :: device_id
         integer(int64), intent(in), optional :: lbounds(3)
      end subroutine dp_devxlib_malloc_alloc_c3d
      module subroutine dp_devxlib_malloc_alloc_c4d(dev_ptr, dimensions, ierr, device_id, lbounds)
         implicit none
         complex(real64), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:,:,:)
         integer(int64), intent(in)           :: dimensions(4)
         integer(int32), intent(out)          :: ierr
         integer(int32), intent(in), optional :: device_id
         integer(int64), intent(in), optional :: lbounds(4)
      end subroutine dp_devxlib_malloc_alloc_c4d
      module subroutine dp_devxlib_malloc_alloc_c5d(dev_ptr, dimensions, ierr, device_id, lbounds)
         implicit none
         complex(real64), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:,:,:,:)
         integer(int64), intent(in)           :: dimensions(5)
         integer(int32), intent(out)          :: ierr
         integer(int32), intent(in), optional :: device_id
         integer(int64), intent(in), optional :: lbounds(5)
      end subroutine dp_devxlib_malloc_alloc_c5d
      module subroutine dp_devxlib_malloc_alloc_c6d(dev_ptr, dimensions, ierr, device_id, lbounds)
         implicit none
         complex(real64), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:,:,:,:,:)
         integer(int64), intent(in)           :: dimensions(6)
         integer(int32), intent(out)          :: ierr
         integer(int32), intent(in), optional :: device_id
         integer(int64), intent(in), optional :: lbounds(6)
      end subroutine dp_devxlib_malloc_alloc_c6d
      module subroutine i4_devxlib_malloc_alloc_i1d(dev_ptr, dimensions, ierr, device_id, lbounds)
         implicit none
         integer(int32), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:)
         integer(int64), intent(in)           :: dimensions
         integer(int32), intent(out)          :: ierr
         integer(int32), intent(in), optional :: device_id
         integer(int64), intent(in), optional :: lbounds
      end subroutine i4_devxlib_malloc_alloc_i1d
      module subroutine i4_devxlib_malloc_alloc_i2d(dev_ptr, dimensions, ierr, device_id, lbounds)
         implicit none
         integer(int32), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:)
         integer(int64), intent(in)           :: dimensions(2)
         integer(int32), intent(out)          :: ierr
         integer(int32), intent(in), optional :: device_id
         integer(int64), intent(in), optional :: lbounds(2)
      end subroutine i4_devxlib_malloc_alloc_i2d
      module subroutine i4_devxlib_malloc_alloc_i3d(dev_ptr, dimensions, ierr, device_id, lbounds)
         implicit none
         integer(int32), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:,:)
         integer(int64), intent(in)           :: dimensions(3)
         integer(int32), intent(out)          :: ierr
         integer(int32), intent(in), optional :: device_id
         integer(int64), intent(in), optional :: lbounds(3)
      end subroutine i4_devxlib_malloc_alloc_i3d
      module subroutine i4_devxlib_malloc_alloc_i4d(dev_ptr, dimensions, ierr, device_id, lbounds)
         implicit none
         integer(int32), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:,:,:)
         integer(int64), intent(in)           :: dimensions(4)
         integer(int32), intent(out)          :: ierr
         integer(int32), intent(in), optional :: device_id
         integer(int64), intent(in), optional :: lbounds(4)
      end subroutine i4_devxlib_malloc_alloc_i4d
      module subroutine i4_devxlib_malloc_alloc_i5d(dev_ptr, dimensions, ierr, device_id, lbounds)
         implicit none
         integer(int32), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:,:,:,:)
         integer(int64), intent(in)           :: dimensions(5)
         integer(int32), intent(out)          :: ierr
         integer(int32), intent(in), optional :: device_id
         integer(int64), intent(in), optional :: lbounds(5)
      end subroutine i4_devxlib_malloc_alloc_i5d
      module subroutine i4_devxlib_malloc_alloc_i6d(dev_ptr, dimensions, ierr, device_id, lbounds)
         implicit none
         integer(int32), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:,:,:,:,:)
         integer(int64), intent(in)           :: dimensions(6)
         integer(int32), intent(out)          :: ierr
         integer(int32), intent(in), optional :: device_id
         integer(int64), intent(in), optional :: lbounds(6)
      end subroutine i4_devxlib_malloc_alloc_i6d
      module subroutine i8_devxlib_malloc_alloc_i1d(dev_ptr, dimensions, ierr, device_id, lbounds)
         implicit none
         integer(int64), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:)
         integer(int64), intent(in)           :: dimensions
         integer(int32), intent(out)          :: ierr
         integer(int32), intent(in), optional :: device_id
         integer(int64), intent(in), optional :: lbounds
      end subroutine i8_devxlib_malloc_alloc_i1d
      module subroutine i8_devxlib_malloc_alloc_i2d(dev_ptr, dimensions, ierr, device_id, lbounds)
         implicit none
         integer(int64), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:)
         integer(int64), intent(in)           :: dimensions(2)
         integer(int32), intent(out)          :: ierr
         integer(int32), intent(in), optional :: device_id
         integer(int64), intent(in), optional :: lbounds(2)
      end subroutine i8_devxlib_malloc_alloc_i2d
      module subroutine i8_devxlib_malloc_alloc_i3d(dev_ptr, dimensions, ierr, device_id, lbounds)
         implicit none
         integer(int64), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:,:)
         integer(int64), intent(in)           :: dimensions(3)
         integer(int32), intent(out)          :: ierr
         integer(int32), intent(in), optional :: device_id
         integer(int64), intent(in), optional :: lbounds(3)
      end subroutine i8_devxlib_malloc_alloc_i3d
      module subroutine i8_devxlib_malloc_alloc_i4d(dev_ptr, dimensions, ierr, device_id, lbounds)
         implicit none
         integer(int64), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:,:,:)
         integer(int64), intent(in)           :: dimensions(4)
         integer(int32), intent(out)          :: ierr
         integer(int32), intent(in), optional :: device_id
         integer(int64), intent(in), optional :: lbounds(4)
      end subroutine i8_devxlib_malloc_alloc_i4d
      module subroutine i8_devxlib_malloc_alloc_i5d(dev_ptr, dimensions, ierr, device_id, lbounds)
         implicit none
         integer(int64), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:,:,:,:)
         integer(int64), intent(in)           :: dimensions(5)
         integer(int32), intent(out)          :: ierr
         integer(int32), intent(in), optional :: device_id
         integer(int64), intent(in), optional :: lbounds(5)
      end subroutine i8_devxlib_malloc_alloc_i5d
      module subroutine i8_devxlib_malloc_alloc_i6d(dev_ptr, dimensions, ierr, device_id, lbounds)
         implicit none
         integer(int64), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:,:,:,:,:)
         integer(int64), intent(in)           :: dimensions(6)
         integer(int32), intent(out)          :: ierr
         integer(int32), intent(in), optional :: device_id
         integer(int64), intent(in), optional :: lbounds(6)
      end subroutine i8_devxlib_malloc_alloc_i6d
      module subroutine l4_devxlib_malloc_alloc_l1d(dev_ptr, dimensions, ierr, device_id, lbounds)
         implicit none
         logical(int32), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:)
         integer(int64), intent(in)           :: dimensions
         integer(int32), intent(out)          :: ierr
         integer(int32), intent(in), optional :: device_id
         integer(int64), intent(in), optional :: lbounds
      end subroutine l4_devxlib_malloc_alloc_l1d
      module subroutine l4_devxlib_malloc_alloc_l2d(dev_ptr, dimensions, ierr, device_id, lbounds)
         implicit none
         logical(int32), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:)
         integer(int64), intent(in)           :: dimensions(2)
         integer(int32), intent(out)          :: ierr
         integer(int32), intent(in), optional :: device_id
         integer(int64), intent(in), optional :: lbounds(2)
      end subroutine l4_devxlib_malloc_alloc_l2d
      module subroutine l4_devxlib_malloc_alloc_l3d(dev_ptr, dimensions, ierr, device_id, lbounds)
         implicit none
         logical(int32), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:,:)
         integer(int64), intent(in)           :: dimensions(3)
         integer(int32), intent(out)          :: ierr
         integer(int32), intent(in), optional :: device_id
         integer(int64), intent(in), optional :: lbounds(3)
      end subroutine l4_devxlib_malloc_alloc_l3d
      module subroutine l4_devxlib_malloc_alloc_l4d(dev_ptr, dimensions, ierr, device_id, lbounds)
         implicit none
         logical(int32), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:,:,:)
         integer(int64), intent(in)           :: dimensions(4)
         integer(int32), intent(out)          :: ierr
         integer(int32), intent(in), optional :: device_id
         integer(int64), intent(in), optional :: lbounds(4)
      end subroutine l4_devxlib_malloc_alloc_l4d
      module subroutine l4_devxlib_malloc_alloc_l5d(dev_ptr, dimensions, ierr, device_id, lbounds)
         implicit none
         logical(int32), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:,:,:,:)
         integer(int64), intent(in)           :: dimensions(5)
         integer(int32), intent(out)          :: ierr
         integer(int32), intent(in), optional :: device_id
         integer(int64), intent(in), optional :: lbounds(5)
      end subroutine l4_devxlib_malloc_alloc_l5d
      module subroutine l4_devxlib_malloc_alloc_l6d(dev_ptr, dimensions, ierr, device_id, lbounds)
         implicit none
         logical(int32), pointer, contiguous, intent(out) DEV_ATTR :: dev_ptr(:,:,:,:,:,:)
         integer(int64), intent(in)           :: dimensions(6)
         integer(int32), intent(out)          :: ierr
         integer(int32), intent(in), optional :: device_id
         integer(int64), intent(in), optional :: lbounds(6)
      end subroutine l4_devxlib_malloc_alloc_l6d
   endinterface

   interface
      module subroutine sp_devxlib_malloc_free_r1d(dev_ptr, device_id)
         implicit none
         real(real32), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:)
         integer, optional, intent(in)  :: device_id
      end subroutine sp_devxlib_malloc_free_r1d
      module subroutine sp_devxlib_malloc_free_r2d(dev_ptr, device_id)
         implicit none
         real(real32), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:)
         integer, optional, intent(in)  :: device_id
      end subroutine sp_devxlib_malloc_free_r2d
      module subroutine sp_devxlib_malloc_free_r3d(dev_ptr, device_id)
         implicit none
         real(real32), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:,:)
         integer, optional, intent(in)  :: device_id
      end subroutine sp_devxlib_malloc_free_r3d
      module subroutine sp_devxlib_malloc_free_r4d(dev_ptr, device_id)
         implicit none
         real(real32), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:,:,:)
         integer, optional, intent(in)  :: device_id
      end subroutine sp_devxlib_malloc_free_r4d
      module subroutine sp_devxlib_malloc_free_r5d(dev_ptr, device_id)
         implicit none
         real(real32), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:,:,:,:)
         integer, optional, intent(in)  :: device_id
      end subroutine sp_devxlib_malloc_free_r5d
      module subroutine sp_devxlib_malloc_free_r6d(dev_ptr, device_id)
         implicit none
         real(real32), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:,:,:,:,:)
         integer, optional, intent(in)  :: device_id
      end subroutine sp_devxlib_malloc_free_r6d
      module subroutine dp_devxlib_malloc_free_r1d(dev_ptr, device_id)
         implicit none
         real(real64), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:)
         integer, optional, intent(in)  :: device_id
      end subroutine dp_devxlib_malloc_free_r1d
      module subroutine dp_devxlib_malloc_free_r2d(dev_ptr, device_id)
         implicit none
         real(real64), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:)
         integer, optional, intent(in)  :: device_id
      end subroutine dp_devxlib_malloc_free_r2d
      module subroutine dp_devxlib_malloc_free_r3d(dev_ptr, device_id)
         implicit none
         real(real64), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:,:)
         integer, optional, intent(in)  :: device_id
      end subroutine dp_devxlib_malloc_free_r3d
      module subroutine dp_devxlib_malloc_free_r4d(dev_ptr, device_id)
         implicit none
         real(real64), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:,:,:)
         integer, optional, intent(in)  :: device_id
      end subroutine dp_devxlib_malloc_free_r4d
      module subroutine dp_devxlib_malloc_free_r5d(dev_ptr, device_id)
         implicit none
         real(real64), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:,:,:,:)
         integer, optional, intent(in)  :: device_id
      end subroutine dp_devxlib_malloc_free_r5d
      module subroutine dp_devxlib_malloc_free_r6d(dev_ptr, device_id)
         implicit none
         real(real64), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:,:,:,:,:)
         integer, optional, intent(in)  :: device_id
      end subroutine dp_devxlib_malloc_free_r6d
      module subroutine sp_devxlib_malloc_free_c1d(dev_ptr, device_id)
         implicit none
         complex(real32), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:)
         integer, optional, intent(in)  :: device_id
      end subroutine sp_devxlib_malloc_free_c1d
      module subroutine sp_devxlib_malloc_free_c2d(dev_ptr, device_id)
         implicit none
         complex(real32), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:)
         integer, optional, intent(in)  :: device_id
      end subroutine sp_devxlib_malloc_free_c2d
      module subroutine sp_devxlib_malloc_free_c3d(dev_ptr, device_id)
         implicit none
         complex(real32), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:,:)
         integer, optional, intent(in)  :: device_id
      end subroutine sp_devxlib_malloc_free_c3d
      module subroutine sp_devxlib_malloc_free_c4d(dev_ptr, device_id)
         implicit none
         complex(real32), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:,:,:)
         integer, optional, intent(in)  :: device_id
      end subroutine sp_devxlib_malloc_free_c4d
      module subroutine sp_devxlib_malloc_free_c5d(dev_ptr, device_id)
         implicit none
         complex(real32), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:,:,:,:)
         integer, optional, intent(in)  :: device_id
      end subroutine sp_devxlib_malloc_free_c5d
      module subroutine sp_devxlib_malloc_free_c6d(dev_ptr, device_id)
         implicit none
         complex(real32), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:,:,:,:,:)
         integer, optional, intent(in)  :: device_id
      end subroutine sp_devxlib_malloc_free_c6d
      module subroutine dp_devxlib_malloc_free_c1d(dev_ptr, device_id)
         implicit none
         complex(real64), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:)
         integer, optional, intent(in)  :: device_id
      end subroutine dp_devxlib_malloc_free_c1d
      module subroutine dp_devxlib_malloc_free_c2d(dev_ptr, device_id)
         implicit none
         complex(real64), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:)
         integer, optional, intent(in)  :: device_id
      end subroutine dp_devxlib_malloc_free_c2d
      module subroutine dp_devxlib_malloc_free_c3d(dev_ptr, device_id)
         implicit none
         complex(real64), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:,:)
         integer, optional, intent(in)  :: device_id
      end subroutine dp_devxlib_malloc_free_c3d
      module subroutine dp_devxlib_malloc_free_c4d(dev_ptr, device_id)
         implicit none
         complex(real64), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:,:,:)
         integer, optional, intent(in)  :: device_id
      end subroutine dp_devxlib_malloc_free_c4d
      module subroutine dp_devxlib_malloc_free_c5d(dev_ptr, device_id)
         implicit none
         complex(real64), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:,:,:,:)
         integer, optional, intent(in)  :: device_id
      end subroutine dp_devxlib_malloc_free_c5d
      module subroutine dp_devxlib_malloc_free_c6d(dev_ptr, device_id)
         implicit none
         complex(real64), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:,:,:,:,:)
         integer, optional, intent(in)  :: device_id
      end subroutine dp_devxlib_malloc_free_c6d
      module subroutine i4_devxlib_malloc_free_i1d(dev_ptr, device_id)
         implicit none
         integer(int32), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:)
         integer, optional, intent(in)  :: device_id
      end subroutine i4_devxlib_malloc_free_i1d
      module subroutine i4_devxlib_malloc_free_i2d(dev_ptr, device_id)
         implicit none
         integer(int32), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:)
         integer, optional, intent(in)  :: device_id
      end subroutine i4_devxlib_malloc_free_i2d
      module subroutine i4_devxlib_malloc_free_i3d(dev_ptr, device_id)
         implicit none
         integer(int32), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:,:)
         integer, optional, intent(in)  :: device_id
      end subroutine i4_devxlib_malloc_free_i3d
      module subroutine i4_devxlib_malloc_free_i4d(dev_ptr, device_id)
         implicit none
         integer(int32), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:,:,:)
         integer, optional, intent(in)  :: device_id
      end subroutine i4_devxlib_malloc_free_i4d
      module subroutine i4_devxlib_malloc_free_i5d(dev_ptr, device_id)
         implicit none
         integer(int32), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:,:,:,:)
         integer, optional, intent(in)  :: device_id
      end subroutine i4_devxlib_malloc_free_i5d
      module subroutine i4_devxlib_malloc_free_i6d(dev_ptr, device_id)
         implicit none
         integer(int32), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:,:,:,:,:)
         integer, optional, intent(in)  :: device_id
      end subroutine i4_devxlib_malloc_free_i6d
      module subroutine i8_devxlib_malloc_free_i1d(dev_ptr, device_id)
         implicit none
         integer(int64), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:)
         integer, optional, intent(in)  :: device_id
      end subroutine i8_devxlib_malloc_free_i1d
      module subroutine i8_devxlib_malloc_free_i2d(dev_ptr, device_id)
         implicit none
         integer(int64), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:)
         integer, optional, intent(in)  :: device_id
      end subroutine i8_devxlib_malloc_free_i2d
      module subroutine i8_devxlib_malloc_free_i3d(dev_ptr, device_id)
         implicit none
         integer(int64), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:,:)
         integer, optional, intent(in)  :: device_id
      end subroutine i8_devxlib_malloc_free_i3d
      module subroutine i8_devxlib_malloc_free_i4d(dev_ptr, device_id)
         implicit none
         integer(int64), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:,:,:)
         integer, optional, intent(in)  :: device_id
      end subroutine i8_devxlib_malloc_free_i4d
      module subroutine i8_devxlib_malloc_free_i5d(dev_ptr, device_id)
         implicit none
         integer(int64), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:,:,:,:)
         integer, optional, intent(in)  :: device_id
      end subroutine i8_devxlib_malloc_free_i5d
      module subroutine i8_devxlib_malloc_free_i6d(dev_ptr, device_id)
         implicit none
         integer(int64), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:,:,:,:,:)
         integer, optional, intent(in)  :: device_id
      end subroutine i8_devxlib_malloc_free_i6d
      module subroutine l4_devxlib_malloc_free_l1d(dev_ptr, device_id)
         implicit none
         logical(int32), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:)
         integer, optional, intent(in)  :: device_id
      end subroutine l4_devxlib_malloc_free_l1d
      module subroutine l4_devxlib_malloc_free_l2d(dev_ptr, device_id)
         implicit none
         logical(int32), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:)
         integer, optional, intent(in)  :: device_id
      end subroutine l4_devxlib_malloc_free_l2d
      module subroutine l4_devxlib_malloc_free_l3d(dev_ptr, device_id)
         implicit none
         logical(int32), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:,:)
         integer, optional, intent(in)  :: device_id
      end subroutine l4_devxlib_malloc_free_l3d
      module subroutine l4_devxlib_malloc_free_l4d(dev_ptr, device_id)
         implicit none
         logical(int32), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:,:,:)
         integer, optional, intent(in)  :: device_id
      end subroutine l4_devxlib_malloc_free_l4d
      module subroutine l4_devxlib_malloc_free_l5d(dev_ptr, device_id)
         implicit none
         logical(int32), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:,:,:,:)
         integer, optional, intent(in)  :: device_id
      end subroutine l4_devxlib_malloc_free_l5d
      module subroutine l4_devxlib_malloc_free_l6d(dev_ptr, device_id)
         implicit none
         logical(int32), pointer, contiguous, intent(inout) DEV_ATTR :: dev_ptr(:,:,:,:,:,:)
         integer, optional, intent(in)  :: device_id
      end subroutine l4_devxlib_malloc_free_l6d
   endinterface

   interface
      module function sp_devxlib_malloc_allocated_r1d(array) result(res)
         implicit none
         logical :: res
         real(real32), allocatable, intent(in) DEV_ATTR :: array(:)
      end function sp_devxlib_malloc_allocated_r1d
      module function sp_devxlib_malloc_allocated_r2d(array) result(res)
         implicit none
         logical :: res
         real(real32), allocatable, intent(in) DEV_ATTR :: array(:,:)
      end function sp_devxlib_malloc_allocated_r2d
      module function sp_devxlib_malloc_allocated_r3d(array) result(res)
         implicit none
         logical :: res
         real(real32), allocatable, intent(in) DEV_ATTR :: array(:,:,:)
      end function sp_devxlib_malloc_allocated_r3d
      module function sp_devxlib_malloc_allocated_r4d(array) result(res)
         implicit none
         logical :: res
         real(real32), allocatable, intent(in) DEV_ATTR :: array(:,:,:,:)
      end function sp_devxlib_malloc_allocated_r4d
      module function sp_devxlib_malloc_allocated_r5d(array) result(res)
         implicit none
         logical :: res
         real(real32), allocatable, intent(in) DEV_ATTR :: array(:,:,:,:,:)
      end function sp_devxlib_malloc_allocated_r5d
      module function sp_devxlib_malloc_allocated_r6d(array) result(res)
         implicit none
         logical :: res
         real(real32), allocatable, intent(in) DEV_ATTR :: array(:,:,:,:,:,:)
      end function sp_devxlib_malloc_allocated_r6d
      module function dp_devxlib_malloc_allocated_r1d(array) result(res)
         implicit none
         logical :: res
         real(real64), allocatable, intent(in) DEV_ATTR :: array(:)
      end function dp_devxlib_malloc_allocated_r1d
      module function dp_devxlib_malloc_allocated_r2d(array) result(res)
         implicit none
         logical :: res
         real(real64), allocatable, intent(in) DEV_ATTR :: array(:,:)
      end function dp_devxlib_malloc_allocated_r2d
      module function dp_devxlib_malloc_allocated_r3d(array) result(res)
         implicit none
         logical :: res
         real(real64), allocatable, intent(in) DEV_ATTR :: array(:,:,:)
      end function dp_devxlib_malloc_allocated_r3d
      module function dp_devxlib_malloc_allocated_r4d(array) result(res)
         implicit none
         logical :: res
         real(real64), allocatable, intent(in) DEV_ATTR :: array(:,:,:,:)
      end function dp_devxlib_malloc_allocated_r4d
      module function dp_devxlib_malloc_allocated_r5d(array) result(res)
         implicit none
         logical :: res
         real(real64), allocatable, intent(in) DEV_ATTR :: array(:,:,:,:,:)
      end function dp_devxlib_malloc_allocated_r5d
      module function dp_devxlib_malloc_allocated_r6d(array) result(res)
         implicit none
         logical :: res
         real(real64), allocatable, intent(in) DEV_ATTR :: array(:,:,:,:,:,:)
      end function dp_devxlib_malloc_allocated_r6d
      module function sp_devxlib_malloc_allocated_c1d(array) result(res)
         implicit none
         logical :: res
         complex(real32), allocatable, intent(in) DEV_ATTR :: array(:)
      end function sp_devxlib_malloc_allocated_c1d
      module function sp_devxlib_malloc_allocated_c2d(array) result(res)
         implicit none
         logical :: res
         complex(real32), allocatable, intent(in) DEV_ATTR :: array(:,:)
      end function sp_devxlib_malloc_allocated_c2d
      module function sp_devxlib_malloc_allocated_c3d(array) result(res)
         implicit none
         logical :: res
         complex(real32), allocatable, intent(in) DEV_ATTR :: array(:,:,:)
      end function sp_devxlib_malloc_allocated_c3d
      module function sp_devxlib_malloc_allocated_c4d(array) result(res)
         implicit none
         logical :: res
         complex(real32), allocatable, intent(in) DEV_ATTR :: array(:,:,:,:)
      end function sp_devxlib_malloc_allocated_c4d
      module function sp_devxlib_malloc_allocated_c5d(array) result(res)
         implicit none
         logical :: res
         complex(real32), allocatable, intent(in) DEV_ATTR :: array(:,:,:,:,:)
      end function sp_devxlib_malloc_allocated_c5d
      module function sp_devxlib_malloc_allocated_c6d(array) result(res)
         implicit none
         logical :: res
         complex(real32), allocatable, intent(in) DEV_ATTR :: array(:,:,:,:,:,:)
      end function sp_devxlib_malloc_allocated_c6d
      module function dp_devxlib_malloc_allocated_c1d(array) result(res)
         implicit none
         logical :: res
         complex(real64), allocatable, intent(in) DEV_ATTR :: array(:)
      end function dp_devxlib_malloc_allocated_c1d
      module function dp_devxlib_malloc_allocated_c2d(array) result(res)
         implicit none
         logical :: res
         complex(real64), allocatable, intent(in) DEV_ATTR :: array(:,:)
      end function dp_devxlib_malloc_allocated_c2d
      module function dp_devxlib_malloc_allocated_c3d(array) result(res)
         implicit none
         logical :: res
         complex(real64), allocatable, intent(in) DEV_ATTR :: array(:,:,:)
      end function dp_devxlib_malloc_allocated_c3d
      module function dp_devxlib_malloc_allocated_c4d(array) result(res)
         implicit none
         logical :: res
         complex(real64), allocatable, intent(in) DEV_ATTR :: array(:,:,:,:)
      end function dp_devxlib_malloc_allocated_c4d
      module function dp_devxlib_malloc_allocated_c5d(array) result(res)
         implicit none
         logical :: res
         complex(real64), allocatable, intent(in) DEV_ATTR :: array(:,:,:,:,:)
      end function dp_devxlib_malloc_allocated_c5d
      module function dp_devxlib_malloc_allocated_c6d(array) result(res)
         implicit none
         logical :: res
         complex(real64), allocatable, intent(in) DEV_ATTR :: array(:,:,:,:,:,:)
      end function dp_devxlib_malloc_allocated_c6d
      module function i4_devxlib_malloc_allocated_i1d(array) result(res)
         implicit none
         logical :: res
         integer(int32), allocatable, intent(in) DEV_ATTR :: array(:)
      end function i4_devxlib_malloc_allocated_i1d
      module function i4_devxlib_malloc_allocated_i2d(array) result(res)
         implicit none
         logical :: res
         integer(int32), allocatable, intent(in) DEV_ATTR :: array(:,:)
      end function i4_devxlib_malloc_allocated_i2d
      module function i4_devxlib_malloc_allocated_i3d(array) result(res)
         implicit none
         logical :: res
         integer(int32), allocatable, intent(in) DEV_ATTR :: array(:,:,:)
      end function i4_devxlib_malloc_allocated_i3d
      module function i4_devxlib_malloc_allocated_i4d(array) result(res)
         implicit none
         logical :: res
         integer(int32), allocatable, intent(in) DEV_ATTR :: array(:,:,:,:)
      end function i4_devxlib_malloc_allocated_i4d
      module function i4_devxlib_malloc_allocated_i5d(array) result(res)
         implicit none
         logical :: res
         integer(int32), allocatable, intent(in) DEV_ATTR :: array(:,:,:,:,:)
      end function i4_devxlib_malloc_allocated_i5d
      module function i4_devxlib_malloc_allocated_i6d(array) result(res)
         implicit none
         logical :: res
         integer(int32), allocatable, intent(in) DEV_ATTR :: array(:,:,:,:,:,:)
      end function i4_devxlib_malloc_allocated_i6d
      module function i8_devxlib_malloc_allocated_i1d(array) result(res)
         implicit none
         logical :: res
         integer(int64), allocatable, intent(in) DEV_ATTR :: array(:)
      end function i8_devxlib_malloc_allocated_i1d
      module function i8_devxlib_malloc_allocated_i2d(array) result(res)
         implicit none
         logical :: res
         integer(int64), allocatable, intent(in) DEV_ATTR :: array(:,:)
      end function i8_devxlib_malloc_allocated_i2d
      module function i8_devxlib_malloc_allocated_i3d(array) result(res)
         implicit none
         logical :: res
         integer(int64), allocatable, intent(in) DEV_ATTR :: array(:,:,:)
      end function i8_devxlib_malloc_allocated_i3d
      module function i8_devxlib_malloc_allocated_i4d(array) result(res)
         implicit none
         logical :: res
         integer(int64), allocatable, intent(in) DEV_ATTR :: array(:,:,:,:)
      end function i8_devxlib_malloc_allocated_i4d
      module function i8_devxlib_malloc_allocated_i5d(array) result(res)
         implicit none
         logical :: res
         integer(int64), allocatable, intent(in) DEV_ATTR :: array(:,:,:,:,:)
      end function i8_devxlib_malloc_allocated_i5d
      module function i8_devxlib_malloc_allocated_i6d(array) result(res)
         implicit none
         logical :: res
         integer(int64), allocatable, intent(in) DEV_ATTR :: array(:,:,:,:,:,:)
      end function i8_devxlib_malloc_allocated_i6d
      module function l4_devxlib_malloc_allocated_l1d(array) result(res)
         implicit none
         logical :: res
         logical(int32), allocatable, intent(in) DEV_ATTR :: array(:)
      end function l4_devxlib_malloc_allocated_l1d
      module function l4_devxlib_malloc_allocated_l2d(array) result(res)
         implicit none
         logical :: res
         logical(int32), allocatable, intent(in) DEV_ATTR :: array(:,:)
      end function l4_devxlib_malloc_allocated_l2d
      module function l4_devxlib_malloc_allocated_l3d(array) result(res)
         implicit none
         logical :: res
         logical(int32), allocatable, intent(in) DEV_ATTR :: array(:,:,:)
      end function l4_devxlib_malloc_allocated_l3d
      module function l4_devxlib_malloc_allocated_l4d(array) result(res)
         implicit none
         logical :: res
         logical(int32), allocatable, intent(in) DEV_ATTR :: array(:,:,:,:)
      end function l4_devxlib_malloc_allocated_l4d
      module function l4_devxlib_malloc_allocated_l5d(array) result(res)
         implicit none
         logical :: res
         logical(int32), allocatable, intent(in) DEV_ATTR :: array(:,:,:,:,:)
      end function l4_devxlib_malloc_allocated_l5d
      module function l4_devxlib_malloc_allocated_l6d(array) result(res)
         implicit none
         logical :: res
         logical(int32), allocatable, intent(in) DEV_ATTR :: array(:,:,:,:,:,:)
      end function l4_devxlib_malloc_allocated_l6d
   endinterface

   interface
      module function sp_devxlib_malloc_allocated_r1d_p(dev_ptr) result(res)
         implicit none
         logical :: res
         real(real32), pointer, intent(in) DEV_ATTR :: dev_ptr(:)
      end function sp_devxlib_malloc_allocated_r1d_p
      module function sp_devxlib_malloc_allocated_r2d_p(dev_ptr) result(res)
         implicit none
         logical :: res
         real(real32), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:)
      end function sp_devxlib_malloc_allocated_r2d_p
      module function sp_devxlib_malloc_allocated_r3d_p(dev_ptr) result(res)
         implicit none
         logical :: res
         real(real32), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:,:)
      end function sp_devxlib_malloc_allocated_r3d_p
      module function sp_devxlib_malloc_allocated_r4d_p(dev_ptr) result(res)
         implicit none
         logical :: res
         real(real32), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:,:,:)
      end function sp_devxlib_malloc_allocated_r4d_p
      module function sp_devxlib_malloc_allocated_r5d_p(dev_ptr) result(res)
         implicit none
         logical :: res
         real(real32), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:,:,:,:)
      end function sp_devxlib_malloc_allocated_r5d_p
      module function sp_devxlib_malloc_allocated_r6d_p(dev_ptr) result(res)
         implicit none
         logical :: res
         real(real32), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:,:,:,:,:)
      end function sp_devxlib_malloc_allocated_r6d_p
      module function dp_devxlib_malloc_allocated_r1d_p(dev_ptr) result(res)
         implicit none
         logical :: res
         real(real64), pointer, intent(in) DEV_ATTR :: dev_ptr(:)
      end function dp_devxlib_malloc_allocated_r1d_p
      module function dp_devxlib_malloc_allocated_r2d_p(dev_ptr) result(res)
         implicit none
         logical :: res
         real(real64), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:)
      end function dp_devxlib_malloc_allocated_r2d_p
      module function dp_devxlib_malloc_allocated_r3d_p(dev_ptr) result(res)
         implicit none
         logical :: res
         real(real64), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:,:)
      end function dp_devxlib_malloc_allocated_r3d_p
      module function dp_devxlib_malloc_allocated_r4d_p(dev_ptr) result(res)
         implicit none
         logical :: res
         real(real64), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:,:,:)
      end function dp_devxlib_malloc_allocated_r4d_p
      module function dp_devxlib_malloc_allocated_r5d_p(dev_ptr) result(res)
         implicit none
         logical :: res
         real(real64), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:,:,:,:)
      end function dp_devxlib_malloc_allocated_r5d_p
      module function dp_devxlib_malloc_allocated_r6d_p(dev_ptr) result(res)
         implicit none
         logical :: res
         real(real64), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:,:,:,:,:)
      end function dp_devxlib_malloc_allocated_r6d_p
      module function sp_devxlib_malloc_allocated_c1d_p(dev_ptr) result(res)
         implicit none
         logical :: res
         complex(real32), pointer, intent(in) DEV_ATTR :: dev_ptr(:)
      end function sp_devxlib_malloc_allocated_c1d_p
      module function sp_devxlib_malloc_allocated_c2d_p(dev_ptr) result(res)
         implicit none
         logical :: res
         complex(real32), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:)
      end function sp_devxlib_malloc_allocated_c2d_p
      module function sp_devxlib_malloc_allocated_c3d_p(dev_ptr) result(res)
         implicit none
         logical :: res
         complex(real32), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:,:)
      end function sp_devxlib_malloc_allocated_c3d_p
      module function sp_devxlib_malloc_allocated_c4d_p(dev_ptr) result(res)
         implicit none
         logical :: res
         complex(real32), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:,:,:)
      end function sp_devxlib_malloc_allocated_c4d_p
      module function sp_devxlib_malloc_allocated_c5d_p(dev_ptr) result(res)
         implicit none
         logical :: res
         complex(real32), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:,:,:,:)
      end function sp_devxlib_malloc_allocated_c5d_p
      module function sp_devxlib_malloc_allocated_c6d_p(dev_ptr) result(res)
         implicit none
         logical :: res
         complex(real32), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:,:,:,:,:)
      end function sp_devxlib_malloc_allocated_c6d_p
      module function dp_devxlib_malloc_allocated_c1d_p(dev_ptr) result(res)
         implicit none
         logical :: res
         complex(real64), pointer, intent(in) DEV_ATTR :: dev_ptr(:)
      end function dp_devxlib_malloc_allocated_c1d_p
      module function dp_devxlib_malloc_allocated_c2d_p(dev_ptr) result(res)
         implicit none
         logical :: res
         complex(real64), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:)
      end function dp_devxlib_malloc_allocated_c2d_p
      module function dp_devxlib_malloc_allocated_c3d_p(dev_ptr) result(res)
         implicit none
         logical :: res
         complex(real64), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:,:)
      end function dp_devxlib_malloc_allocated_c3d_p
      module function dp_devxlib_malloc_allocated_c4d_p(dev_ptr) result(res)
         implicit none
         logical :: res
         complex(real64), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:,:,:)
      end function dp_devxlib_malloc_allocated_c4d_p
      module function dp_devxlib_malloc_allocated_c5d_p(dev_ptr) result(res)
         implicit none
         logical :: res
         complex(real64), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:,:,:,:)
      end function dp_devxlib_malloc_allocated_c5d_p
      module function dp_devxlib_malloc_allocated_c6d_p(dev_ptr) result(res)
         implicit none
         logical :: res
         complex(real64), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:,:,:,:,:)
      end function dp_devxlib_malloc_allocated_c6d_p
      module function i4_devxlib_malloc_allocated_i1d_p(dev_ptr) result(res)
         implicit none
         logical :: res
         integer(int32), pointer, intent(in) DEV_ATTR :: dev_ptr(:)
      end function i4_devxlib_malloc_allocated_i1d_p
      module function i4_devxlib_malloc_allocated_i2d_p(dev_ptr) result(res)
         implicit none
         logical :: res
         integer(int32), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:)
      end function i4_devxlib_malloc_allocated_i2d_p
      module function i4_devxlib_malloc_allocated_i3d_p(dev_ptr) result(res)
         implicit none
         logical :: res
         integer(int32), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:,:)
      end function i4_devxlib_malloc_allocated_i3d_p
      module function i4_devxlib_malloc_allocated_i4d_p(dev_ptr) result(res)
         implicit none
         logical :: res
         integer(int32), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:,:,:)
      end function i4_devxlib_malloc_allocated_i4d_p
      module function i4_devxlib_malloc_allocated_i5d_p(dev_ptr) result(res)
         implicit none
         logical :: res
         integer(int32), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:,:,:,:)
      end function i4_devxlib_malloc_allocated_i5d_p
      module function i4_devxlib_malloc_allocated_i6d_p(dev_ptr) result(res)
         implicit none
         logical :: res
         integer(int32), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:,:,:,:,:)
      end function i4_devxlib_malloc_allocated_i6d_p
      module function i8_devxlib_malloc_allocated_i1d_p(dev_ptr) result(res)
         implicit none
         logical :: res
         integer(int64), pointer, intent(in) DEV_ATTR :: dev_ptr(:)
      end function i8_devxlib_malloc_allocated_i1d_p
      module function i8_devxlib_malloc_allocated_i2d_p(dev_ptr) result(res)
         implicit none
         logical :: res
         integer(int64), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:)
      end function i8_devxlib_malloc_allocated_i2d_p
      module function i8_devxlib_malloc_allocated_i3d_p(dev_ptr) result(res)
         implicit none
         logical :: res
         integer(int64), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:,:)
      end function i8_devxlib_malloc_allocated_i3d_p
      module function i8_devxlib_malloc_allocated_i4d_p(dev_ptr) result(res)
         implicit none
         logical :: res
         integer(int64), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:,:,:)
      end function i8_devxlib_malloc_allocated_i4d_p
      module function i8_devxlib_malloc_allocated_i5d_p(dev_ptr) result(res)
         implicit none
         logical :: res
         integer(int64), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:,:,:,:)
      end function i8_devxlib_malloc_allocated_i5d_p
      module function i8_devxlib_malloc_allocated_i6d_p(dev_ptr) result(res)
         implicit none
         logical :: res
         integer(int64), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:,:,:,:,:)
      end function i8_devxlib_malloc_allocated_i6d_p
      module function l4_devxlib_malloc_allocated_l1d_p(dev_ptr) result(res)
         implicit none
         logical :: res
         logical(int32), pointer, intent(in) DEV_ATTR :: dev_ptr(:)
      end function l4_devxlib_malloc_allocated_l1d_p
      module function l4_devxlib_malloc_allocated_l2d_p(dev_ptr) result(res)
         implicit none
         logical :: res
         logical(int32), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:)
      end function l4_devxlib_malloc_allocated_l2d_p
      module function l4_devxlib_malloc_allocated_l3d_p(dev_ptr) result(res)
         implicit none
         logical :: res
         logical(int32), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:,:)
      end function l4_devxlib_malloc_allocated_l3d_p
      module function l4_devxlib_malloc_allocated_l4d_p(dev_ptr) result(res)
         implicit none
         logical :: res
         logical(int32), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:,:,:)
      end function l4_devxlib_malloc_allocated_l4d_p
      module function l4_devxlib_malloc_allocated_l5d_p(dev_ptr) result(res)
         implicit none
         logical :: res
         logical(int32), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:,:,:,:)
      end function l4_devxlib_malloc_allocated_l5d_p
      module function l4_devxlib_malloc_allocated_l6d_p(dev_ptr) result(res)
         implicit none
         logical :: res
         logical(int32), pointer, intent(in) DEV_ATTR :: dev_ptr(:,:,:,:,:,:)
      end function l4_devxlib_malloc_allocated_l6d_p
   endinterface
endmodule devxlib_malloc

!
! Copyright (C) 2021, MaX CoE
! Distributed under the MIT License
! (license terms are at http://opensource.org/licenses/MIT).
!
!--
!
! Wrappers and interfaces for cudaFortran and Cuda lib
!
#include<devxlib_defs.h>
#include<devxlib_macros.h>
!
!#if !defined __DXL_CUDAF
!#include<mod_cudafor.f90>
!#endif
!
module dev_cudafor_m
  !
#if defined __DXL_CUDAF
  use cudafor
#else
  use cudafor_m
#endif
  implicit none

contains
  subroutine cudafor_foo ()
  end subroutine

end module dev_cudafor_m

!
! This file is part of FBUF - Fortran BUFfers For Accelerators
! Copyright 2018 Pietro Bonfa'
! License: GPLv2
!
!--
!
#include<devxlib_macros.h>
#include<devxlib_defs.h>
!
program main

use devXlib

implicit none

call test_buff

contains

subroutine test_buff()
    !
    use devxlib_tester_fbuff
    use devxlib_buffer, ONLY : devxlib_buffer_t
    implicit none
    !
    type(devxlib_buffer_t) :: buf
    !
    ! The tester class
    type(tester_t) :: my_tester
    !
    integer, pointer DEV_ATTR :: a_v1(:)
    integer, pointer DEV_ATTR :: a_v2(:)
    integer, pointer DEV_ATTR :: a_v3(:)
    integer, pointer DEV_ATTR :: a_v4(:)
    integer, pointer DEV_ATTR :: a_m1(:,:)
    integer :: info

    CALL my_tester% init()

    ! Initialize buffers
    CALL buf%init(info, .true.)
    !
    CALL buf%lock_buffer(a_v1, 0, info)
    CALL buf%release_buffer(a_v1, info)
    CALL buf%lock_buffer(a_m1, (/2, 0/), info)
    CALL buf%release_buffer(a_m1, info)
    !
    !
    CALL buf%lock_buffer(a_v1, 10, info)
    !
    ! First time a buffer is allocated, it has exactly the requested size
    !CALL my_tester% assert_equal(SIZE(a_v1), 10)
    !CALL my_tester% assert_equal(info, 0)
    ! Set elements of a_v1 to 1
    !DEV_OMPGPU target map(alloc:a_v1)
    a_v1 = 1
    !DEV_OMPGPU end target

    ! The previous buffer is already allocated, we get a new one here
    CALL buf%lock_buffer(a_v2, 11, info)
    CALL my_tester% assert_equal(SIZE(a_v2), 11)
    CALL my_tester% assert_equal(info, 0)

    ! The last available slot
    CALL buf%lock_buffer(a_v3, 12, info)
    CALL my_tester% assert_equal(SIZE(a_v3), 12)
    CALL my_tester% assert_equal(info, 0)

    ! Largest request, 134 elements
    CALL buf%lock_buffer(a_v4, 134, info)
    CALL my_tester% assert_equal(SIZE(a_v4), 134)
    CALL my_tester% assert_equal(info, 0)

    ! Release buffer 4 which was allocated as a standard pointer
    CALL buf%release_buffer(a_v4, info)
    ! Re-request a buffer, but smaller.
    CALL buf%lock_buffer(a_v4, 5, info)
    CALL my_tester% assert_equal(SIZE(a_v4), 5)
    CALL my_tester% assert_equal(info, 0)
    !
    ! Release buffer v4 and v3
    CALL buf%release_buffer(a_v4, info)
    CALL buf%release_buffer(a_v3, info)
    !
    ! Now request a buffer 5 items log. We should be given the previously allocated 12 elements array
    CALL buf%lock_buffer(a_v3, 5, info)
    CALL my_tester% assert_equal(SIZE(a_v3), 5)
    CALL my_tester% assert_equal(info, 0)

    !CALL my_tester% assert_equal(SUM(a_v1), 10)
    CALL buf%release_buffer(a_v1, info)
    CALL buf%release_buffer(a_v2, info)
    CALL buf%release_buffer(a_v3, info)

    CALL buf%lock_buffer(a_m1, (/3,3/), info)
    CALL buf%release_buffer(a_m1, info)
    !
    CALL buf%lock_buffer(a_m1, (/2,2/), info)
    CALL buf%release_buffer(a_m1, info)
    !
    CALL buf%lock_buffer(a_m1, (/3,2/), info)
    CALL buf%release_buffer(a_m1, info)
    !
    CALL buf%lock_buffer(a_m1, (/3,1/), info)
    CALL buf%release_buffer(a_m1, info)

    CALL my_tester% print()

end subroutine
end program

!
!        Copyright (C) 2000-2019 the YAMBO team
!              http://www.yambo-code.org
!
! Authors (see AUTHORS file for details): CA, AF
!
! This file is distributed under the terms of the GNU 
! General Public License. You can redistribute it and/or 
! modify it under the terms of the GNU General Public 
! License as published by the Free Software Foundation; 
! either version 2, or (at your option) any later version.
!
! This program is distributed in the hope that it will 
! be useful, but WITHOUT ANY WARRANTY; without even the 
! implied warranty of MERCHANTABILITY or FITNESS FOR A 
! PARTICULAR PURPOSE.  See the GNU General Public License 
! for more details.
!
! You should have received a copy of the GNU General Public 
! License along with this program; if not, write to the Free 
! Software Foundation, Inc., 59 Temple Place - Suite 330,Boston, 
! MA 02111-1307, USA or visit http://www.gnu.org/copyleft/gpl.txt.
!
module wrapper
 !
 ! To remember:
 !
 ! TRANSA = 'N' or 'n',  op( A ) = A.
 ! TRANSA = 'T' or 't',  op( A ) = A'.
 ! TRANSA = 'C' or 'c',  op( A ) = conjg( A' ).
 !
 use pars,   ONLY:SP,cI
#ifdef _CUDA
 use cublas
#endif
 !
 implicit none
 !
 interface M_by_M
   module procedure mm_cgemm,mm_c 
 end interface
 !
 interface M_by_V 
   module procedure mv_cgemv,mv_sgemv,mv_c,mv_r
#ifdef _CUDA
   module procedure                   mv_c_gpu
#endif
 end interface
 !
 interface V_by_V_plus_V
   module procedure vv_saxpy,vv_caxpy,MM_caxpy
#ifdef _CUDA
   module procedure          vv_caxpy_gpu
#endif
 end interface
 !
 interface V_by_V_pwise
   module procedure V_by_V_pwise_cpu
#ifdef _CUDA
   module procedure V_by_V_pwise_gpu
#endif
 end interface
 !
 interface Vstar_dot_V
   module procedure Vstar_dot_V_c1_cpu, Vstar_dot_V_c2_cpu
#ifdef _CUDA
   module procedure Vstar_dot_V_c1_gpu, Vstar_dot_V_c2_gpu
#endif
 end interface
 !
 interface Vstar_dot_VV
   module procedure Vstar_dot_VV_c1_cpu
#ifdef _CUDA
   module procedure Vstar_dot_VV_c1_gpu
#endif
 end interface
 !
 interface V_dot_V
   module procedure V_dot_V_r1_cpu, V_dot_V_c1_cpu, V_dot_V_c2_cpu
#ifdef _CUDA
   module procedure V_dot_V_c1_gpu
#endif
 end interface
 !
 interface V_dot_VV
   module procedure V_dot_VV_c1_cpu
#ifdef _CUDA
   module procedure V_dot_VV_c1_gpu
#endif
 end interface
 !
 public :: V_copy
 public :: Vstar_dot_V
 public :: Vstar_dot_VV
 public :: V_dot_V
 public :: V_dot_VV
 public :: M_by_V
 public :: V_by_V_plus_V
 public :: V_by_V_pwise
 public :: FADEVA
 !
 contains
   !
   !===================
   ! interface M_by_M 
   !===================
   !
   subroutine mm_cgemm(TRANSA,TRANSB,M,N,K,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
     !
     ! CGEMM  performs one of the matrix-matrix operations
     !
     !    C := alpha*op( A )*op( B ) + beta*C,
     !
     ! where  op( X ) is one of
     !
     !    op( X ) = X   or   op( X ) = X**T   or   op( X ) = X**H,
     !
     ! alpha and beta are scalars, and A, B and C are matrices, with op( A )
     ! an m by k matrix,  op( B )  a  k by n matrix and  C an m by n matrix.
     !
     complex(SP), intent(in)  :: ALPHA,BETA
     integer,     intent(in)  :: K,LDA,LDB,LDC,M,N
     character,   intent(in)  :: TRANSA,TRANSB
     complex(SP), intent(in)  :: A(LDA,*),B(LDB,*)
     complex(SP), intent(out) :: C(LDC,*)
#if defined _DOUBLE
     call ZGEMM(TRANSA,TRANSB,M,N,K,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
#else
     call CGEMM(TRANSA,TRANSB,M,N,K,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
#endif
   end subroutine mm_cgemm
   !
   subroutine mm_c(TRANSA,TRANSB,msize,A,B,C)
     integer,  intent(in)  :: msize
     complex(SP), intent(in)  :: A(msize,msize),B(msize,msize)
     complex(SP), intent(out) :: C(msize,msize)
     character,   intent(in)  :: TRANSA,TRANSB
#if defined _DOUBLE
     call ZGEMM(TRANSA,TRANSB,msize,msize,msize,(1._SP,0._SP),A,msize,B,msize,(0._SP,0._SP),C,msize)
#else
     call CGEMM(TRANSA,TRANSB,msize,msize,msize,(1._SP,0._SP),A,msize,B,msize,(0._SP,0._SP),C,msize)
#endif
   end subroutine mm_c
   !
   !===================
   ! interface M_by_V 
   !===================
   !
   subroutine mv_sgemv(TRANS,M,N,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
     real(SP), intent(in) :: ALPHA,BETA
     integer,  intent(in) :: INCX,INCY,LDA,M,N
     character,intent(in) :: TRANS
     real(SP), intent(in) :: A(LDA,*),X(*)
     real(SP), intent(out):: Y(*)
#if defined _DOUBLE
     call DGEMV(TRANS,M,N,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
#else
     call SGEMV(TRANS,M,N,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
#endif
   end subroutine mv_sgemv
   !
   subroutine mv_cgemv(TRANS,M,N,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
     complex(SP), intent(in) :: ALPHA,BETA
     integer,     intent(in) :: INCX,INCY,LDA,M,N
     character,   intent(in) :: TRANS
     complex(SP), intent(in) :: A(LDA,*),X(*)
     complex(SP), intent(out):: Y(*)
#if defined _DOUBLE
     call ZGEMV(TRANS,M,N,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
#else
     call CGEMV(TRANS,M,N,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
#endif
   end subroutine mv_cgemv
   !
   subroutine mv_c(TRANS,msize,A,X,Y)
     integer,     intent(in) :: msize
     complex(SP), intent(in) :: A(msize,*),X(*)
     complex(SP), intent(out):: Y(*)
     character,   intent(in) :: TRANS
#if defined _DOUBLE
     call ZGEMV(TRANS,msize,msize,(1._SP,0._SP),A,msize,X,1,(0._SP,0._SP),Y,1)
#else
     call CGEMV(TRANS,msize,msize,(1._SP,0._SP),A,msize,X,1,(0._SP,0._SP),Y,1)
#endif
   end subroutine mv_c
   !
#ifdef _CUDA
   subroutine mv_c_gpu(TRANS,msize,A,X,Y)
     integer,     intent(in) :: msize
     complex(SP), device, intent(in) :: A(msize,*),X(*)
     complex(SP), device, intent(out):: Y(*)
     character,   intent(in) :: TRANS
#if defined _DOUBLE
     call cublasZgemv(TRANS,msize,msize,(1._SP,0._SP),A,msize,X,1,(0._SP,0._SP),Y,1)
#else
     call cublasCgemv(TRANS,msize,msize,(1._SP,0._SP),A,msize,X,1,(0._SP,0._SP),Y,1)
#endif
   end subroutine mv_c_gpu
#endif
   !
   subroutine mv_r(TRANS,msize,A,X,Y)
     integer,  intent(in) :: msize
     real(SP), intent(in) :: A(msize,*),X(*)
     real(SP), intent(out):: Y(*)
     character,intent(in) :: TRANS
#if defined _DOUBLE
     call DGEMV(TRANS,msize,msize,1._SP,A,msize,X,1,0._SP,Y,1)
#else
     call SGEMV(TRANS,msize,msize,1._SP,A,msize,X,1,0._SP,Y,1)
#endif
   end subroutine mv_r
   !
   !=========================
   ! interface V_by_V_plus_V 
   !=========================
   !
   subroutine MM_caxpy(N, CA, CX,  CY )
     complex(SP), intent(in) :: CA
     integer,     intent(in) :: N
     complex(SP), intent(in) :: CX(N,N)
     complex(SP), intent(out):: CY(N,N)
#if defined _DOUBLE
     call ZAXPY(N**2,CA,CX,1,CY,1)
#else
     call CAXPY(N**2,CA,CX,1,CY,1)
#endif
   end subroutine MM_caxpy
   !
   subroutine vv_caxpy(N, CA, CX,  CY )
     complex(SP), intent(in) :: CA
     integer,     intent(in) :: N
     complex(SP), intent(in) :: CX(*)
     complex(SP), intent(out):: CY(*)
#if defined _DOUBLE
     call ZAXPY(N,CA,CX,1,CY,1)
#else
     call CAXPY(N,CA,CX,1,CY,1)
#endif
   end subroutine vv_caxpy
   !
#ifdef _CUDA
   subroutine vv_caxpy_gpu(N, CA, CX, CY )
     complex(SP), intent(in) :: CA
     integer,     intent(in) :: N
     complex(SP), device, intent(in) :: CX(*)
     complex(SP), device, intent(out):: CY(*)
#if defined _DOUBLE
     call cublasZaxpy(N,CA,CX,1,CY,1)
#else
     call cublasCaxpy(N,CA,CX,1,CY,1)
#endif
   end subroutine vv_caxpy_gpu
#endif
   !
   subroutine vv_saxpy(N, CA, CX, CY )
     real(SP),    intent(in) :: CA
     integer,     intent(in) :: N
     real(SP),    intent(in) :: CX(*)
     real(SP),    intent(out):: CY(*)
#if defined _DOUBLE
     call DAXPY(N,CA,CX,1,CY,1)
#else
     call SAXPY(N,CA,CX,1,CY,1)
#endif
   end subroutine vv_saxpy   
   !
   !======
   ! COPY 
   !======
   !
   subroutine V_copy(N,CX,CY)
     integer,    intent(in)  :: N
     complex(SP),intent(in)  :: CX(*)
     complex(SP),intent(out) :: CY(*)
#if defined _DOUBLE
     call zcopy(N,CX,1,CY,1)
#else
     call ccopy(N,CX,1,CY,1)
#endif
   end subroutine V_copy   
   !
   !==============
   ! DOT PRODUCTS: Vstar_dot_V
   !==============
   !
   complex(SP) function Vstar_dot_V_c1_cpu(N,CX,CY)
     implicit none
     integer,    intent(in) :: N
     complex(SP),intent(in) :: CX(*),CY(*)
#if defined _DOUBLE
     complex(SP)::zdotc
     Vstar_dot_V_c1_cpu=ZDOTC(N,CX,1,CY,1)
#else
     complex(SP)::cdotc
     Vstar_dot_V_c1_cpu=CDOTC(N,CX,1,CY,1)
#endif
   end function Vstar_dot_V_c1_cpu
   !
   complex(SP) function Vstar_dot_V_c2_cpu(N,CX,CY)
     implicit none
     integer,    intent(in) :: N
     complex(SP),intent(in) :: CX(:,:),CY(:,:)
#if defined _DOUBLE
     complex(SP)::zdotc
     Vstar_dot_V_c2_cpu=ZDOTC(N,CX,1,CY,1)
#else
     complex(SP)::cdotc
     Vstar_dot_V_c2_cpu=CDOTC(N,CX,1,CY,1)
#endif
   end function Vstar_dot_V_c2_cpu
   !
#ifdef _CUDA
   complex(SP) function Vstar_dot_V_c1_gpu(N,CX,CY)
     implicit none
     integer,             intent(in) :: N
     complex(SP), device, intent(in) :: CX(*),CY(*)
     !
#if defined _DOUBLE
     Vstar_dot_V_c1_gpu=cublasZdotc(N,CX,1,CY,1)
#else
     Vstar_dot_V_c1_gpu=cublasCdotc(N,CX,1,CY,1)
#endif
   end function Vstar_dot_V_c1_gpu
   !
   complex(SP) function Vstar_dot_V_c2_gpu(N,CX,CY)
     implicit none
     integer,             intent(in) :: N
     complex(SP), device, intent(in) :: CX(:,:),CY(:,:)
     !
#if defined _DOUBLE
     Vstar_dot_V_c2_gpu=cublasZdotc(N,CX,1,CY,1)
#else
     Vstar_dot_V_c2_gpu=cublasCdotc(N,CX,1,CY,1)
#endif
   end function Vstar_dot_V_c2_gpu
   !
#endif
   !
   !==============
   ! DOT PRODUCTS: Vstar_dot_VV
   !==============
   !
   complex(SP) function Vstar_dot_VV_c1_cpu(N,CX,CY,CZ)
     implicit none
     integer,    intent(in) :: N
     complex(SP),intent(in) :: CX(N),CY(N),CZ(N)
#if defined _DOUBLE
     complex(SP)::zdotc
     Vstar_dot_VV_c1_cpu=ZDOTC(N,CX,1,CY*CZ,1)
#else
     complex(SP)::cdotc
     Vstar_dot_VV_c1_cpu=CDOTC(N,CX,1,CY*CZ,1)
#endif
   end function Vstar_dot_VV_c1_cpu
   !
#ifdef _CUDA
   complex(SP) function Vstar_dot_VV_c1_gpu(N,CX,CY,CZ)
     implicit none
     integer,             intent(in) :: N
     complex(SP), device, intent(in) :: CX(N),CY(N),CZ(N)
     integer :: i
     !
     Vstar_dot_VV_c1_gpu=0.0_SP
     !$cuf kernel do(1) <<<*,*>>>
     do i = 1, N
       Vstar_dot_VV_c1_gpu=Vstar_dot_VV_c1_gpu+conjg(CX(i))*CY(i)*CZ(i)
     enddo
   end function Vstar_dot_VV_c1_gpu
#endif
   !
   !==============
   ! DOT PRODUCTS: V_dot_V
   !==============
   !
   real(SP) function V_dot_V_r1_cpu(N,CX,CY)
     implicit none
     integer, intent(in) :: N
     real(SP),intent(in) :: CX(*),CY(*)
#if defined _DOUBLE
     real(SP)::ddot
     V_dot_V_r1_cpu=DDOT(N,CX,1,CY,1)
#else
     real(SP)::sdot
     V_dot_V_r1_cpu=SDOT(N,CX,1,CY,1)
#endif
   end function V_dot_V_r1_cpu
   !
   complex(SP) function V_dot_V_c1_cpu(N,CX,CY)
     implicit none
     integer,    intent(in) :: N
     complex(SP),intent(in) :: CX(*),CY(*)
#if defined _DOUBLE
     complex(SP)::zdotu
     V_dot_V_c1_cpu=ZDOTU(N,CX,1,CY,1)
#else
     complex(SP)::cdotu
     V_dot_V_c1_cpu=CDOTU(N,CX,1,CY,1)
#endif
   end function V_dot_V_c1_cpu
   !
   complex(SP) function V_dot_V_c2_cpu(N,CX,CY)
     implicit none
     integer,    intent(in) :: N
     complex(SP),intent(in) :: CX(:,:),CY(:,:)
#if defined _DOUBLE
     complex(SP)::zdotu
     V_dot_V_c2_cpu=ZDOTU(N,CX,1,CY,1)
#else
     complex(SP)::cdotu
     V_dot_V_c2_cpu=CDOTU(N,CX,1,CY,1)
#endif
   end function V_dot_V_c2_cpu
   !
#ifdef _CUDA
   complex(SP) function V_dot_V_c1_gpu(N,CX,CY)
     implicit none
     integer,    intent(in) :: N
     complex(SP), device, intent(in) :: CX(*),CY(*)
#if defined _DOUBLE
     complex(SP)::zdotu
     V_dot_V_c1_gpu=cublasZDOTU(N,CX,1,CY,1)
#else
     complex(SP)::cdotu
     V_dot_V_c1_gpu=cublasCDOTU(N,CX,1,CY,1)
#endif
   end function V_dot_V_c1_gpu
#endif
   !
   !==============
   ! DOT PRODUCTS: V_dot_VV
   !==============
   !
   complex(SP) function V_dot_VV_c1_cpu(N,CX,CY,CZ)
     implicit none
     integer,    intent(in) :: N
     complex(SP),intent(in) :: CX(N),CY(N),CZ(N)
#if defined _DOUBLE
     complex(SP)::zdotu
     V_dot_VV_c1_cpu=ZDOTU(N,CX,1,CY*CZ,1)
#else
     complex(SP)::cdotu
     V_dot_VV_c1_cpu=CDOTU(N,CX,1,CY*CZ,1)
#endif
   end function V_dot_VV_c1_cpu
   !
#ifdef _CUDA
   complex(SP) function V_dot_VV_c1_gpu(N,CX,CY,CZ)
     integer,    intent(in) :: N
     complex(SP), device, intent(in) :: CX(N),CY(N),CZ(N)
     integer :: i
     !
     V_dot_VV_c1_gpu=0.0_SP
     !$cuf kernel do(1) <<<*,*>>>
     do i = 1, N
       V_dot_VV_c1_gpu=V_dot_VV_c1_gpu+CX(i)*CY(i)*CZ(i)
     enddo
   end function V_dot_VV_c1_gpu
#endif
   !
   !=========
   ! MISC
   !=========
   !
   complex(SP) function FADEVA(Z)
     !
     complex(SP), intent(in) :: Z
     real(SP)    :: rW(2),rZ(2)
     integer     :: istatus
     !
     istatus=0
     rZ=(/real(Z,SP),aimag(Z)/)
     !
     ! Compute rW=w(-z)
     !=================
#if defined _DOUBLE
     call zwofz(rZ,rW,istatus)
#else
     call cwofz(rZ,rW,istatus)
#endif
     !
     FADEVA=cmplx(rW(1),rW(2),SP)
     !
   end function
   !
   subroutine V_by_V_pwise_cpu(N,CZ,CX,CY)
     integer,    intent(in) :: N
     complex(SP),intent(in) :: CX(*),CY(*)
     complex(SP),intent(out):: CZ(*)
     !
     integer :: i
     do i=1,N
        CZ(i)=CX(i)*CY(i)
     enddo
   end subroutine V_by_V_pwise_cpu
   !
#ifdef _CUDA
   subroutine V_by_V_pwise_gpu(N,CZ,CX,CY)
     integer,    intent(in) :: N
     complex(SP), device, intent(in) :: CX(N),CY(N)
     complex(SP), device, intent(out):: CZ(N)
     !
     integer :: i
     !$cuf kernel do(1) <<<*,*>>> 
     do i=1,N
        CZ(i)=CX(i)*CY(i)
     enddo
   end subroutine V_by_V_pwise_gpu
#endif
   !
end module

!
! Copyright (C) 2021, MaX CoE
! Distributed under the MIT License 
! (license terms are at http://opensource.org/licenses/MIT).
!
!--
!
! Wrappers for openacc symbols
!
#if defined __DXL_OPENACC && defined __GFORTRAN__
#include<mod_openacc.f90>
#endif
!
!
module dev_openacc_m
  !
#if defined __DXL_OPENACC
  use openacc
#if defined __GFORTRAN__
  use openacc_m
#endif
#endif
  implicit none
 
contains
  subroutine openacc_foo ()
  end subroutine

end module dev_openacc_m

!
! Copyright (C) 2021, MaX CoE
! Distributed under the MIT License
! (license terms are at http://opensource.org/licenses/MIT).
!
!--
!
! Wrappers for selected Linear Algebra subroutines
!
#include<devxlib_defs.h>
#include<devxlib_macros.h>
!
#ifdef __DXL_HAVE_DEVICE
  !
  ! checks
  !
#if ! defined __DXL_CUBLAS && ! defined __DXL_ROCBLAS && ! defined __DXL_MKL_GPU
# error
#endif
#endif

submodule (devxlib_linalg) devxlib_linalg_dot

   implicit none

   contains

   module function dev_SDOT_gpu(N,X,INCX,Y,INCY) result(res)
      implicit none
      real(real32) TAR_ATTR :: res
      integer,  intent(in) :: N
      integer,  intent(in) :: INCX,INCY
      real(real32), intent(in) TAR_ATTR DEV_ATTR :: X(:)
      real(real32)             TAR_ATTR DEV_ATTR :: Y(:)
      !
      integer :: ierr
      !
      call acc_loc_dev_sync()
      !
      !DEV_ACC data present(X,Y)
      !DEV_ACC host_data use_device(X,Y)
#if defined __DXL_CUBLAS
      res= cublasSdot(N,X,INCX,Y,INCY)
#elif defined __DXL_ROCBLAS
      !DEV_OMPGPU target data use_device_ptr(X,Y)
      ierr= rocblas_sdot(handle,N,c_loc(X),INCX,c_loc(Y),INCY,c_loc(res))
      !DEV_OMPGPU end target data
#elif defined __DXL_MKL_GPU
      !DEV_OMPGPU target data use_device_addr(X,Y)
      !DEV_OMPGPU dispatch
      res= SDOT(N,X,INCX,Y,INCY)
      !DEV_OMPGPU end dispatch
      !DEV_OMPGPU end target data
#else
      res= SDOT(N,X,INCX,Y,INCY)
#endif
      !DEV_ACC end host_data
      !DEV_ACC end data
      !
      call acc_loc_dev_sync()
      !
   end function dev_SDOT_gpu
   !
   module function dev_DDOT_gpu(N,X,INCX,Y,INCY) result(res)
      implicit none
      real(real64) TAR_ATTR :: res
      integer,  intent(in) :: N
      integer,  intent(in) :: INCX,INCY
      real(real64), intent(in) TAR_ATTR DEV_ATTR :: X(:)
      real(real64)             TAR_ATTR DEV_ATTR :: Y(:)
      !
      integer :: ierr
      !
      call acc_loc_dev_sync()
      !
      !DEV_ACC data present(X,Y)
      !DEV_ACC host_data use_device(X,Y)
#if defined __DXL_CUBLAS
      res= cublasDdot(N,X,INCX,Y,INCY)
#elif defined __DXL_ROCBLAS
      !DEV_OMPGPU target data use_device_ptr(X,Y)
      ierr= rocblas_ddot(handle,N,c_loc(X),INCX,c_loc(Y),INCY,c_loc(res))
      !DEV_OMPGPU end target data
#elif defined __DXL_MKL_GPU
      !DEV_OMPGPU target data use_device_addr(X,Y)
      !DEV_OMPGPU dispatch
      res= DDOT(N,X,INCX,Y,INCY)
      !DEV_OMPGPU end dispatch
      !DEV_OMPGPU end target data
#else
      res= DDOT(N,X,INCX,Y,INCY)
#endif
      !DEV_ACC end host_data
      !DEV_ACC end data
      !
      call acc_loc_dev_sync()
      !
   end function dev_DDOT_gpu
   !
   module function dev_CDOTU_gpu(N,X,INCX,Y,INCY) result(res)
      implicit none
      complex(real32) TAR_ATTR :: res
      integer,  intent(in) :: N
      integer,  intent(in) :: INCX,INCY
      complex(real32), intent(in) TAR_ATTR DEV_ATTR :: X(:)
      complex(real32)             TAR_ATTR DEV_ATTR :: Y(:)
      !
      integer :: ierr
      !
      call acc_loc_dev_sync()
      !
      !DEV_ACC data present(X,Y)
      !DEV_ACC host_data use_device(X,Y)
#if defined __DXL_CUBLAS
      res= cublasCdotu(N,X,INCX,Y,INCY)
#elif defined __DXL_ROCBLAS
      !DEV_OMPGPU target data use_device_ptr(X,Y)
      ierr= rocblas_cdotu(handle,N,c_loc(X),INCX,c_loc(Y),INCY,c_loc(res))
      !DEV_OMPGPU end target data
#elif defined __DXL_MKL_GPU
      !DEV_OMPGPU target data use_device_addr(X,Y)
      !DEV_OMPGPU dispatch
      res= CDOTU(N,X,INCX,Y,INCY)
      !DEV_OMPGPU end dispatch
      !DEV_OMPGPU end target data
#else
      res= CDOTU(N,X,INCX,Y,INCY)
#endif
      !DEV_ACC end host_data
      !DEV_ACC end data
      !
      call acc_loc_dev_sync()
      !
   end function dev_CDOTU_gpu
   !
   module function dev_ZDOTU_gpu(N,X,INCX,Y,INCY) result(res)
      implicit none
      complex(real64) TAR_ATTR :: res
      integer,  intent(in) :: N
      integer,  intent(in) :: INCX,INCY
      complex(real64), intent(in) TAR_ATTR DEV_ATTR :: X(:)
      complex(real64)             TAR_ATTR DEV_ATTR :: Y(:)
      !
      integer :: ierr
      !
      call acc_loc_dev_sync()
      !
      !DEV_ACC data present(X,Y)
      !DEV_ACC host_data use_device(X,Y)
#if defined __DXL_CUBLAS
      res= cublasZdotu(N,X,INCX,Y,INCY)
#elif defined __DXL_ROCBLAS
      !DEV_OMPGPU target data use_device_ptr(X,Y)
      ierr= rocblas_zdotu(handle,N,c_loc(X),INCX,c_loc(Y),INCY,c_loc(res))
      !DEV_OMPGPU end target data
#elif defined __DXL_MKL_GPU
      !DEV_OMPGPU target data use_device_addr(X,Y)
      !DEV_OMPGPU dispatch
      res= ZDOTU(N,X,INCX,Y,INCY)
      !DEV_OMPGPU end dispatch
      !DEV_OMPGPU end target data
#else
      res= ZDOTU(N,X,INCX,Y,INCY)
#endif
      !DEV_ACC end host_data
      !DEV_ACC end data
      !
      call acc_loc_dev_sync()
      !
   end function dev_ZDOTU_gpu
   !
   module function dev_CDOTC_gpu(N,X,INCX,Y,INCY) result(res)
      implicit none
      complex(real32) TAR_ATTR :: res
      integer,  intent(in) :: N
      integer,  intent(in) :: INCX,INCY
      complex(real32), intent(in) TAR_ATTR DEV_ATTR :: X(:)
      complex(real32)             TAR_ATTR DEV_ATTR :: Y(:)
      !
      integer :: ierr
      !
      call acc_loc_dev_sync()
      !
      !DEV_ACC data present(X,Y)
      !DEV_ACC host_data use_device(X,Y)
#if defined __DXL_CUBLAS
      res= cublasCdotc(N,X,INCX,Y,INCY)
#elif defined __DXL_ROCBLAS
      !DEV_OMPGPU target data use_device_ptr(X,Y)
      ierr= rocblas_cdotc(handle,N,c_loc(X),INCX,c_loc(Y),INCY,c_loc(res))
      !DEV_OMPGPU end target data
#elif defined __DXL_MKL_GPU
      !DEV_OMPGPU target data use_device_addr(X,Y)
      !DEV_OMPGPU dispatch
      res= CDOTC(N,X,INCX,Y,INCY)
      !DEV_OMPGPU end dispatch
      !DEV_OMPGPU end target data
#else
      res= CDOTC(N,X,INCX,Y,INCY)
#endif
      !DEV_ACC end host_data
      !DEV_ACC end data
      !
      call acc_loc_dev_sync()
      !
   end function dev_CDOTC_gpu
   !
   module function dev_ZDOTC_gpu(N,X,INCX,Y,INCY) result(res)
      implicit none
      complex(real64) TAR_ATTR :: res
      integer, intent(in) :: N
      integer, intent(in) :: INCX,INCY
      complex(real64), intent(in) TAR_ATTR DEV_ATTR :: X(:)
      complex(real64)             TAR_ATTR DEV_ATTR :: Y(:)
      !
      integer :: ierr
      !
      call acc_loc_dev_sync()
      !
      !DEV_ACC data present(X,Y)
      !DEV_ACC host_data use_device(X,Y)
#if defined __DXL_CUBLAS
      res= cublasZdotc(N,X,INCX,Y,INCY)
#elif defined __DXL_ROCBLAS
      !DEV_OMPGPU target data use_device_ptr(X,Y)
      ierr= rocblas_zdotc(handle,N,c_loc(X),INCX,c_loc(Y),INCY,c_loc(res))
      !DEV_OMPGPU end target data
#elif defined __DXL_MKL_GPU
      !DEV_OMPGPU target data use_device_addr(X,Y)
      !DEV_OMPGPU dispatch
      res= ZDOTC(N,X,INCX,Y,INCY)
      !DEV_OMPGPU end dispatch
      !DEV_OMPGPU end target data
#else
      res= ZDOTC(N,X,INCX,Y,INCY)
#endif
      !DEV_ACC end host_data
      !DEV_ACC end data
      !
      call acc_loc_dev_sync()
      !
   end function dev_ZDOTC_gpu
   !
end submodule devxlib_linalg_dot

#! /usr/bin/env bash
#
# General utility to run tests
#
#================================================================
#
# Input flags for this script (./run.sh FLAG): 
#
MANUAL=" 
 Usage
   run.sh [-h,--help] [-l,--list] [-v,--verbose] [-a,--all] [-c,--clean] [<tests>]

 run deviceXlib tests
 When the command line is empty the following manual page is printed:
 
 -h,--help       print this manual    
 -l,--list       print the list of existing tests
 -v,--verbose    print verbose output
 -a,--all        run all tests
 -c,--clean      clean tests outputs
 <tests>         a list of the tests to run (eg 'linalg' 'memcpy' )

"
#
#================================================================
#
# List of tests
#
TEST_LIST=" 
 Tests:

   linalg        Linear algebra wrappers
   malloc        Memory allocations on GPUs
   mapping       Memory mapping (HOST/DEV)
   buffer        Buffers on GPU memory 
   memcpy        Memory copies
   memcpy_async  Memory copies (Async)
   memset        Memory init
   pinned        Handling of pinned memory
"
#
#================================================================
#
testdir=`echo $0 | sed 's/\(.*\)\/.*/\1/'`
bindir=$testdir/../bin
bold_on="[1m"
bold_off="[0m"
#
# parse command line input
#
LIST=
CLEAN=
VERBOSE=
#
for OPT in $*
do
  case $OPT in
  ("-h" | "--help") echo "$MANUAL" ; exit 0 ;;
  ("-l" | "--list") echo "$TEST_LIST" ; exit 0 ;;
  ("-a" | "--all")      LIST="ALL" ;;
  ("-v" | "--verbose")  VERBOSE="yes" ;;
  ("-c" | "--clean")    CLEAN="yes" ;;
  (*)                   LIST="$LIST $OPT" ;;
  esac
done
# 
if [ "$CLEAN" = "yes" ] ; then rm -f $testdir/*.out ; exit 0 ; fi
#
if [ "$LIST" == "ALL" ] ; then
   LIST=`echo "$TEST_LIST" | awk '{ if (NR<=3) {next} else {print $1} }'`
fi
if [ -z "$LIST" ] ; then echo "$MANUAL" ; exit 0 ; fi

#
# reporting
#
echo "
${bold_on}Running tests:${bold_off} 
"
ind=0
for mytest in $LIST ; do
  var=$((ind++))
  echo "  ($ind)  $mytest"
done
echo

#
# perform the required tasks
#
for mytest in $LIST
do
    testfile=$bindir/test_${mytest}.x    
    output=$testdir/test_${mytest}.out
    #
    if [ ! -x $testfile ] ; then
        echo "  file $testfile does not exist" ; exit 3
    fi
    # 
    # running test 
    #
    echo
    echo " Running ${bold_on}${mytest}${bold_off}"
    #
    $testfile > $output
    if [ "$VERBOSE" = "yes" ] ; then cat $output | grep -v "\#" ; fi
    cat $output | grep '\#' | awk -f $testdir/fmt_output.awk
    #
done

echo
exit 0

#! /bin/awk -f

BEGIN{
  #
  # definitions about colors & styles
  #
  bold_on="[1m"
  bold_off="[0m"
  green_on="[1;32;48m"
  green_off="[0m"
  orange_on="[1;33;48m"
  orange_off="[0m"
  red_on="[1;31;48m"
  red_off="[0m"
  #
  stat_pass= green_on"passed"green_off ;
  stat_warn= orange_on"warning"orange_off ;
  stat_fail= red_on"failed"red_off ;
  #
  npass=0
  nfail=0
  completed=0
}

{
  if ( match($0,"SUMMARY") ) {completed=1; next}
  if ( match($0,"# passed") ) {npass+=$(NF)}
  if ( match($0,"# failed") ) {nfail+=$(NF)}
  if ( match($1,"#") ) {print}
}

END{
  ntot=npass+nfail
  #
  str=stat_fail
  if (ntot > 0) {
    if (nfail+0.0 < 0.15*(ntot+0.0)) {str=stat_warn}
    if (nfail==0) {str=stat_pass}
  }
  if (completed==0) {
    str=stat_fail
    printf "   # %s (crashed)\n", str
  } else {
    printf "   # %s (fails %d/%d)\n", str, nfail, ntot
  }
}

#! /bin/sh
# compute dependencies for the WanT directory tree

# run from directory where this script is
cd `echo $0 | sed 's/\(.*\)\/.*/\1/'` # extract pathname
# come back to AGWX HOME
cd ..
#
TOPDIR=`pwd`
BINDIR=$TOPDIR/config

DIR_LIST="src"
SPECIAL_MODULES="cudafor cublas cusolver \
                 openacc omp_lib \
                 onemkl_blas_omp_offload_lp64 \
                 mkl_omp_offload.f90 \
                 mkl_dfti.f90 \
                 magma iso_c_binding \
                 iso_fortran_env \
                 device_memcpy_interf.f90 \
                 device_defs_mod.f90 \
                 device_linalg.f90 \
                 device_auxfunc_interf.f90"

for DIR in $DIR_LIST
do
    # set inter-directory dependencies
    case $DIR in
        src  )   DEPENDS="../../include"                ;;
    esac

    # generate dependencies file
    if test -d $TOPDIR/$DIR
    then
        cd $TOPDIR/$DIR
        $BINDIR/moduledep.sh  $DEPENDS > make.depend
        $BINDIR/includedep.sh $DEPENDS >> make.depend
    fi

    # handle special cases
    if test "$DIR" = "src"
    then
        mv make.depend make.depend.tmp
        sed 's/@fftw.c@/fftw.c/' make.depend.tmp > make.depend
    fi

    # eliminate dependencies on special modules
    for module in $SPECIAL_MODULES
    do
        mv make.depend make.depend.tmp
        grep -v "@$module@" make.depend.tmp > make.depend
    done

    test -e make.depend.tmp && rm make.depend.tmp

    # check for missing dependencies
    if grep @ make.depend
    then
        notfound=1
        echo WARNING: dependencies not found in directory $DIR
    else
        echo directory $DIR : ok
    fi
    #
    # eliminate missing deps to make the script working
    mv make.depend make.depend.tmp
    awk '{
           if ( match($0, "@") ) {
               print "#", $0
           } else {
               print
           }
         }' make.depend.tmp > make.depend
    #
    test -e make.depend.tmp && rm make.depend.tmp
    #
done
#
if test "$notfound" = ""
then
    echo all dependencies updated successfully
fi

#! /bin/sh 
# generates the file include/build_date.h

# run from directory where this script is
cd `echo $0 | sed 's/\(.*\)\/.*/\1/'` # extract pathname
# come back to WanT HOME
cd ..  
#
TOPDIR=`pwd`
TARGETDIR=$TOPDIR/include
TARGETFILE=$TARGETDIR/build_date.h

if [ -e "$TARGETFILE" ] ; then rm $TARGETFILE ; fi
#
cat > $TARGETFILE << EOF

!
! Copyright (C) 2010 WanT Group
!
! This file is distributed under the terms of the
! GNU General Public License. See the file "License"
! in the root directory of the present distribution,
! or http://www.gnu.org/copyleft/gpl.txt .
!

#define   __CONF_BUILD_DATE           "`date '+%c'`"

EOF

exit 0

#!/bin/sh 
# includedep.sh -- script that computes dependencies on preprocessor includes

# files whose dependencies must be computed
sources=`echo *.c *.f90 |
sed 's/\*\.c//g
     s/\*\.f90//g'`       # remove the "*.c" and "*.f90" that remain
#                         # when there are no such files
if test "$sources" = " " ; then exit ; fi

# files that may be included
# extra directories may be specified on the command line
includes=`echo *.h`
for dir in $*
do
    includes="$includes `echo $dir/*.h`"
done
includes=`echo $includes |
sed 's/[^ ]*\*\.h//g'`     # remove the "dir/*.h" that remain
#                          # when there are no such files

# create list of include dependencies
# each line is of the form:
# file_name.o : @include_file.h@
egrep '^ *# *include *"' $sources |  # look for #include "..." statements
#                                    #   ignore #include <...> ones
sed 's/f90:/o /
     s/c:/o /
     s/# *include *//
     s/\"/ /g' |                     # replace extension, insert space
#                                    #   remove '# include' statements
#                                    #   remove quotes 
awk '{print $1 " : @" $2 "@"}' |     # create dependency entry
sort | uniq > includedep.tmp1        # remove duplicates

# create list of available include files
# for each file, create a line of the form:
# s/@file_name@/pathname/g
echo $includes | tr " " "\n" |
sed 's/\//\\\//g
     s/.*\/\([^/]*\)/\1 &/' |         # escape slashes
awk '{print "s/@" $1 "@/" $2 "/" }' > includedep.tmp2

# replace file names with pathnames
# by applying the file of substitution patterns just created
sed -f includedep.tmp2 includedep.tmp1 

rm -f includedep.tmp1 includedep.tmp2 # remove temporary files

#!/bin/sh
# moduledep.sh -- script that computes dependencies on Fortran 90 modules

# files whose dependencies must be computed
sources=`echo *.f90 |
sed 's/\*\.f90//g'`   # remove the "*.f90" that remains
#                     # when there are no such files
if test "$sources" = "" ; then exit ; fi

# files that may contain modules
# extra directories can be specified on the command line
sources_all="$sources"
for dir in $*
do
  sources_all="$sources_all `echo $dir/*.f90`"
done
sources_all=`echo $sources_all |
sed 's/[^ ]*\*\.f90//g'`     # remove the "dir/*.f90" that remain
#                            # when there are no such files

rm -f moduledep.tmp1 moduledep.tmp2 # destroy previous contents

# create list of module dependencies
# each line is of the form:
# file_name.o : @module_name@
# cast all module names to lowercase because Fortran is case insensitive
egrep -i "^ *use " $sources |             # look for "USE name"
sed 's/f90:/o /
     s/,/ /' |                            # replace extension, insert space
#                                         #   and remove trailing comma
awk '{print $1 " : @" tolower($3) "@"}' | # create dependency entry
sort | uniq > moduledep.tmp1              # remove duplicates

# create list of available modules
# for each module, create a line of the form:
# s/@module_name@/file_name/g
egrep -i "^ *module " $sources_all |           # look for "MODULE name"
sed 's/f90:/o /
     s/\//\\\//g' |                            # replace extension, insert
#                                              #   space and escape slashes
awk '{print "s/@" tolower($3) "@/" $1 "/" }' | # create substitution line
sort | uniq > moduledep.tmp2                   # remove duplicates


# replace module names with file names
# by applying the file of substitution patterns just created
sed -f moduledep.tmp2 moduledep.tmp1 |
awk '{if ($1 != $3) print}' |          # remove self dependencies
sort -d | uniq                         # remove duplicates

rm -f moduledep.tmp1 moduledep.tmp2 # remove temporary files
